require=(function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){
'use strict';

var compileSchema = require('./compile')
  , resolve = require('./compile/resolve')
  , Cache = require('./cache')
  , SchemaObject = require('./compile/schema_obj')
  , stableStringify = require('fast-json-stable-stringify')
  , formats = require('./compile/formats')
  , rules = require('./compile/rules')
  , $dataMetaSchema = require('./data')
  , util = require('./compile/util');

module.exports = Ajv;

Ajv.prototype.validate = validate;
Ajv.prototype.compile = compile;
Ajv.prototype.addSchema = addSchema;
Ajv.prototype.addMetaSchema = addMetaSchema;
Ajv.prototype.validateSchema = validateSchema;
Ajv.prototype.getSchema = getSchema;
Ajv.prototype.removeSchema = removeSchema;
Ajv.prototype.addFormat = addFormat;
Ajv.prototype.errorsText = errorsText;

Ajv.prototype._addSchema = _addSchema;
Ajv.prototype._compile = _compile;

Ajv.prototype.compileAsync = require('./compile/async');
var customKeyword = require('./keyword');
Ajv.prototype.addKeyword = customKeyword.add;
Ajv.prototype.getKeyword = customKeyword.get;
Ajv.prototype.removeKeyword = customKeyword.remove;
Ajv.prototype.validateKeyword = customKeyword.validate;

var errorClasses = require('./compile/error_classes');
Ajv.ValidationError = errorClasses.Validation;
Ajv.MissingRefError = errorClasses.MissingRef;
Ajv.$dataMetaSchema = $dataMetaSchema;

var META_SCHEMA_ID = 'http://json-schema.org/draft-07/schema';

var META_IGNORE_OPTIONS = [ 'removeAdditional', 'useDefaults', 'coerceTypes', 'strictDefaults' ];
var META_SUPPORT_DATA = ['/properties'];

/**
 * Creates validator instance.
 * Usage: `Ajv(opts)`
 * @param {Object} opts optional options
 * @return {Object} ajv instance
 */
function Ajv(opts) {
  if (!(this instanceof Ajv)) return new Ajv(opts);
  opts = this._opts = util.copy(opts) || {};
  setLogger(this);
  this._schemas = {};
  this._refs = {};
  this._fragments = {};
  this._formats = formats(opts.format);

  this._cache = opts.cache || new Cache;
  this._loadingSchemas = {};
  this._compilations = [];
  this.RULES = rules();
  this._getId = chooseGetId(opts);

  opts.loopRequired = opts.loopRequired || Infinity;
  if (opts.errorDataPath == 'property') opts._errorDataPathProperty = true;
  if (opts.serialize === undefined) opts.serialize = stableStringify;
  this._metaOpts = getMetaSchemaOptions(this);

  if (opts.formats) addInitialFormats(this);
  addDefaultMetaSchema(this);
  if (typeof opts.meta == 'object') this.addMetaSchema(opts.meta);
  if (opts.nullable) this.addKeyword('nullable', {metaSchema: {type: 'boolean'}});
  addInitialSchemas(this);
}



/**
 * Validate data using schema
 * Schema will be compiled and cached (using serialized JSON as key. [fast-json-stable-stringify](https://github.com/epoberezkin/fast-json-stable-stringify) is used to serialize.
 * @this   Ajv
 * @param  {String|Object} schemaKeyRef key, ref or schema object
 * @param  {Any} data to be validated
 * @return {Boolean} validation result. Errors from the last validation will be available in `ajv.errors` (and also in compiled schema: `schema.errors`).
 */
function validate(schemaKeyRef, data) {
  var v;
  if (typeof schemaKeyRef == 'string') {
    v = this.getSchema(schemaKeyRef);
    if (!v) throw new Error('no schema with key or ref "' + schemaKeyRef + '"');
  } else {
    var schemaObj = this._addSchema(schemaKeyRef);
    v = schemaObj.validate || this._compile(schemaObj);
  }

  var valid = v(data);
  if (v.$async !== true) this.errors = v.errors;
  return valid;
}


/**
 * Create validating function for passed schema.
 * @this   Ajv
 * @param  {Object} schema schema object
 * @param  {Boolean} _meta true if schema is a meta-schema. Used internally to compile meta schemas of custom keywords.
 * @return {Function} validating function
 */
function compile(schema, _meta) {
  var schemaObj = this._addSchema(schema, undefined, _meta);
  return schemaObj.validate || this._compile(schemaObj);
}


/**
 * Adds schema to the instance.
 * @this   Ajv
 * @param {Object|Array} schema schema or array of schemas. If array is passed, `key` and other parameters will be ignored.
 * @param {String} key Optional schema key. Can be passed to `validate` method instead of schema object or id/ref. One schema per instance can have empty `id` and `key`.
 * @param {Boolean} _skipValidation true to skip schema validation. Used internally, option validateSchema should be used instead.
 * @param {Boolean} _meta true if schema is a meta-schema. Used internally, addMetaSchema should be used instead.
 * @return {Ajv} this for method chaining
 */
function addSchema(schema, key, _skipValidation, _meta) {
  if (Array.isArray(schema)){
    for (var i=0; i<schema.length; i++) this.addSchema(schema[i], undefined, _skipValidation, _meta);
    return this;
  }
  var id = this._getId(schema);
  if (id !== undefined && typeof id != 'string')
    throw new Error('schema id must be string');
  key = resolve.normalizeId(key || id);
  checkUnique(this, key);
  this._schemas[key] = this._addSchema(schema, _skipValidation, _meta, true);
  return this;
}


/**
 * Add schema that will be used to validate other schemas
 * options in META_IGNORE_OPTIONS are alway set to false
 * @this   Ajv
 * @param {Object} schema schema object
 * @param {String} key optional schema key
 * @param {Boolean} skipValidation true to skip schema validation, can be used to override validateSchema option for meta-schema
 * @return {Ajv} this for method chaining
 */
function addMetaSchema(schema, key, skipValidation) {
  this.addSchema(schema, key, skipValidation, true);
  return this;
}


/**
 * Validate schema
 * @this   Ajv
 * @param {Object} schema schema to validate
 * @param {Boolean} throwOrLogError pass true to throw (or log) an error if invalid
 * @return {Boolean} true if schema is valid
 */
function validateSchema(schema, throwOrLogError) {
  var $schema = schema.$schema;
  if ($schema !== undefined && typeof $schema != 'string')
    throw new Error('$schema must be a string');
  $schema = $schema || this._opts.defaultMeta || defaultMeta(this);
  if (!$schema) {
    this.logger.warn('meta-schema not available');
    this.errors = null;
    return true;
  }
  var valid = this.validate($schema, schema);
  if (!valid && throwOrLogError) {
    var message = 'schema is invalid: ' + this.errorsText();
    if (this._opts.validateSchema == 'log') this.logger.error(message);
    else throw new Error(message);
  }
  return valid;
}


function defaultMeta(self) {
  var meta = self._opts.meta;
  self._opts.defaultMeta = typeof meta == 'object'
                            ? self._getId(meta) || meta
                            : self.getSchema(META_SCHEMA_ID)
                              ? META_SCHEMA_ID
                              : undefined;
  return self._opts.defaultMeta;
}


/**
 * Get compiled schema from the instance by `key` or `ref`.
 * @this   Ajv
 * @param  {String} keyRef `key` that was passed to `addSchema` or full schema reference (`schema.id` or resolved id).
 * @return {Function} schema validating function (with property `schema`).
 */
function getSchema(keyRef) {
  var schemaObj = _getSchemaObj(this, keyRef);
  switch (typeof schemaObj) {
    case 'object': return schemaObj.validate || this._compile(schemaObj);
    case 'string': return this.getSchema(schemaObj);
    case 'undefined': return _getSchemaFragment(this, keyRef);
  }
}


function _getSchemaFragment(self, ref) {
  var res = resolve.schema.call(self, { schema: {} }, ref);
  if (res) {
    var schema = res.schema
      , root = res.root
      , baseId = res.baseId;
    var v = compileSchema.call(self, schema, root, undefined, baseId);
    self._fragments[ref] = new SchemaObject({
      ref: ref,
      fragment: true,
      schema: schema,
      root: root,
      baseId: baseId,
      validate: v
    });
    return v;
  }
}


function _getSchemaObj(self, keyRef) {
  keyRef = resolve.normalizeId(keyRef);
  return self._schemas[keyRef] || self._refs[keyRef] || self._fragments[keyRef];
}


/**
 * Remove cached schema(s).
 * If no parameter is passed all schemas but meta-schemas are removed.
 * If RegExp is passed all schemas with key/id matching pattern but meta-schemas are removed.
 * Even if schema is referenced by other schemas it still can be removed as other schemas have local references.
 * @this   Ajv
 * @param  {String|Object|RegExp} schemaKeyRef key, ref, pattern to match key/ref or schema object
 * @return {Ajv} this for method chaining
 */
function removeSchema(schemaKeyRef) {
  if (schemaKeyRef instanceof RegExp) {
    _removeAllSchemas(this, this._schemas, schemaKeyRef);
    _removeAllSchemas(this, this._refs, schemaKeyRef);
    return this;
  }
  switch (typeof schemaKeyRef) {
    case 'undefined':
      _removeAllSchemas(this, this._schemas);
      _removeAllSchemas(this, this._refs);
      this._cache.clear();
      return this;
    case 'string':
      var schemaObj = _getSchemaObj(this, schemaKeyRef);
      if (schemaObj) this._cache.del(schemaObj.cacheKey);
      delete this._schemas[schemaKeyRef];
      delete this._refs[schemaKeyRef];
      return this;
    case 'object':
      var serialize = this._opts.serialize;
      var cacheKey = serialize ? serialize(schemaKeyRef) : schemaKeyRef;
      this._cache.del(cacheKey);
      var id = this._getId(schemaKeyRef);
      if (id) {
        id = resolve.normalizeId(id);
        delete this._schemas[id];
        delete this._refs[id];
      }
  }
  return this;
}


function _removeAllSchemas(self, schemas, regex) {
  for (var keyRef in schemas) {
    var schemaObj = schemas[keyRef];
    if (!schemaObj.meta && (!regex || regex.test(keyRef))) {
      self._cache.del(schemaObj.cacheKey);
      delete schemas[keyRef];
    }
  }
}


/* @this   Ajv */
function _addSchema(schema, skipValidation, meta, shouldAddSchema) {
  if (typeof schema != 'object' && typeof schema != 'boolean')
    throw new Error('schema should be object or boolean');
  var serialize = this._opts.serialize;
  var cacheKey = serialize ? serialize(schema) : schema;
  var cached = this._cache.get(cacheKey);
  if (cached) return cached;

  shouldAddSchema = shouldAddSchema || this._opts.addUsedSchema !== false;

  var id = resolve.normalizeId(this._getId(schema));
  if (id && shouldAddSchema) checkUnique(this, id);

  var willValidate = this._opts.validateSchema !== false && !skipValidation;
  var recursiveMeta;
  if (willValidate && !(recursiveMeta = id && id == resolve.normalizeId(schema.$schema)))
    this.validateSchema(schema, true);

  var localRefs = resolve.ids.call(this, schema);

  var schemaObj = new SchemaObject({
    id: id,
    schema: schema,
    localRefs: localRefs,
    cacheKey: cacheKey,
    meta: meta
  });

  if (id[0] != '#' && shouldAddSchema) this._refs[id] = schemaObj;
  this._cache.put(cacheKey, schemaObj);

  if (willValidate && recursiveMeta) this.validateSchema(schema, true);

  return schemaObj;
}


/* @this   Ajv */
function _compile(schemaObj, root) {
  if (schemaObj.compiling) {
    schemaObj.validate = callValidate;
    callValidate.schema = schemaObj.schema;
    callValidate.errors = null;
    callValidate.root = root ? root : callValidate;
    if (schemaObj.schema.$async === true)
      callValidate.$async = true;
    return callValidate;
  }
  schemaObj.compiling = true;

  var currentOpts;
  if (schemaObj.meta) {
    currentOpts = this._opts;
    this._opts = this._metaOpts;
  }

  var v;
  try { v = compileSchema.call(this, schemaObj.schema, root, schemaObj.localRefs); }
  catch(e) {
    delete schemaObj.validate;
    throw e;
  }
  finally {
    schemaObj.compiling = false;
    if (schemaObj.meta) this._opts = currentOpts;
  }

  schemaObj.validate = v;
  schemaObj.refs = v.refs;
  schemaObj.refVal = v.refVal;
  schemaObj.root = v.root;
  return v;


  /* @this   {*} - custom context, see passContext option */
  function callValidate() {
    /* jshint validthis: true */
    var _validate = schemaObj.validate;
    var result = _validate.apply(this, arguments);
    callValidate.errors = _validate.errors;
    return result;
  }
}


function chooseGetId(opts) {
  switch (opts.schemaId) {
    case 'auto': return _get$IdOrId;
    case 'id': return _getId;
    default: return _get$Id;
  }
}

/* @this   Ajv */
function _getId(schema) {
  if (schema.$id) this.logger.warn('schema $id ignored', schema.$id);
  return schema.id;
}

/* @this   Ajv */
function _get$Id(schema) {
  if (schema.id) this.logger.warn('schema id ignored', schema.id);
  return schema.$id;
}


function _get$IdOrId(schema) {
  if (schema.$id && schema.id && schema.$id != schema.id)
    throw new Error('schema $id is different from id');
  return schema.$id || schema.id;
}


/**
 * Convert array of error message objects to string
 * @this   Ajv
 * @param  {Array<Object>} errors optional array of validation errors, if not passed errors from the instance are used.
 * @param  {Object} options optional options with properties `separator` and `dataVar`.
 * @return {String} human readable string with all errors descriptions
 */
function errorsText(errors, options) {
  errors = errors || this.errors;
  if (!errors) return 'No errors';
  options = options || {};
  var separator = options.separator === undefined ? ', ' : options.separator;
  var dataVar = options.dataVar === undefined ? 'data' : options.dataVar;

  var text = '';
  for (var i=0; i<errors.length; i++) {
    var e = errors[i];
    if (e) text += dataVar + e.dataPath + ' ' + e.message + separator;
  }
  return text.slice(0, -separator.length);
}


/**
 * Add custom format
 * @this   Ajv
 * @param {String} name format name
 * @param {String|RegExp|Function} format string is converted to RegExp; function should return boolean (true when valid)
 * @return {Ajv} this for method chaining
 */
function addFormat(name, format) {
  if (typeof format == 'string') format = new RegExp(format);
  this._formats[name] = format;
  return this;
}


function addDefaultMetaSchema(self) {
  var $dataSchema;
  if (self._opts.$data) {
    $dataSchema = require('./refs/data.json');
    self.addMetaSchema($dataSchema, $dataSchema.$id, true);
  }
  if (self._opts.meta === false) return;
  var metaSchema = require('./refs/json-schema-draft-07.json');
  if (self._opts.$data) metaSchema = $dataMetaSchema(metaSchema, META_SUPPORT_DATA);
  self.addMetaSchema(metaSchema, META_SCHEMA_ID, true);
  self._refs['http://json-schema.org/schema'] = META_SCHEMA_ID;
}


function addInitialSchemas(self) {
  var optsSchemas = self._opts.schemas;
  if (!optsSchemas) return;
  if (Array.isArray(optsSchemas)) self.addSchema(optsSchemas);
  else for (var key in optsSchemas) self.addSchema(optsSchemas[key], key);
}


function addInitialFormats(self) {
  for (var name in self._opts.formats) {
    var format = self._opts.formats[name];
    self.addFormat(name, format);
  }
}


function checkUnique(self, id) {
  if (self._schemas[id] || self._refs[id])
    throw new Error('schema with key or id "' + id + '" already exists');
}


function getMetaSchemaOptions(self) {
  var metaOpts = util.copy(self._opts);
  for (var i=0; i<META_IGNORE_OPTIONS.length; i++)
    delete metaOpts[META_IGNORE_OPTIONS[i]];
  return metaOpts;
}


function setLogger(self) {
  var logger = self._opts.logger;
  if (logger === false) {
    self.logger = {log: noop, warn: noop, error: noop};
  } else {
    if (logger === undefined) logger = console;
    if (!(typeof logger == 'object' && logger.log && logger.warn && logger.error))
      throw new Error('logger must implement log, warn and error methods');
    self.logger = logger;
  }
}


function noop() {}

},{"./cache":2,"./compile":6,"./compile/async":3,"./compile/error_classes":4,"./compile/formats":5,"./compile/resolve":7,"./compile/rules":8,"./compile/schema_obj":9,"./compile/util":11,"./data":12,"./keyword":40,"./refs/data.json":41,"./refs/json-schema-draft-07.json":42,"fast-json-stable-stringify":56}],2:[function(require,module,exports){
'use strict';


var Cache = module.exports = function Cache() {
  this._cache = {};
};


Cache.prototype.put = function Cache_put(key, value) {
  this._cache[key] = value;
};


Cache.prototype.get = function Cache_get(key) {
  return this._cache[key];
};


Cache.prototype.del = function Cache_del(key) {
  delete this._cache[key];
};


Cache.prototype.clear = function Cache_clear() {
  this._cache = {};
};

},{}],3:[function(require,module,exports){
'use strict';

var MissingRefError = require('./error_classes').MissingRef;

module.exports = compileAsync;


/**
 * Creates validating function for passed schema with asynchronous loading of missing schemas.
 * `loadSchema` option should be a function that accepts schema uri and returns promise that resolves with the schema.
 * @this  Ajv
 * @param {Object}   schema schema object
 * @param {Boolean}  meta optional true to compile meta-schema; this parameter can be skipped
 * @param {Function} callback an optional node-style callback, it is called with 2 parameters: error (or null) and validating function.
 * @return {Promise} promise that resolves with a validating function.
 */
function compileAsync(schema, meta, callback) {
  /* eslint no-shadow: 0 */
  /* global Promise */
  /* jshint validthis: true */
  var self = this;
  if (typeof this._opts.loadSchema != 'function')
    throw new Error('options.loadSchema should be a function');

  if (typeof meta == 'function') {
    callback = meta;
    meta = undefined;
  }

  var p = loadMetaSchemaOf(schema).then(function () {
    var schemaObj = self._addSchema(schema, undefined, meta);
    return schemaObj.validate || _compileAsync(schemaObj);
  });

  if (callback) {
    p.then(
      function(v) { callback(null, v); },
      callback
    );
  }

  return p;


  function loadMetaSchemaOf(sch) {
    var $schema = sch.$schema;
    return $schema && !self.getSchema($schema)
            ? compileAsync.call(self, { $ref: $schema }, true)
            : Promise.resolve();
  }


  function _compileAsync(schemaObj) {
    try { return self._compile(schemaObj); }
    catch(e) {
      if (e instanceof MissingRefError) return loadMissingSchema(e);
      throw e;
    }


    function loadMissingSchema(e) {
      var ref = e.missingSchema;
      if (added(ref)) throw new Error('Schema ' + ref + ' is loaded but ' + e.missingRef + ' cannot be resolved');

      var schemaPromise = self._loadingSchemas[ref];
      if (!schemaPromise) {
        schemaPromise = self._loadingSchemas[ref] = self._opts.loadSchema(ref);
        schemaPromise.then(removePromise, removePromise);
      }

      return schemaPromise.then(function (sch) {
        if (!added(ref)) {
          return loadMetaSchemaOf(sch).then(function () {
            if (!added(ref)) self.addSchema(sch, ref, undefined, meta);
          });
        }
      }).then(function() {
        return _compileAsync(schemaObj);
      });

      function removePromise() {
        delete self._loadingSchemas[ref];
      }

      function added(ref) {
        return self._refs[ref] || self._schemas[ref];
      }
    }
  }
}

},{"./error_classes":4}],4:[function(require,module,exports){
'use strict';

var resolve = require('./resolve');

module.exports = {
  Validation: errorSubclass(ValidationError),
  MissingRef: errorSubclass(MissingRefError)
};


function ValidationError(errors) {
  this.message = 'validation failed';
  this.errors = errors;
  this.ajv = this.validation = true;
}


MissingRefError.message = function (baseId, ref) {
  return 'can\'t resolve reference ' + ref + ' from id ' + baseId;
};


function MissingRefError(baseId, ref, message) {
  this.message = message || MissingRefError.message(baseId, ref);
  this.missingRef = resolve.url(baseId, ref);
  this.missingSchema = resolve.normalizeId(resolve.fullPath(this.missingRef));
}


function errorSubclass(Subclass) {
  Subclass.prototype = Object.create(Error.prototype);
  Subclass.prototype.constructor = Subclass;
  return Subclass;
}

},{"./resolve":7}],5:[function(require,module,exports){
'use strict';

var util = require('./util');

var DATE = /^(\d\d\d\d)-(\d\d)-(\d\d)$/;
var DAYS = [0,31,28,31,30,31,30,31,31,30,31,30,31];
var TIME = /^(\d\d):(\d\d):(\d\d)(\.\d+)?(z|[+-]\d\d:\d\d)?$/i;
var HOSTNAME = /^[a-z0-9](?:[a-z0-9-]{0,61}[a-z0-9])?(?:\.[a-z0-9](?:[-0-9a-z]{0,61}[0-9a-z])?)*$/i;
var URI = /^(?:[a-z][a-z0-9+\-.]*:)(?:\/?\/(?:(?:[a-z0-9\-._~!$&'()*+,;=:]|%[0-9a-f]{2})*@)?(?:\[(?:(?:(?:(?:[0-9a-f]{1,4}:){6}|::(?:[0-9a-f]{1,4}:){5}|(?:[0-9a-f]{1,4})?::(?:[0-9a-f]{1,4}:){4}|(?:(?:[0-9a-f]{1,4}:){0,1}[0-9a-f]{1,4})?::(?:[0-9a-f]{1,4}:){3}|(?:(?:[0-9a-f]{1,4}:){0,2}[0-9a-f]{1,4})?::(?:[0-9a-f]{1,4}:){2}|(?:(?:[0-9a-f]{1,4}:){0,3}[0-9a-f]{1,4})?::[0-9a-f]{1,4}:|(?:(?:[0-9a-f]{1,4}:){0,4}[0-9a-f]{1,4})?::)(?:[0-9a-f]{1,4}:[0-9a-f]{1,4}|(?:(?:25[0-5]|2[0-4]\d|[01]?\d\d?)\.){3}(?:25[0-5]|2[0-4]\d|[01]?\d\d?))|(?:(?:[0-9a-f]{1,4}:){0,5}[0-9a-f]{1,4})?::[0-9a-f]{1,4}|(?:(?:[0-9a-f]{1,4}:){0,6}[0-9a-f]{1,4})?::)|[Vv][0-9a-f]+\.[a-z0-9\-._~!$&'()*+,;=:]+)\]|(?:(?:25[0-5]|2[0-4]\d|[01]?\d\d?)\.){3}(?:25[0-5]|2[0-4]\d|[01]?\d\d?)|(?:[a-z0-9\-._~!$&'()*+,;=]|%[0-9a-f]{2})*)(?::\d*)?(?:\/(?:[a-z0-9\-._~!$&'()*+,;=:@]|%[0-9a-f]{2})*)*|\/(?:(?:[a-z0-9\-._~!$&'()*+,;=:@]|%[0-9a-f]{2})+(?:\/(?:[a-z0-9\-._~!$&'()*+,;=:@]|%[0-9a-f]{2})*)*)?|(?:[a-z0-9\-._~!$&'()*+,;=:@]|%[0-9a-f]{2})+(?:\/(?:[a-z0-9\-._~!$&'()*+,;=:@]|%[0-9a-f]{2})*)*)(?:\?(?:[a-z0-9\-._~!$&'()*+,;=:@/?]|%[0-9a-f]{2})*)?(?:#(?:[a-z0-9\-._~!$&'()*+,;=:@/?]|%[0-9a-f]{2})*)?$/i;
var URIREF = /^(?:[a-z][a-z0-9+\-.]*:)?(?:\/?\/(?:(?:[a-z0-9\-._~!$&'()*+,;=:]|%[0-9a-f]{2})*@)?(?:\[(?:(?:(?:(?:[0-9a-f]{1,4}:){6}|::(?:[0-9a-f]{1,4}:){5}|(?:[0-9a-f]{1,4})?::(?:[0-9a-f]{1,4}:){4}|(?:(?:[0-9a-f]{1,4}:){0,1}[0-9a-f]{1,4})?::(?:[0-9a-f]{1,4}:){3}|(?:(?:[0-9a-f]{1,4}:){0,2}[0-9a-f]{1,4})?::(?:[0-9a-f]{1,4}:){2}|(?:(?:[0-9a-f]{1,4}:){0,3}[0-9a-f]{1,4})?::[0-9a-f]{1,4}:|(?:(?:[0-9a-f]{1,4}:){0,4}[0-9a-f]{1,4})?::)(?:[0-9a-f]{1,4}:[0-9a-f]{1,4}|(?:(?:25[0-5]|2[0-4]\d|[01]?\d\d?)\.){3}(?:25[0-5]|2[0-4]\d|[01]?\d\d?))|(?:(?:[0-9a-f]{1,4}:){0,5}[0-9a-f]{1,4})?::[0-9a-f]{1,4}|(?:(?:[0-9a-f]{1,4}:){0,6}[0-9a-f]{1,4})?::)|[Vv][0-9a-f]+\.[a-z0-9\-._~!$&'()*+,;=:]+)\]|(?:(?:25[0-5]|2[0-4]\d|[01]?\d\d?)\.){3}(?:25[0-5]|2[0-4]\d|[01]?\d\d?)|(?:[a-z0-9\-._~!$&'"()*+,;=]|%[0-9a-f]{2})*)(?::\d*)?(?:\/(?:[a-z0-9\-._~!$&'"()*+,;=:@]|%[0-9a-f]{2})*)*|\/(?:(?:[a-z0-9\-._~!$&'"()*+,;=:@]|%[0-9a-f]{2})+(?:\/(?:[a-z0-9\-._~!$&'"()*+,;=:@]|%[0-9a-f]{2})*)*)?|(?:[a-z0-9\-._~!$&'"()*+,;=:@]|%[0-9a-f]{2})+(?:\/(?:[a-z0-9\-._~!$&'"()*+,;=:@]|%[0-9a-f]{2})*)*)?(?:\?(?:[a-z0-9\-._~!$&'"()*+,;=:@/?]|%[0-9a-f]{2})*)?(?:#(?:[a-z0-9\-._~!$&'"()*+,;=:@/?]|%[0-9a-f]{2})*)?$/i;
// uri-template: https://tools.ietf.org/html/rfc6570
var URITEMPLATE = /^(?:(?:[^\x00-\x20"'<>%\\^`{|}]|%[0-9a-f]{2})|\{[+#./;?&=,!@|]?(?:[a-z0-9_]|%[0-9a-f]{2})+(?::[1-9][0-9]{0,3}|\*)?(?:,(?:[a-z0-9_]|%[0-9a-f]{2})+(?::[1-9][0-9]{0,3}|\*)?)*\})*$/i;
// For the source: https://gist.github.com/dperini/729294
// For test cases: https://mathiasbynens.be/demo/url-regex
// @todo Delete current URL in favour of the commented out URL rule when this issue is fixed https://github.com/eslint/eslint/issues/7983.
// var URL = /^(?:(?:https?|ftp):\/\/)(?:\S+(?::\S*)?@)?(?:(?!10(?:\.\d{1,3}){3})(?!127(?:\.\d{1,3}){3})(?!169\.254(?:\.\d{1,3}){2})(?!192\.168(?:\.\d{1,3}){2})(?!172\.(?:1[6-9]|2\d|3[0-1])(?:\.\d{1,3}){2})(?:[1-9]\d?|1\d\d|2[01]\d|22[0-3])(?:\.(?:1?\d{1,2}|2[0-4]\d|25[0-5])){2}(?:\.(?:[1-9]\d?|1\d\d|2[0-4]\d|25[0-4]))|(?:(?:[a-z\u{00a1}-\u{ffff}0-9]+-?)*[a-z\u{00a1}-\u{ffff}0-9]+)(?:\.(?:[a-z\u{00a1}-\u{ffff}0-9]+-?)*[a-z\u{00a1}-\u{ffff}0-9]+)*(?:\.(?:[a-z\u{00a1}-\u{ffff}]{2,})))(?::\d{2,5})?(?:\/[^\s]*)?$/iu;
var URL = /^(?:(?:http[s\u017F]?|ftp):\/\/)(?:(?:[\0-\x08\x0E-\x1F!-\x9F\xA1-\u167F\u1681-\u1FFF\u200B-\u2027\u202A-\u202E\u2030-\u205E\u2060-\u2FFF\u3001-\uD7FF\uE000-\uFEFE\uFF00-\uFFFF]|[\uD800-\uDBFF][\uDC00-\uDFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF])+(?::(?:[\0-\x08\x0E-\x1F!-\x9F\xA1-\u167F\u1681-\u1FFF\u200B-\u2027\u202A-\u202E\u2030-\u205E\u2060-\u2FFF\u3001-\uD7FF\uE000-\uFEFE\uFF00-\uFFFF]|[\uD800-\uDBFF][\uDC00-\uDFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF])*)?@)?(?:(?!10(?:\.[0-9]{1,3}){3})(?!127(?:\.[0-9]{1,3}){3})(?!169\.254(?:\.[0-9]{1,3}){2})(?!192\.168(?:\.[0-9]{1,3}){2})(?!172\.(?:1[6-9]|2[0-9]|3[01])(?:\.[0-9]{1,3}){2})(?:[1-9][0-9]?|1[0-9][0-9]|2[01][0-9]|22[0-3])(?:\.(?:1?[0-9]{1,2}|2[0-4][0-9]|25[0-5])){2}(?:\.(?:[1-9][0-9]?|1[0-9][0-9]|2[0-4][0-9]|25[0-4]))|(?:(?:(?:[0-9KSa-z\xA1-\uD7FF\uE000-\uFFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF])+-?)*(?:[0-9KSa-z\xA1-\uD7FF\uE000-\uFFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF])+)(?:\.(?:(?:[0-9KSa-z\xA1-\uD7FF\uE000-\uFFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF])+-?)*(?:[0-9KSa-z\xA1-\uD7FF\uE000-\uFFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF])+)*(?:\.(?:(?:[KSa-z\xA1-\uD7FF\uE000-\uFFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF]){2,})))(?::[0-9]{2,5})?(?:\/(?:[\0-\x08\x0E-\x1F!-\x9F\xA1-\u167F\u1681-\u1FFF\u200B-\u2027\u202A-\u202E\u2030-\u205E\u2060-\u2FFF\u3001-\uD7FF\uE000-\uFEFE\uFF00-\uFFFF]|[\uD800-\uDBFF][\uDC00-\uDFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF])*)?$/i;
var UUID = /^(?:urn:uuid:)?[0-9a-f]{8}-(?:[0-9a-f]{4}-){3}[0-9a-f]{12}$/i;
var JSON_POINTER = /^(?:\/(?:[^~/]|~0|~1)*)*$/;
var JSON_POINTER_URI_FRAGMENT = /^#(?:\/(?:[a-z0-9_\-.!$&'()*+,;:=@]|%[0-9a-f]{2}|~0|~1)*)*$/i;
var RELATIVE_JSON_POINTER = /^(?:0|[1-9][0-9]*)(?:#|(?:\/(?:[^~/]|~0|~1)*)*)$/;


module.exports = formats;

function formats(mode) {
  mode = mode == 'full' ? 'full' : 'fast';
  return util.copy(formats[mode]);
}


formats.fast = {
  // date: http://tools.ietf.org/html/rfc3339#section-5.6
  date: /^\d\d\d\d-[0-1]\d-[0-3]\d$/,
  // date-time: http://tools.ietf.org/html/rfc3339#section-5.6
  time: /^(?:[0-2]\d:[0-5]\d:[0-5]\d|23:59:60)(?:\.\d+)?(?:z|[+-]\d\d:\d\d)?$/i,
  'date-time': /^\d\d\d\d-[0-1]\d-[0-3]\d[t\s](?:[0-2]\d:[0-5]\d:[0-5]\d|23:59:60)(?:\.\d+)?(?:z|[+-]\d\d:\d\d)$/i,
  // uri: https://github.com/mafintosh/is-my-json-valid/blob/master/formats.js
  uri: /^(?:[a-z][a-z0-9+-.]*:)(?:\/?\/)?[^\s]*$/i,
  'uri-reference': /^(?:(?:[a-z][a-z0-9+-.]*:)?\/?\/)?(?:[^\\\s#][^\s#]*)?(?:#[^\\\s]*)?$/i,
  'uri-template': URITEMPLATE,
  url: URL,
  // email (sources from jsen validator):
  // http://stackoverflow.com/questions/201323/using-a-regular-expression-to-validate-an-email-address#answer-8829363
  // http://www.w3.org/TR/html5/forms.html#valid-e-mail-address (search for 'willful violation')
  email: /^[a-z0-9.!#$%&'*+/=?^_`{|}~-]+@[a-z0-9](?:[a-z0-9-]{0,61}[a-z0-9])?(?:\.[a-z0-9](?:[a-z0-9-]{0,61}[a-z0-9])?)*$/i,
  hostname: HOSTNAME,
  // optimized https://www.safaribooksonline.com/library/view/regular-expressions-cookbook/9780596802837/ch07s16.html
  ipv4: /^(?:(?:25[0-5]|2[0-4]\d|[01]?\d\d?)\.){3}(?:25[0-5]|2[0-4]\d|[01]?\d\d?)$/,
  // optimized http://stackoverflow.com/questions/53497/regular-expression-that-matches-valid-ipv6-addresses
  ipv6: /^\s*(?:(?:(?:[0-9a-f]{1,4}:){7}(?:[0-9a-f]{1,4}|:))|(?:(?:[0-9a-f]{1,4}:){6}(?::[0-9a-f]{1,4}|(?:(?:25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(?:\.(?:25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(?:(?:[0-9a-f]{1,4}:){5}(?:(?:(?::[0-9a-f]{1,4}){1,2})|:(?:(?:25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(?:\.(?:25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(?:(?:[0-9a-f]{1,4}:){4}(?:(?:(?::[0-9a-f]{1,4}){1,3})|(?:(?::[0-9a-f]{1,4})?:(?:(?:25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(?:\.(?:25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(?:(?:[0-9a-f]{1,4}:){3}(?:(?:(?::[0-9a-f]{1,4}){1,4})|(?:(?::[0-9a-f]{1,4}){0,2}:(?:(?:25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(?:\.(?:25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(?:(?:[0-9a-f]{1,4}:){2}(?:(?:(?::[0-9a-f]{1,4}){1,5})|(?:(?::[0-9a-f]{1,4}){0,3}:(?:(?:25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(?:\.(?:25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(?:(?:[0-9a-f]{1,4}:){1}(?:(?:(?::[0-9a-f]{1,4}){1,6})|(?:(?::[0-9a-f]{1,4}){0,4}:(?:(?:25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(?:\.(?:25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(?::(?:(?:(?::[0-9a-f]{1,4}){1,7})|(?:(?::[0-9a-f]{1,4}){0,5}:(?:(?:25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(?:\.(?:25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:)))(?:%.+)?\s*$/i,
  regex: regex,
  // uuid: http://tools.ietf.org/html/rfc4122
  uuid: UUID,
  // JSON-pointer: https://tools.ietf.org/html/rfc6901
  // uri fragment: https://tools.ietf.org/html/rfc3986#appendix-A
  'json-pointer': JSON_POINTER,
  'json-pointer-uri-fragment': JSON_POINTER_URI_FRAGMENT,
  // relative JSON-pointer: http://tools.ietf.org/html/draft-luff-relative-json-pointer-00
  'relative-json-pointer': RELATIVE_JSON_POINTER
};


formats.full = {
  date: date,
  time: time,
  'date-time': date_time,
  uri: uri,
  'uri-reference': URIREF,
  'uri-template': URITEMPLATE,
  url: URL,
  email: /^[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?$/i,
  hostname: hostname,
  ipv4: /^(?:(?:25[0-5]|2[0-4]\d|[01]?\d\d?)\.){3}(?:25[0-5]|2[0-4]\d|[01]?\d\d?)$/,
  ipv6: /^\s*(?:(?:(?:[0-9a-f]{1,4}:){7}(?:[0-9a-f]{1,4}|:))|(?:(?:[0-9a-f]{1,4}:){6}(?::[0-9a-f]{1,4}|(?:(?:25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(?:\.(?:25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(?:(?:[0-9a-f]{1,4}:){5}(?:(?:(?::[0-9a-f]{1,4}){1,2})|:(?:(?:25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(?:\.(?:25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(?:(?:[0-9a-f]{1,4}:){4}(?:(?:(?::[0-9a-f]{1,4}){1,3})|(?:(?::[0-9a-f]{1,4})?:(?:(?:25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(?:\.(?:25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(?:(?:[0-9a-f]{1,4}:){3}(?:(?:(?::[0-9a-f]{1,4}){1,4})|(?:(?::[0-9a-f]{1,4}){0,2}:(?:(?:25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(?:\.(?:25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(?:(?:[0-9a-f]{1,4}:){2}(?:(?:(?::[0-9a-f]{1,4}){1,5})|(?:(?::[0-9a-f]{1,4}){0,3}:(?:(?:25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(?:\.(?:25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(?:(?:[0-9a-f]{1,4}:){1}(?:(?:(?::[0-9a-f]{1,4}){1,6})|(?:(?::[0-9a-f]{1,4}){0,4}:(?:(?:25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(?:\.(?:25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(?::(?:(?:(?::[0-9a-f]{1,4}){1,7})|(?:(?::[0-9a-f]{1,4}){0,5}:(?:(?:25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(?:\.(?:25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:)))(?:%.+)?\s*$/i,
  regex: regex,
  uuid: UUID,
  'json-pointer': JSON_POINTER,
  'json-pointer-uri-fragment': JSON_POINTER_URI_FRAGMENT,
  'relative-json-pointer': RELATIVE_JSON_POINTER
};


function isLeapYear(year) {
  // https://tools.ietf.org/html/rfc3339#appendix-C
  return year % 4 === 0 && (year % 100 !== 0 || year % 400 === 0);
}


function date(str) {
  // full-date from http://tools.ietf.org/html/rfc3339#section-5.6
  var matches = str.match(DATE);
  if (!matches) return false;

  var year = +matches[1];
  var month = +matches[2];
  var day = +matches[3];

  return month >= 1 && month <= 12 && day >= 1 &&
          day <= (month == 2 && isLeapYear(year) ? 29 : DAYS[month]);
}


function time(str, full) {
  var matches = str.match(TIME);
  if (!matches) return false;

  var hour = matches[1];
  var minute = matches[2];
  var second = matches[3];
  var timeZone = matches[5];
  return ((hour <= 23 && minute <= 59 && second <= 59) ||
          (hour == 23 && minute == 59 && second == 60)) &&
         (!full || timeZone);
}


var DATE_TIME_SEPARATOR = /t|\s/i;
function date_time(str) {
  // http://tools.ietf.org/html/rfc3339#section-5.6
  var dateTime = str.split(DATE_TIME_SEPARATOR);
  return dateTime.length == 2 && date(dateTime[0]) && time(dateTime[1], true);
}


function hostname(str) {
  // https://tools.ietf.org/html/rfc1034#section-3.5
  // https://tools.ietf.org/html/rfc1123#section-2
  return str.length <= 255 && HOSTNAME.test(str);
}


var NOT_URI_FRAGMENT = /\/|:/;
function uri(str) {
  // http://jmrware.com/articles/2009/uri_regexp/URI_regex.html + optional protocol + required "."
  return NOT_URI_FRAGMENT.test(str) && URI.test(str);
}


var Z_ANCHOR = /[^\\]\\Z/;
function regex(str) {
  if (Z_ANCHOR.test(str)) return false;
  try {
    new RegExp(str);
    return true;
  } catch(e) {
    return false;
  }
}

},{"./util":11}],6:[function(require,module,exports){
'use strict';

var resolve = require('./resolve')
  , util = require('./util')
  , errorClasses = require('./error_classes')
  , stableStringify = require('fast-json-stable-stringify');

var validateGenerator = require('../dotjs/validate');

/**
 * Functions below are used inside compiled validations function
 */

var ucs2length = util.ucs2length;
var equal = require('fast-deep-equal');

// this error is thrown by async schemas to return validation errors via exception
var ValidationError = errorClasses.Validation;

module.exports = compile;


/**
 * Compiles schema to validation function
 * @this   Ajv
 * @param  {Object} schema schema object
 * @param  {Object} root object with information about the root schema for this schema
 * @param  {Object} localRefs the hash of local references inside the schema (created by resolve.id), used for inline resolution
 * @param  {String} baseId base ID for IDs in the schema
 * @return {Function} validation function
 */
function compile(schema, root, localRefs, baseId) {
  /* jshint validthis: true, evil: true */
  /* eslint no-shadow: 0 */
  var self = this
    , opts = this._opts
    , refVal = [ undefined ]
    , refs = {}
    , patterns = []
    , patternsHash = {}
    , defaults = []
    , defaultsHash = {}
    , customRules = [];

  root = root || { schema: schema, refVal: refVal, refs: refs };

  var c = checkCompiling.call(this, schema, root, baseId);
  var compilation = this._compilations[c.index];
  if (c.compiling) return (compilation.callValidate = callValidate);

  var formats = this._formats;
  var RULES = this.RULES;

  try {
    var v = localCompile(schema, root, localRefs, baseId);
    compilation.validate = v;
    var cv = compilation.callValidate;
    if (cv) {
      cv.schema = v.schema;
      cv.errors = null;
      cv.refs = v.refs;
      cv.refVal = v.refVal;
      cv.root = v.root;
      cv.$async = v.$async;
      if (opts.sourceCode) cv.source = v.source;
    }
    return v;
  } finally {
    endCompiling.call(this, schema, root, baseId);
  }

  /* @this   {*} - custom context, see passContext option */
  function callValidate() {
    /* jshint validthis: true */
    var validate = compilation.validate;
    var result = validate.apply(this, arguments);
    callValidate.errors = validate.errors;
    return result;
  }

  function localCompile(_schema, _root, localRefs, baseId) {
    var isRoot = !_root || (_root && _root.schema == _schema);
    if (_root.schema != root.schema)
      return compile.call(self, _schema, _root, localRefs, baseId);

    var $async = _schema.$async === true;

    var sourceCode = validateGenerator({
      isTop: true,
      schema: _schema,
      isRoot: isRoot,
      baseId: baseId,
      root: _root,
      schemaPath: '',
      errSchemaPath: '#',
      errorPath: '""',
      MissingRefError: errorClasses.MissingRef,
      RULES: RULES,
      validate: validateGenerator,
      util: util,
      resolve: resolve,
      resolveRef: resolveRef,
      usePattern: usePattern,
      useDefault: useDefault,
      useCustomRule: useCustomRule,
      opts: opts,
      formats: formats,
      logger: self.logger,
      self: self
    });

    sourceCode = vars(refVal, refValCode) + vars(patterns, patternCode)
                   + vars(defaults, defaultCode) + vars(customRules, customRuleCode)
                   + sourceCode;

    if (opts.processCode) sourceCode = opts.processCode(sourceCode);
    // console.log('\n\n\n *** \n', JSON.stringify(sourceCode));
    var validate;
    try {
      var makeValidate = new Function(
        'self',
        'RULES',
        'formats',
        'root',
        'refVal',
        'defaults',
        'customRules',
        'equal',
        'ucs2length',
        'ValidationError',
        sourceCode
      );

      validate = makeValidate(
        self,
        RULES,
        formats,
        root,
        refVal,
        defaults,
        customRules,
        equal,
        ucs2length,
        ValidationError
      );

      refVal[0] = validate;
    } catch(e) {
      self.logger.error('Error compiling schema, function code:', sourceCode);
      throw e;
    }

    validate.schema = _schema;
    validate.errors = null;
    validate.refs = refs;
    validate.refVal = refVal;
    validate.root = isRoot ? validate : _root;
    if ($async) validate.$async = true;
    if (opts.sourceCode === true) {
      validate.source = {
        code: sourceCode,
        patterns: patterns,
        defaults: defaults
      };
    }

    return validate;
  }

  function resolveRef(baseId, ref, isRoot) {
    ref = resolve.url(baseId, ref);
    var refIndex = refs[ref];
    var _refVal, refCode;
    if (refIndex !== undefined) {
      _refVal = refVal[refIndex];
      refCode = 'refVal[' + refIndex + ']';
      return resolvedRef(_refVal, refCode);
    }
    if (!isRoot && root.refs) {
      var rootRefId = root.refs[ref];
      if (rootRefId !== undefined) {
        _refVal = root.refVal[rootRefId];
        refCode = addLocalRef(ref, _refVal);
        return resolvedRef(_refVal, refCode);
      }
    }

    refCode = addLocalRef(ref);
    var v = resolve.call(self, localCompile, root, ref);
    if (v === undefined) {
      var localSchema = localRefs && localRefs[ref];
      if (localSchema) {
        v = resolve.inlineRef(localSchema, opts.inlineRefs)
            ? localSchema
            : compile.call(self, localSchema, root, localRefs, baseId);
      }
    }

    if (v === undefined) {
      removeLocalRef(ref);
    } else {
      replaceLocalRef(ref, v);
      return resolvedRef(v, refCode);
    }
  }

  function addLocalRef(ref, v) {
    var refId = refVal.length;
    refVal[refId] = v;
    refs[ref] = refId;
    return 'refVal' + refId;
  }

  function removeLocalRef(ref) {
    delete refs[ref];
  }

  function replaceLocalRef(ref, v) {
    var refId = refs[ref];
    refVal[refId] = v;
  }

  function resolvedRef(refVal, code) {
    return typeof refVal == 'object' || typeof refVal == 'boolean'
            ? { code: code, schema: refVal, inline: true }
            : { code: code, $async: refVal && !!refVal.$async };
  }

  function usePattern(regexStr) {
    var index = patternsHash[regexStr];
    if (index === undefined) {
      index = patternsHash[regexStr] = patterns.length;
      patterns[index] = regexStr;
    }
    return 'pattern' + index;
  }

  function useDefault(value) {
    switch (typeof value) {
      case 'boolean':
      case 'number':
        return '' + value;
      case 'string':
        return util.toQuotedString(value);
      case 'object':
        if (value === null) return 'null';
        var valueStr = stableStringify(value);
        var index = defaultsHash[valueStr];
        if (index === undefined) {
          index = defaultsHash[valueStr] = defaults.length;
          defaults[index] = value;
        }
        return 'default' + index;
    }
  }

  function useCustomRule(rule, schema, parentSchema, it) {
    if (self._opts.validateSchema !== false) {
      var deps = rule.definition.dependencies;
      if (deps && !deps.every(function(keyword) {
        return Object.prototype.hasOwnProperty.call(parentSchema, keyword);
      }))
        throw new Error('parent schema must have all required keywords: ' + deps.join(','));

      var validateSchema = rule.definition.validateSchema;
      if (validateSchema) {
        var valid = validateSchema(schema);
        if (!valid) {
          var message = 'keyword schema is invalid: ' + self.errorsText(validateSchema.errors);
          if (self._opts.validateSchema == 'log') self.logger.error(message);
          else throw new Error(message);
        }
      }
    }

    var compile = rule.definition.compile
      , inline = rule.definition.inline
      , macro = rule.definition.macro;

    var validate;
    if (compile) {
      validate = compile.call(self, schema, parentSchema, it);
    } else if (macro) {
      validate = macro.call(self, schema, parentSchema, it);
      if (opts.validateSchema !== false) self.validateSchema(validate, true);
    } else if (inline) {
      validate = inline.call(self, it, rule.keyword, schema, parentSchema);
    } else {
      validate = rule.definition.validate;
      if (!validate) return;
    }

    if (validate === undefined)
      throw new Error('custom keyword "' + rule.keyword + '"failed to compile');

    var index = customRules.length;
    customRules[index] = validate;

    return {
      code: 'customRule' + index,
      validate: validate
    };
  }
}


/**
 * Checks if the schema is currently compiled
 * @this   Ajv
 * @param  {Object} schema schema to compile
 * @param  {Object} root root object
 * @param  {String} baseId base schema ID
 * @return {Object} object with properties "index" (compilation index) and "compiling" (boolean)
 */
function checkCompiling(schema, root, baseId) {
  /* jshint validthis: true */
  var index = compIndex.call(this, schema, root, baseId);
  if (index >= 0) return { index: index, compiling: true };
  index = this._compilations.length;
  this._compilations[index] = {
    schema: schema,
    root: root,
    baseId: baseId
  };
  return { index: index, compiling: false };
}


/**
 * Removes the schema from the currently compiled list
 * @this   Ajv
 * @param  {Object} schema schema to compile
 * @param  {Object} root root object
 * @param  {String} baseId base schema ID
 */
function endCompiling(schema, root, baseId) {
  /* jshint validthis: true */
  var i = compIndex.call(this, schema, root, baseId);
  if (i >= 0) this._compilations.splice(i, 1);
}


/**
 * Index of schema compilation in the currently compiled list
 * @this   Ajv
 * @param  {Object} schema schema to compile
 * @param  {Object} root root object
 * @param  {String} baseId base schema ID
 * @return {Integer} compilation index
 */
function compIndex(schema, root, baseId) {
  /* jshint validthis: true */
  for (var i=0; i<this._compilations.length; i++) {
    var c = this._compilations[i];
    if (c.schema == schema && c.root == root && c.baseId == baseId) return i;
  }
  return -1;
}


function patternCode(i, patterns) {
  return 'var pattern' + i + ' = new RegExp(' + util.toQuotedString(patterns[i]) + ');';
}


function defaultCode(i) {
  return 'var default' + i + ' = defaults[' + i + '];';
}


function refValCode(i, refVal) {
  return refVal[i] === undefined ? '' : 'var refVal' + i + ' = refVal[' + i + '];';
}


function customRuleCode(i) {
  return 'var customRule' + i + ' = customRules[' + i + '];';
}


function vars(arr, statement) {
  if (!arr.length) return '';
  var code = '';
  for (var i=0; i<arr.length; i++)
    code += statement(i, arr);
  return code;
}

},{"../dotjs/validate":39,"./error_classes":4,"./resolve":7,"./util":11,"fast-deep-equal":43,"fast-json-stable-stringify":56}],7:[function(require,module,exports){
'use strict';

var URI = require('uri-js')
  , equal = require('fast-deep-equal')
  , util = require('./util')
  , SchemaObject = require('./schema_obj')
  , traverse = require('json-schema-traverse');

module.exports = resolve;

resolve.normalizeId = normalizeId;
resolve.fullPath = getFullPath;
resolve.url = resolveUrl;
resolve.ids = resolveIds;
resolve.inlineRef = inlineRef;
resolve.schema = resolveSchema;

/**
 * [resolve and compile the references ($ref)]
 * @this   Ajv
 * @param  {Function} compile reference to schema compilation funciton (localCompile)
 * @param  {Object} root object with information about the root schema for the current schema
 * @param  {String} ref reference to resolve
 * @return {Object|Function} schema object (if the schema can be inlined) or validation function
 */
function resolve(compile, root, ref) {
  /* jshint validthis: true */
  var refVal = this._refs[ref];
  if (typeof refVal == 'string') {
    if (this._refs[refVal]) refVal = this._refs[refVal];
    else return resolve.call(this, compile, root, refVal);
  }

  refVal = refVal || this._schemas[ref];
  if (refVal instanceof SchemaObject) {
    return inlineRef(refVal.schema, this._opts.inlineRefs)
            ? refVal.schema
            : refVal.validate || this._compile(refVal);
  }

  var res = resolveSchema.call(this, root, ref);
  var schema, v, baseId;
  if (res) {
    schema = res.schema;
    root = res.root;
    baseId = res.baseId;
  }

  if (schema instanceof SchemaObject) {
    v = schema.validate || compile.call(this, schema.schema, root, undefined, baseId);
  } else if (schema !== undefined) {
    v = inlineRef(schema, this._opts.inlineRefs)
        ? schema
        : compile.call(this, schema, root, undefined, baseId);
  }

  return v;
}


/**
 * Resolve schema, its root and baseId
 * @this Ajv
 * @param  {Object} root root object with properties schema, refVal, refs
 * @param  {String} ref  reference to resolve
 * @return {Object} object with properties schema, root, baseId
 */
function resolveSchema(root, ref) {
  /* jshint validthis: true */
  var p = URI.parse(ref)
    , refPath = _getFullPath(p)
    , baseId = getFullPath(this._getId(root.schema));
  if (Object.keys(root.schema).length === 0 || refPath !== baseId) {
    var id = normalizeId(refPath);
    var refVal = this._refs[id];
    if (typeof refVal == 'string') {
      return resolveRecursive.call(this, root, refVal, p);
    } else if (refVal instanceof SchemaObject) {
      if (!refVal.validate) this._compile(refVal);
      root = refVal;
    } else {
      refVal = this._schemas[id];
      if (refVal instanceof SchemaObject) {
        if (!refVal.validate) this._compile(refVal);
        if (id == normalizeId(ref))
          return { schema: refVal, root: root, baseId: baseId };
        root = refVal;
      } else {
        return;
      }
    }
    if (!root.schema) return;
    baseId = getFullPath(this._getId(root.schema));
  }
  return getJsonPointer.call(this, p, baseId, root.schema, root);
}


/* @this Ajv */
function resolveRecursive(root, ref, parsedRef) {
  /* jshint validthis: true */
  var res = resolveSchema.call(this, root, ref);
  if (res) {
    var schema = res.schema;
    var baseId = res.baseId;
    root = res.root;
    var id = this._getId(schema);
    if (id) baseId = resolveUrl(baseId, id);
    return getJsonPointer.call(this, parsedRef, baseId, schema, root);
  }
}


var PREVENT_SCOPE_CHANGE = util.toHash(['properties', 'patternProperties', 'enum', 'dependencies', 'definitions']);
/* @this Ajv */
function getJsonPointer(parsedRef, baseId, schema, root) {
  /* jshint validthis: true */
  parsedRef.fragment = parsedRef.fragment || '';
  if (parsedRef.fragment.slice(0,1) != '/') return;
  var parts = parsedRef.fragment.split('/');

  for (var i = 1; i < parts.length; i++) {
    var part = parts[i];
    if (part) {
      part = util.unescapeFragment(part);
      schema = schema[part];
      if (schema === undefined) break;
      var id;
      if (!PREVENT_SCOPE_CHANGE[part]) {
        id = this._getId(schema);
        if (id) baseId = resolveUrl(baseId, id);
        if (schema.$ref) {
          var $ref = resolveUrl(baseId, schema.$ref);
          var res = resolveSchema.call(this, root, $ref);
          if (res) {
            schema = res.schema;
            root = res.root;
            baseId = res.baseId;
          }
        }
      }
    }
  }
  if (schema !== undefined && schema !== root.schema)
    return { schema: schema, root: root, baseId: baseId };
}


var SIMPLE_INLINED = util.toHash([
  'type', 'format', 'pattern',
  'maxLength', 'minLength',
  'maxProperties', 'minProperties',
  'maxItems', 'minItems',
  'maximum', 'minimum',
  'uniqueItems', 'multipleOf',
  'required', 'enum'
]);
function inlineRef(schema, limit) {
  if (limit === false) return false;
  if (limit === undefined || limit === true) return checkNoRef(schema);
  else if (limit) return countKeys(schema) <= limit;
}


function checkNoRef(schema) {
  var item;
  if (Array.isArray(schema)) {
    for (var i=0; i<schema.length; i++) {
      item = schema[i];
      if (typeof item == 'object' && !checkNoRef(item)) return false;
    }
  } else {
    for (var key in schema) {
      if (key == '$ref') return false;
      item = schema[key];
      if (typeof item == 'object' && !checkNoRef(item)) return false;
    }
  }
  return true;
}


function countKeys(schema) {
  var count = 0, item;
  if (Array.isArray(schema)) {
    for (var i=0; i<schema.length; i++) {
      item = schema[i];
      if (typeof item == 'object') count += countKeys(item);
      if (count == Infinity) return Infinity;
    }
  } else {
    for (var key in schema) {
      if (key == '$ref') return Infinity;
      if (SIMPLE_INLINED[key]) {
        count++;
      } else {
        item = schema[key];
        if (typeof item == 'object') count += countKeys(item) + 1;
        if (count == Infinity) return Infinity;
      }
    }
  }
  return count;
}


function getFullPath(id, normalize) {
  if (normalize !== false) id = normalizeId(id);
  var p = URI.parse(id);
  return _getFullPath(p);
}


function _getFullPath(p) {
  return URI.serialize(p).split('#')[0] + '#';
}


var TRAILING_SLASH_HASH = /#\/?$/;
function normalizeId(id) {
  return id ? id.replace(TRAILING_SLASH_HASH, '') : '';
}


function resolveUrl(baseId, id) {
  id = normalizeId(id);
  return URI.resolve(baseId, id);
}


/* @this Ajv */
function resolveIds(schema) {
  var schemaId = normalizeId(this._getId(schema));
  var baseIds = {'': schemaId};
  var fullPaths = {'': getFullPath(schemaId, false)};
  var localRefs = {};
  var self = this;

  traverse(schema, {allKeys: true}, function(sch, jsonPtr, rootSchema, parentJsonPtr, parentKeyword, parentSchema, keyIndex) {
    if (jsonPtr === '') return;
    var id = self._getId(sch);
    var baseId = baseIds[parentJsonPtr];
    var fullPath = fullPaths[parentJsonPtr] + '/' + parentKeyword;
    if (keyIndex !== undefined)
      fullPath += '/' + (typeof keyIndex == 'number' ? keyIndex : util.escapeFragment(keyIndex));

    if (typeof id == 'string') {
      id = baseId = normalizeId(baseId ? URI.resolve(baseId, id) : id);

      var refVal = self._refs[id];
      if (typeof refVal == 'string') refVal = self._refs[refVal];
      if (refVal && refVal.schema) {
        if (!equal(sch, refVal.schema))
          throw new Error('id "' + id + '" resolves to more than one schema');
      } else if (id != normalizeId(fullPath)) {
        if (id[0] == '#') {
          if (localRefs[id] && !equal(sch, localRefs[id]))
            throw new Error('id "' + id + '" resolves to more than one schema');
          localRefs[id] = sch;
        } else {
          self._refs[id] = fullPath;
        }
      }
    }
    baseIds[jsonPtr] = baseId;
    fullPaths[jsonPtr] = fullPath;
  });

  return localRefs;
}

},{"./schema_obj":9,"./util":11,"fast-deep-equal":43,"json-schema-traverse":44,"uri-js":291}],8:[function(require,module,exports){
'use strict';

var ruleModules = require('../dotjs')
  , toHash = require('./util').toHash;

module.exports = function rules() {
  var RULES = [
    { type: 'number',
      rules: [ { 'maximum': ['exclusiveMaximum'] },
               { 'minimum': ['exclusiveMinimum'] }, 'multipleOf', 'format'] },
    { type: 'string',
      rules: [ 'maxLength', 'minLength', 'pattern', 'format' ] },
    { type: 'array',
      rules: [ 'maxItems', 'minItems', 'items', 'contains', 'uniqueItems' ] },
    { type: 'object',
      rules: [ 'maxProperties', 'minProperties', 'required', 'dependencies', 'propertyNames',
               { 'properties': ['additionalProperties', 'patternProperties'] } ] },
    { rules: [ '$ref', 'const', 'enum', 'not', 'anyOf', 'oneOf', 'allOf', 'if' ] }
  ];

  var ALL = [ 'type', '$comment' ];
  var KEYWORDS = [
    '$schema', '$id', 'id', '$data', '$async', 'title',
    'description', 'default', 'definitions',
    'examples', 'readOnly', 'writeOnly',
    'contentMediaType', 'contentEncoding',
    'additionalItems', 'then', 'else'
  ];
  var TYPES = [ 'number', 'integer', 'string', 'array', 'object', 'boolean', 'null' ];
  RULES.all = toHash(ALL);
  RULES.types = toHash(TYPES);

  RULES.forEach(function (group) {
    group.rules = group.rules.map(function (keyword) {
      var implKeywords;
      if (typeof keyword == 'object') {
        var key = Object.keys(keyword)[0];
        implKeywords = keyword[key];
        keyword = key;
        implKeywords.forEach(function (k) {
          ALL.push(k);
          RULES.all[k] = true;
        });
      }
      ALL.push(keyword);
      var rule = RULES.all[keyword] = {
        keyword: keyword,
        code: ruleModules[keyword],
        implements: implKeywords
      };
      return rule;
    });

    RULES.all.$comment = {
      keyword: '$comment',
      code: ruleModules.$comment
    };

    if (group.type) RULES.types[group.type] = group;
  });

  RULES.keywords = toHash(ALL.concat(KEYWORDS));
  RULES.custom = {};

  return RULES;
};

},{"../dotjs":28,"./util":11}],9:[function(require,module,exports){
'use strict';

var util = require('./util');

module.exports = SchemaObject;

function SchemaObject(obj) {
  util.copy(obj, this);
}

},{"./util":11}],10:[function(require,module,exports){
'use strict';

// https://mathiasbynens.be/notes/javascript-encoding
// https://github.com/bestiejs/punycode.js - punycode.ucs2.decode
module.exports = function ucs2length(str) {
  var length = 0
    , len = str.length
    , pos = 0
    , value;
  while (pos < len) {
    length++;
    value = str.charCodeAt(pos++);
    if (value >= 0xD800 && value <= 0xDBFF && pos < len) {
      // high surrogate, and there is a next character
      value = str.charCodeAt(pos);
      if ((value & 0xFC00) == 0xDC00) pos++; // low surrogate
    }
  }
  return length;
};

},{}],11:[function(require,module,exports){
'use strict';


module.exports = {
  copy: copy,
  checkDataType: checkDataType,
  checkDataTypes: checkDataTypes,
  coerceToTypes: coerceToTypes,
  toHash: toHash,
  getProperty: getProperty,
  escapeQuotes: escapeQuotes,
  equal: require('fast-deep-equal'),
  ucs2length: require('./ucs2length'),
  varOccurences: varOccurences,
  varReplace: varReplace,
  cleanUpCode: cleanUpCode,
  finalCleanUpCode: finalCleanUpCode,
  schemaHasRules: schemaHasRules,
  schemaHasRulesExcept: schemaHasRulesExcept,
  schemaUnknownRules: schemaUnknownRules,
  toQuotedString: toQuotedString,
  getPathExpr: getPathExpr,
  getPath: getPath,
  getData: getData,
  unescapeFragment: unescapeFragment,
  unescapeJsonPointer: unescapeJsonPointer,
  escapeFragment: escapeFragment,
  escapeJsonPointer: escapeJsonPointer
};


function copy(o, to) {
  to = to || {};
  for (var key in o) to[key] = o[key];
  return to;
}


function checkDataType(dataType, data, negate) {
  var EQUAL = negate ? ' !== ' : ' === '
    , AND = negate ? ' || ' : ' && '
    , OK = negate ? '!' : ''
    , NOT = negate ? '' : '!';
  switch (dataType) {
    case 'null': return data + EQUAL + 'null';
    case 'array': return OK + 'Array.isArray(' + data + ')';
    case 'object': return '(' + OK + data + AND +
                          'typeof ' + data + EQUAL + '"object"' + AND +
                          NOT + 'Array.isArray(' + data + '))';
    case 'integer': return '(typeof ' + data + EQUAL + '"number"' + AND +
                           NOT + '(' + data + ' % 1)' +
                           AND + data + EQUAL + data + ')';
    default: return 'typeof ' + data + EQUAL + '"' + dataType + '"';
  }
}


function checkDataTypes(dataTypes, data) {
  switch (dataTypes.length) {
    case 1: return checkDataType(dataTypes[0], data, true);
    default:
      var code = '';
      var types = toHash(dataTypes);
      if (types.array && types.object) {
        code = types.null ? '(': '(!' + data + ' || ';
        code += 'typeof ' + data + ' !== "object")';
        delete types.null;
        delete types.array;
        delete types.object;
      }
      if (types.number) delete types.integer;
      for (var t in types)
        code += (code ? ' && ' : '' ) + checkDataType(t, data, true);

      return code;
  }
}


var COERCE_TO_TYPES = toHash([ 'string', 'number', 'integer', 'boolean', 'null' ]);
function coerceToTypes(optionCoerceTypes, dataTypes) {
  if (Array.isArray(dataTypes)) {
    var types = [];
    for (var i=0; i<dataTypes.length; i++) {
      var t = dataTypes[i];
      if (COERCE_TO_TYPES[t]) types[types.length] = t;
      else if (optionCoerceTypes === 'array' && t === 'array') types[types.length] = t;
    }
    if (types.length) return types;
  } else if (COERCE_TO_TYPES[dataTypes]) {
    return [dataTypes];
  } else if (optionCoerceTypes === 'array' && dataTypes === 'array') {
    return ['array'];
  }
}


function toHash(arr) {
  var hash = {};
  for (var i=0; i<arr.length; i++) hash[arr[i]] = true;
  return hash;
}


var IDENTIFIER = /^[a-z$_][a-z$_0-9]*$/i;
var SINGLE_QUOTE = /'|\\/g;
function getProperty(key) {
  return typeof key == 'number'
          ? '[' + key + ']'
          : IDENTIFIER.test(key)
            ? '.' + key
            : "['" + escapeQuotes(key) + "']";
}


function escapeQuotes(str) {
  return str.replace(SINGLE_QUOTE, '\\$&')
            .replace(/\n/g, '\\n')
            .replace(/\r/g, '\\r')
            .replace(/\f/g, '\\f')
            .replace(/\t/g, '\\t');
}


function varOccurences(str, dataVar) {
  dataVar += '[^0-9]';
  var matches = str.match(new RegExp(dataVar, 'g'));
  return matches ? matches.length : 0;
}


function varReplace(str, dataVar, expr) {
  dataVar += '([^0-9])';
  expr = expr.replace(/\$/g, '$$$$');
  return str.replace(new RegExp(dataVar, 'g'), expr + '$1');
}


var EMPTY_ELSE = /else\s*{\s*}/g
  , EMPTY_IF_NO_ELSE = /if\s*\([^)]+\)\s*\{\s*\}(?!\s*else)/g
  , EMPTY_IF_WITH_ELSE = /if\s*\(([^)]+)\)\s*\{\s*\}\s*else(?!\s*if)/g;
function cleanUpCode(out) {
  return out.replace(EMPTY_ELSE, '')
            .replace(EMPTY_IF_NO_ELSE, '')
            .replace(EMPTY_IF_WITH_ELSE, 'if (!($1))');
}


var ERRORS_REGEXP = /[^v.]errors/g
  , REMOVE_ERRORS = /var errors = 0;|var vErrors = null;|validate.errors = vErrors;/g
  , REMOVE_ERRORS_ASYNC = /var errors = 0;|var vErrors = null;/g
  , RETURN_VALID = 'return errors === 0;'
  , RETURN_TRUE = 'validate.errors = null; return true;'
  , RETURN_ASYNC = /if \(errors === 0\) return data;\s*else throw new ValidationError\(vErrors\);/
  , RETURN_DATA_ASYNC = 'return data;'
  , ROOTDATA_REGEXP = /[^A-Za-z_$]rootData[^A-Za-z0-9_$]/g
  , REMOVE_ROOTDATA = /if \(rootData === undefined\) rootData = data;/;

function finalCleanUpCode(out, async) {
  var matches = out.match(ERRORS_REGEXP);
  if (matches && matches.length == 2) {
    out = async
          ? out.replace(REMOVE_ERRORS_ASYNC, '')
               .replace(RETURN_ASYNC, RETURN_DATA_ASYNC)
          : out.replace(REMOVE_ERRORS, '')
               .replace(RETURN_VALID, RETURN_TRUE);
  }

  matches = out.match(ROOTDATA_REGEXP);
  if (!matches || matches.length !== 3) return out;
  return out.replace(REMOVE_ROOTDATA, '');
}


function schemaHasRules(schema, rules) {
  if (typeof schema == 'boolean') return !schema;
  for (var key in schema) if (rules[key]) return true;
}


function schemaHasRulesExcept(schema, rules, exceptKeyword) {
  if (typeof schema == 'boolean') return !schema && exceptKeyword != 'not';
  for (var key in schema) if (key != exceptKeyword && rules[key]) return true;
}


function schemaUnknownRules(schema, rules) {
  if (typeof schema == 'boolean') return;
  for (var key in schema) if (!rules[key]) return key;
}


function toQuotedString(str) {
  return '\'' + escapeQuotes(str) + '\'';
}


function getPathExpr(currentPath, expr, jsonPointers, isNumber) {
  var path = jsonPointers // false by default
              ? '\'/\' + ' + expr + (isNumber ? '' : '.replace(/~/g, \'~0\').replace(/\\//g, \'~1\')')
              : (isNumber ? '\'[\' + ' + expr + ' + \']\'' : '\'[\\\'\' + ' + expr + ' + \'\\\']\'');
  return joinPaths(currentPath, path);
}


function getPath(currentPath, prop, jsonPointers) {
  var path = jsonPointers // false by default
              ? toQuotedString('/' + escapeJsonPointer(prop))
              : toQuotedString(getProperty(prop));
  return joinPaths(currentPath, path);
}


var JSON_POINTER = /^\/(?:[^~]|~0|~1)*$/;
var RELATIVE_JSON_POINTER = /^([0-9]+)(#|\/(?:[^~]|~0|~1)*)?$/;
function getData($data, lvl, paths) {
  var up, jsonPointer, data, matches;
  if ($data === '') return 'rootData';
  if ($data[0] == '/') {
    if (!JSON_POINTER.test($data)) throw new Error('Invalid JSON-pointer: ' + $data);
    jsonPointer = $data;
    data = 'rootData';
  } else {
    matches = $data.match(RELATIVE_JSON_POINTER);
    if (!matches) throw new Error('Invalid JSON-pointer: ' + $data);
    up = +matches[1];
    jsonPointer = matches[2];
    if (jsonPointer == '#') {
      if (up >= lvl) throw new Error('Cannot access property/index ' + up + ' levels up, current level is ' + lvl);
      return paths[lvl - up];
    }

    if (up > lvl) throw new Error('Cannot access data ' + up + ' levels up, current level is ' + lvl);
    data = 'data' + ((lvl - up) || '');
    if (!jsonPointer) return data;
  }

  var expr = data;
  var segments = jsonPointer.split('/');
  for (var i=0; i<segments.length; i++) {
    var segment = segments[i];
    if (segment) {
      data += getProperty(unescapeJsonPointer(segment));
      expr += ' && ' + data;
    }
  }
  return expr;
}


function joinPaths (a, b) {
  if (a == '""') return b;
  return (a + ' + ' + b).replace(/' \+ '/g, '');
}


function unescapeFragment(str) {
  return unescapeJsonPointer(decodeURIComponent(str));
}


function escapeFragment(str) {
  return encodeURIComponent(escapeJsonPointer(str));
}


function escapeJsonPointer(str) {
  return str.replace(/~/g, '~0').replace(/\//g, '~1');
}


function unescapeJsonPointer(str) {
  return str.replace(/~1/g, '/').replace(/~0/g, '~');
}

},{"./ucs2length":10,"fast-deep-equal":43}],12:[function(require,module,exports){
'use strict';

var KEYWORDS = [
  'multipleOf',
  'maximum',
  'exclusiveMaximum',
  'minimum',
  'exclusiveMinimum',
  'maxLength',
  'minLength',
  'pattern',
  'additionalItems',
  'maxItems',
  'minItems',
  'uniqueItems',
  'maxProperties',
  'minProperties',
  'required',
  'additionalProperties',
  'enum',
  'format',
  'const'
];

module.exports = function (metaSchema, keywordsJsonPointers) {
  for (var i=0; i<keywordsJsonPointers.length; i++) {
    metaSchema = JSON.parse(JSON.stringify(metaSchema));
    var segments = keywordsJsonPointers[i].split('/');
    var keywords = metaSchema;
    var j;
    for (j=1; j<segments.length; j++)
      keywords = keywords[segments[j]];

    for (j=0; j<KEYWORDS.length; j++) {
      var key = KEYWORDS[j];
      var schema = keywords[key];
      if (schema) {
        keywords[key] = {
          anyOf: [
            schema,
            { $ref: 'https://raw.githubusercontent.com/epoberezkin/ajv/master/lib/refs/data.json#' }
          ]
        };
      }
    }
  }

  return metaSchema;
};

},{}],13:[function(require,module,exports){
'use strict';

var metaSchema = require('./refs/json-schema-draft-07.json');

module.exports = {
  $id: 'https://github.com/epoberezkin/ajv/blob/master/lib/definition_schema.js',
  definitions: {
    simpleTypes: metaSchema.definitions.simpleTypes
  },
  type: 'object',
  dependencies: {
    schema: ['validate'],
    $data: ['validate'],
    statements: ['inline'],
    valid: {not: {required: ['macro']}}
  },
  properties: {
    type: metaSchema.properties.type,
    schema: {type: 'boolean'},
    statements: {type: 'boolean'},
    dependencies: {
      type: 'array',
      items: {type: 'string'}
    },
    metaSchema: {type: 'object'},
    modifying: {type: 'boolean'},
    valid: {type: 'boolean'},
    $data: {type: 'boolean'},
    async: {type: 'boolean'},
    errors: {
      anyOf: [
        {type: 'boolean'},
        {const: 'full'}
      ]
    }
  }
};

},{"./refs/json-schema-draft-07.json":42}],14:[function(require,module,exports){
'use strict';
module.exports = function generate__limit(it, $keyword, $ruleType) {
  var out = ' ';
  var $lvl = it.level;
  var $dataLvl = it.dataLevel;
  var $schema = it.schema[$keyword];
  var $schemaPath = it.schemaPath + it.util.getProperty($keyword);
  var $errSchemaPath = it.errSchemaPath + '/' + $keyword;
  var $breakOnError = !it.opts.allErrors;
  var $errorKeyword;
  var $data = 'data' + ($dataLvl || '');
  var $isData = it.opts.$data && $schema && $schema.$data,
    $schemaValue;
  if ($isData) {
    out += ' var schema' + ($lvl) + ' = ' + (it.util.getData($schema.$data, $dataLvl, it.dataPathArr)) + '; ';
    $schemaValue = 'schema' + $lvl;
  } else {
    $schemaValue = $schema;
  }
  var $isMax = $keyword == 'maximum',
    $exclusiveKeyword = $isMax ? 'exclusiveMaximum' : 'exclusiveMinimum',
    $schemaExcl = it.schema[$exclusiveKeyword],
    $isDataExcl = it.opts.$data && $schemaExcl && $schemaExcl.$data,
    $op = $isMax ? '<' : '>',
    $notOp = $isMax ? '>' : '<',
    $errorKeyword = undefined;
  if ($isDataExcl) {
    var $schemaValueExcl = it.util.getData($schemaExcl.$data, $dataLvl, it.dataPathArr),
      $exclusive = 'exclusive' + $lvl,
      $exclType = 'exclType' + $lvl,
      $exclIsNumber = 'exclIsNumber' + $lvl,
      $opExpr = 'op' + $lvl,
      $opStr = '\' + ' + $opExpr + ' + \'';
    out += ' var schemaExcl' + ($lvl) + ' = ' + ($schemaValueExcl) + '; ';
    $schemaValueExcl = 'schemaExcl' + $lvl;
    out += ' var ' + ($exclusive) + '; var ' + ($exclType) + ' = typeof ' + ($schemaValueExcl) + '; if (' + ($exclType) + ' != \'boolean\' && ' + ($exclType) + ' != \'undefined\' && ' + ($exclType) + ' != \'number\') { ';
    var $errorKeyword = $exclusiveKeyword;
    var $$outStack = $$outStack || [];
    $$outStack.push(out);
    out = ''; /* istanbul ignore else */
    if (it.createErrors !== false) {
      out += ' { keyword: \'' + ($errorKeyword || '_exclusiveLimit') + '\' , dataPath: (dataPath || \'\') + ' + (it.errorPath) + ' , schemaPath: ' + (it.util.toQuotedString($errSchemaPath)) + ' , params: {} ';
      if (it.opts.messages !== false) {
        out += ' , message: \'' + ($exclusiveKeyword) + ' should be boolean\' ';
      }
      if (it.opts.verbose) {
        out += ' , schema: validate.schema' + ($schemaPath) + ' , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
      }
      out += ' } ';
    } else {
      out += ' {} ';
    }
    var __err = out;
    out = $$outStack.pop();
    if (!it.compositeRule && $breakOnError) {
      /* istanbul ignore if */
      if (it.async) {
        out += ' throw new ValidationError([' + (__err) + ']); ';
      } else {
        out += ' validate.errors = [' + (__err) + ']; return false; ';
      }
    } else {
      out += ' var err = ' + (__err) + ';  if (vErrors === null) vErrors = [err]; else vErrors.push(err); errors++; ';
    }
    out += ' } else if ( ';
    if ($isData) {
      out += ' (' + ($schemaValue) + ' !== undefined && typeof ' + ($schemaValue) + ' != \'number\') || ';
    }
    out += ' ' + ($exclType) + ' == \'number\' ? ( (' + ($exclusive) + ' = ' + ($schemaValue) + ' === undefined || ' + ($schemaValueExcl) + ' ' + ($op) + '= ' + ($schemaValue) + ') ? ' + ($data) + ' ' + ($notOp) + '= ' + ($schemaValueExcl) + ' : ' + ($data) + ' ' + ($notOp) + ' ' + ($schemaValue) + ' ) : ( (' + ($exclusive) + ' = ' + ($schemaValueExcl) + ' === true) ? ' + ($data) + ' ' + ($notOp) + '= ' + ($schemaValue) + ' : ' + ($data) + ' ' + ($notOp) + ' ' + ($schemaValue) + ' ) || ' + ($data) + ' !== ' + ($data) + ') { var op' + ($lvl) + ' = ' + ($exclusive) + ' ? \'' + ($op) + '\' : \'' + ($op) + '=\'; ';
    if ($schema === undefined) {
      $errorKeyword = $exclusiveKeyword;
      $errSchemaPath = it.errSchemaPath + '/' + $exclusiveKeyword;
      $schemaValue = $schemaValueExcl;
      $isData = $isDataExcl;
    }
  } else {
    var $exclIsNumber = typeof $schemaExcl == 'number',
      $opStr = $op;
    if ($exclIsNumber && $isData) {
      var $opExpr = '\'' + $opStr + '\'';
      out += ' if ( ';
      if ($isData) {
        out += ' (' + ($schemaValue) + ' !== undefined && typeof ' + ($schemaValue) + ' != \'number\') || ';
      }
      out += ' ( ' + ($schemaValue) + ' === undefined || ' + ($schemaExcl) + ' ' + ($op) + '= ' + ($schemaValue) + ' ? ' + ($data) + ' ' + ($notOp) + '= ' + ($schemaExcl) + ' : ' + ($data) + ' ' + ($notOp) + ' ' + ($schemaValue) + ' ) || ' + ($data) + ' !== ' + ($data) + ') { ';
    } else {
      if ($exclIsNumber && $schema === undefined) {
        $exclusive = true;
        $errorKeyword = $exclusiveKeyword;
        $errSchemaPath = it.errSchemaPath + '/' + $exclusiveKeyword;
        $schemaValue = $schemaExcl;
        $notOp += '=';
      } else {
        if ($exclIsNumber) $schemaValue = Math[$isMax ? 'min' : 'max']($schemaExcl, $schema);
        if ($schemaExcl === ($exclIsNumber ? $schemaValue : true)) {
          $exclusive = true;
          $errorKeyword = $exclusiveKeyword;
          $errSchemaPath = it.errSchemaPath + '/' + $exclusiveKeyword;
          $notOp += '=';
        } else {
          $exclusive = false;
          $opStr += '=';
        }
      }
      var $opExpr = '\'' + $opStr + '\'';
      out += ' if ( ';
      if ($isData) {
        out += ' (' + ($schemaValue) + ' !== undefined && typeof ' + ($schemaValue) + ' != \'number\') || ';
      }
      out += ' ' + ($data) + ' ' + ($notOp) + ' ' + ($schemaValue) + ' || ' + ($data) + ' !== ' + ($data) + ') { ';
    }
  }
  $errorKeyword = $errorKeyword || $keyword;
  var $$outStack = $$outStack || [];
  $$outStack.push(out);
  out = ''; /* istanbul ignore else */
  if (it.createErrors !== false) {
    out += ' { keyword: \'' + ($errorKeyword || '_limit') + '\' , dataPath: (dataPath || \'\') + ' + (it.errorPath) + ' , schemaPath: ' + (it.util.toQuotedString($errSchemaPath)) + ' , params: { comparison: ' + ($opExpr) + ', limit: ' + ($schemaValue) + ', exclusive: ' + ($exclusive) + ' } ';
    if (it.opts.messages !== false) {
      out += ' , message: \'should be ' + ($opStr) + ' ';
      if ($isData) {
        out += '\' + ' + ($schemaValue);
      } else {
        out += '' + ($schemaValue) + '\'';
      }
    }
    if (it.opts.verbose) {
      out += ' , schema:  ';
      if ($isData) {
        out += 'validate.schema' + ($schemaPath);
      } else {
        out += '' + ($schema);
      }
      out += '         , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
    }
    out += ' } ';
  } else {
    out += ' {} ';
  }
  var __err = out;
  out = $$outStack.pop();
  if (!it.compositeRule && $breakOnError) {
    /* istanbul ignore if */
    if (it.async) {
      out += ' throw new ValidationError([' + (__err) + ']); ';
    } else {
      out += ' validate.errors = [' + (__err) + ']; return false; ';
    }
  } else {
    out += ' var err = ' + (__err) + ';  if (vErrors === null) vErrors = [err]; else vErrors.push(err); errors++; ';
  }
  out += ' } ';
  if ($breakOnError) {
    out += ' else { ';
  }
  return out;
}

},{}],15:[function(require,module,exports){
'use strict';
module.exports = function generate__limitItems(it, $keyword, $ruleType) {
  var out = ' ';
  var $lvl = it.level;
  var $dataLvl = it.dataLevel;
  var $schema = it.schema[$keyword];
  var $schemaPath = it.schemaPath + it.util.getProperty($keyword);
  var $errSchemaPath = it.errSchemaPath + '/' + $keyword;
  var $breakOnError = !it.opts.allErrors;
  var $errorKeyword;
  var $data = 'data' + ($dataLvl || '');
  var $isData = it.opts.$data && $schema && $schema.$data,
    $schemaValue;
  if ($isData) {
    out += ' var schema' + ($lvl) + ' = ' + (it.util.getData($schema.$data, $dataLvl, it.dataPathArr)) + '; ';
    $schemaValue = 'schema' + $lvl;
  } else {
    $schemaValue = $schema;
  }
  var $op = $keyword == 'maxItems' ? '>' : '<';
  out += 'if ( ';
  if ($isData) {
    out += ' (' + ($schemaValue) + ' !== undefined && typeof ' + ($schemaValue) + ' != \'number\') || ';
  }
  out += ' ' + ($data) + '.length ' + ($op) + ' ' + ($schemaValue) + ') { ';
  var $errorKeyword = $keyword;
  var $$outStack = $$outStack || [];
  $$outStack.push(out);
  out = ''; /* istanbul ignore else */
  if (it.createErrors !== false) {
    out += ' { keyword: \'' + ($errorKeyword || '_limitItems') + '\' , dataPath: (dataPath || \'\') + ' + (it.errorPath) + ' , schemaPath: ' + (it.util.toQuotedString($errSchemaPath)) + ' , params: { limit: ' + ($schemaValue) + ' } ';
    if (it.opts.messages !== false) {
      out += ' , message: \'should NOT have ';
      if ($keyword == 'maxItems') {
        out += 'more';
      } else {
        out += 'fewer';
      }
      out += ' than ';
      if ($isData) {
        out += '\' + ' + ($schemaValue) + ' + \'';
      } else {
        out += '' + ($schema);
      }
      out += ' items\' ';
    }
    if (it.opts.verbose) {
      out += ' , schema:  ';
      if ($isData) {
        out += 'validate.schema' + ($schemaPath);
      } else {
        out += '' + ($schema);
      }
      out += '         , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
    }
    out += ' } ';
  } else {
    out += ' {} ';
  }
  var __err = out;
  out = $$outStack.pop();
  if (!it.compositeRule && $breakOnError) {
    /* istanbul ignore if */
    if (it.async) {
      out += ' throw new ValidationError([' + (__err) + ']); ';
    } else {
      out += ' validate.errors = [' + (__err) + ']; return false; ';
    }
  } else {
    out += ' var err = ' + (__err) + ';  if (vErrors === null) vErrors = [err]; else vErrors.push(err); errors++; ';
  }
  out += '} ';
  if ($breakOnError) {
    out += ' else { ';
  }
  return out;
}

},{}],16:[function(require,module,exports){
'use strict';
module.exports = function generate__limitLength(it, $keyword, $ruleType) {
  var out = ' ';
  var $lvl = it.level;
  var $dataLvl = it.dataLevel;
  var $schema = it.schema[$keyword];
  var $schemaPath = it.schemaPath + it.util.getProperty($keyword);
  var $errSchemaPath = it.errSchemaPath + '/' + $keyword;
  var $breakOnError = !it.opts.allErrors;
  var $errorKeyword;
  var $data = 'data' + ($dataLvl || '');
  var $isData = it.opts.$data && $schema && $schema.$data,
    $schemaValue;
  if ($isData) {
    out += ' var schema' + ($lvl) + ' = ' + (it.util.getData($schema.$data, $dataLvl, it.dataPathArr)) + '; ';
    $schemaValue = 'schema' + $lvl;
  } else {
    $schemaValue = $schema;
  }
  var $op = $keyword == 'maxLength' ? '>' : '<';
  out += 'if ( ';
  if ($isData) {
    out += ' (' + ($schemaValue) + ' !== undefined && typeof ' + ($schemaValue) + ' != \'number\') || ';
  }
  if (it.opts.unicode === false) {
    out += ' ' + ($data) + '.length ';
  } else {
    out += ' ucs2length(' + ($data) + ') ';
  }
  out += ' ' + ($op) + ' ' + ($schemaValue) + ') { ';
  var $errorKeyword = $keyword;
  var $$outStack = $$outStack || [];
  $$outStack.push(out);
  out = ''; /* istanbul ignore else */
  if (it.createErrors !== false) {
    out += ' { keyword: \'' + ($errorKeyword || '_limitLength') + '\' , dataPath: (dataPath || \'\') + ' + (it.errorPath) + ' , schemaPath: ' + (it.util.toQuotedString($errSchemaPath)) + ' , params: { limit: ' + ($schemaValue) + ' } ';
    if (it.opts.messages !== false) {
      out += ' , message: \'should NOT be ';
      if ($keyword == 'maxLength') {
        out += 'longer';
      } else {
        out += 'shorter';
      }
      out += ' than ';
      if ($isData) {
        out += '\' + ' + ($schemaValue) + ' + \'';
      } else {
        out += '' + ($schema);
      }
      out += ' characters\' ';
    }
    if (it.opts.verbose) {
      out += ' , schema:  ';
      if ($isData) {
        out += 'validate.schema' + ($schemaPath);
      } else {
        out += '' + ($schema);
      }
      out += '         , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
    }
    out += ' } ';
  } else {
    out += ' {} ';
  }
  var __err = out;
  out = $$outStack.pop();
  if (!it.compositeRule && $breakOnError) {
    /* istanbul ignore if */
    if (it.async) {
      out += ' throw new ValidationError([' + (__err) + ']); ';
    } else {
      out += ' validate.errors = [' + (__err) + ']; return false; ';
    }
  } else {
    out += ' var err = ' + (__err) + ';  if (vErrors === null) vErrors = [err]; else vErrors.push(err); errors++; ';
  }
  out += '} ';
  if ($breakOnError) {
    out += ' else { ';
  }
  return out;
}

},{}],17:[function(require,module,exports){
'use strict';
module.exports = function generate__limitProperties(it, $keyword, $ruleType) {
  var out = ' ';
  var $lvl = it.level;
  var $dataLvl = it.dataLevel;
  var $schema = it.schema[$keyword];
  var $schemaPath = it.schemaPath + it.util.getProperty($keyword);
  var $errSchemaPath = it.errSchemaPath + '/' + $keyword;
  var $breakOnError = !it.opts.allErrors;
  var $errorKeyword;
  var $data = 'data' + ($dataLvl || '');
  var $isData = it.opts.$data && $schema && $schema.$data,
    $schemaValue;
  if ($isData) {
    out += ' var schema' + ($lvl) + ' = ' + (it.util.getData($schema.$data, $dataLvl, it.dataPathArr)) + '; ';
    $schemaValue = 'schema' + $lvl;
  } else {
    $schemaValue = $schema;
  }
  var $op = $keyword == 'maxProperties' ? '>' : '<';
  out += 'if ( ';
  if ($isData) {
    out += ' (' + ($schemaValue) + ' !== undefined && typeof ' + ($schemaValue) + ' != \'number\') || ';
  }
  out += ' Object.keys(' + ($data) + ').length ' + ($op) + ' ' + ($schemaValue) + ') { ';
  var $errorKeyword = $keyword;
  var $$outStack = $$outStack || [];
  $$outStack.push(out);
  out = ''; /* istanbul ignore else */
  if (it.createErrors !== false) {
    out += ' { keyword: \'' + ($errorKeyword || '_limitProperties') + '\' , dataPath: (dataPath || \'\') + ' + (it.errorPath) + ' , schemaPath: ' + (it.util.toQuotedString($errSchemaPath)) + ' , params: { limit: ' + ($schemaValue) + ' } ';
    if (it.opts.messages !== false) {
      out += ' , message: \'should NOT have ';
      if ($keyword == 'maxProperties') {
        out += 'more';
      } else {
        out += 'fewer';
      }
      out += ' than ';
      if ($isData) {
        out += '\' + ' + ($schemaValue) + ' + \'';
      } else {
        out += '' + ($schema);
      }
      out += ' properties\' ';
    }
    if (it.opts.verbose) {
      out += ' , schema:  ';
      if ($isData) {
        out += 'validate.schema' + ($schemaPath);
      } else {
        out += '' + ($schema);
      }
      out += '         , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
    }
    out += ' } ';
  } else {
    out += ' {} ';
  }
  var __err = out;
  out = $$outStack.pop();
  if (!it.compositeRule && $breakOnError) {
    /* istanbul ignore if */
    if (it.async) {
      out += ' throw new ValidationError([' + (__err) + ']); ';
    } else {
      out += ' validate.errors = [' + (__err) + ']; return false; ';
    }
  } else {
    out += ' var err = ' + (__err) + ';  if (vErrors === null) vErrors = [err]; else vErrors.push(err); errors++; ';
  }
  out += '} ';
  if ($breakOnError) {
    out += ' else { ';
  }
  return out;
}

},{}],18:[function(require,module,exports){
'use strict';
module.exports = function generate_allOf(it, $keyword, $ruleType) {
  var out = ' ';
  var $schema = it.schema[$keyword];
  var $schemaPath = it.schemaPath + it.util.getProperty($keyword);
  var $errSchemaPath = it.errSchemaPath + '/' + $keyword;
  var $breakOnError = !it.opts.allErrors;
  var $it = it.util.copy(it);
  var $closingBraces = '';
  $it.level++;
  var $nextValid = 'valid' + $it.level;
  var $currentBaseId = $it.baseId,
    $allSchemasEmpty = true;
  var arr1 = $schema;
  if (arr1) {
    var $sch, $i = -1,
      l1 = arr1.length - 1;
    while ($i < l1) {
      $sch = arr1[$i += 1];
      if ((it.opts.strictKeywords ? typeof $sch == 'object' && Object.keys($sch).length > 0 : it.util.schemaHasRules($sch, it.RULES.all))) {
        $allSchemasEmpty = false;
        $it.schema = $sch;
        $it.schemaPath = $schemaPath + '[' + $i + ']';
        $it.errSchemaPath = $errSchemaPath + '/' + $i;
        out += '  ' + (it.validate($it)) + ' ';
        $it.baseId = $currentBaseId;
        if ($breakOnError) {
          out += ' if (' + ($nextValid) + ') { ';
          $closingBraces += '}';
        }
      }
    }
  }
  if ($breakOnError) {
    if ($allSchemasEmpty) {
      out += ' if (true) { ';
    } else {
      out += ' ' + ($closingBraces.slice(0, -1)) + ' ';
    }
  }
  out = it.util.cleanUpCode(out);
  return out;
}

},{}],19:[function(require,module,exports){
'use strict';
module.exports = function generate_anyOf(it, $keyword, $ruleType) {
  var out = ' ';
  var $lvl = it.level;
  var $dataLvl = it.dataLevel;
  var $schema = it.schema[$keyword];
  var $schemaPath = it.schemaPath + it.util.getProperty($keyword);
  var $errSchemaPath = it.errSchemaPath + '/' + $keyword;
  var $breakOnError = !it.opts.allErrors;
  var $data = 'data' + ($dataLvl || '');
  var $valid = 'valid' + $lvl;
  var $errs = 'errs__' + $lvl;
  var $it = it.util.copy(it);
  var $closingBraces = '';
  $it.level++;
  var $nextValid = 'valid' + $it.level;
  var $noEmptySchema = $schema.every(function($sch) {
    return (it.opts.strictKeywords ? typeof $sch == 'object' && Object.keys($sch).length > 0 : it.util.schemaHasRules($sch, it.RULES.all));
  });
  if ($noEmptySchema) {
    var $currentBaseId = $it.baseId;
    out += ' var ' + ($errs) + ' = errors; var ' + ($valid) + ' = false;  ';
    var $wasComposite = it.compositeRule;
    it.compositeRule = $it.compositeRule = true;
    var arr1 = $schema;
    if (arr1) {
      var $sch, $i = -1,
        l1 = arr1.length - 1;
      while ($i < l1) {
        $sch = arr1[$i += 1];
        $it.schema = $sch;
        $it.schemaPath = $schemaPath + '[' + $i + ']';
        $it.errSchemaPath = $errSchemaPath + '/' + $i;
        out += '  ' + (it.validate($it)) + ' ';
        $it.baseId = $currentBaseId;
        out += ' ' + ($valid) + ' = ' + ($valid) + ' || ' + ($nextValid) + '; if (!' + ($valid) + ') { ';
        $closingBraces += '}';
      }
    }
    it.compositeRule = $it.compositeRule = $wasComposite;
    out += ' ' + ($closingBraces) + ' if (!' + ($valid) + ') {   var err =   '; /* istanbul ignore else */
    if (it.createErrors !== false) {
      out += ' { keyword: \'' + ('anyOf') + '\' , dataPath: (dataPath || \'\') + ' + (it.errorPath) + ' , schemaPath: ' + (it.util.toQuotedString($errSchemaPath)) + ' , params: {} ';
      if (it.opts.messages !== false) {
        out += ' , message: \'should match some schema in anyOf\' ';
      }
      if (it.opts.verbose) {
        out += ' , schema: validate.schema' + ($schemaPath) + ' , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
      }
      out += ' } ';
    } else {
      out += ' {} ';
    }
    out += ';  if (vErrors === null) vErrors = [err]; else vErrors.push(err); errors++; ';
    if (!it.compositeRule && $breakOnError) {
      /* istanbul ignore if */
      if (it.async) {
        out += ' throw new ValidationError(vErrors); ';
      } else {
        out += ' validate.errors = vErrors; return false; ';
      }
    }
    out += ' } else {  errors = ' + ($errs) + '; if (vErrors !== null) { if (' + ($errs) + ') vErrors.length = ' + ($errs) + '; else vErrors = null; } ';
    if (it.opts.allErrors) {
      out += ' } ';
    }
    out = it.util.cleanUpCode(out);
  } else {
    if ($breakOnError) {
      out += ' if (true) { ';
    }
  }
  return out;
}

},{}],20:[function(require,module,exports){
'use strict';
module.exports = function generate_comment(it, $keyword, $ruleType) {
  var out = ' ';
  var $schema = it.schema[$keyword];
  var $errSchemaPath = it.errSchemaPath + '/' + $keyword;
  var $breakOnError = !it.opts.allErrors;
  var $comment = it.util.toQuotedString($schema);
  if (it.opts.$comment === true) {
    out += ' console.log(' + ($comment) + ');';
  } else if (typeof it.opts.$comment == 'function') {
    out += ' self._opts.$comment(' + ($comment) + ', ' + (it.util.toQuotedString($errSchemaPath)) + ', validate.root.schema);';
  }
  return out;
}

},{}],21:[function(require,module,exports){
'use strict';
module.exports = function generate_const(it, $keyword, $ruleType) {
  var out = ' ';
  var $lvl = it.level;
  var $dataLvl = it.dataLevel;
  var $schema = it.schema[$keyword];
  var $schemaPath = it.schemaPath + it.util.getProperty($keyword);
  var $errSchemaPath = it.errSchemaPath + '/' + $keyword;
  var $breakOnError = !it.opts.allErrors;
  var $data = 'data' + ($dataLvl || '');
  var $valid = 'valid' + $lvl;
  var $isData = it.opts.$data && $schema && $schema.$data,
    $schemaValue;
  if ($isData) {
    out += ' var schema' + ($lvl) + ' = ' + (it.util.getData($schema.$data, $dataLvl, it.dataPathArr)) + '; ';
    $schemaValue = 'schema' + $lvl;
  } else {
    $schemaValue = $schema;
  }
  if (!$isData) {
    out += ' var schema' + ($lvl) + ' = validate.schema' + ($schemaPath) + ';';
  }
  out += 'var ' + ($valid) + ' = equal(' + ($data) + ', schema' + ($lvl) + '); if (!' + ($valid) + ') {   ';
  var $$outStack = $$outStack || [];
  $$outStack.push(out);
  out = ''; /* istanbul ignore else */
  if (it.createErrors !== false) {
    out += ' { keyword: \'' + ('const') + '\' , dataPath: (dataPath || \'\') + ' + (it.errorPath) + ' , schemaPath: ' + (it.util.toQuotedString($errSchemaPath)) + ' , params: { allowedValue: schema' + ($lvl) + ' } ';
    if (it.opts.messages !== false) {
      out += ' , message: \'should be equal to constant\' ';
    }
    if (it.opts.verbose) {
      out += ' , schema: validate.schema' + ($schemaPath) + ' , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
    }
    out += ' } ';
  } else {
    out += ' {} ';
  }
  var __err = out;
  out = $$outStack.pop();
  if (!it.compositeRule && $breakOnError) {
    /* istanbul ignore if */
    if (it.async) {
      out += ' throw new ValidationError([' + (__err) + ']); ';
    } else {
      out += ' validate.errors = [' + (__err) + ']; return false; ';
    }
  } else {
    out += ' var err = ' + (__err) + ';  if (vErrors === null) vErrors = [err]; else vErrors.push(err); errors++; ';
  }
  out += ' }';
  if ($breakOnError) {
    out += ' else { ';
  }
  return out;
}

},{}],22:[function(require,module,exports){
'use strict';
module.exports = function generate_contains(it, $keyword, $ruleType) {
  var out = ' ';
  var $lvl = it.level;
  var $dataLvl = it.dataLevel;
  var $schema = it.schema[$keyword];
  var $schemaPath = it.schemaPath + it.util.getProperty($keyword);
  var $errSchemaPath = it.errSchemaPath + '/' + $keyword;
  var $breakOnError = !it.opts.allErrors;
  var $data = 'data' + ($dataLvl || '');
  var $valid = 'valid' + $lvl;
  var $errs = 'errs__' + $lvl;
  var $it = it.util.copy(it);
  var $closingBraces = '';
  $it.level++;
  var $nextValid = 'valid' + $it.level;
  var $idx = 'i' + $lvl,
    $dataNxt = $it.dataLevel = it.dataLevel + 1,
    $nextData = 'data' + $dataNxt,
    $currentBaseId = it.baseId,
    $nonEmptySchema = (it.opts.strictKeywords ? typeof $schema == 'object' && Object.keys($schema).length > 0 : it.util.schemaHasRules($schema, it.RULES.all));
  out += 'var ' + ($errs) + ' = errors;var ' + ($valid) + ';';
  if ($nonEmptySchema) {
    var $wasComposite = it.compositeRule;
    it.compositeRule = $it.compositeRule = true;
    $it.schema = $schema;
    $it.schemaPath = $schemaPath;
    $it.errSchemaPath = $errSchemaPath;
    out += ' var ' + ($nextValid) + ' = false; for (var ' + ($idx) + ' = 0; ' + ($idx) + ' < ' + ($data) + '.length; ' + ($idx) + '++) { ';
    $it.errorPath = it.util.getPathExpr(it.errorPath, $idx, it.opts.jsonPointers, true);
    var $passData = $data + '[' + $idx + ']';
    $it.dataPathArr[$dataNxt] = $idx;
    var $code = it.validate($it);
    $it.baseId = $currentBaseId;
    if (it.util.varOccurences($code, $nextData) < 2) {
      out += ' ' + (it.util.varReplace($code, $nextData, $passData)) + ' ';
    } else {
      out += ' var ' + ($nextData) + ' = ' + ($passData) + '; ' + ($code) + ' ';
    }
    out += ' if (' + ($nextValid) + ') break; }  ';
    it.compositeRule = $it.compositeRule = $wasComposite;
    out += ' ' + ($closingBraces) + ' if (!' + ($nextValid) + ') {';
  } else {
    out += ' if (' + ($data) + '.length == 0) {';
  }
  var $$outStack = $$outStack || [];
  $$outStack.push(out);
  out = ''; /* istanbul ignore else */
  if (it.createErrors !== false) {
    out += ' { keyword: \'' + ('contains') + '\' , dataPath: (dataPath || \'\') + ' + (it.errorPath) + ' , schemaPath: ' + (it.util.toQuotedString($errSchemaPath)) + ' , params: {} ';
    if (it.opts.messages !== false) {
      out += ' , message: \'should contain a valid item\' ';
    }
    if (it.opts.verbose) {
      out += ' , schema: validate.schema' + ($schemaPath) + ' , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
    }
    out += ' } ';
  } else {
    out += ' {} ';
  }
  var __err = out;
  out = $$outStack.pop();
  if (!it.compositeRule && $breakOnError) {
    /* istanbul ignore if */
    if (it.async) {
      out += ' throw new ValidationError([' + (__err) + ']); ';
    } else {
      out += ' validate.errors = [' + (__err) + ']; return false; ';
    }
  } else {
    out += ' var err = ' + (__err) + ';  if (vErrors === null) vErrors = [err]; else vErrors.push(err); errors++; ';
  }
  out += ' } else { ';
  if ($nonEmptySchema) {
    out += '  errors = ' + ($errs) + '; if (vErrors !== null) { if (' + ($errs) + ') vErrors.length = ' + ($errs) + '; else vErrors = null; } ';
  }
  if (it.opts.allErrors) {
    out += ' } ';
  }
  out = it.util.cleanUpCode(out);
  return out;
}

},{}],23:[function(require,module,exports){
'use strict';
module.exports = function generate_custom(it, $keyword, $ruleType) {
  var out = ' ';
  var $lvl = it.level;
  var $dataLvl = it.dataLevel;
  var $schema = it.schema[$keyword];
  var $schemaPath = it.schemaPath + it.util.getProperty($keyword);
  var $errSchemaPath = it.errSchemaPath + '/' + $keyword;
  var $breakOnError = !it.opts.allErrors;
  var $errorKeyword;
  var $data = 'data' + ($dataLvl || '');
  var $valid = 'valid' + $lvl;
  var $errs = 'errs__' + $lvl;
  var $isData = it.opts.$data && $schema && $schema.$data,
    $schemaValue;
  if ($isData) {
    out += ' var schema' + ($lvl) + ' = ' + (it.util.getData($schema.$data, $dataLvl, it.dataPathArr)) + '; ';
    $schemaValue = 'schema' + $lvl;
  } else {
    $schemaValue = $schema;
  }
  var $rule = this,
    $definition = 'definition' + $lvl,
    $rDef = $rule.definition,
    $closingBraces = '';
  var $compile, $inline, $macro, $ruleValidate, $validateCode;
  if ($isData && $rDef.$data) {
    $validateCode = 'keywordValidate' + $lvl;
    var $validateSchema = $rDef.validateSchema;
    out += ' var ' + ($definition) + ' = RULES.custom[\'' + ($keyword) + '\'].definition; var ' + ($validateCode) + ' = ' + ($definition) + '.validate;';
  } else {
    $ruleValidate = it.useCustomRule($rule, $schema, it.schema, it);
    if (!$ruleValidate) return;
    $schemaValue = 'validate.schema' + $schemaPath;
    $validateCode = $ruleValidate.code;
    $compile = $rDef.compile;
    $inline = $rDef.inline;
    $macro = $rDef.macro;
  }
  var $ruleErrs = $validateCode + '.errors',
    $i = 'i' + $lvl,
    $ruleErr = 'ruleErr' + $lvl,
    $asyncKeyword = $rDef.async;
  if ($asyncKeyword && !it.async) throw new Error('async keyword in sync schema');
  if (!($inline || $macro)) {
    out += '' + ($ruleErrs) + ' = null;';
  }
  out += 'var ' + ($errs) + ' = errors;var ' + ($valid) + ';';
  if ($isData && $rDef.$data) {
    $closingBraces += '}';
    out += ' if (' + ($schemaValue) + ' === undefined) { ' + ($valid) + ' = true; } else { ';
    if ($validateSchema) {
      $closingBraces += '}';
      out += ' ' + ($valid) + ' = ' + ($definition) + '.validateSchema(' + ($schemaValue) + '); if (' + ($valid) + ') { ';
    }
  }
  if ($inline) {
    if ($rDef.statements) {
      out += ' ' + ($ruleValidate.validate) + ' ';
    } else {
      out += ' ' + ($valid) + ' = ' + ($ruleValidate.validate) + '; ';
    }
  } else if ($macro) {
    var $it = it.util.copy(it);
    var $closingBraces = '';
    $it.level++;
    var $nextValid = 'valid' + $it.level;
    $it.schema = $ruleValidate.validate;
    $it.schemaPath = '';
    var $wasComposite = it.compositeRule;
    it.compositeRule = $it.compositeRule = true;
    var $code = it.validate($it).replace(/validate\.schema/g, $validateCode);
    it.compositeRule = $it.compositeRule = $wasComposite;
    out += ' ' + ($code);
  } else {
    var $$outStack = $$outStack || [];
    $$outStack.push(out);
    out = '';
    out += '  ' + ($validateCode) + '.call( ';
    if (it.opts.passContext) {
      out += 'this';
    } else {
      out += 'self';
    }
    if ($compile || $rDef.schema === false) {
      out += ' , ' + ($data) + ' ';
    } else {
      out += ' , ' + ($schemaValue) + ' , ' + ($data) + ' , validate.schema' + (it.schemaPath) + ' ';
    }
    out += ' , (dataPath || \'\')';
    if (it.errorPath != '""') {
      out += ' + ' + (it.errorPath);
    }
    var $parentData = $dataLvl ? 'data' + (($dataLvl - 1) || '') : 'parentData',
      $parentDataProperty = $dataLvl ? it.dataPathArr[$dataLvl] : 'parentDataProperty';
    out += ' , ' + ($parentData) + ' , ' + ($parentDataProperty) + ' , rootData )  ';
    var def_callRuleValidate = out;
    out = $$outStack.pop();
    if ($rDef.errors === false) {
      out += ' ' + ($valid) + ' = ';
      if ($asyncKeyword) {
        out += 'await ';
      }
      out += '' + (def_callRuleValidate) + '; ';
    } else {
      if ($asyncKeyword) {
        $ruleErrs = 'customErrors' + $lvl;
        out += ' var ' + ($ruleErrs) + ' = null; try { ' + ($valid) + ' = await ' + (def_callRuleValidate) + '; } catch (e) { ' + ($valid) + ' = false; if (e instanceof ValidationError) ' + ($ruleErrs) + ' = e.errors; else throw e; } ';
      } else {
        out += ' ' + ($ruleErrs) + ' = null; ' + ($valid) + ' = ' + (def_callRuleValidate) + '; ';
      }
    }
  }
  if ($rDef.modifying) {
    out += ' if (' + ($parentData) + ') ' + ($data) + ' = ' + ($parentData) + '[' + ($parentDataProperty) + '];';
  }
  out += '' + ($closingBraces);
  if ($rDef.valid) {
    if ($breakOnError) {
      out += ' if (true) { ';
    }
  } else {
    out += ' if ( ';
    if ($rDef.valid === undefined) {
      out += ' !';
      if ($macro) {
        out += '' + ($nextValid);
      } else {
        out += '' + ($valid);
      }
    } else {
      out += ' ' + (!$rDef.valid) + ' ';
    }
    out += ') { ';
    $errorKeyword = $rule.keyword;
    var $$outStack = $$outStack || [];
    $$outStack.push(out);
    out = '';
    var $$outStack = $$outStack || [];
    $$outStack.push(out);
    out = ''; /* istanbul ignore else */
    if (it.createErrors !== false) {
      out += ' { keyword: \'' + ($errorKeyword || 'custom') + '\' , dataPath: (dataPath || \'\') + ' + (it.errorPath) + ' , schemaPath: ' + (it.util.toQuotedString($errSchemaPath)) + ' , params: { keyword: \'' + ($rule.keyword) + '\' } ';
      if (it.opts.messages !== false) {
        out += ' , message: \'should pass "' + ($rule.keyword) + '" keyword validation\' ';
      }
      if (it.opts.verbose) {
        out += ' , schema: validate.schema' + ($schemaPath) + ' , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
      }
      out += ' } ';
    } else {
      out += ' {} ';
    }
    var __err = out;
    out = $$outStack.pop();
    if (!it.compositeRule && $breakOnError) {
      /* istanbul ignore if */
      if (it.async) {
        out += ' throw new ValidationError([' + (__err) + ']); ';
      } else {
        out += ' validate.errors = [' + (__err) + ']; return false; ';
      }
    } else {
      out += ' var err = ' + (__err) + ';  if (vErrors === null) vErrors = [err]; else vErrors.push(err); errors++; ';
    }
    var def_customError = out;
    out = $$outStack.pop();
    if ($inline) {
      if ($rDef.errors) {
        if ($rDef.errors != 'full') {
          out += '  for (var ' + ($i) + '=' + ($errs) + '; ' + ($i) + '<errors; ' + ($i) + '++) { var ' + ($ruleErr) + ' = vErrors[' + ($i) + ']; if (' + ($ruleErr) + '.dataPath === undefined) ' + ($ruleErr) + '.dataPath = (dataPath || \'\') + ' + (it.errorPath) + '; if (' + ($ruleErr) + '.schemaPath === undefined) { ' + ($ruleErr) + '.schemaPath = "' + ($errSchemaPath) + '"; } ';
          if (it.opts.verbose) {
            out += ' ' + ($ruleErr) + '.schema = ' + ($schemaValue) + '; ' + ($ruleErr) + '.data = ' + ($data) + '; ';
          }
          out += ' } ';
        }
      } else {
        if ($rDef.errors === false) {
          out += ' ' + (def_customError) + ' ';
        } else {
          out += ' if (' + ($errs) + ' == errors) { ' + (def_customError) + ' } else {  for (var ' + ($i) + '=' + ($errs) + '; ' + ($i) + '<errors; ' + ($i) + '++) { var ' + ($ruleErr) + ' = vErrors[' + ($i) + ']; if (' + ($ruleErr) + '.dataPath === undefined) ' + ($ruleErr) + '.dataPath = (dataPath || \'\') + ' + (it.errorPath) + '; if (' + ($ruleErr) + '.schemaPath === undefined) { ' + ($ruleErr) + '.schemaPath = "' + ($errSchemaPath) + '"; } ';
          if (it.opts.verbose) {
            out += ' ' + ($ruleErr) + '.schema = ' + ($schemaValue) + '; ' + ($ruleErr) + '.data = ' + ($data) + '; ';
          }
          out += ' } } ';
        }
      }
    } else if ($macro) {
      out += '   var err =   '; /* istanbul ignore else */
      if (it.createErrors !== false) {
        out += ' { keyword: \'' + ($errorKeyword || 'custom') + '\' , dataPath: (dataPath || \'\') + ' + (it.errorPath) + ' , schemaPath: ' + (it.util.toQuotedString($errSchemaPath)) + ' , params: { keyword: \'' + ($rule.keyword) + '\' } ';
        if (it.opts.messages !== false) {
          out += ' , message: \'should pass "' + ($rule.keyword) + '" keyword validation\' ';
        }
        if (it.opts.verbose) {
          out += ' , schema: validate.schema' + ($schemaPath) + ' , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
        }
        out += ' } ';
      } else {
        out += ' {} ';
      }
      out += ';  if (vErrors === null) vErrors = [err]; else vErrors.push(err); errors++; ';
      if (!it.compositeRule && $breakOnError) {
        /* istanbul ignore if */
        if (it.async) {
          out += ' throw new ValidationError(vErrors); ';
        } else {
          out += ' validate.errors = vErrors; return false; ';
        }
      }
    } else {
      if ($rDef.errors === false) {
        out += ' ' + (def_customError) + ' ';
      } else {
        out += ' if (Array.isArray(' + ($ruleErrs) + ')) { if (vErrors === null) vErrors = ' + ($ruleErrs) + '; else vErrors = vErrors.concat(' + ($ruleErrs) + '); errors = vErrors.length;  for (var ' + ($i) + '=' + ($errs) + '; ' + ($i) + '<errors; ' + ($i) + '++) { var ' + ($ruleErr) + ' = vErrors[' + ($i) + ']; if (' + ($ruleErr) + '.dataPath === undefined) ' + ($ruleErr) + '.dataPath = (dataPath || \'\') + ' + (it.errorPath) + ';  ' + ($ruleErr) + '.schemaPath = "' + ($errSchemaPath) + '";  ';
        if (it.opts.verbose) {
          out += ' ' + ($ruleErr) + '.schema = ' + ($schemaValue) + '; ' + ($ruleErr) + '.data = ' + ($data) + '; ';
        }
        out += ' } } else { ' + (def_customError) + ' } ';
      }
    }
    out += ' } ';
    if ($breakOnError) {
      out += ' else { ';
    }
  }
  return out;
}

},{}],24:[function(require,module,exports){
'use strict';
module.exports = function generate_dependencies(it, $keyword, $ruleType) {
  var out = ' ';
  var $lvl = it.level;
  var $dataLvl = it.dataLevel;
  var $schema = it.schema[$keyword];
  var $schemaPath = it.schemaPath + it.util.getProperty($keyword);
  var $errSchemaPath = it.errSchemaPath + '/' + $keyword;
  var $breakOnError = !it.opts.allErrors;
  var $data = 'data' + ($dataLvl || '');
  var $errs = 'errs__' + $lvl;
  var $it = it.util.copy(it);
  var $closingBraces = '';
  $it.level++;
  var $nextValid = 'valid' + $it.level;
  var $schemaDeps = {},
    $propertyDeps = {},
    $ownProperties = it.opts.ownProperties;
  for ($property in $schema) {
    var $sch = $schema[$property];
    var $deps = Array.isArray($sch) ? $propertyDeps : $schemaDeps;
    $deps[$property] = $sch;
  }
  out += 'var ' + ($errs) + ' = errors;';
  var $currentErrorPath = it.errorPath;
  out += 'var missing' + ($lvl) + ';';
  for (var $property in $propertyDeps) {
    $deps = $propertyDeps[$property];
    if ($deps.length) {
      out += ' if ( ' + ($data) + (it.util.getProperty($property)) + ' !== undefined ';
      if ($ownProperties) {
        out += ' && Object.prototype.hasOwnProperty.call(' + ($data) + ', \'' + (it.util.escapeQuotes($property)) + '\') ';
      }
      if ($breakOnError) {
        out += ' && ( ';
        var arr1 = $deps;
        if (arr1) {
          var $propertyKey, $i = -1,
            l1 = arr1.length - 1;
          while ($i < l1) {
            $propertyKey = arr1[$i += 1];
            if ($i) {
              out += ' || ';
            }
            var $prop = it.util.getProperty($propertyKey),
              $useData = $data + $prop;
            out += ' ( ( ' + ($useData) + ' === undefined ';
            if ($ownProperties) {
              out += ' || ! Object.prototype.hasOwnProperty.call(' + ($data) + ', \'' + (it.util.escapeQuotes($propertyKey)) + '\') ';
            }
            out += ') && (missing' + ($lvl) + ' = ' + (it.util.toQuotedString(it.opts.jsonPointers ? $propertyKey : $prop)) + ') ) ';
          }
        }
        out += ')) {  ';
        var $propertyPath = 'missing' + $lvl,
          $missingProperty = '\' + ' + $propertyPath + ' + \'';
        if (it.opts._errorDataPathProperty) {
          it.errorPath = it.opts.jsonPointers ? it.util.getPathExpr($currentErrorPath, $propertyPath, true) : $currentErrorPath + ' + ' + $propertyPath;
        }
        var $$outStack = $$outStack || [];
        $$outStack.push(out);
        out = ''; /* istanbul ignore else */
        if (it.createErrors !== false) {
          out += ' { keyword: \'' + ('dependencies') + '\' , dataPath: (dataPath || \'\') + ' + (it.errorPath) + ' , schemaPath: ' + (it.util.toQuotedString($errSchemaPath)) + ' , params: { property: \'' + (it.util.escapeQuotes($property)) + '\', missingProperty: \'' + ($missingProperty) + '\', depsCount: ' + ($deps.length) + ', deps: \'' + (it.util.escapeQuotes($deps.length == 1 ? $deps[0] : $deps.join(", "))) + '\' } ';
          if (it.opts.messages !== false) {
            out += ' , message: \'should have ';
            if ($deps.length == 1) {
              out += 'property ' + (it.util.escapeQuotes($deps[0]));
            } else {
              out += 'properties ' + (it.util.escapeQuotes($deps.join(", ")));
            }
            out += ' when property ' + (it.util.escapeQuotes($property)) + ' is present\' ';
          }
          if (it.opts.verbose) {
            out += ' , schema: validate.schema' + ($schemaPath) + ' , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
          }
          out += ' } ';
        } else {
          out += ' {} ';
        }
        var __err = out;
        out = $$outStack.pop();
        if (!it.compositeRule && $breakOnError) {
          /* istanbul ignore if */
          if (it.async) {
            out += ' throw new ValidationError([' + (__err) + ']); ';
          } else {
            out += ' validate.errors = [' + (__err) + ']; return false; ';
          }
        } else {
          out += ' var err = ' + (__err) + ';  if (vErrors === null) vErrors = [err]; else vErrors.push(err); errors++; ';
        }
      } else {
        out += ' ) { ';
        var arr2 = $deps;
        if (arr2) {
          var $propertyKey, i2 = -1,
            l2 = arr2.length - 1;
          while (i2 < l2) {
            $propertyKey = arr2[i2 += 1];
            var $prop = it.util.getProperty($propertyKey),
              $missingProperty = it.util.escapeQuotes($propertyKey),
              $useData = $data + $prop;
            if (it.opts._errorDataPathProperty) {
              it.errorPath = it.util.getPath($currentErrorPath, $propertyKey, it.opts.jsonPointers);
            }
            out += ' if ( ' + ($useData) + ' === undefined ';
            if ($ownProperties) {
              out += ' || ! Object.prototype.hasOwnProperty.call(' + ($data) + ', \'' + (it.util.escapeQuotes($propertyKey)) + '\') ';
            }
            out += ') {  var err =   '; /* istanbul ignore else */
            if (it.createErrors !== false) {
              out += ' { keyword: \'' + ('dependencies') + '\' , dataPath: (dataPath || \'\') + ' + (it.errorPath) + ' , schemaPath: ' + (it.util.toQuotedString($errSchemaPath)) + ' , params: { property: \'' + (it.util.escapeQuotes($property)) + '\', missingProperty: \'' + ($missingProperty) + '\', depsCount: ' + ($deps.length) + ', deps: \'' + (it.util.escapeQuotes($deps.length == 1 ? $deps[0] : $deps.join(", "))) + '\' } ';
              if (it.opts.messages !== false) {
                out += ' , message: \'should have ';
                if ($deps.length == 1) {
                  out += 'property ' + (it.util.escapeQuotes($deps[0]));
                } else {
                  out += 'properties ' + (it.util.escapeQuotes($deps.join(", ")));
                }
                out += ' when property ' + (it.util.escapeQuotes($property)) + ' is present\' ';
              }
              if (it.opts.verbose) {
                out += ' , schema: validate.schema' + ($schemaPath) + ' , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
              }
              out += ' } ';
            } else {
              out += ' {} ';
            }
            out += ';  if (vErrors === null) vErrors = [err]; else vErrors.push(err); errors++; } ';
          }
        }
      }
      out += ' }   ';
      if ($breakOnError) {
        $closingBraces += '}';
        out += ' else { ';
      }
    }
  }
  it.errorPath = $currentErrorPath;
  var $currentBaseId = $it.baseId;
  for (var $property in $schemaDeps) {
    var $sch = $schemaDeps[$property];
    if ((it.opts.strictKeywords ? typeof $sch == 'object' && Object.keys($sch).length > 0 : it.util.schemaHasRules($sch, it.RULES.all))) {
      out += ' ' + ($nextValid) + ' = true; if ( ' + ($data) + (it.util.getProperty($property)) + ' !== undefined ';
      if ($ownProperties) {
        out += ' && Object.prototype.hasOwnProperty.call(' + ($data) + ', \'' + (it.util.escapeQuotes($property)) + '\') ';
      }
      out += ') { ';
      $it.schema = $sch;
      $it.schemaPath = $schemaPath + it.util.getProperty($property);
      $it.errSchemaPath = $errSchemaPath + '/' + it.util.escapeFragment($property);
      out += '  ' + (it.validate($it)) + ' ';
      $it.baseId = $currentBaseId;
      out += ' }  ';
      if ($breakOnError) {
        out += ' if (' + ($nextValid) + ') { ';
        $closingBraces += '}';
      }
    }
  }
  if ($breakOnError) {
    out += '   ' + ($closingBraces) + ' if (' + ($errs) + ' == errors) {';
  }
  out = it.util.cleanUpCode(out);
  return out;
}

},{}],25:[function(require,module,exports){
'use strict';
module.exports = function generate_enum(it, $keyword, $ruleType) {
  var out = ' ';
  var $lvl = it.level;
  var $dataLvl = it.dataLevel;
  var $schema = it.schema[$keyword];
  var $schemaPath = it.schemaPath + it.util.getProperty($keyword);
  var $errSchemaPath = it.errSchemaPath + '/' + $keyword;
  var $breakOnError = !it.opts.allErrors;
  var $data = 'data' + ($dataLvl || '');
  var $valid = 'valid' + $lvl;
  var $isData = it.opts.$data && $schema && $schema.$data,
    $schemaValue;
  if ($isData) {
    out += ' var schema' + ($lvl) + ' = ' + (it.util.getData($schema.$data, $dataLvl, it.dataPathArr)) + '; ';
    $schemaValue = 'schema' + $lvl;
  } else {
    $schemaValue = $schema;
  }
  var $i = 'i' + $lvl,
    $vSchema = 'schema' + $lvl;
  if (!$isData) {
    out += ' var ' + ($vSchema) + ' = validate.schema' + ($schemaPath) + ';';
  }
  out += 'var ' + ($valid) + ';';
  if ($isData) {
    out += ' if (schema' + ($lvl) + ' === undefined) ' + ($valid) + ' = true; else if (!Array.isArray(schema' + ($lvl) + ')) ' + ($valid) + ' = false; else {';
  }
  out += '' + ($valid) + ' = false;for (var ' + ($i) + '=0; ' + ($i) + '<' + ($vSchema) + '.length; ' + ($i) + '++) if (equal(' + ($data) + ', ' + ($vSchema) + '[' + ($i) + '])) { ' + ($valid) + ' = true; break; }';
  if ($isData) {
    out += '  }  ';
  }
  out += ' if (!' + ($valid) + ') {   ';
  var $$outStack = $$outStack || [];
  $$outStack.push(out);
  out = ''; /* istanbul ignore else */
  if (it.createErrors !== false) {
    out += ' { keyword: \'' + ('enum') + '\' , dataPath: (dataPath || \'\') + ' + (it.errorPath) + ' , schemaPath: ' + (it.util.toQuotedString($errSchemaPath)) + ' , params: { allowedValues: schema' + ($lvl) + ' } ';
    if (it.opts.messages !== false) {
      out += ' , message: \'should be equal to one of the allowed values\' ';
    }
    if (it.opts.verbose) {
      out += ' , schema: validate.schema' + ($schemaPath) + ' , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
    }
    out += ' } ';
  } else {
    out += ' {} ';
  }
  var __err = out;
  out = $$outStack.pop();
  if (!it.compositeRule && $breakOnError) {
    /* istanbul ignore if */
    if (it.async) {
      out += ' throw new ValidationError([' + (__err) + ']); ';
    } else {
      out += ' validate.errors = [' + (__err) + ']; return false; ';
    }
  } else {
    out += ' var err = ' + (__err) + ';  if (vErrors === null) vErrors = [err]; else vErrors.push(err); errors++; ';
  }
  out += ' }';
  if ($breakOnError) {
    out += ' else { ';
  }
  return out;
}

},{}],26:[function(require,module,exports){
'use strict';
module.exports = function generate_format(it, $keyword, $ruleType) {
  var out = ' ';
  var $lvl = it.level;
  var $dataLvl = it.dataLevel;
  var $schema = it.schema[$keyword];
  var $schemaPath = it.schemaPath + it.util.getProperty($keyword);
  var $errSchemaPath = it.errSchemaPath + '/' + $keyword;
  var $breakOnError = !it.opts.allErrors;
  var $data = 'data' + ($dataLvl || '');
  if (it.opts.format === false) {
    if ($breakOnError) {
      out += ' if (true) { ';
    }
    return out;
  }
  var $isData = it.opts.$data && $schema && $schema.$data,
    $schemaValue;
  if ($isData) {
    out += ' var schema' + ($lvl) + ' = ' + (it.util.getData($schema.$data, $dataLvl, it.dataPathArr)) + '; ';
    $schemaValue = 'schema' + $lvl;
  } else {
    $schemaValue = $schema;
  }
  var $unknownFormats = it.opts.unknownFormats,
    $allowUnknown = Array.isArray($unknownFormats);
  if ($isData) {
    var $format = 'format' + $lvl,
      $isObject = 'isObject' + $lvl,
      $formatType = 'formatType' + $lvl;
    out += ' var ' + ($format) + ' = formats[' + ($schemaValue) + ']; var ' + ($isObject) + ' = typeof ' + ($format) + ' == \'object\' && !(' + ($format) + ' instanceof RegExp) && ' + ($format) + '.validate; var ' + ($formatType) + ' = ' + ($isObject) + ' && ' + ($format) + '.type || \'string\'; if (' + ($isObject) + ') { ';
    if (it.async) {
      out += ' var async' + ($lvl) + ' = ' + ($format) + '.async; ';
    }
    out += ' ' + ($format) + ' = ' + ($format) + '.validate; } if (  ';
    if ($isData) {
      out += ' (' + ($schemaValue) + ' !== undefined && typeof ' + ($schemaValue) + ' != \'string\') || ';
    }
    out += ' (';
    if ($unknownFormats != 'ignore') {
      out += ' (' + ($schemaValue) + ' && !' + ($format) + ' ';
      if ($allowUnknown) {
        out += ' && self._opts.unknownFormats.indexOf(' + ($schemaValue) + ') == -1 ';
      }
      out += ') || ';
    }
    out += ' (' + ($format) + ' && ' + ($formatType) + ' == \'' + ($ruleType) + '\' && !(typeof ' + ($format) + ' == \'function\' ? ';
    if (it.async) {
      out += ' (async' + ($lvl) + ' ? await ' + ($format) + '(' + ($data) + ') : ' + ($format) + '(' + ($data) + ')) ';
    } else {
      out += ' ' + ($format) + '(' + ($data) + ') ';
    }
    out += ' : ' + ($format) + '.test(' + ($data) + '))))) {';
  } else {
    var $format = it.formats[$schema];
    if (!$format) {
      if ($unknownFormats == 'ignore') {
        it.logger.warn('unknown format "' + $schema + '" ignored in schema at path "' + it.errSchemaPath + '"');
        if ($breakOnError) {
          out += ' if (true) { ';
        }
        return out;
      } else if ($allowUnknown && $unknownFormats.indexOf($schema) >= 0) {
        if ($breakOnError) {
          out += ' if (true) { ';
        }
        return out;
      } else {
        throw new Error('unknown format "' + $schema + '" is used in schema at path "' + it.errSchemaPath + '"');
      }
    }
    var $isObject = typeof $format == 'object' && !($format instanceof RegExp) && $format.validate;
    var $formatType = $isObject && $format.type || 'string';
    if ($isObject) {
      var $async = $format.async === true;
      $format = $format.validate;
    }
    if ($formatType != $ruleType) {
      if ($breakOnError) {
        out += ' if (true) { ';
      }
      return out;
    }
    if ($async) {
      if (!it.async) throw new Error('async format in sync schema');
      var $formatRef = 'formats' + it.util.getProperty($schema) + '.validate';
      out += ' if (!(await ' + ($formatRef) + '(' + ($data) + '))) { ';
    } else {
      out += ' if (! ';
      var $formatRef = 'formats' + it.util.getProperty($schema);
      if ($isObject) $formatRef += '.validate';
      if (typeof $format == 'function') {
        out += ' ' + ($formatRef) + '(' + ($data) + ') ';
      } else {
        out += ' ' + ($formatRef) + '.test(' + ($data) + ') ';
      }
      out += ') { ';
    }
  }
  var $$outStack = $$outStack || [];
  $$outStack.push(out);
  out = ''; /* istanbul ignore else */
  if (it.createErrors !== false) {
    out += ' { keyword: \'' + ('format') + '\' , dataPath: (dataPath || \'\') + ' + (it.errorPath) + ' , schemaPath: ' + (it.util.toQuotedString($errSchemaPath)) + ' , params: { format:  ';
    if ($isData) {
      out += '' + ($schemaValue);
    } else {
      out += '' + (it.util.toQuotedString($schema));
    }
    out += '  } ';
    if (it.opts.messages !== false) {
      out += ' , message: \'should match format "';
      if ($isData) {
        out += '\' + ' + ($schemaValue) + ' + \'';
      } else {
        out += '' + (it.util.escapeQuotes($schema));
      }
      out += '"\' ';
    }
    if (it.opts.verbose) {
      out += ' , schema:  ';
      if ($isData) {
        out += 'validate.schema' + ($schemaPath);
      } else {
        out += '' + (it.util.toQuotedString($schema));
      }
      out += '         , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
    }
    out += ' } ';
  } else {
    out += ' {} ';
  }
  var __err = out;
  out = $$outStack.pop();
  if (!it.compositeRule && $breakOnError) {
    /* istanbul ignore if */
    if (it.async) {
      out += ' throw new ValidationError([' + (__err) + ']); ';
    } else {
      out += ' validate.errors = [' + (__err) + ']; return false; ';
    }
  } else {
    out += ' var err = ' + (__err) + ';  if (vErrors === null) vErrors = [err]; else vErrors.push(err); errors++; ';
  }
  out += ' } ';
  if ($breakOnError) {
    out += ' else { ';
  }
  return out;
}

},{}],27:[function(require,module,exports){
'use strict';
module.exports = function generate_if(it, $keyword, $ruleType) {
  var out = ' ';
  var $lvl = it.level;
  var $dataLvl = it.dataLevel;
  var $schema = it.schema[$keyword];
  var $schemaPath = it.schemaPath + it.util.getProperty($keyword);
  var $errSchemaPath = it.errSchemaPath + '/' + $keyword;
  var $breakOnError = !it.opts.allErrors;
  var $data = 'data' + ($dataLvl || '');
  var $valid = 'valid' + $lvl;
  var $errs = 'errs__' + $lvl;
  var $it = it.util.copy(it);
  $it.level++;
  var $nextValid = 'valid' + $it.level;
  var $thenSch = it.schema['then'],
    $elseSch = it.schema['else'],
    $thenPresent = $thenSch !== undefined && (it.opts.strictKeywords ? typeof $thenSch == 'object' && Object.keys($thenSch).length > 0 : it.util.schemaHasRules($thenSch, it.RULES.all)),
    $elsePresent = $elseSch !== undefined && (it.opts.strictKeywords ? typeof $elseSch == 'object' && Object.keys($elseSch).length > 0 : it.util.schemaHasRules($elseSch, it.RULES.all)),
    $currentBaseId = $it.baseId;
  if ($thenPresent || $elsePresent) {
    var $ifClause;
    $it.createErrors = false;
    $it.schema = $schema;
    $it.schemaPath = $schemaPath;
    $it.errSchemaPath = $errSchemaPath;
    out += ' var ' + ($errs) + ' = errors; var ' + ($valid) + ' = true;  ';
    var $wasComposite = it.compositeRule;
    it.compositeRule = $it.compositeRule = true;
    out += '  ' + (it.validate($it)) + ' ';
    $it.baseId = $currentBaseId;
    $it.createErrors = true;
    out += '  errors = ' + ($errs) + '; if (vErrors !== null) { if (' + ($errs) + ') vErrors.length = ' + ($errs) + '; else vErrors = null; }  ';
    it.compositeRule = $it.compositeRule = $wasComposite;
    if ($thenPresent) {
      out += ' if (' + ($nextValid) + ') {  ';
      $it.schema = it.schema['then'];
      $it.schemaPath = it.schemaPath + '.then';
      $it.errSchemaPath = it.errSchemaPath + '/then';
      out += '  ' + (it.validate($it)) + ' ';
      $it.baseId = $currentBaseId;
      out += ' ' + ($valid) + ' = ' + ($nextValid) + '; ';
      if ($thenPresent && $elsePresent) {
        $ifClause = 'ifClause' + $lvl;
        out += ' var ' + ($ifClause) + ' = \'then\'; ';
      } else {
        $ifClause = '\'then\'';
      }
      out += ' } ';
      if ($elsePresent) {
        out += ' else { ';
      }
    } else {
      out += ' if (!' + ($nextValid) + ') { ';
    }
    if ($elsePresent) {
      $it.schema = it.schema['else'];
      $it.schemaPath = it.schemaPath + '.else';
      $it.errSchemaPath = it.errSchemaPath + '/else';
      out += '  ' + (it.validate($it)) + ' ';
      $it.baseId = $currentBaseId;
      out += ' ' + ($valid) + ' = ' + ($nextValid) + '; ';
      if ($thenPresent && $elsePresent) {
        $ifClause = 'ifClause' + $lvl;
        out += ' var ' + ($ifClause) + ' = \'else\'; ';
      } else {
        $ifClause = '\'else\'';
      }
      out += ' } ';
    }
    out += ' if (!' + ($valid) + ') {   var err =   '; /* istanbul ignore else */
    if (it.createErrors !== false) {
      out += ' { keyword: \'' + ('if') + '\' , dataPath: (dataPath || \'\') + ' + (it.errorPath) + ' , schemaPath: ' + (it.util.toQuotedString($errSchemaPath)) + ' , params: { failingKeyword: ' + ($ifClause) + ' } ';
      if (it.opts.messages !== false) {
        out += ' , message: \'should match "\' + ' + ($ifClause) + ' + \'" schema\' ';
      }
      if (it.opts.verbose) {
        out += ' , schema: validate.schema' + ($schemaPath) + ' , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
      }
      out += ' } ';
    } else {
      out += ' {} ';
    }
    out += ';  if (vErrors === null) vErrors = [err]; else vErrors.push(err); errors++; ';
    if (!it.compositeRule && $breakOnError) {
      /* istanbul ignore if */
      if (it.async) {
        out += ' throw new ValidationError(vErrors); ';
      } else {
        out += ' validate.errors = vErrors; return false; ';
      }
    }
    out += ' }   ';
    if ($breakOnError) {
      out += ' else { ';
    }
    out = it.util.cleanUpCode(out);
  } else {
    if ($breakOnError) {
      out += ' if (true) { ';
    }
  }
  return out;
}

},{}],28:[function(require,module,exports){
'use strict';

//all requires must be explicit because browserify won't work with dynamic requires
module.exports = {
  '$ref': require('./ref'),
  allOf: require('./allOf'),
  anyOf: require('./anyOf'),
  '$comment': require('./comment'),
  const: require('./const'),
  contains: require('./contains'),
  dependencies: require('./dependencies'),
  'enum': require('./enum'),
  format: require('./format'),
  'if': require('./if'),
  items: require('./items'),
  maximum: require('./_limit'),
  minimum: require('./_limit'),
  maxItems: require('./_limitItems'),
  minItems: require('./_limitItems'),
  maxLength: require('./_limitLength'),
  minLength: require('./_limitLength'),
  maxProperties: require('./_limitProperties'),
  minProperties: require('./_limitProperties'),
  multipleOf: require('./multipleOf'),
  not: require('./not'),
  oneOf: require('./oneOf'),
  pattern: require('./pattern'),
  properties: require('./properties'),
  propertyNames: require('./propertyNames'),
  required: require('./required'),
  uniqueItems: require('./uniqueItems'),
  validate: require('./validate')
};

},{"./_limit":14,"./_limitItems":15,"./_limitLength":16,"./_limitProperties":17,"./allOf":18,"./anyOf":19,"./comment":20,"./const":21,"./contains":22,"./dependencies":24,"./enum":25,"./format":26,"./if":27,"./items":29,"./multipleOf":30,"./not":31,"./oneOf":32,"./pattern":33,"./properties":34,"./propertyNames":35,"./ref":36,"./required":37,"./uniqueItems":38,"./validate":39}],29:[function(require,module,exports){
'use strict';
module.exports = function generate_items(it, $keyword, $ruleType) {
  var out = ' ';
  var $lvl = it.level;
  var $dataLvl = it.dataLevel;
  var $schema = it.schema[$keyword];
  var $schemaPath = it.schemaPath + it.util.getProperty($keyword);
  var $errSchemaPath = it.errSchemaPath + '/' + $keyword;
  var $breakOnError = !it.opts.allErrors;
  var $data = 'data' + ($dataLvl || '');
  var $valid = 'valid' + $lvl;
  var $errs = 'errs__' + $lvl;
  var $it = it.util.copy(it);
  var $closingBraces = '';
  $it.level++;
  var $nextValid = 'valid' + $it.level;
  var $idx = 'i' + $lvl,
    $dataNxt = $it.dataLevel = it.dataLevel + 1,
    $nextData = 'data' + $dataNxt,
    $currentBaseId = it.baseId;
  out += 'var ' + ($errs) + ' = errors;var ' + ($valid) + ';';
  if (Array.isArray($schema)) {
    var $additionalItems = it.schema.additionalItems;
    if ($additionalItems === false) {
      out += ' ' + ($valid) + ' = ' + ($data) + '.length <= ' + ($schema.length) + '; ';
      var $currErrSchemaPath = $errSchemaPath;
      $errSchemaPath = it.errSchemaPath + '/additionalItems';
      out += '  if (!' + ($valid) + ') {   ';
      var $$outStack = $$outStack || [];
      $$outStack.push(out);
      out = ''; /* istanbul ignore else */
      if (it.createErrors !== false) {
        out += ' { keyword: \'' + ('additionalItems') + '\' , dataPath: (dataPath || \'\') + ' + (it.errorPath) + ' , schemaPath: ' + (it.util.toQuotedString($errSchemaPath)) + ' , params: { limit: ' + ($schema.length) + ' } ';
        if (it.opts.messages !== false) {
          out += ' , message: \'should NOT have more than ' + ($schema.length) + ' items\' ';
        }
        if (it.opts.verbose) {
          out += ' , schema: false , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
        }
        out += ' } ';
      } else {
        out += ' {} ';
      }
      var __err = out;
      out = $$outStack.pop();
      if (!it.compositeRule && $breakOnError) {
        /* istanbul ignore if */
        if (it.async) {
          out += ' throw new ValidationError([' + (__err) + ']); ';
        } else {
          out += ' validate.errors = [' + (__err) + ']; return false; ';
        }
      } else {
        out += ' var err = ' + (__err) + ';  if (vErrors === null) vErrors = [err]; else vErrors.push(err); errors++; ';
      }
      out += ' } ';
      $errSchemaPath = $currErrSchemaPath;
      if ($breakOnError) {
        $closingBraces += '}';
        out += ' else { ';
      }
    }
    var arr1 = $schema;
    if (arr1) {
      var $sch, $i = -1,
        l1 = arr1.length - 1;
      while ($i < l1) {
        $sch = arr1[$i += 1];
        if ((it.opts.strictKeywords ? typeof $sch == 'object' && Object.keys($sch).length > 0 : it.util.schemaHasRules($sch, it.RULES.all))) {
          out += ' ' + ($nextValid) + ' = true; if (' + ($data) + '.length > ' + ($i) + ') { ';
          var $passData = $data + '[' + $i + ']';
          $it.schema = $sch;
          $it.schemaPath = $schemaPath + '[' + $i + ']';
          $it.errSchemaPath = $errSchemaPath + '/' + $i;
          $it.errorPath = it.util.getPathExpr(it.errorPath, $i, it.opts.jsonPointers, true);
          $it.dataPathArr[$dataNxt] = $i;
          var $code = it.validate($it);
          $it.baseId = $currentBaseId;
          if (it.util.varOccurences($code, $nextData) < 2) {
            out += ' ' + (it.util.varReplace($code, $nextData, $passData)) + ' ';
          } else {
            out += ' var ' + ($nextData) + ' = ' + ($passData) + '; ' + ($code) + ' ';
          }
          out += ' }  ';
          if ($breakOnError) {
            out += ' if (' + ($nextValid) + ') { ';
            $closingBraces += '}';
          }
        }
      }
    }
    if (typeof $additionalItems == 'object' && (it.opts.strictKeywords ? typeof $additionalItems == 'object' && Object.keys($additionalItems).length > 0 : it.util.schemaHasRules($additionalItems, it.RULES.all))) {
      $it.schema = $additionalItems;
      $it.schemaPath = it.schemaPath + '.additionalItems';
      $it.errSchemaPath = it.errSchemaPath + '/additionalItems';
      out += ' ' + ($nextValid) + ' = true; if (' + ($data) + '.length > ' + ($schema.length) + ') {  for (var ' + ($idx) + ' = ' + ($schema.length) + '; ' + ($idx) + ' < ' + ($data) + '.length; ' + ($idx) + '++) { ';
      $it.errorPath = it.util.getPathExpr(it.errorPath, $idx, it.opts.jsonPointers, true);
      var $passData = $data + '[' + $idx + ']';
      $it.dataPathArr[$dataNxt] = $idx;
      var $code = it.validate($it);
      $it.baseId = $currentBaseId;
      if (it.util.varOccurences($code, $nextData) < 2) {
        out += ' ' + (it.util.varReplace($code, $nextData, $passData)) + ' ';
      } else {
        out += ' var ' + ($nextData) + ' = ' + ($passData) + '; ' + ($code) + ' ';
      }
      if ($breakOnError) {
        out += ' if (!' + ($nextValid) + ') break; ';
      }
      out += ' } }  ';
      if ($breakOnError) {
        out += ' if (' + ($nextValid) + ') { ';
        $closingBraces += '}';
      }
    }
  } else if ((it.opts.strictKeywords ? typeof $schema == 'object' && Object.keys($schema).length > 0 : it.util.schemaHasRules($schema, it.RULES.all))) {
    $it.schema = $schema;
    $it.schemaPath = $schemaPath;
    $it.errSchemaPath = $errSchemaPath;
    out += '  for (var ' + ($idx) + ' = ' + (0) + '; ' + ($idx) + ' < ' + ($data) + '.length; ' + ($idx) + '++) { ';
    $it.errorPath = it.util.getPathExpr(it.errorPath, $idx, it.opts.jsonPointers, true);
    var $passData = $data + '[' + $idx + ']';
    $it.dataPathArr[$dataNxt] = $idx;
    var $code = it.validate($it);
    $it.baseId = $currentBaseId;
    if (it.util.varOccurences($code, $nextData) < 2) {
      out += ' ' + (it.util.varReplace($code, $nextData, $passData)) + ' ';
    } else {
      out += ' var ' + ($nextData) + ' = ' + ($passData) + '; ' + ($code) + ' ';
    }
    if ($breakOnError) {
      out += ' if (!' + ($nextValid) + ') break; ';
    }
    out += ' }';
  }
  if ($breakOnError) {
    out += ' ' + ($closingBraces) + ' if (' + ($errs) + ' == errors) {';
  }
  out = it.util.cleanUpCode(out);
  return out;
}

},{}],30:[function(require,module,exports){
'use strict';
module.exports = function generate_multipleOf(it, $keyword, $ruleType) {
  var out = ' ';
  var $lvl = it.level;
  var $dataLvl = it.dataLevel;
  var $schema = it.schema[$keyword];
  var $schemaPath = it.schemaPath + it.util.getProperty($keyword);
  var $errSchemaPath = it.errSchemaPath + '/' + $keyword;
  var $breakOnError = !it.opts.allErrors;
  var $data = 'data' + ($dataLvl || '');
  var $isData = it.opts.$data && $schema && $schema.$data,
    $schemaValue;
  if ($isData) {
    out += ' var schema' + ($lvl) + ' = ' + (it.util.getData($schema.$data, $dataLvl, it.dataPathArr)) + '; ';
    $schemaValue = 'schema' + $lvl;
  } else {
    $schemaValue = $schema;
  }
  out += 'var division' + ($lvl) + ';if (';
  if ($isData) {
    out += ' ' + ($schemaValue) + ' !== undefined && ( typeof ' + ($schemaValue) + ' != \'number\' || ';
  }
  out += ' (division' + ($lvl) + ' = ' + ($data) + ' / ' + ($schemaValue) + ', ';
  if (it.opts.multipleOfPrecision) {
    out += ' Math.abs(Math.round(division' + ($lvl) + ') - division' + ($lvl) + ') > 1e-' + (it.opts.multipleOfPrecision) + ' ';
  } else {
    out += ' division' + ($lvl) + ' !== parseInt(division' + ($lvl) + ') ';
  }
  out += ' ) ';
  if ($isData) {
    out += '  )  ';
  }
  out += ' ) {   ';
  var $$outStack = $$outStack || [];
  $$outStack.push(out);
  out = ''; /* istanbul ignore else */
  if (it.createErrors !== false) {
    out += ' { keyword: \'' + ('multipleOf') + '\' , dataPath: (dataPath || \'\') + ' + (it.errorPath) + ' , schemaPath: ' + (it.util.toQuotedString($errSchemaPath)) + ' , params: { multipleOf: ' + ($schemaValue) + ' } ';
    if (it.opts.messages !== false) {
      out += ' , message: \'should be multiple of ';
      if ($isData) {
        out += '\' + ' + ($schemaValue);
      } else {
        out += '' + ($schemaValue) + '\'';
      }
    }
    if (it.opts.verbose) {
      out += ' , schema:  ';
      if ($isData) {
        out += 'validate.schema' + ($schemaPath);
      } else {
        out += '' + ($schema);
      }
      out += '         , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
    }
    out += ' } ';
  } else {
    out += ' {} ';
  }
  var __err = out;
  out = $$outStack.pop();
  if (!it.compositeRule && $breakOnError) {
    /* istanbul ignore if */
    if (it.async) {
      out += ' throw new ValidationError([' + (__err) + ']); ';
    } else {
      out += ' validate.errors = [' + (__err) + ']; return false; ';
    }
  } else {
    out += ' var err = ' + (__err) + ';  if (vErrors === null) vErrors = [err]; else vErrors.push(err); errors++; ';
  }
  out += '} ';
  if ($breakOnError) {
    out += ' else { ';
  }
  return out;
}

},{}],31:[function(require,module,exports){
'use strict';
module.exports = function generate_not(it, $keyword, $ruleType) {
  var out = ' ';
  var $lvl = it.level;
  var $dataLvl = it.dataLevel;
  var $schema = it.schema[$keyword];
  var $schemaPath = it.schemaPath + it.util.getProperty($keyword);
  var $errSchemaPath = it.errSchemaPath + '/' + $keyword;
  var $breakOnError = !it.opts.allErrors;
  var $data = 'data' + ($dataLvl || '');
  var $errs = 'errs__' + $lvl;
  var $it = it.util.copy(it);
  $it.level++;
  var $nextValid = 'valid' + $it.level;
  if ((it.opts.strictKeywords ? typeof $schema == 'object' && Object.keys($schema).length > 0 : it.util.schemaHasRules($schema, it.RULES.all))) {
    $it.schema = $schema;
    $it.schemaPath = $schemaPath;
    $it.errSchemaPath = $errSchemaPath;
    out += ' var ' + ($errs) + ' = errors;  ';
    var $wasComposite = it.compositeRule;
    it.compositeRule = $it.compositeRule = true;
    $it.createErrors = false;
    var $allErrorsOption;
    if ($it.opts.allErrors) {
      $allErrorsOption = $it.opts.allErrors;
      $it.opts.allErrors = false;
    }
    out += ' ' + (it.validate($it)) + ' ';
    $it.createErrors = true;
    if ($allErrorsOption) $it.opts.allErrors = $allErrorsOption;
    it.compositeRule = $it.compositeRule = $wasComposite;
    out += ' if (' + ($nextValid) + ') {   ';
    var $$outStack = $$outStack || [];
    $$outStack.push(out);
    out = ''; /* istanbul ignore else */
    if (it.createErrors !== false) {
      out += ' { keyword: \'' + ('not') + '\' , dataPath: (dataPath || \'\') + ' + (it.errorPath) + ' , schemaPath: ' + (it.util.toQuotedString($errSchemaPath)) + ' , params: {} ';
      if (it.opts.messages !== false) {
        out += ' , message: \'should NOT be valid\' ';
      }
      if (it.opts.verbose) {
        out += ' , schema: validate.schema' + ($schemaPath) + ' , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
      }
      out += ' } ';
    } else {
      out += ' {} ';
    }
    var __err = out;
    out = $$outStack.pop();
    if (!it.compositeRule && $breakOnError) {
      /* istanbul ignore if */
      if (it.async) {
        out += ' throw new ValidationError([' + (__err) + ']); ';
      } else {
        out += ' validate.errors = [' + (__err) + ']; return false; ';
      }
    } else {
      out += ' var err = ' + (__err) + ';  if (vErrors === null) vErrors = [err]; else vErrors.push(err); errors++; ';
    }
    out += ' } else {  errors = ' + ($errs) + '; if (vErrors !== null) { if (' + ($errs) + ') vErrors.length = ' + ($errs) + '; else vErrors = null; } ';
    if (it.opts.allErrors) {
      out += ' } ';
    }
  } else {
    out += '  var err =   '; /* istanbul ignore else */
    if (it.createErrors !== false) {
      out += ' { keyword: \'' + ('not') + '\' , dataPath: (dataPath || \'\') + ' + (it.errorPath) + ' , schemaPath: ' + (it.util.toQuotedString($errSchemaPath)) + ' , params: {} ';
      if (it.opts.messages !== false) {
        out += ' , message: \'should NOT be valid\' ';
      }
      if (it.opts.verbose) {
        out += ' , schema: validate.schema' + ($schemaPath) + ' , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
      }
      out += ' } ';
    } else {
      out += ' {} ';
    }
    out += ';  if (vErrors === null) vErrors = [err]; else vErrors.push(err); errors++; ';
    if ($breakOnError) {
      out += ' if (false) { ';
    }
  }
  return out;
}

},{}],32:[function(require,module,exports){
'use strict';
module.exports = function generate_oneOf(it, $keyword, $ruleType) {
  var out = ' ';
  var $lvl = it.level;
  var $dataLvl = it.dataLevel;
  var $schema = it.schema[$keyword];
  var $schemaPath = it.schemaPath + it.util.getProperty($keyword);
  var $errSchemaPath = it.errSchemaPath + '/' + $keyword;
  var $breakOnError = !it.opts.allErrors;
  var $data = 'data' + ($dataLvl || '');
  var $valid = 'valid' + $lvl;
  var $errs = 'errs__' + $lvl;
  var $it = it.util.copy(it);
  var $closingBraces = '';
  $it.level++;
  var $nextValid = 'valid' + $it.level;
  var $currentBaseId = $it.baseId,
    $prevValid = 'prevValid' + $lvl,
    $passingSchemas = 'passingSchemas' + $lvl;
  out += 'var ' + ($errs) + ' = errors , ' + ($prevValid) + ' = false , ' + ($valid) + ' = false , ' + ($passingSchemas) + ' = null; ';
  var $wasComposite = it.compositeRule;
  it.compositeRule = $it.compositeRule = true;
  var arr1 = $schema;
  if (arr1) {
    var $sch, $i = -1,
      l1 = arr1.length - 1;
    while ($i < l1) {
      $sch = arr1[$i += 1];
      if ((it.opts.strictKeywords ? typeof $sch == 'object' && Object.keys($sch).length > 0 : it.util.schemaHasRules($sch, it.RULES.all))) {
        $it.schema = $sch;
        $it.schemaPath = $schemaPath + '[' + $i + ']';
        $it.errSchemaPath = $errSchemaPath + '/' + $i;
        out += '  ' + (it.validate($it)) + ' ';
        $it.baseId = $currentBaseId;
      } else {
        out += ' var ' + ($nextValid) + ' = true; ';
      }
      if ($i) {
        out += ' if (' + ($nextValid) + ' && ' + ($prevValid) + ') { ' + ($valid) + ' = false; ' + ($passingSchemas) + ' = [' + ($passingSchemas) + ', ' + ($i) + ']; } else { ';
        $closingBraces += '}';
      }
      out += ' if (' + ($nextValid) + ') { ' + ($valid) + ' = ' + ($prevValid) + ' = true; ' + ($passingSchemas) + ' = ' + ($i) + '; }';
    }
  }
  it.compositeRule = $it.compositeRule = $wasComposite;
  out += '' + ($closingBraces) + 'if (!' + ($valid) + ') {   var err =   '; /* istanbul ignore else */
  if (it.createErrors !== false) {
    out += ' { keyword: \'' + ('oneOf') + '\' , dataPath: (dataPath || \'\') + ' + (it.errorPath) + ' , schemaPath: ' + (it.util.toQuotedString($errSchemaPath)) + ' , params: { passingSchemas: ' + ($passingSchemas) + ' } ';
    if (it.opts.messages !== false) {
      out += ' , message: \'should match exactly one schema in oneOf\' ';
    }
    if (it.opts.verbose) {
      out += ' , schema: validate.schema' + ($schemaPath) + ' , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
    }
    out += ' } ';
  } else {
    out += ' {} ';
  }
  out += ';  if (vErrors === null) vErrors = [err]; else vErrors.push(err); errors++; ';
  if (!it.compositeRule && $breakOnError) {
    /* istanbul ignore if */
    if (it.async) {
      out += ' throw new ValidationError(vErrors); ';
    } else {
      out += ' validate.errors = vErrors; return false; ';
    }
  }
  out += '} else {  errors = ' + ($errs) + '; if (vErrors !== null) { if (' + ($errs) + ') vErrors.length = ' + ($errs) + '; else vErrors = null; }';
  if (it.opts.allErrors) {
    out += ' } ';
  }
  return out;
}

},{}],33:[function(require,module,exports){
'use strict';
module.exports = function generate_pattern(it, $keyword, $ruleType) {
  var out = ' ';
  var $lvl = it.level;
  var $dataLvl = it.dataLevel;
  var $schema = it.schema[$keyword];
  var $schemaPath = it.schemaPath + it.util.getProperty($keyword);
  var $errSchemaPath = it.errSchemaPath + '/' + $keyword;
  var $breakOnError = !it.opts.allErrors;
  var $data = 'data' + ($dataLvl || '');
  var $isData = it.opts.$data && $schema && $schema.$data,
    $schemaValue;
  if ($isData) {
    out += ' var schema' + ($lvl) + ' = ' + (it.util.getData($schema.$data, $dataLvl, it.dataPathArr)) + '; ';
    $schemaValue = 'schema' + $lvl;
  } else {
    $schemaValue = $schema;
  }
  var $regexp = $isData ? '(new RegExp(' + $schemaValue + '))' : it.usePattern($schema);
  out += 'if ( ';
  if ($isData) {
    out += ' (' + ($schemaValue) + ' !== undefined && typeof ' + ($schemaValue) + ' != \'string\') || ';
  }
  out += ' !' + ($regexp) + '.test(' + ($data) + ') ) {   ';
  var $$outStack = $$outStack || [];
  $$outStack.push(out);
  out = ''; /* istanbul ignore else */
  if (it.createErrors !== false) {
    out += ' { keyword: \'' + ('pattern') + '\' , dataPath: (dataPath || \'\') + ' + (it.errorPath) + ' , schemaPath: ' + (it.util.toQuotedString($errSchemaPath)) + ' , params: { pattern:  ';
    if ($isData) {
      out += '' + ($schemaValue);
    } else {
      out += '' + (it.util.toQuotedString($schema));
    }
    out += '  } ';
    if (it.opts.messages !== false) {
      out += ' , message: \'should match pattern "';
      if ($isData) {
        out += '\' + ' + ($schemaValue) + ' + \'';
      } else {
        out += '' + (it.util.escapeQuotes($schema));
      }
      out += '"\' ';
    }
    if (it.opts.verbose) {
      out += ' , schema:  ';
      if ($isData) {
        out += 'validate.schema' + ($schemaPath);
      } else {
        out += '' + (it.util.toQuotedString($schema));
      }
      out += '         , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
    }
    out += ' } ';
  } else {
    out += ' {} ';
  }
  var __err = out;
  out = $$outStack.pop();
  if (!it.compositeRule && $breakOnError) {
    /* istanbul ignore if */
    if (it.async) {
      out += ' throw new ValidationError([' + (__err) + ']); ';
    } else {
      out += ' validate.errors = [' + (__err) + ']; return false; ';
    }
  } else {
    out += ' var err = ' + (__err) + ';  if (vErrors === null) vErrors = [err]; else vErrors.push(err); errors++; ';
  }
  out += '} ';
  if ($breakOnError) {
    out += ' else { ';
  }
  return out;
}

},{}],34:[function(require,module,exports){
'use strict';
module.exports = function generate_properties(it, $keyword, $ruleType) {
  var out = ' ';
  var $lvl = it.level;
  var $dataLvl = it.dataLevel;
  var $schema = it.schema[$keyword];
  var $schemaPath = it.schemaPath + it.util.getProperty($keyword);
  var $errSchemaPath = it.errSchemaPath + '/' + $keyword;
  var $breakOnError = !it.opts.allErrors;
  var $data = 'data' + ($dataLvl || '');
  var $errs = 'errs__' + $lvl;
  var $it = it.util.copy(it);
  var $closingBraces = '';
  $it.level++;
  var $nextValid = 'valid' + $it.level;
  var $key = 'key' + $lvl,
    $idx = 'idx' + $lvl,
    $dataNxt = $it.dataLevel = it.dataLevel + 1,
    $nextData = 'data' + $dataNxt,
    $dataProperties = 'dataProperties' + $lvl;
  var $schemaKeys = Object.keys($schema || {}),
    $pProperties = it.schema.patternProperties || {},
    $pPropertyKeys = Object.keys($pProperties),
    $aProperties = it.schema.additionalProperties,
    $someProperties = $schemaKeys.length || $pPropertyKeys.length,
    $noAdditional = $aProperties === false,
    $additionalIsSchema = typeof $aProperties == 'object' && Object.keys($aProperties).length,
    $removeAdditional = it.opts.removeAdditional,
    $checkAdditional = $noAdditional || $additionalIsSchema || $removeAdditional,
    $ownProperties = it.opts.ownProperties,
    $currentBaseId = it.baseId;
  var $required = it.schema.required;
  if ($required && !(it.opts.$data && $required.$data) && $required.length < it.opts.loopRequired) var $requiredHash = it.util.toHash($required);
  out += 'var ' + ($errs) + ' = errors;var ' + ($nextValid) + ' = true;';
  if ($ownProperties) {
    out += ' var ' + ($dataProperties) + ' = undefined;';
  }
  if ($checkAdditional) {
    if ($ownProperties) {
      out += ' ' + ($dataProperties) + ' = ' + ($dataProperties) + ' || Object.keys(' + ($data) + '); for (var ' + ($idx) + '=0; ' + ($idx) + '<' + ($dataProperties) + '.length; ' + ($idx) + '++) { var ' + ($key) + ' = ' + ($dataProperties) + '[' + ($idx) + ']; ';
    } else {
      out += ' for (var ' + ($key) + ' in ' + ($data) + ') { ';
    }
    if ($someProperties) {
      out += ' var isAdditional' + ($lvl) + ' = !(false ';
      if ($schemaKeys.length) {
        if ($schemaKeys.length > 8) {
          out += ' || validate.schema' + ($schemaPath) + '.hasOwnProperty(' + ($key) + ') ';
        } else {
          var arr1 = $schemaKeys;
          if (arr1) {
            var $propertyKey, i1 = -1,
              l1 = arr1.length - 1;
            while (i1 < l1) {
              $propertyKey = arr1[i1 += 1];
              out += ' || ' + ($key) + ' == ' + (it.util.toQuotedString($propertyKey)) + ' ';
            }
          }
        }
      }
      if ($pPropertyKeys.length) {
        var arr2 = $pPropertyKeys;
        if (arr2) {
          var $pProperty, $i = -1,
            l2 = arr2.length - 1;
          while ($i < l2) {
            $pProperty = arr2[$i += 1];
            out += ' || ' + (it.usePattern($pProperty)) + '.test(' + ($key) + ') ';
          }
        }
      }
      out += ' ); if (isAdditional' + ($lvl) + ') { ';
    }
    if ($removeAdditional == 'all') {
      out += ' delete ' + ($data) + '[' + ($key) + ']; ';
    } else {
      var $currentErrorPath = it.errorPath;
      var $additionalProperty = '\' + ' + $key + ' + \'';
      if (it.opts._errorDataPathProperty) {
        it.errorPath = it.util.getPathExpr(it.errorPath, $key, it.opts.jsonPointers);
      }
      if ($noAdditional) {
        if ($removeAdditional) {
          out += ' delete ' + ($data) + '[' + ($key) + ']; ';
        } else {
          out += ' ' + ($nextValid) + ' = false; ';
          var $currErrSchemaPath = $errSchemaPath;
          $errSchemaPath = it.errSchemaPath + '/additionalProperties';
          var $$outStack = $$outStack || [];
          $$outStack.push(out);
          out = ''; /* istanbul ignore else */
          if (it.createErrors !== false) {
            out += ' { keyword: \'' + ('additionalProperties') + '\' , dataPath: (dataPath || \'\') + ' + (it.errorPath) + ' , schemaPath: ' + (it.util.toQuotedString($errSchemaPath)) + ' , params: { additionalProperty: \'' + ($additionalProperty) + '\' } ';
            if (it.opts.messages !== false) {
              out += ' , message: \'';
              if (it.opts._errorDataPathProperty) {
                out += 'is an invalid additional property';
              } else {
                out += 'should NOT have additional properties';
              }
              out += '\' ';
            }
            if (it.opts.verbose) {
              out += ' , schema: false , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
            }
            out += ' } ';
          } else {
            out += ' {} ';
          }
          var __err = out;
          out = $$outStack.pop();
          if (!it.compositeRule && $breakOnError) {
            /* istanbul ignore if */
            if (it.async) {
              out += ' throw new ValidationError([' + (__err) + ']); ';
            } else {
              out += ' validate.errors = [' + (__err) + ']; return false; ';
            }
          } else {
            out += ' var err = ' + (__err) + ';  if (vErrors === null) vErrors = [err]; else vErrors.push(err); errors++; ';
          }
          $errSchemaPath = $currErrSchemaPath;
          if ($breakOnError) {
            out += ' break; ';
          }
        }
      } else if ($additionalIsSchema) {
        if ($removeAdditional == 'failing') {
          out += ' var ' + ($errs) + ' = errors;  ';
          var $wasComposite = it.compositeRule;
          it.compositeRule = $it.compositeRule = true;
          $it.schema = $aProperties;
          $it.schemaPath = it.schemaPath + '.additionalProperties';
          $it.errSchemaPath = it.errSchemaPath + '/additionalProperties';
          $it.errorPath = it.opts._errorDataPathProperty ? it.errorPath : it.util.getPathExpr(it.errorPath, $key, it.opts.jsonPointers);
          var $passData = $data + '[' + $key + ']';
          $it.dataPathArr[$dataNxt] = $key;
          var $code = it.validate($it);
          $it.baseId = $currentBaseId;
          if (it.util.varOccurences($code, $nextData) < 2) {
            out += ' ' + (it.util.varReplace($code, $nextData, $passData)) + ' ';
          } else {
            out += ' var ' + ($nextData) + ' = ' + ($passData) + '; ' + ($code) + ' ';
          }
          out += ' if (!' + ($nextValid) + ') { errors = ' + ($errs) + '; if (validate.errors !== null) { if (errors) validate.errors.length = errors; else validate.errors = null; } delete ' + ($data) + '[' + ($key) + ']; }  ';
          it.compositeRule = $it.compositeRule = $wasComposite;
        } else {
          $it.schema = $aProperties;
          $it.schemaPath = it.schemaPath + '.additionalProperties';
          $it.errSchemaPath = it.errSchemaPath + '/additionalProperties';
          $it.errorPath = it.opts._errorDataPathProperty ? it.errorPath : it.util.getPathExpr(it.errorPath, $key, it.opts.jsonPointers);
          var $passData = $data + '[' + $key + ']';
          $it.dataPathArr[$dataNxt] = $key;
          var $code = it.validate($it);
          $it.baseId = $currentBaseId;
          if (it.util.varOccurences($code, $nextData) < 2) {
            out += ' ' + (it.util.varReplace($code, $nextData, $passData)) + ' ';
          } else {
            out += ' var ' + ($nextData) + ' = ' + ($passData) + '; ' + ($code) + ' ';
          }
          if ($breakOnError) {
            out += ' if (!' + ($nextValid) + ') break; ';
          }
        }
      }
      it.errorPath = $currentErrorPath;
    }
    if ($someProperties) {
      out += ' } ';
    }
    out += ' }  ';
    if ($breakOnError) {
      out += ' if (' + ($nextValid) + ') { ';
      $closingBraces += '}';
    }
  }
  var $useDefaults = it.opts.useDefaults && !it.compositeRule;
  if ($schemaKeys.length) {
    var arr3 = $schemaKeys;
    if (arr3) {
      var $propertyKey, i3 = -1,
        l3 = arr3.length - 1;
      while (i3 < l3) {
        $propertyKey = arr3[i3 += 1];
        var $sch = $schema[$propertyKey];
        if ((it.opts.strictKeywords ? typeof $sch == 'object' && Object.keys($sch).length > 0 : it.util.schemaHasRules($sch, it.RULES.all))) {
          var $prop = it.util.getProperty($propertyKey),
            $passData = $data + $prop,
            $hasDefault = $useDefaults && $sch.default !== undefined;
          $it.schema = $sch;
          $it.schemaPath = $schemaPath + $prop;
          $it.errSchemaPath = $errSchemaPath + '/' + it.util.escapeFragment($propertyKey);
          $it.errorPath = it.util.getPath(it.errorPath, $propertyKey, it.opts.jsonPointers);
          $it.dataPathArr[$dataNxt] = it.util.toQuotedString($propertyKey);
          var $code = it.validate($it);
          $it.baseId = $currentBaseId;
          if (it.util.varOccurences($code, $nextData) < 2) {
            $code = it.util.varReplace($code, $nextData, $passData);
            var $useData = $passData;
          } else {
            var $useData = $nextData;
            out += ' var ' + ($nextData) + ' = ' + ($passData) + '; ';
          }
          if ($hasDefault) {
            out += ' ' + ($code) + ' ';
          } else {
            if ($requiredHash && $requiredHash[$propertyKey]) {
              out += ' if ( ' + ($useData) + ' === undefined ';
              if ($ownProperties) {
                out += ' || ! Object.prototype.hasOwnProperty.call(' + ($data) + ', \'' + (it.util.escapeQuotes($propertyKey)) + '\') ';
              }
              out += ') { ' + ($nextValid) + ' = false; ';
              var $currentErrorPath = it.errorPath,
                $currErrSchemaPath = $errSchemaPath,
                $missingProperty = it.util.escapeQuotes($propertyKey);
              if (it.opts._errorDataPathProperty) {
                it.errorPath = it.util.getPath($currentErrorPath, $propertyKey, it.opts.jsonPointers);
              }
              $errSchemaPath = it.errSchemaPath + '/required';
              var $$outStack = $$outStack || [];
              $$outStack.push(out);
              out = ''; /* istanbul ignore else */
              if (it.createErrors !== false) {
                out += ' { keyword: \'' + ('required') + '\' , dataPath: (dataPath || \'\') + ' + (it.errorPath) + ' , schemaPath: ' + (it.util.toQuotedString($errSchemaPath)) + ' , params: { missingProperty: \'' + ($missingProperty) + '\' } ';
                if (it.opts.messages !== false) {
                  out += ' , message: \'';
                  if (it.opts._errorDataPathProperty) {
                    out += 'is a required property';
                  } else {
                    out += 'should have required property \\\'' + ($missingProperty) + '\\\'';
                  }
                  out += '\' ';
                }
                if (it.opts.verbose) {
                  out += ' , schema: validate.schema' + ($schemaPath) + ' , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
                }
                out += ' } ';
              } else {
                out += ' {} ';
              }
              var __err = out;
              out = $$outStack.pop();
              if (!it.compositeRule && $breakOnError) {
                /* istanbul ignore if */
                if (it.async) {
                  out += ' throw new ValidationError([' + (__err) + ']); ';
                } else {
                  out += ' validate.errors = [' + (__err) + ']; return false; ';
                }
              } else {
                out += ' var err = ' + (__err) + ';  if (vErrors === null) vErrors = [err]; else vErrors.push(err); errors++; ';
              }
              $errSchemaPath = $currErrSchemaPath;
              it.errorPath = $currentErrorPath;
              out += ' } else { ';
            } else {
              if ($breakOnError) {
                out += ' if ( ' + ($useData) + ' === undefined ';
                if ($ownProperties) {
                  out += ' || ! Object.prototype.hasOwnProperty.call(' + ($data) + ', \'' + (it.util.escapeQuotes($propertyKey)) + '\') ';
                }
                out += ') { ' + ($nextValid) + ' = true; } else { ';
              } else {
                out += ' if (' + ($useData) + ' !== undefined ';
                if ($ownProperties) {
                  out += ' &&   Object.prototype.hasOwnProperty.call(' + ($data) + ', \'' + (it.util.escapeQuotes($propertyKey)) + '\') ';
                }
                out += ' ) { ';
              }
            }
            out += ' ' + ($code) + ' } ';
          }
        }
        if ($breakOnError) {
          out += ' if (' + ($nextValid) + ') { ';
          $closingBraces += '}';
        }
      }
    }
  }
  if ($pPropertyKeys.length) {
    var arr4 = $pPropertyKeys;
    if (arr4) {
      var $pProperty, i4 = -1,
        l4 = arr4.length - 1;
      while (i4 < l4) {
        $pProperty = arr4[i4 += 1];
        var $sch = $pProperties[$pProperty];
        if ((it.opts.strictKeywords ? typeof $sch == 'object' && Object.keys($sch).length > 0 : it.util.schemaHasRules($sch, it.RULES.all))) {
          $it.schema = $sch;
          $it.schemaPath = it.schemaPath + '.patternProperties' + it.util.getProperty($pProperty);
          $it.errSchemaPath = it.errSchemaPath + '/patternProperties/' + it.util.escapeFragment($pProperty);
          if ($ownProperties) {
            out += ' ' + ($dataProperties) + ' = ' + ($dataProperties) + ' || Object.keys(' + ($data) + '); for (var ' + ($idx) + '=0; ' + ($idx) + '<' + ($dataProperties) + '.length; ' + ($idx) + '++) { var ' + ($key) + ' = ' + ($dataProperties) + '[' + ($idx) + ']; ';
          } else {
            out += ' for (var ' + ($key) + ' in ' + ($data) + ') { ';
          }
          out += ' if (' + (it.usePattern($pProperty)) + '.test(' + ($key) + ')) { ';
          $it.errorPath = it.util.getPathExpr(it.errorPath, $key, it.opts.jsonPointers);
          var $passData = $data + '[' + $key + ']';
          $it.dataPathArr[$dataNxt] = $key;
          var $code = it.validate($it);
          $it.baseId = $currentBaseId;
          if (it.util.varOccurences($code, $nextData) < 2) {
            out += ' ' + (it.util.varReplace($code, $nextData, $passData)) + ' ';
          } else {
            out += ' var ' + ($nextData) + ' = ' + ($passData) + '; ' + ($code) + ' ';
          }
          if ($breakOnError) {
            out += ' if (!' + ($nextValid) + ') break; ';
          }
          out += ' } ';
          if ($breakOnError) {
            out += ' else ' + ($nextValid) + ' = true; ';
          }
          out += ' }  ';
          if ($breakOnError) {
            out += ' if (' + ($nextValid) + ') { ';
            $closingBraces += '}';
          }
        }
      }
    }
  }
  if ($breakOnError) {
    out += ' ' + ($closingBraces) + ' if (' + ($errs) + ' == errors) {';
  }
  out = it.util.cleanUpCode(out);
  return out;
}

},{}],35:[function(require,module,exports){
'use strict';
module.exports = function generate_propertyNames(it, $keyword, $ruleType) {
  var out = ' ';
  var $lvl = it.level;
  var $dataLvl = it.dataLevel;
  var $schema = it.schema[$keyword];
  var $schemaPath = it.schemaPath + it.util.getProperty($keyword);
  var $errSchemaPath = it.errSchemaPath + '/' + $keyword;
  var $breakOnError = !it.opts.allErrors;
  var $data = 'data' + ($dataLvl || '');
  var $errs = 'errs__' + $lvl;
  var $it = it.util.copy(it);
  var $closingBraces = '';
  $it.level++;
  var $nextValid = 'valid' + $it.level;
  out += 'var ' + ($errs) + ' = errors;';
  if ((it.opts.strictKeywords ? typeof $schema == 'object' && Object.keys($schema).length > 0 : it.util.schemaHasRules($schema, it.RULES.all))) {
    $it.schema = $schema;
    $it.schemaPath = $schemaPath;
    $it.errSchemaPath = $errSchemaPath;
    var $key = 'key' + $lvl,
      $idx = 'idx' + $lvl,
      $i = 'i' + $lvl,
      $invalidName = '\' + ' + $key + ' + \'',
      $dataNxt = $it.dataLevel = it.dataLevel + 1,
      $nextData = 'data' + $dataNxt,
      $dataProperties = 'dataProperties' + $lvl,
      $ownProperties = it.opts.ownProperties,
      $currentBaseId = it.baseId;
    if ($ownProperties) {
      out += ' var ' + ($dataProperties) + ' = undefined; ';
    }
    if ($ownProperties) {
      out += ' ' + ($dataProperties) + ' = ' + ($dataProperties) + ' || Object.keys(' + ($data) + '); for (var ' + ($idx) + '=0; ' + ($idx) + '<' + ($dataProperties) + '.length; ' + ($idx) + '++) { var ' + ($key) + ' = ' + ($dataProperties) + '[' + ($idx) + ']; ';
    } else {
      out += ' for (var ' + ($key) + ' in ' + ($data) + ') { ';
    }
    out += ' var startErrs' + ($lvl) + ' = errors; ';
    var $passData = $key;
    var $wasComposite = it.compositeRule;
    it.compositeRule = $it.compositeRule = true;
    var $code = it.validate($it);
    $it.baseId = $currentBaseId;
    if (it.util.varOccurences($code, $nextData) < 2) {
      out += ' ' + (it.util.varReplace($code, $nextData, $passData)) + ' ';
    } else {
      out += ' var ' + ($nextData) + ' = ' + ($passData) + '; ' + ($code) + ' ';
    }
    it.compositeRule = $it.compositeRule = $wasComposite;
    out += ' if (!' + ($nextValid) + ') { for (var ' + ($i) + '=startErrs' + ($lvl) + '; ' + ($i) + '<errors; ' + ($i) + '++) { vErrors[' + ($i) + '].propertyName = ' + ($key) + '; }   var err =   '; /* istanbul ignore else */
    if (it.createErrors !== false) {
      out += ' { keyword: \'' + ('propertyNames') + '\' , dataPath: (dataPath || \'\') + ' + (it.errorPath) + ' , schemaPath: ' + (it.util.toQuotedString($errSchemaPath)) + ' , params: { propertyName: \'' + ($invalidName) + '\' } ';
      if (it.opts.messages !== false) {
        out += ' , message: \'property name \\\'' + ($invalidName) + '\\\' is invalid\' ';
      }
      if (it.opts.verbose) {
        out += ' , schema: validate.schema' + ($schemaPath) + ' , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
      }
      out += ' } ';
    } else {
      out += ' {} ';
    }
    out += ';  if (vErrors === null) vErrors = [err]; else vErrors.push(err); errors++; ';
    if (!it.compositeRule && $breakOnError) {
      /* istanbul ignore if */
      if (it.async) {
        out += ' throw new ValidationError(vErrors); ';
      } else {
        out += ' validate.errors = vErrors; return false; ';
      }
    }
    if ($breakOnError) {
      out += ' break; ';
    }
    out += ' } }';
  }
  if ($breakOnError) {
    out += ' ' + ($closingBraces) + ' if (' + ($errs) + ' == errors) {';
  }
  out = it.util.cleanUpCode(out);
  return out;
}

},{}],36:[function(require,module,exports){
'use strict';
module.exports = function generate_ref(it, $keyword, $ruleType) {
  var out = ' ';
  var $lvl = it.level;
  var $dataLvl = it.dataLevel;
  var $schema = it.schema[$keyword];
  var $errSchemaPath = it.errSchemaPath + '/' + $keyword;
  var $breakOnError = !it.opts.allErrors;
  var $data = 'data' + ($dataLvl || '');
  var $valid = 'valid' + $lvl;
  var $async, $refCode;
  if ($schema == '#' || $schema == '#/') {
    if (it.isRoot) {
      $async = it.async;
      $refCode = 'validate';
    } else {
      $async = it.root.schema.$async === true;
      $refCode = 'root.refVal[0]';
    }
  } else {
    var $refVal = it.resolveRef(it.baseId, $schema, it.isRoot);
    if ($refVal === undefined) {
      var $message = it.MissingRefError.message(it.baseId, $schema);
      if (it.opts.missingRefs == 'fail') {
        it.logger.error($message);
        var $$outStack = $$outStack || [];
        $$outStack.push(out);
        out = ''; /* istanbul ignore else */
        if (it.createErrors !== false) {
          out += ' { keyword: \'' + ('$ref') + '\' , dataPath: (dataPath || \'\') + ' + (it.errorPath) + ' , schemaPath: ' + (it.util.toQuotedString($errSchemaPath)) + ' , params: { ref: \'' + (it.util.escapeQuotes($schema)) + '\' } ';
          if (it.opts.messages !== false) {
            out += ' , message: \'can\\\'t resolve reference ' + (it.util.escapeQuotes($schema)) + '\' ';
          }
          if (it.opts.verbose) {
            out += ' , schema: ' + (it.util.toQuotedString($schema)) + ' , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
          }
          out += ' } ';
        } else {
          out += ' {} ';
        }
        var __err = out;
        out = $$outStack.pop();
        if (!it.compositeRule && $breakOnError) {
          /* istanbul ignore if */
          if (it.async) {
            out += ' throw new ValidationError([' + (__err) + ']); ';
          } else {
            out += ' validate.errors = [' + (__err) + ']; return false; ';
          }
        } else {
          out += ' var err = ' + (__err) + ';  if (vErrors === null) vErrors = [err]; else vErrors.push(err); errors++; ';
        }
        if ($breakOnError) {
          out += ' if (false) { ';
        }
      } else if (it.opts.missingRefs == 'ignore') {
        it.logger.warn($message);
        if ($breakOnError) {
          out += ' if (true) { ';
        }
      } else {
        throw new it.MissingRefError(it.baseId, $schema, $message);
      }
    } else if ($refVal.inline) {
      var $it = it.util.copy(it);
      $it.level++;
      var $nextValid = 'valid' + $it.level;
      $it.schema = $refVal.schema;
      $it.schemaPath = '';
      $it.errSchemaPath = $schema;
      var $code = it.validate($it).replace(/validate\.schema/g, $refVal.code);
      out += ' ' + ($code) + ' ';
      if ($breakOnError) {
        out += ' if (' + ($nextValid) + ') { ';
      }
    } else {
      $async = $refVal.$async === true || (it.async && $refVal.$async !== false);
      $refCode = $refVal.code;
    }
  }
  if ($refCode) {
    var $$outStack = $$outStack || [];
    $$outStack.push(out);
    out = '';
    if (it.opts.passContext) {
      out += ' ' + ($refCode) + '.call(this, ';
    } else {
      out += ' ' + ($refCode) + '( ';
    }
    out += ' ' + ($data) + ', (dataPath || \'\')';
    if (it.errorPath != '""') {
      out += ' + ' + (it.errorPath);
    }
    var $parentData = $dataLvl ? 'data' + (($dataLvl - 1) || '') : 'parentData',
      $parentDataProperty = $dataLvl ? it.dataPathArr[$dataLvl] : 'parentDataProperty';
    out += ' , ' + ($parentData) + ' , ' + ($parentDataProperty) + ', rootData)  ';
    var __callValidate = out;
    out = $$outStack.pop();
    if ($async) {
      if (!it.async) throw new Error('async schema referenced by sync schema');
      if ($breakOnError) {
        out += ' var ' + ($valid) + '; ';
      }
      out += ' try { await ' + (__callValidate) + '; ';
      if ($breakOnError) {
        out += ' ' + ($valid) + ' = true; ';
      }
      out += ' } catch (e) { if (!(e instanceof ValidationError)) throw e; if (vErrors === null) vErrors = e.errors; else vErrors = vErrors.concat(e.errors); errors = vErrors.length; ';
      if ($breakOnError) {
        out += ' ' + ($valid) + ' = false; ';
      }
      out += ' } ';
      if ($breakOnError) {
        out += ' if (' + ($valid) + ') { ';
      }
    } else {
      out += ' if (!' + (__callValidate) + ') { if (vErrors === null) vErrors = ' + ($refCode) + '.errors; else vErrors = vErrors.concat(' + ($refCode) + '.errors); errors = vErrors.length; } ';
      if ($breakOnError) {
        out += ' else { ';
      }
    }
  }
  return out;
}

},{}],37:[function(require,module,exports){
'use strict';
module.exports = function generate_required(it, $keyword, $ruleType) {
  var out = ' ';
  var $lvl = it.level;
  var $dataLvl = it.dataLevel;
  var $schema = it.schema[$keyword];
  var $schemaPath = it.schemaPath + it.util.getProperty($keyword);
  var $errSchemaPath = it.errSchemaPath + '/' + $keyword;
  var $breakOnError = !it.opts.allErrors;
  var $data = 'data' + ($dataLvl || '');
  var $valid = 'valid' + $lvl;
  var $isData = it.opts.$data && $schema && $schema.$data,
    $schemaValue;
  if ($isData) {
    out += ' var schema' + ($lvl) + ' = ' + (it.util.getData($schema.$data, $dataLvl, it.dataPathArr)) + '; ';
    $schemaValue = 'schema' + $lvl;
  } else {
    $schemaValue = $schema;
  }
  var $vSchema = 'schema' + $lvl;
  if (!$isData) {
    if ($schema.length < it.opts.loopRequired && it.schema.properties && Object.keys(it.schema.properties).length) {
      var $required = [];
      var arr1 = $schema;
      if (arr1) {
        var $property, i1 = -1,
          l1 = arr1.length - 1;
        while (i1 < l1) {
          $property = arr1[i1 += 1];
          var $propertySch = it.schema.properties[$property];
          if (!($propertySch && (it.opts.strictKeywords ? typeof $propertySch == 'object' && Object.keys($propertySch).length > 0 : it.util.schemaHasRules($propertySch, it.RULES.all)))) {
            $required[$required.length] = $property;
          }
        }
      }
    } else {
      var $required = $schema;
    }
  }
  if ($isData || $required.length) {
    var $currentErrorPath = it.errorPath,
      $loopRequired = $isData || $required.length >= it.opts.loopRequired,
      $ownProperties = it.opts.ownProperties;
    if ($breakOnError) {
      out += ' var missing' + ($lvl) + '; ';
      if ($loopRequired) {
        if (!$isData) {
          out += ' var ' + ($vSchema) + ' = validate.schema' + ($schemaPath) + '; ';
        }
        var $i = 'i' + $lvl,
          $propertyPath = 'schema' + $lvl + '[' + $i + ']',
          $missingProperty = '\' + ' + $propertyPath + ' + \'';
        if (it.opts._errorDataPathProperty) {
          it.errorPath = it.util.getPathExpr($currentErrorPath, $propertyPath, it.opts.jsonPointers);
        }
        out += ' var ' + ($valid) + ' = true; ';
        if ($isData) {
          out += ' if (schema' + ($lvl) + ' === undefined) ' + ($valid) + ' = true; else if (!Array.isArray(schema' + ($lvl) + ')) ' + ($valid) + ' = false; else {';
        }
        out += ' for (var ' + ($i) + ' = 0; ' + ($i) + ' < ' + ($vSchema) + '.length; ' + ($i) + '++) { ' + ($valid) + ' = ' + ($data) + '[' + ($vSchema) + '[' + ($i) + ']] !== undefined ';
        if ($ownProperties) {
          out += ' &&   Object.prototype.hasOwnProperty.call(' + ($data) + ', ' + ($vSchema) + '[' + ($i) + ']) ';
        }
        out += '; if (!' + ($valid) + ') break; } ';
        if ($isData) {
          out += '  }  ';
        }
        out += '  if (!' + ($valid) + ') {   ';
        var $$outStack = $$outStack || [];
        $$outStack.push(out);
        out = ''; /* istanbul ignore else */
        if (it.createErrors !== false) {
          out += ' { keyword: \'' + ('required') + '\' , dataPath: (dataPath || \'\') + ' + (it.errorPath) + ' , schemaPath: ' + (it.util.toQuotedString($errSchemaPath)) + ' , params: { missingProperty: \'' + ($missingProperty) + '\' } ';
          if (it.opts.messages !== false) {
            out += ' , message: \'';
            if (it.opts._errorDataPathProperty) {
              out += 'is a required property';
            } else {
              out += 'should have required property \\\'' + ($missingProperty) + '\\\'';
            }
            out += '\' ';
          }
          if (it.opts.verbose) {
            out += ' , schema: validate.schema' + ($schemaPath) + ' , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
          }
          out += ' } ';
        } else {
          out += ' {} ';
        }
        var __err = out;
        out = $$outStack.pop();
        if (!it.compositeRule && $breakOnError) {
          /* istanbul ignore if */
          if (it.async) {
            out += ' throw new ValidationError([' + (__err) + ']); ';
          } else {
            out += ' validate.errors = [' + (__err) + ']; return false; ';
          }
        } else {
          out += ' var err = ' + (__err) + ';  if (vErrors === null) vErrors = [err]; else vErrors.push(err); errors++; ';
        }
        out += ' } else { ';
      } else {
        out += ' if ( ';
        var arr2 = $required;
        if (arr2) {
          var $propertyKey, $i = -1,
            l2 = arr2.length - 1;
          while ($i < l2) {
            $propertyKey = arr2[$i += 1];
            if ($i) {
              out += ' || ';
            }
            var $prop = it.util.getProperty($propertyKey),
              $useData = $data + $prop;
            out += ' ( ( ' + ($useData) + ' === undefined ';
            if ($ownProperties) {
              out += ' || ! Object.prototype.hasOwnProperty.call(' + ($data) + ', \'' + (it.util.escapeQuotes($propertyKey)) + '\') ';
            }
            out += ') && (missing' + ($lvl) + ' = ' + (it.util.toQuotedString(it.opts.jsonPointers ? $propertyKey : $prop)) + ') ) ';
          }
        }
        out += ') {  ';
        var $propertyPath = 'missing' + $lvl,
          $missingProperty = '\' + ' + $propertyPath + ' + \'';
        if (it.opts._errorDataPathProperty) {
          it.errorPath = it.opts.jsonPointers ? it.util.getPathExpr($currentErrorPath, $propertyPath, true) : $currentErrorPath + ' + ' + $propertyPath;
        }
        var $$outStack = $$outStack || [];
        $$outStack.push(out);
        out = ''; /* istanbul ignore else */
        if (it.createErrors !== false) {
          out += ' { keyword: \'' + ('required') + '\' , dataPath: (dataPath || \'\') + ' + (it.errorPath) + ' , schemaPath: ' + (it.util.toQuotedString($errSchemaPath)) + ' , params: { missingProperty: \'' + ($missingProperty) + '\' } ';
          if (it.opts.messages !== false) {
            out += ' , message: \'';
            if (it.opts._errorDataPathProperty) {
              out += 'is a required property';
            } else {
              out += 'should have required property \\\'' + ($missingProperty) + '\\\'';
            }
            out += '\' ';
          }
          if (it.opts.verbose) {
            out += ' , schema: validate.schema' + ($schemaPath) + ' , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
          }
          out += ' } ';
        } else {
          out += ' {} ';
        }
        var __err = out;
        out = $$outStack.pop();
        if (!it.compositeRule && $breakOnError) {
          /* istanbul ignore if */
          if (it.async) {
            out += ' throw new ValidationError([' + (__err) + ']); ';
          } else {
            out += ' validate.errors = [' + (__err) + ']; return false; ';
          }
        } else {
          out += ' var err = ' + (__err) + ';  if (vErrors === null) vErrors = [err]; else vErrors.push(err); errors++; ';
        }
        out += ' } else { ';
      }
    } else {
      if ($loopRequired) {
        if (!$isData) {
          out += ' var ' + ($vSchema) + ' = validate.schema' + ($schemaPath) + '; ';
        }
        var $i = 'i' + $lvl,
          $propertyPath = 'schema' + $lvl + '[' + $i + ']',
          $missingProperty = '\' + ' + $propertyPath + ' + \'';
        if (it.opts._errorDataPathProperty) {
          it.errorPath = it.util.getPathExpr($currentErrorPath, $propertyPath, it.opts.jsonPointers);
        }
        if ($isData) {
          out += ' if (' + ($vSchema) + ' && !Array.isArray(' + ($vSchema) + ')) {  var err =   '; /* istanbul ignore else */
          if (it.createErrors !== false) {
            out += ' { keyword: \'' + ('required') + '\' , dataPath: (dataPath || \'\') + ' + (it.errorPath) + ' , schemaPath: ' + (it.util.toQuotedString($errSchemaPath)) + ' , params: { missingProperty: \'' + ($missingProperty) + '\' } ';
            if (it.opts.messages !== false) {
              out += ' , message: \'';
              if (it.opts._errorDataPathProperty) {
                out += 'is a required property';
              } else {
                out += 'should have required property \\\'' + ($missingProperty) + '\\\'';
              }
              out += '\' ';
            }
            if (it.opts.verbose) {
              out += ' , schema: validate.schema' + ($schemaPath) + ' , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
            }
            out += ' } ';
          } else {
            out += ' {} ';
          }
          out += ';  if (vErrors === null) vErrors = [err]; else vErrors.push(err); errors++; } else if (' + ($vSchema) + ' !== undefined) { ';
        }
        out += ' for (var ' + ($i) + ' = 0; ' + ($i) + ' < ' + ($vSchema) + '.length; ' + ($i) + '++) { if (' + ($data) + '[' + ($vSchema) + '[' + ($i) + ']] === undefined ';
        if ($ownProperties) {
          out += ' || ! Object.prototype.hasOwnProperty.call(' + ($data) + ', ' + ($vSchema) + '[' + ($i) + ']) ';
        }
        out += ') {  var err =   '; /* istanbul ignore else */
        if (it.createErrors !== false) {
          out += ' { keyword: \'' + ('required') + '\' , dataPath: (dataPath || \'\') + ' + (it.errorPath) + ' , schemaPath: ' + (it.util.toQuotedString($errSchemaPath)) + ' , params: { missingProperty: \'' + ($missingProperty) + '\' } ';
          if (it.opts.messages !== false) {
            out += ' , message: \'';
            if (it.opts._errorDataPathProperty) {
              out += 'is a required property';
            } else {
              out += 'should have required property \\\'' + ($missingProperty) + '\\\'';
            }
            out += '\' ';
          }
          if (it.opts.verbose) {
            out += ' , schema: validate.schema' + ($schemaPath) + ' , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
          }
          out += ' } ';
        } else {
          out += ' {} ';
        }
        out += ';  if (vErrors === null) vErrors = [err]; else vErrors.push(err); errors++; } } ';
        if ($isData) {
          out += '  }  ';
        }
      } else {
        var arr3 = $required;
        if (arr3) {
          var $propertyKey, i3 = -1,
            l3 = arr3.length - 1;
          while (i3 < l3) {
            $propertyKey = arr3[i3 += 1];
            var $prop = it.util.getProperty($propertyKey),
              $missingProperty = it.util.escapeQuotes($propertyKey),
              $useData = $data + $prop;
            if (it.opts._errorDataPathProperty) {
              it.errorPath = it.util.getPath($currentErrorPath, $propertyKey, it.opts.jsonPointers);
            }
            out += ' if ( ' + ($useData) + ' === undefined ';
            if ($ownProperties) {
              out += ' || ! Object.prototype.hasOwnProperty.call(' + ($data) + ', \'' + (it.util.escapeQuotes($propertyKey)) + '\') ';
            }
            out += ') {  var err =   '; /* istanbul ignore else */
            if (it.createErrors !== false) {
              out += ' { keyword: \'' + ('required') + '\' , dataPath: (dataPath || \'\') + ' + (it.errorPath) + ' , schemaPath: ' + (it.util.toQuotedString($errSchemaPath)) + ' , params: { missingProperty: \'' + ($missingProperty) + '\' } ';
              if (it.opts.messages !== false) {
                out += ' , message: \'';
                if (it.opts._errorDataPathProperty) {
                  out += 'is a required property';
                } else {
                  out += 'should have required property \\\'' + ($missingProperty) + '\\\'';
                }
                out += '\' ';
              }
              if (it.opts.verbose) {
                out += ' , schema: validate.schema' + ($schemaPath) + ' , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
              }
              out += ' } ';
            } else {
              out += ' {} ';
            }
            out += ';  if (vErrors === null) vErrors = [err]; else vErrors.push(err); errors++; } ';
          }
        }
      }
    }
    it.errorPath = $currentErrorPath;
  } else if ($breakOnError) {
    out += ' if (true) {';
  }
  return out;
}

},{}],38:[function(require,module,exports){
'use strict';
module.exports = function generate_uniqueItems(it, $keyword, $ruleType) {
  var out = ' ';
  var $lvl = it.level;
  var $dataLvl = it.dataLevel;
  var $schema = it.schema[$keyword];
  var $schemaPath = it.schemaPath + it.util.getProperty($keyword);
  var $errSchemaPath = it.errSchemaPath + '/' + $keyword;
  var $breakOnError = !it.opts.allErrors;
  var $data = 'data' + ($dataLvl || '');
  var $valid = 'valid' + $lvl;
  var $isData = it.opts.$data && $schema && $schema.$data,
    $schemaValue;
  if ($isData) {
    out += ' var schema' + ($lvl) + ' = ' + (it.util.getData($schema.$data, $dataLvl, it.dataPathArr)) + '; ';
    $schemaValue = 'schema' + $lvl;
  } else {
    $schemaValue = $schema;
  }
  if (($schema || $isData) && it.opts.uniqueItems !== false) {
    if ($isData) {
      out += ' var ' + ($valid) + '; if (' + ($schemaValue) + ' === false || ' + ($schemaValue) + ' === undefined) ' + ($valid) + ' = true; else if (typeof ' + ($schemaValue) + ' != \'boolean\') ' + ($valid) + ' = false; else { ';
    }
    out += ' var i = ' + ($data) + '.length , ' + ($valid) + ' = true , j; if (i > 1) { ';
    var $itemType = it.schema.items && it.schema.items.type,
      $typeIsArray = Array.isArray($itemType);
    if (!$itemType || $itemType == 'object' || $itemType == 'array' || ($typeIsArray && ($itemType.indexOf('object') >= 0 || $itemType.indexOf('array') >= 0))) {
      out += ' outer: for (;i--;) { for (j = i; j--;) { if (equal(' + ($data) + '[i], ' + ($data) + '[j])) { ' + ($valid) + ' = false; break outer; } } } ';
    } else {
      out += ' var itemIndices = {}, item; for (;i--;) { var item = ' + ($data) + '[i]; ';
      var $method = 'checkDataType' + ($typeIsArray ? 's' : '');
      out += ' if (' + (it.util[$method]($itemType, 'item', true)) + ') continue; ';
      if ($typeIsArray) {
        out += ' if (typeof item == \'string\') item = \'"\' + item; ';
      }
      out += ' if (typeof itemIndices[item] == \'number\') { ' + ($valid) + ' = false; j = itemIndices[item]; break; } itemIndices[item] = i; } ';
    }
    out += ' } ';
    if ($isData) {
      out += '  }  ';
    }
    out += ' if (!' + ($valid) + ') {   ';
    var $$outStack = $$outStack || [];
    $$outStack.push(out);
    out = ''; /* istanbul ignore else */
    if (it.createErrors !== false) {
      out += ' { keyword: \'' + ('uniqueItems') + '\' , dataPath: (dataPath || \'\') + ' + (it.errorPath) + ' , schemaPath: ' + (it.util.toQuotedString($errSchemaPath)) + ' , params: { i: i, j: j } ';
      if (it.opts.messages !== false) {
        out += ' , message: \'should NOT have duplicate items (items ## \' + j + \' and \' + i + \' are identical)\' ';
      }
      if (it.opts.verbose) {
        out += ' , schema:  ';
        if ($isData) {
          out += 'validate.schema' + ($schemaPath);
        } else {
          out += '' + ($schema);
        }
        out += '         , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
      }
      out += ' } ';
    } else {
      out += ' {} ';
    }
    var __err = out;
    out = $$outStack.pop();
    if (!it.compositeRule && $breakOnError) {
      /* istanbul ignore if */
      if (it.async) {
        out += ' throw new ValidationError([' + (__err) + ']); ';
      } else {
        out += ' validate.errors = [' + (__err) + ']; return false; ';
      }
    } else {
      out += ' var err = ' + (__err) + ';  if (vErrors === null) vErrors = [err]; else vErrors.push(err); errors++; ';
    }
    out += ' } ';
    if ($breakOnError) {
      out += ' else { ';
    }
  } else {
    if ($breakOnError) {
      out += ' if (true) { ';
    }
  }
  return out;
}

},{}],39:[function(require,module,exports){
'use strict';
module.exports = function generate_validate(it, $keyword, $ruleType) {
  var out = '';
  var $async = it.schema.$async === true,
    $refKeywords = it.util.schemaHasRulesExcept(it.schema, it.RULES.all, '$ref'),
    $id = it.self._getId(it.schema);
  if (it.opts.strictKeywords) {
    var $unknownKwd = it.util.schemaUnknownRules(it.schema, it.RULES.keywords);
    if ($unknownKwd) {
      var $keywordsMsg = 'unknown keyword: ' + $unknownKwd;
      if (it.opts.strictKeywords === 'log') it.logger.warn($keywordsMsg);
      else throw new Error($keywordsMsg);
    }
  }
  if (it.isTop) {
    out += ' var validate = ';
    if ($async) {
      it.async = true;
      out += 'async ';
    }
    out += 'function(data, dataPath, parentData, parentDataProperty, rootData) { \'use strict\'; ';
    if ($id && (it.opts.sourceCode || it.opts.processCode)) {
      out += ' ' + ('/\*# sourceURL=' + $id + ' */') + ' ';
    }
  }
  if (typeof it.schema == 'boolean' || !($refKeywords || it.schema.$ref)) {
    var $keyword = 'false schema';
    var $lvl = it.level;
    var $dataLvl = it.dataLevel;
    var $schema = it.schema[$keyword];
    var $schemaPath = it.schemaPath + it.util.getProperty($keyword);
    var $errSchemaPath = it.errSchemaPath + '/' + $keyword;
    var $breakOnError = !it.opts.allErrors;
    var $errorKeyword;
    var $data = 'data' + ($dataLvl || '');
    var $valid = 'valid' + $lvl;
    if (it.schema === false) {
      if (it.isTop) {
        $breakOnError = true;
      } else {
        out += ' var ' + ($valid) + ' = false; ';
      }
      var $$outStack = $$outStack || [];
      $$outStack.push(out);
      out = ''; /* istanbul ignore else */
      if (it.createErrors !== false) {
        out += ' { keyword: \'' + ($errorKeyword || 'false schema') + '\' , dataPath: (dataPath || \'\') + ' + (it.errorPath) + ' , schemaPath: ' + (it.util.toQuotedString($errSchemaPath)) + ' , params: {} ';
        if (it.opts.messages !== false) {
          out += ' , message: \'boolean schema is false\' ';
        }
        if (it.opts.verbose) {
          out += ' , schema: false , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
        }
        out += ' } ';
      } else {
        out += ' {} ';
      }
      var __err = out;
      out = $$outStack.pop();
      if (!it.compositeRule && $breakOnError) {
        /* istanbul ignore if */
        if (it.async) {
          out += ' throw new ValidationError([' + (__err) + ']); ';
        } else {
          out += ' validate.errors = [' + (__err) + ']; return false; ';
        }
      } else {
        out += ' var err = ' + (__err) + ';  if (vErrors === null) vErrors = [err]; else vErrors.push(err); errors++; ';
      }
    } else {
      if (it.isTop) {
        if ($async) {
          out += ' return data; ';
        } else {
          out += ' validate.errors = null; return true; ';
        }
      } else {
        out += ' var ' + ($valid) + ' = true; ';
      }
    }
    if (it.isTop) {
      out += ' }; return validate; ';
    }
    return out;
  }
  if (it.isTop) {
    var $top = it.isTop,
      $lvl = it.level = 0,
      $dataLvl = it.dataLevel = 0,
      $data = 'data';
    it.rootId = it.resolve.fullPath(it.self._getId(it.root.schema));
    it.baseId = it.baseId || it.rootId;
    delete it.isTop;
    it.dataPathArr = [undefined];
    if (it.schema.default !== undefined && it.opts.useDefaults && it.opts.strictDefaults) {
      var $defaultMsg = 'default is ignored in the schema root';
      if (it.opts.strictDefaults === 'log') it.logger.warn($defaultMsg);
      else throw new Error($defaultMsg);
    }
    out += ' var vErrors = null; ';
    out += ' var errors = 0;     ';
    out += ' if (rootData === undefined) rootData = data; ';
  } else {
    var $lvl = it.level,
      $dataLvl = it.dataLevel,
      $data = 'data' + ($dataLvl || '');
    if ($id) it.baseId = it.resolve.url(it.baseId, $id);
    if ($async && !it.async) throw new Error('async schema in sync schema');
    out += ' var errs_' + ($lvl) + ' = errors;';
  }
  var $valid = 'valid' + $lvl,
    $breakOnError = !it.opts.allErrors,
    $closingBraces1 = '',
    $closingBraces2 = '';
  var $errorKeyword;
  var $typeSchema = it.schema.type,
    $typeIsArray = Array.isArray($typeSchema);
  if ($typeSchema && it.opts.nullable && it.schema.nullable === true) {
    if ($typeIsArray) {
      if ($typeSchema.indexOf('null') == -1) $typeSchema = $typeSchema.concat('null');
    } else if ($typeSchema != 'null') {
      $typeSchema = [$typeSchema, 'null'];
      $typeIsArray = true;
    }
  }
  if ($typeIsArray && $typeSchema.length == 1) {
    $typeSchema = $typeSchema[0];
    $typeIsArray = false;
  }
  if (it.schema.$ref && $refKeywords) {
    if (it.opts.extendRefs == 'fail') {
      throw new Error('$ref: validation keywords used in schema at path "' + it.errSchemaPath + '" (see option extendRefs)');
    } else if (it.opts.extendRefs !== true) {
      $refKeywords = false;
      it.logger.warn('$ref: keywords ignored in schema at path "' + it.errSchemaPath + '"');
    }
  }
  if (it.schema.$comment && it.opts.$comment) {
    out += ' ' + (it.RULES.all.$comment.code(it, '$comment'));
  }
  if ($typeSchema) {
    if (it.opts.coerceTypes) {
      var $coerceToTypes = it.util.coerceToTypes(it.opts.coerceTypes, $typeSchema);
    }
    var $rulesGroup = it.RULES.types[$typeSchema];
    if ($coerceToTypes || $typeIsArray || $rulesGroup === true || ($rulesGroup && !$shouldUseGroup($rulesGroup))) {
      var $schemaPath = it.schemaPath + '.type',
        $errSchemaPath = it.errSchemaPath + '/type';
      var $schemaPath = it.schemaPath + '.type',
        $errSchemaPath = it.errSchemaPath + '/type',
        $method = $typeIsArray ? 'checkDataTypes' : 'checkDataType';
      out += ' if (' + (it.util[$method]($typeSchema, $data, true)) + ') { ';
      if ($coerceToTypes) {
        var $dataType = 'dataType' + $lvl,
          $coerced = 'coerced' + $lvl;
        out += ' var ' + ($dataType) + ' = typeof ' + ($data) + '; ';
        if (it.opts.coerceTypes == 'array') {
          out += ' if (' + ($dataType) + ' == \'object\' && Array.isArray(' + ($data) + ')) ' + ($dataType) + ' = \'array\'; ';
        }
        out += ' var ' + ($coerced) + ' = undefined; ';
        var $bracesCoercion = '';
        var arr1 = $coerceToTypes;
        if (arr1) {
          var $type, $i = -1,
            l1 = arr1.length - 1;
          while ($i < l1) {
            $type = arr1[$i += 1];
            if ($i) {
              out += ' if (' + ($coerced) + ' === undefined) { ';
              $bracesCoercion += '}';
            }
            if (it.opts.coerceTypes == 'array' && $type != 'array') {
              out += ' if (' + ($dataType) + ' == \'array\' && ' + ($data) + '.length == 1) { ' + ($coerced) + ' = ' + ($data) + ' = ' + ($data) + '[0]; ' + ($dataType) + ' = typeof ' + ($data) + ';  } ';
            }
            if ($type == 'string') {
              out += ' if (' + ($dataType) + ' == \'number\' || ' + ($dataType) + ' == \'boolean\') ' + ($coerced) + ' = \'\' + ' + ($data) + '; else if (' + ($data) + ' === null) ' + ($coerced) + ' = \'\'; ';
            } else if ($type == 'number' || $type == 'integer') {
              out += ' if (' + ($dataType) + ' == \'boolean\' || ' + ($data) + ' === null || (' + ($dataType) + ' == \'string\' && ' + ($data) + ' && ' + ($data) + ' == +' + ($data) + ' ';
              if ($type == 'integer') {
                out += ' && !(' + ($data) + ' % 1)';
              }
              out += ')) ' + ($coerced) + ' = +' + ($data) + '; ';
            } else if ($type == 'boolean') {
              out += ' if (' + ($data) + ' === \'false\' || ' + ($data) + ' === 0 || ' + ($data) + ' === null) ' + ($coerced) + ' = false; else if (' + ($data) + ' === \'true\' || ' + ($data) + ' === 1) ' + ($coerced) + ' = true; ';
            } else if ($type == 'null') {
              out += ' if (' + ($data) + ' === \'\' || ' + ($data) + ' === 0 || ' + ($data) + ' === false) ' + ($coerced) + ' = null; ';
            } else if (it.opts.coerceTypes == 'array' && $type == 'array') {
              out += ' if (' + ($dataType) + ' == \'string\' || ' + ($dataType) + ' == \'number\' || ' + ($dataType) + ' == \'boolean\' || ' + ($data) + ' == null) ' + ($coerced) + ' = [' + ($data) + ']; ';
            }
          }
        }
        out += ' ' + ($bracesCoercion) + ' if (' + ($coerced) + ' === undefined) {   ';
        var $$outStack = $$outStack || [];
        $$outStack.push(out);
        out = ''; /* istanbul ignore else */
        if (it.createErrors !== false) {
          out += ' { keyword: \'' + ($errorKeyword || 'type') + '\' , dataPath: (dataPath || \'\') + ' + (it.errorPath) + ' , schemaPath: ' + (it.util.toQuotedString($errSchemaPath)) + ' , params: { type: \'';
          if ($typeIsArray) {
            out += '' + ($typeSchema.join(","));
          } else {
            out += '' + ($typeSchema);
          }
          out += '\' } ';
          if (it.opts.messages !== false) {
            out += ' , message: \'should be ';
            if ($typeIsArray) {
              out += '' + ($typeSchema.join(","));
            } else {
              out += '' + ($typeSchema);
            }
            out += '\' ';
          }
          if (it.opts.verbose) {
            out += ' , schema: validate.schema' + ($schemaPath) + ' , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
          }
          out += ' } ';
        } else {
          out += ' {} ';
        }
        var __err = out;
        out = $$outStack.pop();
        if (!it.compositeRule && $breakOnError) {
          /* istanbul ignore if */
          if (it.async) {
            out += ' throw new ValidationError([' + (__err) + ']); ';
          } else {
            out += ' validate.errors = [' + (__err) + ']; return false; ';
          }
        } else {
          out += ' var err = ' + (__err) + ';  if (vErrors === null) vErrors = [err]; else vErrors.push(err); errors++; ';
        }
        out += ' } else {  ';
        var $parentData = $dataLvl ? 'data' + (($dataLvl - 1) || '') : 'parentData',
          $parentDataProperty = $dataLvl ? it.dataPathArr[$dataLvl] : 'parentDataProperty';
        out += ' ' + ($data) + ' = ' + ($coerced) + '; ';
        if (!$dataLvl) {
          out += 'if (' + ($parentData) + ' !== undefined)';
        }
        out += ' ' + ($parentData) + '[' + ($parentDataProperty) + '] = ' + ($coerced) + '; } ';
      } else {
        var $$outStack = $$outStack || [];
        $$outStack.push(out);
        out = ''; /* istanbul ignore else */
        if (it.createErrors !== false) {
          out += ' { keyword: \'' + ($errorKeyword || 'type') + '\' , dataPath: (dataPath || \'\') + ' + (it.errorPath) + ' , schemaPath: ' + (it.util.toQuotedString($errSchemaPath)) + ' , params: { type: \'';
          if ($typeIsArray) {
            out += '' + ($typeSchema.join(","));
          } else {
            out += '' + ($typeSchema);
          }
          out += '\' } ';
          if (it.opts.messages !== false) {
            out += ' , message: \'should be ';
            if ($typeIsArray) {
              out += '' + ($typeSchema.join(","));
            } else {
              out += '' + ($typeSchema);
            }
            out += '\' ';
          }
          if (it.opts.verbose) {
            out += ' , schema: validate.schema' + ($schemaPath) + ' , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
          }
          out += ' } ';
        } else {
          out += ' {} ';
        }
        var __err = out;
        out = $$outStack.pop();
        if (!it.compositeRule && $breakOnError) {
          /* istanbul ignore if */
          if (it.async) {
            out += ' throw new ValidationError([' + (__err) + ']); ';
          } else {
            out += ' validate.errors = [' + (__err) + ']; return false; ';
          }
        } else {
          out += ' var err = ' + (__err) + ';  if (vErrors === null) vErrors = [err]; else vErrors.push(err); errors++; ';
        }
      }
      out += ' } ';
    }
  }
  if (it.schema.$ref && !$refKeywords) {
    out += ' ' + (it.RULES.all.$ref.code(it, '$ref')) + ' ';
    if ($breakOnError) {
      out += ' } if (errors === ';
      if ($top) {
        out += '0';
      } else {
        out += 'errs_' + ($lvl);
      }
      out += ') { ';
      $closingBraces2 += '}';
    }
  } else {
    var arr2 = it.RULES;
    if (arr2) {
      var $rulesGroup, i2 = -1,
        l2 = arr2.length - 1;
      while (i2 < l2) {
        $rulesGroup = arr2[i2 += 1];
        if ($shouldUseGroup($rulesGroup)) {
          if ($rulesGroup.type) {
            out += ' if (' + (it.util.checkDataType($rulesGroup.type, $data)) + ') { ';
          }
          if (it.opts.useDefaults) {
            if ($rulesGroup.type == 'object' && it.schema.properties) {
              var $schema = it.schema.properties,
                $schemaKeys = Object.keys($schema);
              var arr3 = $schemaKeys;
              if (arr3) {
                var $propertyKey, i3 = -1,
                  l3 = arr3.length - 1;
                while (i3 < l3) {
                  $propertyKey = arr3[i3 += 1];
                  var $sch = $schema[$propertyKey];
                  if ($sch.default !== undefined) {
                    var $passData = $data + it.util.getProperty($propertyKey);
                    if (it.compositeRule) {
                      if (it.opts.strictDefaults) {
                        var $defaultMsg = 'default is ignored for: ' + $passData;
                        if (it.opts.strictDefaults === 'log') it.logger.warn($defaultMsg);
                        else throw new Error($defaultMsg);
                      }
                    } else {
                      out += ' if (' + ($passData) + ' === undefined ';
                      if (it.opts.useDefaults == 'empty') {
                        out += ' || ' + ($passData) + ' === null || ' + ($passData) + ' === \'\' ';
                      }
                      out += ' ) ' + ($passData) + ' = ';
                      if (it.opts.useDefaults == 'shared') {
                        out += ' ' + (it.useDefault($sch.default)) + ' ';
                      } else {
                        out += ' ' + (JSON.stringify($sch.default)) + ' ';
                      }
                      out += '; ';
                    }
                  }
                }
              }
            } else if ($rulesGroup.type == 'array' && Array.isArray(it.schema.items)) {
              var arr4 = it.schema.items;
              if (arr4) {
                var $sch, $i = -1,
                  l4 = arr4.length - 1;
                while ($i < l4) {
                  $sch = arr4[$i += 1];
                  if ($sch.default !== undefined) {
                    var $passData = $data + '[' + $i + ']';
                    if (it.compositeRule) {
                      if (it.opts.strictDefaults) {
                        var $defaultMsg = 'default is ignored for: ' + $passData;
                        if (it.opts.strictDefaults === 'log') it.logger.warn($defaultMsg);
                        else throw new Error($defaultMsg);
                      }
                    } else {
                      out += ' if (' + ($passData) + ' === undefined ';
                      if (it.opts.useDefaults == 'empty') {
                        out += ' || ' + ($passData) + ' === null || ' + ($passData) + ' === \'\' ';
                      }
                      out += ' ) ' + ($passData) + ' = ';
                      if (it.opts.useDefaults == 'shared') {
                        out += ' ' + (it.useDefault($sch.default)) + ' ';
                      } else {
                        out += ' ' + (JSON.stringify($sch.default)) + ' ';
                      }
                      out += '; ';
                    }
                  }
                }
              }
            }
          }
          var arr5 = $rulesGroup.rules;
          if (arr5) {
            var $rule, i5 = -1,
              l5 = arr5.length - 1;
            while (i5 < l5) {
              $rule = arr5[i5 += 1];
              if ($shouldUseRule($rule)) {
                var $code = $rule.code(it, $rule.keyword, $rulesGroup.type);
                if ($code) {
                  out += ' ' + ($code) + ' ';
                  if ($breakOnError) {
                    $closingBraces1 += '}';
                  }
                }
              }
            }
          }
          if ($breakOnError) {
            out += ' ' + ($closingBraces1) + ' ';
            $closingBraces1 = '';
          }
          if ($rulesGroup.type) {
            out += ' } ';
            if ($typeSchema && $typeSchema === $rulesGroup.type && !$coerceToTypes) {
              out += ' else { ';
              var $schemaPath = it.schemaPath + '.type',
                $errSchemaPath = it.errSchemaPath + '/type';
              var $$outStack = $$outStack || [];
              $$outStack.push(out);
              out = ''; /* istanbul ignore else */
              if (it.createErrors !== false) {
                out += ' { keyword: \'' + ($errorKeyword || 'type') + '\' , dataPath: (dataPath || \'\') + ' + (it.errorPath) + ' , schemaPath: ' + (it.util.toQuotedString($errSchemaPath)) + ' , params: { type: \'';
                if ($typeIsArray) {
                  out += '' + ($typeSchema.join(","));
                } else {
                  out += '' + ($typeSchema);
                }
                out += '\' } ';
                if (it.opts.messages !== false) {
                  out += ' , message: \'should be ';
                  if ($typeIsArray) {
                    out += '' + ($typeSchema.join(","));
                  } else {
                    out += '' + ($typeSchema);
                  }
                  out += '\' ';
                }
                if (it.opts.verbose) {
                  out += ' , schema: validate.schema' + ($schemaPath) + ' , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
                }
                out += ' } ';
              } else {
                out += ' {} ';
              }
              var __err = out;
              out = $$outStack.pop();
              if (!it.compositeRule && $breakOnError) {
                /* istanbul ignore if */
                if (it.async) {
                  out += ' throw new ValidationError([' + (__err) + ']); ';
                } else {
                  out += ' validate.errors = [' + (__err) + ']; return false; ';
                }
              } else {
                out += ' var err = ' + (__err) + ';  if (vErrors === null) vErrors = [err]; else vErrors.push(err); errors++; ';
              }
              out += ' } ';
            }
          }
          if ($breakOnError) {
            out += ' if (errors === ';
            if ($top) {
              out += '0';
            } else {
              out += 'errs_' + ($lvl);
            }
            out += ') { ';
            $closingBraces2 += '}';
          }
        }
      }
    }
  }
  if ($breakOnError) {
    out += ' ' + ($closingBraces2) + ' ';
  }
  if ($top) {
    if ($async) {
      out += ' if (errors === 0) return data;           ';
      out += ' else throw new ValidationError(vErrors); ';
    } else {
      out += ' validate.errors = vErrors; ';
      out += ' return errors === 0;       ';
    }
    out += ' }; return validate;';
  } else {
    out += ' var ' + ($valid) + ' = errors === errs_' + ($lvl) + ';';
  }
  out = it.util.cleanUpCode(out);
  if ($top) {
    out = it.util.finalCleanUpCode(out, $async);
  }

  function $shouldUseGroup($rulesGroup) {
    var rules = $rulesGroup.rules;
    for (var i = 0; i < rules.length; i++)
      if ($shouldUseRule(rules[i])) return true;
  }

  function $shouldUseRule($rule) {
    return it.schema[$rule.keyword] !== undefined || ($rule.implements && $ruleImplementsSomeKeyword($rule));
  }

  function $ruleImplementsSomeKeyword($rule) {
    var impl = $rule.implements;
    for (var i = 0; i < impl.length; i++)
      if (it.schema[impl[i]] !== undefined) return true;
  }
  return out;
}

},{}],40:[function(require,module,exports){
'use strict';

var IDENTIFIER = /^[a-z_$][a-z0-9_$-]*$/i;
var customRuleCode = require('./dotjs/custom');
var definitionSchema = require('./definition_schema');

module.exports = {
  add: addKeyword,
  get: getKeyword,
  remove: removeKeyword,
  validate: validateKeyword
};


/**
 * Define custom keyword
 * @this  Ajv
 * @param {String} keyword custom keyword, should be unique (including different from all standard, custom and macro keywords).
 * @param {Object} definition keyword definition object with properties `type` (type(s) which the keyword applies to), `validate` or `compile`.
 * @return {Ajv} this for method chaining
 */
function addKeyword(keyword, definition) {
  /* jshint validthis: true */
  /* eslint no-shadow: 0 */
  var RULES = this.RULES;
  if (RULES.keywords[keyword])
    throw new Error('Keyword ' + keyword + ' is already defined');

  if (!IDENTIFIER.test(keyword))
    throw new Error('Keyword ' + keyword + ' is not a valid identifier');

  if (definition) {
    this.validateKeyword(definition, true);

    var dataType = definition.type;
    if (Array.isArray(dataType)) {
      for (var i=0; i<dataType.length; i++)
        _addRule(keyword, dataType[i], definition);
    } else {
      _addRule(keyword, dataType, definition);
    }

    var metaSchema = definition.metaSchema;
    if (metaSchema) {
      if (definition.$data && this._opts.$data) {
        metaSchema = {
          anyOf: [
            metaSchema,
            { '$ref': 'https://raw.githubusercontent.com/epoberezkin/ajv/master/lib/refs/data.json#' }
          ]
        };
      }
      definition.validateSchema = this.compile(metaSchema, true);
    }
  }

  RULES.keywords[keyword] = RULES.all[keyword] = true;


  function _addRule(keyword, dataType, definition) {
    var ruleGroup;
    for (var i=0; i<RULES.length; i++) {
      var rg = RULES[i];
      if (rg.type == dataType) {
        ruleGroup = rg;
        break;
      }
    }

    if (!ruleGroup) {
      ruleGroup = { type: dataType, rules: [] };
      RULES.push(ruleGroup);
    }

    var rule = {
      keyword: keyword,
      definition: definition,
      custom: true,
      code: customRuleCode,
      implements: definition.implements
    };
    ruleGroup.rules.push(rule);
    RULES.custom[keyword] = rule;
  }

  return this;
}


/**
 * Get keyword
 * @this  Ajv
 * @param {String} keyword pre-defined or custom keyword.
 * @return {Object|Boolean} custom keyword definition, `true` if it is a predefined keyword, `false` otherwise.
 */
function getKeyword(keyword) {
  /* jshint validthis: true */
  var rule = this.RULES.custom[keyword];
  return rule ? rule.definition : this.RULES.keywords[keyword] || false;
}


/**
 * Remove keyword
 * @this  Ajv
 * @param {String} keyword pre-defined or custom keyword.
 * @return {Ajv} this for method chaining
 */
function removeKeyword(keyword) {
  /* jshint validthis: true */
  var RULES = this.RULES;
  delete RULES.keywords[keyword];
  delete RULES.all[keyword];
  delete RULES.custom[keyword];
  for (var i=0; i<RULES.length; i++) {
    var rules = RULES[i].rules;
    for (var j=0; j<rules.length; j++) {
      if (rules[j].keyword == keyword) {
        rules.splice(j, 1);
        break;
      }
    }
  }
  return this;
}


/**
 * Validate keyword definition
 * @this  Ajv
 * @param {Object} definition keyword definition object.
 * @param {Boolean} throwError true to throw exception if definition is invalid
 * @return {boolean} validation result
 */
function validateKeyword(definition, throwError) {
  validateKeyword.errors = null;
  var v = this._validateKeyword = this._validateKeyword
                                  || this.compile(definitionSchema, true);

  if (v(definition)) return true;
  validateKeyword.errors = v.errors;
  if (throwError)
    throw new Error('custom keyword definition is invalid: '  + this.errorsText(v.errors));
  else
    return false;
}

},{"./definition_schema":13,"./dotjs/custom":23}],41:[function(require,module,exports){
module.exports={
    "$schema": "http://json-schema.org/draft-07/schema#",
    "$id": "https://raw.githubusercontent.com/epoberezkin/ajv/master/lib/refs/data.json#",
    "description": "Meta-schema for $data reference (JSON Schema extension proposal)",
    "type": "object",
    "required": [ "$data" ],
    "properties": {
        "$data": {
            "type": "string",
            "anyOf": [
                { "format": "relative-json-pointer" }, 
                { "format": "json-pointer" }
            ]
        }
    },
    "additionalProperties": false
}

},{}],42:[function(require,module,exports){
module.exports={
    "$schema": "http://json-schema.org/draft-07/schema#",
    "$id": "http://json-schema.org/draft-07/schema#",
    "title": "Core schema meta-schema",
    "definitions": {
        "schemaArray": {
            "type": "array",
            "minItems": 1,
            "items": { "$ref": "#" }
        },
        "nonNegativeInteger": {
            "type": "integer",
            "minimum": 0
        },
        "nonNegativeIntegerDefault0": {
            "allOf": [
                { "$ref": "#/definitions/nonNegativeInteger" },
                { "default": 0 }
            ]
        },
        "simpleTypes": {
            "enum": [
                "array",
                "boolean",
                "integer",
                "null",
                "number",
                "object",
                "string"
            ]
        },
        "stringArray": {
            "type": "array",
            "items": { "type": "string" },
            "uniqueItems": true,
            "default": []
        }
    },
    "type": ["object", "boolean"],
    "properties": {
        "$id": {
            "type": "string",
            "format": "uri-reference"
        },
        "$schema": {
            "type": "string",
            "format": "uri"
        },
        "$ref": {
            "type": "string",
            "format": "uri-reference"
        },
        "$comment": {
            "type": "string"
        },
        "title": {
            "type": "string"
        },
        "description": {
            "type": "string"
        },
        "default": true,
        "readOnly": {
            "type": "boolean",
            "default": false
        },
        "examples": {
            "type": "array",
            "items": true
        },
        "multipleOf": {
            "type": "number",
            "exclusiveMinimum": 0
        },
        "maximum": {
            "type": "number"
        },
        "exclusiveMaximum": {
            "type": "number"
        },
        "minimum": {
            "type": "number"
        },
        "exclusiveMinimum": {
            "type": "number"
        },
        "maxLength": { "$ref": "#/definitions/nonNegativeInteger" },
        "minLength": { "$ref": "#/definitions/nonNegativeIntegerDefault0" },
        "pattern": {
            "type": "string",
            "format": "regex"
        },
        "additionalItems": { "$ref": "#" },
        "items": {
            "anyOf": [
                { "$ref": "#" },
                { "$ref": "#/definitions/schemaArray" }
            ],
            "default": true
        },
        "maxItems": { "$ref": "#/definitions/nonNegativeInteger" },
        "minItems": { "$ref": "#/definitions/nonNegativeIntegerDefault0" },
        "uniqueItems": {
            "type": "boolean",
            "default": false
        },
        "contains": { "$ref": "#" },
        "maxProperties": { "$ref": "#/definitions/nonNegativeInteger" },
        "minProperties": { "$ref": "#/definitions/nonNegativeIntegerDefault0" },
        "required": { "$ref": "#/definitions/stringArray" },
        "additionalProperties": { "$ref": "#" },
        "definitions": {
            "type": "object",
            "additionalProperties": { "$ref": "#" },
            "default": {}
        },
        "properties": {
            "type": "object",
            "additionalProperties": { "$ref": "#" },
            "default": {}
        },
        "patternProperties": {
            "type": "object",
            "additionalProperties": { "$ref": "#" },
            "propertyNames": { "format": "regex" },
            "default": {}
        },
        "dependencies": {
            "type": "object",
            "additionalProperties": {
                "anyOf": [
                    { "$ref": "#" },
                    { "$ref": "#/definitions/stringArray" }
                ]
            }
        },
        "propertyNames": { "$ref": "#" },
        "const": true,
        "enum": {
            "type": "array",
            "items": true,
            "minItems": 1,
            "uniqueItems": true
        },
        "type": {
            "anyOf": [
                { "$ref": "#/definitions/simpleTypes" },
                {
                    "type": "array",
                    "items": { "$ref": "#/definitions/simpleTypes" },
                    "minItems": 1,
                    "uniqueItems": true
                }
            ]
        },
        "format": { "type": "string" },
        "contentMediaType": { "type": "string" },
        "contentEncoding": { "type": "string" },
        "if": {"$ref": "#"},
        "then": {"$ref": "#"},
        "else": {"$ref": "#"},
        "allOf": { "$ref": "#/definitions/schemaArray" },
        "anyOf": { "$ref": "#/definitions/schemaArray" },
        "oneOf": { "$ref": "#/definitions/schemaArray" },
        "not": { "$ref": "#" }
    },
    "default": true
}

},{}],43:[function(require,module,exports){
'use strict';

var isArray = Array.isArray;
var keyList = Object.keys;
var hasProp = Object.prototype.hasOwnProperty;

module.exports = function equal(a, b) {
  if (a === b) return true;

  if (a && b && typeof a == 'object' && typeof b == 'object') {
    var arrA = isArray(a)
      , arrB = isArray(b)
      , i
      , length
      , key;

    if (arrA && arrB) {
      length = a.length;
      if (length != b.length) return false;
      for (i = length; i-- !== 0;)
        if (!equal(a[i], b[i])) return false;
      return true;
    }

    if (arrA != arrB) return false;

    var dateA = a instanceof Date
      , dateB = b instanceof Date;
    if (dateA != dateB) return false;
    if (dateA && dateB) return a.getTime() == b.getTime();

    var regexpA = a instanceof RegExp
      , regexpB = b instanceof RegExp;
    if (regexpA != regexpB) return false;
    if (regexpA && regexpB) return a.toString() == b.toString();

    var keys = keyList(a);
    length = keys.length;

    if (length !== keyList(b).length)
      return false;

    for (i = length; i-- !== 0;)
      if (!hasProp.call(b, keys[i])) return false;

    for (i = length; i-- !== 0;) {
      key = keys[i];
      if (!equal(a[key], b[key])) return false;
    }

    return true;
  }

  return a!==a && b!==b;
};

},{}],44:[function(require,module,exports){
'use strict';

var traverse = module.exports = function (schema, opts, cb) {
  // Legacy support for v0.3.1 and earlier.
  if (typeof opts == 'function') {
    cb = opts;
    opts = {};
  }

  cb = opts.cb || cb;
  var pre = (typeof cb == 'function') ? cb : cb.pre || function() {};
  var post = cb.post || function() {};

  _traverse(opts, pre, post, schema, '', schema);
};


traverse.keywords = {
  additionalItems: true,
  items: true,
  contains: true,
  additionalProperties: true,
  propertyNames: true,
  not: true
};

traverse.arrayKeywords = {
  items: true,
  allOf: true,
  anyOf: true,
  oneOf: true
};

traverse.propsKeywords = {
  definitions: true,
  properties: true,
  patternProperties: true,
  dependencies: true
};

traverse.skipKeywords = {
  default: true,
  enum: true,
  const: true,
  required: true,
  maximum: true,
  minimum: true,
  exclusiveMaximum: true,
  exclusiveMinimum: true,
  multipleOf: true,
  maxLength: true,
  minLength: true,
  pattern: true,
  format: true,
  maxItems: true,
  minItems: true,
  uniqueItems: true,
  maxProperties: true,
  minProperties: true
};


function _traverse(opts, pre, post, schema, jsonPtr, rootSchema, parentJsonPtr, parentKeyword, parentSchema, keyIndex) {
  if (schema && typeof schema == 'object' && !Array.isArray(schema)) {
    pre(schema, jsonPtr, rootSchema, parentJsonPtr, parentKeyword, parentSchema, keyIndex);
    for (var key in schema) {
      var sch = schema[key];
      if (Array.isArray(sch)) {
        if (key in traverse.arrayKeywords) {
          for (var i=0; i<sch.length; i++)
            _traverse(opts, pre, post, sch[i], jsonPtr + '/' + key + '/' + i, rootSchema, jsonPtr, key, schema, i);
        }
      } else if (key in traverse.propsKeywords) {
        if (sch && typeof sch == 'object') {
          for (var prop in sch)
            _traverse(opts, pre, post, sch[prop], jsonPtr + '/' + key + '/' + escapeJsonPtr(prop), rootSchema, jsonPtr, key, schema, prop);
        }
      } else if (key in traverse.keywords || (opts.allKeys && !(key in traverse.skipKeywords))) {
        _traverse(opts, pre, post, sch, jsonPtr + '/' + key, rootSchema, jsonPtr, key, schema);
      }
    }
    post(schema, jsonPtr, rootSchema, parentJsonPtr, parentKeyword, parentSchema, keyIndex);
  }
}


function escapeJsonPtr(str) {
  return str.replace(/~/g, '~0').replace(/\//g, '~1');
}

},{}],45:[function(require,module,exports){
(function (global){
'use strict';

var objectAssign = require('object-assign');

// compare and isBuffer taken from https://github.com/feross/buffer/blob/680e9e5e488f22aac27599a57dc844a6315928dd/index.js
// original notice:

/*!
 * The buffer module from node.js, for the browser.
 *
 * @author   Feross Aboukhadijeh <feross@feross.org> <http://feross.org>
 * @license  MIT
 */
function compare(a, b) {
  if (a === b) {
    return 0;
  }

  var x = a.length;
  var y = b.length;

  for (var i = 0, len = Math.min(x, y); i < len; ++i) {
    if (a[i] !== b[i]) {
      x = a[i];
      y = b[i];
      break;
    }
  }

  if (x < y) {
    return -1;
  }
  if (y < x) {
    return 1;
  }
  return 0;
}
function isBuffer(b) {
  if (global.Buffer && typeof global.Buffer.isBuffer === 'function') {
    return global.Buffer.isBuffer(b);
  }
  return !!(b != null && b._isBuffer);
}

// based on node assert, original notice:
// NB: The URL to the CommonJS spec is kept just for tradition.
//     node-assert has evolved a lot since then, both in API and behavior.

// http://wiki.commonjs.org/wiki/Unit_Testing/1.0
//
// THIS IS NOT TESTED NOR LIKELY TO WORK OUTSIDE V8!
//
// Originally from narwhal.js (http://narwhaljs.org)
// Copyright (c) 2009 Thomas Robinson <280north.com>
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the 'Software'), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
// ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
// WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

var util = require('util/');
var hasOwn = Object.prototype.hasOwnProperty;
var pSlice = Array.prototype.slice;
var functionsHaveNames = (function () {
  return function foo() {}.name === 'foo';
}());
function pToString (obj) {
  return Object.prototype.toString.call(obj);
}
function isView(arrbuf) {
  if (isBuffer(arrbuf)) {
    return false;
  }
  if (typeof global.ArrayBuffer !== 'function') {
    return false;
  }
  if (typeof ArrayBuffer.isView === 'function') {
    return ArrayBuffer.isView(arrbuf);
  }
  if (!arrbuf) {
    return false;
  }
  if (arrbuf instanceof DataView) {
    return true;
  }
  if (arrbuf.buffer && arrbuf.buffer instanceof ArrayBuffer) {
    return true;
  }
  return false;
}
// 1. The assert module provides functions that throw
// AssertionError's when particular conditions are not met. The
// assert module must conform to the following interface.

var assert = module.exports = ok;

// 2. The AssertionError is defined in assert.
// new assert.AssertionError({ message: message,
//                             actual: actual,
//                             expected: expected })

var regex = /\s*function\s+([^\(\s]*)\s*/;
// based on https://github.com/ljharb/function.prototype.name/blob/adeeeec8bfcc6068b187d7d9fb3d5bb1d3a30899/implementation.js
function getName(func) {
  if (!util.isFunction(func)) {
    return;
  }
  if (functionsHaveNames) {
    return func.name;
  }
  var str = func.toString();
  var match = str.match(regex);
  return match && match[1];
}
assert.AssertionError = function AssertionError(options) {
  this.name = 'AssertionError';
  this.actual = options.actual;
  this.expected = options.expected;
  this.operator = options.operator;
  if (options.message) {
    this.message = options.message;
    this.generatedMessage = false;
  } else {
    this.message = getMessage(this);
    this.generatedMessage = true;
  }
  var stackStartFunction = options.stackStartFunction || fail;
  if (Error.captureStackTrace) {
    Error.captureStackTrace(this, stackStartFunction);
  } else {
    // non v8 browsers so we can have a stacktrace
    var err = new Error();
    if (err.stack) {
      var out = err.stack;

      // try to strip useless frames
      var fn_name = getName(stackStartFunction);
      var idx = out.indexOf('\n' + fn_name);
      if (idx >= 0) {
        // once we have located the function frame
        // we need to strip out everything before it (and its line)
        var next_line = out.indexOf('\n', idx + 1);
        out = out.substring(next_line + 1);
      }

      this.stack = out;
    }
  }
};

// assert.AssertionError instanceof Error
util.inherits(assert.AssertionError, Error);

function truncate(s, n) {
  if (typeof s === 'string') {
    return s.length < n ? s : s.slice(0, n);
  } else {
    return s;
  }
}
function inspect(something) {
  if (functionsHaveNames || !util.isFunction(something)) {
    return util.inspect(something);
  }
  var rawname = getName(something);
  var name = rawname ? ': ' + rawname : '';
  return '[Function' +  name + ']';
}
function getMessage(self) {
  return truncate(inspect(self.actual), 128) + ' ' +
         self.operator + ' ' +
         truncate(inspect(self.expected), 128);
}

// At present only the three keys mentioned above are used and
// understood by the spec. Implementations or sub modules can pass
// other keys to the AssertionError's constructor - they will be
// ignored.

// 3. All of the following functions must throw an AssertionError
// when a corresponding condition is not met, with a message that
// may be undefined if not provided.  All assertion methods provide
// both the actual and expected values to the assertion error for
// display purposes.

function fail(actual, expected, message, operator, stackStartFunction) {
  throw new assert.AssertionError({
    message: message,
    actual: actual,
    expected: expected,
    operator: operator,
    stackStartFunction: stackStartFunction
  });
}

// EXTENSION! allows for well behaved errors defined elsewhere.
assert.fail = fail;

// 4. Pure assertion tests whether a value is truthy, as determined
// by !!guard.
// assert.ok(guard, message_opt);
// This statement is equivalent to assert.equal(true, !!guard,
// message_opt);. To test strictly for the value true, use
// assert.strictEqual(true, guard, message_opt);.

function ok(value, message) {
  if (!value) fail(value, true, message, '==', assert.ok);
}
assert.ok = ok;

// 5. The equality assertion tests shallow, coercive equality with
// ==.
// assert.equal(actual, expected, message_opt);

assert.equal = function equal(actual, expected, message) {
  if (actual != expected) fail(actual, expected, message, '==', assert.equal);
};

// 6. The non-equality assertion tests for whether two objects are not equal
// with != assert.notEqual(actual, expected, message_opt);

assert.notEqual = function notEqual(actual, expected, message) {
  if (actual == expected) {
    fail(actual, expected, message, '!=', assert.notEqual);
  }
};

// 7. The equivalence assertion tests a deep equality relation.
// assert.deepEqual(actual, expected, message_opt);

assert.deepEqual = function deepEqual(actual, expected, message) {
  if (!_deepEqual(actual, expected, false)) {
    fail(actual, expected, message, 'deepEqual', assert.deepEqual);
  }
};

assert.deepStrictEqual = function deepStrictEqual(actual, expected, message) {
  if (!_deepEqual(actual, expected, true)) {
    fail(actual, expected, message, 'deepStrictEqual', assert.deepStrictEqual);
  }
};

function _deepEqual(actual, expected, strict, memos) {
  // 7.1. All identical values are equivalent, as determined by ===.
  if (actual === expected) {
    return true;
  } else if (isBuffer(actual) && isBuffer(expected)) {
    return compare(actual, expected) === 0;

  // 7.2. If the expected value is a Date object, the actual value is
  // equivalent if it is also a Date object that refers to the same time.
  } else if (util.isDate(actual) && util.isDate(expected)) {
    return actual.getTime() === expected.getTime();

  // 7.3 If the expected value is a RegExp object, the actual value is
  // equivalent if it is also a RegExp object with the same source and
  // properties (`global`, `multiline`, `lastIndex`, `ignoreCase`).
  } else if (util.isRegExp(actual) && util.isRegExp(expected)) {
    return actual.source === expected.source &&
           actual.global === expected.global &&
           actual.multiline === expected.multiline &&
           actual.lastIndex === expected.lastIndex &&
           actual.ignoreCase === expected.ignoreCase;

  // 7.4. Other pairs that do not both pass typeof value == 'object',
  // equivalence is determined by ==.
  } else if ((actual === null || typeof actual !== 'object') &&
             (expected === null || typeof expected !== 'object')) {
    return strict ? actual === expected : actual == expected;

  // If both values are instances of typed arrays, wrap their underlying
  // ArrayBuffers in a Buffer each to increase performance
  // This optimization requires the arrays to have the same type as checked by
  // Object.prototype.toString (aka pToString). Never perform binary
  // comparisons for Float*Arrays, though, since e.g. +0 === -0 but their
  // bit patterns are not identical.
  } else if (isView(actual) && isView(expected) &&
             pToString(actual) === pToString(expected) &&
             !(actual instanceof Float32Array ||
               actual instanceof Float64Array)) {
    return compare(new Uint8Array(actual.buffer),
                   new Uint8Array(expected.buffer)) === 0;

  // 7.5 For all other Object pairs, including Array objects, equivalence is
  // determined by having the same number of owned properties (as verified
  // with Object.prototype.hasOwnProperty.call), the same set of keys
  // (although not necessarily the same order), equivalent values for every
  // corresponding key, and an identical 'prototype' property. Note: this
  // accounts for both named and indexed properties on Arrays.
  } else if (isBuffer(actual) !== isBuffer(expected)) {
    return false;
  } else {
    memos = memos || {actual: [], expected: []};

    var actualIndex = memos.actual.indexOf(actual);
    if (actualIndex !== -1) {
      if (actualIndex === memos.expected.indexOf(expected)) {
        return true;
      }
    }

    memos.actual.push(actual);
    memos.expected.push(expected);

    return objEquiv(actual, expected, strict, memos);
  }
}

function isArguments(object) {
  return Object.prototype.toString.call(object) == '[object Arguments]';
}

function objEquiv(a, b, strict, actualVisitedObjects) {
  if (a === null || a === undefined || b === null || b === undefined)
    return false;
  // if one is a primitive, the other must be same
  if (util.isPrimitive(a) || util.isPrimitive(b))
    return a === b;
  if (strict && Object.getPrototypeOf(a) !== Object.getPrototypeOf(b))
    return false;
  var aIsArgs = isArguments(a);
  var bIsArgs = isArguments(b);
  if ((aIsArgs && !bIsArgs) || (!aIsArgs && bIsArgs))
    return false;
  if (aIsArgs) {
    a = pSlice.call(a);
    b = pSlice.call(b);
    return _deepEqual(a, b, strict);
  }
  var ka = objectKeys(a);
  var kb = objectKeys(b);
  var key, i;
  // having the same number of owned properties (keys incorporates
  // hasOwnProperty)
  if (ka.length !== kb.length)
    return false;
  //the same set of keys (although not necessarily the same order),
  ka.sort();
  kb.sort();
  //~~~cheap key test
  for (i = ka.length - 1; i >= 0; i--) {
    if (ka[i] !== kb[i])
      return false;
  }
  //equivalent values for every corresponding key, and
  //~~~possibly expensive deep test
  for (i = ka.length - 1; i >= 0; i--) {
    key = ka[i];
    if (!_deepEqual(a[key], b[key], strict, actualVisitedObjects))
      return false;
  }
  return true;
}

// 8. The non-equivalence assertion tests for any deep inequality.
// assert.notDeepEqual(actual, expected, message_opt);

assert.notDeepEqual = function notDeepEqual(actual, expected, message) {
  if (_deepEqual(actual, expected, false)) {
    fail(actual, expected, message, 'notDeepEqual', assert.notDeepEqual);
  }
};

assert.notDeepStrictEqual = notDeepStrictEqual;
function notDeepStrictEqual(actual, expected, message) {
  if (_deepEqual(actual, expected, true)) {
    fail(actual, expected, message, 'notDeepStrictEqual', notDeepStrictEqual);
  }
}


// 9. The strict equality assertion tests strict equality, as determined by ===.
// assert.strictEqual(actual, expected, message_opt);

assert.strictEqual = function strictEqual(actual, expected, message) {
  if (actual !== expected) {
    fail(actual, expected, message, '===', assert.strictEqual);
  }
};

// 10. The strict non-equality assertion tests for strict inequality, as
// determined by !==.  assert.notStrictEqual(actual, expected, message_opt);

assert.notStrictEqual = function notStrictEqual(actual, expected, message) {
  if (actual === expected) {
    fail(actual, expected, message, '!==', assert.notStrictEqual);
  }
};

function expectedException(actual, expected) {
  if (!actual || !expected) {
    return false;
  }

  if (Object.prototype.toString.call(expected) == '[object RegExp]') {
    return expected.test(actual);
  }

  try {
    if (actual instanceof expected) {
      return true;
    }
  } catch (e) {
    // Ignore.  The instanceof check doesn't work for arrow functions.
  }

  if (Error.isPrototypeOf(expected)) {
    return false;
  }

  return expected.call({}, actual) === true;
}

function _tryBlock(block) {
  var error;
  try {
    block();
  } catch (e) {
    error = e;
  }
  return error;
}

function _throws(shouldThrow, block, expected, message) {
  var actual;

  if (typeof block !== 'function') {
    throw new TypeError('"block" argument must be a function');
  }

  if (typeof expected === 'string') {
    message = expected;
    expected = null;
  }

  actual = _tryBlock(block);

  message = (expected && expected.name ? ' (' + expected.name + ').' : '.') +
            (message ? ' ' + message : '.');

  if (shouldThrow && !actual) {
    fail(actual, expected, 'Missing expected exception' + message);
  }

  var userProvidedMessage = typeof message === 'string';
  var isUnwantedException = !shouldThrow && util.isError(actual);
  var isUnexpectedException = !shouldThrow && actual && !expected;

  if ((isUnwantedException &&
      userProvidedMessage &&
      expectedException(actual, expected)) ||
      isUnexpectedException) {
    fail(actual, expected, 'Got unwanted exception' + message);
  }

  if ((shouldThrow && actual && expected &&
      !expectedException(actual, expected)) || (!shouldThrow && actual)) {
    throw actual;
  }
}

// 11. Expected to throw an error:
// assert.throws(block, Error_opt, message_opt);

assert.throws = function(block, /*optional*/error, /*optional*/message) {
  _throws(true, block, error, message);
};

// EXTENSION! This is annoying to write outside this module.
assert.doesNotThrow = function(block, /*optional*/error, /*optional*/message) {
  _throws(false, block, error, message);
};

assert.ifError = function(err) { if (err) throw err; };

// Expose a strict only variant of assert
function strict(value, message) {
  if (!value) fail(value, true, message, '==', strict);
}
assert.strict = objectAssign(strict, assert, {
  equal: assert.strictEqual,
  deepEqual: assert.deepStrictEqual,
  notEqual: assert.notStrictEqual,
  notDeepEqual: assert.notDeepStrictEqual
});
assert.strict.strict = assert.strict;

var objectKeys = Object.keys || function (obj) {
  var keys = [];
  for (var key in obj) {
    if (hasOwn.call(obj, key)) keys.push(key);
  }
  return keys;
};

}).call(this,typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})

},{"object-assign":61,"util/":48}],46:[function(require,module,exports){
if (typeof Object.create === 'function') {
  // implementation from standard node.js 'util' module
  module.exports = function inherits(ctor, superCtor) {
    ctor.super_ = superCtor
    ctor.prototype = Object.create(superCtor.prototype, {
      constructor: {
        value: ctor,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
  };
} else {
  // old school shim for old browsers
  module.exports = function inherits(ctor, superCtor) {
    ctor.super_ = superCtor
    var TempCtor = function () {}
    TempCtor.prototype = superCtor.prototype
    ctor.prototype = new TempCtor()
    ctor.prototype.constructor = ctor
  }
}

},{}],47:[function(require,module,exports){
module.exports = function isBuffer(arg) {
  return arg && typeof arg === 'object'
    && typeof arg.copy === 'function'
    && typeof arg.fill === 'function'
    && typeof arg.readUInt8 === 'function';
}
},{}],48:[function(require,module,exports){
(function (process,global){
// Copyright Joyent, Inc. and other Node contributors.
//
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to permit
// persons to whom the Software is furnished to do so, subject to the
// following conditions:
//
// The above copyright notice and this permission notice shall be included
// in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
// USE OR OTHER DEALINGS IN THE SOFTWARE.

var formatRegExp = /%[sdj%]/g;
exports.format = function(f) {
  if (!isString(f)) {
    var objects = [];
    for (var i = 0; i < arguments.length; i++) {
      objects.push(inspect(arguments[i]));
    }
    return objects.join(' ');
  }

  var i = 1;
  var args = arguments;
  var len = args.length;
  var str = String(f).replace(formatRegExp, function(x) {
    if (x === '%%') return '%';
    if (i >= len) return x;
    switch (x) {
      case '%s': return String(args[i++]);
      case '%d': return Number(args[i++]);
      case '%j':
        try {
          return JSON.stringify(args[i++]);
        } catch (_) {
          return '[Circular]';
        }
      default:
        return x;
    }
  });
  for (var x = args[i]; i < len; x = args[++i]) {
    if (isNull(x) || !isObject(x)) {
      str += ' ' + x;
    } else {
      str += ' ' + inspect(x);
    }
  }
  return str;
};


// Mark that a method should not be used.
// Returns a modified function which warns once by default.
// If --no-deprecation is set, then it is a no-op.
exports.deprecate = function(fn, msg) {
  // Allow for deprecating things in the process of starting up.
  if (isUndefined(global.process)) {
    return function() {
      return exports.deprecate(fn, msg).apply(this, arguments);
    };
  }

  if (process.noDeprecation === true) {
    return fn;
  }

  var warned = false;
  function deprecated() {
    if (!warned) {
      if (process.throwDeprecation) {
        throw new Error(msg);
      } else if (process.traceDeprecation) {
        console.trace(msg);
      } else {
        console.error(msg);
      }
      warned = true;
    }
    return fn.apply(this, arguments);
  }

  return deprecated;
};


var debugs = {};
var debugEnviron;
exports.debuglog = function(set) {
  if (isUndefined(debugEnviron))
    debugEnviron = process.env.NODE_DEBUG || '';
  set = set.toUpperCase();
  if (!debugs[set]) {
    if (new RegExp('\\b' + set + '\\b', 'i').test(debugEnviron)) {
      var pid = process.pid;
      debugs[set] = function() {
        var msg = exports.format.apply(exports, arguments);
        console.error('%s %d: %s', set, pid, msg);
      };
    } else {
      debugs[set] = function() {};
    }
  }
  return debugs[set];
};


/**
 * Echos the value of a value. Trys to print the value out
 * in the best way possible given the different types.
 *
 * @param {Object} obj The object to print out.
 * @param {Object} opts Optional options object that alters the output.
 */
/* legacy: obj, showHidden, depth, colors*/
function inspect(obj, opts) {
  // default options
  var ctx = {
    seen: [],
    stylize: stylizeNoColor
  };
  // legacy...
  if (arguments.length >= 3) ctx.depth = arguments[2];
  if (arguments.length >= 4) ctx.colors = arguments[3];
  if (isBoolean(opts)) {
    // legacy...
    ctx.showHidden = opts;
  } else if (opts) {
    // got an "options" object
    exports._extend(ctx, opts);
  }
  // set default options
  if (isUndefined(ctx.showHidden)) ctx.showHidden = false;
  if (isUndefined(ctx.depth)) ctx.depth = 2;
  if (isUndefined(ctx.colors)) ctx.colors = false;
  if (isUndefined(ctx.customInspect)) ctx.customInspect = true;
  if (ctx.colors) ctx.stylize = stylizeWithColor;
  return formatValue(ctx, obj, ctx.depth);
}
exports.inspect = inspect;


// http://en.wikipedia.org/wiki/ANSI_escape_code#graphics
inspect.colors = {
  'bold' : [1, 22],
  'italic' : [3, 23],
  'underline' : [4, 24],
  'inverse' : [7, 27],
  'white' : [37, 39],
  'grey' : [90, 39],
  'black' : [30, 39],
  'blue' : [34, 39],
  'cyan' : [36, 39],
  'green' : [32, 39],
  'magenta' : [35, 39],
  'red' : [31, 39],
  'yellow' : [33, 39]
};

// Don't use 'blue' not visible on cmd.exe
inspect.styles = {
  'special': 'cyan',
  'number': 'yellow',
  'boolean': 'yellow',
  'undefined': 'grey',
  'null': 'bold',
  'string': 'green',
  'date': 'magenta',
  // "name": intentionally not styling
  'regexp': 'red'
};


function stylizeWithColor(str, styleType) {
  var style = inspect.styles[styleType];

  if (style) {
    return '\u001b[' + inspect.colors[style][0] + 'm' + str +
           '\u001b[' + inspect.colors[style][1] + 'm';
  } else {
    return str;
  }
}


function stylizeNoColor(str, styleType) {
  return str;
}


function arrayToHash(array) {
  var hash = {};

  array.forEach(function(val, idx) {
    hash[val] = true;
  });

  return hash;
}


function formatValue(ctx, value, recurseTimes) {
  // Provide a hook for user-specified inspect functions.
  // Check that value is an object with an inspect function on it
  if (ctx.customInspect &&
      value &&
      isFunction(value.inspect) &&
      // Filter out the util module, it's inspect function is special
      value.inspect !== exports.inspect &&
      // Also filter out any prototype objects using the circular check.
      !(value.constructor && value.constructor.prototype === value)) {
    var ret = value.inspect(recurseTimes, ctx);
    if (!isString(ret)) {
      ret = formatValue(ctx, ret, recurseTimes);
    }
    return ret;
  }

  // Primitive types cannot have properties
  var primitive = formatPrimitive(ctx, value);
  if (primitive) {
    return primitive;
  }

  // Look up the keys of the object.
  var keys = Object.keys(value);
  var visibleKeys = arrayToHash(keys);

  if (ctx.showHidden) {
    keys = Object.getOwnPropertyNames(value);
  }

  // IE doesn't make error fields non-enumerable
  // http://msdn.microsoft.com/en-us/library/ie/dww52sbt(v=vs.94).aspx
  if (isError(value)
      && (keys.indexOf('message') >= 0 || keys.indexOf('description') >= 0)) {
    return formatError(value);
  }

  // Some type of object without properties can be shortcutted.
  if (keys.length === 0) {
    if (isFunction(value)) {
      var name = value.name ? ': ' + value.name : '';
      return ctx.stylize('[Function' + name + ']', 'special');
    }
    if (isRegExp(value)) {
      return ctx.stylize(RegExp.prototype.toString.call(value), 'regexp');
    }
    if (isDate(value)) {
      return ctx.stylize(Date.prototype.toString.call(value), 'date');
    }
    if (isError(value)) {
      return formatError(value);
    }
  }

  var base = '', array = false, braces = ['{', '}'];

  // Make Array say that they are Array
  if (isArray(value)) {
    array = true;
    braces = ['[', ']'];
  }

  // Make functions say that they are functions
  if (isFunction(value)) {
    var n = value.name ? ': ' + value.name : '';
    base = ' [Function' + n + ']';
  }

  // Make RegExps say that they are RegExps
  if (isRegExp(value)) {
    base = ' ' + RegExp.prototype.toString.call(value);
  }

  // Make dates with properties first say the date
  if (isDate(value)) {
    base = ' ' + Date.prototype.toUTCString.call(value);
  }

  // Make error with message first say the error
  if (isError(value)) {
    base = ' ' + formatError(value);
  }

  if (keys.length === 0 && (!array || value.length == 0)) {
    return braces[0] + base + braces[1];
  }

  if (recurseTimes < 0) {
    if (isRegExp(value)) {
      return ctx.stylize(RegExp.prototype.toString.call(value), 'regexp');
    } else {
      return ctx.stylize('[Object]', 'special');
    }
  }

  ctx.seen.push(value);

  var output;
  if (array) {
    output = formatArray(ctx, value, recurseTimes, visibleKeys, keys);
  } else {
    output = keys.map(function(key) {
      return formatProperty(ctx, value, recurseTimes, visibleKeys, key, array);
    });
  }

  ctx.seen.pop();

  return reduceToSingleString(output, base, braces);
}


function formatPrimitive(ctx, value) {
  if (isUndefined(value))
    return ctx.stylize('undefined', 'undefined');
  if (isString(value)) {
    var simple = '\'' + JSON.stringify(value).replace(/^"|"$/g, '')
                                             .replace(/'/g, "\\'")
                                             .replace(/\\"/g, '"') + '\'';
    return ctx.stylize(simple, 'string');
  }
  if (isNumber(value))
    return ctx.stylize('' + value, 'number');
  if (isBoolean(value))
    return ctx.stylize('' + value, 'boolean');
  // For some reason typeof null is "object", so special case here.
  if (isNull(value))
    return ctx.stylize('null', 'null');
}


function formatError(value) {
  return '[' + Error.prototype.toString.call(value) + ']';
}


function formatArray(ctx, value, recurseTimes, visibleKeys, keys) {
  var output = [];
  for (var i = 0, l = value.length; i < l; ++i) {
    if (hasOwnProperty(value, String(i))) {
      output.push(formatProperty(ctx, value, recurseTimes, visibleKeys,
          String(i), true));
    } else {
      output.push('');
    }
  }
  keys.forEach(function(key) {
    if (!key.match(/^\d+$/)) {
      output.push(formatProperty(ctx, value, recurseTimes, visibleKeys,
          key, true));
    }
  });
  return output;
}


function formatProperty(ctx, value, recurseTimes, visibleKeys, key, array) {
  var name, str, desc;
  desc = Object.getOwnPropertyDescriptor(value, key) || { value: value[key] };
  if (desc.get) {
    if (desc.set) {
      str = ctx.stylize('[Getter/Setter]', 'special');
    } else {
      str = ctx.stylize('[Getter]', 'special');
    }
  } else {
    if (desc.set) {
      str = ctx.stylize('[Setter]', 'special');
    }
  }
  if (!hasOwnProperty(visibleKeys, key)) {
    name = '[' + key + ']';
  }
  if (!str) {
    if (ctx.seen.indexOf(desc.value) < 0) {
      if (isNull(recurseTimes)) {
        str = formatValue(ctx, desc.value, null);
      } else {
        str = formatValue(ctx, desc.value, recurseTimes - 1);
      }
      if (str.indexOf('\n') > -1) {
        if (array) {
          str = str.split('\n').map(function(line) {
            return '  ' + line;
          }).join('\n').substr(2);
        } else {
          str = '\n' + str.split('\n').map(function(line) {
            return '   ' + line;
          }).join('\n');
        }
      }
    } else {
      str = ctx.stylize('[Circular]', 'special');
    }
  }
  if (isUndefined(name)) {
    if (array && key.match(/^\d+$/)) {
      return str;
    }
    name = JSON.stringify('' + key);
    if (name.match(/^"([a-zA-Z_][a-zA-Z_0-9]*)"$/)) {
      name = name.substr(1, name.length - 2);
      name = ctx.stylize(name, 'name');
    } else {
      name = name.replace(/'/g, "\\'")
                 .replace(/\\"/g, '"')
                 .replace(/(^"|"$)/g, "'");
      name = ctx.stylize(name, 'string');
    }
  }

  return name + ': ' + str;
}


function reduceToSingleString(output, base, braces) {
  var numLinesEst = 0;
  var length = output.reduce(function(prev, cur) {
    numLinesEst++;
    if (cur.indexOf('\n') >= 0) numLinesEst++;
    return prev + cur.replace(/\u001b\[\d\d?m/g, '').length + 1;
  }, 0);

  if (length > 60) {
    return braces[0] +
           (base === '' ? '' : base + '\n ') +
           ' ' +
           output.join(',\n  ') +
           ' ' +
           braces[1];
  }

  return braces[0] + base + ' ' + output.join(', ') + ' ' + braces[1];
}


// NOTE: These type checking functions intentionally don't use `instanceof`
// because it is fragile and can be easily faked with `Object.create()`.
function isArray(ar) {
  return Array.isArray(ar);
}
exports.isArray = isArray;

function isBoolean(arg) {
  return typeof arg === 'boolean';
}
exports.isBoolean = isBoolean;

function isNull(arg) {
  return arg === null;
}
exports.isNull = isNull;

function isNullOrUndefined(arg) {
  return arg == null;
}
exports.isNullOrUndefined = isNullOrUndefined;

function isNumber(arg) {
  return typeof arg === 'number';
}
exports.isNumber = isNumber;

function isString(arg) {
  return typeof arg === 'string';
}
exports.isString = isString;

function isSymbol(arg) {
  return typeof arg === 'symbol';
}
exports.isSymbol = isSymbol;

function isUndefined(arg) {
  return arg === void 0;
}
exports.isUndefined = isUndefined;

function isRegExp(re) {
  return isObject(re) && objectToString(re) === '[object RegExp]';
}
exports.isRegExp = isRegExp;

function isObject(arg) {
  return typeof arg === 'object' && arg !== null;
}
exports.isObject = isObject;

function isDate(d) {
  return isObject(d) && objectToString(d) === '[object Date]';
}
exports.isDate = isDate;

function isError(e) {
  return isObject(e) &&
      (objectToString(e) === '[object Error]' || e instanceof Error);
}
exports.isError = isError;

function isFunction(arg) {
  return typeof arg === 'function';
}
exports.isFunction = isFunction;

function isPrimitive(arg) {
  return arg === null ||
         typeof arg === 'boolean' ||
         typeof arg === 'number' ||
         typeof arg === 'string' ||
         typeof arg === 'symbol' ||  // ES6 symbol
         typeof arg === 'undefined';
}
exports.isPrimitive = isPrimitive;

exports.isBuffer = require('./support/isBuffer');

function objectToString(o) {
  return Object.prototype.toString.call(o);
}


function pad(n) {
  return n < 10 ? '0' + n.toString(10) : n.toString(10);
}


var months = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep',
              'Oct', 'Nov', 'Dec'];

// 26 Feb 16:19:34
function timestamp() {
  var d = new Date();
  var time = [pad(d.getHours()),
              pad(d.getMinutes()),
              pad(d.getSeconds())].join(':');
  return [d.getDate(), months[d.getMonth()], time].join(' ');
}


// log is just a thin wrapper to console.log that prepends a timestamp
exports.log = function() {
  console.log('%s - %s', timestamp(), exports.format.apply(exports, arguments));
};


/**
 * Inherit the prototype methods from one constructor into another.
 *
 * The Function.prototype.inherits from lang.js rewritten as a standalone
 * function (not on Function.prototype). NOTE: If this file is to be loaded
 * during bootstrapping this function needs to be rewritten using some native
 * functions as prototype setup using normal JavaScript does not work as
 * expected during bootstrapping (see mirror.js in r114903).
 *
 * @param {function} ctor Constructor function which needs to inherit the
 *     prototype.
 * @param {function} superCtor Constructor function to inherit prototype from.
 */
exports.inherits = require('inherits');

exports._extend = function(origin, add) {
  // Don't do anything if add isn't an object
  if (!add || !isObject(add)) return origin;

  var keys = Object.keys(add);
  var i = keys.length;
  while (i--) {
    origin[keys[i]] = add[keys[i]];
  }
  return origin;
};

function hasOwnProperty(obj, prop) {
  return Object.prototype.hasOwnProperty.call(obj, prop);
}

}).call(this,require('_process'),typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})

},{"./support/isBuffer":47,"_process":74,"inherits":46}],49:[function(require,module,exports){
'use strict'

exports.byteLength = byteLength
exports.toByteArray = toByteArray
exports.fromByteArray = fromByteArray

var lookup = []
var revLookup = []
var Arr = typeof Uint8Array !== 'undefined' ? Uint8Array : Array

var code = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/'
for (var i = 0, len = code.length; i < len; ++i) {
  lookup[i] = code[i]
  revLookup[code.charCodeAt(i)] = i
}

// Support decoding URL-safe base64 strings, as Node.js does.
// See: https://en.wikipedia.org/wiki/Base64#URL_applications
revLookup['-'.charCodeAt(0)] = 62
revLookup['_'.charCodeAt(0)] = 63

function getLens (b64) {
  var len = b64.length

  if (len % 4 > 0) {
    throw new Error('Invalid string. Length must be a multiple of 4')
  }

  // Trim off extra bytes after placeholder bytes are found
  // See: https://github.com/beatgammit/base64-js/issues/42
  var validLen = b64.indexOf('=')
  if (validLen === -1) validLen = len

  var placeHoldersLen = validLen === len
    ? 0
    : 4 - (validLen % 4)

  return [validLen, placeHoldersLen]
}

// base64 is 4/3 + up to two characters of the original data
function byteLength (b64) {
  var lens = getLens(b64)
  var validLen = lens[0]
  var placeHoldersLen = lens[1]
  return ((validLen + placeHoldersLen) * 3 / 4) - placeHoldersLen
}

function _byteLength (b64, validLen, placeHoldersLen) {
  return ((validLen + placeHoldersLen) * 3 / 4) - placeHoldersLen
}

function toByteArray (b64) {
  var tmp
  var lens = getLens(b64)
  var validLen = lens[0]
  var placeHoldersLen = lens[1]

  var arr = new Arr(_byteLength(b64, validLen, placeHoldersLen))

  var curByte = 0

  // if there are placeholders, only get up to the last complete 4 chars
  var len = placeHoldersLen > 0
    ? validLen - 4
    : validLen

  var i
  for (i = 0; i < len; i += 4) {
    tmp =
      (revLookup[b64.charCodeAt(i)] << 18) |
      (revLookup[b64.charCodeAt(i + 1)] << 12) |
      (revLookup[b64.charCodeAt(i + 2)] << 6) |
      revLookup[b64.charCodeAt(i + 3)]
    arr[curByte++] = (tmp >> 16) & 0xFF
    arr[curByte++] = (tmp >> 8) & 0xFF
    arr[curByte++] = tmp & 0xFF
  }

  if (placeHoldersLen === 2) {
    tmp =
      (revLookup[b64.charCodeAt(i)] << 2) |
      (revLookup[b64.charCodeAt(i + 1)] >> 4)
    arr[curByte++] = tmp & 0xFF
  }

  if (placeHoldersLen === 1) {
    tmp =
      (revLookup[b64.charCodeAt(i)] << 10) |
      (revLookup[b64.charCodeAt(i + 1)] << 4) |
      (revLookup[b64.charCodeAt(i + 2)] >> 2)
    arr[curByte++] = (tmp >> 8) & 0xFF
    arr[curByte++] = tmp & 0xFF
  }

  return arr
}

function tripletToBase64 (num) {
  return lookup[num >> 18 & 0x3F] +
    lookup[num >> 12 & 0x3F] +
    lookup[num >> 6 & 0x3F] +
    lookup[num & 0x3F]
}

function encodeChunk (uint8, start, end) {
  var tmp
  var output = []
  for (var i = start; i < end; i += 3) {
    tmp =
      ((uint8[i] << 16) & 0xFF0000) +
      ((uint8[i + 1] << 8) & 0xFF00) +
      (uint8[i + 2] & 0xFF)
    output.push(tripletToBase64(tmp))
  }
  return output.join('')
}

function fromByteArray (uint8) {
  var tmp
  var len = uint8.length
  var extraBytes = len % 3 // if we have 1 byte left, pad 2 bytes
  var parts = []
  var maxChunkLength = 16383 // must be multiple of 3

  // go through the array every three bytes, we'll deal with trailing stuff later
  for (var i = 0, len2 = len - extraBytes; i < len2; i += maxChunkLength) {
    parts.push(encodeChunk(
      uint8, i, (i + maxChunkLength) > len2 ? len2 : (i + maxChunkLength)
    ))
  }

  // pad the end with zeros, but make sure to not forget the extra bytes
  if (extraBytes === 1) {
    tmp = uint8[len - 1]
    parts.push(
      lookup[tmp >> 2] +
      lookup[(tmp << 4) & 0x3F] +
      '=='
    )
  } else if (extraBytes === 2) {
    tmp = (uint8[len - 2] << 8) + uint8[len - 1]
    parts.push(
      lookup[tmp >> 10] +
      lookup[(tmp >> 4) & 0x3F] +
      lookup[(tmp << 2) & 0x3F] +
      '='
    )
  }

  return parts.join('')
}

},{}],50:[function(require,module,exports){

},{}],51:[function(require,module,exports){
(function (process,Buffer){
'use strict';
/* eslint camelcase: "off" */

var assert = require('assert');

var Zstream = require('pako/lib/zlib/zstream');
var zlib_deflate = require('pako/lib/zlib/deflate.js');
var zlib_inflate = require('pako/lib/zlib/inflate.js');
var constants = require('pako/lib/zlib/constants');

for (var key in constants) {
  exports[key] = constants[key];
}

// zlib modes
exports.NONE = 0;
exports.DEFLATE = 1;
exports.INFLATE = 2;
exports.GZIP = 3;
exports.GUNZIP = 4;
exports.DEFLATERAW = 5;
exports.INFLATERAW = 6;
exports.UNZIP = 7;

var GZIP_HEADER_ID1 = 0x1f;
var GZIP_HEADER_ID2 = 0x8b;

/**
 * Emulate Node's zlib C++ layer for use by the JS layer in index.js
 */
function Zlib(mode) {
  if (typeof mode !== 'number' || mode < exports.DEFLATE || mode > exports.UNZIP) {
    throw new TypeError('Bad argument');
  }

  this.dictionary = null;
  this.err = 0;
  this.flush = 0;
  this.init_done = false;
  this.level = 0;
  this.memLevel = 0;
  this.mode = mode;
  this.strategy = 0;
  this.windowBits = 0;
  this.write_in_progress = false;
  this.pending_close = false;
  this.gzip_id_bytes_read = 0;
}

Zlib.prototype.close = function () {
  if (this.write_in_progress) {
    this.pending_close = true;
    return;
  }

  this.pending_close = false;

  assert(this.init_done, 'close before init');
  assert(this.mode <= exports.UNZIP);

  if (this.mode === exports.DEFLATE || this.mode === exports.GZIP || this.mode === exports.DEFLATERAW) {
    zlib_deflate.deflateEnd(this.strm);
  } else if (this.mode === exports.INFLATE || this.mode === exports.GUNZIP || this.mode === exports.INFLATERAW || this.mode === exports.UNZIP) {
    zlib_inflate.inflateEnd(this.strm);
  }

  this.mode = exports.NONE;

  this.dictionary = null;
};

Zlib.prototype.write = function (flush, input, in_off, in_len, out, out_off, out_len) {
  return this._write(true, flush, input, in_off, in_len, out, out_off, out_len);
};

Zlib.prototype.writeSync = function (flush, input, in_off, in_len, out, out_off, out_len) {
  return this._write(false, flush, input, in_off, in_len, out, out_off, out_len);
};

Zlib.prototype._write = function (async, flush, input, in_off, in_len, out, out_off, out_len) {
  assert.equal(arguments.length, 8);

  assert(this.init_done, 'write before init');
  assert(this.mode !== exports.NONE, 'already finalized');
  assert.equal(false, this.write_in_progress, 'write already in progress');
  assert.equal(false, this.pending_close, 'close is pending');

  this.write_in_progress = true;

  assert.equal(false, flush === undefined, 'must provide flush value');

  this.write_in_progress = true;

  if (flush !== exports.Z_NO_FLUSH && flush !== exports.Z_PARTIAL_FLUSH && flush !== exports.Z_SYNC_FLUSH && flush !== exports.Z_FULL_FLUSH && flush !== exports.Z_FINISH && flush !== exports.Z_BLOCK) {
    throw new Error('Invalid flush value');
  }

  if (input == null) {
    input = Buffer.alloc(0);
    in_len = 0;
    in_off = 0;
  }

  this.strm.avail_in = in_len;
  this.strm.input = input;
  this.strm.next_in = in_off;
  this.strm.avail_out = out_len;
  this.strm.output = out;
  this.strm.next_out = out_off;
  this.flush = flush;

  if (!async) {
    // sync version
    this._process();

    if (this._checkError()) {
      return this._afterSync();
    }
    return;
  }

  // async version
  var self = this;
  process.nextTick(function () {
    self._process();
    self._after();
  });

  return this;
};

Zlib.prototype._afterSync = function () {
  var avail_out = this.strm.avail_out;
  var avail_in = this.strm.avail_in;

  this.write_in_progress = false;

  return [avail_in, avail_out];
};

Zlib.prototype._process = function () {
  var next_expected_header_byte = null;

  // If the avail_out is left at 0, then it means that it ran out
  // of room.  If there was avail_out left over, then it means
  // that all of the input was consumed.
  switch (this.mode) {
    case exports.DEFLATE:
    case exports.GZIP:
    case exports.DEFLATERAW:
      this.err = zlib_deflate.deflate(this.strm, this.flush);
      break;
    case exports.UNZIP:
      if (this.strm.avail_in > 0) {
        next_expected_header_byte = this.strm.next_in;
      }

      switch (this.gzip_id_bytes_read) {
        case 0:
          if (next_expected_header_byte === null) {
            break;
          }

          if (this.strm.input[next_expected_header_byte] === GZIP_HEADER_ID1) {
            this.gzip_id_bytes_read = 1;
            next_expected_header_byte++;

            if (this.strm.avail_in === 1) {
              // The only available byte was already read.
              break;
            }
          } else {
            this.mode = exports.INFLATE;
            break;
          }

        // fallthrough
        case 1:
          if (next_expected_header_byte === null) {
            break;
          }

          if (this.strm.input[next_expected_header_byte] === GZIP_HEADER_ID2) {
            this.gzip_id_bytes_read = 2;
            this.mode = exports.GUNZIP;
          } else {
            // There is no actual difference between INFLATE and INFLATERAW
            // (after initialization).
            this.mode = exports.INFLATE;
          }

          break;
        default:
          throw new Error('invalid number of gzip magic number bytes read');
      }

    // fallthrough
    case exports.INFLATE:
    case exports.GUNZIP:
    case exports.INFLATERAW:
      this.err = zlib_inflate.inflate(this.strm, this.flush

      // If data was encoded with dictionary
      );if (this.err === exports.Z_NEED_DICT && this.dictionary) {
        // Load it
        this.err = zlib_inflate.inflateSetDictionary(this.strm, this.dictionary);
        if (this.err === exports.Z_OK) {
          // And try to decode again
          this.err = zlib_inflate.inflate(this.strm, this.flush);
        } else if (this.err === exports.Z_DATA_ERROR) {
          // Both inflateSetDictionary() and inflate() return Z_DATA_ERROR.
          // Make it possible for After() to tell a bad dictionary from bad
          // input.
          this.err = exports.Z_NEED_DICT;
        }
      }
      while (this.strm.avail_in > 0 && this.mode === exports.GUNZIP && this.err === exports.Z_STREAM_END && this.strm.next_in[0] !== 0x00) {
        // Bytes remain in input buffer. Perhaps this is another compressed
        // member in the same archive, or just trailing garbage.
        // Trailing zero bytes are okay, though, since they are frequently
        // used for padding.

        this.reset();
        this.err = zlib_inflate.inflate(this.strm, this.flush);
      }
      break;
    default:
      throw new Error('Unknown mode ' + this.mode);
  }
};

Zlib.prototype._checkError = function () {
  // Acceptable error states depend on the type of zlib stream.
  switch (this.err) {
    case exports.Z_OK:
    case exports.Z_BUF_ERROR:
      if (this.strm.avail_out !== 0 && this.flush === exports.Z_FINISH) {
        this._error('unexpected end of file');
        return false;
      }
      break;
    case exports.Z_STREAM_END:
      // normal statuses, not fatal
      break;
    case exports.Z_NEED_DICT:
      if (this.dictionary == null) {
        this._error('Missing dictionary');
      } else {
        this._error('Bad dictionary');
      }
      return false;
    default:
      // something else.
      this._error('Zlib error');
      return false;
  }

  return true;
};

Zlib.prototype._after = function () {
  if (!this._checkError()) {
    return;
  }

  var avail_out = this.strm.avail_out;
  var avail_in = this.strm.avail_in;

  this.write_in_progress = false;

  // call the write() cb
  this.callback(avail_in, avail_out);

  if (this.pending_close) {
    this.close();
  }
};

Zlib.prototype._error = function (message) {
  if (this.strm.msg) {
    message = this.strm.msg;
  }
  this.onerror(message, this.err

  // no hope of rescue.
  );this.write_in_progress = false;
  if (this.pending_close) {
    this.close();
  }
};

Zlib.prototype.init = function (windowBits, level, memLevel, strategy, dictionary) {
  assert(arguments.length === 4 || arguments.length === 5, 'init(windowBits, level, memLevel, strategy, [dictionary])');

  assert(windowBits >= 8 && windowBits <= 15, 'invalid windowBits');
  assert(level >= -1 && level <= 9, 'invalid compression level');

  assert(memLevel >= 1 && memLevel <= 9, 'invalid memlevel');

  assert(strategy === exports.Z_FILTERED || strategy === exports.Z_HUFFMAN_ONLY || strategy === exports.Z_RLE || strategy === exports.Z_FIXED || strategy === exports.Z_DEFAULT_STRATEGY, 'invalid strategy');

  this._init(level, windowBits, memLevel, strategy, dictionary);
  this._setDictionary();
};

Zlib.prototype.params = function () {
  throw new Error('deflateParams Not supported');
};

Zlib.prototype.reset = function () {
  this._reset();
  this._setDictionary();
};

Zlib.prototype._init = function (level, windowBits, memLevel, strategy, dictionary) {
  this.level = level;
  this.windowBits = windowBits;
  this.memLevel = memLevel;
  this.strategy = strategy;

  this.flush = exports.Z_NO_FLUSH;

  this.err = exports.Z_OK;

  if (this.mode === exports.GZIP || this.mode === exports.GUNZIP) {
    this.windowBits += 16;
  }

  if (this.mode === exports.UNZIP) {
    this.windowBits += 32;
  }

  if (this.mode === exports.DEFLATERAW || this.mode === exports.INFLATERAW) {
    this.windowBits = -1 * this.windowBits;
  }

  this.strm = new Zstream();

  switch (this.mode) {
    case exports.DEFLATE:
    case exports.GZIP:
    case exports.DEFLATERAW:
      this.err = zlib_deflate.deflateInit2(this.strm, this.level, exports.Z_DEFLATED, this.windowBits, this.memLevel, this.strategy);
      break;
    case exports.INFLATE:
    case exports.GUNZIP:
    case exports.INFLATERAW:
    case exports.UNZIP:
      this.err = zlib_inflate.inflateInit2(this.strm, this.windowBits);
      break;
    default:
      throw new Error('Unknown mode ' + this.mode);
  }

  if (this.err !== exports.Z_OK) {
    this._error('Init error');
  }

  this.dictionary = dictionary;

  this.write_in_progress = false;
  this.init_done = true;
};

Zlib.prototype._setDictionary = function () {
  if (this.dictionary == null) {
    return;
  }

  this.err = exports.Z_OK;

  switch (this.mode) {
    case exports.DEFLATE:
    case exports.DEFLATERAW:
      this.err = zlib_deflate.deflateSetDictionary(this.strm, this.dictionary);
      break;
    default:
      break;
  }

  if (this.err !== exports.Z_OK) {
    this._error('Failed to set dictionary');
  }
};

Zlib.prototype._reset = function () {
  this.err = exports.Z_OK;

  switch (this.mode) {
    case exports.DEFLATE:
    case exports.DEFLATERAW:
    case exports.GZIP:
      this.err = zlib_deflate.deflateReset(this.strm);
      break;
    case exports.INFLATE:
    case exports.INFLATERAW:
    case exports.GUNZIP:
      this.err = zlib_inflate.inflateReset(this.strm);
      break;
    default:
      break;
  }

  if (this.err !== exports.Z_OK) {
    this._error('Failed to reset stream');
  }
};

exports.Zlib = Zlib;
}).call(this,require('_process'),require("buffer").Buffer)

},{"_process":74,"assert":45,"buffer":53,"pako/lib/zlib/constants":64,"pako/lib/zlib/deflate.js":66,"pako/lib/zlib/inflate.js":68,"pako/lib/zlib/zstream":72}],52:[function(require,module,exports){
(function (process){
'use strict';

var Buffer = require('buffer').Buffer;
var Transform = require('stream').Transform;
var binding = require('./binding');
var util = require('util');
var assert = require('assert').ok;
var kMaxLength = require('buffer').kMaxLength;
var kRangeErrorMessage = 'Cannot create final Buffer. It would be larger ' + 'than 0x' + kMaxLength.toString(16) + ' bytes';

// zlib doesn't provide these, so kludge them in following the same
// const naming scheme zlib uses.
binding.Z_MIN_WINDOWBITS = 8;
binding.Z_MAX_WINDOWBITS = 15;
binding.Z_DEFAULT_WINDOWBITS = 15;

// fewer than 64 bytes per chunk is stupid.
// technically it could work with as few as 8, but even 64 bytes
// is absurdly low.  Usually a MB or more is best.
binding.Z_MIN_CHUNK = 64;
binding.Z_MAX_CHUNK = Infinity;
binding.Z_DEFAULT_CHUNK = 16 * 1024;

binding.Z_MIN_MEMLEVEL = 1;
binding.Z_MAX_MEMLEVEL = 9;
binding.Z_DEFAULT_MEMLEVEL = 8;

binding.Z_MIN_LEVEL = -1;
binding.Z_MAX_LEVEL = 9;
binding.Z_DEFAULT_LEVEL = binding.Z_DEFAULT_COMPRESSION;

// expose all the zlib constants
var bkeys = Object.keys(binding);
for (var bk = 0; bk < bkeys.length; bk++) {
  var bkey = bkeys[bk];
  if (bkey.match(/^Z/)) {
    Object.defineProperty(exports, bkey, {
      enumerable: true, value: binding[bkey], writable: false
    });
  }
}

// translation table for return codes.
var codes = {
  Z_OK: binding.Z_OK,
  Z_STREAM_END: binding.Z_STREAM_END,
  Z_NEED_DICT: binding.Z_NEED_DICT,
  Z_ERRNO: binding.Z_ERRNO,
  Z_STREAM_ERROR: binding.Z_STREAM_ERROR,
  Z_DATA_ERROR: binding.Z_DATA_ERROR,
  Z_MEM_ERROR: binding.Z_MEM_ERROR,
  Z_BUF_ERROR: binding.Z_BUF_ERROR,
  Z_VERSION_ERROR: binding.Z_VERSION_ERROR
};

var ckeys = Object.keys(codes);
for (var ck = 0; ck < ckeys.length; ck++) {
  var ckey = ckeys[ck];
  codes[codes[ckey]] = ckey;
}

Object.defineProperty(exports, 'codes', {
  enumerable: true, value: Object.freeze(codes), writable: false
});

exports.Deflate = Deflate;
exports.Inflate = Inflate;
exports.Gzip = Gzip;
exports.Gunzip = Gunzip;
exports.DeflateRaw = DeflateRaw;
exports.InflateRaw = InflateRaw;
exports.Unzip = Unzip;

exports.createDeflate = function (o) {
  return new Deflate(o);
};

exports.createInflate = function (o) {
  return new Inflate(o);
};

exports.createDeflateRaw = function (o) {
  return new DeflateRaw(o);
};

exports.createInflateRaw = function (o) {
  return new InflateRaw(o);
};

exports.createGzip = function (o) {
  return new Gzip(o);
};

exports.createGunzip = function (o) {
  return new Gunzip(o);
};

exports.createUnzip = function (o) {
  return new Unzip(o);
};

// Convenience methods.
// compress/decompress a string or buffer in one step.
exports.deflate = function (buffer, opts, callback) {
  if (typeof opts === 'function') {
    callback = opts;
    opts = {};
  }
  return zlibBuffer(new Deflate(opts), buffer, callback);
};

exports.deflateSync = function (buffer, opts) {
  return zlibBufferSync(new Deflate(opts), buffer);
};

exports.gzip = function (buffer, opts, callback) {
  if (typeof opts === 'function') {
    callback = opts;
    opts = {};
  }
  return zlibBuffer(new Gzip(opts), buffer, callback);
};

exports.gzipSync = function (buffer, opts) {
  return zlibBufferSync(new Gzip(opts), buffer);
};

exports.deflateRaw = function (buffer, opts, callback) {
  if (typeof opts === 'function') {
    callback = opts;
    opts = {};
  }
  return zlibBuffer(new DeflateRaw(opts), buffer, callback);
};

exports.deflateRawSync = function (buffer, opts) {
  return zlibBufferSync(new DeflateRaw(opts), buffer);
};

exports.unzip = function (buffer, opts, callback) {
  if (typeof opts === 'function') {
    callback = opts;
    opts = {};
  }
  return zlibBuffer(new Unzip(opts), buffer, callback);
};

exports.unzipSync = function (buffer, opts) {
  return zlibBufferSync(new Unzip(opts), buffer);
};

exports.inflate = function (buffer, opts, callback) {
  if (typeof opts === 'function') {
    callback = opts;
    opts = {};
  }
  return zlibBuffer(new Inflate(opts), buffer, callback);
};

exports.inflateSync = function (buffer, opts) {
  return zlibBufferSync(new Inflate(opts), buffer);
};

exports.gunzip = function (buffer, opts, callback) {
  if (typeof opts === 'function') {
    callback = opts;
    opts = {};
  }
  return zlibBuffer(new Gunzip(opts), buffer, callback);
};

exports.gunzipSync = function (buffer, opts) {
  return zlibBufferSync(new Gunzip(opts), buffer);
};

exports.inflateRaw = function (buffer, opts, callback) {
  if (typeof opts === 'function') {
    callback = opts;
    opts = {};
  }
  return zlibBuffer(new InflateRaw(opts), buffer, callback);
};

exports.inflateRawSync = function (buffer, opts) {
  return zlibBufferSync(new InflateRaw(opts), buffer);
};

function zlibBuffer(engine, buffer, callback) {
  var buffers = [];
  var nread = 0;

  engine.on('error', onError);
  engine.on('end', onEnd);

  engine.end(buffer);
  flow();

  function flow() {
    var chunk;
    while (null !== (chunk = engine.read())) {
      buffers.push(chunk);
      nread += chunk.length;
    }
    engine.once('readable', flow);
  }

  function onError(err) {
    engine.removeListener('end', onEnd);
    engine.removeListener('readable', flow);
    callback(err);
  }

  function onEnd() {
    var buf;
    var err = null;

    if (nread >= kMaxLength) {
      err = new RangeError(kRangeErrorMessage);
    } else {
      buf = Buffer.concat(buffers, nread);
    }

    buffers = [];
    engine.close();
    callback(err, buf);
  }
}

function zlibBufferSync(engine, buffer) {
  if (typeof buffer === 'string') buffer = Buffer.from(buffer);

  if (!Buffer.isBuffer(buffer)) throw new TypeError('Not a string or buffer');

  var flushFlag = engine._finishFlushFlag;

  return engine._processChunk(buffer, flushFlag);
}

// generic zlib
// minimal 2-byte header
function Deflate(opts) {
  if (!(this instanceof Deflate)) return new Deflate(opts);
  Zlib.call(this, opts, binding.DEFLATE);
}

function Inflate(opts) {
  if (!(this instanceof Inflate)) return new Inflate(opts);
  Zlib.call(this, opts, binding.INFLATE);
}

// gzip - bigger header, same deflate compression
function Gzip(opts) {
  if (!(this instanceof Gzip)) return new Gzip(opts);
  Zlib.call(this, opts, binding.GZIP);
}

function Gunzip(opts) {
  if (!(this instanceof Gunzip)) return new Gunzip(opts);
  Zlib.call(this, opts, binding.GUNZIP);
}

// raw - no header
function DeflateRaw(opts) {
  if (!(this instanceof DeflateRaw)) return new DeflateRaw(opts);
  Zlib.call(this, opts, binding.DEFLATERAW);
}

function InflateRaw(opts) {
  if (!(this instanceof InflateRaw)) return new InflateRaw(opts);
  Zlib.call(this, opts, binding.INFLATERAW);
}

// auto-detect header.
function Unzip(opts) {
  if (!(this instanceof Unzip)) return new Unzip(opts);
  Zlib.call(this, opts, binding.UNZIP);
}

function isValidFlushFlag(flag) {
  return flag === binding.Z_NO_FLUSH || flag === binding.Z_PARTIAL_FLUSH || flag === binding.Z_SYNC_FLUSH || flag === binding.Z_FULL_FLUSH || flag === binding.Z_FINISH || flag === binding.Z_BLOCK;
}

// the Zlib class they all inherit from
// This thing manages the queue of requests, and returns
// true or false if there is anything in the queue when
// you call the .write() method.

function Zlib(opts, mode) {
  var _this = this;

  this._opts = opts = opts || {};
  this._chunkSize = opts.chunkSize || exports.Z_DEFAULT_CHUNK;

  Transform.call(this, opts);

  if (opts.flush && !isValidFlushFlag(opts.flush)) {
    throw new Error('Invalid flush flag: ' + opts.flush);
  }
  if (opts.finishFlush && !isValidFlushFlag(opts.finishFlush)) {
    throw new Error('Invalid flush flag: ' + opts.finishFlush);
  }

  this._flushFlag = opts.flush || binding.Z_NO_FLUSH;
  this._finishFlushFlag = typeof opts.finishFlush !== 'undefined' ? opts.finishFlush : binding.Z_FINISH;

  if (opts.chunkSize) {
    if (opts.chunkSize < exports.Z_MIN_CHUNK || opts.chunkSize > exports.Z_MAX_CHUNK) {
      throw new Error('Invalid chunk size: ' + opts.chunkSize);
    }
  }

  if (opts.windowBits) {
    if (opts.windowBits < exports.Z_MIN_WINDOWBITS || opts.windowBits > exports.Z_MAX_WINDOWBITS) {
      throw new Error('Invalid windowBits: ' + opts.windowBits);
    }
  }

  if (opts.level) {
    if (opts.level < exports.Z_MIN_LEVEL || opts.level > exports.Z_MAX_LEVEL) {
      throw new Error('Invalid compression level: ' + opts.level);
    }
  }

  if (opts.memLevel) {
    if (opts.memLevel < exports.Z_MIN_MEMLEVEL || opts.memLevel > exports.Z_MAX_MEMLEVEL) {
      throw new Error('Invalid memLevel: ' + opts.memLevel);
    }
  }

  if (opts.strategy) {
    if (opts.strategy != exports.Z_FILTERED && opts.strategy != exports.Z_HUFFMAN_ONLY && opts.strategy != exports.Z_RLE && opts.strategy != exports.Z_FIXED && opts.strategy != exports.Z_DEFAULT_STRATEGY) {
      throw new Error('Invalid strategy: ' + opts.strategy);
    }
  }

  if (opts.dictionary) {
    if (!Buffer.isBuffer(opts.dictionary)) {
      throw new Error('Invalid dictionary: it should be a Buffer instance');
    }
  }

  this._handle = new binding.Zlib(mode);

  var self = this;
  this._hadError = false;
  this._handle.onerror = function (message, errno) {
    // there is no way to cleanly recover.
    // continuing only obscures problems.
    _close(self);
    self._hadError = true;

    var error = new Error(message);
    error.errno = errno;
    error.code = exports.codes[errno];
    self.emit('error', error);
  };

  var level = exports.Z_DEFAULT_COMPRESSION;
  if (typeof opts.level === 'number') level = opts.level;

  var strategy = exports.Z_DEFAULT_STRATEGY;
  if (typeof opts.strategy === 'number') strategy = opts.strategy;

  this._handle.init(opts.windowBits || exports.Z_DEFAULT_WINDOWBITS, level, opts.memLevel || exports.Z_DEFAULT_MEMLEVEL, strategy, opts.dictionary);

  this._buffer = Buffer.allocUnsafe(this._chunkSize);
  this._offset = 0;
  this._level = level;
  this._strategy = strategy;

  this.once('end', this.close);

  Object.defineProperty(this, '_closed', {
    get: function () {
      return !_this._handle;
    },
    configurable: true,
    enumerable: true
  });
}

util.inherits(Zlib, Transform);

Zlib.prototype.params = function (level, strategy, callback) {
  if (level < exports.Z_MIN_LEVEL || level > exports.Z_MAX_LEVEL) {
    throw new RangeError('Invalid compression level: ' + level);
  }
  if (strategy != exports.Z_FILTERED && strategy != exports.Z_HUFFMAN_ONLY && strategy != exports.Z_RLE && strategy != exports.Z_FIXED && strategy != exports.Z_DEFAULT_STRATEGY) {
    throw new TypeError('Invalid strategy: ' + strategy);
  }

  if (this._level !== level || this._strategy !== strategy) {
    var self = this;
    this.flush(binding.Z_SYNC_FLUSH, function () {
      assert(self._handle, 'zlib binding closed');
      self._handle.params(level, strategy);
      if (!self._hadError) {
        self._level = level;
        self._strategy = strategy;
        if (callback) callback();
      }
    });
  } else {
    process.nextTick(callback);
  }
};

Zlib.prototype.reset = function () {
  assert(this._handle, 'zlib binding closed');
  return this._handle.reset();
};

// This is the _flush function called by the transform class,
// internally, when the last chunk has been written.
Zlib.prototype._flush = function (callback) {
  this._transform(Buffer.alloc(0), '', callback);
};

Zlib.prototype.flush = function (kind, callback) {
  var _this2 = this;

  var ws = this._writableState;

  if (typeof kind === 'function' || kind === undefined && !callback) {
    callback = kind;
    kind = binding.Z_FULL_FLUSH;
  }

  if (ws.ended) {
    if (callback) process.nextTick(callback);
  } else if (ws.ending) {
    if (callback) this.once('end', callback);
  } else if (ws.needDrain) {
    if (callback) {
      this.once('drain', function () {
        return _this2.flush(kind, callback);
      });
    }
  } else {
    this._flushFlag = kind;
    this.write(Buffer.alloc(0), '', callback);
  }
};

Zlib.prototype.close = function (callback) {
  _close(this, callback);
  process.nextTick(emitCloseNT, this);
};

function _close(engine, callback) {
  if (callback) process.nextTick(callback);

  // Caller may invoke .close after a zlib error (which will null _handle).
  if (!engine._handle) return;

  engine._handle.close();
  engine._handle = null;
}

function emitCloseNT(self) {
  self.emit('close');
}

Zlib.prototype._transform = function (chunk, encoding, cb) {
  var flushFlag;
  var ws = this._writableState;
  var ending = ws.ending || ws.ended;
  var last = ending && (!chunk || ws.length === chunk.length);

  if (chunk !== null && !Buffer.isBuffer(chunk)) return cb(new Error('invalid input'));

  if (!this._handle) return cb(new Error('zlib binding closed'));

  // If it's the last chunk, or a final flush, we use the Z_FINISH flush flag
  // (or whatever flag was provided using opts.finishFlush).
  // If it's explicitly flushing at some other time, then we use
  // Z_FULL_FLUSH. Otherwise, use Z_NO_FLUSH for maximum compression
  // goodness.
  if (last) flushFlag = this._finishFlushFlag;else {
    flushFlag = this._flushFlag;
    // once we've flushed the last of the queue, stop flushing and
    // go back to the normal behavior.
    if (chunk.length >= ws.length) {
      this._flushFlag = this._opts.flush || binding.Z_NO_FLUSH;
    }
  }

  this._processChunk(chunk, flushFlag, cb);
};

Zlib.prototype._processChunk = function (chunk, flushFlag, cb) {
  var availInBefore = chunk && chunk.length;
  var availOutBefore = this._chunkSize - this._offset;
  var inOff = 0;

  var self = this;

  var async = typeof cb === 'function';

  if (!async) {
    var buffers = [];
    var nread = 0;

    var error;
    this.on('error', function (er) {
      error = er;
    });

    assert(this._handle, 'zlib binding closed');
    do {
      var res = this._handle.writeSync(flushFlag, chunk, // in
      inOff, // in_off
      availInBefore, // in_len
      this._buffer, // out
      this._offset, //out_off
      availOutBefore); // out_len
    } while (!this._hadError && callback(res[0], res[1]));

    if (this._hadError) {
      throw error;
    }

    if (nread >= kMaxLength) {
      _close(this);
      throw new RangeError(kRangeErrorMessage);
    }

    var buf = Buffer.concat(buffers, nread);
    _close(this);

    return buf;
  }

  assert(this._handle, 'zlib binding closed');
  var req = this._handle.write(flushFlag, chunk, // in
  inOff, // in_off
  availInBefore, // in_len
  this._buffer, // out
  this._offset, //out_off
  availOutBefore); // out_len

  req.buffer = chunk;
  req.callback = callback;

  function callback(availInAfter, availOutAfter) {
    // When the callback is used in an async write, the callback's
    // context is the `req` object that was created. The req object
    // is === this._handle, and that's why it's important to null
    // out the values after they are done being used. `this._handle`
    // can stay in memory longer than the callback and buffer are needed.
    if (this) {
      this.buffer = null;
      this.callback = null;
    }

    if (self._hadError) return;

    var have = availOutBefore - availOutAfter;
    assert(have >= 0, 'have should not go down');

    if (have > 0) {
      var out = self._buffer.slice(self._offset, self._offset + have);
      self._offset += have;
      // serve some output to the consumer.
      if (async) {
        self.push(out);
      } else {
        buffers.push(out);
        nread += out.length;
      }
    }

    // exhausted the output buffer, or used all the input create a new one.
    if (availOutAfter === 0 || self._offset >= self._chunkSize) {
      availOutBefore = self._chunkSize;
      self._offset = 0;
      self._buffer = Buffer.allocUnsafe(self._chunkSize);
    }

    if (availOutAfter === 0) {
      // Not actually done.  Need to reprocess.
      // Also, update the availInBefore to the availInAfter value,
      // so that if we have to hit it a third (fourth, etc.) time,
      // it'll have the correct byte counts.
      inOff += availInBefore - availInAfter;
      availInBefore = availInAfter;

      if (!async) return true;

      var newReq = self._handle.write(flushFlag, chunk, inOff, availInBefore, self._buffer, self._offset, self._chunkSize);
      newReq.callback = callback; // this same function
      newReq.buffer = chunk;
      return;
    }

    if (!async) return false;

    // finished with the chunk.
    cb();
  }
};

util.inherits(Deflate, Zlib);
util.inherits(Inflate, Zlib);
util.inherits(Gzip, Zlib);
util.inherits(Gunzip, Zlib);
util.inherits(DeflateRaw, Zlib);
util.inherits(InflateRaw, Zlib);
util.inherits(Unzip, Zlib);
}).call(this,require('_process'))

},{"./binding":51,"_process":74,"assert":45,"buffer":53,"stream":289,"util":294}],53:[function(require,module,exports){
(function (Buffer){
/*!
 * The buffer module from node.js, for the browser.
 *
 * @author   Feross Aboukhadijeh <https://feross.org>
 * @license  MIT
 */
/* eslint-disable no-proto */

'use strict'

var base64 = require('base64-js')
var ieee754 = require('ieee754')
var customInspectSymbol =
  (typeof Symbol === 'function' && typeof Symbol.for === 'function')
    ? Symbol.for('nodejs.util.inspect.custom')
    : null

exports.Buffer = Buffer
exports.SlowBuffer = SlowBuffer
exports.INSPECT_MAX_BYTES = 50

var K_MAX_LENGTH = 0x7fffffff
exports.kMaxLength = K_MAX_LENGTH

/**
 * If `Buffer.TYPED_ARRAY_SUPPORT`:
 *   === true    Use Uint8Array implementation (fastest)
 *   === false   Print warning and recommend using `buffer` v4.x which has an Object
 *               implementation (most compatible, even IE6)
 *
 * Browsers that support typed arrays are IE 10+, Firefox 4+, Chrome 7+, Safari 5.1+,
 * Opera 11.6+, iOS 4.2+.
 *
 * We report that the browser does not support typed arrays if the are not subclassable
 * using __proto__. Firefox 4-29 lacks support for adding new properties to `Uint8Array`
 * (See: https://bugzilla.mozilla.org/show_bug.cgi?id=695438). IE 10 lacks support
 * for __proto__ and has a buggy typed array implementation.
 */
Buffer.TYPED_ARRAY_SUPPORT = typedArraySupport()

if (!Buffer.TYPED_ARRAY_SUPPORT && typeof console !== 'undefined' &&
    typeof console.error === 'function') {
  console.error(
    'This browser lacks typed array (Uint8Array) support which is required by ' +
    '`buffer` v5.x. Use `buffer` v4.x if you require old browser support.'
  )
}

function typedArraySupport () {
  // Can typed array instances can be augmented?
  try {
    var arr = new Uint8Array(1)
    var proto = { foo: function () { return 42 } }
    Object.setPrototypeOf(proto, Uint8Array.prototype)
    Object.setPrototypeOf(arr, proto)
    return arr.foo() === 42
  } catch (e) {
    return false
  }
}

Object.defineProperty(Buffer.prototype, 'parent', {
  enumerable: true,
  get: function () {
    if (!Buffer.isBuffer(this)) return undefined
    return this.buffer
  }
})

Object.defineProperty(Buffer.prototype, 'offset', {
  enumerable: true,
  get: function () {
    if (!Buffer.isBuffer(this)) return undefined
    return this.byteOffset
  }
})

function createBuffer (length) {
  if (length > K_MAX_LENGTH) {
    throw new RangeError('The value "' + length + '" is invalid for option "size"')
  }
  // Return an augmented `Uint8Array` instance
  var buf = new Uint8Array(length)
  Object.setPrototypeOf(buf, Buffer.prototype)
  return buf
}

/**
 * The Buffer constructor returns instances of `Uint8Array` that have their
 * prototype changed to `Buffer.prototype`. Furthermore, `Buffer` is a subclass of
 * `Uint8Array`, so the returned instances will have all the node `Buffer` methods
 * and the `Uint8Array` methods. Square bracket notation works as expected -- it
 * returns a single octet.
 *
 * The `Uint8Array` prototype remains unmodified.
 */

function Buffer (arg, encodingOrOffset, length) {
  // Common case.
  if (typeof arg === 'number') {
    if (typeof encodingOrOffset === 'string') {
      throw new TypeError(
        'The "string" argument must be of type string. Received type number'
      )
    }
    return allocUnsafe(arg)
  }
  return from(arg, encodingOrOffset, length)
}

// Fix subarray() in ES2016. See: https://github.com/feross/buffer/pull/97
if (typeof Symbol !== 'undefined' && Symbol.species != null &&
    Buffer[Symbol.species] === Buffer) {
  Object.defineProperty(Buffer, Symbol.species, {
    value: null,
    configurable: true,
    enumerable: false,
    writable: false
  })
}

Buffer.poolSize = 8192 // not used by this implementation

function from (value, encodingOrOffset, length) {
  if (typeof value === 'string') {
    return fromString(value, encodingOrOffset)
  }

  if (ArrayBuffer.isView(value)) {
    return fromArrayLike(value)
  }

  if (value == null) {
    throw new TypeError(
      'The first argument must be one of type string, Buffer, ArrayBuffer, Array, ' +
      'or Array-like Object. Received type ' + (typeof value)
    )
  }

  if (isInstance(value, ArrayBuffer) ||
      (value && isInstance(value.buffer, ArrayBuffer))) {
    return fromArrayBuffer(value, encodingOrOffset, length)
  }

  if (typeof value === 'number') {
    throw new TypeError(
      'The "value" argument must not be of type number. Received type number'
    )
  }

  var valueOf = value.valueOf && value.valueOf()
  if (valueOf != null && valueOf !== value) {
    return Buffer.from(valueOf, encodingOrOffset, length)
  }

  var b = fromObject(value)
  if (b) return b

  if (typeof Symbol !== 'undefined' && Symbol.toPrimitive != null &&
      typeof value[Symbol.toPrimitive] === 'function') {
    return Buffer.from(
      value[Symbol.toPrimitive]('string'), encodingOrOffset, length
    )
  }

  throw new TypeError(
    'The first argument must be one of type string, Buffer, ArrayBuffer, Array, ' +
    'or Array-like Object. Received type ' + (typeof value)
  )
}

/**
 * Functionally equivalent to Buffer(arg, encoding) but throws a TypeError
 * if value is a number.
 * Buffer.from(str[, encoding])
 * Buffer.from(array)
 * Buffer.from(buffer)
 * Buffer.from(arrayBuffer[, byteOffset[, length]])
 **/
Buffer.from = function (value, encodingOrOffset, length) {
  return from(value, encodingOrOffset, length)
}

// Note: Change prototype *after* Buffer.from is defined to workaround Chrome bug:
// https://github.com/feross/buffer/pull/148
Object.setPrototypeOf(Buffer.prototype, Uint8Array.prototype)
Object.setPrototypeOf(Buffer, Uint8Array)

function assertSize (size) {
  if (typeof size !== 'number') {
    throw new TypeError('"size" argument must be of type number')
  } else if (size < 0) {
    throw new RangeError('The value "' + size + '" is invalid for option "size"')
  }
}

function alloc (size, fill, encoding) {
  assertSize(size)
  if (size <= 0) {
    return createBuffer(size)
  }
  if (fill !== undefined) {
    // Only pay attention to encoding if it's a string. This
    // prevents accidentally sending in a number that would
    // be interpretted as a start offset.
    return typeof encoding === 'string'
      ? createBuffer(size).fill(fill, encoding)
      : createBuffer(size).fill(fill)
  }
  return createBuffer(size)
}

/**
 * Creates a new filled Buffer instance.
 * alloc(size[, fill[, encoding]])
 **/
Buffer.alloc = function (size, fill, encoding) {
  return alloc(size, fill, encoding)
}

function allocUnsafe (size) {
  assertSize(size)
  return createBuffer(size < 0 ? 0 : checked(size) | 0)
}

/**
 * Equivalent to Buffer(num), by default creates a non-zero-filled Buffer instance.
 * */
Buffer.allocUnsafe = function (size) {
  return allocUnsafe(size)
}
/**
 * Equivalent to SlowBuffer(num), by default creates a non-zero-filled Buffer instance.
 */
Buffer.allocUnsafeSlow = function (size) {
  return allocUnsafe(size)
}

function fromString (string, encoding) {
  if (typeof encoding !== 'string' || encoding === '') {
    encoding = 'utf8'
  }

  if (!Buffer.isEncoding(encoding)) {
    throw new TypeError('Unknown encoding: ' + encoding)
  }

  var length = byteLength(string, encoding) | 0
  var buf = createBuffer(length)

  var actual = buf.write(string, encoding)

  if (actual !== length) {
    // Writing a hex string, for example, that contains invalid characters will
    // cause everything after the first invalid character to be ignored. (e.g.
    // 'abxxcd' will be treated as 'ab')
    buf = buf.slice(0, actual)
  }

  return buf
}

function fromArrayLike (array) {
  var length = array.length < 0 ? 0 : checked(array.length) | 0
  var buf = createBuffer(length)
  for (var i = 0; i < length; i += 1) {
    buf[i] = array[i] & 255
  }
  return buf
}

function fromArrayBuffer (array, byteOffset, length) {
  if (byteOffset < 0 || array.byteLength < byteOffset) {
    throw new RangeError('"offset" is outside of buffer bounds')
  }

  if (array.byteLength < byteOffset + (length || 0)) {
    throw new RangeError('"length" is outside of buffer bounds')
  }

  var buf
  if (byteOffset === undefined && length === undefined) {
    buf = new Uint8Array(array)
  } else if (length === undefined) {
    buf = new Uint8Array(array, byteOffset)
  } else {
    buf = new Uint8Array(array, byteOffset, length)
  }

  // Return an augmented `Uint8Array` instance
  Object.setPrototypeOf(buf, Buffer.prototype)

  return buf
}

function fromObject (obj) {
  if (Buffer.isBuffer(obj)) {
    var len = checked(obj.length) | 0
    var buf = createBuffer(len)

    if (buf.length === 0) {
      return buf
    }

    obj.copy(buf, 0, 0, len)
    return buf
  }

  if (obj.length !== undefined) {
    if (typeof obj.length !== 'number' || numberIsNaN(obj.length)) {
      return createBuffer(0)
    }
    return fromArrayLike(obj)
  }

  if (obj.type === 'Buffer' && Array.isArray(obj.data)) {
    return fromArrayLike(obj.data)
  }
}

function checked (length) {
  // Note: cannot use `length < K_MAX_LENGTH` here because that fails when
  // length is NaN (which is otherwise coerced to zero.)
  if (length >= K_MAX_LENGTH) {
    throw new RangeError('Attempt to allocate Buffer larger than maximum ' +
                         'size: 0x' + K_MAX_LENGTH.toString(16) + ' bytes')
  }
  return length | 0
}

function SlowBuffer (length) {
  if (+length != length) { // eslint-disable-line eqeqeq
    length = 0
  }
  return Buffer.alloc(+length)
}

Buffer.isBuffer = function isBuffer (b) {
  return b != null && b._isBuffer === true &&
    b !== Buffer.prototype // so Buffer.isBuffer(Buffer.prototype) will be false
}

Buffer.compare = function compare (a, b) {
  if (isInstance(a, Uint8Array)) a = Buffer.from(a, a.offset, a.byteLength)
  if (isInstance(b, Uint8Array)) b = Buffer.from(b, b.offset, b.byteLength)
  if (!Buffer.isBuffer(a) || !Buffer.isBuffer(b)) {
    throw new TypeError(
      'The "buf1", "buf2" arguments must be one of type Buffer or Uint8Array'
    )
  }

  if (a === b) return 0

  var x = a.length
  var y = b.length

  for (var i = 0, len = Math.min(x, y); i < len; ++i) {
    if (a[i] !== b[i]) {
      x = a[i]
      y = b[i]
      break
    }
  }

  if (x < y) return -1
  if (y < x) return 1
  return 0
}

Buffer.isEncoding = function isEncoding (encoding) {
  switch (String(encoding).toLowerCase()) {
    case 'hex':
    case 'utf8':
    case 'utf-8':
    case 'ascii':
    case 'latin1':
    case 'binary':
    case 'base64':
    case 'ucs2':
    case 'ucs-2':
    case 'utf16le':
    case 'utf-16le':
      return true
    default:
      return false
  }
}

Buffer.concat = function concat (list, length) {
  if (!Array.isArray(list)) {
    throw new TypeError('"list" argument must be an Array of Buffers')
  }

  if (list.length === 0) {
    return Buffer.alloc(0)
  }

  var i
  if (length === undefined) {
    length = 0
    for (i = 0; i < list.length; ++i) {
      length += list[i].length
    }
  }

  var buffer = Buffer.allocUnsafe(length)
  var pos = 0
  for (i = 0; i < list.length; ++i) {
    var buf = list[i]
    if (isInstance(buf, Uint8Array)) {
      buf = Buffer.from(buf)
    }
    if (!Buffer.isBuffer(buf)) {
      throw new TypeError('"list" argument must be an Array of Buffers')
    }
    buf.copy(buffer, pos)
    pos += buf.length
  }
  return buffer
}

function byteLength (string, encoding) {
  if (Buffer.isBuffer(string)) {
    return string.length
  }
  if (ArrayBuffer.isView(string) || isInstance(string, ArrayBuffer)) {
    return string.byteLength
  }
  if (typeof string !== 'string') {
    throw new TypeError(
      'The "string" argument must be one of type string, Buffer, or ArrayBuffer. ' +
      'Received type ' + typeof string
    )
  }

  var len = string.length
  var mustMatch = (arguments.length > 2 && arguments[2] === true)
  if (!mustMatch && len === 0) return 0

  // Use a for loop to avoid recursion
  var loweredCase = false
  for (;;) {
    switch (encoding) {
      case 'ascii':
      case 'latin1':
      case 'binary':
        return len
      case 'utf8':
      case 'utf-8':
        return utf8ToBytes(string).length
      case 'ucs2':
      case 'ucs-2':
      case 'utf16le':
      case 'utf-16le':
        return len * 2
      case 'hex':
        return len >>> 1
      case 'base64':
        return base64ToBytes(string).length
      default:
        if (loweredCase) {
          return mustMatch ? -1 : utf8ToBytes(string).length // assume utf8
        }
        encoding = ('' + encoding).toLowerCase()
        loweredCase = true
    }
  }
}
Buffer.byteLength = byteLength

function slowToString (encoding, start, end) {
  var loweredCase = false

  // No need to verify that "this.length <= MAX_UINT32" since it's a read-only
  // property of a typed array.

  // This behaves neither like String nor Uint8Array in that we set start/end
  // to their upper/lower bounds if the value passed is out of range.
  // undefined is handled specially as per ECMA-262 6th Edition,
  // Section 13.3.3.7 Runtime Semantics: KeyedBindingInitialization.
  if (start === undefined || start < 0) {
    start = 0
  }
  // Return early if start > this.length. Done here to prevent potential uint32
  // coercion fail below.
  if (start > this.length) {
    return ''
  }

  if (end === undefined || end > this.length) {
    end = this.length
  }

  if (end <= 0) {
    return ''
  }

  // Force coersion to uint32. This will also coerce falsey/NaN values to 0.
  end >>>= 0
  start >>>= 0

  if (end <= start) {
    return ''
  }

  if (!encoding) encoding = 'utf8'

  while (true) {
    switch (encoding) {
      case 'hex':
        return hexSlice(this, start, end)

      case 'utf8':
      case 'utf-8':
        return utf8Slice(this, start, end)

      case 'ascii':
        return asciiSlice(this, start, end)

      case 'latin1':
      case 'binary':
        return latin1Slice(this, start, end)

      case 'base64':
        return base64Slice(this, start, end)

      case 'ucs2':
      case 'ucs-2':
      case 'utf16le':
      case 'utf-16le':
        return utf16leSlice(this, start, end)

      default:
        if (loweredCase) throw new TypeError('Unknown encoding: ' + encoding)
        encoding = (encoding + '').toLowerCase()
        loweredCase = true
    }
  }
}

// This property is used by `Buffer.isBuffer` (and the `is-buffer` npm package)
// to detect a Buffer instance. It's not possible to use `instanceof Buffer`
// reliably in a browserify context because there could be multiple different
// copies of the 'buffer' package in use. This method works even for Buffer
// instances that were created from another copy of the `buffer` package.
// See: https://github.com/feross/buffer/issues/154
Buffer.prototype._isBuffer = true

function swap (b, n, m) {
  var i = b[n]
  b[n] = b[m]
  b[m] = i
}

Buffer.prototype.swap16 = function swap16 () {
  var len = this.length
  if (len % 2 !== 0) {
    throw new RangeError('Buffer size must be a multiple of 16-bits')
  }
  for (var i = 0; i < len; i += 2) {
    swap(this, i, i + 1)
  }
  return this
}

Buffer.prototype.swap32 = function swap32 () {
  var len = this.length
  if (len % 4 !== 0) {
    throw new RangeError('Buffer size must be a multiple of 32-bits')
  }
  for (var i = 0; i < len; i += 4) {
    swap(this, i, i + 3)
    swap(this, i + 1, i + 2)
  }
  return this
}

Buffer.prototype.swap64 = function swap64 () {
  var len = this.length
  if (len % 8 !== 0) {
    throw new RangeError('Buffer size must be a multiple of 64-bits')
  }
  for (var i = 0; i < len; i += 8) {
    swap(this, i, i + 7)
    swap(this, i + 1, i + 6)
    swap(this, i + 2, i + 5)
    swap(this, i + 3, i + 4)
  }
  return this
}

Buffer.prototype.toString = function toString () {
  var length = this.length
  if (length === 0) return ''
  if (arguments.length === 0) return utf8Slice(this, 0, length)
  return slowToString.apply(this, arguments)
}

Buffer.prototype.toLocaleString = Buffer.prototype.toString

Buffer.prototype.equals = function equals (b) {
  if (!Buffer.isBuffer(b)) throw new TypeError('Argument must be a Buffer')
  if (this === b) return true
  return Buffer.compare(this, b) === 0
}

Buffer.prototype.inspect = function inspect () {
  var str = ''
  var max = exports.INSPECT_MAX_BYTES
  str = this.toString('hex', 0, max).replace(/(.{2})/g, '$1 ').trim()
  if (this.length > max) str += ' ... '
  return '<Buffer ' + str + '>'
}
if (customInspectSymbol) {
  Buffer.prototype[customInspectSymbol] = Buffer.prototype.inspect
}

Buffer.prototype.compare = function compare (target, start, end, thisStart, thisEnd) {
  if (isInstance(target, Uint8Array)) {
    target = Buffer.from(target, target.offset, target.byteLength)
  }
  if (!Buffer.isBuffer(target)) {
    throw new TypeError(
      'The "target" argument must be one of type Buffer or Uint8Array. ' +
      'Received type ' + (typeof target)
    )
  }

  if (start === undefined) {
    start = 0
  }
  if (end === undefined) {
    end = target ? target.length : 0
  }
  if (thisStart === undefined) {
    thisStart = 0
  }
  if (thisEnd === undefined) {
    thisEnd = this.length
  }

  if (start < 0 || end > target.length || thisStart < 0 || thisEnd > this.length) {
    throw new RangeError('out of range index')
  }

  if (thisStart >= thisEnd && start >= end) {
    return 0
  }
  if (thisStart >= thisEnd) {
    return -1
  }
  if (start >= end) {
    return 1
  }

  start >>>= 0
  end >>>= 0
  thisStart >>>= 0
  thisEnd >>>= 0

  if (this === target) return 0

  var x = thisEnd - thisStart
  var y = end - start
  var len = Math.min(x, y)

  var thisCopy = this.slice(thisStart, thisEnd)
  var targetCopy = target.slice(start, end)

  for (var i = 0; i < len; ++i) {
    if (thisCopy[i] !== targetCopy[i]) {
      x = thisCopy[i]
      y = targetCopy[i]
      break
    }
  }

  if (x < y) return -1
  if (y < x) return 1
  return 0
}

// Finds either the first index of `val` in `buffer` at offset >= `byteOffset`,
// OR the last index of `val` in `buffer` at offset <= `byteOffset`.
//
// Arguments:
// - buffer - a Buffer to search
// - val - a string, Buffer, or number
// - byteOffset - an index into `buffer`; will be clamped to an int32
// - encoding - an optional encoding, relevant is val is a string
// - dir - true for indexOf, false for lastIndexOf
function bidirectionalIndexOf (buffer, val, byteOffset, encoding, dir) {
  // Empty buffer means no match
  if (buffer.length === 0) return -1

  // Normalize byteOffset
  if (typeof byteOffset === 'string') {
    encoding = byteOffset
    byteOffset = 0
  } else if (byteOffset > 0x7fffffff) {
    byteOffset = 0x7fffffff
  } else if (byteOffset < -0x80000000) {
    byteOffset = -0x80000000
  }
  byteOffset = +byteOffset // Coerce to Number.
  if (numberIsNaN(byteOffset)) {
    // byteOffset: it it's undefined, null, NaN, "foo", etc, search whole buffer
    byteOffset = dir ? 0 : (buffer.length - 1)
  }

  // Normalize byteOffset: negative offsets start from the end of the buffer
  if (byteOffset < 0) byteOffset = buffer.length + byteOffset
  if (byteOffset >= buffer.length) {
    if (dir) return -1
    else byteOffset = buffer.length - 1
  } else if (byteOffset < 0) {
    if (dir) byteOffset = 0
    else return -1
  }

  // Normalize val
  if (typeof val === 'string') {
    val = Buffer.from(val, encoding)
  }

  // Finally, search either indexOf (if dir is true) or lastIndexOf
  if (Buffer.isBuffer(val)) {
    // Special case: looking for empty string/buffer always fails
    if (val.length === 0) {
      return -1
    }
    return arrayIndexOf(buffer, val, byteOffset, encoding, dir)
  } else if (typeof val === 'number') {
    val = val & 0xFF // Search for a byte value [0-255]
    if (typeof Uint8Array.prototype.indexOf === 'function') {
      if (dir) {
        return Uint8Array.prototype.indexOf.call(buffer, val, byteOffset)
      } else {
        return Uint8Array.prototype.lastIndexOf.call(buffer, val, byteOffset)
      }
    }
    return arrayIndexOf(buffer, [val], byteOffset, encoding, dir)
  }

  throw new TypeError('val must be string, number or Buffer')
}

function arrayIndexOf (arr, val, byteOffset, encoding, dir) {
  var indexSize = 1
  var arrLength = arr.length
  var valLength = val.length

  if (encoding !== undefined) {
    encoding = String(encoding).toLowerCase()
    if (encoding === 'ucs2' || encoding === 'ucs-2' ||
        encoding === 'utf16le' || encoding === 'utf-16le') {
      if (arr.length < 2 || val.length < 2) {
        return -1
      }
      indexSize = 2
      arrLength /= 2
      valLength /= 2
      byteOffset /= 2
    }
  }

  function read (buf, i) {
    if (indexSize === 1) {
      return buf[i]
    } else {
      return buf.readUInt16BE(i * indexSize)
    }
  }

  var i
  if (dir) {
    var foundIndex = -1
    for (i = byteOffset; i < arrLength; i++) {
      if (read(arr, i) === read(val, foundIndex === -1 ? 0 : i - foundIndex)) {
        if (foundIndex === -1) foundIndex = i
        if (i - foundIndex + 1 === valLength) return foundIndex * indexSize
      } else {
        if (foundIndex !== -1) i -= i - foundIndex
        foundIndex = -1
      }
    }
  } else {
    if (byteOffset + valLength > arrLength) byteOffset = arrLength - valLength
    for (i = byteOffset; i >= 0; i--) {
      var found = true
      for (var j = 0; j < valLength; j++) {
        if (read(arr, i + j) !== read(val, j)) {
          found = false
          break
        }
      }
      if (found) return i
    }
  }

  return -1
}

Buffer.prototype.includes = function includes (val, byteOffset, encoding) {
  return this.indexOf(val, byteOffset, encoding) !== -1
}

Buffer.prototype.indexOf = function indexOf (val, byteOffset, encoding) {
  return bidirectionalIndexOf(this, val, byteOffset, encoding, true)
}

Buffer.prototype.lastIndexOf = function lastIndexOf (val, byteOffset, encoding) {
  return bidirectionalIndexOf(this, val, byteOffset, encoding, false)
}

function hexWrite (buf, string, offset, length) {
  offset = Number(offset) || 0
  var remaining = buf.length - offset
  if (!length) {
    length = remaining
  } else {
    length = Number(length)
    if (length > remaining) {
      length = remaining
    }
  }

  var strLen = string.length

  if (length > strLen / 2) {
    length = strLen / 2
  }
  for (var i = 0; i < length; ++i) {
    var parsed = parseInt(string.substr(i * 2, 2), 16)
    if (numberIsNaN(parsed)) return i
    buf[offset + i] = parsed
  }
  return i
}

function utf8Write (buf, string, offset, length) {
  return blitBuffer(utf8ToBytes(string, buf.length - offset), buf, offset, length)
}

function asciiWrite (buf, string, offset, length) {
  return blitBuffer(asciiToBytes(string), buf, offset, length)
}

function latin1Write (buf, string, offset, length) {
  return asciiWrite(buf, string, offset, length)
}

function base64Write (buf, string, offset, length) {
  return blitBuffer(base64ToBytes(string), buf, offset, length)
}

function ucs2Write (buf, string, offset, length) {
  return blitBuffer(utf16leToBytes(string, buf.length - offset), buf, offset, length)
}

Buffer.prototype.write = function write (string, offset, length, encoding) {
  // Buffer#write(string)
  if (offset === undefined) {
    encoding = 'utf8'
    length = this.length
    offset = 0
  // Buffer#write(string, encoding)
  } else if (length === undefined && typeof offset === 'string') {
    encoding = offset
    length = this.length
    offset = 0
  // Buffer#write(string, offset[, length][, encoding])
  } else if (isFinite(offset)) {
    offset = offset >>> 0
    if (isFinite(length)) {
      length = length >>> 0
      if (encoding === undefined) encoding = 'utf8'
    } else {
      encoding = length
      length = undefined
    }
  } else {
    throw new Error(
      'Buffer.write(string, encoding, offset[, length]) is no longer supported'
    )
  }

  var remaining = this.length - offset
  if (length === undefined || length > remaining) length = remaining

  if ((string.length > 0 && (length < 0 || offset < 0)) || offset > this.length) {
    throw new RangeError('Attempt to write outside buffer bounds')
  }

  if (!encoding) encoding = 'utf8'

  var loweredCase = false
  for (;;) {
    switch (encoding) {
      case 'hex':
        return hexWrite(this, string, offset, length)

      case 'utf8':
      case 'utf-8':
        return utf8Write(this, string, offset, length)

      case 'ascii':
        return asciiWrite(this, string, offset, length)

      case 'latin1':
      case 'binary':
        return latin1Write(this, string, offset, length)

      case 'base64':
        // Warning: maxLength not taken into account in base64Write
        return base64Write(this, string, offset, length)

      case 'ucs2':
      case 'ucs-2':
      case 'utf16le':
      case 'utf-16le':
        return ucs2Write(this, string, offset, length)

      default:
        if (loweredCase) throw new TypeError('Unknown encoding: ' + encoding)
        encoding = ('' + encoding).toLowerCase()
        loweredCase = true
    }
  }
}

Buffer.prototype.toJSON = function toJSON () {
  return {
    type: 'Buffer',
    data: Array.prototype.slice.call(this._arr || this, 0)
  }
}

function base64Slice (buf, start, end) {
  if (start === 0 && end === buf.length) {
    return base64.fromByteArray(buf)
  } else {
    return base64.fromByteArray(buf.slice(start, end))
  }
}

function utf8Slice (buf, start, end) {
  end = Math.min(buf.length, end)
  var res = []

  var i = start
  while (i < end) {
    var firstByte = buf[i]
    var codePoint = null
    var bytesPerSequence = (firstByte > 0xEF) ? 4
      : (firstByte > 0xDF) ? 3
        : (firstByte > 0xBF) ? 2
          : 1

    if (i + bytesPerSequence <= end) {
      var secondByte, thirdByte, fourthByte, tempCodePoint

      switch (bytesPerSequence) {
        case 1:
          if (firstByte < 0x80) {
            codePoint = firstByte
          }
          break
        case 2:
          secondByte = buf[i + 1]
          if ((secondByte & 0xC0) === 0x80) {
            tempCodePoint = (firstByte & 0x1F) << 0x6 | (secondByte & 0x3F)
            if (tempCodePoint > 0x7F) {
              codePoint = tempCodePoint
            }
          }
          break
        case 3:
          secondByte = buf[i + 1]
          thirdByte = buf[i + 2]
          if ((secondByte & 0xC0) === 0x80 && (thirdByte & 0xC0) === 0x80) {
            tempCodePoint = (firstByte & 0xF) << 0xC | (secondByte & 0x3F) << 0x6 | (thirdByte & 0x3F)
            if (tempCodePoint > 0x7FF && (tempCodePoint < 0xD800 || tempCodePoint > 0xDFFF)) {
              codePoint = tempCodePoint
            }
          }
          break
        case 4:
          secondByte = buf[i + 1]
          thirdByte = buf[i + 2]
          fourthByte = buf[i + 3]
          if ((secondByte & 0xC0) === 0x80 && (thirdByte & 0xC0) === 0x80 && (fourthByte & 0xC0) === 0x80) {
            tempCodePoint = (firstByte & 0xF) << 0x12 | (secondByte & 0x3F) << 0xC | (thirdByte & 0x3F) << 0x6 | (fourthByte & 0x3F)
            if (tempCodePoint > 0xFFFF && tempCodePoint < 0x110000) {
              codePoint = tempCodePoint
            }
          }
      }
    }

    if (codePoint === null) {
      // we did not generate a valid codePoint so insert a
      // replacement char (U+FFFD) and advance only 1 byte
      codePoint = 0xFFFD
      bytesPerSequence = 1
    } else if (codePoint > 0xFFFF) {
      // encode to utf16 (surrogate pair dance)
      codePoint -= 0x10000
      res.push(codePoint >>> 10 & 0x3FF | 0xD800)
      codePoint = 0xDC00 | codePoint & 0x3FF
    }

    res.push(codePoint)
    i += bytesPerSequence
  }

  return decodeCodePointsArray(res)
}

// Based on http://stackoverflow.com/a/22747272/680742, the browser with
// the lowest limit is Chrome, with 0x10000 args.
// We go 1 magnitude less, for safety
var MAX_ARGUMENTS_LENGTH = 0x1000

function decodeCodePointsArray (codePoints) {
  var len = codePoints.length
  if (len <= MAX_ARGUMENTS_LENGTH) {
    return String.fromCharCode.apply(String, codePoints) // avoid extra slice()
  }

  // Decode in chunks to avoid "call stack size exceeded".
  var res = ''
  var i = 0
  while (i < len) {
    res += String.fromCharCode.apply(
      String,
      codePoints.slice(i, i += MAX_ARGUMENTS_LENGTH)
    )
  }
  return res
}

function asciiSlice (buf, start, end) {
  var ret = ''
  end = Math.min(buf.length, end)

  for (var i = start; i < end; ++i) {
    ret += String.fromCharCode(buf[i] & 0x7F)
  }
  return ret
}

function latin1Slice (buf, start, end) {
  var ret = ''
  end = Math.min(buf.length, end)

  for (var i = start; i < end; ++i) {
    ret += String.fromCharCode(buf[i])
  }
  return ret
}

function hexSlice (buf, start, end) {
  var len = buf.length

  if (!start || start < 0) start = 0
  if (!end || end < 0 || end > len) end = len

  var out = ''
  for (var i = start; i < end; ++i) {
    out += toHex(buf[i])
  }
  return out
}

function utf16leSlice (buf, start, end) {
  var bytes = buf.slice(start, end)
  var res = ''
  for (var i = 0; i < bytes.length; i += 2) {
    res += String.fromCharCode(bytes[i] + (bytes[i + 1] * 256))
  }
  return res
}

Buffer.prototype.slice = function slice (start, end) {
  var len = this.length
  start = ~~start
  end = end === undefined ? len : ~~end

  if (start < 0) {
    start += len
    if (start < 0) start = 0
  } else if (start > len) {
    start = len
  }

  if (end < 0) {
    end += len
    if (end < 0) end = 0
  } else if (end > len) {
    end = len
  }

  if (end < start) end = start

  var newBuf = this.subarray(start, end)
  // Return an augmented `Uint8Array` instance
  Object.setPrototypeOf(newBuf, Buffer.prototype)

  return newBuf
}

/*
 * Need to make sure that buffer isn't trying to write out of bounds.
 */
function checkOffset (offset, ext, length) {
  if ((offset % 1) !== 0 || offset < 0) throw new RangeError('offset is not uint')
  if (offset + ext > length) throw new RangeError('Trying to access beyond buffer length')
}

Buffer.prototype.readUIntLE = function readUIntLE (offset, byteLength, noAssert) {
  offset = offset >>> 0
  byteLength = byteLength >>> 0
  if (!noAssert) checkOffset(offset, byteLength, this.length)

  var val = this[offset]
  var mul = 1
  var i = 0
  while (++i < byteLength && (mul *= 0x100)) {
    val += this[offset + i] * mul
  }

  return val
}

Buffer.prototype.readUIntBE = function readUIntBE (offset, byteLength, noAssert) {
  offset = offset >>> 0
  byteLength = byteLength >>> 0
  if (!noAssert) {
    checkOffset(offset, byteLength, this.length)
  }

  var val = this[offset + --byteLength]
  var mul = 1
  while (byteLength > 0 && (mul *= 0x100)) {
    val += this[offset + --byteLength] * mul
  }

  return val
}

Buffer.prototype.readUInt8 = function readUInt8 (offset, noAssert) {
  offset = offset >>> 0
  if (!noAssert) checkOffset(offset, 1, this.length)
  return this[offset]
}

Buffer.prototype.readUInt16LE = function readUInt16LE (offset, noAssert) {
  offset = offset >>> 0
  if (!noAssert) checkOffset(offset, 2, this.length)
  return this[offset] | (this[offset + 1] << 8)
}

Buffer.prototype.readUInt16BE = function readUInt16BE (offset, noAssert) {
  offset = offset >>> 0
  if (!noAssert) checkOffset(offset, 2, this.length)
  return (this[offset] << 8) | this[offset + 1]
}

Buffer.prototype.readUInt32LE = function readUInt32LE (offset, noAssert) {
  offset = offset >>> 0
  if (!noAssert) checkOffset(offset, 4, this.length)

  return ((this[offset]) |
      (this[offset + 1] << 8) |
      (this[offset + 2] << 16)) +
      (this[offset + 3] * 0x1000000)
}

Buffer.prototype.readUInt32BE = function readUInt32BE (offset, noAssert) {
  offset = offset >>> 0
  if (!noAssert) checkOffset(offset, 4, this.length)

  return (this[offset] * 0x1000000) +
    ((this[offset + 1] << 16) |
    (this[offset + 2] << 8) |
    this[offset + 3])
}

Buffer.prototype.readIntLE = function readIntLE (offset, byteLength, noAssert) {
  offset = offset >>> 0
  byteLength = byteLength >>> 0
  if (!noAssert) checkOffset(offset, byteLength, this.length)

  var val = this[offset]
  var mul = 1
  var i = 0
  while (++i < byteLength && (mul *= 0x100)) {
    val += this[offset + i] * mul
  }
  mul *= 0x80

  if (val >= mul) val -= Math.pow(2, 8 * byteLength)

  return val
}

Buffer.prototype.readIntBE = function readIntBE (offset, byteLength, noAssert) {
  offset = offset >>> 0
  byteLength = byteLength >>> 0
  if (!noAssert) checkOffset(offset, byteLength, this.length)

  var i = byteLength
  var mul = 1
  var val = this[offset + --i]
  while (i > 0 && (mul *= 0x100)) {
    val += this[offset + --i] * mul
  }
  mul *= 0x80

  if (val >= mul) val -= Math.pow(2, 8 * byteLength)

  return val
}

Buffer.prototype.readInt8 = function readInt8 (offset, noAssert) {
  offset = offset >>> 0
  if (!noAssert) checkOffset(offset, 1, this.length)
  if (!(this[offset] & 0x80)) return (this[offset])
  return ((0xff - this[offset] + 1) * -1)
}

Buffer.prototype.readInt16LE = function readInt16LE (offset, noAssert) {
  offset = offset >>> 0
  if (!noAssert) checkOffset(offset, 2, this.length)
  var val = this[offset] | (this[offset + 1] << 8)
  return (val & 0x8000) ? val | 0xFFFF0000 : val
}

Buffer.prototype.readInt16BE = function readInt16BE (offset, noAssert) {
  offset = offset >>> 0
  if (!noAssert) checkOffset(offset, 2, this.length)
  var val = this[offset + 1] | (this[offset] << 8)
  return (val & 0x8000) ? val | 0xFFFF0000 : val
}

Buffer.prototype.readInt32LE = function readInt32LE (offset, noAssert) {
  offset = offset >>> 0
  if (!noAssert) checkOffset(offset, 4, this.length)

  return (this[offset]) |
    (this[offset + 1] << 8) |
    (this[offset + 2] << 16) |
    (this[offset + 3] << 24)
}

Buffer.prototype.readInt32BE = function readInt32BE (offset, noAssert) {
  offset = offset >>> 0
  if (!noAssert) checkOffset(offset, 4, this.length)

  return (this[offset] << 24) |
    (this[offset + 1] << 16) |
    (this[offset + 2] << 8) |
    (this[offset + 3])
}

Buffer.prototype.readFloatLE = function readFloatLE (offset, noAssert) {
  offset = offset >>> 0
  if (!noAssert) checkOffset(offset, 4, this.length)
  return ieee754.read(this, offset, true, 23, 4)
}

Buffer.prototype.readFloatBE = function readFloatBE (offset, noAssert) {
  offset = offset >>> 0
  if (!noAssert) checkOffset(offset, 4, this.length)
  return ieee754.read(this, offset, false, 23, 4)
}

Buffer.prototype.readDoubleLE = function readDoubleLE (offset, noAssert) {
  offset = offset >>> 0
  if (!noAssert) checkOffset(offset, 8, this.length)
  return ieee754.read(this, offset, true, 52, 8)
}

Buffer.prototype.readDoubleBE = function readDoubleBE (offset, noAssert) {
  offset = offset >>> 0
  if (!noAssert) checkOffset(offset, 8, this.length)
  return ieee754.read(this, offset, false, 52, 8)
}

function checkInt (buf, value, offset, ext, max, min) {
  if (!Buffer.isBuffer(buf)) throw new TypeError('"buffer" argument must be a Buffer instance')
  if (value > max || value < min) throw new RangeError('"value" argument is out of bounds')
  if (offset + ext > buf.length) throw new RangeError('Index out of range')
}

Buffer.prototype.writeUIntLE = function writeUIntLE (value, offset, byteLength, noAssert) {
  value = +value
  offset = offset >>> 0
  byteLength = byteLength >>> 0
  if (!noAssert) {
    var maxBytes = Math.pow(2, 8 * byteLength) - 1
    checkInt(this, value, offset, byteLength, maxBytes, 0)
  }

  var mul = 1
  var i = 0
  this[offset] = value & 0xFF
  while (++i < byteLength && (mul *= 0x100)) {
    this[offset + i] = (value / mul) & 0xFF
  }

  return offset + byteLength
}

Buffer.prototype.writeUIntBE = function writeUIntBE (value, offset, byteLength, noAssert) {
  value = +value
  offset = offset >>> 0
  byteLength = byteLength >>> 0
  if (!noAssert) {
    var maxBytes = Math.pow(2, 8 * byteLength) - 1
    checkInt(this, value, offset, byteLength, maxBytes, 0)
  }

  var i = byteLength - 1
  var mul = 1
  this[offset + i] = value & 0xFF
  while (--i >= 0 && (mul *= 0x100)) {
    this[offset + i] = (value / mul) & 0xFF
  }

  return offset + byteLength
}

Buffer.prototype.writeUInt8 = function writeUInt8 (value, offset, noAssert) {
  value = +value
  offset = offset >>> 0
  if (!noAssert) checkInt(this, value, offset, 1, 0xff, 0)
  this[offset] = (value & 0xff)
  return offset + 1
}

Buffer.prototype.writeUInt16LE = function writeUInt16LE (value, offset, noAssert) {
  value = +value
  offset = offset >>> 0
  if (!noAssert) checkInt(this, value, offset, 2, 0xffff, 0)
  this[offset] = (value & 0xff)
  this[offset + 1] = (value >>> 8)
  return offset + 2
}

Buffer.prototype.writeUInt16BE = function writeUInt16BE (value, offset, noAssert) {
  value = +value
  offset = offset >>> 0
  if (!noAssert) checkInt(this, value, offset, 2, 0xffff, 0)
  this[offset] = (value >>> 8)
  this[offset + 1] = (value & 0xff)
  return offset + 2
}

Buffer.prototype.writeUInt32LE = function writeUInt32LE (value, offset, noAssert) {
  value = +value
  offset = offset >>> 0
  if (!noAssert) checkInt(this, value, offset, 4, 0xffffffff, 0)
  this[offset + 3] = (value >>> 24)
  this[offset + 2] = (value >>> 16)
  this[offset + 1] = (value >>> 8)
  this[offset] = (value & 0xff)
  return offset + 4
}

Buffer.prototype.writeUInt32BE = function writeUInt32BE (value, offset, noAssert) {
  value = +value
  offset = offset >>> 0
  if (!noAssert) checkInt(this, value, offset, 4, 0xffffffff, 0)
  this[offset] = (value >>> 24)
  this[offset + 1] = (value >>> 16)
  this[offset + 2] = (value >>> 8)
  this[offset + 3] = (value & 0xff)
  return offset + 4
}

Buffer.prototype.writeIntLE = function writeIntLE (value, offset, byteLength, noAssert) {
  value = +value
  offset = offset >>> 0
  if (!noAssert) {
    var limit = Math.pow(2, (8 * byteLength) - 1)

    checkInt(this, value, offset, byteLength, limit - 1, -limit)
  }

  var i = 0
  var mul = 1
  var sub = 0
  this[offset] = value & 0xFF
  while (++i < byteLength && (mul *= 0x100)) {
    if (value < 0 && sub === 0 && this[offset + i - 1] !== 0) {
      sub = 1
    }
    this[offset + i] = ((value / mul) >> 0) - sub & 0xFF
  }

  return offset + byteLength
}

Buffer.prototype.writeIntBE = function writeIntBE (value, offset, byteLength, noAssert) {
  value = +value
  offset = offset >>> 0
  if (!noAssert) {
    var limit = Math.pow(2, (8 * byteLength) - 1)

    checkInt(this, value, offset, byteLength, limit - 1, -limit)
  }

  var i = byteLength - 1
  var mul = 1
  var sub = 0
  this[offset + i] = value & 0xFF
  while (--i >= 0 && (mul *= 0x100)) {
    if (value < 0 && sub === 0 && this[offset + i + 1] !== 0) {
      sub = 1
    }
    this[offset + i] = ((value / mul) >> 0) - sub & 0xFF
  }

  return offset + byteLength
}

Buffer.prototype.writeInt8 = function writeInt8 (value, offset, noAssert) {
  value = +value
  offset = offset >>> 0
  if (!noAssert) checkInt(this, value, offset, 1, 0x7f, -0x80)
  if (value < 0) value = 0xff + value + 1
  this[offset] = (value & 0xff)
  return offset + 1
}

Buffer.prototype.writeInt16LE = function writeInt16LE (value, offset, noAssert) {
  value = +value
  offset = offset >>> 0
  if (!noAssert) checkInt(this, value, offset, 2, 0x7fff, -0x8000)
  this[offset] = (value & 0xff)
  this[offset + 1] = (value >>> 8)
  return offset + 2
}

Buffer.prototype.writeInt16BE = function writeInt16BE (value, offset, noAssert) {
  value = +value
  offset = offset >>> 0
  if (!noAssert) checkInt(this, value, offset, 2, 0x7fff, -0x8000)
  this[offset] = (value >>> 8)
  this[offset + 1] = (value & 0xff)
  return offset + 2
}

Buffer.prototype.writeInt32LE = function writeInt32LE (value, offset, noAssert) {
  value = +value
  offset = offset >>> 0
  if (!noAssert) checkInt(this, value, offset, 4, 0x7fffffff, -0x80000000)
  this[offset] = (value & 0xff)
  this[offset + 1] = (value >>> 8)
  this[offset + 2] = (value >>> 16)
  this[offset + 3] = (value >>> 24)
  return offset + 4
}

Buffer.prototype.writeInt32BE = function writeInt32BE (value, offset, noAssert) {
  value = +value
  offset = offset >>> 0
  if (!noAssert) checkInt(this, value, offset, 4, 0x7fffffff, -0x80000000)
  if (value < 0) value = 0xffffffff + value + 1
  this[offset] = (value >>> 24)
  this[offset + 1] = (value >>> 16)
  this[offset + 2] = (value >>> 8)
  this[offset + 3] = (value & 0xff)
  return offset + 4
}

function checkIEEE754 (buf, value, offset, ext, max, min) {
  if (offset + ext > buf.length) throw new RangeError('Index out of range')
  if (offset < 0) throw new RangeError('Index out of range')
}

function writeFloat (buf, value, offset, littleEndian, noAssert) {
  value = +value
  offset = offset >>> 0
  if (!noAssert) {
    checkIEEE754(buf, value, offset, 4, 3.4028234663852886e+38, -3.4028234663852886e+38)
  }
  ieee754.write(buf, value, offset, littleEndian, 23, 4)
  return offset + 4
}

Buffer.prototype.writeFloatLE = function writeFloatLE (value, offset, noAssert) {
  return writeFloat(this, value, offset, true, noAssert)
}

Buffer.prototype.writeFloatBE = function writeFloatBE (value, offset, noAssert) {
  return writeFloat(this, value, offset, false, noAssert)
}

function writeDouble (buf, value, offset, littleEndian, noAssert) {
  value = +value
  offset = offset >>> 0
  if (!noAssert) {
    checkIEEE754(buf, value, offset, 8, 1.7976931348623157E+308, -1.7976931348623157E+308)
  }
  ieee754.write(buf, value, offset, littleEndian, 52, 8)
  return offset + 8
}

Buffer.prototype.writeDoubleLE = function writeDoubleLE (value, offset, noAssert) {
  return writeDouble(this, value, offset, true, noAssert)
}

Buffer.prototype.writeDoubleBE = function writeDoubleBE (value, offset, noAssert) {
  return writeDouble(this, value, offset, false, noAssert)
}

// copy(targetBuffer, targetStart=0, sourceStart=0, sourceEnd=buffer.length)
Buffer.prototype.copy = function copy (target, targetStart, start, end) {
  if (!Buffer.isBuffer(target)) throw new TypeError('argument should be a Buffer')
  if (!start) start = 0
  if (!end && end !== 0) end = this.length
  if (targetStart >= target.length) targetStart = target.length
  if (!targetStart) targetStart = 0
  if (end > 0 && end < start) end = start

  // Copy 0 bytes; we're done
  if (end === start) return 0
  if (target.length === 0 || this.length === 0) return 0

  // Fatal error conditions
  if (targetStart < 0) {
    throw new RangeError('targetStart out of bounds')
  }
  if (start < 0 || start >= this.length) throw new RangeError('Index out of range')
  if (end < 0) throw new RangeError('sourceEnd out of bounds')

  // Are we oob?
  if (end > this.length) end = this.length
  if (target.length - targetStart < end - start) {
    end = target.length - targetStart + start
  }

  var len = end - start

  if (this === target && typeof Uint8Array.prototype.copyWithin === 'function') {
    // Use built-in when available, missing from IE11
    this.copyWithin(targetStart, start, end)
  } else if (this === target && start < targetStart && targetStart < end) {
    // descending copy from end
    for (var i = len - 1; i >= 0; --i) {
      target[i + targetStart] = this[i + start]
    }
  } else {
    Uint8Array.prototype.set.call(
      target,
      this.subarray(start, end),
      targetStart
    )
  }

  return len
}

// Usage:
//    buffer.fill(number[, offset[, end]])
//    buffer.fill(buffer[, offset[, end]])
//    buffer.fill(string[, offset[, end]][, encoding])
Buffer.prototype.fill = function fill (val, start, end, encoding) {
  // Handle string cases:
  if (typeof val === 'string') {
    if (typeof start === 'string') {
      encoding = start
      start = 0
      end = this.length
    } else if (typeof end === 'string') {
      encoding = end
      end = this.length
    }
    if (encoding !== undefined && typeof encoding !== 'string') {
      throw new TypeError('encoding must be a string')
    }
    if (typeof encoding === 'string' && !Buffer.isEncoding(encoding)) {
      throw new TypeError('Unknown encoding: ' + encoding)
    }
    if (val.length === 1) {
      var code = val.charCodeAt(0)
      if ((encoding === 'utf8' && code < 128) ||
          encoding === 'latin1') {
        // Fast path: If `val` fits into a single byte, use that numeric value.
        val = code
      }
    }
  } else if (typeof val === 'number') {
    val = val & 255
  } else if (typeof val === 'boolean') {
    val = Number(val)
  }

  // Invalid ranges are not set to a default, so can range check early.
  if (start < 0 || this.length < start || this.length < end) {
    throw new RangeError('Out of range index')
  }

  if (end <= start) {
    return this
  }

  start = start >>> 0
  end = end === undefined ? this.length : end >>> 0

  if (!val) val = 0

  var i
  if (typeof val === 'number') {
    for (i = start; i < end; ++i) {
      this[i] = val
    }
  } else {
    var bytes = Buffer.isBuffer(val)
      ? val
      : Buffer.from(val, encoding)
    var len = bytes.length
    if (len === 0) {
      throw new TypeError('The value "' + val +
        '" is invalid for argument "value"')
    }
    for (i = 0; i < end - start; ++i) {
      this[i + start] = bytes[i % len]
    }
  }

  return this
}

// HELPER FUNCTIONS
// ================

var INVALID_BASE64_RE = /[^+/0-9A-Za-z-_]/g

function base64clean (str) {
  // Node takes equal signs as end of the Base64 encoding
  str = str.split('=')[0]
  // Node strips out invalid characters like \n and \t from the string, base64-js does not
  str = str.trim().replace(INVALID_BASE64_RE, '')
  // Node converts strings with length < 2 to ''
  if (str.length < 2) return ''
  // Node allows for non-padded base64 strings (missing trailing ===), base64-js does not
  while (str.length % 4 !== 0) {
    str = str + '='
  }
  return str
}

function toHex (n) {
  if (n < 16) return '0' + n.toString(16)
  return n.toString(16)
}

function utf8ToBytes (string, units) {
  units = units || Infinity
  var codePoint
  var length = string.length
  var leadSurrogate = null
  var bytes = []

  for (var i = 0; i < length; ++i) {
    codePoint = string.charCodeAt(i)

    // is surrogate component
    if (codePoint > 0xD7FF && codePoint < 0xE000) {
      // last char was a lead
      if (!leadSurrogate) {
        // no lead yet
        if (codePoint > 0xDBFF) {
          // unexpected trail
          if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD)
          continue
        } else if (i + 1 === length) {
          // unpaired lead
          if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD)
          continue
        }

        // valid lead
        leadSurrogate = codePoint

        continue
      }

      // 2 leads in a row
      if (codePoint < 0xDC00) {
        if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD)
        leadSurrogate = codePoint
        continue
      }

      // valid surrogate pair
      codePoint = (leadSurrogate - 0xD800 << 10 | codePoint - 0xDC00) + 0x10000
    } else if (leadSurrogate) {
      // valid bmp char, but last char was a lead
      if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD)
    }

    leadSurrogate = null

    // encode utf8
    if (codePoint < 0x80) {
      if ((units -= 1) < 0) break
      bytes.push(codePoint)
    } else if (codePoint < 0x800) {
      if ((units -= 2) < 0) break
      bytes.push(
        codePoint >> 0x6 | 0xC0,
        codePoint & 0x3F | 0x80
      )
    } else if (codePoint < 0x10000) {
      if ((units -= 3) < 0) break
      bytes.push(
        codePoint >> 0xC | 0xE0,
        codePoint >> 0x6 & 0x3F | 0x80,
        codePoint & 0x3F | 0x80
      )
    } else if (codePoint < 0x110000) {
      if ((units -= 4) < 0) break
      bytes.push(
        codePoint >> 0x12 | 0xF0,
        codePoint >> 0xC & 0x3F | 0x80,
        codePoint >> 0x6 & 0x3F | 0x80,
        codePoint & 0x3F | 0x80
      )
    } else {
      throw new Error('Invalid code point')
    }
  }

  return bytes
}

function asciiToBytes (str) {
  var byteArray = []
  for (var i = 0; i < str.length; ++i) {
    // Node's code seems to be doing this and not & 0x7F..
    byteArray.push(str.charCodeAt(i) & 0xFF)
  }
  return byteArray
}

function utf16leToBytes (str, units) {
  var c, hi, lo
  var byteArray = []
  for (var i = 0; i < str.length; ++i) {
    if ((units -= 2) < 0) break

    c = str.charCodeAt(i)
    hi = c >> 8
    lo = c % 256
    byteArray.push(lo)
    byteArray.push(hi)
  }

  return byteArray
}

function base64ToBytes (str) {
  return base64.toByteArray(base64clean(str))
}

function blitBuffer (src, dst, offset, length) {
  for (var i = 0; i < length; ++i) {
    if ((i + offset >= dst.length) || (i >= src.length)) break
    dst[i + offset] = src[i]
  }
  return i
}

// ArrayBuffer or Uint8Array objects from other contexts (i.e. iframes) do not pass
// the `instanceof` check but they should be treated as of that type.
// See: https://github.com/feross/buffer/issues/166
function isInstance (obj, type) {
  return obj instanceof type ||
    (obj != null && obj.constructor != null && obj.constructor.name != null &&
      obj.constructor.name === type.name)
}
function numberIsNaN (obj) {
  // For IE11 support
  return obj !== obj // eslint-disable-line no-self-compare
}

}).call(this,require("buffer").Buffer)

},{"base64-js":49,"buffer":53,"ieee754":57}],54:[function(require,module,exports){
(function (Buffer){
// Copyright Joyent, Inc. and other Node contributors.
//
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to permit
// persons to whom the Software is furnished to do so, subject to the
// following conditions:
//
// The above copyright notice and this permission notice shall be included
// in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
// USE OR OTHER DEALINGS IN THE SOFTWARE.

// NOTE: These type checking functions intentionally don't use `instanceof`
// because it is fragile and can be easily faked with `Object.create()`.

function isArray(arg) {
  if (Array.isArray) {
    return Array.isArray(arg);
  }
  return objectToString(arg) === '[object Array]';
}
exports.isArray = isArray;

function isBoolean(arg) {
  return typeof arg === 'boolean';
}
exports.isBoolean = isBoolean;

function isNull(arg) {
  return arg === null;
}
exports.isNull = isNull;

function isNullOrUndefined(arg) {
  return arg == null;
}
exports.isNullOrUndefined = isNullOrUndefined;

function isNumber(arg) {
  return typeof arg === 'number';
}
exports.isNumber = isNumber;

function isString(arg) {
  return typeof arg === 'string';
}
exports.isString = isString;

function isSymbol(arg) {
  return typeof arg === 'symbol';
}
exports.isSymbol = isSymbol;

function isUndefined(arg) {
  return arg === void 0;
}
exports.isUndefined = isUndefined;

function isRegExp(re) {
  return objectToString(re) === '[object RegExp]';
}
exports.isRegExp = isRegExp;

function isObject(arg) {
  return typeof arg === 'object' && arg !== null;
}
exports.isObject = isObject;

function isDate(d) {
  return objectToString(d) === '[object Date]';
}
exports.isDate = isDate;

function isError(e) {
  return (objectToString(e) === '[object Error]' || e instanceof Error);
}
exports.isError = isError;

function isFunction(arg) {
  return typeof arg === 'function';
}
exports.isFunction = isFunction;

function isPrimitive(arg) {
  return arg === null ||
         typeof arg === 'boolean' ||
         typeof arg === 'number' ||
         typeof arg === 'string' ||
         typeof arg === 'symbol' ||  // ES6 symbol
         typeof arg === 'undefined';
}
exports.isPrimitive = isPrimitive;

exports.isBuffer = Buffer.isBuffer;

function objectToString(o) {
  return Object.prototype.toString.call(o);
}

}).call(this,{"isBuffer":require("../../is-buffer/index.js")})

},{"../../is-buffer/index.js":59}],55:[function(require,module,exports){
// Copyright Joyent, Inc. and other Node contributors.
//
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to permit
// persons to whom the Software is furnished to do so, subject to the
// following conditions:
//
// The above copyright notice and this permission notice shall be included
// in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
// USE OR OTHER DEALINGS IN THE SOFTWARE.

var objectCreate = Object.create || objectCreatePolyfill
var objectKeys = Object.keys || objectKeysPolyfill
var bind = Function.prototype.bind || functionBindPolyfill

function EventEmitter() {
  if (!this._events || !Object.prototype.hasOwnProperty.call(this, '_events')) {
    this._events = objectCreate(null);
    this._eventsCount = 0;
  }

  this._maxListeners = this._maxListeners || undefined;
}
module.exports = EventEmitter;

// Backwards-compat with node 0.10.x
EventEmitter.EventEmitter = EventEmitter;

EventEmitter.prototype._events = undefined;
EventEmitter.prototype._maxListeners = undefined;

// By default EventEmitters will print a warning if more than 10 listeners are
// added to it. This is a useful default which helps finding memory leaks.
var defaultMaxListeners = 10;

var hasDefineProperty;
try {
  var o = {};
  if (Object.defineProperty) Object.defineProperty(o, 'x', { value: 0 });
  hasDefineProperty = o.x === 0;
} catch (err) { hasDefineProperty = false }
if (hasDefineProperty) {
  Object.defineProperty(EventEmitter, 'defaultMaxListeners', {
    enumerable: true,
    get: function() {
      return defaultMaxListeners;
    },
    set: function(arg) {
      // check whether the input is a positive number (whose value is zero or
      // greater and not a NaN).
      if (typeof arg !== 'number' || arg < 0 || arg !== arg)
        throw new TypeError('"defaultMaxListeners" must be a positive number');
      defaultMaxListeners = arg;
    }
  });
} else {
  EventEmitter.defaultMaxListeners = defaultMaxListeners;
}

// Obviously not all Emitters should be limited to 10. This function allows
// that to be increased. Set to zero for unlimited.
EventEmitter.prototype.setMaxListeners = function setMaxListeners(n) {
  if (typeof n !== 'number' || n < 0 || isNaN(n))
    throw new TypeError('"n" argument must be a positive number');
  this._maxListeners = n;
  return this;
};

function $getMaxListeners(that) {
  if (that._maxListeners === undefined)
    return EventEmitter.defaultMaxListeners;
  return that._maxListeners;
}

EventEmitter.prototype.getMaxListeners = function getMaxListeners() {
  return $getMaxListeners(this);
};

// These standalone emit* functions are used to optimize calling of event
// handlers for fast cases because emit() itself often has a variable number of
// arguments and can be deoptimized because of that. These functions always have
// the same number of arguments and thus do not get deoptimized, so the code
// inside them can execute faster.
function emitNone(handler, isFn, self) {
  if (isFn)
    handler.call(self);
  else {
    var len = handler.length;
    var listeners = arrayClone(handler, len);
    for (var i = 0; i < len; ++i)
      listeners[i].call(self);
  }
}
function emitOne(handler, isFn, self, arg1) {
  if (isFn)
    handler.call(self, arg1);
  else {
    var len = handler.length;
    var listeners = arrayClone(handler, len);
    for (var i = 0; i < len; ++i)
      listeners[i].call(self, arg1);
  }
}
function emitTwo(handler, isFn, self, arg1, arg2) {
  if (isFn)
    handler.call(self, arg1, arg2);
  else {
    var len = handler.length;
    var listeners = arrayClone(handler, len);
    for (var i = 0; i < len; ++i)
      listeners[i].call(self, arg1, arg2);
  }
}
function emitThree(handler, isFn, self, arg1, arg2, arg3) {
  if (isFn)
    handler.call(self, arg1, arg2, arg3);
  else {
    var len = handler.length;
    var listeners = arrayClone(handler, len);
    for (var i = 0; i < len; ++i)
      listeners[i].call(self, arg1, arg2, arg3);
  }
}

function emitMany(handler, isFn, self, args) {
  if (isFn)
    handler.apply(self, args);
  else {
    var len = handler.length;
    var listeners = arrayClone(handler, len);
    for (var i = 0; i < len; ++i)
      listeners[i].apply(self, args);
  }
}

EventEmitter.prototype.emit = function emit(type) {
  var er, handler, len, args, i, events;
  var doError = (type === 'error');

  events = this._events;
  if (events)
    doError = (doError && events.error == null);
  else if (!doError)
    return false;

  // If there is no 'error' event listener then throw.
  if (doError) {
    if (arguments.length > 1)
      er = arguments[1];
    if (er instanceof Error) {
      throw er; // Unhandled 'error' event
    } else {
      // At least give some kind of context to the user
      var err = new Error('Unhandled "error" event. (' + er + ')');
      err.context = er;
      throw err;
    }
    return false;
  }

  handler = events[type];

  if (!handler)
    return false;

  var isFn = typeof handler === 'function';
  len = arguments.length;
  switch (len) {
      // fast cases
    case 1:
      emitNone(handler, isFn, this);
      break;
    case 2:
      emitOne(handler, isFn, this, arguments[1]);
      break;
    case 3:
      emitTwo(handler, isFn, this, arguments[1], arguments[2]);
      break;
    case 4:
      emitThree(handler, isFn, this, arguments[1], arguments[2], arguments[3]);
      break;
      // slower
    default:
      args = new Array(len - 1);
      for (i = 1; i < len; i++)
        args[i - 1] = arguments[i];
      emitMany(handler, isFn, this, args);
  }

  return true;
};

function _addListener(target, type, listener, prepend) {
  var m;
  var events;
  var existing;

  if (typeof listener !== 'function')
    throw new TypeError('"listener" argument must be a function');

  events = target._events;
  if (!events) {
    events = target._events = objectCreate(null);
    target._eventsCount = 0;
  } else {
    // To avoid recursion in the case that type === "newListener"! Before
    // adding it to the listeners, first emit "newListener".
    if (events.newListener) {
      target.emit('newListener', type,
          listener.listener ? listener.listener : listener);

      // Re-assign `events` because a newListener handler could have caused the
      // this._events to be assigned to a new object
      events = target._events;
    }
    existing = events[type];
  }

  if (!existing) {
    // Optimize the case of one listener. Don't need the extra array object.
    existing = events[type] = listener;
    ++target._eventsCount;
  } else {
    if (typeof existing === 'function') {
      // Adding the second element, need to change to array.
      existing = events[type] =
          prepend ? [listener, existing] : [existing, listener];
    } else {
      // If we've already got an array, just append.
      if (prepend) {
        existing.unshift(listener);
      } else {
        existing.push(listener);
      }
    }

    // Check for listener leak
    if (!existing.warned) {
      m = $getMaxListeners(target);
      if (m && m > 0 && existing.length > m) {
        existing.warned = true;
        var w = new Error('Possible EventEmitter memory leak detected. ' +
            existing.length + ' "' + String(type) + '" listeners ' +
            'added. Use emitter.setMaxListeners() to ' +
            'increase limit.');
        w.name = 'MaxListenersExceededWarning';
        w.emitter = target;
        w.type = type;
        w.count = existing.length;
        if (typeof console === 'object' && console.warn) {
          console.warn('%s: %s', w.name, w.message);
        }
      }
    }
  }

  return target;
}

EventEmitter.prototype.addListener = function addListener(type, listener) {
  return _addListener(this, type, listener, false);
};

EventEmitter.prototype.on = EventEmitter.prototype.addListener;

EventEmitter.prototype.prependListener =
    function prependListener(type, listener) {
      return _addListener(this, type, listener, true);
    };

function onceWrapper() {
  if (!this.fired) {
    this.target.removeListener(this.type, this.wrapFn);
    this.fired = true;
    switch (arguments.length) {
      case 0:
        return this.listener.call(this.target);
      case 1:
        return this.listener.call(this.target, arguments[0]);
      case 2:
        return this.listener.call(this.target, arguments[0], arguments[1]);
      case 3:
        return this.listener.call(this.target, arguments[0], arguments[1],
            arguments[2]);
      default:
        var args = new Array(arguments.length);
        for (var i = 0; i < args.length; ++i)
          args[i] = arguments[i];
        this.listener.apply(this.target, args);
    }
  }
}

function _onceWrap(target, type, listener) {
  var state = { fired: false, wrapFn: undefined, target: target, type: type, listener: listener };
  var wrapped = bind.call(onceWrapper, state);
  wrapped.listener = listener;
  state.wrapFn = wrapped;
  return wrapped;
}

EventEmitter.prototype.once = function once(type, listener) {
  if (typeof listener !== 'function')
    throw new TypeError('"listener" argument must be a function');
  this.on(type, _onceWrap(this, type, listener));
  return this;
};

EventEmitter.prototype.prependOnceListener =
    function prependOnceListener(type, listener) {
      if (typeof listener !== 'function')
        throw new TypeError('"listener" argument must be a function');
      this.prependListener(type, _onceWrap(this, type, listener));
      return this;
    };

// Emits a 'removeListener' event if and only if the listener was removed.
EventEmitter.prototype.removeListener =
    function removeListener(type, listener) {
      var list, events, position, i, originalListener;

      if (typeof listener !== 'function')
        throw new TypeError('"listener" argument must be a function');

      events = this._events;
      if (!events)
        return this;

      list = events[type];
      if (!list)
        return this;

      if (list === listener || list.listener === listener) {
        if (--this._eventsCount === 0)
          this._events = objectCreate(null);
        else {
          delete events[type];
          if (events.removeListener)
            this.emit('removeListener', type, list.listener || listener);
        }
      } else if (typeof list !== 'function') {
        position = -1;

        for (i = list.length - 1; i >= 0; i--) {
          if (list[i] === listener || list[i].listener === listener) {
            originalListener = list[i].listener;
            position = i;
            break;
          }
        }

        if (position < 0)
          return this;

        if (position === 0)
          list.shift();
        else
          spliceOne(list, position);

        if (list.length === 1)
          events[type] = list[0];

        if (events.removeListener)
          this.emit('removeListener', type, originalListener || listener);
      }

      return this;
    };

EventEmitter.prototype.removeAllListeners =
    function removeAllListeners(type) {
      var listeners, events, i;

      events = this._events;
      if (!events)
        return this;

      // not listening for removeListener, no need to emit
      if (!events.removeListener) {
        if (arguments.length === 0) {
          this._events = objectCreate(null);
          this._eventsCount = 0;
        } else if (events[type]) {
          if (--this._eventsCount === 0)
            this._events = objectCreate(null);
          else
            delete events[type];
        }
        return this;
      }

      // emit removeListener for all listeners on all events
      if (arguments.length === 0) {
        var keys = objectKeys(events);
        var key;
        for (i = 0; i < keys.length; ++i) {
          key = keys[i];
          if (key === 'removeListener') continue;
          this.removeAllListeners(key);
        }
        this.removeAllListeners('removeListener');
        this._events = objectCreate(null);
        this._eventsCount = 0;
        return this;
      }

      listeners = events[type];

      if (typeof listeners === 'function') {
        this.removeListener(type, listeners);
      } else if (listeners) {
        // LIFO order
        for (i = listeners.length - 1; i >= 0; i--) {
          this.removeListener(type, listeners[i]);
        }
      }

      return this;
    };

function _listeners(target, type, unwrap) {
  var events = target._events;

  if (!events)
    return [];

  var evlistener = events[type];
  if (!evlistener)
    return [];

  if (typeof evlistener === 'function')
    return unwrap ? [evlistener.listener || evlistener] : [evlistener];

  return unwrap ? unwrapListeners(evlistener) : arrayClone(evlistener, evlistener.length);
}

EventEmitter.prototype.listeners = function listeners(type) {
  return _listeners(this, type, true);
};

EventEmitter.prototype.rawListeners = function rawListeners(type) {
  return _listeners(this, type, false);
};

EventEmitter.listenerCount = function(emitter, type) {
  if (typeof emitter.listenerCount === 'function') {
    return emitter.listenerCount(type);
  } else {
    return listenerCount.call(emitter, type);
  }
};

EventEmitter.prototype.listenerCount = listenerCount;
function listenerCount(type) {
  var events = this._events;

  if (events) {
    var evlistener = events[type];

    if (typeof evlistener === 'function') {
      return 1;
    } else if (evlistener) {
      return evlistener.length;
    }
  }

  return 0;
}

EventEmitter.prototype.eventNames = function eventNames() {
  return this._eventsCount > 0 ? Reflect.ownKeys(this._events) : [];
};

// About 1.5x faster than the two-arg version of Array#splice().
function spliceOne(list, index) {
  for (var i = index, k = i + 1, n = list.length; k < n; i += 1, k += 1)
    list[i] = list[k];
  list.pop();
}

function arrayClone(arr, n) {
  var copy = new Array(n);
  for (var i = 0; i < n; ++i)
    copy[i] = arr[i];
  return copy;
}

function unwrapListeners(arr) {
  var ret = new Array(arr.length);
  for (var i = 0; i < ret.length; ++i) {
    ret[i] = arr[i].listener || arr[i];
  }
  return ret;
}

function objectCreatePolyfill(proto) {
  var F = function() {};
  F.prototype = proto;
  return new F;
}
function objectKeysPolyfill(obj) {
  var keys = [];
  for (var k in obj) if (Object.prototype.hasOwnProperty.call(obj, k)) {
    keys.push(k);
  }
  return k;
}
function functionBindPolyfill(context) {
  var fn = this;
  return function () {
    return fn.apply(context, arguments);
  };
}

},{}],56:[function(require,module,exports){
'use strict';

module.exports = function (data, opts) {
    if (!opts) opts = {};
    if (typeof opts === 'function') opts = { cmp: opts };
    var cycles = (typeof opts.cycles === 'boolean') ? opts.cycles : false;

    var cmp = opts.cmp && (function (f) {
        return function (node) {
            return function (a, b) {
                var aobj = { key: a, value: node[a] };
                var bobj = { key: b, value: node[b] };
                return f(aobj, bobj);
            };
        };
    })(opts.cmp);

    var seen = [];
    return (function stringify (node) {
        if (node && node.toJSON && typeof node.toJSON === 'function') {
            node = node.toJSON();
        }

        if (node === undefined) return;
        if (typeof node == 'number') return isFinite(node) ? '' + node : 'null';
        if (typeof node !== 'object') return JSON.stringify(node);

        var i, out;
        if (Array.isArray(node)) {
            out = '[';
            for (i = 0; i < node.length; i++) {
                if (i) out += ',';
                out += stringify(node[i]) || 'null';
            }
            return out + ']';
        }

        if (node === null) return 'null';

        if (seen.indexOf(node) !== -1) {
            if (cycles) return JSON.stringify('__cycle__');
            throw new TypeError('Converting circular structure to JSON');
        }

        var seenIndex = seen.push(node) - 1;
        var keys = Object.keys(node).sort(cmp && cmp(node));
        out = '';
        for (i = 0; i < keys.length; i++) {
            var key = keys[i];
            var value = stringify(node[key]);

            if (!value) continue;
            if (out) out += ',';
            out += JSON.stringify(key) + ':' + value;
        }
        seen.splice(seenIndex, 1);
        return '{' + out + '}';
    })(data);
};

},{}],57:[function(require,module,exports){
exports.read = function (buffer, offset, isLE, mLen, nBytes) {
  var e, m
  var eLen = (nBytes * 8) - mLen - 1
  var eMax = (1 << eLen) - 1
  var eBias = eMax >> 1
  var nBits = -7
  var i = isLE ? (nBytes - 1) : 0
  var d = isLE ? -1 : 1
  var s = buffer[offset + i]

  i += d

  e = s & ((1 << (-nBits)) - 1)
  s >>= (-nBits)
  nBits += eLen
  for (; nBits > 0; e = (e * 256) + buffer[offset + i], i += d, nBits -= 8) {}

  m = e & ((1 << (-nBits)) - 1)
  e >>= (-nBits)
  nBits += mLen
  for (; nBits > 0; m = (m * 256) + buffer[offset + i], i += d, nBits -= 8) {}

  if (e === 0) {
    e = 1 - eBias
  } else if (e === eMax) {
    return m ? NaN : ((s ? -1 : 1) * Infinity)
  } else {
    m = m + Math.pow(2, mLen)
    e = e - eBias
  }
  return (s ? -1 : 1) * m * Math.pow(2, e - mLen)
}

exports.write = function (buffer, value, offset, isLE, mLen, nBytes) {
  var e, m, c
  var eLen = (nBytes * 8) - mLen - 1
  var eMax = (1 << eLen) - 1
  var eBias = eMax >> 1
  var rt = (mLen === 23 ? Math.pow(2, -24) - Math.pow(2, -77) : 0)
  var i = isLE ? 0 : (nBytes - 1)
  var d = isLE ? 1 : -1
  var s = value < 0 || (value === 0 && 1 / value < 0) ? 1 : 0

  value = Math.abs(value)

  if (isNaN(value) || value === Infinity) {
    m = isNaN(value) ? 1 : 0
    e = eMax
  } else {
    e = Math.floor(Math.log(value) / Math.LN2)
    if (value * (c = Math.pow(2, -e)) < 1) {
      e--
      c *= 2
    }
    if (e + eBias >= 1) {
      value += rt / c
    } else {
      value += rt * Math.pow(2, 1 - eBias)
    }
    if (value * c >= 2) {
      e++
      c /= 2
    }

    if (e + eBias >= eMax) {
      m = 0
      e = eMax
    } else if (e + eBias >= 1) {
      m = ((value * c) - 1) * Math.pow(2, mLen)
      e = e + eBias
    } else {
      m = value * Math.pow(2, eBias - 1) * Math.pow(2, mLen)
      e = 0
    }
  }

  for (; mLen >= 8; buffer[offset + i] = m & 0xff, i += d, m /= 256, mLen -= 8) {}

  e = (e << mLen) | m
  eLen += mLen
  for (; eLen > 0; buffer[offset + i] = e & 0xff, i += d, e /= 256, eLen -= 8) {}

  buffer[offset + i - d] |= s * 128
}

},{}],58:[function(require,module,exports){
arguments[4][46][0].apply(exports,arguments)
},{"dup":46}],59:[function(require,module,exports){
/*!
 * Determine if an object is a Buffer
 *
 * @author   Feross Aboukhadijeh <https://feross.org>
 * @license  MIT
 */

// The _isBuffer check is for Safari 5-7 support, because it's missing
// Object.prototype.constructor. Remove this eventually
module.exports = function (obj) {
  return obj != null && (isBuffer(obj) || isSlowBuffer(obj) || !!obj._isBuffer)
}

function isBuffer (obj) {
  return !!obj.constructor && typeof obj.constructor.isBuffer === 'function' && obj.constructor.isBuffer(obj)
}

// For Node v0.10 support. Remove this eventually.
function isSlowBuffer (obj) {
  return typeof obj.readFloatLE === 'function' && typeof obj.slice === 'function' && isBuffer(obj.slice(0, 0))
}

},{}],60:[function(require,module,exports){
var toString = {}.toString;

module.exports = Array.isArray || function (arr) {
  return toString.call(arr) == '[object Array]';
};

},{}],61:[function(require,module,exports){
/*
object-assign
(c) Sindre Sorhus
@license MIT
*/

'use strict';
/* eslint-disable no-unused-vars */
var getOwnPropertySymbols = Object.getOwnPropertySymbols;
var hasOwnProperty = Object.prototype.hasOwnProperty;
var propIsEnumerable = Object.prototype.propertyIsEnumerable;

function toObject(val) {
	if (val === null || val === undefined) {
		throw new TypeError('Object.assign cannot be called with null or undefined');
	}

	return Object(val);
}

function shouldUseNative() {
	try {
		if (!Object.assign) {
			return false;
		}

		// Detect buggy property enumeration order in older V8 versions.

		// https://bugs.chromium.org/p/v8/issues/detail?id=4118
		var test1 = new String('abc');  // eslint-disable-line no-new-wrappers
		test1[5] = 'de';
		if (Object.getOwnPropertyNames(test1)[0] === '5') {
			return false;
		}

		// https://bugs.chromium.org/p/v8/issues/detail?id=3056
		var test2 = {};
		for (var i = 0; i < 10; i++) {
			test2['_' + String.fromCharCode(i)] = i;
		}
		var order2 = Object.getOwnPropertyNames(test2).map(function (n) {
			return test2[n];
		});
		if (order2.join('') !== '0123456789') {
			return false;
		}

		// https://bugs.chromium.org/p/v8/issues/detail?id=3056
		var test3 = {};
		'abcdefghijklmnopqrst'.split('').forEach(function (letter) {
			test3[letter] = letter;
		});
		if (Object.keys(Object.assign({}, test3)).join('') !==
				'abcdefghijklmnopqrst') {
			return false;
		}

		return true;
	} catch (err) {
		// We don't expect any of the above to throw, but better to be safe.
		return false;
	}
}

module.exports = shouldUseNative() ? Object.assign : function (target, source) {
	var from;
	var to = toObject(target);
	var symbols;

	for (var s = 1; s < arguments.length; s++) {
		from = Object(arguments[s]);

		for (var key in from) {
			if (hasOwnProperty.call(from, key)) {
				to[key] = from[key];
			}
		}

		if (getOwnPropertySymbols) {
			symbols = getOwnPropertySymbols(from);
			for (var i = 0; i < symbols.length; i++) {
				if (propIsEnumerable.call(from, symbols[i])) {
					to[symbols[i]] = from[symbols[i]];
				}
			}
		}
	}

	return to;
};

},{}],62:[function(require,module,exports){
'use strict';


var TYPED_OK =  (typeof Uint8Array !== 'undefined') &&
                (typeof Uint16Array !== 'undefined') &&
                (typeof Int32Array !== 'undefined');

function _has(obj, key) {
  return Object.prototype.hasOwnProperty.call(obj, key);
}

exports.assign = function (obj /*from1, from2, from3, ...*/) {
  var sources = Array.prototype.slice.call(arguments, 1);
  while (sources.length) {
    var source = sources.shift();
    if (!source) { continue; }

    if (typeof source !== 'object') {
      throw new TypeError(source + 'must be non-object');
    }

    for (var p in source) {
      if (_has(source, p)) {
        obj[p] = source[p];
      }
    }
  }

  return obj;
};


// reduce buffer size, avoiding mem copy
exports.shrinkBuf = function (buf, size) {
  if (buf.length === size) { return buf; }
  if (buf.subarray) { return buf.subarray(0, size); }
  buf.length = size;
  return buf;
};


var fnTyped = {
  arraySet: function (dest, src, src_offs, len, dest_offs) {
    if (src.subarray && dest.subarray) {
      dest.set(src.subarray(src_offs, src_offs + len), dest_offs);
      return;
    }
    // Fallback to ordinary array
    for (var i = 0; i < len; i++) {
      dest[dest_offs + i] = src[src_offs + i];
    }
  },
  // Join array of chunks to single array.
  flattenChunks: function (chunks) {
    var i, l, len, pos, chunk, result;

    // calculate data length
    len = 0;
    for (i = 0, l = chunks.length; i < l; i++) {
      len += chunks[i].length;
    }

    // join chunks
    result = new Uint8Array(len);
    pos = 0;
    for (i = 0, l = chunks.length; i < l; i++) {
      chunk = chunks[i];
      result.set(chunk, pos);
      pos += chunk.length;
    }

    return result;
  }
};

var fnUntyped = {
  arraySet: function (dest, src, src_offs, len, dest_offs) {
    for (var i = 0; i < len; i++) {
      dest[dest_offs + i] = src[src_offs + i];
    }
  },
  // Join array of chunks to single array.
  flattenChunks: function (chunks) {
    return [].concat.apply([], chunks);
  }
};


// Enable/Disable typed arrays use, for testing
//
exports.setTyped = function (on) {
  if (on) {
    exports.Buf8  = Uint8Array;
    exports.Buf16 = Uint16Array;
    exports.Buf32 = Int32Array;
    exports.assign(exports, fnTyped);
  } else {
    exports.Buf8  = Array;
    exports.Buf16 = Array;
    exports.Buf32 = Array;
    exports.assign(exports, fnUntyped);
  }
};

exports.setTyped(TYPED_OK);

},{}],63:[function(require,module,exports){
'use strict';

// Note: adler32 takes 12% for level 0 and 2% for level 6.
// It isn't worth it to make additional optimizations as in original.
// Small size is preferable.

// (C) 1995-2013 Jean-loup Gailly and Mark Adler
// (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
//
// This software is provided 'as-is', without any express or implied
// warranty. In no event will the authors be held liable for any damages
// arising from the use of this software.
//
// Permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions:
//
// 1. The origin of this software must not be misrepresented; you must not
//   claim that you wrote the original software. If you use this software
//   in a product, an acknowledgment in the product documentation would be
//   appreciated but is not required.
// 2. Altered source versions must be plainly marked as such, and must not be
//   misrepresented as being the original software.
// 3. This notice may not be removed or altered from any source distribution.

function adler32(adler, buf, len, pos) {
  var s1 = (adler & 0xffff) |0,
      s2 = ((adler >>> 16) & 0xffff) |0,
      n = 0;

  while (len !== 0) {
    // Set limit ~ twice less than 5552, to keep
    // s2 in 31-bits, because we force signed ints.
    // in other case %= will fail.
    n = len > 2000 ? 2000 : len;
    len -= n;

    do {
      s1 = (s1 + buf[pos++]) |0;
      s2 = (s2 + s1) |0;
    } while (--n);

    s1 %= 65521;
    s2 %= 65521;
  }

  return (s1 | (s2 << 16)) |0;
}


module.exports = adler32;

},{}],64:[function(require,module,exports){
'use strict';

// (C) 1995-2013 Jean-loup Gailly and Mark Adler
// (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
//
// This software is provided 'as-is', without any express or implied
// warranty. In no event will the authors be held liable for any damages
// arising from the use of this software.
//
// Permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions:
//
// 1. The origin of this software must not be misrepresented; you must not
//   claim that you wrote the original software. If you use this software
//   in a product, an acknowledgment in the product documentation would be
//   appreciated but is not required.
// 2. Altered source versions must be plainly marked as such, and must not be
//   misrepresented as being the original software.
// 3. This notice may not be removed or altered from any source distribution.

module.exports = {

  /* Allowed flush values; see deflate() and inflate() below for details */
  Z_NO_FLUSH:         0,
  Z_PARTIAL_FLUSH:    1,
  Z_SYNC_FLUSH:       2,
  Z_FULL_FLUSH:       3,
  Z_FINISH:           4,
  Z_BLOCK:            5,
  Z_TREES:            6,

  /* Return codes for the compression/decompression functions. Negative values
  * are errors, positive values are used for special but normal events.
  */
  Z_OK:               0,
  Z_STREAM_END:       1,
  Z_NEED_DICT:        2,
  Z_ERRNO:           -1,
  Z_STREAM_ERROR:    -2,
  Z_DATA_ERROR:      -3,
  //Z_MEM_ERROR:     -4,
  Z_BUF_ERROR:       -5,
  //Z_VERSION_ERROR: -6,

  /* compression levels */
  Z_NO_COMPRESSION:         0,
  Z_BEST_SPEED:             1,
  Z_BEST_COMPRESSION:       9,
  Z_DEFAULT_COMPRESSION:   -1,


  Z_FILTERED:               1,
  Z_HUFFMAN_ONLY:           2,
  Z_RLE:                    3,
  Z_FIXED:                  4,
  Z_DEFAULT_STRATEGY:       0,

  /* Possible values of the data_type field (though see inflate()) */
  Z_BINARY:                 0,
  Z_TEXT:                   1,
  //Z_ASCII:                1, // = Z_TEXT (deprecated)
  Z_UNKNOWN:                2,

  /* The deflate compression method */
  Z_DEFLATED:               8
  //Z_NULL:                 null // Use -1 or null inline, depending on var type
};

},{}],65:[function(require,module,exports){
'use strict';

// Note: we can't get significant speed boost here.
// So write code to minimize size - no pregenerated tables
// and array tools dependencies.

// (C) 1995-2013 Jean-loup Gailly and Mark Adler
// (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
//
// This software is provided 'as-is', without any express or implied
// warranty. In no event will the authors be held liable for any damages
// arising from the use of this software.
//
// Permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions:
//
// 1. The origin of this software must not be misrepresented; you must not
//   claim that you wrote the original software. If you use this software
//   in a product, an acknowledgment in the product documentation would be
//   appreciated but is not required.
// 2. Altered source versions must be plainly marked as such, and must not be
//   misrepresented as being the original software.
// 3. This notice may not be removed or altered from any source distribution.

// Use ordinary array, since untyped makes no boost here
function makeTable() {
  var c, table = [];

  for (var n = 0; n < 256; n++) {
    c = n;
    for (var k = 0; k < 8; k++) {
      c = ((c & 1) ? (0xEDB88320 ^ (c >>> 1)) : (c >>> 1));
    }
    table[n] = c;
  }

  return table;
}

// Create table on load. Just 255 signed longs. Not a problem.
var crcTable = makeTable();


function crc32(crc, buf, len, pos) {
  var t = crcTable,
      end = pos + len;

  crc ^= -1;

  for (var i = pos; i < end; i++) {
    crc = (crc >>> 8) ^ t[(crc ^ buf[i]) & 0xFF];
  }

  return (crc ^ (-1)); // >>> 0;
}


module.exports = crc32;

},{}],66:[function(require,module,exports){
'use strict';

// (C) 1995-2013 Jean-loup Gailly and Mark Adler
// (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
//
// This software is provided 'as-is', without any express or implied
// warranty. In no event will the authors be held liable for any damages
// arising from the use of this software.
//
// Permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions:
//
// 1. The origin of this software must not be misrepresented; you must not
//   claim that you wrote the original software. If you use this software
//   in a product, an acknowledgment in the product documentation would be
//   appreciated but is not required.
// 2. Altered source versions must be plainly marked as such, and must not be
//   misrepresented as being the original software.
// 3. This notice may not be removed or altered from any source distribution.

var utils   = require('../utils/common');
var trees   = require('./trees');
var adler32 = require('./adler32');
var crc32   = require('./crc32');
var msg     = require('./messages');

/* Public constants ==========================================================*/
/* ===========================================================================*/


/* Allowed flush values; see deflate() and inflate() below for details */
var Z_NO_FLUSH      = 0;
var Z_PARTIAL_FLUSH = 1;
//var Z_SYNC_FLUSH    = 2;
var Z_FULL_FLUSH    = 3;
var Z_FINISH        = 4;
var Z_BLOCK         = 5;
//var Z_TREES         = 6;


/* Return codes for the compression/decompression functions. Negative values
 * are errors, positive values are used for special but normal events.
 */
var Z_OK            = 0;
var Z_STREAM_END    = 1;
//var Z_NEED_DICT     = 2;
//var Z_ERRNO         = -1;
var Z_STREAM_ERROR  = -2;
var Z_DATA_ERROR    = -3;
//var Z_MEM_ERROR     = -4;
var Z_BUF_ERROR     = -5;
//var Z_VERSION_ERROR = -6;


/* compression levels */
//var Z_NO_COMPRESSION      = 0;
//var Z_BEST_SPEED          = 1;
//var Z_BEST_COMPRESSION    = 9;
var Z_DEFAULT_COMPRESSION = -1;


var Z_FILTERED            = 1;
var Z_HUFFMAN_ONLY        = 2;
var Z_RLE                 = 3;
var Z_FIXED               = 4;
var Z_DEFAULT_STRATEGY    = 0;

/* Possible values of the data_type field (though see inflate()) */
//var Z_BINARY              = 0;
//var Z_TEXT                = 1;
//var Z_ASCII               = 1; // = Z_TEXT
var Z_UNKNOWN             = 2;


/* The deflate compression method */
var Z_DEFLATED  = 8;

/*============================================================================*/


var MAX_MEM_LEVEL = 9;
/* Maximum value for memLevel in deflateInit2 */
var MAX_WBITS = 15;
/* 32K LZ77 window */
var DEF_MEM_LEVEL = 8;


var LENGTH_CODES  = 29;
/* number of length codes, not counting the special END_BLOCK code */
var LITERALS      = 256;
/* number of literal bytes 0..255 */
var L_CODES       = LITERALS + 1 + LENGTH_CODES;
/* number of Literal or Length codes, including the END_BLOCK code */
var D_CODES       = 30;
/* number of distance codes */
var BL_CODES      = 19;
/* number of codes used to transfer the bit lengths */
var HEAP_SIZE     = 2 * L_CODES + 1;
/* maximum heap size */
var MAX_BITS  = 15;
/* All codes must not exceed MAX_BITS bits */

var MIN_MATCH = 3;
var MAX_MATCH = 258;
var MIN_LOOKAHEAD = (MAX_MATCH + MIN_MATCH + 1);

var PRESET_DICT = 0x20;

var INIT_STATE = 42;
var EXTRA_STATE = 69;
var NAME_STATE = 73;
var COMMENT_STATE = 91;
var HCRC_STATE = 103;
var BUSY_STATE = 113;
var FINISH_STATE = 666;

var BS_NEED_MORE      = 1; /* block not completed, need more input or more output */
var BS_BLOCK_DONE     = 2; /* block flush performed */
var BS_FINISH_STARTED = 3; /* finish started, need only more output at next deflate */
var BS_FINISH_DONE    = 4; /* finish done, accept no more input or output */

var OS_CODE = 0x03; // Unix :) . Don't detect, use this default.

function err(strm, errorCode) {
  strm.msg = msg[errorCode];
  return errorCode;
}

function rank(f) {
  return ((f) << 1) - ((f) > 4 ? 9 : 0);
}

function zero(buf) { var len = buf.length; while (--len >= 0) { buf[len] = 0; } }


/* =========================================================================
 * Flush as much pending output as possible. All deflate() output goes
 * through this function so some applications may wish to modify it
 * to avoid allocating a large strm->output buffer and copying into it.
 * (See also read_buf()).
 */
function flush_pending(strm) {
  var s = strm.state;

  //_tr_flush_bits(s);
  var len = s.pending;
  if (len > strm.avail_out) {
    len = strm.avail_out;
  }
  if (len === 0) { return; }

  utils.arraySet(strm.output, s.pending_buf, s.pending_out, len, strm.next_out);
  strm.next_out += len;
  s.pending_out += len;
  strm.total_out += len;
  strm.avail_out -= len;
  s.pending -= len;
  if (s.pending === 0) {
    s.pending_out = 0;
  }
}


function flush_block_only(s, last) {
  trees._tr_flush_block(s, (s.block_start >= 0 ? s.block_start : -1), s.strstart - s.block_start, last);
  s.block_start = s.strstart;
  flush_pending(s.strm);
}


function put_byte(s, b) {
  s.pending_buf[s.pending++] = b;
}


/* =========================================================================
 * Put a short in the pending buffer. The 16-bit value is put in MSB order.
 * IN assertion: the stream state is correct and there is enough room in
 * pending_buf.
 */
function putShortMSB(s, b) {
//  put_byte(s, (Byte)(b >> 8));
//  put_byte(s, (Byte)(b & 0xff));
  s.pending_buf[s.pending++] = (b >>> 8) & 0xff;
  s.pending_buf[s.pending++] = b & 0xff;
}


/* ===========================================================================
 * Read a new buffer from the current input stream, update the adler32
 * and total number of bytes read.  All deflate() input goes through
 * this function so some applications may wish to modify it to avoid
 * allocating a large strm->input buffer and copying from it.
 * (See also flush_pending()).
 */
function read_buf(strm, buf, start, size) {
  var len = strm.avail_in;

  if (len > size) { len = size; }
  if (len === 0) { return 0; }

  strm.avail_in -= len;

  // zmemcpy(buf, strm->next_in, len);
  utils.arraySet(buf, strm.input, strm.next_in, len, start);
  if (strm.state.wrap === 1) {
    strm.adler = adler32(strm.adler, buf, len, start);
  }

  else if (strm.state.wrap === 2) {
    strm.adler = crc32(strm.adler, buf, len, start);
  }

  strm.next_in += len;
  strm.total_in += len;

  return len;
}


/* ===========================================================================
 * Set match_start to the longest match starting at the given string and
 * return its length. Matches shorter or equal to prev_length are discarded,
 * in which case the result is equal to prev_length and match_start is
 * garbage.
 * IN assertions: cur_match is the head of the hash chain for the current
 *   string (strstart) and its distance is <= MAX_DIST, and prev_length >= 1
 * OUT assertion: the match length is not greater than s->lookahead.
 */
function longest_match(s, cur_match) {
  var chain_length = s.max_chain_length;      /* max hash chain length */
  var scan = s.strstart; /* current string */
  var match;                       /* matched string */
  var len;                           /* length of current match */
  var best_len = s.prev_length;              /* best match length so far */
  var nice_match = s.nice_match;             /* stop if match long enough */
  var limit = (s.strstart > (s.w_size - MIN_LOOKAHEAD)) ?
      s.strstart - (s.w_size - MIN_LOOKAHEAD) : 0/*NIL*/;

  var _win = s.window; // shortcut

  var wmask = s.w_mask;
  var prev  = s.prev;

  /* Stop when cur_match becomes <= limit. To simplify the code,
   * we prevent matches with the string of window index 0.
   */

  var strend = s.strstart + MAX_MATCH;
  var scan_end1  = _win[scan + best_len - 1];
  var scan_end   = _win[scan + best_len];

  /* The code is optimized for HASH_BITS >= 8 and MAX_MATCH-2 multiple of 16.
   * It is easy to get rid of this optimization if necessary.
   */
  // Assert(s->hash_bits >= 8 && MAX_MATCH == 258, "Code too clever");

  /* Do not waste too much time if we already have a good match: */
  if (s.prev_length >= s.good_match) {
    chain_length >>= 2;
  }
  /* Do not look for matches beyond the end of the input. This is necessary
   * to make deflate deterministic.
   */
  if (nice_match > s.lookahead) { nice_match = s.lookahead; }

  // Assert((ulg)s->strstart <= s->window_size-MIN_LOOKAHEAD, "need lookahead");

  do {
    // Assert(cur_match < s->strstart, "no future");
    match = cur_match;

    /* Skip to next match if the match length cannot increase
     * or if the match length is less than 2.  Note that the checks below
     * for insufficient lookahead only occur occasionally for performance
     * reasons.  Therefore uninitialized memory will be accessed, and
     * conditional jumps will be made that depend on those values.
     * However the length of the match is limited to the lookahead, so
     * the output of deflate is not affected by the uninitialized values.
     */

    if (_win[match + best_len]     !== scan_end  ||
        _win[match + best_len - 1] !== scan_end1 ||
        _win[match]                !== _win[scan] ||
        _win[++match]              !== _win[scan + 1]) {
      continue;
    }

    /* The check at best_len-1 can be removed because it will be made
     * again later. (This heuristic is not always a win.)
     * It is not necessary to compare scan[2] and match[2] since they
     * are always equal when the other bytes match, given that
     * the hash keys are equal and that HASH_BITS >= 8.
     */
    scan += 2;
    match++;
    // Assert(*scan == *match, "match[2]?");

    /* We check for insufficient lookahead only every 8th comparison;
     * the 256th check will be made at strstart+258.
     */
    do {
      /*jshint noempty:false*/
    } while (_win[++scan] === _win[++match] && _win[++scan] === _win[++match] &&
             _win[++scan] === _win[++match] && _win[++scan] === _win[++match] &&
             _win[++scan] === _win[++match] && _win[++scan] === _win[++match] &&
             _win[++scan] === _win[++match] && _win[++scan] === _win[++match] &&
             scan < strend);

    // Assert(scan <= s->window+(unsigned)(s->window_size-1), "wild scan");

    len = MAX_MATCH - (strend - scan);
    scan = strend - MAX_MATCH;

    if (len > best_len) {
      s.match_start = cur_match;
      best_len = len;
      if (len >= nice_match) {
        break;
      }
      scan_end1  = _win[scan + best_len - 1];
      scan_end   = _win[scan + best_len];
    }
  } while ((cur_match = prev[cur_match & wmask]) > limit && --chain_length !== 0);

  if (best_len <= s.lookahead) {
    return best_len;
  }
  return s.lookahead;
}


/* ===========================================================================
 * Fill the window when the lookahead becomes insufficient.
 * Updates strstart and lookahead.
 *
 * IN assertion: lookahead < MIN_LOOKAHEAD
 * OUT assertions: strstart <= window_size-MIN_LOOKAHEAD
 *    At least one byte has been read, or avail_in == 0; reads are
 *    performed for at least two bytes (required for the zip translate_eol
 *    option -- not supported here).
 */
function fill_window(s) {
  var _w_size = s.w_size;
  var p, n, m, more, str;

  //Assert(s->lookahead < MIN_LOOKAHEAD, "already enough lookahead");

  do {
    more = s.window_size - s.lookahead - s.strstart;

    // JS ints have 32 bit, block below not needed
    /* Deal with !@#$% 64K limit: */
    //if (sizeof(int) <= 2) {
    //    if (more == 0 && s->strstart == 0 && s->lookahead == 0) {
    //        more = wsize;
    //
    //  } else if (more == (unsigned)(-1)) {
    //        /* Very unlikely, but possible on 16 bit machine if
    //         * strstart == 0 && lookahead == 1 (input done a byte at time)
    //         */
    //        more--;
    //    }
    //}


    /* If the window is almost full and there is insufficient lookahead,
     * move the upper half to the lower one to make room in the upper half.
     */
    if (s.strstart >= _w_size + (_w_size - MIN_LOOKAHEAD)) {

      utils.arraySet(s.window, s.window, _w_size, _w_size, 0);
      s.match_start -= _w_size;
      s.strstart -= _w_size;
      /* we now have strstart >= MAX_DIST */
      s.block_start -= _w_size;

      /* Slide the hash table (could be avoided with 32 bit values
       at the expense of memory usage). We slide even when level == 0
       to keep the hash table consistent if we switch back to level > 0
       later. (Using level 0 permanently is not an optimal usage of
       zlib, so we don't care about this pathological case.)
       */

      n = s.hash_size;
      p = n;
      do {
        m = s.head[--p];
        s.head[p] = (m >= _w_size ? m - _w_size : 0);
      } while (--n);

      n = _w_size;
      p = n;
      do {
        m = s.prev[--p];
        s.prev[p] = (m >= _w_size ? m - _w_size : 0);
        /* If n is not on any hash chain, prev[n] is garbage but
         * its value will never be used.
         */
      } while (--n);

      more += _w_size;
    }
    if (s.strm.avail_in === 0) {
      break;
    }

    /* If there was no sliding:
     *    strstart <= WSIZE+MAX_DIST-1 && lookahead <= MIN_LOOKAHEAD - 1 &&
     *    more == window_size - lookahead - strstart
     * => more >= window_size - (MIN_LOOKAHEAD-1 + WSIZE + MAX_DIST-1)
     * => more >= window_size - 2*WSIZE + 2
     * In the BIG_MEM or MMAP case (not yet supported),
     *   window_size == input_size + MIN_LOOKAHEAD  &&
     *   strstart + s->lookahead <= input_size => more >= MIN_LOOKAHEAD.
     * Otherwise, window_size == 2*WSIZE so more >= 2.
     * If there was sliding, more >= WSIZE. So in all cases, more >= 2.
     */
    //Assert(more >= 2, "more < 2");
    n = read_buf(s.strm, s.window, s.strstart + s.lookahead, more);
    s.lookahead += n;

    /* Initialize the hash value now that we have some input: */
    if (s.lookahead + s.insert >= MIN_MATCH) {
      str = s.strstart - s.insert;
      s.ins_h = s.window[str];

      /* UPDATE_HASH(s, s->ins_h, s->window[str + 1]); */
      s.ins_h = ((s.ins_h << s.hash_shift) ^ s.window[str + 1]) & s.hash_mask;
//#if MIN_MATCH != 3
//        Call update_hash() MIN_MATCH-3 more times
//#endif
      while (s.insert) {
        /* UPDATE_HASH(s, s->ins_h, s->window[str + MIN_MATCH-1]); */
        s.ins_h = ((s.ins_h << s.hash_shift) ^ s.window[str + MIN_MATCH - 1]) & s.hash_mask;

        s.prev[str & s.w_mask] = s.head[s.ins_h];
        s.head[s.ins_h] = str;
        str++;
        s.insert--;
        if (s.lookahead + s.insert < MIN_MATCH) {
          break;
        }
      }
    }
    /* If the whole input has less than MIN_MATCH bytes, ins_h is garbage,
     * but this is not important since only literal bytes will be emitted.
     */

  } while (s.lookahead < MIN_LOOKAHEAD && s.strm.avail_in !== 0);

  /* If the WIN_INIT bytes after the end of the current data have never been
   * written, then zero those bytes in order to avoid memory check reports of
   * the use of uninitialized (or uninitialised as Julian writes) bytes by
   * the longest match routines.  Update the high water mark for the next
   * time through here.  WIN_INIT is set to MAX_MATCH since the longest match
   * routines allow scanning to strstart + MAX_MATCH, ignoring lookahead.
   */
//  if (s.high_water < s.window_size) {
//    var curr = s.strstart + s.lookahead;
//    var init = 0;
//
//    if (s.high_water < curr) {
//      /* Previous high water mark below current data -- zero WIN_INIT
//       * bytes or up to end of window, whichever is less.
//       */
//      init = s.window_size - curr;
//      if (init > WIN_INIT)
//        init = WIN_INIT;
//      zmemzero(s->window + curr, (unsigned)init);
//      s->high_water = curr + init;
//    }
//    else if (s->high_water < (ulg)curr + WIN_INIT) {
//      /* High water mark at or above current data, but below current data
//       * plus WIN_INIT -- zero out to current data plus WIN_INIT, or up
//       * to end of window, whichever is less.
//       */
//      init = (ulg)curr + WIN_INIT - s->high_water;
//      if (init > s->window_size - s->high_water)
//        init = s->window_size - s->high_water;
//      zmemzero(s->window + s->high_water, (unsigned)init);
//      s->high_water += init;
//    }
//  }
//
//  Assert((ulg)s->strstart <= s->window_size - MIN_LOOKAHEAD,
//    "not enough room for search");
}

/* ===========================================================================
 * Copy without compression as much as possible from the input stream, return
 * the current block state.
 * This function does not insert new strings in the dictionary since
 * uncompressible data is probably not useful. This function is used
 * only for the level=0 compression option.
 * NOTE: this function should be optimized to avoid extra copying from
 * window to pending_buf.
 */
function deflate_stored(s, flush) {
  /* Stored blocks are limited to 0xffff bytes, pending_buf is limited
   * to pending_buf_size, and each stored block has a 5 byte header:
   */
  var max_block_size = 0xffff;

  if (max_block_size > s.pending_buf_size - 5) {
    max_block_size = s.pending_buf_size - 5;
  }

  /* Copy as much as possible from input to output: */
  for (;;) {
    /* Fill the window as much as possible: */
    if (s.lookahead <= 1) {

      //Assert(s->strstart < s->w_size+MAX_DIST(s) ||
      //  s->block_start >= (long)s->w_size, "slide too late");
//      if (!(s.strstart < s.w_size + (s.w_size - MIN_LOOKAHEAD) ||
//        s.block_start >= s.w_size)) {
//        throw  new Error("slide too late");
//      }

      fill_window(s);
      if (s.lookahead === 0 && flush === Z_NO_FLUSH) {
        return BS_NEED_MORE;
      }

      if (s.lookahead === 0) {
        break;
      }
      /* flush the current block */
    }
    //Assert(s->block_start >= 0L, "block gone");
//    if (s.block_start < 0) throw new Error("block gone");

    s.strstart += s.lookahead;
    s.lookahead = 0;

    /* Emit a stored block if pending_buf will be full: */
    var max_start = s.block_start + max_block_size;

    if (s.strstart === 0 || s.strstart >= max_start) {
      /* strstart == 0 is possible when wraparound on 16-bit machine */
      s.lookahead = s.strstart - max_start;
      s.strstart = max_start;
      /*** FLUSH_BLOCK(s, 0); ***/
      flush_block_only(s, false);
      if (s.strm.avail_out === 0) {
        return BS_NEED_MORE;
      }
      /***/


    }
    /* Flush if we may have to slide, otherwise block_start may become
     * negative and the data will be gone:
     */
    if (s.strstart - s.block_start >= (s.w_size - MIN_LOOKAHEAD)) {
      /*** FLUSH_BLOCK(s, 0); ***/
      flush_block_only(s, false);
      if (s.strm.avail_out === 0) {
        return BS_NEED_MORE;
      }
      /***/
    }
  }

  s.insert = 0;

  if (flush === Z_FINISH) {
    /*** FLUSH_BLOCK(s, 1); ***/
    flush_block_only(s, true);
    if (s.strm.avail_out === 0) {
      return BS_FINISH_STARTED;
    }
    /***/
    return BS_FINISH_DONE;
  }

  if (s.strstart > s.block_start) {
    /*** FLUSH_BLOCK(s, 0); ***/
    flush_block_only(s, false);
    if (s.strm.avail_out === 0) {
      return BS_NEED_MORE;
    }
    /***/
  }

  return BS_NEED_MORE;
}

/* ===========================================================================
 * Compress as much as possible from the input stream, return the current
 * block state.
 * This function does not perform lazy evaluation of matches and inserts
 * new strings in the dictionary only for unmatched strings or for short
 * matches. It is used only for the fast compression options.
 */
function deflate_fast(s, flush) {
  var hash_head;        /* head of the hash chain */
  var bflush;           /* set if current block must be flushed */

  for (;;) {
    /* Make sure that we always have enough lookahead, except
     * at the end of the input file. We need MAX_MATCH bytes
     * for the next match, plus MIN_MATCH bytes to insert the
     * string following the next match.
     */
    if (s.lookahead < MIN_LOOKAHEAD) {
      fill_window(s);
      if (s.lookahead < MIN_LOOKAHEAD && flush === Z_NO_FLUSH) {
        return BS_NEED_MORE;
      }
      if (s.lookahead === 0) {
        break; /* flush the current block */
      }
    }

    /* Insert the string window[strstart .. strstart+2] in the
     * dictionary, and set hash_head to the head of the hash chain:
     */
    hash_head = 0/*NIL*/;
    if (s.lookahead >= MIN_MATCH) {
      /*** INSERT_STRING(s, s.strstart, hash_head); ***/
      s.ins_h = ((s.ins_h << s.hash_shift) ^ s.window[s.strstart + MIN_MATCH - 1]) & s.hash_mask;
      hash_head = s.prev[s.strstart & s.w_mask] = s.head[s.ins_h];
      s.head[s.ins_h] = s.strstart;
      /***/
    }

    /* Find the longest match, discarding those <= prev_length.
     * At this point we have always match_length < MIN_MATCH
     */
    if (hash_head !== 0/*NIL*/ && ((s.strstart - hash_head) <= (s.w_size - MIN_LOOKAHEAD))) {
      /* To simplify the code, we prevent matches with the string
       * of window index 0 (in particular we have to avoid a match
       * of the string with itself at the start of the input file).
       */
      s.match_length = longest_match(s, hash_head);
      /* longest_match() sets match_start */
    }
    if (s.match_length >= MIN_MATCH) {
      // check_match(s, s.strstart, s.match_start, s.match_length); // for debug only

      /*** _tr_tally_dist(s, s.strstart - s.match_start,
                     s.match_length - MIN_MATCH, bflush); ***/
      bflush = trees._tr_tally(s, s.strstart - s.match_start, s.match_length - MIN_MATCH);

      s.lookahead -= s.match_length;

      /* Insert new strings in the hash table only if the match length
       * is not too large. This saves time but degrades compression.
       */
      if (s.match_length <= s.max_lazy_match/*max_insert_length*/ && s.lookahead >= MIN_MATCH) {
        s.match_length--; /* string at strstart already in table */
        do {
          s.strstart++;
          /*** INSERT_STRING(s, s.strstart, hash_head); ***/
          s.ins_h = ((s.ins_h << s.hash_shift) ^ s.window[s.strstart + MIN_MATCH - 1]) & s.hash_mask;
          hash_head = s.prev[s.strstart & s.w_mask] = s.head[s.ins_h];
          s.head[s.ins_h] = s.strstart;
          /***/
          /* strstart never exceeds WSIZE-MAX_MATCH, so there are
           * always MIN_MATCH bytes ahead.
           */
        } while (--s.match_length !== 0);
        s.strstart++;
      } else
      {
        s.strstart += s.match_length;
        s.match_length = 0;
        s.ins_h = s.window[s.strstart];
        /* UPDATE_HASH(s, s.ins_h, s.window[s.strstart+1]); */
        s.ins_h = ((s.ins_h << s.hash_shift) ^ s.window[s.strstart + 1]) & s.hash_mask;

//#if MIN_MATCH != 3
//                Call UPDATE_HASH() MIN_MATCH-3 more times
//#endif
        /* If lookahead < MIN_MATCH, ins_h is garbage, but it does not
         * matter since it will be recomputed at next deflate call.
         */
      }
    } else {
      /* No match, output a literal byte */
      //Tracevv((stderr,"%c", s.window[s.strstart]));
      /*** _tr_tally_lit(s, s.window[s.strstart], bflush); ***/
      bflush = trees._tr_tally(s, 0, s.window[s.strstart]);

      s.lookahead--;
      s.strstart++;
    }
    if (bflush) {
      /*** FLUSH_BLOCK(s, 0); ***/
      flush_block_only(s, false);
      if (s.strm.avail_out === 0) {
        return BS_NEED_MORE;
      }
      /***/
    }
  }
  s.insert = ((s.strstart < (MIN_MATCH - 1)) ? s.strstart : MIN_MATCH - 1);
  if (flush === Z_FINISH) {
    /*** FLUSH_BLOCK(s, 1); ***/
    flush_block_only(s, true);
    if (s.strm.avail_out === 0) {
      return BS_FINISH_STARTED;
    }
    /***/
    return BS_FINISH_DONE;
  }
  if (s.last_lit) {
    /*** FLUSH_BLOCK(s, 0); ***/
    flush_block_only(s, false);
    if (s.strm.avail_out === 0) {
      return BS_NEED_MORE;
    }
    /***/
  }
  return BS_BLOCK_DONE;
}

/* ===========================================================================
 * Same as above, but achieves better compression. We use a lazy
 * evaluation for matches: a match is finally adopted only if there is
 * no better match at the next window position.
 */
function deflate_slow(s, flush) {
  var hash_head;          /* head of hash chain */
  var bflush;              /* set if current block must be flushed */

  var max_insert;

  /* Process the input block. */
  for (;;) {
    /* Make sure that we always have enough lookahead, except
     * at the end of the input file. We need MAX_MATCH bytes
     * for the next match, plus MIN_MATCH bytes to insert the
     * string following the next match.
     */
    if (s.lookahead < MIN_LOOKAHEAD) {
      fill_window(s);
      if (s.lookahead < MIN_LOOKAHEAD && flush === Z_NO_FLUSH) {
        return BS_NEED_MORE;
      }
      if (s.lookahead === 0) { break; } /* flush the current block */
    }

    /* Insert the string window[strstart .. strstart+2] in the
     * dictionary, and set hash_head to the head of the hash chain:
     */
    hash_head = 0/*NIL*/;
    if (s.lookahead >= MIN_MATCH) {
      /*** INSERT_STRING(s, s.strstart, hash_head); ***/
      s.ins_h = ((s.ins_h << s.hash_shift) ^ s.window[s.strstart + MIN_MATCH - 1]) & s.hash_mask;
      hash_head = s.prev[s.strstart & s.w_mask] = s.head[s.ins_h];
      s.head[s.ins_h] = s.strstart;
      /***/
    }

    /* Find the longest match, discarding those <= prev_length.
     */
    s.prev_length = s.match_length;
    s.prev_match = s.match_start;
    s.match_length = MIN_MATCH - 1;

    if (hash_head !== 0/*NIL*/ && s.prev_length < s.max_lazy_match &&
        s.strstart - hash_head <= (s.w_size - MIN_LOOKAHEAD)/*MAX_DIST(s)*/) {
      /* To simplify the code, we prevent matches with the string
       * of window index 0 (in particular we have to avoid a match
       * of the string with itself at the start of the input file).
       */
      s.match_length = longest_match(s, hash_head);
      /* longest_match() sets match_start */

      if (s.match_length <= 5 &&
         (s.strategy === Z_FILTERED || (s.match_length === MIN_MATCH && s.strstart - s.match_start > 4096/*TOO_FAR*/))) {

        /* If prev_match is also MIN_MATCH, match_start is garbage
         * but we will ignore the current match anyway.
         */
        s.match_length = MIN_MATCH - 1;
      }
    }
    /* If there was a match at the previous step and the current
     * match is not better, output the previous match:
     */
    if (s.prev_length >= MIN_MATCH && s.match_length <= s.prev_length) {
      max_insert = s.strstart + s.lookahead - MIN_MATCH;
      /* Do not insert strings in hash table beyond this. */

      //check_match(s, s.strstart-1, s.prev_match, s.prev_length);

      /***_tr_tally_dist(s, s.strstart - 1 - s.prev_match,
                     s.prev_length - MIN_MATCH, bflush);***/
      bflush = trees._tr_tally(s, s.strstart - 1 - s.prev_match, s.prev_length - MIN_MATCH);
      /* Insert in hash table all strings up to the end of the match.
       * strstart-1 and strstart are already inserted. If there is not
       * enough lookahead, the last two strings are not inserted in
       * the hash table.
       */
      s.lookahead -= s.prev_length - 1;
      s.prev_length -= 2;
      do {
        if (++s.strstart <= max_insert) {
          /*** INSERT_STRING(s, s.strstart, hash_head); ***/
          s.ins_h = ((s.ins_h << s.hash_shift) ^ s.window[s.strstart + MIN_MATCH - 1]) & s.hash_mask;
          hash_head = s.prev[s.strstart & s.w_mask] = s.head[s.ins_h];
          s.head[s.ins_h] = s.strstart;
          /***/
        }
      } while (--s.prev_length !== 0);
      s.match_available = 0;
      s.match_length = MIN_MATCH - 1;
      s.strstart++;

      if (bflush) {
        /*** FLUSH_BLOCK(s, 0); ***/
        flush_block_only(s, false);
        if (s.strm.avail_out === 0) {
          return BS_NEED_MORE;
        }
        /***/
      }

    } else if (s.match_available) {
      /* If there was no match at the previous position, output a
       * single literal. If there was a match but the current match
       * is longer, truncate the previous match to a single literal.
       */
      //Tracevv((stderr,"%c", s->window[s->strstart-1]));
      /*** _tr_tally_lit(s, s.window[s.strstart-1], bflush); ***/
      bflush = trees._tr_tally(s, 0, s.window[s.strstart - 1]);

      if (bflush) {
        /*** FLUSH_BLOCK_ONLY(s, 0) ***/
        flush_block_only(s, false);
        /***/
      }
      s.strstart++;
      s.lookahead--;
      if (s.strm.avail_out === 0) {
        return BS_NEED_MORE;
      }
    } else {
      /* There is no previous match to compare with, wait for
       * the next step to decide.
       */
      s.match_available = 1;
      s.strstart++;
      s.lookahead--;
    }
  }
  //Assert (flush != Z_NO_FLUSH, "no flush?");
  if (s.match_available) {
    //Tracevv((stderr,"%c", s->window[s->strstart-1]));
    /*** _tr_tally_lit(s, s.window[s.strstart-1], bflush); ***/
    bflush = trees._tr_tally(s, 0, s.window[s.strstart - 1]);

    s.match_available = 0;
  }
  s.insert = s.strstart < MIN_MATCH - 1 ? s.strstart : MIN_MATCH - 1;
  if (flush === Z_FINISH) {
    /*** FLUSH_BLOCK(s, 1); ***/
    flush_block_only(s, true);
    if (s.strm.avail_out === 0) {
      return BS_FINISH_STARTED;
    }
    /***/
    return BS_FINISH_DONE;
  }
  if (s.last_lit) {
    /*** FLUSH_BLOCK(s, 0); ***/
    flush_block_only(s, false);
    if (s.strm.avail_out === 0) {
      return BS_NEED_MORE;
    }
    /***/
  }

  return BS_BLOCK_DONE;
}


/* ===========================================================================
 * For Z_RLE, simply look for runs of bytes, generate matches only of distance
 * one.  Do not maintain a hash table.  (It will be regenerated if this run of
 * deflate switches away from Z_RLE.)
 */
function deflate_rle(s, flush) {
  var bflush;            /* set if current block must be flushed */
  var prev;              /* byte at distance one to match */
  var scan, strend;      /* scan goes up to strend for length of run */

  var _win = s.window;

  for (;;) {
    /* Make sure that we always have enough lookahead, except
     * at the end of the input file. We need MAX_MATCH bytes
     * for the longest run, plus one for the unrolled loop.
     */
    if (s.lookahead <= MAX_MATCH) {
      fill_window(s);
      if (s.lookahead <= MAX_MATCH && flush === Z_NO_FLUSH) {
        return BS_NEED_MORE;
      }
      if (s.lookahead === 0) { break; } /* flush the current block */
    }

    /* See how many times the previous byte repeats */
    s.match_length = 0;
    if (s.lookahead >= MIN_MATCH && s.strstart > 0) {
      scan = s.strstart - 1;
      prev = _win[scan];
      if (prev === _win[++scan] && prev === _win[++scan] && prev === _win[++scan]) {
        strend = s.strstart + MAX_MATCH;
        do {
          /*jshint noempty:false*/
        } while (prev === _win[++scan] && prev === _win[++scan] &&
                 prev === _win[++scan] && prev === _win[++scan] &&
                 prev === _win[++scan] && prev === _win[++scan] &&
                 prev === _win[++scan] && prev === _win[++scan] &&
                 scan < strend);
        s.match_length = MAX_MATCH - (strend - scan);
        if (s.match_length > s.lookahead) {
          s.match_length = s.lookahead;
        }
      }
      //Assert(scan <= s->window+(uInt)(s->window_size-1), "wild scan");
    }

    /* Emit match if have run of MIN_MATCH or longer, else emit literal */
    if (s.match_length >= MIN_MATCH) {
      //check_match(s, s.strstart, s.strstart - 1, s.match_length);

      /*** _tr_tally_dist(s, 1, s.match_length - MIN_MATCH, bflush); ***/
      bflush = trees._tr_tally(s, 1, s.match_length - MIN_MATCH);

      s.lookahead -= s.match_length;
      s.strstart += s.match_length;
      s.match_length = 0;
    } else {
      /* No match, output a literal byte */
      //Tracevv((stderr,"%c", s->window[s->strstart]));
      /*** _tr_tally_lit(s, s.window[s.strstart], bflush); ***/
      bflush = trees._tr_tally(s, 0, s.window[s.strstart]);

      s.lookahead--;
      s.strstart++;
    }
    if (bflush) {
      /*** FLUSH_BLOCK(s, 0); ***/
      flush_block_only(s, false);
      if (s.strm.avail_out === 0) {
        return BS_NEED_MORE;
      }
      /***/
    }
  }
  s.insert = 0;
  if (flush === Z_FINISH) {
    /*** FLUSH_BLOCK(s, 1); ***/
    flush_block_only(s, true);
    if (s.strm.avail_out === 0) {
      return BS_FINISH_STARTED;
    }
    /***/
    return BS_FINISH_DONE;
  }
  if (s.last_lit) {
    /*** FLUSH_BLOCK(s, 0); ***/
    flush_block_only(s, false);
    if (s.strm.avail_out === 0) {
      return BS_NEED_MORE;
    }
    /***/
  }
  return BS_BLOCK_DONE;
}

/* ===========================================================================
 * For Z_HUFFMAN_ONLY, do not look for matches.  Do not maintain a hash table.
 * (It will be regenerated if this run of deflate switches away from Huffman.)
 */
function deflate_huff(s, flush) {
  var bflush;             /* set if current block must be flushed */

  for (;;) {
    /* Make sure that we have a literal to write. */
    if (s.lookahead === 0) {
      fill_window(s);
      if (s.lookahead === 0) {
        if (flush === Z_NO_FLUSH) {
          return BS_NEED_MORE;
        }
        break;      /* flush the current block */
      }
    }

    /* Output a literal byte */
    s.match_length = 0;
    //Tracevv((stderr,"%c", s->window[s->strstart]));
    /*** _tr_tally_lit(s, s.window[s.strstart], bflush); ***/
    bflush = trees._tr_tally(s, 0, s.window[s.strstart]);
    s.lookahead--;
    s.strstart++;
    if (bflush) {
      /*** FLUSH_BLOCK(s, 0); ***/
      flush_block_only(s, false);
      if (s.strm.avail_out === 0) {
        return BS_NEED_MORE;
      }
      /***/
    }
  }
  s.insert = 0;
  if (flush === Z_FINISH) {
    /*** FLUSH_BLOCK(s, 1); ***/
    flush_block_only(s, true);
    if (s.strm.avail_out === 0) {
      return BS_FINISH_STARTED;
    }
    /***/
    return BS_FINISH_DONE;
  }
  if (s.last_lit) {
    /*** FLUSH_BLOCK(s, 0); ***/
    flush_block_only(s, false);
    if (s.strm.avail_out === 0) {
      return BS_NEED_MORE;
    }
    /***/
  }
  return BS_BLOCK_DONE;
}

/* Values for max_lazy_match, good_match and max_chain_length, depending on
 * the desired pack level (0..9). The values given below have been tuned to
 * exclude worst case performance for pathological files. Better values may be
 * found for specific files.
 */
function Config(good_length, max_lazy, nice_length, max_chain, func) {
  this.good_length = good_length;
  this.max_lazy = max_lazy;
  this.nice_length = nice_length;
  this.max_chain = max_chain;
  this.func = func;
}

var configuration_table;

configuration_table = [
  /*      good lazy nice chain */
  new Config(0, 0, 0, 0, deflate_stored),          /* 0 store only */
  new Config(4, 4, 8, 4, deflate_fast),            /* 1 max speed, no lazy matches */
  new Config(4, 5, 16, 8, deflate_fast),           /* 2 */
  new Config(4, 6, 32, 32, deflate_fast),          /* 3 */

  new Config(4, 4, 16, 16, deflate_slow),          /* 4 lazy matches */
  new Config(8, 16, 32, 32, deflate_slow),         /* 5 */
  new Config(8, 16, 128, 128, deflate_slow),       /* 6 */
  new Config(8, 32, 128, 256, deflate_slow),       /* 7 */
  new Config(32, 128, 258, 1024, deflate_slow),    /* 8 */
  new Config(32, 258, 258, 4096, deflate_slow)     /* 9 max compression */
];


/* ===========================================================================
 * Initialize the "longest match" routines for a new zlib stream
 */
function lm_init(s) {
  s.window_size = 2 * s.w_size;

  /*** CLEAR_HASH(s); ***/
  zero(s.head); // Fill with NIL (= 0);

  /* Set the default configuration parameters:
   */
  s.max_lazy_match = configuration_table[s.level].max_lazy;
  s.good_match = configuration_table[s.level].good_length;
  s.nice_match = configuration_table[s.level].nice_length;
  s.max_chain_length = configuration_table[s.level].max_chain;

  s.strstart = 0;
  s.block_start = 0;
  s.lookahead = 0;
  s.insert = 0;
  s.match_length = s.prev_length = MIN_MATCH - 1;
  s.match_available = 0;
  s.ins_h = 0;
}


function DeflateState() {
  this.strm = null;            /* pointer back to this zlib stream */
  this.status = 0;            /* as the name implies */
  this.pending_buf = null;      /* output still pending */
  this.pending_buf_size = 0;  /* size of pending_buf */
  this.pending_out = 0;       /* next pending byte to output to the stream */
  this.pending = 0;           /* nb of bytes in the pending buffer */
  this.wrap = 0;              /* bit 0 true for zlib, bit 1 true for gzip */
  this.gzhead = null;         /* gzip header information to write */
  this.gzindex = 0;           /* where in extra, name, or comment */
  this.method = Z_DEFLATED; /* can only be DEFLATED */
  this.last_flush = -1;   /* value of flush param for previous deflate call */

  this.w_size = 0;  /* LZ77 window size (32K by default) */
  this.w_bits = 0;  /* log2(w_size)  (8..16) */
  this.w_mask = 0;  /* w_size - 1 */

  this.window = null;
  /* Sliding window. Input bytes are read into the second half of the window,
   * and move to the first half later to keep a dictionary of at least wSize
   * bytes. With this organization, matches are limited to a distance of
   * wSize-MAX_MATCH bytes, but this ensures that IO is always
   * performed with a length multiple of the block size.
   */

  this.window_size = 0;
  /* Actual size of window: 2*wSize, except when the user input buffer
   * is directly used as sliding window.
   */

  this.prev = null;
  /* Link to older string with same hash index. To limit the size of this
   * array to 64K, this link is maintained only for the last 32K strings.
   * An index in this array is thus a window index modulo 32K.
   */

  this.head = null;   /* Heads of the hash chains or NIL. */

  this.ins_h = 0;       /* hash index of string to be inserted */
  this.hash_size = 0;   /* number of elements in hash table */
  this.hash_bits = 0;   /* log2(hash_size) */
  this.hash_mask = 0;   /* hash_size-1 */

  this.hash_shift = 0;
  /* Number of bits by which ins_h must be shifted at each input
   * step. It must be such that after MIN_MATCH steps, the oldest
   * byte no longer takes part in the hash key, that is:
   *   hash_shift * MIN_MATCH >= hash_bits
   */

  this.block_start = 0;
  /* Window position at the beginning of the current output block. Gets
   * negative when the window is moved backwards.
   */

  this.match_length = 0;      /* length of best match */
  this.prev_match = 0;        /* previous match */
  this.match_available = 0;   /* set if previous match exists */
  this.strstart = 0;          /* start of string to insert */
  this.match_start = 0;       /* start of matching string */
  this.lookahead = 0;         /* number of valid bytes ahead in window */

  this.prev_length = 0;
  /* Length of the best match at previous step. Matches not greater than this
   * are discarded. This is used in the lazy match evaluation.
   */

  this.max_chain_length = 0;
  /* To speed up deflation, hash chains are never searched beyond this
   * length.  A higher limit improves compression ratio but degrades the
   * speed.
   */

  this.max_lazy_match = 0;
  /* Attempt to find a better match only when the current match is strictly
   * smaller than this value. This mechanism is used only for compression
   * levels >= 4.
   */
  // That's alias to max_lazy_match, don't use directly
  //this.max_insert_length = 0;
  /* Insert new strings in the hash table only if the match length is not
   * greater than this length. This saves time but degrades compression.
   * max_insert_length is used only for compression levels <= 3.
   */

  this.level = 0;     /* compression level (1..9) */
  this.strategy = 0;  /* favor or force Huffman coding*/

  this.good_match = 0;
  /* Use a faster search when the previous match is longer than this */

  this.nice_match = 0; /* Stop searching when current match exceeds this */

              /* used by trees.c: */

  /* Didn't use ct_data typedef below to suppress compiler warning */

  // struct ct_data_s dyn_ltree[HEAP_SIZE];   /* literal and length tree */
  // struct ct_data_s dyn_dtree[2*D_CODES+1]; /* distance tree */
  // struct ct_data_s bl_tree[2*BL_CODES+1];  /* Huffman tree for bit lengths */

  // Use flat array of DOUBLE size, with interleaved fata,
  // because JS does not support effective
  this.dyn_ltree  = new utils.Buf16(HEAP_SIZE * 2);
  this.dyn_dtree  = new utils.Buf16((2 * D_CODES + 1) * 2);
  this.bl_tree    = new utils.Buf16((2 * BL_CODES + 1) * 2);
  zero(this.dyn_ltree);
  zero(this.dyn_dtree);
  zero(this.bl_tree);

  this.l_desc   = null;         /* desc. for literal tree */
  this.d_desc   = null;         /* desc. for distance tree */
  this.bl_desc  = null;         /* desc. for bit length tree */

  //ush bl_count[MAX_BITS+1];
  this.bl_count = new utils.Buf16(MAX_BITS + 1);
  /* number of codes at each bit length for an optimal tree */

  //int heap[2*L_CODES+1];      /* heap used to build the Huffman trees */
  this.heap = new utils.Buf16(2 * L_CODES + 1);  /* heap used to build the Huffman trees */
  zero(this.heap);

  this.heap_len = 0;               /* number of elements in the heap */
  this.heap_max = 0;               /* element of largest frequency */
  /* The sons of heap[n] are heap[2*n] and heap[2*n+1]. heap[0] is not used.
   * The same heap array is used to build all trees.
   */

  this.depth = new utils.Buf16(2 * L_CODES + 1); //uch depth[2*L_CODES+1];
  zero(this.depth);
  /* Depth of each subtree used as tie breaker for trees of equal frequency
   */

  this.l_buf = 0;          /* buffer index for literals or lengths */

  this.lit_bufsize = 0;
  /* Size of match buffer for literals/lengths.  There are 4 reasons for
   * limiting lit_bufsize to 64K:
   *   - frequencies can be kept in 16 bit counters
   *   - if compression is not successful for the first block, all input
   *     data is still in the window so we can still emit a stored block even
   *     when input comes from standard input.  (This can also be done for
   *     all blocks if lit_bufsize is not greater than 32K.)
   *   - if compression is not successful for a file smaller than 64K, we can
   *     even emit a stored file instead of a stored block (saving 5 bytes).
   *     This is applicable only for zip (not gzip or zlib).
   *   - creating new Huffman trees less frequently may not provide fast
   *     adaptation to changes in the input data statistics. (Take for
   *     example a binary file with poorly compressible code followed by
   *     a highly compressible string table.) Smaller buffer sizes give
   *     fast adaptation but have of course the overhead of transmitting
   *     trees more frequently.
   *   - I can't count above 4
   */

  this.last_lit = 0;      /* running index in l_buf */

  this.d_buf = 0;
  /* Buffer index for distances. To simplify the code, d_buf and l_buf have
   * the same number of elements. To use different lengths, an extra flag
   * array would be necessary.
   */

  this.opt_len = 0;       /* bit length of current block with optimal trees */
  this.static_len = 0;    /* bit length of current block with static trees */
  this.matches = 0;       /* number of string matches in current block */
  this.insert = 0;        /* bytes at end of window left to insert */


  this.bi_buf = 0;
  /* Output buffer. bits are inserted starting at the bottom (least
   * significant bits).
   */
  this.bi_valid = 0;
  /* Number of valid bits in bi_buf.  All bits above the last valid bit
   * are always zero.
   */

  // Used for window memory init. We safely ignore it for JS. That makes
  // sense only for pointers and memory check tools.
  //this.high_water = 0;
  /* High water mark offset in window for initialized bytes -- bytes above
   * this are set to zero in order to avoid memory check warnings when
   * longest match routines access bytes past the input.  This is then
   * updated to the new high water mark.
   */
}


function deflateResetKeep(strm) {
  var s;

  if (!strm || !strm.state) {
    return err(strm, Z_STREAM_ERROR);
  }

  strm.total_in = strm.total_out = 0;
  strm.data_type = Z_UNKNOWN;

  s = strm.state;
  s.pending = 0;
  s.pending_out = 0;

  if (s.wrap < 0) {
    s.wrap = -s.wrap;
    /* was made negative by deflate(..., Z_FINISH); */
  }
  s.status = (s.wrap ? INIT_STATE : BUSY_STATE);
  strm.adler = (s.wrap === 2) ?
    0  // crc32(0, Z_NULL, 0)
  :
    1; // adler32(0, Z_NULL, 0)
  s.last_flush = Z_NO_FLUSH;
  trees._tr_init(s);
  return Z_OK;
}


function deflateReset(strm) {
  var ret = deflateResetKeep(strm);
  if (ret === Z_OK) {
    lm_init(strm.state);
  }
  return ret;
}


function deflateSetHeader(strm, head) {
  if (!strm || !strm.state) { return Z_STREAM_ERROR; }
  if (strm.state.wrap !== 2) { return Z_STREAM_ERROR; }
  strm.state.gzhead = head;
  return Z_OK;
}


function deflateInit2(strm, level, method, windowBits, memLevel, strategy) {
  if (!strm) { // === Z_NULL
    return Z_STREAM_ERROR;
  }
  var wrap = 1;

  if (level === Z_DEFAULT_COMPRESSION) {
    level = 6;
  }

  if (windowBits < 0) { /* suppress zlib wrapper */
    wrap = 0;
    windowBits = -windowBits;
  }

  else if (windowBits > 15) {
    wrap = 2;           /* write gzip wrapper instead */
    windowBits -= 16;
  }


  if (memLevel < 1 || memLevel > MAX_MEM_LEVEL || method !== Z_DEFLATED ||
    windowBits < 8 || windowBits > 15 || level < 0 || level > 9 ||
    strategy < 0 || strategy > Z_FIXED) {
    return err(strm, Z_STREAM_ERROR);
  }


  if (windowBits === 8) {
    windowBits = 9;
  }
  /* until 256-byte window bug fixed */

  var s = new DeflateState();

  strm.state = s;
  s.strm = strm;

  s.wrap = wrap;
  s.gzhead = null;
  s.w_bits = windowBits;
  s.w_size = 1 << s.w_bits;
  s.w_mask = s.w_size - 1;

  s.hash_bits = memLevel + 7;
  s.hash_size = 1 << s.hash_bits;
  s.hash_mask = s.hash_size - 1;
  s.hash_shift = ~~((s.hash_bits + MIN_MATCH - 1) / MIN_MATCH);

  s.window = new utils.Buf8(s.w_size * 2);
  s.head = new utils.Buf16(s.hash_size);
  s.prev = new utils.Buf16(s.w_size);

  // Don't need mem init magic for JS.
  //s.high_water = 0;  /* nothing written to s->window yet */

  s.lit_bufsize = 1 << (memLevel + 6); /* 16K elements by default */

  s.pending_buf_size = s.lit_bufsize * 4;

  //overlay = (ushf *) ZALLOC(strm, s->lit_bufsize, sizeof(ush)+2);
  //s->pending_buf = (uchf *) overlay;
  s.pending_buf = new utils.Buf8(s.pending_buf_size);

  // It is offset from `s.pending_buf` (size is `s.lit_bufsize * 2`)
  //s->d_buf = overlay + s->lit_bufsize/sizeof(ush);
  s.d_buf = 1 * s.lit_bufsize;

  //s->l_buf = s->pending_buf + (1+sizeof(ush))*s->lit_bufsize;
  s.l_buf = (1 + 2) * s.lit_bufsize;

  s.level = level;
  s.strategy = strategy;
  s.method = method;

  return deflateReset(strm);
}

function deflateInit(strm, level) {
  return deflateInit2(strm, level, Z_DEFLATED, MAX_WBITS, DEF_MEM_LEVEL, Z_DEFAULT_STRATEGY);
}


function deflate(strm, flush) {
  var old_flush, s;
  var beg, val; // for gzip header write only

  if (!strm || !strm.state ||
    flush > Z_BLOCK || flush < 0) {
    return strm ? err(strm, Z_STREAM_ERROR) : Z_STREAM_ERROR;
  }

  s = strm.state;

  if (!strm.output ||
      (!strm.input && strm.avail_in !== 0) ||
      (s.status === FINISH_STATE && flush !== Z_FINISH)) {
    return err(strm, (strm.avail_out === 0) ? Z_BUF_ERROR : Z_STREAM_ERROR);
  }

  s.strm = strm; /* just in case */
  old_flush = s.last_flush;
  s.last_flush = flush;

  /* Write the header */
  if (s.status === INIT_STATE) {

    if (s.wrap === 2) { // GZIP header
      strm.adler = 0;  //crc32(0L, Z_NULL, 0);
      put_byte(s, 31);
      put_byte(s, 139);
      put_byte(s, 8);
      if (!s.gzhead) { // s->gzhead == Z_NULL
        put_byte(s, 0);
        put_byte(s, 0);
        put_byte(s, 0);
        put_byte(s, 0);
        put_byte(s, 0);
        put_byte(s, s.level === 9 ? 2 :
                    (s.strategy >= Z_HUFFMAN_ONLY || s.level < 2 ?
                     4 : 0));
        put_byte(s, OS_CODE);
        s.status = BUSY_STATE;
      }
      else {
        put_byte(s, (s.gzhead.text ? 1 : 0) +
                    (s.gzhead.hcrc ? 2 : 0) +
                    (!s.gzhead.extra ? 0 : 4) +
                    (!s.gzhead.name ? 0 : 8) +
                    (!s.gzhead.comment ? 0 : 16)
        );
        put_byte(s, s.gzhead.time & 0xff);
        put_byte(s, (s.gzhead.time >> 8) & 0xff);
        put_byte(s, (s.gzhead.time >> 16) & 0xff);
        put_byte(s, (s.gzhead.time >> 24) & 0xff);
        put_byte(s, s.level === 9 ? 2 :
                    (s.strategy >= Z_HUFFMAN_ONLY || s.level < 2 ?
                     4 : 0));
        put_byte(s, s.gzhead.os & 0xff);
        if (s.gzhead.extra && s.gzhead.extra.length) {
          put_byte(s, s.gzhead.extra.length & 0xff);
          put_byte(s, (s.gzhead.extra.length >> 8) & 0xff);
        }
        if (s.gzhead.hcrc) {
          strm.adler = crc32(strm.adler, s.pending_buf, s.pending, 0);
        }
        s.gzindex = 0;
        s.status = EXTRA_STATE;
      }
    }
    else // DEFLATE header
    {
      var header = (Z_DEFLATED + ((s.w_bits - 8) << 4)) << 8;
      var level_flags = -1;

      if (s.strategy >= Z_HUFFMAN_ONLY || s.level < 2) {
        level_flags = 0;
      } else if (s.level < 6) {
        level_flags = 1;
      } else if (s.level === 6) {
        level_flags = 2;
      } else {
        level_flags = 3;
      }
      header |= (level_flags << 6);
      if (s.strstart !== 0) { header |= PRESET_DICT; }
      header += 31 - (header % 31);

      s.status = BUSY_STATE;
      putShortMSB(s, header);

      /* Save the adler32 of the preset dictionary: */
      if (s.strstart !== 0) {
        putShortMSB(s, strm.adler >>> 16);
        putShortMSB(s, strm.adler & 0xffff);
      }
      strm.adler = 1; // adler32(0L, Z_NULL, 0);
    }
  }

//#ifdef GZIP
  if (s.status === EXTRA_STATE) {
    if (s.gzhead.extra/* != Z_NULL*/) {
      beg = s.pending;  /* start of bytes to update crc */

      while (s.gzindex < (s.gzhead.extra.length & 0xffff)) {
        if (s.pending === s.pending_buf_size) {
          if (s.gzhead.hcrc && s.pending > beg) {
            strm.adler = crc32(strm.adler, s.pending_buf, s.pending - beg, beg);
          }
          flush_pending(strm);
          beg = s.pending;
          if (s.pending === s.pending_buf_size) {
            break;
          }
        }
        put_byte(s, s.gzhead.extra[s.gzindex] & 0xff);
        s.gzindex++;
      }
      if (s.gzhead.hcrc && s.pending > beg) {
        strm.adler = crc32(strm.adler, s.pending_buf, s.pending - beg, beg);
      }
      if (s.gzindex === s.gzhead.extra.length) {
        s.gzindex = 0;
        s.status = NAME_STATE;
      }
    }
    else {
      s.status = NAME_STATE;
    }
  }
  if (s.status === NAME_STATE) {
    if (s.gzhead.name/* != Z_NULL*/) {
      beg = s.pending;  /* start of bytes to update crc */
      //int val;

      do {
        if (s.pending === s.pending_buf_size) {
          if (s.gzhead.hcrc && s.pending > beg) {
            strm.adler = crc32(strm.adler, s.pending_buf, s.pending - beg, beg);
          }
          flush_pending(strm);
          beg = s.pending;
          if (s.pending === s.pending_buf_size) {
            val = 1;
            break;
          }
        }
        // JS specific: little magic to add zero terminator to end of string
        if (s.gzindex < s.gzhead.name.length) {
          val = s.gzhead.name.charCodeAt(s.gzindex++) & 0xff;
        } else {
          val = 0;
        }
        put_byte(s, val);
      } while (val !== 0);

      if (s.gzhead.hcrc && s.pending > beg) {
        strm.adler = crc32(strm.adler, s.pending_buf, s.pending - beg, beg);
      }
      if (val === 0) {
        s.gzindex = 0;
        s.status = COMMENT_STATE;
      }
    }
    else {
      s.status = COMMENT_STATE;
    }
  }
  if (s.status === COMMENT_STATE) {
    if (s.gzhead.comment/* != Z_NULL*/) {
      beg = s.pending;  /* start of bytes to update crc */
      //int val;

      do {
        if (s.pending === s.pending_buf_size) {
          if (s.gzhead.hcrc && s.pending > beg) {
            strm.adler = crc32(strm.adler, s.pending_buf, s.pending - beg, beg);
          }
          flush_pending(strm);
          beg = s.pending;
          if (s.pending === s.pending_buf_size) {
            val = 1;
            break;
          }
        }
        // JS specific: little magic to add zero terminator to end of string
        if (s.gzindex < s.gzhead.comment.length) {
          val = s.gzhead.comment.charCodeAt(s.gzindex++) & 0xff;
        } else {
          val = 0;
        }
        put_byte(s, val);
      } while (val !== 0);

      if (s.gzhead.hcrc && s.pending > beg) {
        strm.adler = crc32(strm.adler, s.pending_buf, s.pending - beg, beg);
      }
      if (val === 0) {
        s.status = HCRC_STATE;
      }
    }
    else {
      s.status = HCRC_STATE;
    }
  }
  if (s.status === HCRC_STATE) {
    if (s.gzhead.hcrc) {
      if (s.pending + 2 > s.pending_buf_size) {
        flush_pending(strm);
      }
      if (s.pending + 2 <= s.pending_buf_size) {
        put_byte(s, strm.adler & 0xff);
        put_byte(s, (strm.adler >> 8) & 0xff);
        strm.adler = 0; //crc32(0L, Z_NULL, 0);
        s.status = BUSY_STATE;
      }
    }
    else {
      s.status = BUSY_STATE;
    }
  }
//#endif

  /* Flush as much pending output as possible */
  if (s.pending !== 0) {
    flush_pending(strm);
    if (strm.avail_out === 0) {
      /* Since avail_out is 0, deflate will be called again with
       * more output space, but possibly with both pending and
       * avail_in equal to zero. There won't be anything to do,
       * but this is not an error situation so make sure we
       * return OK instead of BUF_ERROR at next call of deflate:
       */
      s.last_flush = -1;
      return Z_OK;
    }

    /* Make sure there is something to do and avoid duplicate consecutive
     * flushes. For repeated and useless calls with Z_FINISH, we keep
     * returning Z_STREAM_END instead of Z_BUF_ERROR.
     */
  } else if (strm.avail_in === 0 && rank(flush) <= rank(old_flush) &&
    flush !== Z_FINISH) {
    return err(strm, Z_BUF_ERROR);
  }

  /* User must not provide more input after the first FINISH: */
  if (s.status === FINISH_STATE && strm.avail_in !== 0) {
    return err(strm, Z_BUF_ERROR);
  }

  /* Start a new block or continue the current one.
   */
  if (strm.avail_in !== 0 || s.lookahead !== 0 ||
    (flush !== Z_NO_FLUSH && s.status !== FINISH_STATE)) {
    var bstate = (s.strategy === Z_HUFFMAN_ONLY) ? deflate_huff(s, flush) :
      (s.strategy === Z_RLE ? deflate_rle(s, flush) :
        configuration_table[s.level].func(s, flush));

    if (bstate === BS_FINISH_STARTED || bstate === BS_FINISH_DONE) {
      s.status = FINISH_STATE;
    }
    if (bstate === BS_NEED_MORE || bstate === BS_FINISH_STARTED) {
      if (strm.avail_out === 0) {
        s.last_flush = -1;
        /* avoid BUF_ERROR next call, see above */
      }
      return Z_OK;
      /* If flush != Z_NO_FLUSH && avail_out == 0, the next call
       * of deflate should use the same flush parameter to make sure
       * that the flush is complete. So we don't have to output an
       * empty block here, this will be done at next call. This also
       * ensures that for a very small output buffer, we emit at most
       * one empty block.
       */
    }
    if (bstate === BS_BLOCK_DONE) {
      if (flush === Z_PARTIAL_FLUSH) {
        trees._tr_align(s);
      }
      else if (flush !== Z_BLOCK) { /* FULL_FLUSH or SYNC_FLUSH */

        trees._tr_stored_block(s, 0, 0, false);
        /* For a full flush, this empty block will be recognized
         * as a special marker by inflate_sync().
         */
        if (flush === Z_FULL_FLUSH) {
          /*** CLEAR_HASH(s); ***/             /* forget history */
          zero(s.head); // Fill with NIL (= 0);

          if (s.lookahead === 0) {
            s.strstart = 0;
            s.block_start = 0;
            s.insert = 0;
          }
        }
      }
      flush_pending(strm);
      if (strm.avail_out === 0) {
        s.last_flush = -1; /* avoid BUF_ERROR at next call, see above */
        return Z_OK;
      }
    }
  }
  //Assert(strm->avail_out > 0, "bug2");
  //if (strm.avail_out <= 0) { throw new Error("bug2");}

  if (flush !== Z_FINISH) { return Z_OK; }
  if (s.wrap <= 0) { return Z_STREAM_END; }

  /* Write the trailer */
  if (s.wrap === 2) {
    put_byte(s, strm.adler & 0xff);
    put_byte(s, (strm.adler >> 8) & 0xff);
    put_byte(s, (strm.adler >> 16) & 0xff);
    put_byte(s, (strm.adler >> 24) & 0xff);
    put_byte(s, strm.total_in & 0xff);
    put_byte(s, (strm.total_in >> 8) & 0xff);
    put_byte(s, (strm.total_in >> 16) & 0xff);
    put_byte(s, (strm.total_in >> 24) & 0xff);
  }
  else
  {
    putShortMSB(s, strm.adler >>> 16);
    putShortMSB(s, strm.adler & 0xffff);
  }

  flush_pending(strm);
  /* If avail_out is zero, the application will call deflate again
   * to flush the rest.
   */
  if (s.wrap > 0) { s.wrap = -s.wrap; }
  /* write the trailer only once! */
  return s.pending !== 0 ? Z_OK : Z_STREAM_END;
}

function deflateEnd(strm) {
  var status;

  if (!strm/*== Z_NULL*/ || !strm.state/*== Z_NULL*/) {
    return Z_STREAM_ERROR;
  }

  status = strm.state.status;
  if (status !== INIT_STATE &&
    status !== EXTRA_STATE &&
    status !== NAME_STATE &&
    status !== COMMENT_STATE &&
    status !== HCRC_STATE &&
    status !== BUSY_STATE &&
    status !== FINISH_STATE
  ) {
    return err(strm, Z_STREAM_ERROR);
  }

  strm.state = null;

  return status === BUSY_STATE ? err(strm, Z_DATA_ERROR) : Z_OK;
}


/* =========================================================================
 * Initializes the compression dictionary from the given byte
 * sequence without producing any compressed output.
 */
function deflateSetDictionary(strm, dictionary) {
  var dictLength = dictionary.length;

  var s;
  var str, n;
  var wrap;
  var avail;
  var next;
  var input;
  var tmpDict;

  if (!strm/*== Z_NULL*/ || !strm.state/*== Z_NULL*/) {
    return Z_STREAM_ERROR;
  }

  s = strm.state;
  wrap = s.wrap;

  if (wrap === 2 || (wrap === 1 && s.status !== INIT_STATE) || s.lookahead) {
    return Z_STREAM_ERROR;
  }

  /* when using zlib wrappers, compute Adler-32 for provided dictionary */
  if (wrap === 1) {
    /* adler32(strm->adler, dictionary, dictLength); */
    strm.adler = adler32(strm.adler, dictionary, dictLength, 0);
  }

  s.wrap = 0;   /* avoid computing Adler-32 in read_buf */

  /* if dictionary would fill window, just replace the history */
  if (dictLength >= s.w_size) {
    if (wrap === 0) {            /* already empty otherwise */
      /*** CLEAR_HASH(s); ***/
      zero(s.head); // Fill with NIL (= 0);
      s.strstart = 0;
      s.block_start = 0;
      s.insert = 0;
    }
    /* use the tail */
    // dictionary = dictionary.slice(dictLength - s.w_size);
    tmpDict = new utils.Buf8(s.w_size);
    utils.arraySet(tmpDict, dictionary, dictLength - s.w_size, s.w_size, 0);
    dictionary = tmpDict;
    dictLength = s.w_size;
  }
  /* insert dictionary into window and hash */
  avail = strm.avail_in;
  next = strm.next_in;
  input = strm.input;
  strm.avail_in = dictLength;
  strm.next_in = 0;
  strm.input = dictionary;
  fill_window(s);
  while (s.lookahead >= MIN_MATCH) {
    str = s.strstart;
    n = s.lookahead - (MIN_MATCH - 1);
    do {
      /* UPDATE_HASH(s, s->ins_h, s->window[str + MIN_MATCH-1]); */
      s.ins_h = ((s.ins_h << s.hash_shift) ^ s.window[str + MIN_MATCH - 1]) & s.hash_mask;

      s.prev[str & s.w_mask] = s.head[s.ins_h];

      s.head[s.ins_h] = str;
      str++;
    } while (--n);
    s.strstart = str;
    s.lookahead = MIN_MATCH - 1;
    fill_window(s);
  }
  s.strstart += s.lookahead;
  s.block_start = s.strstart;
  s.insert = s.lookahead;
  s.lookahead = 0;
  s.match_length = s.prev_length = MIN_MATCH - 1;
  s.match_available = 0;
  strm.next_in = next;
  strm.input = input;
  strm.avail_in = avail;
  s.wrap = wrap;
  return Z_OK;
}


exports.deflateInit = deflateInit;
exports.deflateInit2 = deflateInit2;
exports.deflateReset = deflateReset;
exports.deflateResetKeep = deflateResetKeep;
exports.deflateSetHeader = deflateSetHeader;
exports.deflate = deflate;
exports.deflateEnd = deflateEnd;
exports.deflateSetDictionary = deflateSetDictionary;
exports.deflateInfo = 'pako deflate (from Nodeca project)';

/* Not implemented
exports.deflateBound = deflateBound;
exports.deflateCopy = deflateCopy;
exports.deflateParams = deflateParams;
exports.deflatePending = deflatePending;
exports.deflatePrime = deflatePrime;
exports.deflateTune = deflateTune;
*/

},{"../utils/common":62,"./adler32":63,"./crc32":65,"./messages":70,"./trees":71}],67:[function(require,module,exports){
'use strict';

// (C) 1995-2013 Jean-loup Gailly and Mark Adler
// (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
//
// This software is provided 'as-is', without any express or implied
// warranty. In no event will the authors be held liable for any damages
// arising from the use of this software.
//
// Permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions:
//
// 1. The origin of this software must not be misrepresented; you must not
//   claim that you wrote the original software. If you use this software
//   in a product, an acknowledgment in the product documentation would be
//   appreciated but is not required.
// 2. Altered source versions must be plainly marked as such, and must not be
//   misrepresented as being the original software.
// 3. This notice may not be removed or altered from any source distribution.

// See state defs from inflate.js
var BAD = 30;       /* got a data error -- remain here until reset */
var TYPE = 12;      /* i: waiting for type bits, including last-flag bit */

/*
   Decode literal, length, and distance codes and write out the resulting
   literal and match bytes until either not enough input or output is
   available, an end-of-block is encountered, or a data error is encountered.
   When large enough input and output buffers are supplied to inflate(), for
   example, a 16K input buffer and a 64K output buffer, more than 95% of the
   inflate execution time is spent in this routine.

   Entry assumptions:

        state.mode === LEN
        strm.avail_in >= 6
        strm.avail_out >= 258
        start >= strm.avail_out
        state.bits < 8

   On return, state.mode is one of:

        LEN -- ran out of enough output space or enough available input
        TYPE -- reached end of block code, inflate() to interpret next block
        BAD -- error in block data

   Notes:

    - The maximum input bits used by a length/distance pair is 15 bits for the
      length code, 5 bits for the length extra, 15 bits for the distance code,
      and 13 bits for the distance extra.  This totals 48 bits, or six bytes.
      Therefore if strm.avail_in >= 6, then there is enough input to avoid
      checking for available input while decoding.

    - The maximum bytes that a single length/distance pair can output is 258
      bytes, which is the maximum length that can be coded.  inflate_fast()
      requires strm.avail_out >= 258 for each loop to avoid checking for
      output space.
 */
module.exports = function inflate_fast(strm, start) {
  var state;
  var _in;                    /* local strm.input */
  var last;                   /* have enough input while in < last */
  var _out;                   /* local strm.output */
  var beg;                    /* inflate()'s initial strm.output */
  var end;                    /* while out < end, enough space available */
//#ifdef INFLATE_STRICT
  var dmax;                   /* maximum distance from zlib header */
//#endif
  var wsize;                  /* window size or zero if not using window */
  var whave;                  /* valid bytes in the window */
  var wnext;                  /* window write index */
  // Use `s_window` instead `window`, avoid conflict with instrumentation tools
  var s_window;               /* allocated sliding window, if wsize != 0 */
  var hold;                   /* local strm.hold */
  var bits;                   /* local strm.bits */
  var lcode;                  /* local strm.lencode */
  var dcode;                  /* local strm.distcode */
  var lmask;                  /* mask for first level of length codes */
  var dmask;                  /* mask for first level of distance codes */
  var here;                   /* retrieved table entry */
  var op;                     /* code bits, operation, extra bits, or */
                              /*  window position, window bytes to copy */
  var len;                    /* match length, unused bytes */
  var dist;                   /* match distance */
  var from;                   /* where to copy match from */
  var from_source;


  var input, output; // JS specific, because we have no pointers

  /* copy state to local variables */
  state = strm.state;
  //here = state.here;
  _in = strm.next_in;
  input = strm.input;
  last = _in + (strm.avail_in - 5);
  _out = strm.next_out;
  output = strm.output;
  beg = _out - (start - strm.avail_out);
  end = _out + (strm.avail_out - 257);
//#ifdef INFLATE_STRICT
  dmax = state.dmax;
//#endif
  wsize = state.wsize;
  whave = state.whave;
  wnext = state.wnext;
  s_window = state.window;
  hold = state.hold;
  bits = state.bits;
  lcode = state.lencode;
  dcode = state.distcode;
  lmask = (1 << state.lenbits) - 1;
  dmask = (1 << state.distbits) - 1;


  /* decode literals and length/distances until end-of-block or not enough
     input data or output space */

  top:
  do {
    if (bits < 15) {
      hold += input[_in++] << bits;
      bits += 8;
      hold += input[_in++] << bits;
      bits += 8;
    }

    here = lcode[hold & lmask];

    dolen:
    for (;;) { // Goto emulation
      op = here >>> 24/*here.bits*/;
      hold >>>= op;
      bits -= op;
      op = (here >>> 16) & 0xff/*here.op*/;
      if (op === 0) {                          /* literal */
        //Tracevv((stderr, here.val >= 0x20 && here.val < 0x7f ?
        //        "inflate:         literal '%c'\n" :
        //        "inflate:         literal 0x%02x\n", here.val));
        output[_out++] = here & 0xffff/*here.val*/;
      }
      else if (op & 16) {                     /* length base */
        len = here & 0xffff/*here.val*/;
        op &= 15;                           /* number of extra bits */
        if (op) {
          if (bits < op) {
            hold += input[_in++] << bits;
            bits += 8;
          }
          len += hold & ((1 << op) - 1);
          hold >>>= op;
          bits -= op;
        }
        //Tracevv((stderr, "inflate:         length %u\n", len));
        if (bits < 15) {
          hold += input[_in++] << bits;
          bits += 8;
          hold += input[_in++] << bits;
          bits += 8;
        }
        here = dcode[hold & dmask];

        dodist:
        for (;;) { // goto emulation
          op = here >>> 24/*here.bits*/;
          hold >>>= op;
          bits -= op;
          op = (here >>> 16) & 0xff/*here.op*/;

          if (op & 16) {                      /* distance base */
            dist = here & 0xffff/*here.val*/;
            op &= 15;                       /* number of extra bits */
            if (bits < op) {
              hold += input[_in++] << bits;
              bits += 8;
              if (bits < op) {
                hold += input[_in++] << bits;
                bits += 8;
              }
            }
            dist += hold & ((1 << op) - 1);
//#ifdef INFLATE_STRICT
            if (dist > dmax) {
              strm.msg = 'invalid distance too far back';
              state.mode = BAD;
              break top;
            }
//#endif
            hold >>>= op;
            bits -= op;
            //Tracevv((stderr, "inflate:         distance %u\n", dist));
            op = _out - beg;                /* max distance in output */
            if (dist > op) {                /* see if copy from window */
              op = dist - op;               /* distance back in window */
              if (op > whave) {
                if (state.sane) {
                  strm.msg = 'invalid distance too far back';
                  state.mode = BAD;
                  break top;
                }

// (!) This block is disabled in zlib defaults,
// don't enable it for binary compatibility
//#ifdef INFLATE_ALLOW_INVALID_DISTANCE_TOOFAR_ARRR
//                if (len <= op - whave) {
//                  do {
//                    output[_out++] = 0;
//                  } while (--len);
//                  continue top;
//                }
//                len -= op - whave;
//                do {
//                  output[_out++] = 0;
//                } while (--op > whave);
//                if (op === 0) {
//                  from = _out - dist;
//                  do {
//                    output[_out++] = output[from++];
//                  } while (--len);
//                  continue top;
//                }
//#endif
              }
              from = 0; // window index
              from_source = s_window;
              if (wnext === 0) {           /* very common case */
                from += wsize - op;
                if (op < len) {         /* some from window */
                  len -= op;
                  do {
                    output[_out++] = s_window[from++];
                  } while (--op);
                  from = _out - dist;  /* rest from output */
                  from_source = output;
                }
              }
              else if (wnext < op) {      /* wrap around window */
                from += wsize + wnext - op;
                op -= wnext;
                if (op < len) {         /* some from end of window */
                  len -= op;
                  do {
                    output[_out++] = s_window[from++];
                  } while (--op);
                  from = 0;
                  if (wnext < len) {  /* some from start of window */
                    op = wnext;
                    len -= op;
                    do {
                      output[_out++] = s_window[from++];
                    } while (--op);
                    from = _out - dist;      /* rest from output */
                    from_source = output;
                  }
                }
              }
              else {                      /* contiguous in window */
                from += wnext - op;
                if (op < len) {         /* some from window */
                  len -= op;
                  do {
                    output[_out++] = s_window[from++];
                  } while (--op);
                  from = _out - dist;  /* rest from output */
                  from_source = output;
                }
              }
              while (len > 2) {
                output[_out++] = from_source[from++];
                output[_out++] = from_source[from++];
                output[_out++] = from_source[from++];
                len -= 3;
              }
              if (len) {
                output[_out++] = from_source[from++];
                if (len > 1) {
                  output[_out++] = from_source[from++];
                }
              }
            }
            else {
              from = _out - dist;          /* copy direct from output */
              do {                        /* minimum length is three */
                output[_out++] = output[from++];
                output[_out++] = output[from++];
                output[_out++] = output[from++];
                len -= 3;
              } while (len > 2);
              if (len) {
                output[_out++] = output[from++];
                if (len > 1) {
                  output[_out++] = output[from++];
                }
              }
            }
          }
          else if ((op & 64) === 0) {          /* 2nd level distance code */
            here = dcode[(here & 0xffff)/*here.val*/ + (hold & ((1 << op) - 1))];
            continue dodist;
          }
          else {
            strm.msg = 'invalid distance code';
            state.mode = BAD;
            break top;
          }

          break; // need to emulate goto via "continue"
        }
      }
      else if ((op & 64) === 0) {              /* 2nd level length code */
        here = lcode[(here & 0xffff)/*here.val*/ + (hold & ((1 << op) - 1))];
        continue dolen;
      }
      else if (op & 32) {                     /* end-of-block */
        //Tracevv((stderr, "inflate:         end of block\n"));
        state.mode = TYPE;
        break top;
      }
      else {
        strm.msg = 'invalid literal/length code';
        state.mode = BAD;
        break top;
      }

      break; // need to emulate goto via "continue"
    }
  } while (_in < last && _out < end);

  /* return unused bytes (on entry, bits < 8, so in won't go too far back) */
  len = bits >> 3;
  _in -= len;
  bits -= len << 3;
  hold &= (1 << bits) - 1;

  /* update state and return */
  strm.next_in = _in;
  strm.next_out = _out;
  strm.avail_in = (_in < last ? 5 + (last - _in) : 5 - (_in - last));
  strm.avail_out = (_out < end ? 257 + (end - _out) : 257 - (_out - end));
  state.hold = hold;
  state.bits = bits;
  return;
};

},{}],68:[function(require,module,exports){
'use strict';

// (C) 1995-2013 Jean-loup Gailly and Mark Adler
// (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
//
// This software is provided 'as-is', without any express or implied
// warranty. In no event will the authors be held liable for any damages
// arising from the use of this software.
//
// Permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions:
//
// 1. The origin of this software must not be misrepresented; you must not
//   claim that you wrote the original software. If you use this software
//   in a product, an acknowledgment in the product documentation would be
//   appreciated but is not required.
// 2. Altered source versions must be plainly marked as such, and must not be
//   misrepresented as being the original software.
// 3. This notice may not be removed or altered from any source distribution.

var utils         = require('../utils/common');
var adler32       = require('./adler32');
var crc32         = require('./crc32');
var inflate_fast  = require('./inffast');
var inflate_table = require('./inftrees');

var CODES = 0;
var LENS = 1;
var DISTS = 2;

/* Public constants ==========================================================*/
/* ===========================================================================*/


/* Allowed flush values; see deflate() and inflate() below for details */
//var Z_NO_FLUSH      = 0;
//var Z_PARTIAL_FLUSH = 1;
//var Z_SYNC_FLUSH    = 2;
//var Z_FULL_FLUSH    = 3;
var Z_FINISH        = 4;
var Z_BLOCK         = 5;
var Z_TREES         = 6;


/* Return codes for the compression/decompression functions. Negative values
 * are errors, positive values are used for special but normal events.
 */
var Z_OK            = 0;
var Z_STREAM_END    = 1;
var Z_NEED_DICT     = 2;
//var Z_ERRNO         = -1;
var Z_STREAM_ERROR  = -2;
var Z_DATA_ERROR    = -3;
var Z_MEM_ERROR     = -4;
var Z_BUF_ERROR     = -5;
//var Z_VERSION_ERROR = -6;

/* The deflate compression method */
var Z_DEFLATED  = 8;


/* STATES ====================================================================*/
/* ===========================================================================*/


var    HEAD = 1;       /* i: waiting for magic header */
var    FLAGS = 2;      /* i: waiting for method and flags (gzip) */
var    TIME = 3;       /* i: waiting for modification time (gzip) */
var    OS = 4;         /* i: waiting for extra flags and operating system (gzip) */
var    EXLEN = 5;      /* i: waiting for extra length (gzip) */
var    EXTRA = 6;      /* i: waiting for extra bytes (gzip) */
var    NAME = 7;       /* i: waiting for end of file name (gzip) */
var    COMMENT = 8;    /* i: waiting for end of comment (gzip) */
var    HCRC = 9;       /* i: waiting for header crc (gzip) */
var    DICTID = 10;    /* i: waiting for dictionary check value */
var    DICT = 11;      /* waiting for inflateSetDictionary() call */
var        TYPE = 12;      /* i: waiting for type bits, including last-flag bit */
var        TYPEDO = 13;    /* i: same, but skip check to exit inflate on new block */
var        STORED = 14;    /* i: waiting for stored size (length and complement) */
var        COPY_ = 15;     /* i/o: same as COPY below, but only first time in */
var        COPY = 16;      /* i/o: waiting for input or output to copy stored block */
var        TABLE = 17;     /* i: waiting for dynamic block table lengths */
var        LENLENS = 18;   /* i: waiting for code length code lengths */
var        CODELENS = 19;  /* i: waiting for length/lit and distance code lengths */
var            LEN_ = 20;      /* i: same as LEN below, but only first time in */
var            LEN = 21;       /* i: waiting for length/lit/eob code */
var            LENEXT = 22;    /* i: waiting for length extra bits */
var            DIST = 23;      /* i: waiting for distance code */
var            DISTEXT = 24;   /* i: waiting for distance extra bits */
var            MATCH = 25;     /* o: waiting for output space to copy string */
var            LIT = 26;       /* o: waiting for output space to write literal */
var    CHECK = 27;     /* i: waiting for 32-bit check value */
var    LENGTH = 28;    /* i: waiting for 32-bit length (gzip) */
var    DONE = 29;      /* finished check, done -- remain here until reset */
var    BAD = 30;       /* got a data error -- remain here until reset */
var    MEM = 31;       /* got an inflate() memory error -- remain here until reset */
var    SYNC = 32;      /* looking for synchronization bytes to restart inflate() */

/* ===========================================================================*/



var ENOUGH_LENS = 852;
var ENOUGH_DISTS = 592;
//var ENOUGH =  (ENOUGH_LENS+ENOUGH_DISTS);

var MAX_WBITS = 15;
/* 32K LZ77 window */
var DEF_WBITS = MAX_WBITS;


function zswap32(q) {
  return  (((q >>> 24) & 0xff) +
          ((q >>> 8) & 0xff00) +
          ((q & 0xff00) << 8) +
          ((q & 0xff) << 24));
}


function InflateState() {
  this.mode = 0;             /* current inflate mode */
  this.last = false;          /* true if processing last block */
  this.wrap = 0;              /* bit 0 true for zlib, bit 1 true for gzip */
  this.havedict = false;      /* true if dictionary provided */
  this.flags = 0;             /* gzip header method and flags (0 if zlib) */
  this.dmax = 0;              /* zlib header max distance (INFLATE_STRICT) */
  this.check = 0;             /* protected copy of check value */
  this.total = 0;             /* protected copy of output count */
  // TODO: may be {}
  this.head = null;           /* where to save gzip header information */

  /* sliding window */
  this.wbits = 0;             /* log base 2 of requested window size */
  this.wsize = 0;             /* window size or zero if not using window */
  this.whave = 0;             /* valid bytes in the window */
  this.wnext = 0;             /* window write index */
  this.window = null;         /* allocated sliding window, if needed */

  /* bit accumulator */
  this.hold = 0;              /* input bit accumulator */
  this.bits = 0;              /* number of bits in "in" */

  /* for string and stored block copying */
  this.length = 0;            /* literal or length of data to copy */
  this.offset = 0;            /* distance back to copy string from */

  /* for table and code decoding */
  this.extra = 0;             /* extra bits needed */

  /* fixed and dynamic code tables */
  this.lencode = null;          /* starting table for length/literal codes */
  this.distcode = null;         /* starting table for distance codes */
  this.lenbits = 0;           /* index bits for lencode */
  this.distbits = 0;          /* index bits for distcode */

  /* dynamic table building */
  this.ncode = 0;             /* number of code length code lengths */
  this.nlen = 0;              /* number of length code lengths */
  this.ndist = 0;             /* number of distance code lengths */
  this.have = 0;              /* number of code lengths in lens[] */
  this.next = null;              /* next available space in codes[] */

  this.lens = new utils.Buf16(320); /* temporary storage for code lengths */
  this.work = new utils.Buf16(288); /* work area for code table building */

  /*
   because we don't have pointers in js, we use lencode and distcode directly
   as buffers so we don't need codes
  */
  //this.codes = new utils.Buf32(ENOUGH);       /* space for code tables */
  this.lendyn = null;              /* dynamic table for length/literal codes (JS specific) */
  this.distdyn = null;             /* dynamic table for distance codes (JS specific) */
  this.sane = 0;                   /* if false, allow invalid distance too far */
  this.back = 0;                   /* bits back of last unprocessed length/lit */
  this.was = 0;                    /* initial length of match */
}

function inflateResetKeep(strm) {
  var state;

  if (!strm || !strm.state) { return Z_STREAM_ERROR; }
  state = strm.state;
  strm.total_in = strm.total_out = state.total = 0;
  strm.msg = ''; /*Z_NULL*/
  if (state.wrap) {       /* to support ill-conceived Java test suite */
    strm.adler = state.wrap & 1;
  }
  state.mode = HEAD;
  state.last = 0;
  state.havedict = 0;
  state.dmax = 32768;
  state.head = null/*Z_NULL*/;
  state.hold = 0;
  state.bits = 0;
  //state.lencode = state.distcode = state.next = state.codes;
  state.lencode = state.lendyn = new utils.Buf32(ENOUGH_LENS);
  state.distcode = state.distdyn = new utils.Buf32(ENOUGH_DISTS);

  state.sane = 1;
  state.back = -1;
  //Tracev((stderr, "inflate: reset\n"));
  return Z_OK;
}

function inflateReset(strm) {
  var state;

  if (!strm || !strm.state) { return Z_STREAM_ERROR; }
  state = strm.state;
  state.wsize = 0;
  state.whave = 0;
  state.wnext = 0;
  return inflateResetKeep(strm);

}

function inflateReset2(strm, windowBits) {
  var wrap;
  var state;

  /* get the state */
  if (!strm || !strm.state) { return Z_STREAM_ERROR; }
  state = strm.state;

  /* extract wrap request from windowBits parameter */
  if (windowBits < 0) {
    wrap = 0;
    windowBits = -windowBits;
  }
  else {
    wrap = (windowBits >> 4) + 1;
    if (windowBits < 48) {
      windowBits &= 15;
    }
  }

  /* set number of window bits, free window if different */
  if (windowBits && (windowBits < 8 || windowBits > 15)) {
    return Z_STREAM_ERROR;
  }
  if (state.window !== null && state.wbits !== windowBits) {
    state.window = null;
  }

  /* update state and reset the rest of it */
  state.wrap = wrap;
  state.wbits = windowBits;
  return inflateReset(strm);
}

function inflateInit2(strm, windowBits) {
  var ret;
  var state;

  if (!strm) { return Z_STREAM_ERROR; }
  //strm.msg = Z_NULL;                 /* in case we return an error */

  state = new InflateState();

  //if (state === Z_NULL) return Z_MEM_ERROR;
  //Tracev((stderr, "inflate: allocated\n"));
  strm.state = state;
  state.window = null/*Z_NULL*/;
  ret = inflateReset2(strm, windowBits);
  if (ret !== Z_OK) {
    strm.state = null/*Z_NULL*/;
  }
  return ret;
}

function inflateInit(strm) {
  return inflateInit2(strm, DEF_WBITS);
}


/*
 Return state with length and distance decoding tables and index sizes set to
 fixed code decoding.  Normally this returns fixed tables from inffixed.h.
 If BUILDFIXED is defined, then instead this routine builds the tables the
 first time it's called, and returns those tables the first time and
 thereafter.  This reduces the size of the code by about 2K bytes, in
 exchange for a little execution time.  However, BUILDFIXED should not be
 used for threaded applications, since the rewriting of the tables and virgin
 may not be thread-safe.
 */
var virgin = true;

var lenfix, distfix; // We have no pointers in JS, so keep tables separate

function fixedtables(state) {
  /* build fixed huffman tables if first call (may not be thread safe) */
  if (virgin) {
    var sym;

    lenfix = new utils.Buf32(512);
    distfix = new utils.Buf32(32);

    /* literal/length table */
    sym = 0;
    while (sym < 144) { state.lens[sym++] = 8; }
    while (sym < 256) { state.lens[sym++] = 9; }
    while (sym < 280) { state.lens[sym++] = 7; }
    while (sym < 288) { state.lens[sym++] = 8; }

    inflate_table(LENS,  state.lens, 0, 288, lenfix,   0, state.work, { bits: 9 });

    /* distance table */
    sym = 0;
    while (sym < 32) { state.lens[sym++] = 5; }

    inflate_table(DISTS, state.lens, 0, 32,   distfix, 0, state.work, { bits: 5 });

    /* do this just once */
    virgin = false;
  }

  state.lencode = lenfix;
  state.lenbits = 9;
  state.distcode = distfix;
  state.distbits = 5;
}


/*
 Update the window with the last wsize (normally 32K) bytes written before
 returning.  If window does not exist yet, create it.  This is only called
 when a window is already in use, or when output has been written during this
 inflate call, but the end of the deflate stream has not been reached yet.
 It is also called to create a window for dictionary data when a dictionary
 is loaded.

 Providing output buffers larger than 32K to inflate() should provide a speed
 advantage, since only the last 32K of output is copied to the sliding window
 upon return from inflate(), and since all distances after the first 32K of
 output will fall in the output data, making match copies simpler and faster.
 The advantage may be dependent on the size of the processor's data caches.
 */
function updatewindow(strm, src, end, copy) {
  var dist;
  var state = strm.state;

  /* if it hasn't been done already, allocate space for the window */
  if (state.window === null) {
    state.wsize = 1 << state.wbits;
    state.wnext = 0;
    state.whave = 0;

    state.window = new utils.Buf8(state.wsize);
  }

  /* copy state->wsize or less output bytes into the circular window */
  if (copy >= state.wsize) {
    utils.arraySet(state.window, src, end - state.wsize, state.wsize, 0);
    state.wnext = 0;
    state.whave = state.wsize;
  }
  else {
    dist = state.wsize - state.wnext;
    if (dist > copy) {
      dist = copy;
    }
    //zmemcpy(state->window + state->wnext, end - copy, dist);
    utils.arraySet(state.window, src, end - copy, dist, state.wnext);
    copy -= dist;
    if (copy) {
      //zmemcpy(state->window, end - copy, copy);
      utils.arraySet(state.window, src, end - copy, copy, 0);
      state.wnext = copy;
      state.whave = state.wsize;
    }
    else {
      state.wnext += dist;
      if (state.wnext === state.wsize) { state.wnext = 0; }
      if (state.whave < state.wsize) { state.whave += dist; }
    }
  }
  return 0;
}

function inflate(strm, flush) {
  var state;
  var input, output;          // input/output buffers
  var next;                   /* next input INDEX */
  var put;                    /* next output INDEX */
  var have, left;             /* available input and output */
  var hold;                   /* bit buffer */
  var bits;                   /* bits in bit buffer */
  var _in, _out;              /* save starting available input and output */
  var copy;                   /* number of stored or match bytes to copy */
  var from;                   /* where to copy match bytes from */
  var from_source;
  var here = 0;               /* current decoding table entry */
  var here_bits, here_op, here_val; // paked "here" denormalized (JS specific)
  //var last;                   /* parent table entry */
  var last_bits, last_op, last_val; // paked "last" denormalized (JS specific)
  var len;                    /* length to copy for repeats, bits to drop */
  var ret;                    /* return code */
  var hbuf = new utils.Buf8(4);    /* buffer for gzip header crc calculation */
  var opts;

  var n; // temporary var for NEED_BITS

  var order = /* permutation of code lengths */
    [ 16, 17, 18, 0, 8, 7, 9, 6, 10, 5, 11, 4, 12, 3, 13, 2, 14, 1, 15 ];


  if (!strm || !strm.state || !strm.output ||
      (!strm.input && strm.avail_in !== 0)) {
    return Z_STREAM_ERROR;
  }

  state = strm.state;
  if (state.mode === TYPE) { state.mode = TYPEDO; }    /* skip check */


  //--- LOAD() ---
  put = strm.next_out;
  output = strm.output;
  left = strm.avail_out;
  next = strm.next_in;
  input = strm.input;
  have = strm.avail_in;
  hold = state.hold;
  bits = state.bits;
  //---

  _in = have;
  _out = left;
  ret = Z_OK;

  inf_leave: // goto emulation
  for (;;) {
    switch (state.mode) {
      case HEAD:
        if (state.wrap === 0) {
          state.mode = TYPEDO;
          break;
        }
        //=== NEEDBITS(16);
        while (bits < 16) {
          if (have === 0) { break inf_leave; }
          have--;
          hold += input[next++] << bits;
          bits += 8;
        }
        //===//
        if ((state.wrap & 2) && hold === 0x8b1f) {  /* gzip header */
          state.check = 0/*crc32(0L, Z_NULL, 0)*/;
          //=== CRC2(state.check, hold);
          hbuf[0] = hold & 0xff;
          hbuf[1] = (hold >>> 8) & 0xff;
          state.check = crc32(state.check, hbuf, 2, 0);
          //===//

          //=== INITBITS();
          hold = 0;
          bits = 0;
          //===//
          state.mode = FLAGS;
          break;
        }
        state.flags = 0;           /* expect zlib header */
        if (state.head) {
          state.head.done = false;
        }
        if (!(state.wrap & 1) ||   /* check if zlib header allowed */
          (((hold & 0xff)/*BITS(8)*/ << 8) + (hold >> 8)) % 31) {
          strm.msg = 'incorrect header check';
          state.mode = BAD;
          break;
        }
        if ((hold & 0x0f)/*BITS(4)*/ !== Z_DEFLATED) {
          strm.msg = 'unknown compression method';
          state.mode = BAD;
          break;
        }
        //--- DROPBITS(4) ---//
        hold >>>= 4;
        bits -= 4;
        //---//
        len = (hold & 0x0f)/*BITS(4)*/ + 8;
        if (state.wbits === 0) {
          state.wbits = len;
        }
        else if (len > state.wbits) {
          strm.msg = 'invalid window size';
          state.mode = BAD;
          break;
        }
        state.dmax = 1 << len;
        //Tracev((stderr, "inflate:   zlib header ok\n"));
        strm.adler = state.check = 1/*adler32(0L, Z_NULL, 0)*/;
        state.mode = hold & 0x200 ? DICTID : TYPE;
        //=== INITBITS();
        hold = 0;
        bits = 0;
        //===//
        break;
      case FLAGS:
        //=== NEEDBITS(16); */
        while (bits < 16) {
          if (have === 0) { break inf_leave; }
          have--;
          hold += input[next++] << bits;
          bits += 8;
        }
        //===//
        state.flags = hold;
        if ((state.flags & 0xff) !== Z_DEFLATED) {
          strm.msg = 'unknown compression method';
          state.mode = BAD;
          break;
        }
        if (state.flags & 0xe000) {
          strm.msg = 'unknown header flags set';
          state.mode = BAD;
          break;
        }
        if (state.head) {
          state.head.text = ((hold >> 8) & 1);
        }
        if (state.flags & 0x0200) {
          //=== CRC2(state.check, hold);
          hbuf[0] = hold & 0xff;
          hbuf[1] = (hold >>> 8) & 0xff;
          state.check = crc32(state.check, hbuf, 2, 0);
          //===//
        }
        //=== INITBITS();
        hold = 0;
        bits = 0;
        //===//
        state.mode = TIME;
        /* falls through */
      case TIME:
        //=== NEEDBITS(32); */
        while (bits < 32) {
          if (have === 0) { break inf_leave; }
          have--;
          hold += input[next++] << bits;
          bits += 8;
        }
        //===//
        if (state.head) {
          state.head.time = hold;
        }
        if (state.flags & 0x0200) {
          //=== CRC4(state.check, hold)
          hbuf[0] = hold & 0xff;
          hbuf[1] = (hold >>> 8) & 0xff;
          hbuf[2] = (hold >>> 16) & 0xff;
          hbuf[3] = (hold >>> 24) & 0xff;
          state.check = crc32(state.check, hbuf, 4, 0);
          //===
        }
        //=== INITBITS();
        hold = 0;
        bits = 0;
        //===//
        state.mode = OS;
        /* falls through */
      case OS:
        //=== NEEDBITS(16); */
        while (bits < 16) {
          if (have === 0) { break inf_leave; }
          have--;
          hold += input[next++] << bits;
          bits += 8;
        }
        //===//
        if (state.head) {
          state.head.xflags = (hold & 0xff);
          state.head.os = (hold >> 8);
        }
        if (state.flags & 0x0200) {
          //=== CRC2(state.check, hold);
          hbuf[0] = hold & 0xff;
          hbuf[1] = (hold >>> 8) & 0xff;
          state.check = crc32(state.check, hbuf, 2, 0);
          //===//
        }
        //=== INITBITS();
        hold = 0;
        bits = 0;
        //===//
        state.mode = EXLEN;
        /* falls through */
      case EXLEN:
        if (state.flags & 0x0400) {
          //=== NEEDBITS(16); */
          while (bits < 16) {
            if (have === 0) { break inf_leave; }
            have--;
            hold += input[next++] << bits;
            bits += 8;
          }
          //===//
          state.length = hold;
          if (state.head) {
            state.head.extra_len = hold;
          }
          if (state.flags & 0x0200) {
            //=== CRC2(state.check, hold);
            hbuf[0] = hold & 0xff;
            hbuf[1] = (hold >>> 8) & 0xff;
            state.check = crc32(state.check, hbuf, 2, 0);
            //===//
          }
          //=== INITBITS();
          hold = 0;
          bits = 0;
          //===//
        }
        else if (state.head) {
          state.head.extra = null/*Z_NULL*/;
        }
        state.mode = EXTRA;
        /* falls through */
      case EXTRA:
        if (state.flags & 0x0400) {
          copy = state.length;
          if (copy > have) { copy = have; }
          if (copy) {
            if (state.head) {
              len = state.head.extra_len - state.length;
              if (!state.head.extra) {
                // Use untyped array for more convenient processing later
                state.head.extra = new Array(state.head.extra_len);
              }
              utils.arraySet(
                state.head.extra,
                input,
                next,
                // extra field is limited to 65536 bytes
                // - no need for additional size check
                copy,
                /*len + copy > state.head.extra_max - len ? state.head.extra_max : copy,*/
                len
              );
              //zmemcpy(state.head.extra + len, next,
              //        len + copy > state.head.extra_max ?
              //        state.head.extra_max - len : copy);
            }
            if (state.flags & 0x0200) {
              state.check = crc32(state.check, input, copy, next);
            }
            have -= copy;
            next += copy;
            state.length -= copy;
          }
          if (state.length) { break inf_leave; }
        }
        state.length = 0;
        state.mode = NAME;
        /* falls through */
      case NAME:
        if (state.flags & 0x0800) {
          if (have === 0) { break inf_leave; }
          copy = 0;
          do {
            // TODO: 2 or 1 bytes?
            len = input[next + copy++];
            /* use constant limit because in js we should not preallocate memory */
            if (state.head && len &&
                (state.length < 65536 /*state.head.name_max*/)) {
              state.head.name += String.fromCharCode(len);
            }
          } while (len && copy < have);

          if (state.flags & 0x0200) {
            state.check = crc32(state.check, input, copy, next);
          }
          have -= copy;
          next += copy;
          if (len) { break inf_leave; }
        }
        else if (state.head) {
          state.head.name = null;
        }
        state.length = 0;
        state.mode = COMMENT;
        /* falls through */
      case COMMENT:
        if (state.flags & 0x1000) {
          if (have === 0) { break inf_leave; }
          copy = 0;
          do {
            len = input[next + copy++];
            /* use constant limit because in js we should not preallocate memory */
            if (state.head && len &&
                (state.length < 65536 /*state.head.comm_max*/)) {
              state.head.comment += String.fromCharCode(len);
            }
          } while (len && copy < have);
          if (state.flags & 0x0200) {
            state.check = crc32(state.check, input, copy, next);
          }
          have -= copy;
          next += copy;
          if (len) { break inf_leave; }
        }
        else if (state.head) {
          state.head.comment = null;
        }
        state.mode = HCRC;
        /* falls through */
      case HCRC:
        if (state.flags & 0x0200) {
          //=== NEEDBITS(16); */
          while (bits < 16) {
            if (have === 0) { break inf_leave; }
            have--;
            hold += input[next++] << bits;
            bits += 8;
          }
          //===//
          if (hold !== (state.check & 0xffff)) {
            strm.msg = 'header crc mismatch';
            state.mode = BAD;
            break;
          }
          //=== INITBITS();
          hold = 0;
          bits = 0;
          //===//
        }
        if (state.head) {
          state.head.hcrc = ((state.flags >> 9) & 1);
          state.head.done = true;
        }
        strm.adler = state.check = 0;
        state.mode = TYPE;
        break;
      case DICTID:
        //=== NEEDBITS(32); */
        while (bits < 32) {
          if (have === 0) { break inf_leave; }
          have--;
          hold += input[next++] << bits;
          bits += 8;
        }
        //===//
        strm.adler = state.check = zswap32(hold);
        //=== INITBITS();
        hold = 0;
        bits = 0;
        //===//
        state.mode = DICT;
        /* falls through */
      case DICT:
        if (state.havedict === 0) {
          //--- RESTORE() ---
          strm.next_out = put;
          strm.avail_out = left;
          strm.next_in = next;
          strm.avail_in = have;
          state.hold = hold;
          state.bits = bits;
          //---
          return Z_NEED_DICT;
        }
        strm.adler = state.check = 1/*adler32(0L, Z_NULL, 0)*/;
        state.mode = TYPE;
        /* falls through */
      case TYPE:
        if (flush === Z_BLOCK || flush === Z_TREES) { break inf_leave; }
        /* falls through */
      case TYPEDO:
        if (state.last) {
          //--- BYTEBITS() ---//
          hold >>>= bits & 7;
          bits -= bits & 7;
          //---//
          state.mode = CHECK;
          break;
        }
        //=== NEEDBITS(3); */
        while (bits < 3) {
          if (have === 0) { break inf_leave; }
          have--;
          hold += input[next++] << bits;
          bits += 8;
        }
        //===//
        state.last = (hold & 0x01)/*BITS(1)*/;
        //--- DROPBITS(1) ---//
        hold >>>= 1;
        bits -= 1;
        //---//

        switch ((hold & 0x03)/*BITS(2)*/) {
          case 0:                             /* stored block */
            //Tracev((stderr, "inflate:     stored block%s\n",
            //        state.last ? " (last)" : ""));
            state.mode = STORED;
            break;
          case 1:                             /* fixed block */
            fixedtables(state);
            //Tracev((stderr, "inflate:     fixed codes block%s\n",
            //        state.last ? " (last)" : ""));
            state.mode = LEN_;             /* decode codes */
            if (flush === Z_TREES) {
              //--- DROPBITS(2) ---//
              hold >>>= 2;
              bits -= 2;
              //---//
              break inf_leave;
            }
            break;
          case 2:                             /* dynamic block */
            //Tracev((stderr, "inflate:     dynamic codes block%s\n",
            //        state.last ? " (last)" : ""));
            state.mode = TABLE;
            break;
          case 3:
            strm.msg = 'invalid block type';
            state.mode = BAD;
        }
        //--- DROPBITS(2) ---//
        hold >>>= 2;
        bits -= 2;
        //---//
        break;
      case STORED:
        //--- BYTEBITS() ---// /* go to byte boundary */
        hold >>>= bits & 7;
        bits -= bits & 7;
        //---//
        //=== NEEDBITS(32); */
        while (bits < 32) {
          if (have === 0) { break inf_leave; }
          have--;
          hold += input[next++] << bits;
          bits += 8;
        }
        //===//
        if ((hold & 0xffff) !== ((hold >>> 16) ^ 0xffff)) {
          strm.msg = 'invalid stored block lengths';
          state.mode = BAD;
          break;
        }
        state.length = hold & 0xffff;
        //Tracev((stderr, "inflate:       stored length %u\n",
        //        state.length));
        //=== INITBITS();
        hold = 0;
        bits = 0;
        //===//
        state.mode = COPY_;
        if (flush === Z_TREES) { break inf_leave; }
        /* falls through */
      case COPY_:
        state.mode = COPY;
        /* falls through */
      case COPY:
        copy = state.length;
        if (copy) {
          if (copy > have) { copy = have; }
          if (copy > left) { copy = left; }
          if (copy === 0) { break inf_leave; }
          //--- zmemcpy(put, next, copy); ---
          utils.arraySet(output, input, next, copy, put);
          //---//
          have -= copy;
          next += copy;
          left -= copy;
          put += copy;
          state.length -= copy;
          break;
        }
        //Tracev((stderr, "inflate:       stored end\n"));
        state.mode = TYPE;
        break;
      case TABLE:
        //=== NEEDBITS(14); */
        while (bits < 14) {
          if (have === 0) { break inf_leave; }
          have--;
          hold += input[next++] << bits;
          bits += 8;
        }
        //===//
        state.nlen = (hold & 0x1f)/*BITS(5)*/ + 257;
        //--- DROPBITS(5) ---//
        hold >>>= 5;
        bits -= 5;
        //---//
        state.ndist = (hold & 0x1f)/*BITS(5)*/ + 1;
        //--- DROPBITS(5) ---//
        hold >>>= 5;
        bits -= 5;
        //---//
        state.ncode = (hold & 0x0f)/*BITS(4)*/ + 4;
        //--- DROPBITS(4) ---//
        hold >>>= 4;
        bits -= 4;
        //---//
//#ifndef PKZIP_BUG_WORKAROUND
        if (state.nlen > 286 || state.ndist > 30) {
          strm.msg = 'too many length or distance symbols';
          state.mode = BAD;
          break;
        }
//#endif
        //Tracev((stderr, "inflate:       table sizes ok\n"));
        state.have = 0;
        state.mode = LENLENS;
        /* falls through */
      case LENLENS:
        while (state.have < state.ncode) {
          //=== NEEDBITS(3);
          while (bits < 3) {
            if (have === 0) { break inf_leave; }
            have--;
            hold += input[next++] << bits;
            bits += 8;
          }
          //===//
          state.lens[order[state.have++]] = (hold & 0x07);//BITS(3);
          //--- DROPBITS(3) ---//
          hold >>>= 3;
          bits -= 3;
          //---//
        }
        while (state.have < 19) {
          state.lens[order[state.have++]] = 0;
        }
        // We have separate tables & no pointers. 2 commented lines below not needed.
        //state.next = state.codes;
        //state.lencode = state.next;
        // Switch to use dynamic table
        state.lencode = state.lendyn;
        state.lenbits = 7;

        opts = { bits: state.lenbits };
        ret = inflate_table(CODES, state.lens, 0, 19, state.lencode, 0, state.work, opts);
        state.lenbits = opts.bits;

        if (ret) {
          strm.msg = 'invalid code lengths set';
          state.mode = BAD;
          break;
        }
        //Tracev((stderr, "inflate:       code lengths ok\n"));
        state.have = 0;
        state.mode = CODELENS;
        /* falls through */
      case CODELENS:
        while (state.have < state.nlen + state.ndist) {
          for (;;) {
            here = state.lencode[hold & ((1 << state.lenbits) - 1)];/*BITS(state.lenbits)*/
            here_bits = here >>> 24;
            here_op = (here >>> 16) & 0xff;
            here_val = here & 0xffff;

            if ((here_bits) <= bits) { break; }
            //--- PULLBYTE() ---//
            if (have === 0) { break inf_leave; }
            have--;
            hold += input[next++] << bits;
            bits += 8;
            //---//
          }
          if (here_val < 16) {
            //--- DROPBITS(here.bits) ---//
            hold >>>= here_bits;
            bits -= here_bits;
            //---//
            state.lens[state.have++] = here_val;
          }
          else {
            if (here_val === 16) {
              //=== NEEDBITS(here.bits + 2);
              n = here_bits + 2;
              while (bits < n) {
                if (have === 0) { break inf_leave; }
                have--;
                hold += input[next++] << bits;
                bits += 8;
              }
              //===//
              //--- DROPBITS(here.bits) ---//
              hold >>>= here_bits;
              bits -= here_bits;
              //---//
              if (state.have === 0) {
                strm.msg = 'invalid bit length repeat';
                state.mode = BAD;
                break;
              }
              len = state.lens[state.have - 1];
              copy = 3 + (hold & 0x03);//BITS(2);
              //--- DROPBITS(2) ---//
              hold >>>= 2;
              bits -= 2;
              //---//
            }
            else if (here_val === 17) {
              //=== NEEDBITS(here.bits + 3);
              n = here_bits + 3;
              while (bits < n) {
                if (have === 0) { break inf_leave; }
                have--;
                hold += input[next++] << bits;
                bits += 8;
              }
              //===//
              //--- DROPBITS(here.bits) ---//
              hold >>>= here_bits;
              bits -= here_bits;
              //---//
              len = 0;
              copy = 3 + (hold & 0x07);//BITS(3);
              //--- DROPBITS(3) ---//
              hold >>>= 3;
              bits -= 3;
              //---//
            }
            else {
              //=== NEEDBITS(here.bits + 7);
              n = here_bits + 7;
              while (bits < n) {
                if (have === 0) { break inf_leave; }
                have--;
                hold += input[next++] << bits;
                bits += 8;
              }
              //===//
              //--- DROPBITS(here.bits) ---//
              hold >>>= here_bits;
              bits -= here_bits;
              //---//
              len = 0;
              copy = 11 + (hold & 0x7f);//BITS(7);
              //--- DROPBITS(7) ---//
              hold >>>= 7;
              bits -= 7;
              //---//
            }
            if (state.have + copy > state.nlen + state.ndist) {
              strm.msg = 'invalid bit length repeat';
              state.mode = BAD;
              break;
            }
            while (copy--) {
              state.lens[state.have++] = len;
            }
          }
        }

        /* handle error breaks in while */
        if (state.mode === BAD) { break; }

        /* check for end-of-block code (better have one) */
        if (state.lens[256] === 0) {
          strm.msg = 'invalid code -- missing end-of-block';
          state.mode = BAD;
          break;
        }

        /* build code tables -- note: do not change the lenbits or distbits
           values here (9 and 6) without reading the comments in inftrees.h
           concerning the ENOUGH constants, which depend on those values */
        state.lenbits = 9;

        opts = { bits: state.lenbits };
        ret = inflate_table(LENS, state.lens, 0, state.nlen, state.lencode, 0, state.work, opts);
        // We have separate tables & no pointers. 2 commented lines below not needed.
        // state.next_index = opts.table_index;
        state.lenbits = opts.bits;
        // state.lencode = state.next;

        if (ret) {
          strm.msg = 'invalid literal/lengths set';
          state.mode = BAD;
          break;
        }

        state.distbits = 6;
        //state.distcode.copy(state.codes);
        // Switch to use dynamic table
        state.distcode = state.distdyn;
        opts = { bits: state.distbits };
        ret = inflate_table(DISTS, state.lens, state.nlen, state.ndist, state.distcode, 0, state.work, opts);
        // We have separate tables & no pointers. 2 commented lines below not needed.
        // state.next_index = opts.table_index;
        state.distbits = opts.bits;
        // state.distcode = state.next;

        if (ret) {
          strm.msg = 'invalid distances set';
          state.mode = BAD;
          break;
        }
        //Tracev((stderr, 'inflate:       codes ok\n'));
        state.mode = LEN_;
        if (flush === Z_TREES) { break inf_leave; }
        /* falls through */
      case LEN_:
        state.mode = LEN;
        /* falls through */
      case LEN:
        if (have >= 6 && left >= 258) {
          //--- RESTORE() ---
          strm.next_out = put;
          strm.avail_out = left;
          strm.next_in = next;
          strm.avail_in = have;
          state.hold = hold;
          state.bits = bits;
          //---
          inflate_fast(strm, _out);
          //--- LOAD() ---
          put = strm.next_out;
          output = strm.output;
          left = strm.avail_out;
          next = strm.next_in;
          input = strm.input;
          have = strm.avail_in;
          hold = state.hold;
          bits = state.bits;
          //---

          if (state.mode === TYPE) {
            state.back = -1;
          }
          break;
        }
        state.back = 0;
        for (;;) {
          here = state.lencode[hold & ((1 << state.lenbits) - 1)];  /*BITS(state.lenbits)*/
          here_bits = here >>> 24;
          here_op = (here >>> 16) & 0xff;
          here_val = here & 0xffff;

          if (here_bits <= bits) { break; }
          //--- PULLBYTE() ---//
          if (have === 0) { break inf_leave; }
          have--;
          hold += input[next++] << bits;
          bits += 8;
          //---//
        }
        if (here_op && (here_op & 0xf0) === 0) {
          last_bits = here_bits;
          last_op = here_op;
          last_val = here_val;
          for (;;) {
            here = state.lencode[last_val +
                    ((hold & ((1 << (last_bits + last_op)) - 1))/*BITS(last.bits + last.op)*/ >> last_bits)];
            here_bits = here >>> 24;
            here_op = (here >>> 16) & 0xff;
            here_val = here & 0xffff;

            if ((last_bits + here_bits) <= bits) { break; }
            //--- PULLBYTE() ---//
            if (have === 0) { break inf_leave; }
            have--;
            hold += input[next++] << bits;
            bits += 8;
            //---//
          }
          //--- DROPBITS(last.bits) ---//
          hold >>>= last_bits;
          bits -= last_bits;
          //---//
          state.back += last_bits;
        }
        //--- DROPBITS(here.bits) ---//
        hold >>>= here_bits;
        bits -= here_bits;
        //---//
        state.back += here_bits;
        state.length = here_val;
        if (here_op === 0) {
          //Tracevv((stderr, here.val >= 0x20 && here.val < 0x7f ?
          //        "inflate:         literal '%c'\n" :
          //        "inflate:         literal 0x%02x\n", here.val));
          state.mode = LIT;
          break;
        }
        if (here_op & 32) {
          //Tracevv((stderr, "inflate:         end of block\n"));
          state.back = -1;
          state.mode = TYPE;
          break;
        }
        if (here_op & 64) {
          strm.msg = 'invalid literal/length code';
          state.mode = BAD;
          break;
        }
        state.extra = here_op & 15;
        state.mode = LENEXT;
        /* falls through */
      case LENEXT:
        if (state.extra) {
          //=== NEEDBITS(state.extra);
          n = state.extra;
          while (bits < n) {
            if (have === 0) { break inf_leave; }
            have--;
            hold += input[next++] << bits;
            bits += 8;
          }
          //===//
          state.length += hold & ((1 << state.extra) - 1)/*BITS(state.extra)*/;
          //--- DROPBITS(state.extra) ---//
          hold >>>= state.extra;
          bits -= state.extra;
          //---//
          state.back += state.extra;
        }
        //Tracevv((stderr, "inflate:         length %u\n", state.length));
        state.was = state.length;
        state.mode = DIST;
        /* falls through */
      case DIST:
        for (;;) {
          here = state.distcode[hold & ((1 << state.distbits) - 1)];/*BITS(state.distbits)*/
          here_bits = here >>> 24;
          here_op = (here >>> 16) & 0xff;
          here_val = here & 0xffff;

          if ((here_bits) <= bits) { break; }
          //--- PULLBYTE() ---//
          if (have === 0) { break inf_leave; }
          have--;
          hold += input[next++] << bits;
          bits += 8;
          //---//
        }
        if ((here_op & 0xf0) === 0) {
          last_bits = here_bits;
          last_op = here_op;
          last_val = here_val;
          for (;;) {
            here = state.distcode[last_val +
                    ((hold & ((1 << (last_bits + last_op)) - 1))/*BITS(last.bits + last.op)*/ >> last_bits)];
            here_bits = here >>> 24;
            here_op = (here >>> 16) & 0xff;
            here_val = here & 0xffff;

            if ((last_bits + here_bits) <= bits) { break; }
            //--- PULLBYTE() ---//
            if (have === 0) { break inf_leave; }
            have--;
            hold += input[next++] << bits;
            bits += 8;
            //---//
          }
          //--- DROPBITS(last.bits) ---//
          hold >>>= last_bits;
          bits -= last_bits;
          //---//
          state.back += last_bits;
        }
        //--- DROPBITS(here.bits) ---//
        hold >>>= here_bits;
        bits -= here_bits;
        //---//
        state.back += here_bits;
        if (here_op & 64) {
          strm.msg = 'invalid distance code';
          state.mode = BAD;
          break;
        }
        state.offset = here_val;
        state.extra = (here_op) & 15;
        state.mode = DISTEXT;
        /* falls through */
      case DISTEXT:
        if (state.extra) {
          //=== NEEDBITS(state.extra);
          n = state.extra;
          while (bits < n) {
            if (have === 0) { break inf_leave; }
            have--;
            hold += input[next++] << bits;
            bits += 8;
          }
          //===//
          state.offset += hold & ((1 << state.extra) - 1)/*BITS(state.extra)*/;
          //--- DROPBITS(state.extra) ---//
          hold >>>= state.extra;
          bits -= state.extra;
          //---//
          state.back += state.extra;
        }
//#ifdef INFLATE_STRICT
        if (state.offset > state.dmax) {
          strm.msg = 'invalid distance too far back';
          state.mode = BAD;
          break;
        }
//#endif
        //Tracevv((stderr, "inflate:         distance %u\n", state.offset));
        state.mode = MATCH;
        /* falls through */
      case MATCH:
        if (left === 0) { break inf_leave; }
        copy = _out - left;
        if (state.offset > copy) {         /* copy from window */
          copy = state.offset - copy;
          if (copy > state.whave) {
            if (state.sane) {
              strm.msg = 'invalid distance too far back';
              state.mode = BAD;
              break;
            }
// (!) This block is disabled in zlib defaults,
// don't enable it for binary compatibility
//#ifdef INFLATE_ALLOW_INVALID_DISTANCE_TOOFAR_ARRR
//          Trace((stderr, "inflate.c too far\n"));
//          copy -= state.whave;
//          if (copy > state.length) { copy = state.length; }
//          if (copy > left) { copy = left; }
//          left -= copy;
//          state.length -= copy;
//          do {
//            output[put++] = 0;
//          } while (--copy);
//          if (state.length === 0) { state.mode = LEN; }
//          break;
//#endif
          }
          if (copy > state.wnext) {
            copy -= state.wnext;
            from = state.wsize - copy;
          }
          else {
            from = state.wnext - copy;
          }
          if (copy > state.length) { copy = state.length; }
          from_source = state.window;
        }
        else {                              /* copy from output */
          from_source = output;
          from = put - state.offset;
          copy = state.length;
        }
        if (copy > left) { copy = left; }
        left -= copy;
        state.length -= copy;
        do {
          output[put++] = from_source[from++];
        } while (--copy);
        if (state.length === 0) { state.mode = LEN; }
        break;
      case LIT:
        if (left === 0) { break inf_leave; }
        output[put++] = state.length;
        left--;
        state.mode = LEN;
        break;
      case CHECK:
        if (state.wrap) {
          //=== NEEDBITS(32);
          while (bits < 32) {
            if (have === 0) { break inf_leave; }
            have--;
            // Use '|' instead of '+' to make sure that result is signed
            hold |= input[next++] << bits;
            bits += 8;
          }
          //===//
          _out -= left;
          strm.total_out += _out;
          state.total += _out;
          if (_out) {
            strm.adler = state.check =
                /*UPDATE(state.check, put - _out, _out);*/
                (state.flags ? crc32(state.check, output, _out, put - _out) : adler32(state.check, output, _out, put - _out));

          }
          _out = left;
          // NB: crc32 stored as signed 32-bit int, zswap32 returns signed too
          if ((state.flags ? hold : zswap32(hold)) !== state.check) {
            strm.msg = 'incorrect data check';
            state.mode = BAD;
            break;
          }
          //=== INITBITS();
          hold = 0;
          bits = 0;
          //===//
          //Tracev((stderr, "inflate:   check matches trailer\n"));
        }
        state.mode = LENGTH;
        /* falls through */
      case LENGTH:
        if (state.wrap && state.flags) {
          //=== NEEDBITS(32);
          while (bits < 32) {
            if (have === 0) { break inf_leave; }
            have--;
            hold += input[next++] << bits;
            bits += 8;
          }
          //===//
          if (hold !== (state.total & 0xffffffff)) {
            strm.msg = 'incorrect length check';
            state.mode = BAD;
            break;
          }
          //=== INITBITS();
          hold = 0;
          bits = 0;
          //===//
          //Tracev((stderr, "inflate:   length matches trailer\n"));
        }
        state.mode = DONE;
        /* falls through */
      case DONE:
        ret = Z_STREAM_END;
        break inf_leave;
      case BAD:
        ret = Z_DATA_ERROR;
        break inf_leave;
      case MEM:
        return Z_MEM_ERROR;
      case SYNC:
        /* falls through */
      default:
        return Z_STREAM_ERROR;
    }
  }

  // inf_leave <- here is real place for "goto inf_leave", emulated via "break inf_leave"

  /*
     Return from inflate(), updating the total counts and the check value.
     If there was no progress during the inflate() call, return a buffer
     error.  Call updatewindow() to create and/or update the window state.
     Note: a memory error from inflate() is non-recoverable.
   */

  //--- RESTORE() ---
  strm.next_out = put;
  strm.avail_out = left;
  strm.next_in = next;
  strm.avail_in = have;
  state.hold = hold;
  state.bits = bits;
  //---

  if (state.wsize || (_out !== strm.avail_out && state.mode < BAD &&
                      (state.mode < CHECK || flush !== Z_FINISH))) {
    if (updatewindow(strm, strm.output, strm.next_out, _out - strm.avail_out)) {
      state.mode = MEM;
      return Z_MEM_ERROR;
    }
  }
  _in -= strm.avail_in;
  _out -= strm.avail_out;
  strm.total_in += _in;
  strm.total_out += _out;
  state.total += _out;
  if (state.wrap && _out) {
    strm.adler = state.check = /*UPDATE(state.check, strm.next_out - _out, _out);*/
      (state.flags ? crc32(state.check, output, _out, strm.next_out - _out) : adler32(state.check, output, _out, strm.next_out - _out));
  }
  strm.data_type = state.bits + (state.last ? 64 : 0) +
                    (state.mode === TYPE ? 128 : 0) +
                    (state.mode === LEN_ || state.mode === COPY_ ? 256 : 0);
  if (((_in === 0 && _out === 0) || flush === Z_FINISH) && ret === Z_OK) {
    ret = Z_BUF_ERROR;
  }
  return ret;
}

function inflateEnd(strm) {

  if (!strm || !strm.state /*|| strm->zfree == (free_func)0*/) {
    return Z_STREAM_ERROR;
  }

  var state = strm.state;
  if (state.window) {
    state.window = null;
  }
  strm.state = null;
  return Z_OK;
}

function inflateGetHeader(strm, head) {
  var state;

  /* check state */
  if (!strm || !strm.state) { return Z_STREAM_ERROR; }
  state = strm.state;
  if ((state.wrap & 2) === 0) { return Z_STREAM_ERROR; }

  /* save header structure */
  state.head = head;
  head.done = false;
  return Z_OK;
}

function inflateSetDictionary(strm, dictionary) {
  var dictLength = dictionary.length;

  var state;
  var dictid;
  var ret;

  /* check state */
  if (!strm /* == Z_NULL */ || !strm.state /* == Z_NULL */) { return Z_STREAM_ERROR; }
  state = strm.state;

  if (state.wrap !== 0 && state.mode !== DICT) {
    return Z_STREAM_ERROR;
  }

  /* check for correct dictionary identifier */
  if (state.mode === DICT) {
    dictid = 1; /* adler32(0, null, 0)*/
    /* dictid = adler32(dictid, dictionary, dictLength); */
    dictid = adler32(dictid, dictionary, dictLength, 0);
    if (dictid !== state.check) {
      return Z_DATA_ERROR;
    }
  }
  /* copy dictionary to window using updatewindow(), which will amend the
   existing dictionary if appropriate */
  ret = updatewindow(strm, dictionary, dictLength, dictLength);
  if (ret) {
    state.mode = MEM;
    return Z_MEM_ERROR;
  }
  state.havedict = 1;
  // Tracev((stderr, "inflate:   dictionary set\n"));
  return Z_OK;
}

exports.inflateReset = inflateReset;
exports.inflateReset2 = inflateReset2;
exports.inflateResetKeep = inflateResetKeep;
exports.inflateInit = inflateInit;
exports.inflateInit2 = inflateInit2;
exports.inflate = inflate;
exports.inflateEnd = inflateEnd;
exports.inflateGetHeader = inflateGetHeader;
exports.inflateSetDictionary = inflateSetDictionary;
exports.inflateInfo = 'pako inflate (from Nodeca project)';

/* Not implemented
exports.inflateCopy = inflateCopy;
exports.inflateGetDictionary = inflateGetDictionary;
exports.inflateMark = inflateMark;
exports.inflatePrime = inflatePrime;
exports.inflateSync = inflateSync;
exports.inflateSyncPoint = inflateSyncPoint;
exports.inflateUndermine = inflateUndermine;
*/

},{"../utils/common":62,"./adler32":63,"./crc32":65,"./inffast":67,"./inftrees":69}],69:[function(require,module,exports){
'use strict';

// (C) 1995-2013 Jean-loup Gailly and Mark Adler
// (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
//
// This software is provided 'as-is', without any express or implied
// warranty. In no event will the authors be held liable for any damages
// arising from the use of this software.
//
// Permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions:
//
// 1. The origin of this software must not be misrepresented; you must not
//   claim that you wrote the original software. If you use this software
//   in a product, an acknowledgment in the product documentation would be
//   appreciated but is not required.
// 2. Altered source versions must be plainly marked as such, and must not be
//   misrepresented as being the original software.
// 3. This notice may not be removed or altered from any source distribution.

var utils = require('../utils/common');

var MAXBITS = 15;
var ENOUGH_LENS = 852;
var ENOUGH_DISTS = 592;
//var ENOUGH = (ENOUGH_LENS+ENOUGH_DISTS);

var CODES = 0;
var LENS = 1;
var DISTS = 2;

var lbase = [ /* Length codes 257..285 base */
  3, 4, 5, 6, 7, 8, 9, 10, 11, 13, 15, 17, 19, 23, 27, 31,
  35, 43, 51, 59, 67, 83, 99, 115, 131, 163, 195, 227, 258, 0, 0
];

var lext = [ /* Length codes 257..285 extra */
  16, 16, 16, 16, 16, 16, 16, 16, 17, 17, 17, 17, 18, 18, 18, 18,
  19, 19, 19, 19, 20, 20, 20, 20, 21, 21, 21, 21, 16, 72, 78
];

var dbase = [ /* Distance codes 0..29 base */
  1, 2, 3, 4, 5, 7, 9, 13, 17, 25, 33, 49, 65, 97, 129, 193,
  257, 385, 513, 769, 1025, 1537, 2049, 3073, 4097, 6145,
  8193, 12289, 16385, 24577, 0, 0
];

var dext = [ /* Distance codes 0..29 extra */
  16, 16, 16, 16, 17, 17, 18, 18, 19, 19, 20, 20, 21, 21, 22, 22,
  23, 23, 24, 24, 25, 25, 26, 26, 27, 27,
  28, 28, 29, 29, 64, 64
];

module.exports = function inflate_table(type, lens, lens_index, codes, table, table_index, work, opts)
{
  var bits = opts.bits;
      //here = opts.here; /* table entry for duplication */

  var len = 0;               /* a code's length in bits */
  var sym = 0;               /* index of code symbols */
  var min = 0, max = 0;          /* minimum and maximum code lengths */
  var root = 0;              /* number of index bits for root table */
  var curr = 0;              /* number of index bits for current table */
  var drop = 0;              /* code bits to drop for sub-table */
  var left = 0;                   /* number of prefix codes available */
  var used = 0;              /* code entries in table used */
  var huff = 0;              /* Huffman code */
  var incr;              /* for incrementing code, index */
  var fill;              /* index for replicating entries */
  var low;               /* low bits for current root entry */
  var mask;              /* mask for low root bits */
  var next;             /* next available space in table */
  var base = null;     /* base value table to use */
  var base_index = 0;
//  var shoextra;    /* extra bits table to use */
  var end;                    /* use base and extra for symbol > end */
  var count = new utils.Buf16(MAXBITS + 1); //[MAXBITS+1];    /* number of codes of each length */
  var offs = new utils.Buf16(MAXBITS + 1); //[MAXBITS+1];     /* offsets in table for each length */
  var extra = null;
  var extra_index = 0;

  var here_bits, here_op, here_val;

  /*
   Process a set of code lengths to create a canonical Huffman code.  The
   code lengths are lens[0..codes-1].  Each length corresponds to the
   symbols 0..codes-1.  The Huffman code is generated by first sorting the
   symbols by length from short to long, and retaining the symbol order
   for codes with equal lengths.  Then the code starts with all zero bits
   for the first code of the shortest length, and the codes are integer
   increments for the same length, and zeros are appended as the length
   increases.  For the deflate format, these bits are stored backwards
   from their more natural integer increment ordering, and so when the
   decoding tables are built in the large loop below, the integer codes
   are incremented backwards.

   This routine assumes, but does not check, that all of the entries in
   lens[] are in the range 0..MAXBITS.  The caller must assure this.
   1..MAXBITS is interpreted as that code length.  zero means that that
   symbol does not occur in this code.

   The codes are sorted by computing a count of codes for each length,
   creating from that a table of starting indices for each length in the
   sorted table, and then entering the symbols in order in the sorted
   table.  The sorted table is work[], with that space being provided by
   the caller.

   The length counts are used for other purposes as well, i.e. finding
   the minimum and maximum length codes, determining if there are any
   codes at all, checking for a valid set of lengths, and looking ahead
   at length counts to determine sub-table sizes when building the
   decoding tables.
   */

  /* accumulate lengths for codes (assumes lens[] all in 0..MAXBITS) */
  for (len = 0; len <= MAXBITS; len++) {
    count[len] = 0;
  }
  for (sym = 0; sym < codes; sym++) {
    count[lens[lens_index + sym]]++;
  }

  /* bound code lengths, force root to be within code lengths */
  root = bits;
  for (max = MAXBITS; max >= 1; max--) {
    if (count[max] !== 0) { break; }
  }
  if (root > max) {
    root = max;
  }
  if (max === 0) {                     /* no symbols to code at all */
    //table.op[opts.table_index] = 64;  //here.op = (var char)64;    /* invalid code marker */
    //table.bits[opts.table_index] = 1;   //here.bits = (var char)1;
    //table.val[opts.table_index++] = 0;   //here.val = (var short)0;
    table[table_index++] = (1 << 24) | (64 << 16) | 0;


    //table.op[opts.table_index] = 64;
    //table.bits[opts.table_index] = 1;
    //table.val[opts.table_index++] = 0;
    table[table_index++] = (1 << 24) | (64 << 16) | 0;

    opts.bits = 1;
    return 0;     /* no symbols, but wait for decoding to report error */
  }
  for (min = 1; min < max; min++) {
    if (count[min] !== 0) { break; }
  }
  if (root < min) {
    root = min;
  }

  /* check for an over-subscribed or incomplete set of lengths */
  left = 1;
  for (len = 1; len <= MAXBITS; len++) {
    left <<= 1;
    left -= count[len];
    if (left < 0) {
      return -1;
    }        /* over-subscribed */
  }
  if (left > 0 && (type === CODES || max !== 1)) {
    return -1;                      /* incomplete set */
  }

  /* generate offsets into symbol table for each length for sorting */
  offs[1] = 0;
  for (len = 1; len < MAXBITS; len++) {
    offs[len + 1] = offs[len] + count[len];
  }

  /* sort symbols by length, by symbol order within each length */
  for (sym = 0; sym < codes; sym++) {
    if (lens[lens_index + sym] !== 0) {
      work[offs[lens[lens_index + sym]]++] = sym;
    }
  }

  /*
   Create and fill in decoding tables.  In this loop, the table being
   filled is at next and has curr index bits.  The code being used is huff
   with length len.  That code is converted to an index by dropping drop
   bits off of the bottom.  For codes where len is less than drop + curr,
   those top drop + curr - len bits are incremented through all values to
   fill the table with replicated entries.

   root is the number of index bits for the root table.  When len exceeds
   root, sub-tables are created pointed to by the root entry with an index
   of the low root bits of huff.  This is saved in low to check for when a
   new sub-table should be started.  drop is zero when the root table is
   being filled, and drop is root when sub-tables are being filled.

   When a new sub-table is needed, it is necessary to look ahead in the
   code lengths to determine what size sub-table is needed.  The length
   counts are used for this, and so count[] is decremented as codes are
   entered in the tables.

   used keeps track of how many table entries have been allocated from the
   provided *table space.  It is checked for LENS and DIST tables against
   the constants ENOUGH_LENS and ENOUGH_DISTS to guard against changes in
   the initial root table size constants.  See the comments in inftrees.h
   for more information.

   sym increments through all symbols, and the loop terminates when
   all codes of length max, i.e. all codes, have been processed.  This
   routine permits incomplete codes, so another loop after this one fills
   in the rest of the decoding tables with invalid code markers.
   */

  /* set up for code type */
  // poor man optimization - use if-else instead of switch,
  // to avoid deopts in old v8
  if (type === CODES) {
    base = extra = work;    /* dummy value--not used */
    end = 19;

  } else if (type === LENS) {
    base = lbase;
    base_index -= 257;
    extra = lext;
    extra_index -= 257;
    end = 256;

  } else {                    /* DISTS */
    base = dbase;
    extra = dext;
    end = -1;
  }

  /* initialize opts for loop */
  huff = 0;                   /* starting code */
  sym = 0;                    /* starting code symbol */
  len = min;                  /* starting code length */
  next = table_index;              /* current table to fill in */
  curr = root;                /* current table index bits */
  drop = 0;                   /* current bits to drop from code for index */
  low = -1;                   /* trigger new sub-table when len > root */
  used = 1 << root;          /* use root table entries */
  mask = used - 1;            /* mask for comparing low */

  /* check available table space */
  if ((type === LENS && used > ENOUGH_LENS) ||
    (type === DISTS && used > ENOUGH_DISTS)) {
    return 1;
  }

  /* process all codes and make table entries */
  for (;;) {
    /* create table entry */
    here_bits = len - drop;
    if (work[sym] < end) {
      here_op = 0;
      here_val = work[sym];
    }
    else if (work[sym] > end) {
      here_op = extra[extra_index + work[sym]];
      here_val = base[base_index + work[sym]];
    }
    else {
      here_op = 32 + 64;         /* end of block */
      here_val = 0;
    }

    /* replicate for those indices with low len bits equal to huff */
    incr = 1 << (len - drop);
    fill = 1 << curr;
    min = fill;                 /* save offset to next table */
    do {
      fill -= incr;
      table[next + (huff >> drop) + fill] = (here_bits << 24) | (here_op << 16) | here_val |0;
    } while (fill !== 0);

    /* backwards increment the len-bit code huff */
    incr = 1 << (len - 1);
    while (huff & incr) {
      incr >>= 1;
    }
    if (incr !== 0) {
      huff &= incr - 1;
      huff += incr;
    } else {
      huff = 0;
    }

    /* go to next symbol, update count, len */
    sym++;
    if (--count[len] === 0) {
      if (len === max) { break; }
      len = lens[lens_index + work[sym]];
    }

    /* create new sub-table if needed */
    if (len > root && (huff & mask) !== low) {
      /* if first time, transition to sub-tables */
      if (drop === 0) {
        drop = root;
      }

      /* increment past last table */
      next += min;            /* here min is 1 << curr */

      /* determine length of next table */
      curr = len - drop;
      left = 1 << curr;
      while (curr + drop < max) {
        left -= count[curr + drop];
        if (left <= 0) { break; }
        curr++;
        left <<= 1;
      }

      /* check for enough space */
      used += 1 << curr;
      if ((type === LENS && used > ENOUGH_LENS) ||
        (type === DISTS && used > ENOUGH_DISTS)) {
        return 1;
      }

      /* point entry in root table to sub-table */
      low = huff & mask;
      /*table.op[low] = curr;
      table.bits[low] = root;
      table.val[low] = next - opts.table_index;*/
      table[low] = (root << 24) | (curr << 16) | (next - table_index) |0;
    }
  }

  /* fill in remaining table entry if code is incomplete (guaranteed to have
   at most one remaining entry, since if the code is incomplete, the
   maximum code length that was allowed to get this far is one bit) */
  if (huff !== 0) {
    //table.op[next + huff] = 64;            /* invalid code marker */
    //table.bits[next + huff] = len - drop;
    //table.val[next + huff] = 0;
    table[next + huff] = ((len - drop) << 24) | (64 << 16) |0;
  }

  /* set return parameters */
  //opts.table_index += used;
  opts.bits = root;
  return 0;
};

},{"../utils/common":62}],70:[function(require,module,exports){
'use strict';

// (C) 1995-2013 Jean-loup Gailly and Mark Adler
// (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
//
// This software is provided 'as-is', without any express or implied
// warranty. In no event will the authors be held liable for any damages
// arising from the use of this software.
//
// Permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions:
//
// 1. The origin of this software must not be misrepresented; you must not
//   claim that you wrote the original software. If you use this software
//   in a product, an acknowledgment in the product documentation would be
//   appreciated but is not required.
// 2. Altered source versions must be plainly marked as such, and must not be
//   misrepresented as being the original software.
// 3. This notice may not be removed or altered from any source distribution.

module.exports = {
  2:      'need dictionary',     /* Z_NEED_DICT       2  */
  1:      'stream end',          /* Z_STREAM_END      1  */
  0:      '',                    /* Z_OK              0  */
  '-1':   'file error',          /* Z_ERRNO         (-1) */
  '-2':   'stream error',        /* Z_STREAM_ERROR  (-2) */
  '-3':   'data error',          /* Z_DATA_ERROR    (-3) */
  '-4':   'insufficient memory', /* Z_MEM_ERROR     (-4) */
  '-5':   'buffer error',        /* Z_BUF_ERROR     (-5) */
  '-6':   'incompatible version' /* Z_VERSION_ERROR (-6) */
};

},{}],71:[function(require,module,exports){
'use strict';

// (C) 1995-2013 Jean-loup Gailly and Mark Adler
// (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
//
// This software is provided 'as-is', without any express or implied
// warranty. In no event will the authors be held liable for any damages
// arising from the use of this software.
//
// Permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions:
//
// 1. The origin of this software must not be misrepresented; you must not
//   claim that you wrote the original software. If you use this software
//   in a product, an acknowledgment in the product documentation would be
//   appreciated but is not required.
// 2. Altered source versions must be plainly marked as such, and must not be
//   misrepresented as being the original software.
// 3. This notice may not be removed or altered from any source distribution.

/* eslint-disable space-unary-ops */

var utils = require('../utils/common');

/* Public constants ==========================================================*/
/* ===========================================================================*/


//var Z_FILTERED          = 1;
//var Z_HUFFMAN_ONLY      = 2;
//var Z_RLE               = 3;
var Z_FIXED               = 4;
//var Z_DEFAULT_STRATEGY  = 0;

/* Possible values of the data_type field (though see inflate()) */
var Z_BINARY              = 0;
var Z_TEXT                = 1;
//var Z_ASCII             = 1; // = Z_TEXT
var Z_UNKNOWN             = 2;

/*============================================================================*/


function zero(buf) { var len = buf.length; while (--len >= 0) { buf[len] = 0; } }

// From zutil.h

var STORED_BLOCK = 0;
var STATIC_TREES = 1;
var DYN_TREES    = 2;
/* The three kinds of block type */

var MIN_MATCH    = 3;
var MAX_MATCH    = 258;
/* The minimum and maximum match lengths */

// From deflate.h
/* ===========================================================================
 * Internal compression state.
 */

var LENGTH_CODES  = 29;
/* number of length codes, not counting the special END_BLOCK code */

var LITERALS      = 256;
/* number of literal bytes 0..255 */

var L_CODES       = LITERALS + 1 + LENGTH_CODES;
/* number of Literal or Length codes, including the END_BLOCK code */

var D_CODES       = 30;
/* number of distance codes */

var BL_CODES      = 19;
/* number of codes used to transfer the bit lengths */

var HEAP_SIZE     = 2 * L_CODES + 1;
/* maximum heap size */

var MAX_BITS      = 15;
/* All codes must not exceed MAX_BITS bits */

var Buf_size      = 16;
/* size of bit buffer in bi_buf */


/* ===========================================================================
 * Constants
 */

var MAX_BL_BITS = 7;
/* Bit length codes must not exceed MAX_BL_BITS bits */

var END_BLOCK   = 256;
/* end of block literal code */

var REP_3_6     = 16;
/* repeat previous bit length 3-6 times (2 bits of repeat count) */

var REPZ_3_10   = 17;
/* repeat a zero length 3-10 times  (3 bits of repeat count) */

var REPZ_11_138 = 18;
/* repeat a zero length 11-138 times  (7 bits of repeat count) */

/* eslint-disable comma-spacing,array-bracket-spacing */
var extra_lbits =   /* extra bits for each length code */
  [0,0,0,0,0,0,0,0,1,1,1,1,2,2,2,2,3,3,3,3,4,4,4,4,5,5,5,5,0];

var extra_dbits =   /* extra bits for each distance code */
  [0,0,0,0,1,1,2,2,3,3,4,4,5,5,6,6,7,7,8,8,9,9,10,10,11,11,12,12,13,13];

var extra_blbits =  /* extra bits for each bit length code */
  [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,7];

var bl_order =
  [16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15];
/* eslint-enable comma-spacing,array-bracket-spacing */

/* The lengths of the bit length codes are sent in order of decreasing
 * probability, to avoid transmitting the lengths for unused bit length codes.
 */

/* ===========================================================================
 * Local data. These are initialized only once.
 */

// We pre-fill arrays with 0 to avoid uninitialized gaps

var DIST_CODE_LEN = 512; /* see definition of array dist_code below */

// !!!! Use flat array instead of structure, Freq = i*2, Len = i*2+1
var static_ltree  = new Array((L_CODES + 2) * 2);
zero(static_ltree);
/* The static literal tree. Since the bit lengths are imposed, there is no
 * need for the L_CODES extra codes used during heap construction. However
 * The codes 286 and 287 are needed to build a canonical tree (see _tr_init
 * below).
 */

var static_dtree  = new Array(D_CODES * 2);
zero(static_dtree);
/* The static distance tree. (Actually a trivial tree since all codes use
 * 5 bits.)
 */

var _dist_code    = new Array(DIST_CODE_LEN);
zero(_dist_code);
/* Distance codes. The first 256 values correspond to the distances
 * 3 .. 258, the last 256 values correspond to the top 8 bits of
 * the 15 bit distances.
 */

var _length_code  = new Array(MAX_MATCH - MIN_MATCH + 1);
zero(_length_code);
/* length code for each normalized match length (0 == MIN_MATCH) */

var base_length   = new Array(LENGTH_CODES);
zero(base_length);
/* First normalized length for each code (0 = MIN_MATCH) */

var base_dist     = new Array(D_CODES);
zero(base_dist);
/* First normalized distance for each code (0 = distance of 1) */


function StaticTreeDesc(static_tree, extra_bits, extra_base, elems, max_length) {

  this.static_tree  = static_tree;  /* static tree or NULL */
  this.extra_bits   = extra_bits;   /* extra bits for each code or NULL */
  this.extra_base   = extra_base;   /* base index for extra_bits */
  this.elems        = elems;        /* max number of elements in the tree */
  this.max_length   = max_length;   /* max bit length for the codes */

  // show if `static_tree` has data or dummy - needed for monomorphic objects
  this.has_stree    = static_tree && static_tree.length;
}


var static_l_desc;
var static_d_desc;
var static_bl_desc;


function TreeDesc(dyn_tree, stat_desc) {
  this.dyn_tree = dyn_tree;     /* the dynamic tree */
  this.max_code = 0;            /* largest code with non zero frequency */
  this.stat_desc = stat_desc;   /* the corresponding static tree */
}



function d_code(dist) {
  return dist < 256 ? _dist_code[dist] : _dist_code[256 + (dist >>> 7)];
}


/* ===========================================================================
 * Output a short LSB first on the stream.
 * IN assertion: there is enough room in pendingBuf.
 */
function put_short(s, w) {
//    put_byte(s, (uch)((w) & 0xff));
//    put_byte(s, (uch)((ush)(w) >> 8));
  s.pending_buf[s.pending++] = (w) & 0xff;
  s.pending_buf[s.pending++] = (w >>> 8) & 0xff;
}


/* ===========================================================================
 * Send a value on a given number of bits.
 * IN assertion: length <= 16 and value fits in length bits.
 */
function send_bits(s, value, length) {
  if (s.bi_valid > (Buf_size - length)) {
    s.bi_buf |= (value << s.bi_valid) & 0xffff;
    put_short(s, s.bi_buf);
    s.bi_buf = value >> (Buf_size - s.bi_valid);
    s.bi_valid += length - Buf_size;
  } else {
    s.bi_buf |= (value << s.bi_valid) & 0xffff;
    s.bi_valid += length;
  }
}


function send_code(s, c, tree) {
  send_bits(s, tree[c * 2]/*.Code*/, tree[c * 2 + 1]/*.Len*/);
}


/* ===========================================================================
 * Reverse the first len bits of a code, using straightforward code (a faster
 * method would use a table)
 * IN assertion: 1 <= len <= 15
 */
function bi_reverse(code, len) {
  var res = 0;
  do {
    res |= code & 1;
    code >>>= 1;
    res <<= 1;
  } while (--len > 0);
  return res >>> 1;
}


/* ===========================================================================
 * Flush the bit buffer, keeping at most 7 bits in it.
 */
function bi_flush(s) {
  if (s.bi_valid === 16) {
    put_short(s, s.bi_buf);
    s.bi_buf = 0;
    s.bi_valid = 0;

  } else if (s.bi_valid >= 8) {
    s.pending_buf[s.pending++] = s.bi_buf & 0xff;
    s.bi_buf >>= 8;
    s.bi_valid -= 8;
  }
}


/* ===========================================================================
 * Compute the optimal bit lengths for a tree and update the total bit length
 * for the current block.
 * IN assertion: the fields freq and dad are set, heap[heap_max] and
 *    above are the tree nodes sorted by increasing frequency.
 * OUT assertions: the field len is set to the optimal bit length, the
 *     array bl_count contains the frequencies for each bit length.
 *     The length opt_len is updated; static_len is also updated if stree is
 *     not null.
 */
function gen_bitlen(s, desc)
//    deflate_state *s;
//    tree_desc *desc;    /* the tree descriptor */
{
  var tree            = desc.dyn_tree;
  var max_code        = desc.max_code;
  var stree           = desc.stat_desc.static_tree;
  var has_stree       = desc.stat_desc.has_stree;
  var extra           = desc.stat_desc.extra_bits;
  var base            = desc.stat_desc.extra_base;
  var max_length      = desc.stat_desc.max_length;
  var h;              /* heap index */
  var n, m;           /* iterate over the tree elements */
  var bits;           /* bit length */
  var xbits;          /* extra bits */
  var f;              /* frequency */
  var overflow = 0;   /* number of elements with bit length too large */

  for (bits = 0; bits <= MAX_BITS; bits++) {
    s.bl_count[bits] = 0;
  }

  /* In a first pass, compute the optimal bit lengths (which may
   * overflow in the case of the bit length tree).
   */
  tree[s.heap[s.heap_max] * 2 + 1]/*.Len*/ = 0; /* root of the heap */

  for (h = s.heap_max + 1; h < HEAP_SIZE; h++) {
    n = s.heap[h];
    bits = tree[tree[n * 2 + 1]/*.Dad*/ * 2 + 1]/*.Len*/ + 1;
    if (bits > max_length) {
      bits = max_length;
      overflow++;
    }
    tree[n * 2 + 1]/*.Len*/ = bits;
    /* We overwrite tree[n].Dad which is no longer needed */

    if (n > max_code) { continue; } /* not a leaf node */

    s.bl_count[bits]++;
    xbits = 0;
    if (n >= base) {
      xbits = extra[n - base];
    }
    f = tree[n * 2]/*.Freq*/;
    s.opt_len += f * (bits + xbits);
    if (has_stree) {
      s.static_len += f * (stree[n * 2 + 1]/*.Len*/ + xbits);
    }
  }
  if (overflow === 0) { return; }

  // Trace((stderr,"\nbit length overflow\n"));
  /* This happens for example on obj2 and pic of the Calgary corpus */

  /* Find the first bit length which could increase: */
  do {
    bits = max_length - 1;
    while (s.bl_count[bits] === 0) { bits--; }
    s.bl_count[bits]--;      /* move one leaf down the tree */
    s.bl_count[bits + 1] += 2; /* move one overflow item as its brother */
    s.bl_count[max_length]--;
    /* The brother of the overflow item also moves one step up,
     * but this does not affect bl_count[max_length]
     */
    overflow -= 2;
  } while (overflow > 0);

  /* Now recompute all bit lengths, scanning in increasing frequency.
   * h is still equal to HEAP_SIZE. (It is simpler to reconstruct all
   * lengths instead of fixing only the wrong ones. This idea is taken
   * from 'ar' written by Haruhiko Okumura.)
   */
  for (bits = max_length; bits !== 0; bits--) {
    n = s.bl_count[bits];
    while (n !== 0) {
      m = s.heap[--h];
      if (m > max_code) { continue; }
      if (tree[m * 2 + 1]/*.Len*/ !== bits) {
        // Trace((stderr,"code %d bits %d->%d\n", m, tree[m].Len, bits));
        s.opt_len += (bits - tree[m * 2 + 1]/*.Len*/) * tree[m * 2]/*.Freq*/;
        tree[m * 2 + 1]/*.Len*/ = bits;
      }
      n--;
    }
  }
}


/* ===========================================================================
 * Generate the codes for a given tree and bit counts (which need not be
 * optimal).
 * IN assertion: the array bl_count contains the bit length statistics for
 * the given tree and the field len is set for all tree elements.
 * OUT assertion: the field code is set for all tree elements of non
 *     zero code length.
 */
function gen_codes(tree, max_code, bl_count)
//    ct_data *tree;             /* the tree to decorate */
//    int max_code;              /* largest code with non zero frequency */
//    ushf *bl_count;            /* number of codes at each bit length */
{
  var next_code = new Array(MAX_BITS + 1); /* next code value for each bit length */
  var code = 0;              /* running code value */
  var bits;                  /* bit index */
  var n;                     /* code index */

  /* The distribution counts are first used to generate the code values
   * without bit reversal.
   */
  for (bits = 1; bits <= MAX_BITS; bits++) {
    next_code[bits] = code = (code + bl_count[bits - 1]) << 1;
  }
  /* Check that the bit counts in bl_count are consistent. The last code
   * must be all ones.
   */
  //Assert (code + bl_count[MAX_BITS]-1 == (1<<MAX_BITS)-1,
  //        "inconsistent bit counts");
  //Tracev((stderr,"\ngen_codes: max_code %d ", max_code));

  for (n = 0;  n <= max_code; n++) {
    var len = tree[n * 2 + 1]/*.Len*/;
    if (len === 0) { continue; }
    /* Now reverse the bits */
    tree[n * 2]/*.Code*/ = bi_reverse(next_code[len]++, len);

    //Tracecv(tree != static_ltree, (stderr,"\nn %3d %c l %2d c %4x (%x) ",
    //     n, (isgraph(n) ? n : ' '), len, tree[n].Code, next_code[len]-1));
  }
}


/* ===========================================================================
 * Initialize the various 'constant' tables.
 */
function tr_static_init() {
  var n;        /* iterates over tree elements */
  var bits;     /* bit counter */
  var length;   /* length value */
  var code;     /* code value */
  var dist;     /* distance index */
  var bl_count = new Array(MAX_BITS + 1);
  /* number of codes at each bit length for an optimal tree */

  // do check in _tr_init()
  //if (static_init_done) return;

  /* For some embedded targets, global variables are not initialized: */
/*#ifdef NO_INIT_GLOBAL_POINTERS
  static_l_desc.static_tree = static_ltree;
  static_l_desc.extra_bits = extra_lbits;
  static_d_desc.static_tree = static_dtree;
  static_d_desc.extra_bits = extra_dbits;
  static_bl_desc.extra_bits = extra_blbits;
#endif*/

  /* Initialize the mapping length (0..255) -> length code (0..28) */
  length = 0;
  for (code = 0; code < LENGTH_CODES - 1; code++) {
    base_length[code] = length;
    for (n = 0; n < (1 << extra_lbits[code]); n++) {
      _length_code[length++] = code;
    }
  }
  //Assert (length == 256, "tr_static_init: length != 256");
  /* Note that the length 255 (match length 258) can be represented
   * in two different ways: code 284 + 5 bits or code 285, so we
   * overwrite length_code[255] to use the best encoding:
   */
  _length_code[length - 1] = code;

  /* Initialize the mapping dist (0..32K) -> dist code (0..29) */
  dist = 0;
  for (code = 0; code < 16; code++) {
    base_dist[code] = dist;
    for (n = 0; n < (1 << extra_dbits[code]); n++) {
      _dist_code[dist++] = code;
    }
  }
  //Assert (dist == 256, "tr_static_init: dist != 256");
  dist >>= 7; /* from now on, all distances are divided by 128 */
  for (; code < D_CODES; code++) {
    base_dist[code] = dist << 7;
    for (n = 0; n < (1 << (extra_dbits[code] - 7)); n++) {
      _dist_code[256 + dist++] = code;
    }
  }
  //Assert (dist == 256, "tr_static_init: 256+dist != 512");

  /* Construct the codes of the static literal tree */
  for (bits = 0; bits <= MAX_BITS; bits++) {
    bl_count[bits] = 0;
  }

  n = 0;
  while (n <= 143) {
    static_ltree[n * 2 + 1]/*.Len*/ = 8;
    n++;
    bl_count[8]++;
  }
  while (n <= 255) {
    static_ltree[n * 2 + 1]/*.Len*/ = 9;
    n++;
    bl_count[9]++;
  }
  while (n <= 279) {
    static_ltree[n * 2 + 1]/*.Len*/ = 7;
    n++;
    bl_count[7]++;
  }
  while (n <= 287) {
    static_ltree[n * 2 + 1]/*.Len*/ = 8;
    n++;
    bl_count[8]++;
  }
  /* Codes 286 and 287 do not exist, but we must include them in the
   * tree construction to get a canonical Huffman tree (longest code
   * all ones)
   */
  gen_codes(static_ltree, L_CODES + 1, bl_count);

  /* The static distance tree is trivial: */
  for (n = 0; n < D_CODES; n++) {
    static_dtree[n * 2 + 1]/*.Len*/ = 5;
    static_dtree[n * 2]/*.Code*/ = bi_reverse(n, 5);
  }

  // Now data ready and we can init static trees
  static_l_desc = new StaticTreeDesc(static_ltree, extra_lbits, LITERALS + 1, L_CODES, MAX_BITS);
  static_d_desc = new StaticTreeDesc(static_dtree, extra_dbits, 0,          D_CODES, MAX_BITS);
  static_bl_desc = new StaticTreeDesc(new Array(0), extra_blbits, 0,         BL_CODES, MAX_BL_BITS);

  //static_init_done = true;
}


/* ===========================================================================
 * Initialize a new block.
 */
function init_block(s) {
  var n; /* iterates over tree elements */

  /* Initialize the trees. */
  for (n = 0; n < L_CODES;  n++) { s.dyn_ltree[n * 2]/*.Freq*/ = 0; }
  for (n = 0; n < D_CODES;  n++) { s.dyn_dtree[n * 2]/*.Freq*/ = 0; }
  for (n = 0; n < BL_CODES; n++) { s.bl_tree[n * 2]/*.Freq*/ = 0; }

  s.dyn_ltree[END_BLOCK * 2]/*.Freq*/ = 1;
  s.opt_len = s.static_len = 0;
  s.last_lit = s.matches = 0;
}


/* ===========================================================================
 * Flush the bit buffer and align the output on a byte boundary
 */
function bi_windup(s)
{
  if (s.bi_valid > 8) {
    put_short(s, s.bi_buf);
  } else if (s.bi_valid > 0) {
    //put_byte(s, (Byte)s->bi_buf);
    s.pending_buf[s.pending++] = s.bi_buf;
  }
  s.bi_buf = 0;
  s.bi_valid = 0;
}

/* ===========================================================================
 * Copy a stored block, storing first the length and its
 * one's complement if requested.
 */
function copy_block(s, buf, len, header)
//DeflateState *s;
//charf    *buf;    /* the input data */
//unsigned len;     /* its length */
//int      header;  /* true if block header must be written */
{
  bi_windup(s);        /* align on byte boundary */

  if (header) {
    put_short(s, len);
    put_short(s, ~len);
  }
//  while (len--) {
//    put_byte(s, *buf++);
//  }
  utils.arraySet(s.pending_buf, s.window, buf, len, s.pending);
  s.pending += len;
}

/* ===========================================================================
 * Compares to subtrees, using the tree depth as tie breaker when
 * the subtrees have equal frequency. This minimizes the worst case length.
 */
function smaller(tree, n, m, depth) {
  var _n2 = n * 2;
  var _m2 = m * 2;
  return (tree[_n2]/*.Freq*/ < tree[_m2]/*.Freq*/ ||
         (tree[_n2]/*.Freq*/ === tree[_m2]/*.Freq*/ && depth[n] <= depth[m]));
}

/* ===========================================================================
 * Restore the heap property by moving down the tree starting at node k,
 * exchanging a node with the smallest of its two sons if necessary, stopping
 * when the heap property is re-established (each father smaller than its
 * two sons).
 */
function pqdownheap(s, tree, k)
//    deflate_state *s;
//    ct_data *tree;  /* the tree to restore */
//    int k;               /* node to move down */
{
  var v = s.heap[k];
  var j = k << 1;  /* left son of k */
  while (j <= s.heap_len) {
    /* Set j to the smallest of the two sons: */
    if (j < s.heap_len &&
      smaller(tree, s.heap[j + 1], s.heap[j], s.depth)) {
      j++;
    }
    /* Exit if v is smaller than both sons */
    if (smaller(tree, v, s.heap[j], s.depth)) { break; }

    /* Exchange v with the smallest son */
    s.heap[k] = s.heap[j];
    k = j;

    /* And continue down the tree, setting j to the left son of k */
    j <<= 1;
  }
  s.heap[k] = v;
}


// inlined manually
// var SMALLEST = 1;

/* ===========================================================================
 * Send the block data compressed using the given Huffman trees
 */
function compress_block(s, ltree, dtree)
//    deflate_state *s;
//    const ct_data *ltree; /* literal tree */
//    const ct_data *dtree; /* distance tree */
{
  var dist;           /* distance of matched string */
  var lc;             /* match length or unmatched char (if dist == 0) */
  var lx = 0;         /* running index in l_buf */
  var code;           /* the code to send */
  var extra;          /* number of extra bits to send */

  if (s.last_lit !== 0) {
    do {
      dist = (s.pending_buf[s.d_buf + lx * 2] << 8) | (s.pending_buf[s.d_buf + lx * 2 + 1]);
      lc = s.pending_buf[s.l_buf + lx];
      lx++;

      if (dist === 0) {
        send_code(s, lc, ltree); /* send a literal byte */
        //Tracecv(isgraph(lc), (stderr," '%c' ", lc));
      } else {
        /* Here, lc is the match length - MIN_MATCH */
        code = _length_code[lc];
        send_code(s, code + LITERALS + 1, ltree); /* send the length code */
        extra = extra_lbits[code];
        if (extra !== 0) {
          lc -= base_length[code];
          send_bits(s, lc, extra);       /* send the extra length bits */
        }
        dist--; /* dist is now the match distance - 1 */
        code = d_code(dist);
        //Assert (code < D_CODES, "bad d_code");

        send_code(s, code, dtree);       /* send the distance code */
        extra = extra_dbits[code];
        if (extra !== 0) {
          dist -= base_dist[code];
          send_bits(s, dist, extra);   /* send the extra distance bits */
        }
      } /* literal or match pair ? */

      /* Check that the overlay between pending_buf and d_buf+l_buf is ok: */
      //Assert((uInt)(s->pending) < s->lit_bufsize + 2*lx,
      //       "pendingBuf overflow");

    } while (lx < s.last_lit);
  }

  send_code(s, END_BLOCK, ltree);
}


/* ===========================================================================
 * Construct one Huffman tree and assigns the code bit strings and lengths.
 * Update the total bit length for the current block.
 * IN assertion: the field freq is set for all tree elements.
 * OUT assertions: the fields len and code are set to the optimal bit length
 *     and corresponding code. The length opt_len is updated; static_len is
 *     also updated if stree is not null. The field max_code is set.
 */
function build_tree(s, desc)
//    deflate_state *s;
//    tree_desc *desc; /* the tree descriptor */
{
  var tree     = desc.dyn_tree;
  var stree    = desc.stat_desc.static_tree;
  var has_stree = desc.stat_desc.has_stree;
  var elems    = desc.stat_desc.elems;
  var n, m;          /* iterate over heap elements */
  var max_code = -1; /* largest code with non zero frequency */
  var node;          /* new node being created */

  /* Construct the initial heap, with least frequent element in
   * heap[SMALLEST]. The sons of heap[n] are heap[2*n] and heap[2*n+1].
   * heap[0] is not used.
   */
  s.heap_len = 0;
  s.heap_max = HEAP_SIZE;

  for (n = 0; n < elems; n++) {
    if (tree[n * 2]/*.Freq*/ !== 0) {
      s.heap[++s.heap_len] = max_code = n;
      s.depth[n] = 0;

    } else {
      tree[n * 2 + 1]/*.Len*/ = 0;
    }
  }

  /* The pkzip format requires that at least one distance code exists,
   * and that at least one bit should be sent even if there is only one
   * possible code. So to avoid special checks later on we force at least
   * two codes of non zero frequency.
   */
  while (s.heap_len < 2) {
    node = s.heap[++s.heap_len] = (max_code < 2 ? ++max_code : 0);
    tree[node * 2]/*.Freq*/ = 1;
    s.depth[node] = 0;
    s.opt_len--;

    if (has_stree) {
      s.static_len -= stree[node * 2 + 1]/*.Len*/;
    }
    /* node is 0 or 1 so it does not have extra bits */
  }
  desc.max_code = max_code;

  /* The elements heap[heap_len/2+1 .. heap_len] are leaves of the tree,
   * establish sub-heaps of increasing lengths:
   */
  for (n = (s.heap_len >> 1/*int /2*/); n >= 1; n--) { pqdownheap(s, tree, n); }

  /* Construct the Huffman tree by repeatedly combining the least two
   * frequent nodes.
   */
  node = elems;              /* next internal node of the tree */
  do {
    //pqremove(s, tree, n);  /* n = node of least frequency */
    /*** pqremove ***/
    n = s.heap[1/*SMALLEST*/];
    s.heap[1/*SMALLEST*/] = s.heap[s.heap_len--];
    pqdownheap(s, tree, 1/*SMALLEST*/);
    /***/

    m = s.heap[1/*SMALLEST*/]; /* m = node of next least frequency */

    s.heap[--s.heap_max] = n; /* keep the nodes sorted by frequency */
    s.heap[--s.heap_max] = m;

    /* Create a new node father of n and m */
    tree[node * 2]/*.Freq*/ = tree[n * 2]/*.Freq*/ + tree[m * 2]/*.Freq*/;
    s.depth[node] = (s.depth[n] >= s.depth[m] ? s.depth[n] : s.depth[m]) + 1;
    tree[n * 2 + 1]/*.Dad*/ = tree[m * 2 + 1]/*.Dad*/ = node;

    /* and insert the new node in the heap */
    s.heap[1/*SMALLEST*/] = node++;
    pqdownheap(s, tree, 1/*SMALLEST*/);

  } while (s.heap_len >= 2);

  s.heap[--s.heap_max] = s.heap[1/*SMALLEST*/];

  /* At this point, the fields freq and dad are set. We can now
   * generate the bit lengths.
   */
  gen_bitlen(s, desc);

  /* The field len is now set, we can generate the bit codes */
  gen_codes(tree, max_code, s.bl_count);
}


/* ===========================================================================
 * Scan a literal or distance tree to determine the frequencies of the codes
 * in the bit length tree.
 */
function scan_tree(s, tree, max_code)
//    deflate_state *s;
//    ct_data *tree;   /* the tree to be scanned */
//    int max_code;    /* and its largest code of non zero frequency */
{
  var n;                     /* iterates over all tree elements */
  var prevlen = -1;          /* last emitted length */
  var curlen;                /* length of current code */

  var nextlen = tree[0 * 2 + 1]/*.Len*/; /* length of next code */

  var count = 0;             /* repeat count of the current code */
  var max_count = 7;         /* max repeat count */
  var min_count = 4;         /* min repeat count */

  if (nextlen === 0) {
    max_count = 138;
    min_count = 3;
  }
  tree[(max_code + 1) * 2 + 1]/*.Len*/ = 0xffff; /* guard */

  for (n = 0; n <= max_code; n++) {
    curlen = nextlen;
    nextlen = tree[(n + 1) * 2 + 1]/*.Len*/;

    if (++count < max_count && curlen === nextlen) {
      continue;

    } else if (count < min_count) {
      s.bl_tree[curlen * 2]/*.Freq*/ += count;

    } else if (curlen !== 0) {

      if (curlen !== prevlen) { s.bl_tree[curlen * 2]/*.Freq*/++; }
      s.bl_tree[REP_3_6 * 2]/*.Freq*/++;

    } else if (count <= 10) {
      s.bl_tree[REPZ_3_10 * 2]/*.Freq*/++;

    } else {
      s.bl_tree[REPZ_11_138 * 2]/*.Freq*/++;
    }

    count = 0;
    prevlen = curlen;

    if (nextlen === 0) {
      max_count = 138;
      min_count = 3;

    } else if (curlen === nextlen) {
      max_count = 6;
      min_count = 3;

    } else {
      max_count = 7;
      min_count = 4;
    }
  }
}


/* ===========================================================================
 * Send a literal or distance tree in compressed form, using the codes in
 * bl_tree.
 */
function send_tree(s, tree, max_code)
//    deflate_state *s;
//    ct_data *tree; /* the tree to be scanned */
//    int max_code;       /* and its largest code of non zero frequency */
{
  var n;                     /* iterates over all tree elements */
  var prevlen = -1;          /* last emitted length */
  var curlen;                /* length of current code */

  var nextlen = tree[0 * 2 + 1]/*.Len*/; /* length of next code */

  var count = 0;             /* repeat count of the current code */
  var max_count = 7;         /* max repeat count */
  var min_count = 4;         /* min repeat count */

  /* tree[max_code+1].Len = -1; */  /* guard already set */
  if (nextlen === 0) {
    max_count = 138;
    min_count = 3;
  }

  for (n = 0; n <= max_code; n++) {
    curlen = nextlen;
    nextlen = tree[(n + 1) * 2 + 1]/*.Len*/;

    if (++count < max_count && curlen === nextlen) {
      continue;

    } else if (count < min_count) {
      do { send_code(s, curlen, s.bl_tree); } while (--count !== 0);

    } else if (curlen !== 0) {
      if (curlen !== prevlen) {
        send_code(s, curlen, s.bl_tree);
        count--;
      }
      //Assert(count >= 3 && count <= 6, " 3_6?");
      send_code(s, REP_3_6, s.bl_tree);
      send_bits(s, count - 3, 2);

    } else if (count <= 10) {
      send_code(s, REPZ_3_10, s.bl_tree);
      send_bits(s, count - 3, 3);

    } else {
      send_code(s, REPZ_11_138, s.bl_tree);
      send_bits(s, count - 11, 7);
    }

    count = 0;
    prevlen = curlen;
    if (nextlen === 0) {
      max_count = 138;
      min_count = 3;

    } else if (curlen === nextlen) {
      max_count = 6;
      min_count = 3;

    } else {
      max_count = 7;
      min_count = 4;
    }
  }
}


/* ===========================================================================
 * Construct the Huffman tree for the bit lengths and return the index in
 * bl_order of the last bit length code to send.
 */
function build_bl_tree(s) {
  var max_blindex;  /* index of last bit length code of non zero freq */

  /* Determine the bit length frequencies for literal and distance trees */
  scan_tree(s, s.dyn_ltree, s.l_desc.max_code);
  scan_tree(s, s.dyn_dtree, s.d_desc.max_code);

  /* Build the bit length tree: */
  build_tree(s, s.bl_desc);
  /* opt_len now includes the length of the tree representations, except
   * the lengths of the bit lengths codes and the 5+5+4 bits for the counts.
   */

  /* Determine the number of bit length codes to send. The pkzip format
   * requires that at least 4 bit length codes be sent. (appnote.txt says
   * 3 but the actual value used is 4.)
   */
  for (max_blindex = BL_CODES - 1; max_blindex >= 3; max_blindex--) {
    if (s.bl_tree[bl_order[max_blindex] * 2 + 1]/*.Len*/ !== 0) {
      break;
    }
  }
  /* Update opt_len to include the bit length tree and counts */
  s.opt_len += 3 * (max_blindex + 1) + 5 + 5 + 4;
  //Tracev((stderr, "\ndyn trees: dyn %ld, stat %ld",
  //        s->opt_len, s->static_len));

  return max_blindex;
}


/* ===========================================================================
 * Send the header for a block using dynamic Huffman trees: the counts, the
 * lengths of the bit length codes, the literal tree and the distance tree.
 * IN assertion: lcodes >= 257, dcodes >= 1, blcodes >= 4.
 */
function send_all_trees(s, lcodes, dcodes, blcodes)
//    deflate_state *s;
//    int lcodes, dcodes, blcodes; /* number of codes for each tree */
{
  var rank;                    /* index in bl_order */

  //Assert (lcodes >= 257 && dcodes >= 1 && blcodes >= 4, "not enough codes");
  //Assert (lcodes <= L_CODES && dcodes <= D_CODES && blcodes <= BL_CODES,
  //        "too many codes");
  //Tracev((stderr, "\nbl counts: "));
  send_bits(s, lcodes - 257, 5); /* not +255 as stated in appnote.txt */
  send_bits(s, dcodes - 1,   5);
  send_bits(s, blcodes - 4,  4); /* not -3 as stated in appnote.txt */
  for (rank = 0; rank < blcodes; rank++) {
    //Tracev((stderr, "\nbl code %2d ", bl_order[rank]));
    send_bits(s, s.bl_tree[bl_order[rank] * 2 + 1]/*.Len*/, 3);
  }
  //Tracev((stderr, "\nbl tree: sent %ld", s->bits_sent));

  send_tree(s, s.dyn_ltree, lcodes - 1); /* literal tree */
  //Tracev((stderr, "\nlit tree: sent %ld", s->bits_sent));

  send_tree(s, s.dyn_dtree, dcodes - 1); /* distance tree */
  //Tracev((stderr, "\ndist tree: sent %ld", s->bits_sent));
}


/* ===========================================================================
 * Check if the data type is TEXT or BINARY, using the following algorithm:
 * - TEXT if the two conditions below are satisfied:
 *    a) There are no non-portable control characters belonging to the
 *       "black list" (0..6, 14..25, 28..31).
 *    b) There is at least one printable character belonging to the
 *       "white list" (9 {TAB}, 10 {LF}, 13 {CR}, 32..255).
 * - BINARY otherwise.
 * - The following partially-portable control characters form a
 *   "gray list" that is ignored in this detection algorithm:
 *   (7 {BEL}, 8 {BS}, 11 {VT}, 12 {FF}, 26 {SUB}, 27 {ESC}).
 * IN assertion: the fields Freq of dyn_ltree are set.
 */
function detect_data_type(s) {
  /* black_mask is the bit mask of black-listed bytes
   * set bits 0..6, 14..25, and 28..31
   * 0xf3ffc07f = binary 11110011111111111100000001111111
   */
  var black_mask = 0xf3ffc07f;
  var n;

  /* Check for non-textual ("black-listed") bytes. */
  for (n = 0; n <= 31; n++, black_mask >>>= 1) {
    if ((black_mask & 1) && (s.dyn_ltree[n * 2]/*.Freq*/ !== 0)) {
      return Z_BINARY;
    }
  }

  /* Check for textual ("white-listed") bytes. */
  if (s.dyn_ltree[9 * 2]/*.Freq*/ !== 0 || s.dyn_ltree[10 * 2]/*.Freq*/ !== 0 ||
      s.dyn_ltree[13 * 2]/*.Freq*/ !== 0) {
    return Z_TEXT;
  }
  for (n = 32; n < LITERALS; n++) {
    if (s.dyn_ltree[n * 2]/*.Freq*/ !== 0) {
      return Z_TEXT;
    }
  }

  /* There are no "black-listed" or "white-listed" bytes:
   * this stream either is empty or has tolerated ("gray-listed") bytes only.
   */
  return Z_BINARY;
}


var static_init_done = false;

/* ===========================================================================
 * Initialize the tree data structures for a new zlib stream.
 */
function _tr_init(s)
{

  if (!static_init_done) {
    tr_static_init();
    static_init_done = true;
  }

  s.l_desc  = new TreeDesc(s.dyn_ltree, static_l_desc);
  s.d_desc  = new TreeDesc(s.dyn_dtree, static_d_desc);
  s.bl_desc = new TreeDesc(s.bl_tree, static_bl_desc);

  s.bi_buf = 0;
  s.bi_valid = 0;

  /* Initialize the first block of the first file: */
  init_block(s);
}


/* ===========================================================================
 * Send a stored block
 */
function _tr_stored_block(s, buf, stored_len, last)
//DeflateState *s;
//charf *buf;       /* input block */
//ulg stored_len;   /* length of input block */
//int last;         /* one if this is the last block for a file */
{
  send_bits(s, (STORED_BLOCK << 1) + (last ? 1 : 0), 3);    /* send block type */
  copy_block(s, buf, stored_len, true); /* with header */
}


/* ===========================================================================
 * Send one empty static block to give enough lookahead for inflate.
 * This takes 10 bits, of which 7 may remain in the bit buffer.
 */
function _tr_align(s) {
  send_bits(s, STATIC_TREES << 1, 3);
  send_code(s, END_BLOCK, static_ltree);
  bi_flush(s);
}


/* ===========================================================================
 * Determine the best encoding for the current block: dynamic trees, static
 * trees or store, and output the encoded block to the zip file.
 */
function _tr_flush_block(s, buf, stored_len, last)
//DeflateState *s;
//charf *buf;       /* input block, or NULL if too old */
//ulg stored_len;   /* length of input block */
//int last;         /* one if this is the last block for a file */
{
  var opt_lenb, static_lenb;  /* opt_len and static_len in bytes */
  var max_blindex = 0;        /* index of last bit length code of non zero freq */

  /* Build the Huffman trees unless a stored block is forced */
  if (s.level > 0) {

    /* Check if the file is binary or text */
    if (s.strm.data_type === Z_UNKNOWN) {
      s.strm.data_type = detect_data_type(s);
    }

    /* Construct the literal and distance trees */
    build_tree(s, s.l_desc);
    // Tracev((stderr, "\nlit data: dyn %ld, stat %ld", s->opt_len,
    //        s->static_len));

    build_tree(s, s.d_desc);
    // Tracev((stderr, "\ndist data: dyn %ld, stat %ld", s->opt_len,
    //        s->static_len));
    /* At this point, opt_len and static_len are the total bit lengths of
     * the compressed block data, excluding the tree representations.
     */

    /* Build the bit length tree for the above two trees, and get the index
     * in bl_order of the last bit length code to send.
     */
    max_blindex = build_bl_tree(s);

    /* Determine the best encoding. Compute the block lengths in bytes. */
    opt_lenb = (s.opt_len + 3 + 7) >>> 3;
    static_lenb = (s.static_len + 3 + 7) >>> 3;

    // Tracev((stderr, "\nopt %lu(%lu) stat %lu(%lu) stored %lu lit %u ",
    //        opt_lenb, s->opt_len, static_lenb, s->static_len, stored_len,
    //        s->last_lit));

    if (static_lenb <= opt_lenb) { opt_lenb = static_lenb; }

  } else {
    // Assert(buf != (char*)0, "lost buf");
    opt_lenb = static_lenb = stored_len + 5; /* force a stored block */
  }

  if ((stored_len + 4 <= opt_lenb) && (buf !== -1)) {
    /* 4: two words for the lengths */

    /* The test buf != NULL is only necessary if LIT_BUFSIZE > WSIZE.
     * Otherwise we can't have processed more than WSIZE input bytes since
     * the last block flush, because compression would have been
     * successful. If LIT_BUFSIZE <= WSIZE, it is never too late to
     * transform a block into a stored block.
     */
    _tr_stored_block(s, buf, stored_len, last);

  } else if (s.strategy === Z_FIXED || static_lenb === opt_lenb) {

    send_bits(s, (STATIC_TREES << 1) + (last ? 1 : 0), 3);
    compress_block(s, static_ltree, static_dtree);

  } else {
    send_bits(s, (DYN_TREES << 1) + (last ? 1 : 0), 3);
    send_all_trees(s, s.l_desc.max_code + 1, s.d_desc.max_code + 1, max_blindex + 1);
    compress_block(s, s.dyn_ltree, s.dyn_dtree);
  }
  // Assert (s->compressed_len == s->bits_sent, "bad compressed size");
  /* The above check is made mod 2^32, for files larger than 512 MB
   * and uLong implemented on 32 bits.
   */
  init_block(s);

  if (last) {
    bi_windup(s);
  }
  // Tracev((stderr,"\ncomprlen %lu(%lu) ", s->compressed_len>>3,
  //       s->compressed_len-7*last));
}

/* ===========================================================================
 * Save the match info and tally the frequency counts. Return true if
 * the current block must be flushed.
 */
function _tr_tally(s, dist, lc)
//    deflate_state *s;
//    unsigned dist;  /* distance of matched string */
//    unsigned lc;    /* match length-MIN_MATCH or unmatched char (if dist==0) */
{
  //var out_length, in_length, dcode;

  s.pending_buf[s.d_buf + s.last_lit * 2]     = (dist >>> 8) & 0xff;
  s.pending_buf[s.d_buf + s.last_lit * 2 + 1] = dist & 0xff;

  s.pending_buf[s.l_buf + s.last_lit] = lc & 0xff;
  s.last_lit++;

  if (dist === 0) {
    /* lc is the unmatched char */
    s.dyn_ltree[lc * 2]/*.Freq*/++;
  } else {
    s.matches++;
    /* Here, lc is the match length - MIN_MATCH */
    dist--;             /* dist = match distance - 1 */
    //Assert((ush)dist < (ush)MAX_DIST(s) &&
    //       (ush)lc <= (ush)(MAX_MATCH-MIN_MATCH) &&
    //       (ush)d_code(dist) < (ush)D_CODES,  "_tr_tally: bad match");

    s.dyn_ltree[(_length_code[lc] + LITERALS + 1) * 2]/*.Freq*/++;
    s.dyn_dtree[d_code(dist) * 2]/*.Freq*/++;
  }

// (!) This block is disabled in zlib defaults,
// don't enable it for binary compatibility

//#ifdef TRUNCATE_BLOCK
//  /* Try to guess if it is profitable to stop the current block here */
//  if ((s.last_lit & 0x1fff) === 0 && s.level > 2) {
//    /* Compute an upper bound for the compressed length */
//    out_length = s.last_lit*8;
//    in_length = s.strstart - s.block_start;
//
//    for (dcode = 0; dcode < D_CODES; dcode++) {
//      out_length += s.dyn_dtree[dcode*2]/*.Freq*/ * (5 + extra_dbits[dcode]);
//    }
//    out_length >>>= 3;
//    //Tracev((stderr,"\nlast_lit %u, in %ld, out ~%ld(%ld%%) ",
//    //       s->last_lit, in_length, out_length,
//    //       100L - out_length*100L/in_length));
//    if (s.matches < (s.last_lit>>1)/*int /2*/ && out_length < (in_length>>1)/*int /2*/) {
//      return true;
//    }
//  }
//#endif

  return (s.last_lit === s.lit_bufsize - 1);
  /* We avoid equality with lit_bufsize because of wraparound at 64K
   * on 16 bit machines and because stored blocks are restricted to
   * 64K-1 bytes.
   */
}

exports._tr_init  = _tr_init;
exports._tr_stored_block = _tr_stored_block;
exports._tr_flush_block  = _tr_flush_block;
exports._tr_tally = _tr_tally;
exports._tr_align = _tr_align;

},{"../utils/common":62}],72:[function(require,module,exports){
'use strict';

// (C) 1995-2013 Jean-loup Gailly and Mark Adler
// (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
//
// This software is provided 'as-is', without any express or implied
// warranty. In no event will the authors be held liable for any damages
// arising from the use of this software.
//
// Permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions:
//
// 1. The origin of this software must not be misrepresented; you must not
//   claim that you wrote the original software. If you use this software
//   in a product, an acknowledgment in the product documentation would be
//   appreciated but is not required.
// 2. Altered source versions must be plainly marked as such, and must not be
//   misrepresented as being the original software.
// 3. This notice may not be removed or altered from any source distribution.

function ZStream() {
  /* next input byte */
  this.input = null; // JS specific, because we have no pointers
  this.next_in = 0;
  /* number of bytes available at input */
  this.avail_in = 0;
  /* total number of input bytes read so far */
  this.total_in = 0;
  /* next output byte should be put there */
  this.output = null; // JS specific, because we have no pointers
  this.next_out = 0;
  /* remaining free space at output */
  this.avail_out = 0;
  /* total number of bytes output so far */
  this.total_out = 0;
  /* last error message, NULL if no error */
  this.msg = ''/*Z_NULL*/;
  /* not visible by applications */
  this.state = null;
  /* best guess about the data type: binary or text */
  this.data_type = 2/*Z_UNKNOWN*/;
  /* adler32 value of the uncompressed data */
  this.adler = 0;
}

module.exports = ZStream;

},{}],73:[function(require,module,exports){
(function (process){
'use strict';

if (!process.version ||
    process.version.indexOf('v0.') === 0 ||
    process.version.indexOf('v1.') === 0 && process.version.indexOf('v1.8.') !== 0) {
  module.exports = { nextTick: nextTick };
} else {
  module.exports = process
}

function nextTick(fn, arg1, arg2, arg3) {
  if (typeof fn !== 'function') {
    throw new TypeError('"callback" argument must be a function');
  }
  var len = arguments.length;
  var args, i;
  switch (len) {
  case 0:
  case 1:
    return process.nextTick(fn);
  case 2:
    return process.nextTick(function afterTickOne() {
      fn.call(null, arg1);
    });
  case 3:
    return process.nextTick(function afterTickTwo() {
      fn.call(null, arg1, arg2);
    });
  case 4:
    return process.nextTick(function afterTickThree() {
      fn.call(null, arg1, arg2, arg3);
    });
  default:
    args = new Array(len - 1);
    i = 0;
    while (i < args.length) {
      args[i++] = arguments[i];
    }
    return process.nextTick(function afterTick() {
      fn.apply(null, args);
    });
  }
}


}).call(this,require('_process'))

},{"_process":74}],74:[function(require,module,exports){
// shim for using process in browser
var process = module.exports = {};

// cached from whatever global is present so that test runners that stub it
// don't break things.  But we need to wrap it in a try catch in case it is
// wrapped in strict mode code which doesn't define any globals.  It's inside a
// function because try/catches deoptimize in certain engines.

var cachedSetTimeout;
var cachedClearTimeout;

function defaultSetTimout() {
    throw new Error('setTimeout has not been defined');
}
function defaultClearTimeout () {
    throw new Error('clearTimeout has not been defined');
}
(function () {
    try {
        if (typeof setTimeout === 'function') {
            cachedSetTimeout = setTimeout;
        } else {
            cachedSetTimeout = defaultSetTimout;
        }
    } catch (e) {
        cachedSetTimeout = defaultSetTimout;
    }
    try {
        if (typeof clearTimeout === 'function') {
            cachedClearTimeout = clearTimeout;
        } else {
            cachedClearTimeout = defaultClearTimeout;
        }
    } catch (e) {
        cachedClearTimeout = defaultClearTimeout;
    }
} ())
function runTimeout(fun) {
    if (cachedSetTimeout === setTimeout) {
        //normal enviroments in sane situations
        return setTimeout(fun, 0);
    }
    // if setTimeout wasn't available but was latter defined
    if ((cachedSetTimeout === defaultSetTimout || !cachedSetTimeout) && setTimeout) {
        cachedSetTimeout = setTimeout;
        return setTimeout(fun, 0);
    }
    try {
        // when when somebody has screwed with setTimeout but no I.E. maddness
        return cachedSetTimeout(fun, 0);
    } catch(e){
        try {
            // When we are in I.E. but the script has been evaled so I.E. doesn't trust the global object when called normally
            return cachedSetTimeout.call(null, fun, 0);
        } catch(e){
            // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error
            return cachedSetTimeout.call(this, fun, 0);
        }
    }


}
function runClearTimeout(marker) {
    if (cachedClearTimeout === clearTimeout) {
        //normal enviroments in sane situations
        return clearTimeout(marker);
    }
    // if clearTimeout wasn't available but was latter defined
    if ((cachedClearTimeout === defaultClearTimeout || !cachedClearTimeout) && clearTimeout) {
        cachedClearTimeout = clearTimeout;
        return clearTimeout(marker);
    }
    try {
        // when when somebody has screwed with setTimeout but no I.E. maddness
        return cachedClearTimeout(marker);
    } catch (e){
        try {
            // When we are in I.E. but the script has been evaled so I.E. doesn't  trust the global object when called normally
            return cachedClearTimeout.call(null, marker);
        } catch (e){
            // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error.
            // Some versions of I.E. have different rules for clearTimeout vs setTimeout
            return cachedClearTimeout.call(this, marker);
        }
    }



}
var queue = [];
var draining = false;
var currentQueue;
var queueIndex = -1;

function cleanUpNextTick() {
    if (!draining || !currentQueue) {
        return;
    }
    draining = false;
    if (currentQueue.length) {
        queue = currentQueue.concat(queue);
    } else {
        queueIndex = -1;
    }
    if (queue.length) {
        drainQueue();
    }
}

function drainQueue() {
    if (draining) {
        return;
    }
    var timeout = runTimeout(cleanUpNextTick);
    draining = true;

    var len = queue.length;
    while(len) {
        currentQueue = queue;
        queue = [];
        while (++queueIndex < len) {
            if (currentQueue) {
                currentQueue[queueIndex].run();
            }
        }
        queueIndex = -1;
        len = queue.length;
    }
    currentQueue = null;
    draining = false;
    runClearTimeout(timeout);
}

process.nextTick = function (fun) {
    var args = new Array(arguments.length - 1);
    if (arguments.length > 1) {
        for (var i = 1; i < arguments.length; i++) {
            args[i - 1] = arguments[i];
        }
    }
    queue.push(new Item(fun, args));
    if (queue.length === 1 && !draining) {
        runTimeout(drainQueue);
    }
};

// v8 likes predictible objects
function Item(fun, array) {
    this.fun = fun;
    this.array = array;
}
Item.prototype.run = function () {
    this.fun.apply(null, this.array);
};
process.title = 'browser';
process.browser = true;
process.env = {};
process.argv = [];
process.version = ''; // empty string to avoid regexp issues
process.versions = {};

function noop() {}

process.on = noop;
process.addListener = noop;
process.once = noop;
process.off = noop;
process.removeListener = noop;
process.removeAllListeners = noop;
process.emit = noop;
process.prependListener = noop;
process.prependOnceListener = noop;

process.listeners = function (name) { return [] }

process.binding = function (name) {
    throw new Error('process.binding is not supported');
};

process.cwd = function () { return '/' };
process.chdir = function (dir) {
    throw new Error('process.chdir is not supported');
};
process.umask = function() { return 0; };

},{}],75:[function(require,module,exports){
module.exports = require('./lib/_stream_duplex.js');

},{"./lib/_stream_duplex.js":76}],76:[function(require,module,exports){
// Copyright Joyent, Inc. and other Node contributors.
//
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to permit
// persons to whom the Software is furnished to do so, subject to the
// following conditions:
//
// The above copyright notice and this permission notice shall be included
// in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
// USE OR OTHER DEALINGS IN THE SOFTWARE.

// a duplex stream is just a stream that is both readable and writable.
// Since JS doesn't have multiple prototypal inheritance, this class
// prototypally inherits from Readable, and then parasitically from
// Writable.

'use strict';

/*<replacement>*/

var pna = require('process-nextick-args');
/*</replacement>*/

/*<replacement>*/
var objectKeys = Object.keys || function (obj) {
  var keys = [];
  for (var key in obj) {
    keys.push(key);
  }return keys;
};
/*</replacement>*/

module.exports = Duplex;

/*<replacement>*/
var util = require('core-util-is');
util.inherits = require('inherits');
/*</replacement>*/

var Readable = require('./_stream_readable');
var Writable = require('./_stream_writable');

util.inherits(Duplex, Readable);

{
  // avoid scope creep, the keys array can then be collected
  var keys = objectKeys(Writable.prototype);
  for (var v = 0; v < keys.length; v++) {
    var method = keys[v];
    if (!Duplex.prototype[method]) Duplex.prototype[method] = Writable.prototype[method];
  }
}

function Duplex(options) {
  if (!(this instanceof Duplex)) return new Duplex(options);

  Readable.call(this, options);
  Writable.call(this, options);

  if (options && options.readable === false) this.readable = false;

  if (options && options.writable === false) this.writable = false;

  this.allowHalfOpen = true;
  if (options && options.allowHalfOpen === false) this.allowHalfOpen = false;

  this.once('end', onend);
}

Object.defineProperty(Duplex.prototype, 'writableHighWaterMark', {
  // making it explicit this property is not enumerable
  // because otherwise some prototype manipulation in
  // userland will fail
  enumerable: false,
  get: function () {
    return this._writableState.highWaterMark;
  }
});

// the no-half-open enforcer
function onend() {
  // if we allow half-open state, or if the writable side ended,
  // then we're ok.
  if (this.allowHalfOpen || this._writableState.ended) return;

  // no more data can be written.
  // But allow more writes to happen in this tick.
  pna.nextTick(onEndNT, this);
}

function onEndNT(self) {
  self.end();
}

Object.defineProperty(Duplex.prototype, 'destroyed', {
  get: function () {
    if (this._readableState === undefined || this._writableState === undefined) {
      return false;
    }
    return this._readableState.destroyed && this._writableState.destroyed;
  },
  set: function (value) {
    // we ignore the value if the stream
    // has not been initialized yet
    if (this._readableState === undefined || this._writableState === undefined) {
      return;
    }

    // backward compatibility, the user is explicitly
    // managing destroyed
    this._readableState.destroyed = value;
    this._writableState.destroyed = value;
  }
});

Duplex.prototype._destroy = function (err, cb) {
  this.push(null);
  this.end();

  pna.nextTick(cb, err);
};
},{"./_stream_readable":78,"./_stream_writable":80,"core-util-is":54,"inherits":58,"process-nextick-args":73}],77:[function(require,module,exports){
// Copyright Joyent, Inc. and other Node contributors.
//
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to permit
// persons to whom the Software is furnished to do so, subject to the
// following conditions:
//
// The above copyright notice and this permission notice shall be included
// in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
// USE OR OTHER DEALINGS IN THE SOFTWARE.

// a passthrough stream.
// basically just the most minimal sort of Transform stream.
// Every written chunk gets output as-is.

'use strict';

module.exports = PassThrough;

var Transform = require('./_stream_transform');

/*<replacement>*/
var util = require('core-util-is');
util.inherits = require('inherits');
/*</replacement>*/

util.inherits(PassThrough, Transform);

function PassThrough(options) {
  if (!(this instanceof PassThrough)) return new PassThrough(options);

  Transform.call(this, options);
}

PassThrough.prototype._transform = function (chunk, encoding, cb) {
  cb(null, chunk);
};
},{"./_stream_transform":79,"core-util-is":54,"inherits":58}],78:[function(require,module,exports){
(function (process,global){
// Copyright Joyent, Inc. and other Node contributors.
//
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to permit
// persons to whom the Software is furnished to do so, subject to the
// following conditions:
//
// The above copyright notice and this permission notice shall be included
// in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
// USE OR OTHER DEALINGS IN THE SOFTWARE.

'use strict';

/*<replacement>*/

var pna = require('process-nextick-args');
/*</replacement>*/

module.exports = Readable;

/*<replacement>*/
var isArray = require('isarray');
/*</replacement>*/

/*<replacement>*/
var Duplex;
/*</replacement>*/

Readable.ReadableState = ReadableState;

/*<replacement>*/
var EE = require('events').EventEmitter;

var EElistenerCount = function (emitter, type) {
  return emitter.listeners(type).length;
};
/*</replacement>*/

/*<replacement>*/
var Stream = require('./internal/streams/stream');
/*</replacement>*/

/*<replacement>*/

var Buffer = require('safe-buffer').Buffer;
var OurUint8Array = global.Uint8Array || function () {};
function _uint8ArrayToBuffer(chunk) {
  return Buffer.from(chunk);
}
function _isUint8Array(obj) {
  return Buffer.isBuffer(obj) || obj instanceof OurUint8Array;
}

/*</replacement>*/

/*<replacement>*/
var util = require('core-util-is');
util.inherits = require('inherits');
/*</replacement>*/

/*<replacement>*/
var debugUtil = require('util');
var debug = void 0;
if (debugUtil && debugUtil.debuglog) {
  debug = debugUtil.debuglog('stream');
} else {
  debug = function () {};
}
/*</replacement>*/

var BufferList = require('./internal/streams/BufferList');
var destroyImpl = require('./internal/streams/destroy');
var StringDecoder;

util.inherits(Readable, Stream);

var kProxyEvents = ['error', 'close', 'destroy', 'pause', 'resume'];

function prependListener(emitter, event, fn) {
  // Sadly this is not cacheable as some libraries bundle their own
  // event emitter implementation with them.
  if (typeof emitter.prependListener === 'function') return emitter.prependListener(event, fn);

  // This is a hack to make sure that our error handler is attached before any
  // userland ones.  NEVER DO THIS. This is here only because this code needs
  // to continue to work with older versions of Node.js that do not include
  // the prependListener() method. The goal is to eventually remove this hack.
  if (!emitter._events || !emitter._events[event]) emitter.on(event, fn);else if (isArray(emitter._events[event])) emitter._events[event].unshift(fn);else emitter._events[event] = [fn, emitter._events[event]];
}

function ReadableState(options, stream) {
  Duplex = Duplex || require('./_stream_duplex');

  options = options || {};

  // Duplex streams are both readable and writable, but share
  // the same options object.
  // However, some cases require setting options to different
  // values for the readable and the writable sides of the duplex stream.
  // These options can be provided separately as readableXXX and writableXXX.
  var isDuplex = stream instanceof Duplex;

  // object stream flag. Used to make read(n) ignore n and to
  // make all the buffer merging and length checks go away
  this.objectMode = !!options.objectMode;

  if (isDuplex) this.objectMode = this.objectMode || !!options.readableObjectMode;

  // the point at which it stops calling _read() to fill the buffer
  // Note: 0 is a valid value, means "don't call _read preemptively ever"
  var hwm = options.highWaterMark;
  var readableHwm = options.readableHighWaterMark;
  var defaultHwm = this.objectMode ? 16 : 16 * 1024;

  if (hwm || hwm === 0) this.highWaterMark = hwm;else if (isDuplex && (readableHwm || readableHwm === 0)) this.highWaterMark = readableHwm;else this.highWaterMark = defaultHwm;

  // cast to ints.
  this.highWaterMark = Math.floor(this.highWaterMark);

  // A linked list is used to store data chunks instead of an array because the
  // linked list can remove elements from the beginning faster than
  // array.shift()
  this.buffer = new BufferList();
  this.length = 0;
  this.pipes = null;
  this.pipesCount = 0;
  this.flowing = null;
  this.ended = false;
  this.endEmitted = false;
  this.reading = false;

  // a flag to be able to tell if the event 'readable'/'data' is emitted
  // immediately, or on a later tick.  We set this to true at first, because
  // any actions that shouldn't happen until "later" should generally also
  // not happen before the first read call.
  this.sync = true;

  // whenever we return null, then we set a flag to say
  // that we're awaiting a 'readable' event emission.
  this.needReadable = false;
  this.emittedReadable = false;
  this.readableListening = false;
  this.resumeScheduled = false;

  // has it been destroyed
  this.destroyed = false;

  // Crypto is kind of old and crusty.  Historically, its default string
  // encoding is 'binary' so we have to make this configurable.
  // Everything else in the universe uses 'utf8', though.
  this.defaultEncoding = options.defaultEncoding || 'utf8';

  // the number of writers that are awaiting a drain event in .pipe()s
  this.awaitDrain = 0;

  // if true, a maybeReadMore has been scheduled
  this.readingMore = false;

  this.decoder = null;
  this.encoding = null;
  if (options.encoding) {
    if (!StringDecoder) StringDecoder = require('string_decoder/').StringDecoder;
    this.decoder = new StringDecoder(options.encoding);
    this.encoding = options.encoding;
  }
}

function Readable(options) {
  Duplex = Duplex || require('./_stream_duplex');

  if (!(this instanceof Readable)) return new Readable(options);

  this._readableState = new ReadableState(options, this);

  // legacy
  this.readable = true;

  if (options) {
    if (typeof options.read === 'function') this._read = options.read;

    if (typeof options.destroy === 'function') this._destroy = options.destroy;
  }

  Stream.call(this);
}

Object.defineProperty(Readable.prototype, 'destroyed', {
  get: function () {
    if (this._readableState === undefined) {
      return false;
    }
    return this._readableState.destroyed;
  },
  set: function (value) {
    // we ignore the value if the stream
    // has not been initialized yet
    if (!this._readableState) {
      return;
    }

    // backward compatibility, the user is explicitly
    // managing destroyed
    this._readableState.destroyed = value;
  }
});

Readable.prototype.destroy = destroyImpl.destroy;
Readable.prototype._undestroy = destroyImpl.undestroy;
Readable.prototype._destroy = function (err, cb) {
  this.push(null);
  cb(err);
};

// Manually shove something into the read() buffer.
// This returns true if the highWaterMark has not been hit yet,
// similar to how Writable.write() returns true if you should
// write() some more.
Readable.prototype.push = function (chunk, encoding) {
  var state = this._readableState;
  var skipChunkCheck;

  if (!state.objectMode) {
    if (typeof chunk === 'string') {
      encoding = encoding || state.defaultEncoding;
      if (encoding !== state.encoding) {
        chunk = Buffer.from(chunk, encoding);
        encoding = '';
      }
      skipChunkCheck = true;
    }
  } else {
    skipChunkCheck = true;
  }

  return readableAddChunk(this, chunk, encoding, false, skipChunkCheck);
};

// Unshift should *always* be something directly out of read()
Readable.prototype.unshift = function (chunk) {
  return readableAddChunk(this, chunk, null, true, false);
};

function readableAddChunk(stream, chunk, encoding, addToFront, skipChunkCheck) {
  var state = stream._readableState;
  if (chunk === null) {
    state.reading = false;
    onEofChunk(stream, state);
  } else {
    var er;
    if (!skipChunkCheck) er = chunkInvalid(state, chunk);
    if (er) {
      stream.emit('error', er);
    } else if (state.objectMode || chunk && chunk.length > 0) {
      if (typeof chunk !== 'string' && !state.objectMode && Object.getPrototypeOf(chunk) !== Buffer.prototype) {
        chunk = _uint8ArrayToBuffer(chunk);
      }

      if (addToFront) {
        if (state.endEmitted) stream.emit('error', new Error('stream.unshift() after end event'));else addChunk(stream, state, chunk, true);
      } else if (state.ended) {
        stream.emit('error', new Error('stream.push() after EOF'));
      } else {
        state.reading = false;
        if (state.decoder && !encoding) {
          chunk = state.decoder.write(chunk);
          if (state.objectMode || chunk.length !== 0) addChunk(stream, state, chunk, false);else maybeReadMore(stream, state);
        } else {
          addChunk(stream, state, chunk, false);
        }
      }
    } else if (!addToFront) {
      state.reading = false;
    }
  }

  return needMoreData(state);
}

function addChunk(stream, state, chunk, addToFront) {
  if (state.flowing && state.length === 0 && !state.sync) {
    stream.emit('data', chunk);
    stream.read(0);
  } else {
    // update the buffer info.
    state.length += state.objectMode ? 1 : chunk.length;
    if (addToFront) state.buffer.unshift(chunk);else state.buffer.push(chunk);

    if (state.needReadable) emitReadable(stream);
  }
  maybeReadMore(stream, state);
}

function chunkInvalid(state, chunk) {
  var er;
  if (!_isUint8Array(chunk) && typeof chunk !== 'string' && chunk !== undefined && !state.objectMode) {
    er = new TypeError('Invalid non-string/buffer chunk');
  }
  return er;
}

// if it's past the high water mark, we can push in some more.
// Also, if we have no data yet, we can stand some
// more bytes.  This is to work around cases where hwm=0,
// such as the repl.  Also, if the push() triggered a
// readable event, and the user called read(largeNumber) such that
// needReadable was set, then we ought to push more, so that another
// 'readable' event will be triggered.
function needMoreData(state) {
  return !state.ended && (state.needReadable || state.length < state.highWaterMark || state.length === 0);
}

Readable.prototype.isPaused = function () {
  return this._readableState.flowing === false;
};

// backwards compatibility.
Readable.prototype.setEncoding = function (enc) {
  if (!StringDecoder) StringDecoder = require('string_decoder/').StringDecoder;
  this._readableState.decoder = new StringDecoder(enc);
  this._readableState.encoding = enc;
  return this;
};

// Don't raise the hwm > 8MB
var MAX_HWM = 0x800000;
function computeNewHighWaterMark(n) {
  if (n >= MAX_HWM) {
    n = MAX_HWM;
  } else {
    // Get the next highest power of 2 to prevent increasing hwm excessively in
    // tiny amounts
    n--;
    n |= n >>> 1;
    n |= n >>> 2;
    n |= n >>> 4;
    n |= n >>> 8;
    n |= n >>> 16;
    n++;
  }
  return n;
}

// This function is designed to be inlinable, so please take care when making
// changes to the function body.
function howMuchToRead(n, state) {
  if (n <= 0 || state.length === 0 && state.ended) return 0;
  if (state.objectMode) return 1;
  if (n !== n) {
    // Only flow one buffer at a time
    if (state.flowing && state.length) return state.buffer.head.data.length;else return state.length;
  }
  // If we're asking for more than the current hwm, then raise the hwm.
  if (n > state.highWaterMark) state.highWaterMark = computeNewHighWaterMark(n);
  if (n <= state.length) return n;
  // Don't have enough
  if (!state.ended) {
    state.needReadable = true;
    return 0;
  }
  return state.length;
}

// you can override either this method, or the async _read(n) below.
Readable.prototype.read = function (n) {
  debug('read', n);
  n = parseInt(n, 10);
  var state = this._readableState;
  var nOrig = n;

  if (n !== 0) state.emittedReadable = false;

  // if we're doing read(0) to trigger a readable event, but we
  // already have a bunch of data in the buffer, then just trigger
  // the 'readable' event and move on.
  if (n === 0 && state.needReadable && (state.length >= state.highWaterMark || state.ended)) {
    debug('read: emitReadable', state.length, state.ended);
    if (state.length === 0 && state.ended) endReadable(this);else emitReadable(this);
    return null;
  }

  n = howMuchToRead(n, state);

  // if we've ended, and we're now clear, then finish it up.
  if (n === 0 && state.ended) {
    if (state.length === 0) endReadable(this);
    return null;
  }

  // All the actual chunk generation logic needs to be
  // *below* the call to _read.  The reason is that in certain
  // synthetic stream cases, such as passthrough streams, _read
  // may be a completely synchronous operation which may change
  // the state of the read buffer, providing enough data when
  // before there was *not* enough.
  //
  // So, the steps are:
  // 1. Figure out what the state of things will be after we do
  // a read from the buffer.
  //
  // 2. If that resulting state will trigger a _read, then call _read.
  // Note that this may be asynchronous, or synchronous.  Yes, it is
  // deeply ugly to write APIs this way, but that still doesn't mean
  // that the Readable class should behave improperly, as streams are
  // designed to be sync/async agnostic.
  // Take note if the _read call is sync or async (ie, if the read call
  // has returned yet), so that we know whether or not it's safe to emit
  // 'readable' etc.
  //
  // 3. Actually pull the requested chunks out of the buffer and return.

  // if we need a readable event, then we need to do some reading.
  var doRead = state.needReadable;
  debug('need readable', doRead);

  // if we currently have less than the highWaterMark, then also read some
  if (state.length === 0 || state.length - n < state.highWaterMark) {
    doRead = true;
    debug('length less than watermark', doRead);
  }

  // however, if we've ended, then there's no point, and if we're already
  // reading, then it's unnecessary.
  if (state.ended || state.reading) {
    doRead = false;
    debug('reading or ended', doRead);
  } else if (doRead) {
    debug('do read');
    state.reading = true;
    state.sync = true;
    // if the length is currently zero, then we *need* a readable event.
    if (state.length === 0) state.needReadable = true;
    // call internal read method
    this._read(state.highWaterMark);
    state.sync = false;
    // If _read pushed data synchronously, then `reading` will be false,
    // and we need to re-evaluate how much data we can return to the user.
    if (!state.reading) n = howMuchToRead(nOrig, state);
  }

  var ret;
  if (n > 0) ret = fromList(n, state);else ret = null;

  if (ret === null) {
    state.needReadable = true;
    n = 0;
  } else {
    state.length -= n;
  }

  if (state.length === 0) {
    // If we have nothing in the buffer, then we want to know
    // as soon as we *do* get something into the buffer.
    if (!state.ended) state.needReadable = true;

    // If we tried to read() past the EOF, then emit end on the next tick.
    if (nOrig !== n && state.ended) endReadable(this);
  }

  if (ret !== null) this.emit('data', ret);

  return ret;
};

function onEofChunk(stream, state) {
  if (state.ended) return;
  if (state.decoder) {
    var chunk = state.decoder.end();
    if (chunk && chunk.length) {
      state.buffer.push(chunk);
      state.length += state.objectMode ? 1 : chunk.length;
    }
  }
  state.ended = true;

  // emit 'readable' now to make sure it gets picked up.
  emitReadable(stream);
}

// Don't emit readable right away in sync mode, because this can trigger
// another read() call => stack overflow.  This way, it might trigger
// a nextTick recursion warning, but that's not so bad.
function emitReadable(stream) {
  var state = stream._readableState;
  state.needReadable = false;
  if (!state.emittedReadable) {
    debug('emitReadable', state.flowing);
    state.emittedReadable = true;
    if (state.sync) pna.nextTick(emitReadable_, stream);else emitReadable_(stream);
  }
}

function emitReadable_(stream) {
  debug('emit readable');
  stream.emit('readable');
  flow(stream);
}

// at this point, the user has presumably seen the 'readable' event,
// and called read() to consume some data.  that may have triggered
// in turn another _read(n) call, in which case reading = true if
// it's in progress.
// However, if we're not ended, or reading, and the length < hwm,
// then go ahead and try to read some more preemptively.
function maybeReadMore(stream, state) {
  if (!state.readingMore) {
    state.readingMore = true;
    pna.nextTick(maybeReadMore_, stream, state);
  }
}

function maybeReadMore_(stream, state) {
  var len = state.length;
  while (!state.reading && !state.flowing && !state.ended && state.length < state.highWaterMark) {
    debug('maybeReadMore read 0');
    stream.read(0);
    if (len === state.length)
      // didn't get any data, stop spinning.
      break;else len = state.length;
  }
  state.readingMore = false;
}

// abstract method.  to be overridden in specific implementation classes.
// call cb(er, data) where data is <= n in length.
// for virtual (non-string, non-buffer) streams, "length" is somewhat
// arbitrary, and perhaps not very meaningful.
Readable.prototype._read = function (n) {
  this.emit('error', new Error('_read() is not implemented'));
};

Readable.prototype.pipe = function (dest, pipeOpts) {
  var src = this;
  var state = this._readableState;

  switch (state.pipesCount) {
    case 0:
      state.pipes = dest;
      break;
    case 1:
      state.pipes = [state.pipes, dest];
      break;
    default:
      state.pipes.push(dest);
      break;
  }
  state.pipesCount += 1;
  debug('pipe count=%d opts=%j', state.pipesCount, pipeOpts);

  var doEnd = (!pipeOpts || pipeOpts.end !== false) && dest !== process.stdout && dest !== process.stderr;

  var endFn = doEnd ? onend : unpipe;
  if (state.endEmitted) pna.nextTick(endFn);else src.once('end', endFn);

  dest.on('unpipe', onunpipe);
  function onunpipe(readable, unpipeInfo) {
    debug('onunpipe');
    if (readable === src) {
      if (unpipeInfo && unpipeInfo.hasUnpiped === false) {
        unpipeInfo.hasUnpiped = true;
        cleanup();
      }
    }
  }

  function onend() {
    debug('onend');
    dest.end();
  }

  // when the dest drains, it reduces the awaitDrain counter
  // on the source.  This would be more elegant with a .once()
  // handler in flow(), but adding and removing repeatedly is
  // too slow.
  var ondrain = pipeOnDrain(src);
  dest.on('drain', ondrain);

  var cleanedUp = false;
  function cleanup() {
    debug('cleanup');
    // cleanup event handlers once the pipe is broken
    dest.removeListener('close', onclose);
    dest.removeListener('finish', onfinish);
    dest.removeListener('drain', ondrain);
    dest.removeListener('error', onerror);
    dest.removeListener('unpipe', onunpipe);
    src.removeListener('end', onend);
    src.removeListener('end', unpipe);
    src.removeListener('data', ondata);

    cleanedUp = true;

    // if the reader is waiting for a drain event from this
    // specific writer, then it would cause it to never start
    // flowing again.
    // So, if this is awaiting a drain, then we just call it now.
    // If we don't know, then assume that we are waiting for one.
    if (state.awaitDrain && (!dest._writableState || dest._writableState.needDrain)) ondrain();
  }

  // If the user pushes more data while we're writing to dest then we'll end up
  // in ondata again. However, we only want to increase awaitDrain once because
  // dest will only emit one 'drain' event for the multiple writes.
  // => Introduce a guard on increasing awaitDrain.
  var increasedAwaitDrain = false;
  src.on('data', ondata);
  function ondata(chunk) {
    debug('ondata');
    increasedAwaitDrain = false;
    var ret = dest.write(chunk);
    if (false === ret && !increasedAwaitDrain) {
      // If the user unpiped during `dest.write()`, it is possible
      // to get stuck in a permanently paused state if that write
      // also returned false.
      // => Check whether `dest` is still a piping destination.
      if ((state.pipesCount === 1 && state.pipes === dest || state.pipesCount > 1 && indexOf(state.pipes, dest) !== -1) && !cleanedUp) {
        debug('false write response, pause', src._readableState.awaitDrain);
        src._readableState.awaitDrain++;
        increasedAwaitDrain = true;
      }
      src.pause();
    }
  }

  // if the dest has an error, then stop piping into it.
  // however, don't suppress the throwing behavior for this.
  function onerror(er) {
    debug('onerror', er);
    unpipe();
    dest.removeListener('error', onerror);
    if (EElistenerCount(dest, 'error') === 0) dest.emit('error', er);
  }

  // Make sure our error handler is attached before userland ones.
  prependListener(dest, 'error', onerror);

  // Both close and finish should trigger unpipe, but only once.
  function onclose() {
    dest.removeListener('finish', onfinish);
    unpipe();
  }
  dest.once('close', onclose);
  function onfinish() {
    debug('onfinish');
    dest.removeListener('close', onclose);
    unpipe();
  }
  dest.once('finish', onfinish);

  function unpipe() {
    debug('unpipe');
    src.unpipe(dest);
  }

  // tell the dest that it's being piped to
  dest.emit('pipe', src);

  // start the flow if it hasn't been started already.
  if (!state.flowing) {
    debug('pipe resume');
    src.resume();
  }

  return dest;
};

function pipeOnDrain(src) {
  return function () {
    var state = src._readableState;
    debug('pipeOnDrain', state.awaitDrain);
    if (state.awaitDrain) state.awaitDrain--;
    if (state.awaitDrain === 0 && EElistenerCount(src, 'data')) {
      state.flowing = true;
      flow(src);
    }
  };
}

Readable.prototype.unpipe = function (dest) {
  var state = this._readableState;
  var unpipeInfo = { hasUnpiped: false };

  // if we're not piping anywhere, then do nothing.
  if (state.pipesCount === 0) return this;

  // just one destination.  most common case.
  if (state.pipesCount === 1) {
    // passed in one, but it's not the right one.
    if (dest && dest !== state.pipes) return this;

    if (!dest) dest = state.pipes;

    // got a match.
    state.pipes = null;
    state.pipesCount = 0;
    state.flowing = false;
    if (dest) dest.emit('unpipe', this, unpipeInfo);
    return this;
  }

  // slow case. multiple pipe destinations.

  if (!dest) {
    // remove all.
    var dests = state.pipes;
    var len = state.pipesCount;
    state.pipes = null;
    state.pipesCount = 0;
    state.flowing = false;

    for (var i = 0; i < len; i++) {
      dests[i].emit('unpipe', this, unpipeInfo);
    }return this;
  }

  // try to find the right one.
  var index = indexOf(state.pipes, dest);
  if (index === -1) return this;

  state.pipes.splice(index, 1);
  state.pipesCount -= 1;
  if (state.pipesCount === 1) state.pipes = state.pipes[0];

  dest.emit('unpipe', this, unpipeInfo);

  return this;
};

// set up data events if they are asked for
// Ensure readable listeners eventually get something
Readable.prototype.on = function (ev, fn) {
  var res = Stream.prototype.on.call(this, ev, fn);

  if (ev === 'data') {
    // Start flowing on next tick if stream isn't explicitly paused
    if (this._readableState.flowing !== false) this.resume();
  } else if (ev === 'readable') {
    var state = this._readableState;
    if (!state.endEmitted && !state.readableListening) {
      state.readableListening = state.needReadable = true;
      state.emittedReadable = false;
      if (!state.reading) {
        pna.nextTick(nReadingNextTick, this);
      } else if (state.length) {
        emitReadable(this);
      }
    }
  }

  return res;
};
Readable.prototype.addListener = Readable.prototype.on;

function nReadingNextTick(self) {
  debug('readable nexttick read 0');
  self.read(0);
}

// pause() and resume() are remnants of the legacy readable stream API
// If the user uses them, then switch into old mode.
Readable.prototype.resume = function () {
  var state = this._readableState;
  if (!state.flowing) {
    debug('resume');
    state.flowing = true;
    resume(this, state);
  }
  return this;
};

function resume(stream, state) {
  if (!state.resumeScheduled) {
    state.resumeScheduled = true;
    pna.nextTick(resume_, stream, state);
  }
}

function resume_(stream, state) {
  if (!state.reading) {
    debug('resume read 0');
    stream.read(0);
  }

  state.resumeScheduled = false;
  state.awaitDrain = 0;
  stream.emit('resume');
  flow(stream);
  if (state.flowing && !state.reading) stream.read(0);
}

Readable.prototype.pause = function () {
  debug('call pause flowing=%j', this._readableState.flowing);
  if (false !== this._readableState.flowing) {
    debug('pause');
    this._readableState.flowing = false;
    this.emit('pause');
  }
  return this;
};

function flow(stream) {
  var state = stream._readableState;
  debug('flow', state.flowing);
  while (state.flowing && stream.read() !== null) {}
}

// wrap an old-style stream as the async data source.
// This is *not* part of the readable stream interface.
// It is an ugly unfortunate mess of history.
Readable.prototype.wrap = function (stream) {
  var _this = this;

  var state = this._readableState;
  var paused = false;

  stream.on('end', function () {
    debug('wrapped end');
    if (state.decoder && !state.ended) {
      var chunk = state.decoder.end();
      if (chunk && chunk.length) _this.push(chunk);
    }

    _this.push(null);
  });

  stream.on('data', function (chunk) {
    debug('wrapped data');
    if (state.decoder) chunk = state.decoder.write(chunk);

    // don't skip over falsy values in objectMode
    if (state.objectMode && (chunk === null || chunk === undefined)) return;else if (!state.objectMode && (!chunk || !chunk.length)) return;

    var ret = _this.push(chunk);
    if (!ret) {
      paused = true;
      stream.pause();
    }
  });

  // proxy all the other methods.
  // important when wrapping filters and duplexes.
  for (var i in stream) {
    if (this[i] === undefined && typeof stream[i] === 'function') {
      this[i] = function (method) {
        return function () {
          return stream[method].apply(stream, arguments);
        };
      }(i);
    }
  }

  // proxy certain important events.
  for (var n = 0; n < kProxyEvents.length; n++) {
    stream.on(kProxyEvents[n], this.emit.bind(this, kProxyEvents[n]));
  }

  // when we try to consume some more bytes, simply unpause the
  // underlying stream.
  this._read = function (n) {
    debug('wrapped _read', n);
    if (paused) {
      paused = false;
      stream.resume();
    }
  };

  return this;
};

Object.defineProperty(Readable.prototype, 'readableHighWaterMark', {
  // making it explicit this property is not enumerable
  // because otherwise some prototype manipulation in
  // userland will fail
  enumerable: false,
  get: function () {
    return this._readableState.highWaterMark;
  }
});

// exposed for testing purposes only.
Readable._fromList = fromList;

// Pluck off n bytes from an array of buffers.
// Length is the combined lengths of all the buffers in the list.
// This function is designed to be inlinable, so please take care when making
// changes to the function body.
function fromList(n, state) {
  // nothing buffered
  if (state.length === 0) return null;

  var ret;
  if (state.objectMode) ret = state.buffer.shift();else if (!n || n >= state.length) {
    // read it all, truncate the list
    if (state.decoder) ret = state.buffer.join('');else if (state.buffer.length === 1) ret = state.buffer.head.data;else ret = state.buffer.concat(state.length);
    state.buffer.clear();
  } else {
    // read part of list
    ret = fromListPartial(n, state.buffer, state.decoder);
  }

  return ret;
}

// Extracts only enough buffered data to satisfy the amount requested.
// This function is designed to be inlinable, so please take care when making
// changes to the function body.
function fromListPartial(n, list, hasStrings) {
  var ret;
  if (n < list.head.data.length) {
    // slice is the same for buffers and strings
    ret = list.head.data.slice(0, n);
    list.head.data = list.head.data.slice(n);
  } else if (n === list.head.data.length) {
    // first chunk is a perfect match
    ret = list.shift();
  } else {
    // result spans more than one buffer
    ret = hasStrings ? copyFromBufferString(n, list) : copyFromBuffer(n, list);
  }
  return ret;
}

// Copies a specified amount of characters from the list of buffered data
// chunks.
// This function is designed to be inlinable, so please take care when making
// changes to the function body.
function copyFromBufferString(n, list) {
  var p = list.head;
  var c = 1;
  var ret = p.data;
  n -= ret.length;
  while (p = p.next) {
    var str = p.data;
    var nb = n > str.length ? str.length : n;
    if (nb === str.length) ret += str;else ret += str.slice(0, n);
    n -= nb;
    if (n === 0) {
      if (nb === str.length) {
        ++c;
        if (p.next) list.head = p.next;else list.head = list.tail = null;
      } else {
        list.head = p;
        p.data = str.slice(nb);
      }
      break;
    }
    ++c;
  }
  list.length -= c;
  return ret;
}

// Copies a specified amount of bytes from the list of buffered data chunks.
// This function is designed to be inlinable, so please take care when making
// changes to the function body.
function copyFromBuffer(n, list) {
  var ret = Buffer.allocUnsafe(n);
  var p = list.head;
  var c = 1;
  p.data.copy(ret);
  n -= p.data.length;
  while (p = p.next) {
    var buf = p.data;
    var nb = n > buf.length ? buf.length : n;
    buf.copy(ret, ret.length - n, 0, nb);
    n -= nb;
    if (n === 0) {
      if (nb === buf.length) {
        ++c;
        if (p.next) list.head = p.next;else list.head = list.tail = null;
      } else {
        list.head = p;
        p.data = buf.slice(nb);
      }
      break;
    }
    ++c;
  }
  list.length -= c;
  return ret;
}

function endReadable(stream) {
  var state = stream._readableState;

  // If we get here before consuming all the bytes, then that is a
  // bug in node.  Should never happen.
  if (state.length > 0) throw new Error('"endReadable()" called on non-empty stream');

  if (!state.endEmitted) {
    state.ended = true;
    pna.nextTick(endReadableNT, state, stream);
  }
}

function endReadableNT(state, stream) {
  // Check that we didn't get one last unshift.
  if (!state.endEmitted && state.length === 0) {
    state.endEmitted = true;
    stream.readable = false;
    stream.emit('end');
  }
}

function indexOf(xs, x) {
  for (var i = 0, l = xs.length; i < l; i++) {
    if (xs[i] === x) return i;
  }
  return -1;
}
}).call(this,require('_process'),typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})

},{"./_stream_duplex":76,"./internal/streams/BufferList":81,"./internal/streams/destroy":82,"./internal/streams/stream":83,"_process":74,"core-util-is":54,"events":55,"inherits":58,"isarray":60,"process-nextick-args":73,"safe-buffer":288,"string_decoder/":84,"util":50}],79:[function(require,module,exports){
// Copyright Joyent, Inc. and other Node contributors.
//
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to permit
// persons to whom the Software is furnished to do so, subject to the
// following conditions:
//
// The above copyright notice and this permission notice shall be included
// in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
// USE OR OTHER DEALINGS IN THE SOFTWARE.

// a transform stream is a readable/writable stream where you do
// something with the data.  Sometimes it's called a "filter",
// but that's not a great name for it, since that implies a thing where
// some bits pass through, and others are simply ignored.  (That would
// be a valid example of a transform, of course.)
//
// While the output is causally related to the input, it's not a
// necessarily symmetric or synchronous transformation.  For example,
// a zlib stream might take multiple plain-text writes(), and then
// emit a single compressed chunk some time in the future.
//
// Here's how this works:
//
// The Transform stream has all the aspects of the readable and writable
// stream classes.  When you write(chunk), that calls _write(chunk,cb)
// internally, and returns false if there's a lot of pending writes
// buffered up.  When you call read(), that calls _read(n) until
// there's enough pending readable data buffered up.
//
// In a transform stream, the written data is placed in a buffer.  When
// _read(n) is called, it transforms the queued up data, calling the
// buffered _write cb's as it consumes chunks.  If consuming a single
// written chunk would result in multiple output chunks, then the first
// outputted bit calls the readcb, and subsequent chunks just go into
// the read buffer, and will cause it to emit 'readable' if necessary.
//
// This way, back-pressure is actually determined by the reading side,
// since _read has to be called to start processing a new chunk.  However,
// a pathological inflate type of transform can cause excessive buffering
// here.  For example, imagine a stream where every byte of input is
// interpreted as an integer from 0-255, and then results in that many
// bytes of output.  Writing the 4 bytes {ff,ff,ff,ff} would result in
// 1kb of data being output.  In this case, you could write a very small
// amount of input, and end up with a very large amount of output.  In
// such a pathological inflating mechanism, there'd be no way to tell
// the system to stop doing the transform.  A single 4MB write could
// cause the system to run out of memory.
//
// However, even in such a pathological case, only a single written chunk
// would be consumed, and then the rest would wait (un-transformed) until
// the results of the previous transformed chunk were consumed.

'use strict';

module.exports = Transform;

var Duplex = require('./_stream_duplex');

/*<replacement>*/
var util = require('core-util-is');
util.inherits = require('inherits');
/*</replacement>*/

util.inherits(Transform, Duplex);

function afterTransform(er, data) {
  var ts = this._transformState;
  ts.transforming = false;

  var cb = ts.writecb;

  if (!cb) {
    return this.emit('error', new Error('write callback called multiple times'));
  }

  ts.writechunk = null;
  ts.writecb = null;

  if (data != null) // single equals check for both `null` and `undefined`
    this.push(data);

  cb(er);

  var rs = this._readableState;
  rs.reading = false;
  if (rs.needReadable || rs.length < rs.highWaterMark) {
    this._read(rs.highWaterMark);
  }
}

function Transform(options) {
  if (!(this instanceof Transform)) return new Transform(options);

  Duplex.call(this, options);

  this._transformState = {
    afterTransform: afterTransform.bind(this),
    needTransform: false,
    transforming: false,
    writecb: null,
    writechunk: null,
    writeencoding: null
  };

  // start out asking for a readable event once data is transformed.
  this._readableState.needReadable = true;

  // we have implemented the _read method, and done the other things
  // that Readable wants before the first _read call, so unset the
  // sync guard flag.
  this._readableState.sync = false;

  if (options) {
    if (typeof options.transform === 'function') this._transform = options.transform;

    if (typeof options.flush === 'function') this._flush = options.flush;
  }

  // When the writable side finishes, then flush out anything remaining.
  this.on('prefinish', prefinish);
}

function prefinish() {
  var _this = this;

  if (typeof this._flush === 'function') {
    this._flush(function (er, data) {
      done(_this, er, data);
    });
  } else {
    done(this, null, null);
  }
}

Transform.prototype.push = function (chunk, encoding) {
  this._transformState.needTransform = false;
  return Duplex.prototype.push.call(this, chunk, encoding);
};

// This is the part where you do stuff!
// override this function in implementation classes.
// 'chunk' is an input chunk.
//
// Call `push(newChunk)` to pass along transformed output
// to the readable side.  You may call 'push' zero or more times.
//
// Call `cb(err)` when you are done with this chunk.  If you pass
// an error, then that'll put the hurt on the whole operation.  If you
// never call cb(), then you'll never get another chunk.
Transform.prototype._transform = function (chunk, encoding, cb) {
  throw new Error('_transform() is not implemented');
};

Transform.prototype._write = function (chunk, encoding, cb) {
  var ts = this._transformState;
  ts.writecb = cb;
  ts.writechunk = chunk;
  ts.writeencoding = encoding;
  if (!ts.transforming) {
    var rs = this._readableState;
    if (ts.needTransform || rs.needReadable || rs.length < rs.highWaterMark) this._read(rs.highWaterMark);
  }
};

// Doesn't matter what the args are here.
// _transform does all the work.
// That we got here means that the readable side wants more data.
Transform.prototype._read = function (n) {
  var ts = this._transformState;

  if (ts.writechunk !== null && ts.writecb && !ts.transforming) {
    ts.transforming = true;
    this._transform(ts.writechunk, ts.writeencoding, ts.afterTransform);
  } else {
    // mark that we need a transform, so that any data that comes in
    // will get processed, now that we've asked for it.
    ts.needTransform = true;
  }
};

Transform.prototype._destroy = function (err, cb) {
  var _this2 = this;

  Duplex.prototype._destroy.call(this, err, function (err2) {
    cb(err2);
    _this2.emit('close');
  });
};

function done(stream, er, data) {
  if (er) return stream.emit('error', er);

  if (data != null) // single equals check for both `null` and `undefined`
    stream.push(data);

  // if there's nothing in the write buffer, then that means
  // that nothing more will ever be provided
  if (stream._writableState.length) throw new Error('Calling transform done when ws.length != 0');

  if (stream._transformState.transforming) throw new Error('Calling transform done when still transforming');

  return stream.push(null);
}
},{"./_stream_duplex":76,"core-util-is":54,"inherits":58}],80:[function(require,module,exports){
(function (process,global,setImmediate){
// Copyright Joyent, Inc. and other Node contributors.
//
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to permit
// persons to whom the Software is furnished to do so, subject to the
// following conditions:
//
// The above copyright notice and this permission notice shall be included
// in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
// USE OR OTHER DEALINGS IN THE SOFTWARE.

// A bit simpler than readable streams.
// Implement an async ._write(chunk, encoding, cb), and it'll handle all
// the drain event emission and buffering.

'use strict';

/*<replacement>*/

var pna = require('process-nextick-args');
/*</replacement>*/

module.exports = Writable;

/* <replacement> */
function WriteReq(chunk, encoding, cb) {
  this.chunk = chunk;
  this.encoding = encoding;
  this.callback = cb;
  this.next = null;
}

// It seems a linked list but it is not
// there will be only 2 of these for each stream
function CorkedRequest(state) {
  var _this = this;

  this.next = null;
  this.entry = null;
  this.finish = function () {
    onCorkedFinish(_this, state);
  };
}
/* </replacement> */

/*<replacement>*/
var asyncWrite = !process.browser && ['v0.10', 'v0.9.'].indexOf(process.version.slice(0, 5)) > -1 ? setImmediate : pna.nextTick;
/*</replacement>*/

/*<replacement>*/
var Duplex;
/*</replacement>*/

Writable.WritableState = WritableState;

/*<replacement>*/
var util = require('core-util-is');
util.inherits = require('inherits');
/*</replacement>*/

/*<replacement>*/
var internalUtil = {
  deprecate: require('util-deprecate')
};
/*</replacement>*/

/*<replacement>*/
var Stream = require('./internal/streams/stream');
/*</replacement>*/

/*<replacement>*/

var Buffer = require('safe-buffer').Buffer;
var OurUint8Array = global.Uint8Array || function () {};
function _uint8ArrayToBuffer(chunk) {
  return Buffer.from(chunk);
}
function _isUint8Array(obj) {
  return Buffer.isBuffer(obj) || obj instanceof OurUint8Array;
}

/*</replacement>*/

var destroyImpl = require('./internal/streams/destroy');

util.inherits(Writable, Stream);

function nop() {}

function WritableState(options, stream) {
  Duplex = Duplex || require('./_stream_duplex');

  options = options || {};

  // Duplex streams are both readable and writable, but share
  // the same options object.
  // However, some cases require setting options to different
  // values for the readable and the writable sides of the duplex stream.
  // These options can be provided separately as readableXXX and writableXXX.
  var isDuplex = stream instanceof Duplex;

  // object stream flag to indicate whether or not this stream
  // contains buffers or objects.
  this.objectMode = !!options.objectMode;

  if (isDuplex) this.objectMode = this.objectMode || !!options.writableObjectMode;

  // the point at which write() starts returning false
  // Note: 0 is a valid value, means that we always return false if
  // the entire buffer is not flushed immediately on write()
  var hwm = options.highWaterMark;
  var writableHwm = options.writableHighWaterMark;
  var defaultHwm = this.objectMode ? 16 : 16 * 1024;

  if (hwm || hwm === 0) this.highWaterMark = hwm;else if (isDuplex && (writableHwm || writableHwm === 0)) this.highWaterMark = writableHwm;else this.highWaterMark = defaultHwm;

  // cast to ints.
  this.highWaterMark = Math.floor(this.highWaterMark);

  // if _final has been called
  this.finalCalled = false;

  // drain event flag.
  this.needDrain = false;
  // at the start of calling end()
  this.ending = false;
  // when end() has been called, and returned
  this.ended = false;
  // when 'finish' is emitted
  this.finished = false;

  // has it been destroyed
  this.destroyed = false;

  // should we decode strings into buffers before passing to _write?
  // this is here so that some node-core streams can optimize string
  // handling at a lower level.
  var noDecode = options.decodeStrings === false;
  this.decodeStrings = !noDecode;

  // Crypto is kind of old and crusty.  Historically, its default string
  // encoding is 'binary' so we have to make this configurable.
  // Everything else in the universe uses 'utf8', though.
  this.defaultEncoding = options.defaultEncoding || 'utf8';

  // not an actual buffer we keep track of, but a measurement
  // of how much we're waiting to get pushed to some underlying
  // socket or file.
  this.length = 0;

  // a flag to see when we're in the middle of a write.
  this.writing = false;

  // when true all writes will be buffered until .uncork() call
  this.corked = 0;

  // a flag to be able to tell if the onwrite cb is called immediately,
  // or on a later tick.  We set this to true at first, because any
  // actions that shouldn't happen until "later" should generally also
  // not happen before the first write call.
  this.sync = true;

  // a flag to know if we're processing previously buffered items, which
  // may call the _write() callback in the same tick, so that we don't
  // end up in an overlapped onwrite situation.
  this.bufferProcessing = false;

  // the callback that's passed to _write(chunk,cb)
  this.onwrite = function (er) {
    onwrite(stream, er);
  };

  // the callback that the user supplies to write(chunk,encoding,cb)
  this.writecb = null;

  // the amount that is being written when _write is called.
  this.writelen = 0;

  this.bufferedRequest = null;
  this.lastBufferedRequest = null;

  // number of pending user-supplied write callbacks
  // this must be 0 before 'finish' can be emitted
  this.pendingcb = 0;

  // emit prefinish if the only thing we're waiting for is _write cbs
  // This is relevant for synchronous Transform streams
  this.prefinished = false;

  // True if the error was already emitted and should not be thrown again
  this.errorEmitted = false;

  // count buffered requests
  this.bufferedRequestCount = 0;

  // allocate the first CorkedRequest, there is always
  // one allocated and free to use, and we maintain at most two
  this.corkedRequestsFree = new CorkedRequest(this);
}

WritableState.prototype.getBuffer = function getBuffer() {
  var current = this.bufferedRequest;
  var out = [];
  while (current) {
    out.push(current);
    current = current.next;
  }
  return out;
};

(function () {
  try {
    Object.defineProperty(WritableState.prototype, 'buffer', {
      get: internalUtil.deprecate(function () {
        return this.getBuffer();
      }, '_writableState.buffer is deprecated. Use _writableState.getBuffer ' + 'instead.', 'DEP0003')
    });
  } catch (_) {}
})();

// Test _writableState for inheritance to account for Duplex streams,
// whose prototype chain only points to Readable.
var realHasInstance;
if (typeof Symbol === 'function' && Symbol.hasInstance && typeof Function.prototype[Symbol.hasInstance] === 'function') {
  realHasInstance = Function.prototype[Symbol.hasInstance];
  Object.defineProperty(Writable, Symbol.hasInstance, {
    value: function (object) {
      if (realHasInstance.call(this, object)) return true;
      if (this !== Writable) return false;

      return object && object._writableState instanceof WritableState;
    }
  });
} else {
  realHasInstance = function (object) {
    return object instanceof this;
  };
}

function Writable(options) {
  Duplex = Duplex || require('./_stream_duplex');

  // Writable ctor is applied to Duplexes, too.
  // `realHasInstance` is necessary because using plain `instanceof`
  // would return false, as no `_writableState` property is attached.

  // Trying to use the custom `instanceof` for Writable here will also break the
  // Node.js LazyTransform implementation, which has a non-trivial getter for
  // `_writableState` that would lead to infinite recursion.
  if (!realHasInstance.call(Writable, this) && !(this instanceof Duplex)) {
    return new Writable(options);
  }

  this._writableState = new WritableState(options, this);

  // legacy.
  this.writable = true;

  if (options) {
    if (typeof options.write === 'function') this._write = options.write;

    if (typeof options.writev === 'function') this._writev = options.writev;

    if (typeof options.destroy === 'function') this._destroy = options.destroy;

    if (typeof options.final === 'function') this._final = options.final;
  }

  Stream.call(this);
}

// Otherwise people can pipe Writable streams, which is just wrong.
Writable.prototype.pipe = function () {
  this.emit('error', new Error('Cannot pipe, not readable'));
};

function writeAfterEnd(stream, cb) {
  var er = new Error('write after end');
  // TODO: defer error events consistently everywhere, not just the cb
  stream.emit('error', er);
  pna.nextTick(cb, er);
}

// Checks that a user-supplied chunk is valid, especially for the particular
// mode the stream is in. Currently this means that `null` is never accepted
// and undefined/non-string values are only allowed in object mode.
function validChunk(stream, state, chunk, cb) {
  var valid = true;
  var er = false;

  if (chunk === null) {
    er = new TypeError('May not write null values to stream');
  } else if (typeof chunk !== 'string' && chunk !== undefined && !state.objectMode) {
    er = new TypeError('Invalid non-string/buffer chunk');
  }
  if (er) {
    stream.emit('error', er);
    pna.nextTick(cb, er);
    valid = false;
  }
  return valid;
}

Writable.prototype.write = function (chunk, encoding, cb) {
  var state = this._writableState;
  var ret = false;
  var isBuf = !state.objectMode && _isUint8Array(chunk);

  if (isBuf && !Buffer.isBuffer(chunk)) {
    chunk = _uint8ArrayToBuffer(chunk);
  }

  if (typeof encoding === 'function') {
    cb = encoding;
    encoding = null;
  }

  if (isBuf) encoding = 'buffer';else if (!encoding) encoding = state.defaultEncoding;

  if (typeof cb !== 'function') cb = nop;

  if (state.ended) writeAfterEnd(this, cb);else if (isBuf || validChunk(this, state, chunk, cb)) {
    state.pendingcb++;
    ret = writeOrBuffer(this, state, isBuf, chunk, encoding, cb);
  }

  return ret;
};

Writable.prototype.cork = function () {
  var state = this._writableState;

  state.corked++;
};

Writable.prototype.uncork = function () {
  var state = this._writableState;

  if (state.corked) {
    state.corked--;

    if (!state.writing && !state.corked && !state.finished && !state.bufferProcessing && state.bufferedRequest) clearBuffer(this, state);
  }
};

Writable.prototype.setDefaultEncoding = function setDefaultEncoding(encoding) {
  // node::ParseEncoding() requires lower case.
  if (typeof encoding === 'string') encoding = encoding.toLowerCase();
  if (!(['hex', 'utf8', 'utf-8', 'ascii', 'binary', 'base64', 'ucs2', 'ucs-2', 'utf16le', 'utf-16le', 'raw'].indexOf((encoding + '').toLowerCase()) > -1)) throw new TypeError('Unknown encoding: ' + encoding);
  this._writableState.defaultEncoding = encoding;
  return this;
};

function decodeChunk(state, chunk, encoding) {
  if (!state.objectMode && state.decodeStrings !== false && typeof chunk === 'string') {
    chunk = Buffer.from(chunk, encoding);
  }
  return chunk;
}

Object.defineProperty(Writable.prototype, 'writableHighWaterMark', {
  // making it explicit this property is not enumerable
  // because otherwise some prototype manipulation in
  // userland will fail
  enumerable: false,
  get: function () {
    return this._writableState.highWaterMark;
  }
});

// if we're already writing something, then just put this
// in the queue, and wait our turn.  Otherwise, call _write
// If we return false, then we need a drain event, so set that flag.
function writeOrBuffer(stream, state, isBuf, chunk, encoding, cb) {
  if (!isBuf) {
    var newChunk = decodeChunk(state, chunk, encoding);
    if (chunk !== newChunk) {
      isBuf = true;
      encoding = 'buffer';
      chunk = newChunk;
    }
  }
  var len = state.objectMode ? 1 : chunk.length;

  state.length += len;

  var ret = state.length < state.highWaterMark;
  // we must ensure that previous needDrain will not be reset to false.
  if (!ret) state.needDrain = true;

  if (state.writing || state.corked) {
    var last = state.lastBufferedRequest;
    state.lastBufferedRequest = {
      chunk: chunk,
      encoding: encoding,
      isBuf: isBuf,
      callback: cb,
      next: null
    };
    if (last) {
      last.next = state.lastBufferedRequest;
    } else {
      state.bufferedRequest = state.lastBufferedRequest;
    }
    state.bufferedRequestCount += 1;
  } else {
    doWrite(stream, state, false, len, chunk, encoding, cb);
  }

  return ret;
}

function doWrite(stream, state, writev, len, chunk, encoding, cb) {
  state.writelen = len;
  state.writecb = cb;
  state.writing = true;
  state.sync = true;
  if (writev) stream._writev(chunk, state.onwrite);else stream._write(chunk, encoding, state.onwrite);
  state.sync = false;
}

function onwriteError(stream, state, sync, er, cb) {
  --state.pendingcb;

  if (sync) {
    // defer the callback if we are being called synchronously
    // to avoid piling up things on the stack
    pna.nextTick(cb, er);
    // this can emit finish, and it will always happen
    // after error
    pna.nextTick(finishMaybe, stream, state);
    stream._writableState.errorEmitted = true;
    stream.emit('error', er);
  } else {
    // the caller expect this to happen before if
    // it is async
    cb(er);
    stream._writableState.errorEmitted = true;
    stream.emit('error', er);
    // this can emit finish, but finish must
    // always follow error
    finishMaybe(stream, state);
  }
}

function onwriteStateUpdate(state) {
  state.writing = false;
  state.writecb = null;
  state.length -= state.writelen;
  state.writelen = 0;
}

function onwrite(stream, er) {
  var state = stream._writableState;
  var sync = state.sync;
  var cb = state.writecb;

  onwriteStateUpdate(state);

  if (er) onwriteError(stream, state, sync, er, cb);else {
    // Check if we're actually ready to finish, but don't emit yet
    var finished = needFinish(state);

    if (!finished && !state.corked && !state.bufferProcessing && state.bufferedRequest) {
      clearBuffer(stream, state);
    }

    if (sync) {
      /*<replacement>*/
      asyncWrite(afterWrite, stream, state, finished, cb);
      /*</replacement>*/
    } else {
      afterWrite(stream, state, finished, cb);
    }
  }
}

function afterWrite(stream, state, finished, cb) {
  if (!finished) onwriteDrain(stream, state);
  state.pendingcb--;
  cb();
  finishMaybe(stream, state);
}

// Must force callback to be called on nextTick, so that we don't
// emit 'drain' before the write() consumer gets the 'false' return
// value, and has a chance to attach a 'drain' listener.
function onwriteDrain(stream, state) {
  if (state.length === 0 && state.needDrain) {
    state.needDrain = false;
    stream.emit('drain');
  }
}

// if there's something in the buffer waiting, then process it
function clearBuffer(stream, state) {
  state.bufferProcessing = true;
  var entry = state.bufferedRequest;

  if (stream._writev && entry && entry.next) {
    // Fast case, write everything using _writev()
    var l = state.bufferedRequestCount;
    var buffer = new Array(l);
    var holder = state.corkedRequestsFree;
    holder.entry = entry;

    var count = 0;
    var allBuffers = true;
    while (entry) {
      buffer[count] = entry;
      if (!entry.isBuf) allBuffers = false;
      entry = entry.next;
      count += 1;
    }
    buffer.allBuffers = allBuffers;

    doWrite(stream, state, true, state.length, buffer, '', holder.finish);

    // doWrite is almost always async, defer these to save a bit of time
    // as the hot path ends with doWrite
    state.pendingcb++;
    state.lastBufferedRequest = null;
    if (holder.next) {
      state.corkedRequestsFree = holder.next;
      holder.next = null;
    } else {
      state.corkedRequestsFree = new CorkedRequest(state);
    }
    state.bufferedRequestCount = 0;
  } else {
    // Slow case, write chunks one-by-one
    while (entry) {
      var chunk = entry.chunk;
      var encoding = entry.encoding;
      var cb = entry.callback;
      var len = state.objectMode ? 1 : chunk.length;

      doWrite(stream, state, false, len, chunk, encoding, cb);
      entry = entry.next;
      state.bufferedRequestCount--;
      // if we didn't call the onwrite immediately, then
      // it means that we need to wait until it does.
      // also, that means that the chunk and cb are currently
      // being processed, so move the buffer counter past them.
      if (state.writing) {
        break;
      }
    }

    if (entry === null) state.lastBufferedRequest = null;
  }

  state.bufferedRequest = entry;
  state.bufferProcessing = false;
}

Writable.prototype._write = function (chunk, encoding, cb) {
  cb(new Error('_write() is not implemented'));
};

Writable.prototype._writev = null;

Writable.prototype.end = function (chunk, encoding, cb) {
  var state = this._writableState;

  if (typeof chunk === 'function') {
    cb = chunk;
    chunk = null;
    encoding = null;
  } else if (typeof encoding === 'function') {
    cb = encoding;
    encoding = null;
  }

  if (chunk !== null && chunk !== undefined) this.write(chunk, encoding);

  // .end() fully uncorks
  if (state.corked) {
    state.corked = 1;
    this.uncork();
  }

  // ignore unnecessary end() calls.
  if (!state.ending && !state.finished) endWritable(this, state, cb);
};

function needFinish(state) {
  return state.ending && state.length === 0 && state.bufferedRequest === null && !state.finished && !state.writing;
}
function callFinal(stream, state) {
  stream._final(function (err) {
    state.pendingcb--;
    if (err) {
      stream.emit('error', err);
    }
    state.prefinished = true;
    stream.emit('prefinish');
    finishMaybe(stream, state);
  });
}
function prefinish(stream, state) {
  if (!state.prefinished && !state.finalCalled) {
    if (typeof stream._final === 'function') {
      state.pendingcb++;
      state.finalCalled = true;
      pna.nextTick(callFinal, stream, state);
    } else {
      state.prefinished = true;
      stream.emit('prefinish');
    }
  }
}

function finishMaybe(stream, state) {
  var need = needFinish(state);
  if (need) {
    prefinish(stream, state);
    if (state.pendingcb === 0) {
      state.finished = true;
      stream.emit('finish');
    }
  }
  return need;
}

function endWritable(stream, state, cb) {
  state.ending = true;
  finishMaybe(stream, state);
  if (cb) {
    if (state.finished) pna.nextTick(cb);else stream.once('finish', cb);
  }
  state.ended = true;
  stream.writable = false;
}

function onCorkedFinish(corkReq, state, err) {
  var entry = corkReq.entry;
  corkReq.entry = null;
  while (entry) {
    var cb = entry.callback;
    state.pendingcb--;
    cb(err);
    entry = entry.next;
  }
  if (state.corkedRequestsFree) {
    state.corkedRequestsFree.next = corkReq;
  } else {
    state.corkedRequestsFree = corkReq;
  }
}

Object.defineProperty(Writable.prototype, 'destroyed', {
  get: function () {
    if (this._writableState === undefined) {
      return false;
    }
    return this._writableState.destroyed;
  },
  set: function (value) {
    // we ignore the value if the stream
    // has not been initialized yet
    if (!this._writableState) {
      return;
    }

    // backward compatibility, the user is explicitly
    // managing destroyed
    this._writableState.destroyed = value;
  }
});

Writable.prototype.destroy = destroyImpl.destroy;
Writable.prototype._undestroy = destroyImpl.undestroy;
Writable.prototype._destroy = function (err, cb) {
  this.end();
  cb(err);
};
}).call(this,require('_process'),typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {},require("timers").setImmediate)

},{"./_stream_duplex":76,"./internal/streams/destroy":82,"./internal/streams/stream":83,"_process":74,"core-util-is":54,"inherits":58,"process-nextick-args":73,"safe-buffer":288,"timers":290,"util-deprecate":292}],81:[function(require,module,exports){
'use strict';

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Buffer = require('safe-buffer').Buffer;
var util = require('util');

function copyBuffer(src, target, offset) {
  src.copy(target, offset);
}

module.exports = function () {
  function BufferList() {
    _classCallCheck(this, BufferList);

    this.head = null;
    this.tail = null;
    this.length = 0;
  }

  BufferList.prototype.push = function push(v) {
    var entry = { data: v, next: null };
    if (this.length > 0) this.tail.next = entry;else this.head = entry;
    this.tail = entry;
    ++this.length;
  };

  BufferList.prototype.unshift = function unshift(v) {
    var entry = { data: v, next: this.head };
    if (this.length === 0) this.tail = entry;
    this.head = entry;
    ++this.length;
  };

  BufferList.prototype.shift = function shift() {
    if (this.length === 0) return;
    var ret = this.head.data;
    if (this.length === 1) this.head = this.tail = null;else this.head = this.head.next;
    --this.length;
    return ret;
  };

  BufferList.prototype.clear = function clear() {
    this.head = this.tail = null;
    this.length = 0;
  };

  BufferList.prototype.join = function join(s) {
    if (this.length === 0) return '';
    var p = this.head;
    var ret = '' + p.data;
    while (p = p.next) {
      ret += s + p.data;
    }return ret;
  };

  BufferList.prototype.concat = function concat(n) {
    if (this.length === 0) return Buffer.alloc(0);
    if (this.length === 1) return this.head.data;
    var ret = Buffer.allocUnsafe(n >>> 0);
    var p = this.head;
    var i = 0;
    while (p) {
      copyBuffer(p.data, ret, i);
      i += p.data.length;
      p = p.next;
    }
    return ret;
  };

  return BufferList;
}();

if (util && util.inspect && util.inspect.custom) {
  module.exports.prototype[util.inspect.custom] = function () {
    var obj = util.inspect({ length: this.length });
    return this.constructor.name + ' ' + obj;
  };
}
},{"safe-buffer":288,"util":50}],82:[function(require,module,exports){
'use strict';

/*<replacement>*/

var pna = require('process-nextick-args');
/*</replacement>*/

// undocumented cb() API, needed for core, not for public API
function destroy(err, cb) {
  var _this = this;

  var readableDestroyed = this._readableState && this._readableState.destroyed;
  var writableDestroyed = this._writableState && this._writableState.destroyed;

  if (readableDestroyed || writableDestroyed) {
    if (cb) {
      cb(err);
    } else if (err && (!this._writableState || !this._writableState.errorEmitted)) {
      pna.nextTick(emitErrorNT, this, err);
    }
    return this;
  }

  // we set destroyed to true before firing error callbacks in order
  // to make it re-entrance safe in case destroy() is called within callbacks

  if (this._readableState) {
    this._readableState.destroyed = true;
  }

  // if this is a duplex stream mark the writable part as destroyed as well
  if (this._writableState) {
    this._writableState.destroyed = true;
  }

  this._destroy(err || null, function (err) {
    if (!cb && err) {
      pna.nextTick(emitErrorNT, _this, err);
      if (_this._writableState) {
        _this._writableState.errorEmitted = true;
      }
    } else if (cb) {
      cb(err);
    }
  });

  return this;
}

function undestroy() {
  if (this._readableState) {
    this._readableState.destroyed = false;
    this._readableState.reading = false;
    this._readableState.ended = false;
    this._readableState.endEmitted = false;
  }

  if (this._writableState) {
    this._writableState.destroyed = false;
    this._writableState.ended = false;
    this._writableState.ending = false;
    this._writableState.finished = false;
    this._writableState.errorEmitted = false;
  }
}

function emitErrorNT(self, err) {
  self.emit('error', err);
}

module.exports = {
  destroy: destroy,
  undestroy: undestroy
};
},{"process-nextick-args":73}],83:[function(require,module,exports){
module.exports = require('events').EventEmitter;

},{"events":55}],84:[function(require,module,exports){
// Copyright Joyent, Inc. and other Node contributors.
//
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to permit
// persons to whom the Software is furnished to do so, subject to the
// following conditions:
//
// The above copyright notice and this permission notice shall be included
// in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
// USE OR OTHER DEALINGS IN THE SOFTWARE.

'use strict';

/*<replacement>*/

var Buffer = require('safe-buffer').Buffer;
/*</replacement>*/

var isEncoding = Buffer.isEncoding || function (encoding) {
  encoding = '' + encoding;
  switch (encoding && encoding.toLowerCase()) {
    case 'hex':case 'utf8':case 'utf-8':case 'ascii':case 'binary':case 'base64':case 'ucs2':case 'ucs-2':case 'utf16le':case 'utf-16le':case 'raw':
      return true;
    default:
      return false;
  }
};

function _normalizeEncoding(enc) {
  if (!enc) return 'utf8';
  var retried;
  while (true) {
    switch (enc) {
      case 'utf8':
      case 'utf-8':
        return 'utf8';
      case 'ucs2':
      case 'ucs-2':
      case 'utf16le':
      case 'utf-16le':
        return 'utf16le';
      case 'latin1':
      case 'binary':
        return 'latin1';
      case 'base64':
      case 'ascii':
      case 'hex':
        return enc;
      default:
        if (retried) return; // undefined
        enc = ('' + enc).toLowerCase();
        retried = true;
    }
  }
};

// Do not cache `Buffer.isEncoding` when checking encoding names as some
// modules monkey-patch it to support additional encodings
function normalizeEncoding(enc) {
  var nenc = _normalizeEncoding(enc);
  if (typeof nenc !== 'string' && (Buffer.isEncoding === isEncoding || !isEncoding(enc))) throw new Error('Unknown encoding: ' + enc);
  return nenc || enc;
}

// StringDecoder provides an interface for efficiently splitting a series of
// buffers into a series of JS strings without breaking apart multi-byte
// characters.
exports.StringDecoder = StringDecoder;
function StringDecoder(encoding) {
  this.encoding = normalizeEncoding(encoding);
  var nb;
  switch (this.encoding) {
    case 'utf16le':
      this.text = utf16Text;
      this.end = utf16End;
      nb = 4;
      break;
    case 'utf8':
      this.fillLast = utf8FillLast;
      nb = 4;
      break;
    case 'base64':
      this.text = base64Text;
      this.end = base64End;
      nb = 3;
      break;
    default:
      this.write = simpleWrite;
      this.end = simpleEnd;
      return;
  }
  this.lastNeed = 0;
  this.lastTotal = 0;
  this.lastChar = Buffer.allocUnsafe(nb);
}

StringDecoder.prototype.write = function (buf) {
  if (buf.length === 0) return '';
  var r;
  var i;
  if (this.lastNeed) {
    r = this.fillLast(buf);
    if (r === undefined) return '';
    i = this.lastNeed;
    this.lastNeed = 0;
  } else {
    i = 0;
  }
  if (i < buf.length) return r ? r + this.text(buf, i) : this.text(buf, i);
  return r || '';
};

StringDecoder.prototype.end = utf8End;

// Returns only complete characters in a Buffer
StringDecoder.prototype.text = utf8Text;

// Attempts to complete a partial non-UTF-8 character using bytes from a Buffer
StringDecoder.prototype.fillLast = function (buf) {
  if (this.lastNeed <= buf.length) {
    buf.copy(this.lastChar, this.lastTotal - this.lastNeed, 0, this.lastNeed);
    return this.lastChar.toString(this.encoding, 0, this.lastTotal);
  }
  buf.copy(this.lastChar, this.lastTotal - this.lastNeed, 0, buf.length);
  this.lastNeed -= buf.length;
};

// Checks the type of a UTF-8 byte, whether it's ASCII, a leading byte, or a
// continuation byte. If an invalid byte is detected, -2 is returned.
function utf8CheckByte(byte) {
  if (byte <= 0x7F) return 0;else if (byte >> 5 === 0x06) return 2;else if (byte >> 4 === 0x0E) return 3;else if (byte >> 3 === 0x1E) return 4;
  return byte >> 6 === 0x02 ? -1 : -2;
}

// Checks at most 3 bytes at the end of a Buffer in order to detect an
// incomplete multi-byte UTF-8 character. The total number of bytes (2, 3, or 4)
// needed to complete the UTF-8 character (if applicable) are returned.
function utf8CheckIncomplete(self, buf, i) {
  var j = buf.length - 1;
  if (j < i) return 0;
  var nb = utf8CheckByte(buf[j]);
  if (nb >= 0) {
    if (nb > 0) self.lastNeed = nb - 1;
    return nb;
  }
  if (--j < i || nb === -2) return 0;
  nb = utf8CheckByte(buf[j]);
  if (nb >= 0) {
    if (nb > 0) self.lastNeed = nb - 2;
    return nb;
  }
  if (--j < i || nb === -2) return 0;
  nb = utf8CheckByte(buf[j]);
  if (nb >= 0) {
    if (nb > 0) {
      if (nb === 2) nb = 0;else self.lastNeed = nb - 3;
    }
    return nb;
  }
  return 0;
}

// Validates as many continuation bytes for a multi-byte UTF-8 character as
// needed or are available. If we see a non-continuation byte where we expect
// one, we "replace" the validated continuation bytes we've seen so far with
// a single UTF-8 replacement character ('\ufffd'), to match v8's UTF-8 decoding
// behavior. The continuation byte check is included three times in the case
// where all of the continuation bytes for a character exist in the same buffer.
// It is also done this way as a slight performance increase instead of using a
// loop.
function utf8CheckExtraBytes(self, buf, p) {
  if ((buf[0] & 0xC0) !== 0x80) {
    self.lastNeed = 0;
    return '\ufffd';
  }
  if (self.lastNeed > 1 && buf.length > 1) {
    if ((buf[1] & 0xC0) !== 0x80) {
      self.lastNeed = 1;
      return '\ufffd';
    }
    if (self.lastNeed > 2 && buf.length > 2) {
      if ((buf[2] & 0xC0) !== 0x80) {
        self.lastNeed = 2;
        return '\ufffd';
      }
    }
  }
}

// Attempts to complete a multi-byte UTF-8 character using bytes from a Buffer.
function utf8FillLast(buf) {
  var p = this.lastTotal - this.lastNeed;
  var r = utf8CheckExtraBytes(this, buf, p);
  if (r !== undefined) return r;
  if (this.lastNeed <= buf.length) {
    buf.copy(this.lastChar, p, 0, this.lastNeed);
    return this.lastChar.toString(this.encoding, 0, this.lastTotal);
  }
  buf.copy(this.lastChar, p, 0, buf.length);
  this.lastNeed -= buf.length;
}

// Returns all complete UTF-8 characters in a Buffer. If the Buffer ended on a
// partial character, the character's bytes are buffered until the required
// number of bytes are available.
function utf8Text(buf, i) {
  var total = utf8CheckIncomplete(this, buf, i);
  if (!this.lastNeed) return buf.toString('utf8', i);
  this.lastTotal = total;
  var end = buf.length - (total - this.lastNeed);
  buf.copy(this.lastChar, 0, end);
  return buf.toString('utf8', i, end);
}

// For UTF-8, a replacement character is added when ending on a partial
// character.
function utf8End(buf) {
  var r = buf && buf.length ? this.write(buf) : '';
  if (this.lastNeed) return r + '\ufffd';
  return r;
}

// UTF-16LE typically needs two bytes per character, but even if we have an even
// number of bytes available, we need to check if we end on a leading/high
// surrogate. In that case, we need to wait for the next two bytes in order to
// decode the last character properly.
function utf16Text(buf, i) {
  if ((buf.length - i) % 2 === 0) {
    var r = buf.toString('utf16le', i);
    if (r) {
      var c = r.charCodeAt(r.length - 1);
      if (c >= 0xD800 && c <= 0xDBFF) {
        this.lastNeed = 2;
        this.lastTotal = 4;
        this.lastChar[0] = buf[buf.length - 2];
        this.lastChar[1] = buf[buf.length - 1];
        return r.slice(0, -1);
      }
    }
    return r;
  }
  this.lastNeed = 1;
  this.lastTotal = 2;
  this.lastChar[0] = buf[buf.length - 1];
  return buf.toString('utf16le', i, buf.length - 1);
}

// For UTF-16LE we do not explicitly append special replacement characters if we
// end on a partial character, we simply let v8 handle that.
function utf16End(buf) {
  var r = buf && buf.length ? this.write(buf) : '';
  if (this.lastNeed) {
    var end = this.lastTotal - this.lastNeed;
    return r + this.lastChar.toString('utf16le', 0, end);
  }
  return r;
}

function base64Text(buf, i) {
  var n = (buf.length - i) % 3;
  if (n === 0) return buf.toString('base64', i);
  this.lastNeed = 3 - n;
  this.lastTotal = 3;
  if (n === 1) {
    this.lastChar[0] = buf[buf.length - 1];
  } else {
    this.lastChar[0] = buf[buf.length - 2];
    this.lastChar[1] = buf[buf.length - 1];
  }
  return buf.toString('base64', i, buf.length - n);
}

function base64End(buf) {
  var r = buf && buf.length ? this.write(buf) : '';
  if (this.lastNeed) return r + this.lastChar.toString('base64', 0, 3 - this.lastNeed);
  return r;
}

// Pass bytes on through for single-byte encodings (e.g. ascii, latin1, hex)
function simpleWrite(buf) {
  return buf.toString(this.encoding);
}

function simpleEnd(buf) {
  return buf && buf.length ? this.write(buf) : '';
}
},{"safe-buffer":288}],85:[function(require,module,exports){
module.exports = require('./readable').PassThrough

},{"./readable":86}],86:[function(require,module,exports){
exports = module.exports = require('./lib/_stream_readable.js');
exports.Stream = exports;
exports.Readable = exports;
exports.Writable = require('./lib/_stream_writable.js');
exports.Duplex = require('./lib/_stream_duplex.js');
exports.Transform = require('./lib/_stream_transform.js');
exports.PassThrough = require('./lib/_stream_passthrough.js');

},{"./lib/_stream_duplex.js":76,"./lib/_stream_passthrough.js":77,"./lib/_stream_readable.js":78,"./lib/_stream_transform.js":79,"./lib/_stream_writable.js":80}],87:[function(require,module,exports){
module.exports = require('./readable').Transform

},{"./readable":86}],88:[function(require,module,exports){
module.exports = require('./lib/_stream_writable.js');

},{"./lib/_stream_writable.js":80}],89:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Observable_1 = require("./internal/Observable");
exports.Observable = Observable_1.Observable;
var ConnectableObservable_1 = require("./internal/observable/ConnectableObservable");
exports.ConnectableObservable = ConnectableObservable_1.ConnectableObservable;
var groupBy_1 = require("./internal/operators/groupBy");
exports.GroupedObservable = groupBy_1.GroupedObservable;
var observable_1 = require("./internal/symbol/observable");
exports.observable = observable_1.observable;
var Subject_1 = require("./internal/Subject");
exports.Subject = Subject_1.Subject;
var BehaviorSubject_1 = require("./internal/BehaviorSubject");
exports.BehaviorSubject = BehaviorSubject_1.BehaviorSubject;
var ReplaySubject_1 = require("./internal/ReplaySubject");
exports.ReplaySubject = ReplaySubject_1.ReplaySubject;
var AsyncSubject_1 = require("./internal/AsyncSubject");
exports.AsyncSubject = AsyncSubject_1.AsyncSubject;
var asap_1 = require("./internal/scheduler/asap");
exports.asapScheduler = asap_1.asap;
var async_1 = require("./internal/scheduler/async");
exports.asyncScheduler = async_1.async;
var queue_1 = require("./internal/scheduler/queue");
exports.queueScheduler = queue_1.queue;
var animationFrame_1 = require("./internal/scheduler/animationFrame");
exports.animationFrameScheduler = animationFrame_1.animationFrame;
var VirtualTimeScheduler_1 = require("./internal/scheduler/VirtualTimeScheduler");
exports.VirtualTimeScheduler = VirtualTimeScheduler_1.VirtualTimeScheduler;
exports.VirtualAction = VirtualTimeScheduler_1.VirtualAction;
var Scheduler_1 = require("./internal/Scheduler");
exports.Scheduler = Scheduler_1.Scheduler;
var Subscription_1 = require("./internal/Subscription");
exports.Subscription = Subscription_1.Subscription;
var Subscriber_1 = require("./internal/Subscriber");
exports.Subscriber = Subscriber_1.Subscriber;
var Notification_1 = require("./internal/Notification");
exports.Notification = Notification_1.Notification;
exports.NotificationKind = Notification_1.NotificationKind;
var pipe_1 = require("./internal/util/pipe");
exports.pipe = pipe_1.pipe;
var noop_1 = require("./internal/util/noop");
exports.noop = noop_1.noop;
var identity_1 = require("./internal/util/identity");
exports.identity = identity_1.identity;
var isObservable_1 = require("./internal/util/isObservable");
exports.isObservable = isObservable_1.isObservable;
var ArgumentOutOfRangeError_1 = require("./internal/util/ArgumentOutOfRangeError");
exports.ArgumentOutOfRangeError = ArgumentOutOfRangeError_1.ArgumentOutOfRangeError;
var EmptyError_1 = require("./internal/util/EmptyError");
exports.EmptyError = EmptyError_1.EmptyError;
var ObjectUnsubscribedError_1 = require("./internal/util/ObjectUnsubscribedError");
exports.ObjectUnsubscribedError = ObjectUnsubscribedError_1.ObjectUnsubscribedError;
var UnsubscriptionError_1 = require("./internal/util/UnsubscriptionError");
exports.UnsubscriptionError = UnsubscriptionError_1.UnsubscriptionError;
var TimeoutError_1 = require("./internal/util/TimeoutError");
exports.TimeoutError = TimeoutError_1.TimeoutError;
var bindCallback_1 = require("./internal/observable/bindCallback");
exports.bindCallback = bindCallback_1.bindCallback;
var bindNodeCallback_1 = require("./internal/observable/bindNodeCallback");
exports.bindNodeCallback = bindNodeCallback_1.bindNodeCallback;
var combineLatest_1 = require("./internal/observable/combineLatest");
exports.combineLatest = combineLatest_1.combineLatest;
var concat_1 = require("./internal/observable/concat");
exports.concat = concat_1.concat;
var defer_1 = require("./internal/observable/defer");
exports.defer = defer_1.defer;
var empty_1 = require("./internal/observable/empty");
exports.empty = empty_1.empty;
var forkJoin_1 = require("./internal/observable/forkJoin");
exports.forkJoin = forkJoin_1.forkJoin;
var from_1 = require("./internal/observable/from");
exports.from = from_1.from;
var fromEvent_1 = require("./internal/observable/fromEvent");
exports.fromEvent = fromEvent_1.fromEvent;
var fromEventPattern_1 = require("./internal/observable/fromEventPattern");
exports.fromEventPattern = fromEventPattern_1.fromEventPattern;
var generate_1 = require("./internal/observable/generate");
exports.generate = generate_1.generate;
var iif_1 = require("./internal/observable/iif");
exports.iif = iif_1.iif;
var interval_1 = require("./internal/observable/interval");
exports.interval = interval_1.interval;
var merge_1 = require("./internal/observable/merge");
exports.merge = merge_1.merge;
var never_1 = require("./internal/observable/never");
exports.never = never_1.never;
var of_1 = require("./internal/observable/of");
exports.of = of_1.of;
var onErrorResumeNext_1 = require("./internal/observable/onErrorResumeNext");
exports.onErrorResumeNext = onErrorResumeNext_1.onErrorResumeNext;
var pairs_1 = require("./internal/observable/pairs");
exports.pairs = pairs_1.pairs;
var partition_1 = require("./internal/observable/partition");
exports.partition = partition_1.partition;
var race_1 = require("./internal/observable/race");
exports.race = race_1.race;
var range_1 = require("./internal/observable/range");
exports.range = range_1.range;
var throwError_1 = require("./internal/observable/throwError");
exports.throwError = throwError_1.throwError;
var timer_1 = require("./internal/observable/timer");
exports.timer = timer_1.timer;
var using_1 = require("./internal/observable/using");
exports.using = using_1.using;
var zip_1 = require("./internal/observable/zip");
exports.zip = zip_1.zip;
var scheduled_1 = require("./internal/scheduled/scheduled");
exports.scheduled = scheduled_1.scheduled;
var empty_2 = require("./internal/observable/empty");
exports.EMPTY = empty_2.EMPTY;
var never_2 = require("./internal/observable/never");
exports.NEVER = never_2.NEVER;
var config_1 = require("./internal/config");
exports.config = config_1.config;

},{"./internal/AsyncSubject":90,"./internal/BehaviorSubject":91,"./internal/Notification":93,"./internal/Observable":94,"./internal/ReplaySubject":97,"./internal/Scheduler":98,"./internal/Subject":99,"./internal/Subscriber":101,"./internal/Subscription":102,"./internal/config":103,"./internal/observable/ConnectableObservable":104,"./internal/observable/bindCallback":106,"./internal/observable/bindNodeCallback":107,"./internal/observable/combineLatest":108,"./internal/observable/concat":109,"./internal/observable/defer":110,"./internal/observable/empty":111,"./internal/observable/forkJoin":112,"./internal/observable/from":113,"./internal/observable/fromEvent":115,"./internal/observable/fromEventPattern":116,"./internal/observable/generate":117,"./internal/observable/iif":118,"./internal/observable/interval":119,"./internal/observable/merge":120,"./internal/observable/never":121,"./internal/observable/of":122,"./internal/observable/onErrorResumeNext":123,"./internal/observable/pairs":124,"./internal/observable/partition":125,"./internal/observable/race":126,"./internal/observable/range":127,"./internal/observable/throwError":128,"./internal/observable/timer":129,"./internal/observable/using":130,"./internal/observable/zip":131,"./internal/operators/groupBy":167,"./internal/scheduled/scheduled":239,"./internal/scheduler/VirtualTimeScheduler":249,"./internal/scheduler/animationFrame":250,"./internal/scheduler/asap":251,"./internal/scheduler/async":252,"./internal/scheduler/queue":253,"./internal/symbol/observable":255,"./internal/util/ArgumentOutOfRangeError":257,"./internal/util/EmptyError":258,"./internal/util/ObjectUnsubscribedError":260,"./internal/util/TimeoutError":261,"./internal/util/UnsubscriptionError":262,"./internal/util/identity":265,"./internal/util/isObservable":274,"./internal/util/noop":277,"./internal/util/pipe":279}],90:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subject_1 = require("./Subject");
var Subscription_1 = require("./Subscription");
var AsyncSubject = (function (_super) {
    __extends(AsyncSubject, _super);
    function AsyncSubject() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.value = null;
        _this.hasNext = false;
        _this.hasCompleted = false;
        return _this;
    }
    AsyncSubject.prototype._subscribe = function (subscriber) {
        if (this.hasError) {
            subscriber.error(this.thrownError);
            return Subscription_1.Subscription.EMPTY;
        }
        else if (this.hasCompleted && this.hasNext) {
            subscriber.next(this.value);
            subscriber.complete();
            return Subscription_1.Subscription.EMPTY;
        }
        return _super.prototype._subscribe.call(this, subscriber);
    };
    AsyncSubject.prototype.next = function (value) {
        if (!this.hasCompleted) {
            this.value = value;
            this.hasNext = true;
        }
    };
    AsyncSubject.prototype.error = function (error) {
        if (!this.hasCompleted) {
            _super.prototype.error.call(this, error);
        }
    };
    AsyncSubject.prototype.complete = function () {
        this.hasCompleted = true;
        if (this.hasNext) {
            _super.prototype.next.call(this, this.value);
        }
        _super.prototype.complete.call(this);
    };
    return AsyncSubject;
}(Subject_1.Subject));
exports.AsyncSubject = AsyncSubject;

},{"./Subject":99,"./Subscription":102}],91:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subject_1 = require("./Subject");
var ObjectUnsubscribedError_1 = require("./util/ObjectUnsubscribedError");
var BehaviorSubject = (function (_super) {
    __extends(BehaviorSubject, _super);
    function BehaviorSubject(_value) {
        var _this = _super.call(this) || this;
        _this._value = _value;
        return _this;
    }
    Object.defineProperty(BehaviorSubject.prototype, "value", {
        get: function () {
            return this.getValue();
        },
        enumerable: true,
        configurable: true
    });
    BehaviorSubject.prototype._subscribe = function (subscriber) {
        var subscription = _super.prototype._subscribe.call(this, subscriber);
        if (subscription && !subscription.closed) {
            subscriber.next(this._value);
        }
        return subscription;
    };
    BehaviorSubject.prototype.getValue = function () {
        if (this.hasError) {
            throw this.thrownError;
        }
        else if (this.closed) {
            throw new ObjectUnsubscribedError_1.ObjectUnsubscribedError();
        }
        else {
            return this._value;
        }
    };
    BehaviorSubject.prototype.next = function (value) {
        _super.prototype.next.call(this, this._value = value);
    };
    return BehaviorSubject;
}(Subject_1.Subject));
exports.BehaviorSubject = BehaviorSubject;

},{"./Subject":99,"./util/ObjectUnsubscribedError":260}],92:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subscriber_1 = require("./Subscriber");
var InnerSubscriber = (function (_super) {
    __extends(InnerSubscriber, _super);
    function InnerSubscriber(parent, outerValue, outerIndex) {
        var _this = _super.call(this) || this;
        _this.parent = parent;
        _this.outerValue = outerValue;
        _this.outerIndex = outerIndex;
        _this.index = 0;
        return _this;
    }
    InnerSubscriber.prototype._next = function (value) {
        this.parent.notifyNext(this.outerValue, value, this.outerIndex, this.index++, this);
    };
    InnerSubscriber.prototype._error = function (error) {
        this.parent.notifyError(error, this);
        this.unsubscribe();
    };
    InnerSubscriber.prototype._complete = function () {
        this.parent.notifyComplete(this);
        this.unsubscribe();
    };
    return InnerSubscriber;
}(Subscriber_1.Subscriber));
exports.InnerSubscriber = InnerSubscriber;

},{"./Subscriber":101}],93:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var empty_1 = require("./observable/empty");
var of_1 = require("./observable/of");
var throwError_1 = require("./observable/throwError");
var NotificationKind;
(function (NotificationKind) {
    NotificationKind["NEXT"] = "N";
    NotificationKind["ERROR"] = "E";
    NotificationKind["COMPLETE"] = "C";
})(NotificationKind = exports.NotificationKind || (exports.NotificationKind = {}));
var Notification = (function () {
    function Notification(kind, value, error) {
        this.kind = kind;
        this.value = value;
        this.error = error;
        this.hasValue = kind === 'N';
    }
    Notification.prototype.observe = function (observer) {
        switch (this.kind) {
            case 'N':
                return observer.next && observer.next(this.value);
            case 'E':
                return observer.error && observer.error(this.error);
            case 'C':
                return observer.complete && observer.complete();
        }
    };
    Notification.prototype.do = function (next, error, complete) {
        var kind = this.kind;
        switch (kind) {
            case 'N':
                return next && next(this.value);
            case 'E':
                return error && error(this.error);
            case 'C':
                return complete && complete();
        }
    };
    Notification.prototype.accept = function (nextOrObserver, error, complete) {
        if (nextOrObserver && typeof nextOrObserver.next === 'function') {
            return this.observe(nextOrObserver);
        }
        else {
            return this.do(nextOrObserver, error, complete);
        }
    };
    Notification.prototype.toObservable = function () {
        var kind = this.kind;
        switch (kind) {
            case 'N':
                return of_1.of(this.value);
            case 'E':
                return throwError_1.throwError(this.error);
            case 'C':
                return empty_1.empty();
        }
        throw new Error('unexpected notification kind value');
    };
    Notification.createNext = function (value) {
        if (typeof value !== 'undefined') {
            return new Notification('N', value);
        }
        return Notification.undefinedValueNotification;
    };
    Notification.createError = function (err) {
        return new Notification('E', undefined, err);
    };
    Notification.createComplete = function () {
        return Notification.completeNotification;
    };
    Notification.completeNotification = new Notification('C');
    Notification.undefinedValueNotification = new Notification('N', undefined);
    return Notification;
}());
exports.Notification = Notification;

},{"./observable/empty":111,"./observable/of":122,"./observable/throwError":128}],94:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var canReportError_1 = require("./util/canReportError");
var toSubscriber_1 = require("./util/toSubscriber");
var observable_1 = require("./symbol/observable");
var pipe_1 = require("./util/pipe");
var config_1 = require("./config");
var Observable = (function () {
    function Observable(subscribe) {
        this._isScalar = false;
        if (subscribe) {
            this._subscribe = subscribe;
        }
    }
    Observable.prototype.lift = function (operator) {
        var observable = new Observable();
        observable.source = this;
        observable.operator = operator;
        return observable;
    };
    Observable.prototype.subscribe = function (observerOrNext, error, complete) {
        var operator = this.operator;
        var sink = toSubscriber_1.toSubscriber(observerOrNext, error, complete);
        if (operator) {
            sink.add(operator.call(sink, this.source));
        }
        else {
            sink.add(this.source || (config_1.config.useDeprecatedSynchronousErrorHandling && !sink.syncErrorThrowable) ?
                this._subscribe(sink) :
                this._trySubscribe(sink));
        }
        if (config_1.config.useDeprecatedSynchronousErrorHandling) {
            if (sink.syncErrorThrowable) {
                sink.syncErrorThrowable = false;
                if (sink.syncErrorThrown) {
                    throw sink.syncErrorValue;
                }
            }
        }
        return sink;
    };
    Observable.prototype._trySubscribe = function (sink) {
        try {
            return this._subscribe(sink);
        }
        catch (err) {
            if (config_1.config.useDeprecatedSynchronousErrorHandling) {
                sink.syncErrorThrown = true;
                sink.syncErrorValue = err;
            }
            if (canReportError_1.canReportError(sink)) {
                sink.error(err);
            }
            else {
                console.warn(err);
            }
        }
    };
    Observable.prototype.forEach = function (next, promiseCtor) {
        var _this = this;
        promiseCtor = getPromiseCtor(promiseCtor);
        return new promiseCtor(function (resolve, reject) {
            var subscription;
            subscription = _this.subscribe(function (value) {
                try {
                    next(value);
                }
                catch (err) {
                    reject(err);
                    if (subscription) {
                        subscription.unsubscribe();
                    }
                }
            }, reject, resolve);
        });
    };
    Observable.prototype._subscribe = function (subscriber) {
        var source = this.source;
        return source && source.subscribe(subscriber);
    };
    Observable.prototype[observable_1.observable] = function () {
        return this;
    };
    Observable.prototype.pipe = function () {
        var operations = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            operations[_i] = arguments[_i];
        }
        if (operations.length === 0) {
            return this;
        }
        return pipe_1.pipeFromArray(operations)(this);
    };
    Observable.prototype.toPromise = function (promiseCtor) {
        var _this = this;
        promiseCtor = getPromiseCtor(promiseCtor);
        return new promiseCtor(function (resolve, reject) {
            var value;
            _this.subscribe(function (x) { return value = x; }, function (err) { return reject(err); }, function () { return resolve(value); });
        });
    };
    Observable.create = function (subscribe) {
        return new Observable(subscribe);
    };
    return Observable;
}());
exports.Observable = Observable;
function getPromiseCtor(promiseCtor) {
    if (!promiseCtor) {
        promiseCtor = config_1.config.Promise || Promise;
    }
    if (!promiseCtor) {
        throw new Error('no Promise impl found');
    }
    return promiseCtor;
}

},{"./config":103,"./symbol/observable":255,"./util/canReportError":263,"./util/pipe":279,"./util/toSubscriber":286}],95:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var config_1 = require("./config");
var hostReportError_1 = require("./util/hostReportError");
exports.empty = {
    closed: true,
    next: function (value) { },
    error: function (err) {
        if (config_1.config.useDeprecatedSynchronousErrorHandling) {
            throw err;
        }
        else {
            hostReportError_1.hostReportError(err);
        }
    },
    complete: function () { }
};

},{"./config":103,"./util/hostReportError":264}],96:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subscriber_1 = require("./Subscriber");
var OuterSubscriber = (function (_super) {
    __extends(OuterSubscriber, _super);
    function OuterSubscriber() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    OuterSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
        this.destination.next(innerValue);
    };
    OuterSubscriber.prototype.notifyError = function (error, innerSub) {
        this.destination.error(error);
    };
    OuterSubscriber.prototype.notifyComplete = function (innerSub) {
        this.destination.complete();
    };
    return OuterSubscriber;
}(Subscriber_1.Subscriber));
exports.OuterSubscriber = OuterSubscriber;

},{"./Subscriber":101}],97:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subject_1 = require("./Subject");
var queue_1 = require("./scheduler/queue");
var Subscription_1 = require("./Subscription");
var observeOn_1 = require("./operators/observeOn");
var ObjectUnsubscribedError_1 = require("./util/ObjectUnsubscribedError");
var SubjectSubscription_1 = require("./SubjectSubscription");
var ReplaySubject = (function (_super) {
    __extends(ReplaySubject, _super);
    function ReplaySubject(bufferSize, windowTime, scheduler) {
        if (bufferSize === void 0) { bufferSize = Number.POSITIVE_INFINITY; }
        if (windowTime === void 0) { windowTime = Number.POSITIVE_INFINITY; }
        var _this = _super.call(this) || this;
        _this.scheduler = scheduler;
        _this._events = [];
        _this._infiniteTimeWindow = false;
        _this._bufferSize = bufferSize < 1 ? 1 : bufferSize;
        _this._windowTime = windowTime < 1 ? 1 : windowTime;
        if (windowTime === Number.POSITIVE_INFINITY) {
            _this._infiniteTimeWindow = true;
            _this.next = _this.nextInfiniteTimeWindow;
        }
        else {
            _this.next = _this.nextTimeWindow;
        }
        return _this;
    }
    ReplaySubject.prototype.nextInfiniteTimeWindow = function (value) {
        var _events = this._events;
        _events.push(value);
        if (_events.length > this._bufferSize) {
            _events.shift();
        }
        _super.prototype.next.call(this, value);
    };
    ReplaySubject.prototype.nextTimeWindow = function (value) {
        this._events.push(new ReplayEvent(this._getNow(), value));
        this._trimBufferThenGetEvents();
        _super.prototype.next.call(this, value);
    };
    ReplaySubject.prototype._subscribe = function (subscriber) {
        var _infiniteTimeWindow = this._infiniteTimeWindow;
        var _events = _infiniteTimeWindow ? this._events : this._trimBufferThenGetEvents();
        var scheduler = this.scheduler;
        var len = _events.length;
        var subscription;
        if (this.closed) {
            throw new ObjectUnsubscribedError_1.ObjectUnsubscribedError();
        }
        else if (this.isStopped || this.hasError) {
            subscription = Subscription_1.Subscription.EMPTY;
        }
        else {
            this.observers.push(subscriber);
            subscription = new SubjectSubscription_1.SubjectSubscription(this, subscriber);
        }
        if (scheduler) {
            subscriber.add(subscriber = new observeOn_1.ObserveOnSubscriber(subscriber, scheduler));
        }
        if (_infiniteTimeWindow) {
            for (var i = 0; i < len && !subscriber.closed; i++) {
                subscriber.next(_events[i]);
            }
        }
        else {
            for (var i = 0; i < len && !subscriber.closed; i++) {
                subscriber.next(_events[i].value);
            }
        }
        if (this.hasError) {
            subscriber.error(this.thrownError);
        }
        else if (this.isStopped) {
            subscriber.complete();
        }
        return subscription;
    };
    ReplaySubject.prototype._getNow = function () {
        return (this.scheduler || queue_1.queue).now();
    };
    ReplaySubject.prototype._trimBufferThenGetEvents = function () {
        var now = this._getNow();
        var _bufferSize = this._bufferSize;
        var _windowTime = this._windowTime;
        var _events = this._events;
        var eventsCount = _events.length;
        var spliceCount = 0;
        while (spliceCount < eventsCount) {
            if ((now - _events[spliceCount].time) < _windowTime) {
                break;
            }
            spliceCount++;
        }
        if (eventsCount > _bufferSize) {
            spliceCount = Math.max(spliceCount, eventsCount - _bufferSize);
        }
        if (spliceCount > 0) {
            _events.splice(0, spliceCount);
        }
        return _events;
    };
    return ReplaySubject;
}(Subject_1.Subject));
exports.ReplaySubject = ReplaySubject;
var ReplayEvent = (function () {
    function ReplayEvent(time, value) {
        this.time = time;
        this.value = value;
    }
    return ReplayEvent;
}());

},{"./Subject":99,"./SubjectSubscription":100,"./Subscription":102,"./operators/observeOn":182,"./scheduler/queue":253,"./util/ObjectUnsubscribedError":260}],98:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Scheduler = (function () {
    function Scheduler(SchedulerAction, now) {
        if (now === void 0) { now = Scheduler.now; }
        this.SchedulerAction = SchedulerAction;
        this.now = now;
    }
    Scheduler.prototype.schedule = function (work, delay, state) {
        if (delay === void 0) { delay = 0; }
        return new this.SchedulerAction(this, work).schedule(state, delay);
    };
    Scheduler.now = function () { return Date.now(); };
    return Scheduler;
}());
exports.Scheduler = Scheduler;

},{}],99:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Observable_1 = require("./Observable");
var Subscriber_1 = require("./Subscriber");
var Subscription_1 = require("./Subscription");
var ObjectUnsubscribedError_1 = require("./util/ObjectUnsubscribedError");
var SubjectSubscription_1 = require("./SubjectSubscription");
var rxSubscriber_1 = require("../internal/symbol/rxSubscriber");
var SubjectSubscriber = (function (_super) {
    __extends(SubjectSubscriber, _super);
    function SubjectSubscriber(destination) {
        var _this = _super.call(this, destination) || this;
        _this.destination = destination;
        return _this;
    }
    return SubjectSubscriber;
}(Subscriber_1.Subscriber));
exports.SubjectSubscriber = SubjectSubscriber;
var Subject = (function (_super) {
    __extends(Subject, _super);
    function Subject() {
        var _this = _super.call(this) || this;
        _this.observers = [];
        _this.closed = false;
        _this.isStopped = false;
        _this.hasError = false;
        _this.thrownError = null;
        return _this;
    }
    Subject.prototype[rxSubscriber_1.rxSubscriber] = function () {
        return new SubjectSubscriber(this);
    };
    Subject.prototype.lift = function (operator) {
        var subject = new AnonymousSubject(this, this);
        subject.operator = operator;
        return subject;
    };
    Subject.prototype.next = function (value) {
        if (this.closed) {
            throw new ObjectUnsubscribedError_1.ObjectUnsubscribedError();
        }
        if (!this.isStopped) {
            var observers = this.observers;
            var len = observers.length;
            var copy = observers.slice();
            for (var i = 0; i < len; i++) {
                copy[i].next(value);
            }
        }
    };
    Subject.prototype.error = function (err) {
        if (this.closed) {
            throw new ObjectUnsubscribedError_1.ObjectUnsubscribedError();
        }
        this.hasError = true;
        this.thrownError = err;
        this.isStopped = true;
        var observers = this.observers;
        var len = observers.length;
        var copy = observers.slice();
        for (var i = 0; i < len; i++) {
            copy[i].error(err);
        }
        this.observers.length = 0;
    };
    Subject.prototype.complete = function () {
        if (this.closed) {
            throw new ObjectUnsubscribedError_1.ObjectUnsubscribedError();
        }
        this.isStopped = true;
        var observers = this.observers;
        var len = observers.length;
        var copy = observers.slice();
        for (var i = 0; i < len; i++) {
            copy[i].complete();
        }
        this.observers.length = 0;
    };
    Subject.prototype.unsubscribe = function () {
        this.isStopped = true;
        this.closed = true;
        this.observers = null;
    };
    Subject.prototype._trySubscribe = function (subscriber) {
        if (this.closed) {
            throw new ObjectUnsubscribedError_1.ObjectUnsubscribedError();
        }
        else {
            return _super.prototype._trySubscribe.call(this, subscriber);
        }
    };
    Subject.prototype._subscribe = function (subscriber) {
        if (this.closed) {
            throw new ObjectUnsubscribedError_1.ObjectUnsubscribedError();
        }
        else if (this.hasError) {
            subscriber.error(this.thrownError);
            return Subscription_1.Subscription.EMPTY;
        }
        else if (this.isStopped) {
            subscriber.complete();
            return Subscription_1.Subscription.EMPTY;
        }
        else {
            this.observers.push(subscriber);
            return new SubjectSubscription_1.SubjectSubscription(this, subscriber);
        }
    };
    Subject.prototype.asObservable = function () {
        var observable = new Observable_1.Observable();
        observable.source = this;
        return observable;
    };
    Subject.create = function (destination, source) {
        return new AnonymousSubject(destination, source);
    };
    return Subject;
}(Observable_1.Observable));
exports.Subject = Subject;
var AnonymousSubject = (function (_super) {
    __extends(AnonymousSubject, _super);
    function AnonymousSubject(destination, source) {
        var _this = _super.call(this) || this;
        _this.destination = destination;
        _this.source = source;
        return _this;
    }
    AnonymousSubject.prototype.next = function (value) {
        var destination = this.destination;
        if (destination && destination.next) {
            destination.next(value);
        }
    };
    AnonymousSubject.prototype.error = function (err) {
        var destination = this.destination;
        if (destination && destination.error) {
            this.destination.error(err);
        }
    };
    AnonymousSubject.prototype.complete = function () {
        var destination = this.destination;
        if (destination && destination.complete) {
            this.destination.complete();
        }
    };
    AnonymousSubject.prototype._subscribe = function (subscriber) {
        var source = this.source;
        if (source) {
            return this.source.subscribe(subscriber);
        }
        else {
            return Subscription_1.Subscription.EMPTY;
        }
    };
    return AnonymousSubject;
}(Subject));
exports.AnonymousSubject = AnonymousSubject;

},{"../internal/symbol/rxSubscriber":256,"./Observable":94,"./SubjectSubscription":100,"./Subscriber":101,"./Subscription":102,"./util/ObjectUnsubscribedError":260}],100:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subscription_1 = require("./Subscription");
var SubjectSubscription = (function (_super) {
    __extends(SubjectSubscription, _super);
    function SubjectSubscription(subject, subscriber) {
        var _this = _super.call(this) || this;
        _this.subject = subject;
        _this.subscriber = subscriber;
        _this.closed = false;
        return _this;
    }
    SubjectSubscription.prototype.unsubscribe = function () {
        if (this.closed) {
            return;
        }
        this.closed = true;
        var subject = this.subject;
        var observers = subject.observers;
        this.subject = null;
        if (!observers || observers.length === 0 || subject.isStopped || subject.closed) {
            return;
        }
        var subscriberIndex = observers.indexOf(this.subscriber);
        if (subscriberIndex !== -1) {
            observers.splice(subscriberIndex, 1);
        }
    };
    return SubjectSubscription;
}(Subscription_1.Subscription));
exports.SubjectSubscription = SubjectSubscription;

},{"./Subscription":102}],101:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var isFunction_1 = require("./util/isFunction");
var Observer_1 = require("./Observer");
var Subscription_1 = require("./Subscription");
var rxSubscriber_1 = require("../internal/symbol/rxSubscriber");
var config_1 = require("./config");
var hostReportError_1 = require("./util/hostReportError");
var Subscriber = (function (_super) {
    __extends(Subscriber, _super);
    function Subscriber(destinationOrNext, error, complete) {
        var _this = _super.call(this) || this;
        _this.syncErrorValue = null;
        _this.syncErrorThrown = false;
        _this.syncErrorThrowable = false;
        _this.isStopped = false;
        switch (arguments.length) {
            case 0:
                _this.destination = Observer_1.empty;
                break;
            case 1:
                if (!destinationOrNext) {
                    _this.destination = Observer_1.empty;
                    break;
                }
                if (typeof destinationOrNext === 'object') {
                    if (destinationOrNext instanceof Subscriber) {
                        _this.syncErrorThrowable = destinationOrNext.syncErrorThrowable;
                        _this.destination = destinationOrNext;
                        destinationOrNext.add(_this);
                    }
                    else {
                        _this.syncErrorThrowable = true;
                        _this.destination = new SafeSubscriber(_this, destinationOrNext);
                    }
                    break;
                }
            default:
                _this.syncErrorThrowable = true;
                _this.destination = new SafeSubscriber(_this, destinationOrNext, error, complete);
                break;
        }
        return _this;
    }
    Subscriber.prototype[rxSubscriber_1.rxSubscriber] = function () { return this; };
    Subscriber.create = function (next, error, complete) {
        var subscriber = new Subscriber(next, error, complete);
        subscriber.syncErrorThrowable = false;
        return subscriber;
    };
    Subscriber.prototype.next = function (value) {
        if (!this.isStopped) {
            this._next(value);
        }
    };
    Subscriber.prototype.error = function (err) {
        if (!this.isStopped) {
            this.isStopped = true;
            this._error(err);
        }
    };
    Subscriber.prototype.complete = function () {
        if (!this.isStopped) {
            this.isStopped = true;
            this._complete();
        }
    };
    Subscriber.prototype.unsubscribe = function () {
        if (this.closed) {
            return;
        }
        this.isStopped = true;
        _super.prototype.unsubscribe.call(this);
    };
    Subscriber.prototype._next = function (value) {
        this.destination.next(value);
    };
    Subscriber.prototype._error = function (err) {
        this.destination.error(err);
        this.unsubscribe();
    };
    Subscriber.prototype._complete = function () {
        this.destination.complete();
        this.unsubscribe();
    };
    Subscriber.prototype._unsubscribeAndRecycle = function () {
        var _parentOrParents = this._parentOrParents;
        this._parentOrParents = null;
        this.unsubscribe();
        this.closed = false;
        this.isStopped = false;
        this._parentOrParents = _parentOrParents;
        return this;
    };
    return Subscriber;
}(Subscription_1.Subscription));
exports.Subscriber = Subscriber;
var SafeSubscriber = (function (_super) {
    __extends(SafeSubscriber, _super);
    function SafeSubscriber(_parentSubscriber, observerOrNext, error, complete) {
        var _this = _super.call(this) || this;
        _this._parentSubscriber = _parentSubscriber;
        var next;
        var context = _this;
        if (isFunction_1.isFunction(observerOrNext)) {
            next = observerOrNext;
        }
        else if (observerOrNext) {
            next = observerOrNext.next;
            error = observerOrNext.error;
            complete = observerOrNext.complete;
            if (observerOrNext !== Observer_1.empty) {
                context = Object.create(observerOrNext);
                if (isFunction_1.isFunction(context.unsubscribe)) {
                    _this.add(context.unsubscribe.bind(context));
                }
                context.unsubscribe = _this.unsubscribe.bind(_this);
            }
        }
        _this._context = context;
        _this._next = next;
        _this._error = error;
        _this._complete = complete;
        return _this;
    }
    SafeSubscriber.prototype.next = function (value) {
        if (!this.isStopped && this._next) {
            var _parentSubscriber = this._parentSubscriber;
            if (!config_1.config.useDeprecatedSynchronousErrorHandling || !_parentSubscriber.syncErrorThrowable) {
                this.__tryOrUnsub(this._next, value);
            }
            else if (this.__tryOrSetError(_parentSubscriber, this._next, value)) {
                this.unsubscribe();
            }
        }
    };
    SafeSubscriber.prototype.error = function (err) {
        if (!this.isStopped) {
            var _parentSubscriber = this._parentSubscriber;
            var useDeprecatedSynchronousErrorHandling = config_1.config.useDeprecatedSynchronousErrorHandling;
            if (this._error) {
                if (!useDeprecatedSynchronousErrorHandling || !_parentSubscriber.syncErrorThrowable) {
                    this.__tryOrUnsub(this._error, err);
                    this.unsubscribe();
                }
                else {
                    this.__tryOrSetError(_parentSubscriber, this._error, err);
                    this.unsubscribe();
                }
            }
            else if (!_parentSubscriber.syncErrorThrowable) {
                this.unsubscribe();
                if (useDeprecatedSynchronousErrorHandling) {
                    throw err;
                }
                hostReportError_1.hostReportError(err);
            }
            else {
                if (useDeprecatedSynchronousErrorHandling) {
                    _parentSubscriber.syncErrorValue = err;
                    _parentSubscriber.syncErrorThrown = true;
                }
                else {
                    hostReportError_1.hostReportError(err);
                }
                this.unsubscribe();
            }
        }
    };
    SafeSubscriber.prototype.complete = function () {
        var _this = this;
        if (!this.isStopped) {
            var _parentSubscriber = this._parentSubscriber;
            if (this._complete) {
                var wrappedComplete = function () { return _this._complete.call(_this._context); };
                if (!config_1.config.useDeprecatedSynchronousErrorHandling || !_parentSubscriber.syncErrorThrowable) {
                    this.__tryOrUnsub(wrappedComplete);
                    this.unsubscribe();
                }
                else {
                    this.__tryOrSetError(_parentSubscriber, wrappedComplete);
                    this.unsubscribe();
                }
            }
            else {
                this.unsubscribe();
            }
        }
    };
    SafeSubscriber.prototype.__tryOrUnsub = function (fn, value) {
        try {
            fn.call(this._context, value);
        }
        catch (err) {
            this.unsubscribe();
            if (config_1.config.useDeprecatedSynchronousErrorHandling) {
                throw err;
            }
            else {
                hostReportError_1.hostReportError(err);
            }
        }
    };
    SafeSubscriber.prototype.__tryOrSetError = function (parent, fn, value) {
        if (!config_1.config.useDeprecatedSynchronousErrorHandling) {
            throw new Error('bad call');
        }
        try {
            fn.call(this._context, value);
        }
        catch (err) {
            if (config_1.config.useDeprecatedSynchronousErrorHandling) {
                parent.syncErrorValue = err;
                parent.syncErrorThrown = true;
                return true;
            }
            else {
                hostReportError_1.hostReportError(err);
                return true;
            }
        }
        return false;
    };
    SafeSubscriber.prototype._unsubscribe = function () {
        var _parentSubscriber = this._parentSubscriber;
        this._context = null;
        this._parentSubscriber = null;
        _parentSubscriber.unsubscribe();
    };
    return SafeSubscriber;
}(Subscriber));
exports.SafeSubscriber = SafeSubscriber;

},{"../internal/symbol/rxSubscriber":256,"./Observer":95,"./Subscription":102,"./config":103,"./util/hostReportError":264,"./util/isFunction":269}],102:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var isArray_1 = require("./util/isArray");
var isObject_1 = require("./util/isObject");
var isFunction_1 = require("./util/isFunction");
var UnsubscriptionError_1 = require("./util/UnsubscriptionError");
var Subscription = (function () {
    function Subscription(unsubscribe) {
        this.closed = false;
        this._parentOrParents = null;
        this._subscriptions = null;
        if (unsubscribe) {
            this._unsubscribe = unsubscribe;
        }
    }
    Subscription.prototype.unsubscribe = function () {
        var errors;
        if (this.closed) {
            return;
        }
        var _a = this, _parentOrParents = _a._parentOrParents, _unsubscribe = _a._unsubscribe, _subscriptions = _a._subscriptions;
        this.closed = true;
        this._parentOrParents = null;
        this._subscriptions = null;
        if (_parentOrParents instanceof Subscription) {
            _parentOrParents.remove(this);
        }
        else if (_parentOrParents !== null) {
            for (var index = 0; index < _parentOrParents.length; ++index) {
                var parent_1 = _parentOrParents[index];
                parent_1.remove(this);
            }
        }
        if (isFunction_1.isFunction(_unsubscribe)) {
            try {
                _unsubscribe.call(this);
            }
            catch (e) {
                errors = e instanceof UnsubscriptionError_1.UnsubscriptionError ? flattenUnsubscriptionErrors(e.errors) : [e];
            }
        }
        if (isArray_1.isArray(_subscriptions)) {
            var index = -1;
            var len = _subscriptions.length;
            while (++index < len) {
                var sub = _subscriptions[index];
                if (isObject_1.isObject(sub)) {
                    try {
                        sub.unsubscribe();
                    }
                    catch (e) {
                        errors = errors || [];
                        if (e instanceof UnsubscriptionError_1.UnsubscriptionError) {
                            errors = errors.concat(flattenUnsubscriptionErrors(e.errors));
                        }
                        else {
                            errors.push(e);
                        }
                    }
                }
            }
        }
        if (errors) {
            throw new UnsubscriptionError_1.UnsubscriptionError(errors);
        }
    };
    Subscription.prototype.add = function (teardown) {
        var subscription = teardown;
        if (!teardown) {
            return Subscription.EMPTY;
        }
        switch (typeof teardown) {
            case 'function':
                subscription = new Subscription(teardown);
            case 'object':
                if (subscription === this || subscription.closed || typeof subscription.unsubscribe !== 'function') {
                    return subscription;
                }
                else if (this.closed) {
                    subscription.unsubscribe();
                    return subscription;
                }
                else if (!(subscription instanceof Subscription)) {
                    var tmp = subscription;
                    subscription = new Subscription();
                    subscription._subscriptions = [tmp];
                }
                break;
            default: {
                throw new Error('unrecognized teardown ' + teardown + ' added to Subscription.');
            }
        }
        var _parentOrParents = subscription._parentOrParents;
        if (_parentOrParents === null) {
            subscription._parentOrParents = this;
        }
        else if (_parentOrParents instanceof Subscription) {
            if (_parentOrParents === this) {
                return subscription;
            }
            subscription._parentOrParents = [_parentOrParents, this];
        }
        else if (_parentOrParents.indexOf(this) === -1) {
            _parentOrParents.push(this);
        }
        else {
            return subscription;
        }
        var subscriptions = this._subscriptions;
        if (subscriptions === null) {
            this._subscriptions = [subscription];
        }
        else {
            subscriptions.push(subscription);
        }
        return subscription;
    };
    Subscription.prototype.remove = function (subscription) {
        var subscriptions = this._subscriptions;
        if (subscriptions) {
            var subscriptionIndex = subscriptions.indexOf(subscription);
            if (subscriptionIndex !== -1) {
                subscriptions.splice(subscriptionIndex, 1);
            }
        }
    };
    Subscription.EMPTY = (function (empty) {
        empty.closed = true;
        return empty;
    }(new Subscription()));
    return Subscription;
}());
exports.Subscription = Subscription;
function flattenUnsubscriptionErrors(errors) {
    return errors.reduce(function (errs, err) { return errs.concat((err instanceof UnsubscriptionError_1.UnsubscriptionError) ? err.errors : err); }, []);
}

},{"./util/UnsubscriptionError":262,"./util/isArray":266,"./util/isFunction":269,"./util/isObject":273}],103:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _enable_super_gross_mode_that_will_cause_bad_things = false;
exports.config = {
    Promise: undefined,
    set useDeprecatedSynchronousErrorHandling(value) {
        if (value) {
            var error = new Error();
            console.warn('DEPRECATED! RxJS was set to use deprecated synchronous error handling behavior by code at: \n' + error.stack);
        }
        else if (_enable_super_gross_mode_that_will_cause_bad_things) {
            console.log('RxJS: Back to a better error behavior. Thank you. <3');
        }
        _enable_super_gross_mode_that_will_cause_bad_things = value;
    },
    get useDeprecatedSynchronousErrorHandling() {
        return _enable_super_gross_mode_that_will_cause_bad_things;
    },
};

},{}],104:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subject_1 = require("../Subject");
var Observable_1 = require("../Observable");
var Subscriber_1 = require("../Subscriber");
var Subscription_1 = require("../Subscription");
var refCount_1 = require("../operators/refCount");
var ConnectableObservable = (function (_super) {
    __extends(ConnectableObservable, _super);
    function ConnectableObservable(source, subjectFactory) {
        var _this = _super.call(this) || this;
        _this.source = source;
        _this.subjectFactory = subjectFactory;
        _this._refCount = 0;
        _this._isComplete = false;
        return _this;
    }
    ConnectableObservable.prototype._subscribe = function (subscriber) {
        return this.getSubject().subscribe(subscriber);
    };
    ConnectableObservable.prototype.getSubject = function () {
        var subject = this._subject;
        if (!subject || subject.isStopped) {
            this._subject = this.subjectFactory();
        }
        return this._subject;
    };
    ConnectableObservable.prototype.connect = function () {
        var connection = this._connection;
        if (!connection) {
            this._isComplete = false;
            connection = this._connection = new Subscription_1.Subscription();
            connection.add(this.source
                .subscribe(new ConnectableSubscriber(this.getSubject(), this)));
            if (connection.closed) {
                this._connection = null;
                connection = Subscription_1.Subscription.EMPTY;
            }
        }
        return connection;
    };
    ConnectableObservable.prototype.refCount = function () {
        return refCount_1.refCount()(this);
    };
    return ConnectableObservable;
}(Observable_1.Observable));
exports.ConnectableObservable = ConnectableObservable;
var connectableProto = ConnectableObservable.prototype;
exports.connectableObservableDescriptor = {
    operator: { value: null },
    _refCount: { value: 0, writable: true },
    _subject: { value: null, writable: true },
    _connection: { value: null, writable: true },
    _subscribe: { value: connectableProto._subscribe },
    _isComplete: { value: connectableProto._isComplete, writable: true },
    getSubject: { value: connectableProto.getSubject },
    connect: { value: connectableProto.connect },
    refCount: { value: connectableProto.refCount }
};
var ConnectableSubscriber = (function (_super) {
    __extends(ConnectableSubscriber, _super);
    function ConnectableSubscriber(destination, connectable) {
        var _this = _super.call(this, destination) || this;
        _this.connectable = connectable;
        return _this;
    }
    ConnectableSubscriber.prototype._error = function (err) {
        this._unsubscribe();
        _super.prototype._error.call(this, err);
    };
    ConnectableSubscriber.prototype._complete = function () {
        this.connectable._isComplete = true;
        this._unsubscribe();
        _super.prototype._complete.call(this);
    };
    ConnectableSubscriber.prototype._unsubscribe = function () {
        var connectable = this.connectable;
        if (connectable) {
            this.connectable = null;
            var connection = connectable._connection;
            connectable._refCount = 0;
            connectable._subject = null;
            connectable._connection = null;
            if (connection) {
                connection.unsubscribe();
            }
        }
    };
    return ConnectableSubscriber;
}(Subject_1.SubjectSubscriber));
var RefCountOperator = (function () {
    function RefCountOperator(connectable) {
        this.connectable = connectable;
    }
    RefCountOperator.prototype.call = function (subscriber, source) {
        var connectable = this.connectable;
        connectable._refCount++;
        var refCounter = new RefCountSubscriber(subscriber, connectable);
        var subscription = source.subscribe(refCounter);
        if (!refCounter.closed) {
            refCounter.connection = connectable.connect();
        }
        return subscription;
    };
    return RefCountOperator;
}());
var RefCountSubscriber = (function (_super) {
    __extends(RefCountSubscriber, _super);
    function RefCountSubscriber(destination, connectable) {
        var _this = _super.call(this, destination) || this;
        _this.connectable = connectable;
        return _this;
    }
    RefCountSubscriber.prototype._unsubscribe = function () {
        var connectable = this.connectable;
        if (!connectable) {
            this.connection = null;
            return;
        }
        this.connectable = null;
        var refCount = connectable._refCount;
        if (refCount <= 0) {
            this.connection = null;
            return;
        }
        connectable._refCount = refCount - 1;
        if (refCount > 1) {
            this.connection = null;
            return;
        }
        var connection = this.connection;
        var sharedConnection = connectable._connection;
        this.connection = null;
        if (sharedConnection && (!connection || sharedConnection === connection)) {
            sharedConnection.unsubscribe();
        }
    };
    return RefCountSubscriber;
}(Subscriber_1.Subscriber));

},{"../Observable":94,"../Subject":99,"../Subscriber":101,"../Subscription":102,"../operators/refCount":193}],105:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Observable_1 = require("../Observable");
var asap_1 = require("../scheduler/asap");
var isNumeric_1 = require("../util/isNumeric");
var SubscribeOnObservable = (function (_super) {
    __extends(SubscribeOnObservable, _super);
    function SubscribeOnObservable(source, delayTime, scheduler) {
        if (delayTime === void 0) { delayTime = 0; }
        if (scheduler === void 0) { scheduler = asap_1.asap; }
        var _this = _super.call(this) || this;
        _this.source = source;
        _this.delayTime = delayTime;
        _this.scheduler = scheduler;
        if (!isNumeric_1.isNumeric(delayTime) || delayTime < 0) {
            _this.delayTime = 0;
        }
        if (!scheduler || typeof scheduler.schedule !== 'function') {
            _this.scheduler = asap_1.asap;
        }
        return _this;
    }
    SubscribeOnObservable.create = function (source, delay, scheduler) {
        if (delay === void 0) { delay = 0; }
        if (scheduler === void 0) { scheduler = asap_1.asap; }
        return new SubscribeOnObservable(source, delay, scheduler);
    };
    SubscribeOnObservable.dispatch = function (arg) {
        var source = arg.source, subscriber = arg.subscriber;
        return this.add(source.subscribe(subscriber));
    };
    SubscribeOnObservable.prototype._subscribe = function (subscriber) {
        var delay = this.delayTime;
        var source = this.source;
        var scheduler = this.scheduler;
        return scheduler.schedule(SubscribeOnObservable.dispatch, delay, {
            source: source, subscriber: subscriber
        });
    };
    return SubscribeOnObservable;
}(Observable_1.Observable));
exports.SubscribeOnObservable = SubscribeOnObservable;

},{"../Observable":94,"../scheduler/asap":251,"../util/isNumeric":272}],106:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Observable_1 = require("../Observable");
var AsyncSubject_1 = require("../AsyncSubject");
var map_1 = require("../operators/map");
var canReportError_1 = require("../util/canReportError");
var isArray_1 = require("../util/isArray");
var isScheduler_1 = require("../util/isScheduler");
function bindCallback(callbackFunc, resultSelector, scheduler) {
    if (resultSelector) {
        if (isScheduler_1.isScheduler(resultSelector)) {
            scheduler = resultSelector;
        }
        else {
            return function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                return bindCallback(callbackFunc, scheduler).apply(void 0, args).pipe(map_1.map(function (args) { return isArray_1.isArray(args) ? resultSelector.apply(void 0, args) : resultSelector(args); }));
            };
        }
    }
    return function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var context = this;
        var subject;
        var params = {
            context: context,
            subject: subject,
            callbackFunc: callbackFunc,
            scheduler: scheduler,
        };
        return new Observable_1.Observable(function (subscriber) {
            if (!scheduler) {
                if (!subject) {
                    subject = new AsyncSubject_1.AsyncSubject();
                    var handler = function () {
                        var innerArgs = [];
                        for (var _i = 0; _i < arguments.length; _i++) {
                            innerArgs[_i] = arguments[_i];
                        }
                        subject.next(innerArgs.length <= 1 ? innerArgs[0] : innerArgs);
                        subject.complete();
                    };
                    try {
                        callbackFunc.apply(context, args.concat([handler]));
                    }
                    catch (err) {
                        if (canReportError_1.canReportError(subject)) {
                            subject.error(err);
                        }
                        else {
                            console.warn(err);
                        }
                    }
                }
                return subject.subscribe(subscriber);
            }
            else {
                var state = {
                    args: args, subscriber: subscriber, params: params,
                };
                return scheduler.schedule(dispatch, 0, state);
            }
        });
    };
}
exports.bindCallback = bindCallback;
function dispatch(state) {
    var _this = this;
    var self = this;
    var args = state.args, subscriber = state.subscriber, params = state.params;
    var callbackFunc = params.callbackFunc, context = params.context, scheduler = params.scheduler;
    var subject = params.subject;
    if (!subject) {
        subject = params.subject = new AsyncSubject_1.AsyncSubject();
        var handler = function () {
            var innerArgs = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                innerArgs[_i] = arguments[_i];
            }
            var value = innerArgs.length <= 1 ? innerArgs[0] : innerArgs;
            _this.add(scheduler.schedule(dispatchNext, 0, { value: value, subject: subject }));
        };
        try {
            callbackFunc.apply(context, args.concat([handler]));
        }
        catch (err) {
            subject.error(err);
        }
    }
    this.add(subject.subscribe(subscriber));
}
function dispatchNext(state) {
    var value = state.value, subject = state.subject;
    subject.next(value);
    subject.complete();
}
function dispatchError(state) {
    var err = state.err, subject = state.subject;
    subject.error(err);
}

},{"../AsyncSubject":90,"../Observable":94,"../operators/map":171,"../util/canReportError":263,"../util/isArray":266,"../util/isScheduler":276}],107:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Observable_1 = require("../Observable");
var AsyncSubject_1 = require("../AsyncSubject");
var map_1 = require("../operators/map");
var canReportError_1 = require("../util/canReportError");
var isScheduler_1 = require("../util/isScheduler");
var isArray_1 = require("../util/isArray");
function bindNodeCallback(callbackFunc, resultSelector, scheduler) {
    if (resultSelector) {
        if (isScheduler_1.isScheduler(resultSelector)) {
            scheduler = resultSelector;
        }
        else {
            return function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                return bindNodeCallback(callbackFunc, scheduler).apply(void 0, args).pipe(map_1.map(function (args) { return isArray_1.isArray(args) ? resultSelector.apply(void 0, args) : resultSelector(args); }));
            };
        }
    }
    return function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var params = {
            subject: undefined,
            args: args,
            callbackFunc: callbackFunc,
            scheduler: scheduler,
            context: this,
        };
        return new Observable_1.Observable(function (subscriber) {
            var context = params.context;
            var subject = params.subject;
            if (!scheduler) {
                if (!subject) {
                    subject = params.subject = new AsyncSubject_1.AsyncSubject();
                    var handler = function () {
                        var innerArgs = [];
                        for (var _i = 0; _i < arguments.length; _i++) {
                            innerArgs[_i] = arguments[_i];
                        }
                        var err = innerArgs.shift();
                        if (err) {
                            subject.error(err);
                            return;
                        }
                        subject.next(innerArgs.length <= 1 ? innerArgs[0] : innerArgs);
                        subject.complete();
                    };
                    try {
                        callbackFunc.apply(context, args.concat([handler]));
                    }
                    catch (err) {
                        if (canReportError_1.canReportError(subject)) {
                            subject.error(err);
                        }
                        else {
                            console.warn(err);
                        }
                    }
                }
                return subject.subscribe(subscriber);
            }
            else {
                return scheduler.schedule(dispatch, 0, { params: params, subscriber: subscriber, context: context });
            }
        });
    };
}
exports.bindNodeCallback = bindNodeCallback;
function dispatch(state) {
    var _this = this;
    var params = state.params, subscriber = state.subscriber, context = state.context;
    var callbackFunc = params.callbackFunc, args = params.args, scheduler = params.scheduler;
    var subject = params.subject;
    if (!subject) {
        subject = params.subject = new AsyncSubject_1.AsyncSubject();
        var handler = function () {
            var innerArgs = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                innerArgs[_i] = arguments[_i];
            }
            var err = innerArgs.shift();
            if (err) {
                _this.add(scheduler.schedule(dispatchError, 0, { err: err, subject: subject }));
            }
            else {
                var value = innerArgs.length <= 1 ? innerArgs[0] : innerArgs;
                _this.add(scheduler.schedule(dispatchNext, 0, { value: value, subject: subject }));
            }
        };
        try {
            callbackFunc.apply(context, args.concat([handler]));
        }
        catch (err) {
            this.add(scheduler.schedule(dispatchError, 0, { err: err, subject: subject }));
        }
    }
    this.add(subject.subscribe(subscriber));
}
function dispatchNext(arg) {
    var value = arg.value, subject = arg.subject;
    subject.next(value);
    subject.complete();
}
function dispatchError(arg) {
    var err = arg.err, subject = arg.subject;
    subject.error(err);
}

},{"../AsyncSubject":90,"../Observable":94,"../operators/map":171,"../util/canReportError":263,"../util/isArray":266,"../util/isScheduler":276}],108:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var isScheduler_1 = require("../util/isScheduler");
var isArray_1 = require("../util/isArray");
var OuterSubscriber_1 = require("../OuterSubscriber");
var subscribeToResult_1 = require("../util/subscribeToResult");
var fromArray_1 = require("./fromArray");
var NONE = {};
function combineLatest() {
    var observables = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        observables[_i] = arguments[_i];
    }
    var resultSelector = null;
    var scheduler = null;
    if (isScheduler_1.isScheduler(observables[observables.length - 1])) {
        scheduler = observables.pop();
    }
    if (typeof observables[observables.length - 1] === 'function') {
        resultSelector = observables.pop();
    }
    if (observables.length === 1 && isArray_1.isArray(observables[0])) {
        observables = observables[0];
    }
    return fromArray_1.fromArray(observables, scheduler).lift(new CombineLatestOperator(resultSelector));
}
exports.combineLatest = combineLatest;
var CombineLatestOperator = (function () {
    function CombineLatestOperator(resultSelector) {
        this.resultSelector = resultSelector;
    }
    CombineLatestOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new CombineLatestSubscriber(subscriber, this.resultSelector));
    };
    return CombineLatestOperator;
}());
exports.CombineLatestOperator = CombineLatestOperator;
var CombineLatestSubscriber = (function (_super) {
    __extends(CombineLatestSubscriber, _super);
    function CombineLatestSubscriber(destination, resultSelector) {
        var _this = _super.call(this, destination) || this;
        _this.resultSelector = resultSelector;
        _this.active = 0;
        _this.values = [];
        _this.observables = [];
        return _this;
    }
    CombineLatestSubscriber.prototype._next = function (observable) {
        this.values.push(NONE);
        this.observables.push(observable);
    };
    CombineLatestSubscriber.prototype._complete = function () {
        var observables = this.observables;
        var len = observables.length;
        if (len === 0) {
            this.destination.complete();
        }
        else {
            this.active = len;
            this.toRespond = len;
            for (var i = 0; i < len; i++) {
                var observable = observables[i];
                this.add(subscribeToResult_1.subscribeToResult(this, observable, observable, i));
            }
        }
    };
    CombineLatestSubscriber.prototype.notifyComplete = function (unused) {
        if ((this.active -= 1) === 0) {
            this.destination.complete();
        }
    };
    CombineLatestSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
        var values = this.values;
        var oldVal = values[outerIndex];
        var toRespond = !this.toRespond
            ? 0
            : oldVal === NONE ? --this.toRespond : this.toRespond;
        values[outerIndex] = innerValue;
        if (toRespond === 0) {
            if (this.resultSelector) {
                this._tryResultSelector(values);
            }
            else {
                this.destination.next(values.slice());
            }
        }
    };
    CombineLatestSubscriber.prototype._tryResultSelector = function (values) {
        var result;
        try {
            result = this.resultSelector.apply(this, values);
        }
        catch (err) {
            this.destination.error(err);
            return;
        }
        this.destination.next(result);
    };
    return CombineLatestSubscriber;
}(OuterSubscriber_1.OuterSubscriber));
exports.CombineLatestSubscriber = CombineLatestSubscriber;

},{"../OuterSubscriber":96,"../util/isArray":266,"../util/isScheduler":276,"../util/subscribeToResult":285,"./fromArray":114}],109:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var of_1 = require("./of");
var concatAll_1 = require("../operators/concatAll");
function concat() {
    var observables = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        observables[_i] = arguments[_i];
    }
    return concatAll_1.concatAll()(of_1.of.apply(void 0, observables));
}
exports.concat = concat;

},{"../operators/concatAll":143,"./of":122}],110:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Observable_1 = require("../Observable");
var from_1 = require("./from");
var empty_1 = require("./empty");
function defer(observableFactory) {
    return new Observable_1.Observable(function (subscriber) {
        var input;
        try {
            input = observableFactory();
        }
        catch (err) {
            subscriber.error(err);
            return undefined;
        }
        var source = input ? from_1.from(input) : empty_1.empty();
        return source.subscribe(subscriber);
    });
}
exports.defer = defer;

},{"../Observable":94,"./empty":111,"./from":113}],111:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Observable_1 = require("../Observable");
exports.EMPTY = new Observable_1.Observable(function (subscriber) { return subscriber.complete(); });
function empty(scheduler) {
    return scheduler ? emptyScheduled(scheduler) : exports.EMPTY;
}
exports.empty = empty;
function emptyScheduled(scheduler) {
    return new Observable_1.Observable(function (subscriber) { return scheduler.schedule(function () { return subscriber.complete(); }); });
}

},{"../Observable":94}],112:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Observable_1 = require("../Observable");
var isArray_1 = require("../util/isArray");
var map_1 = require("../operators/map");
var isObject_1 = require("../util/isObject");
var from_1 = require("./from");
function forkJoin() {
    var sources = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        sources[_i] = arguments[_i];
    }
    if (sources.length === 1) {
        var first_1 = sources[0];
        if (isArray_1.isArray(first_1)) {
            return forkJoinInternal(first_1, null);
        }
        if (isObject_1.isObject(first_1) && Object.getPrototypeOf(first_1) === Object.prototype) {
            var keys = Object.keys(first_1);
            return forkJoinInternal(keys.map(function (key) { return first_1[key]; }), keys);
        }
    }
    if (typeof sources[sources.length - 1] === 'function') {
        var resultSelector_1 = sources.pop();
        sources = (sources.length === 1 && isArray_1.isArray(sources[0])) ? sources[0] : sources;
        return forkJoinInternal(sources, null).pipe(map_1.map(function (args) { return resultSelector_1.apply(void 0, args); }));
    }
    return forkJoinInternal(sources, null);
}
exports.forkJoin = forkJoin;
function forkJoinInternal(sources, keys) {
    return new Observable_1.Observable(function (subscriber) {
        var len = sources.length;
        if (len === 0) {
            subscriber.complete();
            return;
        }
        var values = new Array(len);
        var completed = 0;
        var emitted = 0;
        var _loop_1 = function (i) {
            var source = from_1.from(sources[i]);
            var hasValue = false;
            subscriber.add(source.subscribe({
                next: function (value) {
                    if (!hasValue) {
                        hasValue = true;
                        emitted++;
                    }
                    values[i] = value;
                },
                error: function (err) { return subscriber.error(err); },
                complete: function () {
                    completed++;
                    if (completed === len || !hasValue) {
                        if (emitted === len) {
                            subscriber.next(keys ?
                                keys.reduce(function (result, key, i) { return (result[key] = values[i], result); }, {}) :
                                values);
                        }
                        subscriber.complete();
                    }
                }
            }));
        };
        for (var i = 0; i < len; i++) {
            _loop_1(i);
        }
    });
}

},{"../Observable":94,"../operators/map":171,"../util/isArray":266,"../util/isObject":273,"./from":113}],113:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Observable_1 = require("../Observable");
var subscribeTo_1 = require("../util/subscribeTo");
var scheduled_1 = require("../scheduled/scheduled");
function from(input, scheduler) {
    if (!scheduler) {
        if (input instanceof Observable_1.Observable) {
            return input;
        }
        return new Observable_1.Observable(subscribeTo_1.subscribeTo(input));
    }
    else {
        return scheduled_1.scheduled(input, scheduler);
    }
}
exports.from = from;

},{"../Observable":94,"../scheduled/scheduled":239,"../util/subscribeTo":280}],114:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Observable_1 = require("../Observable");
var subscribeToArray_1 = require("../util/subscribeToArray");
var scheduleArray_1 = require("../scheduled/scheduleArray");
function fromArray(input, scheduler) {
    if (!scheduler) {
        return new Observable_1.Observable(subscribeToArray_1.subscribeToArray(input));
    }
    else {
        return scheduleArray_1.scheduleArray(input, scheduler);
    }
}
exports.fromArray = fromArray;

},{"../Observable":94,"../scheduled/scheduleArray":235,"../util/subscribeToArray":281}],115:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Observable_1 = require("../Observable");
var isArray_1 = require("../util/isArray");
var isFunction_1 = require("../util/isFunction");
var map_1 = require("../operators/map");
var toString = Object.prototype.toString;
function fromEvent(target, eventName, options, resultSelector) {
    if (isFunction_1.isFunction(options)) {
        resultSelector = options;
        options = undefined;
    }
    if (resultSelector) {
        return fromEvent(target, eventName, options).pipe(map_1.map(function (args) { return isArray_1.isArray(args) ? resultSelector.apply(void 0, args) : resultSelector(args); }));
    }
    return new Observable_1.Observable(function (subscriber) {
        function handler(e) {
            if (arguments.length > 1) {
                subscriber.next(Array.prototype.slice.call(arguments));
            }
            else {
                subscriber.next(e);
            }
        }
        setupSubscription(target, eventName, handler, subscriber, options);
    });
}
exports.fromEvent = fromEvent;
function setupSubscription(sourceObj, eventName, handler, subscriber, options) {
    var unsubscribe;
    if (isEventTarget(sourceObj)) {
        var source_1 = sourceObj;
        sourceObj.addEventListener(eventName, handler, options);
        unsubscribe = function () { return source_1.removeEventListener(eventName, handler, options); };
    }
    else if (isJQueryStyleEventEmitter(sourceObj)) {
        var source_2 = sourceObj;
        sourceObj.on(eventName, handler);
        unsubscribe = function () { return source_2.off(eventName, handler); };
    }
    else if (isNodeStyleEventEmitter(sourceObj)) {
        var source_3 = sourceObj;
        sourceObj.addListener(eventName, handler);
        unsubscribe = function () { return source_3.removeListener(eventName, handler); };
    }
    else if (sourceObj && sourceObj.length) {
        for (var i = 0, len = sourceObj.length; i < len; i++) {
            setupSubscription(sourceObj[i], eventName, handler, subscriber, options);
        }
    }
    else {
        throw new TypeError('Invalid event target');
    }
    subscriber.add(unsubscribe);
}
function isNodeStyleEventEmitter(sourceObj) {
    return sourceObj && typeof sourceObj.addListener === 'function' && typeof sourceObj.removeListener === 'function';
}
function isJQueryStyleEventEmitter(sourceObj) {
    return sourceObj && typeof sourceObj.on === 'function' && typeof sourceObj.off === 'function';
}
function isEventTarget(sourceObj) {
    return sourceObj && typeof sourceObj.addEventListener === 'function' && typeof sourceObj.removeEventListener === 'function';
}

},{"../Observable":94,"../operators/map":171,"../util/isArray":266,"../util/isFunction":269}],116:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Observable_1 = require("../Observable");
var isArray_1 = require("../util/isArray");
var isFunction_1 = require("../util/isFunction");
var map_1 = require("../operators/map");
function fromEventPattern(addHandler, removeHandler, resultSelector) {
    if (resultSelector) {
        return fromEventPattern(addHandler, removeHandler).pipe(map_1.map(function (args) { return isArray_1.isArray(args) ? resultSelector.apply(void 0, args) : resultSelector(args); }));
    }
    return new Observable_1.Observable(function (subscriber) {
        var handler = function () {
            var e = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                e[_i] = arguments[_i];
            }
            return subscriber.next(e.length === 1 ? e[0] : e);
        };
        var retValue;
        try {
            retValue = addHandler(handler);
        }
        catch (err) {
            subscriber.error(err);
            return undefined;
        }
        if (!isFunction_1.isFunction(removeHandler)) {
            return undefined;
        }
        return function () { return removeHandler(handler, retValue); };
    });
}
exports.fromEventPattern = fromEventPattern;

},{"../Observable":94,"../operators/map":171,"../util/isArray":266,"../util/isFunction":269}],117:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Observable_1 = require("../Observable");
var identity_1 = require("../util/identity");
var isScheduler_1 = require("../util/isScheduler");
function generate(initialStateOrOptions, condition, iterate, resultSelectorOrObservable, scheduler) {
    var resultSelector;
    var initialState;
    if (arguments.length == 1) {
        var options = initialStateOrOptions;
        initialState = options.initialState;
        condition = options.condition;
        iterate = options.iterate;
        resultSelector = options.resultSelector || identity_1.identity;
        scheduler = options.scheduler;
    }
    else if (resultSelectorOrObservable === undefined || isScheduler_1.isScheduler(resultSelectorOrObservable)) {
        initialState = initialStateOrOptions;
        resultSelector = identity_1.identity;
        scheduler = resultSelectorOrObservable;
    }
    else {
        initialState = initialStateOrOptions;
        resultSelector = resultSelectorOrObservable;
    }
    return new Observable_1.Observable(function (subscriber) {
        var state = initialState;
        if (scheduler) {
            return scheduler.schedule(dispatch, 0, {
                subscriber: subscriber,
                iterate: iterate,
                condition: condition,
                resultSelector: resultSelector,
                state: state
            });
        }
        do {
            if (condition) {
                var conditionResult = void 0;
                try {
                    conditionResult = condition(state);
                }
                catch (err) {
                    subscriber.error(err);
                    return undefined;
                }
                if (!conditionResult) {
                    subscriber.complete();
                    break;
                }
            }
            var value = void 0;
            try {
                value = resultSelector(state);
            }
            catch (err) {
                subscriber.error(err);
                return undefined;
            }
            subscriber.next(value);
            if (subscriber.closed) {
                break;
            }
            try {
                state = iterate(state);
            }
            catch (err) {
                subscriber.error(err);
                return undefined;
            }
        } while (true);
        return undefined;
    });
}
exports.generate = generate;
function dispatch(state) {
    var subscriber = state.subscriber, condition = state.condition;
    if (subscriber.closed) {
        return undefined;
    }
    if (state.needIterate) {
        try {
            state.state = state.iterate(state.state);
        }
        catch (err) {
            subscriber.error(err);
            return undefined;
        }
    }
    else {
        state.needIterate = true;
    }
    if (condition) {
        var conditionResult = void 0;
        try {
            conditionResult = condition(state.state);
        }
        catch (err) {
            subscriber.error(err);
            return undefined;
        }
        if (!conditionResult) {
            subscriber.complete();
            return undefined;
        }
        if (subscriber.closed) {
            return undefined;
        }
    }
    var value;
    try {
        value = state.resultSelector(state.state);
    }
    catch (err) {
        subscriber.error(err);
        return undefined;
    }
    if (subscriber.closed) {
        return undefined;
    }
    subscriber.next(value);
    if (subscriber.closed) {
        return undefined;
    }
    return this.schedule(state);
}

},{"../Observable":94,"../util/identity":265,"../util/isScheduler":276}],118:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var defer_1 = require("./defer");
var empty_1 = require("./empty");
function iif(condition, trueResult, falseResult) {
    if (trueResult === void 0) { trueResult = empty_1.EMPTY; }
    if (falseResult === void 0) { falseResult = empty_1.EMPTY; }
    return defer_1.defer(function () { return condition() ? trueResult : falseResult; });
}
exports.iif = iif;

},{"./defer":110,"./empty":111}],119:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Observable_1 = require("../Observable");
var async_1 = require("../scheduler/async");
var isNumeric_1 = require("../util/isNumeric");
function interval(period, scheduler) {
    if (period === void 0) { period = 0; }
    if (scheduler === void 0) { scheduler = async_1.async; }
    if (!isNumeric_1.isNumeric(period) || period < 0) {
        period = 0;
    }
    if (!scheduler || typeof scheduler.schedule !== 'function') {
        scheduler = async_1.async;
    }
    return new Observable_1.Observable(function (subscriber) {
        subscriber.add(scheduler.schedule(dispatch, period, { subscriber: subscriber, counter: 0, period: period }));
        return subscriber;
    });
}
exports.interval = interval;
function dispatch(state) {
    var subscriber = state.subscriber, counter = state.counter, period = state.period;
    subscriber.next(counter);
    this.schedule({ subscriber: subscriber, counter: counter + 1, period: period }, period);
}

},{"../Observable":94,"../scheduler/async":252,"../util/isNumeric":272}],120:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Observable_1 = require("../Observable");
var isScheduler_1 = require("../util/isScheduler");
var mergeAll_1 = require("../operators/mergeAll");
var fromArray_1 = require("./fromArray");
function merge() {
    var observables = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        observables[_i] = arguments[_i];
    }
    var concurrent = Number.POSITIVE_INFINITY;
    var scheduler = null;
    var last = observables[observables.length - 1];
    if (isScheduler_1.isScheduler(last)) {
        scheduler = observables.pop();
        if (observables.length > 1 && typeof observables[observables.length - 1] === 'number') {
            concurrent = observables.pop();
        }
    }
    else if (typeof last === 'number') {
        concurrent = observables.pop();
    }
    if (scheduler === null && observables.length === 1 && observables[0] instanceof Observable_1.Observable) {
        return observables[0];
    }
    return mergeAll_1.mergeAll(concurrent)(fromArray_1.fromArray(observables, scheduler));
}
exports.merge = merge;

},{"../Observable":94,"../operators/mergeAll":176,"../util/isScheduler":276,"./fromArray":114}],121:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Observable_1 = require("../Observable");
var noop_1 = require("../util/noop");
exports.NEVER = new Observable_1.Observable(noop_1.noop);
function never() {
    return exports.NEVER;
}
exports.never = never;

},{"../Observable":94,"../util/noop":277}],122:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var isScheduler_1 = require("../util/isScheduler");
var fromArray_1 = require("./fromArray");
var scheduleArray_1 = require("../scheduled/scheduleArray");
function of() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    var scheduler = args[args.length - 1];
    if (isScheduler_1.isScheduler(scheduler)) {
        args.pop();
        return scheduleArray_1.scheduleArray(args, scheduler);
    }
    else {
        return fromArray_1.fromArray(args);
    }
}
exports.of = of;

},{"../scheduled/scheduleArray":235,"../util/isScheduler":276,"./fromArray":114}],123:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Observable_1 = require("../Observable");
var from_1 = require("./from");
var isArray_1 = require("../util/isArray");
var empty_1 = require("./empty");
function onErrorResumeNext() {
    var sources = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        sources[_i] = arguments[_i];
    }
    if (sources.length === 0) {
        return empty_1.EMPTY;
    }
    var first = sources[0], remainder = sources.slice(1);
    if (sources.length === 1 && isArray_1.isArray(first)) {
        return onErrorResumeNext.apply(void 0, first);
    }
    return new Observable_1.Observable(function (subscriber) {
        var subNext = function () { return subscriber.add(onErrorResumeNext.apply(void 0, remainder).subscribe(subscriber)); };
        return from_1.from(first).subscribe({
            next: function (value) { subscriber.next(value); },
            error: subNext,
            complete: subNext,
        });
    });
}
exports.onErrorResumeNext = onErrorResumeNext;

},{"../Observable":94,"../util/isArray":266,"./empty":111,"./from":113}],124:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Observable_1 = require("../Observable");
var Subscription_1 = require("../Subscription");
function pairs(obj, scheduler) {
    if (!scheduler) {
        return new Observable_1.Observable(function (subscriber) {
            var keys = Object.keys(obj);
            for (var i = 0; i < keys.length && !subscriber.closed; i++) {
                var key = keys[i];
                if (obj.hasOwnProperty(key)) {
                    subscriber.next([key, obj[key]]);
                }
            }
            subscriber.complete();
        });
    }
    else {
        return new Observable_1.Observable(function (subscriber) {
            var keys = Object.keys(obj);
            var subscription = new Subscription_1.Subscription();
            subscription.add(scheduler.schedule(dispatch, 0, { keys: keys, index: 0, subscriber: subscriber, subscription: subscription, obj: obj }));
            return subscription;
        });
    }
}
exports.pairs = pairs;
function dispatch(state) {
    var keys = state.keys, index = state.index, subscriber = state.subscriber, subscription = state.subscription, obj = state.obj;
    if (!subscriber.closed) {
        if (index < keys.length) {
            var key = keys[index];
            subscriber.next([key, obj[key]]);
            subscription.add(this.schedule({ keys: keys, index: index + 1, subscriber: subscriber, subscription: subscription, obj: obj }));
        }
        else {
            subscriber.complete();
        }
    }
}
exports.dispatch = dispatch;

},{"../Observable":94,"../Subscription":102}],125:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var not_1 = require("../util/not");
var subscribeTo_1 = require("../util/subscribeTo");
var filter_1 = require("../operators/filter");
var Observable_1 = require("../Observable");
function partition(source, predicate, thisArg) {
    return [
        filter_1.filter(predicate, thisArg)(new Observable_1.Observable(subscribeTo_1.subscribeTo(source))),
        filter_1.filter(not_1.not(predicate, thisArg))(new Observable_1.Observable(subscribeTo_1.subscribeTo(source)))
    ];
}
exports.partition = partition;

},{"../Observable":94,"../operators/filter":162,"../util/not":278,"../util/subscribeTo":280}],126:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var isArray_1 = require("../util/isArray");
var fromArray_1 = require("./fromArray");
var OuterSubscriber_1 = require("../OuterSubscriber");
var subscribeToResult_1 = require("../util/subscribeToResult");
function race() {
    var observables = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        observables[_i] = arguments[_i];
    }
    if (observables.length === 1) {
        if (isArray_1.isArray(observables[0])) {
            observables = observables[0];
        }
        else {
            return observables[0];
        }
    }
    return fromArray_1.fromArray(observables, undefined).lift(new RaceOperator());
}
exports.race = race;
var RaceOperator = (function () {
    function RaceOperator() {
    }
    RaceOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new RaceSubscriber(subscriber));
    };
    return RaceOperator;
}());
exports.RaceOperator = RaceOperator;
var RaceSubscriber = (function (_super) {
    __extends(RaceSubscriber, _super);
    function RaceSubscriber(destination) {
        var _this = _super.call(this, destination) || this;
        _this.hasFirst = false;
        _this.observables = [];
        _this.subscriptions = [];
        return _this;
    }
    RaceSubscriber.prototype._next = function (observable) {
        this.observables.push(observable);
    };
    RaceSubscriber.prototype._complete = function () {
        var observables = this.observables;
        var len = observables.length;
        if (len === 0) {
            this.destination.complete();
        }
        else {
            for (var i = 0; i < len && !this.hasFirst; i++) {
                var observable = observables[i];
                var subscription = subscribeToResult_1.subscribeToResult(this, observable, observable, i);
                if (this.subscriptions) {
                    this.subscriptions.push(subscription);
                }
                this.add(subscription);
            }
            this.observables = null;
        }
    };
    RaceSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
        if (!this.hasFirst) {
            this.hasFirst = true;
            for (var i = 0; i < this.subscriptions.length; i++) {
                if (i !== outerIndex) {
                    var subscription = this.subscriptions[i];
                    subscription.unsubscribe();
                    this.remove(subscription);
                }
            }
            this.subscriptions = null;
        }
        this.destination.next(innerValue);
    };
    return RaceSubscriber;
}(OuterSubscriber_1.OuterSubscriber));
exports.RaceSubscriber = RaceSubscriber;

},{"../OuterSubscriber":96,"../util/isArray":266,"../util/subscribeToResult":285,"./fromArray":114}],127:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Observable_1 = require("../Observable");
function range(start, count, scheduler) {
    if (start === void 0) { start = 0; }
    return new Observable_1.Observable(function (subscriber) {
        if (count === undefined) {
            count = start;
            start = 0;
        }
        var index = 0;
        var current = start;
        if (scheduler) {
            return scheduler.schedule(dispatch, 0, {
                index: index, count: count, start: start, subscriber: subscriber
            });
        }
        else {
            do {
                if (index++ >= count) {
                    subscriber.complete();
                    break;
                }
                subscriber.next(current++);
                if (subscriber.closed) {
                    break;
                }
            } while (true);
        }
        return undefined;
    });
}
exports.range = range;
function dispatch(state) {
    var start = state.start, index = state.index, count = state.count, subscriber = state.subscriber;
    if (index >= count) {
        subscriber.complete();
        return;
    }
    subscriber.next(start);
    if (subscriber.closed) {
        return;
    }
    state.index = index + 1;
    state.start = start + 1;
    this.schedule(state);
}
exports.dispatch = dispatch;

},{"../Observable":94}],128:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Observable_1 = require("../Observable");
function throwError(error, scheduler) {
    if (!scheduler) {
        return new Observable_1.Observable(function (subscriber) { return subscriber.error(error); });
    }
    else {
        return new Observable_1.Observable(function (subscriber) { return scheduler.schedule(dispatch, 0, { error: error, subscriber: subscriber }); });
    }
}
exports.throwError = throwError;
function dispatch(_a) {
    var error = _a.error, subscriber = _a.subscriber;
    subscriber.error(error);
}

},{"../Observable":94}],129:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Observable_1 = require("../Observable");
var async_1 = require("../scheduler/async");
var isNumeric_1 = require("../util/isNumeric");
var isScheduler_1 = require("../util/isScheduler");
function timer(dueTime, periodOrScheduler, scheduler) {
    if (dueTime === void 0) { dueTime = 0; }
    var period = -1;
    if (isNumeric_1.isNumeric(periodOrScheduler)) {
        period = Number(periodOrScheduler) < 1 && 1 || Number(periodOrScheduler);
    }
    else if (isScheduler_1.isScheduler(periodOrScheduler)) {
        scheduler = periodOrScheduler;
    }
    if (!isScheduler_1.isScheduler(scheduler)) {
        scheduler = async_1.async;
    }
    return new Observable_1.Observable(function (subscriber) {
        var due = isNumeric_1.isNumeric(dueTime)
            ? dueTime
            : (+dueTime - scheduler.now());
        return scheduler.schedule(dispatch, due, {
            index: 0, period: period, subscriber: subscriber
        });
    });
}
exports.timer = timer;
function dispatch(state) {
    var index = state.index, period = state.period, subscriber = state.subscriber;
    subscriber.next(index);
    if (subscriber.closed) {
        return;
    }
    else if (period === -1) {
        return subscriber.complete();
    }
    state.index = index + 1;
    this.schedule(state, period);
}

},{"../Observable":94,"../scheduler/async":252,"../util/isNumeric":272,"../util/isScheduler":276}],130:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Observable_1 = require("../Observable");
var from_1 = require("./from");
var empty_1 = require("./empty");
function using(resourceFactory, observableFactory) {
    return new Observable_1.Observable(function (subscriber) {
        var resource;
        try {
            resource = resourceFactory();
        }
        catch (err) {
            subscriber.error(err);
            return undefined;
        }
        var result;
        try {
            result = observableFactory(resource);
        }
        catch (err) {
            subscriber.error(err);
            return undefined;
        }
        var source = result ? from_1.from(result) : empty_1.EMPTY;
        var subscription = source.subscribe(subscriber);
        return function () {
            subscription.unsubscribe();
            if (resource) {
                resource.unsubscribe();
            }
        };
    });
}
exports.using = using;

},{"../Observable":94,"./empty":111,"./from":113}],131:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var fromArray_1 = require("./fromArray");
var isArray_1 = require("../util/isArray");
var Subscriber_1 = require("../Subscriber");
var OuterSubscriber_1 = require("../OuterSubscriber");
var subscribeToResult_1 = require("../util/subscribeToResult");
var iterator_1 = require("../../internal/symbol/iterator");
function zip() {
    var observables = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        observables[_i] = arguments[_i];
    }
    var resultSelector = observables[observables.length - 1];
    if (typeof resultSelector === 'function') {
        observables.pop();
    }
    return fromArray_1.fromArray(observables, undefined).lift(new ZipOperator(resultSelector));
}
exports.zip = zip;
var ZipOperator = (function () {
    function ZipOperator(resultSelector) {
        this.resultSelector = resultSelector;
    }
    ZipOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new ZipSubscriber(subscriber, this.resultSelector));
    };
    return ZipOperator;
}());
exports.ZipOperator = ZipOperator;
var ZipSubscriber = (function (_super) {
    __extends(ZipSubscriber, _super);
    function ZipSubscriber(destination, resultSelector, values) {
        if (values === void 0) { values = Object.create(null); }
        var _this = _super.call(this, destination) || this;
        _this.iterators = [];
        _this.active = 0;
        _this.resultSelector = (typeof resultSelector === 'function') ? resultSelector : null;
        _this.values = values;
        return _this;
    }
    ZipSubscriber.prototype._next = function (value) {
        var iterators = this.iterators;
        if (isArray_1.isArray(value)) {
            iterators.push(new StaticArrayIterator(value));
        }
        else if (typeof value[iterator_1.iterator] === 'function') {
            iterators.push(new StaticIterator(value[iterator_1.iterator]()));
        }
        else {
            iterators.push(new ZipBufferIterator(this.destination, this, value));
        }
    };
    ZipSubscriber.prototype._complete = function () {
        var iterators = this.iterators;
        var len = iterators.length;
        this.unsubscribe();
        if (len === 0) {
            this.destination.complete();
            return;
        }
        this.active = len;
        for (var i = 0; i < len; i++) {
            var iterator = iterators[i];
            if (iterator.stillUnsubscribed) {
                var destination = this.destination;
                destination.add(iterator.subscribe(iterator, i));
            }
            else {
                this.active--;
            }
        }
    };
    ZipSubscriber.prototype.notifyInactive = function () {
        this.active--;
        if (this.active === 0) {
            this.destination.complete();
        }
    };
    ZipSubscriber.prototype.checkIterators = function () {
        var iterators = this.iterators;
        var len = iterators.length;
        var destination = this.destination;
        for (var i = 0; i < len; i++) {
            var iterator = iterators[i];
            if (typeof iterator.hasValue === 'function' && !iterator.hasValue()) {
                return;
            }
        }
        var shouldComplete = false;
        var args = [];
        for (var i = 0; i < len; i++) {
            var iterator = iterators[i];
            var result = iterator.next();
            if (iterator.hasCompleted()) {
                shouldComplete = true;
            }
            if (result.done) {
                destination.complete();
                return;
            }
            args.push(result.value);
        }
        if (this.resultSelector) {
            this._tryresultSelector(args);
        }
        else {
            destination.next(args);
        }
        if (shouldComplete) {
            destination.complete();
        }
    };
    ZipSubscriber.prototype._tryresultSelector = function (args) {
        var result;
        try {
            result = this.resultSelector.apply(this, args);
        }
        catch (err) {
            this.destination.error(err);
            return;
        }
        this.destination.next(result);
    };
    return ZipSubscriber;
}(Subscriber_1.Subscriber));
exports.ZipSubscriber = ZipSubscriber;
var StaticIterator = (function () {
    function StaticIterator(iterator) {
        this.iterator = iterator;
        this.nextResult = iterator.next();
    }
    StaticIterator.prototype.hasValue = function () {
        return true;
    };
    StaticIterator.prototype.next = function () {
        var result = this.nextResult;
        this.nextResult = this.iterator.next();
        return result;
    };
    StaticIterator.prototype.hasCompleted = function () {
        var nextResult = this.nextResult;
        return nextResult && nextResult.done;
    };
    return StaticIterator;
}());
var StaticArrayIterator = (function () {
    function StaticArrayIterator(array) {
        this.array = array;
        this.index = 0;
        this.length = 0;
        this.length = array.length;
    }
    StaticArrayIterator.prototype[iterator_1.iterator] = function () {
        return this;
    };
    StaticArrayIterator.prototype.next = function (value) {
        var i = this.index++;
        var array = this.array;
        return i < this.length ? { value: array[i], done: false } : { value: null, done: true };
    };
    StaticArrayIterator.prototype.hasValue = function () {
        return this.array.length > this.index;
    };
    StaticArrayIterator.prototype.hasCompleted = function () {
        return this.array.length === this.index;
    };
    return StaticArrayIterator;
}());
var ZipBufferIterator = (function (_super) {
    __extends(ZipBufferIterator, _super);
    function ZipBufferIterator(destination, parent, observable) {
        var _this = _super.call(this, destination) || this;
        _this.parent = parent;
        _this.observable = observable;
        _this.stillUnsubscribed = true;
        _this.buffer = [];
        _this.isComplete = false;
        return _this;
    }
    ZipBufferIterator.prototype[iterator_1.iterator] = function () {
        return this;
    };
    ZipBufferIterator.prototype.next = function () {
        var buffer = this.buffer;
        if (buffer.length === 0 && this.isComplete) {
            return { value: null, done: true };
        }
        else {
            return { value: buffer.shift(), done: false };
        }
    };
    ZipBufferIterator.prototype.hasValue = function () {
        return this.buffer.length > 0;
    };
    ZipBufferIterator.prototype.hasCompleted = function () {
        return this.buffer.length === 0 && this.isComplete;
    };
    ZipBufferIterator.prototype.notifyComplete = function () {
        if (this.buffer.length > 0) {
            this.isComplete = true;
            this.parent.notifyInactive();
        }
        else {
            this.destination.complete();
        }
    };
    ZipBufferIterator.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
        this.buffer.push(innerValue);
        this.parent.checkIterators();
    };
    ZipBufferIterator.prototype.subscribe = function (value, index) {
        return subscribeToResult_1.subscribeToResult(this, this.observable, this, index);
    };
    return ZipBufferIterator;
}(OuterSubscriber_1.OuterSubscriber));

},{"../../internal/symbol/iterator":254,"../OuterSubscriber":96,"../Subscriber":101,"../util/isArray":266,"../util/subscribeToResult":285,"./fromArray":114}],132:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var OuterSubscriber_1 = require("../OuterSubscriber");
var subscribeToResult_1 = require("../util/subscribeToResult");
function audit(durationSelector) {
    return function auditOperatorFunction(source) {
        return source.lift(new AuditOperator(durationSelector));
    };
}
exports.audit = audit;
var AuditOperator = (function () {
    function AuditOperator(durationSelector) {
        this.durationSelector = durationSelector;
    }
    AuditOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new AuditSubscriber(subscriber, this.durationSelector));
    };
    return AuditOperator;
}());
var AuditSubscriber = (function (_super) {
    __extends(AuditSubscriber, _super);
    function AuditSubscriber(destination, durationSelector) {
        var _this = _super.call(this, destination) || this;
        _this.durationSelector = durationSelector;
        _this.hasValue = false;
        return _this;
    }
    AuditSubscriber.prototype._next = function (value) {
        this.value = value;
        this.hasValue = true;
        if (!this.throttled) {
            var duration = void 0;
            try {
                var durationSelector = this.durationSelector;
                duration = durationSelector(value);
            }
            catch (err) {
                return this.destination.error(err);
            }
            var innerSubscription = subscribeToResult_1.subscribeToResult(this, duration);
            if (!innerSubscription || innerSubscription.closed) {
                this.clearThrottle();
            }
            else {
                this.add(this.throttled = innerSubscription);
            }
        }
    };
    AuditSubscriber.prototype.clearThrottle = function () {
        var _a = this, value = _a.value, hasValue = _a.hasValue, throttled = _a.throttled;
        if (throttled) {
            this.remove(throttled);
            this.throttled = null;
            throttled.unsubscribe();
        }
        if (hasValue) {
            this.value = null;
            this.hasValue = false;
            this.destination.next(value);
        }
    };
    AuditSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex) {
        this.clearThrottle();
    };
    AuditSubscriber.prototype.notifyComplete = function () {
        this.clearThrottle();
    };
    return AuditSubscriber;
}(OuterSubscriber_1.OuterSubscriber));

},{"../OuterSubscriber":96,"../util/subscribeToResult":285}],133:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var async_1 = require("../scheduler/async");
var audit_1 = require("./audit");
var timer_1 = require("../observable/timer");
function auditTime(duration, scheduler) {
    if (scheduler === void 0) { scheduler = async_1.async; }
    return audit_1.audit(function () { return timer_1.timer(duration, scheduler); });
}
exports.auditTime = auditTime;

},{"../observable/timer":129,"../scheduler/async":252,"./audit":132}],134:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var OuterSubscriber_1 = require("../OuterSubscriber");
var subscribeToResult_1 = require("../util/subscribeToResult");
function buffer(closingNotifier) {
    return function bufferOperatorFunction(source) {
        return source.lift(new BufferOperator(closingNotifier));
    };
}
exports.buffer = buffer;
var BufferOperator = (function () {
    function BufferOperator(closingNotifier) {
        this.closingNotifier = closingNotifier;
    }
    BufferOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new BufferSubscriber(subscriber, this.closingNotifier));
    };
    return BufferOperator;
}());
var BufferSubscriber = (function (_super) {
    __extends(BufferSubscriber, _super);
    function BufferSubscriber(destination, closingNotifier) {
        var _this = _super.call(this, destination) || this;
        _this.buffer = [];
        _this.add(subscribeToResult_1.subscribeToResult(_this, closingNotifier));
        return _this;
    }
    BufferSubscriber.prototype._next = function (value) {
        this.buffer.push(value);
    };
    BufferSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
        var buffer = this.buffer;
        this.buffer = [];
        this.destination.next(buffer);
    };
    return BufferSubscriber;
}(OuterSubscriber_1.OuterSubscriber));

},{"../OuterSubscriber":96,"../util/subscribeToResult":285}],135:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subscriber_1 = require("../Subscriber");
function bufferCount(bufferSize, startBufferEvery) {
    if (startBufferEvery === void 0) { startBufferEvery = null; }
    return function bufferCountOperatorFunction(source) {
        return source.lift(new BufferCountOperator(bufferSize, startBufferEvery));
    };
}
exports.bufferCount = bufferCount;
var BufferCountOperator = (function () {
    function BufferCountOperator(bufferSize, startBufferEvery) {
        this.bufferSize = bufferSize;
        this.startBufferEvery = startBufferEvery;
        if (!startBufferEvery || bufferSize === startBufferEvery) {
            this.subscriberClass = BufferCountSubscriber;
        }
        else {
            this.subscriberClass = BufferSkipCountSubscriber;
        }
    }
    BufferCountOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new this.subscriberClass(subscriber, this.bufferSize, this.startBufferEvery));
    };
    return BufferCountOperator;
}());
var BufferCountSubscriber = (function (_super) {
    __extends(BufferCountSubscriber, _super);
    function BufferCountSubscriber(destination, bufferSize) {
        var _this = _super.call(this, destination) || this;
        _this.bufferSize = bufferSize;
        _this.buffer = [];
        return _this;
    }
    BufferCountSubscriber.prototype._next = function (value) {
        var buffer = this.buffer;
        buffer.push(value);
        if (buffer.length == this.bufferSize) {
            this.destination.next(buffer);
            this.buffer = [];
        }
    };
    BufferCountSubscriber.prototype._complete = function () {
        var buffer = this.buffer;
        if (buffer.length > 0) {
            this.destination.next(buffer);
        }
        _super.prototype._complete.call(this);
    };
    return BufferCountSubscriber;
}(Subscriber_1.Subscriber));
var BufferSkipCountSubscriber = (function (_super) {
    __extends(BufferSkipCountSubscriber, _super);
    function BufferSkipCountSubscriber(destination, bufferSize, startBufferEvery) {
        var _this = _super.call(this, destination) || this;
        _this.bufferSize = bufferSize;
        _this.startBufferEvery = startBufferEvery;
        _this.buffers = [];
        _this.count = 0;
        return _this;
    }
    BufferSkipCountSubscriber.prototype._next = function (value) {
        var _a = this, bufferSize = _a.bufferSize, startBufferEvery = _a.startBufferEvery, buffers = _a.buffers, count = _a.count;
        this.count++;
        if (count % startBufferEvery === 0) {
            buffers.push([]);
        }
        for (var i = buffers.length; i--;) {
            var buffer = buffers[i];
            buffer.push(value);
            if (buffer.length === bufferSize) {
                buffers.splice(i, 1);
                this.destination.next(buffer);
            }
        }
    };
    BufferSkipCountSubscriber.prototype._complete = function () {
        var _a = this, buffers = _a.buffers, destination = _a.destination;
        while (buffers.length > 0) {
            var buffer = buffers.shift();
            if (buffer.length > 0) {
                destination.next(buffer);
            }
        }
        _super.prototype._complete.call(this);
    };
    return BufferSkipCountSubscriber;
}(Subscriber_1.Subscriber));

},{"../Subscriber":101}],136:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var async_1 = require("../scheduler/async");
var Subscriber_1 = require("../Subscriber");
var isScheduler_1 = require("../util/isScheduler");
function bufferTime(bufferTimeSpan) {
    var length = arguments.length;
    var scheduler = async_1.async;
    if (isScheduler_1.isScheduler(arguments[arguments.length - 1])) {
        scheduler = arguments[arguments.length - 1];
        length--;
    }
    var bufferCreationInterval = null;
    if (length >= 2) {
        bufferCreationInterval = arguments[1];
    }
    var maxBufferSize = Number.POSITIVE_INFINITY;
    if (length >= 3) {
        maxBufferSize = arguments[2];
    }
    return function bufferTimeOperatorFunction(source) {
        return source.lift(new BufferTimeOperator(bufferTimeSpan, bufferCreationInterval, maxBufferSize, scheduler));
    };
}
exports.bufferTime = bufferTime;
var BufferTimeOperator = (function () {
    function BufferTimeOperator(bufferTimeSpan, bufferCreationInterval, maxBufferSize, scheduler) {
        this.bufferTimeSpan = bufferTimeSpan;
        this.bufferCreationInterval = bufferCreationInterval;
        this.maxBufferSize = maxBufferSize;
        this.scheduler = scheduler;
    }
    BufferTimeOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new BufferTimeSubscriber(subscriber, this.bufferTimeSpan, this.bufferCreationInterval, this.maxBufferSize, this.scheduler));
    };
    return BufferTimeOperator;
}());
var Context = (function () {
    function Context() {
        this.buffer = [];
    }
    return Context;
}());
var BufferTimeSubscriber = (function (_super) {
    __extends(BufferTimeSubscriber, _super);
    function BufferTimeSubscriber(destination, bufferTimeSpan, bufferCreationInterval, maxBufferSize, scheduler) {
        var _this = _super.call(this, destination) || this;
        _this.bufferTimeSpan = bufferTimeSpan;
        _this.bufferCreationInterval = bufferCreationInterval;
        _this.maxBufferSize = maxBufferSize;
        _this.scheduler = scheduler;
        _this.contexts = [];
        var context = _this.openContext();
        _this.timespanOnly = bufferCreationInterval == null || bufferCreationInterval < 0;
        if (_this.timespanOnly) {
            var timeSpanOnlyState = { subscriber: _this, context: context, bufferTimeSpan: bufferTimeSpan };
            _this.add(context.closeAction = scheduler.schedule(dispatchBufferTimeSpanOnly, bufferTimeSpan, timeSpanOnlyState));
        }
        else {
            var closeState = { subscriber: _this, context: context };
            var creationState = { bufferTimeSpan: bufferTimeSpan, bufferCreationInterval: bufferCreationInterval, subscriber: _this, scheduler: scheduler };
            _this.add(context.closeAction = scheduler.schedule(dispatchBufferClose, bufferTimeSpan, closeState));
            _this.add(scheduler.schedule(dispatchBufferCreation, bufferCreationInterval, creationState));
        }
        return _this;
    }
    BufferTimeSubscriber.prototype._next = function (value) {
        var contexts = this.contexts;
        var len = contexts.length;
        var filledBufferContext;
        for (var i = 0; i < len; i++) {
            var context_1 = contexts[i];
            var buffer = context_1.buffer;
            buffer.push(value);
            if (buffer.length == this.maxBufferSize) {
                filledBufferContext = context_1;
            }
        }
        if (filledBufferContext) {
            this.onBufferFull(filledBufferContext);
        }
    };
    BufferTimeSubscriber.prototype._error = function (err) {
        this.contexts.length = 0;
        _super.prototype._error.call(this, err);
    };
    BufferTimeSubscriber.prototype._complete = function () {
        var _a = this, contexts = _a.contexts, destination = _a.destination;
        while (contexts.length > 0) {
            var context_2 = contexts.shift();
            destination.next(context_2.buffer);
        }
        _super.prototype._complete.call(this);
    };
    BufferTimeSubscriber.prototype._unsubscribe = function () {
        this.contexts = null;
    };
    BufferTimeSubscriber.prototype.onBufferFull = function (context) {
        this.closeContext(context);
        var closeAction = context.closeAction;
        closeAction.unsubscribe();
        this.remove(closeAction);
        if (!this.closed && this.timespanOnly) {
            context = this.openContext();
            var bufferTimeSpan = this.bufferTimeSpan;
            var timeSpanOnlyState = { subscriber: this, context: context, bufferTimeSpan: bufferTimeSpan };
            this.add(context.closeAction = this.scheduler.schedule(dispatchBufferTimeSpanOnly, bufferTimeSpan, timeSpanOnlyState));
        }
    };
    BufferTimeSubscriber.prototype.openContext = function () {
        var context = new Context();
        this.contexts.push(context);
        return context;
    };
    BufferTimeSubscriber.prototype.closeContext = function (context) {
        this.destination.next(context.buffer);
        var contexts = this.contexts;
        var spliceIndex = contexts ? contexts.indexOf(context) : -1;
        if (spliceIndex >= 0) {
            contexts.splice(contexts.indexOf(context), 1);
        }
    };
    return BufferTimeSubscriber;
}(Subscriber_1.Subscriber));
function dispatchBufferTimeSpanOnly(state) {
    var subscriber = state.subscriber;
    var prevContext = state.context;
    if (prevContext) {
        subscriber.closeContext(prevContext);
    }
    if (!subscriber.closed) {
        state.context = subscriber.openContext();
        state.context.closeAction = this.schedule(state, state.bufferTimeSpan);
    }
}
function dispatchBufferCreation(state) {
    var bufferCreationInterval = state.bufferCreationInterval, bufferTimeSpan = state.bufferTimeSpan, subscriber = state.subscriber, scheduler = state.scheduler;
    var context = subscriber.openContext();
    var action = this;
    if (!subscriber.closed) {
        subscriber.add(context.closeAction = scheduler.schedule(dispatchBufferClose, bufferTimeSpan, { subscriber: subscriber, context: context }));
        action.schedule(state, bufferCreationInterval);
    }
}
function dispatchBufferClose(arg) {
    var subscriber = arg.subscriber, context = arg.context;
    subscriber.closeContext(context);
}

},{"../Subscriber":101,"../scheduler/async":252,"../util/isScheduler":276}],137:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subscription_1 = require("../Subscription");
var subscribeToResult_1 = require("../util/subscribeToResult");
var OuterSubscriber_1 = require("../OuterSubscriber");
function bufferToggle(openings, closingSelector) {
    return function bufferToggleOperatorFunction(source) {
        return source.lift(new BufferToggleOperator(openings, closingSelector));
    };
}
exports.bufferToggle = bufferToggle;
var BufferToggleOperator = (function () {
    function BufferToggleOperator(openings, closingSelector) {
        this.openings = openings;
        this.closingSelector = closingSelector;
    }
    BufferToggleOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new BufferToggleSubscriber(subscriber, this.openings, this.closingSelector));
    };
    return BufferToggleOperator;
}());
var BufferToggleSubscriber = (function (_super) {
    __extends(BufferToggleSubscriber, _super);
    function BufferToggleSubscriber(destination, openings, closingSelector) {
        var _this = _super.call(this, destination) || this;
        _this.openings = openings;
        _this.closingSelector = closingSelector;
        _this.contexts = [];
        _this.add(subscribeToResult_1.subscribeToResult(_this, openings));
        return _this;
    }
    BufferToggleSubscriber.prototype._next = function (value) {
        var contexts = this.contexts;
        var len = contexts.length;
        for (var i = 0; i < len; i++) {
            contexts[i].buffer.push(value);
        }
    };
    BufferToggleSubscriber.prototype._error = function (err) {
        var contexts = this.contexts;
        while (contexts.length > 0) {
            var context_1 = contexts.shift();
            context_1.subscription.unsubscribe();
            context_1.buffer = null;
            context_1.subscription = null;
        }
        this.contexts = null;
        _super.prototype._error.call(this, err);
    };
    BufferToggleSubscriber.prototype._complete = function () {
        var contexts = this.contexts;
        while (contexts.length > 0) {
            var context_2 = contexts.shift();
            this.destination.next(context_2.buffer);
            context_2.subscription.unsubscribe();
            context_2.buffer = null;
            context_2.subscription = null;
        }
        this.contexts = null;
        _super.prototype._complete.call(this);
    };
    BufferToggleSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
        outerValue ? this.closeBuffer(outerValue) : this.openBuffer(innerValue);
    };
    BufferToggleSubscriber.prototype.notifyComplete = function (innerSub) {
        this.closeBuffer(innerSub.context);
    };
    BufferToggleSubscriber.prototype.openBuffer = function (value) {
        try {
            var closingSelector = this.closingSelector;
            var closingNotifier = closingSelector.call(this, value);
            if (closingNotifier) {
                this.trySubscribe(closingNotifier);
            }
        }
        catch (err) {
            this._error(err);
        }
    };
    BufferToggleSubscriber.prototype.closeBuffer = function (context) {
        var contexts = this.contexts;
        if (contexts && context) {
            var buffer = context.buffer, subscription = context.subscription;
            this.destination.next(buffer);
            contexts.splice(contexts.indexOf(context), 1);
            this.remove(subscription);
            subscription.unsubscribe();
        }
    };
    BufferToggleSubscriber.prototype.trySubscribe = function (closingNotifier) {
        var contexts = this.contexts;
        var buffer = [];
        var subscription = new Subscription_1.Subscription();
        var context = { buffer: buffer, subscription: subscription };
        contexts.push(context);
        var innerSubscription = subscribeToResult_1.subscribeToResult(this, closingNotifier, context);
        if (!innerSubscription || innerSubscription.closed) {
            this.closeBuffer(context);
        }
        else {
            innerSubscription.context = context;
            this.add(innerSubscription);
            subscription.add(innerSubscription);
        }
    };
    return BufferToggleSubscriber;
}(OuterSubscriber_1.OuterSubscriber));

},{"../OuterSubscriber":96,"../Subscription":102,"../util/subscribeToResult":285}],138:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subscription_1 = require("../Subscription");
var OuterSubscriber_1 = require("../OuterSubscriber");
var subscribeToResult_1 = require("../util/subscribeToResult");
function bufferWhen(closingSelector) {
    return function (source) {
        return source.lift(new BufferWhenOperator(closingSelector));
    };
}
exports.bufferWhen = bufferWhen;
var BufferWhenOperator = (function () {
    function BufferWhenOperator(closingSelector) {
        this.closingSelector = closingSelector;
    }
    BufferWhenOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new BufferWhenSubscriber(subscriber, this.closingSelector));
    };
    return BufferWhenOperator;
}());
var BufferWhenSubscriber = (function (_super) {
    __extends(BufferWhenSubscriber, _super);
    function BufferWhenSubscriber(destination, closingSelector) {
        var _this = _super.call(this, destination) || this;
        _this.closingSelector = closingSelector;
        _this.subscribing = false;
        _this.openBuffer();
        return _this;
    }
    BufferWhenSubscriber.prototype._next = function (value) {
        this.buffer.push(value);
    };
    BufferWhenSubscriber.prototype._complete = function () {
        var buffer = this.buffer;
        if (buffer) {
            this.destination.next(buffer);
        }
        _super.prototype._complete.call(this);
    };
    BufferWhenSubscriber.prototype._unsubscribe = function () {
        this.buffer = null;
        this.subscribing = false;
    };
    BufferWhenSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
        this.openBuffer();
    };
    BufferWhenSubscriber.prototype.notifyComplete = function () {
        if (this.subscribing) {
            this.complete();
        }
        else {
            this.openBuffer();
        }
    };
    BufferWhenSubscriber.prototype.openBuffer = function () {
        var closingSubscription = this.closingSubscription;
        if (closingSubscription) {
            this.remove(closingSubscription);
            closingSubscription.unsubscribe();
        }
        var buffer = this.buffer;
        if (this.buffer) {
            this.destination.next(buffer);
        }
        this.buffer = [];
        var closingNotifier;
        try {
            var closingSelector = this.closingSelector;
            closingNotifier = closingSelector();
        }
        catch (err) {
            return this.error(err);
        }
        closingSubscription = new Subscription_1.Subscription();
        this.closingSubscription = closingSubscription;
        this.add(closingSubscription);
        this.subscribing = true;
        closingSubscription.add(subscribeToResult_1.subscribeToResult(this, closingNotifier));
        this.subscribing = false;
    };
    return BufferWhenSubscriber;
}(OuterSubscriber_1.OuterSubscriber));

},{"../OuterSubscriber":96,"../Subscription":102,"../util/subscribeToResult":285}],139:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var OuterSubscriber_1 = require("../OuterSubscriber");
var InnerSubscriber_1 = require("../InnerSubscriber");
var subscribeToResult_1 = require("../util/subscribeToResult");
function catchError(selector) {
    return function catchErrorOperatorFunction(source) {
        var operator = new CatchOperator(selector);
        var caught = source.lift(operator);
        return (operator.caught = caught);
    };
}
exports.catchError = catchError;
var CatchOperator = (function () {
    function CatchOperator(selector) {
        this.selector = selector;
    }
    CatchOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new CatchSubscriber(subscriber, this.selector, this.caught));
    };
    return CatchOperator;
}());
var CatchSubscriber = (function (_super) {
    __extends(CatchSubscriber, _super);
    function CatchSubscriber(destination, selector, caught) {
        var _this = _super.call(this, destination) || this;
        _this.selector = selector;
        _this.caught = caught;
        return _this;
    }
    CatchSubscriber.prototype.error = function (err) {
        if (!this.isStopped) {
            var result = void 0;
            try {
                result = this.selector(err, this.caught);
            }
            catch (err2) {
                _super.prototype.error.call(this, err2);
                return;
            }
            this._unsubscribeAndRecycle();
            var innerSubscriber = new InnerSubscriber_1.InnerSubscriber(this, undefined, undefined);
            this.add(innerSubscriber);
            subscribeToResult_1.subscribeToResult(this, result, undefined, undefined, innerSubscriber);
        }
    };
    return CatchSubscriber;
}(OuterSubscriber_1.OuterSubscriber));

},{"../InnerSubscriber":92,"../OuterSubscriber":96,"../util/subscribeToResult":285}],140:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var combineLatest_1 = require("../observable/combineLatest");
function combineAll(project) {
    return function (source) { return source.lift(new combineLatest_1.CombineLatestOperator(project)); };
}
exports.combineAll = combineAll;

},{"../observable/combineLatest":108}],141:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var isArray_1 = require("../util/isArray");
var combineLatest_1 = require("../observable/combineLatest");
var from_1 = require("../observable/from");
var none = {};
function combineLatest() {
    var observables = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        observables[_i] = arguments[_i];
    }
    var project = null;
    if (typeof observables[observables.length - 1] === 'function') {
        project = observables.pop();
    }
    if (observables.length === 1 && isArray_1.isArray(observables[0])) {
        observables = observables[0].slice();
    }
    return function (source) { return source.lift.call(from_1.from([source].concat(observables)), new combineLatest_1.CombineLatestOperator(project)); };
}
exports.combineLatest = combineLatest;

},{"../observable/combineLatest":108,"../observable/from":113,"../util/isArray":266}],142:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var concat_1 = require("../observable/concat");
function concat() {
    var observables = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        observables[_i] = arguments[_i];
    }
    return function (source) { return source.lift.call(concat_1.concat.apply(void 0, [source].concat(observables))); };
}
exports.concat = concat;

},{"../observable/concat":109}],143:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var mergeAll_1 = require("./mergeAll");
function concatAll() {
    return mergeAll_1.mergeAll(1);
}
exports.concatAll = concatAll;

},{"./mergeAll":176}],144:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var mergeMap_1 = require("./mergeMap");
function concatMap(project, resultSelector) {
    return mergeMap_1.mergeMap(project, resultSelector, 1);
}
exports.concatMap = concatMap;

},{"./mergeMap":177}],145:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var concatMap_1 = require("./concatMap");
function concatMapTo(innerObservable, resultSelector) {
    return concatMap_1.concatMap(function () { return innerObservable; }, resultSelector);
}
exports.concatMapTo = concatMapTo;

},{"./concatMap":144}],146:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subscriber_1 = require("../Subscriber");
function count(predicate) {
    return function (source) { return source.lift(new CountOperator(predicate, source)); };
}
exports.count = count;
var CountOperator = (function () {
    function CountOperator(predicate, source) {
        this.predicate = predicate;
        this.source = source;
    }
    CountOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new CountSubscriber(subscriber, this.predicate, this.source));
    };
    return CountOperator;
}());
var CountSubscriber = (function (_super) {
    __extends(CountSubscriber, _super);
    function CountSubscriber(destination, predicate, source) {
        var _this = _super.call(this, destination) || this;
        _this.predicate = predicate;
        _this.source = source;
        _this.count = 0;
        _this.index = 0;
        return _this;
    }
    CountSubscriber.prototype._next = function (value) {
        if (this.predicate) {
            this._tryPredicate(value);
        }
        else {
            this.count++;
        }
    };
    CountSubscriber.prototype._tryPredicate = function (value) {
        var result;
        try {
            result = this.predicate(value, this.index++, this.source);
        }
        catch (err) {
            this.destination.error(err);
            return;
        }
        if (result) {
            this.count++;
        }
    };
    CountSubscriber.prototype._complete = function () {
        this.destination.next(this.count);
        this.destination.complete();
    };
    return CountSubscriber;
}(Subscriber_1.Subscriber));

},{"../Subscriber":101}],147:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var OuterSubscriber_1 = require("../OuterSubscriber");
var subscribeToResult_1 = require("../util/subscribeToResult");
function debounce(durationSelector) {
    return function (source) { return source.lift(new DebounceOperator(durationSelector)); };
}
exports.debounce = debounce;
var DebounceOperator = (function () {
    function DebounceOperator(durationSelector) {
        this.durationSelector = durationSelector;
    }
    DebounceOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new DebounceSubscriber(subscriber, this.durationSelector));
    };
    return DebounceOperator;
}());
var DebounceSubscriber = (function (_super) {
    __extends(DebounceSubscriber, _super);
    function DebounceSubscriber(destination, durationSelector) {
        var _this = _super.call(this, destination) || this;
        _this.durationSelector = durationSelector;
        _this.hasValue = false;
        _this.durationSubscription = null;
        return _this;
    }
    DebounceSubscriber.prototype._next = function (value) {
        try {
            var result = this.durationSelector.call(this, value);
            if (result) {
                this._tryNext(value, result);
            }
        }
        catch (err) {
            this.destination.error(err);
        }
    };
    DebounceSubscriber.prototype._complete = function () {
        this.emitValue();
        this.destination.complete();
    };
    DebounceSubscriber.prototype._tryNext = function (value, duration) {
        var subscription = this.durationSubscription;
        this.value = value;
        this.hasValue = true;
        if (subscription) {
            subscription.unsubscribe();
            this.remove(subscription);
        }
        subscription = subscribeToResult_1.subscribeToResult(this, duration);
        if (subscription && !subscription.closed) {
            this.add(this.durationSubscription = subscription);
        }
    };
    DebounceSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
        this.emitValue();
    };
    DebounceSubscriber.prototype.notifyComplete = function () {
        this.emitValue();
    };
    DebounceSubscriber.prototype.emitValue = function () {
        if (this.hasValue) {
            var value = this.value;
            var subscription = this.durationSubscription;
            if (subscription) {
                this.durationSubscription = null;
                subscription.unsubscribe();
                this.remove(subscription);
            }
            this.value = null;
            this.hasValue = false;
            _super.prototype._next.call(this, value);
        }
    };
    return DebounceSubscriber;
}(OuterSubscriber_1.OuterSubscriber));

},{"../OuterSubscriber":96,"../util/subscribeToResult":285}],148:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subscriber_1 = require("../Subscriber");
var async_1 = require("../scheduler/async");
function debounceTime(dueTime, scheduler) {
    if (scheduler === void 0) { scheduler = async_1.async; }
    return function (source) { return source.lift(new DebounceTimeOperator(dueTime, scheduler)); };
}
exports.debounceTime = debounceTime;
var DebounceTimeOperator = (function () {
    function DebounceTimeOperator(dueTime, scheduler) {
        this.dueTime = dueTime;
        this.scheduler = scheduler;
    }
    DebounceTimeOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new DebounceTimeSubscriber(subscriber, this.dueTime, this.scheduler));
    };
    return DebounceTimeOperator;
}());
var DebounceTimeSubscriber = (function (_super) {
    __extends(DebounceTimeSubscriber, _super);
    function DebounceTimeSubscriber(destination, dueTime, scheduler) {
        var _this = _super.call(this, destination) || this;
        _this.dueTime = dueTime;
        _this.scheduler = scheduler;
        _this.debouncedSubscription = null;
        _this.lastValue = null;
        _this.hasValue = false;
        return _this;
    }
    DebounceTimeSubscriber.prototype._next = function (value) {
        this.clearDebounce();
        this.lastValue = value;
        this.hasValue = true;
        this.add(this.debouncedSubscription = this.scheduler.schedule(dispatchNext, this.dueTime, this));
    };
    DebounceTimeSubscriber.prototype._complete = function () {
        this.debouncedNext();
        this.destination.complete();
    };
    DebounceTimeSubscriber.prototype.debouncedNext = function () {
        this.clearDebounce();
        if (this.hasValue) {
            var lastValue = this.lastValue;
            this.lastValue = null;
            this.hasValue = false;
            this.destination.next(lastValue);
        }
    };
    DebounceTimeSubscriber.prototype.clearDebounce = function () {
        var debouncedSubscription = this.debouncedSubscription;
        if (debouncedSubscription !== null) {
            this.remove(debouncedSubscription);
            debouncedSubscription.unsubscribe();
            this.debouncedSubscription = null;
        }
    };
    return DebounceTimeSubscriber;
}(Subscriber_1.Subscriber));
function dispatchNext(subscriber) {
    subscriber.debouncedNext();
}

},{"../Subscriber":101,"../scheduler/async":252}],149:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subscriber_1 = require("../Subscriber");
function defaultIfEmpty(defaultValue) {
    if (defaultValue === void 0) { defaultValue = null; }
    return function (source) { return source.lift(new DefaultIfEmptyOperator(defaultValue)); };
}
exports.defaultIfEmpty = defaultIfEmpty;
var DefaultIfEmptyOperator = (function () {
    function DefaultIfEmptyOperator(defaultValue) {
        this.defaultValue = defaultValue;
    }
    DefaultIfEmptyOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new DefaultIfEmptySubscriber(subscriber, this.defaultValue));
    };
    return DefaultIfEmptyOperator;
}());
var DefaultIfEmptySubscriber = (function (_super) {
    __extends(DefaultIfEmptySubscriber, _super);
    function DefaultIfEmptySubscriber(destination, defaultValue) {
        var _this = _super.call(this, destination) || this;
        _this.defaultValue = defaultValue;
        _this.isEmpty = true;
        return _this;
    }
    DefaultIfEmptySubscriber.prototype._next = function (value) {
        this.isEmpty = false;
        this.destination.next(value);
    };
    DefaultIfEmptySubscriber.prototype._complete = function () {
        if (this.isEmpty) {
            this.destination.next(this.defaultValue);
        }
        this.destination.complete();
    };
    return DefaultIfEmptySubscriber;
}(Subscriber_1.Subscriber));

},{"../Subscriber":101}],150:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var async_1 = require("../scheduler/async");
var isDate_1 = require("../util/isDate");
var Subscriber_1 = require("../Subscriber");
var Notification_1 = require("../Notification");
function delay(delay, scheduler) {
    if (scheduler === void 0) { scheduler = async_1.async; }
    var absoluteDelay = isDate_1.isDate(delay);
    var delayFor = absoluteDelay ? (+delay - scheduler.now()) : Math.abs(delay);
    return function (source) { return source.lift(new DelayOperator(delayFor, scheduler)); };
}
exports.delay = delay;
var DelayOperator = (function () {
    function DelayOperator(delay, scheduler) {
        this.delay = delay;
        this.scheduler = scheduler;
    }
    DelayOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new DelaySubscriber(subscriber, this.delay, this.scheduler));
    };
    return DelayOperator;
}());
var DelaySubscriber = (function (_super) {
    __extends(DelaySubscriber, _super);
    function DelaySubscriber(destination, delay, scheduler) {
        var _this = _super.call(this, destination) || this;
        _this.delay = delay;
        _this.scheduler = scheduler;
        _this.queue = [];
        _this.active = false;
        _this.errored = false;
        return _this;
    }
    DelaySubscriber.dispatch = function (state) {
        var source = state.source;
        var queue = source.queue;
        var scheduler = state.scheduler;
        var destination = state.destination;
        while (queue.length > 0 && (queue[0].time - scheduler.now()) <= 0) {
            queue.shift().notification.observe(destination);
        }
        if (queue.length > 0) {
            var delay_1 = Math.max(0, queue[0].time - scheduler.now());
            this.schedule(state, delay_1);
        }
        else {
            this.unsubscribe();
            source.active = false;
        }
    };
    DelaySubscriber.prototype._schedule = function (scheduler) {
        this.active = true;
        var destination = this.destination;
        destination.add(scheduler.schedule(DelaySubscriber.dispatch, this.delay, {
            source: this, destination: this.destination, scheduler: scheduler
        }));
    };
    DelaySubscriber.prototype.scheduleNotification = function (notification) {
        if (this.errored === true) {
            return;
        }
        var scheduler = this.scheduler;
        var message = new DelayMessage(scheduler.now() + this.delay, notification);
        this.queue.push(message);
        if (this.active === false) {
            this._schedule(scheduler);
        }
    };
    DelaySubscriber.prototype._next = function (value) {
        this.scheduleNotification(Notification_1.Notification.createNext(value));
    };
    DelaySubscriber.prototype._error = function (err) {
        this.errored = true;
        this.queue = [];
        this.destination.error(err);
        this.unsubscribe();
    };
    DelaySubscriber.prototype._complete = function () {
        this.scheduleNotification(Notification_1.Notification.createComplete());
        this.unsubscribe();
    };
    return DelaySubscriber;
}(Subscriber_1.Subscriber));
var DelayMessage = (function () {
    function DelayMessage(time, notification) {
        this.time = time;
        this.notification = notification;
    }
    return DelayMessage;
}());

},{"../Notification":93,"../Subscriber":101,"../scheduler/async":252,"../util/isDate":268}],151:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subscriber_1 = require("../Subscriber");
var Observable_1 = require("../Observable");
var OuterSubscriber_1 = require("../OuterSubscriber");
var subscribeToResult_1 = require("../util/subscribeToResult");
function delayWhen(delayDurationSelector, subscriptionDelay) {
    if (subscriptionDelay) {
        return function (source) {
            return new SubscriptionDelayObservable(source, subscriptionDelay)
                .lift(new DelayWhenOperator(delayDurationSelector));
        };
    }
    return function (source) { return source.lift(new DelayWhenOperator(delayDurationSelector)); };
}
exports.delayWhen = delayWhen;
var DelayWhenOperator = (function () {
    function DelayWhenOperator(delayDurationSelector) {
        this.delayDurationSelector = delayDurationSelector;
    }
    DelayWhenOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new DelayWhenSubscriber(subscriber, this.delayDurationSelector));
    };
    return DelayWhenOperator;
}());
var DelayWhenSubscriber = (function (_super) {
    __extends(DelayWhenSubscriber, _super);
    function DelayWhenSubscriber(destination, delayDurationSelector) {
        var _this = _super.call(this, destination) || this;
        _this.delayDurationSelector = delayDurationSelector;
        _this.completed = false;
        _this.delayNotifierSubscriptions = [];
        _this.index = 0;
        return _this;
    }
    DelayWhenSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
        this.destination.next(outerValue);
        this.removeSubscription(innerSub);
        this.tryComplete();
    };
    DelayWhenSubscriber.prototype.notifyError = function (error, innerSub) {
        this._error(error);
    };
    DelayWhenSubscriber.prototype.notifyComplete = function (innerSub) {
        var value = this.removeSubscription(innerSub);
        if (value) {
            this.destination.next(value);
        }
        this.tryComplete();
    };
    DelayWhenSubscriber.prototype._next = function (value) {
        var index = this.index++;
        try {
            var delayNotifier = this.delayDurationSelector(value, index);
            if (delayNotifier) {
                this.tryDelay(delayNotifier, value);
            }
        }
        catch (err) {
            this.destination.error(err);
        }
    };
    DelayWhenSubscriber.prototype._complete = function () {
        this.completed = true;
        this.tryComplete();
        this.unsubscribe();
    };
    DelayWhenSubscriber.prototype.removeSubscription = function (subscription) {
        subscription.unsubscribe();
        var subscriptionIdx = this.delayNotifierSubscriptions.indexOf(subscription);
        if (subscriptionIdx !== -1) {
            this.delayNotifierSubscriptions.splice(subscriptionIdx, 1);
        }
        return subscription.outerValue;
    };
    DelayWhenSubscriber.prototype.tryDelay = function (delayNotifier, value) {
        var notifierSubscription = subscribeToResult_1.subscribeToResult(this, delayNotifier, value);
        if (notifierSubscription && !notifierSubscription.closed) {
            var destination = this.destination;
            destination.add(notifierSubscription);
            this.delayNotifierSubscriptions.push(notifierSubscription);
        }
    };
    DelayWhenSubscriber.prototype.tryComplete = function () {
        if (this.completed && this.delayNotifierSubscriptions.length === 0) {
            this.destination.complete();
        }
    };
    return DelayWhenSubscriber;
}(OuterSubscriber_1.OuterSubscriber));
var SubscriptionDelayObservable = (function (_super) {
    __extends(SubscriptionDelayObservable, _super);
    function SubscriptionDelayObservable(source, subscriptionDelay) {
        var _this = _super.call(this) || this;
        _this.source = source;
        _this.subscriptionDelay = subscriptionDelay;
        return _this;
    }
    SubscriptionDelayObservable.prototype._subscribe = function (subscriber) {
        this.subscriptionDelay.subscribe(new SubscriptionDelaySubscriber(subscriber, this.source));
    };
    return SubscriptionDelayObservable;
}(Observable_1.Observable));
var SubscriptionDelaySubscriber = (function (_super) {
    __extends(SubscriptionDelaySubscriber, _super);
    function SubscriptionDelaySubscriber(parent, source) {
        var _this = _super.call(this) || this;
        _this.parent = parent;
        _this.source = source;
        _this.sourceSubscribed = false;
        return _this;
    }
    SubscriptionDelaySubscriber.prototype._next = function (unused) {
        this.subscribeToSource();
    };
    SubscriptionDelaySubscriber.prototype._error = function (err) {
        this.unsubscribe();
        this.parent.error(err);
    };
    SubscriptionDelaySubscriber.prototype._complete = function () {
        this.unsubscribe();
        this.subscribeToSource();
    };
    SubscriptionDelaySubscriber.prototype.subscribeToSource = function () {
        if (!this.sourceSubscribed) {
            this.sourceSubscribed = true;
            this.unsubscribe();
            this.source.subscribe(this.parent);
        }
    };
    return SubscriptionDelaySubscriber;
}(Subscriber_1.Subscriber));

},{"../Observable":94,"../OuterSubscriber":96,"../Subscriber":101,"../util/subscribeToResult":285}],152:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subscriber_1 = require("../Subscriber");
function dematerialize() {
    return function dematerializeOperatorFunction(source) {
        return source.lift(new DeMaterializeOperator());
    };
}
exports.dematerialize = dematerialize;
var DeMaterializeOperator = (function () {
    function DeMaterializeOperator() {
    }
    DeMaterializeOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new DeMaterializeSubscriber(subscriber));
    };
    return DeMaterializeOperator;
}());
var DeMaterializeSubscriber = (function (_super) {
    __extends(DeMaterializeSubscriber, _super);
    function DeMaterializeSubscriber(destination) {
        return _super.call(this, destination) || this;
    }
    DeMaterializeSubscriber.prototype._next = function (value) {
        value.observe(this.destination);
    };
    return DeMaterializeSubscriber;
}(Subscriber_1.Subscriber));

},{"../Subscriber":101}],153:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var OuterSubscriber_1 = require("../OuterSubscriber");
var subscribeToResult_1 = require("../util/subscribeToResult");
function distinct(keySelector, flushes) {
    return function (source) { return source.lift(new DistinctOperator(keySelector, flushes)); };
}
exports.distinct = distinct;
var DistinctOperator = (function () {
    function DistinctOperator(keySelector, flushes) {
        this.keySelector = keySelector;
        this.flushes = flushes;
    }
    DistinctOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new DistinctSubscriber(subscriber, this.keySelector, this.flushes));
    };
    return DistinctOperator;
}());
var DistinctSubscriber = (function (_super) {
    __extends(DistinctSubscriber, _super);
    function DistinctSubscriber(destination, keySelector, flushes) {
        var _this = _super.call(this, destination) || this;
        _this.keySelector = keySelector;
        _this.values = new Set();
        if (flushes) {
            _this.add(subscribeToResult_1.subscribeToResult(_this, flushes));
        }
        return _this;
    }
    DistinctSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
        this.values.clear();
    };
    DistinctSubscriber.prototype.notifyError = function (error, innerSub) {
        this._error(error);
    };
    DistinctSubscriber.prototype._next = function (value) {
        if (this.keySelector) {
            this._useKeySelector(value);
        }
        else {
            this._finalizeNext(value, value);
        }
    };
    DistinctSubscriber.prototype._useKeySelector = function (value) {
        var key;
        var destination = this.destination;
        try {
            key = this.keySelector(value);
        }
        catch (err) {
            destination.error(err);
            return;
        }
        this._finalizeNext(key, value);
    };
    DistinctSubscriber.prototype._finalizeNext = function (key, value) {
        var values = this.values;
        if (!values.has(key)) {
            values.add(key);
            this.destination.next(value);
        }
    };
    return DistinctSubscriber;
}(OuterSubscriber_1.OuterSubscriber));
exports.DistinctSubscriber = DistinctSubscriber;

},{"../OuterSubscriber":96,"../util/subscribeToResult":285}],154:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subscriber_1 = require("../Subscriber");
function distinctUntilChanged(compare, keySelector) {
    return function (source) { return source.lift(new DistinctUntilChangedOperator(compare, keySelector)); };
}
exports.distinctUntilChanged = distinctUntilChanged;
var DistinctUntilChangedOperator = (function () {
    function DistinctUntilChangedOperator(compare, keySelector) {
        this.compare = compare;
        this.keySelector = keySelector;
    }
    DistinctUntilChangedOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new DistinctUntilChangedSubscriber(subscriber, this.compare, this.keySelector));
    };
    return DistinctUntilChangedOperator;
}());
var DistinctUntilChangedSubscriber = (function (_super) {
    __extends(DistinctUntilChangedSubscriber, _super);
    function DistinctUntilChangedSubscriber(destination, compare, keySelector) {
        var _this = _super.call(this, destination) || this;
        _this.keySelector = keySelector;
        _this.hasKey = false;
        if (typeof compare === 'function') {
            _this.compare = compare;
        }
        return _this;
    }
    DistinctUntilChangedSubscriber.prototype.compare = function (x, y) {
        return x === y;
    };
    DistinctUntilChangedSubscriber.prototype._next = function (value) {
        var key;
        try {
            var keySelector = this.keySelector;
            key = keySelector ? keySelector(value) : value;
        }
        catch (err) {
            return this.destination.error(err);
        }
        var result = false;
        if (this.hasKey) {
            try {
                var compare = this.compare;
                result = compare(this.key, key);
            }
            catch (err) {
                return this.destination.error(err);
            }
        }
        else {
            this.hasKey = true;
        }
        if (!result) {
            this.key = key;
            this.destination.next(value);
        }
    };
    return DistinctUntilChangedSubscriber;
}(Subscriber_1.Subscriber));

},{"../Subscriber":101}],155:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var distinctUntilChanged_1 = require("./distinctUntilChanged");
function distinctUntilKeyChanged(key, compare) {
    return distinctUntilChanged_1.distinctUntilChanged(function (x, y) { return compare ? compare(x[key], y[key]) : x[key] === y[key]; });
}
exports.distinctUntilKeyChanged = distinctUntilKeyChanged;

},{"./distinctUntilChanged":154}],156:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ArgumentOutOfRangeError_1 = require("../util/ArgumentOutOfRangeError");
var filter_1 = require("./filter");
var throwIfEmpty_1 = require("./throwIfEmpty");
var defaultIfEmpty_1 = require("./defaultIfEmpty");
var take_1 = require("./take");
function elementAt(index, defaultValue) {
    if (index < 0) {
        throw new ArgumentOutOfRangeError_1.ArgumentOutOfRangeError();
    }
    var hasDefaultValue = arguments.length >= 2;
    return function (source) { return source.pipe(filter_1.filter(function (v, i) { return i === index; }), take_1.take(1), hasDefaultValue
        ? defaultIfEmpty_1.defaultIfEmpty(defaultValue)
        : throwIfEmpty_1.throwIfEmpty(function () { return new ArgumentOutOfRangeError_1.ArgumentOutOfRangeError(); })); };
}
exports.elementAt = elementAt;

},{"../util/ArgumentOutOfRangeError":257,"./defaultIfEmpty":149,"./filter":162,"./take":214,"./throwIfEmpty":221}],157:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var concat_1 = require("../observable/concat");
var of_1 = require("../observable/of");
function endWith() {
    var array = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        array[_i] = arguments[_i];
    }
    return function (source) { return concat_1.concat(source, of_1.of.apply(void 0, array)); };
}
exports.endWith = endWith;

},{"../observable/concat":109,"../observable/of":122}],158:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subscriber_1 = require("../Subscriber");
function every(predicate, thisArg) {
    return function (source) { return source.lift(new EveryOperator(predicate, thisArg, source)); };
}
exports.every = every;
var EveryOperator = (function () {
    function EveryOperator(predicate, thisArg, source) {
        this.predicate = predicate;
        this.thisArg = thisArg;
        this.source = source;
    }
    EveryOperator.prototype.call = function (observer, source) {
        return source.subscribe(new EverySubscriber(observer, this.predicate, this.thisArg, this.source));
    };
    return EveryOperator;
}());
var EverySubscriber = (function (_super) {
    __extends(EverySubscriber, _super);
    function EverySubscriber(destination, predicate, thisArg, source) {
        var _this = _super.call(this, destination) || this;
        _this.predicate = predicate;
        _this.thisArg = thisArg;
        _this.source = source;
        _this.index = 0;
        _this.thisArg = thisArg || _this;
        return _this;
    }
    EverySubscriber.prototype.notifyComplete = function (everyValueMatch) {
        this.destination.next(everyValueMatch);
        this.destination.complete();
    };
    EverySubscriber.prototype._next = function (value) {
        var result = false;
        try {
            result = this.predicate.call(this.thisArg, value, this.index++, this.source);
        }
        catch (err) {
            this.destination.error(err);
            return;
        }
        if (!result) {
            this.notifyComplete(false);
        }
    };
    EverySubscriber.prototype._complete = function () {
        this.notifyComplete(true);
    };
    return EverySubscriber;
}(Subscriber_1.Subscriber));

},{"../Subscriber":101}],159:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var OuterSubscriber_1 = require("../OuterSubscriber");
var subscribeToResult_1 = require("../util/subscribeToResult");
function exhaust() {
    return function (source) { return source.lift(new SwitchFirstOperator()); };
}
exports.exhaust = exhaust;
var SwitchFirstOperator = (function () {
    function SwitchFirstOperator() {
    }
    SwitchFirstOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new SwitchFirstSubscriber(subscriber));
    };
    return SwitchFirstOperator;
}());
var SwitchFirstSubscriber = (function (_super) {
    __extends(SwitchFirstSubscriber, _super);
    function SwitchFirstSubscriber(destination) {
        var _this = _super.call(this, destination) || this;
        _this.hasCompleted = false;
        _this.hasSubscription = false;
        return _this;
    }
    SwitchFirstSubscriber.prototype._next = function (value) {
        if (!this.hasSubscription) {
            this.hasSubscription = true;
            this.add(subscribeToResult_1.subscribeToResult(this, value));
        }
    };
    SwitchFirstSubscriber.prototype._complete = function () {
        this.hasCompleted = true;
        if (!this.hasSubscription) {
            this.destination.complete();
        }
    };
    SwitchFirstSubscriber.prototype.notifyComplete = function (innerSub) {
        this.remove(innerSub);
        this.hasSubscription = false;
        if (this.hasCompleted) {
            this.destination.complete();
        }
    };
    return SwitchFirstSubscriber;
}(OuterSubscriber_1.OuterSubscriber));

},{"../OuterSubscriber":96,"../util/subscribeToResult":285}],160:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var OuterSubscriber_1 = require("../OuterSubscriber");
var InnerSubscriber_1 = require("../InnerSubscriber");
var subscribeToResult_1 = require("../util/subscribeToResult");
var map_1 = require("./map");
var from_1 = require("../observable/from");
function exhaustMap(project, resultSelector) {
    if (resultSelector) {
        return function (source) { return source.pipe(exhaustMap(function (a, i) { return from_1.from(project(a, i)).pipe(map_1.map(function (b, ii) { return resultSelector(a, b, i, ii); })); })); };
    }
    return function (source) {
        return source.lift(new ExhaustMapOperator(project));
    };
}
exports.exhaustMap = exhaustMap;
var ExhaustMapOperator = (function () {
    function ExhaustMapOperator(project) {
        this.project = project;
    }
    ExhaustMapOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new ExhaustMapSubscriber(subscriber, this.project));
    };
    return ExhaustMapOperator;
}());
var ExhaustMapSubscriber = (function (_super) {
    __extends(ExhaustMapSubscriber, _super);
    function ExhaustMapSubscriber(destination, project) {
        var _this = _super.call(this, destination) || this;
        _this.project = project;
        _this.hasSubscription = false;
        _this.hasCompleted = false;
        _this.index = 0;
        return _this;
    }
    ExhaustMapSubscriber.prototype._next = function (value) {
        if (!this.hasSubscription) {
            this.tryNext(value);
        }
    };
    ExhaustMapSubscriber.prototype.tryNext = function (value) {
        var result;
        var index = this.index++;
        try {
            result = this.project(value, index);
        }
        catch (err) {
            this.destination.error(err);
            return;
        }
        this.hasSubscription = true;
        this._innerSub(result, value, index);
    };
    ExhaustMapSubscriber.prototype._innerSub = function (result, value, index) {
        var innerSubscriber = new InnerSubscriber_1.InnerSubscriber(this, undefined, undefined);
        var destination = this.destination;
        destination.add(innerSubscriber);
        subscribeToResult_1.subscribeToResult(this, result, value, index, innerSubscriber);
    };
    ExhaustMapSubscriber.prototype._complete = function () {
        this.hasCompleted = true;
        if (!this.hasSubscription) {
            this.destination.complete();
        }
        this.unsubscribe();
    };
    ExhaustMapSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
        this.destination.next(innerValue);
    };
    ExhaustMapSubscriber.prototype.notifyError = function (err) {
        this.destination.error(err);
    };
    ExhaustMapSubscriber.prototype.notifyComplete = function (innerSub) {
        var destination = this.destination;
        destination.remove(innerSub);
        this.hasSubscription = false;
        if (this.hasCompleted) {
            this.destination.complete();
        }
    };
    return ExhaustMapSubscriber;
}(OuterSubscriber_1.OuterSubscriber));

},{"../InnerSubscriber":92,"../OuterSubscriber":96,"../observable/from":113,"../util/subscribeToResult":285,"./map":171}],161:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var OuterSubscriber_1 = require("../OuterSubscriber");
var subscribeToResult_1 = require("../util/subscribeToResult");
function expand(project, concurrent, scheduler) {
    if (concurrent === void 0) { concurrent = Number.POSITIVE_INFINITY; }
    if (scheduler === void 0) { scheduler = undefined; }
    concurrent = (concurrent || 0) < 1 ? Number.POSITIVE_INFINITY : concurrent;
    return function (source) { return source.lift(new ExpandOperator(project, concurrent, scheduler)); };
}
exports.expand = expand;
var ExpandOperator = (function () {
    function ExpandOperator(project, concurrent, scheduler) {
        this.project = project;
        this.concurrent = concurrent;
        this.scheduler = scheduler;
    }
    ExpandOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new ExpandSubscriber(subscriber, this.project, this.concurrent, this.scheduler));
    };
    return ExpandOperator;
}());
exports.ExpandOperator = ExpandOperator;
var ExpandSubscriber = (function (_super) {
    __extends(ExpandSubscriber, _super);
    function ExpandSubscriber(destination, project, concurrent, scheduler) {
        var _this = _super.call(this, destination) || this;
        _this.project = project;
        _this.concurrent = concurrent;
        _this.scheduler = scheduler;
        _this.index = 0;
        _this.active = 0;
        _this.hasCompleted = false;
        if (concurrent < Number.POSITIVE_INFINITY) {
            _this.buffer = [];
        }
        return _this;
    }
    ExpandSubscriber.dispatch = function (arg) {
        var subscriber = arg.subscriber, result = arg.result, value = arg.value, index = arg.index;
        subscriber.subscribeToProjection(result, value, index);
    };
    ExpandSubscriber.prototype._next = function (value) {
        var destination = this.destination;
        if (destination.closed) {
            this._complete();
            return;
        }
        var index = this.index++;
        if (this.active < this.concurrent) {
            destination.next(value);
            try {
                var project = this.project;
                var result = project(value, index);
                if (!this.scheduler) {
                    this.subscribeToProjection(result, value, index);
                }
                else {
                    var state = { subscriber: this, result: result, value: value, index: index };
                    var destination_1 = this.destination;
                    destination_1.add(this.scheduler.schedule(ExpandSubscriber.dispatch, 0, state));
                }
            }
            catch (e) {
                destination.error(e);
            }
        }
        else {
            this.buffer.push(value);
        }
    };
    ExpandSubscriber.prototype.subscribeToProjection = function (result, value, index) {
        this.active++;
        var destination = this.destination;
        destination.add(subscribeToResult_1.subscribeToResult(this, result, value, index));
    };
    ExpandSubscriber.prototype._complete = function () {
        this.hasCompleted = true;
        if (this.hasCompleted && this.active === 0) {
            this.destination.complete();
        }
        this.unsubscribe();
    };
    ExpandSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
        this._next(innerValue);
    };
    ExpandSubscriber.prototype.notifyComplete = function (innerSub) {
        var buffer = this.buffer;
        var destination = this.destination;
        destination.remove(innerSub);
        this.active--;
        if (buffer && buffer.length > 0) {
            this._next(buffer.shift());
        }
        if (this.hasCompleted && this.active === 0) {
            this.destination.complete();
        }
    };
    return ExpandSubscriber;
}(OuterSubscriber_1.OuterSubscriber));
exports.ExpandSubscriber = ExpandSubscriber;

},{"../OuterSubscriber":96,"../util/subscribeToResult":285}],162:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subscriber_1 = require("../Subscriber");
function filter(predicate, thisArg) {
    return function filterOperatorFunction(source) {
        return source.lift(new FilterOperator(predicate, thisArg));
    };
}
exports.filter = filter;
var FilterOperator = (function () {
    function FilterOperator(predicate, thisArg) {
        this.predicate = predicate;
        this.thisArg = thisArg;
    }
    FilterOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new FilterSubscriber(subscriber, this.predicate, this.thisArg));
    };
    return FilterOperator;
}());
var FilterSubscriber = (function (_super) {
    __extends(FilterSubscriber, _super);
    function FilterSubscriber(destination, predicate, thisArg) {
        var _this = _super.call(this, destination) || this;
        _this.predicate = predicate;
        _this.thisArg = thisArg;
        _this.count = 0;
        return _this;
    }
    FilterSubscriber.prototype._next = function (value) {
        var result;
        try {
            result = this.predicate.call(this.thisArg, value, this.count++);
        }
        catch (err) {
            this.destination.error(err);
            return;
        }
        if (result) {
            this.destination.next(value);
        }
    };
    return FilterSubscriber;
}(Subscriber_1.Subscriber));

},{"../Subscriber":101}],163:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subscriber_1 = require("../Subscriber");
var Subscription_1 = require("../Subscription");
function finalize(callback) {
    return function (source) { return source.lift(new FinallyOperator(callback)); };
}
exports.finalize = finalize;
var FinallyOperator = (function () {
    function FinallyOperator(callback) {
        this.callback = callback;
    }
    FinallyOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new FinallySubscriber(subscriber, this.callback));
    };
    return FinallyOperator;
}());
var FinallySubscriber = (function (_super) {
    __extends(FinallySubscriber, _super);
    function FinallySubscriber(destination, callback) {
        var _this = _super.call(this, destination) || this;
        _this.add(new Subscription_1.Subscription(callback));
        return _this;
    }
    return FinallySubscriber;
}(Subscriber_1.Subscriber));

},{"../Subscriber":101,"../Subscription":102}],164:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subscriber_1 = require("../Subscriber");
function find(predicate, thisArg) {
    if (typeof predicate !== 'function') {
        throw new TypeError('predicate is not a function');
    }
    return function (source) { return source.lift(new FindValueOperator(predicate, source, false, thisArg)); };
}
exports.find = find;
var FindValueOperator = (function () {
    function FindValueOperator(predicate, source, yieldIndex, thisArg) {
        this.predicate = predicate;
        this.source = source;
        this.yieldIndex = yieldIndex;
        this.thisArg = thisArg;
    }
    FindValueOperator.prototype.call = function (observer, source) {
        return source.subscribe(new FindValueSubscriber(observer, this.predicate, this.source, this.yieldIndex, this.thisArg));
    };
    return FindValueOperator;
}());
exports.FindValueOperator = FindValueOperator;
var FindValueSubscriber = (function (_super) {
    __extends(FindValueSubscriber, _super);
    function FindValueSubscriber(destination, predicate, source, yieldIndex, thisArg) {
        var _this = _super.call(this, destination) || this;
        _this.predicate = predicate;
        _this.source = source;
        _this.yieldIndex = yieldIndex;
        _this.thisArg = thisArg;
        _this.index = 0;
        return _this;
    }
    FindValueSubscriber.prototype.notifyComplete = function (value) {
        var destination = this.destination;
        destination.next(value);
        destination.complete();
        this.unsubscribe();
    };
    FindValueSubscriber.prototype._next = function (value) {
        var _a = this, predicate = _a.predicate, thisArg = _a.thisArg;
        var index = this.index++;
        try {
            var result = predicate.call(thisArg || this, value, index, this.source);
            if (result) {
                this.notifyComplete(this.yieldIndex ? index : value);
            }
        }
        catch (err) {
            this.destination.error(err);
        }
    };
    FindValueSubscriber.prototype._complete = function () {
        this.notifyComplete(this.yieldIndex ? -1 : undefined);
    };
    return FindValueSubscriber;
}(Subscriber_1.Subscriber));
exports.FindValueSubscriber = FindValueSubscriber;

},{"../Subscriber":101}],165:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var find_1 = require("../operators/find");
function findIndex(predicate, thisArg) {
    return function (source) { return source.lift(new find_1.FindValueOperator(predicate, source, true, thisArg)); };
}
exports.findIndex = findIndex;

},{"../operators/find":164}],166:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var EmptyError_1 = require("../util/EmptyError");
var filter_1 = require("./filter");
var take_1 = require("./take");
var defaultIfEmpty_1 = require("./defaultIfEmpty");
var throwIfEmpty_1 = require("./throwIfEmpty");
var identity_1 = require("../util/identity");
function first(predicate, defaultValue) {
    var hasDefaultValue = arguments.length >= 2;
    return function (source) { return source.pipe(predicate ? filter_1.filter(function (v, i) { return predicate(v, i, source); }) : identity_1.identity, take_1.take(1), hasDefaultValue ? defaultIfEmpty_1.defaultIfEmpty(defaultValue) : throwIfEmpty_1.throwIfEmpty(function () { return new EmptyError_1.EmptyError(); })); };
}
exports.first = first;

},{"../util/EmptyError":258,"../util/identity":265,"./defaultIfEmpty":149,"./filter":162,"./take":214,"./throwIfEmpty":221}],167:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subscriber_1 = require("../Subscriber");
var Subscription_1 = require("../Subscription");
var Observable_1 = require("../Observable");
var Subject_1 = require("../Subject");
function groupBy(keySelector, elementSelector, durationSelector, subjectSelector) {
    return function (source) {
        return source.lift(new GroupByOperator(keySelector, elementSelector, durationSelector, subjectSelector));
    };
}
exports.groupBy = groupBy;
var GroupByOperator = (function () {
    function GroupByOperator(keySelector, elementSelector, durationSelector, subjectSelector) {
        this.keySelector = keySelector;
        this.elementSelector = elementSelector;
        this.durationSelector = durationSelector;
        this.subjectSelector = subjectSelector;
    }
    GroupByOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new GroupBySubscriber(subscriber, this.keySelector, this.elementSelector, this.durationSelector, this.subjectSelector));
    };
    return GroupByOperator;
}());
var GroupBySubscriber = (function (_super) {
    __extends(GroupBySubscriber, _super);
    function GroupBySubscriber(destination, keySelector, elementSelector, durationSelector, subjectSelector) {
        var _this = _super.call(this, destination) || this;
        _this.keySelector = keySelector;
        _this.elementSelector = elementSelector;
        _this.durationSelector = durationSelector;
        _this.subjectSelector = subjectSelector;
        _this.groups = null;
        _this.attemptedToUnsubscribe = false;
        _this.count = 0;
        return _this;
    }
    GroupBySubscriber.prototype._next = function (value) {
        var key;
        try {
            key = this.keySelector(value);
        }
        catch (err) {
            this.error(err);
            return;
        }
        this._group(value, key);
    };
    GroupBySubscriber.prototype._group = function (value, key) {
        var groups = this.groups;
        if (!groups) {
            groups = this.groups = new Map();
        }
        var group = groups.get(key);
        var element;
        if (this.elementSelector) {
            try {
                element = this.elementSelector(value);
            }
            catch (err) {
                this.error(err);
            }
        }
        else {
            element = value;
        }
        if (!group) {
            group = (this.subjectSelector ? this.subjectSelector() : new Subject_1.Subject());
            groups.set(key, group);
            var groupedObservable = new GroupedObservable(key, group, this);
            this.destination.next(groupedObservable);
            if (this.durationSelector) {
                var duration = void 0;
                try {
                    duration = this.durationSelector(new GroupedObservable(key, group));
                }
                catch (err) {
                    this.error(err);
                    return;
                }
                this.add(duration.subscribe(new GroupDurationSubscriber(key, group, this)));
            }
        }
        if (!group.closed) {
            group.next(element);
        }
    };
    GroupBySubscriber.prototype._error = function (err) {
        var groups = this.groups;
        if (groups) {
            groups.forEach(function (group, key) {
                group.error(err);
            });
            groups.clear();
        }
        this.destination.error(err);
    };
    GroupBySubscriber.prototype._complete = function () {
        var groups = this.groups;
        if (groups) {
            groups.forEach(function (group, key) {
                group.complete();
            });
            groups.clear();
        }
        this.destination.complete();
    };
    GroupBySubscriber.prototype.removeGroup = function (key) {
        this.groups.delete(key);
    };
    GroupBySubscriber.prototype.unsubscribe = function () {
        if (!this.closed) {
            this.attemptedToUnsubscribe = true;
            if (this.count === 0) {
                _super.prototype.unsubscribe.call(this);
            }
        }
    };
    return GroupBySubscriber;
}(Subscriber_1.Subscriber));
var GroupDurationSubscriber = (function (_super) {
    __extends(GroupDurationSubscriber, _super);
    function GroupDurationSubscriber(key, group, parent) {
        var _this = _super.call(this, group) || this;
        _this.key = key;
        _this.group = group;
        _this.parent = parent;
        return _this;
    }
    GroupDurationSubscriber.prototype._next = function (value) {
        this.complete();
    };
    GroupDurationSubscriber.prototype._unsubscribe = function () {
        var _a = this, parent = _a.parent, key = _a.key;
        this.key = this.parent = null;
        if (parent) {
            parent.removeGroup(key);
        }
    };
    return GroupDurationSubscriber;
}(Subscriber_1.Subscriber));
var GroupedObservable = (function (_super) {
    __extends(GroupedObservable, _super);
    function GroupedObservable(key, groupSubject, refCountSubscription) {
        var _this = _super.call(this) || this;
        _this.key = key;
        _this.groupSubject = groupSubject;
        _this.refCountSubscription = refCountSubscription;
        return _this;
    }
    GroupedObservable.prototype._subscribe = function (subscriber) {
        var subscription = new Subscription_1.Subscription();
        var _a = this, refCountSubscription = _a.refCountSubscription, groupSubject = _a.groupSubject;
        if (refCountSubscription && !refCountSubscription.closed) {
            subscription.add(new InnerRefCountSubscription(refCountSubscription));
        }
        subscription.add(groupSubject.subscribe(subscriber));
        return subscription;
    };
    return GroupedObservable;
}(Observable_1.Observable));
exports.GroupedObservable = GroupedObservable;
var InnerRefCountSubscription = (function (_super) {
    __extends(InnerRefCountSubscription, _super);
    function InnerRefCountSubscription(parent) {
        var _this = _super.call(this) || this;
        _this.parent = parent;
        parent.count++;
        return _this;
    }
    InnerRefCountSubscription.prototype.unsubscribe = function () {
        var parent = this.parent;
        if (!parent.closed && !this.closed) {
            _super.prototype.unsubscribe.call(this);
            parent.count -= 1;
            if (parent.count === 0 && parent.attemptedToUnsubscribe) {
                parent.unsubscribe();
            }
        }
    };
    return InnerRefCountSubscription;
}(Subscription_1.Subscription));

},{"../Observable":94,"../Subject":99,"../Subscriber":101,"../Subscription":102}],168:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subscriber_1 = require("../Subscriber");
function ignoreElements() {
    return function ignoreElementsOperatorFunction(source) {
        return source.lift(new IgnoreElementsOperator());
    };
}
exports.ignoreElements = ignoreElements;
var IgnoreElementsOperator = (function () {
    function IgnoreElementsOperator() {
    }
    IgnoreElementsOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new IgnoreElementsSubscriber(subscriber));
    };
    return IgnoreElementsOperator;
}());
var IgnoreElementsSubscriber = (function (_super) {
    __extends(IgnoreElementsSubscriber, _super);
    function IgnoreElementsSubscriber() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    IgnoreElementsSubscriber.prototype._next = function (unused) {
    };
    return IgnoreElementsSubscriber;
}(Subscriber_1.Subscriber));

},{"../Subscriber":101}],169:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subscriber_1 = require("../Subscriber");
function isEmpty() {
    return function (source) { return source.lift(new IsEmptyOperator()); };
}
exports.isEmpty = isEmpty;
var IsEmptyOperator = (function () {
    function IsEmptyOperator() {
    }
    IsEmptyOperator.prototype.call = function (observer, source) {
        return source.subscribe(new IsEmptySubscriber(observer));
    };
    return IsEmptyOperator;
}());
var IsEmptySubscriber = (function (_super) {
    __extends(IsEmptySubscriber, _super);
    function IsEmptySubscriber(destination) {
        return _super.call(this, destination) || this;
    }
    IsEmptySubscriber.prototype.notifyComplete = function (isEmpty) {
        var destination = this.destination;
        destination.next(isEmpty);
        destination.complete();
    };
    IsEmptySubscriber.prototype._next = function (value) {
        this.notifyComplete(false);
    };
    IsEmptySubscriber.prototype._complete = function () {
        this.notifyComplete(true);
    };
    return IsEmptySubscriber;
}(Subscriber_1.Subscriber));

},{"../Subscriber":101}],170:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var EmptyError_1 = require("../util/EmptyError");
var filter_1 = require("./filter");
var takeLast_1 = require("./takeLast");
var throwIfEmpty_1 = require("./throwIfEmpty");
var defaultIfEmpty_1 = require("./defaultIfEmpty");
var identity_1 = require("../util/identity");
function last(predicate, defaultValue) {
    var hasDefaultValue = arguments.length >= 2;
    return function (source) { return source.pipe(predicate ? filter_1.filter(function (v, i) { return predicate(v, i, source); }) : identity_1.identity, takeLast_1.takeLast(1), hasDefaultValue ? defaultIfEmpty_1.defaultIfEmpty(defaultValue) : throwIfEmpty_1.throwIfEmpty(function () { return new EmptyError_1.EmptyError(); })); };
}
exports.last = last;

},{"../util/EmptyError":258,"../util/identity":265,"./defaultIfEmpty":149,"./filter":162,"./takeLast":215,"./throwIfEmpty":221}],171:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subscriber_1 = require("../Subscriber");
function map(project, thisArg) {
    return function mapOperation(source) {
        if (typeof project !== 'function') {
            throw new TypeError('argument is not a function. Are you looking for `mapTo()`?');
        }
        return source.lift(new MapOperator(project, thisArg));
    };
}
exports.map = map;
var MapOperator = (function () {
    function MapOperator(project, thisArg) {
        this.project = project;
        this.thisArg = thisArg;
    }
    MapOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new MapSubscriber(subscriber, this.project, this.thisArg));
    };
    return MapOperator;
}());
exports.MapOperator = MapOperator;
var MapSubscriber = (function (_super) {
    __extends(MapSubscriber, _super);
    function MapSubscriber(destination, project, thisArg) {
        var _this = _super.call(this, destination) || this;
        _this.project = project;
        _this.count = 0;
        _this.thisArg = thisArg || _this;
        return _this;
    }
    MapSubscriber.prototype._next = function (value) {
        var result;
        try {
            result = this.project.call(this.thisArg, value, this.count++);
        }
        catch (err) {
            this.destination.error(err);
            return;
        }
        this.destination.next(result);
    };
    return MapSubscriber;
}(Subscriber_1.Subscriber));

},{"../Subscriber":101}],172:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subscriber_1 = require("../Subscriber");
function mapTo(value) {
    return function (source) { return source.lift(new MapToOperator(value)); };
}
exports.mapTo = mapTo;
var MapToOperator = (function () {
    function MapToOperator(value) {
        this.value = value;
    }
    MapToOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new MapToSubscriber(subscriber, this.value));
    };
    return MapToOperator;
}());
var MapToSubscriber = (function (_super) {
    __extends(MapToSubscriber, _super);
    function MapToSubscriber(destination, value) {
        var _this = _super.call(this, destination) || this;
        _this.value = value;
        return _this;
    }
    MapToSubscriber.prototype._next = function (x) {
        this.destination.next(this.value);
    };
    return MapToSubscriber;
}(Subscriber_1.Subscriber));

},{"../Subscriber":101}],173:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subscriber_1 = require("../Subscriber");
var Notification_1 = require("../Notification");
function materialize() {
    return function materializeOperatorFunction(source) {
        return source.lift(new MaterializeOperator());
    };
}
exports.materialize = materialize;
var MaterializeOperator = (function () {
    function MaterializeOperator() {
    }
    MaterializeOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new MaterializeSubscriber(subscriber));
    };
    return MaterializeOperator;
}());
var MaterializeSubscriber = (function (_super) {
    __extends(MaterializeSubscriber, _super);
    function MaterializeSubscriber(destination) {
        return _super.call(this, destination) || this;
    }
    MaterializeSubscriber.prototype._next = function (value) {
        this.destination.next(Notification_1.Notification.createNext(value));
    };
    MaterializeSubscriber.prototype._error = function (err) {
        var destination = this.destination;
        destination.next(Notification_1.Notification.createError(err));
        destination.complete();
    };
    MaterializeSubscriber.prototype._complete = function () {
        var destination = this.destination;
        destination.next(Notification_1.Notification.createComplete());
        destination.complete();
    };
    return MaterializeSubscriber;
}(Subscriber_1.Subscriber));

},{"../Notification":93,"../Subscriber":101}],174:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var reduce_1 = require("./reduce");
function max(comparer) {
    var max = (typeof comparer === 'function')
        ? function (x, y) { return comparer(x, y) > 0 ? x : y; }
        : function (x, y) { return x > y ? x : y; };
    return reduce_1.reduce(max);
}
exports.max = max;

},{"./reduce":192}],175:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var merge_1 = require("../observable/merge");
function merge() {
    var observables = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        observables[_i] = arguments[_i];
    }
    return function (source) { return source.lift.call(merge_1.merge.apply(void 0, [source].concat(observables))); };
}
exports.merge = merge;

},{"../observable/merge":120}],176:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var mergeMap_1 = require("./mergeMap");
var identity_1 = require("../util/identity");
function mergeAll(concurrent) {
    if (concurrent === void 0) { concurrent = Number.POSITIVE_INFINITY; }
    return mergeMap_1.mergeMap(identity_1.identity, concurrent);
}
exports.mergeAll = mergeAll;

},{"../util/identity":265,"./mergeMap":177}],177:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var subscribeToResult_1 = require("../util/subscribeToResult");
var OuterSubscriber_1 = require("../OuterSubscriber");
var InnerSubscriber_1 = require("../InnerSubscriber");
var map_1 = require("./map");
var from_1 = require("../observable/from");
function mergeMap(project, resultSelector, concurrent) {
    if (concurrent === void 0) { concurrent = Number.POSITIVE_INFINITY; }
    if (typeof resultSelector === 'function') {
        return function (source) { return source.pipe(mergeMap(function (a, i) { return from_1.from(project(a, i)).pipe(map_1.map(function (b, ii) { return resultSelector(a, b, i, ii); })); }, concurrent)); };
    }
    else if (typeof resultSelector === 'number') {
        concurrent = resultSelector;
    }
    return function (source) { return source.lift(new MergeMapOperator(project, concurrent)); };
}
exports.mergeMap = mergeMap;
var MergeMapOperator = (function () {
    function MergeMapOperator(project, concurrent) {
        if (concurrent === void 0) { concurrent = Number.POSITIVE_INFINITY; }
        this.project = project;
        this.concurrent = concurrent;
    }
    MergeMapOperator.prototype.call = function (observer, source) {
        return source.subscribe(new MergeMapSubscriber(observer, this.project, this.concurrent));
    };
    return MergeMapOperator;
}());
exports.MergeMapOperator = MergeMapOperator;
var MergeMapSubscriber = (function (_super) {
    __extends(MergeMapSubscriber, _super);
    function MergeMapSubscriber(destination, project, concurrent) {
        if (concurrent === void 0) { concurrent = Number.POSITIVE_INFINITY; }
        var _this = _super.call(this, destination) || this;
        _this.project = project;
        _this.concurrent = concurrent;
        _this.hasCompleted = false;
        _this.buffer = [];
        _this.active = 0;
        _this.index = 0;
        return _this;
    }
    MergeMapSubscriber.prototype._next = function (value) {
        if (this.active < this.concurrent) {
            this._tryNext(value);
        }
        else {
            this.buffer.push(value);
        }
    };
    MergeMapSubscriber.prototype._tryNext = function (value) {
        var result;
        var index = this.index++;
        try {
            result = this.project(value, index);
        }
        catch (err) {
            this.destination.error(err);
            return;
        }
        this.active++;
        this._innerSub(result, value, index);
    };
    MergeMapSubscriber.prototype._innerSub = function (ish, value, index) {
        var innerSubscriber = new InnerSubscriber_1.InnerSubscriber(this, undefined, undefined);
        var destination = this.destination;
        destination.add(innerSubscriber);
        subscribeToResult_1.subscribeToResult(this, ish, value, index, innerSubscriber);
    };
    MergeMapSubscriber.prototype._complete = function () {
        this.hasCompleted = true;
        if (this.active === 0 && this.buffer.length === 0) {
            this.destination.complete();
        }
        this.unsubscribe();
    };
    MergeMapSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
        this.destination.next(innerValue);
    };
    MergeMapSubscriber.prototype.notifyComplete = function (innerSub) {
        var buffer = this.buffer;
        this.remove(innerSub);
        this.active--;
        if (buffer.length > 0) {
            this._next(buffer.shift());
        }
        else if (this.active === 0 && this.hasCompleted) {
            this.destination.complete();
        }
    };
    return MergeMapSubscriber;
}(OuterSubscriber_1.OuterSubscriber));
exports.MergeMapSubscriber = MergeMapSubscriber;

},{"../InnerSubscriber":92,"../OuterSubscriber":96,"../observable/from":113,"../util/subscribeToResult":285,"./map":171}],178:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var mergeMap_1 = require("./mergeMap");
function mergeMapTo(innerObservable, resultSelector, concurrent) {
    if (concurrent === void 0) { concurrent = Number.POSITIVE_INFINITY; }
    if (typeof resultSelector === 'function') {
        return mergeMap_1.mergeMap(function () { return innerObservable; }, resultSelector, concurrent);
    }
    if (typeof resultSelector === 'number') {
        concurrent = resultSelector;
    }
    return mergeMap_1.mergeMap(function () { return innerObservable; }, concurrent);
}
exports.mergeMapTo = mergeMapTo;

},{"./mergeMap":177}],179:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var subscribeToResult_1 = require("../util/subscribeToResult");
var OuterSubscriber_1 = require("../OuterSubscriber");
var InnerSubscriber_1 = require("../InnerSubscriber");
function mergeScan(accumulator, seed, concurrent) {
    if (concurrent === void 0) { concurrent = Number.POSITIVE_INFINITY; }
    return function (source) { return source.lift(new MergeScanOperator(accumulator, seed, concurrent)); };
}
exports.mergeScan = mergeScan;
var MergeScanOperator = (function () {
    function MergeScanOperator(accumulator, seed, concurrent) {
        this.accumulator = accumulator;
        this.seed = seed;
        this.concurrent = concurrent;
    }
    MergeScanOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new MergeScanSubscriber(subscriber, this.accumulator, this.seed, this.concurrent));
    };
    return MergeScanOperator;
}());
exports.MergeScanOperator = MergeScanOperator;
var MergeScanSubscriber = (function (_super) {
    __extends(MergeScanSubscriber, _super);
    function MergeScanSubscriber(destination, accumulator, acc, concurrent) {
        var _this = _super.call(this, destination) || this;
        _this.accumulator = accumulator;
        _this.acc = acc;
        _this.concurrent = concurrent;
        _this.hasValue = false;
        _this.hasCompleted = false;
        _this.buffer = [];
        _this.active = 0;
        _this.index = 0;
        return _this;
    }
    MergeScanSubscriber.prototype._next = function (value) {
        if (this.active < this.concurrent) {
            var index = this.index++;
            var destination = this.destination;
            var ish = void 0;
            try {
                var accumulator = this.accumulator;
                ish = accumulator(this.acc, value, index);
            }
            catch (e) {
                return destination.error(e);
            }
            this.active++;
            this._innerSub(ish, value, index);
        }
        else {
            this.buffer.push(value);
        }
    };
    MergeScanSubscriber.prototype._innerSub = function (ish, value, index) {
        var innerSubscriber = new InnerSubscriber_1.InnerSubscriber(this, undefined, undefined);
        var destination = this.destination;
        destination.add(innerSubscriber);
        subscribeToResult_1.subscribeToResult(this, ish, value, index, innerSubscriber);
    };
    MergeScanSubscriber.prototype._complete = function () {
        this.hasCompleted = true;
        if (this.active === 0 && this.buffer.length === 0) {
            if (this.hasValue === false) {
                this.destination.next(this.acc);
            }
            this.destination.complete();
        }
        this.unsubscribe();
    };
    MergeScanSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
        var destination = this.destination;
        this.acc = innerValue;
        this.hasValue = true;
        destination.next(innerValue);
    };
    MergeScanSubscriber.prototype.notifyComplete = function (innerSub) {
        var buffer = this.buffer;
        var destination = this.destination;
        destination.remove(innerSub);
        this.active--;
        if (buffer.length > 0) {
            this._next(buffer.shift());
        }
        else if (this.active === 0 && this.hasCompleted) {
            if (this.hasValue === false) {
                this.destination.next(this.acc);
            }
            this.destination.complete();
        }
    };
    return MergeScanSubscriber;
}(OuterSubscriber_1.OuterSubscriber));
exports.MergeScanSubscriber = MergeScanSubscriber;

},{"../InnerSubscriber":92,"../OuterSubscriber":96,"../util/subscribeToResult":285}],180:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var reduce_1 = require("./reduce");
function min(comparer) {
    var min = (typeof comparer === 'function')
        ? function (x, y) { return comparer(x, y) < 0 ? x : y; }
        : function (x, y) { return x < y ? x : y; };
    return reduce_1.reduce(min);
}
exports.min = min;

},{"./reduce":192}],181:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ConnectableObservable_1 = require("../observable/ConnectableObservable");
function multicast(subjectOrSubjectFactory, selector) {
    return function multicastOperatorFunction(source) {
        var subjectFactory;
        if (typeof subjectOrSubjectFactory === 'function') {
            subjectFactory = subjectOrSubjectFactory;
        }
        else {
            subjectFactory = function subjectFactory() {
                return subjectOrSubjectFactory;
            };
        }
        if (typeof selector === 'function') {
            return source.lift(new MulticastOperator(subjectFactory, selector));
        }
        var connectable = Object.create(source, ConnectableObservable_1.connectableObservableDescriptor);
        connectable.source = source;
        connectable.subjectFactory = subjectFactory;
        return connectable;
    };
}
exports.multicast = multicast;
var MulticastOperator = (function () {
    function MulticastOperator(subjectFactory, selector) {
        this.subjectFactory = subjectFactory;
        this.selector = selector;
    }
    MulticastOperator.prototype.call = function (subscriber, source) {
        var selector = this.selector;
        var subject = this.subjectFactory();
        var subscription = selector(subject).subscribe(subscriber);
        subscription.add(source.subscribe(subject));
        return subscription;
    };
    return MulticastOperator;
}());
exports.MulticastOperator = MulticastOperator;

},{"../observable/ConnectableObservable":104}],182:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subscriber_1 = require("../Subscriber");
var Notification_1 = require("../Notification");
function observeOn(scheduler, delay) {
    if (delay === void 0) { delay = 0; }
    return function observeOnOperatorFunction(source) {
        return source.lift(new ObserveOnOperator(scheduler, delay));
    };
}
exports.observeOn = observeOn;
var ObserveOnOperator = (function () {
    function ObserveOnOperator(scheduler, delay) {
        if (delay === void 0) { delay = 0; }
        this.scheduler = scheduler;
        this.delay = delay;
    }
    ObserveOnOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new ObserveOnSubscriber(subscriber, this.scheduler, this.delay));
    };
    return ObserveOnOperator;
}());
exports.ObserveOnOperator = ObserveOnOperator;
var ObserveOnSubscriber = (function (_super) {
    __extends(ObserveOnSubscriber, _super);
    function ObserveOnSubscriber(destination, scheduler, delay) {
        if (delay === void 0) { delay = 0; }
        var _this = _super.call(this, destination) || this;
        _this.scheduler = scheduler;
        _this.delay = delay;
        return _this;
    }
    ObserveOnSubscriber.dispatch = function (arg) {
        var notification = arg.notification, destination = arg.destination;
        notification.observe(destination);
        this.unsubscribe();
    };
    ObserveOnSubscriber.prototype.scheduleMessage = function (notification) {
        var destination = this.destination;
        destination.add(this.scheduler.schedule(ObserveOnSubscriber.dispatch, this.delay, new ObserveOnMessage(notification, this.destination)));
    };
    ObserveOnSubscriber.prototype._next = function (value) {
        this.scheduleMessage(Notification_1.Notification.createNext(value));
    };
    ObserveOnSubscriber.prototype._error = function (err) {
        this.scheduleMessage(Notification_1.Notification.createError(err));
        this.unsubscribe();
    };
    ObserveOnSubscriber.prototype._complete = function () {
        this.scheduleMessage(Notification_1.Notification.createComplete());
        this.unsubscribe();
    };
    return ObserveOnSubscriber;
}(Subscriber_1.Subscriber));
exports.ObserveOnSubscriber = ObserveOnSubscriber;
var ObserveOnMessage = (function () {
    function ObserveOnMessage(notification, destination) {
        this.notification = notification;
        this.destination = destination;
    }
    return ObserveOnMessage;
}());
exports.ObserveOnMessage = ObserveOnMessage;

},{"../Notification":93,"../Subscriber":101}],183:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var from_1 = require("../observable/from");
var isArray_1 = require("../util/isArray");
var OuterSubscriber_1 = require("../OuterSubscriber");
var InnerSubscriber_1 = require("../InnerSubscriber");
var subscribeToResult_1 = require("../util/subscribeToResult");
function onErrorResumeNext() {
    var nextSources = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        nextSources[_i] = arguments[_i];
    }
    if (nextSources.length === 1 && isArray_1.isArray(nextSources[0])) {
        nextSources = nextSources[0];
    }
    return function (source) { return source.lift(new OnErrorResumeNextOperator(nextSources)); };
}
exports.onErrorResumeNext = onErrorResumeNext;
function onErrorResumeNextStatic() {
    var nextSources = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        nextSources[_i] = arguments[_i];
    }
    var source = null;
    if (nextSources.length === 1 && isArray_1.isArray(nextSources[0])) {
        nextSources = nextSources[0];
    }
    source = nextSources.shift();
    return from_1.from(source, null).lift(new OnErrorResumeNextOperator(nextSources));
}
exports.onErrorResumeNextStatic = onErrorResumeNextStatic;
var OnErrorResumeNextOperator = (function () {
    function OnErrorResumeNextOperator(nextSources) {
        this.nextSources = nextSources;
    }
    OnErrorResumeNextOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new OnErrorResumeNextSubscriber(subscriber, this.nextSources));
    };
    return OnErrorResumeNextOperator;
}());
var OnErrorResumeNextSubscriber = (function (_super) {
    __extends(OnErrorResumeNextSubscriber, _super);
    function OnErrorResumeNextSubscriber(destination, nextSources) {
        var _this = _super.call(this, destination) || this;
        _this.destination = destination;
        _this.nextSources = nextSources;
        return _this;
    }
    OnErrorResumeNextSubscriber.prototype.notifyError = function (error, innerSub) {
        this.subscribeToNextSource();
    };
    OnErrorResumeNextSubscriber.prototype.notifyComplete = function (innerSub) {
        this.subscribeToNextSource();
    };
    OnErrorResumeNextSubscriber.prototype._error = function (err) {
        this.subscribeToNextSource();
        this.unsubscribe();
    };
    OnErrorResumeNextSubscriber.prototype._complete = function () {
        this.subscribeToNextSource();
        this.unsubscribe();
    };
    OnErrorResumeNextSubscriber.prototype.subscribeToNextSource = function () {
        var next = this.nextSources.shift();
        if (!!next) {
            var innerSubscriber = new InnerSubscriber_1.InnerSubscriber(this, undefined, undefined);
            var destination = this.destination;
            destination.add(innerSubscriber);
            subscribeToResult_1.subscribeToResult(this, next, undefined, undefined, innerSubscriber);
        }
        else {
            this.destination.complete();
        }
    };
    return OnErrorResumeNextSubscriber;
}(OuterSubscriber_1.OuterSubscriber));

},{"../InnerSubscriber":92,"../OuterSubscriber":96,"../observable/from":113,"../util/isArray":266,"../util/subscribeToResult":285}],184:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subscriber_1 = require("../Subscriber");
function pairwise() {
    return function (source) { return source.lift(new PairwiseOperator()); };
}
exports.pairwise = pairwise;
var PairwiseOperator = (function () {
    function PairwiseOperator() {
    }
    PairwiseOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new PairwiseSubscriber(subscriber));
    };
    return PairwiseOperator;
}());
var PairwiseSubscriber = (function (_super) {
    __extends(PairwiseSubscriber, _super);
    function PairwiseSubscriber(destination) {
        var _this = _super.call(this, destination) || this;
        _this.hasPrev = false;
        return _this;
    }
    PairwiseSubscriber.prototype._next = function (value) {
        var pair;
        if (this.hasPrev) {
            pair = [this.prev, value];
        }
        else {
            this.hasPrev = true;
        }
        this.prev = value;
        if (pair) {
            this.destination.next(pair);
        }
    };
    return PairwiseSubscriber;
}(Subscriber_1.Subscriber));

},{"../Subscriber":101}],185:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var not_1 = require("../util/not");
var filter_1 = require("./filter");
function partition(predicate, thisArg) {
    return function (source) { return [
        filter_1.filter(predicate, thisArg)(source),
        filter_1.filter(not_1.not(predicate, thisArg))(source)
    ]; };
}
exports.partition = partition;

},{"../util/not":278,"./filter":162}],186:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var map_1 = require("./map");
function pluck() {
    var properties = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        properties[_i] = arguments[_i];
    }
    var length = properties.length;
    if (length === 0) {
        throw new Error('list of properties cannot be empty.');
    }
    return function (source) { return map_1.map(plucker(properties, length))(source); };
}
exports.pluck = pluck;
function plucker(props, length) {
    var mapper = function (x) {
        var currentProp = x;
        for (var i = 0; i < length; i++) {
            var p = currentProp[props[i]];
            if (typeof p !== 'undefined') {
                currentProp = p;
            }
            else {
                return undefined;
            }
        }
        return currentProp;
    };
    return mapper;
}

},{"./map":171}],187:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Subject_1 = require("../Subject");
var multicast_1 = require("./multicast");
function publish(selector) {
    return selector ?
        multicast_1.multicast(function () { return new Subject_1.Subject(); }, selector) :
        multicast_1.multicast(new Subject_1.Subject());
}
exports.publish = publish;

},{"../Subject":99,"./multicast":181}],188:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var BehaviorSubject_1 = require("../BehaviorSubject");
var multicast_1 = require("./multicast");
function publishBehavior(value) {
    return function (source) { return multicast_1.multicast(new BehaviorSubject_1.BehaviorSubject(value))(source); };
}
exports.publishBehavior = publishBehavior;

},{"../BehaviorSubject":91,"./multicast":181}],189:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var AsyncSubject_1 = require("../AsyncSubject");
var multicast_1 = require("./multicast");
function publishLast() {
    return function (source) { return multicast_1.multicast(new AsyncSubject_1.AsyncSubject())(source); };
}
exports.publishLast = publishLast;

},{"../AsyncSubject":90,"./multicast":181}],190:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ReplaySubject_1 = require("../ReplaySubject");
var multicast_1 = require("./multicast");
function publishReplay(bufferSize, windowTime, selectorOrScheduler, scheduler) {
    if (selectorOrScheduler && typeof selectorOrScheduler !== 'function') {
        scheduler = selectorOrScheduler;
    }
    var selector = typeof selectorOrScheduler === 'function' ? selectorOrScheduler : undefined;
    var subject = new ReplaySubject_1.ReplaySubject(bufferSize, windowTime, scheduler);
    return function (source) { return multicast_1.multicast(function () { return subject; }, selector)(source); };
}
exports.publishReplay = publishReplay;

},{"../ReplaySubject":97,"./multicast":181}],191:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var isArray_1 = require("../util/isArray");
var race_1 = require("../observable/race");
function race() {
    var observables = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        observables[_i] = arguments[_i];
    }
    return function raceOperatorFunction(source) {
        if (observables.length === 1 && isArray_1.isArray(observables[0])) {
            observables = observables[0];
        }
        return source.lift.call(race_1.race.apply(void 0, [source].concat(observables)));
    };
}
exports.race = race;

},{"../observable/race":126,"../util/isArray":266}],192:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var scan_1 = require("./scan");
var takeLast_1 = require("./takeLast");
var defaultIfEmpty_1 = require("./defaultIfEmpty");
var pipe_1 = require("../util/pipe");
function reduce(accumulator, seed) {
    if (arguments.length >= 2) {
        return function reduceOperatorFunctionWithSeed(source) {
            return pipe_1.pipe(scan_1.scan(accumulator, seed), takeLast_1.takeLast(1), defaultIfEmpty_1.defaultIfEmpty(seed))(source);
        };
    }
    return function reduceOperatorFunction(source) {
        return pipe_1.pipe(scan_1.scan(function (acc, value, index) { return accumulator(acc, value, index + 1); }), takeLast_1.takeLast(1))(source);
    };
}
exports.reduce = reduce;

},{"../util/pipe":279,"./defaultIfEmpty":149,"./scan":200,"./takeLast":215}],193:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subscriber_1 = require("../Subscriber");
function refCount() {
    return function refCountOperatorFunction(source) {
        return source.lift(new RefCountOperator(source));
    };
}
exports.refCount = refCount;
var RefCountOperator = (function () {
    function RefCountOperator(connectable) {
        this.connectable = connectable;
    }
    RefCountOperator.prototype.call = function (subscriber, source) {
        var connectable = this.connectable;
        connectable._refCount++;
        var refCounter = new RefCountSubscriber(subscriber, connectable);
        var subscription = source.subscribe(refCounter);
        if (!refCounter.closed) {
            refCounter.connection = connectable.connect();
        }
        return subscription;
    };
    return RefCountOperator;
}());
var RefCountSubscriber = (function (_super) {
    __extends(RefCountSubscriber, _super);
    function RefCountSubscriber(destination, connectable) {
        var _this = _super.call(this, destination) || this;
        _this.connectable = connectable;
        return _this;
    }
    RefCountSubscriber.prototype._unsubscribe = function () {
        var connectable = this.connectable;
        if (!connectable) {
            this.connection = null;
            return;
        }
        this.connectable = null;
        var refCount = connectable._refCount;
        if (refCount <= 0) {
            this.connection = null;
            return;
        }
        connectable._refCount = refCount - 1;
        if (refCount > 1) {
            this.connection = null;
            return;
        }
        var connection = this.connection;
        var sharedConnection = connectable._connection;
        this.connection = null;
        if (sharedConnection && (!connection || sharedConnection === connection)) {
            sharedConnection.unsubscribe();
        }
    };
    return RefCountSubscriber;
}(Subscriber_1.Subscriber));

},{"../Subscriber":101}],194:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subscriber_1 = require("../Subscriber");
var empty_1 = require("../observable/empty");
function repeat(count) {
    if (count === void 0) { count = -1; }
    return function (source) {
        if (count === 0) {
            return empty_1.empty();
        }
        else if (count < 0) {
            return source.lift(new RepeatOperator(-1, source));
        }
        else {
            return source.lift(new RepeatOperator(count - 1, source));
        }
    };
}
exports.repeat = repeat;
var RepeatOperator = (function () {
    function RepeatOperator(count, source) {
        this.count = count;
        this.source = source;
    }
    RepeatOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new RepeatSubscriber(subscriber, this.count, this.source));
    };
    return RepeatOperator;
}());
var RepeatSubscriber = (function (_super) {
    __extends(RepeatSubscriber, _super);
    function RepeatSubscriber(destination, count, source) {
        var _this = _super.call(this, destination) || this;
        _this.count = count;
        _this.source = source;
        return _this;
    }
    RepeatSubscriber.prototype.complete = function () {
        if (!this.isStopped) {
            var _a = this, source = _a.source, count = _a.count;
            if (count === 0) {
                return _super.prototype.complete.call(this);
            }
            else if (count > -1) {
                this.count = count - 1;
            }
            source.subscribe(this._unsubscribeAndRecycle());
        }
    };
    return RepeatSubscriber;
}(Subscriber_1.Subscriber));

},{"../Subscriber":101,"../observable/empty":111}],195:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subject_1 = require("../Subject");
var OuterSubscriber_1 = require("../OuterSubscriber");
var subscribeToResult_1 = require("../util/subscribeToResult");
function repeatWhen(notifier) {
    return function (source) { return source.lift(new RepeatWhenOperator(notifier)); };
}
exports.repeatWhen = repeatWhen;
var RepeatWhenOperator = (function () {
    function RepeatWhenOperator(notifier) {
        this.notifier = notifier;
    }
    RepeatWhenOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new RepeatWhenSubscriber(subscriber, this.notifier, source));
    };
    return RepeatWhenOperator;
}());
var RepeatWhenSubscriber = (function (_super) {
    __extends(RepeatWhenSubscriber, _super);
    function RepeatWhenSubscriber(destination, notifier, source) {
        var _this = _super.call(this, destination) || this;
        _this.notifier = notifier;
        _this.source = source;
        _this.sourceIsBeingSubscribedTo = true;
        return _this;
    }
    RepeatWhenSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
        this.sourceIsBeingSubscribedTo = true;
        this.source.subscribe(this);
    };
    RepeatWhenSubscriber.prototype.notifyComplete = function (innerSub) {
        if (this.sourceIsBeingSubscribedTo === false) {
            return _super.prototype.complete.call(this);
        }
    };
    RepeatWhenSubscriber.prototype.complete = function () {
        this.sourceIsBeingSubscribedTo = false;
        if (!this.isStopped) {
            if (!this.retries) {
                this.subscribeToRetries();
            }
            if (!this.retriesSubscription || this.retriesSubscription.closed) {
                return _super.prototype.complete.call(this);
            }
            this._unsubscribeAndRecycle();
            this.notifications.next();
        }
    };
    RepeatWhenSubscriber.prototype._unsubscribe = function () {
        var _a = this, notifications = _a.notifications, retriesSubscription = _a.retriesSubscription;
        if (notifications) {
            notifications.unsubscribe();
            this.notifications = null;
        }
        if (retriesSubscription) {
            retriesSubscription.unsubscribe();
            this.retriesSubscription = null;
        }
        this.retries = null;
    };
    RepeatWhenSubscriber.prototype._unsubscribeAndRecycle = function () {
        var _unsubscribe = this._unsubscribe;
        this._unsubscribe = null;
        _super.prototype._unsubscribeAndRecycle.call(this);
        this._unsubscribe = _unsubscribe;
        return this;
    };
    RepeatWhenSubscriber.prototype.subscribeToRetries = function () {
        this.notifications = new Subject_1.Subject();
        var retries;
        try {
            var notifier = this.notifier;
            retries = notifier(this.notifications);
        }
        catch (e) {
            return _super.prototype.complete.call(this);
        }
        this.retries = retries;
        this.retriesSubscription = subscribeToResult_1.subscribeToResult(this, retries);
    };
    return RepeatWhenSubscriber;
}(OuterSubscriber_1.OuterSubscriber));

},{"../OuterSubscriber":96,"../Subject":99,"../util/subscribeToResult":285}],196:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subscriber_1 = require("../Subscriber");
function retry(count) {
    if (count === void 0) { count = -1; }
    return function (source) { return source.lift(new RetryOperator(count, source)); };
}
exports.retry = retry;
var RetryOperator = (function () {
    function RetryOperator(count, source) {
        this.count = count;
        this.source = source;
    }
    RetryOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new RetrySubscriber(subscriber, this.count, this.source));
    };
    return RetryOperator;
}());
var RetrySubscriber = (function (_super) {
    __extends(RetrySubscriber, _super);
    function RetrySubscriber(destination, count, source) {
        var _this = _super.call(this, destination) || this;
        _this.count = count;
        _this.source = source;
        return _this;
    }
    RetrySubscriber.prototype.error = function (err) {
        if (!this.isStopped) {
            var _a = this, source = _a.source, count = _a.count;
            if (count === 0) {
                return _super.prototype.error.call(this, err);
            }
            else if (count > -1) {
                this.count = count - 1;
            }
            source.subscribe(this._unsubscribeAndRecycle());
        }
    };
    return RetrySubscriber;
}(Subscriber_1.Subscriber));

},{"../Subscriber":101}],197:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subject_1 = require("../Subject");
var OuterSubscriber_1 = require("../OuterSubscriber");
var subscribeToResult_1 = require("../util/subscribeToResult");
function retryWhen(notifier) {
    return function (source) { return source.lift(new RetryWhenOperator(notifier, source)); };
}
exports.retryWhen = retryWhen;
var RetryWhenOperator = (function () {
    function RetryWhenOperator(notifier, source) {
        this.notifier = notifier;
        this.source = source;
    }
    RetryWhenOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new RetryWhenSubscriber(subscriber, this.notifier, this.source));
    };
    return RetryWhenOperator;
}());
var RetryWhenSubscriber = (function (_super) {
    __extends(RetryWhenSubscriber, _super);
    function RetryWhenSubscriber(destination, notifier, source) {
        var _this = _super.call(this, destination) || this;
        _this.notifier = notifier;
        _this.source = source;
        return _this;
    }
    RetryWhenSubscriber.prototype.error = function (err) {
        if (!this.isStopped) {
            var errors = this.errors;
            var retries = this.retries;
            var retriesSubscription = this.retriesSubscription;
            if (!retries) {
                errors = new Subject_1.Subject();
                try {
                    var notifier = this.notifier;
                    retries = notifier(errors);
                }
                catch (e) {
                    return _super.prototype.error.call(this, e);
                }
                retriesSubscription = subscribeToResult_1.subscribeToResult(this, retries);
            }
            else {
                this.errors = null;
                this.retriesSubscription = null;
            }
            this._unsubscribeAndRecycle();
            this.errors = errors;
            this.retries = retries;
            this.retriesSubscription = retriesSubscription;
            errors.next(err);
        }
    };
    RetryWhenSubscriber.prototype._unsubscribe = function () {
        var _a = this, errors = _a.errors, retriesSubscription = _a.retriesSubscription;
        if (errors) {
            errors.unsubscribe();
            this.errors = null;
        }
        if (retriesSubscription) {
            retriesSubscription.unsubscribe();
            this.retriesSubscription = null;
        }
        this.retries = null;
    };
    RetryWhenSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
        var _unsubscribe = this._unsubscribe;
        this._unsubscribe = null;
        this._unsubscribeAndRecycle();
        this._unsubscribe = _unsubscribe;
        this.source.subscribe(this);
    };
    return RetryWhenSubscriber;
}(OuterSubscriber_1.OuterSubscriber));

},{"../OuterSubscriber":96,"../Subject":99,"../util/subscribeToResult":285}],198:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var OuterSubscriber_1 = require("../OuterSubscriber");
var subscribeToResult_1 = require("../util/subscribeToResult");
function sample(notifier) {
    return function (source) { return source.lift(new SampleOperator(notifier)); };
}
exports.sample = sample;
var SampleOperator = (function () {
    function SampleOperator(notifier) {
        this.notifier = notifier;
    }
    SampleOperator.prototype.call = function (subscriber, source) {
        var sampleSubscriber = new SampleSubscriber(subscriber);
        var subscription = source.subscribe(sampleSubscriber);
        subscription.add(subscribeToResult_1.subscribeToResult(sampleSubscriber, this.notifier));
        return subscription;
    };
    return SampleOperator;
}());
var SampleSubscriber = (function (_super) {
    __extends(SampleSubscriber, _super);
    function SampleSubscriber() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.hasValue = false;
        return _this;
    }
    SampleSubscriber.prototype._next = function (value) {
        this.value = value;
        this.hasValue = true;
    };
    SampleSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
        this.emitValue();
    };
    SampleSubscriber.prototype.notifyComplete = function () {
        this.emitValue();
    };
    SampleSubscriber.prototype.emitValue = function () {
        if (this.hasValue) {
            this.hasValue = false;
            this.destination.next(this.value);
        }
    };
    return SampleSubscriber;
}(OuterSubscriber_1.OuterSubscriber));

},{"../OuterSubscriber":96,"../util/subscribeToResult":285}],199:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subscriber_1 = require("../Subscriber");
var async_1 = require("../scheduler/async");
function sampleTime(period, scheduler) {
    if (scheduler === void 0) { scheduler = async_1.async; }
    return function (source) { return source.lift(new SampleTimeOperator(period, scheduler)); };
}
exports.sampleTime = sampleTime;
var SampleTimeOperator = (function () {
    function SampleTimeOperator(period, scheduler) {
        this.period = period;
        this.scheduler = scheduler;
    }
    SampleTimeOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new SampleTimeSubscriber(subscriber, this.period, this.scheduler));
    };
    return SampleTimeOperator;
}());
var SampleTimeSubscriber = (function (_super) {
    __extends(SampleTimeSubscriber, _super);
    function SampleTimeSubscriber(destination, period, scheduler) {
        var _this = _super.call(this, destination) || this;
        _this.period = period;
        _this.scheduler = scheduler;
        _this.hasValue = false;
        _this.add(scheduler.schedule(dispatchNotification, period, { subscriber: _this, period: period }));
        return _this;
    }
    SampleTimeSubscriber.prototype._next = function (value) {
        this.lastValue = value;
        this.hasValue = true;
    };
    SampleTimeSubscriber.prototype.notifyNext = function () {
        if (this.hasValue) {
            this.hasValue = false;
            this.destination.next(this.lastValue);
        }
    };
    return SampleTimeSubscriber;
}(Subscriber_1.Subscriber));
function dispatchNotification(state) {
    var subscriber = state.subscriber, period = state.period;
    subscriber.notifyNext();
    this.schedule(state, period);
}

},{"../Subscriber":101,"../scheduler/async":252}],200:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subscriber_1 = require("../Subscriber");
function scan(accumulator, seed) {
    var hasSeed = false;
    if (arguments.length >= 2) {
        hasSeed = true;
    }
    return function scanOperatorFunction(source) {
        return source.lift(new ScanOperator(accumulator, seed, hasSeed));
    };
}
exports.scan = scan;
var ScanOperator = (function () {
    function ScanOperator(accumulator, seed, hasSeed) {
        if (hasSeed === void 0) { hasSeed = false; }
        this.accumulator = accumulator;
        this.seed = seed;
        this.hasSeed = hasSeed;
    }
    ScanOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new ScanSubscriber(subscriber, this.accumulator, this.seed, this.hasSeed));
    };
    return ScanOperator;
}());
var ScanSubscriber = (function (_super) {
    __extends(ScanSubscriber, _super);
    function ScanSubscriber(destination, accumulator, _seed, hasSeed) {
        var _this = _super.call(this, destination) || this;
        _this.accumulator = accumulator;
        _this._seed = _seed;
        _this.hasSeed = hasSeed;
        _this.index = 0;
        return _this;
    }
    Object.defineProperty(ScanSubscriber.prototype, "seed", {
        get: function () {
            return this._seed;
        },
        set: function (value) {
            this.hasSeed = true;
            this._seed = value;
        },
        enumerable: true,
        configurable: true
    });
    ScanSubscriber.prototype._next = function (value) {
        if (!this.hasSeed) {
            this.seed = value;
            this.destination.next(value);
        }
        else {
            return this._tryNext(value);
        }
    };
    ScanSubscriber.prototype._tryNext = function (value) {
        var index = this.index++;
        var result;
        try {
            result = this.accumulator(this.seed, value, index);
        }
        catch (err) {
            this.destination.error(err);
        }
        this.seed = result;
        this.destination.next(result);
    };
    return ScanSubscriber;
}(Subscriber_1.Subscriber));

},{"../Subscriber":101}],201:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subscriber_1 = require("../Subscriber");
function sequenceEqual(compareTo, comparator) {
    return function (source) { return source.lift(new SequenceEqualOperator(compareTo, comparator)); };
}
exports.sequenceEqual = sequenceEqual;
var SequenceEqualOperator = (function () {
    function SequenceEqualOperator(compareTo, comparator) {
        this.compareTo = compareTo;
        this.comparator = comparator;
    }
    SequenceEqualOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new SequenceEqualSubscriber(subscriber, this.compareTo, this.comparator));
    };
    return SequenceEqualOperator;
}());
exports.SequenceEqualOperator = SequenceEqualOperator;
var SequenceEqualSubscriber = (function (_super) {
    __extends(SequenceEqualSubscriber, _super);
    function SequenceEqualSubscriber(destination, compareTo, comparator) {
        var _this = _super.call(this, destination) || this;
        _this.compareTo = compareTo;
        _this.comparator = comparator;
        _this._a = [];
        _this._b = [];
        _this._oneComplete = false;
        _this.destination.add(compareTo.subscribe(new SequenceEqualCompareToSubscriber(destination, _this)));
        return _this;
    }
    SequenceEqualSubscriber.prototype._next = function (value) {
        if (this._oneComplete && this._b.length === 0) {
            this.emit(false);
        }
        else {
            this._a.push(value);
            this.checkValues();
        }
    };
    SequenceEqualSubscriber.prototype._complete = function () {
        if (this._oneComplete) {
            this.emit(this._a.length === 0 && this._b.length === 0);
        }
        else {
            this._oneComplete = true;
        }
        this.unsubscribe();
    };
    SequenceEqualSubscriber.prototype.checkValues = function () {
        var _c = this, _a = _c._a, _b = _c._b, comparator = _c.comparator;
        while (_a.length > 0 && _b.length > 0) {
            var a = _a.shift();
            var b = _b.shift();
            var areEqual = false;
            try {
                areEqual = comparator ? comparator(a, b) : a === b;
            }
            catch (e) {
                this.destination.error(e);
            }
            if (!areEqual) {
                this.emit(false);
            }
        }
    };
    SequenceEqualSubscriber.prototype.emit = function (value) {
        var destination = this.destination;
        destination.next(value);
        destination.complete();
    };
    SequenceEqualSubscriber.prototype.nextB = function (value) {
        if (this._oneComplete && this._a.length === 0) {
            this.emit(false);
        }
        else {
            this._b.push(value);
            this.checkValues();
        }
    };
    SequenceEqualSubscriber.prototype.completeB = function () {
        if (this._oneComplete) {
            this.emit(this._a.length === 0 && this._b.length === 0);
        }
        else {
            this._oneComplete = true;
        }
    };
    return SequenceEqualSubscriber;
}(Subscriber_1.Subscriber));
exports.SequenceEqualSubscriber = SequenceEqualSubscriber;
var SequenceEqualCompareToSubscriber = (function (_super) {
    __extends(SequenceEqualCompareToSubscriber, _super);
    function SequenceEqualCompareToSubscriber(destination, parent) {
        var _this = _super.call(this, destination) || this;
        _this.parent = parent;
        return _this;
    }
    SequenceEqualCompareToSubscriber.prototype._next = function (value) {
        this.parent.nextB(value);
    };
    SequenceEqualCompareToSubscriber.prototype._error = function (err) {
        this.parent.error(err);
        this.unsubscribe();
    };
    SequenceEqualCompareToSubscriber.prototype._complete = function () {
        this.parent.completeB();
        this.unsubscribe();
    };
    return SequenceEqualCompareToSubscriber;
}(Subscriber_1.Subscriber));

},{"../Subscriber":101}],202:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var multicast_1 = require("./multicast");
var refCount_1 = require("./refCount");
var Subject_1 = require("../Subject");
function shareSubjectFactory() {
    return new Subject_1.Subject();
}
function share() {
    return function (source) { return refCount_1.refCount()(multicast_1.multicast(shareSubjectFactory)(source)); };
}
exports.share = share;

},{"../Subject":99,"./multicast":181,"./refCount":193}],203:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ReplaySubject_1 = require("../ReplaySubject");
function shareReplay(configOrBufferSize, windowTime, scheduler) {
    var config;
    if (configOrBufferSize && typeof configOrBufferSize === 'object') {
        config = configOrBufferSize;
    }
    else {
        config = {
            bufferSize: configOrBufferSize,
            windowTime: windowTime,
            refCount: false,
            scheduler: scheduler
        };
    }
    return function (source) { return source.lift(shareReplayOperator(config)); };
}
exports.shareReplay = shareReplay;
function shareReplayOperator(_a) {
    var _b = _a.bufferSize, bufferSize = _b === void 0 ? Number.POSITIVE_INFINITY : _b, _c = _a.windowTime, windowTime = _c === void 0 ? Number.POSITIVE_INFINITY : _c, useRefCount = _a.refCount, scheduler = _a.scheduler;
    var subject;
    var refCount = 0;
    var subscription;
    var hasError = false;
    var isComplete = false;
    return function shareReplayOperation(source) {
        refCount++;
        if (!subject || hasError) {
            hasError = false;
            subject = new ReplaySubject_1.ReplaySubject(bufferSize, windowTime, scheduler);
            subscription = source.subscribe({
                next: function (value) { subject.next(value); },
                error: function (err) {
                    hasError = true;
                    subject.error(err);
                },
                complete: function () {
                    isComplete = true;
                    subject.complete();
                },
            });
        }
        var innerSub = subject.subscribe(this);
        this.add(function () {
            refCount--;
            innerSub.unsubscribe();
            if (subscription && !isComplete && useRefCount && refCount === 0) {
                subscription.unsubscribe();
                subscription = undefined;
                subject = undefined;
            }
        });
    };
}

},{"../ReplaySubject":97}],204:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subscriber_1 = require("../Subscriber");
var EmptyError_1 = require("../util/EmptyError");
function single(predicate) {
    return function (source) { return source.lift(new SingleOperator(predicate, source)); };
}
exports.single = single;
var SingleOperator = (function () {
    function SingleOperator(predicate, source) {
        this.predicate = predicate;
        this.source = source;
    }
    SingleOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new SingleSubscriber(subscriber, this.predicate, this.source));
    };
    return SingleOperator;
}());
var SingleSubscriber = (function (_super) {
    __extends(SingleSubscriber, _super);
    function SingleSubscriber(destination, predicate, source) {
        var _this = _super.call(this, destination) || this;
        _this.predicate = predicate;
        _this.source = source;
        _this.seenValue = false;
        _this.index = 0;
        return _this;
    }
    SingleSubscriber.prototype.applySingleValue = function (value) {
        if (this.seenValue) {
            this.destination.error('Sequence contains more than one element');
        }
        else {
            this.seenValue = true;
            this.singleValue = value;
        }
    };
    SingleSubscriber.prototype._next = function (value) {
        var index = this.index++;
        if (this.predicate) {
            this.tryNext(value, index);
        }
        else {
            this.applySingleValue(value);
        }
    };
    SingleSubscriber.prototype.tryNext = function (value, index) {
        try {
            if (this.predicate(value, index, this.source)) {
                this.applySingleValue(value);
            }
        }
        catch (err) {
            this.destination.error(err);
        }
    };
    SingleSubscriber.prototype._complete = function () {
        var destination = this.destination;
        if (this.index > 0) {
            destination.next(this.seenValue ? this.singleValue : undefined);
            destination.complete();
        }
        else {
            destination.error(new EmptyError_1.EmptyError);
        }
    };
    return SingleSubscriber;
}(Subscriber_1.Subscriber));

},{"../Subscriber":101,"../util/EmptyError":258}],205:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subscriber_1 = require("../Subscriber");
function skip(count) {
    return function (source) { return source.lift(new SkipOperator(count)); };
}
exports.skip = skip;
var SkipOperator = (function () {
    function SkipOperator(total) {
        this.total = total;
    }
    SkipOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new SkipSubscriber(subscriber, this.total));
    };
    return SkipOperator;
}());
var SkipSubscriber = (function (_super) {
    __extends(SkipSubscriber, _super);
    function SkipSubscriber(destination, total) {
        var _this = _super.call(this, destination) || this;
        _this.total = total;
        _this.count = 0;
        return _this;
    }
    SkipSubscriber.prototype._next = function (x) {
        if (++this.count > this.total) {
            this.destination.next(x);
        }
    };
    return SkipSubscriber;
}(Subscriber_1.Subscriber));

},{"../Subscriber":101}],206:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subscriber_1 = require("../Subscriber");
var ArgumentOutOfRangeError_1 = require("../util/ArgumentOutOfRangeError");
function skipLast(count) {
    return function (source) { return source.lift(new SkipLastOperator(count)); };
}
exports.skipLast = skipLast;
var SkipLastOperator = (function () {
    function SkipLastOperator(_skipCount) {
        this._skipCount = _skipCount;
        if (this._skipCount < 0) {
            throw new ArgumentOutOfRangeError_1.ArgumentOutOfRangeError;
        }
    }
    SkipLastOperator.prototype.call = function (subscriber, source) {
        if (this._skipCount === 0) {
            return source.subscribe(new Subscriber_1.Subscriber(subscriber));
        }
        else {
            return source.subscribe(new SkipLastSubscriber(subscriber, this._skipCount));
        }
    };
    return SkipLastOperator;
}());
var SkipLastSubscriber = (function (_super) {
    __extends(SkipLastSubscriber, _super);
    function SkipLastSubscriber(destination, _skipCount) {
        var _this = _super.call(this, destination) || this;
        _this._skipCount = _skipCount;
        _this._count = 0;
        _this._ring = new Array(_skipCount);
        return _this;
    }
    SkipLastSubscriber.prototype._next = function (value) {
        var skipCount = this._skipCount;
        var count = this._count++;
        if (count < skipCount) {
            this._ring[count] = value;
        }
        else {
            var currentIndex = count % skipCount;
            var ring = this._ring;
            var oldValue = ring[currentIndex];
            ring[currentIndex] = value;
            this.destination.next(oldValue);
        }
    };
    return SkipLastSubscriber;
}(Subscriber_1.Subscriber));

},{"../Subscriber":101,"../util/ArgumentOutOfRangeError":257}],207:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var OuterSubscriber_1 = require("../OuterSubscriber");
var InnerSubscriber_1 = require("../InnerSubscriber");
var subscribeToResult_1 = require("../util/subscribeToResult");
function skipUntil(notifier) {
    return function (source) { return source.lift(new SkipUntilOperator(notifier)); };
}
exports.skipUntil = skipUntil;
var SkipUntilOperator = (function () {
    function SkipUntilOperator(notifier) {
        this.notifier = notifier;
    }
    SkipUntilOperator.prototype.call = function (destination, source) {
        return source.subscribe(new SkipUntilSubscriber(destination, this.notifier));
    };
    return SkipUntilOperator;
}());
var SkipUntilSubscriber = (function (_super) {
    __extends(SkipUntilSubscriber, _super);
    function SkipUntilSubscriber(destination, notifier) {
        var _this = _super.call(this, destination) || this;
        _this.hasValue = false;
        var innerSubscriber = new InnerSubscriber_1.InnerSubscriber(_this, undefined, undefined);
        _this.add(innerSubscriber);
        _this.innerSubscription = innerSubscriber;
        subscribeToResult_1.subscribeToResult(_this, notifier, undefined, undefined, innerSubscriber);
        return _this;
    }
    SkipUntilSubscriber.prototype._next = function (value) {
        if (this.hasValue) {
            _super.prototype._next.call(this, value);
        }
    };
    SkipUntilSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
        this.hasValue = true;
        if (this.innerSubscription) {
            this.innerSubscription.unsubscribe();
        }
    };
    SkipUntilSubscriber.prototype.notifyComplete = function () {
    };
    return SkipUntilSubscriber;
}(OuterSubscriber_1.OuterSubscriber));

},{"../InnerSubscriber":92,"../OuterSubscriber":96,"../util/subscribeToResult":285}],208:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subscriber_1 = require("../Subscriber");
function skipWhile(predicate) {
    return function (source) { return source.lift(new SkipWhileOperator(predicate)); };
}
exports.skipWhile = skipWhile;
var SkipWhileOperator = (function () {
    function SkipWhileOperator(predicate) {
        this.predicate = predicate;
    }
    SkipWhileOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new SkipWhileSubscriber(subscriber, this.predicate));
    };
    return SkipWhileOperator;
}());
var SkipWhileSubscriber = (function (_super) {
    __extends(SkipWhileSubscriber, _super);
    function SkipWhileSubscriber(destination, predicate) {
        var _this = _super.call(this, destination) || this;
        _this.predicate = predicate;
        _this.skipping = true;
        _this.index = 0;
        return _this;
    }
    SkipWhileSubscriber.prototype._next = function (value) {
        var destination = this.destination;
        if (this.skipping) {
            this.tryCallPredicate(value);
        }
        if (!this.skipping) {
            destination.next(value);
        }
    };
    SkipWhileSubscriber.prototype.tryCallPredicate = function (value) {
        try {
            var result = this.predicate(value, this.index++);
            this.skipping = Boolean(result);
        }
        catch (err) {
            this.destination.error(err);
        }
    };
    return SkipWhileSubscriber;
}(Subscriber_1.Subscriber));

},{"../Subscriber":101}],209:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var concat_1 = require("../observable/concat");
var isScheduler_1 = require("../util/isScheduler");
function startWith() {
    var array = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        array[_i] = arguments[_i];
    }
    var scheduler = array[array.length - 1];
    if (isScheduler_1.isScheduler(scheduler)) {
        array.pop();
        return function (source) { return concat_1.concat(array, source, scheduler); };
    }
    else {
        return function (source) { return concat_1.concat(array, source); };
    }
}
exports.startWith = startWith;

},{"../observable/concat":109,"../util/isScheduler":276}],210:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var SubscribeOnObservable_1 = require("../observable/SubscribeOnObservable");
function subscribeOn(scheduler, delay) {
    if (delay === void 0) { delay = 0; }
    return function subscribeOnOperatorFunction(source) {
        return source.lift(new SubscribeOnOperator(scheduler, delay));
    };
}
exports.subscribeOn = subscribeOn;
var SubscribeOnOperator = (function () {
    function SubscribeOnOperator(scheduler, delay) {
        this.scheduler = scheduler;
        this.delay = delay;
    }
    SubscribeOnOperator.prototype.call = function (subscriber, source) {
        return new SubscribeOnObservable_1.SubscribeOnObservable(source, this.delay, this.scheduler).subscribe(subscriber);
    };
    return SubscribeOnOperator;
}());

},{"../observable/SubscribeOnObservable":105}],211:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var switchMap_1 = require("./switchMap");
var identity_1 = require("../util/identity");
function switchAll() {
    return switchMap_1.switchMap(identity_1.identity);
}
exports.switchAll = switchAll;

},{"../util/identity":265,"./switchMap":212}],212:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var OuterSubscriber_1 = require("../OuterSubscriber");
var InnerSubscriber_1 = require("../InnerSubscriber");
var subscribeToResult_1 = require("../util/subscribeToResult");
var map_1 = require("./map");
var from_1 = require("../observable/from");
function switchMap(project, resultSelector) {
    if (typeof resultSelector === 'function') {
        return function (source) { return source.pipe(switchMap(function (a, i) { return from_1.from(project(a, i)).pipe(map_1.map(function (b, ii) { return resultSelector(a, b, i, ii); })); })); };
    }
    return function (source) { return source.lift(new SwitchMapOperator(project)); };
}
exports.switchMap = switchMap;
var SwitchMapOperator = (function () {
    function SwitchMapOperator(project) {
        this.project = project;
    }
    SwitchMapOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new SwitchMapSubscriber(subscriber, this.project));
    };
    return SwitchMapOperator;
}());
var SwitchMapSubscriber = (function (_super) {
    __extends(SwitchMapSubscriber, _super);
    function SwitchMapSubscriber(destination, project) {
        var _this = _super.call(this, destination) || this;
        _this.project = project;
        _this.index = 0;
        return _this;
    }
    SwitchMapSubscriber.prototype._next = function (value) {
        var result;
        var index = this.index++;
        try {
            result = this.project(value, index);
        }
        catch (error) {
            this.destination.error(error);
            return;
        }
        this._innerSub(result, value, index);
    };
    SwitchMapSubscriber.prototype._innerSub = function (result, value, index) {
        var innerSubscription = this.innerSubscription;
        if (innerSubscription) {
            innerSubscription.unsubscribe();
        }
        var innerSubscriber = new InnerSubscriber_1.InnerSubscriber(this, undefined, undefined);
        var destination = this.destination;
        destination.add(innerSubscriber);
        this.innerSubscription = subscribeToResult_1.subscribeToResult(this, result, value, index, innerSubscriber);
    };
    SwitchMapSubscriber.prototype._complete = function () {
        var innerSubscription = this.innerSubscription;
        if (!innerSubscription || innerSubscription.closed) {
            _super.prototype._complete.call(this);
        }
        this.unsubscribe();
    };
    SwitchMapSubscriber.prototype._unsubscribe = function () {
        this.innerSubscription = null;
    };
    SwitchMapSubscriber.prototype.notifyComplete = function (innerSub) {
        var destination = this.destination;
        destination.remove(innerSub);
        this.innerSubscription = null;
        if (this.isStopped) {
            _super.prototype._complete.call(this);
        }
    };
    SwitchMapSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
        this.destination.next(innerValue);
    };
    return SwitchMapSubscriber;
}(OuterSubscriber_1.OuterSubscriber));

},{"../InnerSubscriber":92,"../OuterSubscriber":96,"../observable/from":113,"../util/subscribeToResult":285,"./map":171}],213:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var switchMap_1 = require("./switchMap");
function switchMapTo(innerObservable, resultSelector) {
    return resultSelector ? switchMap_1.switchMap(function () { return innerObservable; }, resultSelector) : switchMap_1.switchMap(function () { return innerObservable; });
}
exports.switchMapTo = switchMapTo;

},{"./switchMap":212}],214:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subscriber_1 = require("../Subscriber");
var ArgumentOutOfRangeError_1 = require("../util/ArgumentOutOfRangeError");
var empty_1 = require("../observable/empty");
function take(count) {
    return function (source) {
        if (count === 0) {
            return empty_1.empty();
        }
        else {
            return source.lift(new TakeOperator(count));
        }
    };
}
exports.take = take;
var TakeOperator = (function () {
    function TakeOperator(total) {
        this.total = total;
        if (this.total < 0) {
            throw new ArgumentOutOfRangeError_1.ArgumentOutOfRangeError;
        }
    }
    TakeOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new TakeSubscriber(subscriber, this.total));
    };
    return TakeOperator;
}());
var TakeSubscriber = (function (_super) {
    __extends(TakeSubscriber, _super);
    function TakeSubscriber(destination, total) {
        var _this = _super.call(this, destination) || this;
        _this.total = total;
        _this.count = 0;
        return _this;
    }
    TakeSubscriber.prototype._next = function (value) {
        var total = this.total;
        var count = ++this.count;
        if (count <= total) {
            this.destination.next(value);
            if (count === total) {
                this.destination.complete();
                this.unsubscribe();
            }
        }
    };
    return TakeSubscriber;
}(Subscriber_1.Subscriber));

},{"../Subscriber":101,"../observable/empty":111,"../util/ArgumentOutOfRangeError":257}],215:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subscriber_1 = require("../Subscriber");
var ArgumentOutOfRangeError_1 = require("../util/ArgumentOutOfRangeError");
var empty_1 = require("../observable/empty");
function takeLast(count) {
    return function takeLastOperatorFunction(source) {
        if (count === 0) {
            return empty_1.empty();
        }
        else {
            return source.lift(new TakeLastOperator(count));
        }
    };
}
exports.takeLast = takeLast;
var TakeLastOperator = (function () {
    function TakeLastOperator(total) {
        this.total = total;
        if (this.total < 0) {
            throw new ArgumentOutOfRangeError_1.ArgumentOutOfRangeError;
        }
    }
    TakeLastOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new TakeLastSubscriber(subscriber, this.total));
    };
    return TakeLastOperator;
}());
var TakeLastSubscriber = (function (_super) {
    __extends(TakeLastSubscriber, _super);
    function TakeLastSubscriber(destination, total) {
        var _this = _super.call(this, destination) || this;
        _this.total = total;
        _this.ring = new Array();
        _this.count = 0;
        return _this;
    }
    TakeLastSubscriber.prototype._next = function (value) {
        var ring = this.ring;
        var total = this.total;
        var count = this.count++;
        if (ring.length < total) {
            ring.push(value);
        }
        else {
            var index = count % total;
            ring[index] = value;
        }
    };
    TakeLastSubscriber.prototype._complete = function () {
        var destination = this.destination;
        var count = this.count;
        if (count > 0) {
            var total = this.count >= this.total ? this.total : this.count;
            var ring = this.ring;
            for (var i = 0; i < total; i++) {
                var idx = (count++) % total;
                destination.next(ring[idx]);
            }
        }
        destination.complete();
    };
    return TakeLastSubscriber;
}(Subscriber_1.Subscriber));

},{"../Subscriber":101,"../observable/empty":111,"../util/ArgumentOutOfRangeError":257}],216:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var OuterSubscriber_1 = require("../OuterSubscriber");
var subscribeToResult_1 = require("../util/subscribeToResult");
function takeUntil(notifier) {
    return function (source) { return source.lift(new TakeUntilOperator(notifier)); };
}
exports.takeUntil = takeUntil;
var TakeUntilOperator = (function () {
    function TakeUntilOperator(notifier) {
        this.notifier = notifier;
    }
    TakeUntilOperator.prototype.call = function (subscriber, source) {
        var takeUntilSubscriber = new TakeUntilSubscriber(subscriber);
        var notifierSubscription = subscribeToResult_1.subscribeToResult(takeUntilSubscriber, this.notifier);
        if (notifierSubscription && !takeUntilSubscriber.seenValue) {
            takeUntilSubscriber.add(notifierSubscription);
            return source.subscribe(takeUntilSubscriber);
        }
        return takeUntilSubscriber;
    };
    return TakeUntilOperator;
}());
var TakeUntilSubscriber = (function (_super) {
    __extends(TakeUntilSubscriber, _super);
    function TakeUntilSubscriber(destination) {
        var _this = _super.call(this, destination) || this;
        _this.seenValue = false;
        return _this;
    }
    TakeUntilSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
        this.seenValue = true;
        this.complete();
    };
    TakeUntilSubscriber.prototype.notifyComplete = function () {
    };
    return TakeUntilSubscriber;
}(OuterSubscriber_1.OuterSubscriber));

},{"../OuterSubscriber":96,"../util/subscribeToResult":285}],217:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subscriber_1 = require("../Subscriber");
function takeWhile(predicate, inclusive) {
    if (inclusive === void 0) { inclusive = false; }
    return function (source) {
        return source.lift(new TakeWhileOperator(predicate, inclusive));
    };
}
exports.takeWhile = takeWhile;
var TakeWhileOperator = (function () {
    function TakeWhileOperator(predicate, inclusive) {
        this.predicate = predicate;
        this.inclusive = inclusive;
    }
    TakeWhileOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new TakeWhileSubscriber(subscriber, this.predicate, this.inclusive));
    };
    return TakeWhileOperator;
}());
var TakeWhileSubscriber = (function (_super) {
    __extends(TakeWhileSubscriber, _super);
    function TakeWhileSubscriber(destination, predicate, inclusive) {
        var _this = _super.call(this, destination) || this;
        _this.predicate = predicate;
        _this.inclusive = inclusive;
        _this.index = 0;
        return _this;
    }
    TakeWhileSubscriber.prototype._next = function (value) {
        var destination = this.destination;
        var result;
        try {
            result = this.predicate(value, this.index++);
        }
        catch (err) {
            destination.error(err);
            return;
        }
        this.nextOrComplete(value, result);
    };
    TakeWhileSubscriber.prototype.nextOrComplete = function (value, predicateResult) {
        var destination = this.destination;
        if (Boolean(predicateResult)) {
            destination.next(value);
        }
        else {
            if (this.inclusive) {
                destination.next(value);
            }
            destination.complete();
        }
    };
    return TakeWhileSubscriber;
}(Subscriber_1.Subscriber));

},{"../Subscriber":101}],218:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subscriber_1 = require("../Subscriber");
var noop_1 = require("../util/noop");
var isFunction_1 = require("../util/isFunction");
function tap(nextOrObserver, error, complete) {
    return function tapOperatorFunction(source) {
        return source.lift(new DoOperator(nextOrObserver, error, complete));
    };
}
exports.tap = tap;
var DoOperator = (function () {
    function DoOperator(nextOrObserver, error, complete) {
        this.nextOrObserver = nextOrObserver;
        this.error = error;
        this.complete = complete;
    }
    DoOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new TapSubscriber(subscriber, this.nextOrObserver, this.error, this.complete));
    };
    return DoOperator;
}());
var TapSubscriber = (function (_super) {
    __extends(TapSubscriber, _super);
    function TapSubscriber(destination, observerOrNext, error, complete) {
        var _this = _super.call(this, destination) || this;
        _this._tapNext = noop_1.noop;
        _this._tapError = noop_1.noop;
        _this._tapComplete = noop_1.noop;
        _this._tapError = error || noop_1.noop;
        _this._tapComplete = complete || noop_1.noop;
        if (isFunction_1.isFunction(observerOrNext)) {
            _this._context = _this;
            _this._tapNext = observerOrNext;
        }
        else if (observerOrNext) {
            _this._context = observerOrNext;
            _this._tapNext = observerOrNext.next || noop_1.noop;
            _this._tapError = observerOrNext.error || noop_1.noop;
            _this._tapComplete = observerOrNext.complete || noop_1.noop;
        }
        return _this;
    }
    TapSubscriber.prototype._next = function (value) {
        try {
            this._tapNext.call(this._context, value);
        }
        catch (err) {
            this.destination.error(err);
            return;
        }
        this.destination.next(value);
    };
    TapSubscriber.prototype._error = function (err) {
        try {
            this._tapError.call(this._context, err);
        }
        catch (err) {
            this.destination.error(err);
            return;
        }
        this.destination.error(err);
    };
    TapSubscriber.prototype._complete = function () {
        try {
            this._tapComplete.call(this._context);
        }
        catch (err) {
            this.destination.error(err);
            return;
        }
        return this.destination.complete();
    };
    return TapSubscriber;
}(Subscriber_1.Subscriber));

},{"../Subscriber":101,"../util/isFunction":269,"../util/noop":277}],219:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var OuterSubscriber_1 = require("../OuterSubscriber");
var subscribeToResult_1 = require("../util/subscribeToResult");
exports.defaultThrottleConfig = {
    leading: true,
    trailing: false
};
function throttle(durationSelector, config) {
    if (config === void 0) { config = exports.defaultThrottleConfig; }
    return function (source) { return source.lift(new ThrottleOperator(durationSelector, config.leading, config.trailing)); };
}
exports.throttle = throttle;
var ThrottleOperator = (function () {
    function ThrottleOperator(durationSelector, leading, trailing) {
        this.durationSelector = durationSelector;
        this.leading = leading;
        this.trailing = trailing;
    }
    ThrottleOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new ThrottleSubscriber(subscriber, this.durationSelector, this.leading, this.trailing));
    };
    return ThrottleOperator;
}());
var ThrottleSubscriber = (function (_super) {
    __extends(ThrottleSubscriber, _super);
    function ThrottleSubscriber(destination, durationSelector, _leading, _trailing) {
        var _this = _super.call(this, destination) || this;
        _this.destination = destination;
        _this.durationSelector = durationSelector;
        _this._leading = _leading;
        _this._trailing = _trailing;
        _this._hasValue = false;
        return _this;
    }
    ThrottleSubscriber.prototype._next = function (value) {
        this._hasValue = true;
        this._sendValue = value;
        if (!this._throttled) {
            if (this._leading) {
                this.send();
            }
            else {
                this.throttle(value);
            }
        }
    };
    ThrottleSubscriber.prototype.send = function () {
        var _a = this, _hasValue = _a._hasValue, _sendValue = _a._sendValue;
        if (_hasValue) {
            this.destination.next(_sendValue);
            this.throttle(_sendValue);
        }
        this._hasValue = false;
        this._sendValue = null;
    };
    ThrottleSubscriber.prototype.throttle = function (value) {
        var duration = this.tryDurationSelector(value);
        if (!!duration) {
            this.add(this._throttled = subscribeToResult_1.subscribeToResult(this, duration));
        }
    };
    ThrottleSubscriber.prototype.tryDurationSelector = function (value) {
        try {
            return this.durationSelector(value);
        }
        catch (err) {
            this.destination.error(err);
            return null;
        }
    };
    ThrottleSubscriber.prototype.throttlingDone = function () {
        var _a = this, _throttled = _a._throttled, _trailing = _a._trailing;
        if (_throttled) {
            _throttled.unsubscribe();
        }
        this._throttled = null;
        if (_trailing) {
            this.send();
        }
    };
    ThrottleSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
        this.throttlingDone();
    };
    ThrottleSubscriber.prototype.notifyComplete = function () {
        this.throttlingDone();
    };
    return ThrottleSubscriber;
}(OuterSubscriber_1.OuterSubscriber));

},{"../OuterSubscriber":96,"../util/subscribeToResult":285}],220:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subscriber_1 = require("../Subscriber");
var async_1 = require("../scheduler/async");
var throttle_1 = require("./throttle");
function throttleTime(duration, scheduler, config) {
    if (scheduler === void 0) { scheduler = async_1.async; }
    if (config === void 0) { config = throttle_1.defaultThrottleConfig; }
    return function (source) { return source.lift(new ThrottleTimeOperator(duration, scheduler, config.leading, config.trailing)); };
}
exports.throttleTime = throttleTime;
var ThrottleTimeOperator = (function () {
    function ThrottleTimeOperator(duration, scheduler, leading, trailing) {
        this.duration = duration;
        this.scheduler = scheduler;
        this.leading = leading;
        this.trailing = trailing;
    }
    ThrottleTimeOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new ThrottleTimeSubscriber(subscriber, this.duration, this.scheduler, this.leading, this.trailing));
    };
    return ThrottleTimeOperator;
}());
var ThrottleTimeSubscriber = (function (_super) {
    __extends(ThrottleTimeSubscriber, _super);
    function ThrottleTimeSubscriber(destination, duration, scheduler, leading, trailing) {
        var _this = _super.call(this, destination) || this;
        _this.duration = duration;
        _this.scheduler = scheduler;
        _this.leading = leading;
        _this.trailing = trailing;
        _this._hasTrailingValue = false;
        _this._trailingValue = null;
        return _this;
    }
    ThrottleTimeSubscriber.prototype._next = function (value) {
        if (this.throttled) {
            if (this.trailing) {
                this._trailingValue = value;
                this._hasTrailingValue = true;
            }
        }
        else {
            this.add(this.throttled = this.scheduler.schedule(dispatchNext, this.duration, { subscriber: this }));
            if (this.leading) {
                this.destination.next(value);
            }
            else if (this.trailing) {
                this._trailingValue = value;
                this._hasTrailingValue = true;
            }
        }
    };
    ThrottleTimeSubscriber.prototype._complete = function () {
        if (this._hasTrailingValue) {
            this.destination.next(this._trailingValue);
            this.destination.complete();
        }
        else {
            this.destination.complete();
        }
    };
    ThrottleTimeSubscriber.prototype.clearThrottle = function () {
        var throttled = this.throttled;
        if (throttled) {
            if (this.trailing && this._hasTrailingValue) {
                this.destination.next(this._trailingValue);
                this._trailingValue = null;
                this._hasTrailingValue = false;
            }
            throttled.unsubscribe();
            this.remove(throttled);
            this.throttled = null;
        }
    };
    return ThrottleTimeSubscriber;
}(Subscriber_1.Subscriber));
function dispatchNext(arg) {
    var subscriber = arg.subscriber;
    subscriber.clearThrottle();
}

},{"../Subscriber":101,"../scheduler/async":252,"./throttle":219}],221:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var EmptyError_1 = require("../util/EmptyError");
var Subscriber_1 = require("../Subscriber");
function throwIfEmpty(errorFactory) {
    if (errorFactory === void 0) { errorFactory = defaultErrorFactory; }
    return function (source) {
        return source.lift(new ThrowIfEmptyOperator(errorFactory));
    };
}
exports.throwIfEmpty = throwIfEmpty;
var ThrowIfEmptyOperator = (function () {
    function ThrowIfEmptyOperator(errorFactory) {
        this.errorFactory = errorFactory;
    }
    ThrowIfEmptyOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new ThrowIfEmptySubscriber(subscriber, this.errorFactory));
    };
    return ThrowIfEmptyOperator;
}());
var ThrowIfEmptySubscriber = (function (_super) {
    __extends(ThrowIfEmptySubscriber, _super);
    function ThrowIfEmptySubscriber(destination, errorFactory) {
        var _this = _super.call(this, destination) || this;
        _this.errorFactory = errorFactory;
        _this.hasValue = false;
        return _this;
    }
    ThrowIfEmptySubscriber.prototype._next = function (value) {
        this.hasValue = true;
        this.destination.next(value);
    };
    ThrowIfEmptySubscriber.prototype._complete = function () {
        if (!this.hasValue) {
            var err = void 0;
            try {
                err = this.errorFactory();
            }
            catch (e) {
                err = e;
            }
            this.destination.error(err);
        }
        else {
            return this.destination.complete();
        }
    };
    return ThrowIfEmptySubscriber;
}(Subscriber_1.Subscriber));
function defaultErrorFactory() {
    return new EmptyError_1.EmptyError();
}

},{"../Subscriber":101,"../util/EmptyError":258}],222:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var async_1 = require("../scheduler/async");
var scan_1 = require("./scan");
var defer_1 = require("../observable/defer");
var map_1 = require("./map");
function timeInterval(scheduler) {
    if (scheduler === void 0) { scheduler = async_1.async; }
    return function (source) { return defer_1.defer(function () {
        return source.pipe(scan_1.scan(function (_a, value) {
            var current = _a.current;
            return ({ value: value, current: scheduler.now(), last: current });
        }, { current: scheduler.now(), value: undefined, last: undefined }), map_1.map(function (_a) {
            var current = _a.current, last = _a.last, value = _a.value;
            return new TimeInterval(value, current - last);
        }));
    }); };
}
exports.timeInterval = timeInterval;
var TimeInterval = (function () {
    function TimeInterval(value, interval) {
        this.value = value;
        this.interval = interval;
    }
    return TimeInterval;
}());
exports.TimeInterval = TimeInterval;

},{"../observable/defer":110,"../scheduler/async":252,"./map":171,"./scan":200}],223:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var async_1 = require("../scheduler/async");
var TimeoutError_1 = require("../util/TimeoutError");
var timeoutWith_1 = require("./timeoutWith");
var throwError_1 = require("../observable/throwError");
function timeout(due, scheduler) {
    if (scheduler === void 0) { scheduler = async_1.async; }
    return timeoutWith_1.timeoutWith(due, throwError_1.throwError(new TimeoutError_1.TimeoutError()), scheduler);
}
exports.timeout = timeout;

},{"../observable/throwError":128,"../scheduler/async":252,"../util/TimeoutError":261,"./timeoutWith":224}],224:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var async_1 = require("../scheduler/async");
var isDate_1 = require("../util/isDate");
var OuterSubscriber_1 = require("../OuterSubscriber");
var subscribeToResult_1 = require("../util/subscribeToResult");
function timeoutWith(due, withObservable, scheduler) {
    if (scheduler === void 0) { scheduler = async_1.async; }
    return function (source) {
        var absoluteTimeout = isDate_1.isDate(due);
        var waitFor = absoluteTimeout ? (+due - scheduler.now()) : Math.abs(due);
        return source.lift(new TimeoutWithOperator(waitFor, absoluteTimeout, withObservable, scheduler));
    };
}
exports.timeoutWith = timeoutWith;
var TimeoutWithOperator = (function () {
    function TimeoutWithOperator(waitFor, absoluteTimeout, withObservable, scheduler) {
        this.waitFor = waitFor;
        this.absoluteTimeout = absoluteTimeout;
        this.withObservable = withObservable;
        this.scheduler = scheduler;
    }
    TimeoutWithOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new TimeoutWithSubscriber(subscriber, this.absoluteTimeout, this.waitFor, this.withObservable, this.scheduler));
    };
    return TimeoutWithOperator;
}());
var TimeoutWithSubscriber = (function (_super) {
    __extends(TimeoutWithSubscriber, _super);
    function TimeoutWithSubscriber(destination, absoluteTimeout, waitFor, withObservable, scheduler) {
        var _this = _super.call(this, destination) || this;
        _this.absoluteTimeout = absoluteTimeout;
        _this.waitFor = waitFor;
        _this.withObservable = withObservable;
        _this.scheduler = scheduler;
        _this.action = null;
        _this.scheduleTimeout();
        return _this;
    }
    TimeoutWithSubscriber.dispatchTimeout = function (subscriber) {
        var withObservable = subscriber.withObservable;
        subscriber._unsubscribeAndRecycle();
        subscriber.add(subscribeToResult_1.subscribeToResult(subscriber, withObservable));
    };
    TimeoutWithSubscriber.prototype.scheduleTimeout = function () {
        var action = this.action;
        if (action) {
            this.action = action.schedule(this, this.waitFor);
        }
        else {
            this.add(this.action = this.scheduler.schedule(TimeoutWithSubscriber.dispatchTimeout, this.waitFor, this));
        }
    };
    TimeoutWithSubscriber.prototype._next = function (value) {
        if (!this.absoluteTimeout) {
            this.scheduleTimeout();
        }
        _super.prototype._next.call(this, value);
    };
    TimeoutWithSubscriber.prototype._unsubscribe = function () {
        this.action = null;
        this.scheduler = null;
        this.withObservable = null;
    };
    return TimeoutWithSubscriber;
}(OuterSubscriber_1.OuterSubscriber));

},{"../OuterSubscriber":96,"../scheduler/async":252,"../util/isDate":268,"../util/subscribeToResult":285}],225:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var async_1 = require("../scheduler/async");
var map_1 = require("./map");
function timestamp(scheduler) {
    if (scheduler === void 0) { scheduler = async_1.async; }
    return map_1.map(function (value) { return new Timestamp(value, scheduler.now()); });
}
exports.timestamp = timestamp;
var Timestamp = (function () {
    function Timestamp(value, timestamp) {
        this.value = value;
        this.timestamp = timestamp;
    }
    return Timestamp;
}());
exports.Timestamp = Timestamp;

},{"../scheduler/async":252,"./map":171}],226:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var reduce_1 = require("./reduce");
function toArrayReducer(arr, item, index) {
    if (index === 0) {
        return [item];
    }
    arr.push(item);
    return arr;
}
function toArray() {
    return reduce_1.reduce(toArrayReducer, []);
}
exports.toArray = toArray;

},{"./reduce":192}],227:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subject_1 = require("../Subject");
var OuterSubscriber_1 = require("../OuterSubscriber");
var subscribeToResult_1 = require("../util/subscribeToResult");
function window(windowBoundaries) {
    return function windowOperatorFunction(source) {
        return source.lift(new WindowOperator(windowBoundaries));
    };
}
exports.window = window;
var WindowOperator = (function () {
    function WindowOperator(windowBoundaries) {
        this.windowBoundaries = windowBoundaries;
    }
    WindowOperator.prototype.call = function (subscriber, source) {
        var windowSubscriber = new WindowSubscriber(subscriber);
        var sourceSubscription = source.subscribe(windowSubscriber);
        if (!sourceSubscription.closed) {
            windowSubscriber.add(subscribeToResult_1.subscribeToResult(windowSubscriber, this.windowBoundaries));
        }
        return sourceSubscription;
    };
    return WindowOperator;
}());
var WindowSubscriber = (function (_super) {
    __extends(WindowSubscriber, _super);
    function WindowSubscriber(destination) {
        var _this = _super.call(this, destination) || this;
        _this.window = new Subject_1.Subject();
        destination.next(_this.window);
        return _this;
    }
    WindowSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
        this.openWindow();
    };
    WindowSubscriber.prototype.notifyError = function (error, innerSub) {
        this._error(error);
    };
    WindowSubscriber.prototype.notifyComplete = function (innerSub) {
        this._complete();
    };
    WindowSubscriber.prototype._next = function (value) {
        this.window.next(value);
    };
    WindowSubscriber.prototype._error = function (err) {
        this.window.error(err);
        this.destination.error(err);
    };
    WindowSubscriber.prototype._complete = function () {
        this.window.complete();
        this.destination.complete();
    };
    WindowSubscriber.prototype._unsubscribe = function () {
        this.window = null;
    };
    WindowSubscriber.prototype.openWindow = function () {
        var prevWindow = this.window;
        if (prevWindow) {
            prevWindow.complete();
        }
        var destination = this.destination;
        var newWindow = this.window = new Subject_1.Subject();
        destination.next(newWindow);
    };
    return WindowSubscriber;
}(OuterSubscriber_1.OuterSubscriber));

},{"../OuterSubscriber":96,"../Subject":99,"../util/subscribeToResult":285}],228:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subscriber_1 = require("../Subscriber");
var Subject_1 = require("../Subject");
function windowCount(windowSize, startWindowEvery) {
    if (startWindowEvery === void 0) { startWindowEvery = 0; }
    return function windowCountOperatorFunction(source) {
        return source.lift(new WindowCountOperator(windowSize, startWindowEvery));
    };
}
exports.windowCount = windowCount;
var WindowCountOperator = (function () {
    function WindowCountOperator(windowSize, startWindowEvery) {
        this.windowSize = windowSize;
        this.startWindowEvery = startWindowEvery;
    }
    WindowCountOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new WindowCountSubscriber(subscriber, this.windowSize, this.startWindowEvery));
    };
    return WindowCountOperator;
}());
var WindowCountSubscriber = (function (_super) {
    __extends(WindowCountSubscriber, _super);
    function WindowCountSubscriber(destination, windowSize, startWindowEvery) {
        var _this = _super.call(this, destination) || this;
        _this.destination = destination;
        _this.windowSize = windowSize;
        _this.startWindowEvery = startWindowEvery;
        _this.windows = [new Subject_1.Subject()];
        _this.count = 0;
        destination.next(_this.windows[0]);
        return _this;
    }
    WindowCountSubscriber.prototype._next = function (value) {
        var startWindowEvery = (this.startWindowEvery > 0) ? this.startWindowEvery : this.windowSize;
        var destination = this.destination;
        var windowSize = this.windowSize;
        var windows = this.windows;
        var len = windows.length;
        for (var i = 0; i < len && !this.closed; i++) {
            windows[i].next(value);
        }
        var c = this.count - windowSize + 1;
        if (c >= 0 && c % startWindowEvery === 0 && !this.closed) {
            windows.shift().complete();
        }
        if (++this.count % startWindowEvery === 0 && !this.closed) {
            var window_1 = new Subject_1.Subject();
            windows.push(window_1);
            destination.next(window_1);
        }
    };
    WindowCountSubscriber.prototype._error = function (err) {
        var windows = this.windows;
        if (windows) {
            while (windows.length > 0 && !this.closed) {
                windows.shift().error(err);
            }
        }
        this.destination.error(err);
    };
    WindowCountSubscriber.prototype._complete = function () {
        var windows = this.windows;
        if (windows) {
            while (windows.length > 0 && !this.closed) {
                windows.shift().complete();
            }
        }
        this.destination.complete();
    };
    WindowCountSubscriber.prototype._unsubscribe = function () {
        this.count = 0;
        this.windows = null;
    };
    return WindowCountSubscriber;
}(Subscriber_1.Subscriber));

},{"../Subject":99,"../Subscriber":101}],229:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subject_1 = require("../Subject");
var async_1 = require("../scheduler/async");
var Subscriber_1 = require("../Subscriber");
var isNumeric_1 = require("../util/isNumeric");
var isScheduler_1 = require("../util/isScheduler");
function windowTime(windowTimeSpan) {
    var scheduler = async_1.async;
    var windowCreationInterval = null;
    var maxWindowSize = Number.POSITIVE_INFINITY;
    if (isScheduler_1.isScheduler(arguments[3])) {
        scheduler = arguments[3];
    }
    if (isScheduler_1.isScheduler(arguments[2])) {
        scheduler = arguments[2];
    }
    else if (isNumeric_1.isNumeric(arguments[2])) {
        maxWindowSize = arguments[2];
    }
    if (isScheduler_1.isScheduler(arguments[1])) {
        scheduler = arguments[1];
    }
    else if (isNumeric_1.isNumeric(arguments[1])) {
        windowCreationInterval = arguments[1];
    }
    return function windowTimeOperatorFunction(source) {
        return source.lift(new WindowTimeOperator(windowTimeSpan, windowCreationInterval, maxWindowSize, scheduler));
    };
}
exports.windowTime = windowTime;
var WindowTimeOperator = (function () {
    function WindowTimeOperator(windowTimeSpan, windowCreationInterval, maxWindowSize, scheduler) {
        this.windowTimeSpan = windowTimeSpan;
        this.windowCreationInterval = windowCreationInterval;
        this.maxWindowSize = maxWindowSize;
        this.scheduler = scheduler;
    }
    WindowTimeOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new WindowTimeSubscriber(subscriber, this.windowTimeSpan, this.windowCreationInterval, this.maxWindowSize, this.scheduler));
    };
    return WindowTimeOperator;
}());
var CountedSubject = (function (_super) {
    __extends(CountedSubject, _super);
    function CountedSubject() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._numberOfNextedValues = 0;
        return _this;
    }
    CountedSubject.prototype.next = function (value) {
        this._numberOfNextedValues++;
        _super.prototype.next.call(this, value);
    };
    Object.defineProperty(CountedSubject.prototype, "numberOfNextedValues", {
        get: function () {
            return this._numberOfNextedValues;
        },
        enumerable: true,
        configurable: true
    });
    return CountedSubject;
}(Subject_1.Subject));
var WindowTimeSubscriber = (function (_super) {
    __extends(WindowTimeSubscriber, _super);
    function WindowTimeSubscriber(destination, windowTimeSpan, windowCreationInterval, maxWindowSize, scheduler) {
        var _this = _super.call(this, destination) || this;
        _this.destination = destination;
        _this.windowTimeSpan = windowTimeSpan;
        _this.windowCreationInterval = windowCreationInterval;
        _this.maxWindowSize = maxWindowSize;
        _this.scheduler = scheduler;
        _this.windows = [];
        var window = _this.openWindow();
        if (windowCreationInterval !== null && windowCreationInterval >= 0) {
            var closeState = { subscriber: _this, window: window, context: null };
            var creationState = { windowTimeSpan: windowTimeSpan, windowCreationInterval: windowCreationInterval, subscriber: _this, scheduler: scheduler };
            _this.add(scheduler.schedule(dispatchWindowClose, windowTimeSpan, closeState));
            _this.add(scheduler.schedule(dispatchWindowCreation, windowCreationInterval, creationState));
        }
        else {
            var timeSpanOnlyState = { subscriber: _this, window: window, windowTimeSpan: windowTimeSpan };
            _this.add(scheduler.schedule(dispatchWindowTimeSpanOnly, windowTimeSpan, timeSpanOnlyState));
        }
        return _this;
    }
    WindowTimeSubscriber.prototype._next = function (value) {
        var windows = this.windows;
        var len = windows.length;
        for (var i = 0; i < len; i++) {
            var window_1 = windows[i];
            if (!window_1.closed) {
                window_1.next(value);
                if (window_1.numberOfNextedValues >= this.maxWindowSize) {
                    this.closeWindow(window_1);
                }
            }
        }
    };
    WindowTimeSubscriber.prototype._error = function (err) {
        var windows = this.windows;
        while (windows.length > 0) {
            windows.shift().error(err);
        }
        this.destination.error(err);
    };
    WindowTimeSubscriber.prototype._complete = function () {
        var windows = this.windows;
        while (windows.length > 0) {
            var window_2 = windows.shift();
            if (!window_2.closed) {
                window_2.complete();
            }
        }
        this.destination.complete();
    };
    WindowTimeSubscriber.prototype.openWindow = function () {
        var window = new CountedSubject();
        this.windows.push(window);
        var destination = this.destination;
        destination.next(window);
        return window;
    };
    WindowTimeSubscriber.prototype.closeWindow = function (window) {
        window.complete();
        var windows = this.windows;
        windows.splice(windows.indexOf(window), 1);
    };
    return WindowTimeSubscriber;
}(Subscriber_1.Subscriber));
function dispatchWindowTimeSpanOnly(state) {
    var subscriber = state.subscriber, windowTimeSpan = state.windowTimeSpan, window = state.window;
    if (window) {
        subscriber.closeWindow(window);
    }
    state.window = subscriber.openWindow();
    this.schedule(state, windowTimeSpan);
}
function dispatchWindowCreation(state) {
    var windowTimeSpan = state.windowTimeSpan, subscriber = state.subscriber, scheduler = state.scheduler, windowCreationInterval = state.windowCreationInterval;
    var window = subscriber.openWindow();
    var action = this;
    var context = { action: action, subscription: null };
    var timeSpanState = { subscriber: subscriber, window: window, context: context };
    context.subscription = scheduler.schedule(dispatchWindowClose, windowTimeSpan, timeSpanState);
    action.add(context.subscription);
    action.schedule(state, windowCreationInterval);
}
function dispatchWindowClose(state) {
    var subscriber = state.subscriber, window = state.window, context = state.context;
    if (context && context.action && context.subscription) {
        context.action.remove(context.subscription);
    }
    subscriber.closeWindow(window);
}

},{"../Subject":99,"../Subscriber":101,"../scheduler/async":252,"../util/isNumeric":272,"../util/isScheduler":276}],230:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subject_1 = require("../Subject");
var Subscription_1 = require("../Subscription");
var OuterSubscriber_1 = require("../OuterSubscriber");
var subscribeToResult_1 = require("../util/subscribeToResult");
function windowToggle(openings, closingSelector) {
    return function (source) { return source.lift(new WindowToggleOperator(openings, closingSelector)); };
}
exports.windowToggle = windowToggle;
var WindowToggleOperator = (function () {
    function WindowToggleOperator(openings, closingSelector) {
        this.openings = openings;
        this.closingSelector = closingSelector;
    }
    WindowToggleOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new WindowToggleSubscriber(subscriber, this.openings, this.closingSelector));
    };
    return WindowToggleOperator;
}());
var WindowToggleSubscriber = (function (_super) {
    __extends(WindowToggleSubscriber, _super);
    function WindowToggleSubscriber(destination, openings, closingSelector) {
        var _this = _super.call(this, destination) || this;
        _this.openings = openings;
        _this.closingSelector = closingSelector;
        _this.contexts = [];
        _this.add(_this.openSubscription = subscribeToResult_1.subscribeToResult(_this, openings, openings));
        return _this;
    }
    WindowToggleSubscriber.prototype._next = function (value) {
        var contexts = this.contexts;
        if (contexts) {
            var len = contexts.length;
            for (var i = 0; i < len; i++) {
                contexts[i].window.next(value);
            }
        }
    };
    WindowToggleSubscriber.prototype._error = function (err) {
        var contexts = this.contexts;
        this.contexts = null;
        if (contexts) {
            var len = contexts.length;
            var index = -1;
            while (++index < len) {
                var context_1 = contexts[index];
                context_1.window.error(err);
                context_1.subscription.unsubscribe();
            }
        }
        _super.prototype._error.call(this, err);
    };
    WindowToggleSubscriber.prototype._complete = function () {
        var contexts = this.contexts;
        this.contexts = null;
        if (contexts) {
            var len = contexts.length;
            var index = -1;
            while (++index < len) {
                var context_2 = contexts[index];
                context_2.window.complete();
                context_2.subscription.unsubscribe();
            }
        }
        _super.prototype._complete.call(this);
    };
    WindowToggleSubscriber.prototype._unsubscribe = function () {
        var contexts = this.contexts;
        this.contexts = null;
        if (contexts) {
            var len = contexts.length;
            var index = -1;
            while (++index < len) {
                var context_3 = contexts[index];
                context_3.window.unsubscribe();
                context_3.subscription.unsubscribe();
            }
        }
    };
    WindowToggleSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
        if (outerValue === this.openings) {
            var closingNotifier = void 0;
            try {
                var closingSelector = this.closingSelector;
                closingNotifier = closingSelector(innerValue);
            }
            catch (e) {
                return this.error(e);
            }
            var window_1 = new Subject_1.Subject();
            var subscription = new Subscription_1.Subscription();
            var context_4 = { window: window_1, subscription: subscription };
            this.contexts.push(context_4);
            var innerSubscription = subscribeToResult_1.subscribeToResult(this, closingNotifier, context_4);
            if (innerSubscription.closed) {
                this.closeWindow(this.contexts.length - 1);
            }
            else {
                innerSubscription.context = context_4;
                subscription.add(innerSubscription);
            }
            this.destination.next(window_1);
        }
        else {
            this.closeWindow(this.contexts.indexOf(outerValue));
        }
    };
    WindowToggleSubscriber.prototype.notifyError = function (err) {
        this.error(err);
    };
    WindowToggleSubscriber.prototype.notifyComplete = function (inner) {
        if (inner !== this.openSubscription) {
            this.closeWindow(this.contexts.indexOf(inner.context));
        }
    };
    WindowToggleSubscriber.prototype.closeWindow = function (index) {
        if (index === -1) {
            return;
        }
        var contexts = this.contexts;
        var context = contexts[index];
        var window = context.window, subscription = context.subscription;
        contexts.splice(index, 1);
        window.complete();
        subscription.unsubscribe();
    };
    return WindowToggleSubscriber;
}(OuterSubscriber_1.OuterSubscriber));

},{"../OuterSubscriber":96,"../Subject":99,"../Subscription":102,"../util/subscribeToResult":285}],231:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subject_1 = require("../Subject");
var OuterSubscriber_1 = require("../OuterSubscriber");
var subscribeToResult_1 = require("../util/subscribeToResult");
function windowWhen(closingSelector) {
    return function windowWhenOperatorFunction(source) {
        return source.lift(new WindowOperator(closingSelector));
    };
}
exports.windowWhen = windowWhen;
var WindowOperator = (function () {
    function WindowOperator(closingSelector) {
        this.closingSelector = closingSelector;
    }
    WindowOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new WindowSubscriber(subscriber, this.closingSelector));
    };
    return WindowOperator;
}());
var WindowSubscriber = (function (_super) {
    __extends(WindowSubscriber, _super);
    function WindowSubscriber(destination, closingSelector) {
        var _this = _super.call(this, destination) || this;
        _this.destination = destination;
        _this.closingSelector = closingSelector;
        _this.openWindow();
        return _this;
    }
    WindowSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
        this.openWindow(innerSub);
    };
    WindowSubscriber.prototype.notifyError = function (error, innerSub) {
        this._error(error);
    };
    WindowSubscriber.prototype.notifyComplete = function (innerSub) {
        this.openWindow(innerSub);
    };
    WindowSubscriber.prototype._next = function (value) {
        this.window.next(value);
    };
    WindowSubscriber.prototype._error = function (err) {
        this.window.error(err);
        this.destination.error(err);
        this.unsubscribeClosingNotification();
    };
    WindowSubscriber.prototype._complete = function () {
        this.window.complete();
        this.destination.complete();
        this.unsubscribeClosingNotification();
    };
    WindowSubscriber.prototype.unsubscribeClosingNotification = function () {
        if (this.closingNotification) {
            this.closingNotification.unsubscribe();
        }
    };
    WindowSubscriber.prototype.openWindow = function (innerSub) {
        if (innerSub === void 0) { innerSub = null; }
        if (innerSub) {
            this.remove(innerSub);
            innerSub.unsubscribe();
        }
        var prevWindow = this.window;
        if (prevWindow) {
            prevWindow.complete();
        }
        var window = this.window = new Subject_1.Subject();
        this.destination.next(window);
        var closingNotifier;
        try {
            var closingSelector = this.closingSelector;
            closingNotifier = closingSelector();
        }
        catch (e) {
            this.destination.error(e);
            this.window.error(e);
            return;
        }
        this.add(this.closingNotification = subscribeToResult_1.subscribeToResult(this, closingNotifier));
    };
    return WindowSubscriber;
}(OuterSubscriber_1.OuterSubscriber));

},{"../OuterSubscriber":96,"../Subject":99,"../util/subscribeToResult":285}],232:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var OuterSubscriber_1 = require("../OuterSubscriber");
var subscribeToResult_1 = require("../util/subscribeToResult");
function withLatestFrom() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    return function (source) {
        var project;
        if (typeof args[args.length - 1] === 'function') {
            project = args.pop();
        }
        var observables = args;
        return source.lift(new WithLatestFromOperator(observables, project));
    };
}
exports.withLatestFrom = withLatestFrom;
var WithLatestFromOperator = (function () {
    function WithLatestFromOperator(observables, project) {
        this.observables = observables;
        this.project = project;
    }
    WithLatestFromOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new WithLatestFromSubscriber(subscriber, this.observables, this.project));
    };
    return WithLatestFromOperator;
}());
var WithLatestFromSubscriber = (function (_super) {
    __extends(WithLatestFromSubscriber, _super);
    function WithLatestFromSubscriber(destination, observables, project) {
        var _this = _super.call(this, destination) || this;
        _this.observables = observables;
        _this.project = project;
        _this.toRespond = [];
        var len = observables.length;
        _this.values = new Array(len);
        for (var i = 0; i < len; i++) {
            _this.toRespond.push(i);
        }
        for (var i = 0; i < len; i++) {
            var observable = observables[i];
            _this.add(subscribeToResult_1.subscribeToResult(_this, observable, observable, i));
        }
        return _this;
    }
    WithLatestFromSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
        this.values[outerIndex] = innerValue;
        var toRespond = this.toRespond;
        if (toRespond.length > 0) {
            var found = toRespond.indexOf(outerIndex);
            if (found !== -1) {
                toRespond.splice(found, 1);
            }
        }
    };
    WithLatestFromSubscriber.prototype.notifyComplete = function () {
    };
    WithLatestFromSubscriber.prototype._next = function (value) {
        if (this.toRespond.length === 0) {
            var args = [value].concat(this.values);
            if (this.project) {
                this._tryProject(args);
            }
            else {
                this.destination.next(args);
            }
        }
    };
    WithLatestFromSubscriber.prototype._tryProject = function (args) {
        var result;
        try {
            result = this.project.apply(this, args);
        }
        catch (err) {
            this.destination.error(err);
            return;
        }
        this.destination.next(result);
    };
    return WithLatestFromSubscriber;
}(OuterSubscriber_1.OuterSubscriber));

},{"../OuterSubscriber":96,"../util/subscribeToResult":285}],233:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var zip_1 = require("../observable/zip");
function zip() {
    var observables = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        observables[_i] = arguments[_i];
    }
    return function zipOperatorFunction(source) {
        return source.lift.call(zip_1.zip.apply(void 0, [source].concat(observables)));
    };
}
exports.zip = zip;

},{"../observable/zip":131}],234:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var zip_1 = require("../observable/zip");
function zipAll(project) {
    return function (source) { return source.lift(new zip_1.ZipOperator(project)); };
}
exports.zipAll = zipAll;

},{"../observable/zip":131}],235:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Observable_1 = require("../Observable");
var Subscription_1 = require("../Subscription");
function scheduleArray(input, scheduler) {
    return new Observable_1.Observable(function (subscriber) {
        var sub = new Subscription_1.Subscription();
        var i = 0;
        sub.add(scheduler.schedule(function () {
            if (i === input.length) {
                subscriber.complete();
                return;
            }
            subscriber.next(input[i++]);
            if (!subscriber.closed) {
                sub.add(this.schedule());
            }
        }));
        return sub;
    });
}
exports.scheduleArray = scheduleArray;

},{"../Observable":94,"../Subscription":102}],236:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Observable_1 = require("../Observable");
var Subscription_1 = require("../Subscription");
var iterator_1 = require("../symbol/iterator");
function scheduleIterable(input, scheduler) {
    if (!input) {
        throw new Error('Iterable cannot be null');
    }
    return new Observable_1.Observable(function (subscriber) {
        var sub = new Subscription_1.Subscription();
        var iterator;
        sub.add(function () {
            if (iterator && typeof iterator.return === 'function') {
                iterator.return();
            }
        });
        sub.add(scheduler.schedule(function () {
            iterator = input[iterator_1.iterator]();
            sub.add(scheduler.schedule(function () {
                if (subscriber.closed) {
                    return;
                }
                var value;
                var done;
                try {
                    var result = iterator.next();
                    value = result.value;
                    done = result.done;
                }
                catch (err) {
                    subscriber.error(err);
                    return;
                }
                if (done) {
                    subscriber.complete();
                }
                else {
                    subscriber.next(value);
                    this.schedule();
                }
            }));
        }));
        return sub;
    });
}
exports.scheduleIterable = scheduleIterable;

},{"../Observable":94,"../Subscription":102,"../symbol/iterator":254}],237:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Observable_1 = require("../Observable");
var Subscription_1 = require("../Subscription");
var observable_1 = require("../symbol/observable");
function scheduleObservable(input, scheduler) {
    return new Observable_1.Observable(function (subscriber) {
        var sub = new Subscription_1.Subscription();
        sub.add(scheduler.schedule(function () {
            var observable = input[observable_1.observable]();
            sub.add(observable.subscribe({
                next: function (value) { sub.add(scheduler.schedule(function () { return subscriber.next(value); })); },
                error: function (err) { sub.add(scheduler.schedule(function () { return subscriber.error(err); })); },
                complete: function () { sub.add(scheduler.schedule(function () { return subscriber.complete(); })); },
            }));
        }));
        return sub;
    });
}
exports.scheduleObservable = scheduleObservable;

},{"../Observable":94,"../Subscription":102,"../symbol/observable":255}],238:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Observable_1 = require("../Observable");
var Subscription_1 = require("../Subscription");
function schedulePromise(input, scheduler) {
    return new Observable_1.Observable(function (subscriber) {
        var sub = new Subscription_1.Subscription();
        sub.add(scheduler.schedule(function () { return input.then(function (value) {
            sub.add(scheduler.schedule(function () {
                subscriber.next(value);
                sub.add(scheduler.schedule(function () { return subscriber.complete(); }));
            }));
        }, function (err) {
            sub.add(scheduler.schedule(function () { return subscriber.error(err); }));
        }); }));
        return sub;
    });
}
exports.schedulePromise = schedulePromise;

},{"../Observable":94,"../Subscription":102}],239:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var scheduleObservable_1 = require("./scheduleObservable");
var schedulePromise_1 = require("./schedulePromise");
var scheduleArray_1 = require("./scheduleArray");
var scheduleIterable_1 = require("./scheduleIterable");
var isInteropObservable_1 = require("../util/isInteropObservable");
var isPromise_1 = require("../util/isPromise");
var isArrayLike_1 = require("../util/isArrayLike");
var isIterable_1 = require("../util/isIterable");
function scheduled(input, scheduler) {
    if (input != null) {
        if (isInteropObservable_1.isInteropObservable(input)) {
            return scheduleObservable_1.scheduleObservable(input, scheduler);
        }
        else if (isPromise_1.isPromise(input)) {
            return schedulePromise_1.schedulePromise(input, scheduler);
        }
        else if (isArrayLike_1.isArrayLike(input)) {
            return scheduleArray_1.scheduleArray(input, scheduler);
        }
        else if (isIterable_1.isIterable(input) || typeof input === 'string') {
            return scheduleIterable_1.scheduleIterable(input, scheduler);
        }
    }
    throw new TypeError((input !== null && typeof input || input) + ' is not observable');
}
exports.scheduled = scheduled;

},{"../util/isArrayLike":267,"../util/isInteropObservable":270,"../util/isIterable":271,"../util/isPromise":275,"./scheduleArray":235,"./scheduleIterable":236,"./scheduleObservable":237,"./schedulePromise":238}],240:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Subscription_1 = require("../Subscription");
var Action = (function (_super) {
    __extends(Action, _super);
    function Action(scheduler, work) {
        return _super.call(this) || this;
    }
    Action.prototype.schedule = function (state, delay) {
        if (delay === void 0) { delay = 0; }
        return this;
    };
    return Action;
}(Subscription_1.Subscription));
exports.Action = Action;

},{"../Subscription":102}],241:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var AsyncAction_1 = require("./AsyncAction");
var AnimationFrameAction = (function (_super) {
    __extends(AnimationFrameAction, _super);
    function AnimationFrameAction(scheduler, work) {
        var _this = _super.call(this, scheduler, work) || this;
        _this.scheduler = scheduler;
        _this.work = work;
        return _this;
    }
    AnimationFrameAction.prototype.requestAsyncId = function (scheduler, id, delay) {
        if (delay === void 0) { delay = 0; }
        if (delay !== null && delay > 0) {
            return _super.prototype.requestAsyncId.call(this, scheduler, id, delay);
        }
        scheduler.actions.push(this);
        return scheduler.scheduled || (scheduler.scheduled = requestAnimationFrame(function () { return scheduler.flush(null); }));
    };
    AnimationFrameAction.prototype.recycleAsyncId = function (scheduler, id, delay) {
        if (delay === void 0) { delay = 0; }
        if ((delay !== null && delay > 0) || (delay === null && this.delay > 0)) {
            return _super.prototype.recycleAsyncId.call(this, scheduler, id, delay);
        }
        if (scheduler.actions.length === 0) {
            cancelAnimationFrame(id);
            scheduler.scheduled = undefined;
        }
        return undefined;
    };
    return AnimationFrameAction;
}(AsyncAction_1.AsyncAction));
exports.AnimationFrameAction = AnimationFrameAction;

},{"./AsyncAction":245}],242:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var AsyncScheduler_1 = require("./AsyncScheduler");
var AnimationFrameScheduler = (function (_super) {
    __extends(AnimationFrameScheduler, _super);
    function AnimationFrameScheduler() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AnimationFrameScheduler.prototype.flush = function (action) {
        this.active = true;
        this.scheduled = undefined;
        var actions = this.actions;
        var error;
        var index = -1;
        var count = actions.length;
        action = action || actions.shift();
        do {
            if (error = action.execute(action.state, action.delay)) {
                break;
            }
        } while (++index < count && (action = actions.shift()));
        this.active = false;
        if (error) {
            while (++index < count && (action = actions.shift())) {
                action.unsubscribe();
            }
            throw error;
        }
    };
    return AnimationFrameScheduler;
}(AsyncScheduler_1.AsyncScheduler));
exports.AnimationFrameScheduler = AnimationFrameScheduler;

},{"./AsyncScheduler":246}],243:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Immediate_1 = require("../util/Immediate");
var AsyncAction_1 = require("./AsyncAction");
var AsapAction = (function (_super) {
    __extends(AsapAction, _super);
    function AsapAction(scheduler, work) {
        var _this = _super.call(this, scheduler, work) || this;
        _this.scheduler = scheduler;
        _this.work = work;
        return _this;
    }
    AsapAction.prototype.requestAsyncId = function (scheduler, id, delay) {
        if (delay === void 0) { delay = 0; }
        if (delay !== null && delay > 0) {
            return _super.prototype.requestAsyncId.call(this, scheduler, id, delay);
        }
        scheduler.actions.push(this);
        return scheduler.scheduled || (scheduler.scheduled = Immediate_1.Immediate.setImmediate(scheduler.flush.bind(scheduler, null)));
    };
    AsapAction.prototype.recycleAsyncId = function (scheduler, id, delay) {
        if (delay === void 0) { delay = 0; }
        if ((delay !== null && delay > 0) || (delay === null && this.delay > 0)) {
            return _super.prototype.recycleAsyncId.call(this, scheduler, id, delay);
        }
        if (scheduler.actions.length === 0) {
            Immediate_1.Immediate.clearImmediate(id);
            scheduler.scheduled = undefined;
        }
        return undefined;
    };
    return AsapAction;
}(AsyncAction_1.AsyncAction));
exports.AsapAction = AsapAction;

},{"../util/Immediate":259,"./AsyncAction":245}],244:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var AsyncScheduler_1 = require("./AsyncScheduler");
var AsapScheduler = (function (_super) {
    __extends(AsapScheduler, _super);
    function AsapScheduler() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AsapScheduler.prototype.flush = function (action) {
        this.active = true;
        this.scheduled = undefined;
        var actions = this.actions;
        var error;
        var index = -1;
        var count = actions.length;
        action = action || actions.shift();
        do {
            if (error = action.execute(action.state, action.delay)) {
                break;
            }
        } while (++index < count && (action = actions.shift()));
        this.active = false;
        if (error) {
            while (++index < count && (action = actions.shift())) {
                action.unsubscribe();
            }
            throw error;
        }
    };
    return AsapScheduler;
}(AsyncScheduler_1.AsyncScheduler));
exports.AsapScheduler = AsapScheduler;

},{"./AsyncScheduler":246}],245:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Action_1 = require("./Action");
var AsyncAction = (function (_super) {
    __extends(AsyncAction, _super);
    function AsyncAction(scheduler, work) {
        var _this = _super.call(this, scheduler, work) || this;
        _this.scheduler = scheduler;
        _this.work = work;
        _this.pending = false;
        return _this;
    }
    AsyncAction.prototype.schedule = function (state, delay) {
        if (delay === void 0) { delay = 0; }
        if (this.closed) {
            return this;
        }
        this.state = state;
        var id = this.id;
        var scheduler = this.scheduler;
        if (id != null) {
            this.id = this.recycleAsyncId(scheduler, id, delay);
        }
        this.pending = true;
        this.delay = delay;
        this.id = this.id || this.requestAsyncId(scheduler, this.id, delay);
        return this;
    };
    AsyncAction.prototype.requestAsyncId = function (scheduler, id, delay) {
        if (delay === void 0) { delay = 0; }
        return setInterval(scheduler.flush.bind(scheduler, this), delay);
    };
    AsyncAction.prototype.recycleAsyncId = function (scheduler, id, delay) {
        if (delay === void 0) { delay = 0; }
        if (delay !== null && this.delay === delay && this.pending === false) {
            return id;
        }
        clearInterval(id);
        return undefined;
    };
    AsyncAction.prototype.execute = function (state, delay) {
        if (this.closed) {
            return new Error('executing a cancelled action');
        }
        this.pending = false;
        var error = this._execute(state, delay);
        if (error) {
            return error;
        }
        else if (this.pending === false && this.id != null) {
            this.id = this.recycleAsyncId(this.scheduler, this.id, null);
        }
    };
    AsyncAction.prototype._execute = function (state, delay) {
        var errored = false;
        var errorValue = undefined;
        try {
            this.work(state);
        }
        catch (e) {
            errored = true;
            errorValue = !!e && e || new Error(e);
        }
        if (errored) {
            this.unsubscribe();
            return errorValue;
        }
    };
    AsyncAction.prototype._unsubscribe = function () {
        var id = this.id;
        var scheduler = this.scheduler;
        var actions = scheduler.actions;
        var index = actions.indexOf(this);
        this.work = null;
        this.state = null;
        this.pending = false;
        this.scheduler = null;
        if (index !== -1) {
            actions.splice(index, 1);
        }
        if (id != null) {
            this.id = this.recycleAsyncId(scheduler, id, null);
        }
        this.delay = null;
    };
    return AsyncAction;
}(Action_1.Action));
exports.AsyncAction = AsyncAction;

},{"./Action":240}],246:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Scheduler_1 = require("../Scheduler");
var AsyncScheduler = (function (_super) {
    __extends(AsyncScheduler, _super);
    function AsyncScheduler(SchedulerAction, now) {
        if (now === void 0) { now = Scheduler_1.Scheduler.now; }
        var _this = _super.call(this, SchedulerAction, function () {
            if (AsyncScheduler.delegate && AsyncScheduler.delegate !== _this) {
                return AsyncScheduler.delegate.now();
            }
            else {
                return now();
            }
        }) || this;
        _this.actions = [];
        _this.active = false;
        _this.scheduled = undefined;
        return _this;
    }
    AsyncScheduler.prototype.schedule = function (work, delay, state) {
        if (delay === void 0) { delay = 0; }
        if (AsyncScheduler.delegate && AsyncScheduler.delegate !== this) {
            return AsyncScheduler.delegate.schedule(work, delay, state);
        }
        else {
            return _super.prototype.schedule.call(this, work, delay, state);
        }
    };
    AsyncScheduler.prototype.flush = function (action) {
        var actions = this.actions;
        if (this.active) {
            actions.push(action);
            return;
        }
        var error;
        this.active = true;
        do {
            if (error = action.execute(action.state, action.delay)) {
                break;
            }
        } while (action = actions.shift());
        this.active = false;
        if (error) {
            while (action = actions.shift()) {
                action.unsubscribe();
            }
            throw error;
        }
    };
    return AsyncScheduler;
}(Scheduler_1.Scheduler));
exports.AsyncScheduler = AsyncScheduler;

},{"../Scheduler":98}],247:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var AsyncAction_1 = require("./AsyncAction");
var QueueAction = (function (_super) {
    __extends(QueueAction, _super);
    function QueueAction(scheduler, work) {
        var _this = _super.call(this, scheduler, work) || this;
        _this.scheduler = scheduler;
        _this.work = work;
        return _this;
    }
    QueueAction.prototype.schedule = function (state, delay) {
        if (delay === void 0) { delay = 0; }
        if (delay > 0) {
            return _super.prototype.schedule.call(this, state, delay);
        }
        this.delay = delay;
        this.state = state;
        this.scheduler.flush(this);
        return this;
    };
    QueueAction.prototype.execute = function (state, delay) {
        return (delay > 0 || this.closed) ?
            _super.prototype.execute.call(this, state, delay) :
            this._execute(state, delay);
    };
    QueueAction.prototype.requestAsyncId = function (scheduler, id, delay) {
        if (delay === void 0) { delay = 0; }
        if ((delay !== null && delay > 0) || (delay === null && this.delay > 0)) {
            return _super.prototype.requestAsyncId.call(this, scheduler, id, delay);
        }
        return scheduler.flush(this);
    };
    return QueueAction;
}(AsyncAction_1.AsyncAction));
exports.QueueAction = QueueAction;

},{"./AsyncAction":245}],248:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var AsyncScheduler_1 = require("./AsyncScheduler");
var QueueScheduler = (function (_super) {
    __extends(QueueScheduler, _super);
    function QueueScheduler() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return QueueScheduler;
}(AsyncScheduler_1.AsyncScheduler));
exports.QueueScheduler = QueueScheduler;

},{"./AsyncScheduler":246}],249:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var AsyncAction_1 = require("./AsyncAction");
var AsyncScheduler_1 = require("./AsyncScheduler");
var VirtualTimeScheduler = (function (_super) {
    __extends(VirtualTimeScheduler, _super);
    function VirtualTimeScheduler(SchedulerAction, maxFrames) {
        if (SchedulerAction === void 0) { SchedulerAction = VirtualAction; }
        if (maxFrames === void 0) { maxFrames = Number.POSITIVE_INFINITY; }
        var _this = _super.call(this, SchedulerAction, function () { return _this.frame; }) || this;
        _this.maxFrames = maxFrames;
        _this.frame = 0;
        _this.index = -1;
        return _this;
    }
    VirtualTimeScheduler.prototype.flush = function () {
        var _a = this, actions = _a.actions, maxFrames = _a.maxFrames;
        var error, action;
        while ((action = actions[0]) && action.delay <= maxFrames) {
            actions.shift();
            this.frame = action.delay;
            if (error = action.execute(action.state, action.delay)) {
                break;
            }
        }
        if (error) {
            while (action = actions.shift()) {
                action.unsubscribe();
            }
            throw error;
        }
    };
    VirtualTimeScheduler.frameTimeFactor = 10;
    return VirtualTimeScheduler;
}(AsyncScheduler_1.AsyncScheduler));
exports.VirtualTimeScheduler = VirtualTimeScheduler;
var VirtualAction = (function (_super) {
    __extends(VirtualAction, _super);
    function VirtualAction(scheduler, work, index) {
        if (index === void 0) { index = scheduler.index += 1; }
        var _this = _super.call(this, scheduler, work) || this;
        _this.scheduler = scheduler;
        _this.work = work;
        _this.index = index;
        _this.active = true;
        _this.index = scheduler.index = index;
        return _this;
    }
    VirtualAction.prototype.schedule = function (state, delay) {
        if (delay === void 0) { delay = 0; }
        if (!this.id) {
            return _super.prototype.schedule.call(this, state, delay);
        }
        this.active = false;
        var action = new VirtualAction(this.scheduler, this.work);
        this.add(action);
        return action.schedule(state, delay);
    };
    VirtualAction.prototype.requestAsyncId = function (scheduler, id, delay) {
        if (delay === void 0) { delay = 0; }
        this.delay = scheduler.frame + delay;
        var actions = scheduler.actions;
        actions.push(this);
        actions.sort(VirtualAction.sortActions);
        return true;
    };
    VirtualAction.prototype.recycleAsyncId = function (scheduler, id, delay) {
        if (delay === void 0) { delay = 0; }
        return undefined;
    };
    VirtualAction.prototype._execute = function (state, delay) {
        if (this.active === true) {
            return _super.prototype._execute.call(this, state, delay);
        }
    };
    VirtualAction.sortActions = function (a, b) {
        if (a.delay === b.delay) {
            if (a.index === b.index) {
                return 0;
            }
            else if (a.index > b.index) {
                return 1;
            }
            else {
                return -1;
            }
        }
        else if (a.delay > b.delay) {
            return 1;
        }
        else {
            return -1;
        }
    };
    return VirtualAction;
}(AsyncAction_1.AsyncAction));
exports.VirtualAction = VirtualAction;

},{"./AsyncAction":245,"./AsyncScheduler":246}],250:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var AnimationFrameAction_1 = require("./AnimationFrameAction");
var AnimationFrameScheduler_1 = require("./AnimationFrameScheduler");
exports.animationFrame = new AnimationFrameScheduler_1.AnimationFrameScheduler(AnimationFrameAction_1.AnimationFrameAction);

},{"./AnimationFrameAction":241,"./AnimationFrameScheduler":242}],251:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var AsapAction_1 = require("./AsapAction");
var AsapScheduler_1 = require("./AsapScheduler");
exports.asap = new AsapScheduler_1.AsapScheduler(AsapAction_1.AsapAction);

},{"./AsapAction":243,"./AsapScheduler":244}],252:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var AsyncAction_1 = require("./AsyncAction");
var AsyncScheduler_1 = require("./AsyncScheduler");
exports.async = new AsyncScheduler_1.AsyncScheduler(AsyncAction_1.AsyncAction);

},{"./AsyncAction":245,"./AsyncScheduler":246}],253:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var QueueAction_1 = require("./QueueAction");
var QueueScheduler_1 = require("./QueueScheduler");
exports.queue = new QueueScheduler_1.QueueScheduler(QueueAction_1.QueueAction);

},{"./QueueAction":247,"./QueueScheduler":248}],254:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function getSymbolIterator() {
    if (typeof Symbol !== 'function' || !Symbol.iterator) {
        return '@@iterator';
    }
    return Symbol.iterator;
}
exports.getSymbolIterator = getSymbolIterator;
exports.iterator = getSymbolIterator();
exports.$$iterator = exports.iterator;

},{}],255:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.observable = typeof Symbol === 'function' && Symbol.observable || '@@observable';

},{}],256:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.rxSubscriber = typeof Symbol === 'function'
    ? Symbol('rxSubscriber')
    : '@@rxSubscriber_' + Math.random();
exports.$$rxSubscriber = exports.rxSubscriber;

},{}],257:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function ArgumentOutOfRangeErrorImpl() {
    Error.call(this);
    this.message = 'argument out of range';
    this.name = 'ArgumentOutOfRangeError';
    return this;
}
ArgumentOutOfRangeErrorImpl.prototype = Object.create(Error.prototype);
exports.ArgumentOutOfRangeError = ArgumentOutOfRangeErrorImpl;

},{}],258:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function EmptyErrorImpl() {
    Error.call(this);
    this.message = 'no elements in sequence';
    this.name = 'EmptyError';
    return this;
}
EmptyErrorImpl.prototype = Object.create(Error.prototype);
exports.EmptyError = EmptyErrorImpl;

},{}],259:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var nextHandle = 1;
var tasksByHandle = {};
function runIfPresent(handle) {
    var cb = tasksByHandle[handle];
    if (cb) {
        cb();
    }
}
exports.Immediate = {
    setImmediate: function (cb) {
        var handle = nextHandle++;
        tasksByHandle[handle] = cb;
        Promise.resolve().then(function () { return runIfPresent(handle); });
        return handle;
    },
    clearImmediate: function (handle) {
        delete tasksByHandle[handle];
    },
};

},{}],260:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function ObjectUnsubscribedErrorImpl() {
    Error.call(this);
    this.message = 'object unsubscribed';
    this.name = 'ObjectUnsubscribedError';
    return this;
}
ObjectUnsubscribedErrorImpl.prototype = Object.create(Error.prototype);
exports.ObjectUnsubscribedError = ObjectUnsubscribedErrorImpl;

},{}],261:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function TimeoutErrorImpl() {
    Error.call(this);
    this.message = 'Timeout has occurred';
    this.name = 'TimeoutError';
    return this;
}
TimeoutErrorImpl.prototype = Object.create(Error.prototype);
exports.TimeoutError = TimeoutErrorImpl;

},{}],262:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function UnsubscriptionErrorImpl(errors) {
    Error.call(this);
    this.message = errors ?
        errors.length + " errors occurred during unsubscription:\n" + errors.map(function (err, i) { return i + 1 + ") " + err.toString(); }).join('\n  ') : '';
    this.name = 'UnsubscriptionError';
    this.errors = errors;
    return this;
}
UnsubscriptionErrorImpl.prototype = Object.create(Error.prototype);
exports.UnsubscriptionError = UnsubscriptionErrorImpl;

},{}],263:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Subscriber_1 = require("../Subscriber");
function canReportError(observer) {
    while (observer) {
        var _a = observer, closed_1 = _a.closed, destination = _a.destination, isStopped = _a.isStopped;
        if (closed_1 || isStopped) {
            return false;
        }
        else if (destination && destination instanceof Subscriber_1.Subscriber) {
            observer = destination;
        }
        else {
            observer = null;
        }
    }
    return true;
}
exports.canReportError = canReportError;

},{"../Subscriber":101}],264:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function hostReportError(err) {
    setTimeout(function () { throw err; }, 0);
}
exports.hostReportError = hostReportError;

},{}],265:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function identity(x) {
    return x;
}
exports.identity = identity;

},{}],266:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isArray = Array.isArray || (function (x) { return x && typeof x.length === 'number'; });

},{}],267:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isArrayLike = (function (x) { return x && typeof x.length === 'number' && typeof x !== 'function'; });

},{}],268:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function isDate(value) {
    return value instanceof Date && !isNaN(+value);
}
exports.isDate = isDate;

},{}],269:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function isFunction(x) {
    return typeof x === 'function';
}
exports.isFunction = isFunction;

},{}],270:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var observable_1 = require("../symbol/observable");
function isInteropObservable(input) {
    return input && typeof input[observable_1.observable] === 'function';
}
exports.isInteropObservable = isInteropObservable;

},{"../symbol/observable":255}],271:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var iterator_1 = require("../symbol/iterator");
function isIterable(input) {
    return input && typeof input[iterator_1.iterator] === 'function';
}
exports.isIterable = isIterable;

},{"../symbol/iterator":254}],272:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var isArray_1 = require("./isArray");
function isNumeric(val) {
    return !isArray_1.isArray(val) && (val - parseFloat(val) + 1) >= 0;
}
exports.isNumeric = isNumeric;

},{"./isArray":266}],273:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function isObject(x) {
    return x !== null && typeof x === 'object';
}
exports.isObject = isObject;

},{}],274:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Observable_1 = require("../Observable");
function isObservable(obj) {
    return !!obj && (obj instanceof Observable_1.Observable || (typeof obj.lift === 'function' && typeof obj.subscribe === 'function'));
}
exports.isObservable = isObservable;

},{"../Observable":94}],275:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function isPromise(value) {
    return !!value && typeof value.subscribe !== 'function' && typeof value.then === 'function';
}
exports.isPromise = isPromise;

},{}],276:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function isScheduler(value) {
    return value && typeof value.schedule === 'function';
}
exports.isScheduler = isScheduler;

},{}],277:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function noop() { }
exports.noop = noop;

},{}],278:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function not(pred, thisArg) {
    function notPred() {
        return !(notPred.pred.apply(notPred.thisArg, arguments));
    }
    notPred.pred = pred;
    notPred.thisArg = thisArg;
    return notPred;
}
exports.not = not;

},{}],279:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var noop_1 = require("./noop");
function pipe() {
    var fns = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        fns[_i] = arguments[_i];
    }
    return pipeFromArray(fns);
}
exports.pipe = pipe;
function pipeFromArray(fns) {
    if (!fns) {
        return noop_1.noop;
    }
    if (fns.length === 1) {
        return fns[0];
    }
    return function piped(input) {
        return fns.reduce(function (prev, fn) { return fn(prev); }, input);
    };
}
exports.pipeFromArray = pipeFromArray;

},{"./noop":277}],280:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var subscribeToArray_1 = require("./subscribeToArray");
var subscribeToPromise_1 = require("./subscribeToPromise");
var subscribeToIterable_1 = require("./subscribeToIterable");
var subscribeToObservable_1 = require("./subscribeToObservable");
var isArrayLike_1 = require("./isArrayLike");
var isPromise_1 = require("./isPromise");
var isObject_1 = require("./isObject");
var iterator_1 = require("../symbol/iterator");
var observable_1 = require("../symbol/observable");
exports.subscribeTo = function (result) {
    if (!!result && typeof result[observable_1.observable] === 'function') {
        return subscribeToObservable_1.subscribeToObservable(result);
    }
    else if (isArrayLike_1.isArrayLike(result)) {
        return subscribeToArray_1.subscribeToArray(result);
    }
    else if (isPromise_1.isPromise(result)) {
        return subscribeToPromise_1.subscribeToPromise(result);
    }
    else if (!!result && typeof result[iterator_1.iterator] === 'function') {
        return subscribeToIterable_1.subscribeToIterable(result);
    }
    else {
        var value = isObject_1.isObject(result) ? 'an invalid object' : "'" + result + "'";
        var msg = "You provided " + value + " where a stream was expected."
            + ' You can provide an Observable, Promise, Array, or Iterable.';
        throw new TypeError(msg);
    }
};

},{"../symbol/iterator":254,"../symbol/observable":255,"./isArrayLike":267,"./isObject":273,"./isPromise":275,"./subscribeToArray":281,"./subscribeToIterable":282,"./subscribeToObservable":283,"./subscribeToPromise":284}],281:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.subscribeToArray = function (array) { return function (subscriber) {
    for (var i = 0, len = array.length; i < len && !subscriber.closed; i++) {
        subscriber.next(array[i]);
    }
    subscriber.complete();
}; };

},{}],282:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var iterator_1 = require("../symbol/iterator");
exports.subscribeToIterable = function (iterable) { return function (subscriber) {
    var iterator = iterable[iterator_1.iterator]();
    do {
        var item = iterator.next();
        if (item.done) {
            subscriber.complete();
            break;
        }
        subscriber.next(item.value);
        if (subscriber.closed) {
            break;
        }
    } while (true);
    if (typeof iterator.return === 'function') {
        subscriber.add(function () {
            if (iterator.return) {
                iterator.return();
            }
        });
    }
    return subscriber;
}; };

},{"../symbol/iterator":254}],283:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var observable_1 = require("../symbol/observable");
exports.subscribeToObservable = function (obj) { return function (subscriber) {
    var obs = obj[observable_1.observable]();
    if (typeof obs.subscribe !== 'function') {
        throw new TypeError('Provided object does not correctly implement Symbol.observable');
    }
    else {
        return obs.subscribe(subscriber);
    }
}; };

},{"../symbol/observable":255}],284:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var hostReportError_1 = require("./hostReportError");
exports.subscribeToPromise = function (promise) { return function (subscriber) {
    promise.then(function (value) {
        if (!subscriber.closed) {
            subscriber.next(value);
            subscriber.complete();
        }
    }, function (err) { return subscriber.error(err); })
        .then(null, hostReportError_1.hostReportError);
    return subscriber;
}; };

},{"./hostReportError":264}],285:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var InnerSubscriber_1 = require("../InnerSubscriber");
var subscribeTo_1 = require("./subscribeTo");
var Observable_1 = require("../Observable");
function subscribeToResult(outerSubscriber, result, outerValue, outerIndex, destination) {
    if (destination === void 0) { destination = new InnerSubscriber_1.InnerSubscriber(outerSubscriber, outerValue, outerIndex); }
    if (destination.closed) {
        return undefined;
    }
    if (result instanceof Observable_1.Observable) {
        return result.subscribe(destination);
    }
    return subscribeTo_1.subscribeTo(result)(destination);
}
exports.subscribeToResult = subscribeToResult;

},{"../InnerSubscriber":92,"../Observable":94,"./subscribeTo":280}],286:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Subscriber_1 = require("../Subscriber");
var rxSubscriber_1 = require("../symbol/rxSubscriber");
var Observer_1 = require("../Observer");
function toSubscriber(nextOrObserver, error, complete) {
    if (nextOrObserver) {
        if (nextOrObserver instanceof Subscriber_1.Subscriber) {
            return nextOrObserver;
        }
        if (nextOrObserver[rxSubscriber_1.rxSubscriber]) {
            return nextOrObserver[rxSubscriber_1.rxSubscriber]();
        }
    }
    if (!nextOrObserver && !error && !complete) {
        return new Subscriber_1.Subscriber(Observer_1.empty);
    }
    return new Subscriber_1.Subscriber(nextOrObserver, error, complete);
}
exports.toSubscriber = toSubscriber;

},{"../Observer":95,"../Subscriber":101,"../symbol/rxSubscriber":256}],287:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var audit_1 = require("../internal/operators/audit");
exports.audit = audit_1.audit;
var auditTime_1 = require("../internal/operators/auditTime");
exports.auditTime = auditTime_1.auditTime;
var buffer_1 = require("../internal/operators/buffer");
exports.buffer = buffer_1.buffer;
var bufferCount_1 = require("../internal/operators/bufferCount");
exports.bufferCount = bufferCount_1.bufferCount;
var bufferTime_1 = require("../internal/operators/bufferTime");
exports.bufferTime = bufferTime_1.bufferTime;
var bufferToggle_1 = require("../internal/operators/bufferToggle");
exports.bufferToggle = bufferToggle_1.bufferToggle;
var bufferWhen_1 = require("../internal/operators/bufferWhen");
exports.bufferWhen = bufferWhen_1.bufferWhen;
var catchError_1 = require("../internal/operators/catchError");
exports.catchError = catchError_1.catchError;
var combineAll_1 = require("../internal/operators/combineAll");
exports.combineAll = combineAll_1.combineAll;
var combineLatest_1 = require("../internal/operators/combineLatest");
exports.combineLatest = combineLatest_1.combineLatest;
var concat_1 = require("../internal/operators/concat");
exports.concat = concat_1.concat;
var concatAll_1 = require("../internal/operators/concatAll");
exports.concatAll = concatAll_1.concatAll;
var concatMap_1 = require("../internal/operators/concatMap");
exports.concatMap = concatMap_1.concatMap;
var concatMapTo_1 = require("../internal/operators/concatMapTo");
exports.concatMapTo = concatMapTo_1.concatMapTo;
var count_1 = require("../internal/operators/count");
exports.count = count_1.count;
var debounce_1 = require("../internal/operators/debounce");
exports.debounce = debounce_1.debounce;
var debounceTime_1 = require("../internal/operators/debounceTime");
exports.debounceTime = debounceTime_1.debounceTime;
var defaultIfEmpty_1 = require("../internal/operators/defaultIfEmpty");
exports.defaultIfEmpty = defaultIfEmpty_1.defaultIfEmpty;
var delay_1 = require("../internal/operators/delay");
exports.delay = delay_1.delay;
var delayWhen_1 = require("../internal/operators/delayWhen");
exports.delayWhen = delayWhen_1.delayWhen;
var dematerialize_1 = require("../internal/operators/dematerialize");
exports.dematerialize = dematerialize_1.dematerialize;
var distinct_1 = require("../internal/operators/distinct");
exports.distinct = distinct_1.distinct;
var distinctUntilChanged_1 = require("../internal/operators/distinctUntilChanged");
exports.distinctUntilChanged = distinctUntilChanged_1.distinctUntilChanged;
var distinctUntilKeyChanged_1 = require("../internal/operators/distinctUntilKeyChanged");
exports.distinctUntilKeyChanged = distinctUntilKeyChanged_1.distinctUntilKeyChanged;
var elementAt_1 = require("../internal/operators/elementAt");
exports.elementAt = elementAt_1.elementAt;
var endWith_1 = require("../internal/operators/endWith");
exports.endWith = endWith_1.endWith;
var every_1 = require("../internal/operators/every");
exports.every = every_1.every;
var exhaust_1 = require("../internal/operators/exhaust");
exports.exhaust = exhaust_1.exhaust;
var exhaustMap_1 = require("../internal/operators/exhaustMap");
exports.exhaustMap = exhaustMap_1.exhaustMap;
var expand_1 = require("../internal/operators/expand");
exports.expand = expand_1.expand;
var filter_1 = require("../internal/operators/filter");
exports.filter = filter_1.filter;
var finalize_1 = require("../internal/operators/finalize");
exports.finalize = finalize_1.finalize;
var find_1 = require("../internal/operators/find");
exports.find = find_1.find;
var findIndex_1 = require("../internal/operators/findIndex");
exports.findIndex = findIndex_1.findIndex;
var first_1 = require("../internal/operators/first");
exports.first = first_1.first;
var groupBy_1 = require("../internal/operators/groupBy");
exports.groupBy = groupBy_1.groupBy;
var ignoreElements_1 = require("../internal/operators/ignoreElements");
exports.ignoreElements = ignoreElements_1.ignoreElements;
var isEmpty_1 = require("../internal/operators/isEmpty");
exports.isEmpty = isEmpty_1.isEmpty;
var last_1 = require("../internal/operators/last");
exports.last = last_1.last;
var map_1 = require("../internal/operators/map");
exports.map = map_1.map;
var mapTo_1 = require("../internal/operators/mapTo");
exports.mapTo = mapTo_1.mapTo;
var materialize_1 = require("../internal/operators/materialize");
exports.materialize = materialize_1.materialize;
var max_1 = require("../internal/operators/max");
exports.max = max_1.max;
var merge_1 = require("../internal/operators/merge");
exports.merge = merge_1.merge;
var mergeAll_1 = require("../internal/operators/mergeAll");
exports.mergeAll = mergeAll_1.mergeAll;
var mergeMap_1 = require("../internal/operators/mergeMap");
exports.mergeMap = mergeMap_1.mergeMap;
var mergeMap_2 = require("../internal/operators/mergeMap");
exports.flatMap = mergeMap_2.mergeMap;
var mergeMapTo_1 = require("../internal/operators/mergeMapTo");
exports.mergeMapTo = mergeMapTo_1.mergeMapTo;
var mergeScan_1 = require("../internal/operators/mergeScan");
exports.mergeScan = mergeScan_1.mergeScan;
var min_1 = require("../internal/operators/min");
exports.min = min_1.min;
var multicast_1 = require("../internal/operators/multicast");
exports.multicast = multicast_1.multicast;
var observeOn_1 = require("../internal/operators/observeOn");
exports.observeOn = observeOn_1.observeOn;
var onErrorResumeNext_1 = require("../internal/operators/onErrorResumeNext");
exports.onErrorResumeNext = onErrorResumeNext_1.onErrorResumeNext;
var pairwise_1 = require("../internal/operators/pairwise");
exports.pairwise = pairwise_1.pairwise;
var partition_1 = require("../internal/operators/partition");
exports.partition = partition_1.partition;
var pluck_1 = require("../internal/operators/pluck");
exports.pluck = pluck_1.pluck;
var publish_1 = require("../internal/operators/publish");
exports.publish = publish_1.publish;
var publishBehavior_1 = require("../internal/operators/publishBehavior");
exports.publishBehavior = publishBehavior_1.publishBehavior;
var publishLast_1 = require("../internal/operators/publishLast");
exports.publishLast = publishLast_1.publishLast;
var publishReplay_1 = require("../internal/operators/publishReplay");
exports.publishReplay = publishReplay_1.publishReplay;
var race_1 = require("../internal/operators/race");
exports.race = race_1.race;
var reduce_1 = require("../internal/operators/reduce");
exports.reduce = reduce_1.reduce;
var repeat_1 = require("../internal/operators/repeat");
exports.repeat = repeat_1.repeat;
var repeatWhen_1 = require("../internal/operators/repeatWhen");
exports.repeatWhen = repeatWhen_1.repeatWhen;
var retry_1 = require("../internal/operators/retry");
exports.retry = retry_1.retry;
var retryWhen_1 = require("../internal/operators/retryWhen");
exports.retryWhen = retryWhen_1.retryWhen;
var refCount_1 = require("../internal/operators/refCount");
exports.refCount = refCount_1.refCount;
var sample_1 = require("../internal/operators/sample");
exports.sample = sample_1.sample;
var sampleTime_1 = require("../internal/operators/sampleTime");
exports.sampleTime = sampleTime_1.sampleTime;
var scan_1 = require("../internal/operators/scan");
exports.scan = scan_1.scan;
var sequenceEqual_1 = require("../internal/operators/sequenceEqual");
exports.sequenceEqual = sequenceEqual_1.sequenceEqual;
var share_1 = require("../internal/operators/share");
exports.share = share_1.share;
var shareReplay_1 = require("../internal/operators/shareReplay");
exports.shareReplay = shareReplay_1.shareReplay;
var single_1 = require("../internal/operators/single");
exports.single = single_1.single;
var skip_1 = require("../internal/operators/skip");
exports.skip = skip_1.skip;
var skipLast_1 = require("../internal/operators/skipLast");
exports.skipLast = skipLast_1.skipLast;
var skipUntil_1 = require("../internal/operators/skipUntil");
exports.skipUntil = skipUntil_1.skipUntil;
var skipWhile_1 = require("../internal/operators/skipWhile");
exports.skipWhile = skipWhile_1.skipWhile;
var startWith_1 = require("../internal/operators/startWith");
exports.startWith = startWith_1.startWith;
var subscribeOn_1 = require("../internal/operators/subscribeOn");
exports.subscribeOn = subscribeOn_1.subscribeOn;
var switchAll_1 = require("../internal/operators/switchAll");
exports.switchAll = switchAll_1.switchAll;
var switchMap_1 = require("../internal/operators/switchMap");
exports.switchMap = switchMap_1.switchMap;
var switchMapTo_1 = require("../internal/operators/switchMapTo");
exports.switchMapTo = switchMapTo_1.switchMapTo;
var take_1 = require("../internal/operators/take");
exports.take = take_1.take;
var takeLast_1 = require("../internal/operators/takeLast");
exports.takeLast = takeLast_1.takeLast;
var takeUntil_1 = require("../internal/operators/takeUntil");
exports.takeUntil = takeUntil_1.takeUntil;
var takeWhile_1 = require("../internal/operators/takeWhile");
exports.takeWhile = takeWhile_1.takeWhile;
var tap_1 = require("../internal/operators/tap");
exports.tap = tap_1.tap;
var throttle_1 = require("../internal/operators/throttle");
exports.throttle = throttle_1.throttle;
var throttleTime_1 = require("../internal/operators/throttleTime");
exports.throttleTime = throttleTime_1.throttleTime;
var throwIfEmpty_1 = require("../internal/operators/throwIfEmpty");
exports.throwIfEmpty = throwIfEmpty_1.throwIfEmpty;
var timeInterval_1 = require("../internal/operators/timeInterval");
exports.timeInterval = timeInterval_1.timeInterval;
var timeout_1 = require("../internal/operators/timeout");
exports.timeout = timeout_1.timeout;
var timeoutWith_1 = require("../internal/operators/timeoutWith");
exports.timeoutWith = timeoutWith_1.timeoutWith;
var timestamp_1 = require("../internal/operators/timestamp");
exports.timestamp = timestamp_1.timestamp;
var toArray_1 = require("../internal/operators/toArray");
exports.toArray = toArray_1.toArray;
var window_1 = require("../internal/operators/window");
exports.window = window_1.window;
var windowCount_1 = require("../internal/operators/windowCount");
exports.windowCount = windowCount_1.windowCount;
var windowTime_1 = require("../internal/operators/windowTime");
exports.windowTime = windowTime_1.windowTime;
var windowToggle_1 = require("../internal/operators/windowToggle");
exports.windowToggle = windowToggle_1.windowToggle;
var windowWhen_1 = require("../internal/operators/windowWhen");
exports.windowWhen = windowWhen_1.windowWhen;
var withLatestFrom_1 = require("../internal/operators/withLatestFrom");
exports.withLatestFrom = withLatestFrom_1.withLatestFrom;
var zip_1 = require("../internal/operators/zip");
exports.zip = zip_1.zip;
var zipAll_1 = require("../internal/operators/zipAll");
exports.zipAll = zipAll_1.zipAll;

},{"../internal/operators/audit":132,"../internal/operators/auditTime":133,"../internal/operators/buffer":134,"../internal/operators/bufferCount":135,"../internal/operators/bufferTime":136,"../internal/operators/bufferToggle":137,"../internal/operators/bufferWhen":138,"../internal/operators/catchError":139,"../internal/operators/combineAll":140,"../internal/operators/combineLatest":141,"../internal/operators/concat":142,"../internal/operators/concatAll":143,"../internal/operators/concatMap":144,"../internal/operators/concatMapTo":145,"../internal/operators/count":146,"../internal/operators/debounce":147,"../internal/operators/debounceTime":148,"../internal/operators/defaultIfEmpty":149,"../internal/operators/delay":150,"../internal/operators/delayWhen":151,"../internal/operators/dematerialize":152,"../internal/operators/distinct":153,"../internal/operators/distinctUntilChanged":154,"../internal/operators/distinctUntilKeyChanged":155,"../internal/operators/elementAt":156,"../internal/operators/endWith":157,"../internal/operators/every":158,"../internal/operators/exhaust":159,"../internal/operators/exhaustMap":160,"../internal/operators/expand":161,"../internal/operators/filter":162,"../internal/operators/finalize":163,"../internal/operators/find":164,"../internal/operators/findIndex":165,"../internal/operators/first":166,"../internal/operators/groupBy":167,"../internal/operators/ignoreElements":168,"../internal/operators/isEmpty":169,"../internal/operators/last":170,"../internal/operators/map":171,"../internal/operators/mapTo":172,"../internal/operators/materialize":173,"../internal/operators/max":174,"../internal/operators/merge":175,"../internal/operators/mergeAll":176,"../internal/operators/mergeMap":177,"../internal/operators/mergeMapTo":178,"../internal/operators/mergeScan":179,"../internal/operators/min":180,"../internal/operators/multicast":181,"../internal/operators/observeOn":182,"../internal/operators/onErrorResumeNext":183,"../internal/operators/pairwise":184,"../internal/operators/partition":185,"../internal/operators/pluck":186,"../internal/operators/publish":187,"../internal/operators/publishBehavior":188,"../internal/operators/publishLast":189,"../internal/operators/publishReplay":190,"../internal/operators/race":191,"../internal/operators/reduce":192,"../internal/operators/refCount":193,"../internal/operators/repeat":194,"../internal/operators/repeatWhen":195,"../internal/operators/retry":196,"../internal/operators/retryWhen":197,"../internal/operators/sample":198,"../internal/operators/sampleTime":199,"../internal/operators/scan":200,"../internal/operators/sequenceEqual":201,"../internal/operators/share":202,"../internal/operators/shareReplay":203,"../internal/operators/single":204,"../internal/operators/skip":205,"../internal/operators/skipLast":206,"../internal/operators/skipUntil":207,"../internal/operators/skipWhile":208,"../internal/operators/startWith":209,"../internal/operators/subscribeOn":210,"../internal/operators/switchAll":211,"../internal/operators/switchMap":212,"../internal/operators/switchMapTo":213,"../internal/operators/take":214,"../internal/operators/takeLast":215,"../internal/operators/takeUntil":216,"../internal/operators/takeWhile":217,"../internal/operators/tap":218,"../internal/operators/throttle":219,"../internal/operators/throttleTime":220,"../internal/operators/throwIfEmpty":221,"../internal/operators/timeInterval":222,"../internal/operators/timeout":223,"../internal/operators/timeoutWith":224,"../internal/operators/timestamp":225,"../internal/operators/toArray":226,"../internal/operators/window":227,"../internal/operators/windowCount":228,"../internal/operators/windowTime":229,"../internal/operators/windowToggle":230,"../internal/operators/windowWhen":231,"../internal/operators/withLatestFrom":232,"../internal/operators/zip":233,"../internal/operators/zipAll":234}],288:[function(require,module,exports){
/* eslint-disable node/no-deprecated-api */
var buffer = require('buffer')
var Buffer = buffer.Buffer

// alternative to using Object.keys for old browsers
function copyProps (src, dst) {
  for (var key in src) {
    dst[key] = src[key]
  }
}
if (Buffer.from && Buffer.alloc && Buffer.allocUnsafe && Buffer.allocUnsafeSlow) {
  module.exports = buffer
} else {
  // Copy properties from require('buffer')
  copyProps(buffer, exports)
  exports.Buffer = SafeBuffer
}

function SafeBuffer (arg, encodingOrOffset, length) {
  return Buffer(arg, encodingOrOffset, length)
}

// Copy static methods from Buffer
copyProps(Buffer, SafeBuffer)

SafeBuffer.from = function (arg, encodingOrOffset, length) {
  if (typeof arg === 'number') {
    throw new TypeError('Argument must not be a number')
  }
  return Buffer(arg, encodingOrOffset, length)
}

SafeBuffer.alloc = function (size, fill, encoding) {
  if (typeof size !== 'number') {
    throw new TypeError('Argument must be a number')
  }
  var buf = Buffer(size)
  if (fill !== undefined) {
    if (typeof encoding === 'string') {
      buf.fill(fill, encoding)
    } else {
      buf.fill(fill)
    }
  } else {
    buf.fill(0)
  }
  return buf
}

SafeBuffer.allocUnsafe = function (size) {
  if (typeof size !== 'number') {
    throw new TypeError('Argument must be a number')
  }
  return Buffer(size)
}

SafeBuffer.allocUnsafeSlow = function (size) {
  if (typeof size !== 'number') {
    throw new TypeError('Argument must be a number')
  }
  return buffer.SlowBuffer(size)
}

},{"buffer":53}],289:[function(require,module,exports){
// Copyright Joyent, Inc. and other Node contributors.
//
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to permit
// persons to whom the Software is furnished to do so, subject to the
// following conditions:
//
// The above copyright notice and this permission notice shall be included
// in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
// USE OR OTHER DEALINGS IN THE SOFTWARE.

module.exports = Stream;

var EE = require('events').EventEmitter;
var inherits = require('inherits');

inherits(Stream, EE);
Stream.Readable = require('readable-stream/readable.js');
Stream.Writable = require('readable-stream/writable.js');
Stream.Duplex = require('readable-stream/duplex.js');
Stream.Transform = require('readable-stream/transform.js');
Stream.PassThrough = require('readable-stream/passthrough.js');

// Backwards-compat with node 0.4.x
Stream.Stream = Stream;



// old-style streams.  Note that the pipe method (the only relevant
// part of this class) is overridden in the Readable class.

function Stream() {
  EE.call(this);
}

Stream.prototype.pipe = function(dest, options) {
  var source = this;

  function ondata(chunk) {
    if (dest.writable) {
      if (false === dest.write(chunk) && source.pause) {
        source.pause();
      }
    }
  }

  source.on('data', ondata);

  function ondrain() {
    if (source.readable && source.resume) {
      source.resume();
    }
  }

  dest.on('drain', ondrain);

  // If the 'end' option is not supplied, dest.end() will be called when
  // source gets the 'end' or 'close' events.  Only dest.end() once.
  if (!dest._isStdio && (!options || options.end !== false)) {
    source.on('end', onend);
    source.on('close', onclose);
  }

  var didOnEnd = false;
  function onend() {
    if (didOnEnd) return;
    didOnEnd = true;

    dest.end();
  }


  function onclose() {
    if (didOnEnd) return;
    didOnEnd = true;

    if (typeof dest.destroy === 'function') dest.destroy();
  }

  // don't leave dangling pipes when there are errors.
  function onerror(er) {
    cleanup();
    if (EE.listenerCount(this, 'error') === 0) {
      throw er; // Unhandled stream error in pipe.
    }
  }

  source.on('error', onerror);
  dest.on('error', onerror);

  // remove all the event listeners that were added.
  function cleanup() {
    source.removeListener('data', ondata);
    dest.removeListener('drain', ondrain);

    source.removeListener('end', onend);
    source.removeListener('close', onclose);

    source.removeListener('error', onerror);
    dest.removeListener('error', onerror);

    source.removeListener('end', cleanup);
    source.removeListener('close', cleanup);

    dest.removeListener('close', cleanup);
  }

  source.on('end', cleanup);
  source.on('close', cleanup);

  dest.on('close', cleanup);

  dest.emit('pipe', source);

  // Allow for unix-like usage: A.pipe(B).pipe(C)
  return dest;
};

},{"events":55,"inherits":58,"readable-stream/duplex.js":75,"readable-stream/passthrough.js":85,"readable-stream/readable.js":86,"readable-stream/transform.js":87,"readable-stream/writable.js":88}],290:[function(require,module,exports){
(function (setImmediate,clearImmediate){
var nextTick = require('process/browser.js').nextTick;
var apply = Function.prototype.apply;
var slice = Array.prototype.slice;
var immediateIds = {};
var nextImmediateId = 0;

// DOM APIs, for completeness

exports.setTimeout = function() {
  return new Timeout(apply.call(setTimeout, window, arguments), clearTimeout);
};
exports.setInterval = function() {
  return new Timeout(apply.call(setInterval, window, arguments), clearInterval);
};
exports.clearTimeout =
exports.clearInterval = function(timeout) { timeout.close(); };

function Timeout(id, clearFn) {
  this._id = id;
  this._clearFn = clearFn;
}
Timeout.prototype.unref = Timeout.prototype.ref = function() {};
Timeout.prototype.close = function() {
  this._clearFn.call(window, this._id);
};

// Does not start the time, just sets up the members needed.
exports.enroll = function(item, msecs) {
  clearTimeout(item._idleTimeoutId);
  item._idleTimeout = msecs;
};

exports.unenroll = function(item) {
  clearTimeout(item._idleTimeoutId);
  item._idleTimeout = -1;
};

exports._unrefActive = exports.active = function(item) {
  clearTimeout(item._idleTimeoutId);

  var msecs = item._idleTimeout;
  if (msecs >= 0) {
    item._idleTimeoutId = setTimeout(function onTimeout() {
      if (item._onTimeout)
        item._onTimeout();
    }, msecs);
  }
};

// That's not how node.js implements it but the exposed api is the same.
exports.setImmediate = typeof setImmediate === "function" ? setImmediate : function(fn) {
  var id = nextImmediateId++;
  var args = arguments.length < 2 ? false : slice.call(arguments, 1);

  immediateIds[id] = true;

  nextTick(function onNextTick() {
    if (immediateIds[id]) {
      // fn.call() is faster so we optimize for the common use-case
      // @see http://jsperf.com/call-apply-segu
      if (args) {
        fn.apply(null, args);
      } else {
        fn.call(null);
      }
      // Prevent ids from leaking
      exports.clearImmediate(id);
    }
  });

  return id;
};

exports.clearImmediate = typeof clearImmediate === "function" ? clearImmediate : function(id) {
  delete immediateIds[id];
};
}).call(this,require("timers").setImmediate,require("timers").clearImmediate)

},{"process/browser.js":74,"timers":290}],291:[function(require,module,exports){
/** @license URI.js v4.2.1 (c) 2011 Gary Court. License: http://github.com/garycourt/uri-js */
(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
	typeof define === 'function' && define.amd ? define(['exports'], factory) :
	(factory((global.URI = global.URI || {})));
}(this, (function (exports) { 'use strict';

function merge() {
    for (var _len = arguments.length, sets = Array(_len), _key = 0; _key < _len; _key++) {
        sets[_key] = arguments[_key];
    }

    if (sets.length > 1) {
        sets[0] = sets[0].slice(0, -1);
        var xl = sets.length - 1;
        for (var x = 1; x < xl; ++x) {
            sets[x] = sets[x].slice(1, -1);
        }
        sets[xl] = sets[xl].slice(1);
        return sets.join('');
    } else {
        return sets[0];
    }
}
function subexp(str) {
    return "(?:" + str + ")";
}
function typeOf(o) {
    return o === undefined ? "undefined" : o === null ? "null" : Object.prototype.toString.call(o).split(" ").pop().split("]").shift().toLowerCase();
}
function toUpperCase(str) {
    return str.toUpperCase();
}
function toArray(obj) {
    return obj !== undefined && obj !== null ? obj instanceof Array ? obj : typeof obj.length !== "number" || obj.split || obj.setInterval || obj.call ? [obj] : Array.prototype.slice.call(obj) : [];
}
function assign(target, source) {
    var obj = target;
    if (source) {
        for (var key in source) {
            obj[key] = source[key];
        }
    }
    return obj;
}

function buildExps(isIRI) {
    var ALPHA$$ = "[A-Za-z]",
        CR$ = "[\\x0D]",
        DIGIT$$ = "[0-9]",
        DQUOTE$$ = "[\\x22]",
        HEXDIG$$ = merge(DIGIT$$, "[A-Fa-f]"),
        //case-insensitive
    LF$$ = "[\\x0A]",
        SP$$ = "[\\x20]",
        PCT_ENCODED$ = subexp(subexp("%[EFef]" + HEXDIG$$ + "%" + HEXDIG$$ + HEXDIG$$ + "%" + HEXDIG$$ + HEXDIG$$) + "|" + subexp("%[89A-Fa-f]" + HEXDIG$$ + "%" + HEXDIG$$ + HEXDIG$$) + "|" + subexp("%" + HEXDIG$$ + HEXDIG$$)),
        //expanded
    GEN_DELIMS$$ = "[\\:\\/\\?\\#\\[\\]\\@]",
        SUB_DELIMS$$ = "[\\!\\$\\&\\'\\(\\)\\*\\+\\,\\;\\=]",
        RESERVED$$ = merge(GEN_DELIMS$$, SUB_DELIMS$$),
        UCSCHAR$$ = isIRI ? "[\\xA0-\\u200D\\u2010-\\u2029\\u202F-\\uD7FF\\uF900-\\uFDCF\\uFDF0-\\uFFEF]" : "[]",
        //subset, excludes bidi control characters
    IPRIVATE$$ = isIRI ? "[\\uE000-\\uF8FF]" : "[]",
        //subset
    UNRESERVED$$ = merge(ALPHA$$, DIGIT$$, "[\\-\\.\\_\\~]", UCSCHAR$$),
        SCHEME$ = subexp(ALPHA$$ + merge(ALPHA$$, DIGIT$$, "[\\+\\-\\.]") + "*"),
        USERINFO$ = subexp(subexp(PCT_ENCODED$ + "|" + merge(UNRESERVED$$, SUB_DELIMS$$, "[\\:]")) + "*"),
        DEC_OCTET$ = subexp(subexp("25[0-5]") + "|" + subexp("2[0-4]" + DIGIT$$) + "|" + subexp("1" + DIGIT$$ + DIGIT$$) + "|" + subexp("[1-9]" + DIGIT$$) + "|" + DIGIT$$),
        DEC_OCTET_RELAXED$ = subexp(subexp("25[0-5]") + "|" + subexp("2[0-4]" + DIGIT$$) + "|" + subexp("1" + DIGIT$$ + DIGIT$$) + "|" + subexp("0?[1-9]" + DIGIT$$) + "|0?0?" + DIGIT$$),
        //relaxed parsing rules
    IPV4ADDRESS$ = subexp(DEC_OCTET_RELAXED$ + "\\." + DEC_OCTET_RELAXED$ + "\\." + DEC_OCTET_RELAXED$ + "\\." + DEC_OCTET_RELAXED$),
        H16$ = subexp(HEXDIG$$ + "{1,4}"),
        LS32$ = subexp(subexp(H16$ + "\\:" + H16$) + "|" + IPV4ADDRESS$),
        IPV6ADDRESS1$ = subexp(subexp(H16$ + "\\:") + "{6}" + LS32$),
        //                           6( h16 ":" ) ls32
    IPV6ADDRESS2$ = subexp("\\:\\:" + subexp(H16$ + "\\:") + "{5}" + LS32$),
        //                      "::" 5( h16 ":" ) ls32
    IPV6ADDRESS3$ = subexp(subexp(H16$) + "?\\:\\:" + subexp(H16$ + "\\:") + "{4}" + LS32$),
        //[               h16 ] "::" 4( h16 ":" ) ls32
    IPV6ADDRESS4$ = subexp(subexp(subexp(H16$ + "\\:") + "{0,1}" + H16$) + "?\\:\\:" + subexp(H16$ + "\\:") + "{3}" + LS32$),
        //[ *1( h16 ":" ) h16 ] "::" 3( h16 ":" ) ls32
    IPV6ADDRESS5$ = subexp(subexp(subexp(H16$ + "\\:") + "{0,2}" + H16$) + "?\\:\\:" + subexp(H16$ + "\\:") + "{2}" + LS32$),
        //[ *2( h16 ":" ) h16 ] "::" 2( h16 ":" ) ls32
    IPV6ADDRESS6$ = subexp(subexp(subexp(H16$ + "\\:") + "{0,3}" + H16$) + "?\\:\\:" + H16$ + "\\:" + LS32$),
        //[ *3( h16 ":" ) h16 ] "::"    h16 ":"   ls32
    IPV6ADDRESS7$ = subexp(subexp(subexp(H16$ + "\\:") + "{0,4}" + H16$) + "?\\:\\:" + LS32$),
        //[ *4( h16 ":" ) h16 ] "::"              ls32
    IPV6ADDRESS8$ = subexp(subexp(subexp(H16$ + "\\:") + "{0,5}" + H16$) + "?\\:\\:" + H16$),
        //[ *5( h16 ":" ) h16 ] "::"              h16
    IPV6ADDRESS9$ = subexp(subexp(subexp(H16$ + "\\:") + "{0,6}" + H16$) + "?\\:\\:"),
        //[ *6( h16 ":" ) h16 ] "::"
    IPV6ADDRESS$ = subexp([IPV6ADDRESS1$, IPV6ADDRESS2$, IPV6ADDRESS3$, IPV6ADDRESS4$, IPV6ADDRESS5$, IPV6ADDRESS6$, IPV6ADDRESS7$, IPV6ADDRESS8$, IPV6ADDRESS9$].join("|")),
        ZONEID$ = subexp(subexp(UNRESERVED$$ + "|" + PCT_ENCODED$) + "+"),
        //RFC 6874
    IPV6ADDRZ$ = subexp(IPV6ADDRESS$ + "\\%25" + ZONEID$),
        //RFC 6874
    IPV6ADDRZ_RELAXED$ = subexp(IPV6ADDRESS$ + subexp("\\%25|\\%(?!" + HEXDIG$$ + "{2})") + ZONEID$),
        //RFC 6874, with relaxed parsing rules
    IPVFUTURE$ = subexp("[vV]" + HEXDIG$$ + "+\\." + merge(UNRESERVED$$, SUB_DELIMS$$, "[\\:]") + "+"),
        IP_LITERAL$ = subexp("\\[" + subexp(IPV6ADDRZ_RELAXED$ + "|" + IPV6ADDRESS$ + "|" + IPVFUTURE$) + "\\]"),
        //RFC 6874
    REG_NAME$ = subexp(subexp(PCT_ENCODED$ + "|" + merge(UNRESERVED$$, SUB_DELIMS$$)) + "*"),
        HOST$ = subexp(IP_LITERAL$ + "|" + IPV4ADDRESS$ + "(?!" + REG_NAME$ + ")" + "|" + REG_NAME$),
        PORT$ = subexp(DIGIT$$ + "*"),
        AUTHORITY$ = subexp(subexp(USERINFO$ + "@") + "?" + HOST$ + subexp("\\:" + PORT$) + "?"),
        PCHAR$ = subexp(PCT_ENCODED$ + "|" + merge(UNRESERVED$$, SUB_DELIMS$$, "[\\:\\@]")),
        SEGMENT$ = subexp(PCHAR$ + "*"),
        SEGMENT_NZ$ = subexp(PCHAR$ + "+"),
        SEGMENT_NZ_NC$ = subexp(subexp(PCT_ENCODED$ + "|" + merge(UNRESERVED$$, SUB_DELIMS$$, "[\\@]")) + "+"),
        PATH_ABEMPTY$ = subexp(subexp("\\/" + SEGMENT$) + "*"),
        PATH_ABSOLUTE$ = subexp("\\/" + subexp(SEGMENT_NZ$ + PATH_ABEMPTY$) + "?"),
        //simplified
    PATH_NOSCHEME$ = subexp(SEGMENT_NZ_NC$ + PATH_ABEMPTY$),
        //simplified
    PATH_ROOTLESS$ = subexp(SEGMENT_NZ$ + PATH_ABEMPTY$),
        //simplified
    PATH_EMPTY$ = "(?!" + PCHAR$ + ")",
        PATH$ = subexp(PATH_ABEMPTY$ + "|" + PATH_ABSOLUTE$ + "|" + PATH_NOSCHEME$ + "|" + PATH_ROOTLESS$ + "|" + PATH_EMPTY$),
        QUERY$ = subexp(subexp(PCHAR$ + "|" + merge("[\\/\\?]", IPRIVATE$$)) + "*"),
        FRAGMENT$ = subexp(subexp(PCHAR$ + "|[\\/\\?]") + "*"),
        HIER_PART$ = subexp(subexp("\\/\\/" + AUTHORITY$ + PATH_ABEMPTY$) + "|" + PATH_ABSOLUTE$ + "|" + PATH_ROOTLESS$ + "|" + PATH_EMPTY$),
        URI$ = subexp(SCHEME$ + "\\:" + HIER_PART$ + subexp("\\?" + QUERY$) + "?" + subexp("\\#" + FRAGMENT$) + "?"),
        RELATIVE_PART$ = subexp(subexp("\\/\\/" + AUTHORITY$ + PATH_ABEMPTY$) + "|" + PATH_ABSOLUTE$ + "|" + PATH_NOSCHEME$ + "|" + PATH_EMPTY$),
        RELATIVE$ = subexp(RELATIVE_PART$ + subexp("\\?" + QUERY$) + "?" + subexp("\\#" + FRAGMENT$) + "?"),
        URI_REFERENCE$ = subexp(URI$ + "|" + RELATIVE$),
        ABSOLUTE_URI$ = subexp(SCHEME$ + "\\:" + HIER_PART$ + subexp("\\?" + QUERY$) + "?"),
        GENERIC_REF$ = "^(" + SCHEME$ + ")\\:" + subexp(subexp("\\/\\/(" + subexp("(" + USERINFO$ + ")@") + "?(" + HOST$ + ")" + subexp("\\:(" + PORT$ + ")") + "?)") + "?(" + PATH_ABEMPTY$ + "|" + PATH_ABSOLUTE$ + "|" + PATH_ROOTLESS$ + "|" + PATH_EMPTY$ + ")") + subexp("\\?(" + QUERY$ + ")") + "?" + subexp("\\#(" + FRAGMENT$ + ")") + "?$",
        RELATIVE_REF$ = "^(){0}" + subexp(subexp("\\/\\/(" + subexp("(" + USERINFO$ + ")@") + "?(" + HOST$ + ")" + subexp("\\:(" + PORT$ + ")") + "?)") + "?(" + PATH_ABEMPTY$ + "|" + PATH_ABSOLUTE$ + "|" + PATH_NOSCHEME$ + "|" + PATH_EMPTY$ + ")") + subexp("\\?(" + QUERY$ + ")") + "?" + subexp("\\#(" + FRAGMENT$ + ")") + "?$",
        ABSOLUTE_REF$ = "^(" + SCHEME$ + ")\\:" + subexp(subexp("\\/\\/(" + subexp("(" + USERINFO$ + ")@") + "?(" + HOST$ + ")" + subexp("\\:(" + PORT$ + ")") + "?)") + "?(" + PATH_ABEMPTY$ + "|" + PATH_ABSOLUTE$ + "|" + PATH_ROOTLESS$ + "|" + PATH_EMPTY$ + ")") + subexp("\\?(" + QUERY$ + ")") + "?$",
        SAMEDOC_REF$ = "^" + subexp("\\#(" + FRAGMENT$ + ")") + "?$",
        AUTHORITY_REF$ = "^" + subexp("(" + USERINFO$ + ")@") + "?(" + HOST$ + ")" + subexp("\\:(" + PORT$ + ")") + "?$";
    return {
        NOT_SCHEME: new RegExp(merge("[^]", ALPHA$$, DIGIT$$, "[\\+\\-\\.]"), "g"),
        NOT_USERINFO: new RegExp(merge("[^\\%\\:]", UNRESERVED$$, SUB_DELIMS$$), "g"),
        NOT_HOST: new RegExp(merge("[^\\%\\[\\]\\:]", UNRESERVED$$, SUB_DELIMS$$), "g"),
        NOT_PATH: new RegExp(merge("[^\\%\\/\\:\\@]", UNRESERVED$$, SUB_DELIMS$$), "g"),
        NOT_PATH_NOSCHEME: new RegExp(merge("[^\\%\\/\\@]", UNRESERVED$$, SUB_DELIMS$$), "g"),
        NOT_QUERY: new RegExp(merge("[^\\%]", UNRESERVED$$, SUB_DELIMS$$, "[\\:\\@\\/\\?]", IPRIVATE$$), "g"),
        NOT_FRAGMENT: new RegExp(merge("[^\\%]", UNRESERVED$$, SUB_DELIMS$$, "[\\:\\@\\/\\?]"), "g"),
        ESCAPE: new RegExp(merge("[^]", UNRESERVED$$, SUB_DELIMS$$), "g"),
        UNRESERVED: new RegExp(UNRESERVED$$, "g"),
        OTHER_CHARS: new RegExp(merge("[^\\%]", UNRESERVED$$, RESERVED$$), "g"),
        PCT_ENCODED: new RegExp(PCT_ENCODED$, "g"),
        IPV4ADDRESS: new RegExp("^(" + IPV4ADDRESS$ + ")$"),
        IPV6ADDRESS: new RegExp("^\\[?(" + IPV6ADDRESS$ + ")" + subexp(subexp("\\%25|\\%(?!" + HEXDIG$$ + "{2})") + "(" + ZONEID$ + ")") + "?\\]?$") //RFC 6874, with relaxed parsing rules
    };
}
var URI_PROTOCOL = buildExps(false);

var IRI_PROTOCOL = buildExps(true);

var slicedToArray = function () {
  function sliceIterator(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"]) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  return function (arr, i) {
    if (Array.isArray(arr)) {
      return arr;
    } else if (Symbol.iterator in Object(arr)) {
      return sliceIterator(arr, i);
    } else {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }
  };
}();













var toConsumableArray = function (arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  } else {
    return Array.from(arr);
  }
};

/** Highest positive signed 32-bit float value */

var maxInt = 2147483647; // aka. 0x7FFFFFFF or 2^31-1

/** Bootstring parameters */
var base = 36;
var tMin = 1;
var tMax = 26;
var skew = 38;
var damp = 700;
var initialBias = 72;
var initialN = 128; // 0x80
var delimiter = '-'; // '\x2D'

/** Regular expressions */
var regexPunycode = /^xn--/;
var regexNonASCII = /[^\0-\x7E]/; // non-ASCII chars
var regexSeparators = /[\x2E\u3002\uFF0E\uFF61]/g; // RFC 3490 separators

/** Error messages */
var errors = {
	'overflow': 'Overflow: input needs wider integers to process',
	'not-basic': 'Illegal input >= 0x80 (not a basic code point)',
	'invalid-input': 'Invalid input'
};

/** Convenience shortcuts */
var baseMinusTMin = base - tMin;
var floor = Math.floor;
var stringFromCharCode = String.fromCharCode;

/*--------------------------------------------------------------------------*/

/**
 * A generic error utility function.
 * @private
 * @param {String} type The error type.
 * @returns {Error} Throws a `RangeError` with the applicable error message.
 */
function error$1(type) {
	throw new RangeError(errors[type]);
}

/**
 * A generic `Array#map` utility function.
 * @private
 * @param {Array} array The array to iterate over.
 * @param {Function} callback The function that gets called for every array
 * item.
 * @returns {Array} A new array of values returned by the callback function.
 */
function map(array, fn) {
	var result = [];
	var length = array.length;
	while (length--) {
		result[length] = fn(array[length]);
	}
	return result;
}

/**
 * A simple `Array#map`-like wrapper to work with domain name strings or email
 * addresses.
 * @private
 * @param {String} domain The domain name or email address.
 * @param {Function} callback The function that gets called for every
 * character.
 * @returns {Array} A new string of characters returned by the callback
 * function.
 */
function mapDomain(string, fn) {
	var parts = string.split('@');
	var result = '';
	if (parts.length > 1) {
		// In email addresses, only the domain name should be punycoded. Leave
		// the local part (i.e. everything up to `@`) intact.
		result = parts[0] + '@';
		string = parts[1];
	}
	// Avoid `split(regex)` for IE8 compatibility. See #17.
	string = string.replace(regexSeparators, '\x2E');
	var labels = string.split('.');
	var encoded = map(labels, fn).join('.');
	return result + encoded;
}

/**
 * Creates an array containing the numeric code points of each Unicode
 * character in the string. While JavaScript uses UCS-2 internally,
 * this function will convert a pair of surrogate halves (each of which
 * UCS-2 exposes as separate characters) into a single code point,
 * matching UTF-16.
 * @see `punycode.ucs2.encode`
 * @see <https://mathiasbynens.be/notes/javascript-encoding>
 * @memberOf punycode.ucs2
 * @name decode
 * @param {String} string The Unicode input string (UCS-2).
 * @returns {Array} The new array of code points.
 */
function ucs2decode(string) {
	var output = [];
	var counter = 0;
	var length = string.length;
	while (counter < length) {
		var value = string.charCodeAt(counter++);
		if (value >= 0xD800 && value <= 0xDBFF && counter < length) {
			// It's a high surrogate, and there is a next character.
			var extra = string.charCodeAt(counter++);
			if ((extra & 0xFC00) == 0xDC00) {
				// Low surrogate.
				output.push(((value & 0x3FF) << 10) + (extra & 0x3FF) + 0x10000);
			} else {
				// It's an unmatched surrogate; only append this code unit, in case the
				// next code unit is the high surrogate of a surrogate pair.
				output.push(value);
				counter--;
			}
		} else {
			output.push(value);
		}
	}
	return output;
}

/**
 * Creates a string based on an array of numeric code points.
 * @see `punycode.ucs2.decode`
 * @memberOf punycode.ucs2
 * @name encode
 * @param {Array} codePoints The array of numeric code points.
 * @returns {String} The new Unicode string (UCS-2).
 */
var ucs2encode = function ucs2encode(array) {
	return String.fromCodePoint.apply(String, toConsumableArray(array));
};

/**
 * Converts a basic code point into a digit/integer.
 * @see `digitToBasic()`
 * @private
 * @param {Number} codePoint The basic numeric code point value.
 * @returns {Number} The numeric value of a basic code point (for use in
 * representing integers) in the range `0` to `base - 1`, or `base` if
 * the code point does not represent a value.
 */
var basicToDigit = function basicToDigit(codePoint) {
	if (codePoint - 0x30 < 0x0A) {
		return codePoint - 0x16;
	}
	if (codePoint - 0x41 < 0x1A) {
		return codePoint - 0x41;
	}
	if (codePoint - 0x61 < 0x1A) {
		return codePoint - 0x61;
	}
	return base;
};

/**
 * Converts a digit/integer into a basic code point.
 * @see `basicToDigit()`
 * @private
 * @param {Number} digit The numeric value of a basic code point.
 * @returns {Number} The basic code point whose value (when used for
 * representing integers) is `digit`, which needs to be in the range
 * `0` to `base - 1`. If `flag` is non-zero, the uppercase form is
 * used; else, the lowercase form is used. The behavior is undefined
 * if `flag` is non-zero and `digit` has no uppercase form.
 */
var digitToBasic = function digitToBasic(digit, flag) {
	//  0..25 map to ASCII a..z or A..Z
	// 26..35 map to ASCII 0..9
	return digit + 22 + 75 * (digit < 26) - ((flag != 0) << 5);
};

/**
 * Bias adaptation function as per section 3.4 of RFC 3492.
 * https://tools.ietf.org/html/rfc3492#section-3.4
 * @private
 */
var adapt = function adapt(delta, numPoints, firstTime) {
	var k = 0;
	delta = firstTime ? floor(delta / damp) : delta >> 1;
	delta += floor(delta / numPoints);
	for (; /* no initialization */delta > baseMinusTMin * tMax >> 1; k += base) {
		delta = floor(delta / baseMinusTMin);
	}
	return floor(k + (baseMinusTMin + 1) * delta / (delta + skew));
};

/**
 * Converts a Punycode string of ASCII-only symbols to a string of Unicode
 * symbols.
 * @memberOf punycode
 * @param {String} input The Punycode string of ASCII-only symbols.
 * @returns {String} The resulting string of Unicode symbols.
 */
var decode = function decode(input) {
	// Don't use UCS-2.
	var output = [];
	var inputLength = input.length;
	var i = 0;
	var n = initialN;
	var bias = initialBias;

	// Handle the basic code points: let `basic` be the number of input code
	// points before the last delimiter, or `0` if there is none, then copy
	// the first basic code points to the output.

	var basic = input.lastIndexOf(delimiter);
	if (basic < 0) {
		basic = 0;
	}

	for (var j = 0; j < basic; ++j) {
		// if it's not a basic code point
		if (input.charCodeAt(j) >= 0x80) {
			error$1('not-basic');
		}
		output.push(input.charCodeAt(j));
	}

	// Main decoding loop: start just after the last delimiter if any basic code
	// points were copied; start at the beginning otherwise.

	for (var index = basic > 0 ? basic + 1 : 0; index < inputLength;) /* no final expression */{

		// `index` is the index of the next character to be consumed.
		// Decode a generalized variable-length integer into `delta`,
		// which gets added to `i`. The overflow checking is easier
		// if we increase `i` as we go, then subtract off its starting
		// value at the end to obtain `delta`.
		var oldi = i;
		for (var w = 1, k = base;; /* no condition */k += base) {

			if (index >= inputLength) {
				error$1('invalid-input');
			}

			var digit = basicToDigit(input.charCodeAt(index++));

			if (digit >= base || digit > floor((maxInt - i) / w)) {
				error$1('overflow');
			}

			i += digit * w;
			var t = k <= bias ? tMin : k >= bias + tMax ? tMax : k - bias;

			if (digit < t) {
				break;
			}

			var baseMinusT = base - t;
			if (w > floor(maxInt / baseMinusT)) {
				error$1('overflow');
			}

			w *= baseMinusT;
		}

		var out = output.length + 1;
		bias = adapt(i - oldi, out, oldi == 0);

		// `i` was supposed to wrap around from `out` to `0`,
		// incrementing `n` each time, so we'll fix that now:
		if (floor(i / out) > maxInt - n) {
			error$1('overflow');
		}

		n += floor(i / out);
		i %= out;

		// Insert `n` at position `i` of the output.
		output.splice(i++, 0, n);
	}

	return String.fromCodePoint.apply(String, output);
};

/**
 * Converts a string of Unicode symbols (e.g. a domain name label) to a
 * Punycode string of ASCII-only symbols.
 * @memberOf punycode
 * @param {String} input The string of Unicode symbols.
 * @returns {String} The resulting Punycode string of ASCII-only symbols.
 */
var encode = function encode(input) {
	var output = [];

	// Convert the input in UCS-2 to an array of Unicode code points.
	input = ucs2decode(input);

	// Cache the length.
	var inputLength = input.length;

	// Initialize the state.
	var n = initialN;
	var delta = 0;
	var bias = initialBias;

	// Handle the basic code points.
	var _iteratorNormalCompletion = true;
	var _didIteratorError = false;
	var _iteratorError = undefined;

	try {
		for (var _iterator = input[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
			var _currentValue2 = _step.value;

			if (_currentValue2 < 0x80) {
				output.push(stringFromCharCode(_currentValue2));
			}
		}
	} catch (err) {
		_didIteratorError = true;
		_iteratorError = err;
	} finally {
		try {
			if (!_iteratorNormalCompletion && _iterator.return) {
				_iterator.return();
			}
		} finally {
			if (_didIteratorError) {
				throw _iteratorError;
			}
		}
	}

	var basicLength = output.length;
	var handledCPCount = basicLength;

	// `handledCPCount` is the number of code points that have been handled;
	// `basicLength` is the number of basic code points.

	// Finish the basic string with a delimiter unless it's empty.
	if (basicLength) {
		output.push(delimiter);
	}

	// Main encoding loop:
	while (handledCPCount < inputLength) {

		// All non-basic code points < n have been handled already. Find the next
		// larger one:
		var m = maxInt;
		var _iteratorNormalCompletion2 = true;
		var _didIteratorError2 = false;
		var _iteratorError2 = undefined;

		try {
			for (var _iterator2 = input[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
				var currentValue = _step2.value;

				if (currentValue >= n && currentValue < m) {
					m = currentValue;
				}
			}

			// Increase `delta` enough to advance the decoder's <n,i> state to <m,0>,
			// but guard against overflow.
		} catch (err) {
			_didIteratorError2 = true;
			_iteratorError2 = err;
		} finally {
			try {
				if (!_iteratorNormalCompletion2 && _iterator2.return) {
					_iterator2.return();
				}
			} finally {
				if (_didIteratorError2) {
					throw _iteratorError2;
				}
			}
		}

		var handledCPCountPlusOne = handledCPCount + 1;
		if (m - n > floor((maxInt - delta) / handledCPCountPlusOne)) {
			error$1('overflow');
		}

		delta += (m - n) * handledCPCountPlusOne;
		n = m;

		var _iteratorNormalCompletion3 = true;
		var _didIteratorError3 = false;
		var _iteratorError3 = undefined;

		try {
			for (var _iterator3 = input[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
				var _currentValue = _step3.value;

				if (_currentValue < n && ++delta > maxInt) {
					error$1('overflow');
				}
				if (_currentValue == n) {
					// Represent delta as a generalized variable-length integer.
					var q = delta;
					for (var k = base;; /* no condition */k += base) {
						var t = k <= bias ? tMin : k >= bias + tMax ? tMax : k - bias;
						if (q < t) {
							break;
						}
						var qMinusT = q - t;
						var baseMinusT = base - t;
						output.push(stringFromCharCode(digitToBasic(t + qMinusT % baseMinusT, 0)));
						q = floor(qMinusT / baseMinusT);
					}

					output.push(stringFromCharCode(digitToBasic(q, 0)));
					bias = adapt(delta, handledCPCountPlusOne, handledCPCount == basicLength);
					delta = 0;
					++handledCPCount;
				}
			}
		} catch (err) {
			_didIteratorError3 = true;
			_iteratorError3 = err;
		} finally {
			try {
				if (!_iteratorNormalCompletion3 && _iterator3.return) {
					_iterator3.return();
				}
			} finally {
				if (_didIteratorError3) {
					throw _iteratorError3;
				}
			}
		}

		++delta;
		++n;
	}
	return output.join('');
};

/**
 * Converts a Punycode string representing a domain name or an email address
 * to Unicode. Only the Punycoded parts of the input will be converted, i.e.
 * it doesn't matter if you call it on a string that has already been
 * converted to Unicode.
 * @memberOf punycode
 * @param {String} input The Punycoded domain name or email address to
 * convert to Unicode.
 * @returns {String} The Unicode representation of the given Punycode
 * string.
 */
var toUnicode = function toUnicode(input) {
	return mapDomain(input, function (string) {
		return regexPunycode.test(string) ? decode(string.slice(4).toLowerCase()) : string;
	});
};

/**
 * Converts a Unicode string representing a domain name or an email address to
 * Punycode. Only the non-ASCII parts of the domain name will be converted,
 * i.e. it doesn't matter if you call it with a domain that's already in
 * ASCII.
 * @memberOf punycode
 * @param {String} input The domain name or email address to convert, as a
 * Unicode string.
 * @returns {String} The Punycode representation of the given domain name or
 * email address.
 */
var toASCII = function toASCII(input) {
	return mapDomain(input, function (string) {
		return regexNonASCII.test(string) ? 'xn--' + encode(string) : string;
	});
};

/*--------------------------------------------------------------------------*/

/** Define the public API */
var punycode = {
	/**
  * A string representing the current Punycode.js version number.
  * @memberOf punycode
  * @type String
  */
	'version': '2.1.0',
	/**
  * An object of methods to convert from JavaScript's internal character
  * representation (UCS-2) to Unicode code points, and back.
  * @see <https://mathiasbynens.be/notes/javascript-encoding>
  * @memberOf punycode
  * @type Object
  */
	'ucs2': {
		'decode': ucs2decode,
		'encode': ucs2encode
	},
	'decode': decode,
	'encode': encode,
	'toASCII': toASCII,
	'toUnicode': toUnicode
};

/**
 * URI.js
 *
 * @fileoverview An RFC 3986 compliant, scheme extendable URI parsing/validating/resolving library for JavaScript.
 * @author <a href="mailto:gary.court@gmail.com">Gary Court</a>
 * @see http://github.com/garycourt/uri-js
 */
/**
 * Copyright 2011 Gary Court. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are
 * permitted provided that the following conditions are met:
 *
 *    1. Redistributions of source code must retain the above copyright notice, this list of
 *       conditions and the following disclaimer.
 *
 *    2. Redistributions in binary form must reproduce the above copyright notice, this list
 *       of conditions and the following disclaimer in the documentation and/or other materials
 *       provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY GARY COURT ``AS IS'' AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL GARY COURT OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * The views and conclusions contained in the software and documentation are those of the
 * authors and should not be interpreted as representing official policies, either expressed
 * or implied, of Gary Court.
 */
var SCHEMES = {};
function pctEncChar(chr) {
    var c = chr.charCodeAt(0);
    var e = void 0;
    if (c < 16) e = "%0" + c.toString(16).toUpperCase();else if (c < 128) e = "%" + c.toString(16).toUpperCase();else if (c < 2048) e = "%" + (c >> 6 | 192).toString(16).toUpperCase() + "%" + (c & 63 | 128).toString(16).toUpperCase();else e = "%" + (c >> 12 | 224).toString(16).toUpperCase() + "%" + (c >> 6 & 63 | 128).toString(16).toUpperCase() + "%" + (c & 63 | 128).toString(16).toUpperCase();
    return e;
}
function pctDecChars(str) {
    var newStr = "";
    var i = 0;
    var il = str.length;
    while (i < il) {
        var c = parseInt(str.substr(i + 1, 2), 16);
        if (c < 128) {
            newStr += String.fromCharCode(c);
            i += 3;
        } else if (c >= 194 && c < 224) {
            if (il - i >= 6) {
                var c2 = parseInt(str.substr(i + 4, 2), 16);
                newStr += String.fromCharCode((c & 31) << 6 | c2 & 63);
            } else {
                newStr += str.substr(i, 6);
            }
            i += 6;
        } else if (c >= 224) {
            if (il - i >= 9) {
                var _c = parseInt(str.substr(i + 4, 2), 16);
                var c3 = parseInt(str.substr(i + 7, 2), 16);
                newStr += String.fromCharCode((c & 15) << 12 | (_c & 63) << 6 | c3 & 63);
            } else {
                newStr += str.substr(i, 9);
            }
            i += 9;
        } else {
            newStr += str.substr(i, 3);
            i += 3;
        }
    }
    return newStr;
}
function _normalizeComponentEncoding(components, protocol) {
    function decodeUnreserved(str) {
        var decStr = pctDecChars(str);
        return !decStr.match(protocol.UNRESERVED) ? str : decStr;
    }
    if (components.scheme) components.scheme = String(components.scheme).replace(protocol.PCT_ENCODED, decodeUnreserved).toLowerCase().replace(protocol.NOT_SCHEME, "");
    if (components.userinfo !== undefined) components.userinfo = String(components.userinfo).replace(protocol.PCT_ENCODED, decodeUnreserved).replace(protocol.NOT_USERINFO, pctEncChar).replace(protocol.PCT_ENCODED, toUpperCase);
    if (components.host !== undefined) components.host = String(components.host).replace(protocol.PCT_ENCODED, decodeUnreserved).toLowerCase().replace(protocol.NOT_HOST, pctEncChar).replace(protocol.PCT_ENCODED, toUpperCase);
    if (components.path !== undefined) components.path = String(components.path).replace(protocol.PCT_ENCODED, decodeUnreserved).replace(components.scheme ? protocol.NOT_PATH : protocol.NOT_PATH_NOSCHEME, pctEncChar).replace(protocol.PCT_ENCODED, toUpperCase);
    if (components.query !== undefined) components.query = String(components.query).replace(protocol.PCT_ENCODED, decodeUnreserved).replace(protocol.NOT_QUERY, pctEncChar).replace(protocol.PCT_ENCODED, toUpperCase);
    if (components.fragment !== undefined) components.fragment = String(components.fragment).replace(protocol.PCT_ENCODED, decodeUnreserved).replace(protocol.NOT_FRAGMENT, pctEncChar).replace(protocol.PCT_ENCODED, toUpperCase);
    return components;
}

function _stripLeadingZeros(str) {
    return str.replace(/^0*(.*)/, "$1") || "0";
}
function _normalizeIPv4(host, protocol) {
    var matches = host.match(protocol.IPV4ADDRESS) || [];

    var _matches = slicedToArray(matches, 2),
        address = _matches[1];

    if (address) {
        return address.split(".").map(_stripLeadingZeros).join(".");
    } else {
        return host;
    }
}
function _normalizeIPv6(host, protocol) {
    var matches = host.match(protocol.IPV6ADDRESS) || [];

    var _matches2 = slicedToArray(matches, 3),
        address = _matches2[1],
        zone = _matches2[2];

    if (address) {
        var _address$toLowerCase$ = address.toLowerCase().split('::').reverse(),
            _address$toLowerCase$2 = slicedToArray(_address$toLowerCase$, 2),
            last = _address$toLowerCase$2[0],
            first = _address$toLowerCase$2[1];

        var firstFields = first ? first.split(":").map(_stripLeadingZeros) : [];
        var lastFields = last.split(":").map(_stripLeadingZeros);
        var isLastFieldIPv4Address = protocol.IPV4ADDRESS.test(lastFields[lastFields.length - 1]);
        var fieldCount = isLastFieldIPv4Address ? 7 : 8;
        var lastFieldsStart = lastFields.length - fieldCount;
        var fields = Array(fieldCount);
        for (var x = 0; x < fieldCount; ++x) {
            fields[x] = firstFields[x] || lastFields[lastFieldsStart + x] || '';
        }
        if (isLastFieldIPv4Address) {
            fields[fieldCount - 1] = _normalizeIPv4(fields[fieldCount - 1], protocol);
        }
        var allZeroFields = fields.reduce(function (acc, field, index) {
            if (!field || field === "0") {
                var lastLongest = acc[acc.length - 1];
                if (lastLongest && lastLongest.index + lastLongest.length === index) {
                    lastLongest.length++;
                } else {
                    acc.push({ index: index, length: 1 });
                }
            }
            return acc;
        }, []);
        var longestZeroFields = allZeroFields.sort(function (a, b) {
            return b.length - a.length;
        })[0];
        var newHost = void 0;
        if (longestZeroFields && longestZeroFields.length > 1) {
            var newFirst = fields.slice(0, longestZeroFields.index);
            var newLast = fields.slice(longestZeroFields.index + longestZeroFields.length);
            newHost = newFirst.join(":") + "::" + newLast.join(":");
        } else {
            newHost = fields.join(":");
        }
        if (zone) {
            newHost += "%" + zone;
        }
        return newHost;
    } else {
        return host;
    }
}
var URI_PARSE = /^(?:([^:\/?#]+):)?(?:\/\/((?:([^\/?#@]*)@)?(\[[^\/?#\]]+\]|[^\/?#:]*)(?:\:(\d*))?))?([^?#]*)(?:\?([^#]*))?(?:#((?:.|\n|\r)*))?/i;
var NO_MATCH_IS_UNDEFINED = "".match(/(){0}/)[1] === undefined;
function parse(uriString) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    var components = {};
    var protocol = options.iri !== false ? IRI_PROTOCOL : URI_PROTOCOL;
    if (options.reference === "suffix") uriString = (options.scheme ? options.scheme + ":" : "") + "//" + uriString;
    var matches = uriString.match(URI_PARSE);
    if (matches) {
        if (NO_MATCH_IS_UNDEFINED) {
            //store each component
            components.scheme = matches[1];
            components.userinfo = matches[3];
            components.host = matches[4];
            components.port = parseInt(matches[5], 10);
            components.path = matches[6] || "";
            components.query = matches[7];
            components.fragment = matches[8];
            //fix port number
            if (isNaN(components.port)) {
                components.port = matches[5];
            }
        } else {
            //IE FIX for improper RegExp matching
            //store each component
            components.scheme = matches[1] || undefined;
            components.userinfo = uriString.indexOf("@") !== -1 ? matches[3] : undefined;
            components.host = uriString.indexOf("//") !== -1 ? matches[4] : undefined;
            components.port = parseInt(matches[5], 10);
            components.path = matches[6] || "";
            components.query = uriString.indexOf("?") !== -1 ? matches[7] : undefined;
            components.fragment = uriString.indexOf("#") !== -1 ? matches[8] : undefined;
            //fix port number
            if (isNaN(components.port)) {
                components.port = uriString.match(/\/\/(?:.|\n)*\:(?:\/|\?|\#|$)/) ? matches[4] : undefined;
            }
        }
        if (components.host) {
            //normalize IP hosts
            components.host = _normalizeIPv6(_normalizeIPv4(components.host, protocol), protocol);
        }
        //determine reference type
        if (components.scheme === undefined && components.userinfo === undefined && components.host === undefined && components.port === undefined && !components.path && components.query === undefined) {
            components.reference = "same-document";
        } else if (components.scheme === undefined) {
            components.reference = "relative";
        } else if (components.fragment === undefined) {
            components.reference = "absolute";
        } else {
            components.reference = "uri";
        }
        //check for reference errors
        if (options.reference && options.reference !== "suffix" && options.reference !== components.reference) {
            components.error = components.error || "URI is not a " + options.reference + " reference.";
        }
        //find scheme handler
        var schemeHandler = SCHEMES[(options.scheme || components.scheme || "").toLowerCase()];
        //check if scheme can't handle IRIs
        if (!options.unicodeSupport && (!schemeHandler || !schemeHandler.unicodeSupport)) {
            //if host component is a domain name
            if (components.host && (options.domainHost || schemeHandler && schemeHandler.domainHost)) {
                //convert Unicode IDN -> ASCII IDN
                try {
                    components.host = punycode.toASCII(components.host.replace(protocol.PCT_ENCODED, pctDecChars).toLowerCase());
                } catch (e) {
                    components.error = components.error || "Host's domain name can not be converted to ASCII via punycode: " + e;
                }
            }
            //convert IRI -> URI
            _normalizeComponentEncoding(components, URI_PROTOCOL);
        } else {
            //normalize encodings
            _normalizeComponentEncoding(components, protocol);
        }
        //perform scheme specific parsing
        if (schemeHandler && schemeHandler.parse) {
            schemeHandler.parse(components, options);
        }
    } else {
        components.error = components.error || "URI can not be parsed.";
    }
    return components;
}

function _recomposeAuthority(components, options) {
    var protocol = options.iri !== false ? IRI_PROTOCOL : URI_PROTOCOL;
    var uriTokens = [];
    if (components.userinfo !== undefined) {
        uriTokens.push(components.userinfo);
        uriTokens.push("@");
    }
    if (components.host !== undefined) {
        //normalize IP hosts, add brackets and escape zone separator for IPv6
        uriTokens.push(_normalizeIPv6(_normalizeIPv4(String(components.host), protocol), protocol).replace(protocol.IPV6ADDRESS, function (_, $1, $2) {
            return "[" + $1 + ($2 ? "%25" + $2 : "") + "]";
        }));
    }
    if (typeof components.port === "number") {
        uriTokens.push(":");
        uriTokens.push(components.port.toString(10));
    }
    return uriTokens.length ? uriTokens.join("") : undefined;
}

var RDS1 = /^\.\.?\//;
var RDS2 = /^\/\.(\/|$)/;
var RDS3 = /^\/\.\.(\/|$)/;
var RDS5 = /^\/?(?:.|\n)*?(?=\/|$)/;
function removeDotSegments(input) {
    var output = [];
    while (input.length) {
        if (input.match(RDS1)) {
            input = input.replace(RDS1, "");
        } else if (input.match(RDS2)) {
            input = input.replace(RDS2, "/");
        } else if (input.match(RDS3)) {
            input = input.replace(RDS3, "/");
            output.pop();
        } else if (input === "." || input === "..") {
            input = "";
        } else {
            var im = input.match(RDS5);
            if (im) {
                var s = im[0];
                input = input.slice(s.length);
                output.push(s);
            } else {
                throw new Error("Unexpected dot segment condition");
            }
        }
    }
    return output.join("");
}

function serialize(components) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    var protocol = options.iri ? IRI_PROTOCOL : URI_PROTOCOL;
    var uriTokens = [];
    //find scheme handler
    var schemeHandler = SCHEMES[(options.scheme || components.scheme || "").toLowerCase()];
    //perform scheme specific serialization
    if (schemeHandler && schemeHandler.serialize) schemeHandler.serialize(components, options);
    if (components.host) {
        //if host component is an IPv6 address
        if (protocol.IPV6ADDRESS.test(components.host)) {}
        //TODO: normalize IPv6 address as per RFC 5952

        //if host component is a domain name
        else if (options.domainHost || schemeHandler && schemeHandler.domainHost) {
                //convert IDN via punycode
                try {
                    components.host = !options.iri ? punycode.toASCII(components.host.replace(protocol.PCT_ENCODED, pctDecChars).toLowerCase()) : punycode.toUnicode(components.host);
                } catch (e) {
                    components.error = components.error || "Host's domain name can not be converted to " + (!options.iri ? "ASCII" : "Unicode") + " via punycode: " + e;
                }
            }
    }
    //normalize encoding
    _normalizeComponentEncoding(components, protocol);
    if (options.reference !== "suffix" && components.scheme) {
        uriTokens.push(components.scheme);
        uriTokens.push(":");
    }
    var authority = _recomposeAuthority(components, options);
    if (authority !== undefined) {
        if (options.reference !== "suffix") {
            uriTokens.push("//");
        }
        uriTokens.push(authority);
        if (components.path && components.path.charAt(0) !== "/") {
            uriTokens.push("/");
        }
    }
    if (components.path !== undefined) {
        var s = components.path;
        if (!options.absolutePath && (!schemeHandler || !schemeHandler.absolutePath)) {
            s = removeDotSegments(s);
        }
        if (authority === undefined) {
            s = s.replace(/^\/\//, "/%2F"); //don't allow the path to start with "//"
        }
        uriTokens.push(s);
    }
    if (components.query !== undefined) {
        uriTokens.push("?");
        uriTokens.push(components.query);
    }
    if (components.fragment !== undefined) {
        uriTokens.push("#");
        uriTokens.push(components.fragment);
    }
    return uriTokens.join(""); //merge tokens into a string
}

function resolveComponents(base, relative) {
    var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    var skipNormalization = arguments[3];

    var target = {};
    if (!skipNormalization) {
        base = parse(serialize(base, options), options); //normalize base components
        relative = parse(serialize(relative, options), options); //normalize relative components
    }
    options = options || {};
    if (!options.tolerant && relative.scheme) {
        target.scheme = relative.scheme;
        //target.authority = relative.authority;
        target.userinfo = relative.userinfo;
        target.host = relative.host;
        target.port = relative.port;
        target.path = removeDotSegments(relative.path || "");
        target.query = relative.query;
    } else {
        if (relative.userinfo !== undefined || relative.host !== undefined || relative.port !== undefined) {
            //target.authority = relative.authority;
            target.userinfo = relative.userinfo;
            target.host = relative.host;
            target.port = relative.port;
            target.path = removeDotSegments(relative.path || "");
            target.query = relative.query;
        } else {
            if (!relative.path) {
                target.path = base.path;
                if (relative.query !== undefined) {
                    target.query = relative.query;
                } else {
                    target.query = base.query;
                }
            } else {
                if (relative.path.charAt(0) === "/") {
                    target.path = removeDotSegments(relative.path);
                } else {
                    if ((base.userinfo !== undefined || base.host !== undefined || base.port !== undefined) && !base.path) {
                        target.path = "/" + relative.path;
                    } else if (!base.path) {
                        target.path = relative.path;
                    } else {
                        target.path = base.path.slice(0, base.path.lastIndexOf("/") + 1) + relative.path;
                    }
                    target.path = removeDotSegments(target.path);
                }
                target.query = relative.query;
            }
            //target.authority = base.authority;
            target.userinfo = base.userinfo;
            target.host = base.host;
            target.port = base.port;
        }
        target.scheme = base.scheme;
    }
    target.fragment = relative.fragment;
    return target;
}

function resolve(baseURI, relativeURI, options) {
    var schemelessOptions = assign({ scheme: 'null' }, options);
    return serialize(resolveComponents(parse(baseURI, schemelessOptions), parse(relativeURI, schemelessOptions), schemelessOptions, true), schemelessOptions);
}

function normalize(uri, options) {
    if (typeof uri === "string") {
        uri = serialize(parse(uri, options), options);
    } else if (typeOf(uri) === "object") {
        uri = parse(serialize(uri, options), options);
    }
    return uri;
}

function equal(uriA, uriB, options) {
    if (typeof uriA === "string") {
        uriA = serialize(parse(uriA, options), options);
    } else if (typeOf(uriA) === "object") {
        uriA = serialize(uriA, options);
    }
    if (typeof uriB === "string") {
        uriB = serialize(parse(uriB, options), options);
    } else if (typeOf(uriB) === "object") {
        uriB = serialize(uriB, options);
    }
    return uriA === uriB;
}

function escapeComponent(str, options) {
    return str && str.toString().replace(!options || !options.iri ? URI_PROTOCOL.ESCAPE : IRI_PROTOCOL.ESCAPE, pctEncChar);
}

function unescapeComponent(str, options) {
    return str && str.toString().replace(!options || !options.iri ? URI_PROTOCOL.PCT_ENCODED : IRI_PROTOCOL.PCT_ENCODED, pctDecChars);
}

var handler = {
    scheme: "http",
    domainHost: true,
    parse: function parse(components, options) {
        //report missing host
        if (!components.host) {
            components.error = components.error || "HTTP URIs must have a host.";
        }
        return components;
    },
    serialize: function serialize(components, options) {
        //normalize the default port
        if (components.port === (String(components.scheme).toLowerCase() !== "https" ? 80 : 443) || components.port === "") {
            components.port = undefined;
        }
        //normalize the empty path
        if (!components.path) {
            components.path = "/";
        }
        //NOTE: We do not parse query strings for HTTP URIs
        //as WWW Form Url Encoded query strings are part of the HTML4+ spec,
        //and not the HTTP spec.
        return components;
    }
};

var handler$1 = {
    scheme: "https",
    domainHost: handler.domainHost,
    parse: handler.parse,
    serialize: handler.serialize
};

var O = {};
var isIRI = true;
//RFC 3986
var UNRESERVED$$ = "[A-Za-z0-9\\-\\.\\_\\~" + (isIRI ? "\\xA0-\\u200D\\u2010-\\u2029\\u202F-\\uD7FF\\uF900-\\uFDCF\\uFDF0-\\uFFEF" : "") + "]";
var HEXDIG$$ = "[0-9A-Fa-f]"; //case-insensitive
var PCT_ENCODED$ = subexp(subexp("%[EFef]" + HEXDIG$$ + "%" + HEXDIG$$ + HEXDIG$$ + "%" + HEXDIG$$ + HEXDIG$$) + "|" + subexp("%[89A-Fa-f]" + HEXDIG$$ + "%" + HEXDIG$$ + HEXDIG$$) + "|" + subexp("%" + HEXDIG$$ + HEXDIG$$)); //expanded
//RFC 5322, except these symbols as per RFC 6068: @ : / ? # [ ] & ; =
//const ATEXT$$ = "[A-Za-z0-9\\!\\#\\$\\%\\&\\'\\*\\+\\-\\/\\=\\?\\^\\_\\`\\{\\|\\}\\~]";
//const WSP$$ = "[\\x20\\x09]";
//const OBS_QTEXT$$ = "[\\x01-\\x08\\x0B\\x0C\\x0E-\\x1F\\x7F]";  //(%d1-8 / %d11-12 / %d14-31 / %d127)
//const QTEXT$$ = merge("[\\x21\\x23-\\x5B\\x5D-\\x7E]", OBS_QTEXT$$);  //%d33 / %d35-91 / %d93-126 / obs-qtext
//const VCHAR$$ = "[\\x21-\\x7E]";
//const WSP$$ = "[\\x20\\x09]";
//const OBS_QP$ = subexp("\\\\" + merge("[\\x00\\x0D\\x0A]", OBS_QTEXT$$));  //%d0 / CR / LF / obs-qtext
//const FWS$ = subexp(subexp(WSP$$ + "*" + "\\x0D\\x0A") + "?" + WSP$$ + "+");
//const QUOTED_PAIR$ = subexp(subexp("\\\\" + subexp(VCHAR$$ + "|" + WSP$$)) + "|" + OBS_QP$);
//const QUOTED_STRING$ = subexp('\\"' + subexp(FWS$ + "?" + QCONTENT$) + "*" + FWS$ + "?" + '\\"');
var ATEXT$$ = "[A-Za-z0-9\\!\\$\\%\\'\\*\\+\\-\\^\\_\\`\\{\\|\\}\\~]";
var QTEXT$$ = "[\\!\\$\\%\\'\\(\\)\\*\\+\\,\\-\\.0-9\\<\\>A-Z\\x5E-\\x7E]";
var VCHAR$$ = merge(QTEXT$$, "[\\\"\\\\]");
var SOME_DELIMS$$ = "[\\!\\$\\'\\(\\)\\*\\+\\,\\;\\:\\@]";
var UNRESERVED = new RegExp(UNRESERVED$$, "g");
var PCT_ENCODED = new RegExp(PCT_ENCODED$, "g");
var NOT_LOCAL_PART = new RegExp(merge("[^]", ATEXT$$, "[\\.]", '[\\"]', VCHAR$$), "g");
var NOT_HFNAME = new RegExp(merge("[^]", UNRESERVED$$, SOME_DELIMS$$), "g");
var NOT_HFVALUE = NOT_HFNAME;
function decodeUnreserved(str) {
    var decStr = pctDecChars(str);
    return !decStr.match(UNRESERVED) ? str : decStr;
}
var handler$2 = {
    scheme: "mailto",
    parse: function parse$$1(components, options) {
        var mailtoComponents = components;
        var to = mailtoComponents.to = mailtoComponents.path ? mailtoComponents.path.split(",") : [];
        mailtoComponents.path = undefined;
        if (mailtoComponents.query) {
            var unknownHeaders = false;
            var headers = {};
            var hfields = mailtoComponents.query.split("&");
            for (var x = 0, xl = hfields.length; x < xl; ++x) {
                var hfield = hfields[x].split("=");
                switch (hfield[0]) {
                    case "to":
                        var toAddrs = hfield[1].split(",");
                        for (var _x = 0, _xl = toAddrs.length; _x < _xl; ++_x) {
                            to.push(toAddrs[_x]);
                        }
                        break;
                    case "subject":
                        mailtoComponents.subject = unescapeComponent(hfield[1], options);
                        break;
                    case "body":
                        mailtoComponents.body = unescapeComponent(hfield[1], options);
                        break;
                    default:
                        unknownHeaders = true;
                        headers[unescapeComponent(hfield[0], options)] = unescapeComponent(hfield[1], options);
                        break;
                }
            }
            if (unknownHeaders) mailtoComponents.headers = headers;
        }
        mailtoComponents.query = undefined;
        for (var _x2 = 0, _xl2 = to.length; _x2 < _xl2; ++_x2) {
            var addr = to[_x2].split("@");
            addr[0] = unescapeComponent(addr[0]);
            if (!options.unicodeSupport) {
                //convert Unicode IDN -> ASCII IDN
                try {
                    addr[1] = punycode.toASCII(unescapeComponent(addr[1], options).toLowerCase());
                } catch (e) {
                    mailtoComponents.error = mailtoComponents.error || "Email address's domain name can not be converted to ASCII via punycode: " + e;
                }
            } else {
                addr[1] = unescapeComponent(addr[1], options).toLowerCase();
            }
            to[_x2] = addr.join("@");
        }
        return mailtoComponents;
    },
    serialize: function serialize$$1(mailtoComponents, options) {
        var components = mailtoComponents;
        var to = toArray(mailtoComponents.to);
        if (to) {
            for (var x = 0, xl = to.length; x < xl; ++x) {
                var toAddr = String(to[x]);
                var atIdx = toAddr.lastIndexOf("@");
                var localPart = toAddr.slice(0, atIdx).replace(PCT_ENCODED, decodeUnreserved).replace(PCT_ENCODED, toUpperCase).replace(NOT_LOCAL_PART, pctEncChar);
                var domain = toAddr.slice(atIdx + 1);
                //convert IDN via punycode
                try {
                    domain = !options.iri ? punycode.toASCII(unescapeComponent(domain, options).toLowerCase()) : punycode.toUnicode(domain);
                } catch (e) {
                    components.error = components.error || "Email address's domain name can not be converted to " + (!options.iri ? "ASCII" : "Unicode") + " via punycode: " + e;
                }
                to[x] = localPart + "@" + domain;
            }
            components.path = to.join(",");
        }
        var headers = mailtoComponents.headers = mailtoComponents.headers || {};
        if (mailtoComponents.subject) headers["subject"] = mailtoComponents.subject;
        if (mailtoComponents.body) headers["body"] = mailtoComponents.body;
        var fields = [];
        for (var name in headers) {
            if (headers[name] !== O[name]) {
                fields.push(name.replace(PCT_ENCODED, decodeUnreserved).replace(PCT_ENCODED, toUpperCase).replace(NOT_HFNAME, pctEncChar) + "=" + headers[name].replace(PCT_ENCODED, decodeUnreserved).replace(PCT_ENCODED, toUpperCase).replace(NOT_HFVALUE, pctEncChar));
            }
        }
        if (fields.length) {
            components.query = fields.join("&");
        }
        return components;
    }
};

var URN_PARSE = /^([^\:]+)\:(.*)/;
//RFC 2141
var handler$3 = {
    scheme: "urn",
    parse: function parse$$1(components, options) {
        var matches = components.path && components.path.match(URN_PARSE);
        var urnComponents = components;
        if (matches) {
            var scheme = options.scheme || urnComponents.scheme || "urn";
            var nid = matches[1].toLowerCase();
            var nss = matches[2];
            var urnScheme = scheme + ":" + (options.nid || nid);
            var schemeHandler = SCHEMES[urnScheme];
            urnComponents.nid = nid;
            urnComponents.nss = nss;
            urnComponents.path = undefined;
            if (schemeHandler) {
                urnComponents = schemeHandler.parse(urnComponents, options);
            }
        } else {
            urnComponents.error = urnComponents.error || "URN can not be parsed.";
        }
        return urnComponents;
    },
    serialize: function serialize$$1(urnComponents, options) {
        var scheme = options.scheme || urnComponents.scheme || "urn";
        var nid = urnComponents.nid;
        var urnScheme = scheme + ":" + (options.nid || nid);
        var schemeHandler = SCHEMES[urnScheme];
        if (schemeHandler) {
            urnComponents = schemeHandler.serialize(urnComponents, options);
        }
        var uriComponents = urnComponents;
        var nss = urnComponents.nss;
        uriComponents.path = (nid || options.nid) + ":" + nss;
        return uriComponents;
    }
};

var UUID = /^[0-9A-Fa-f]{8}(?:\-[0-9A-Fa-f]{4}){3}\-[0-9A-Fa-f]{12}$/;
//RFC 4122
var handler$4 = {
    scheme: "urn:uuid",
    parse: function parse(urnComponents, options) {
        var uuidComponents = urnComponents;
        uuidComponents.uuid = uuidComponents.nss;
        uuidComponents.nss = undefined;
        if (!options.tolerant && (!uuidComponents.uuid || !uuidComponents.uuid.match(UUID))) {
            uuidComponents.error = uuidComponents.error || "UUID is not valid.";
        }
        return uuidComponents;
    },
    serialize: function serialize(uuidComponents, options) {
        var urnComponents = uuidComponents;
        //normalize UUID
        urnComponents.nss = (uuidComponents.uuid || "").toLowerCase();
        return urnComponents;
    }
};

SCHEMES[handler.scheme] = handler;
SCHEMES[handler$1.scheme] = handler$1;
SCHEMES[handler$2.scheme] = handler$2;
SCHEMES[handler$3.scheme] = handler$3;
SCHEMES[handler$4.scheme] = handler$4;

exports.SCHEMES = SCHEMES;
exports.pctEncChar = pctEncChar;
exports.pctDecChars = pctDecChars;
exports.parse = parse;
exports.removeDotSegments = removeDotSegments;
exports.serialize = serialize;
exports.resolveComponents = resolveComponents;
exports.resolve = resolve;
exports.normalize = normalize;
exports.equal = equal;
exports.escapeComponent = escapeComponent;
exports.unescapeComponent = unescapeComponent;

Object.defineProperty(exports, '__esModule', { value: true });

})));


},{}],292:[function(require,module,exports){
(function (global){

/**
 * Module exports.
 */

module.exports = deprecate;

/**
 * Mark that a method should not be used.
 * Returns a modified function which warns once by default.
 *
 * If `localStorage.noDeprecation = true` is set, then it is a no-op.
 *
 * If `localStorage.throwDeprecation = true` is set, then deprecated functions
 * will throw an Error when invoked.
 *
 * If `localStorage.traceDeprecation = true` is set, then deprecated functions
 * will invoke `console.trace()` instead of `console.error()`.
 *
 * @param {Function} fn - the function to deprecate
 * @param {String} msg - the string to print to the console when `fn` is invoked
 * @returns {Function} a new "deprecated" version of `fn`
 * @api public
 */

function deprecate (fn, msg) {
  if (config('noDeprecation')) {
    return fn;
  }

  var warned = false;
  function deprecated() {
    if (!warned) {
      if (config('throwDeprecation')) {
        throw new Error(msg);
      } else if (config('traceDeprecation')) {
        console.trace(msg);
      } else {
        console.warn(msg);
      }
      warned = true;
    }
    return fn.apply(this, arguments);
  }

  return deprecated;
}

/**
 * Checks `localStorage` for boolean values for the given `name`.
 *
 * @param {String} name
 * @returns {Boolean}
 * @api private
 */

function config (name) {
  // accessing global.localStorage can trigger a DOMException in sandboxed iframes
  try {
    if (!global.localStorage) return false;
  } catch (_) {
    return false;
  }
  var val = global.localStorage[name];
  if (null == val) return false;
  return String(val).toLowerCase() === 'true';
}

}).call(this,typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})

},{}],293:[function(require,module,exports){
arguments[4][47][0].apply(exports,arguments)
},{"dup":47}],294:[function(require,module,exports){
(function (process,global){
// Copyright Joyent, Inc. and other Node contributors.
//
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to permit
// persons to whom the Software is furnished to do so, subject to the
// following conditions:
//
// The above copyright notice and this permission notice shall be included
// in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
// USE OR OTHER DEALINGS IN THE SOFTWARE.

var formatRegExp = /%[sdj%]/g;
exports.format = function(f) {
  if (!isString(f)) {
    var objects = [];
    for (var i = 0; i < arguments.length; i++) {
      objects.push(inspect(arguments[i]));
    }
    return objects.join(' ');
  }

  var i = 1;
  var args = arguments;
  var len = args.length;
  var str = String(f).replace(formatRegExp, function(x) {
    if (x === '%%') return '%';
    if (i >= len) return x;
    switch (x) {
      case '%s': return String(args[i++]);
      case '%d': return Number(args[i++]);
      case '%j':
        try {
          return JSON.stringify(args[i++]);
        } catch (_) {
          return '[Circular]';
        }
      default:
        return x;
    }
  });
  for (var x = args[i]; i < len; x = args[++i]) {
    if (isNull(x) || !isObject(x)) {
      str += ' ' + x;
    } else {
      str += ' ' + inspect(x);
    }
  }
  return str;
};


// Mark that a method should not be used.
// Returns a modified function which warns once by default.
// If --no-deprecation is set, then it is a no-op.
exports.deprecate = function(fn, msg) {
  // Allow for deprecating things in the process of starting up.
  if (isUndefined(global.process)) {
    return function() {
      return exports.deprecate(fn, msg).apply(this, arguments);
    };
  }

  if (process.noDeprecation === true) {
    return fn;
  }

  var warned = false;
  function deprecated() {
    if (!warned) {
      if (process.throwDeprecation) {
        throw new Error(msg);
      } else if (process.traceDeprecation) {
        console.trace(msg);
      } else {
        console.error(msg);
      }
      warned = true;
    }
    return fn.apply(this, arguments);
  }

  return deprecated;
};


var debugs = {};
var debugEnviron;
exports.debuglog = function(set) {
  if (isUndefined(debugEnviron))
    debugEnviron = process.env.NODE_DEBUG || '';
  set = set.toUpperCase();
  if (!debugs[set]) {
    if (new RegExp('\\b' + set + '\\b', 'i').test(debugEnviron)) {
      var pid = process.pid;
      debugs[set] = function() {
        var msg = exports.format.apply(exports, arguments);
        console.error('%s %d: %s', set, pid, msg);
      };
    } else {
      debugs[set] = function() {};
    }
  }
  return debugs[set];
};


/**
 * Echos the value of a value. Trys to print the value out
 * in the best way possible given the different types.
 *
 * @param {Object} obj The object to print out.
 * @param {Object} opts Optional options object that alters the output.
 */
/* legacy: obj, showHidden, depth, colors*/
function inspect(obj, opts) {
  // default options
  var ctx = {
    seen: [],
    stylize: stylizeNoColor
  };
  // legacy...
  if (arguments.length >= 3) ctx.depth = arguments[2];
  if (arguments.length >= 4) ctx.colors = arguments[3];
  if (isBoolean(opts)) {
    // legacy...
    ctx.showHidden = opts;
  } else if (opts) {
    // got an "options" object
    exports._extend(ctx, opts);
  }
  // set default options
  if (isUndefined(ctx.showHidden)) ctx.showHidden = false;
  if (isUndefined(ctx.depth)) ctx.depth = 2;
  if (isUndefined(ctx.colors)) ctx.colors = false;
  if (isUndefined(ctx.customInspect)) ctx.customInspect = true;
  if (ctx.colors) ctx.stylize = stylizeWithColor;
  return formatValue(ctx, obj, ctx.depth);
}
exports.inspect = inspect;


// http://en.wikipedia.org/wiki/ANSI_escape_code#graphics
inspect.colors = {
  'bold' : [1, 22],
  'italic' : [3, 23],
  'underline' : [4, 24],
  'inverse' : [7, 27],
  'white' : [37, 39],
  'grey' : [90, 39],
  'black' : [30, 39],
  'blue' : [34, 39],
  'cyan' : [36, 39],
  'green' : [32, 39],
  'magenta' : [35, 39],
  'red' : [31, 39],
  'yellow' : [33, 39]
};

// Don't use 'blue' not visible on cmd.exe
inspect.styles = {
  'special': 'cyan',
  'number': 'yellow',
  'boolean': 'yellow',
  'undefined': 'grey',
  'null': 'bold',
  'string': 'green',
  'date': 'magenta',
  // "name": intentionally not styling
  'regexp': 'red'
};


function stylizeWithColor(str, styleType) {
  var style = inspect.styles[styleType];

  if (style) {
    return '\u001b[' + inspect.colors[style][0] + 'm' + str +
           '\u001b[' + inspect.colors[style][1] + 'm';
  } else {
    return str;
  }
}


function stylizeNoColor(str, styleType) {
  return str;
}


function arrayToHash(array) {
  var hash = {};

  array.forEach(function(val, idx) {
    hash[val] = true;
  });

  return hash;
}


function formatValue(ctx, value, recurseTimes) {
  // Provide a hook for user-specified inspect functions.
  // Check that value is an object with an inspect function on it
  if (ctx.customInspect &&
      value &&
      isFunction(value.inspect) &&
      // Filter out the util module, it's inspect function is special
      value.inspect !== exports.inspect &&
      // Also filter out any prototype objects using the circular check.
      !(value.constructor && value.constructor.prototype === value)) {
    var ret = value.inspect(recurseTimes, ctx);
    if (!isString(ret)) {
      ret = formatValue(ctx, ret, recurseTimes);
    }
    return ret;
  }

  // Primitive types cannot have properties
  var primitive = formatPrimitive(ctx, value);
  if (primitive) {
    return primitive;
  }

  // Look up the keys of the object.
  var keys = Object.keys(value);
  var visibleKeys = arrayToHash(keys);

  if (ctx.showHidden) {
    keys = Object.getOwnPropertyNames(value);
  }

  // IE doesn't make error fields non-enumerable
  // http://msdn.microsoft.com/en-us/library/ie/dww52sbt(v=vs.94).aspx
  if (isError(value)
      && (keys.indexOf('message') >= 0 || keys.indexOf('description') >= 0)) {
    return formatError(value);
  }

  // Some type of object without properties can be shortcutted.
  if (keys.length === 0) {
    if (isFunction(value)) {
      var name = value.name ? ': ' + value.name : '';
      return ctx.stylize('[Function' + name + ']', 'special');
    }
    if (isRegExp(value)) {
      return ctx.stylize(RegExp.prototype.toString.call(value), 'regexp');
    }
    if (isDate(value)) {
      return ctx.stylize(Date.prototype.toString.call(value), 'date');
    }
    if (isError(value)) {
      return formatError(value);
    }
  }

  var base = '', array = false, braces = ['{', '}'];

  // Make Array say that they are Array
  if (isArray(value)) {
    array = true;
    braces = ['[', ']'];
  }

  // Make functions say that they are functions
  if (isFunction(value)) {
    var n = value.name ? ': ' + value.name : '';
    base = ' [Function' + n + ']';
  }

  // Make RegExps say that they are RegExps
  if (isRegExp(value)) {
    base = ' ' + RegExp.prototype.toString.call(value);
  }

  // Make dates with properties first say the date
  if (isDate(value)) {
    base = ' ' + Date.prototype.toUTCString.call(value);
  }

  // Make error with message first say the error
  if (isError(value)) {
    base = ' ' + formatError(value);
  }

  if (keys.length === 0 && (!array || value.length == 0)) {
    return braces[0] + base + braces[1];
  }

  if (recurseTimes < 0) {
    if (isRegExp(value)) {
      return ctx.stylize(RegExp.prototype.toString.call(value), 'regexp');
    } else {
      return ctx.stylize('[Object]', 'special');
    }
  }

  ctx.seen.push(value);

  var output;
  if (array) {
    output = formatArray(ctx, value, recurseTimes, visibleKeys, keys);
  } else {
    output = keys.map(function(key) {
      return formatProperty(ctx, value, recurseTimes, visibleKeys, key, array);
    });
  }

  ctx.seen.pop();

  return reduceToSingleString(output, base, braces);
}


function formatPrimitive(ctx, value) {
  if (isUndefined(value))
    return ctx.stylize('undefined', 'undefined');
  if (isString(value)) {
    var simple = '\'' + JSON.stringify(value).replace(/^"|"$/g, '')
                                             .replace(/'/g, "\\'")
                                             .replace(/\\"/g, '"') + '\'';
    return ctx.stylize(simple, 'string');
  }
  if (isNumber(value))
    return ctx.stylize('' + value, 'number');
  if (isBoolean(value))
    return ctx.stylize('' + value, 'boolean');
  // For some reason typeof null is "object", so special case here.
  if (isNull(value))
    return ctx.stylize('null', 'null');
}


function formatError(value) {
  return '[' + Error.prototype.toString.call(value) + ']';
}


function formatArray(ctx, value, recurseTimes, visibleKeys, keys) {
  var output = [];
  for (var i = 0, l = value.length; i < l; ++i) {
    if (hasOwnProperty(value, String(i))) {
      output.push(formatProperty(ctx, value, recurseTimes, visibleKeys,
          String(i), true));
    } else {
      output.push('');
    }
  }
  keys.forEach(function(key) {
    if (!key.match(/^\d+$/)) {
      output.push(formatProperty(ctx, value, recurseTimes, visibleKeys,
          key, true));
    }
  });
  return output;
}


function formatProperty(ctx, value, recurseTimes, visibleKeys, key, array) {
  var name, str, desc;
  desc = Object.getOwnPropertyDescriptor(value, key) || { value: value[key] };
  if (desc.get) {
    if (desc.set) {
      str = ctx.stylize('[Getter/Setter]', 'special');
    } else {
      str = ctx.stylize('[Getter]', 'special');
    }
  } else {
    if (desc.set) {
      str = ctx.stylize('[Setter]', 'special');
    }
  }
  if (!hasOwnProperty(visibleKeys, key)) {
    name = '[' + key + ']';
  }
  if (!str) {
    if (ctx.seen.indexOf(desc.value) < 0) {
      if (isNull(recurseTimes)) {
        str = formatValue(ctx, desc.value, null);
      } else {
        str = formatValue(ctx, desc.value, recurseTimes - 1);
      }
      if (str.indexOf('\n') > -1) {
        if (array) {
          str = str.split('\n').map(function(line) {
            return '  ' + line;
          }).join('\n').substr(2);
        } else {
          str = '\n' + str.split('\n').map(function(line) {
            return '   ' + line;
          }).join('\n');
        }
      }
    } else {
      str = ctx.stylize('[Circular]', 'special');
    }
  }
  if (isUndefined(name)) {
    if (array && key.match(/^\d+$/)) {
      return str;
    }
    name = JSON.stringify('' + key);
    if (name.match(/^"([a-zA-Z_][a-zA-Z_0-9]*)"$/)) {
      name = name.substr(1, name.length - 2);
      name = ctx.stylize(name, 'name');
    } else {
      name = name.replace(/'/g, "\\'")
                 .replace(/\\"/g, '"')
                 .replace(/(^"|"$)/g, "'");
      name = ctx.stylize(name, 'string');
    }
  }

  return name + ': ' + str;
}


function reduceToSingleString(output, base, braces) {
  var numLinesEst = 0;
  var length = output.reduce(function(prev, cur) {
    numLinesEst++;
    if (cur.indexOf('\n') >= 0) numLinesEst++;
    return prev + cur.replace(/\u001b\[\d\d?m/g, '').length + 1;
  }, 0);

  if (length > 60) {
    return braces[0] +
           (base === '' ? '' : base + '\n ') +
           ' ' +
           output.join(',\n  ') +
           ' ' +
           braces[1];
  }

  return braces[0] + base + ' ' + output.join(', ') + ' ' + braces[1];
}


// NOTE: These type checking functions intentionally don't use `instanceof`
// because it is fragile and can be easily faked with `Object.create()`.
function isArray(ar) {
  return Array.isArray(ar);
}
exports.isArray = isArray;

function isBoolean(arg) {
  return typeof arg === 'boolean';
}
exports.isBoolean = isBoolean;

function isNull(arg) {
  return arg === null;
}
exports.isNull = isNull;

function isNullOrUndefined(arg) {
  return arg == null;
}
exports.isNullOrUndefined = isNullOrUndefined;

function isNumber(arg) {
  return typeof arg === 'number';
}
exports.isNumber = isNumber;

function isString(arg) {
  return typeof arg === 'string';
}
exports.isString = isString;

function isSymbol(arg) {
  return typeof arg === 'symbol';
}
exports.isSymbol = isSymbol;

function isUndefined(arg) {
  return arg === void 0;
}
exports.isUndefined = isUndefined;

function isRegExp(re) {
  return isObject(re) && objectToString(re) === '[object RegExp]';
}
exports.isRegExp = isRegExp;

function isObject(arg) {
  return typeof arg === 'object' && arg !== null;
}
exports.isObject = isObject;

function isDate(d) {
  return isObject(d) && objectToString(d) === '[object Date]';
}
exports.isDate = isDate;

function isError(e) {
  return isObject(e) &&
      (objectToString(e) === '[object Error]' || e instanceof Error);
}
exports.isError = isError;

function isFunction(arg) {
  return typeof arg === 'function';
}
exports.isFunction = isFunction;

function isPrimitive(arg) {
  return arg === null ||
         typeof arg === 'boolean' ||
         typeof arg === 'number' ||
         typeof arg === 'string' ||
         typeof arg === 'symbol' ||  // ES6 symbol
         typeof arg === 'undefined';
}
exports.isPrimitive = isPrimitive;

exports.isBuffer = require('./support/isBuffer');

function objectToString(o) {
  return Object.prototype.toString.call(o);
}


function pad(n) {
  return n < 10 ? '0' + n.toString(10) : n.toString(10);
}


var months = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep',
              'Oct', 'Nov', 'Dec'];

// 26 Feb 16:19:34
function timestamp() {
  var d = new Date();
  var time = [pad(d.getHours()),
              pad(d.getMinutes()),
              pad(d.getSeconds())].join(':');
  return [d.getDate(), months[d.getMonth()], time].join(' ');
}


// log is just a thin wrapper to console.log that prepends a timestamp
exports.log = function() {
  console.log('%s - %s', timestamp(), exports.format.apply(exports, arguments));
};


/**
 * Inherit the prototype methods from one constructor into another.
 *
 * The Function.prototype.inherits from lang.js rewritten as a standalone
 * function (not on Function.prototype). NOTE: If this file is to be loaded
 * during bootstrapping this function needs to be rewritten using some native
 * functions as prototype setup using normal JavaScript does not work as
 * expected during bootstrapping (see mirror.js in r114903).
 *
 * @param {function} ctor Constructor function which needs to inherit the
 *     prototype.
 * @param {function} superCtor Constructor function to inherit prototype from.
 */
exports.inherits = require('inherits');

exports._extend = function(origin, add) {
  // Don't do anything if add isn't an object
  if (!add || !isObject(add)) return origin;

  var keys = Object.keys(add);
  var i = keys.length;
  while (i--) {
    origin[keys[i]] = add[keys[i]];
  }
  return origin;
};

function hasOwnProperty(obj, prop) {
  return Object.prototype.hasOwnProperty.call(obj, prop);
}

}).call(this,require('_process'),typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})

},{"./support/isBuffer":293,"_process":74,"inherits":58}],295:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createAccount = createAccount;
exports.completeCreateAccount = completeCreateAccount;
exports.failCreateAccount = failCreateAccount;
exports.updateAccountS3Access = updateAccountS3Access;
exports.completeUpdateAccountS3Access = completeUpdateAccountS3Access;
exports.failUpdateAccountS3Access = failUpdateAccountS3Access;
exports.setAccountIpRestrictions = setAccountIpRestrictions;
exports.completeSetAccountIpRestrictions = completeSetAccountIpRestrictions;
exports.failSetAccountIpRestrictions = failSetAccountIpRestrictions;
exports.changeAccountPassword = changeAccountPassword;
exports.completeChangeAccountPassword = completeChangeAccountPassword;
exports.failChangeAccountPassword = failChangeAccountPassword;
exports.resetAccountPassword = resetAccountPassword;
exports.completeResetAccountPassword = completeResetAccountPassword;
exports.failResetAccountPassword = failResetAccountPassword;
exports.addExternalConnection = addExternalConnection;
exports.completeAddExternalConnection = completeAddExternalConnection;
exports.failAddExternalConnection = failAddExternalConnection;
exports.updateExternalConnection = updateExternalConnection;
exports.completeUpdateExternalConnection = completeUpdateExternalConnection;
exports.failUpdateExternalConnection = failUpdateExternalConnection;
exports.tryDeleteAccount = tryDeleteAccount;
exports.completeDeleteAccount = completeDeleteAccount;
exports.failDeleteAccount = failDeleteAccount;
exports.deleteExternalConnection = deleteExternalConnection;
exports.completeDeleteExternalConnection = completeDeleteExternalConnection;
exports.failDeleteExternalConnection = failDeleteExternalConnection;
exports.regenerateAccountCredentials = regenerateAccountCredentials;
exports.completeRegenerateAccountCredentials = completeRegenerateAccountCredentials;
exports.failRegenerateAccountCredentials = failRegenerateAccountCredentials;
exports.updateAccountUITheme = updateAccountUITheme;

var _stringUtils = require("utils/string-utils");

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
function createAccount(accountName, isAdmin, password, defaultResource, hasAccessToAllBucekts, allowedBuckets, allowBucketCreation) {
  return {
    type: _actionTypes.CREATE_ACCOUNT,
    payload: {
      accountName,
      isAdmin,
      password,
      defaultResource,
      hasAccessToAllBucekts,
      allowedBuckets,
      allowBucketCreation
    }
  };
}

function completeCreateAccount(accountName, password) {
  return {
    type: _actionTypes.COMPLETE_CREATE_ACCOUNT,
    payload: {
      accountName,
      password
    }
  };
}

function failCreateAccount(accountName, error) {
  return {
    type: _actionTypes.FAIL_CREATE_ACCOUNT,
    payload: {
      accountName,
      error
    }
  };
}

function updateAccountS3Access(accountName, defaultResource, hasAccessToAllBuckets, allowedBuckets, allowBucketCreation) {
  return {
    type: _actionTypes.UPDATE_ACCOUNT_S3_ACCESS,
    payload: {
      accountName,
      defaultResource,
      hasAccessToAllBuckets,
      allowedBuckets,
      allowBucketCreation
    }
  };
}

function completeUpdateAccountS3Access(accountName) {
  return {
    type: _actionTypes.COMPLETE_UPDATE_ACCOUNT_S3_ACCESS,
    payload: {
      accountName
    }
  };
}

function failUpdateAccountS3Access(accountName, error) {
  return {
    type: _actionTypes.FAIL_UPDATE_ACCOUNT_S3_ACCESS,
    payload: {
      accountName,
      error
    }
  };
}

function setAccountIpRestrictions(accountName, allowedIps) {
  return {
    type: _actionTypes.SET_ACCOUNT_IP_RESTRICTIONS,
    payload: {
      accountName,
      allowedIps
    }
  };
}

function completeSetAccountIpRestrictions(accountName) {
  return {
    type: _actionTypes.COMPLETE_SET_ACCOUNT_IP_RESTRICTIONS,
    payload: {
      accountName
    }
  };
}

function failSetAccountIpRestrictions(accountName, error) {
  return {
    type: _actionTypes.FAIL_SET_ACCOUNT_IP_RESTRICTIONS,
    payload: {
      accountName,
      error
    }
  };
}

function changeAccountPassword(verificationPassword, accountName, password) {
  return {
    type: _actionTypes.CHANGE_ACCOUNT_PASSWORD,
    payload: {
      verificationPassword,
      accountName,
      password
    }
  };
}

function completeChangeAccountPassword(accountName, expireNewPassword) {
  return {
    type: _actionTypes.COMPLETE_CHANGE_ACCOUNT_PASSWORD,
    payload: {
      accountName,
      expireNewPassword
    }
  };
}

function failChangeAccountPassword(accountName, error) {
  return {
    type: _actionTypes.FAIL_CHANGE_ACCOUNT_PASSWORD,
    payload: {
      accountName,
      error
    }
  };
}

function resetAccountPassword(verificationPassword, accountName) {
  const password = (0, _stringUtils.randomString)();
  return {
    type: _actionTypes.RESET_ACCOUNT_PASSWORD,
    payload: {
      verificationPassword,
      accountName,
      password
    }
  };
}

function completeResetAccountPassword(accountName, password) {
  return {
    type: _actionTypes.COMPLETE_RESET_ACCOUNT_PASSWORD,
    payload: {
      accountName,
      password
    }
  };
}

function failResetAccountPassword(accountName, error) {
  return {
    type: _actionTypes.FAIL_RESET_ACCOUNT_PASSWORD,
    payload: {
      accountName,
      error
    }
  };
}

function addExternalConnection(name, service, params) {
  return {
    type: _actionTypes.ADD_EXTERNAL_CONNECTION,
    payload: {
      name,
      service,
      params
    }
  };
}

function completeAddExternalConnection(connection) {
  return {
    type: _actionTypes.COMPLETE_ADD_EXTERNAL_CONNECTION,
    payload: {
      connection
    }
  };
}

function failAddExternalConnection(connection, error) {
  return {
    type: _actionTypes.FAIL_ADD_EXTERNAL_CONNECTION,
    payload: {
      connection,
      error
    }
  };
}

function updateExternalConnection(name, service, params) {
  return {
    type: _actionTypes.UPDATE_EXTERNAL_CONNECTION,
    payload: {
      name,
      service,
      params
    }
  };
}

function completeUpdateExternalConnection(connection) {
  return {
    type: _actionTypes.COMPLETE_UPDATE_EXTERNAL_CONNECTION,
    payload: {
      connection
    }
  };
}

function failUpdateExternalConnection(connection, error) {
  return {
    type: _actionTypes.FAIL_UPDATE_EXTERNAL_CONNECTION,
    payload: {
      connection,
      error
    }
  };
}

function tryDeleteAccount(email, isCurrentUser, isConfirmed = false) {
  return {
    type: _actionTypes.TRY_DELETE_ACCOUNT,
    payload: {
      email,
      isCurrentUser,
      isConfirmed
    }
  };
}

function completeDeleteAccount(email, isCurrentUser) {
  return {
    type: _actionTypes.COMPLETE_DELETE_ACCOUNT,
    payload: {
      email,
      isCurrentUser
    }
  };
}

function failDeleteAccount(email, error) {
  return {
    type: _actionTypes.FAIL_DELETE_ACCOUNT,
    payload: {
      email,
      error
    }
  };
}

function deleteExternalConnection(connection) {
  return {
    type: _actionTypes.DELETE_EXTERNAL_CONNECTION,
    payload: {
      connection
    }
  };
}

function completeDeleteExternalConnection(connection) {
  return {
    type: _actionTypes.COMPLETE_DELETE_EXTERNAL_CONNECTION,
    payload: {
      connection
    }
  };
}

function failDeleteExternalConnection(connection, error) {
  return {
    type: _actionTypes.FAIL_DELETE_EXTERNAL_CONNECTION,
    payload: {
      connection,
      error
    }
  };
}

function regenerateAccountCredentials(accountName) {
  return {
    type: _actionTypes.REGENERATE_ACCOUNT_CREDENTIALS,
    payload: {
      accountName
    }
  };
}

function completeRegenerateAccountCredentials(accountName) {
  return {
    type: _actionTypes.COMPLETE_REGENERATE_ACCOUNT_CREDENTIALS,
    payload: {
      accountName
    }
  };
}

function failRegenerateAccountCredentials(accountName, error) {
  return {
    type: _actionTypes.FAIL_REGENERATE_ACCOUNT_CREDENTIALS,
    payload: {
      accountName,
      error
    }
  };
}

function updateAccountUITheme(accountName, theme) {
  return {
    type: _actionTypes.UPDATE_ACCOUNT_UI_THEME,
    payload: {
      accountName,
      theme
    }
  };
}

},{"action-types":318,"utils/string-utils":1046}],296:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.fetchAlerts = fetchAlerts;
exports.completeFetchAlerts = completeFetchAlerts;
exports.failFetchAlerts = failFetchAlerts;
exports.updateAlerts = updateAlerts;
exports.completeUpdateAlerts = completeUpdateAlerts;
exports.failUpdateAlerts = failUpdateAlerts;
exports.fetchUnreadAlertsCount = fetchUnreadAlertsCount;
exports.completeFetchUnreadAlertsCount = completeFetchUnreadAlertsCount;
exports.failFetchUnreadAlertsCount = failFetchUnreadAlertsCount;
exports.dropAlerts = dropAlerts;

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
function fetchAlerts(query, limit) {
  return {
    type: _actionTypes.FETCH_ALERTS,
    payload: {
      query,
      limit
    }
  };
}

function completeFetchAlerts(requested, list) {
  return {
    type: _actionTypes.COMPLETE_FETCH_ALERTS,
    payload: {
      requested,
      list
    }
  };
}

function failFetchAlerts(error) {
  return {
    type: _actionTypes.FAIL_FETCH_ALERTS,
    payload: {
      error
    }
  };
}

function updateAlerts(query, read) {
  return {
    type: _actionTypes.UPDATE_ALERTS,
    payload: {
      query,
      read
    }
  };
}

function completeUpdateAlerts(query, read) {
  return {
    type: _actionTypes.COMPLETE_UPDATE_ALERTS,
    payload: {
      query,
      read
    }
  };
}

function failUpdateAlerts(query, read, error) {
  return {
    type: _actionTypes.FAIL_UPDATE_ALERTS,
    payload: {
      query,
      read,
      error
    }
  };
}

function fetchUnreadAlertsCount() {
  return {
    type: _actionTypes.FETCH_UNREAD_ALERTS_COUNT
  };
}

function completeFetchUnreadAlertsCount(crit, major, info) {
  return {
    type: _actionTypes.COMPLETE_FETCH_UNREAD_ALERTS_COUNT,
    payload: {
      crit,
      major,
      info
    }
  };
}

function failFetchUnreadAlertsCount(error) {
  return {
    type: _actionTypes.FAIL_FETCH_UNREAD_ALERTS_COUNT,
    payload: {
      error
    }
  };
}

function dropAlerts() {
  return {
    type: _actionTypes.DROP_ALERTS
  };
}

},{"action-types":318}],297:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.fetchBucketUsageHistory = fetchBucketUsageHistory;
exports.completeFetchBucketUsageHistory = completeFetchBucketUsageHistory;
exports.failFetchBucketUsageHistory = failFetchBucketUsageHistory;
exports.dropBucketUsageHistory = dropBucketUsageHistory;
exports.fetchAccountUsageHistory = fetchAccountUsageHistory;
exports.completeFetchAccountUsageHistory = completeFetchAccountUsageHistory;
exports.failFetchAccountUsageHistory = failFetchAccountUsageHistory;
exports.dropAccountUsageHistory = dropAccountUsageHistory;
exports.fetchObjectsDistribution = fetchObjectsDistribution;
exports.completeFetchObjectsDistribution = completeFetchObjectsDistribution;
exports.failCompleteFetchObjectsDistribution = failCompleteFetchObjectsDistribution;
exports.dropCompleteFetchObjectsDistribution = dropCompleteFetchObjectsDistribution;
exports.fetchCloudUsageStats = fetchCloudUsageStats;
exports.completeFetchCloudUsageStats = completeFetchCloudUsageStats;
exports.failFetchCloudUsageStats = failFetchCloudUsageStats;
exports.dropCloudUsageStats = dropCloudUsageStats;
exports.fetchLambdaFuncUsageHistory = fetchLambdaFuncUsageHistory;
exports.completeFetchLambdaFuncUsageHistory = completeFetchLambdaFuncUsageHistory;
exports.failFetchLambdaFuncUsageHistory = failFetchLambdaFuncUsageHistory;
exports.dropLambdaFuncUsageHistory = dropLambdaFuncUsageHistory;

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
function fetchBucketUsageHistory(buckets, duration) {
  return {
    type: _actionTypes.FETCH_BUCKET_USAGE_HISTORY,
    payload: {
      buckets,
      duration
    }
  };
}

function completeFetchBucketUsageHistory(query, usage) {
  return {
    type: _actionTypes.COMPLETE_FETCH_BUCKET_USAGE_HISTORY,
    payload: {
      query,
      usage
    }
  };
}

function failFetchBucketUsageHistory(query, error) {
  return {
    type: _actionTypes.FAIL_FETCH_BUCKET_USAGE_HISTORY,
    payload: {
      query,
      error
    }
  };
}

function dropBucketUsageHistory() {
  return {
    type: _actionTypes.DROP_BUCKET_USAGE_HISTORY
  };
}

function fetchAccountUsageHistory(duration, endpointGroups) {
  return {
    type: _actionTypes.FETCH_ACCOUNT_USAGE_HISTORY,
    payload: {
      timestamp: Date.now(),
      endpointGroups,
      duration
    }
  };
}

function completeFetchAccountUsageHistory(query, usage) {
  return {
    type: _actionTypes.COMPLETE_FETCH_ACCOUNT_USAGE_HISTORY,
    payload: {
      query,
      usage
    }
  };
}

function failFetchAccountUsageHistory(query, error) {
  return {
    type: _actionTypes.FAIL_FETCH_ACCOUNT_USAGE_HISTORY,
    payload: {
      query,
      error
    }
  };
}

function dropAccountUsageHistory() {
  return {
    type: _actionTypes.DROP_ACCOUNT_USAGE_HISTORY
  };
}

function fetchObjectsDistribution() {
  return {
    type: _actionTypes.FETCH_OBJECTS_DISTRIBUTION
  };
}

function completeFetchObjectsDistribution(distribution) {
  return {
    type: _actionTypes.COMPLETE_FETCH_OBJECTS_DISTRIBUTION,
    payload: distribution
  };
}

function failCompleteFetchObjectsDistribution(error) {
  return {
    type: _actionTypes.FAIL_FETCH_OBJECTS_DISTRIBUTION,
    payload: {
      error
    }
  };
}

function dropCompleteFetchObjectsDistribution() {
  return {
    type: _actionTypes.DROP_FETCH_OBJECTS_DISTRIBUTION
  };
}

function fetchCloudUsageStats(duration) {
  return {
    type: _actionTypes.FETCH_CLOUD_USAGE_STATS,
    payload: {
      duration
    }
  };
}

function completeFetchCloudUsageStats(query, usage) {
  return {
    type: _actionTypes.COMPLETE_FETCH_CLOUD_USAGE_STATS,
    payload: {
      query,
      usage
    }
  };
}

function failFetchCloudUsageStats(query, error) {
  return {
    type: _actionTypes.FAIL_FETCH_CLOUD_USAGE_STATS,
    payload: {
      query,
      error
    }
  };
}

function dropCloudUsageStats() {
  return {
    type: _actionTypes.DROP_CLOUD_USAGE_STATS
  };
}

function fetchLambdaFuncUsageHistory(name, version, timespan, step) {
  return {
    type: _actionTypes.FETCH_LAMBDA_FUNC_USAGE_HISTORY,
    payload: {
      name,
      version,
      timespan,
      step
    }
  };
}

function completeFetchLambdaFuncUsageHistory(query, usage) {
  return {
    type: _actionTypes.COMPLETE_FETCH_LAMBDA_FUNC_USAGE_HISTORY,
    payload: {
      query,
      usage
    }
  };
}

function failFetchLambdaFuncUsageHistory(query, error) {
  return {
    type: _actionTypes.FAIL_FETCH_LAMBDA_FUNC_USAGE_HISTORY,
    payload: {
      query,
      error
    }
  };
}

function dropLambdaFuncUsageHistory(name, version) {
  return {
    type: _actionTypes.DROP_LAMBDA_FUNC_USAGE_HISTORY,
    payload: {
      name,
      version
    }
  };
}

},{"action-types":318}],298:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.fetchAuditLog = fetchAuditLog;
exports.completeFetchAuditLog = completeFetchAuditLog;
exports.failFetchAuditLog = failFetchAuditLog;
exports.dropAuditLog = dropAuditLog;
exports.exportAuditLog = exportAuditLog;
exports.completeExportAuditLog = completeExportAuditLog;
exports.failExportAuditLog = failExportAuditLog;
exports.selectAuditRecord = selectAuditRecord;

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
function fetchAuditLog(query, limit, till) {
  return {
    type: _actionTypes.FETCH_AUDIT_LOG,
    payload: {
      query,
      limit,
      till
    }
  };
}

function completeFetchAuditLog(requested, list) {
  return {
    type: _actionTypes.COMPLETE_FETCH_AUDIT_LOG,
    payload: {
      requested,
      list
    }
  };
}

function failFetchAuditLog(error) {
  return {
    type: _actionTypes.FAIL_FETCH_AUDIT_LOG,
    payload: {
      error
    }
  };
}

function dropAuditLog() {
  return {
    type: _actionTypes.DROP_AUDIT_LOG
  };
}

function exportAuditLog(categories) {
  return {
    type: _actionTypes.EXPORT_AUDIT_LOG,
    payload: {
      categories
    }
  };
}

function completeExportAuditLog(logUri) {
  return {
    type: _actionTypes.COMPLETE_EXPORT_AUDIT_LOG,
    payload: {
      logUri
    }
  };
}

function failExportAuditLog(error) {
  return {
    type: _actionTypes.FAIL_EXPORT_AUDIT_LOG,
    payload: {
      error
    }
  };
}

function selectAuditRecord(recordId) {
  return {
    type: _actionTypes.SELECT_AUDIT_RECORD,
    payload: {
      recordId
    }
  };
}

},{"action-types":318}],299:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createBucket = createBucket;
exports.completeCreateBucket = completeCreateBucket;
exports.failCreateBucket = failCreateBucket;
exports.updateBucketQuotaPolicy = updateBucketQuotaPolicy;
exports.completeUpdateBucketQuotaPolicy = completeUpdateBucketQuotaPolicy;
exports.failUpdateBucketQuotaPolicy = failUpdateBucketQuotaPolicy;
exports.updateBucketResiliencyPolicy = updateBucketResiliencyPolicy;
exports.completeUpdateBucketResiliencyPolicy = completeUpdateBucketResiliencyPolicy;
exports.failUpdateBucketResiliencyPolicy = failUpdateBucketResiliencyPolicy;
exports.updateBucketVersioningPolicy = updateBucketVersioningPolicy;
exports.completeUpdateBucketVersioningPolicy = completeUpdateBucketVersioningPolicy;
exports.failUpdateBucketVersioningPolicy = failUpdateBucketVersioningPolicy;
exports.deleteBucket = deleteBucket;
exports.completeDeleteBucket = completeDeleteBucket;
exports.failDeleteBucket = failDeleteBucket;
exports.createNamespaceBucket = createNamespaceBucket;
exports.completeCreateNamespaceBucket = completeCreateNamespaceBucket;
exports.failCreateNamespaceBucket = failCreateNamespaceBucket;
exports.updateNamespaceBucketPlacement = updateNamespaceBucketPlacement;
exports.completeUpdateNamespaceBucketPlacement = completeUpdateNamespaceBucketPlacement;
exports.failNamespaceBucketPlacement = failNamespaceBucketPlacement;
exports.deleteNamespaceBucket = deleteNamespaceBucket;
exports.completeDeleteNamespaceBucket = completeDeleteNamespaceBucket;
exports.failCompleteDeleteNamespaceBucket = failCompleteDeleteNamespaceBucket;
exports.updateBucketS3Access = updateBucketS3Access;
exports.completeUpdateBucketS3Access = completeUpdateBucketS3Access;
exports.failUpdateBucketS3Access = failUpdateBucketS3Access;
exports.addBucketTrigger = addBucketTrigger;
exports.completeAddBucketTrigger = completeAddBucketTrigger;
exports.failAddBucketTrigger = failAddBucketTrigger;
exports.updateBucketTrigger = updateBucketTrigger;
exports.completeUpdateBucketTrigger = completeUpdateBucketTrigger;
exports.failUpdateBucketTrigger = failUpdateBucketTrigger;
exports.removeBucketTrigger = removeBucketTrigger;
exports.completeRemoveBucketTrigger = completeRemoveBucketTrigger;
exports.failRemoveBucketTrigger = failRemoveBucketTrigger;
exports.updateTierPlacementPolicy = updateTierPlacementPolicy;
exports.completeUpdateTierPlacementPolicy = completeUpdateTierPlacementPolicy;
exports.failUpdateTierPlacementPolicy = failUpdateTierPlacementPolicy;
exports.addBucketTier = addBucketTier;
exports.completeAddBucketTier = completeAddBucketTier;
exports.failAddBucketTier = failAddBucketTier;

var _actionTypes = require("action-types");

function createBucket(name, placementType, resourceIds) {
  return {
    type: _actionTypes.CREATE_BUCKET,
    payload: {
      name,
      placementType,
      resourceIds
    }
  };
}

function completeCreateBucket(name) {
  return {
    type: _actionTypes.COMPLETE_CREATE_BUCKET,
    payload: {
      name
    }
  };
}

function failCreateBucket(name, error) {
  return {
    type: _actionTypes.FAIL_CREATE_BUCKET,
    payload: {
      name,
      error
    }
  };
}

function updateBucketQuotaPolicy(bucket, quota) {
  return {
    type: _actionTypes.UPDATE_BUCKET_QUOTA_POLICY,
    payload: {
      bucket,
      quota
    }
  };
}

function completeUpdateBucketQuotaPolicy(bucket) {
  return {
    type: _actionTypes.COMPLETE_UPDATE_BUCKET_QUOTA_POLICY,
    payload: {
      bucket
    }
  };
}

function failUpdateBucketQuotaPolicy(bucket, error) {
  return {
    type: _actionTypes.FAIL_UPDATE_BUCKET_QUOTA_POLICY,
    payload: {
      bucket,
      error
    }
  };
}

function updateBucketResiliencyPolicy(bucket, policy) {
  return {
    type: _actionTypes.UPDATE_BUCKET_RESILIENCY_POLICY,
    payload: {
      bucket,
      policy
    }
  };
}

function completeUpdateBucketResiliencyPolicy(bucket) {
  return {
    type: _actionTypes.COMPLETE_UPDATE_BUCKET_RESILIENCY_POLICY,
    payload: {
      bucket
    }
  };
}

function failUpdateBucketResiliencyPolicy(bucket, error) {
  return {
    type: _actionTypes.FAIL_UPDATE_BUCKET_RESILIENCY_POLICY,
    payload: {
      bucket,
      error
    }
  };
}

function updateBucketVersioningPolicy(bucket, versioning) {
  return {
    type: _actionTypes.UPDATE_BUCKET_VERSIONING_POLICY,
    payload: {
      bucket,
      versioning
    }
  };
}

function completeUpdateBucketVersioningPolicy(bucket, versioning) {
  return {
    type: _actionTypes.COMPLETE_UPDATE_BUCKET_VERSIONING_POLICY,
    payload: {
      bucket,
      versioning
    }
  };
}

function failUpdateBucketVersioningPolicy(bucket, versioning, error) {
  return {
    type: _actionTypes.FAIL_UPDATE_BUCKET_VERSIONING_POLICY,
    payload: {
      bucket,
      versioning,
      error
    }
  };
}

function deleteBucket(bucket) {
  return {
    type: _actionTypes.DELETE_BUCKET,
    payload: {
      bucket
    }
  };
}

function completeDeleteBucket(bucket) {
  return {
    type: _actionTypes.COMPLETE_DELETE_BUCKET,
    payload: {
      bucket
    }
  };
}

function failDeleteBucket(bucket, error) {
  return {
    type: _actionTypes.FAIL_DELETE_BUCKET,
    payload: {
      bucket,
      error
    }
  };
}

function createNamespaceBucket(name, readFrom, writeTo, caching) {
  return {
    type: _actionTypes.CREATE_NAMESPACE_BUCKET,
    payload: {
      name,
      readFrom,
      writeTo,
      caching
    }
  };
}

function completeCreateNamespaceBucket(name) {
  return {
    type: _actionTypes.COMPLETE_CREATE_NAMESPACE_BUCKET,
    payload: {
      name
    }
  };
}

function failCreateNamespaceBucket(name, error) {
  return {
    type: _actionTypes.FAIL_CREATE_NAMESPACE_BUCKET,
    payload: {
      name,
      error
    }
  };
}

function updateNamespaceBucketPlacement(name, readFrom, writeTo) {
  return {
    type: _actionTypes.UPDATE_NAMESPACE_BUCKET_PLACEMENT,
    payload: {
      name,
      readFrom,
      writeTo
    }
  };
}

function completeUpdateNamespaceBucketPlacement(name) {
  return {
    type: _actionTypes.COMPLETE_UPDATE_NAMESPACE_BUCKET_PLACEMENT,
    payload: {
      name
    }
  };
}

function failNamespaceBucketPlacement(name, error) {
  return {
    type: _actionTypes.FAIL_UPDATE_NAMESPACE_BUCKET_PLACEMENT,
    payload: {
      name,
      error
    }
  };
}

function deleteNamespaceBucket(name) {
  return {
    type: _actionTypes.DELETE_NAMESPACE_BUCKET,
    payload: {
      name
    }
  };
}

function completeDeleteNamespaceBucket(name) {
  return {
    type: _actionTypes.COMPLETE_DELETE_NAMESPACE_BUCKET,
    payload: {
      name
    }
  };
}

function failCompleteDeleteNamespaceBucket(name, error) {
  return {
    type: _actionTypes.FAIL_DELETE_NAMESPACE_BUCKET,
    payload: {
      name,
      error
    }
  };
}

function updateBucketS3Access(bucketName, allowedAccounts) {
  return {
    type: _actionTypes.UPDATE_BUCKET_S3_ACCESS,
    payload: {
      bucketName,
      allowedAccounts
    }
  };
}

function completeUpdateBucketS3Access(bucketName) {
  return {
    type: _actionTypes.COMPLETE_UPDATE_BUCKET_S3_ACCESS,
    payload: {
      bucketName
    }
  };
}

function failUpdateBucketS3Access(bucketName, error) {
  return {
    type: _actionTypes.FAIL_UPDATE_BUCKET_S3_ACCESS,
    payload: {
      bucketName,
      error
    }
  };
}

function addBucketTrigger(config) {
  return {
    type: _actionTypes.ADD_BUCKET_TRIGGER,
    payload: config
  };
}

function completeAddBucketTrigger(bucketName) {
  return {
    type: _actionTypes.COMPLETE_ADD_BUCKET_TRIGGER,
    payload: {
      bucketName
    }
  };
}

function failAddBucketTrigger(bucketName, error) {
  return {
    type: _actionTypes.FAIL_ADD_BUCKET_TRIGGER,
    payload: {
      bucketName,
      error
    }
  };
}

function updateBucketTrigger(bucketName, triggerId, config, displayEntity) {
  return {
    type: _actionTypes.UPDATE_BUCKET_TRIGGER,
    payload: {
      bucketName,
      triggerId,
      config,
      displayEntity
    }
  };
}

function completeUpdateBucketTrigger(displayEntity) {
  return {
    type: _actionTypes.COMPLETE_UPDATE_BUCKET_TRIGGER,
    payload: {
      displayEntity
    }
  };
}

function failUpdateBucketTrigger(displayEntity, error) {
  return {
    type: _actionTypes.FAIL_UPDATE_BUCKET_TRIGGER,
    payload: {
      displayEntity,
      error
    }
  };
}

function removeBucketTrigger(bucketName, triggerId) {
  return {
    type: _actionTypes.REMOVE_BUCKET_TRIGGER,
    payload: {
      bucketName,
      triggerId
    }
  };
}

function completeRemoveBucketTrigger(bucketName) {
  return {
    type: _actionTypes.COMPLETE_REMOVE_BUCKET_TRIGGER,
    payload: {
      bucketName
    }
  };
}

function failRemoveBucketTrigger(bucketName, error) {
  return {
    type: _actionTypes.FAIL_REMOVE_BUCKET_TRIGGER,
    payload: {
      bucketName,
      error
    }
  };
}

function updateTierPlacementPolicy(bucket, tier, policyType, resourceIds) {
  return {
    type: _actionTypes.UPDATE_TIER_PLACEMENT_POLICY,
    payload: {
      bucket,
      tier,
      policyType,
      resourceIds
    }
  };
}

function completeUpdateTierPlacementPolicy(bucket, tier) {
  return {
    type: _actionTypes.COMPLETE_UPDATE_TIER_PLACEMENT_POLICY,
    payload: {
      bucket,
      tier
    }
  };
}

function failUpdateTierPlacementPolicy(bucket, tier, error) {
  return {
    type: _actionTypes.FAIL_UPDATE_TIER_PLACEMENT_POLICY,
    payload: {
      bucket,
      tier,
      error
    }
  };
}

function addBucketTier(bucket, policyType, resourceIds) {
  return {
    type: _actionTypes.ADD_BUCKET_TIER,
    payload: {
      bucket,
      policyType,
      resourceIds
    }
  };
}

function completeAddBucketTier(bucket) {
  return {
    type: _actionTypes.COMPLETE_ADD_BUCKET_TIER,
    payload: {
      bucket
    }
  };
}

function failAddBucketTier(bucket, error) {
  return {
    type: _actionTypes.FAIL_ADD_BUCKET_TIER,
    payload: {
      bucket,
      error
    }
  };
}

},{"action-types":318}],300:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.fetchCloudTargets = fetchCloudTargets;
exports.completeFetchCloudTargets = completeFetchCloudTargets;
exports.failFetchCloudTargets = failFetchCloudTargets;
exports.dropCloudTargets = dropCloudTargets;
exports.createCloudResource = createCloudResource;
exports.completeCreateCloudResource = completeCreateCloudResource;
exports.failCreateCloudResource = failCreateCloudResource;

var _actionTypes = require("action-types");

function fetchCloudTargets(connection) {
  return {
    type: _actionTypes.FETCH_CLOUD_TARGETS,
    payload: {
      connection
    }
  };
}

function completeFetchCloudTargets(connection, targets) {
  return {
    type: _actionTypes.COMPLETE_FETCH_CLOUD_TARGETS,
    payload: {
      connection,
      targets
    }
  };
}

function failFetchCloudTargets(connection, error) {
  return {
    type: _actionTypes.FAIL_FETCH_CLOUD_TARGETS,
    payload: {
      connection,
      error
    }
  };
}

function dropCloudTargets() {
  return {
    type: _actionTypes.DROP_CLOUD_TARGETS
  };
}

function createCloudResource(name, connection, target) {
  return {
    type: _actionTypes.CREATE_CLOUD_RESOURCE,
    payload: {
      name,
      connection,
      target
    }
  };
}

function completeCreateCloudResource(name) {
  return {
    type: _actionTypes.COMPLETE_CREATE_CLOUD_RESOURCE,
    payload: {
      name
    }
  };
}

function failCreateCloudResource(name, error) {
  return {
    type: _actionTypes.FAIL_CREATE_CLOUD_RESOURCE,
    payload: {
      name,
      error
    }
  };
}

},{"action-types":318}],301:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.generateEndpointGroupDeploymentYAML = generateEndpointGroupDeploymentYAML;
exports.completeGenerateEndpointGroupDeploymentYAML = completeGenerateEndpointGroupDeploymentYAML;
exports.failGenerateEndpointGroupDeploymentYAML = failGenerateEndpointGroupDeploymentYAML;
exports.updateEndpointGroup = updateEndpointGroup;
exports.completeUpdateEndpointGroup = completeUpdateEndpointGroup;
exports.failUpdateEndpointGroup = failUpdateEndpointGroup;
exports.fetchEndpointsHistory = fetchEndpointsHistory;
exports.completeFetchEndpointsHistory = completeFetchEndpointsHistory;
exports.failFetchEndpointsHistory = failFetchEndpointsHistory;
exports.dropEndpointsHistory = dropEndpointsHistory;

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
function generateEndpointGroupDeploymentYAML(region, endpointConf) {
  return {
    type: _actionTypes.GENERATE_ENDPOINT_GROUP_DEPLOYMENT_YAML,
    payload: {
      region,
      endpointConf
    }
  };
}

function completeGenerateEndpointGroupDeploymentYAML(deployYAMLUri) {
  return {
    type: _actionTypes.COMPLETE_GENERATE_ENDPOINT_GROUP_DEPLOYMENT_YAML,
    payload: {
      deployYAMLUri
    }
  };
}

function failGenerateEndpointGroupDeploymentYAML(error) {
  return {
    type: _actionTypes.FAIL_GENERATE_ENDPOINT_GROUP_DEPLOYMENT_YAML,
    payload: {
      error
    }
  };
}

function updateEndpointGroup(name, region, endpointConf) {
  return {
    type: _actionTypes.UPDATE_ENDPOINT_GROUP,
    payload: {
      name,
      region,
      endpointConf
    }
  };
}

function completeUpdateEndpointGroup(name) {
  return {
    type: _actionTypes.COMPLETE_UPDATE_ENDPOINT_GROUP,
    payload: {
      name
    }
  };
}

function failUpdateEndpointGroup(name, error) {
  return {
    type: _actionTypes.FAIL_UPDATE_ENDPOINT_GROUP,
    payload: {
      name,
      error
    }
  };
}

function fetchEndpointsHistory(groups, timespan) {
  return {
    type: _actionTypes.FETCH_ENDPOINTS_HISTORY,
    payload: {
      timestamp: Date.now(),
      groups,
      timespan
    }
  };
}

function completeFetchEndpointsHistory(query, history) {
  return {
    type: _actionTypes.COMPLETE_FETCH_ENDPOINTS_HISTORY,
    payload: {
      query,
      history
    }
  };
}

function failFetchEndpointsHistory(query, error) {
  return {
    type: _actionTypes.FAIL_FETCH_ENDPOINTS_HISTORY,
    payload: {
      query,
      error
    }
  };
}

function dropEndpointsHistory() {
  return {
    type: _actionTypes.DROP_ENDPOINTS_HISTORY,
    payload: {}
  };
}

},{"action-types":318}],302:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.togglePreviewContent = togglePreviewContent;
exports.setupEnv = setupEnv;
exports.dismissBrowserSticky = dismissBrowserSticky;

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
function togglePreviewContent() {
  return {
    type: _actionTypes.TOGGLE_PREVIEW_CONTENT
  };
}

function setupEnv(browser, previewContent) {
  return {
    type: _actionTypes.SETUP_ENV,
    payload: {
      browser,
      previewContent
    }
  };
}

function dismissBrowserSticky() {
  return {
    type: _actionTypes.DISSMISS_BROWSER_STICKY
  };
}

},{"action-types":318}],303:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.initializeForm = initializeForm;
exports.updateForm = updateForm;
exports.resetForm = resetForm;
exports.touchForm = touchForm;
exports.untouchForm = untouchForm;
exports.setFormValidity = setFormValidity;
exports.submitForm = submitForm;
exports.completeSubmitForm = completeSubmitForm;
exports.dropForm = dropForm;

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
function initializeForm(form, values = {}) {
  return {
    type: _actionTypes.INIT_FORM,
    payload: {
      form,
      values
    }
  };
}

function updateForm(form, values, touch = true) {
  return {
    type: _actionTypes.UPDATE_FORM,
    payload: {
      form,
      values,
      touch
    }
  };
}

function resetForm(form) {
  return {
    type: _actionTypes.RESET_FORM,
    payload: {
      form
    }
  };
}

function touchForm(form, fields) {
  return {
    type: _actionTypes.TOUCH_FORM,
    payload: {
      form,
      fields
    }
  };
}

function untouchForm(form, fields) {
  return {
    type: _actionTypes.UNTOUCH_FORM,
    payload: {
      form,
      fields
    }
  };
}

function setFormValidity(form, validity) {
  return {
    type: _actionTypes.SET_FORM_VALIDITY,
    payload: {
      form,
      values: validity.values,
      fieldsValidity: validity.fieldsValidity,
      warnings: validity.warnings,
      syncErrors: validity.syncErrors,
      asyncErrors: validity.asyncErrors,
      validatingAsync: validity.validatingAsync,
      confirmValidity: validity.confirmValidity,
      touch: validity.touch
    }
  };
}

function submitForm(form) {
  return {
    type: _actionTypes.SUBMIT_FORM,
    payload: {
      form
    }
  };
}

function completeSubmitForm(form, errors = {}) {
  return {
    type: _actionTypes.COMPLETE_SUBMIT_FORM,
    payload: {
      form,
      errors
    }
  };
}

function dropForm(form) {
  return {
    type: _actionTypes.DROP_FROM,
    payload: {
      form
    }
  };
}

},{"action-types":318}],304:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createLambdaFunc = createLambdaFunc;
exports.completeCreateLambdaFunc = completeCreateLambdaFunc;
exports.failCreateLambdaFunc = failCreateLambdaFunc;
exports.deleteLambdaFunc = deleteLambdaFunc;
exports.completeDeleteLambdaFunc = completeDeleteLambdaFunc;
exports.failDeleteLambdaFunc = failDeleteLambdaFunc;
exports.updateLambdaFuncConfig = updateLambdaFuncConfig;
exports.completeUpdateLambdaFuncConfig = completeUpdateLambdaFuncConfig;
exports.failUpdateLambdaFuncConfig = failUpdateLambdaFuncConfig;
exports.updateLambdaFuncCode = updateLambdaFuncCode;
exports.completeUpdateLambdaFuncCode = completeUpdateLambdaFuncCode;
exports.failUpdateLambdaFuncCode = failUpdateLambdaFuncCode;
exports.loadLambdaFuncCode = loadLambdaFuncCode;
exports.completeLoadLambdaFuncCode = completeLoadLambdaFuncCode;
exports.failLoadLambdaFuncCode = failLoadLambdaFuncCode;
exports.dropLambdaFuncCode = dropLambdaFuncCode;
exports.invokeLambdaFunc = invokeLambdaFunc;
exports.completeInvokeLambdaFunc = completeInvokeLambdaFunc;
exports.failInvokeLambdaFunc = failInvokeLambdaFunc;

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
function createLambdaFunc(name, version, description, runtime, handlerFile, handlerFunc, memorySize, timeout, codeBufferKey, codeBufferSize) {
  return {
    type: _actionTypes.CREATE_LAMBDA_FUNC,
    payload: {
      name,
      version,
      description,
      runtime,
      handlerFile,
      handlerFunc,
      memorySize,
      timeout,
      codeBufferKey,
      codeBufferSize
    }
  };
}

function completeCreateLambdaFunc(name, version) {
  return {
    type: _actionTypes.COMPLETE_CREATE_LAMBDA_FUNC,
    payload: {
      name,
      version
    }
  };
}

function failCreateLambdaFunc(name, version, error) {
  return {
    type: _actionTypes.FAIL_CREATE_LAMBDA_FUNC,
    payload: {
      name,
      version,
      error
    }
  };
}

function deleteLambdaFunc(name, version) {
  return {
    type: _actionTypes.DELETE_LAMBDA_FUNC,
    payload: {
      name,
      version
    }
  };
}

function completeDeleteLambdaFunc(name, version) {
  return {
    type: _actionTypes.COMPLETE_DELETE_LAMBDA_FUNC,
    payload: {
      name,
      version
    }
  };
}

function failDeleteLambdaFunc(name, version, error) {
  return {
    type: _actionTypes.FAIL_DELETE_LAMBDA_FUNC,
    payload: {
      name,
      version,
      error
    }
  };
}

function updateLambdaFuncConfig(name, version, description, runtime, memorySize, timeout) {
  return {
    type: _actionTypes.UPDATE_LAMBDA_FUNC_CONFIG,
    payload: {
      name,
      version,
      description,
      runtime,
      memorySize,
      timeout
    }
  };
}

function completeUpdateLambdaFuncConfig(name, version) {
  return {
    type: _actionTypes.COMPLETE_UPDATE_LAMBDA_FUNC_CONFIG,
    payload: {
      name,
      version
    }
  };
}

function failUpdateLambdaFuncConfig(name, version, error) {
  return {
    type: _actionTypes.FAIL_UPDATE_LAMBDA_FUNC_CONFIG,
    payload: {
      name,
      version,
      error
    }
  };
}

function updateLambdaFuncCode(name, version, handlerFile, handlerFunc, bufferHandle, bufferSize) {
  return {
    type: _actionTypes.UPDATE_LAMBDA_FUNC_CODE,
    payload: {
      name,
      version,
      handlerFile,
      handlerFunc,
      bufferHandle,
      bufferSize
    }
  };
}

function completeUpdateLambdaFuncCode(name, version) {
  return {
    type: _actionTypes.COMPLETE_UPDATE_LAMBDA_FUNC_CODE,
    payload: {
      name,
      version
    }
  };
}

function failUpdateLambdaFuncCode(name, version, error) {
  return {
    type: _actionTypes.FAIL_UPDATE_LAMBDA_FUNC_CODE,
    payload: {
      name,
      version,
      error
    }
  };
}

function loadLambdaFuncCode(name, version) {
  return {
    type: _actionTypes.LOAD_LAMBDA_FUNC_CODE,
    payload: {
      name,
      version
    }
  };
}

function completeLoadLambdaFuncCode(name, version, codeHash, bufferHandle) {
  return {
    type: _actionTypes.COMPLETE_LOAD_LAMBDA_FUNC_CODE,
    payload: {
      name,
      version,
      codeHash,
      bufferHandle
    }
  };
}

function failLoadLambdaFuncCode(name, version, error) {
  return {
    type: _actionTypes.FAIL_LOAD_LAMBDA_FUNC_CODE,
    payload: {
      name,
      version,
      error
    }
  };
}

function dropLambdaFuncCode(name, version) {
  return {
    type: _actionTypes.DROP_LAMBDA_FUNC_CODE,
    payload: {
      name,
      version
    }
  };
}

function invokeLambdaFunc(name, version, event) {
  return {
    type: _actionTypes.INVOKE_LAMBDA_FUNC,
    payload: {
      name,
      version,
      event
    }
  };
}

function completeInvokeLambdaFunc(name, version, error, result) {
  return {
    type: _actionTypes.COMPLETE_INVOKE_LAMBDA_FUNC,
    payload: {
      name,
      version,
      error,
      result
    }
  };
}

function failInvokeLambdaFunc(name, version, error) {
  return {
    type: _actionTypes.FAIL_INVOKE_LAMBDA_FUNC,
    payload: {
      name,
      version,
      error
    }
  };
}

},{"action-types":318}],305:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.fetchHosts = fetchHosts;
exports.completeFetchHosts = completeFetchHosts;
exports.failFetchHosts = failFetchHosts;
exports.dropHostsView = dropHostsView;
exports.collectHostDiagnostics = collectHostDiagnostics;
exports.completeCollectHostDiagnostics = completeCollectHostDiagnostics;
exports.failCollectHostDiagnostics = failCollectHostDiagnostics;
exports.setHostDebugMode = setHostDebugMode;
exports.completeSetHostDebugMode = completeSetHostDebugMode;
exports.failSetHostDebugMode = failSetHostDebugMode;
exports.fetchHostObjects = fetchHostObjects;
exports.completeFetchHostObjects = completeFetchHostObjects;
exports.failFetchHostObjects = failFetchHostObjects;
exports.retrustHost = retrustHost;
exports.completeRetrustHost = completeRetrustHost;
exports.failRetrustHost = failRetrustHost;
exports.removeHost = removeHost;

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
function fetchHosts(view, query, statistics = false) {
  return {
    type: _actionTypes.FETCH_HOSTS,
    payload: {
      view,
      query,
      statistics
    }
  };
}

function completeFetchHosts(query, response) {
  return {
    type: _actionTypes.COMPLETE_FETCH_HOSTS,
    payload: {
      query,
      response
    }
  };
}

function failFetchHosts(query, error) {
  return {
    type: _actionTypes.FAIL_FETCH_HOSTS,
    payload: {
      query,
      error
    }
  };
}

function dropHostsView(view) {
  return {
    type: _actionTypes.DROP_HOSTS_VIEW,
    payload: {
      view
    }
  };
}

function collectHostDiagnostics(host) {
  return {
    type: _actionTypes.COLLECT_HOST_DIAGNOSTICS,
    payload: {
      host
    }
  };
}

function completeCollectHostDiagnostics(host, packageUri) {
  return {
    type: _actionTypes.COMPLETE_COLLECT_HOST_DIAGNOSTICS,
    payload: {
      host,
      packageUri
    }
  };
}

function failCollectHostDiagnostics(host, error) {
  return {
    type: _actionTypes.FAIL_COLLECT_HOST_DIAGNOSTICS,
    payload: {
      host,
      error
    }
  };
}

function setHostDebugMode(host, on) {
  return {
    type: _actionTypes.SET_HOST_DEBUG_MODE,
    payload: {
      host,
      on
    }
  };
}

function completeSetHostDebugMode(host, on) {
  return {
    type: _actionTypes.COMPLETE_SET_HOST_DEBUG_MODE,
    payload: {
      host,
      on
    }
  };
}

function failSetHostDebugMode(host, on, error) {
  return {
    type: _actionTypes.FAIL_SET_HOST_DEBUG_MODE,
    payload: {
      host,
      on,
      error
    }
  };
}

function fetchHostObjects(host, skip, limit) {
  return {
    type: _actionTypes.FETCH_HOST_OBJECTS,
    payload: {
      host,
      skip,
      limit
    }
  };
}

function completeFetchHostObjects(host, skip, limit, response) {
  return {
    type: _actionTypes.COMPLETE_FETCH_HOST_OBJECTS,
    payload: {
      query: {
        host,
        skip,
        limit
      },
      response
    }
  };
}

function failFetchHostObjects(host, skip, limit, error) {
  return {
    type: _actionTypes.FAIL_FETCH_HOST_OBJECTS,
    payload: {
      query: {
        host,
        skip,
        limit
      },
      error
    }
  };
}

function retrustHost(host) {
  return {
    type: _actionTypes.RETRUST_HOST,
    payload: {
      host
    }
  };
}

function completeRetrustHost(host) {
  return {
    type: _actionTypes.COMPLETE_RETRUST_HOST,
    payload: {
      host
    }
  };
}

function failRetrustHost(host, error) {
  return {
    type: _actionTypes.FAIL_RETRUST_HOST,
    payload: {
      host,
      error
    }
  };
}

function removeHost(host) {
  return {
    type: _actionTypes.REMOVE_HOST,
    payload: {
      host
    }
  };
}

},{"action-types":318}],306:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _envActions = require("./env-actions");

Object.keys(_envActions).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _envActions[key];
    }
  });
});

var _uiActions = require("./ui-actions");

Object.keys(_uiActions).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _uiActions[key];
    }
  });
});

var _locationActions = require("./location-actions");

Object.keys(_locationActions).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _locationActions[key];
    }
  });
});

var _sessionActions = require("./session-actions");

Object.keys(_sessionActions).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _sessionActions[key];
    }
  });
});

var _modalsActions = require("./modals-actions");

Object.keys(_modalsActions).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _modalsActions[key];
    }
  });
});

var _formsActions = require("./forms-actions");

Object.keys(_formsActions).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _formsActions[key];
    }
  });
});

var _alertsActions = require("./alerts-actions");

Object.keys(_alertsActions).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _alertsActions[key];
    }
  });
});

var _auditLogActions = require("./audit-log-actions");

Object.keys(_auditLogActions).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _auditLogActions[key];
    }
  });
});

var _systemActions = require("./system-actions");

Object.keys(_systemActions).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _systemActions[key];
    }
  });
});

var _uploadActions = require("./upload-actions");

Object.keys(_uploadActions).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _uploadActions[key];
    }
  });
});

var _bucketActions = require("./bucket-actions");

Object.keys(_bucketActions).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _bucketActions[key];
    }
  });
});

var _resourceActions = require("./resource-actions");

Object.keys(_resourceActions).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _resourceActions[key];
    }
  });
});

var _hostActions = require("./host-actions");

Object.keys(_hostActions).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _hostActions[key];
    }
  });
});

var _accountActions = require("./account-actions");

Object.keys(_accountActions).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _accountActions[key];
    }
  });
});

var _cloudActions = require("./cloud-actions");

Object.keys(_cloudActions).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _cloudActions[key];
    }
  });
});

var _namespaceActions = require("./namespace-actions");

Object.keys(_namespaceActions).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _namespaceActions[key];
    }
  });
});

var _objectActions = require("./object-actions");

Object.keys(_objectActions).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _objectActions[key];
    }
  });
});

var _topologyActions = require("./topology-actions");

Object.keys(_topologyActions).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _topologyActions[key];
    }
  });
});

var _funcActions = require("./func-actions");

Object.keys(_funcActions).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _funcActions[key];
    }
  });
});

var _endpointActions = require("./endpoint-actions");

Object.keys(_endpointActions).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _endpointActions[key];
    }
  });
});

var _supportActions = require("./support-actions");

Object.keys(_supportActions).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _supportActions[key];
    }
  });
});

var _analyticsActions = require("./analytics-actions");

Object.keys(_analyticsActions).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _analyticsActions[key];
    }
  });
});

},{"./account-actions":295,"./alerts-actions":296,"./analytics-actions":297,"./audit-log-actions":298,"./bucket-actions":299,"./cloud-actions":300,"./endpoint-actions":301,"./env-actions":302,"./forms-actions":303,"./func-actions":304,"./host-actions":305,"./location-actions":307,"./modals-actions":308,"./namespace-actions":309,"./object-actions":310,"./resource-actions":311,"./session-actions":312,"./support-actions":313,"./system-actions":314,"./topology-actions":315,"./ui-actions":316,"./upload-actions":317}],307:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.requestLocation = requestLocation;
exports.refreshLocation = refreshLocation;
exports.changeLocation = changeLocation;

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
function requestLocation(url, redirect = false) {
  return {
    type: _actionTypes.REQUEST_LOCATION,
    payload: {
      url,
      redirect
    }
  };
}

function refreshLocation() {
  return {
    type: _actionTypes.REFRESH_LOCATION
  };
}

function changeLocation(location) {
  return {
    type: _actionTypes.CHANGE_LOCATION,
    payload: location
  };
}

},{"action-types":318}],308:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.updateModal = updateModal;
exports.closeModal = closeModal;
exports.openAddCloudResourceModal = openAddCloudResourceModal;
exports.openAddCloudConnectionModal = openAddCloudConnectionModal;
exports.openS3AccessDetailsModal = openS3AccessDetailsModal;
exports.openBucketS3AccessModal = openBucketS3AccessModal;
exports.openAddTierModal = openAddTierModal;
exports.openEditTierDataPlacementModal = openEditTierDataPlacementModal;
exports.openEditBucketDataResiliencyModal = openEditBucketDataResiliencyModal;
exports.openRiskyBucketDataResiliencyWarningModal = openRiskyBucketDataResiliencyWarningModal;
exports.openEmptyDataPlacementWarningModal = openEmptyDataPlacementWarningModal;
exports.openKeepUsingInternalStorageModal = openKeepUsingInternalStorageModal;
exports.openFileUploadsModal = openFileUploadsModal;
exports.openDeleteCurrentAccountWarningModal = openDeleteCurrentAccountWarningModal;
exports.openStartMaintenanceModal = openStartMaintenanceModal;
exports.openObjectPreviewModal = openObjectPreviewModal;
exports.openTestNodeModal = openTestNodeModal;
exports.openEditAccountS3AccessModal = openEditAccountS3AccessModal;
exports.openEditServerDetailsModal = openEditServerDetailsModal;
exports.openCreateAccountModal = openCreateAccountModal;
exports.openEditBucketQuotaModal = openEditBucketQuotaModal;
exports.openAccountCreatedModal = openAccountCreatedModal;
exports.openSetAccountIpRestrictionsModal = openSetAccountIpRestrictionsModal;
exports.openConnectAppModal = openConnectAppModal;
exports.openCreateNamespaceResourceModal = openCreateNamespaceResourceModal;
exports.openCreateNamespaceBucketModal = openCreateNamespaceBucketModal;
exports.openEditNamespaceBucketDataPlacementModal = openEditNamespaceBucketDataPlacementModal;
exports.openSetNodeAsTrustedModal = openSetNodeAsTrustedModal;
exports.openWelcomeModal = openWelcomeModal;
exports.openAttachServerModal = openAttachServerModal;
exports.openChangeClusterConnectivityIpModal = openChangeClusterConnectivityIpModal;
exports.openManagementConsoleErrorModal = openManagementConsoleErrorModal;
exports.openAddBucketTriggerModal = openAddBucketTriggerModal;
exports.openEditBucketTriggerModal = openEditBucketTriggerModal;
exports.openCreateFuncModal = openCreateFuncModal;
exports.openCreateBucketModal = openCreateBucketModal;
exports.openRegenerateAccountCredentialsModal = openRegenerateAccountCredentialsModal;
exports.openAssignRegionModal = openAssignRegionModal;
exports.openChangePasswordModal = openChangePasswordModal;
exports.openResetPasswordModal = openResetPasswordModal;
exports.openPasswordResetCompletedModal = openPasswordResetCompletedModal;
exports.openPasswordResetFailedModal = openPasswordResetFailedModal;
exports.openEditFuncConfigModal = openEditFuncConfigModal;
exports.openInvokeFuncModal = openInvokeFuncModal;
exports.openBucketPlacementSummaryModal = openBucketPlacementSummaryModal;
exports.openEditFuncCodeModal = openEditFuncCodeModal;
exports.openAddResourcesModal = openAddResourcesModal;
exports.openSessionExpiredModal = openSessionExpiredModal;
exports.openDeployK8sPoolModal = openDeployK8sPoolModal;
exports.openEditK8sPoolModal = openEditK8sPoolModal;
exports.openDeletePoolWithDataWarningModal = openDeletePoolWithDataWarningModal;
exports.openConfirmDangerousScalingModal = openConfirmDangerousScalingModal;
exports.openEditCloudConnectionModal = openEditCloudConnectionModal;
exports.openCloudConnectionUpdateWarningModal = openCloudConnectionUpdateWarningModal;
exports.openCompleteSSLCertificateInstallationModal = openCompleteSSLCertificateInstallationModal;
exports.openDeployRemoteEndpointGroupModal = openDeployRemoteEndpointGroupModal;
exports.openEditEndpointGroupModal = openEditEndpointGroupModal;
exports.openOAuthAccessDeniedModal = openOAuthAccessDeniedModal;
exports.openOAuthUnauthorizedModal = openOAuthUnauthorizedModal;

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
function updateModal(options) {
  return {
    type: _actionTypes.UPDATE_MODAL,
    payload: options
  };
}

function closeModal(count = 1) {
  return {
    type: _actionTypes.CLOSE_MODAL,
    payload: {
      count
    }
  };
}

function openAddCloudResourceModal() {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: 'add-cloud-resource-modal',
      options: {
        title: 'Add Cloud Resource',
        size: 'medium'
      }
    }
  };
}

function openAddCloudConnectionModal(allowedServices) {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: {
        name: 'add-cloud-connection-modal',
        params: {
          allowedServices
        }
      },
      options: {
        title: 'Add Cloud Connection',
        size: 'medium'
      }
    }
  };
}

function openS3AccessDetailsModal(endpoint, accessKey, secretKey) {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: {
        name: 's3-access-details-modal',
        params: {
          endpoint,
          accessKey,
          secretKey
        }
      },
      options: {
        title: 'Connection Details',
        size: 'small'
      }
    }
  };
}

function openBucketS3AccessModal(bucketName) {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: {
        name: 'edit-bucket-s3-access-modal',
        params: {
          bucketName
        }
      },
      options: {
        title: 'Edit Bucket S3 Access'
      }
    }
  };
}

function openAddTierModal(bucketName) {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: {
        name: 'add-tier-modal',
        params: {
          bucketName
        }
      },
      options: {
        title: 'Add a New Tier',
        size: 'xlarge'
      }
    }
  };
}

function openEditTierDataPlacementModal(bucketName, tierName, tierDisplayName) {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: {
        name: 'edit-tier-data-placement-modal',
        params: {
          bucketName,
          tierName
        }
      },
      options: {
        title: `Edit ${tierDisplayName} Data Placement`,
        size: 'xlarge'
      }
    }
  };
}

function openEditBucketDataResiliencyModal(bucketName) {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: {
        name: 'edit-bucket-data-resiliency-modal',
        params: {
          bucketName
        }
      },
      options: {
        title: 'Edit Data Resiliency',
        size: 'large'
      }
    }
  };
}

function openRiskyBucketDataResiliencyWarningModal(action) {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: {
        name: 'risky-bucket-data-resiliency-warning-modal',
        params: {
          action
        }
      },
      options: {
        title: 'Risky Data Resiliency Policy',
        severity: 'warning',
        size: 'xsmall'
      }
    }
  };
}

function openEmptyDataPlacementWarningModal(bucketName, tierName, action) {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: {
        name: 'empty-data-placement-warning-modal',
        params: {
          bucketName,
          tierName,
          action
        }
      },
      options: {
        title: 'Empty data placement policy',
        size: 'xsmall',
        severity: 'warning'
      }
    }
  };
}

function openKeepUsingInternalStorageModal(action) {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: {
        name: 'keep-using-internal-storage-modal',
        params: {
          action
        }
      },
      options: {
        title: 'Internal Storage Usage',
        size: 'xsmall',
        severity: 'warning',
        closeButton: 'hidden',
        backdropClose: false
      }
    }
  };
}

function openFileUploadsModal() {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: 'file-uploads-modal',
      options: {
        title: 'File Uploads',
        size: 'large'
      }
    }
  };
}

function openDeleteCurrentAccountWarningModal(email) {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: {
        name: 'delete-current-account-warning-modal',
        params: {
          email
        }
      },
      options: {
        title: 'Deleting Current Account',
        severity: 'warning',
        size: 'xsmall'
      }
    }
  };
}

function openStartMaintenanceModal() {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: 'start-maintenance-modal',
      options: {
        title: 'Maintenance Mode',
        size: 'xsmall'
      }
    }
  };
}

function openObjectPreviewModal(objectUri) {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: {
        name: 'object-preview-modal',
        params: {
          objectUri
        }
      },
      options: {
        size: 'large'
      }
    }
  };
}

function openTestNodeModal(nodeRpcAddress) {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: {
        name: 'test-node-modal',
        params: {
          nodeRpcAddress
        }
      },
      options: {
        size: 'xlarge',
        title: 'Node\'s connectivity test',
        backdropClose: false,
        closeButton: 'hidden'
      }
    }
  };
}

function openEditAccountS3AccessModal(accountName) {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: {
        name: 'edit-account-s3-access-modal',
        params: {
          accountName
        }
      },
      options: {
        title: 'Edit Account S3 Access',
        size: 'medium'
      }
    }
  };
}

function openEditServerDetailsModal(serverSecret) {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: {
        name: 'edit-server-details-modal',
        params: {
          serverSecret
        }
      },
      options: {
        size: 'xsmall',
        title: 'Edit Server Details'
      }
    }
  };
}

function openCreateAccountModal() {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: 'create-account-modal',
      options: {
        size: 'medium',
        title: 'Create Account'
      }
    }
  };
}

function openEditBucketQuotaModal(bucketName) {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: {
        name: 'edit-bucket-quota-modal',
        params: {
          bucketName
        }
      },
      options: {
        size: 'small',
        title: 'Edit Quota'
      }
    }
  };
}

function openAccountCreatedModal(accountName, password) {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: {
        name: 'account-created-modal',
        params: {
          accountName,
          password
        }
      },
      options: {
        title: 'Account Created Successfully',
        severity: 'success',
        size: 'small'
      }
    }
  };
}

function openSetAccountIpRestrictionsModal(accountName) {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: {
        name: 'set-account-ip-restrictions-modal',
        params: {
          accountName
        }
      },
      options: {
        title: 'Set IP Restrictions'
      }
    }
  };
}

function openConnectAppModal() {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: 'connect-app-modal',
      options: {
        size: 'medium',
        title: 'Connect Application'
      }
    }
  };
}

function openCreateNamespaceResourceModal() {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: 'create-namespace-resource-modal',
      options: {
        title: 'Create Namespace Resource',
        size: 'medium'
      }
    }
  };
}

function openCreateNamespaceBucketModal() {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: 'create-namespace-bucket-modal',
      options: {
        title: 'Create Namespace Bucket',
        size: 'medium'
      }
    }
  };
}

function openEditNamespaceBucketDataPlacementModal(bucket) {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: {
        name: 'edit-namespace-bucket-data-placement-modal',
        params: {
          bucket
        }
      },
      options: {
        title: 'Edit Bucket Data Placement Policy',
        size: 'medium'
      }
    }
  };
}

function openSetNodeAsTrustedModal(host, untrustedReasons) {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: {
        name: 'set-node-as-trusted-modal',
        params: {
          host,
          untrustedReasons
        }
      },
      options: {
        title: 'Set Node as Trusted',
        size: 'small'
      }
    }
  };
}

function openWelcomeModal() {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: 'welcome-modal',
      options: {
        size: 'xsmall',
        severity: 'success',
        title: 'System Created Successfully',
        backdropClose: false,
        closeButton: 'hidden'
      }
    }
  };
}

function openAttachServerModal() {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: 'attach-server-modal',
      options: {
        title: 'Attach New Server',
        size: 'medium'
      }
    }
  };
}

function openChangeClusterConnectivityIpModal(secret) {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: {
        name: 'change-cluster-connectivity-ip-modal',
        params: {
          secret
        }
      },
      options: {
        title: 'Change Cluster Connectivity IP',
        size: 'small'
      }
    }
  };
}

function openManagementConsoleErrorModal() {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: 'management-console-error-modal',
      options: {
        title: 'Management Console Error',
        size: 'xsmall',
        severity: 'error',
        backdropClose: false,
        closeButton: 'hidden'
      }
    }
  };
}

function openAddBucketTriggerModal(bucketName, funcId = null) {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: {
        name: 'add-bucket-trigger-modal',
        params: {
          bucketName,
          funcId
        }
      },
      options: {
        size: 'medium',
        title: 'Add Trigger'
      }
    }
  };
}

function openEditBucketTriggerModal(mode, triggerId) {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: {
        name: 'edit-bucket-trigger-modal',
        params: {
          triggerId,
          mode
        }
      },
      options: {
        size: 'medium',
        title: 'Edit Trigger'
      }
    }
  };
}

function openCreateFuncModal() {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: 'create-func-modal',
      options: {
        title: 'Create Function',
        size: 'medium'
      }
    }
  };
}

function openCreateBucketModal() {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: 'create-bucket-modal',
      options: {
        title: 'Create Bucket',
        size: 'small'
      }
    }
  };
}

function openRegenerateAccountCredentialsModal(accountName) {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: {
        name: 'regenerate-account-credentials-modal',
        params: {
          accountName
        }
      },
      options: {
        title: 'Regenerate Account Credentials',
        size: 'xsmall'
      }
    }
  };
}

function openAssignRegionModal(resourceType, resourceName) {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: {
        name: 'assign-region-modal',
        params: {
          resourceType,
          resourceName
        }
      },
      options: {
        title: 'Assign Region',
        size: 'xsmall'
      }
    }
  };
}

function openChangePasswordModal(accountName) {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: {
        name: 'change-password-modal',
        params: {
          accountName
        }
      },
      options: {
        title: 'Change My Account Password',
        size: 'small'
      }
    }
  };
}

function openResetPasswordModal(accountName) {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: {
        name: 'reset-password-modal',
        params: {
          accountName
        }
      },
      options: {
        title: 'Reset Account Password',
        size: 'xsmall'
      }
    }
  };
}

function openPasswordResetCompletedModal(accountName, password) {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: {
        name: 'password-reset-completed-modal',
        params: {
          accountName,
          password
        }
      },
      options: {
        title: 'Password Reset Successful',
        size: 'small',
        severity: 'success'
      }
    }
  };
}

function openPasswordResetFailedModal(accountName) {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: {
        name: 'password-reset-failed-modal',
        params: {
          accountName
        }
      },
      options: {
        title: 'Password Reset Failed',
        size: 'xsmall',
        severity: 'error'
      }
    }
  };
}

function openEditFuncConfigModal(funcName, funcVersion) {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: {
        name: 'edit-func-config-modal',
        params: {
          funcName,
          funcVersion
        }
      },
      options: {
        title: 'Function Configuration',
        size: 'medium'
      }
    }
  };
}

function openInvokeFuncModal(funcName, funcVersion) {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: {
        name: 'invoke-func-modal',
        params: {
          funcName,
          funcVersion
        }
      },
      options: {
        title: 'Set Event and Invoke',
        size: 'medium'
      }
    }
  };
}

function openBucketPlacementSummaryModal(bucketName) {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: {
        name: 'bucket-placement-summary-modal',
        params: {
          bucketName
        }
      },
      options: {
        title: 'Bucket Tiering Structure',
        size: 'xlarge'
      }
    }
  };
}

function openEditFuncCodeModal(funcName, funcVersion) {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: {
        name: 'edit-func-code-modal',
        params: {
          funcName,
          funcVersion
        }
      },
      options: {
        title: 'Edit Function Code',
        size: 'medium'
      }
    }
  };
}

function openAddResourcesModal() {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: 'add-resources-modal',
      options: {
        title: 'Add Resources'
      }
    }
  };
}

function openSessionExpiredModal() {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: 'session-expired-modal',
      options: {
        title: 'Session Expired',
        size: 'xsmall',
        severity: 'info',
        closeButton: 'hidden',
        backdropClose: false
      }
    }
  };
}

function openDeployK8sPoolModal() {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: {
        name: 'deploy-k8s-pool-modal',
        params: {}
      },
      options: {
        title: 'Deploy Kubernetes Pool',
        size: 'medium'
      }
    }
  };
}

function openEditK8sPoolModal(poolName) {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: {
        name: 'edit-k8s-pool-modal',
        params: {
          poolName
        }
      },
      options: {
        title: 'Edit Pool Configuration',
        size: 'medium'
      }
    }
  };
}

function openDeletePoolWithDataWarningModal(poolName) {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: {
        name: 'delete-pool-with-data-warning-modal',
        params: {
          poolName
        }
      },
      options: {
        title: 'Delete Pool with Stored Data',
        severity: 'warning',
        size: 'small'
      }
    }
  };
}

function openConfirmDangerousScalingModal(action) {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: {
        name: 'confirm-dangerous-scaling-modal',
        params: {
          action
        }
      },
      options: {
        title: 'Not Enough Storage Capacity',
        severity: 'warning',
        size: 'xsmall'
      }
    }
  };
}

function openEditCloudConnectionModal(accountName, connectionName) {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: {
        name: 'edit-cloud-connection-modal',
        params: {
          accountName,
          connectionName
        }
      },
      options: {
        title: 'Edit Cloud Connection',
        size: 'medium'
      }
    }
  };
}

function openCloudConnectionUpdateWarningModal(accountName, connectionName, updateAction) {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: {
        name: 'cloud-connection-update-warning-modal',
        params: {
          accountName,
          connectionName,
          updateAction
        }
      },
      options: {
        title: 'Connection Access Issue',
        size: 'small',
        severity: 'warning'
      }
    }
  };
}

function openCompleteSSLCertificateInstallationModal() {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: 'complete-ssl-certificate-installation-modal',
      options: {
        title: 'SSL Certificate Uploaded Successfully',
        size: 'xsmall',
        severity: 'success',
        closeButton: 'hidden',
        backdropClose: false
      }
    }
  };
}

function openDeployRemoteEndpointGroupModal() {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: 'deploy-remote-endpoint-group-modal',
      options: {
        title: 'Deploy Remote Endpoint Group',
        size: 'small'
      }
    }
  };
}

function openEditEndpointGroupModal(groupName) {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: {
        name: 'edit-endpoint-group-modal',
        params: {
          groupName
        }
      },
      options: {
        title: 'Edit Endpoint Group ',
        size: 'small'
      }
    }
  };
}

function openOAuthAccessDeniedModal() {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: {
        name: 'oauth-access-denied-modal',
        params: {}
      },
      options: {
        title: 'Access Denied',
        size: 'xsmall',
        severity: 'info',
        closeButton: 'hidden',
        backdropClose: false
      }
    }
  };
}

function openOAuthUnauthorizedModal() {
  return {
    type: _actionTypes.OPEN_MODAL,
    payload: {
      component: {
        name: 'oauth-unauthorized-modal',
        params: {}
      },
      options: {
        title: 'Access Denied',
        size: 'xsmall',
        severity: 'info',
        closeButton: 'hidden',
        backdropClose: false
      }
    }
  };
}
/** INJECT:actionCreator **/

},{"action-types":318}],309:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createNamespaceResource = createNamespaceResource;
exports.completeCreateNamespaceResource = completeCreateNamespaceResource;
exports.failCreateNamespaceResource = failCreateNamespaceResource;
exports.deleteNamespaceResource = deleteNamespaceResource;
exports.completeDeleteNamespaceResource = completeDeleteNamespaceResource;
exports.failDeleteNamespaceResource = failDeleteNamespaceResource;

var _actionTypes = require("action-types");

function createNamespaceResource(name, connection, target) {
  return {
    type: _actionTypes.CREATE_NAMESPACE_RESOURCE,
    payload: {
      name,
      connection,
      target
    }
  };
}

function completeCreateNamespaceResource(name) {
  return {
    type: _actionTypes.COMPLETE_CREATE_NAMESPACE_RESOURCE,
    payload: {
      name
    }
  };
}

function failCreateNamespaceResource(name, error) {
  return {
    type: _actionTypes.FAIL_CREATE_NAMESPACE_RESOURCE,
    payload: {
      name,
      error
    }
  };
}

function deleteNamespaceResource(name) {
  return {
    type: _actionTypes.DELETE_NAMESPACE_RESOURCE,
    payload: {
      name
    }
  };
}

function completeDeleteNamespaceResource(name) {
  return {
    type: _actionTypes.COMPLETE_DELETE_NAMESPACE_RESOURCE,
    payload: {
      name
    }
  };
}

function failDeleteNamespaceResource(name, error) {
  return {
    type: _actionTypes.FAIL_DELETE_NAMESPACE_RESOURCE,
    payload: {
      name,
      error
    }
  };
}

},{"action-types":318}],310:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.fetchObjects = fetchObjects;
exports.completeFetchObjects = completeFetchObjects;
exports.failFetchObjects = failFetchObjects;
exports.fetchObject = fetchObject;
exports.completeFetchObject = completeFetchObject;
exports.failFetchObject = failFetchObject;
exports.deleteObject = deleteObject;
exports.completeDeleteObject = completeDeleteObject;
exports.failDeleteObject = failDeleteObject;
exports.dropObjectsView = dropObjectsView;
exports.fetchObjectParts = fetchObjectParts;
exports.completeFetchObjectParts = completeFetchObjectParts;
exports.failFetchObjectParts = failFetchObjectParts;

var _actionTypes = require("action-types");

function fetchObjects(view, query, s3Endpoint) {
  return {
    type: _actionTypes.FETCH_OBJECTS,
    payload: {
      view,
      query,
      s3Endpoint
    }
  };
}

function completeFetchObjects(query, response) {
  return {
    type: _actionTypes.COMPLETE_FETCH_OBJECTS,
    payload: {
      query,
      response
    }
  };
}

function failFetchObjects(query, error) {
  return {
    type: _actionTypes.FAIL_FETCH_OBJECTS,
    payload: {
      query,
      error
    }
  };
}

function fetchObject(view, bucket, object, version, s3Endpoint) {
  return {
    type: _actionTypes.FETCH_OBJECT,
    payload: {
      view,
      bucket,
      object,
      version,
      s3Endpoint
    }
  };
}

function completeFetchObject(bucket, object, version, response) {
  return {
    type: _actionTypes.COMPLETE_FETCH_OBJECT,
    payload: {
      bucket,
      object,
      version,
      response
    }
  };
}

function failFetchObject(bucket, object, version, error) {
  return {
    type: _actionTypes.FAIL_FETCH_OBJECT,
    payload: {
      bucket,
      object,
      version,
      error
    }
  };
}

function deleteObject(objId, accessData) {
  return {
    type: _actionTypes.DELETE_OBJECT,
    payload: {
      objId,
      accessData
    }
  };
}

function completeDeleteObject(objId) {
  return {
    type: _actionTypes.COMPLETE_DELETE_OBJECT,
    payload: {
      objId
    }
  };
}

function failDeleteObject(objId, error) {
  return {
    type: _actionTypes.FAIL_DELETE_OBJECT,
    payload: {
      objId,
      error
    }
  };
}

function dropObjectsView(view) {
  return {
    type: _actionTypes.DROP_OBJECTS_VIEW,
    payload: {
      view
    }
  };
}

function fetchObjectParts(query) {
  return {
    type: _actionTypes.FETCH_OBJECT_PARTS,
    payload: query
  };
}

function completeFetchObjectParts(query, chunks) {
  return {
    type: _actionTypes.COMPLETE_FETCH_OBJECT_PARTS,
    payload: {
      query,
      chunks
    }
  };
}

function failFetchObjectParts(query, error) {
  return {
    type: _actionTypes.FAIL_FETCH_OBJECT_PARTS,
    payload: {
      query,
      error
    }
  };
}

},{"action-types":318}],311:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createHostsPool = createHostsPool;
exports.completeCreateHostsPool = completeCreateHostsPool;
exports.failCreateHostsPool = failCreateHostsPool;
exports.scaleHostsPool = scaleHostsPool;
exports.completeScaleHostsPool = completeScaleHostsPool;
exports.failScaleHostsPool = failScaleHostsPool;
exports.deleteResource = deleteResource;
exports.completeDeleteResource = completeDeleteResource;
exports.failDeleteResource = failDeleteResource;
exports.assignRegionToResource = assignRegionToResource;
exports.completeAssignRegionToResource = completeAssignRegionToResource;
exports.failAssignRegionToResource = failAssignRegionToResource;
exports.fetchCloudResourceObjects = fetchCloudResourceObjects;
exports.completeFetchCloudResourceObjects = completeFetchCloudResourceObjects;
exports.failFetchCloudResourceObjects = failFetchCloudResourceObjects;

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
function createHostsPool(name, hostCount, hostVolumeSize, isManaged) {
  return {
    type: _actionTypes.CREATE_HOSTS_POOL,
    payload: {
      name,
      hostCount,
      hostVolumeSize,
      isManaged
    }
  };
}

function completeCreateHostsPool(name, deployYAMLUri, autoDownload) {
  return {
    type: _actionTypes.COMPLETE_CREATE_HOSTS_POOL,
    payload: {
      name,
      deployYAMLUri,
      autoDownload
    }
  };
}

function failCreateHostsPool(name, error) {
  return {
    type: _actionTypes.FAIL_CREATE_HOSTS_POOL,
    payload: {
      name,
      error
    }
  };
}

function scaleHostsPool(poolName, hostCount) {
  return {
    type: _actionTypes.SCALE_HOSTS_POOL,
    payload: {
      poolName,
      hostCount
    }
  };
}

function completeScaleHostsPool(poolName) {
  return {
    type: _actionTypes.COMPLETE_SCALE_HOSTS_POOL,
    payload: {
      poolName
    }
  };
}

function failScaleHostsPool(poolName, error) {
  return {
    type: _actionTypes.FAIL_SCALE_HOSTS_POOL,
    payload: {
      poolName,
      error
    }
  };
}

function deleteResource(resource) {
  return {
    type: _actionTypes.DELETE_RESOURCE,
    payload: {
      resource
    }
  };
}

function completeDeleteResource(resource) {
  return {
    type: _actionTypes.COMPLETE_DELETE_RESOURCE,
    payload: {
      resource
    }
  };
}

function failDeleteResource(resource, error) {
  return {
    type: _actionTypes.FAIL_DELETE_RESOURCE,
    payload: {
      resource,
      error
    }
  };
}

function assignRegionToResource(resourceType, resourceName, region) {
  return {
    type: _actionTypes.ASSIGN_REGION_TO_RESOURCE,
    payload: {
      resourceType,
      resourceName,
      region
    }
  };
}

function completeAssignRegionToResource(resourceType, resourceName, region) {
  return {
    type: _actionTypes.COMPLETE_ASSIGN_REGION_TO_RESOURCE,
    payload: {
      resourceType,
      resourceName,
      region
    }
  };
}

function failAssignRegionToResource(resourceType, resourceName, region, error) {
  return {
    type: _actionTypes.FAIL_ASSIGN_REGION_TO_RESOURCE,
    payload: {
      resourceType,
      resourceName,
      region,
      error
    }
  };
}

function fetchCloudResourceObjects(resource, skip, limit) {
  return {
    type: _actionTypes.FETCH_CLOUD_RESOURCE_OBJECTS,
    payload: {
      resource,
      skip,
      limit
    }
  };
}

function completeFetchCloudResourceObjects(resource, skip, limit, response) {
  return {
    type: _actionTypes.COMPLETE_FETCH_CLOUD_RESOURCE_OBJECTS,
    payload: {
      query: {
        resource,
        skip,
        limit
      },
      response
    }
  };
}

function failFetchCloudResourceObjects(resource, skip, limit, error) {
  return {
    type: _actionTypes.FAIL_FETCH_CLOUD_RESOURCE_OBJECTS,
    payload: {
      query: {
        resource,
        skip,
        limit
      },
      error
    }
  };
}

},{"action-types":318}],312:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.restoreSession = restoreSession;
exports.completeRestoreSession = completeRestoreSession;
exports.failRestoreSession = failRestoreSession;
exports.signIn = signIn;
exports.completeSignIn = completeSignIn;
exports.failSignIn = failSignIn;
exports.signInWithOAuth = signInWithOAuth;
exports.signOut = signOut;
exports.expireSession = expireSession;

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
function restoreSession() {
  return {
    type: _actionTypes.RESTORE_SESSION
  };
}

function completeRestoreSession(token, sessionInfo, persistent = false, uiTheme) {
  const {
    account,
    system
  } = sessionInfo;
  return {
    type: _actionTypes.COMPLETE_RESTORE_SESSION,
    payload: {
      token: token,
      user: account.email,
      system: system.name,
      passwordExpired: Boolean(account.must_change_password),
      authorizedBy: sessionInfo.authorized_by,
      persistent: persistent,
      uiTheme
    }
  };
}

function failRestoreSession(token, error) {
  return {
    type: _actionTypes.FAIL_RESTORE_SESSION,
    payload: {
      token,
      error
    }
  };
}

function signIn(email, password, persistent = false) {
  return {
    type: _actionTypes.SIGN_IN,
    payload: {
      email,
      password,
      persistent
    }
  };
}

function completeSignIn(token, sessionInfo, persistent, uiTheme) {
  const {
    account,
    system
  } = sessionInfo;
  return {
    type: _actionTypes.COMPLETE_SIGN_IN,
    payload: {
      token: token,
      user: account.email,
      system: system.name,
      passwordExpired: Boolean(account.must_change_password),
      authorizedBy: sessionInfo.authorized_by,
      persistent,
      uiTheme
    }
  };
}

function failSignIn(error) {
  return {
    type: _actionTypes.FAIL_SIGN_IN,
    payload: {
      error
    }
  };
}

function signInWithOAuth(oauthGrantCode, returnUrl) {
  return {
    type: _actionTypes.SIGN_IN_WITH_OAUTH,
    payload: {
      oauthGrantCode,
      returnUrl
    }
  };
}

function signOut() {
  return {
    type: _actionTypes.SIGN_OUT
  };
}

function expireSession() {
  return {
    type: _actionTypes.EXPIRE_SESSION
  };
}

},{"action-types":318}],313:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.dumpAppLog = dumpAppLog;

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
function dumpAppLog() {
  return {
    type: _actionTypes.DUMP_APP_LOG
  };
}

},{"action-types":318}],314:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createSystem = createSystem;
exports.completeCreateSystem = completeCreateSystem;
exports.failCreateSystem = failCreateSystem;
exports.fetchSystemInfo = fetchSystemInfo;
exports.completeFetchSystemInfo = completeFetchSystemInfo;
exports.failFetchSystemInfo = failFetchSystemInfo;
exports.fetchNodeInstallationCommands = fetchNodeInstallationCommands;
exports.completeFetchNodeInstallationCommands = completeFetchNodeInstallationCommands;
exports.failFetchNodeInstallationCommands = failFetchNodeInstallationCommands;
exports.fetchSystemStorageHistory = fetchSystemStorageHistory;
exports.completeFetchSystemStorageHistory = completeFetchSystemStorageHistory;
exports.failFetchSystemStorageHistory = failFetchSystemStorageHistory;
exports.fetchVersionReleaseNotes = fetchVersionReleaseNotes;
exports.completeFetchVersionReleaseNotes = completeFetchVersionReleaseNotes;
exports.failFetchVersionReleaseNotes = failFetchVersionReleaseNotes;
exports.enterMaintenanceMode = enterMaintenanceMode;
exports.completeEnterMaintenanceMode = completeEnterMaintenanceMode;
exports.failEnterMaintenanceMode = failEnterMaintenanceMode;
exports.leaveMaintenanceMode = leaveMaintenanceMode;
exports.completeLeaveMaintenanceMode = completeLeaveMaintenanceMode;
exports.failLeaveMaintenanceMode = failLeaveMaintenanceMode;
exports.updateP2PSettings = updateP2PSettings;
exports.completeUpdateP2PSettings = completeUpdateP2PSettings;
exports.failUpdateP2PSettings = failUpdateP2PSettings;
exports.resendActivationCode = resendActivationCode;
exports.setSystemDebugLevel = setSystemDebugLevel;
exports.completeSetSystemDebugLevel = completeSetSystemDebugLevel;
exports.failSetSystemDebugLevel = failSetSystemDebugLevel;
exports.collectSystemDiagnostics = collectSystemDiagnostics;
exports.completeCollectSystemDiagnostics = completeCollectSystemDiagnostics;
exports.failCollectSystemDiagnostics = failCollectSystemDiagnostics;
exports.uploadSSLCertificate = uploadSSLCertificate;
exports.updateUploadSSLCertificate = updateUploadSSLCertificate;
exports.completeUploadSSLCertificate = completeUploadSSLCertificate;
exports.failUploadSSLCertificate = failUploadSSLCertificate;

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
function createSystem(ownerEmail, password, systemName, dnsName, dnsServers, timeConfig) {
  return {
    type: _actionTypes.CREATE_SYSTEM,
    payload: {
      ownerEmail,
      password,
      systemName,
      dnsName,
      dnsServers,
      timeConfig
    }
  };
}

function completeCreateSystem(systemName, ownerEmail, token, uiTheme) {
  return {
    type: _actionTypes.COMPLETE_CREATE_SYSTEM,
    payload: {
      token: token,
      user: ownerEmail,
      system: systemName,
      passwordExpired: false,
      authorizedBy: 'noobaa',
      persistent: false,
      uiTheme
    }
  };
}

function failCreateSystem(error) {
  return {
    type: _actionTypes.FAIL_CREATE_SYSTEM,
    payload: {
      error
    }
  };
}

function fetchSystemInfo() {
  return {
    type: _actionTypes.FETCH_SYSTEM_INFO
  };
}

function completeFetchSystemInfo(info) {
  return {
    type: _actionTypes.COMPLETE_FETCH_SYSTEM_INFO,
    payload: info
  };
}

function failFetchSystemInfo(error) {
  return {
    type: _actionTypes.FAIL_FETCH_SYSTEM_INFO,
    payload: error
  };
}

function fetchNodeInstallationCommands(targetPool, excludedDrives) {
  return {
    type: _actionTypes.FETCH_NODE_INSTALLATION_COMMANDS,
    payload: {
      targetPool,
      excludedDrives
    }
  };
}

function completeFetchNodeInstallationCommands(targetPool, excludedDrives, commands) {
  return {
    type: _actionTypes.COMPLETE_FETCH_NODE_INSTALLATION_COMMANDS,
    payload: {
      targetPool,
      excludedDrives,
      commands
    }
  };
}

function failFetchNodeInstallationCommands(error) {
  return {
    type: _actionTypes.FAIL_FETCH_NODE_INSTALLATION_COMMANDS,
    payload: {
      error
    }
  };
}

function fetchSystemStorageHistory() {
  return {
    type: _actionTypes.FETCH_SYSTEM_STORAGE_HISTORY
  };
}

function completeFetchSystemStorageHistory(history) {
  return {
    type: _actionTypes.COMPLETE_FETCH_SYSTEM_STORAGE_HISTORY,
    payload: {
      history
    }
  };
}

function failFetchSystemStorageHistory(error) {
  return {
    type: _actionTypes.FAIL_FETCH_SYSTEM_STORAGE_HISTORY,
    payload: {
      error
    }
  };
}

function fetchVersionReleaseNotes(version) {
  return {
    type: _actionTypes.FETCH_VERSION_RELEASE_NOTES,
    payload: {
      version
    }
  };
}

function completeFetchVersionReleaseNotes(version, notes) {
  return {
    type: _actionTypes.COMPLETE_FETCH_VERSION_RELEASE_NOTES,
    payload: {
      version,
      notes
    }
  };
}

function failFetchVersionReleaseNotes(version, error) {
  return {
    type: _actionTypes.FAIL_FETCH_VERSION_RELEASE_NOTES,
    payload: {
      version,
      error
    }
  };
}

function enterMaintenanceMode(duration) {
  return {
    type: _actionTypes.ENTER_MAINTENANCE_MODE,
    payload: {
      duration
    }
  };
}

function completeEnterMaintenanceMode() {
  return {
    type: _actionTypes.COMPLETE_ENTER_MAINTENANCE_MODE
  };
}

function failEnterMaintenanceMode(error) {
  return {
    type: _actionTypes.FAIL_ENTER_MAINTENANCE_MODE,
    payload: {
      error
    }
  };
}

function leaveMaintenanceMode() {
  return {
    type: _actionTypes.LEAVE_MAINTENANCE_MODE
  };
}

function completeLeaveMaintenanceMode() {
  return {
    type: _actionTypes.COMPLETE_LEAVE_MAINTENANCE_MODE
  };
}

function failLeaveMaintenanceMode(error) {
  return {
    type: _actionTypes.FAIL_LEAVE_MAINTENANCE_MODE,
    payload: {
      error
    }
  };
}

function updateP2PSettings(tcpPortRange) {
  return {
    type: _actionTypes.UPDATE_P2P_SETTINGS,
    payload: {
      tcpPortRange
    }
  };
}

function completeUpdateP2PSettings() {
  return {
    type: _actionTypes.COMPLETE_UPDATE_P2P_SETTINGS
  };
}

function failUpdateP2PSettings(error) {
  return {
    type: _actionTypes.FAIL_UPDATE_P2P_SETTINGS,
    payload: {
      error
    }
  };
}

function resendActivationCode(email) {
  return {
    type: _actionTypes.RESEND_ACTIVATION_CODE,
    payload: {
      email
    }
  };
}

function setSystemDebugLevel(level) {
  return {
    type: _actionTypes.SET_SYSTEM_DEBUG_LEVEL,
    payload: {
      level
    }
  };
}

function completeSetSystemDebugLevel(level) {
  return {
    type: _actionTypes.COMPLETE_SET_SYSTEM_DEBUG_LEVEL,
    payload: {
      level
    }
  };
}

function failSetSystemDebugLevel(level, error) {
  return {
    type: _actionTypes.FAIL_SET_SYSTEM_DEBUG_LEVEL,
    payload: {
      level,
      error
    }
  };
}

function collectSystemDiagnostics() {
  return {
    type: _actionTypes.COLLECT_SYSTEM_DIAGNOSTICS
  };
}

function completeCollectSystemDiagnostics(packageUri) {
  return {
    type: _actionTypes.COMPLETE_COLLECT_SYSTEM_DIAGNOSTICS,
    payload: {
      packageUri
    }
  };
}

function failCollectSystemDiagnostics(error) {
  return {
    type: _actionTypes.FAIL_COLLECT_SYSTEM_DIAGNOSTICS,
    payload: {
      error
    }
  };
}

function uploadSSLCertificate(certBufferKey) {
  return {
    type: _actionTypes.UPLOAD_SSL_CERTIFICATE,
    payload: {
      certBufferKey
    }
  };
}

function updateUploadSSLCertificate(progress) {
  return {
    type: _actionTypes.UPDATE_UPLOAD_SSL_CERTIFICATE,
    payload: {
      progress
    }
  };
}

function completeUploadSSLCertificate() {
  return {
    type: _actionTypes.COMPLETE_UPLOAD_SSL_CERTIFICATE
  };
}

function failUploadSSLCertificate(error) {
  return {
    type: _actionTypes.FAIL_UPLOAD_SSL_CERTIFICATE,
    payload: {
      error
    }
  };
}

},{"action-types":318}],315:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.updateServerAddress = updateServerAddress;
exports.completeUpdateServerAddress = completeUpdateServerAddress;
exports.failUpdateServerAddress = failUpdateServerAddress;
exports.attachServerToCluster = attachServerToCluster;
exports.completeAttachServerToCluster = completeAttachServerToCluster;
exports.failAttachServerToCluster = failAttachServerToCluster;
exports.updateServerDetails = updateServerDetails;
exports.completeUpdateServerDetails = completeUpdateServerDetails;
exports.failUpdateServerDetails = failUpdateServerDetails;

var _actionTypes = require("action-types");

function updateServerAddress(secret, newAddress, hostname) {
  return {
    type: _actionTypes.UPDATE_SERVER_ADDRESS,
    payload: {
      secret,
      newAddress,
      hostname
    }
  };
}

function completeUpdateServerAddress(secret, hostname) {
  return {
    type: _actionTypes.COMPLETE_UPDATE_SERVER_ADDRESS,
    payload: {
      secret,
      hostname
    }
  };
}

function failUpdateServerAddress(secret, hostname, error) {
  return {
    type: _actionTypes.FAIL_UPDATE_SERVER_ADDRESS,
    payload: {
      secret,
      hostname,
      error
    }
  };
}

function attachServerToCluster(secret, address, hostname, location) {
  return {
    type: _actionTypes.ATTACH_SERVER_TO_CLUSTER,
    payload: {
      secret,
      address,
      hostname,
      location
    }
  };
}

function completeAttachServerToCluster(secret) {
  return {
    type: _actionTypes.COMPLETE_ATTACH_SERVER_TO_CLUSTER,
    payload: {
      secret
    }
  };
}

function failAttachServerToCluster(secret, error) {
  return {
    type: _actionTypes.FAIL_ATTACH_SERVER_TO_CLUSTER,
    payload: {
      secret,
      error
    }
  };
}

function updateServerDetails(secret, hostname, newHostname, locationTag) {
  return {
    type: _actionTypes.UPDATE_SERVER_DETAILS,
    payload: {
      secret,
      hostname,
      newHostname,
      locationTag
    }
  };
}

function completeUpdateServerDetails(secret, hostname, newHostname) {
  return {
    type: _actionTypes.COMPLETE_UPDATE_SERVER_DETAILS,
    payload: {
      secret,
      hostname,
      newHostname
    }
  };
}

function failUpdateServerDetails(secret, hostname, error) {
  return {
    type: _actionTypes.FAIL_UPDATE_SERVER_DETAILS,
    payload: {
      secret,
      hostname,
      error
    }
  };
}

},{"action-types":318}],316:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.openAuditDrawer = openAuditDrawer;
exports.openAlertsDrawer = openAlertsDrawer;
exports.closeDrawer = closeDrawer;
exports.hideNotification = hideNotification;
exports.showNotification = showNotification;

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
// -------------------------------
// Drawer action creators
// -------------------------------
function openAuditDrawer() {
  return {
    type: _actionTypes.OPEN_DRAWER,
    payload: {
      pane: 'audit-pane'
    }
  };
}

function openAlertsDrawer() {
  return {
    type: _actionTypes.OPEN_DRAWER,
    payload: {
      pane: 'alerts-pane'
    }
  };
}

function closeDrawer() {
  return {
    type: _actionTypes.CLOSE_DRAWER
  };
} // -------------------------------
// Notificaitons action creators
// -------------------------------


function hideNotification(id) {
  return {
    type: _actionTypes.HIDE_NOTIFICATION,
    payload: {
      id
    }
  };
}

function showNotification(message, severity = 'info') {
  return {
    type: _actionTypes.SHOW_NOTIFICATION,
    payload: {
      message,
      severity
    }
  };
}

},{"action-types":318}],317:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.uploadObjects = uploadObjects;
exports.updateObjectUpload = updateObjectUpload;
exports.completeObjectUpload = completeObjectUpload;
exports.failObjectUpload = failObjectUpload;
exports.clearCompletedObjectUploads = clearCompletedObjectUploads;

var _stringUtils = require("utils/string-utils");

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
function uploadObjects(bucket, files, connection) {
  const time = Date.now();
  const objects = Array.from(files).map(file => ({
    id: (0, _stringUtils.randomString)(),
    bucket,
    file
  }));
  return {
    type: _actionTypes.UPLOAD_OBJECTS,
    payload: {
      objects,
      time,
      connection
    }
  };
}

function updateObjectUpload(id, loaded) {
  return {
    type: _actionTypes.UPDATE_OBJECT_UPLOAD,
    payload: {
      id,
      loaded
    }
  };
}

function completeObjectUpload(id, extras) {
  return {
    type: _actionTypes.COMPLETE_OBJECT_UPLOAD,
    payload: {
      id,
      extras
    }
  };
}

function failObjectUpload(id, error) {
  return {
    type: _actionTypes.FAIL_OBJECT_UPLOAD,
    payload: {
      id,
      error
    }
  };
}

function clearCompletedObjectUploads() {
  return {
    type: _actionTypes.CLEAR_COMPLETED_OBJECT_UPLOADES
  };
}

},{"action-types":318,"utils/string-utils":1046}],318:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CHANGE_ACCOUNT_PASSWORD = exports.FAIL_SET_ACCOUNT_IP_RESTRICTIONS = exports.COMPLETE_SET_ACCOUNT_IP_RESTRICTIONS = exports.SET_ACCOUNT_IP_RESTRICTIONS = exports.FAIL_UPDATE_ACCOUNT_S3_ACCESS = exports.COMPLETE_UPDATE_ACCOUNT_S3_ACCESS = exports.UPDATE_ACCOUNT_S3_ACCESS = exports.FAIL_CREATE_ACCOUNT = exports.COMPLETE_CREATE_ACCOUNT = exports.CREATE_ACCOUNT = exports.SELECT_AUDIT_RECORD = exports.FAIL_EXPORT_AUDIT_LOG = exports.COMPLETE_EXPORT_AUDIT_LOG = exports.EXPORT_AUDIT_LOG = exports.DROP_AUDIT_LOG = exports.FAIL_FETCH_AUDIT_LOG = exports.COMPLETE_FETCH_AUDIT_LOG = exports.FETCH_AUDIT_LOG = exports.DROP_ALERTS = exports.FAIL_FETCH_UREAD_ALERTS_COUNT = exports.COMPLETE_FETCH_UNREAD_ALERTS_COUNT = exports.FETCH_UNREAD_ALERTS_COUNT = exports.FAIL_UPDATE_ALERTS = exports.COMPLETE_UPDATE_ALERTS = exports.UPDATE_ALERTS = exports.FAIL_FETCH_ALERTS = exports.COMPLETE_FETCH_ALERTS = exports.FETCH_ALERTS = exports.FAIL_FETCH_NODE_INSTALLATION_COMMANDS = exports.COMPLETE_FETCH_NODE_INSTALLATION_COMMANDS = exports.FETCH_NODE_INSTALLATION_COMMANDS = exports.FAIL_UPDATE_SERVER_DETAILS = exports.COMPLETE_UPDATE_SERVER_DETAILS = exports.UPDATE_SERVER_DETAILS = exports.FAIL_ATTACH_SERVER_TO_CLUSTER = exports.COMPLETE_ATTACH_SERVER_TO_CLUSTER = exports.ATTACH_SERVER_TO_CLUSTER = exports.FAIL_UPDATE_SERVER_ADDRESS = exports.COMPLETE_UPDATE_SERVER_ADDRESS = exports.UPDATE_SERVER_ADDRESS = exports.FAIL_UPLOAD_SSL_CERTIFICATE = exports.COMPLETE_UPLOAD_SSL_CERTIFICATE = exports.UPDATE_UPLOAD_SSL_CERTIFICATE = exports.UPLOAD_SSL_CERTIFICATE = exports.FAIL_COLLECT_SYSTEM_DIAGNOSTICS = exports.COMPLETE_COLLECT_SYSTEM_DIAGNOSTICS = exports.COLLECT_SYSTEM_DIAGNOSTICS = exports.FAIL_SET_SYSTEM_DEBUG_LEVEL = exports.COMPLETE_SET_SYSTEM_DEBUG_LEVEL = exports.SET_SYSTEM_DEBUG_LEVEL = exports.RESEND_ACTIVATION_CODE = exports.FAIL_UPDATE_P2P_SETTINGS = exports.COMPLETE_UPDATE_P2P_SETTINGS = exports.UPDATE_P2P_SETTINGS = exports.FAIL_LEAVE_MAINTENANCE_MODE = exports.COMPLETE_LEAVE_MAINTENANCE_MODE = exports.LEAVE_MAINTENANCE_MODE = exports.FAIL_ENTER_MAINTENANCE_MODE = exports.COMPLETE_ENTER_MAINTENANCE_MODE = exports.ENTER_MAINTENANCE_MODE = exports.FAIL_FETCH_VERSION_RELEASE_NOTES = exports.COMPLETE_FETCH_VERSION_RELEASE_NOTES = exports.FETCH_VERSION_RELEASE_NOTES = exports.FAIL_FETCH_SYSTEM_STORAGE_HISTORY = exports.COMPLETE_FETCH_SYSTEM_STORAGE_HISTORY = exports.FETCH_SYSTEM_STORAGE_HISTORY = exports.FAIL_FETCH_SYSTEM_INFO = exports.COMPLETE_FETCH_SYSTEM_INFO = exports.FETCH_SYSTEM_INFO = exports.FAIL_CREATE_SYSTEM = exports.COMPLETE_CREATE_SYSTEM = exports.CREATE_SYSTEM = exports.SHOW_NOTIFICATION = exports.HIDE_NOTIFICATION = exports.CLOSE_MODAL = exports.UPDATE_MODAL = exports.OPEN_MODAL = exports.DROP_FROM = exports.COMPLETE_SUBMIT_FORM = exports.SUBMIT_FORM = exports.SET_FORM_VALIDITY = exports.UNTOUCH_FORM = exports.TOUCH_FORM = exports.RESET_FORM = exports.UPDATE_FORM = exports.INIT_FORM = exports.CLOSE_DRAWER = exports.OPEN_DRAWER = exports.SIGN_IN_WITH_OAUTH = exports.SIGN_OUT = exports.FAIL_SIGN_IN = exports.COMPLETE_SIGN_IN = exports.SIGN_IN = exports.EXPIRE_SESSION = exports.FAIL_RESTORE_SESSION = exports.COMPLETE_RESTORE_SESSION = exports.RESTORE_SESSION = exports.CHANGE_LOCATION = exports.REFRESH_LOCATION = exports.REQUEST_LOCATION = void 0;
exports.DELETE_NAMESPACE_RESOURCE = exports.FAIL_CREATE_NAMESPACE_RESOURCE = exports.COMPLETE_CREATE_NAMESPACE_RESOURCE = exports.CREATE_NAMESPACE_RESOURCE = exports.FAIL_FETCH_CLOUD_RESOURCE_OBJECTS = exports.COMPLETE_FETCH_CLOUD_RESOURCE_OBJECTS = exports.FETCH_CLOUD_RESOURCE_OBJECTS = exports.FAIL_ASSIGN_REGION_TO_RESOURCE = exports.COMPLETE_ASSIGN_REGION_TO_RESOURCE = exports.ASSIGN_REGION_TO_RESOURCE = exports.FAIL_DELETE_RESOURCE = exports.COMPLETE_DELETE_RESOURCE = exports.DELETE_RESOURCE = exports.FAIL_SCALE_HOSTS_POOL = exports.COMPLETE_SCALE_HOSTS_POOL = exports.SCALE_HOSTS_POOL = exports.FAIL_CREATE_HOSTS_POOL = exports.COMPLETE_CREATE_HOSTS_POOL = exports.CREATE_HOSTS_POOL = exports.FAIL_ADD_BUCKET_TIER = exports.COMPLETE_ADD_BUCKET_TIER = exports.ADD_BUCKET_TIER = exports.FAIL_UPDATE_TIER_PLACEMENT_POLICY = exports.COMPLETE_UPDATE_TIER_PLACEMENT_POLICY = exports.UPDATE_TIER_PLACEMENT_POLICY = exports.FAIL_REMOVE_BUCKET_TRIGGER = exports.COMPLETE_REMOVE_BUCKET_TRIGGER = exports.REMOVE_BUCKET_TRIGGER = exports.FAIL_UPDATE_BUCKET_TRIGGER = exports.COMPLETE_UPDATE_BUCKET_TRIGGER = exports.UPDATE_BUCKET_TRIGGER = exports.FAIL_ADD_BUCKET_TRIGGER = exports.COMPLETE_ADD_BUCKET_TRIGGER = exports.ADD_BUCKET_TRIGGER = exports.FAIL_UPDATE_BUCKET_S3_ACCESS = exports.COMPLETE_UPDATE_BUCKET_S3_ACCESS = exports.UPDATE_BUCKET_S3_ACCESS = exports.FAIL_DELETE_NAMESPACE_BUCKET = exports.COMPLETE_DELETE_NAMESPACE_BUCKET = exports.DELETE_NAMESPACE_BUCKET = exports.FAIL_UPDATE_NAMESPACE_BUCKET_PLACEMENT = exports.COMPLETE_UPDATE_NAMESPACE_BUCKET_PLACEMENT = exports.UPDATE_NAMESPACE_BUCKET_PLACEMENT = exports.FAIL_CREATE_NAMESPACE_BUCKET = exports.COMPLETE_CREATE_NAMESPACE_BUCKET = exports.CREATE_NAMESPACE_BUCKET = exports.FAIL_DELETE_BUCKET = exports.COMPLETE_DELETE_BUCKET = exports.DELETE_BUCKET = exports.FAIL_UPDATE_BUCKET_VERSIONING_POLICY = exports.COMPLETE_UPDATE_BUCKET_VERSIONING_POLICY = exports.UPDATE_BUCKET_VERSIONING_POLICY = exports.FAIL_UPDATE_BUCKET_RESILIENCY_POLICY = exports.COMPLETE_UPDATE_BUCKET_RESILIENCY_POLICY = exports.UPDATE_BUCKET_RESILIENCY_POLICY = exports.FAIL_UPDATE_BUCKET_QUOTA_POLICY = exports.COMPLETE_UPDATE_BUCKET_QUOTA_POLICY = exports.UPDATE_BUCKET_QUOTA_POLICY = exports.FAIL_CREATE_BUCKET = exports.COMPLETE_CREATE_BUCKET = exports.CREATE_BUCKET = exports.FAIL_FETCH_OBJECT_PARTS = exports.COMPLETE_FETCH_OBJECT_PARTS = exports.FETCH_OBJECT_PARTS = exports.FAIL_DELETE_OBJECT = exports.DROP_OBJECTS_VIEW = exports.COMPLETE_DELETE_OBJECT = exports.DELETE_OBJECT = exports.FAIL_FETCH_OBJECT = exports.COMPLETE_FETCH_OBJECT = exports.FETCH_OBJECT = exports.FAIL_FETCH_OBJECTS = exports.COMPLETE_FETCH_OBJECTS = exports.FETCH_OBJECTS = exports.CLEAR_COMPLETED_OBJECT_UPLOADES = exports.FAIL_OBJECT_UPLOAD = exports.COMPLETE_OBJECT_UPLOAD = exports.UPDATE_OBJECT_UPLOAD = exports.UPLOAD_OBJECTS = exports.UPDATE_ACCOUNT_UI_THEME = exports.FAIL_REGENERATE_ACCOUNT_CREDENTIALS = exports.COMPLETE_REGENERATE_ACCOUNT_CREDENTIALS = exports.REGENERATE_ACCOUNT_CREDENTIALS = exports.FAIL_DELETE_EXTERNAL_CONNECTION = exports.COMPLETE_DELETE_EXTERNAL_CONNECTION = exports.DELETE_EXTERNAL_CONNECTION = exports.FAIL_DELETE_ACCOUNT = exports.COMPLETE_DELETE_ACCOUNT = exports.TRY_DELETE_ACCOUNT = exports.FAIL_UPDATE_EXTERNAL_CONNECTION = exports.COMPLETE_UPDATE_EXTERNAL_CONNECTION = exports.UPDATE_EXTERNAL_CONNECTION = exports.FAIL_ADD_EXTERNAL_CONNECTION = exports.COMPLETE_ADD_EXTERNAL_CONNECTION = exports.ADD_EXTERNAL_CONNECTION = exports.FAIL_RESET_ACCOUNT_PASSWORD = exports.COMPLETE_RESET_ACCOUNT_PASSWORD = exports.RESET_ACCOUNT_PASSWORD = exports.FAIL_CHANGE_ACCOUNT_PASSWORD = exports.COMPLETE_CHANGE_ACCOUNT_PASSWORD = void 0;
exports.DUMP_APP_LOG = exports.DROP_LAMBDA_FUNC_USAGE_HISTORY = exports.FAIL_FETCH_LAMBDA_FUNC_USAGE_HISTORY = exports.COMPLETE_FETCH_LAMBDA_FUNC_USAGE_HISTORY = exports.FETCH_LAMBDA_FUNC_USAGE_HISTORY = exports.DROP_CLOUD_USAGE_STATS = exports.FAIL_FETCH_CLOUD_USAGE_STATS = exports.COMPLETE_FETCH_CLOUD_USAGE_STATS = exports.FETCH_CLOUD_USAGE_STATS = exports.DROP_FETCH_OBJECTS_DISTRIBUTION = exports.FAIL_FETCH_OBJECTS_DISTRIBUTION = exports.COMPLETE_FETCH_OBJECTS_DISTRIBUTION = exports.FETCH_OBJECTS_DISTRIBUTION = exports.DROP_ACCOUNT_USAGE_HISTORY = exports.FAIL_FETCH_ACCOUNT_USAGE_HISTORY = exports.COMPLETE_FETCH_ACCOUNT_USAGE_HISTORY = exports.FETCH_ACCOUNT_USAGE_HISTORY = exports.DROP_BUCKET_USAGE_HISTORY = exports.FAIL_FETCH_BUCKET_USAGE_HISTORY = exports.COMPLETE_FETCH_BUCKET_USAGE_HISTORY = exports.FETCH_BUCKET_USAGE_HISTORY = exports.DISSMISS_BROWSER_STICKY = exports.SETUP_ENV = exports.TOGGLE_PREVIEW_CONTENT = exports.DROP_ENDPOINTS_HISTORY = exports.FAIL_FETCH_ENDPOINTS_HISTORY = exports.COMPLETE_FETCH_ENDPOINTS_HISTORY = exports.FETCH_ENDPOINTS_HISTORY = exports.FAIL_UPDATE_ENDPOINT_GROUP = exports.COMPLETE_UPDATE_ENDPOINT_GROUP = exports.UPDATE_ENDPOINT_GROUP = exports.FAIL_GENERATE_ENDPOINT_GROUP_DEPLOYMENT_YAML = exports.COMPLETE_GENERATE_ENDPOINT_GROUP_DEPLOYMENT_YAML = exports.GENERATE_ENDPOINT_GROUP_DEPLOYMENT_YAML = exports.FAIL_INVOKE_LAMBDA_FUNC = exports.COMPLETE_INVOKE_LAMBDA_FUNC = exports.INVOKE_LAMBDA_FUNC = exports.DROP_LAMBDA_FUNC_CODE = exports.FAIL_LOAD_LAMBDA_FUNC_CODE = exports.COMPLETE_LOAD_LAMBDA_FUNC_CODE = exports.LOAD_LAMBDA_FUNC_CODE = exports.FAIL_UPDATE_LAMBDA_FUNC_CODE = exports.COMPLETE_UPDATE_LAMBDA_FUNC_CODE = exports.UPDATE_LAMBDA_FUNC_CODE = exports.FAIL_UPDATE_LAMBDA_FUNC_CONFIG = exports.COMPLETE_UPDATE_LAMBDA_FUNC_CONFIG = exports.UPDATE_LAMBDA_FUNC_CONFIG = exports.FAIL_DELETE_LAMBDA_FUNC = exports.COMPLETE_DELETE_LAMBDA_FUNC = exports.DELETE_LAMBDA_FUNC = exports.FAIL_CREATE_LAMBDA_FUNC = exports.COMPLETE_CREATE_LAMBDA_FUNC = exports.CREATE_LAMBDA_FUNC = exports.FAIL_CREATE_CLOUD_RESOURCE = exports.COMPLETE_CREATE_CLOUD_RESOURCE = exports.CREATE_CLOUD_RESOURCE = exports.DROP_CLOUD_TARGETS = exports.FAIL_FETCH_CLOUD_TARGETS = exports.COMPLETE_FETCH_CLOUD_TARGETS = exports.FETCH_CLOUD_TARGETS = exports.REMOVE_HOST = exports.FAIL_RETRUST_HOST = exports.COMPLETE_RETRUST_HOST = exports.RETRUST_HOST = exports.FAIL_FETCH_HOST_OBJECTS = exports.COMPLETE_FETCH_HOST_OBJECTS = exports.FETCH_HOST_OBJECTS = exports.DROP_HOSTS_VIEW = exports.FAIL_SET_HOST_DEBUG_MODE = exports.COMPLETE_SET_HOST_DEBUG_MODE = exports.SET_HOST_DEBUG_MODE = exports.FAIL_COLLECT_HOST_DIAGNOSTICS = exports.COMPLETE_COLLECT_HOST_DIAGNOSTICS = exports.COLLECT_HOST_DIAGNOSTICS = exports.FAIL_FETCH_HOSTS = exports.COMPLETE_FETCH_HOSTS = exports.FETCH_HOSTS = exports.FAIL_DELETE_NAMESPACE_RESOURCE = exports.COMPLETE_DELETE_NAMESPACE_RESOURCE = void 0;

/* Copyright (C) 2016 NooBaa */
// location actions.
const REQUEST_LOCATION = 'REQUEST_LOCATION';
exports.REQUEST_LOCATION = REQUEST_LOCATION;
const REFRESH_LOCATION = 'REFRESH_LOCATION';
exports.REFRESH_LOCATION = REFRESH_LOCATION;
const CHANGE_LOCATION = 'CHANGE_LOCATION'; // Session related actions

exports.CHANGE_LOCATION = CHANGE_LOCATION;
const RESTORE_SESSION = 'RESTORE_SESSION';
exports.RESTORE_SESSION = RESTORE_SESSION;
const COMPLETE_RESTORE_SESSION = 'COMPLETE_RESTORE_SESSION';
exports.COMPLETE_RESTORE_SESSION = COMPLETE_RESTORE_SESSION;
const FAIL_RESTORE_SESSION = 'FAIL_RESTORE_SESSION';
exports.FAIL_RESTORE_SESSION = FAIL_RESTORE_SESSION;
const EXPIRE_SESSION = 'EXPIRE_SESSION';
exports.EXPIRE_SESSION = EXPIRE_SESSION;
const SIGN_IN = 'SIGN_IN';
exports.SIGN_IN = SIGN_IN;
const COMPLETE_SIGN_IN = 'COMPLETE_SIGN_IN';
exports.COMPLETE_SIGN_IN = COMPLETE_SIGN_IN;
const FAIL_SIGN_IN = 'FAIL_SIGN_IN';
exports.FAIL_SIGN_IN = FAIL_SIGN_IN;
const SIGN_OUT = 'SIGN_OUT';
exports.SIGN_OUT = SIGN_OUT;
const SIGN_IN_WITH_OAUTH = 'SIGN_IN_WITH_OAUTH'; // Drawer related actions.

exports.SIGN_IN_WITH_OAUTH = SIGN_IN_WITH_OAUTH;
const OPEN_DRAWER = 'OPEN_DRAWER';
exports.OPEN_DRAWER = OPEN_DRAWER;
const CLOSE_DRAWER = 'CLOSE_DRAWER'; // Forms related actions.

exports.CLOSE_DRAWER = CLOSE_DRAWER;
const INIT_FORM = 'INIT_FORM';
exports.INIT_FORM = INIT_FORM;
const UPDATE_FORM = 'UPDATE_FORM';
exports.UPDATE_FORM = UPDATE_FORM;
const RESET_FORM = 'RESET_FORM';
exports.RESET_FORM = RESET_FORM;
const TOUCH_FORM = 'TOUCH_FORM';
exports.TOUCH_FORM = TOUCH_FORM;
const UNTOUCH_FORM = 'UNTOUCH_FORM';
exports.UNTOUCH_FORM = UNTOUCH_FORM;
const SET_FORM_VALIDITY = 'SET_FORM_VALIDITY';
exports.SET_FORM_VALIDITY = SET_FORM_VALIDITY;
const SUBMIT_FORM = 'SUBMIT_FORM';
exports.SUBMIT_FORM = SUBMIT_FORM;
const COMPLETE_SUBMIT_FORM = 'COMPLETE_SUBMIT_FORM';
exports.COMPLETE_SUBMIT_FORM = COMPLETE_SUBMIT_FORM;
const DROP_FROM = 'DROP_FROM'; // Modals related actions.

exports.DROP_FROM = DROP_FROM;
const OPEN_MODAL = 'OPEN_MODAL';
exports.OPEN_MODAL = OPEN_MODAL;
const UPDATE_MODAL = 'UPDATE_MODAL';
exports.UPDATE_MODAL = UPDATE_MODAL;
const CLOSE_MODAL = 'CLOSE_MODAL'; // Notifications related actions.

exports.CLOSE_MODAL = CLOSE_MODAL;
const HIDE_NOTIFICATION = 'HIDE_NOTIFICATION';
exports.HIDE_NOTIFICATION = HIDE_NOTIFICATION;
const SHOW_NOTIFICATION = 'SHOW_NOTIFICATION'; // System related actions.

exports.SHOW_NOTIFICATION = SHOW_NOTIFICATION;
const CREATE_SYSTEM = 'CREATE_SYSTEM';
exports.CREATE_SYSTEM = CREATE_SYSTEM;
const COMPLETE_CREATE_SYSTEM = 'COMPLETE_CREATE_SYSTEM';
exports.COMPLETE_CREATE_SYSTEM = COMPLETE_CREATE_SYSTEM;
const FAIL_CREATE_SYSTEM = 'FAIL_CREATE_SYSTEM';
exports.FAIL_CREATE_SYSTEM = FAIL_CREATE_SYSTEM;
const FETCH_SYSTEM_INFO = 'FETCH_SYSTEM_INFO';
exports.FETCH_SYSTEM_INFO = FETCH_SYSTEM_INFO;
const COMPLETE_FETCH_SYSTEM_INFO = 'COMPLETE_FETCH_SYSTEM_INFO';
exports.COMPLETE_FETCH_SYSTEM_INFO = COMPLETE_FETCH_SYSTEM_INFO;
const FAIL_FETCH_SYSTEM_INFO = 'FAIL_FETCH_SYSTEM_INFO';
exports.FAIL_FETCH_SYSTEM_INFO = FAIL_FETCH_SYSTEM_INFO;
const FETCH_SYSTEM_STORAGE_HISTORY = 'FETCH_SYSTEM_STORAGE_HISTORY';
exports.FETCH_SYSTEM_STORAGE_HISTORY = FETCH_SYSTEM_STORAGE_HISTORY;
const COMPLETE_FETCH_SYSTEM_STORAGE_HISTORY = 'COMPLETE_FETCH_SYSTEM_STORAGE_HISTORY';
exports.COMPLETE_FETCH_SYSTEM_STORAGE_HISTORY = COMPLETE_FETCH_SYSTEM_STORAGE_HISTORY;
const FAIL_FETCH_SYSTEM_STORAGE_HISTORY = 'FAIL_FETCH_SYSTEM_STORAGE_HISTORY';
exports.FAIL_FETCH_SYSTEM_STORAGE_HISTORY = FAIL_FETCH_SYSTEM_STORAGE_HISTORY;
const FETCH_VERSION_RELEASE_NOTES = 'FETCH_VERSION_RELEASE_NOTES';
exports.FETCH_VERSION_RELEASE_NOTES = FETCH_VERSION_RELEASE_NOTES;
const COMPLETE_FETCH_VERSION_RELEASE_NOTES = 'COMPLETE_FETCH_VERSION_RELEASE_NOTES';
exports.COMPLETE_FETCH_VERSION_RELEASE_NOTES = COMPLETE_FETCH_VERSION_RELEASE_NOTES;
const FAIL_FETCH_VERSION_RELEASE_NOTES = 'FAIL_FETCH_VERSION_RELEASE_NOTES';
exports.FAIL_FETCH_VERSION_RELEASE_NOTES = FAIL_FETCH_VERSION_RELEASE_NOTES;
const ENTER_MAINTENANCE_MODE = 'ENTER_MAINTENANCE_MODE';
exports.ENTER_MAINTENANCE_MODE = ENTER_MAINTENANCE_MODE;
const COMPLETE_ENTER_MAINTENANCE_MODE = 'COMPLETE_ENTER_MAINTENANCE_MODE';
exports.COMPLETE_ENTER_MAINTENANCE_MODE = COMPLETE_ENTER_MAINTENANCE_MODE;
const FAIL_ENTER_MAINTENANCE_MODE = 'FAIL_ENTER_MAINTENANCE_MODE';
exports.FAIL_ENTER_MAINTENANCE_MODE = FAIL_ENTER_MAINTENANCE_MODE;
const LEAVE_MAINTENANCE_MODE = 'LEAVE_MAINTENANCE_MODE';
exports.LEAVE_MAINTENANCE_MODE = LEAVE_MAINTENANCE_MODE;
const COMPLETE_LEAVE_MAINTENANCE_MODE = 'COMPLETE_LEAVE_MAINTENANCE_MODE';
exports.COMPLETE_LEAVE_MAINTENANCE_MODE = COMPLETE_LEAVE_MAINTENANCE_MODE;
const FAIL_LEAVE_MAINTENANCE_MODE = 'FAIL_LEAVE_MAINTENANCE_MODE';
exports.FAIL_LEAVE_MAINTENANCE_MODE = FAIL_LEAVE_MAINTENANCE_MODE;
const UPDATE_P2P_SETTINGS = 'UPDATE_P2P_SETTINGS';
exports.UPDATE_P2P_SETTINGS = UPDATE_P2P_SETTINGS;
const COMPLETE_UPDATE_P2P_SETTINGS = 'COMPLETE_UPDATE_P2P_SETTINGS';
exports.COMPLETE_UPDATE_P2P_SETTINGS = COMPLETE_UPDATE_P2P_SETTINGS;
const FAIL_UPDATE_P2P_SETTINGS = 'FAIL_UPDATE_P2P_SETTINGS';
exports.FAIL_UPDATE_P2P_SETTINGS = FAIL_UPDATE_P2P_SETTINGS;
const RESEND_ACTIVATION_CODE = 'RESEND_ACTIVATION_CODE';
exports.RESEND_ACTIVATION_CODE = RESEND_ACTIVATION_CODE;
const SET_SYSTEM_DEBUG_LEVEL = 'SET_SYSTEM_DEBUG_LEVEL';
exports.SET_SYSTEM_DEBUG_LEVEL = SET_SYSTEM_DEBUG_LEVEL;
const COMPLETE_SET_SYSTEM_DEBUG_LEVEL = 'COMPLETE_SET_SYSTEM_DEBUG_LEVEL';
exports.COMPLETE_SET_SYSTEM_DEBUG_LEVEL = COMPLETE_SET_SYSTEM_DEBUG_LEVEL;
const FAIL_SET_SYSTEM_DEBUG_LEVEL = 'FAIL_SET_SYSTEM_DEBUG_LEVEL';
exports.FAIL_SET_SYSTEM_DEBUG_LEVEL = FAIL_SET_SYSTEM_DEBUG_LEVEL;
const COLLECT_SYSTEM_DIAGNOSTICS = 'COLLECT_SYSTEM_DIAGNOSTICS';
exports.COLLECT_SYSTEM_DIAGNOSTICS = COLLECT_SYSTEM_DIAGNOSTICS;
const COMPLETE_COLLECT_SYSTEM_DIAGNOSTICS = 'COMPLETE_COLLECT_SYSTEM_DIAGNOSTICS';
exports.COMPLETE_COLLECT_SYSTEM_DIAGNOSTICS = COMPLETE_COLLECT_SYSTEM_DIAGNOSTICS;
const FAIL_COLLECT_SYSTEM_DIAGNOSTICS = 'FAIL_COLLECT_SYSTEM_DIAGNOSTICS';
exports.FAIL_COLLECT_SYSTEM_DIAGNOSTICS = FAIL_COLLECT_SYSTEM_DIAGNOSTICS;
const UPLOAD_SSL_CERTIFICATE = 'UPLOAD_SSL_CERTIFICATE';
exports.UPLOAD_SSL_CERTIFICATE = UPLOAD_SSL_CERTIFICATE;
const UPDATE_UPLOAD_SSL_CERTIFICATE = 'UPDATE_UPLOAD_SSL_CERTIFICATE';
exports.UPDATE_UPLOAD_SSL_CERTIFICATE = UPDATE_UPLOAD_SSL_CERTIFICATE;
const COMPLETE_UPLOAD_SSL_CERTIFICATE = 'COMPLETE_UPLOAD_SSL_CERTIFICATE';
exports.COMPLETE_UPLOAD_SSL_CERTIFICATE = COMPLETE_UPLOAD_SSL_CERTIFICATE;
const FAIL_UPLOAD_SSL_CERTIFICATE = 'FAIL_UPLOAD_SSL_CERTIFICATE'; // Topology related actions.

exports.FAIL_UPLOAD_SSL_CERTIFICATE = FAIL_UPLOAD_SSL_CERTIFICATE;
const UPDATE_SERVER_ADDRESS = 'UPDATE_SERVER_ADDRESS';
exports.UPDATE_SERVER_ADDRESS = UPDATE_SERVER_ADDRESS;
const COMPLETE_UPDATE_SERVER_ADDRESS = 'COMPLETE_UPDATE_SERVER_ADDRESS';
exports.COMPLETE_UPDATE_SERVER_ADDRESS = COMPLETE_UPDATE_SERVER_ADDRESS;
const FAIL_UPDATE_SERVER_ADDRESS = 'FAIL_UPDATE_SERVER_ADDRESS';
exports.FAIL_UPDATE_SERVER_ADDRESS = FAIL_UPDATE_SERVER_ADDRESS;
const ATTACH_SERVER_TO_CLUSTER = 'ATTACH_SERVER_TO_CLUSTER';
exports.ATTACH_SERVER_TO_CLUSTER = ATTACH_SERVER_TO_CLUSTER;
const COMPLETE_ATTACH_SERVER_TO_CLUSTER = 'COMPLETE_ATTACH_SERVER_TO_CLUSTER';
exports.COMPLETE_ATTACH_SERVER_TO_CLUSTER = COMPLETE_ATTACH_SERVER_TO_CLUSTER;
const FAIL_ATTACH_SERVER_TO_CLUSTER = 'FAIL_ATTACH_SERVER_TO_CLUSTER';
exports.FAIL_ATTACH_SERVER_TO_CLUSTER = FAIL_ATTACH_SERVER_TO_CLUSTER;
const UPDATE_SERVER_DETAILS = 'UPDATE_SERVER_DETAILS';
exports.UPDATE_SERVER_DETAILS = UPDATE_SERVER_DETAILS;
const COMPLETE_UPDATE_SERVER_DETAILS = 'COMPLETE_UPDATE_SERVER_DETAILS';
exports.COMPLETE_UPDATE_SERVER_DETAILS = COMPLETE_UPDATE_SERVER_DETAILS;
const FAIL_UPDATE_SERVER_DETAILS = 'FAIL_UPDATE_SERVER_DETAILS'; // Node installation related actions.

exports.FAIL_UPDATE_SERVER_DETAILS = FAIL_UPDATE_SERVER_DETAILS;
const FETCH_NODE_INSTALLATION_COMMANDS = 'FETCH_NODE_INSTALLATION_COMMANDS';
exports.FETCH_NODE_INSTALLATION_COMMANDS = FETCH_NODE_INSTALLATION_COMMANDS;
const COMPLETE_FETCH_NODE_INSTALLATION_COMMANDS = 'COMPLETE_FETCH_NODE_INSTALLATION_COMMANDS';
exports.COMPLETE_FETCH_NODE_INSTALLATION_COMMANDS = COMPLETE_FETCH_NODE_INSTALLATION_COMMANDS;
const FAIL_FETCH_NODE_INSTALLATION_COMMANDS = 'FAIL_FETCH_NODE_INSTALLATION_COMMANDS'; // Alerts related actions.

exports.FAIL_FETCH_NODE_INSTALLATION_COMMANDS = FAIL_FETCH_NODE_INSTALLATION_COMMANDS;
const FETCH_ALERTS = 'FETCH_ALERTS';
exports.FETCH_ALERTS = FETCH_ALERTS;
const COMPLETE_FETCH_ALERTS = 'COMPLETE_FETCH_ALERTS';
exports.COMPLETE_FETCH_ALERTS = COMPLETE_FETCH_ALERTS;
const FAIL_FETCH_ALERTS = 'FAIL_FETCH_ALERTS';
exports.FAIL_FETCH_ALERTS = FAIL_FETCH_ALERTS;
const UPDATE_ALERTS = 'UPDATE_ALERTS';
exports.UPDATE_ALERTS = UPDATE_ALERTS;
const COMPLETE_UPDATE_ALERTS = 'COMPLETE_UPDATE_ALERTS';
exports.COMPLETE_UPDATE_ALERTS = COMPLETE_UPDATE_ALERTS;
const FAIL_UPDATE_ALERTS = 'FAIL_UPDATE_ALERTS';
exports.FAIL_UPDATE_ALERTS = FAIL_UPDATE_ALERTS;
const FETCH_UNREAD_ALERTS_COUNT = 'FETCH_UNREAD_ALERTS_COUNT';
exports.FETCH_UNREAD_ALERTS_COUNT = FETCH_UNREAD_ALERTS_COUNT;
const COMPLETE_FETCH_UNREAD_ALERTS_COUNT = 'COMPLETE_FETCH_UNREAD_ALERTS_COUNT';
exports.COMPLETE_FETCH_UNREAD_ALERTS_COUNT = COMPLETE_FETCH_UNREAD_ALERTS_COUNT;
const FAIL_FETCH_UREAD_ALERTS_COUNT = 'COMPLETE_FETCH_UNREAD_ALERTS_COUNT';
exports.FAIL_FETCH_UREAD_ALERTS_COUNT = FAIL_FETCH_UREAD_ALERTS_COUNT;
const DROP_ALERTS = 'DROP_ALERTS'; // Audit log related actions

exports.DROP_ALERTS = DROP_ALERTS;
const FETCH_AUDIT_LOG = 'FETCH_AUDIT_LOG';
exports.FETCH_AUDIT_LOG = FETCH_AUDIT_LOG;
const COMPLETE_FETCH_AUDIT_LOG = 'COMPLETE_FETCH_AUDIT_LOG';
exports.COMPLETE_FETCH_AUDIT_LOG = COMPLETE_FETCH_AUDIT_LOG;
const FAIL_FETCH_AUDIT_LOG = 'FAIL_FETCH_AUDIT_LOG';
exports.FAIL_FETCH_AUDIT_LOG = FAIL_FETCH_AUDIT_LOG;
const DROP_AUDIT_LOG = 'DROP_AUDIT_LOG';
exports.DROP_AUDIT_LOG = DROP_AUDIT_LOG;
const EXPORT_AUDIT_LOG = 'EXPORT_AUDIT_LOG';
exports.EXPORT_AUDIT_LOG = EXPORT_AUDIT_LOG;
const COMPLETE_EXPORT_AUDIT_LOG = 'COMPLETE_EXPORT_AUDIT_LOG';
exports.COMPLETE_EXPORT_AUDIT_LOG = COMPLETE_EXPORT_AUDIT_LOG;
const FAIL_EXPORT_AUDIT_LOG = 'FAIL_EXPORT_AUDIT_LOG';
exports.FAIL_EXPORT_AUDIT_LOG = FAIL_EXPORT_AUDIT_LOG;
const SELECT_AUDIT_RECORD = 'SELECT_AUDIT_RECORD'; // Account related actions.

exports.SELECT_AUDIT_RECORD = SELECT_AUDIT_RECORD;
const CREATE_ACCOUNT = 'CREATE_ACCOUNT';
exports.CREATE_ACCOUNT = CREATE_ACCOUNT;
const COMPLETE_CREATE_ACCOUNT = 'COMPLETE_CREATE_ACCOUNT';
exports.COMPLETE_CREATE_ACCOUNT = COMPLETE_CREATE_ACCOUNT;
const FAIL_CREATE_ACCOUNT = 'FAIL_CREATE_ACCOUNT';
exports.FAIL_CREATE_ACCOUNT = FAIL_CREATE_ACCOUNT;
const UPDATE_ACCOUNT_S3_ACCESS = 'UPDATE_ACCOUNT_S3_ACCESS';
exports.UPDATE_ACCOUNT_S3_ACCESS = UPDATE_ACCOUNT_S3_ACCESS;
const COMPLETE_UPDATE_ACCOUNT_S3_ACCESS = 'COMPLETE_UPDATE_ACCOUNT_S3_ACCESS';
exports.COMPLETE_UPDATE_ACCOUNT_S3_ACCESS = COMPLETE_UPDATE_ACCOUNT_S3_ACCESS;
const FAIL_UPDATE_ACCOUNT_S3_ACCESS = 'FAIL_UPDATE_ACCOUNT_S3_ACCESS';
exports.FAIL_UPDATE_ACCOUNT_S3_ACCESS = FAIL_UPDATE_ACCOUNT_S3_ACCESS;
const SET_ACCOUNT_IP_RESTRICTIONS = 'SET_ACCOUNT_IP_RESTRICTIONS';
exports.SET_ACCOUNT_IP_RESTRICTIONS = SET_ACCOUNT_IP_RESTRICTIONS;
const COMPLETE_SET_ACCOUNT_IP_RESTRICTIONS = 'COMPLETE_SET_ACCOUNT_IP_RESTRICTIONS';
exports.COMPLETE_SET_ACCOUNT_IP_RESTRICTIONS = COMPLETE_SET_ACCOUNT_IP_RESTRICTIONS;
const FAIL_SET_ACCOUNT_IP_RESTRICTIONS = 'FAIL_SET_ACCOUNT_IP_RESTRICTIONS';
exports.FAIL_SET_ACCOUNT_IP_RESTRICTIONS = FAIL_SET_ACCOUNT_IP_RESTRICTIONS;
const CHANGE_ACCOUNT_PASSWORD = 'CHANGE_ACCOUNT_PASSWORD';
exports.CHANGE_ACCOUNT_PASSWORD = CHANGE_ACCOUNT_PASSWORD;
const COMPLETE_CHANGE_ACCOUNT_PASSWORD = 'COMPLETE_CHANGE_ACCOUNT_PASSWORD';
exports.COMPLETE_CHANGE_ACCOUNT_PASSWORD = COMPLETE_CHANGE_ACCOUNT_PASSWORD;
const FAIL_CHANGE_ACCOUNT_PASSWORD = 'FAIL_CHANGE_ACCOUNT_PASSWORD';
exports.FAIL_CHANGE_ACCOUNT_PASSWORD = FAIL_CHANGE_ACCOUNT_PASSWORD;
const RESET_ACCOUNT_PASSWORD = 'RESET_ACCOUNT_PASSWORD';
exports.RESET_ACCOUNT_PASSWORD = RESET_ACCOUNT_PASSWORD;
const COMPLETE_RESET_ACCOUNT_PASSWORD = 'COMPLETE_RESET_ACCOUNT_PASSWORD';
exports.COMPLETE_RESET_ACCOUNT_PASSWORD = COMPLETE_RESET_ACCOUNT_PASSWORD;
const FAIL_RESET_ACCOUNT_PASSWORD = 'FAIL_RESET_ACCOUNT_PASSWORD';
exports.FAIL_RESET_ACCOUNT_PASSWORD = FAIL_RESET_ACCOUNT_PASSWORD;
const ADD_EXTERNAL_CONNECTION = 'ADD_EXTERNAL_CONNECTION';
exports.ADD_EXTERNAL_CONNECTION = ADD_EXTERNAL_CONNECTION;
const COMPLETE_ADD_EXTERNAL_CONNECTION = 'COMPLETE_ADD_EXTERNAL_CONNECTION';
exports.COMPLETE_ADD_EXTERNAL_CONNECTION = COMPLETE_ADD_EXTERNAL_CONNECTION;
const FAIL_ADD_EXTERNAL_CONNECTION = 'FAIL_ADD_EXTERNAL_CONNECTION';
exports.FAIL_ADD_EXTERNAL_CONNECTION = FAIL_ADD_EXTERNAL_CONNECTION;
const UPDATE_EXTERNAL_CONNECTION = 'UPDATE_EXTERNAL_CONNECTION';
exports.UPDATE_EXTERNAL_CONNECTION = UPDATE_EXTERNAL_CONNECTION;
const COMPLETE_UPDATE_EXTERNAL_CONNECTION = 'COMPLETE_UPDATE_EXTERNAL_CONNECTION';
exports.COMPLETE_UPDATE_EXTERNAL_CONNECTION = COMPLETE_UPDATE_EXTERNAL_CONNECTION;
const FAIL_UPDATE_EXTERNAL_CONNECTION = 'FAIL_UPDATE_EXTERNAL_CONNECTION';
exports.FAIL_UPDATE_EXTERNAL_CONNECTION = FAIL_UPDATE_EXTERNAL_CONNECTION;
const TRY_DELETE_ACCOUNT = 'TRY_DELETE_ACCOUNT';
exports.TRY_DELETE_ACCOUNT = TRY_DELETE_ACCOUNT;
const COMPLETE_DELETE_ACCOUNT = 'COMPLETE_DELETE_ACCOUNT';
exports.COMPLETE_DELETE_ACCOUNT = COMPLETE_DELETE_ACCOUNT;
const FAIL_DELETE_ACCOUNT = 'FAIL_DELETE_ACCOUNT';
exports.FAIL_DELETE_ACCOUNT = FAIL_DELETE_ACCOUNT;
const DELETE_EXTERNAL_CONNECTION = 'DELETE_EXTERNAL_CONNECTION';
exports.DELETE_EXTERNAL_CONNECTION = DELETE_EXTERNAL_CONNECTION;
const COMPLETE_DELETE_EXTERNAL_CONNECTION = 'COMPLETE_DELETE_EXTERNAL_CONNECTION';
exports.COMPLETE_DELETE_EXTERNAL_CONNECTION = COMPLETE_DELETE_EXTERNAL_CONNECTION;
const FAIL_DELETE_EXTERNAL_CONNECTION = 'FAIL_DELETE_EXTERNAL_CONNECTION';
exports.FAIL_DELETE_EXTERNAL_CONNECTION = FAIL_DELETE_EXTERNAL_CONNECTION;
const REGENERATE_ACCOUNT_CREDENTIALS = 'REGENERATE_ACCOUNT_CREDENTIALS';
exports.REGENERATE_ACCOUNT_CREDENTIALS = REGENERATE_ACCOUNT_CREDENTIALS;
const COMPLETE_REGENERATE_ACCOUNT_CREDENTIALS = 'COMPLETE_REGENERATE_ACCOUNT_CREDENTIALS';
exports.COMPLETE_REGENERATE_ACCOUNT_CREDENTIALS = COMPLETE_REGENERATE_ACCOUNT_CREDENTIALS;
const FAIL_REGENERATE_ACCOUNT_CREDENTIALS = 'FAIL_REGENERATE_ACCOUNT_CREDENTIALS';
exports.FAIL_REGENERATE_ACCOUNT_CREDENTIALS = FAIL_REGENERATE_ACCOUNT_CREDENTIALS;
const UPDATE_ACCOUNT_UI_THEME = 'UPDATE_ACCOUNT_UI_THEME'; // Object related actions.

exports.UPDATE_ACCOUNT_UI_THEME = UPDATE_ACCOUNT_UI_THEME;
const UPLOAD_OBJECTS = 'UPLOAD_OBJECTS';
exports.UPLOAD_OBJECTS = UPLOAD_OBJECTS;
const UPDATE_OBJECT_UPLOAD = 'UPDATE_OBJECT_UPLOAD';
exports.UPDATE_OBJECT_UPLOAD = UPDATE_OBJECT_UPLOAD;
const COMPLETE_OBJECT_UPLOAD = 'COMPLETE_OBJECT_UPLOAD';
exports.COMPLETE_OBJECT_UPLOAD = COMPLETE_OBJECT_UPLOAD;
const FAIL_OBJECT_UPLOAD = 'FAIL_OBJECT_UPLOAD';
exports.FAIL_OBJECT_UPLOAD = FAIL_OBJECT_UPLOAD;
const CLEAR_COMPLETED_OBJECT_UPLOADES = 'CLEAR_COMPLETED_OBJECT_UPLOADES';
exports.CLEAR_COMPLETED_OBJECT_UPLOADES = CLEAR_COMPLETED_OBJECT_UPLOADES;
const FETCH_OBJECTS = 'FETCH_OBJECTS';
exports.FETCH_OBJECTS = FETCH_OBJECTS;
const COMPLETE_FETCH_OBJECTS = 'COMPLETE_FETCH_OBJECTS';
exports.COMPLETE_FETCH_OBJECTS = COMPLETE_FETCH_OBJECTS;
const FAIL_FETCH_OBJECTS = 'FAIL_FETCH_OBJECTS';
exports.FAIL_FETCH_OBJECTS = FAIL_FETCH_OBJECTS;
const FETCH_OBJECT = 'FETCH_OBJECT';
exports.FETCH_OBJECT = FETCH_OBJECT;
const COMPLETE_FETCH_OBJECT = 'COMPLETE_FETCH_OBJECT';
exports.COMPLETE_FETCH_OBJECT = COMPLETE_FETCH_OBJECT;
const FAIL_FETCH_OBJECT = 'FAIL_FETCH_OBJECT';
exports.FAIL_FETCH_OBJECT = FAIL_FETCH_OBJECT;
const DELETE_OBJECT = 'DELETE_OBJECT';
exports.DELETE_OBJECT = DELETE_OBJECT;
const COMPLETE_DELETE_OBJECT = 'COMPLETE_DELETE_OBJECT';
exports.COMPLETE_DELETE_OBJECT = COMPLETE_DELETE_OBJECT;
const DROP_OBJECTS_VIEW = 'DROP_OBJECTS_VIEW';
exports.DROP_OBJECTS_VIEW = DROP_OBJECTS_VIEW;
const FAIL_DELETE_OBJECT = 'FAIL_DELETE_OBJECT';
exports.FAIL_DELETE_OBJECT = FAIL_DELETE_OBJECT;
const FETCH_OBJECT_PARTS = 'FETCH_OBJECT_PARTS';
exports.FETCH_OBJECT_PARTS = FETCH_OBJECT_PARTS;
const COMPLETE_FETCH_OBJECT_PARTS = 'COMPLETE_FETCH_OBJECT_PARTS';
exports.COMPLETE_FETCH_OBJECT_PARTS = COMPLETE_FETCH_OBJECT_PARTS;
const FAIL_FETCH_OBJECT_PARTS = 'FAIL_FETCH_OBJECT_PARTS'; // Bucket related actions.

exports.FAIL_FETCH_OBJECT_PARTS = FAIL_FETCH_OBJECT_PARTS;
const CREATE_BUCKET = 'CREATE_BUCKET';
exports.CREATE_BUCKET = CREATE_BUCKET;
const COMPLETE_CREATE_BUCKET = 'COMPLETE_CREATE_BUCKET';
exports.COMPLETE_CREATE_BUCKET = COMPLETE_CREATE_BUCKET;
const FAIL_CREATE_BUCKET = 'FAIL_CREATE_BUCKET';
exports.FAIL_CREATE_BUCKET = FAIL_CREATE_BUCKET;
const UPDATE_BUCKET_QUOTA_POLICY = 'UPDATE_BUCKET_QUOTA_POLICY';
exports.UPDATE_BUCKET_QUOTA_POLICY = UPDATE_BUCKET_QUOTA_POLICY;
const COMPLETE_UPDATE_BUCKET_QUOTA_POLICY = 'COMPLETE_UPDATE_BUCKET_QUOTA_POLICY';
exports.COMPLETE_UPDATE_BUCKET_QUOTA_POLICY = COMPLETE_UPDATE_BUCKET_QUOTA_POLICY;
const FAIL_UPDATE_BUCKET_QUOTA_POLICY = 'FAIL_UPDATE_BUCKET_QUOTA_POLICY';
exports.FAIL_UPDATE_BUCKET_QUOTA_POLICY = FAIL_UPDATE_BUCKET_QUOTA_POLICY;
const UPDATE_BUCKET_RESILIENCY_POLICY = 'UPDATE_BUCKET_RESILIENCY_POLICY';
exports.UPDATE_BUCKET_RESILIENCY_POLICY = UPDATE_BUCKET_RESILIENCY_POLICY;
const COMPLETE_UPDATE_BUCKET_RESILIENCY_POLICY = 'COMPLETE_UPDATE_BUCKET_RESILIENCY_POLICY';
exports.COMPLETE_UPDATE_BUCKET_RESILIENCY_POLICY = COMPLETE_UPDATE_BUCKET_RESILIENCY_POLICY;
const FAIL_UPDATE_BUCKET_RESILIENCY_POLICY = 'FAIL_UPDATE_BUCKET_RESILIENCY_POLICY';
exports.FAIL_UPDATE_BUCKET_RESILIENCY_POLICY = FAIL_UPDATE_BUCKET_RESILIENCY_POLICY;
const UPDATE_BUCKET_VERSIONING_POLICY = 'UPDATE_BUCKET_VERSIONING_POLICY';
exports.UPDATE_BUCKET_VERSIONING_POLICY = UPDATE_BUCKET_VERSIONING_POLICY;
const COMPLETE_UPDATE_BUCKET_VERSIONING_POLICY = 'COMPLETE_UPDATE_BUCKET_VERSIONING_POLICY';
exports.COMPLETE_UPDATE_BUCKET_VERSIONING_POLICY = COMPLETE_UPDATE_BUCKET_VERSIONING_POLICY;
const FAIL_UPDATE_BUCKET_VERSIONING_POLICY = 'FAIL_UPDATE_BUCKET_VERSIONING_POLICY';
exports.FAIL_UPDATE_BUCKET_VERSIONING_POLICY = FAIL_UPDATE_BUCKET_VERSIONING_POLICY;
const DELETE_BUCKET = 'DELETE_BUCKET';
exports.DELETE_BUCKET = DELETE_BUCKET;
const COMPLETE_DELETE_BUCKET = 'COMPLETE_DELETE_BUCKET';
exports.COMPLETE_DELETE_BUCKET = COMPLETE_DELETE_BUCKET;
const FAIL_DELETE_BUCKET = 'FAIL_DELETE_BUCKET';
exports.FAIL_DELETE_BUCKET = FAIL_DELETE_BUCKET;
const CREATE_NAMESPACE_BUCKET = 'CREATE_NAMESPACE_BUCKET';
exports.CREATE_NAMESPACE_BUCKET = CREATE_NAMESPACE_BUCKET;
const COMPLETE_CREATE_NAMESPACE_BUCKET = 'COMPLETE_CREATE_NAMESPACE_BUCKET';
exports.COMPLETE_CREATE_NAMESPACE_BUCKET = COMPLETE_CREATE_NAMESPACE_BUCKET;
const FAIL_CREATE_NAMESPACE_BUCKET = 'FAIL_CREATE_NAMESPACE_BUCKET';
exports.FAIL_CREATE_NAMESPACE_BUCKET = FAIL_CREATE_NAMESPACE_BUCKET;
const UPDATE_NAMESPACE_BUCKET_PLACEMENT = 'UPDATE_NAMESPACE_BUCKET_PLACEMENT';
exports.UPDATE_NAMESPACE_BUCKET_PLACEMENT = UPDATE_NAMESPACE_BUCKET_PLACEMENT;
const COMPLETE_UPDATE_NAMESPACE_BUCKET_PLACEMENT = 'COMPLETE_UPDATE_NAMESPACE_BUCKET_PLACEMENT';
exports.COMPLETE_UPDATE_NAMESPACE_BUCKET_PLACEMENT = COMPLETE_UPDATE_NAMESPACE_BUCKET_PLACEMENT;
const FAIL_UPDATE_NAMESPACE_BUCKET_PLACEMENT = 'FAIL_UPDATE_NAMESPACE_BUCKET_PLACEMENT';
exports.FAIL_UPDATE_NAMESPACE_BUCKET_PLACEMENT = FAIL_UPDATE_NAMESPACE_BUCKET_PLACEMENT;
const DELETE_NAMESPACE_BUCKET = 'DELETE_NAMESPACE_BUCKET';
exports.DELETE_NAMESPACE_BUCKET = DELETE_NAMESPACE_BUCKET;
const COMPLETE_DELETE_NAMESPACE_BUCKET = 'COMPLETE_DELETE_NAMESPACE_BUCKET';
exports.COMPLETE_DELETE_NAMESPACE_BUCKET = COMPLETE_DELETE_NAMESPACE_BUCKET;
const FAIL_DELETE_NAMESPACE_BUCKET = 'FAIL_DELETE_NAMESPACE_BUCKET';
exports.FAIL_DELETE_NAMESPACE_BUCKET = FAIL_DELETE_NAMESPACE_BUCKET;
const UPDATE_BUCKET_S3_ACCESS = 'UPDATE_BUCKET_S3_ACCESS';
exports.UPDATE_BUCKET_S3_ACCESS = UPDATE_BUCKET_S3_ACCESS;
const COMPLETE_UPDATE_BUCKET_S3_ACCESS = 'COMPLETE_UPDATE_BUCKET_S3_ACCESS';
exports.COMPLETE_UPDATE_BUCKET_S3_ACCESS = COMPLETE_UPDATE_BUCKET_S3_ACCESS;
const FAIL_UPDATE_BUCKET_S3_ACCESS = 'FAIL_UPDATE_BUCKET_S3_ACCESS';
exports.FAIL_UPDATE_BUCKET_S3_ACCESS = FAIL_UPDATE_BUCKET_S3_ACCESS;
const ADD_BUCKET_TRIGGER = 'ADD_BUCKET_TRIGGER';
exports.ADD_BUCKET_TRIGGER = ADD_BUCKET_TRIGGER;
const COMPLETE_ADD_BUCKET_TRIGGER = 'COMPLETE_ADD_BUCKET_TRIGGER';
exports.COMPLETE_ADD_BUCKET_TRIGGER = COMPLETE_ADD_BUCKET_TRIGGER;
const FAIL_ADD_BUCKET_TRIGGER = 'FAIL_ADD_BUCKET_TRIGGER';
exports.FAIL_ADD_BUCKET_TRIGGER = FAIL_ADD_BUCKET_TRIGGER;
const UPDATE_BUCKET_TRIGGER = 'UPDATE_BUCKET_TRIGGER';
exports.UPDATE_BUCKET_TRIGGER = UPDATE_BUCKET_TRIGGER;
const COMPLETE_UPDATE_BUCKET_TRIGGER = 'COMPLETE_UPDATE_BUCKET_TRIGGER';
exports.COMPLETE_UPDATE_BUCKET_TRIGGER = COMPLETE_UPDATE_BUCKET_TRIGGER;
const FAIL_UPDATE_BUCKET_TRIGGER = 'FAIL_UPDATE_BUCKET_TRIGGER';
exports.FAIL_UPDATE_BUCKET_TRIGGER = FAIL_UPDATE_BUCKET_TRIGGER;
const REMOVE_BUCKET_TRIGGER = 'REMOVE_BUCKET_TRIGGER';
exports.REMOVE_BUCKET_TRIGGER = REMOVE_BUCKET_TRIGGER;
const COMPLETE_REMOVE_BUCKET_TRIGGER = 'COMPLETE_REMOVE_BUCKET_TRIGGER';
exports.COMPLETE_REMOVE_BUCKET_TRIGGER = COMPLETE_REMOVE_BUCKET_TRIGGER;
const FAIL_REMOVE_BUCKET_TRIGGER = 'FAIL_REMOVE_BUCKET_TRIGGER';
exports.FAIL_REMOVE_BUCKET_TRIGGER = FAIL_REMOVE_BUCKET_TRIGGER;
const UPDATE_TIER_PLACEMENT_POLICY = 'UPDATE_TIER_PLACEMENT_POLICY';
exports.UPDATE_TIER_PLACEMENT_POLICY = UPDATE_TIER_PLACEMENT_POLICY;
const COMPLETE_UPDATE_TIER_PLACEMENT_POLICY = 'COMPLETE_UPDATE_TIER_PLACEMENT_POLICY';
exports.COMPLETE_UPDATE_TIER_PLACEMENT_POLICY = COMPLETE_UPDATE_TIER_PLACEMENT_POLICY;
const FAIL_UPDATE_TIER_PLACEMENT_POLICY = 'FAIL_UPDATE_TIER_PLACEMENT_POLICY';
exports.FAIL_UPDATE_TIER_PLACEMENT_POLICY = FAIL_UPDATE_TIER_PLACEMENT_POLICY;
const ADD_BUCKET_TIER = 'ADD_BUCKET_TIER';
exports.ADD_BUCKET_TIER = ADD_BUCKET_TIER;
const COMPLETE_ADD_BUCKET_TIER = 'COMPLETE_ADD_BUCKET_TIER';
exports.COMPLETE_ADD_BUCKET_TIER = COMPLETE_ADD_BUCKET_TIER;
const FAIL_ADD_BUCKET_TIER = 'FAIL_ADD_BUCKET_TIER'; // Resource related actions.

exports.FAIL_ADD_BUCKET_TIER = FAIL_ADD_BUCKET_TIER;
const CREATE_HOSTS_POOL = 'CREATE_HOSTS_POOL';
exports.CREATE_HOSTS_POOL = CREATE_HOSTS_POOL;
const COMPLETE_CREATE_HOSTS_POOL = 'COMPLETE_CREATE_HOSTS_POOL';
exports.COMPLETE_CREATE_HOSTS_POOL = COMPLETE_CREATE_HOSTS_POOL;
const FAIL_CREATE_HOSTS_POOL = 'FAIL_CREATE_HOSTS_POOL';
exports.FAIL_CREATE_HOSTS_POOL = FAIL_CREATE_HOSTS_POOL;
const SCALE_HOSTS_POOL = 'SCALE_HOST_POOL';
exports.SCALE_HOSTS_POOL = SCALE_HOSTS_POOL;
const COMPLETE_SCALE_HOSTS_POOL = 'COMPLETE_SCALE_HOSTS_POOL';
exports.COMPLETE_SCALE_HOSTS_POOL = COMPLETE_SCALE_HOSTS_POOL;
const FAIL_SCALE_HOSTS_POOL = 'FAIL_SCALE_HOSTS_POOL';
exports.FAIL_SCALE_HOSTS_POOL = FAIL_SCALE_HOSTS_POOL;
const DELETE_RESOURCE = 'DELETE_RESOURCE';
exports.DELETE_RESOURCE = DELETE_RESOURCE;
const COMPLETE_DELETE_RESOURCE = 'COMPLETE_DELETE_RESOURCE';
exports.COMPLETE_DELETE_RESOURCE = COMPLETE_DELETE_RESOURCE;
const FAIL_DELETE_RESOURCE = 'FAIL_DELETE_RESOURCE';
exports.FAIL_DELETE_RESOURCE = FAIL_DELETE_RESOURCE;
const ASSIGN_REGION_TO_RESOURCE = 'ASSIGN_REGION_TO_RESOURCE';
exports.ASSIGN_REGION_TO_RESOURCE = ASSIGN_REGION_TO_RESOURCE;
const COMPLETE_ASSIGN_REGION_TO_RESOURCE = 'COMPLETE_ASSIGN_REGION_TO_RESOURCE';
exports.COMPLETE_ASSIGN_REGION_TO_RESOURCE = COMPLETE_ASSIGN_REGION_TO_RESOURCE;
const FAIL_ASSIGN_REGION_TO_RESOURCE = 'FAIL_ASSIGN_REGION_TO_RESOURCE';
exports.FAIL_ASSIGN_REGION_TO_RESOURCE = FAIL_ASSIGN_REGION_TO_RESOURCE;
const FETCH_CLOUD_RESOURCE_OBJECTS = 'FETCH_CLOUD_RESOURCE_OBJECTS';
exports.FETCH_CLOUD_RESOURCE_OBJECTS = FETCH_CLOUD_RESOURCE_OBJECTS;
const COMPLETE_FETCH_CLOUD_RESOURCE_OBJECTS = 'COMPLETE_FETCH_CLOUD_RESOURCE_OBJECTS';
exports.COMPLETE_FETCH_CLOUD_RESOURCE_OBJECTS = COMPLETE_FETCH_CLOUD_RESOURCE_OBJECTS;
const FAIL_FETCH_CLOUD_RESOURCE_OBJECTS = 'FAIL_FETCH_CLOUD_RESOURCE_OBJECTS'; // Namespace related actions

exports.FAIL_FETCH_CLOUD_RESOURCE_OBJECTS = FAIL_FETCH_CLOUD_RESOURCE_OBJECTS;
const CREATE_NAMESPACE_RESOURCE = 'CREATE_NAMESPACE_RESOURCE';
exports.CREATE_NAMESPACE_RESOURCE = CREATE_NAMESPACE_RESOURCE;
const COMPLETE_CREATE_NAMESPACE_RESOURCE = 'COMPLETE_CREATE_NAMESPACE_RESOURCE';
exports.COMPLETE_CREATE_NAMESPACE_RESOURCE = COMPLETE_CREATE_NAMESPACE_RESOURCE;
const FAIL_CREATE_NAMESPACE_RESOURCE = 'FAIL_CREATE_NAMESPACE_RESOURCE';
exports.FAIL_CREATE_NAMESPACE_RESOURCE = FAIL_CREATE_NAMESPACE_RESOURCE;
const DELETE_NAMESPACE_RESOURCE = 'DELETE_NAMESPACE_RESOURCE';
exports.DELETE_NAMESPACE_RESOURCE = DELETE_NAMESPACE_RESOURCE;
const COMPLETE_DELETE_NAMESPACE_RESOURCE = 'COMPLETE_DELETE_NAMESPACE_RESOURCE';
exports.COMPLETE_DELETE_NAMESPACE_RESOURCE = COMPLETE_DELETE_NAMESPACE_RESOURCE;
const FAIL_DELETE_NAMESPACE_RESOURCE = 'FAIL_DELETE_NAMESPACE_RESOURCE'; // Hosts related actions.

exports.FAIL_DELETE_NAMESPACE_RESOURCE = FAIL_DELETE_NAMESPACE_RESOURCE;
const FETCH_HOSTS = 'FETCH_HOSTS';
exports.FETCH_HOSTS = FETCH_HOSTS;
const COMPLETE_FETCH_HOSTS = 'COMPLETE_FETCH_HOSTS';
exports.COMPLETE_FETCH_HOSTS = COMPLETE_FETCH_HOSTS;
const FAIL_FETCH_HOSTS = 'FAIL_FETCH_HOSTS';
exports.FAIL_FETCH_HOSTS = FAIL_FETCH_HOSTS;
const COLLECT_HOST_DIAGNOSTICS = 'COLLECT_HOST_DIAGNOSTICS';
exports.COLLECT_HOST_DIAGNOSTICS = COLLECT_HOST_DIAGNOSTICS;
const COMPLETE_COLLECT_HOST_DIAGNOSTICS = 'COMPLETE_COLLECT_HOST_DIAGNOSTICS';
exports.COMPLETE_COLLECT_HOST_DIAGNOSTICS = COMPLETE_COLLECT_HOST_DIAGNOSTICS;
const FAIL_COLLECT_HOST_DIAGNOSTICS = 'FAIL_COLLECT_HOST_DIAGNOSTICS';
exports.FAIL_COLLECT_HOST_DIAGNOSTICS = FAIL_COLLECT_HOST_DIAGNOSTICS;
const SET_HOST_DEBUG_MODE = 'SET_HOST_DEBUG_MODE';
exports.SET_HOST_DEBUG_MODE = SET_HOST_DEBUG_MODE;
const COMPLETE_SET_HOST_DEBUG_MODE = 'COMPLETE_SET_HOST_DEBUG_MODE';
exports.COMPLETE_SET_HOST_DEBUG_MODE = COMPLETE_SET_HOST_DEBUG_MODE;
const FAIL_SET_HOST_DEBUG_MODE = 'FAIL_SET_HOST_DEBUG_MODE';
exports.FAIL_SET_HOST_DEBUG_MODE = FAIL_SET_HOST_DEBUG_MODE;
const DROP_HOSTS_VIEW = 'DROP_HOSTS_VIEW';
exports.DROP_HOSTS_VIEW = DROP_HOSTS_VIEW;
const FETCH_HOST_OBJECTS = 'FETCH_HOST_OBJECTS';
exports.FETCH_HOST_OBJECTS = FETCH_HOST_OBJECTS;
const COMPLETE_FETCH_HOST_OBJECTS = 'COMPLETE_FETCH_HOST_OBJECTS';
exports.COMPLETE_FETCH_HOST_OBJECTS = COMPLETE_FETCH_HOST_OBJECTS;
const FAIL_FETCH_HOST_OBJECTS = 'FAIL_FETCH_HOST_OBJECTS';
exports.FAIL_FETCH_HOST_OBJECTS = FAIL_FETCH_HOST_OBJECTS;
const RETRUST_HOST = 'RETRUST_HOST';
exports.RETRUST_HOST = RETRUST_HOST;
const COMPLETE_RETRUST_HOST = 'COMPLETE_RETRUST_HOST';
exports.COMPLETE_RETRUST_HOST = COMPLETE_RETRUST_HOST;
const FAIL_RETRUST_HOST = 'FAIL_RETRUST_HOST';
exports.FAIL_RETRUST_HOST = FAIL_RETRUST_HOST;
const REMOVE_HOST = 'REMOVE_HOST'; // Cloud related actions.

exports.REMOVE_HOST = REMOVE_HOST;
const FETCH_CLOUD_TARGETS = 'FETCH_CLOUD_TARGETS';
exports.FETCH_CLOUD_TARGETS = FETCH_CLOUD_TARGETS;
const COMPLETE_FETCH_CLOUD_TARGETS = 'COMPLETE_FETCH_CLOUD_TARGETS';
exports.COMPLETE_FETCH_CLOUD_TARGETS = COMPLETE_FETCH_CLOUD_TARGETS;
const FAIL_FETCH_CLOUD_TARGETS = 'FAIL_FETCH_CLOUD_TARGETS';
exports.FAIL_FETCH_CLOUD_TARGETS = FAIL_FETCH_CLOUD_TARGETS;
const DROP_CLOUD_TARGETS = 'DROP_CLOUD_TARGETS';
exports.DROP_CLOUD_TARGETS = DROP_CLOUD_TARGETS;
const CREATE_CLOUD_RESOURCE = 'CREATE_CLOUD_RESOURCE';
exports.CREATE_CLOUD_RESOURCE = CREATE_CLOUD_RESOURCE;
const COMPLETE_CREATE_CLOUD_RESOURCE = 'COMPLETE_CREATE_CLOUD_RESOURCE';
exports.COMPLETE_CREATE_CLOUD_RESOURCE = COMPLETE_CREATE_CLOUD_RESOURCE;
const FAIL_CREATE_CLOUD_RESOURCE = 'FAIL_CREATE_CLOUD_RESOURCE'; // Lambda related actions

exports.FAIL_CREATE_CLOUD_RESOURCE = FAIL_CREATE_CLOUD_RESOURCE;
const CREATE_LAMBDA_FUNC = 'CREATE_LAMBDA_FUNC';
exports.CREATE_LAMBDA_FUNC = CREATE_LAMBDA_FUNC;
const COMPLETE_CREATE_LAMBDA_FUNC = 'COMPLETE_CREATE_LAMBDA_FUNC';
exports.COMPLETE_CREATE_LAMBDA_FUNC = COMPLETE_CREATE_LAMBDA_FUNC;
const FAIL_CREATE_LAMBDA_FUNC = 'FAIL_CREATE_LAMBDA_FUNC';
exports.FAIL_CREATE_LAMBDA_FUNC = FAIL_CREATE_LAMBDA_FUNC;
const DELETE_LAMBDA_FUNC = 'DELETE_LAMBDA_FUNC';
exports.DELETE_LAMBDA_FUNC = DELETE_LAMBDA_FUNC;
const COMPLETE_DELETE_LAMBDA_FUNC = 'COMPLETE_DELETE_LAMBDA_FUNC';
exports.COMPLETE_DELETE_LAMBDA_FUNC = COMPLETE_DELETE_LAMBDA_FUNC;
const FAIL_DELETE_LAMBDA_FUNC = 'FAIL_DELETE_LAMBDA_FUNC';
exports.FAIL_DELETE_LAMBDA_FUNC = FAIL_DELETE_LAMBDA_FUNC;
const UPDATE_LAMBDA_FUNC_CONFIG = 'UPDATE_LAMBDA_FUNC_CONFIG';
exports.UPDATE_LAMBDA_FUNC_CONFIG = UPDATE_LAMBDA_FUNC_CONFIG;
const COMPLETE_UPDATE_LAMBDA_FUNC_CONFIG = 'COMPLETE_UPDATE_LAMBDA_FUNC_CONFIG';
exports.COMPLETE_UPDATE_LAMBDA_FUNC_CONFIG = COMPLETE_UPDATE_LAMBDA_FUNC_CONFIG;
const FAIL_UPDATE_LAMBDA_FUNC_CONFIG = 'FAIL_UPDATE_LAMBDA_FUNC_CONFIG';
exports.FAIL_UPDATE_LAMBDA_FUNC_CONFIG = FAIL_UPDATE_LAMBDA_FUNC_CONFIG;
const UPDATE_LAMBDA_FUNC_CODE = 'UPDATE_LAMBDA_FUNC_CODE';
exports.UPDATE_LAMBDA_FUNC_CODE = UPDATE_LAMBDA_FUNC_CODE;
const COMPLETE_UPDATE_LAMBDA_FUNC_CODE = 'COMPLETE_UPDATE_LAMBDA_FUNC_CODE';
exports.COMPLETE_UPDATE_LAMBDA_FUNC_CODE = COMPLETE_UPDATE_LAMBDA_FUNC_CODE;
const FAIL_UPDATE_LAMBDA_FUNC_CODE = 'FAIL_UPDATE_LAMBDA_FUNC_CODE';
exports.FAIL_UPDATE_LAMBDA_FUNC_CODE = FAIL_UPDATE_LAMBDA_FUNC_CODE;
const LOAD_LAMBDA_FUNC_CODE = 'LOAD_LAMBDA_FUNC_CODE';
exports.LOAD_LAMBDA_FUNC_CODE = LOAD_LAMBDA_FUNC_CODE;
const COMPLETE_LOAD_LAMBDA_FUNC_CODE = 'COMPLETE_LOAD_LAMBDA_FUNC_CODE';
exports.COMPLETE_LOAD_LAMBDA_FUNC_CODE = COMPLETE_LOAD_LAMBDA_FUNC_CODE;
const FAIL_LOAD_LAMBDA_FUNC_CODE = 'FAIL_LOAD_LAMBDA_FUNC_CODE';
exports.FAIL_LOAD_LAMBDA_FUNC_CODE = FAIL_LOAD_LAMBDA_FUNC_CODE;
const DROP_LAMBDA_FUNC_CODE = 'DROP_LAMBDA_FUNC_CODE';
exports.DROP_LAMBDA_FUNC_CODE = DROP_LAMBDA_FUNC_CODE;
const INVOKE_LAMBDA_FUNC = 'INVOKE_LAMBDA_FUNC';
exports.INVOKE_LAMBDA_FUNC = INVOKE_LAMBDA_FUNC;
const COMPLETE_INVOKE_LAMBDA_FUNC = 'COMPLETE_INVOKE_LAMBDA_FUNC';
exports.COMPLETE_INVOKE_LAMBDA_FUNC = COMPLETE_INVOKE_LAMBDA_FUNC;
const FAIL_INVOKE_LAMBDA_FUNC = 'FAIL_INVOKE_LAMBDA_FUNC'; // Endpoint related actions

exports.FAIL_INVOKE_LAMBDA_FUNC = FAIL_INVOKE_LAMBDA_FUNC;
const GENERATE_ENDPOINT_GROUP_DEPLOYMENT_YAML = 'GENERATE_ENDPOINT_GROUP_DEPLOYMENT_YAML';
exports.GENERATE_ENDPOINT_GROUP_DEPLOYMENT_YAML = GENERATE_ENDPOINT_GROUP_DEPLOYMENT_YAML;
const COMPLETE_GENERATE_ENDPOINT_GROUP_DEPLOYMENT_YAML = 'COMPLETE_GENERATE_ENDPOINT_GROUP_DEPLOYMENT_YAML';
exports.COMPLETE_GENERATE_ENDPOINT_GROUP_DEPLOYMENT_YAML = COMPLETE_GENERATE_ENDPOINT_GROUP_DEPLOYMENT_YAML;
const FAIL_GENERATE_ENDPOINT_GROUP_DEPLOYMENT_YAML = 'FAIL_GENERATE_ENDPOINT_GROUP_DEPLOYMENT_YAML';
exports.FAIL_GENERATE_ENDPOINT_GROUP_DEPLOYMENT_YAML = FAIL_GENERATE_ENDPOINT_GROUP_DEPLOYMENT_YAML;
const UPDATE_ENDPOINT_GROUP = 'UPDATE_ENDPOINT_GROUP';
exports.UPDATE_ENDPOINT_GROUP = UPDATE_ENDPOINT_GROUP;
const COMPLETE_UPDATE_ENDPOINT_GROUP = 'COMPLETE_UPDATE_ENDPOINT_GROUP';
exports.COMPLETE_UPDATE_ENDPOINT_GROUP = COMPLETE_UPDATE_ENDPOINT_GROUP;
const FAIL_UPDATE_ENDPOINT_GROUP = 'FAIL_UPDATE_ENDPOINT_GROUP';
exports.FAIL_UPDATE_ENDPOINT_GROUP = FAIL_UPDATE_ENDPOINT_GROUP;
const FETCH_ENDPOINTS_HISTORY = 'FETCH_ENDPOINTS_HISTORY';
exports.FETCH_ENDPOINTS_HISTORY = FETCH_ENDPOINTS_HISTORY;
const COMPLETE_FETCH_ENDPOINTS_HISTORY = 'COMPLETE_FETCH_ENDPOINTS_HISTORY';
exports.COMPLETE_FETCH_ENDPOINTS_HISTORY = COMPLETE_FETCH_ENDPOINTS_HISTORY;
const FAIL_FETCH_ENDPOINTS_HISTORY = 'FAIL_FETCH_ENDPOINTS_HISTORY';
exports.FAIL_FETCH_ENDPOINTS_HISTORY = FAIL_FETCH_ENDPOINTS_HISTORY;
const DROP_ENDPOINTS_HISTORY = 'DROP_ENDPOINTS_HISTORY'; // Environment actions.

exports.DROP_ENDPOINTS_HISTORY = DROP_ENDPOINTS_HISTORY;
const TOGGLE_PREVIEW_CONTENT = 'TOGGLE_PREVIEW_CONTENT';
exports.TOGGLE_PREVIEW_CONTENT = TOGGLE_PREVIEW_CONTENT;
const SETUP_ENV = 'SETUP_ENV';
exports.SETUP_ENV = SETUP_ENV;
const DISSMISS_BROWSER_STICKY = 'DISSMISS_BROWSER_STICKY'; // Analytics related actions.

exports.DISSMISS_BROWSER_STICKY = DISSMISS_BROWSER_STICKY;
const FETCH_BUCKET_USAGE_HISTORY = 'FETCH_BUCKET_USAGE_HISTORY';
exports.FETCH_BUCKET_USAGE_HISTORY = FETCH_BUCKET_USAGE_HISTORY;
const COMPLETE_FETCH_BUCKET_USAGE_HISTORY = 'COMPLETE_FETCH_BUCKET_USAGE_HISTORY';
exports.COMPLETE_FETCH_BUCKET_USAGE_HISTORY = COMPLETE_FETCH_BUCKET_USAGE_HISTORY;
const FAIL_FETCH_BUCKET_USAGE_HISTORY = 'FAIL_FETCH_BUCKET_USAGE_HISTORY';
exports.FAIL_FETCH_BUCKET_USAGE_HISTORY = FAIL_FETCH_BUCKET_USAGE_HISTORY;
const DROP_BUCKET_USAGE_HISTORY = 'DROP_BUCKET_USAGE_HISTORY';
exports.DROP_BUCKET_USAGE_HISTORY = DROP_BUCKET_USAGE_HISTORY;
const FETCH_ACCOUNT_USAGE_HISTORY = 'FETCH_ACCOUNT_USAGE_HISTORY';
exports.FETCH_ACCOUNT_USAGE_HISTORY = FETCH_ACCOUNT_USAGE_HISTORY;
const COMPLETE_FETCH_ACCOUNT_USAGE_HISTORY = 'COMPLETE_FETCH_ACCOUNT_USAGE_HISTORY';
exports.COMPLETE_FETCH_ACCOUNT_USAGE_HISTORY = COMPLETE_FETCH_ACCOUNT_USAGE_HISTORY;
const FAIL_FETCH_ACCOUNT_USAGE_HISTORY = 'FAIL_FETCH_ACCOUNT_USAGE_HISTORY';
exports.FAIL_FETCH_ACCOUNT_USAGE_HISTORY = FAIL_FETCH_ACCOUNT_USAGE_HISTORY;
const DROP_ACCOUNT_USAGE_HISTORY = 'DROP_ACCOUNT_USAGE_HISTORY';
exports.DROP_ACCOUNT_USAGE_HISTORY = DROP_ACCOUNT_USAGE_HISTORY;
const FETCH_OBJECTS_DISTRIBUTION = 'FETCH_OBJECTS_DISTRIBUTION';
exports.FETCH_OBJECTS_DISTRIBUTION = FETCH_OBJECTS_DISTRIBUTION;
const COMPLETE_FETCH_OBJECTS_DISTRIBUTION = 'COMPLETE_FETCH_OBJECTS_DISTRIBUTION';
exports.COMPLETE_FETCH_OBJECTS_DISTRIBUTION = COMPLETE_FETCH_OBJECTS_DISTRIBUTION;
const FAIL_FETCH_OBJECTS_DISTRIBUTION = 'FAIL_FETCH_OBJECTS_DISTRIBUTION';
exports.FAIL_FETCH_OBJECTS_DISTRIBUTION = FAIL_FETCH_OBJECTS_DISTRIBUTION;
const DROP_FETCH_OBJECTS_DISTRIBUTION = 'DROP_FETCH_OBJECTS_DISTRIBUTION';
exports.DROP_FETCH_OBJECTS_DISTRIBUTION = DROP_FETCH_OBJECTS_DISTRIBUTION;
const FETCH_CLOUD_USAGE_STATS = 'FETCH_CLOUD_USAGE_STATS';
exports.FETCH_CLOUD_USAGE_STATS = FETCH_CLOUD_USAGE_STATS;
const COMPLETE_FETCH_CLOUD_USAGE_STATS = 'COMPLETE_FETCH_CLOUD_USAGE_STATS';
exports.COMPLETE_FETCH_CLOUD_USAGE_STATS = COMPLETE_FETCH_CLOUD_USAGE_STATS;
const FAIL_FETCH_CLOUD_USAGE_STATS = 'FAIL_FETCH_CLOUD_USAGE_STATS';
exports.FAIL_FETCH_CLOUD_USAGE_STATS = FAIL_FETCH_CLOUD_USAGE_STATS;
const DROP_CLOUD_USAGE_STATS = 'DROP_CLOUD_USAGE_STATS';
exports.DROP_CLOUD_USAGE_STATS = DROP_CLOUD_USAGE_STATS;
const FETCH_LAMBDA_FUNC_USAGE_HISTORY = 'FETCH_LAMBDA_FUNC_USAGE_HISTORY';
exports.FETCH_LAMBDA_FUNC_USAGE_HISTORY = FETCH_LAMBDA_FUNC_USAGE_HISTORY;
const COMPLETE_FETCH_LAMBDA_FUNC_USAGE_HISTORY = 'COMPLETE_FETCH_LAMBDA_FUNC_USAGE_HISTORY';
exports.COMPLETE_FETCH_LAMBDA_FUNC_USAGE_HISTORY = COMPLETE_FETCH_LAMBDA_FUNC_USAGE_HISTORY;
const FAIL_FETCH_LAMBDA_FUNC_USAGE_HISTORY = 'FAIL_FETCH_LAMBDA_FUNC_USAGE_HISTORY';
exports.FAIL_FETCH_LAMBDA_FUNC_USAGE_HISTORY = FAIL_FETCH_LAMBDA_FUNC_USAGE_HISTORY;
const DROP_LAMBDA_FUNC_USAGE_HISTORY = 'DROP_LAMBDA_FUNC_USAGE_HISTORY'; // Support actions.

exports.DROP_LAMBDA_FUNC_USAGE_HISTORY = DROP_LAMBDA_FUNC_USAGE_HISTORY;
const DUMP_APP_LOG = 'DUMP_APP_LOG';
exports.DUMP_APP_LOG = DUMP_APP_LOG;

},{}],319:[function(require,module,exports){
(function (global){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var model = _interopRequireWildcard(require("model"));

var routes = _interopRequireWildcard(require("routes"));

var _actions = require("actions");

var _services = require("services");

var _page = _interopRequireDefault(require("page"));

var _coreUtils = require("utils/core-utils");

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
// ----------------------------------------------------------------------
// TODO: Bridge between old and new architectures. will be removed after
// appropriate sections are moved to the new architecture.
// ----------------------------------------------------------------------
const endpoint = global.location.hostname;

function onCompleteFetchSystemInfo(payload) {
  model.systemInfo({ ...payload,
    endpoint
  });
}

function onCompleteSignIn(payload) {
  model.sessionInfo(payload);
  model.loginInfo({
    retryCount: 0
  });
}

function onFailSignIn({
  error
}) {
  if (error.rpc_code === 'UNAUTHORIZED') {
    model.loginInfo({
      unauthorized: error.message,
      retryCount: model.loginInfo().retryCount + 1
    });
  } else {
    throw error;
  }
}

function onCompleteRestoreSession(payload) {
  model.sessionInfo(payload);

  _page.default.start({
    decodeURLComponents: false
  });
}

function onFailRestoreSession({
  error
}) {
  if (error.rpc_code === 'UNAUTHORIZED') {
    if (_services.api.options.auth_token) {
      _services.api.options.auth_token = undefined;
    }

    model.sessionInfo(null);

    _page.default.start({
      decodeURLComponents: false
    });
  } else {
    throw error;
  }
}

function onSignOut() {
  _services.api.options.auth_token = undefined;
  model.sessionInfo(null);
}

function onCompleteCreateSystem(payload) {
  const {
    token,
    system
  } = payload;
  _services.api.options.auth_token = token;
  model.sessionInfo(payload);
  (0, _actions.redirectTo)(routes.system, {
    system
  }, {
    welcome: true
  });
}

function onChangeLocation(payload) {
  model.routeContext(payload);
}

function onChangeAccountPassword() {
  model.resetPasswordState('IN_PROGRESS');
}

function onCompleteChangeAccountPassword() {
  model.resetPasswordState('SUCCESS');
}

function onFailChangeAccountPassword({
  error
}) {
  model.resetPasswordState(error.rpc_code === 'UNAUTHORIZED' ? 'UNAUTHORIZED' : 'ERROR');
}

const actionHandlers = (0, _coreUtils.deepFreeze)({
  [_actionTypes.COMPLETE_FETCH_SYSTEM_INFO]: onCompleteFetchSystemInfo,
  [_actionTypes.COMPLETE_SIGN_IN]: onCompleteSignIn,
  [_actionTypes.FAIL_SIGN_IN]: onFailSignIn,
  [_actionTypes.COMPLETE_RESTORE_SESSION]: onCompleteRestoreSession,
  [_actionTypes.FAIL_RESTORE_SESSION]: onFailRestoreSession,
  [_actionTypes.SIGN_OUT]: onSignOut,
  [_actionTypes.COMPLETE_CREATE_SYSTEM]: onCompleteCreateSystem,
  [_actionTypes.CHANGE_LOCATION]: onChangeLocation,
  [_actionTypes.CHANGE_ACCOUNT_PASSWORD]: onChangeAccountPassword,
  [_actionTypes.COMPLETE_CHANGE_ACCOUNT_PASSWORD]: onCompleteChangeAccountPassword,
  [_actionTypes.FAIL_CHANGE_ACCOUNT_PASSWORD]: onFailChangeAccountPassword
});

function _default(action$) {
  action$.subscribe(action => {
    const {
      type,
      payload
    } = action;
    const handler = actionHandlers[type];
    if (handler) handler(payload);
  });
}

}).call(this,typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})

},{"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-types":318,"actions":320,"model":936,"page":"page","routes":972,"services":1013,"utils/core-utils":1027}],320:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.redirectTo = redirectTo;
exports.loadServerInfo = loadServerInfo;
exports.testNode = testNode;
exports.abortNodeTest = abortNodeTest;
exports.downloadServerDiagnosticPack = downloadServerDiagnosticPack;
exports.setServerDebugLevel = setServerDebugLevel;
exports.notify = notify;
exports.registerForAlerts = registerForAlerts;

var model = _interopRequireWildcard(require("model"));

var _services = require("services");

var _config = _interopRequireDefault(require("config"));

var _coreUtils = require("utils/core-utils");

var _promiseUtils = require("utils/promise-utils");

var _browserUtils = require("utils/browser-utils");

var _state = require("state");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
// Action dispathers from refactored code.
// Use preconfigured hostname or the addrcess of the serving computer.
const endpoint = window.location.hostname; // -----------------------------------------------------
// Utility function to log actions.
// -----------------------------------------------------

const prefix = 'ACTION DISPATHCED';

function logAction(action, payload) {
  if (typeof payload !== 'undefined') {
    console.info(`${prefix} ${action} with`, payload);
  } else {
    console.info(`${prefix} ${action}`);
  }
} // -----------------------------------------------------
// Navigation actions
// -----------------------------------------------------


function redirectTo(route = model.routeContext().pathname, params = {}, query = {}) {
  logAction('redirectTo', {
    route,
    params,
    query
  });
  const uri = (0, _browserUtils.realizeUri)(route, Object.assign({}, model.routeContext().params, params), query);

  _state.action$.next((0, _actionCreators.requestLocation)(uri, true));
} // -----------------------------------------------------
// Information retrieval actions.
// -----------------------------------------------------


async function loadServerInfo(testPhonehomeConnectvity) {
  logAction('loadServerInfo', {
    testPhonehomeConnectvity
  });
  const {
    serverInfo
  } = model;
  serverInfo(null);
  const {
    has_accounts
  } = await _services.api.account.accounts_status();

  if (has_accounts) {
    try {
      const res = await fetch('/oauth/authorize', {
        method: 'HEAD',
        redirect: 'manual'
      });
      serverInfo({
        initialized: true,
        supportOAuth: res.type === 'opaqueredirect' && res.status === 0
      });
    } catch (err) {
      serverInfo({
        initialized: true,
        supportOAuth: false
      });
    }
  } else {
    const config = await _services.api.cluster_server.read_server_config({
      test_ph_connectivity: testPhonehomeConnectvity
    });
    serverInfo({
      initialized: false,
      address: endpoint,
      config: config
    });
  }
} // -----------------------------------------------------
// Managment actions.
// -----------------------------------------------------


function testNode(source, testSet) {
  logAction('testNode', {
    source,
    testSet
  });
  const regexp = /=>(\w{3}):\/\/\[?([.:0-9a-fA-F]+)\]?:(\d+)$/;
  const {
    nodeTestInfo
  } = model;
  nodeTestInfo({
    source: source,
    tests: testSet,
    timestamp: Date.now(),
    results: [],
    state: 'IN_PROGRESS'
  });
  const {
    targetCount,
    testSettings
  } = _config.default.nodeTest;

  _services.api.node.get_test_nodes({
    count: targetCount,
    source: source
  }).then( // Aggregate selected tests.
  targets => [].concat(...testSet.map(testType => targets.map(({
    name,
    rpc_address
  }) => {
    const result = {
      testType: testType,
      targetName: name,
      targetAddress: rpc_address,
      targetIp: '',
      targetPort: '',
      protocol: '',
      state: 'WAITING',
      time: 0,
      position: 0,
      speed: 0,
      progress: 0
    };
    nodeTestInfo().results.push(result);
    return {
      testType: testType,
      source: source,
      target: rpc_address,
      result: result
    };
  })))).then( // Execute the tests in order.
  tests => (0, _promiseUtils.execInOrder)(tests, ({
    source,
    target,
    testType,
    result
  }) => {
    if (nodeTestInfo().state === 'ABORTING') {
      result.state = 'ABORTED';
      nodeTestInfo.valueHasMutated();
      return;
    }

    const {
      stepCount,
      requestLength,
      responseLength,
      count,
      concur
    } = testSettings[testType];
    const stepSize = count * (requestLength + responseLength);
    const totalTestSize = stepSize * stepCount; // Create a step list for the test.

    const steps = (0, _coreUtils.makeArray)(stepCount, {
      source: source,
      target: target,
      request_length: requestLength,
      response_length: responseLength,
      count: count,
      concur: concur
    }); // Set start time.

    const start = Date.now();
    result.state = 'RUNNING'; // Execute the steps in order.

    return (0, _promiseUtils.execInOrder)(steps, stepRequest => {
      if (nodeTestInfo().state === 'ABORTING') {
        return true;
      }

      return _services.api.node.test_node_network(stepRequest).then(({
        session
      }) => {
        const [, protocol, ip, port] = session.match(regexp);
        result.protocol = protocol;
        result.targetIp = ip.replace('::ffff:', '');
        result.targetPort = port;
        result.time = Date.now() - start;
        result.position = result.position + stepSize;
        result.speed = result.position / result.time;
        result.progress = totalTestSize > 0 ? result.position / totalTestSize : 1; // Notify subscribers on the change.

        nodeTestInfo.valueHasMutated();
      });
    }).then(res => res === true ? 'ABORTED' : 'COMPLETED', () => 'FAILED').then(state => {
      // Notify subscribers on the change.
      result.state = state;
      nodeTestInfo.valueHasMutated();
    });
  })).then(() => {
    if (nodeTestInfo().state === 'ABORTING') {
      nodeTestInfo(null);
    } else {
      nodeTestInfo.assign({
        state: 'COMPLETED'
      });
    }
  }).done();
}

function abortNodeTest() {
  logAction('abortNodeTest');
  const nodeTestInfo = model.nodeTestInfo;

  if (nodeTestInfo().state === 'IN_PROGRESS') {
    nodeTestInfo.assign({
      state: 'ABORTING'
    });
  }
}

function downloadServerDiagnosticPack(secret, hostname) {
  logAction('downloadServerDiagnosticPack', {
    secret,
    hostname
  });
  const name = `${hostname}-${secret}`;
  const key = `server:${secret}`;

  if (model.collectDiagnosticsState[key]) {
    return;
  }

  model.collectDiagnosticsState.assign({
    [key]: true
  });

  _services.api.cluster_server.diagnose_system({
    target_secret: secret
  }).catch(err => {
    notify(`Packing server diagnostic file for ${name} failed`, 'error');
    model.collectDiagnosticsState.assign({
      [key]: false
    });
    throw err;
  }).then(url => {
    (0, _browserUtils.downloadFile)(url);
    model.collectDiagnosticsState.assign({
      [key]: false
    });
  }).done();
}

function setServerDebugLevel(secret, hostname, level) {
  logAction('setServerDebugLevel', {
    secret,
    hostname,
    level
  });
  const name = `${hostname}-${secret}`;

  _services.api.cluster_server.set_debug_level({
    target_secret: secret,
    level: level
  }).then(() => notify(`Debug mode was turned ${level === 0 ? 'off' : 'on'} for server ${name}`, 'success'), () => notify(`Could not turn ${level === 0 ? 'off' : 'on'} debug mode for server ${name}`, 'error')).then(() => _state.action$.next((0, _actionCreators.fetchSystemInfo)())).done();
}

function notify(message, severity = 'info') {
  _state.action$.next((0, _actionCreators.showNotification)(message, severity));
}

function registerForAlerts() {
  logAction('registerForAlerts');

  _services.api.redirector.register_for_alerts();
}

},{"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"config":831,"model":936,"services":1013,"state":1016,"utils/browser-utils":1021,"utils/core-utils":1027,"utils/promise-utils":1039}],321:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

/* Copyright (C) 2016 NooBaa */
function _bubbleEvent(event) {
  if (event.bubbles) return;
  const EventType = event.constructor;
  const bublingEvent = new EventType(event.type, { ...event,
    bubbles: true
  });
  event.target.dispatchEvent(bublingEvent);
}

var _default = {
  init: function (element, valueAccessor) {
    const events = (0, _coreUtils.ensureArray)(_knockout.default.unwrap(valueAccessor())).map(val => val.toString());

    for (const event of events) {
      _knockout.default.utils.registerEventHandler(element, event, _bubbleEvent);
    }
  }
};
exports.default = _default;

},{"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","utils/core-utils":1027}],322:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

/* Copyright (C) 2016 NooBaa */
const domDataKey = 'canvasBackBuffer';
var _default = {
  init: function (canvas) {
    const backbuffer = document.createElement('canvas');
    backbuffer.width = canvas.width;
    backbuffer.height = canvas.height;

    _knockout.default.utils.domData.set(canvas, domDataKey, backbuffer);
  },
  update: function (canvas, valueAccessor, allBindings, viewModel) {
    if (canvas.tagName.toUpperCase() !== 'CANVAS') {
      throw new Error('Invalid binding target');
    }

    const backbuffer = _knockout.default.utils.domData.get(canvas, domDataKey);

    const rect = canvas.getBoundingClientRect();

    const {
      draw = _coreUtils.noop,
      width = rect.width | 0,
      height = rect.height | 0
    } = _knockout.default.deepUnwrap(valueAccessor());

    backbuffer.width = width;
    backbuffer.height = height;
    draw.call(viewModel, backbuffer.getContext('2d'), {
      width,
      height
    });
    requestAnimationFrame(() => {
      const {
        width,
        height
      } = backbuffer;
      canvas.width = width;
      canvas.height = height;

      if (width > 0 && height > 0) {
        canvas.getContext('2d').drawImage(backbuffer, 0, 0);
      }
    });
  }
};
exports.default = _default;

},{"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","utils/core-utils":1027}],323:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
var _default = {
  init: function (element, valueAccessor, allBindings, viewModel) {
    const handlers = valueAccessor() || {};

    for (const [event, handler] of Object.entries(handlers)) {
      const boundHandler = evt => handler.call(viewModel, viewModel, evt);

      _knockout.default.utils.registerEventHandler(element, event, boundHandler);
    }
  }
};
exports.default = _default;

},{"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout"}],324:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
var _default = {
  init(element, valueAccessor, allBindings, viewModel, bindingContext) {
    const classList = element.classList;

    let expanded = _knockout.default.pureComputed(() => _knockout.default.unwrap(valueAccessor()));

    classList.add('expandable');

    if (expanded()) {
      classList.add('expanded');
    } else {
      const {
        style
      } = element;
      style.maxHeight = '0px';
      style.display = 'none';
    }

    let sub = expanded.subscribe(expand => requestAnimationFrame(() => {
      const {
        style
      } = element;

      if (expand) {
        classList.add('expanding');
        style.removeProperty('display');
        style.removeProperty('max-height');
        let height = element.offsetHeight;
        style.maxHeight = '0px';
        requestAnimationFrame(() => {
          style.maxHeight = `${height}px`;
        });
      } else {
        style.maxHeight = `${element.offsetHeight}px`;
        classList.remove('expanding', 'expanded');
        requestAnimationFrame(() => {
          style.maxHeight = '0px';
        });
      }
    }));

    _knockout.default.bindingHandlers.event.init(element, () => ({
      transitionend: () => {
        if (expanded()) {
          classList.add('expanded');
          element.style.removeProperty('max-height');
        } else {
          element.style.display = 'none';
        }
      }
    }), allBindings, viewModel, bindingContext);

    _knockout.default.utils.domNodeDisposal.addDisposeCallback(element, () => sub.dispose());
  }

};
exports.default = _default;

},{"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout"}],325:[function(require,module,exports){
(function (global){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

/* Copyright (C) 2016 NooBaa */
const rootElm = global.document.body;
var _default = {
  init: function (_, ...args) {
    const {
      init = _coreUtils.noop
    } = _knockout.default.bindingHandlers['css'];
    return init(rootElm, ...args);
  },
  update: function (_, ...args) {
    const {
      update = _coreUtils.noop
    } = _knockout.default.bindingHandlers['css'];
    return update(rootElm, ...args);
  }
};
exports.default = _default;

}).call(this,typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})

},{"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","utils/core-utils":1027}],326:[function(require,module,exports){
(function (global){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _coreUtils = require("utils/core-utils");

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
const {
  domData,
  domNodeDisposal
} = _knockout.default.utils;
const domDataKey = 'globalEvent';

function addGlobalListener(event, handler) {
  global.addEventListener(event, handler, false);
}

function removeGlobalListener(event, handler) {
  global.removeEventListener(event, handler, false);
}

var _default = {
  init: function (element) {
    // Cleanup registered handlers.
    domNodeDisposal.addDisposeCallback(element, () => {
      const handlers = domData.get(element, domDataKey) || {};
      Object.keys(handlers).forEach(event => removeGlobalListener(event, handlers[event]));
    });
  },
  update: function (element, valueAccessor, allBindings, viewModel) {
    const handlers = (0, _coreUtils.mapValues)(_knockout.default.unwrap(valueAccessor()) || {}, handler => evt => handler.call(viewModel, viewModel, evt));
    const oldHandlers = domData.get(element, domDataKey) || {}; // Remove old handlers which are not used anymore.

    Object.keys(oldHandlers).filter(event => oldHandlers[event] !== handlers[event]).forEach(event => removeGlobalListener(event, handlers[event])); // Register new handlers.

    Object.keys(handlers).filter(event => handlers[event] !== oldHandlers[event]).forEach(event => addGlobalListener(event, handlers[event])); // Save the new handler map to domData.

    domData.set(element, domDataKey, handlers);
  }
};
exports.default = _default;

}).call(this,typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})

},{"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","utils/core-utils":1027}],327:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
var _default = {
  update: function (element, valueAccessor, allBindings, viewModel, bindingContext) {
    return _knockout.default.bindingHandlers.visible.update(element, () => !_knockout.default.unwrap(valueAccessor()), allBindings, viewModel, bindingContext);
  }
};
exports.default = _default;

},{"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout"}],328:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
var _default = {
  init: function (element, valueAccessor, allBindings, viewModel, bindingContext) {
    let obs = valueAccessor();
    let count = 0;
    obs(false);
    return _knockout.default.bindingHandlers.event.init(element, () => ({
      mouseenter: () => obs(!!++count),
      mouseleave: () => obs(!! --count)
    }), allBindings, viewModel, bindingContext);
  }
};
exports.default = _default;

},{"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout"}],329:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _knockout = _interopRequireDefault(require("knockout"));

var _focusUtils = require("utils/focus-utils");

/* Copyright (C) 2016 NooBaa */
const pageJumpSize = 6;
var _default = {
  init: function (element, valueAccessor) {
    _knockout.default.utils.registerEventHandler(element, 'keydown', evt => {
      // Check if the binding is disabled.
      if (!_knockout.default.unwrap(valueAccessor())) {
        return;
      }

      const {
        code,
        target
      } = evt;
      const isInputWithValue = target.tagName.toLowerCase() === 'input' && target.value;
      let candidate = null;

      switch (code.toLowerCase()) {
        case 'arrowup':
          {
            evt.preventDefault();
            candidate = (0, _focusUtils.findNthPrevFocusableIn)(element, target, 1);
            break;
          }

        case 'arrowdown':
          {
            evt.preventDefault();
            candidate = (0, _focusUtils.findNthNextFocusableIn)(element, target, 1);
            break;
          }

        case 'pageup':
          {
            evt.preventDefault();
            candidate = (0, _focusUtils.findNthPrevFocusableIn)(element, target, pageJumpSize);
            break;
          }

        case 'pagedown':
          {
            evt.preventDefault();
            candidate = (0, _focusUtils.findNthNextFocusableIn)(element, target, pageJumpSize);
            break;
          }

        case 'home':
          {
            // Prevent suppress of end key for dropdown filter
            if (!isInputWithValue) {
              evt.preventDefault();
              candidate = (0, _focusUtils.findFirstFocusableIn)(element);
            }

            break;
          }

        case 'end':
          {
            // Prevent suppress of end key for dropdown filter
            if (!isInputWithValue) {
              evt.preventDefault();
              candidate = (0, _focusUtils.findLastFocusableIn)(element);
            }

            break;
          }
      }

      if (candidate && candidate !== target) {
        candidate.focus();
      }
    });
  }
};
exports.default = _default;

},{"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","utils/focus-utils":1029}],330:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
var _default = {
  init: function (element, valueAccessor) {
    const keys = _knockout.default.pureComputed(() => {
      const keys = _knockout.default.unwrap(valueAccessor());

      if (!Array.isArray(keys)) {
        throw new Error('Invlid value, must be an array of key codes');
      }

      return keys.map(key => key.toString().toLowerCase());
    });

    _knockout.default.utils.registerEventHandler(element, 'keydown', evt => {
      if (!keys().includes(evt.code.toLowerCase())) {
        return;
      }

      evt.preventDefault();
      element.click();
    });
  }
};
exports.default = _default;

},{"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout"}],331:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
var _default = {
  allowOnVirtualElements: true,
  init: function (element, valueAccessor, allBindings, viewModel, bindingContext) {
    // Make a modified binding context, with extra properties, and apply it to descendant elements
    var innerContext = bindingContext.extend(valueAccessor);

    _knockout.default.applyBindingsToDescendants(innerContext, element);

    return {
      controlsDescendantBindings: true
    };
  }
};
exports.default = _default;

},{"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout"}],332:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

/* Copyright (C) 2016 NooBaa */
var _default = {
  init: function (element, valueAccessor) {
    (0, _coreUtils.ensureArray)(_knockout.default.unwrap(valueAccessor())).forEach(eventName => _knockout.default.utils.registerEventHandler(element, eventName, evt => {
      evt.cancelBubble = true;

      if (event.stopPropagation) {
        event.stopPropagation();
      }
    }));
  }
};
exports.default = _default;

},{"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","utils/core-utils":1027}],333:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = register;

var _templateEx = _interopRequireDefault(require("./template-ex"));

var _valueEx = _interopRequireDefault(require("./value-ex"));

var _let2 = _interopRequireDefault(require("./let"));

var _visibility = _interopRequireDefault(require("./visibility"));

var _scroll = _interopRequireDefault(require("./scroll"));

var _canvas = _interopRequireDefault(require("./canvas"));

var _expand = _interopRequireDefault(require("./expand"));

var _tooltip = _interopRequireDefault(require("./tooltip"));

var _scrollTo = _interopRequireDefault(require("./scroll-to"));

var _hover = _interopRequireDefault(require("./hover"));

var _shakeOnClick = _interopRequireDefault(require("./shake-on-click"));

var _childEvent = _interopRequireDefault(require("./child-event"));

var _globalEvent = _interopRequireDefault(require("./global-event"));

var _selection = _interopRequireDefault(require("./selection"));

var _preventBubble = _interopRequireDefault(require("./prevent-bubble"));

var _validationCss = _interopRequireDefault(require("./validation-css"));

var _bubbleEvents = _interopRequireDefault(require("./bubble-events"));

var _trapFocus = _interopRequireDefault(require("./trap-focus"));

var _keysToClicks = _interopRequireDefault(require("./keys-to-clicks"));

var _keyboardNavigation = _interopRequireDefault(require("./keyboard-navigation"));

var _hidden = _interopRequireDefault(require("./hidden"));

var _globalCss = _interopRequireDefault(require("./global-css"));

/* Copyright (C) 2016 NooBaa */

/* Copyright (C) 2016 NooBaa */
// Import extended existing handlers
// Import new handlers
function register(ko) {
  function registerHandler([name, handler]) {
    ko.bindingHandlers[name] = handler;

    if (handler.allowOnVirtualElements) {
      ko.virtualElements.allowedBindings[name] = true;
    }
  } // Register the bindings.


  Object.entries({
    template: _templateEx.default,
    value: _valueEx.default,
    let: _let2.default,
    visibility: _visibility.default,
    scroll: _scroll.default,
    canvas: _canvas.default,
    expand: _expand.default,
    tooltip: _tooltip.default,
    scrollTo: _scrollTo.default,
    hover: _hover.default,
    shakeOnClick: _shakeOnClick.default,
    childEvent: _childEvent.default,
    globalEvent: _globalEvent.default,
    selection: _selection.default,
    preventBubble: _preventBubble.default,
    validationCss: _validationCss.default,
    bubbleEvents: _bubbleEvents.default,
    trapFocus: _trapFocus.default,
    keysToClicks: _keysToClicks.default,
    keyboardNavigation: _keyboardNavigation.default,
    hidden: _hidden.default,
    globalCss: _globalCss.default
  }).forEach(registerHandler);
}

},{"./bubble-events":321,"./canvas":322,"./child-event":323,"./expand":324,"./global-css":325,"./global-event":326,"./hidden":327,"./hover":328,"./keyboard-navigation":329,"./keys-to-clicks":330,"./let":331,"./prevent-bubble":332,"./scroll":335,"./scroll-to":334,"./selection":336,"./shake-on-click":337,"./template-ex":338,"./tooltip":351,"./trap-focus":352,"./validation-css":353,"./value-ex":354,"./visibility":355,"@babel/runtime/helpers/interopRequireDefault":1050}],334:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
function scroll(element, valueAccessor) {
  let i = _knockout.default.unwrap(valueAccessor());

  if (-1 < i && i < element.children.length) {
    let child = element.children[i];
    element.scrollTop = Math.min(child.offsetTop, Math.max(element.scrollTop, child.offsetTop + child.clientHeight - element.clientHeight));
  }
}

var _default = {
  init: scroll,
  update: scroll
};
exports.default = _default;

},{"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout"}],335:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

/* Copyright (C) 2016 NooBaa */
function calcScroll(element) {
  const {
    scrollTop,
    scrollHeight,
    offsetHeight
  } = element;
  const dist = scrollHeight - offsetHeight;
  return dist ? scrollTop / dist : 1;
}

var _default = {
  init: function (element, valueAccessor) {
    let pos = valueAccessor();

    if (!_knockout.default.isWritableObservable(pos)) {
      pos = _knockout.default.pureComputed({
        read: pos,
        write: _coreUtils.noop
      });
    }

    _knockout.default.utils.registerEventHandler(element, 'scroll', () => {
      pos(calcScroll(element));
    });
  },

  update(element, valueAccessor) {
    const value = _knockout.default.unwrap(valueAccessor());

    if (typeof value === 'number') {
      const {
        scrollHeight,
        offsetHeight
      } = element;
      element.scrollTop = (scrollHeight - offsetHeight) * value;
    }
  }

};
exports.default = _default;

},{"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","utils/core-utils":1027}],336:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
var _default = {
  init: function (element, valueAccessor) {
    const selection = valueAccessor();
    ['mouseup', 'keyup'].forEach(eventName => _knockout.default.utils.registerEventHandler(element, eventName, ({
      target
    }) => selection({
      start: target.selectionStart,
      end: target.selectionEnd,
      text: target.value.slice(target.selectionStart, target.selectionEnd)
    })));
  }
};
exports.default = _default;

},{"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout"}],337:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
var _default = {
  init: function (element, valueAccessor) {
    const classList = element.classList;

    _knockout.default.utils.registerEventHandler(element, 'click', () => _knockout.default.unwrap(valueAccessor()) && classList.add('shake'));

    _knockout.default.utils.registerEventHandler(element, 'animationend', evt => evt.animationName === 'shake' && classList.remove('shake'));
  }
};
exports.default = _default;

},{"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout"}],338:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _browserUtils = require("utils/browser-utils");

/* Copyright (C) 2016 NooBaa */
const original = _knockout.default.bindingHandlers.template;
var _default = {
  init: function (element, valueAccessor, allBindings, viewModel, bindingContext) {
    let value = valueAccessor();

    if ((0, _coreUtils.hasOwn)(value, 'html')) {
      value.nodes = (0, _browserUtils.domFromHtml)(_knockout.default.unwrap(value.html));
    }

    if ((0, _coreUtils.hasOwn)(value, 'let')) {
      bindingContext = bindingContext.extend(value['let']);
    }

    return original.init(element, () => value, allBindings, viewModel, bindingContext);
  },
  update: function (element, valueAccessor, allBindings, viewModel, bindingContext) {
    let value = valueAccessor();

    if ((0, _coreUtils.hasOwn)(value, 'html')) {
      value.nodes = (0, _browserUtils.domFromHtml)(_knockout.default.unwrap(value.html));
    }

    if ((0, _coreUtils.hasOwn)(value, 'let')) {
      bindingContext = bindingContext.extend(value['let']);
    }

    return original.update(element, () => value, allBindings, viewModel, bindingContext);
  }
};
exports.default = _default;

},{"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","utils/browser-utils":1021,"utils/core-utils":1027}],339:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<ul class=\"list-no-style column\">\n    <!-- ko foreach: list -->\n    <li class=\"row content-middle highlight push-next-half\">\n        <svg-icon class=\"c1 icon-small push-next-half\"\n            ko.css=\"checked ? 'success' : 'error'\"\n            params=\"name: checked ? 'v' : 'x'\"\n        ></svg-icon>\n        <span class=\"c11\">{{text}}</span>\n    </li>\n    <!-- /ko -->\n</ul>\n";

},{}],340:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<!-- ko if: reason === 'SYSTEM_ENTITY' -->\n<p class=\"highlight\">Cannot delete system defined default {{subject}}</p>\n<!-- /ko -->\n\n<!-- ko if: reason === 'NOT_EMPTY' -->\n<p class=\"highlight\">Cannot delete a {{subject}} which contains nodes</p>\n<!-- /ko -->\n\n<!-- ko if: reason === 'IN_USE' -->\n<p class=\"highlight\">Cannot delete a {{subject}} that is assigned to a bucket policy</p>\n<!-- /ko -->\n\n<!-- ko if: reason === 'IS_BACKINGSTORE' -->\n<p class=\"highlight\">Cannot delete a {{subject}} that was created as a backingstore</p>\n<!-- /ko -->\n\n<!-- ko if: reason === 'CONNECTED_BUCKET_DELETING' -->\n<p class=\"highlight\">Cannot delete a {{subject}} that is assigned to a bucket which is being deleted</p>\n<!-- /ko -->\n\n<!-- ko if: reason === 'DEFAULT_RESOURCE' && accounts.length === 1 -->\n<p class=\"highlight\">\n    Cannot delete. The {{subject}} is used as a default resource by\n    <a class=\"link\" ko.attr.href=\"accounts[0].href\" ko.text=\"accounts[0].name\"></a>\n</p>\n<!-- /ko -->\n\n<!-- ko if: reason === 'DEFAULT_RESOURCE' && accounts.length > 1 -->\n<p class=\"highlight\">\n    Cannot delete. The {{subject}} is used as a default resource by the following accounts:\n    <ul class=\"bullet-list highlight\" ko.foreach=\"accounts\">\n        <li>\n            <a class=\"link\" ko.attr.href=\"href\" ko.text=\"name\"></a>\n        </li>\n    </ul>\n</p>\n<!-- /ko -->\n\n<!-- ko if: reason === 'BEING_DELETED' -->\n<p class=\"highlight\">\n    The {{subject}} is currently being deleted\n</p>\n<!-- /ko -->\n\n<!-- ko if: !reason -->\n<p class=\"highlight\">Delete {{subject}}</p>\n<!-- /ko -->\n";

},{}],341:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "text", {
  enumerable: true,
  get: function () {
    return _text.default;
  }
});
Object.defineProperty(exports, "link", {
  enumerable: true,
  get: function () {
    return _link.default;
  }
});
Object.defineProperty(exports, "list", {
  enumerable: true,
  get: function () {
    return _list.default;
  }
});
Object.defineProperty(exports, "linkList", {
  enumerable: true,
  get: function () {
    return _linkList.default;
  }
});
Object.defineProperty(exports, "listWithCaption", {
  enumerable: true,
  get: function () {
    return _listWithCaption.default;
  }
});
Object.defineProperty(exports, "linkListWithCaption", {
  enumerable: true,
  get: function () {
    return _linkListWithCaption.default;
  }
});
Object.defineProperty(exports, "checkList", {
  enumerable: true,
  get: function () {
    return _checkList.default;
  }
});
Object.defineProperty(exports, "propertySheet", {
  enumerable: true,
  get: function () {
    return _propertySheet.default;
  }
});
Object.defineProperty(exports, "preserveWhitespaces", {
  enumerable: true,
  get: function () {
    return _preserveWhitespaces.default;
  }
});
Object.defineProperty(exports, "textAndLink", {
  enumerable: true,
  get: function () {
    return _textAndLink.default;
  }
});
Object.defineProperty(exports, "deleteResource", {
  enumerable: true,
  get: function () {
    return _deleteResource.default;
  }
});

var _text = _interopRequireDefault(require("./text.html"));

var _link = _interopRequireDefault(require("./link.html"));

var _list = _interopRequireDefault(require("./list.html"));

var _linkList = _interopRequireDefault(require("./link-list.html"));

var _listWithCaption = _interopRequireDefault(require("./list-with-caption.html"));

var _linkListWithCaption = _interopRequireDefault(require("./link-list-with-caption.html"));

var _checkList = _interopRequireDefault(require("./check-list.html"));

var _propertySheet = _interopRequireDefault(require("./property-sheet.html"));

var _preserveWhitespaces = _interopRequireDefault(require("./preserve-whitespaces.html"));

var _textAndLink = _interopRequireDefault(require("./text-and-link.html"));

var _deleteResource = _interopRequireDefault(require("./delete-resource.html"));

},{"./check-list.html":339,"./delete-resource.html":340,"./link-list-with-caption.html":342,"./link-list.html":343,"./link.html":344,"./list-with-caption.html":345,"./list.html":346,"./preserve-whitespaces.html":347,"./property-sheet.html":348,"./text-and-link.html":349,"./text.html":350,"@babel/runtime/helpers/interopRequireDefault":1050}],342:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<p ko.text=\"title\"></p>\n<ul class=\"bullet-list\" ko.foreach=\"list\">\n    <li>\n        <a class=\"link\"\n            ko.attr.href=\"href\"\n            ko.text=\"text\"\n        ></a>\n    </li>\n</ul>\n";

},{}],343:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<!-- ko if: $data.length === 1 -->\n<a class=\"link\"\n    ko.attr.href=\"$data[0].href\"\n    ko.text=\"$data[0].text\"\n></a>\n<!-- /ko -->\n\n<!-- ko if: $data.length > 1 -->\n<ul class=\"bullet-list\" ko.foreach=\"$data\">\n    <li>\n        <a class=\"link\"\n            ko.attr.href=\"href\"\n            ko.text=\"text\"\n        ></a>\n    </li>\n</ul>\n<!-- /ko -->\n";

},{}],344:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<a class=\"link\" ko.attr.href=\"href\" ko.text=\"text\"></a>\n";

},{}],345:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<p ko.text=\"title\"></p>\n<ul class=\"bullet-list\" ko.foreach=\"list\">\n    <li ko.text=\"$data\"></li>\n</ul>\n";

},{}],346:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<!-- ko if: $data.length === 1 -->\n<p ko.text=\"$data\"></p>\n<!-- /ko -->\n\n<!-- ko if: $data.length > 1 -->\n<ul class=\"bullet-list highlight\" ko.foreach=\"$data\">\n    <li ko.text=\"$data\"></li>\n</ul>\n<!-- /ko -->\n";

},{}],347:[function(require,module,exports){
module.exports = "<p class=\"preserve-whitespaces-wrap\">{{$data}}</p>\n";

},{}],348:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<property-sheet class=\"prop-sheet\" params=\"properties: $data\"></property-sheet>\n";

},{}],349:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<p class=\"push-next-half\" ko.text=\"text\"></p>\n\n<!-- ko with: link -->\n<br>\n<a class=\"link push-prev-half\"\n    target=\"_blank\"\n    ko.attr.href=\"href\"\n>\n    {{text}}\n</a>\n<!-- /ko -->\n";

},{}],350:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<p ko.text=\"$data\"></p>\n";

},{}],351:[function(require,module,exports){
(function (global){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _knockout = _interopRequireDefault(require("knockout"));

var _browserUtils = require("utils/browser-utils");

var templates = _interopRequireWildcard(require("./tooltip-templates"));

var _coreUtils = require("utils/core-utils");

/* Copyright (C) 2016 NooBaa */
const hiddenTooltipData = {
  template: null,
  css: '',
  style: {
    display: 'none'
  }
};

function _compareTargets(t1, t2) {
  const {
    element: e1,
    params: p1
  } = t1 || {};
  const {
    element: e2,
    params: p2
  } = t2 || {};
  return e1 === e2 && p1 === p2;
}

const delay = 350;

const hoveringTooltip = _knockout.default.observable();

const currTarget = _knockout.default.observable().extend({
  compareUsing: _compareTargets
});

const vm = _knockout.default.observable(hiddenTooltipData);

currTarget.subscribe(target => {
  if (target) {
    const {
      element,
      params
    } = target;
    const {
      template,
      position,
      align,
      breakWords,
      maxWidth
    } = params;
    const winSize = {
      width: global.innerWidth,
      height: global.innerHeight
    };

    const pos = _calcScreenPosition(position, element.getBoundingClientRect(), winSize);

    const style = {
      display: 'block',
      ...pos,
      maxWidth
    };
    const css = [position, align, breakWords ? 'break-words' : '', style.right !== 'auto' ? 'right-pos' : 'left-pos'].join(' ');
    vm({
      template,
      css,
      style
    });
  } else {
    vm(hiddenTooltipData);
  }
}); // Top level element used with applyBinding cannot support the new binding
// syntax for some reason. Falling back to data-bind syntax.

const tooltipHtml = `
    <div class="tooltip" data-bind="
        style: style,
        css: css,
        with: template
    ">
        <div class="tooltip-box">
            <section class="tooltip-content" ko.template="$data"></section>
        </div>
    </div>
`;
const positions = (0, _coreUtils.deepFreeze)(['above', 'after', 'below', 'before']);
const alignments = (0, _coreUtils.deepFreeze)(['start', 'center', 'end']);

function _getTemplate(template = 'text', data) {
  if (!data) return null;
  const html = templates[template] || template;
  return {
    html,
    data
  };
}

function _toPx(val) {
  return `${Math.ceil(val)}px`;
}

function _normalizeValue(value) {
  const {
    text = value,
    position,
    align,
    breakWords,
    template,
    maxWidth
  } = value || {};
  return {
    template: _getTemplate(template, text),
    position: positions.includes(position) ? position : 'below',
    align: alignments.includes(align) ? align : 'center',
    breakWords: Boolean(breakWords),
    maxWidth: maxWidth && `${maxWidth}px`
  };
}

function _calcScreenPosition(position, boundingRect, winSize) {
  const {
    top,
    right,
    bottom,
    left
  } = boundingRect;
  const centerX = (left + right) / 2;
  const centerY = (top + bottom) / 2;
  const leftSideOfScreen = centerX <= winSize.width / 2;

  switch (position) {
    case 'above':
      {
        if (leftSideOfScreen) {
          return {
            top: _toPx(top),
            right: 'auto',
            bottom: 'auto',
            left: _toPx(centerX)
          };
        } else {
          return {
            top: _toPx(top),
            right: _toPx(winSize.width - centerX),
            bottom: 'auto',
            left: 'auto'
          };
        }
      }

    case 'after':
      {
        return {
          top: _toPx(centerY),
          right: 'auto',
          bottom: 'auto',
          left: _toPx(right)
        };
      }

    case 'below':
      {
        if (leftSideOfScreen) {
          return {
            top: _toPx(bottom),
            right: 'auto',
            bottom: 'auto',
            left: _toPx(centerX)
          };
        } else {
          return {
            top: _toPx(bottom),
            right: _toPx(winSize.width - centerX),
            bottom: 'auto',
            left: 'auto'
          };
        }
      }

    case 'before':
      {
        return {
          top: _toPx(centerY),
          right: 'auto',
          bottom: 'auto',
          left: _toPx(left)
        };
      }
  }
} // Attaching the element to the body in async menner to prevent the element from being mount
// during the main applyBinding (creating a double binding on the element).


(0, _coreUtils.runAsync)(() => {
  const [element] = (0, _browserUtils.domFromHtml)(tooltipHtml.trim()); // Need to throttle only the leave event in order to allow the
  // user a little margin of mistake when with the mouse cursor
  // when working inside the tooltip.

  let handle = -1;

  _knockout.default.utils.registerEventHandler(element, 'mouseenter', () => {
    clearTimeout(handle);
    hoveringTooltip(true);
  });

  _knockout.default.utils.registerEventHandler(element, 'mouseleave', () => {
    handle = setTimeout(() => hoveringTooltip(false), delay);
  });

  document.body.appendChild(element);

  _knockout.default.applyBindings(vm, element);
});
var _default = {
  init: function (element, valueAccessor) {
    const params = _knockout.default.pureComputed(() => _normalizeValue(_knockout.default.deepUnwrap(valueAccessor())));

    const hover = _knockout.default.observable(false);

    const computed = _knockout.default.computed(() => {
      if (hover() && params().template) {
        currTarget({
          element,
          params: params()
        });
      } else if (!hoveringTooltip()) {
        const {
          element: currElement
        } = currTarget.peek() || {};
        if (currElement && currElement === element) currTarget(null);
      }
    }); // Handle element enter/leave events (simulate hover)


    let handle = -1;

    _knockout.default.utils.registerEventHandler(element, 'mouseenter', () => {
      clearTimeout(handle); // Throttle the hover enter event only if the tooltip does not
      // already opened for current element.

      const {
        element: currElement
      } = currTarget.peek() || {};

      if (currElement !== element) {
        handle = setTimeout(() => hover(true), delay);
      } else {
        hover(true);
      }
    });

    _knockout.default.utils.registerEventHandler(element, 'mouseleave', () => {
      // Throttle the leave event to give the user some grace time.
      clearTimeout(handle);
      handle = setTimeout(() => hover(false), delay);
    }); // Cleanup code.


    _knockout.default.utils.domNodeDisposal.addDisposeCallback(element, () => {
      // If tooltip is shown for the element discard it.
      const {
        element: currElement
      } = currTarget.peek() || {};
      if (currElement && currElement === element) currTarget(null);
      computed.dispose();
    });
  }
};
exports.default = _default;

}).call(this,typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})

},{"./tooltip-templates":341,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"knockout":"knockout","utils/browser-utils":1021,"utils/core-utils":1027}],352:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _knockout = _interopRequireDefault(require("knockout"));

var _focusUtils = require("utils/focus-utils");

/* Copyright (C) 2016 NooBaa */
var _default = {
  init: function (element, valueAccessor) {
    _knockout.default.utils.registerEventHandler(element, 'keydown', evt => {
      // Binding is disabled or not a tab press
      if (!_knockout.default.unwrap(valueAccessor()) || (evt.code && evt.code.toLowerCase()) !== 'tab') {
        return;
      }

      evt.preventDefault();
      const {
        target,
        shiftKey
      } = evt;
      const elm = shiftKey ? (0, _focusUtils.findPrevFocusableIn)(element, target, true) : (0, _focusUtils.findNextFocusableIn)(element, target, true); // Check that we didn't do a full cycle before focusing.

      if (elm !== target) {
        elm.focus();
      }
    });
  }
};
exports.default = _default;

},{"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","utils/focus-utils":1029}],353:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
var _default = {
  update: function (element, valueAccessor, allBindings, viewModel, bindingContext) {
    const {
      isValid,
      isInvalid,
      isValidating,
      wasTouched,
      warning
    } = valueAccessor();

    const css = _knockout.default.pureComputed(() => ({
      valid: isValid(),
      validating: isValidating(),
      invalid: wasTouched() && isInvalid(),
      warned: Boolean(warning())
    }));

    return _knockout.default.bindingHandlers.css.update(element, () => css, allBindings, viewModel, bindingContext);
  }
};
exports.default = _default;

},{"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout"}],354:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
const original = _knockout.default.bindingHandlers.value;
var _default = {
  init: function (element, valueAccessor, allBindings, viewModel, bindingContext) {
    const value = valueAccessor(); // Parse numbers (form input[type=number] elements) before setting the target observable.

    if (_knockout.default.isWritableObservable(value) && element.tagName.toUpperCase() === 'INPUT' && element.type === 'number') {
      const castingComputed = _knockout.default.pureComputed({
        read: value,
        write: val => value(Number(val))
      });

      valueAccessor = () => castingComputed;
    }

    return original.init(element, valueAccessor, allBindings, viewModel, bindingContext);
  }
};
exports.default = _default;

},{"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout"}],355:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
var _default = {
  init: function (element, valueAccessor) {
    let value = valueAccessor();

    let visibility = _knockout.default.pureComputed(() => !_knockout.default.unwrap(value) ? 'hidden' : 'visible');

    _knockout.default.applyBindingsToNode(element, {
      style: {
        visibility
      }
    });
  }
};
exports.default = _default;

},{"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout"}],356:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"row pad card-shadow\">\n    <div class=\"greedy\">\n        <input type=\"search\"\n            class=\"push-next\"\n            placeholder=\"Filter by name, key or endpoint\"\n            ko.textInput=\"ko.pc(filter, onFilter)\" />\n    </div>\n    <button class=\"btn\"\n        ko.click=\"onAddConnection\"\n        ko.disable=\"!dataReady()\"\n    >\n        Add Connection\n    </button>\n</div>\n\n<list-details class=\"greedy\"\n    params=\"\n        loading: !dataReady(),\n        rows: rows,\n        selected: ko.pc(selectedConnection, onSelectConnection, $component),\n        idSelector: row => row.name(),\n        emptyMessage: emptyMessage,\n        buttonLabel: ''\n    \"\n>\n    <template name=\"row\">\n        <div class=\"row content-middle no-wrap\">\n            <svg-icon class=\"service-icon push-next-half\"\n                params=\"name: $item.icon\"\n            ></svg-icon>\n            <span class=\"highlight\">{{$item.name}}</span>\n            <vr></vr>\n            {{$item.usage}}\n            <!-- ko if: $item.isSummaryVisible -->\n            <vr></vr>\n            {{$item.targetEndpoint}}\n            <vr></vr>\n            <span class=\"greedy push-next\">\n                {{$item.identity}}\n            </span>\n            <button class=\"icon-btn push-next-half\"\n                ko.preventBubble=\"'click'\"\n                ko.click=\"() => $item.onEdit($item.name())\"\n                ko.tooltip=\"'Edit Connection'\"\n            >\n                <svg-icon params=\"name: 'edit'\">\n                </svg-icon>\n            </button>\n            <delete-button\n                ko.preventBubble=\"'click'\"\n                params=\"\n                    id: $item.deleteBtn.id,\n                    text: $item.deleteBtn.text,\n                    tooltip: $item.deleteBtn.tooltip,\n                    active: $item.deleteBtn.isActive,\n                    disabled: $item.deleteBtn.isDisabled,\n                    onToggle: $item.deleteBtn.onToggle,\n                    onDelete: $item.deleteBtn.onDelete\n                \"\n            ></delete-button>\n            <!-- /ko -->\n        </div>\n    </template>\n\n    <template name=\"details\">\n        <div class=\"column greedy hpad no-overflow\" ko.with=\"details\">\n            <div class=\"row content-middle\">\n                <h2 class=\"heading3 greedy\">\n                    {{connName}} details\n                </h2>\n                <button class=\"icon-btn no-focus-ring\" ko.click=\"onX\">\n                    <svg-icon class=\"icon-small\" params=\"name: 'x'\"></svg-icon>\n                </button>\n            </div>\n            <hr class=\"push-both-half\" />\n            <div class=\"column auto-overflow\">\n                <property-sheet params=\"properties: connInfo\">\n                </property-sheet>\n                <!-- ko foreach: usageList -->\n                <section class=\"column push-both\">\n                    <p class=\"push-next-half\">\n                        Connection is used as {{entityType}}:\n                        <!-- ko if: entityUrl -->\n                        <a class=\"link\" ko.attr.href=\"entityUrl\">\n                            {{entityName}}\n                        </a>\n                        <!-- /ko -->\n                        <!-- ko ifnot: entityUrl -->\n                        <span class=\"highlight\">\n                            {{entityName}}\n                        </span>\n                        <!-- /ko -->\n                    </p>\n                    <property-sheet class=\"pad content-box usage-details\"\n                        params=\"properties: usageDetails\"\n                    >\n                        <template name=\"bucketList\">\n                            <!-- ko if: $data.length-->\n                            <ul class=\"list-no-style row multiline content-middle bucket-list\"\n                                ko.foreach=\"$data\"\n                            >\n                                <li class=\"no-wrap pad tag\">\n                                    <a class=\"link\" ko.attr.href=\"url\">\n                                        {{name}}\n                                    </a>\n                                </li>\n                            </ul>\n                            <!-- /ko -->\n                            <!-- ko ifnot: $data.length -->\n                            None\n                            <!-- /ko -->\n                        </template>\n                    </property-sheet>\n                </section>\n                <!-- /ko -->\n                <!-- ko ifnot: usageList().length -->\n                <p class=\"push-prev\">Connection is not used by any resource</p>\n                <!-- /ko -->\n            </div>\n        </div>\n    </template>\n</list-details>\n<hr>\n<paginator params=\"\n    page: ko.pc(page, onPage, $component),\n    itemCount: connectionCount,\n    pageSize: ko.pc(pageSize, onPageSize, $component)\n\"></paginator>\n";

},{}],357:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _accountConnectionsList = _interopRequireDefault(require("./account-connections-list.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _coreUtils = require("utils/core-utils");

var _stringUtils = require("utils/string-utils");

var _cloudUtils = require("utils/cloud-utils");

var _browserUtils = require("utils/browser-utils");

var _bucketUtils = require("utils/bucket-utils");

var _config = require("config");

var _knockout = _interopRequireDefault(require("knockout"));

var routes = _interopRequireWildcard(require("routes"));

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const cloudServiceByType = (0, _coreUtils.keyByProperty)(_cloudUtils.cloudServices, 'value');

function _mapCloudResourceUsage(usage, bucketList, system, serviceMeta) {
  const buckets = bucketList.filter(bucket => (0, _bucketUtils.flatPlacementPolicy)(bucket).some(record => {
    const {
      type,
      name
    } = record.resource;
    return type === 'CLOUD' && name == usage.entity;
  })).map(bucket => {
    const {
      name
    } = bucket;
    const url = (0, _browserUtils.realizeUri)(routes.bucket, {
      system,
      bucket: name
    });
    return {
      name,
      url
    };
  });
  return {
    entityType: 'cloud resource',
    entityName: usage.entity,
    entityUrl: (0, _browserUtils.realizeUri)(routes.cloudResource, {
      system,
      resource: usage.entity
    }),
    usageDetails: [{
      label: `${serviceMeta.displayName} target ${serviceMeta.subject.toLowerCase()} name`,
      value: usage.externalEntity
    }, {
      value: buckets
    }]
  };
}

function _mapNamespaceResourceUsage(usage, nsBucketList, system, serviceMeta) {
  const buckets = nsBucketList.filter(bucket => {
    const {
      writeTo,
      readFrom
    } = bucket.placement;
    return writeTo === usage.entity || readFrom.includes(usage.entity);
  }).map(bucket => {
    const {
      name
    } = bucket;
    const url = (0, _browserUtils.realizeUri)(routes.namespaceBucket, {
      system,
      bucket: name
    });
    return {
      name,
      url
    };
  });
  return {
    entityType: 'namespace resource',
    entityName: usage.entity,
    entityUrl: '',
    usageDetails: [{
      label: `${serviceMeta.displayName} target ${serviceMeta.subject.toLowerCase()} name`,
      value: usage.externalEntity
    }, {
      value: buckets
    }]
  };
}

function _mapConnectionDetails(connection, bucketList, nsBucketList, system) {
  if (!connection) {
    return;
  }

  const serviceMeta = cloudServiceByType[connection.service];
  return {
    connName: connection.name,
    connInfo: [{
      value: connection.endpoint
    }, {
      label: serviceMeta.identityDisplayName,
      value: connection.identity
    }],
    usageList: connection.usage.map(usage => {
      const {
        usageType
      } = usage;

      if (usageType === 'CLOUD_RESOURCE') {
        return _mapCloudResourceUsage(usage, bucketList, system, serviceMeta);
      }

      if (usageType === 'NAMESPACE_RESOURCE') {
        return _mapNamespaceResourceUsage(usage, nsBucketList, system, serviceMeta);
      }

      throw new Error(`Invalid usage type, got ${usageType}`);
    })
  };
}

function _mapConnectionRow(connection, isSummaryVisible, isSelectedForDelete) {
  const connectionInUse = connection.usage.length > 0;
  return {
    icon: cloudServiceByType[connection.service].icon,
    name: connection.name,
    usage: `Used by ${(0, _stringUtils.stringifyAmount)('resource', connection.usage.length)}`,
    isSummaryVisible,
    targetEndpoint: connection.endpoint,
    identity: connection.identity,
    deleteBtn: {
      id: connection.name,
      tooltip: connectionInUse ? 'Cannot delete currently used connection' : 'Delete Connection',
      isActive: isSelectedForDelete,
      isDisabled: connectionInUse
    }
  };
}

class ConnectionRowViewModel {
  constructor({
    list
  }) {
    (0, _defineProperty2.default)(this, "list", null);
    (0, _defineProperty2.default)(this, "icon", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "name", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "usage", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isSummaryVisible", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "targetEndpoint", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "identity", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "deleteBtn", {
      id: _knockout.default.observable(),
      text: 'Delete Connection',
      tooltip: _knockout.default.observable(),
      isActive: _knockout.default.observable(),
      isDisabled: _knockout.default.observable(),
      onToggle: this.onToggleDelete.bind(this),
      onDelete: this.onDelete.bind(this)
    });
    this.list = list;
  }

  onEdit(connName) {
    this.list.onEditConnection(connName);
  }

  onToggleDelete(connName) {
    this.list.onSelectForDelete(connName);
  }

  onDelete(connName) {
    this.list.onDeleteConnection(connName);
  }

}

class ConnectionDetailsViewModel {
  constructor({
    list
  }) {
    (0, _defineProperty2.default)(this, "list", null);
    (0, _defineProperty2.default)(this, "connName", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "connInfo", [{
      label: 'Endpoint',
      value: _knockout.default.observable()
    }, {
      label: _knockout.default.observable(),
      value: _knockout.default.observable()
    }]);
    (0, _defineProperty2.default)(this, "usageList", _knockout.default.observableArray().ofType(ConnectionUsageViewModel));
    this.list = list;
  }

  onX() {
    this.list.onCloseDetails();
  }

}

class ConnectionUsageViewModel {
  constructor() {
    (0, _defineProperty2.default)(this, "entityType", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "entityName", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "entityUrl", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "targetEntity", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "usageDetails", [{
      label: _knockout.default.observable(),
      value: _knockout.default.observable()
    }, {
      label: 'Used as a resource in the following buckets',
      template: 'bucketList',
      value: _knockout.default.observableArray()
    }]);
  }

}

class AccountConnectionsListViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "accountName", '');
    (0, _defineProperty2.default)(this, "pathname", '');
    (0, _defineProperty2.default)(this, "filter", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "page", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "pageSize", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "selectedForDelete", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "connectionCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "emptyMessage", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "selectedConnection", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "rows", _knockout.default.observableArray().ofType(ConnectionRowViewModel, {
      list: this
    }));
    (0, _defineProperty2.default)(this, "details", _knockout.default.observable().ofType(ConnectionDetailsViewModel, {
      list: this
    }));
    (0, _defineProperty2.default)(this, "onFilter", (0, _coreUtils.throttle)(filter => this._query({
      filter,
      page: 0,
      selectedConnection: '',
      selectedForDelete: ''
    }), _config.inputThrottle));
  }

  selectState(state, params) {
    const {
      accounts,
      buckets,
      namespaceBuckets,
      location
    } = state;
    const {
      externalConnections
    } = accounts ? accounts[params.accountName] : {};
    return [params.accountName, externalConnections, buckets, namespaceBuckets, location];
  }

  mapStateToProps(accountName, connections, buckets, nsBuckets, location) {
    if (!connections || !buckets || !nsBuckets) {
      _knockout.default.assignToProps(this, {
        dataReady: false
      });
    } else {
      const {
        pathname,
        query,
        params
      } = location;
      const {
        filter = '',
        selectedConnection = '',
        selectedForDelete = ''
      } = query;
      const page = Number(query.page) || 0;

      const pageSize = Number(query.pageSize) || _config.paginationPageSize.default;

      const pageStart = page * pageSize;
      const filteredConnections = connections.filter(conn => (0, _stringUtils.includesIgnoreCase)(conn.name, filter) || (0, _stringUtils.includesIgnoreCase)(conn.endpoint, filter) || (0, _stringUtils.includesIgnoreCase)(conn.identity, filter)).slice(pageStart, pageStart + pageSize).sort((0, _coreUtils.createCompareFunc)(conn => conn.service));
      const connectionCount = filteredConnections.length;
      const emptyMessage = connections.length === 0 && 'The account has no external connections' || connectionCount === 0 && 'The current filter does not match any connection' || '';

      _knockout.default.assignToProps(this, {
        dataReady: true,
        accountName,
        pathname,
        selectedConnection,
        filter,
        page,
        pageSize,
        selectedForDelete,
        connectionCount,
        emptyMessage,
        rows: filteredConnections.map(connection => _mapConnectionRow(connection, !selectedConnection, selectedForDelete === connection.name)),
        details: _mapConnectionDetails(filteredConnections.find(connection => connection.name === selectedConnection), Object.values(buckets), Object.values(nsBuckets), params.system)
      });
    }
  }

  onAddConnection() {
    this.dispatch((0, _actionCreators.openAddCloudConnectionModal)());
  }

  onPage(page) {
    this._query({
      page,
      selectedConnection: '',
      selectedForDelete: ''
    });
  }

  onPageSize(pageSize) {
    this._query({
      pageSize,
      page: 0,
      selectedConnection: '',
      selectedForDelete: ''
    });
  }

  onSelectConnection(selectedConnection) {
    this._query({
      selectedConnection,
      selectedForDelete: ''
    });
  }

  onCloseDetails() {
    this._query({
      selectedConnection: ''
    });
  }

  onEditConnection(connName) {
    this.dispatch((0, _actionCreators.openEditCloudConnectionModal)(this.accountName, connName));
  }

  onSelectForDelete(selectedForDelete) {
    this._query({
      selectedForDelete
    });
  }

  onDeleteConnection(connName) {
    this.dispatch((0, _actionCreators.deleteExternalConnection)(connName));
  }

  _query(query) {
    const {
      selectedConnection = this.selectedConnection(),
      filter = this.filter(),
      page = this.page(),
      pageSize = this.pageSize(),
      selectedForDelete = this.selectedForDelete()
    } = query;
    const url = (0, _browserUtils.realizeUri)(this.pathname, null, {
      selectedConnection: selectedConnection !== '' ? selectedConnection : undefined,
      filter: filter !== '' ? filter : undefined,
      page,
      pageSize,
      selectedForDelete: selectedForDelete !== '' ? selectedForDelete : undefined
    });
    this.dispatch((0, _actionCreators.requestLocation)(url));
  }

}

var _default = {
  viewModel: AccountConnectionsListViewModel,
  template: _accountConnectionsList.default
};
exports.default = _default;

},{"./account-connections-list.html":356,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"components/connectable":446,"config":831,"knockout":"knockout","routes":972,"utils/browser-utils":1021,"utils/bucket-utils":1022,"utils/cloud-utils":1024,"utils/core-utils":1027,"utils/string-utils":1046}],358:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"row card-shadow pad content-middle push-next\">\n    <h2 class=\"heading3 greedy push-next\">\n        General Information\n    </h2>\n\n    <button class=\"btn\"\n        ko.visible=\"button.isVisible\"\n        ko.click=\"onChangeOrResetPassword\"\n    >\n        {{button.label}}\n    </button>\n</div>\n\n<property-sheet class=\"pad\" params=\"properties: profileInfo\">\n</property-sheet>\n";

},{}],359:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _accountDetailsForm = _interopRequireDefault(require("./account-details-form.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _accountUtils = require("utils/account-utils");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
class AccountDetailsFormViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "accountName", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isCurrentUser", false);
    (0, _defineProperty2.default)(this, "button", {
      label: _knockout.default.observable(),
      tooltip: _knockout.default.observable(),
      isVisible: _knockout.default.observable(),
      isDisabled: _knockout.default.observable()
    });
    (0, _defineProperty2.default)(this, "profileInfo", [{
      label: 'Account Name',
      value: _knockout.default.observable()
    }, {
      label: 'Role',
      value: _knockout.default.observable()
    }]);
  }

  selectState(state, params) {
    const {
      accounts = {},
      session
    } = state;
    return [accounts[params.accountName], session && accounts[session.user], session && session.authorizedBy];
  }

  mapStateToProps(account, user, authorizedBy) {
    if (!account || !user) {
      _knockout.default.assignToProps(this, {
        button: {
          label: 'Reset Password',
          isDisabled: true,
          tooltip: ''
        }
      });
    } else {
      const {
        isAdmin
      } = account;
      const isCurrentUser = user === account;
      const role = isAdmin ? 'Administator' : 'Application';
      const allowResetPassword = authorizedBy === 'noobaa' && (0, _accountUtils.canEditAccount)(user, account);

      _knockout.default.assignToProps(this, {
        accountName: account.name,
        isCurrentUser,
        button: {
          label: isCurrentUser ? 'Change Password' : 'Reset Password',
          isVisible: allowResetPassword
        },
        profileInfo: [{
          value: account.name
        }, {
          value: role
        }]
      });
    }
  }

  onChangeOrResetPassword() {
    const action = this.isCurrentUser ? (0, _actionCreators.openChangePasswordModal)(this.accountName()) : (0, _actionCreators.openResetPasswordModal)(this.accountName());
    this.dispatch(action);
  }

}

var _default = {
  viewModel: AccountDetailsFormViewModel,
  template: _accountDetailsForm.default
};
exports.default = _default;

},{"./account-details-form.html":358,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout","utils/account-utils":1019}],360:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"greedy tabs\">\n    <nav>\n        <a ko.attr.href=\"tabHref('s3-access')\"\n            ko.css.selected=\"selectedTab.eq('s3-access')\"\n        >\n            S3 Access &amp; Permissions\n        </a>\n        <a ko.attr.href=\"tabHref('details')\"\n            ko.css.selected=\"selectedTab.eq('details')\"\n        >\n            Account Details\n        </a>\n        <a ko.attr.href=\"tabHref('connections')\"\n           ko.css.selected=\"selectedTab.eq('connections')\"\n           ko.visible=\"isCurrentUser\"\n        >\n            My Connections\n        </a>\n    </nav>\n\n    <div class=\"tabs-row\">\n        <account-s3-access-form class=\"tab\"\n            ko.css.selected=\"selectedTab.eq('s3-access')\"\n            params=\"accountName: account\"\n        ></account-s3-access-form>\n\n        <account-details-form class=\"tab\"\n            ko.css.selected=\"selectedTab.eq('details')\"\n            params=\"accountName: account\"\n        ></account-details-form>\n\n        <!-- ko if: isCurrentUser -->\n        <account-connections-list class=\"tab\"\n            ko.css.selected=\"selectedTab.eq('connections')\"\n            params=\"accountName: account\"\n        ></account-connections-list>\n        <!-- /ko -->\n    </div>\n</div>\n\n";

},{}],361:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _accountPanel = _interopRequireDefault(require("./account-panel.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _browserUtils = require("utils/browser-utils");

/* Copyright (C) 2016 NooBaa */
class AccountPanelViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "baseRoute", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "selectedTab", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "account", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isCurrentUser", _knockout.default.observable());
  }

  selectState(state) {
    const {
      location,
      session
    } = state;
    return [location, session && session.user];
  }

  mapStateToProps(location, user) {
    const {
      system,
      account,
      tab = 's3-access'
    } = location.params;
    if (!account) return;

    _knockout.default.assignToProps(this, {
      baseRoute: (0, _browserUtils.realizeUri)(location.route, {
        system,
        account
      }, {}, true),
      selectedTab: tab,
      account: account,
      isCurrentUser: account === user
    });
  }

  tabHref(tab) {
    const route = this.baseRoute();
    return route ? (0, _browserUtils.realizeUri)(route, {
      tab
    }) : '';
  }

}

var _default = {
  viewModel: AccountPanelViewModel,
  template: _accountPanel.default
};
exports.default = _default;

},{"./account-panel.html":360,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"components/connectable":446,"knockout":"knockout","utils/browser-utils":1021}],362:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"row card-shadow pad content-middle\">\n    <h2 class=\"heading3 greedy push-next\">\n        Account S3 Access\n    </h2>\n\n    <div class=\"push-next\" ko.tooltip=\"actionsTooltip\">\n        <button class=\"btn\"\n            ko.click=\"onSetIPRestrictions\"\n            ko.enable=\"canEdit\"\n        >\n            Set IP Restrictions\n        </button>\n    </div>\n\n    <div ko.tooltip=\"actionsTooltip\">\n        <button class=\"btn\"\n            ko.click=\"onEditS3Access\"\n            ko.enable=\"canEdit\"\n        >\n            Edit S3 Access\n        </button>\n    </div>\n</div>\n\n<property-sheet class=\"s3-access-details pad push-next \" params=\"\n    properties: s3AccessInfo,\n    loading: !dataReady()\n\">\n    <template name=\"tagList\">\n        <tag-list params=\"\n            tags: tags,\n            maxCount: maxCount,\n            emptyMessage: emptyMessage\n        \"></tag-list>\n    </template>\n</property-sheet>\n\n<hr>\n\n<div class=\"row card-shadow pad content-middle\">\n    <h2 class=\"heading3 greedy push-next\">\n        Account Security Credentials\n    </h2>\n\n    <div ko.tooltip=\"actionsTooltip\">\n        <button class=\"btn\"\n            ko.click=\"onRegenerateAccountCredentials\"\n            ko.enable=\"canEdit\"\n        >\n            Regenerate Credentials\n        </button>\n    </div>\n</div>\n\n<loading-indicator class=\"align-start pad\"\n    ko.visible=\"!dataReady()\"\n></loading-indicator>\n<div class=\"pad column\" ko.if=\"dataReady\">\n    <span class=\"highlight push-next\">\n        Use the following S3 access keys to connect a S3 compatible application to NooBaa:\n    </span>\n    <property-sheet class=\"pad content-box\" params=\"properties: credentials\"></property-sheet>\n</div>\n";

},{}],363:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _accountS3AccessForm = _interopRequireDefault(require("./account-s3-access-form.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _accountUtils = require("utils/account-utils");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const boxCount = 4;

function _getAllowedIpsInfo(allowedIps = []) {
  return {
    tags: allowedIps.map(({
      start,
      end
    }) => {
      return start === end ? start : `${start} - ${end}`;
    }),
    maxCount: boxCount,
    emptyMessage: 'No IP allowed'
  };
}

function _getAllowedBucketsInfo(hasAccessToAllBuckets, allowedBuckets) {
  return {
    tags: hasAccessToAllBuckets ? [] : allowedBuckets,
    maxCount: boxCount,
    emptyMessage: hasAccessToAllBuckets ? 'All current and future buckets' : '(None)'
  };
}

class AccountS3AccessFormViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "accountName", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "canEdit", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "actionsTooltip", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "s3AccessInfo", [{
      label: 'Access Type',
      value: _knockout.default.observable()
    }, {
      label: 'Permitted Buckets',
      template: 'tagList',
      value: {
        tags: _knockout.default.observableArray(),
        maxCount: boxCount,
        emptyMessage: _knockout.default.observable()
      },
      disabled: _knockout.default.observable()
    }, {
      label: 'New Bucket Creation',
      value: _knockout.default.observable(),
      disabled: _knockout.default.observable()
    }, {
      label: 'Default Resource for S3 Applications',
      value: _knockout.default.observable(),
      disabled: _knockout.default.observable()
    }, {
      label: 'IP Restrictions',
      value: _knockout.default.observable(),
      disabled: _knockout.default.observable()
    }, {
      label: 'Allowed IPs',
      template: 'tagList',
      value: {
        tags: _knockout.default.observableArray(),
        maxCount: boxCount,
        emptyMessage: _knockout.default.observable()
      },
      visible: _knockout.default.observable()
    }]);
    (0, _defineProperty2.default)(this, "credentials", [{
      label: 'Access Key',
      allowCopy: true,
      value: _knockout.default.observable(),
      disabled: _knockout.default.observable()
    }, {
      label: 'Secret Key',
      allowCopy: true,
      value: _knockout.default.observable(),
      disabled: _knockout.default.observable()
    }]);
  }

  selectState(state, params) {
    const {
      accounts = {},
      session
    } = state;
    return [accounts[params.accountName], session && session.user && accounts[session.user]];
  }

  mapStateToProps(account, user) {
    if (!account || !user) {
      _knockout.default.assignToProps(this, {
        dataReady: false,
        actionsTooltip: '',
        canEdit: false
      });
    } else {
      const {
        defaultResource,
        isAdmin,
        hasAccessToAllBuckets,
        allowedBuckets,
        accessKeys,
        allowedIps
      } = account;
      const canEdit = (0, _accountUtils.canEditAccount)(user, account);
      const defaultResourceName = defaultResource === 'INTERNAL_STORAGE' && 'Internal Storage' || defaultResource || 'Not Set';

      _knockout.default.assignToProps(this, {
        dataReady: true,
        accountName: account.name,
        canEdit,
        actionsTooltip: canEdit ? '' : 'User has no permission to edit this account',
        s3AccessInfo: [{
          value: isAdmin ? 'Administator' : 'Application'
        }, {
          value: _getAllowedBucketsInfo(hasAccessToAllBuckets, allowedBuckets)
        }, {
          value: account.canCreateBuckets ? 'Allowed' : 'Not Allowed'
        }, {
          value: defaultResourceName
        }, {
          value: allowedIps ? 'Enabled' : 'Not set'
        }, {
          value: _getAllowedIpsInfo(allowedIps),
          visible: Boolean(allowedIps)
        }],
        credentials: [{
          value: accessKeys.accessKey
        }, {
          value: accessKeys.secretKey
        }]
      });
    }
  }

  onEditS3Access() {
    this.dispatch((0, _actionCreators.openEditAccountS3AccessModal)(this.accountName()));
  }

  onSetIPRestrictions() {
    this.dispatch((0, _actionCreators.openSetAccountIpRestrictionsModal)(this.accountName()));
  }

  onRegenerateAccountCredentials() {
    this.dispatch((0, _actionCreators.openRegenerateAccountCredentialsModal)(this.accountName()));
  }

}

var _default = {
  viewModel: AccountS3AccessFormViewModel,
  template: _accountS3AccessForm.default
};
exports.default = _default;

},{"./account-s3-access-form.html":362,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout","utils/account-utils":1019}],364:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<section class=\"column greedy tabs\">\n    <nav>\n        <a ko.attr.href=\"tabHref('accounts')\"\n            ko.css.selected=\"selectedTab.eq('accounts')\"\n        >\n            Accounts\n        </a>\n    </nav>\n\n    <div class=\"tabs-row\">\n        <accounts-table class=\"tab column\"\n            ko.css.selected=\"selectedTab.eq('accounts')\"\n        ></accounts-table>\n    </div>\n</section>\n\n\n\n\n";

},{}],365:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _accountsPanel = _interopRequireDefault(require("./accounts-panel.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _browserUtils = require("utils/browser-utils");

/* Copyright (C) 2016 NooBaa */
class AccountsPanelViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "baseRoute", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "selectedTab", _knockout.default.observable());
  }

  selectState(state) {
    return [state.location];
  }

  mapStateToProps(location) {
    const {
      system,
      tab = 'accounts'
    } = location.params;

    _knockout.default.assignToProps(this, {
      baseRoute: (0, _browserUtils.realizeUri)(location.route, {
        system
      }, {}, true),
      selectedTab: tab
    });
  }

  tabHref(tab) {
    const route = this.baseRoute();
    return route ? (0, _browserUtils.realizeUri)(route, {
      tab
    }) : '';
  }

}

var _default = {
  viewModel: AccountsPanelViewModel,
  template: _accountsPanel.default
};
exports.default = _default;

},{"./accounts-panel.html":364,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"components/connectable":446,"knockout":"knockout","utils/browser-utils":1021}],366:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"row card-shadow pad content-middle\">\n    <div class=\"greedy push-next\">\n        <input type=\"search\"\n            placeholder=\"Filter by account name\"\n            ko.textInput=\"ko.pc(filter, onFilterThrottled)\"\n        />\n    </div>\n    <button class=\"btn align-end\"\n        ko.click=\"onCreateAccount\"\n        ko.disable=\"!dataReady()\"\n    >\n        Create Account\n    </button>\n</div>\n\n<data-table class=\"greedy accounts-table\" params=\"\n    columns: columns,\n    data: rows,\n    sorting: ko.pc(sorting, onSort, $component),\n    loading: !dataReady(),\n    emptyMessage: 'The current filter does not match any account'\n\"></data-table>\n\n<paginator params=\"\n    itemCount: accountCount,\n    pageSize: ko.pc(pageSize, onPageSize, $component),\n    page: ko.pc(page, onPage, $component)\n\"></paginator>\n";

},{}],367:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _accountsTable = _interopRequireDefault(require("./accounts-table.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _config = require("config");

var _browserUtils = require("utils/browser-utils");

var _accountUtils = require("utils/account-utils");

var routes = _interopRequireWildcard(require("routes"));

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const columns = (0, _coreUtils.deepFreeze)([{
  name: 'name',
  label: 'account name',
  type: 'link',
  sortable: true,
  compareKey: account => account.name
}, {
  name: 'accessType',
  sortable: true,
  compareKey: account => account.isAdmin
}, {
  name: 'defaultResource',
  sortable: true,
  compareKey: account => account.defaultResource
}, {
  name: 'deleteButton',
  label: '',
  type: 'delete'
}]);

function _mapAccountToRow(account, currentUser, baseRoute, selectedForDelete) {
  const {
    name,
    defaultResource,
    undeletable
  } = account;
  const isCurrentUser = account === currentUser;
  const accountNameText = `${name} ${isCurrentUser ? '(Current user)' : ''}`;
  const usingInternalStorage = defaultResource === 'INTERNAL_STORAGE';
  const undeletableByUser = !(0, _accountUtils.canDeleteAccount)(currentUser, account);
  return {
    isCurrentUser,
    name: {
      text: accountNameText,
      href: (0, _browserUtils.realizeUri)(baseRoute, {
        account: name
      }),
      tooltip: accountNameText
    },
    accessType: account.isAdmin ? 'Administator' : 'Application',
    defaultResource: {
      text: false || usingInternalStorage && 'Using internal storage' || !defaultResource && '(not set)' || defaultResource,
      tooltip: defaultResource && !usingInternalStorage && {
        text: defaultResource,
        breakWords: true
      }
    },
    deleteButton: {
      id: name,
      active: selectedForDelete === name,
      disabled: undeletableByUser,
      tooltip: _getDeleteAccountTooltip(undeletable || (undeletableByUser ? 'NO_PERMISSIONS' : ''))
    }
  };
}

function _getDeleteAccountTooltip(reason) {
  switch (reason) {
    case 'OWNER':
      return 'Cannot delete system owner';

    case 'OWN_BUCKET':
      return 'Cannot delete an account that own buckets';

    case 'NO_PERMISSIONS':
      return 'User has no permissions to delete this account';

    default:
      return 'Delete Account';
  }
}

class AccountRowViewModel {
  constructor({
    table
  }) {
    (0, _defineProperty2.default)(this, "table", null);
    (0, _defineProperty2.default)(this, "name", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "accessType", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "defaultResource", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isCurrentUser", false);
    (0, _defineProperty2.default)(this, "deleteButton", {
      id: _knockout.default.observable(),
      text: 'Delete Account',
      active: _knockout.default.observable(),
      disabled: _knockout.default.observable(),
      tooltip: _knockout.default.observable(),
      onToggle: this.onSelectForDelete.bind(this),
      onDelete: this.onDelete.bind(this)
    });
    this.table = table;
  }

  onSelectForDelete(email) {
    this.table.onSelectForDelete(email);
  }

  onDelete(email) {
    this.table.onDeleteAccount(email, this.isCurrentUser);
  }

}

class AccountsTableViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "columns", columns);
    (0, _defineProperty2.default)(this, "pathname", '');
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "filter", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "sorting", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "page", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "pageSize", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "selectedForDelete", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "accountCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "onFilterThrottled", (0, _coreUtils.throttle)(this.onFilter, _config.inputThrottle, this));
    (0, _defineProperty2.default)(this, "rows", _knockout.default.observableArray().ofType(AccountRowViewModel, {
      table: this
    }));
  }

  selectState(state) {
    return [state.accounts, state.location, state.session];
  }

  mapStateToProps(accounts, location, session) {
    if (!accounts || !session) {
      _knockout.default.assignToProps(this, {
        dataReady: false
      });
    } else {
      const {
        system,
        tab = 'accounts'
      } = location.params;

      if (tab !== 'accounts') {
        return;
      }

      const {
        filter = '',
        sortBy = 'name',
        selectedForDelete = ''
      } = location.query;
      const page = Number(location.query.page) || 0;

      const pageSize = Number(location.query.pageSize) || _config.paginationPageSize.default;

      const order = Number(location.query.order) || 1;
      const {
        compareKey
      } = columns.find(column => column.name === sortBy);
      const compareAccounts = (0, _coreUtils.createCompareFunc)(compareKey, order);
      const accountList = Object.values(accounts).filter(account => !account.roles.includes('operator'));
      const pageStart = page * pageSize;
      const filteredRows = accountList.filter(account => !filter || account.name.toLowerCase().includes(filter.toLowerCase()));

      _knockout.default.assignToProps(this, {
        dataReady: true,
        pathname: location.pathname,
        filter,
        sorting: {
          sortBy,
          order
        },
        page,
        pageSize,
        selectedForDelete,
        accountCount: filteredRows.length,
        rows: filteredRows.sort(compareAccounts).slice(pageStart, pageStart + pageSize).map(account => _mapAccountToRow(account, accounts[session.user], (0, _browserUtils.realizeUri)(routes.account, {
          system
        }, {}, true), selectedForDelete))
      });
    }
  }

  onFilter(filter) {
    this.onQuery({
      filter,
      page: 0,
      selectedForDelete: undefined
    });
  }

  onSort({
    sortBy,
    order
  }) {
    this.onQuery({
      sortBy,
      order,
      page: 0,
      selectedForDelete: undefined
    });
  }

  onPage(page) {
    this.onQuery({
      page,
      selectedForDelete: undefined
    });
  }

  onPageSize(pageSize) {
    this.onQuery({
      pageSize,
      page: 0,
      selectedForDelete: undefined
    });
  }

  onSelectForDelete(account) {
    this.onQuery({
      selectedForDelete: account
    });
  }

  onQuery(query) {
    const {
      filter = this.filter(),
      sortBy = this.sorting().sortBy,
      order = this.sorting.order,
      page = this.page(),
      pageSize = this.pageSize(),
      selectedForDelete = this.selectedForDelete()
    } = query;
    const uri = (0, _browserUtils.realizeUri)(this.pathname, {}, {
      filter: filter || undefined,
      sortBy,
      order,
      page,
      pageSize,
      selectedForDelete: selectedForDelete || undefined
    });
    this.dispatch((0, _actionCreators.requestLocation)(uri));
  }

  onCreateAccount() {
    this.dispatch((0, _actionCreators.openCreateAccountModal)());
  }

  onDeleteAccount(email, isCurrentUser) {
    this.dispatch((0, _actionCreators.tryDeleteAccount)(email, isCurrentUser));
  }

}

var _default = {
  viewModel: AccountsTableViewModel,
  template: _accountsTable.default
};
exports.default = _default;

},{"./accounts-table.html":366,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"components/connectable":446,"config":831,"knockout":"knockout","routes":972,"utils/account-utils":1019,"utils/browser-utils":1021,"utils/core-utils":1027}],368:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _knockout = _interopRequireDefault(require("knockout"));

var _moment = _interopRequireDefault(require("moment"));

var _coreUtils = require("utils/core-utils");

var _promiseUtils = require("utils/promise-utils");

var _config = require("config");

/* Copyright (C) 2016 NooBaa */
const updatingDelay = 500;
const severityIconMapping = (0, _coreUtils.deepFreeze)({
  CRIT: 'problem',
  MAJOR: 'problem',
  INFO: 'notif-info'
});

class AlertRowViewModel {
  constructor() {
    this.id = _knockout.default.observable();
    this.text = _knockout.default.observable();
    this.css = _knockout.default.observable();
    this.time = _knockout.default.observable();
    this.icon = _knockout.default.observable();
    this.read = _knockout.default.observable();
    this.updating = _knockout.default.observable();
    this.markButton = _knockout.default.pureComputed(() => !this.read() && !this.updating());
  }

  update({
    id,
    alert,
    time,
    severity,
    read,
    updating
  }) {
    this.id(id);
    this.text(alert);
    this.time((0, _moment.default)(time).format(_config.timeShortFormat));
    this.read(read);
    this.css(`${read ? 'read' : 'unread'} alert-${severity.toLowerCase()}`);
    this.icon(severityIconMapping[severity]); // Ensure that the visual updating indicator is visible for at least
    // a minimun (updatingDelay) amount of time.

    if (this.updating() && !updating) {
      (0, _promiseUtils.sleep)(updatingDelay, false).then(this.updating);
    } else {
      this.updating(updating);
    }
  }

}

exports.default = AlertRowViewModel;

},{"@babel/runtime/helpers/interopRequireDefault":1050,"config":831,"knockout":"knockout","moment":"moment","utils/core-utils":1027,"utils/promise-utils":1039}],369:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<h1 class=\"row content-middle heading1 hpad pane-header push-next\">\n    <span class=\"greedy push-next\">Alerts &amp; Notifications</span>\n\n    <button class=\"icon-btn\" ko.click=\"onX\">\n        <svg-icon class=\"icon-small\" params=\"name: 'x'\"></svg-icon>\n    </button>\n</h1>\n\n<section class=\"column hpad greedy push-next\">\n    <toggle-group class=\"push-next align-start\" params=\"\n        options: severityOptions,\n        selected: severityFilter\n    \"></toggle-group>\n\n    <div class=\"row content-middle\">\n        <checkbox class=\"greedy\" params=\"\n            checked: unreadOnlyFilter,\n            label: unreadCheckboxLabel\n        \"></checkbox>\n\n        <button class=\"link alt-colors\"\n            ko.disable=\"markAllDisabled\"\n            ko.click=\"markListAsRead\"\n        >\n            Mark all as read\n        </button>\n    </div>\n\n    <div class=\"column content-box greedy auto-overflow push-prev-half \" ko.scroll=\"scroll\">\n        <ul class=\"list-no-style\" ko.foreach=\"rows\">\n            <li class=\"vpad alert row content-middle\" ko.css=\"css\">\n\n                <svg-icon class=\"column c1\" params=\"name: icon\"></svg-icon>\n                <div class=\"column c9\">\n                    <p class=\"greedy\" ko.text=\"text\"></p>\n                    <span class=\"remark\" ko.text=\"time\"></span>\n                </div>\n\n                <button class=\"column c2 mark-as-read-btn link alt-colors remark align-start content-middle\"\n                    ko.visible=\"markButton\"\n                    ko.click=\"$component.markRowAsRead\"\n                >\n                    Mark as read\n                </button>\n\n                <loading-indicator class=\"column c2 align-start\"\n                    ko.visible=\"updating\"\n                ></loading-indicator>\n\n            </li>\n        </ul>\n\n        <loading-indicator class=\"align-middle greedy pad\"\n            ko.visible=\"loading\"\n        ></loading-indicator>\n\n        <div class=\"align-middle remark pad\" ko.visible=\"endOfList\">\n            No more results\n        </div>\n\n        <div class=\"link align-middle pad\" ko.visible=\"loadFailed\">\n            <button class=\"link error\" ko.click=\"retryLoad\">\n                Loading failed, click to retry\n            </button>\n        </div>\n    </div>\n</section>\n";

},{}],370:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _alertsPane = _interopRequireDefault(require("./alerts-pane.html"));

var _observer = _interopRequireDefault(require("observer"));

var _alertRow = _interopRequireDefault(require("./alert-row"));

var _state = require("state");

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _rxExtensions = require("rx-extensions");

var _config = require("config");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const severityOptions = (0, _coreUtils.deepFreeze)([{
  label: 'all',
  value: 'ALL'
}, {
  label: 'critical',
  value: 'CRIT'
}, {
  label: 'important',
  value: 'MAJOR'
}, {
  label: 'minor',
  value: 'INFO'
}]);

class AlertsPaneViewModel extends _observer.default {
  constructor({
    onClose
  }) {
    super();
    this.onClose = onClose;
    this.loading = _knockout.default.observable();
    this.markAllDisabled = _knockout.default.observable();
    this.loadFailed = _knockout.default.observable();
    this.endOfList = _knockout.default.observable();
    this.severityOptions = severityOptions;
    this.rows = _knockout.default.observableArray();
    this.severityFilter = _knockout.default.observable();
    this.unreadOnlyFilter = _knockout.default.observable();
    this.scroll = _knockout.default.observable();
    this.unreadCheckboxLabel = _knockout.default.observable();

    _knockout.default.group(this.severityFilter, this.unreadOnlyFilter).subscribe(() => this.onFilter());

    this.scroll.subscribe(() => this.onScroll());
    this.observe(_state.state$.pipe((0, _rxExtensions.get)('alerts')), this.onAlerts);

    _state.action$.next((0, _actionCreators.fetchUnreadAlertsCount)());
  }

  onAlerts(alerts) {
    const {
      filter,
      loading,
      endOfList,
      list,
      loadError,
      unreadCounts
    } = alerts;
    const {
      severity = 'ALL',
      read
    } = filter; // Update the view model state.

    this.severityFilter(severity);
    this.unreadOnlyFilter(read === false);
    this.loading(loading);
    this.loadFailed(Boolean(loadError));
    this.markAllDisabled(loading || list.length === 0);
    this.endOfList(endOfList);
    this.rows(list.map((alert, i) => {
      const row = this.rows()[i] || new _alertRow.default();
      row.update(alert);
      return row;
    }));
    const totalCount = (0, _coreUtils.sumBy)(Object.values(unreadCounts));
    const {
      [severity.toLowerCase()]: count = totalCount
    } = unreadCounts;
    this.unreadCheckboxLabel(`Show Unread Only (${count})`);
  }

  onX() {
    this.onClose();
  }

  onFilter() {
    const read = this.unreadOnlyFilter() ? false : undefined;
    const severity = this.severityFilter() !== 'ALL' ? this.severityFilter() : undefined;

    _state.action$.next((0, _actionCreators.fetchAlerts)({
      severity,
      read
    }, _config.infinitScrollPageSize));

    this.scroll(0);
  }

  onScroll() {
    if (!this.loadFailed() && this.scroll() > .99) {
      this._loadMore();
    }
  }

  retryLoad() {
    this._loadMore();
  }

  markRowAsRead(row) {
    const ids = [row.id()];

    _state.action$.next((0, _actionCreators.updateAlerts)({
      ids,
      read: false
    }, true));
  }

  markListAsRead() {
    const severity = this.severityFilter() !== 'ALL' ? this.severityFilter() : undefined;

    _state.action$.next((0, _actionCreators.updateAlerts)({
      severity,
      read: false
    }, true));
  }

  dispose() {
    _state.action$.next((0, _actionCreators.dropAlerts)());

    super.dispose();
  }

  _loadMore() {
    if (this.endOfList()) {
      return;
    }

    const rows = this.rows();
    const till = rows.length ? (0, _coreUtils.last)(rows).id() : undefined;
    const read = this.unreadOnlyFilter() ? false : undefined;
    const severity = this.severityFilter() !== 'ALL' ? this.severityFilter() : undefined;

    _state.action$.next((0, _actionCreators.fetchAlerts)({
      severity,
      read,
      till
    }, _config.infinitScrollPageSize));
  }

}

var _default = {
  viewModel: AlertsPaneViewModel,
  template: _alertsPane.default
};
exports.default = _default;

},{"./alert-row":368,"./alerts-pane.html":369,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"config":831,"knockout":"knockout","observer":937,"rx-extensions":974,"state":1016,"utils/core-utils":1027}],371:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<h1 class=\"row content-middle heading1 pane-header hpad push-next\">\n    <span class=\"greedy push-next\">Audit Log</span>\n\n    <button class=\"icon-btn\"\n        ko.click=\"onX\"\n    >\n        <svg-icon class=\"icon-small\" params=\"name: 'x'\"></svg-icon>\n    </button>\n</h1>\n\n<div class=\"column hpad push-next\">\n    <div class=\"row content-middle\">\n        <h2 class=\"heading3 greedy\">Choose Categories</h2>\n\n        <div>\n            <button type=\"button\"\n                class=\"link alt-colors\"\n                ko.click=\"onSelectAllCategories\"\n            >\n                Select all\n            </button>\n            |\n            <button type=\"button\"\n                class=\"link alt-colors\"\n                ko.click=\"onClearAllCategories\"\n            >\n                Clear\n            </button>\n        </div>\n    </div>\n\n    <multiselect class=\"category-filter\" params=\"\n        options: categoryOptions,\n        selected: ko.pc(selectedCategories, onSelectCategories, $component)\n    \"></multiselect>\n</div>\n\n<div class=\"column hpad greedy push-next\">\n    <div class=\"row\">\n        <h3 class=\"heading3 greedy push-next align-end\">Events</h3>\n\n        <button class=\"icon-btn export-btn\"\n            ko.click=\"onExportToCSV\"\n            ko.tooltip=\"exportTooltip\"\n        >\n            <svg-icon class=\"icon-small\" params=\"name: 'export'\" ></svg-icon>\n        </button>\n    </div>\n\n    <div class=\"greedy content-box scroll-overflow\"\n        ko.scroll=\"ko.pc(ko.observable(), onScroll, $component)\"\n    >\n        <data-table class=\"audit-table \" params=\"\n            columns: columns,\n            data: rows,\n            rowClick: row => onSelectedRecord(row.id),\n            rowCssProp: 'css'\n        \"></data-table>\n\n        <div class=\"border-top column\">\n            <loading-indicator class=\"align-middle greedy pad\"\n                ko.visible=\"loadState.eq('LOADING')\"\n            ></loading-indicator>\n\n            <div class=\"align-middle remark pad\"\n                ko.visible=\"loadState.eq('ALL_LOADED')\"\n            >\n                No more results\n            </div>\n\n            <div class=\"link align-middle pad\"\n                ko.visible=\"loadState.eq('LOAD_ERROR')\"\n            >\n                <button class=\"link error\" ko.click=\"onRetryLoad\">\n                    Loading failed, click to retry\n                </button>\n            </div>\n        </div>\n    </div>\n</div>\n<div class=\"column hpad push-next\">\n    <h3 class=\"heading3\">Event Description</h3>\n    <pre class=\"desc-box content-box pad\">{{desc}}</pre>\n</div>\n\n";

},{}],372:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _auditPane = _interopRequireDefault(require("./audit-pane.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _eventDisplayNames = _interopRequireDefault(require("./event-display-names"));

var _moment = _interopRequireDefault(require("moment"));

var _coreUtils = require("utils/core-utils");

var _browserUtils = require("utils/browser-utils");

var _config = require("config");

var routes = _interopRequireWildcard(require("routes"));

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const categoryDisplayNames = (0, _coreUtils.deepFreeze)({
  node: 'Nodes',
  resource: 'Resources',
  conf: 'Configuration',
  account: 'Accounts',
  dbg: 'Debug',
  cluster: 'Cluster',
  functions: 'Functions',
  obj: 'Objects',
  bucket: 'Buckets'
});
const categoryOptions = Object.entries(categoryDisplayNames).map(pair => ({
  value: pair[0],
  label: pair[1]
}));
const columns = (0, _coreUtils.deepFreeze)([{
  name: 'time'
}, {
  name: 'account'
}, {
  name: 'category'
}, {
  name: 'event'
}, {
  name: 'entity',
  type: 'link'
}]);
const exportTooltip = (0, _coreUtils.deepFreeze)({
  text: 'Export as CSV',
  align: 'end'
});

function _mapEntity(entity, system) {
  if (!entity) {
    return {
      text: '---'
    };
  }

  switch (entity.kind) {
    case 'node':
      {
        const {
          linkable,
          name: host,
          pool
        } = entity;
        return {
          text: host.split('#')[0],
          href: linkable ? (0, _browserUtils.realizeUri)(routes.host, {
            system,
            pool,
            host
          }) : ''
        };
      }

    case 'object':
      {
        const {
          linkable,
          key: object,
          bucket,
          version
        } = entity;
        return {
          text: object,
          href: linkable ? (0, _browserUtils.realizeUri)(routes.object, {
            system,
            bucket,
            object,
            version
          }) : ''
        };
      }

    case 'bucket':
      {
        const {
          linkable,
          name: bucket
        } = entity;
        return {
          text: bucket,
          href: linkable ? (0, _browserUtils.realizeUri)(routes.bucket, {
            system,
            bucket
          }) : ''
        };
      }

    case 'account':
      {
        const {
          linkable,
          name: account
        } = entity;
        return {
          text: account,
          href: linkable ? (0, _browserUtils.realizeUri)(routes.account, {
            system,
            account
          }) : ''
        };
      }

    case 'resource':
      {
        const {
          linkable,
          name,
          resourceType
        } = entity;

        if (!linkable) {
          return {
            text: name
          };
        } else {
          return {
            text: name,
            href: resourceType === 'HOSTS' && (0, _browserUtils.realizeUri)(routes.pool, {
              system,
              pool: name
            }) || resourceType === 'CLOUD' && (0, _browserUtils.realizeUri)(routes.cloudResource, {
              system,
              resource: name
            }) || ''
          };
        }
      }

    case 'server':
      {
        const {
          linkable,
          name: server
        } = entity;
        return {
          text: server,
          href: linkable ? (0, _browserUtils.realizeUri)(routes.server, {
            system,
            server
          }) : ''
        };
      }

    case 'function':
      {
        const {
          linkable,
          name: func
        } = entity;
        return {
          text: func,
          href: linkable ? (0, _browserUtils.realizeUri)(routes.func, {
            system,
            func
          }) : ''
        };
      }
  }
}

function _mapItemToRow(item, system, selectedRecord) {
  const {
    time,
    actor,
    category,
    event,
    entity,
    id
  } = item;
  return {
    id,
    time: (0, _moment.default)(time).format(_config.timeShortFormat),
    account: actor ? actor.name : '---',
    category: categoryDisplayNames[category],
    event: _eventDisplayNames.default[`${category}.${event}`] || '',
    entity: _mapEntity(entity, system),
    css: id === selectedRecord ? 'selected' : ''
  };
}

class EventRowViewModel {
  constructor() {
    (0, _defineProperty2.default)(this, "id", '');
    (0, _defineProperty2.default)(this, "time", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "account", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "category", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "event", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "entity", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "css", _knockout.default.observable());
  }

}

class AuditPaneViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "categoryOptions", categoryOptions);
    (0, _defineProperty2.default)(this, "columns", columns);
    (0, _defineProperty2.default)(this, "exportTooltip", exportTooltip);
    (0, _defineProperty2.default)(this, "selectedCategories", _knockout.default.observableArray());
    (0, _defineProperty2.default)(this, "loadState", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "oldestTimestamp", 0);
    (0, _defineProperty2.default)(this, "desc", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "rows", _knockout.default.observableArray().ofType(EventRowViewModel));
    this.dispatch((0, _actionCreators.fetchAuditLog)({
      categories: Object.keys(categoryDisplayNames).filter(cat => cat !== 'bucket' && cat !== 'obj')
    }, _config.infinitScrollPageSize));
  }

  selectState(state) {
    const {
      auditLog,
      location
    } = state;
    return [auditLog, location.params.system];
  }

  mapStateToProps(auditLog, system) {
    if (!auditLog) {
      _knockout.default.assignToProps(this, {
        isLoading: true,
        desc: ''
      });
    } else {
      const {
        loading,
        loadError,
        endOfList,
        categories,
        list,
        selectedRecord
      } = auditLog;
      const loadState = loading > 0 && 'LOADING' || loadError && 'LOAD_ERROR' || endOfList && 'ALL_LOADED' || 'IDEL';
      const {
        desc
      } = selectedRecord ? list.find(record => record.id === selectedRecord) : {
        desc: ''
      };

      _knockout.default.assignToProps(this, {
        dataReady: true,
        loadState,
        oldestTimestamp: list.length > 0 ? (0, _coreUtils.last)(list).time : Date.now(),
        selectedCategories: categories,
        desc,
        rows: list.map(item => _mapItemToRow(item, system, selectedRecord))
      });
    }
  }

  onX() {
    this.dispatch((0, _actionCreators.closeDrawer)());
  }

  onSelectAllCategories() {
    this.onSelectCategories(Object.keys(categoryDisplayNames));
  }

  onClearAllCategories() {
    this.onSelectCategories([]);
  }

  onSelectCategories(categories) {
    this.dispatch((0, _actionCreators.fetchAuditLog)({
      categories
    }, _config.infinitScrollPageSize));
  }

  onSelectedRecord(recordId) {
    this.dispatch((0, _actionCreators.selectAuditRecord)(recordId));
    return true;
  }

  onScroll(scrollPos) {
    const loadMoreScrollBound = 1 - 1 / this.rows().length;
    const categories = this.selectedCategories();

    if (this.loadState() === 'IDEL' && scrollPos > loadMoreScrollBound) {
      this.dispatch((0, _actionCreators.fetchAuditLog)({
        categories
      }, _config.infinitScrollPageSize, this.oldestTimestamp));
    }
  }

  onRetryLoad() {
    const categories = this.selectedCategories();
    this.dispatch((0, _actionCreators.fetchAuditLog)({
      categories
    }, _config.infinitScrollPageSize, this.oldestTimestamp));
  }

  onExportToCSV() {
    this.dispatch((0, _actionCreators.exportAuditLog)(this.selectedCategories()));
  }

  dispose() {
    this.dispatch((0, _actionCreators.dropAuditLog)());
    super.dispose();
  }

}

var _default = {
  viewModel: AuditPaneViewModel,
  template: _auditPane.default
};
exports.default = _default;

},{"./audit-pane.html":371,"./event-display-names":373,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"components/connectable":446,"config":831,"knockout":"knockout","moment":"moment","routes":972,"utils/browser-utils":1021,"utils/core-utils":1027}],373:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/* Copyright (C) 2016 NooBaa */
var _default = {
  // node
  'node.create': 'Node Added',
  'node.test_node': 'Node Tested',
  'node.decommission': 'Node Deactivated',
  'node.storage_disabled': 'Node Storage Disabled',
  'node.storage_enabled': 'Node Storage Enabled',
  'node.edit_drives': 'Node Storage Drives Edited',
  'node.endpoint_disabled': 'Node S3 Endpoint Disabled',
  'node.endpoint_enabled': 'Node S3 Endpoint Enabled',
  'node.recommission': 'Node Reactivated',
  'node.connected': 'Drive Connected',
  'node.deleted': 'Node Deleted',
  'node.delete_started': 'Node Deletion Started',
  'node.untrusted': 'Node Untrusted',
  'node.retrust': 'Node Retrusted',
  'node.disconnected': 'Drive Disconnected',
  // obj
  'obj.uploaded': 'Upload Completed',
  'obj.deleted': 'Object Deleted',
  // bucket:
  'bucket.create': 'Bucket Created',
  'bucket.delete': 'Bucket Deleted',
  'bucket.set_cloud_sync': 'Bucket Cloud Sync Set',
  'bucket.update_cloud_sync': 'Bucket Cloud Sync Updated',
  'bucket.remove_cloud_sync': 'Bucket Cloud Sync Removed',
  'bucket.edit_policy': 'Edit Bucket Policy',
  'bucket.edit_resiliency': 'Edit Bucket Data Resiliency',
  'bucket.s3_access_updated': 'Bucket S3 Access Updated',
  'bucket.set_lifecycle_configuration_rules': 'Set Lifecycle Configuration',
  'bucket.quota': 'Bucket Quota Configuration',
  'bucket.versioning': 'Bucket Versioning Updated',
  'bucket.delete_lifecycle_configuration_rules': 'Delete Lifecycle Configuration',
  // account:
  'account.create': 'Account Created',
  'account.update': 'Account Updated',
  'account.delete': 'Account Deleted',
  'account.s3_access_updated': 'Account S3 Access Updated',
  'account.generate_credentials': 'Account Credentials Generated',
  'account.connection_create': 'Connection Created',
  'account.connection_delete': 'Connection Deleted',
  // resource:
  'resource.create': 'Pool Created',
  'resource.delete': 'Pool Deleted',
  'resource.cloud_create': 'Cloud Resource Created',
  'resource.cloud_delete': 'Cloud Resource Deleted',
  'resource.assign_nodes': 'Pool Nodes Assigned',
  'resource.pool_assign_region': 'Pool Region Assigned',
  'resource.cloud_assign_region': 'Cloud Resource Region Assigned',
  'resource.scale': 'Pool Scaled',
  // dbg:
  'dbg.set_debug_node': 'Node\'s Debug Mode Change',
  'dbg.diagnose_system': 'System Diagnose',
  'dbg.diagnose_server': 'Server Diagnostics Collected',
  'dbg.set_debug_level': 'System Debug Mode Changed',
  'dbg.set_server_debug_level': 'Server Debug Mode Changed',
  'dbg.maintenance_mode': 'Maintenance Mode Started',
  'dbg.maintenance_mode_stopped': 'Maintenance Mode Stopped',
  // cluster:
  'cluster.added_member_to_cluster': 'Server Added To Cluster',
  'cluster.set_server_conf': 'Server Configuration Set',
  //functions:
  'functions.func_created': 'New function created',
  'functions.func_config_edit': 'Function config edited',
  'functions.func_code_edit': 'Function code edited',
  // conf
  'conf.create_system': 'System Created',
  'conf.server_date_time_updated': 'Server Date And Time Updated',
  'conf.dns_address': 'DNS Address Set',
  'conf.set_phone_home_proxy_address': 'Proxy Address Set',
  'conf.dns_servers': 'DNS Servers Set',
  'conf.set_certificate': 'Certificate Set',
  'conf.upload_package': 'Upgrade package upload started',
  'conf.system_upgrade_started': 'System upgrade started ',
  'conf.system_after_completed': 'System upgrade completed'
};
exports.default = _default;

},{}],374:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<managed-form params=\"\n    name: formName,\n    fields: formFields\n\">\n    <div class=\"card-shadow hpad pad-top column\">\n        <div class=\"column\">\n            <h2 class=\"heading3\">Top 10 Consumer Accounts</h2>\n            <p>Present how connected applications utilizes the system</p>\n        </div>\n        <div class=\"row vpad content-middle\">\n            <dropdown class=\"push-next\" params=\"\n                options: endpointGroupOptions,\n                multiselect: true,\n                selected: $form.selectedEndpointGroups,\n                disabled: !dataReady(),\n                subject: 'endpoint group'\n            \"></dropdown>\n            <dropdown class=\"push-next\" params=\"\n                options: durationOptions,\n                selected: $form.selectedDuration,\n                disabled: !dataReady(),\n            \"></dropdown>\n            <svg-icon class=\"spin match-theme\"\n                params=\"name: 'in-progress'\"\n                ko.visible=\"!dataReady()\"\n            ></svg-icon>\n        </div>\n    </div>\n    <chartjs class=\"pad push-next\" params=\"\n        type: chart.type,\n        options: chart.options,\n        data: chart.data,\n        forceEmptyMessage: true,\n        emptyMessage: chart.emptyMessage\n    \"></chartjs>\n</managed-form>\n";

},{}],375:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _accountUsageForm = _interopRequireDefault(require("./account-usage-form.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _formUtils = require("utils/form-utils");

var _sizeUtils = require("utils/size-utils");

var _themes = _interopRequireDefault(require("themes"));

var _moment = _interopRequireDefault(require("moment"));

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const FETCH_THRESHOLD = _moment.default.duration(10, 'minute').asMilliseconds();

const placeholderBar = {
  account: '',
  readSize: 0,
  writeSize: 0
};
const durations = (0, _coreUtils.deepFreeze)({
  DAY: {
    label: 'Last 24 Hours',
    timespan: 24,
    stepSize: 1,
    stepUnit: 'hour',
    tickFormat: 'HH:mm'
  },
  WEEK: {
    label: 'Last 7 Days',
    timespan: 7,
    stepSize: 1,
    stepUnit: 'day',
    tickFormat: 'D MMM'
  },
  MONTH: {
    label: 'Last 4 Weeks',
    timespan: 28,
    stepSize: 7,
    stepUnit: 'day',
    tickFormat: 'D MMM'
  }
});
const chartOptions = {
  scales: {
    yAxes: [{
      scaleLabel: {
        display: true,
        labelString: 'Aggregated R/W'
      },
      ticks: {
        suggestedMax: _sizeUtils.unitsInBytes.MB,
        // Using space for visual padding.
        callback: size => `${size && (0, _sizeUtils.formatSize)(size)}${' '.repeat(5)}`
      }
    }],
    xAxes: [{
      categoryPercentage: .4
    }]
  },
  tooltips: {
    position: 'nearest',
    mode: 'x',
    custom: tooltip => {
      if (!tooltip.title || tooltip.title.length === 0) {
        tooltip.opacity = 0;
      }
    },
    callbacks: {
      title: items => items[0].xLabel,
      label: item => `Total ${item.datasetIndex === 0 ? 'reads' : 'writes'}: ${(0, _sizeUtils.formatSize)(item.yLabel)}`
    }
  }
};
const durationOptions = (0, _coreUtils.deepFreeze)(Object.entries(durations).map(pair => ({
  value: pair[0],
  label: pair[1].label
})));
const compareBySize = (0, _coreUtils.createCompareFunc)(sample => (0, _sizeUtils.toBytes)((0, _sizeUtils.sumSize)(sample.readSize, sample.writeSize)), -1);

function _perpareChartParams(samples, theme) {
  const bars = [...samples, ...(0, _coreUtils.makeArray)(10 - samples.length, () => placeholderBar)];
  return {
    data: {
      labels: bars.map(bar => bar.account),
      datasets: [{
        backgroundColor: theme.color20,
        data: bars.map(bar => (0, _sizeUtils.toBytes)(bar.readSize))
      }, {
        backgroundColor: theme.color14,
        data: bars.map(bar => (0, _sizeUtils.toBytes)(bar.writeSize))
      }]
    },
    emptyMessage: samples.length === 0 ? 'No data to display' : ''
  };
}

class AccountUsageFormViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "formName", this.constructor.name);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "endpointGroupOptions", _knockout.default.observableArray());
    (0, _defineProperty2.default)(this, "durationOptions", durationOptions);
    (0, _defineProperty2.default)(this, "formFields", {
      initialized: false,
      selectedEndpointGroups: [],
      selectedDuration: durationOptions[0].value
    });
    (0, _defineProperty2.default)(this, "colors", _knockout.default.observableArray());
    (0, _defineProperty2.default)(this, "chart", {
      type: 'bar',
      options: chartOptions,
      data: _knockout.default.observable(),
      emptyMessage: _knockout.default.observable()
    });
  }

  onState(state, params) {
    super.onState(state, params);
    this.initializeForm(state);
    this.fetchThroughput(state);
  }

  initializeForm(state) {
    const form = state.forms[this.formName];
    if (!form) return;

    if (state.accounts && state.endpointGroups && !(0, _formUtils.getFieldValue)(form, 'initialized')) {
      const update = {
        selectedEndpointGroups: Object.keys(state.endpointGroups),
        initialized: true
      };
      this.dispatch((0, _actionCreators.updateForm)(this.formName, update, false));
    }
  }

  fetchThroughput(state) {
    const form = state.forms[this.formName];
    if (!form) return;
    const {
      query
    } = state.accountUsageHistory;
    const {
      selectedEndpointGroups,
      selectedDuration
    } = (0, _formUtils.getFormValues)(form);

    if (!query || Date.now() - query.timestamp > FETCH_THRESHOLD || query.duration !== selectedDuration || !(0, _coreUtils.equalItems)(query.endpointGroups, selectedEndpointGroups)) {
      this.dispatch((0, _actionCreators.fetchAccountUsageHistory)(selectedDuration, selectedEndpointGroups));
    }
  }

  selectState(state) {
    const {
      forms,
      accounts,
      endpointGroups,
      accountUsageHistory,
      session
    } = state;
    return [forms[this.formName], accounts, endpointGroups, accountUsageHistory, session && _themes.default[session.uiTheme]];
  }

  mapStateToProps(form, accounts, endpointGroups, usageHistory, theme) {
    if (!accounts || !usageHistory.samples || !theme || !(0, _formUtils.getFieldValue)(form, 'initialized')) {
      _knockout.default.assignToProps(this, {
        dataReady: false,
        pathname: location.pathname,
        colors: ['', ''],
        chart: {
          emptyMessage: 'Loading data...'
        }
      });
    } else {
      // Take the top 10 samples
      const samples = [...usageHistory.samples].sort(compareBySize).slice(0, 10);

      _knockout.default.assignToProps(this, {
        dataReady: true,
        pathname: location.pathname,
        endpointGroupOptions: Object.keys(endpointGroups),
        chart: _perpareChartParams(samples, theme)
      });
    }
  }

  dispose() {
    this.dispatch((0, _actionCreators.dropAccountUsageHistory)());
    super.dispose();
  }

}

var _default = {
  viewModel: AccountUsageFormViewModel,
  template: _accountUsageForm.default
};
exports.default = _default;

},{"./account-usage-form.html":374,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout","moment":"moment","themes":1018,"utils/core-utils":1027,"utils/form-utils":1030,"utils/size-utils":1043}],376:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<section class=\"column greedy tabs\">\n    <nav>\n        <a ko.attr.href=\"tabHref('traffic')\"\n            ko.css.selected=\"selectedTab.eq('traffic')\"\n        >\n            Traffic\n        </a>\n        <a ko.attr.href=\"tabHref('utilization')\"\n            ko.css.selected=\"selectedTab.eq('utilization')\"\n        >\n            Utilization\n        </a>\n        <a ko.attr.href=\"tabHref('cloud-consumption')\"\n            ko.css.selected=\"selectedTab.eq('cloud-consumption')\"\n        >\n            Cloud Services Consumption\n        </a>\n        <a ko.attr.href=\"tabHref('relations')\"\n            ko.css.selected=\"selectedTab.eq('relations')\"\n        >\n            Data Insights\n        </a>\n    </nav>\n    <div class=\"tabs-row\">\n        <!-- ko if: selectedTab.eq('traffic') -->\n        <div class=\"tab column selected fade-in\">\n            <bucket-usage-form></bucket-usage-form>\n        </div>\n        <!-- /ko -->\n\n        <!-- ko if: selectedTab.eq('utilization') -->\n        <div class=\"tab column selected fade-in\">\n            <analytics-resource-distribution-form></analytics-resource-distribution-form>\n            <hr>\n            <objects-distribution-form></objects-distribution-form>\n        </div>\n        <!-- /ko -->\n\n        <!-- ko if: selectedTab.eq('cloud-consumption') -->\n        <div class=\"tab column selected fade-in\">\n            <cloud-usage-stats-form></cloud-usage-stats-form>\n        </div>\n        <!-- /ko -->\n\n        <!-- ko if: selectedTab.eq('relations') -->\n        <div class=\"tab column selected fade-in\">\n            <data-breakdown-form></data-breakdown-form>\n        </div>\n        <!-- /ko -->\n    </div>\n</section>\n\n";

},{}],377:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _analyticsPanel = _interopRequireDefault(require("./analytics-panel.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _browserUtils = require("utils/browser-utils");

/* Copyright (C) 2016 NooBaa */
class AnalyticsPanelViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "baseRoute", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "selectedTab", _knockout.default.observable());
  }

  selectState(state) {
    return [state.location];
  }

  mapStateToProps(location) {
    const {
      route,
      params
    } = location;
    const {
      system,
      tab = 'traffic'
    } = params;

    _knockout.default.assignToProps(this, {
      baseRoute: (0, _browserUtils.realizeUri)(route, {
        system
      }, {}, true),
      selectedTab: tab
    });
  }

  tabHref(tab) {
    const baseRoute = this.baseRoute();
    if (!baseRoute) return;
    return (0, _browserUtils.realizeUri)(baseRoute, {
      tab
    });
  }

}

var _default = {
  viewModel: AnalyticsPanelViewModel,
  template: _analyticsPanel.default
};
exports.default = _default;

},{"./analytics-panel.html":376,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"components/connectable":446,"knockout":"knockout","utils/browser-utils":1021}],378:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"card-shadow hpad pad-top column push-next\">\n    <div class=\"row content-middle\">\n        <h2 class=\"heading3 push-next\">\n            Buckets Distribution on Resource\n        </h2>\n        <p class=\"remark content-middle\" ko.visible=\"dataReady\">\n            <svg-icon class=\"icon-small\" params=\"name: 'clock'\"></svg-icon>\n            Updated: {{lastUpdateTime}}\n        </p>\n    </div>\n    <p>The top storage consumer buckets per resource of the total usage of the selected resource</p>\n    <editor params=\"label: 'Choose Resource'\">\n        <dropdown params=\"\n            options: resourceOptions,\n            selected: ko.pc(selectedResource, val => onSelectResource(val)),\n            disabled: !dataReady(),\n            placeholder: 'Select Resource',\n        \"></dropdown>\n    </editor>\n</div>\n\n<div class=\"pad\">\n    <chartjs params=\"\n        type: 'bar',\n        options: barsOptions,\n        data: barsData,\n        emptyMessage: 'This resource is not connected to any bucket',\n        forceEmptyMessage: barsIsEmpty\n    \"></chartjs>\n</div>\n";

},{}],379:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _analyticsResourceDistributionForm = _interopRequireDefault(require("./analytics-resource-distribution-form.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _stringUtils = require("utils/string-utils");

var _coreUtils = require("utils/core-utils");

var _browserUtils = require("utils/browser-utils");

var _sizeUtils = require("utils/size-utils");

var _resourceUtils = require("utils/resource-utils");

var _actionCreators = require("action-creators");

var _knockout = _interopRequireDefault(require("knockout"));

var _themes = _interopRequireDefault(require("themes"));

var _moment = _interopRequireDefault(require("moment"));

var _numeral = _interopRequireDefault(require("numeral"));

/* Copyright (C) 2016 NooBaa */
const MIN_COL_COUNT = 4;
const MAX_COL_COUNT = 6;
const hostsIcon = {
  name: 'nodes-pool'
};
const placeholderBar = {
  label: {
    text: '',
    tooltipTitle: '',
    tooltipBody: ''
  },
  value: 0
};
const options = (0, _coreUtils.deepFreeze)({
  scales: {
    yAxes: [{
      scaleLabel: {
        display: true,
        labelString: 'Raw Usage'
      },
      ticks: {
        // Using space for visual padding.
        callback: size => `${size && (0, _sizeUtils.formatSize)(Math.round(size))}${' '.repeat(5)}`
      }
    }],
    xAxes: [{
      gridLines: {
        display: false
      },
      ticks: {
        callback: label => label.text
      }
    }]
  },
  tooltips: {
    position: 'nearest',
    displayColors: false,
    custom: tooltip => {
      if (!tooltip.title || tooltip.title.length === 0) {
        tooltip.opacity = 0;
      }
    },
    callbacks: {
      title: (items, data) => data.labels[items[0].index].tooltipTitle,
      label: (item, data) => data.labels[item.index].tooltipBody
    }
  }
});
const compareDistributionRecords = (0, _coreUtils.createCompareFunc)(record => record.size, -1);

function _getResourceIcon(resource) {
  if (resource.type == 'HOSTS') {
    return {
      icon: hostsIcon
    };
  } else if (resource.type === 'CLOUD') {
    const {
      name: icon
    } = (0, _resourceUtils.getCloudResourceTypeIcon)({
      type: resource.cloudType
    });
    return {
      icon: `${icon}`
    };
  }
}

function _getResourceOption(resource) {
  const {
    icon,
    selectedIcon
  } = _getResourceIcon(resource);

  return {
    value: `${resource.type}:${resource.name}`,
    label: resource.name,
    icon: icon,
    selectedIcon: selectedIcon
  };
}

function _getDistributionBars(distribution) {
  const len = distribution.length;
  const bars = [];
  const bucketBarsCount = len <= MAX_COL_COUNT ? len : MAX_COL_COUNT - 1;
  bars.push(...distribution.slice(0, bucketBarsCount).map(record => ({
    label: {
      text: (0, _stringUtils.shortString)(record.bucket, 16, 0),
      tooltipTitle: record.bucket,
      tooltipBody: `Raw Usage: ${(0, _sizeUtils.formatSize)(record.size)}`
    },
    value: record.size
  })));

  if (len < MIN_COL_COUNT) {
    bars.push(...(0, _coreUtils.makeArray)(MIN_COL_COUNT - len, () => placeholderBar));
  } else if (len > MAX_COL_COUNT) {
    const others = distribution.slice(MAX_COL_COUNT - 1);
    const size = (0, _coreUtils.sumBy)(others, record => record.size);
    const label = `Other Buckets (${(0, _numeral.default)(others.length).format(',')})`;
    const list = others.map(record => `${record.bucket}: ${(0, _sizeUtils.formatSize)(record.size)}`);
    bars.push({
      label: {
        text: label,
        tooltipTitle: label,
        tooltipBody: [...list, `Total Usage: ${(0, _sizeUtils.formatSize)(size)}`]
      },
      value: size
    });
  }

  return bars;
}

class AnalyticsPanelViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "pathname", '');
    (0, _defineProperty2.default)(this, "resourceOptions", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "lastUpdateTime", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "selectedResource", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "barsIsEmpty", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "barsOptions", options);
    (0, _defineProperty2.default)(this, "barsData", {
      labels: _knockout.default.observableArray(),
      datasets: _knockout.default.observableArray()
    });
    (0, _defineProperty2.default)(this, "selectResources", (0, _coreUtils.memoize)((hostPools, cloudResource) => {
      if (!hostPools || !cloudResource) {
        return;
      }

      return [...Object.values(hostPools).map(pool => ({
        type: 'HOSTS',
        name: pool.name
      })), ...Object.values(cloudResource).map(res => ({
        type: 'CLOUD',
        name: res.name,
        cloudType: res.type
      }))];
    }));
    (0, _defineProperty2.default)(this, "selectUsageDistirbution", (0, _coreUtils.memoize)((resType, resName, buckets) => {
      return (0, _resourceUtils.getUsageDistribution)(resType, resName, buckets).sort(compareDistributionRecords);
    }));
  }

  selectState(state) {
    const {
      location,
      hostPools,
      cloudResources,
      buckets,
      session
    } = state;
    const resources = this.selectResources(hostPools, cloudResources);
    const first = resources && resources[0];
    const {
      resourceType = first && first.type,
      resourceName = first && first.name
    } = location.query;
    const distribution = buckets && this.selectUsageDistirbution(resourceType, resourceName, buckets);
    const resourceId = resourceType && resourceName && `${resourceType}:${resourceName}`;
    return [resources, resourceId, distribution, location.pathname, _themes.default[session.uiTheme]];
  }

  mapStateToProps(resources, selectedResource, distribution, pathname, theme) {
    if (!resources || !distribution) {
      _knockout.default.assignToProps(this, {
        dataReady: false
      });
    } else {
      const resourceOptions = resources.map(_getResourceOption);

      const bars = _getDistributionBars(distribution);

      const lastUpdate = distribution.reduce((lastUpdate, record) => Math.min(lastUpdate, record.lastUpdate), Date.now());

      _knockout.default.assignToProps(this, {
        dataReady: true,
        pathname: pathname,
        resourceOptions: resourceOptions,
        lastUpdateTime: (0, _moment.default)(lastUpdate).fromNow(),
        selectedResource: selectedResource,
        barsIsEmpty: distribution.length === 0,
        barsData: {
          labels: bars.map(bar => bar.label),
          datasets: [{
            backgroundColor: theme.color20,
            data: bars.map(bar => bar.value)
          }]
        }
      });
    }
  }

  onSelectResource(resourceId) {
    const [resourceType, resourceName] = resourceId.split(':');
    const url = (0, _browserUtils.realizeUri)(this.pathname, {}, {
      resourceType,
      resourceName
    });
    this.dispatch((0, _actionCreators.requestLocation)(url));
  }

}

var _default = {
  viewModel: AnalyticsPanelViewModel,
  template: _analyticsResourceDistributionForm.default
};
exports.default = _default;

},{"./analytics-resource-distribution-form.html":378,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout","moment":"moment","numeral":"numeral","themes":1018,"utils/browser-utils":1021,"utils/core-utils":1027,"utils/resource-utils":1041,"utils/size-utils":1043,"utils/string-utils":1046}],380:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<managed-form params=\"\n    name: formName,\n    fields: formFields\n\">\n    <div class=\"card-shadow hpad pad-top column\">\n        <div class=\"row\">\n            <div class=\"column greedy push-next\">\n                <h2 class=\"heading3\">System Throughput</h2>\n                <p>Measures how many units of information the system can process in a period of time.</p>\n            </div>\n            <toggle-group params=\"\n                options: chartTypes,\n                selected: ko.pc(chart.type, type => onChartType(type)),\n                disabled: !dataReady()\n            \"></toggle-group>\n        </div>\n        <div class=\"row vpad content-middle\">\n            <dropdown class=\"push-next\" params=\"\n                options: bucketOptions,\n                multiselect: true,\n                filter: true,\n                selected: $form.selectedBuckets,\n                disabled: !dataReady(),\n                placeholder: 'Select Buckets',\n                subject: 'bucket'\n            \"></dropdown>\n            <dropdown class=\"push-next\" params=\"\n                options: durationOptions,\n                selected: $form.selectedDuration,\n                disabled: !dataReady(),\n            \"></dropdown>\n            <svg-icon class=\"spin match-theme\"\n                params=\"name: 'in-progress'\"\n                ko.visible=\"!dataReady()\"\n            ></svg-icon>\n        </div>\n\n    </div>\n    <div class=\"row pad\">\n        <counter class=\"push-next\" params=\"\n            label: 'Total Data Reads',\n            value: totalReads,\n            color: 'rgb(var(--color20))',\n            format: 'size'\n        \"></counter>\n\n        <counter class=\"push-prev\" params=\"\n            label: 'Total Data Writes',\n            value: totalWrites,\n            color: 'rgb(var(--color28))',\n            format: 'size'\n        \"></counter>\n    </div>\n\n    <chartjs class=\"pad push-next\" params=\"\n        type: chart.type,\n        options: chart.options,\n        data: chart.data,\n        emptyMessage: chart.emptyMessage\n    \"></chartjs>\n</managed-form>\n";

},{}],381:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _bucketUsageForm = _interopRequireDefault(require("./bucket-usage-form.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _moment = _interopRequireDefault(require("moment"));

var _coreUtils = require("utils/core-utils");

var _sizeUtils = require("utils/size-utils");

var _formUtils = require("utils/form-utils");

var _colorUtils = require("utils/color-utils");

var _browserUtils = require("utils/browser-utils");

var _themes = _interopRequireDefault(require("themes"));

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const durations = (0, _coreUtils.deepFreeze)({
  DAY: {
    label: 'Last 24 Hours',
    timespan: 24,
    stepSize: 1,
    stepUnit: 'hour',
    tickFormat: 'HH:mm'
  },
  WEEK: {
    label: 'Last 7 Days',
    timespan: 7,
    stepSize: 1,
    stepUnit: 'day',
    tickFormat: 'D MMM'
  },
  MONTH: {
    label: 'Last 4 Weeks',
    timespan: 28,
    stepSize: 7,
    stepUnit: 'day',
    tickFormat: 'D MMM'
  }
});
const durationOptions = (0, _coreUtils.deepFreeze)(Object.entries(durations).map(pair => ({
  value: pair[0],
  label: pair[1].label
})));
const chartTypes = (0, _coreUtils.deepFreeze)([{
  value: 'bar',
  icon: 'bar-chart'
}, {
  value: 'line',
  icon: 'line-chart'
}]);

function _calcTimeMeta(duration, now) {
  const durationMeta = durations[duration];
  const {
    timespan,
    stepUnit,
    stepSize
  } = durationMeta;
  const end = (0, _moment.default)(now).add(1, stepUnit).startOf(stepUnit).valueOf();
  const start = (0, _moment.default)(end).subtract(timespan, stepUnit).valueOf();

  const step = _moment.default.duration(stepSize, stepUnit).valueOf();

  return {
    start,
    end,
    step
  };
}

function _prepareBarChartParams(samples, timeMeta, tickFormat, _, theme) {
  const {
    end,
    start,
    step
  } = timeMeta;
  const groups = (0, _coreUtils.groupBy)(samples, sample => Math.floor((sample.startTime - start) / step));
  const bars = (0, _coreUtils.makeArray)((end - start) / step, i => {
    const {
      readSize,
      writeSize
    } = groups[i].reduce((aggr, sample) => ({
      readSize: (0, _sizeUtils.sumSize)(aggr.readSize, sample.readSize),
      writeSize: (0, _sizeUtils.sumSize)(aggr.writeSize, sample.writeSize)
    }), {
      readSize: 0,
      writeSize: 0
    });
    const label = `${(0, _moment.default)(start + i * step).format(tickFormat)} - ${(0, _moment.default)(start + (i + 1) * step).format(tickFormat)}`;
    return {
      label,
      readSize,
      writeSize
    };
  });
  return {
    type: 'bar',
    data: {
      labels: bars.map(bar => bar.label),
      datasets: [{
        backgroundColor: theme.color20,
        data: bars.map(bar => (0, _sizeUtils.toBytes)(bar.readSize))
      }, {
        backgroundColor: theme.color28,
        data: bars.map(bar => (0, _sizeUtils.toBytes)(bar.writeSize))
      }]
    },
    options: {
      scales: {
        yAxes: [{
          scaleLabel: {
            display: true,
            labelString: 'Aggregated R/W'
          },
          ticks: {
            suggestedMax: 10,
            // Using space for visual padding.
            callback: size => `${size && (0, _sizeUtils.formatSize)(size)}${' '.repeat(5)}`
          }
        }],
        xAxes: [{
          categoryPercentage: .4,
          ticks: {
            fontColor: theme.color11
          }
        }]
      },
      tooltips: {
        position: 'nearest',
        callbacks: {
          title: items => items[0].xLabel,
          label: item => `Total ${item.datasetIndex === 0 ? 'reads' : 'writes'}: ${(0, _sizeUtils.formatSize)(item.yLabel)}`
        }
      }
    },
    emptyMessage: ''
  };
}

function _prepareLineChartParams(samples, timeMeta, tickFormat, now, theme) {
  const data = samples.filter(sample => sample.endTime <= now);
  const commonLineDatasetSettings = {
    pointRadius: 3,
    pointBorderWidth: 4,
    pointHitRadius: 10,
    pointBorderColor: (0, _colorUtils.colorToRgb)(...(0, _colorUtils.rgbToColor)(theme.color11), .2),
    pointHoverBorderColor: 'transparent',
    backgroundColor: 'transparent',
    lineTension: 0,
    fill: false
  };
  return {
    type: 'line',
    data: {
      datasets: [{ ...commonLineDatasetSettings,
        pointBackgroundColor: theme.color20,
        borderColor: theme.color20,
        data: data.map(sample => ({
          x: sample.endTime + 1,
          y: (0, _sizeUtils.toBytes)(sample.readSize)
        }))
      }, { ...commonLineDatasetSettings,
        pointBackgroundColor: theme.color28,
        borderColor: theme.color28,
        data: data.map(sample => ({
          x: sample.endTime + 1,
          y: (0, _sizeUtils.toBytes)(sample.writeSize)
        }))
      }]
    },
    options: {
      scales: {
        yAxes: [{
          scaleLabel: {
            display: true,
            labelString: 'R/W'
          },
          ticks: {
            suggestedMax: 10,
            // Using space for visual padding.
            callback: size => `${size && (0, _sizeUtils.formatSize)(size)}${' '.repeat(5)}`
          }
        }],
        xAxes: [{
          type: 'linear',
          ticks: {
            max: timeMeta.end,
            min: timeMeta.start,
            stepSize: timeMeta.step,
            callback: timestamp => ['', (0, _moment.default)(timestamp).format(tickFormat)]
          }
        }]
      },
      tooltips: {
        position: 'nearest',
        displayColors: false,
        callbacks: {
          title: items => {
            const {
              startTime,
              endTime
            } = data[items[0].index];
            return `${(0, _moment.default)(startTime).format('D MMM HH:mm')} - ${(0, _moment.default)(endTime).format('D MMM HH:mm')}`;
          },
          label: item => `Total ${item.datasetIndex === 0 ? 'reads' : 'writes'}: ${(0, _sizeUtils.formatSize)(item.yLabel)}`
        }
      }
    },
    emptyMessage: ''
  };
}

function _perpareChartParams(chartType, ...args) {
  return chartType === 'bar' && _prepareBarChartParams(...args) || chartType === 'line' && _prepareLineChartParams(...args);
}

class BucketUsageFormViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "formName", this.constructor.name);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "pathname", '');
    (0, _defineProperty2.default)(this, "durationOptions", durationOptions);
    (0, _defineProperty2.default)(this, "bucketOptions", _knockout.default.observableArray());
    (0, _defineProperty2.default)(this, "chartTypes", chartTypes);
    (0, _defineProperty2.default)(this, "totalReads", _knockout.default.observable(0));
    (0, _defineProperty2.default)(this, "totalWrites", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "formFields", {
      initialized: false,
      selectedBuckets: [],
      selectedDuration: durationOptions[0].value
    });
    (0, _defineProperty2.default)(this, "chart", {
      type: _knockout.default.observable(),
      options: _knockout.default.observable(),
      data: _knockout.default.observable(),
      emptyMessage: _knockout.default.observable()
    });
  }

  onState(state, params) {
    super.onState(state, params);
    this.initializeForm(state);
    this.fetchThroughput(state);
  }

  initializeForm(state) {
    const form = state.forms[this.formName];
    if (!form) return;

    if (state.buckets && !(0, _formUtils.getFieldValue)(form, 'initialized')) {
      const update = {
        selectedBuckets: Object.keys(state.buckets),
        initialized: true
      };
      this.dispatch((0, _actionCreators.updateForm)(this.formName, update, false));
    }
  }

  fetchThroughput(state) {
    const form = state.forms[this.formName];
    if (!form) return;
    const {
      buckets = [],
      duration
    } = state.bucketUsageHistory.query || {};
    const {
      selectedBuckets,
      selectedDuration
    } = (0, _formUtils.getFormValues)(form);

    if (duration !== selectedDuration || !(0, _coreUtils.equalItems)(buckets, selectedBuckets)) {
      this.dispatch((0, _actionCreators.fetchBucketUsageHistory)(selectedBuckets, selectedDuration));
    }
  }

  selectState(state) {
    const {
      forms,
      buckets,
      bucketUsageHistory,
      location,
      session
    } = state;
    return [forms[this.formName], buckets, bucketUsageHistory, location, _themes.default[session.uiTheme]];
  }

  mapStateToProps(form, buckets, usageHistory, location, theme) {
    const {
      chart: chartType = 'bar'
    } = location.query;

    if (!buckets || !usageHistory.samples || !(0, _formUtils.getFieldValue)(form, 'initialized')) {
      _knockout.default.assignToProps(this, {
        dataReady: false,
        pathname: location.pathname,
        chart: {
          type: chartType,
          emptyMessage: 'Loading data...'
        }
      });
    } else {
      const chartDuration = usageHistory.query.duration;
      const {
        tickFormat
      } = durations[chartDuration];
      const now = Date.now();

      const timeMeta = _calcTimeMeta(chartDuration, now);

      const {
        samples
      } = usageHistory;
      const totalReads = (0, _coreUtils.sumBy)(samples, sample => (0, _sizeUtils.toBytes)(sample.readSize));
      const totalWrites = (0, _coreUtils.sumBy)(samples, sample => (0, _sizeUtils.toBytes)(sample.writeSize));

      _knockout.default.assignToProps(this, {
        dataReady: true,
        pathname: location.pathname,
        bucketOptions: Object.keys(buckets),
        totalReads: totalReads,
        totalWrites: totalWrites,
        chart: _perpareChartParams(chartType, samples, timeMeta, tickFormat, now, theme)
      });
    }
  }

  onChartType(type) {
    const url = (0, _browserUtils.realizeUri)(this.pathname, {}, {
      chart: type
    });
    this.dispatch((0, _actionCreators.requestLocation)(url));
  }

  dispose() {
    this.dispatch((0, _actionCreators.dropBucketUsageHistory)());
    super.dispose();
  }

}

var _default = {
  viewModel: BucketUsageFormViewModel,
  template: _bucketUsageForm.default
};
exports.default = _default;

},{"./bucket-usage-form.html":380,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout","moment":"moment","themes":1018,"utils/browser-utils":1021,"utils/color-utils":1026,"utils/core-utils":1027,"utils/form-utils":1030,"utils/size-utils":1043}],382:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n<div class=\"card-shadow hpad pad row content-middle\">\n     <dropdown class=\"push-next\" params=\"\n        multiselect: true,\n        options: serviceOptions,\n        selected: ko.pc(selectedServices, onSelectServices, $component),\n        disabled: !dataReady(),\n        subject: 'service'\n    \"></dropdown>\n     <dropdown class=\"push-next\" params=\"\n        options: durationOptions,\n        selected: ko.pc(selectedDuration, onSelectDuration, $component),\n        disabled: !dataReady(),\n    \"></dropdown>\n    <svg-icon class=\"spin match-theme\"\n        params=\"name: 'in-progress'\"\n        ko.visible=\"!dataReady()\"\n    ></svg-icon>\n</div>\n<div class=\"row pad-top\">\n    <section class=\"c6 column hpad\">\n        <h2 class=\"heading3\">I/O Operations Per Cloud Service</h2>\n        <p>Input/Output operations sent to and from NooBaa to connected cloud services</p>\n    </section>\n    <section class=\"c6 column hpad\">\n        <h2 class=\"heading3\">Egress Per Cloud Service</h2>\n        <p>\n            The size of the data NooBaa read from each cloud service\n        </p>\n    </section>\n</div>\n<div class=\"row push-next\">\n    <section class=\"c6 column pad border-right\">\n        <div class=\"row push-next\">\n            <counter class=\"push-next\" params=\"\n                label: 'Total Reads',\n                value: totalReads,\n                color: 'rgb(var(--color20)',\n                format: 'number'\n            \"></counter>\n            <counter class=\"push-prev\" params=\"\n                label: 'Total Writes',\n                value: totalWrites,\n                color: 'rgb(var(--color28)',\n                format: 'number'\n            \"></counter>\n        </div>\n        <chartjs class=\"push-prev\" params=\"\n            type: ioChart.type,\n            options: ioChart.options,\n            data: ioChart.data\n        \"></chartjs>\n    </section>\n    <section class=\"c6 pad column\">\n        <counter class=\"push-next\" params=\"\n            label: 'Total Egress',\n            value: totalEgress,\n            color: 'rgb(var(--color20)',\n            format: 'size'\n        \"></counter>\n        <chartjs class=\"push-prev\"  params=\"\n            type: egressChart.type,\n            options: egressChart.options,\n            data: egressChart.data\n        \"></chartjs>\n    </section>\n</div>\n<p class=\"pad highlight remark row content-middle\">\n    <svg-icon class=\"icon-small push-next-quarter\" params=\"name: 'notif-info'\"></svg-icon>\n    NooBaa writes and reads an approximate size of 7MB per day of internal test blocks to each cloud service\n</p>\n\n\n\n";

},{}],383:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _cloudUsageStatsForm = _interopRequireDefault(require("./cloud-usage-stats-form.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _cloudUtils = require("utils/cloud-utils");

var _browserUtils = require("utils/browser-utils");

var _sizeUtils = require("utils/size-utils");

var _actionCreators = require("action-creators");

var _numeral = _interopRequireDefault(require("numeral"));

var _themes = _interopRequireDefault(require("themes"));

/* Copyright (C) 2016 NooBaa */
const durationOptions = (0, _coreUtils.deepFreeze)([{
  label: 'Last 24 Hours',
  value: 'DAY'
}, {
  label: 'Last 7 Days',
  value: 'WEEK'
}, {
  label: 'Last 4 Weeks',
  value: 'MONTH'
}]);
const s3CompatibleOption = {
  value: 'S3_COMPATIBLE',
  label: 'S3 Compatible service',
  icon: 'cloud'
};
const aspectRatio = 1.5;

class CloudUsageStatsFormViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "pathname", '');
    (0, _defineProperty2.default)(this, "serviceOptions", _knockout.default.observableArray());
    (0, _defineProperty2.default)(this, "durationOptions", durationOptions);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "selectedServices", _knockout.default.observableArray());
    (0, _defineProperty2.default)(this, "selectedDuration", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "totalReads", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "totalWrites", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "totalEgress", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "ioChart", {
      type: 'bar',
      data: _knockout.default.observable(),
      options: {
        aspectRatio,
        scales: {
          yAxes: [{
            scaleLabel: {
              display: true,
              labelString: 'I/O Operations'
            },
            ticks: {
              callback: count => `${(0, _numeral.default)(count).format('0,0')}${' '.repeat(5)}`
            }
          }]
        },
        tooltips: {
          position: 'nearest',
          callbacks: {
            title: items => items[0].xLabel,
            label: item => `Total ${item.datasetIndex === 0 ? 'Reads' : 'Writes'}: ${item.yLabel}`
          }
        }
      }
    });
    (0, _defineProperty2.default)(this, "egressChart", {
      type: 'bar',
      data: _knockout.default.observable(),
      options: {
        aspectRatio,
        scales: {
          yAxes: [{
            scaleLabel: {
              display: true,
              labelString: 'Egress'
            },
            ticks: {
              suggestedMax: 10,
              callback: size => `${size && (0, _sizeUtils.formatSize)(size)}${' '.repeat(5)}`
            }
          }]
        },
        tooltips: {
          position: 'nearest',
          displayColors: false,
          callbacks: {
            label: item => `Total Egress: ${(0, _sizeUtils.formatSize)(item.yLabel)}`
          }
        }
      }
    });
  }

  onState(state, params) {
    super.onState(state, params);
    this.fetchStats(state);
  }

  selectState(state) {
    const {
      cloudUsageStats,
      location,
      session
    } = state;
    return [cloudUsageStats, location, _themes.default[session.uiTheme]];
  }

  mapStateToProps(cloudUsageStats, location, theme) {
    const {
      pathname,
      query
    } = location;
    const duration = query.duration || 'DAY';

    if (!cloudUsageStats.usage) {
      _knockout.default.assignToProps(this, {
        dataReady: false,
        pathname: pathname,
        serviceOptions: [],
        selectedServices: [],
        selectedDuration: duration
      });
    } else {
      const serviceOptions = Object.keys(cloudUsageStats.usage).map(service => {
        if (service === 'S3_COMPATIBLE') {
          return s3CompatibleOption;
        } else {
          const {
            value,
            displayName: label,
            icon,
            selectedIcon
          } = _cloudUtils.cloudServices.find(meta => meta.value === service);

          return {
            value,
            label,
            icon,
            selectedIcon
          };
        }
      });
      const services = query.services === 'NONE' && [] || query.services && query.services.split('|') || serviceOptions.map(option => option.value);
      const bars = services.map(service => {
        const {
          label
        } = serviceOptions.find(option => option.value === service);
        const {
          readCount: reads,
          writeCount: writes,
          readSize
        } = cloudUsageStats.usage[service];
        const egress = (0, _sizeUtils.toBytes)(readSize);
        return {
          label,
          reads,
          writes,
          egress
        };
      });
      const totalReads = (0, _coreUtils.sumBy)(bars, bar => bar.reads);
      const totalWrites = (0, _coreUtils.sumBy)(bars, bar => bar.writes);
      const totalEgress = (0, _sizeUtils.sumSize)(...bars.map(bar => bar.egress));
      const ioChart = {
        data: {
          labels: bars.map(bar => bar.label),
          datasets: [{
            backgroundColor: theme.color20,
            data: bars.map(bar => bar.reads)
          }, {
            backgroundColor: theme.color28,
            data: bars.map(bar => bar.writes)
          }]
        }
      };
      const egressChart = {
        data: {
          labels: bars.map(bar => bar.label),
          datasets: [{
            backgroundColor: theme.color20,
            data: bars.map(bar => bar.egress)
          }]
        }
      };

      _knockout.default.assignToProps(this, {
        dataReady: true,
        pathname: pathname,
        serviceOptions: serviceOptions,
        selectedServices: services,
        selectedDuration: duration,
        totalReads: totalReads,
        totalWrites: totalWrites,
        totalEgress: totalEgress,
        ioChart: ioChart,
        egressChart: egressChart
      });
    }
  }

  fetchStats(state) {
    const duration = this.selectedDuration();
    const {
      query
    } = state.cloudUsageStats;

    if (!query || query.duration !== duration) {
      this.dispatch((0, _actionCreators.fetchCloudUsageStats)(duration));
    }
  }

  onSelectServices(services) {
    this.onQuery({
      services
    });
  }

  onSelectDuration(duration) {
    this.onQuery({
      duration
    });
  }

  onQuery(query) {
    const {
      services: _services = this.selectedServices(),
      duration = this.selectedDuration()
    } = query;
    const services = _services.length > 0 ? _services.join('|') : 'NONE';
    const url = (0, _browserUtils.realizeUri)(this.pathname, {}, {
      services,
      duration
    });
    this.dispatch((0, _actionCreators.requestLocation)(url));
  }

  dispose() {
    this.dispatch((0, _actionCreators.dropCloudUsageStats)());
    super.dispose();
  }

}

var _default = {
  viewModel: CloudUsageStatsFormViewModel,
  template: _cloudUsageStatsForm.default
};
exports.default = _default;

},{"./cloud-usage-stats-form.html":382,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout","numeral":"numeral","themes":1018,"utils/browser-utils":1021,"utils/cloud-utils":1024,"utils/core-utils":1027,"utils/size-utils":1043}],384:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"card-shadow hpad pad-top column push-next\">\n    <h2 class=\"heading3\">\n        Used Data vs R/W\n    </h2>\n    <p class=\"push-next\">\n        Control storage efficiency and allocate appropriate resources according to usage charactisities\n    </p>\n</div>\n\n<radio-group class=\"pad\" params=\"\n    options: viewOptions,\n    selected: ko.pc(selectedView, onSelectView, $component)\n\"></radio-group>\n\n<chart-legend class=\"hpad legend-row\"\n    params=\"items: legend, format: 'size'\"\n></chart-legend>\n\n<chartjs class=\"pad\" params=\"\n    type: chart.type,\n    data: chart.data,\n    options: chart.options\n\"></chartjs>\n\n\n\n";

},{}],385:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _dataBreakdownForm = _interopRequireDefault(require("./data-breakdown-form.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _coreUtils = require("utils/core-utils");

var _sizeUtils = require("utils/size-utils");

var _browserUtils = require("utils/browser-utils");

var _knockout = _interopRequireDefault(require("knockout"));

var _numeral = _interopRequireDefault(require("numeral"));

var _themes = _interopRequireDefault(require("themes"));

var _actionCreators = require("action-creators");

var _colorUtils = require("utils/color-utils");

/* Copyright (C) 2016 NooBaa */
const viewOptions = (0, _coreUtils.deepFreeze)([{
  value: 'BUCKETS',
  label: 'By Buckets'
}, {
  value: 'DATA_TYPES',
  label: 'By Data Types'
}]);
const compareRadius = (0, _coreUtils.createCompareFunc)(bubble => bubble.r, -1);

function _getBubblesForBuckets(buckets) {
  return buckets.map(bucket => ({
    label: bucket.name,
    x: bucket.io.readCount,
    y: bucket.io.writeCount,
    r: (0, _sizeUtils.toBytes)(bucket.data.size)
  }));
}

function _getBubblesForDataTypes(buckets) {
  const bubbles = {};

  for (const {
    statsByDataType
  } of buckets) {
    for (const [dataType, stats] of Object.entries(statsByDataType)) {
      if (!bubbles[dataType]) {
        bubbles[dataType] = {
          label: dataType,
          x: stats.reads,
          y: stats.writes,
          r: (0, _sizeUtils.toBytes)(stats.size)
        };
      } else {
        const bubble = bubbles[dataType];
        bubble.x += stats.reads;
        bubble.y += stats.writes;
        bubble.r += (0, _sizeUtils.toBytes)(stats.size);
      }
    }
  }

  return Object.values(bubbles);
}

function _prepareDatasets(view, buckets, theme) {
  const colors = [theme.color20, theme.color28, theme.color30, theme.color26, theme.color27, theme.color17];
  const maxCount = colors.length;
  let bubbles = view === 'BUCKETS' ? _getBubblesForBuckets(buckets) : _getBubblesForDataTypes(buckets);
  bubbles = bubbles.sort(compareRadius);

  if (bubbles.length > maxCount) {
    const lastBubble = bubbles.slice(maxCount - 1).reduce((bubble, other, i) => {
      const subject = view === 'BUCKETS' ? 'Buckets' : 'Data Types';
      bubble.label = `Other ${subject} (${(0, _numeral.default)(i + 1).format(',')})`;
      bubble.x += other.x;
      bubble.y += other.y, bubble.r += other.r;
      return bubble;
    });
    bubbles = [...bubbles.slice(0, maxCount - 1), lastBubble];
  }

  return bubbles.map((bubble, i) => ({
    label: bubble.label,
    backgroundColor: (0, _colorUtils.colorToRgb)(...(0, _colorUtils.rgbToColor)(colors[i]), 0.3),
    borderColor: colors[i],
    borderWidth: 2,
    dataSize: bubble.r,
    data: [{
      x: bubble.x,
      y: bubble.y,
      r: 2 + (Math.log2(Math.max(bubble.r, 1)) / 5) ** 2
    }]
  }));
}

class DataBreakdownFormViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "pathname", '');
    (0, _defineProperty2.default)(this, "viewOptions", viewOptions);
    (0, _defineProperty2.default)(this, "selectedView", _knockout.default.observable(viewOptions[0].value));
    (0, _defineProperty2.default)(this, "legend", _knockout.default.observableArray());
    (0, _defineProperty2.default)(this, "chart", {
      type: 'bubble',
      data: _knockout.default.observable(),
      options: {
        scales: {
          xAxes: [{
            gridLines: {
              display: false
            },
            scaleLabel: {
              display: true,
              labelString: 'Number of Reads'
            },
            ticks: {
              suggestedMax: 100,
              // Using space for visual padding.
              callback: count => `${(0, _numeral.default)(count).format(',')}${' '.repeat(5)}`
            }
          }],
          yAxes: [{
            scaleLabel: {
              display: true,
              labelString: 'Number of Writes'
            },
            ticks: {
              suggestedMax: 100,
              // Using space for visual padding.
              callback: count => `${(0, _numeral.default)(count).format(',')}${' '.repeat(5)}`
            }
          }]
        },
        tooltips: {
          displayColors: false,
          callbacks: {
            title: (items, data) => data.datasets[items[0].datasetIndex].label,
            label: (item, data) => {
              const {
                r
              } = data.datasets[item.datasetIndex].data[0];
              return [`Nubmer of Reads: ${item.xLabel}`, `Nubmer of Writes: ${item.yLabel}`, `Bucket Data Usage: ${(0, _sizeUtils.formatSize)(2 ** (Math.sqrt(r - 2) * 5))}`];
            }
          }
        }
      }
    });
  }

  selectState(state) {
    const {
      buckets,
      location,
      session
    } = state;
    return [buckets, location, session && _themes.default[session.uiTheme]];
  }

  mapStateToProps(buckets, location, theme) {
    const {
      view = 'BUCKETS'
    } = location.query;

    if (!buckets || !theme) {
      _knockout.default.assignToProps(this, {
        dataReady: false,
        selectedView: view,
        pathname: location.pathname
      });
    } else {
      const bucketList = Object.values(buckets).filter(bucket => bucket.storage.used !== 0);

      const datasets = _prepareDatasets(view, bucketList, theme);

      const legend = datasets.map(dataset => ({
        color: dataset.borderColor,
        label: dataset.label,
        value: dataset.dataSize
      }));

      _knockout.default.assignToProps(this, {
        dataReady: true,
        pathname: location.pathname,
        selectedView: view,
        chart: {
          data: {
            datasets
          }
        },
        legend: legend
      });
    }
  }

  onSelectView(view) {
    const url = (0, _browserUtils.realizeUri)(this.pathname, {}, {
      view
    });
    this.dispatch((0, _actionCreators.requestLocation)(url, true));
    this.selectedView(view);
  }

}

var _default = {
  viewModel: DataBreakdownFormViewModel,
  template: _dataBreakdownForm.default
};
exports.default = _default;

},{"./data-breakdown-form.html":384,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout","numeral":"numeral","themes":1018,"utils/browser-utils":1021,"utils/color-utils":1026,"utils/core-utils":1027,"utils/size-utils":1043}],386:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"card-shadow hpad pad-top column push-next\">\n    <h2 class=\"heading3\">Objects size per bucket</h2>\n    <p>Object size distribution by bucket</p>\n    <editor params=\"label: 'Choose Bucket'\">\n        <dropdown params=\"\n            options: bucketOptions,\n            selected: ko.pc(selectedBucket, bucket => onSelectBucket(bucket)),\n            disabled: !dataReady(),\n            subject: 'bucket'\n        \"></dropdown>\n    </editor>\n</div>\n\n<div class=\"pad\" ko.with=\"chart\">\n    <chartjs params=\"\n        type: type,\n        options: options,\n        data: data\n    \"></chartjs>\n</div>\n\n\n\n";

},{}],387:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectsDistributionForm = _interopRequireDefault(require("./objects-distribution-form.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _sizeUtils = require("utils/size-utils");

var _browserUtils = require("utils/browser-utils");

var _themes = _interopRequireDefault(require("themes"));

var _numeral = _interopRequireDefault(require("numeral"));

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const barCount = 5;
const chartOptions = (0, _coreUtils.deepFreeze)({
  scales: {
    yAxes: [{
      scaleLabel: {
        display: true,
        labelString: 'Number of Objects'
      },
      ticks: {
        callback: count => (0, _numeral.default)(count).format('0,0')
      }
    }]
  },
  tooltips: {
    position: 'nearest',
    displayColors: false,
    callbacks: {
      label: item => `Number of Objects: ${(0, _numeral.default)(item.yLabel).format('0,0')}`
    }
  }
});

function _perpareChartBars(distribution) {
  const step = Math.ceil(distribution.length / barCount);
  return (0, _coreUtils.makeArray)(barCount, i => {
    const fromIndex = i * step;
    const toIndex = fromIndex + step;
    const label = `${(0, _sizeUtils.formatSize)(fromIndex == 0 ? 0 : 2 ** (fromIndex - 1))} - ${(0, _sizeUtils.formatSize)(2 ** (toIndex - 1))}`;
    const value = (0, _coreUtils.sumBy)(distribution.slice(fromIndex, toIndex), bin => bin.count);
    return {
      label,
      value
    };
  });
}

class BucketObjectsDistributionFormViewModel extends _connectable.default {
  constructor(...args) {
    super(...args); // Fetch bucket object distribution.

    (0, _defineProperty2.default)(this, "pathname", '');
    (0, _defineProperty2.default)(this, "query", {});
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "bucketOptions", _knockout.default.observableArray());
    (0, _defineProperty2.default)(this, "selectedBucket", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "chart", {
      type: 'bar',
      options: chartOptions,
      data: _knockout.default.observable()
    });
    this.dispatch((0, _actionCreators.fetchObjectsDistribution)());
  }

  selectState(state) {
    const {
      buckets,
      location,
      objectsDistribution,
      session
    } = state;
    return [buckets, location, objectsDistribution, session && _themes.default[session.uiTheme]];
  }

  mapStateToProps(buckets, location, distributions, theme) {
    const {
      pathname,
      query
    } = location;

    if (!buckets || !distributions.buckets || !theme) {
      _knockout.default.assignToProps(this, {
        dataReady: false,
        query: query,
        pathname: pathname
      });
    } else {
      const bucketNames = Object.keys(buckets);
      const selectedBucket = query.bucket || bucketNames[0];

      const bars = _perpareChartBars(distributions.buckets[selectedBucket]);

      _knockout.default.assignToProps(this, {
        dataReady: true,
        query: query,
        pathname: pathname,
        selectedBucket: selectedBucket,
        bucketOptions: bucketNames,
        chart: {
          data: {
            labels: bars.map(bar => bar.label),
            datasets: [{
              backgroundColor: theme.color28,
              data: bars.map(bar => bar.value)
            }]
          }
        }
      });
    }
  }

  onSelectBucket(bucket) {
    const url = (0, _browserUtils.realizeUri)(this.pathname, {}, { ...this.query,
      bucket
    });
    this.dispatch((0, _actionCreators.requestLocation)(url));
  }

}

var _default = {
  viewModel: BucketObjectsDistributionFormViewModel,
  template: _objectsDistributionForm.default
};
exports.default = _default;

},{"./objects-distribution-form.html":386,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout","numeral":"numeral","themes":1018,"utils/browser-utils":1021,"utils/core-utils":1027,"utils/size-utils":1043}],388:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"layout-wrapper column\"\n    ko.component=\"layout\"\n    ko.css=\"layout\"\n    ko.globalCss=\"css\"\n></div>\n<modal-manager></modal-manager>\n\n";

},{}],389:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _app = _interopRequireDefault(require("./app.html"));

var _knockout = _interopRequireDefault(require("knockout"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _actionCreators = require("action-creators");

var routes = _interopRequireWildcard(require("routes"));

var _browserUtils = require("utils/browser-utils");

var _config = require("config");

/* Copyright (C) 2016 NooBaa */
class AppViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "layout", _knockout.default.observable('empty'));
    (0, _defineProperty2.default)(this, "css", _knockout.default.observable());
  }

  selectState(state) {
    return [state.env, state.session, state.location, state.lastError];
  }

  mapStateToProps(env, session, location = {}, lastError) {
    if (!env) {
      return;
    }

    if (lastError) {
      this.dispatch((0, _actionCreators.openManagementConsoleErrorModal)());
      return;
    }

    const loggedIn = session && !session.passwordExpired;

    if (loggedIn && !location.route) {
      // Redirect to the system routes
      const url = (0, _browserUtils.realizeUri)(routes.system, {
        system: session.system
      });
      this.dispatch((0, _actionCreators.requestLocation)(url, true));
      return;
    }

    const layout = loggedIn ? 'main-layout' : 'login-layout';
    const previewCss = env.previewContent ? 'preview' : '';
    const themeCss = _config.themes[loggedIn ? session.uiTheme : _config.defaultTheme];
    const css = [previewCss, themeCss].filter(Boolean).join(' ');
    this.layout(layout);
    this.css(css);
  }

}

var _default = {
  viewModel: AppViewModel,
  template: _app.default
};
exports.default = _default;

},{"./app.html":388,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"components/connectable":446,"config":831,"knockout":"knockout","routes":972,"utils/browser-utils":1021}],390:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n<div ko.globalevent.beforeunload=\"onBeforeUnload\"></div>\n";

},{}],391:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _exitConfirmationMessage = _interopRequireDefault(require("./exit-confirmation-message.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
class ExitConfirmationMessageViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "showMessage", false);
  }

  selectState(state) {
    const {
      objectUploads
    } = state;
    return [Boolean(objectUploads && objectUploads.stats.uploading)];
  }

  mapStateToProps(uploadingObjects) {
    _knockout.default.assignToProps(this, {
      showMessage: uploadingObjects
    });
  }

  onBeforeUnload(_, evt) {
    if (this.showMessage) {
      return evt.returnValue = 'Changes you made may not be saved.';
    }
  }

}

var _default = {
  viewModel: ExitConfirmationMessageViewModel,
  template: _exitConfirmationMessage.default
};
exports.default = _default;

},{"./exit-confirmation-message.html":390,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"components/connectable":446,"knockout":"knockout"}],392:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<main class=\"column content-middle pad\" ko.if=\"form\" ko.css=\"form\">\n    <svg-icon class=\"logo align-start push-next\" params=\"name: logo\"></svg-icon>\n    <!-- ko component: form --><!-- /ko -->\n</main>\n";

},{}],393:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _loginLayout = _interopRequireDefault(require("./login-layout.html"));

var _baseViewModel = _interopRequireDefault(require("components/base-view-model"));

var _knockout = _interopRequireDefault(require("knockout"));

var _config = require("config");

var _model = require("model");

var _browserUtils = require("utils/browser-utils");

var _actions = require("actions");

var _coreUtils = require("utils/core-utils");

var _actionCreators = require("action-creators");

var _state = require("state");

var routes = _interopRequireWildcard(require("routes"));

/* Copyright (C) 2016 NooBaa */
class LoginLayoutViewModel extends _baseViewModel.default {
  constructor() {
    super();
    this.logo = _config.logo;
    this.form = _knockout.default.pureComputed(() => {
      console.warn('OMOMOM HERE', (0, _model.loginInfo)());

      if (!_config.supportedBrowsers.includes((0, _browserUtils.recognizeBrowser)())) {
        return 'unsupported-form';
      }

      if (!(0, _model.serverInfo)()) {
        return 'splash-screen';
      }

      const {
        initialized
      } = (0, _model.serverInfo)();

      if (initialized) {
        const session = (0, _model.sessionInfo)();

        if ((0, _coreUtils.isUndefined)(session)) {
          return 'splash-screen';
        } else if (location.pathname === routes.oauthCallback) {
          return 'oauth-callback';
        } else if (!session) {
          // Specific params to force login screen (to allow login using local users)
          const skipOAuth = new URLSearchParams(location.search).get('skip-oauth');

          if ((0, _model.serverInfo)().supportOAuth && skipOAuth == null) {
            if ((0, _model.loginInfo)().unauthorized) {
              _state.action$.next((0, _actionCreators.openOAuthUnauthorizedModal)());

              return 'splash-screen';
            } else {
              this.signInWithOAuth();
              return 'splash-screen';
            }
          }

          return 'signin-form';
        } else if (session.passwordExpired) {
          return 'change-password-form';
        } else {
          return 'empty';
        }
      } else {
        return 'create-system-form';
      }
    });

    if (!(0, _model.serverInfo)()) {
      (0, _actions.loadServerInfo)();
    }
  }

  signInWithOAuth() {
    const {
      pathname
    } = window.location;
    const url = `/oauth/authorize?return-url=${encodeURIComponent(pathname)}`;

    _state.action$.next((0, _actionCreators.requestLocation)(url));
  }

}

var _default = {
  viewModel: LoginLayoutViewModel,
  template: _loginLayout.default
};
exports.default = _default;

},{"./login-layout.html":392,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"actions":320,"components/base-view-model":399,"config":831,"knockout":"knockout","model":936,"routes":972,"state":1016,"utils/browser-utils":1021,"utils/core-utils":1027}],394:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<section class=\"sticky-wrapper\">\n    <maintenance-sticky></maintenance-sticky>\n    <debug-mode-sticky></debug-mode-sticky>\n    <phone-home-connectivity-sticky></phone-home-connectivity-sticky>\n    <cluster-availability-sticky></cluster-availability-sticky>\n    <prefered-browsers-sticky></prefered-browsers-sticky>\n</section>\n\n<div class=\"content-wrapper column greedy\">\n    <header class=\"row content-middle main-header\">\n        <a class=\"logo row content-middle align-stretch\" ko.attr.href=\"logoHref\">\n            <svg-icon params=\"name: logo\"></svg-icon>\n        </a>\n        <breadcrumbs class=\"greedy push-both\" params=\"crumbs: breadcrumbs\">\n        </breadcrumbs>\n        <commands-bar class=\"push-next\"></commands-bar>\n        <account-menu></account-menu>\n    </header>\n    <div class=\"row greedy\">\n        <div class=\"column main-nav\">\n            <side-nav class=\"greedy\" params=\"items: navItems, selected: area\"></side-nav>\n            <!-- <uploads-indicator ko.visible=\"isUploadButtonVisible\"></uploads-indicator> -->\n        </div>\n        <!-- ko if: panel -->\n        <main class=\"column align-stretch greedy bounded vpad\"\n            ko.component=\"panel\"\n            ko.css=\"panel\"\n        ></main>\n        <!-- /ko -->\n    </div>\n    <notification-box></notification-box>\n    <drawer></drawer>\n</div>\n\n<exit-confirmation-message></exit-confirmation-message>\n";

},{}],395:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _mainLayout = _interopRequireDefault(require("./main-layout.html"));

var _observer = _interopRequireDefault(require("observer"));

var _state = require("state");

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _browserUtils = require("utils/browser-utils");

var _actions = require("actions");

var routes = _interopRequireWildcard(require("routes"));

var _routeMapping = _interopRequireDefault(require("./route-mapping"));

var _rxExtensions = require("rx-extensions");

var _config = require("config");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const navItems = (0, _coreUtils.deepFreeze)([
/*{
    route: 'route name', (see routes.js)
    icon: 'icon',
    label: 'label', (display name, optional)
    beta: true/false, (shows a beta label)
    preview: true/false (hide when browser not in preview mode)
},*/
{
  route: 'system',
  icon: 'overview',
  label: 'Overview'
}, {
  route: 'resources',
  icon: 'resources',
  label: 'Resources'
}, {
  route: 'buckets',
  icon: 'buckets',
  label: 'Buckets'
}, {
  route: 'funcs',
  icon: 'functions',
  label: 'Functions'
}, {
  route: 'endpoints',
  icon: 'endpoints',
  label: 'Endpoints'
}, {
  route: 'cluster',
  icon: 'cluster',
  label: 'Cluster',
  preview: true
}, {
  route: 'accounts',
  icon: 'accounts',
  label: 'Accounts'
}, {
  route: 'analytics',
  icon: 'line-chart',
  label: 'Analytics',
  beta: true
}]);

function _mapNavItem(item) {
  const {
    icon,
    label,
    beta,
    preview,
    route: name
  } = item;

  const url = _knockout.default.observable();

  return {
    name,
    url,
    icon,
    label,
    beta,
    preview
  };
}

class MainLayoutViewModel extends _observer.default {
  constructor() {
    super();
    this.logo = _config.logo;
    this.logoHref = _knockout.default.observable();
    this.navItems = navItems.map(_mapNavItem);
    this.breadcrumbs = _knockout.default.observableArray();
    this.area = _knockout.default.observable();
    this.panel = _knockout.default.observable();
    this.isUploadButtonVisible = _knockout.default.observable(false);
    this.observe(_state.state$.pipe((0, _rxExtensions.getMany)('location', 'session')), this.onLocation);
    this.observe(_state.state$.pipe((0, _rxExtensions.getMany)('accounts', ['session', 'user'])), this.onAccount);
    (0, _actions.registerForAlerts)();
  }

  onLocation([location, session]) {
    const {
      route,
      params,
      query
    } = location;
    const {
      system
    } = params;
    const {
      panel,
      area,
      crumbsGenerator
    } = _routeMapping.default[route] || {};
    this.logoHref((0, _browserUtils.realizeUri)(routes.system, {
      system
    }));
    this.breadcrumbs(crumbsGenerator(params));
    this.navItems.forEach(item => item.url((0, _browserUtils.realizeUri)(routes[item.name], {
      system
    })));
    this.area(area);
    this.panel(panel ? `${panel}-panel` : 'empty');
    const {
      welcome
    } = query;

    if (welcome) {
      _state.action$.next((0, _actionCreators.openWelcomeModal)());
    } else if (session && session.expired) {
      _state.action$.next((0, _actionCreators.openSessionExpiredModal)());
    }

    _state.action$.next((0, _actionCreators.fetchSystemInfo)());
  }

  onAccount([accounts, user]) {
    if (!accounts || !user) return;
    const account = accounts[user];
    this.isUploadButtonVisible(account && account.isOwner);
  }

}

var _default = {
  viewModel: MainLayoutViewModel,
  template: _mainLayout.default
};
exports.default = _default;

},{"./main-layout.html":394,"./route-mapping":396,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"actions":320,"config":831,"knockout":"knockout","observer":937,"routes":972,"rx-extensions":974,"state":1016,"utils/browser-utils":1021,"utils/core-utils":1027}],396:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _coreUtils = require("utils/core-utils");

var _browserUtils = require("utils/browser-utils");

var _hostUtils = require("utils/host-utils");

var routes = _interopRequireWildcard(require("routes"));

/* Copyright (C) 2016 NooBaa */
var _default = (0, _coreUtils.deepFreeze)({
  [routes.system]: {
    area: 'system',
    panel: 'overview',
    crumbsGenerator: _generateOverviewCrumbs
  },
  [routes.buckets]: {
    area: 'buckets',
    panel: 'buckets',
    crumbsGenerator: _generateBucketsCrumbs
  },
  [routes.bucket]: {
    panel: 'bucket',
    area: 'buckets',
    crumbsGenerator: _generateDataBucketCrumbs
  },
  [routes.namespaceBucket]: {
    panel: 'namespace-bucket',
    area: 'buckets',
    crumbsGenerator: _generateNamespaceBucketCrumbs
  },
  [routes.object]: {
    area: 'buckets',
    panel: 'object',
    crumbsGenerator: _generateObjectCrumbs
  },
  [routes.resources]: {
    area: 'resources',
    panel: 'resources',
    crumbsGenerator: _generateResourcesCrumb
  },
  [routes.pool]: {
    area: 'resources',
    panel: 'pool',
    crumbsGenerator: _generatePoolCrumbs
  },
  [routes.cloudResource]: {
    area: 'resources',
    panel: 'cloud-resource',
    crumbsGenerator: _generateCloudResourceCrumb
  },
  [routes.host]: {
    area: 'resources',
    panel: 'host',
    crumbsGenerator: _generateHostCrumbs
  },
  [routes.management]: {
    area: 'management',
    panel: 'management',
    crumbsGenerator: _generateManagementCrumbs
  },
  [routes.accounts]: {
    area: 'accounts',
    panel: 'accounts',
    crumbsGenerator: _generateAccountsCrumbs
  },
  [routes.account]: {
    area: 'accounts',
    panel: 'account',
    crumbsGenerator: _generateAccountCrumbs
  },
  [routes.cluster]: {
    area: 'cluster',
    panel: 'cluster',
    crumbsGenerator: _generateClusterCrumbs
  },
  [routes.server]: {
    area: 'cluster',
    panel: 'server',
    crumbsGenerator: _generateServerCrumbs
  },
  [routes.funcs]: {
    area: 'funcs',
    panel: 'funcs',
    crumbsGenerator: _generateFunctionsCrumbs
  },
  [routes.func]: {
    area: 'funcs',
    panel: 'func',
    crumbsGenerator: _generateFunctionCrumbs
  },
  [routes.analytics]: {
    area: 'analytics',
    panel: 'analytics',
    crumbsGenerator: _generateAnalyticsCrumbs
  },
  [routes.endpoints]: {
    area: 'endpoints',
    panel: 'endpoints',
    crumbsGenerator: _generateEndpointCrumbs
  }
});

exports.default = _default;

function _generateOverviewCrumbs(params) {
  return [{
    url: (0, _browserUtils.realizeUri)(routes.system, (0, _coreUtils.pick)(params, ['system'])),
    label: 'Overview'
  }];
}

function _generateBucketsCrumbs(params) {
  return [{
    url: (0, _browserUtils.realizeUri)(routes.buckets, (0, _coreUtils.pick)(params, ['system'])),
    label: 'Buckets'
  }];
}

function _generateDataBucketCrumbs(params) {
  return [..._generateBucketsCrumbs(params), {
    url: (0, _browserUtils.realizeUri)(routes.buckets, { ...(0, _coreUtils.pick)(params, ['system']),
      tab: 'data-buckets'
    }),
    label: 'Data Buckets'
  }, {
    url: (0, _browserUtils.realizeUri)(routes.bucket, (0, _coreUtils.pick)(params, ['system', 'bucket'])),
    label: params.bucket
  }];
}

function _generateNamespaceBucketCrumbs(params) {
  return [..._generateBucketsCrumbs(params), {
    url: (0, _browserUtils.realizeUri)(routes.buckets, { ...(0, _coreUtils.pick)(params, ['system']),
      tab: 'namespace-buckets'
    }),
    label: 'Namespace Buckets'
  }, {
    url: (0, _browserUtils.realizeUri)(routes.namespaceBucket, (0, _coreUtils.pick)(params, ['system', 'bucket'])),
    label: params.bucket
  }];
}

function _generateObjectCrumbs(params) {
  return [..._generateDataBucketCrumbs(params), {
    url: (0, _browserUtils.realizeUri)(routes.object, (0, _coreUtils.pick)(params, ['system', 'bucket', 'object', 'version'])),
    label: params.object
  }];
}

function _generateResourcesCrumb(params) {
  return [{
    url: (0, _browserUtils.realizeUri)(routes.resources, (0, _coreUtils.pick)(params, ['system'])),
    label: 'Resources'
  }];
}

function _generatePoolCrumbs(params) {
  return [..._generateResourcesCrumb(params), {
    url: (0, _browserUtils.realizeUri)(routes.resources, { ...(0, _coreUtils.pick)(params, ['system']),
      tab: 'storage'
    }),
    label: 'Storage Resources'
  }, {
    url: (0, _browserUtils.realizeUri)(routes.pool, (0, _coreUtils.pick)(params, ['system', 'pool'])),
    label: params.pool
  }];
}

function _generateCloudResourceCrumb(params) {
  return [..._generateResourcesCrumb(params), {
    url: (0, _browserUtils.realizeUri)(routes.resources, { ...(0, _coreUtils.pick)(params, ['system']),
      tab: 'storage'
    }),
    label: 'Storage Resources'
  }, {
    url: (0, _browserUtils.realizeUri)(routes.cloudResource, (0, _coreUtils.pick)(params, ['system', 'resource'])),
    label: params.resource
  }];
}

function _generateHostCrumbs(params) {
  return [..._generatePoolCrumbs(params), {
    url: (0, _browserUtils.realizeUri)(routes.host, (0, _coreUtils.pick)(params, ['system', 'pool', 'host'])),
    label: (0, _hostUtils.getHostDisplayName)(params.host)
  }];
}

function _generateManagementCrumbs(params) {
  return [{
    url: (0, _browserUtils.realizeUri)(routes.management, (0, _coreUtils.pick)(params, ['system'])),
    label: 'System Management'
  }];
}

function _generateAccountsCrumbs(params) {
  return [{
    url: (0, _browserUtils.realizeUri)(routes.accounts, (0, _coreUtils.pick)(params, ['system'])),
    label: 'Accounts'
  }];
}

function _generateAccountCrumbs(params) {
  return [..._generateAccountsCrumbs(params), {
    url: (0, _browserUtils.realizeUri)(routes.account, (0, _coreUtils.pick)(params, ['system', 'account'])),
    label: params.account
  }];
}

function _generateClusterCrumbs(params) {
  return [{
    url: (0, _browserUtils.realizeUri)(routes.cluster, (0, _coreUtils.pick)(params, ['system'])),
    label: 'Cluster'
  }];
}

function _generateServerCrumbs(params) {
  return [..._generateClusterCrumbs(params), {
    url: (0, _browserUtils.realizeUri)(routes.server, (0, _coreUtils.pick)(params, ['system', 'server'])),
    label: params.server
  }];
}

function _generateFunctionsCrumbs(params) {
  return [{
    url: (0, _browserUtils.realizeUri)(routes.funcs, (0, _coreUtils.pick)(params, ['system'])),
    label: 'Functions'
  }];
}

function _generateFunctionCrumbs(params) {
  return [..._generateFunctionsCrumbs(params), {
    url: (0, _browserUtils.realizeUri)(routes.func, (0, _coreUtils.pick)(params, ['system', 'func'])),
    label: params.func
  }];
}

function _generateAnalyticsCrumbs(params) {
  return [{
    url: (0, _browserUtils.realizeUri)(routes.analytics, (0, _coreUtils.pick)(params, ['system'])),
    label: 'Analytics'
  }];
}

function _generateEndpointCrumbs(params) {
  return [{
    url: (0, _browserUtils.realizeUri)(routes.endpoints, (0, _coreUtils.pick)(params, ['system'])),
    label: 'Endpoints'
  }];
}

},{"@babel/runtime/helpers/interopRequireWildcard":1051,"routes":972,"utils/browser-utils":1021,"utils/core-utils":1027,"utils/host-utils":1032}],397:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<!-- ko if: hasModals -->\n<div class=\"modals-backdrop fixed fade-in\"\n    ko.event.keydown=\"onKeyDown\"\n    ko.event.mousedown=\"(_, evt) => (evt.target === $element && onBackdropDown(), true)\"\n    ko.event.mouseup=\"(_, evt) => (evt.target === $element && onBackdropUp(), true)\"\n>\n    <!-- ko foreach: modals -->\n    <div class=\"modal column text-left pop-centered card-shadow\"\n        tabindex=\"-1\"\n        ko.hasFocus=\"true\"\n        ko.css=\"css\"\n    >\n        <!-- ko if: title.text -->\n        <h1 class=\"row heading1 modal-heading content-middle content-box\" ko.css=\"title.css\">\n            <svg-icon class=\"severity-icon\"\n                params=\"name: title.icon\"\n                ko.visible=\"title.icon\"\n                ko.css=\"title.css\"\n            ></svg-icon>\n\n            <span class=\"greedy push-next\" ko.text=\"title.text\"></span>\n\n            <button class=\"close-btn icon-btn highlight\"\n                tabindex=\"-1\"\n                ko.visible=\"xButton.visible\"\n                ko.disable=\"xButton.disabled\"\n                ko.click=\"onX\"\n            >\n                <svg-icon params=\"name: 'x'\"></svg-icon>\n            </button>\n        </h1>\n        <!-- /ko -->\n        <section class=\"column greedy\"\n            ko.trapFocus=\"true\"\n            ko.component=\"component\"\n        ></section>\n    </div>\n    <!-- /ko -->\n</div>\n<!-- /ko -->\n";

},{}],398:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _modalManager = _interopRequireDefault(require("./modal-manager.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const severityMapping = (0, _coreUtils.deepFreeze)({
  info: {
    icon: 'notif-info',
    css: 'info'
  },
  success: {
    icon: 'notif-success',
    css: 'success'
  },
  warning: {
    icon: 'problem',
    css: 'warning'
  },
  error: {
    icon: 'problem',
    css: 'error'
  }
});

class ModalViewModel {
  constructor({
    manager
  }) {
    (0, _defineProperty2.default)(this, "manager", null);
    (0, _defineProperty2.default)(this, "css", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "title", {
      text: _knockout.default.observable(),
      css: _knockout.default.observable(),
      icon: _knockout.default.observable()
    });
    (0, _defineProperty2.default)(this, "xButton", {
      visible: _knockout.default.observable(),
      disabled: _knockout.default.observable()
    });
    (0, _defineProperty2.default)(this, "component", {
      name: _knockout.default.observable(),
      params: _knockout.default.observable()
    });
    this.manager = manager;
  }

  onX() {
    this.manager.onModalX();
  }

}

class ModalManagerViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "hasModals", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "allowBackdropClose", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isMousePressedOnBackdrop", false);
    (0, _defineProperty2.default)(this, "modals", _knockout.default.observableArray().ofType(ModalViewModel, {
      manager: this
    }));
  }

  selectState(state) {
    return [state.modals];
  }

  mapStateToProps(modals) {
    const hasModals = modals.length > 0;

    _knockout.default.assignToProps(this, {
      hasModals,
      allowBackdropClose: hasModals ? (0, _coreUtils.last)(modals).backdropClose : false,
      modals: modals.map((modal, i) => {
        const {
          size,
          title: text,
          severity,
          closeButton,
          component
        } = modal;
        const {
          icon,
          css
        } = severityMapping[severity] || {}; // Updating the component observables will cause a re-rendering
        // of the modal content so we check that the component changed
        // before updating the observable.

        const modalVM = this.modals.peek()[i];
        const componentChanged = !modalVM || modalVM.component.name() !== component.name;
        return {
          css: `${size ? `modal-${size}` : ''} ${component.name}`,
          title: {
            text,
            css,
            icon
          },
          xButton: {
            visible: closeButton !== 'hidden',
            disabled: closeButton === 'disabled'
          },
          component: componentChanged ? component : undefined
        };
      })
    });
  }

  onBackdropDown() {
    this.isMousePressedOnBackdrop = true;
  }

  onBackdropUp() {
    if (!this.isMousePressedOnBackdrop) {
      return;
    }

    if (this.allowBackdropClose()) {
      this.dispatch((0, _actionCreators.closeModal)());
    }

    this.isMousePressedOnBackdrop = false;
  }

  onModalX() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

  onKeyDown(_, evt) {
    if (evt.code.toLowerCase() === 'escape') {
      this.dispatch((0, _actionCreators.closeModal)());
      return false;
    }

    return true;
  }

}

var _default = {
  viewModel: ModalManagerViewModel,
  template: _modalManager.default
};
exports.default = _default;

},{"./modal-manager.html":397,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout","utils/core-utils":1027}],399:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _coreUtils = require("utils/core-utils");

/* Copyright (C) 2016 NooBaa */
const disposeList = Symbol('disposeList'); // Used to dispose an handle that contain a dispose method.

function dispose(handle) {
  handle.dispose();
}

function isValidationGroup(group) {
  return group && (0, _coreUtils.isFunction)(group.showAllMessages) && (0, _coreUtils.isFunction)(group.isAnyMessageShown);
}

class BaseViewModel {
  constructor() {
    this[disposeList] = [];
  }

  addToDisposeList(subject, disposer = dispose) {
    this[disposeList].push(() => disposer(subject));
  }

  dispose() {
    // This code cleans up subscriptions created by knockout validation extenders.
    // This is done because knockout validation does not dispose of subscriptions
    // extended with validations even when there are no subscriptions to the
    // underlying observable.
    // The code relay on the fact that every validatable observable in a view model
    // is used as part of a validation group that sits as an enumerable property of
    // the view model. This mean that any validatable observale not used in this
    // manner will not be missed in the scan.
    for (const value of Object.values(this)) {
      if (isValidationGroup(value)) {
        value.forEach(obs => obs.extend({
          validatable: false
        }));
      }
    }

    this[disposeList].forEach(disposer => disposer());
  }

}

exports.default = BaseViewModel;

},{"utils/core-utils":1027}],400:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<loading-indicator class=\"align-start pad\" ko.visible=\"!dataReady()\"></loading-indicator>\n\n<!-- ko if: dataReady -->\n<div class=\"column card-shadow\">\n    <div class=\"pad row content-middle\">\n        <div class=\"column greedy push-next\">\n            <h3 class=\"heading3\">\n                Bucket Resources &amp; Tiering Management\n            </h3>\n            <p>In order to store data on this bucket, resources and tiering policies should be added.</p>\n        </div>\n        <div ko.tooltip=\"addTierTooltip\">\n            <button class=\"btn\"\n                ko.click=\"onAddTer\"\n                ko.disable=\"isAddTierDisabled\"\n                >\n                Add Tier\n            </button>\n        </div>\n    </div>\n\n    <!-- ko if: isInternalWarningVisible -->\n    <div class=\"hpad push-next \">\n        <div class=\"row content-middle warning-box pad\">\n            <svg-icon class=\"warning push-next-half\" params=\"name: 'problem'\"></svg-icon>\n            <div class=\"column\">\n                <p>\n                    <span class=\"warning\">\n                        This bucket is using the internal server's disks capacity as a storage source until a\n                        healthy resource will be added to Tier 1\n                    </span>\n                    <more-info-icon params=\"tooltip: internalWarningTooltip\"></more-info-icon>\n                </p>\n                <p class=\"remark\">\n                    {{internalStorageUsage}} used by this bucket\n                </p>\n            </div>\n        </div>\n    </div>\n    <!-- /ko -->\n\n    <!-- ko if: hasMultipleTiers -->\n    <hr>\n    <div class=\"row content-middle pad-half hpad\">\n        <svg-icon class=\"push-next-half\" params=\"name: 'layers'\"></svg-icon>\n        <span class=\"push-next-half\">\n            Tiering Structure:\n        </span>\n        <div class=\"column greedy push-next\">\n            <tag-list class=\"align-start borders pad-quarter\" params=\"\n                tags: tierLabels,\n                separator: 'arrow-right'\n            \"></tag-list>\n        </div>\n        <button class=\"link alt-colors\" ko.click=\"onOpenTiersFlow\">\n            See Full Tiers Flow\n        </button>\n    </div>\n    <!-- /ko -->\n</div>\n<!-- ko foreach: tierNames -->\n<tier-data-placement-policy-form params=\"\n    bucketName: $component.bucketName,\n    tierIndex: $index\n\"></tier-data-placement-policy-form>\n<!-- ko ifnot: $index -->\n<hr>\n<!-- /ko -->\n<!-- /ko -->\n<!-- /ko -->\n\n";

},{}],401:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _bucketDataPlacementForm = _interopRequireDefault(require("./bucket-data-placement-form.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _sizeUtils = require("utils/size-utils");

var _actionCreators = require("action-creators");

var _config = require("config");

/* Copyright (C) 2016 NooBaa */
const addTierTooltips = (0, _coreUtils.deepFreeze)({
  usingInternal: 'Adding more tiers will be enabled after adding storage resources to tier 1',
  hasMaxTiers: 'Adding more tiers will be available in the following versions of NooBaa'
});
const internalWarningTooltip = (0, _coreUtils.deepFreeze)({
  template: 'text',
  text: `
        Using the system internal storage is not recommended due to low performance.
        Please add storage resources(Local nodes or cloud resources).
    `
});

function _findInternalStorageUsage(bucket) {
  const pair = Object.entries(bucket.usageDistribution.resources).find(pair => pair[0].startsWith('INTERNAL'));
  return pair ? pair[1] : 0;
}

class BucketDataPlacementFormViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "bucketName", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "tierNames", _knockout.default.observableArray());
    (0, _defineProperty2.default)(this, "tierLabels", _knockout.default.observableArray());
    (0, _defineProperty2.default)(this, "isAddTierDisabled", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "addTierTooltip", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isInternalWarningVisible", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "internalWarningTooltip", internalWarningTooltip);
    (0, _defineProperty2.default)(this, "internalStorageUsage", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "hasMultipleTiers", _knockout.default.observable());
  }

  selectState(state, params) {
    const {
      buckets,
      system
    } = state;
    return [params.bucketName, buckets && buckets[params.bucketName], system && system.internalStorage];
  }

  mapStateToProps(bucketName, bucket, internalStorage) {
    if (!bucket || !internalStorage) {
      _knockout.default.assignToProps(this, {
        dataReady: false
      });
    } else {
      const {
        tiers
      } = bucket.placement;
      const isUsingInternalStorage = tiers[0].policyType === 'INTERNAL_STORAGE';
      const tierNames = tiers.map(tier => tier.name);
      const tierLabels = tiers.map((_, i) => `Tier ${i + 1}`);
      const hasMaxTiers = tierNames.length >= _config.maxTiersAllowed;
      const isAddTierDisabled = isUsingInternalStorage || hasMaxTiers;
      const addTierTooltip = {
        text: hasMaxTiers && addTierTooltips.hasMaxTiers || isUsingInternalStorage && addTierTooltips.usingInternal || '',
        align: 'end'
      };
      const internalStorageUsage = `${(0, _sizeUtils.formatSize)(_findInternalStorageUsage(bucket))} of ${(0, _sizeUtils.formatSize)(internalStorage.total)}`;

      _knockout.default.assignToProps(this, {
        dataReady: true,
        bucketName,
        tierNames,
        tierLabels,
        isInternalWarningVisible: isUsingInternalStorage,
        isAddTierDisabled,
        addTierTooltip,
        internalStorageUsage,
        hasMultipleTiers: tierNames.length > 1
      });
    }
  }

  onAddTer() {
    this.dispatch((0, _actionCreators.openAddTierModal)(this.bucketName()));
  }

  onOpenTiersFlow() {
    this.dispatch((0, _actionCreators.openBucketPlacementSummaryModal)(this.bucketName()));
  }

}

var _default = {
  viewModel: BucketDataPlacementFormViewModel,
  template: _bucketDataPlacementForm.default
};
exports.default = _default;

},{"./bucket-data-placement-form.html":400,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"config":831,"knockout":"knockout","utils/core-utils":1027,"utils/size-utils":1043}],402:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<h1 class=\"heading3 pad card-shadow\">\n    Bucket Policies and Configurations\n</h1>\n\n<loading-indicator class=\"align-start pad\"\n    ko.visible=\"!dataReady()\"\n></loading-indicator>\n\n<section class=\"fade-in\" ko.visible=\"dataReady\">\n    <bucket-data-resiliency-policy-form>\n    </bucket-data-resiliency-policy-form>\n    <hr>\n    <bucket-versioning-policy-form>\n    </bucket-versioning-policy-form>\n    <hr>\n    <bucket-quota-policy-form>\n    </bucket-quota-policy-form>\n    <hr>\n    <bucket-s3-access-policy-form>\n    </bucket-s3-access-policy-form>\n    <hr>\n</section>\n\n\n\n";

},{}],403:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _bucketDataPoliciesForm = _interopRequireDefault(require("./bucket-data-policies-form.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
class BucketDataPoliciesFormViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
  }

  selectState(state) {
    const {
      buckets,
      location
    } = state;
    const bucketName = location.params.bucket;
    return [Boolean(buckets && buckets[bucketName])];
  }

  mapStateToProps(bucketLoaded) {
    _knockout.default.assignToProps(this, {
      dataReady: bucketLoaded
    });
  }

}

var _default = {
  viewModel: BucketDataPoliciesFormViewModel,
  template: _bucketDataPoliciesForm.default
};
exports.default = _default;

},{"./bucket-data-policies-form.html":402,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"components/connectable":446,"knockout":"knockout"}],404:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<section class=\"pad\">\n    <div class=\"row content-middle bucket-policy-summary\"\n        ko.click=\"onToggleSection\"\n    >\n        <svg-icon class=\"push-next\"\n            params=\"name: stateIcon.name\"\n            ko.css=\"stateIcon.css\"\n            ko.tooltip=\"stateIcon.tooltip\"\n        ></svg-icon>\n        <div class=\"column greedy\">\n            <h2 class=\"heading3 greedy\">Data Resiliency</h2>\n            <p class=\"row content-middle\" ko.visible=\"!isExpanded()\">\n                {{resiliencyType}}\n                <vr class=\"push-both-half\"></vr>\n                {{dataDistribution}}\n            </p>\n            <p ko.visible=\"isExpanded\">\n                The ability of stored objects to recover and continue operating in the case of a failure\n            </p>\n        </div>\n        <button class=\"btn push-both\" ko.click=\"onEditDataResiliency\">\n            Edit Data Resiliency\n        </button>\n        <svg-icon class=\"icon-small rotate\"\n            ko.css=\"{ 'deg-90': !isExpanded() }\"\n            params=\"name: 'chevron'\"\n        ></svg-icon>\n    </div>\n    <div class=\"column hpad\" ko.expand=\"isExpanded\">\n        <property-sheet class=\"hpad push-prev\" params=\"properties: info\">\n            <template name=\"messageWithSeverity\">\n                <p class=\"row content-middle\" ko.css=\"css\" >\n                    {{text}}\n                    <!-- ko with: moreInfo -->\n                    <more-info-icon class=\"icon-small push-prev-half\" params=\"\n                        severity: severity,\n                        tooltip: tooltip\n                    \"></more-info-icon>\n                    <!-- /ko -->\n                </p>\n            </template>\n        </property-sheet>\n    </div>\n</section>\n\n";

},{}],405:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _bucketDataResiliencyPolicyForm = _interopRequireDefault(require("./bucket-data-resiliency-policy-form.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _coreUtils = require("utils/core-utils");

var _browserUtils = require("utils/browser-utils");

var _knockout = _interopRequireDefault(require("knockout"));

var _numeral = _interopRequireDefault(require("numeral"));

var routes = _interopRequireWildcard(require("routes"));

var _bucketUtils = require("utils/bucket-utils");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const policyName = 'data-resiliency';
const rebuildEffortToDisplay = (0, _coreUtils.deepFreeze)({
  LOW: {
    text: 'Low',
    css: '',
    moreInfo: {
      severity: 'normal',
      tooltip: {
        text: 'Rebuild time effort has 3 options: Low/High/Very High and might change according to the amount of fragments or replicas',
        position: 'above'
      }
    }
  },
  HIGH: {
    text: 'High',
    css: '',
    moreInfo: {
      severity: 'normal',
      tooltip: {
        text: 'Rebuild time effort has 3 options: Low/High/Very High and might change according to the amount of fragments or replicas',
        position: 'above'
      }
    }
  },
  VERY_HIGH: {
    text: 'Very High',
    css: 'error',
    moreInfo: {
      severity: 'warning',
      tooltip: {
        text: 'Parity fragments rebuild time might take a while, varies according to data placement policy resources and type',
        position: 'above'
      }
    }
  }
});

function _getConfiguredFailureTolerance(resiliency) {
  const {
    failureTolerance
  } = resiliency;
  const text = (0, _numeral.default)(failureTolerance).format('0,0');

  if (failureTolerance < 2) {
    return {
      text: text,
      css: 'warning',
      moreInfo: {
        severity: 'warning',
        tooltip: {
          text: 'It is not recommended to use a resiliency policy which results in less than a fault tolerance value of 2',
          position: 'above'
        }
      }
    };
  } else {
    return {
      text,
      css: '',
      moreInfo: null
    };
  }
}

function _getActualFailureTolerance(actualTolerance, configuredTolerance, requiredDrives) {
  const {
    hosts,
    nodes
  } = actualTolerance;
  const text = `${hosts} Nodes / ${nodes} Drives`;

  if (hosts < configuredTolerance || nodes < configuredTolerance) {
    return {
      text: text,
      css: 'error',
      moreInfo: {
        severity: 'error',
        tooltip: {
          text: `One or more of the configured mirror sets have less than ${requiredDrives} healthy nodes/drives. This brings the bucket\'s actual tolerance below the configured tolerance`,
          position: 'above'
        }
      }
    };
  } else {
    return {
      text: text,
      css: '',
      moreInfo: {
        severity: 'normal',
        tooltip: {
          text: 'The current number of nodes and drives that can suffer failure without causing any data loss',
          position: 'above'
        }
      }
    };
  }
}

function _getRequiredDrives(resiliency) {
  const {
    requiredDrives
  } = resiliency;
  const text = `${requiredDrives} drives per mirror set`;
  return {
    text
  };
}

class BucketDataResiliencyPolicyFormViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "isExpanded", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "bucketName", '');
    (0, _defineProperty2.default)(this, "toggleUri", '');
    (0, _defineProperty2.default)(this, "stateIcon", {
      name: _knockout.default.observable(),
      css: _knockout.default.observable(),
      tooltip: _knockout.default.observable()
    });
    (0, _defineProperty2.default)(this, "resiliencyType", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "dataDistribution", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "info", [{
      label: 'Data Resiliency Type',
      value: _knockout.default.observable()
    }, {
      label: 'Number of Copies',
      value: _knockout.default.observable(),
      visible: _knockout.default.observable()
    }, {
      label: 'Number of data fragments',
      value: _knockout.default.observable(),
      visible: _knockout.default.observable()
    }, {
      label: 'Number of parity fragments',
      value: _knockout.default.observable(),
      visible: _knockout.default.observable()
    }, {
      label: 'Storage Overhead',
      value: _knockout.default.observable()
    }, {
      label: 'Minimum Required Drives',
      template: 'messageWithSeverity',
      value: {
        css: _knockout.default.observable(),
        text: _knockout.default.observable(),
        moreInfo: _knockout.default.observable()
      }
    }, {
      label: 'Configured Failure Tolerance',
      template: 'messageWithSeverity',
      value: {
        css: _knockout.default.observable(),
        text: _knockout.default.observable(),
        moreInfo: _knockout.default.observable()
      }
    }, {
      label: 'Actual Failure Tolerance',
      template: 'messageWithSeverity',
      value: {
        css: _knockout.default.observable(),
        text: _knockout.default.observable(),
        moreInfo: _knockout.default.observable()
      }
    }, {
      label: 'Rebuild time effort',
      template: 'messageWithSeverity',
      value: {
        css: _knockout.default.observable(),
        text: _knockout.default.observable(),
        moreInfo: _knockout.default.observable()
      }
    }]);
  }

  selectState(state) {
    const {
      location,
      buckets
    } = state;
    const {
      bucket: bucketName
    } = location.params;
    return [location, buckets && buckets[bucketName]];
  }

  mapStateToProps(location, bucket) {
    if (!bucket) {
      _knockout.default.assignToProps(this, {
        isExpanded: false
      });
    } else {
      const {
        system,
        tab = 'data-policies',
        section
      } = location.params;
      const toggleUri = (0, _browserUtils.realizeUri)(routes.bucket, {
        system,
        bucket: bucket.name,
        tab,
        section: section === policyName ? undefined : policyName
      });
      const resiliency = (0, _bucketUtils.summrizeResiliency)(bucket.resiliency);
      const resiliencyType = (0, _bucketUtils.getResiliencyTypeDisplay)(resiliency.type);

      _knockout.default.assignToProps(this, {
        isExpanded: section === policyName,
        bucketName: bucket.name,
        toggleUri,
        stateIcon: (0, _bucketUtils.getResiliencyStateIcon)(bucket.resiliency),
        resiliencyType,
        dataDistribution: resiliency.type === 'REPLICATION' ? `${resiliency.replicas} copies` : `${resiliency.dataFrags} data + ${resiliency.parityFrags} parity fragments`,
        info: [{
          label: 'Data Resiliency Type',
          value: resiliencyType
        }, {
          label: 'Number of Copies',
          value: resiliency.replicas,
          visible: resiliency.type === 'REPLICATION'
        }, {
          label: 'Number of data fragments',
          value: resiliency.dataFrags,
          visible: resiliency.type === 'ERASURE_CODING'
        }, {
          label: 'Number of parity fragments',
          value: resiliency.parityFrags,
          visible: resiliency.type === 'ERASURE_CODING'
        }, {
          label: 'Storage Overhead',
          value: (0, _numeral.default)(resiliency.storageOverhead).format('%')
        }, {
          label: 'Minimum Required Drives',
          template: 'messageWithSeverity',
          value: _getRequiredDrives(resiliency)
        }, {
          label: 'Configured Failure Tolerance',
          template: 'messageWithSeverity',
          value: _getConfiguredFailureTolerance(resiliency)
        }, {
          label: 'Actual Failure Tolerance',
          template: 'messageWithSeverity',
          value: _getActualFailureTolerance(bucket.failureTolerance, resiliency.failureTolerance, resiliency.requiredDrives)
        }, {
          label: 'Rebuild time effort',
          template: 'messageWithSeverity',
          value: rebuildEffortToDisplay[resiliency.rebuildEffort]
        }]
      });
    }
  }

  onToggleSection() {
    this.dispatch((0, _actionCreators.requestLocation)(this.toggleUri));
  }

  onEditDataResiliency(_, evt) {
    this.dispatch((0, _actionCreators.openEditBucketDataResiliencyModal)(this.bucketName));
    evt.stopPropagation();
  }

}

var _default = {
  viewModel: BucketDataResiliencyPolicyFormViewModel,
  template: _bucketDataResiliencyPolicyForm.default
};
exports.default = _default;

},{"./bucket-data-resiliency-policy-form.html":404,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"components/connectable":446,"knockout":"knockout","numeral":"numeral","routes":972,"utils/browser-utils":1021,"utils/bucket-utils":1022,"utils/core-utils":1027}],406:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"column pad card-shadow\">\n    <div class=\"row content-middle\">\n        <input class=\"push-next search-input\" type=\"search\"\n            placeholder=\"Filter by object name\"\n            ko.textInput=\"ko.pc(filter, onFilterThrottled)\"\n        />\n\n        <div class=\"row content-middle greedy\">\n            <toggle-group class=\"push-next state-filter\"\n                params=\"\n                    options: stateFilterOptions,\n                    selected: ko.pc(stateFilter, onFilterByState, $component)\n                \"\n            ></toggle-group>\n\n            <div ko.visible=\"isShowVersionsVisible\"\n                ko.css.disabled=\"stateFilter.eq('UPLOADING')\"\n            >\n                <checkbox class=\"greedy push-next\" params=\"\n                    label: 'Show Versions',\n                    disabled: stateFilter.eq('UPLOADING'),\n                    checked: ko.pc(showVersions, onShowVersions, $component)\n                \"></checkbox>\n                <more-info-icon params=\"tooltip: showVersionsTooltip\"></more-info-icon>\n            </div>\n        </div>\n\n        <div ko.tooltip=\"uploadButton().tooltip\">\n            <button class=\"upload-btn btn\"\n                ko.visible=\"uploadButton().visible\"\n                ko.disable=\"uploadButton().disabled\"\n                ko.click=\"() => fileSelectorExpanded.toggle()\n            \">\n                Upload Objects\n            </button>\n        </div>\n    </div>\n\n    <div class=\"file-selector-wrapper column\" ko.expand=\"fileSelectorExpanded\">\n        <file-selector class=\"push-prev\" params=\"\n            allowMultiSelect: true,\n            onFilesReady: files => uploadFiles(files)\n        \"></file-selector>\n    </div>\n</div>\n\n<data-table class=\"objects-table greedy\" params=\"\n    columns: columns,\n    visibleColumns: visibleColumns,\n    data: rows,\n    sorting: ko.pc(sorting, onSort, $component),\n    loading: !objectsLoaded(),\n    emptyMessage: emptyMessage\n\">\n</data-table>\n\n<paginator params=\"\n    itemCount: objectCount,\n    pageSize: ko.pc(pageSize, onPageSize, $component),\n    page: ko.pc(page, onPage, $component)\n\"></paginator>\n\n";

},{}],407:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _bucketObjectsTable = _interopRequireDefault(require("./bucket-objects-table.html"));

var _observer = _interopRequireDefault(require("observer"));

var _knockout = _interopRequireDefault(require("knockout"));

var _config = require("config");

var _coreUtils = require("utils/core-utils");

var _browserUtils = require("utils/browser-utils");

var _bucketUtils = require("utils/bucket-utils");

var _objectUtils = require("utils/object-utils");

var _objectRow = _interopRequireDefault(require("./object-row"));

var _state = require("state");

var routes = _interopRequireWildcard(require("routes"));

var _numeral = _interopRequireDefault(require("numeral"));

var _rxExtensions = require("rx-extensions");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const showVersionsTooltip = 'All the existing object versions that this bucket contains.';
const columns = (0, _coreUtils.deepFreeze)([{
  name: 'state',
  type: 'icon',
  sortable: true
}, {
  name: 'key',
  label: 'Object Name',
  type: 'link',
  sortable: true
}, {
  name: 'versionId',
  label: 'Version ID'
}, {
  name: 'creationTime',
  sortable: 'create_time'
}, {
  name: 'size',
  sortable: true //,
  // {
  //     name: 'deleteButton',
  //     label: '',
  //     css: 'delete-col',
  //     type: 'delete'
  // }

}]);
const emptyMessages = (0, _coreUtils.deepFreeze)({
  NO_MATCHING_KEYS: 'The current filter does not match any object',
  NO_RESULTS: 'This page does not contain any objects',
  NO_OBJECTS: 'No objects in bucket',
  NO_LATEST: 'All latest versions are delete markers',
  NO_UPLOADS: 'No ongoing uploads in bucket'
});

function _getItemsCountByState(counters, state) {
  const {
    optimal,
    uploading
  } = counters;

  switch (state) {
    case 'ALL':
      return optimal + uploading;

    case 'OPTIMAL':
      return optimal;

    case 'UPLOADING':
      return uploading;
  }
}

function _getStateFilterOptions(counters) {
  return [{
    value: 'ALL',
    label: `All Objects (${(0, _numeral.default)(_getItemsCountByState(counters, 'ALL')).format('0,0')})`
  }, {
    value: 'OPTIMAL',
    label: `Completed (${(0, _numeral.default)(_getItemsCountByState(counters, 'OPTIMAL')).format('0,0')})`
  }, {
    value: 'UPLOADING',
    label: `Uploading (${(0, _numeral.default)(_getItemsCountByState(counters, 'UPLOADING')).format('0,0')})`
  }];
}

function _getUploadTooltip(isOwner, isReadOnly, httpsNoCert) {
  if (!isOwner) {
    return {
      align: 'end',
      text: 'This operation is only available for the system owner'
    };
  }

  if (isReadOnly) {
    return {
      align: 'end',
      text: 'Cannot upload, not enough healthy storage resources'
    };
  }

  if (httpsNoCert) {
    return {
      align: 'end',
      text: 'Cannot upload, a certificate must be installed in order to upload via https'
    };
  }

  return '';
}

class BucketObjectsTableViewModel extends _observer.default {
  constructor({
    bucketName
  }) {
    super();
    (0, _defineProperty2.default)(this, "viewName", this.constructor.name);
    (0, _defineProperty2.default)(this, "showVersionsTooltip", showVersionsTooltip);
    (0, _defineProperty2.default)(this, "columns", columns);
    (0, _defineProperty2.default)(this, "visibleColumns", _knockout.default.observableArray());
    (0, _defineProperty2.default)(this, "baseRoute", '');
    (0, _defineProperty2.default)(this, "bucketName", '');
    (0, _defineProperty2.default)(this, "currQuery", null);
    (0, _defineProperty2.default)(this, "currBucket", null);
    (0, _defineProperty2.default)(this, "bucket", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "objectsLoaded", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isShowVersionsVisible", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "rows", _knockout.default.observableArray());
    (0, _defineProperty2.default)(this, "uploadButton", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "fileSelectorExpanded", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "objectCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "stateFilterOptions", _knockout.default.observableArray());
    (0, _defineProperty2.default)(this, "stateFilter", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "showVersions", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "onFilterThrottled", (0, _coreUtils.throttle)(this.onFilter, _config.inputThrottle, this));
    (0, _defineProperty2.default)(this, "pageSize", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "filter", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "sorting", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "page", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "emptyMessage", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "selectedForDelete", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "bucketObjects", {});
    this.bucketName = _knockout.default.unwrap(bucketName);
    this.observe(_state.state$.pipe((0, _rxExtensions.get)('location')), this.onLocation);
    this.observe(_state.state$.pipe((0, _rxExtensions.getMany)(['buckets', this.bucketName], 'objects', ['session', 'user'], ['accounts'], ['system', 'sslCert', 'installed'])), this.onState);
  }

  onLocation(location) {
    const {
      tab,
      bucket,
      system
    } = location.params;
    if (!bucket || tab !== 'objects') return;
    const {
      stateFilter = 'ALL',
      filter = '',
      sortBy = 'key',
      showVersions = false,
      selectedForDelete
    } = location.query;
    const order = Number(location.query.order) || 1;
    const page = Number(location.query.page) || 0;

    const pageSize = Number(location.query.pageSize) || _config.paginationPageSize.default;

    const baseRoute = (0, _browserUtils.realizeUri)(routes.object, {
      system,
      bucket: bucket
    }, {}, true);
    this.baseRoute = baseRoute;
    this.filter(filter);
    this.stateFilter(stateFilter);
    this.showVersions(showVersions);
    this.sorting({
      sortBy,
      order
    });
    this.page(page);
    this.pageSize(pageSize);
    this.selectedForDelete(selectedForDelete);

    _state.action$.next((0, _actionCreators.fetchObjects)(this.viewName, {
      bucket: bucket,
      filter,
      sortBy,
      order,
      skip: page * pageSize,
      limit: pageSize,
      stateFilter,
      versions: showVersions
    }, location.hostname));
  }

  onState([bucket, bucketObjects, user, accounts, sslCert]) {
    const queryKey = bucketObjects.views[this.viewName];
    const query = bucketObjects.queries[queryKey];

    if (!query || !query.result || !bucket || !user || !accounts) {
      this.uploadButton({});
      this.objectsLoaded(false);
      this.rows([]);
      return;
    }

    const isVersionedBucket = bucket.versioning.mode !== 'DISABLED';
    const showVersionColumn = isVersionedBucket && this.showVersions() && this.stateFilter() !== 'UPLOADING';
    const visibleColumns = this.columns.map(col => col.name).filter(name => showVersionColumn || name !== 'versionId');
    const account = accounts[user];
    const {
      counters,
      items: queryObjects,
      emptyReason
    } = query.result;
    const s3Connection = {
      accessKey: account.accessKeys.accessKey,
      secretKey: account.accessKeys.secretKey,
      endpoint: location.hostname
    };
    const rowParams = {
      baseRoute: this.baseRoute,
      onSelectForDelete: this.onSelectForDelete.bind(this),
      onDelete: this.onDeleteBucketObject.bind(this)
    };

    const modeFilterOptions = _getStateFilterOptions(counters);

    const httpsNoCert = location.protocol === 'https' && !sslCert;
    const isReadOnly = !(0, _bucketUtils.isBucketWritable)(bucket);
    const uploadButton = {
      visible: false,
      // WE may renable this when we fix the cert issues.
      disabled: !account.isOwner || isReadOnly || httpsNoCert,
      tooltip: _getUploadTooltip(account.isOwner, isReadOnly, httpsNoCert)
    };
    const rows = queryObjects.map((bucketObjectKey, i) => {
      const row = this.rows.get(i) || new _objectRow.default(rowParams);
      const obj = bucketObjects.items[bucketObjectKey];
      row.onState(bucketObjectKey, obj, !account.isOwner, isVersionedBucket, this.showVersions(), this.selectedForDelete());
      return row;
    });
    this.isShowVersionsVisible(isVersionedBucket);
    this.visibleColumns(visibleColumns);
    this.s3Connection = s3Connection;
    this.stateFilterOptions(modeFilterOptions);
    this.fileSelectorExpanded(false);
    this.uploadButton(uploadButton);
    this.pathname = location.pathname;
    this.objectCount(_getItemsCountByState(counters, this.stateFilter()));
    this.rows(rows);
    this.emptyMessage(emptyMessages[emptyReason]);
    this.objectsLoaded(true);
  }

  onFilter(filter) {
    this._query({
      filter: filter,
      page: 0,
      selectedForDelete: null
    });
  }

  onFilterByState(state) {
    this._query({
      stateFilter: state,
      page: 0,
      selectedForDelete: null
    });
  }

  onShowVersions(state) {
    this._query({
      showVersions: state,
      page: 0,
      selectedForDelete: null
    });
  }

  onSort(sorting) {
    this._query({
      sorting,
      page: 0,
      selectedForDelete: null
    });
  }

  onPage(page) {
    this._query({
      page,
      selectedForDelete: null
    });
  }

  onPageSize(pageSize) {
    this._query({
      pageSize,
      page: 0,
      selectedForDelete: null
    });
  }

  _query(params) {
    const {
      filter = this.filter(),
      sorting = this.sorting(),
      page = this.page(),
      pageSize = this.pageSize(),
      selectedForDelete = this.selectedForDelete(),
      stateFilter = this.stateFilter(),
      showVersions = this.showVersions()
    } = params;
    const {
      sortBy,
      order
    } = sorting;
    const query = {
      filter: filter || undefined,
      sortBy: sortBy,
      order: order,
      page: page || undefined,
      pageSize,
      selectedForDelete: selectedForDelete || undefined,
      stateFilter: stateFilter,
      showVersions: showVersions || undefined
    };

    _state.action$.next((0, _actionCreators.requestLocation)((0, _browserUtils.realizeUri)(this.pathname, {}, query)));
  }

  onSelectForDelete(selected) {
    this._query({
      selectedForDelete: selected
    });
  }

  onDeleteBucketObject(id) {
    const objId = this.showVersions() ? (0, _objectUtils.splitObjectId)(id) : (0, _coreUtils.pick)((0, _objectUtils.splitObjectId)(id), ['bucket', 'key', 'uploadId']);

    _state.action$.next((0, _actionCreators.deleteObject)(objId, this.s3Connection));
  }

  uploadFiles(files) {
    _state.action$.next((0, _actionCreators.uploadObjects)(_knockout.default.unwrap(this.bucketName), files, this.s3Connection));

    this.fileSelectorExpanded(false);
  }

  dispose() {
    _state.action$.next((0, _actionCreators.dropObjectsView)(this.viewName));

    super.dispose();
  }

}

var _default = {
  viewModel: BucketObjectsTableViewModel,
  template: _bucketObjectsTable.default
};
exports.default = _default;

},{"./bucket-objects-table.html":406,"./object-row":408,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"config":831,"knockout":"knockout","numeral":"numeral","observer":937,"routes":972,"rx-extensions":974,"state":1016,"utils/browser-utils":1021,"utils/bucket-utils":1022,"utils/core-utils":1027,"utils/object-utils":1037}],408:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _browserUtils = require("utils/browser-utils");

var _sizeUtils = require("utils/size-utils");

var _coreUtils = require("utils/core-utils");

var _objectUtils = require("utils/object-utils");

var _config = require("config");

var _moment = _interopRequireDefault(require("moment"));

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
const statusMapping = (0, _coreUtils.deepFreeze)({
  OPTIMAL: {
    css: 'success',
    name: 'healthy',
    tooltip: 'Healthy'
  },
  UPLOADING: {
    css: 'warning',
    name: 'working',
    tooltip: 'Uploading'
  }
});

class ObjectRowViewModel {
  constructor({
    baseRoute,
    onSelectForDelete,
    onDelete
  }) {
    (0, _defineProperty2.default)(this, "baseRoute", '');
    (0, _defineProperty2.default)(this, "onObjectDelete", null);
    (0, _defineProperty2.default)(this, "state", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "key", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "versionId", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "creationTime", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "size", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "deleteButton", {
      text: _knockout.default.observable(),
      id: _knockout.default.observable(),
      tooltip: _knockout.default.observable(),
      disabled: _knockout.default.observable(),
      active: _knockout.default.observable(),
      onToggle: null,
      onDelete: null
    });
    this.baseRoute = baseRoute;
    this.deleteButton.onDelete = onDelete;
    this.deleteButton.onToggle = onSelectForDelete;
  }

  onState(id, obj, isNotOwner, versionedBucket, showingVersions, selectedForDelete) {
    const deleteTooltip = isNotOwner ? 'This operation is only available for the system owner' : null;
    const versionId = obj.uploadId ? '...' : obj.versionId;
    const size = obj.uploadId || obj.deleteMarker ? '...' : (0, _sizeUtils.formatSize)(obj.size.original);
    const creationTime = (0, _moment.default)(obj.createTime).format(_config.timeShortFormat);
    const href = !obj.uploadId && !obj.deleteMarker ? (0, _browserUtils.realizeUri)(this.baseRoute, {
      object: obj.key,
      version: obj.versionId
    }) : undefined;
    const keyText = !versionedBucket && obj.key || !showingVersions && obj.key || obj.uploadId && obj.key || obj.deleteMarker && `${obj.key} (Delete Marker)` || obj.latestVersion && `${obj.key} (Latest Verison)` || obj.key;
    const key = {
      text: keyText,
      href,
      tooltip: {
        text: keyText,
        breakWords: true
      }
    };
    const deleteText = obj.uploadId && 'Abort object upload' || showingVersions && 'Delete object version' || versionedBucket && 'Delete latest object version' || 'Delete object';
    this.state(statusMapping[obj.mode]);
    this.key(key);
    this.versionId((0, _objectUtils.formatVersionId)(versionId));
    this.creationTime(creationTime);
    this.size(size);
    this.deleteButton.id(id);
    this.deleteButton.text(deleteText);
    this.deleteButton.active(id === selectedForDelete);
    this.deleteButton.disabled(isNotOwner);
    this.deleteButton.tooltip(deleteTooltip);
  }

}

exports.default = ObjectRowViewModel;

},{"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"config":831,"knockout":"knockout","moment":"moment","utils/browser-utils":1021,"utils/core-utils":1027,"utils/object-utils":1037,"utils/size-utils":1043}],409:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<bucket-summary class=\"push-next\" params=\"\n    bucketName: bucketName\n\"></bucket-summary>\n\n<div class=\"tabs greedy\">\n    <nav>\n        <a ko.css.selected=\"selectedTab.eq('data-placement')\"\n            ko.attr.href=\"tabHref('data-placement')\"\n        >\n            Resources &amp; Tiers\n            <span class=\"issue-counter\"\n                  ko.attr.data-count=\"placementIssueCounter.count\"\n                  ko.visible=\"placementIssueCounter.count\"\n                  ko.css=\"placementIssueCounter.severity\"\n            ></span>\n        </a>\n        <a ko.css.selected=\"selectedTab.eq('data-policies')\"\n            ko.attr.href=\"tabHref('data-policies')\"\n        >\n            Bucket Policies\n            <span class=\"issue-counter\"\n                  ko.attr.data-count=\"policyIssueCounter.count\"\n                  ko.visible=\"policyIssueCounter.count\"\n                  ko.css=\"policyIssueCounter.severity\"\n            ></span>\n        </a>\n        <a ko.css.selected=\"selectedTab.eq('objects')\"\n            ko.attr.href=\"tabHref('objects')\"\n        >\n            Objects\n        </a>\n<!--         <a ko.css.selected=\"selectedTab.eq('s3-access')\"\n            ko.attr.href=\"tabHref('s3-access')\"\n        >\n            S3 Access\n        </a> -->\n        <a ko.css.selected=\"selectedTab.eq('triggers')\"\n            ko.attr.href=\"tabHref('triggers')\"\n        >\n            Triggers\n        </a>\n    </nav>\n\n    <div class=\"tabs-row\">\n        <bucket-data-placement-form class=\"tab\"\n            ko.css.selected=\"selectedTab.eq('data-placement')\"\n            params=\"bucketName: bucketName\"\n        ></bucket-data-placement-form>\n\n        <bucket-data-policies-form class=\"tab\"\n            ko.css.selected=\"selectedTab.eq('data-policies')\"\n            params=\"bucketName: bucketName\"\n        ></bucket-data-policies-form>\n\n        <bucket-objects-table class=\"tab\"\n            ko.css.selected=\"selectedTab.eq('objects')\"\n            params=\"bucketName: bucketName\"\n        ></bucket-objects-table>\n\n        <bucket-triggers-form class=\"tab column\"\n            ko.css.selected=\"selectedTab.eq('triggers')\"\n            params=\"bucketName: bucketName\"\n        ></bucket-triggers-form>\n    </div>\n</div>\n";

},{}],410:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _bucketPanel = _interopRequireDefault(require("./bucket-panel.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _browserUtils = require("utils/browser-utils");

var _bucketUtils = require("utils/bucket-utils");

/* Copyright (C) 2016 NooBaa */
function _updateCounterState(state, severity) {
  if (severity === 'warning') {
    state.count += 1;

    if (state.severity !== 'error') {
      state.severity = 'warning';
    }
  } else if (severity === 'error') {
    state.count += 1;
    state.severity = 'error';
  }

  return state;
}

function _getPlacementCounterState(bucket) {
  const counterState = {
    count: 0,
    severity: ''
  };
  if (!bucket) return counterState;
  return bucket.placement.tiers.map(tier => tier.policyType !== 'INTERNAL_STORAGE' ? (0, _bucketUtils.getPlacementStateIcon)(tier).css : 'warning').reduce(_updateCounterState, counterState);
}

function _getPolicyCounterState(bucket) {
  const counterState = {
    count: 0,
    severity: ''
  };
  if (!bucket) return counterState;
  const {
    resiliency,
    versioning,
    quota
  } = bucket;
  return [(0, _bucketUtils.getResiliencyStateIcon)(resiliency).css, versioning.mode === 'SUSPENDED' ? 'warning' : '', quota ? (0, _bucketUtils.getQuotaStateIcon)(quota).css : ''].reduce(_updateCounterState, counterState);
}

class BucketPanelViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "baseRoute", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "selectedTab", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "bucketName", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "placementIssueCounter", {
      count: _knockout.default.observable(),
      severity: _knockout.default.observable()
    });
    (0, _defineProperty2.default)(this, "policyIssueCounter", {
      count: _knockout.default.observable(),
      severity: _knockout.default.observable()
    });
  }

  selectState(state) {
    const {
      location,
      buckets
    } = state;
    const bucket = buckets && buckets[location.params.bucket];
    return [location, bucket];
  }

  mapStateToProps(location, bucket) {
    const {
      system,
      bucket: bucketName,
      tab = 'data-placement'
    } = location.params;

    _knockout.default.assignToProps(this, {
      baseRoute: (0, _browserUtils.realizeUri)(location.route, {
        system,
        bucket: bucketName
      }, {}, true),
      selectedTab: tab,
      bucketName: bucketName,
      placementIssueCounter: _getPlacementCounterState(bucket),
      policyIssueCounter: _getPolicyCounterState(bucket)
    });
  }

  tabHref(tab) {
    const route = this.baseRoute();

    if (route) {
      return (0, _browserUtils.realizeUri)(route, {
        tab
      });
    }
  }

}

var _default = {
  viewModel: BucketPanelViewModel,
  template: _bucketPanel.default
};
exports.default = _default;

},{"./bucket-panel.html":409,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"components/connectable":446,"knockout":"knockout","utils/browser-utils":1021,"utils/bucket-utils":1022}],411:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<section class=\"pad\">\n    <div class=\"row content-middle bucket-policy-summary\"\n        ko.click=\"onToggleSection\"\n    >\n        <svg-icon class=\"push-next\"\n            params=\"name: stateIcon().name\"\n            ko.css=\"stateIcon().css\"\n            ko.tooltip=\"stateIcon().tooltip\"\n        ></svg-icon>\n        <div class=\"column greedy\">\n            <h2 class=\"heading3 greedy\">Bucket Quota</h2>\n            <p class=\"row content-middle\"\n                ko.visible=\"!isExpanded()\"\n            >\n                {{quotaStateText}}\n                <vr class=\"push-both-half\"></vr>\n                {{summary}}\n            </p>\n            <p ko.visible=\"isExpanded\">\n                A limit on the amount of data this bucket can potentially use for uploads\n            </p>\n        </div>\n        <button class=\"btn push-both\"\n            ko.click=\"onEditQuota\"\n        >\n            Edit Quota\n        </button>\n        <svg-icon class=\"icon-small rotate\"\n            ko.css=\"{ 'deg-90': !isExpanded() }\"\n            params=\"name: 'chevron'\"\n        ></svg-icon>\n    </div>\n    <div class=\"column hpad\" ko.expand=\"isExpanded\">\n        <property-sheet class=\"hpad push-prev\" params=\"properties: info\">\n        </property-sheet>\n    </div>\n</section>\n";

},{}],412:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _bucketQuotaPolicyForm = _interopRequireDefault(require("./bucket-quota-policy-form.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _coreUtils = require("utils/core-utils");

var _browserUtils = require("utils/browser-utils");

var _sizeUtils = require("utils/size-utils");

var _bucketUtils = require("utils/bucket-utils");

var _knockout = _interopRequireDefault(require("knockout"));

var routes = _interopRequireWildcard(require("routes"));

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const policyName = 'quota';
const disabledIcon = (0, _coreUtils.deepFreeze)({
  name: 'healthy',
  css: 'disabled',
  tooltip: {
    text: 'Disabled',
    align: 'start'
  }
});

class BucketQuotaPolicyFormViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "bucketName", '');
    (0, _defineProperty2.default)(this, "isExpanded", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isQuotaDisabled", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "stateIcon", _knockout.default.observable({}));
    (0, _defineProperty2.default)(this, "summary", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "quotaStateText", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "quotaSize", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "dataLeftUntilQuota", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "toggleUri", '');
    (0, _defineProperty2.default)(this, "info", [{
      label: 'Bucket Quota',
      value: this.quotaStateText
    }, {
      label: 'Configured Limit',
      value: this.quotaSize
    }, {
      label: 'Data left to reach quota',
      value: this.dataLeftUntilQuota,
      disabled: this.isQuotaDisabled
    }]);
  }

  selectState(state) {
    return [state.location, state.buckets];
  }

  mapStateToProps(location, buckets) {
    const {
      system,
      bucket: bucketName,
      tab = 'data-policies',
      section
    } = location.params;
    const isExpanded = section === policyName;

    if (!buckets || !buckets[bucketName]) {
      _knockout.default.assignToProps(this, {
        isExpanded,
        stateIcon: disabledIcon,
        quotaStateText: 'Disabled',
        summary: ''
      });
    } else {
      const toggleSection = section === policyName ? undefined : policyName;
      const toggleUri = (0, _browserUtils.realizeUri)(routes.bucket, {
        system,
        bucket: bucketName,
        tab,
        section: toggleSection
      });
      const {
        quota,
        data
      } = buckets[bucketName];

      if (quota) {
        const quotaSize = (0, _bucketUtils.getQuotaValue)(quota);
        const dataLeftUntilQuota = (0, _sizeUtils.fromBigInteger)(_sizeUtils.bigInteger.max((0, _sizeUtils.toBigInteger)(quotaSize).subtract(data.size), _sizeUtils.bigInteger.zero));

        _knockout.default.assignToProps(this, {
          isExpanded,
          bucketName,
          toggleUri,
          isQuotaDisabled: false,
          stateIcon: (0, _bucketUtils.getQuotaStateIcon)(quota),
          summary: `Set to ${(0, _sizeUtils.formatSize)(quotaSize)}`,
          quotaStateText: 'Enabled',
          quotaSize: (0, _sizeUtils.formatSize)(quotaSize),
          dataLeftUntilQuota: (0, _sizeUtils.formatSize)(dataLeftUntilQuota)
        });
      } else {
        _knockout.default.assignToProps(this, {
          isExpanded,
          bucketName,
          toggleUri,
          isQuotaDisabled: true,
          stateIcon: disabledIcon,
          summary: 'Limit not set',
          quotaStateText: 'Disabled',
          quotaSize: 'Not set',
          dataLeftUntilQuota: 'None'
        });
      }
    }
  }

  onToggleSection() {
    this.dispatch((0, _actionCreators.requestLocation)(this.toggleUri));
  }

  onEditQuota(_, evt) {
    this.dispatch((0, _actionCreators.openEditBucketQuotaModal)(this.bucketName));
    evt.stopPropagation();
  }

}

var _default = {
  viewModel: BucketQuotaPolicyFormViewModel,
  template: _bucketQuotaPolicyForm.default
};
exports.default = _default;

},{"./bucket-quota-policy-form.html":411,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"components/connectable":446,"knockout":"knockout","routes":972,"utils/browser-utils":1021,"utils/bucket-utils":1022,"utils/core-utils":1027,"utils/size-utils":1043}],413:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<section class=\"pad\">\n    <div class=\"row content-middle bucket-policy-summary\"\n        ko.click=\"onToggleSection\"\n    >\n        <svg-icon class=\"push-next\"\n            params=\"name: stateIcon.name\"\n            ko.css=\"stateIcon.css\"\n            ko.tooltip=\"stateIcon.tooltip\"\n        ></svg-icon>\n        <div class=\"column greedy\">\n            <h2 class=\"heading3 greedy\">Accounts S3 Access</h2>\n            <p class=\"row content-middle\">{{summary}}</p>\n        </div>\n        <button class=\"btn push-next\"\n            ko.click=\"onEditS3Access\"\n        >\n            Edit S3 Access\n        </button>\n        <svg-icon class=\"icon-small rotate\"\n            ko.css=\"{ 'deg-90': !isExpanded() }\"\n            params=\"name: 'chevron'\"\n        ></svg-icon>\n    </div>\n    <div class=\"column hpad\" ko.expand=\"isExpanded\">\n        <data-table class=\"content-box accounts-table push-prev\" params=\"\n            columns: columns,\n            data: rows,\n            loading: !dataReady,\n            emptyMessage: 'No accounts were granted access for this bucket'\n        \"></data-table>\n    </div>\n</section>\n\n\n";

},{}],414:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _bucketS3AccessPolicyForm = _interopRequireDefault(require("./bucket-s3-access-policy-form.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _browserUtils = require("utils/browser-utils");

var _stringUtils = require("utils/string-utils");

var routes = _interopRequireWildcard(require("routes"));

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const policyName = 's3-access';
const columns = (0, _coreUtils.deepFreeze)([{
  name: 'name',
  type: 'link'
}, {
  name: 'credentialsDetails',
  type: 'button'
}]);

function _mapAccountToRow(account, location) {
  const {
    hostname: endpoint,
    params
  } = location;
  const {
    name,
    accessKeys
  } = account;
  return {
    name: {
      text: name,
      tooltip: name,
      href: (0, _browserUtils.realizeUri)(routes.account, {
        system: params.system,
        account: name
      })
    },
    connection: { ...accessKeys,
      endpoint
    }
  };
}

class AccountRowViewModel {
  constructor({
    table
  }) {
    (0, _defineProperty2.default)(this, "table", null);
    (0, _defineProperty2.default)(this, "connection", null);
    (0, _defineProperty2.default)(this, "name", {
      text: _knockout.default.observable(),
      href: _knockout.default.observable()
    });
    (0, _defineProperty2.default)(this, "credentialsDetails", {
      text: 'View',
      click: () => this.onShowDetails()
    });
    this.table = table;
  }

  onShowDetails() {
    this.table.onShowAccountDetails(this.connection);
  }

}

class BucketS3AccessTableViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "stateIcon", {
      name: 'healthy',
      css: 'success'
    });
    (0, _defineProperty2.default)(this, "isExpanded", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "toggleUri", '');
    (0, _defineProperty2.default)(this, "summary", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "columns", columns);
    (0, _defineProperty2.default)(this, "bucketName", '');
    (0, _defineProperty2.default)(this, "rows", _knockout.default.observableArray().ofType(AccountRowViewModel, {
      table: this
    }));
  }

  selectState(state) {
    return [state.accounts, state.location];
  }

  mapStateToProps(accounts, location) {
    const {
      params,
      route
    } = location;

    if (!accounts) {
      _knockout.default.assignToProps(this, {
        dataReady: false,
        accountCount: 0
      });
    } else {
      if (route !== routes.bucket) return;
      const connectedAccounts = Object.values(accounts).filter(account => account.allowedBuckets.includes(params.bucket) && !account.roles.includes('operator'));
      const accountCount = connectedAccounts.length;
      const summary = `${(0, _stringUtils.stringifyAmount)('account', accountCount, 'No')} ${accountCount === 1 ? 'is' : 'are'} granted access to this bucket`;
      const isExpanded = params.section === policyName;
      const toggleUri = (0, _browserUtils.realizeUri)(route, {
        system: params.system,
        bucket: params.bucket,
        tab: params.tab,
        section: isExpanded ? undefined : policyName
      });

      _knockout.default.assignToProps(this, {
        dataReady: true,
        bucketName: params.bucket,
        isExpanded,
        toggleUri,
        summary,
        rows: connectedAccounts.map(account => _mapAccountToRow(account, location))
      });
    }
  }

  onToggleSection() {
    this.dispatch((0, _actionCreators.requestLocation)(this.toggleUri));
  }

  onShowAccountDetails(connection) {
    const {
      endpoint,
      accessKey,
      secretKey
    } = connection;
    this.dispatch((0, _actionCreators.openS3AccessDetailsModal)(endpoint, accessKey, secretKey));
  }

  onEditS3Access(_, evt) {
    this.dispatch((0, _actionCreators.openBucketS3AccessModal)(this.bucketName));
    evt.stopPropagation();
  }

}

var _default = {
  viewModel: BucketS3AccessTableViewModel,
  template: _bucketS3AccessPolicyForm.default
};
exports.default = _default;

},{"./bucket-s3-access-policy-form.html":413,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"components/connectable":446,"knockout":"knockout","routes":972,"utils/browser-utils":1021,"utils/core-utils":1027,"utils/string-utils":1046}],415:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"fill row\" ko.visible=\"!dataReady()\">\n    <loading-indicator class=\"align-middle greedy\" params=\"label: true\"></loading-indicator>\n</div>\n\n<div class=\"summary greedy row\" ko.css.visible=\"dataReady\">\n    <section class=\"card c4 column\">\n        <div class=\"row content-middle hpad greedy\" ko.if=\"state\">\n            <svg-icon class=\"push-next\" params=\"name: state().icon.name\"\n                ko.css=\"state().icon.css\"\n                ko.tooltip=\"state().icon.tooltip\"\n            ></svg-icon>\n            <span class=\"heading3 greedy\" ko.text=\"state().text\"></span>\n        </div>\n        <hr/>\n        <div class=\"row content-middle hpad greedy\">\n            <span class=\"c5 push-next\">Resources:</span>\n            <span class=\"c7 text-right\" ko.text=\"dataPlacement\"></span>\n        </div>\n    </section>\n\n    <section class=\"column c4 hpad-double push-both\">\n        <div class=\"row content-middle push-next-half\">\n            <h2 class=\"heading3 greedy push-next\">Storage Availability</h2>\n            <p class=\"remark content-middle\">\n                <svg-icon class=\"icon-small\" params=\"name: 'clock'\"></svg-icon>\n                Updated: {{availablityTime}}\n            </p>\n        </div>\n        <chart-legend class=\"avil-legend greedy\" params=\"\n            items: availablityBar.values,\n            format: 'size'\n        \"></chart-legend>\n\n        <bar class=\"storage-bar bar-flip-markers push-next\" params=\"\n            values: availablityBar.values,\n            markers: availablityBar.markers,\n            limits: true,\n            format: availablityBar.format\n        \"></bar>\n    </section>\n\n    <section class=\"c4 card column\">\n        <div class=\"row content-middle hpad greedy\">\n            <!-- ko with: dataUsageChart -->\n            <svg class=\"data-usage-chart scale-on-hover push-next\"\n                ko.css.disabled=\"disabled\"\n                ko.tooltip=\"tooltip\"\n            >\n                <g class=\"usage-bars\" ko.foreach=\"bars\">\n                    <rect class=\"usage-bar\" ko.style=\"$data\"></rect>\n                </g>\n            </svg>\n            <!-- /ko -->\n            <div class=\"column\">\n                <p class=\"heading3\" ko.text=\"dataOptimization\"></p>\n                <p>\n                    Data Optimization\n                    <more-info-icon\n                        class=\"push-prev-half\"\n                        params=\"tooltip: dataUsageTooltip\"\n                    ></more-info-icon>\n                </p>\n            </div>\n        </div>\n        <hr />\n        <div class=\"row content-middle hpad greedy\">\n            <!-- ko with: rawUsageChart -->\n            <pie-chart class=\"raw-usage-chart pc-hide-values pc-non-interactive scale-on-hover push-next\"\n                ko.tooltip=\"tooltip\"\n                ko.css.disabled=\"disabled\"\n                params=\"values: values\"\n            ></pie-chart>\n            <!-- /ko -->\n            <div class=\"column\">\n                <p class=\"heading3\" ko.text=\"rawUsageLabel\"></p>\n                <p>\n                    Raw Usage\n                   <more-info-icon\n                        class=\"push-prev-half\"\n                        params=\"tooltip: rawUsageTooltip\"\n                    ></more-info-icon>\n                </p>\n            </div>\n        </div>\n    </section>\n</div>\n";

},{}],416:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _bucketSummary = _interopRequireDefault(require("./bucket-summary.html"));

var _chartTooltip = _interopRequireDefault(require("./chart-tooltip.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _coreUtils = require("utils/core-utils");

var _stringUtils = require("utils/string-utils");

var _sizeUtils = require("utils/size-utils");

var _knockout = _interopRequireDefault(require("knockout"));

var _moment = _interopRequireDefault(require("moment"));

var _numeral = _interopRequireDefault(require("numeral"));

var _bucketUtils = require("utils/bucket-utils");

/* Copyright (C) 2016 NooBaa */
const rawUsageTooltip = (0, _coreUtils.deepFreeze)({
  text: 'Raw usage refers to the actual size this bucket is utilizing from it\'s resources including data resiliency replicas or fragments',
  align: 'end'
});
const dataUsageTooltip = (0, _coreUtils.deepFreeze)({
  text: 'Data optimization consist of deduplication and compression',
  align: 'end'
});

function _summrizeResiliencyPolicy(resiliency) {
  const {
    kind,
    replicas,
    dataFrags,
    parityFrags
  } = resiliency;
  const desc = kind === 'REPLICATION' && `replication of ${replicas} copies` || kind === 'ERASURE_CODING' && `erasure coding of ${dataFrags}+${parityFrags}` || 'an unknown policy';
  const driveCount = kind === 'REPLICATION' && replicas || kind === 'ERASURE_CODING' && dataFrags + parityFrags || NaN;
  return {
    desc,
    driveCount
  };
}

function _mapModeToStateTooltip(bucket, dataBreakdown, hostPools, cloudResources) {
  const {
    tiers
  } = bucket.placement;

  switch (bucket.mode) {
    case 'NO_RESOURCES':
      {
        return 'This bucket is not connected to any resources that can be utilized. Add resources via bucket data placement policy';
      }

    case 'NOT_ENOUGH_RESOURCES':
      {
        const {
          desc,
          driveCount
        } = _summrizeResiliencyPolicy(bucket.resiliency);

        return `The bucket’s configured data resiliency is set to ${desc} In order to meet that requirement, each tier must have at least ${driveCount} in their pools or a cloud resource in it\'s placement policy`;
      }

    case 'NOT_ENOUGH_HEALTHY_RESOURCES':
      {
        return 'Some resources are not healthy and the bucket data allocation cannot be completed. Try fixing problematic resources or change the bucket’s placement policy.';
      }

    case 'NO_CAPACITY':
      {
        return 'This bucket has no more available storage. In order to enable data writes, add more resources to the bucket data placement policy';
      }

    case 'ALL_TIERS_HAVE_ISSUES':
      {
        return 'The bucket’s tiering structure is suffering from various issues. Try fixing problematic resources or change the tiers placement policy';
      }

    case 'EXCEEDING_QUOTA':
      {
        return 'This bucket data writes reached the configured limit. Change the bucket quota configurations to enable new writes';
      }

    case 'TIER_NO_RESOURCES':
      {
        const i = tiers.findIndex(tier => tier.mode === 'NO_RESOURCES');
        return `Tier ${i + 1} is not connected to any resources that can be utilized. Add resources via Edit tier ${i + 1} resources.`;
      }

    case 'TIER_NOT_ENOUGH_RESOURCES':
      {
        const tier = tiers.find(tier => tier.mode === 'NOT_ENOUGH_RESOURCES');

        const {
          desc,
          driveCount
        } = _summrizeResiliencyPolicy(bucket.resiliency);

        const storageNodesPerMirrorSet = (0, _bucketUtils.countStorageNodesByMirrorSet)(tier, hostPools);
        const missingNodes = (0, _coreUtils.sumBy)(storageNodesPerMirrorSet, count => Math.max(0, driveCount - count));
        return `The bucket's configured data resiliency is set to ${desc}. In order to meet that requirement, add at least ${missingNodes} more drives to the nodes pool or add a cloud resource to the tier's placement policy`;
      }

    case 'TIER_NOT_ENOUGH_HEALTHY_RESOURCES':
      {
        const i = tiers.findIndex(tier => tier.mode === 'NOT_ENOUGH_HEALTHY_RESOURCES');
        return `Some resources are not healthy and the data allocation cannot be completed. Try fixing problematic resources or change tier ${i + 1} resources policy.`;
      }

    case 'TIER_NO_CAPACITY':
      {
        const i = tiers.findIndex(tier => tier.mode === 'NO_CAPACITY');
        return `Tier ${i + 1} has no more available storage. In order to enable data writes and maintain the tier data structure, add more resources to the tier resources policy`;
      }

    case 'LOW_CAPACITY':
      {
        const available = (0, _sizeUtils.formatSize)(dataBreakdown.availableForUpload);
        return `The currently size available for uploads is ${available}, try adding more resources or change the bucket policies`;
      }

    case 'TIER_LOW_CAPACITY':
      {
        const i = tiers.findIndex(tier => tier.mode === 'LOW_CAPACITY');
        const availableSize = (0, _coreUtils.flatMap)(tiers[i].mirrorSets || [], ms => ms.resources).reduce((size, {
          type,
          name
        }) => {
          const coll = type === 'HOSTS' ? hostPools : cloudResources;
          const {
            free = 0,
            unavailableFree = 0
          } = coll[name];
          return (0, _sizeUtils.sumSize)(size, free, unavailableFree);
        }, 0);
        const available = (0, _sizeUtils.formatSize)(availableSize);
        return `Tier ${i + 1} current available capacity is only ${available}. If you wish to continue writing to this tier, try adding more resources or change the bucket policies `;
      }

    case 'NO_RESOURCES_INTERNAL':
      {
        return 'Bucket doesn\’t have any connected resources in it’s tier. Currently the system is using the internal VM disk capacity to store data which is not recommended. Add resources to the bucket’s tier placement policy.';
      }

    case 'RISKY_TOLERANCE':
      {
        return 'According to the configured data resiliency policy, only 1 node/drive can fail before all stored data will no longer be able to recover. It’s recommended to add more nodes to the pools and distribute drives over the different nodes';
      }

    case 'APPROUCHING_QUOTA':
      {
        const quota = (0, _sizeUtils.formatSize)((0, _bucketUtils.getQuotaValue)(bucket.quota));
        const used = (0, _sizeUtils.formatSize)(dataBreakdown.used);
        const available = (0, _sizeUtils.formatSize)(dataBreakdown.availableForUpload);
        return `Bucket utilization is ${used} out of ${quota}. Please change the configured limit if you wish to write more then ${available} this bucket`;
      }

    case 'DATA_ACTIVITY':
      {
        return 'Currently restoring/migrating/deleting data according to the latest change that was made in the bucket policy. The process might take a while';
      }

    case 'OPTIMAL':
      {
        return 'Bucket is operating as expected according to it’s configured bucket policies';
      }
  }
}

function _getDataPlacementText(placement) {
  const {
    tiers
  } = placement;
  const resources = (0, _coreUtils.flatMap)(tiers, tier => (0, _coreUtils.flatMap)(tier.mirrorSets || [], ms => ms.resources));
  return `${(0, _stringUtils.stringifyAmount)('tier', tiers.length)}, ${(0, _stringUtils.stringifyAmount)('resource', resources.length)}`;
}

function _getBucketStateInfo(bucket, dataBreakdown, hostPools, cloudResources) {
  const {
    name,
    css,
    tooltip: {
      text
    }
  } = (0, _bucketUtils.getBucketStateIcon)(bucket);

  const tooltip = _mapModeToStateTooltip(bucket, dataBreakdown, hostPools, cloudResources);

  return {
    icon: {
      name,
      css,
      tooltip: {
        text: tooltip,
        align: 'start'
      }
    },
    text
  };
}

class BucketSummrayViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "state", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "dataPlacement", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "availablityTime", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "availablityBar", {
      format: _knockout.default.observable(),
      values: [{
        label: 'Used Data',
        color: 'rgb(var(--color20))',
        value: _knockout.default.observable(0),
        tooltip: 'The total amount of data uploaded to this bucket. does not include data optimization or data resiliency'
      }, {
        label: 'Available According to Policies',
        color: 'rgb(var(--color07))',
        value: _knockout.default.observable(0),
        tooltip: 'The actual free space on this bucket for data writes taking into account the current configured bucket policies'
      }, {
        label: 'Available on Internal Storage',
        color: 'rgb(var(--color02))',
        value: _knockout.default.observable(0),
        visible: _knockout.default.observable(),
        tooltip: 'The current available storage from the system internal storage disks, will be used only in the case of no available storage resources on this bucket.'
      }, {
        label: 'Overallocated',
        color: 'rgb(var(--color31))',
        value: _knockout.default.observable(0),
        visible: _knockout.default.observable(),
        tooltip: 'Overallocation happens when configuring a higher quota than this bucket assigned resources can store'
      }, {
        label: 'Overused',
        color: 'rgb(var(--color26))',
        value: _knockout.default.observable(0),
        visible: _knockout.default.observable(),
        tooltip: 'Data that was written and exceeded the bucket configured quota'
      }],
      markers: [{
        visible: _knockout.default.observable(),
        text: _knockout.default.observable(),
        position: 4
      }]
    });
    (0, _defineProperty2.default)(this, "dataOptimization", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "dataUsageTooltip", dataUsageTooltip);
    (0, _defineProperty2.default)(this, "dataUsage", [{
      label: 'Original Data Size',
      color: 'rgb(var(--color11))',
      value: _knockout.default.observable()
    }, {
      label: 'After Optimizations',
      color: 'rgb(var(--color20))',
      value: _knockout.default.observable()
    }]);
    (0, _defineProperty2.default)(this, "dataUsageChart", {
      draw: this.onDrawBars.bind(this),
      disabled: _knockout.default.observable(),
      bars: this.dataUsage.map((item, i) => ({
        x: 1 / 9 * (1 + 4 * i),
        y: _knockout.default.observable(),
        width: 1 / 3,
        height: _knockout.default.observable(),
        fill: item.color
      })),
      tooltip: {
        maxWidth: 280,
        template: _chartTooltip.default,
        text: {
          updateTime: _knockout.default.observable(),
          values: this.dataUsage
        }
      }
    });
    (0, _defineProperty2.default)(this, "rawUsageLabel", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "rawUsageTooltip", rawUsageTooltip);
    (0, _defineProperty2.default)(this, "rawUsageValues", [{
      label: 'Available from Resources',
      color: 'rgb(var(--color13))',
      value: _knockout.default.observable(0)
    }, {
      label: 'Raw Usage',
      color: 'rgb(var(--color20))',
      value: _knockout.default.observable(0)
    }, {
      label: 'Shared Resources Usage',
      color: 'rgb(var(--color29))',
      value: _knockout.default.observable(0)
    }]);
    (0, _defineProperty2.default)(this, "rawUsageChart", {
      values: this.rawUsageValues,
      silhouetteColor: _knockout.default.observable(),
      disabled: _knockout.default.observable(),
      tooltip: {
        maxWidth: 280,
        template: _chartTooltip.default,
        text: {
          caption: _knockout.default.observable(),
          updateTime: _knockout.default.observable(),
          values: this.rawUsageValues
        }
      }
    });
  }

  selectState(state, params) {
    return [state.buckets && state.buckets[params.bucketName], state.hostPools, state.cloudResources];
  }

  mapStateToProps(bucket, hostPools, cloudResources) {
    if (!bucket) {
      _knockout.default.assignToProps(this, {
        dataReady: false
      });
    } else {
      const {
        quota,
        placement
      } = bucket;
      const storage = (0, _coreUtils.mapValues)(bucket.storage, _sizeUtils.toBytes);
      const usingInternalStorage = placement.tiers[0].policyType === 'INTERNAL_STORAGE';
      const data = (0, _coreUtils.mapValues)(bucket.data, _sizeUtils.toBytes);
      const dataBreakdown = (0, _coreUtils.mapValues)((0, _bucketUtils.getDataBreakdown)(data, quota), _sizeUtils.toBytes);
      const rawUsageLabel = storage.used ? (0, _sizeUtils.formatSize)(storage.used) : 'No Usage';
      const rawUsageTooltipCaption = `Total Raw Storage: ${(0, _sizeUtils.formatSize)(storage.total)}`;
      const dataLastUpdateTime = (0, _moment.default)(storage.lastUpdate).fromNow();
      const storageLastUpdateTime = (0, _moment.default)(data.lastUpdate).fromNow();
      const hasSize = data.size > 0;
      const reducedRatio = hasSize ? Math.min(data.sizeReduced / data.size, 1) : 0;
      const dataOptimization = hasSize ? (0, _numeral.default)(1 - reducedRatio).format('%') : 'No Data';
      const storageUsed = storage.used + storage.usedOther;
      const isInOveruse = (0, _sizeUtils.toBytes)(dataBreakdown.overused) > 0;

      _knockout.default.assignToProps(this, {
        dataReady: true,
        state: _getBucketStateInfo(bucket, dataBreakdown, hostPools, cloudResources),
        dataPlacement: _getDataPlacementText(placement),
        availablityBar: {
          format: val => val === 0 && '0' || quota && !isInOveruse && `Quota: ${(0, _sizeUtils.formatSize)(val)}` || (0, _sizeUtils.formatSize)(val),
          values: [{
            value: dataBreakdown.used
          }, {
            value: !usingInternalStorage ? dataBreakdown.availableForUpload : 0
          }, {
            value: usingInternalStorage ? dataBreakdown.availableForUpload : 0,
            visible: usingInternalStorage
          }, {
            value: dataBreakdown.overallocated,
            visible: !(0, _sizeUtils.isSizeZero)(dataBreakdown.overallocated)
          }, {
            value: dataBreakdown.overused,
            visible: !(0, _sizeUtils.isSizeZero)(dataBreakdown.overused)
          }],
          markers: [{
            visible: Boolean(quota) && isInOveruse,
            text: quota ? `Quota: ${(0, _sizeUtils.formatSize)((0, _bucketUtils.getQuotaValue)(quota))}` : ''
          }]
        },
        availablityTime: dataLastUpdateTime,
        dataOptimization: dataOptimization,
        dataUsage: [{
          value: data.size
        }, {
          value: data.sizeReduced
        }],
        dataUsageChart: {
          disabled: !hasSize,
          bars: [{
            y: 0,
            height: 1
          }, {
            y: hasSize ? 1 - reducedRatio : 0,
            height: hasSize ? reducedRatio : 1
          }],
          tooltip: {
            text: {
              updateTime: dataLastUpdateTime
            }
          }
        },
        rawUsageLabel: rawUsageLabel,
        rawUsageValues: [{
          value: storage.free
        }, {
          value: storage.used
        }, {
          value: storage.usedOther
        }],
        rawUsageChart: {
          disabled: storageUsed === 0,
          tooltip: {
            text: {
              caption: rawUsageTooltipCaption,
              updateTime: storageLastUpdateTime
            }
          }
        }
      });
    }
  }

  onDrawBars(ctx, size) {
    if (!this.dataReady()) return;
    const barWidth = 16;
    const {
      width,
      height: scale
    } = size;
    const {
      bars
    } = this.dataUsageChart;
    const spacing = (width - bars.length * barWidth) / (bars.length + 1);
    bars.reduce((offset, bar) => {
      const {
        color,
        height
      } = bar;
      ctx.fillStyle = color;
      ctx.fillRect(offset, (1 - height()) * scale, barWidth, height() * scale);
      return offset + barWidth + spacing;
    }, spacing);
  }

}

var _default = {
  viewModel: BucketSummrayViewModel,
  template: _bucketSummary.default
};
exports.default = _default;

},{"./bucket-summary.html":415,"./chart-tooltip.html":417,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"components/connectable":446,"knockout":"knockout","moment":"moment","numeral":"numeral","utils/bucket-utils":1022,"utils/core-utils":1027,"utils/size-utils":1043,"utils/string-utils":1046}],417:[function(require,module,exports){
module.exports = "<!-- ko if: $data.caption -->\n<h3 class=\"remark highlight\" ko.text=\"caption\"></h3>\n<!-- /ko -->\n\n<chart-legend params=\"items: values, format: 'size'\"></chart-legend>\n\n<p class=\"remark content-middle\">\n    <svg-icon class=\"icon-small push-next-half\" params=\"name: 'clock'\"></svg-icon>\n    Updated: {{updateTime}}\n</p>\n";

},{}],418:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"row pad row content-middle card-shadow\">\n    <div class=\"column greedy push-next\">\n        <h3 class=\"heading3\">\n            Bucket Triggers\n        </h3>\n        <p>Triggers will automatically invoke selected function on the bucket.</p>\n    </div>\n    <button class=\"btn\" ko.click=\"onAddTrigger\">\n        Add Trigger\n    </button>\n</div>\n\n<data-table class=\"functions-table greedy\" params=\"\n    columns: columns,\n    sorting: ko.pc(sorting, onSort, $component),\n    data: rows,\n    loading: !dataReady(),\n    emptyMessage: 'No triggers configured for this bucket'\n\"></data-table>\n\n<paginator params=\"\n    itemCount: triggerCount,\n    pageSize: ko.pc(pageSize, onPageSize, $component),\n    page: ko.pc(page, onPage, $component)\n\"></paginator>\n";

},{}],419:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _bucketTriggersForm = _interopRequireDefault(require("./bucket-triggers-form.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _moment = _interopRequireDefault(require("moment"));

var _coreUtils = require("utils/core-utils");

var _browserUtils = require("utils/browser-utils");

var _bucketUtils = require("utils/bucket-utils");

var _config = require("config");

var _actionCreators = require("action-creators");

var routes = _interopRequireWildcard(require("routes"));

/* Copyright (C) 2016 NooBaa */
const columns = (0, _coreUtils.deepFreeze)([{
  name: 'state',
  type: 'icon',
  sortable: true,
  compareKey: trigger => trigger.enabled
}, {
  name: 'funcName',
  label: 'Function Name',
  type: 'link',
  sortable: true,
  compareKey: trigger => trigger.func.name
}, {
  name: 'event',
  label: 'Event Type',
  sortable: true,
  compareKey: trigger => trigger.event
}, {
  name: 'prefix',
  sortable: true,
  compareKey: trigger => trigger.prefix
}, {
  name: 'suffix',
  sortable: true,
  compareKey: trigger => trigger.suffix
}, {
  name: 'lastRun',
  label: 'Last Run',
  sortable: true,
  compareKey: trigger => trigger.lastRun || 0
}, {
  name: 'edit',
  label: '',
  type: 'iconButton'
}, {
  name: 'delete',
  label: '',
  type: 'delete'
}]);
const modeToStatus = (0, _coreUtils.deepFreeze)({
  DISABLED: {
    name: 'healthy',
    css: 'disabled',
    tooltip: 'Disabled'
  },
  MISSING_PERMISSIONS: {
    name: 'problem',
    css: 'warning',
    tooltip: 'Access issue'
  },
  OPTIMAL: {
    name: 'healthy',
    css: 'success',
    tooltip: 'Healthy'
  }
});

function _mapTriggerToRow(trigger, system, selectedForDelete) {
  const event = _bucketUtils.bucketEvents.find(event => event.value === trigger.event).label;

  const func = trigger.func.name;
  const funcName = {
    text: func,
    href: (0, _browserUtils.realizeUri)(routes.func, {
      system,
      func
    })
  };
  const lastRun = trigger.lastRun ? (0, _moment.default)(trigger.lastRun).fromNow() : '(never run)';
  return {
    state: modeToStatus[trigger.mode],
    funcName,
    event,
    prefix: trigger.prefix || '(not set)',
    suffix: trigger.suffix || '(not set)',
    lastRun,
    triggerId: trigger.id,
    delete: {
      active: selectedForDelete === trigger.id
    }
  };
}

class TriggerRowViewModel {
  constructor({
    table
  }) {
    (0, _defineProperty2.default)(this, "table", null);
    (0, _defineProperty2.default)(this, "state", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "funcName", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "event", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "prefix", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "suffix", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "lastRun", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "triggerId", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "edit", {
      id: this.triggerId,
      icon: 'edit',
      tooltip: 'Edit Trigger',
      onClick: id => this.table.onEditTrigger(id)
    });
    (0, _defineProperty2.default)(this, "delete", {
      text: 'Delete trigger',
      disabled: false,
      active: _knockout.default.observable(),
      id: this.triggerId,
      onToggle: id => this.table.onSelectForDelete(id),
      onDelete: id => this.table.onDeleteTrigger(id)
    });
    this.table = table;
  }

}

class BucketTriggersFormViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "bucketName", '');
    (0, _defineProperty2.default)(this, "columns", columns);
    (0, _defineProperty2.default)(this, "pathname", '');
    (0, _defineProperty2.default)(this, "sorting", _knockout.default.observable({}));
    (0, _defineProperty2.default)(this, "page", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "pageSize", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "selectedForDelete", '');
    (0, _defineProperty2.default)(this, "triggerCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "rows", _knockout.default.observableArray().ofType(TriggerRowViewModel, {
      table: this
    }));
  }

  selectState(state, params) {
    return [params.bucketName, state.bucketTriggers, state.location];
  }

  mapStateToProps(bucketName, triggers, location) {
    if (!triggers || location.params.tab !== 'triggers') {
      _knockout.default.assignToProps(this, {
        dataReady: false
      });
    } else {
      const bucketTriggers = Object.values(triggers).filter(trigger => {
        const {
          kind,
          name
        } = trigger.bucket;
        return kind === 'DATA_BUCKET' && name === bucketName;
      });
      const {
        params,
        query,
        pathname
      } = location;
      const {
        sortBy = 'funcName',
        selectedForDelete
      } = query;
      const page = Number(query.page) || 0;

      const pageSize = Number(query.pageSize) || _config.paginationPageSize.default;

      const order = Number(query.page) || 1;
      const {
        compareKey
      } = columns.find(column => column.name === sortBy);
      const pageStart = page * pageSize;
      const triggerList = Object.values(bucketTriggers);
      const rows = triggerList.sort((0, _coreUtils.createCompareFunc)(compareKey, order)).slice(pageStart, pageStart + pageSize).map(trigger => _mapTriggerToRow(trigger, params.system, selectedForDelete));

      _knockout.default.assignToProps(this, {
        dataReady: true,
        bucketName,
        triggerCount: triggerList.length,
        pathname,
        sorting: {
          sortBy,
          order
        },
        page,
        pageSize,
        selectedForDelete,
        rows: rows
      });
    }
  }

  onAddTrigger() {
    this.dispatch((0, _actionCreators.openAddBucketTriggerModal)(this.bucketName));
  }

  onEditTrigger(triggerId) {
    this.dispatch((0, _actionCreators.openEditBucketTriggerModal)('BUCKET', triggerId));
  }

  onDeleteTrigger(triggerId) {
    this.dispatch((0, _actionCreators.removeBucketTrigger)(this.bucketName, triggerId));
  }

  onSort(sorting) {
    this._query({ ...sorting,
      page: 0,
      selectedForDelete: null
    });
  }

  onPage(page) {
    this._query({
      page,
      selectedForDelete: null
    });
  }

  onPageSize(pageSize) {
    this._query({
      pageSize,
      page: 0,
      selectedForDelete: null
    });
  }

  onSelectForDelete(selected) {
    this._query({
      selectedForDelete: selected
    });
  }

  _query(params) {
    const {
      sortBy = this.sorting().sortBy,
      order = this.sorting().order,
      page = this.page(),
      pageSize = this.pageSize(),
      selectedForDelete = this.selectedForDelete
    } = params;
    const query = {
      sortBy,
      order,
      page,
      pageSize,
      selectedForDelete: selectedForDelete || undefined
    };
    this.dispatch((0, _actionCreators.requestLocation)((0, _browserUtils.realizeUri)(this.pathname, {}, query)));
  }

}

var _default = {
  viewModel: BucketTriggersFormViewModel,
  template: _bucketTriggersForm.default
};
exports.default = _default;

},{"./bucket-triggers-form.html":418,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"components/connectable":446,"config":831,"knockout":"knockout","moment":"moment","routes":972,"utils/browser-utils":1021,"utils/bucket-utils":1022,"utils/core-utils":1027}],420:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<section class=\"pad\">\n    <div class=\"row content-middle bucket-policy-summary\"\n        ko.click=\"onToggleSection\"\n    >\n        <svg-icon class=\"push-next\"\n            params=\"name: stateIcon.name\"\n            ko.css=\"stateIcon.css\"\n            ko.tooltip=\"stateIcon.tooltip\"\n        ></svg-icon>\n        <div class=\"column greedy\">\n            <h2 class=\"heading3 greedy\">Object Versioning</h2>\n            <p class=\"row content-middle\"\n                ko.visible=\"!isExpanded()\"\n            >\n                {{summary}}\n            </p>\n            <p ko.visible=\"isExpanded\">\n                Versioning will keep multiple versions of an object in this bucket\n            </p>\n        </div>\n        <button class=\"btn push-both\"\n            ko.click=\"onToggleVersioning\"\n            ko.preventBubble=\"'click'\"\n        >\n            {{toggleBtn.text}}\n        </button>\n        <svg-icon class=\"icon-small rotate\"\n            ko.css=\"{ 'deg-90': !isExpanded() }\"\n            params=\"name: 'chevron'\"\n        ></svg-icon>\n    </div>\n    <div class=\"column hpad\" ko.expand=\"isExpanded\">\n        <property-sheet class=\"hpad push-prev\" params=\"properties: details\">\n            <templates name=\"styled-text\">\n                <span ko.css=\"css\" ko.text=\"text\"></span>\n            </templates>\n        </property-sheet>\n    </div>\n</section>\n\n";

},{}],421:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _bucketVersioningPolicyForm = _interopRequireDefault(require("./bucket-versioning-policy-form.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _coreUtils = require("utils/core-utils");

var _browserUtils = require("utils/browser-utils");

var _knockout = _interopRequireDefault(require("knockout"));

var routes = _interopRequireWildcard(require("routes"));

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const policyName = 'versioning';
const modeMapping = (0, _coreUtils.deepFreeze)({
  DISABLED: {
    icon: {
      name: 'healthy',
      css: 'disabled',
      tooltip: {
        text: 'Disabled',
        align: 'start'
      }
    },
    summary: 'Disabled',
    toggleBtn: {
      text: 'Enable Versioning',
      updateTo: 'ENABLED'
    },
    state: {
      text: 'Disabled',
      css: ''
    }
  },
  SUSPENDED: {
    icon: {
      name: 'problem',
      css: 'warning',
      tooltip: {
        text: 'Suspended',
        align: 'start'
      }
    },
    summary: 'Versioning is currently suspended',
    toggleBtn: {
      text: 'Resume Versioning',
      updateTo: 'ENABLED'
    },
    state: {
      text: 'Suspended',
      css: 'warning'
    }
  },
  ENABLED: {
    icon: {
      name: 'healthy',
      css: 'success',
      tooltip: {
        text: 'Enabled',
        align: 'start'
      }
    },
    summary: 'Enabled',
    toggleBtn: {
      text: 'Suspend Versioning',
      updateTo: 'SUSPENDED'
    },
    state: {
      text: 'Enabled',
      css: ''
    }
  }
});

class BucketVersioningPolicyFormViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "isExpanded", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "toggleUri", '');
    (0, _defineProperty2.default)(this, "bucketName", '');
    (0, _defineProperty2.default)(this, "toggleBtn", {
      text: _knockout.default.observable(),
      updateTo: ''
    });
    (0, _defineProperty2.default)(this, "stateIcon", {
      name: _knockout.default.observable(),
      css: _knockout.default.observable(),
      tooltip: _knockout.default.observable()
    });
    (0, _defineProperty2.default)(this, "summary", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "details", [{
      label: 'Object versioning state',
      template: 'styled-text',
      value: {
        text: _knockout.default.observable(),
        css: _knockout.default.observable()
      }
    }]);
  }

  selectState(state) {
    const {
      location,
      buckets
    } = state;
    const {
      bucket: bucketName
    } = location.params;
    return [location, buckets && buckets[bucketName]];
  }

  mapStateToProps(location, bucket) {
    if (!bucket || location.route !== routes.bucket) {
      _knockout.default.assignToProps(this, {
        isExpanded: false
      });
    } else {
      const {
        system,
        tab = 'data-policies',
        section
      } = location.params;
      const toggleSection = section === policyName ? undefined : policyName;
      const {
        icon,
        summary,
        toggleBtn,
        state
      } = modeMapping[bucket.versioning.mode];

      _knockout.default.assignToProps(this, {
        isExpanded: section === policyName,
        toggleUri: (0, _browserUtils.realizeUri)(routes.bucket, {
          system,
          bucket: bucket.name,
          tab,
          section: toggleSection
        }),
        bucketName: bucket.name,
        toggleBtn,
        stateIcon: icon,
        summary,
        details: [{
          value: state
        }]
      });
    }
  }

  onToggleSection() {
    this.dispatch((0, _actionCreators.requestLocation)(this.toggleUri));
  }

  onToggleVersioning() {
    this.dispatch((0, _actionCreators.updateBucketVersioningPolicy)(this.bucketName, this.toggleBtn.updateTo));
  }

}

var _default = {
  viewModel: BucketVersioningPolicyFormViewModel,
  template: _bucketVersioningPolicyForm.default
};
exports.default = _default;

},{"./bucket-versioning-policy-form.html":420,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"components/connectable":446,"knockout":"knockout","routes":972,"utils/browser-utils":1021,"utils/core-utils":1027}],422:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<section class=\"pad\" ko.if=\"dataReady\">\n    <div class=\"row content-middle bucket-policy-summary cursor-pointer\"\n        ko.click=\"onToggleSection\"\n    >\n        <svg-icon class=\"push-next\"\n            params=\"name: stateIcon().name\"\n            ko.css=\"stateIcon().css\"\n            ko.tooltip=\"stateIcon().tooltip\"\n        ></svg-icon>\n        <div class=\"column greedy\">\n            <h2 class=\"heading3 greedy\">{{tierDisplayName}}</h2>\n            <p class=\"row content-middle\">\n                Policy Type: {{placementType}}\n                <vr class=\"push-both-half\"></vr>\n                Pools: {{hostPoolCount}}\n                <vr class=\"push-both-half\"></vr>\n                Cloud Resources: {{cloudResourceCount}}\n                <vr class=\"push-both-half\"></vr>\n                Available Capacity: {{capacity}}\n            </p>\n        </div>\n        <div class=\"push-both\" ko.tooltip=\"editTierPlacementTooltip\">\n            <button class=\"btn\"\n                ko.disable=\"isEditTierPlacementDisabled\"\n                ko.click=\"onEditTierPlacement\"\n            >\n                Edit {{tierDisplayName}} Resources\n            </button>\n        </div>\n        <svg-icon class=\"icon-small rotate\"\n            ko.css=\"{ 'deg-90': !isExpanded() }\"\n            params=\"name: 'chevron'\"\n        ></svg-icon>\n    </div>\n    <div class=\"column hpad\" ko.expand=\"isExpanded\">\n        <div class=\"hpad push-prev\">\n            <data-table class=\"content-box placement-table\" params=\"\n                columns: columns,\n                data: rows,\n                emptyMessage: emptyMessage\n            \"></data-table>\n        </div>\n    </div>\n</section>\n\n";

},{}],423:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _tierDataPlacementPolicyForm = _interopRequireDefault(require("./tier-data-placement-policy-form.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _bucketUtils = require("utils/bucket-utils");

var _coreUtils = require("utils/core-utils");

var _storageUtils = require("utils/storage-utils");

var _sizeUtils = require("utils/size-utils");

var _browserUtils = require("utils/browser-utils");

var _resourceUtils = require("utils/resource-utils");

var _actionCreators = require("action-creators");

var _knockout = _interopRequireDefault(require("knockout"));

var _numeral = _interopRequireDefault(require("numeral"));

var routes = _interopRequireWildcard(require("routes"));

/* Copyright (C) 2016 NooBaa */
const columns = (0, _coreUtils.deepFreeze)([{
  name: 'state',
  type: 'icon'
}, {
  name: 'type',
  type: 'icon'
}, {
  name: 'resourceName',
  type: 'link'
}, {
  name: 'region'
}, {
  name: 'healthyHosts',
  label: 'Healthy Nodes'
}, {
  name: 'healthyNodes',
  label: 'Healthy Drives'
}, {
  name: 'bucketUsage',
  label: 'Raw Usage by This Bucket',
  type: 'capacity'
}]);
const nodesPoolType = (0, _coreUtils.deepFreeze)({
  name: 'nodes-pool',
  tooltip: 'Nodes Pool'
});
const emptyTierStateIcon = (0, _coreUtils.deepFreeze)({
  name: 'problem',
  css: 'warning',
  tooltip: {
    align: 'start',
    text: 'Tier is empty'
  }
});
const editTierPlacementTooltip = 'Editing the tier\'s resources will be enabled after adding storage resources to the system';

function _systemHasResources(hostPools, cloudResource) {
  return Object.keys(hostPools).length > 0 || Object.keys(cloudResource).length > 0;
}

function _mapHostPoolToRow(pool, bucketUsage = 0, system) {
  const resourceName = {
    text: pool.name,
    tooltip: {
      text: pool.name,
      breakWords: true
    },
    href: (0, _browserUtils.realizeUri)(routes.pool, {
      system,
      pool: pool.name
    })
  };
  return {
    resourceName,
    state: (0, _resourceUtils.getHostPoolStateIcon)(pool),
    type: nodesPoolType,
    region: pool.region || _resourceUtils.unassignedRegionText,
    healthyHosts: (0, _resourceUtils.getHostPoolHostsSummary)(pool),
    healthyNodes: (0, _resourceUtils.getHostPoolNodesSummary)(pool),
    bucketUsage: {
      total: pool.storage.total,
      used: bucketUsage
    }
  };
}

function _mapCloudResrouceToRow(resource, bucketUsage = 0, system) {
  const resourceName = {
    text: resource.name,
    tooltip: {
      text: resource.name,
      breakWords: true
    },
    href: (0, _browserUtils.realizeUri)(routes.cloudResource, {
      system,
      resource: resource.name
    })
  };
  return {
    resourceName,
    state: (0, _resourceUtils.getCloudResourceStateIcon)(resource),
    type: (0, _resourceUtils.getCloudResourceTypeIcon)(resource),
    region: resource.region || _resourceUtils.unassignedRegionText,
    healthyHosts: '---',
    healthyNodes: '---',
    bucketUsage: {
      total: resource.storage.total,
      used: bucketUsage
    }
  };
}

class ResourceRowViewModel {
  constructor() {
    (0, _defineProperty2.default)(this, "resourceName", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "state", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "type", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "region", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "healthyHosts", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "healthyNodes", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "bucketUsage", {
      total: _knockout.default.observable(),
      used: _knockout.default.observable()
    });
  }

}

class TierDataPlacementPolicyFormViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "bucketName", '');
    (0, _defineProperty2.default)(this, "tierName", '');
    (0, _defineProperty2.default)(this, "tierDisplayName", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "toggleUri", '');
    (0, _defineProperty2.default)(this, "stateIcon", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "placementType", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "hostPoolCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "cloudResourceCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "capacity", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isExpanded", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "columns", columns);
    (0, _defineProperty2.default)(this, "isEditTierPlacementDisabled", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "editTierPlacementTooltip", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "emptyMessage", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "rows", _knockout.default.observableArray().ofType(ResourceRowViewModel));
  }

  selectState(state, params) {
    const {
      bucketName,
      tierIndex
    } = params;
    return [state.buckets && state.buckets[bucketName], tierIndex, state.hostPools, state.cloudResources, state.location.params];
  }

  mapStateToProps(bucket, tierIndex, hostPools, cloudResources, locationParams) {
    const tierDisplayName = `Tier ${tierIndex + 1}`;

    if (!bucket || !hostPools || !cloudResources) {
      _knockout.default.assignToProps(this, {
        dataReady: false,
        tierDisplayName,
        isEditTierPlacementDisabled: false,
        isExpanded: false
      });
    } else {
      const hasResources = _systemHasResources(hostPools, cloudResources);

      const usageDistribution = bucket.usageDistribution.resources;
      const tier = bucket.placement.tiers[tierIndex];
      const {
        system,
        tab = 'data-placement',
        section
      } = locationParams;
      const isExpanded = section === tier.name;
      const toggleUri = (0, _browserUtils.realizeUri)(routes.bucket, {
        system,
        bucket: bucket.name,
        tab,
        section: isExpanded ? undefined : tier.name
      });

      if (tier.policyType === 'INTERNAL_STORAGE') {
        _knockout.default.assignToProps(this, {
          dataReady: true,
          bucketName: bucket.name,
          tierName: tier.name,
          tierDisplayName,
          toggleUri,
          stateIcon: emptyTierStateIcon,
          placementType: 'Spread',
          hostPoolCount: (0, _numeral.default)(0).format(','),
          cloudResourceCount: (0, _numeral.default)(0).format(','),
          capacity: `${(0, _sizeUtils.formatSize)(0)} of ${(0, _sizeUtils.formatSize)(0)}`,
          isExpanded,
          isEditTierPlacementDisabled: !hasResources,
          editTierPlacementTooltip: !hasResources && editTierPlacementTooltip,
          emptyMessage: 'No connected resources - using internal disks as default',
          rows: []
        });
      } else {
        const resources = (0, _coreUtils.flatMap)(tier.mirrorSets, ms => ms.resources);
        const {
          HOSTS: hostPoolNames = [],
          CLOUD: cloudResourceNames = []
        } = (0, _coreUtils.groupBy)(resources, res => res.type, res => res.name);
        const storage = (0, _storageUtils.aggregateStorage)(...resources.map(res => {
          const coll = res.type === 'HOSTS' ? hostPools : cloudResources;
          return coll[res.name].storage;
        }));
        const freeStorage = (0, _sizeUtils.sumSize)(storage.free || 0, storage.unavailableFree || 0);

        _knockout.default.assignToProps(this, {
          dataReady: true,
          bucketName: bucket.name,
          tierName: tier.name,
          tierDisplayName,
          toggleUri,
          stateIcon: (0, _bucketUtils.getPlacementStateIcon)(tier),
          placementType: (0, _bucketUtils.getPlacementTypeDisplayName)(tier.policyType),
          hostPoolCount: (0, _numeral.default)(hostPoolNames.length).format(','),
          cloudResourceCount: (0, _numeral.default)(cloudResourceNames.length).format(','),
          capacity: `${(0, _sizeUtils.formatSize)(freeStorage)} of ${(0, _sizeUtils.formatSize)(storage.total || 0)}`,
          isExpanded,
          isEditTierPlacementDisabled: !hasResources,
          editTierPlacementTooltip: !hasResources && editTierPlacementTooltip,
          emptyMessage: 'No resources participate in policy',
          rows: [...hostPoolNames.map(name => _mapHostPoolToRow(hostPools[name], usageDistribution[(0, _resourceUtils.getResourceId)('HOSTS', name)], system)), ...cloudResourceNames.map(name => _mapCloudResrouceToRow(cloudResources[name], usageDistribution[(0, _resourceUtils.getResourceId)('CLOUD', name)], system))]
        });
      }
    }
  }

  onToggleSection() {
    this.dispatch((0, _actionCreators.requestLocation)(this.toggleUri));
  }

  onEditTierPlacement(_, evt) {
    const {
      bucketName,
      tierName
    } = this;
    const tierDisplayName = this.tierDisplayName();
    this.dispatch((0, _actionCreators.openEditTierDataPlacementModal)(bucketName, tierName, tierDisplayName));
    evt.stopPropagation();
  }

}

var _default = {
  viewModel: TierDataPlacementPolicyFormViewModel,
  template: _tierDataPlacementPolicyForm.default
};
exports.default = _default;

},{"./tier-data-placement-policy-form.html":422,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"components/connectable":446,"knockout":"knockout","numeral":"numeral","routes":972,"utils/browser-utils":1021,"utils/bucket-utils":1022,"utils/core-utils":1027,"utils/resource-utils":1041,"utils/size-utils":1043,"utils/storage-utils":1045}],424:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<buckets-summary class=\"push-next\"></buckets-summary>\n\n<section class=\"column greedy tabs\">\n    <nav>\n        <a ko.attr.href=\"tabHref('data-buckets')\"\n            ko.css.selected=\"selectedTab.eq('data-buckets')\"\n        >\n            Object Buckets\n        </a>\n        <a\n            ko.attr.href=\"tabHref('namespace-buckets')\"\n            ko.css.selected=\"selectedTab.eq('namespace-buckets')\"\n        >\n            Namespace Buckets\n        </a>\n    </nav>\n\n    <div class=\"tabs-row\">\n        <buckets-table class=\"tab column\"\n            ko.css.selected=\"selectedTab.eq('data-buckets')\"\n        ></buckets-table>\n\n        <namespace-buckets-table class=\"tab column\"\n            ko.css.selected=\"selectedTab.eq('namespace-buckets')\"\n        ></namespace-buckets-table>\n    </div>\n</section>\n\n\n";

},{}],425:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _bucketsPanel = _interopRequireDefault(require("./buckets-panel.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _browserUtils = require("utils/browser-utils");

/* Copyright (C) 2016 NooBaa */
class BucketsPanelViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "baseRoute", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "selectedTab", _knockout.default.observable());
  }

  selectState(state) {
    return [state.location];
  }

  mapStateToProps(location) {
    const {
      system,
      tab = 'data-buckets'
    } = location.params;

    _knockout.default.assignToProps(this, {
      baseRoute: (0, _browserUtils.realizeUri)(location.route, {
        system
      }, {}, true),
      selectedTab: tab
    });
  }

  tabHref(tab) {
    const route = this.baseRoute();
    return route ? (0, _browserUtils.realizeUri)(route, {
      tab
    }) : '';
  }

}

var _default = {
  viewModel: BucketsPanelViewModel,
  template: _bucketsPanel.default
};
exports.default = _default;

},{"./buckets-panel.html":424,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"components/connectable":446,"knockout":"knockout","utils/browser-utils":1021}],426:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"fill row\" ko.visible=\"!dataReady()\">\n    <loading-indicator class=\"align-middle greedy\" params=\"label: true\"></loading-indicator>\n</div>\n\n<section class=\"summary row greedy\" ko.css.visible=\"dataReady\">\n    <div class=\"c4 card column push-next\">\n        <div class=\"row content-middle pad-double hpad highlight\">\n            <span class=\"greedy\">Object Buckets</span>\n            <span>{{bucketsCount}}</span>\n        </div>\n        <hr>\n        <div class=\"row content-middle pad-double hpad highlight\">\n            <span class=\"greedy\">Number of Objects</span>\n            <span>{{objectCount}}</span>\n        </div>\n    </div>\n    <div class=\"c4 card column push-both\">\n        <div class=\"row content-middle pad-double hpad highlight\">\n            <span class=\"greedy\">Namespace Buckets</span>\n            <span>{{nsBucketCount}}</span>\n        </div>\n        <hr>\n        <div class=\"row content-middle pad-double hpad highlight\">\n            <span class=\"greedy\">Number of Reads/Writes</span>\n            <span>{{nsReadsWrites}}</span>\n        </div>\n    </div>\n    <div class=\"c4 card column push-prev\">\n        <div class=\"row content-middle pad-double hpad highlight\">\n            <span class=\"greedy\">Data Written on Buckets</span>\n            <span>{{dataWritten}}</span>\n        </div>\n        <hr>\n        <div class=\"row content-middle pad-double hpad highlight\">\n            <span class=\"row content-middle greedy\">\n                Data Reduction Savings\n                <more-info-icon class=\"push-prev-half\"\n                    params=\"tooltip: reducationSavingTooltips\"\n                ></more-info-icon>\n            </span>\n            <span>{{reducationSaving}}</span>\n        </div>\n    </div>\n</section>\n\n";

},{}],427:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _bucketsSummary = _interopRequireDefault(require("./buckets-summary.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _coreUtils = require("utils/core-utils");

var _sizeUtils = require("utils/size-utils");

var _knockout = _interopRequireDefault(require("knockout"));

var _numeral = _interopRequireDefault(require("numeral"));

/* Copyright (C) 2016 NooBaa */
const reducationSavingTooltips = 'Savings shows the uncompressed and non-deduped data that would have been stored without those techniques';

class BucketsSummaryViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "bucketsCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "objectCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "nsBucketCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "nsReadsWrites", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "dataWritten", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "reducationSaving", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "reducationSavingTooltips", reducationSavingTooltips);
  }

  selectState(state) {
    return [state.buckets, state.namespaceBuckets];
  }

  mapStateToProps(buckets, nsBuckets) {
    if (!buckets || !nsBuckets) {
      _knockout.default.assignToProps(this, {
        dataReady: false
      });
    } else {
      const bucketList = Object.values(buckets);
      const bucketCount = bucketList.length;
      const objectCount = (0, _coreUtils.sumBy)(bucketList, bucket => bucket.objects.count);
      const dataSize = (0, _sizeUtils.sumSize)(...bucketList.map(bucket => bucket.data.size));
      const reducedSize = (0, _sizeUtils.sumSize)(...bucketList.map(bucket => bucket.data.sizeReduced));
      const savings = (0, _sizeUtils.fromBigInteger)(_sizeUtils.bigInteger.max((0, _sizeUtils.toBigInteger)(dataSize).subtract(reducedSize), 0));
      const savingsRatio = dataSize > 0 ? (0, _sizeUtils.toBytes)(savings) / (0, _sizeUtils.toBytes)(dataSize) : 0;
      const nsBucketList = Object.values(nsBuckets);
      const nsBucketCount = nsBucketList.length;
      const nsReads = (0, _coreUtils.sumBy)(nsBucketList, bucket => bucket.io.readCount);
      const nsWrites = (0, _coreUtils.sumBy)(nsBucketList, bucket => bucket.io.writeCount);

      _knockout.default.assignToProps(this, {
        dataReady: true,
        bucketsCount: (0, _numeral.default)(bucketCount).format(','),
        objectCount: (0, _numeral.default)(objectCount).format(','),
        nsBucketCount: (0, _numeral.default)(nsBucketCount).format(','),
        nsReadsWrites: `${(0, _numeral.default)(nsReads).format(',')}/${(0, _numeral.default)(nsWrites).format(',')}`,
        dataWritten: (0, _sizeUtils.formatSize)(dataSize),
        reducationSaving: `${(0, _sizeUtils.formatSize)(savings)} (${(0, _numeral.default)(savingsRatio).format('%')})`
      });
    }
  }

}

var _default = {
  viewModel: BucketsSummaryViewModel,
  template: _bucketsSummary.default
};
exports.default = _default;

},{"./buckets-summary.html":426,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"components/connectable":446,"knockout":"knockout","numeral":"numeral","utils/core-utils":1027,"utils/size-utils":1043}],428:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n<div class=\"card-shadow row pad content-middle\">\n    <div class=\"row greedy content-middle push-next\">\n        <input type=\"search\"\n            class=\"push-next\"\n            placeholder=\"Filter by bucket name\"\n            ko.textInput=\"ko.pc(filter, onFilter)\"\n        />\n        <p class=\"remark content-middle\"\n            ko.visible=\"isObjectStatsVisible\"\n        >\n            <svg-icon class=\"icon-small\" params=\"name: 'clock'\"></svg-icon>\n            Object count and usage last updated {{objectStatsLastUpdate}}\n        </p>\n    </div>\n    <button class=\"btn push-next\"\n        ko.click=\"onConnectApplication\"\n        ko.enable=\"dataReady\"\n    >\n        Connect Application\n    </button>\n    <div ko.tooltip=\"createBucketTooltip\">\n        <button class=\"btn align-end\"\n            ko.click=\"onCreateBucket\"\n            ko.disable=\"isCreateBucketDisabled\"\n        >\n            Create Bucket\n        </button>\n    </div>\n</div>\n\n<data-table class=\"greedy\" params=\"\n    columns: columns,\n    data: rows,\n    sorting: ko.pc(sorting, onSort, $component),\n    loading: !dataReady(),\n    emptyMessage: emptyMessage\n\"></data-table>\n\n<paginator params=\"\n    itemCount: bucketCount,\n    pageSize: ko.pc(pageSize, onPageSize, $component),\n    page: ko.pc(page, onPage, $component)\n\"></paginator>\n";

},{}],429:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _bucketsTable = _interopRequireDefault(require("./buckets-table.html"));

var _resourcesColTooltip = _interopRequireDefault(require("./resources-col-tooltip.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _numeral = _interopRequireDefault(require("numeral"));

var _moment = _interopRequireDefault(require("moment"));

var _browserUtils = require("utils/browser-utils");

var _sizeUtils = require("utils/size-utils");

var _stringUtils = require("utils/string-utils");

var _config = require("config");

var _coreUtils = require("utils/core-utils");

var _bucketUtils = require("utils/bucket-utils");

var _actionCreators = require("action-creators");

var routes = _interopRequireWildcard(require("routes"));

/* Copyright (C) 2016 NooBaa */
const columns = (0, _coreUtils.deepFreeze)([{
  name: 'state',
  type: 'icon',
  sortable: true,
  compareKey: bucket => bucket.mode
}, {
  name: 'name',
  label: 'bucket name',
  type: 'link',
  sortable: true,
  compareKey: bucket => bucket.name
}, {
  name: 'objectCount',
  label: 'objects',
  sortable: true,
  compareKey: bucket => bucket.objects.count
}, {
  name: 'resiliencyPolicy',
  sortable: true,
  compareKey: bucket => bucket.resiliency.kind
}, {
  name: 'resources',
  label: 'Resources in Tiers',
  sortable: true,
  compareKey: bucket => {
    const {
      tiers,
      resources
    } = _countTiersAndResources(bucket);

    return [tiers, resources];
  }
}, {
  name: 'versioning',
  sortable: true,
  compareKey: bucket => bucket.versioning.mode
}, {
  name: 'capacity',
  label: 'used capacity',
  type: 'capacity',
  sortable: true,
  compareKey: bucket => (0, _sizeUtils.toBytes)(bucket.storage.used || 0)
}, {
  name: 'deleteButton',
  label: '',
  css: 'delete-col',
  type: 'delete'
}]);
const createButtondDisabledTooltip = (0, _coreUtils.deepFreeze)({
  text: 'The current account is not allowed to create new buckets in the system. To grant permissions, edit the account\'s S3 access in the account page',
  align: 'end'
});
const undeletableReasons = (0, _coreUtils.deepFreeze)({
  NOT_EMPTY: 'Cannot delete a bucket that contains objects or any objects versions'
});
const resourceGroupMetadata = (0, _coreUtils.deepFreeze)({
  HOSTS: {
    icon: 'nodes-pool',
    getHref: (resName, system) => (0, _browserUtils.realizeUri)(routes.pool, {
      system,
      pool: resName
    })
  },
  CLOUD: {
    icon: 'cloud-hollow',
    getHref: (resName, system) => (0, _browserUtils.realizeUri)(routes.cloudResource, {
      system,
      resource: resName
    })
  }
});

function _countTiersAndResources(bucket) {
  const {
    tiers
  } = bucket.placement;
  const resources = (0, _coreUtils.flatMap)(tiers.filter(tier => tier.policyType !== 'INTERNAL_STORAGE'), tier => (0, _coreUtils.flatMap)(tier.mirrorSets, ms => ms.resources));
  return {
    tiers: tiers.length,
    resources: resources.length
  };
}

function _mapResiliency(resiliency) {
  const {
    kind,
    replicas,
    dataFrags,
    parityFrags
  } = resiliency;
  return `${(0, _bucketUtils.getResiliencyTypeDisplay)(kind)} (${kind === 'REPLICATION' ? `${replicas} copies` : `${dataFrags}+${parityFrags}`})`;
}

function _getResourceGroupTooltip(tiers, system) {
  const resourceListPerTier = tiers.map(tier => (0, _coreUtils.flatMap)(tier.mirrorSets || [], ms => ms.resources));
  return {
    template: _resourcesColTooltip.default,
    text: resourceListPerTier.map((list, i) => ({
      tierIndex: i + 1,
      resources: list.map(resource => {
        const {
          name,
          type
        } = resource;
        const {
          getHref,
          icon
        } = resourceGroupMetadata[type];
        const href = getHref(name, system);
        return {
          icon,
          name,
          href
        };
      })
    }))
  };
}

function _mapResources(bucket, system) {
  const {
    tiers,
    resources
  } = _countTiersAndResources(bucket);

  const text = `${(0, _stringUtils.stringifyAmount)('Tier', tiers)}, ${(0, _stringUtils.stringifyAmount)('Resource', resources)}`;

  const tooltip = _getResourceGroupTooltip(bucket.placement.tiers, system);

  return {
    text,
    tooltip
  };
}

function _mapBucket(bucket, system, selectedForDelete) {
  return {
    state: (0, _bucketUtils.getBucketStateIcon)(bucket, 'start'),
    name: {
      text: bucket.name,
      href: (0, _browserUtils.realizeUri)(routes.bucket, {
        system,
        bucket: bucket.name
      }),
      tooltip: {
        text: bucket.name,
        breakWords: true
      }
    },
    objectCount: (0, _numeral.default)(bucket.objects.count).format(','),
    resiliencyPolicy: _mapResiliency(bucket.resiliency),
    resources: _mapResources(bucket, system),
    versioning: (0, _bucketUtils.getVersioningStateText)(bucket.versioning.mode),
    capacity: {
      total: bucket.storage.total,
      used: bucket.storage.used
    },
    deleteButton: {
      id: bucket.name,
      active: selectedForDelete === bucket.name,
      disabled: Boolean(bucket.undeletable),
      tooltip: bucket.undeletable ? undeletableReasons[bucket.undeletable] : null
    }
  };
}

class RowViewModel {
  constructor({
    table
  }) {
    (0, _defineProperty2.default)(this, "table", null);
    (0, _defineProperty2.default)(this, "name", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "state", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "objectCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "resiliencyPolicy", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "tiers", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "resources", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "versioning", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "capacity", {
      total: _knockout.default.observable(),
      used: _knockout.default.observable()
    });
    (0, _defineProperty2.default)(this, "deleteButton", {
      text: 'Delete bucket',
      disabled: _knockout.default.observable(),
      tooltip: _knockout.default.observable(),
      active: _knockout.default.observable(),
      id: _knockout.default.observable(),
      onDelete: this.onDelete.bind(this),
      onToggle: this.onToggle.bind(this)
    });
    this.table = table;
  }

  onToggle(bucketName) {
    this.table.onSelectForDelete(bucketName);
  }

  onDelete(bucketName) {
    this.table.onDelete(bucketName);
  }

}

class BucketsTableViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "columns", columns);
    (0, _defineProperty2.default)(this, "pathname", '');
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "filter", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "sorting", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "page", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "pageSize", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "selectedForDelete", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "bucketCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "createBucketTooltip", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isCreateBucketDisabled", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isObjectStatsVisible", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "objectStatsLastUpdate", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "emptyMessage", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "rows", _knockout.default.observableArray().ofType(RowViewModel, {
      table: this
    }));
    (0, _defineProperty2.default)(this, "onFilter", (0, _coreUtils.throttle)(filter => {
      this._query({
        filter,
        page: 0,
        selectedForDelete: null
      });
    }, _config.inputThrottle));
  }

  selectState(state) {
    return [state.location, state.buckets, (state.accounts || {})[state.session.user]];
  }

  mapStateToProps(location, buckets, userAccount) {
    const {
      system,
      tab = 'data-buckets'
    } = location.params;

    if (tab !== 'data-buckets') {
      return;
    } else if (!buckets) {
      _knockout.default.assignToProps(this, {
        isCreateBucketDisabled: true,
        isObjectStatsVisible: false,
        emptyMessage: '',
        dataReady: false
      });
    } else {
      const {
        pathname,
        query
      } = location;
      const {
        filter = '',
        sortBy = 'name',
        selectedForDelete = ''
      } = query;
      const order = Number(query.order) || 1;
      const page = Number(query.page) || 0;

      const pageSize = Number(query.pageSize) || _config.paginationPageSize.default;

      const {
        compareKey
      } = columns.find(column => column.name === sortBy);
      const {
        canCreateBuckets = false
      } = userAccount;
      const createBucketTooltip = canCreateBuckets ? '' : createButtondDisabledTooltip;
      const allBuckets = Object.values(buckets);
      const bucketList = allBuckets.filter(bucket => (0, _stringUtils.includesIgnoreCase)(bucket.name, filter));
      const rows = bucketList.sort((0, _coreUtils.createCompareFunc)(compareKey, order)).slice(page * pageSize, (page + 1) * pageSize).map(bucket => _mapBucket(bucket, system, selectedForDelete));
      const objectStatsLastUpdate = Math.max(...bucketList.map(bucket => bucket.objects.lastUpdate), 0);
      const emptyMessage = allBuckets.length === 0 && 'There are no object buckets in the system' || bucketList.length === 0 && 'The current filter does not match any object bucket' || '';

      _knockout.default.assignToProps(this, {
        pathname,
        filter,
        sorting: {
          sortBy,
          order
        },
        page,
        pageSize,
        selectedForDelete,
        bucketCount: bucketList.length,
        rows,
        createBucketTooltip,
        isCreateBucketDisabled: !canCreateBuckets,
        isObjectStatsVisible: bucketList.length > 0,
        objectStatsLastUpdate: (0, _moment.default)(objectStatsLastUpdate).fromNow(),
        emptyMessage,
        dataReady: true
      });
    }
  }

  onCreateBucket() {
    this.dispatch((0, _actionCreators.openCreateBucketModal)());
  }

  onConnectApplication() {
    this.dispatch((0, _actionCreators.openConnectAppModal)());
  }

  onSort(sorting) {
    this._query({
      sortBy: sorting.sortBy,
      order: sorting.order,
      page: 0,
      selectedForDelete: null
    });
  }

  onPage(page) {
    this._query({
      page,
      selectedForDelete: null
    });
  }

  onPageSize(pageSize) {
    this._query({
      pageSize,
      page: 0,
      selectedForDelete: null
    });
  }

  onSelectForDelete(bucketName) {
    const selectedForDelete = bucketName || '';

    this._query({
      selectedForDelete
    });
  }

  onDelete(bucketName) {
    this.dispatch((0, _actionCreators.deleteBucket)(bucketName));
  }

  _query(query) {
    const {
      filter = this.filter(),
      sortBy = this.sorting().sortBy,
      order = this.sorting().order,
      page = this.page(),
      pageSize = this.pageSize(),
      selectedForDelete = this.selectedForDelete()
    } = query;
    const queryUrl = (0, _browserUtils.realizeUri)(this.pathname, null, {
      filter: filter || undefined,
      sortBy,
      order,
      page,
      pageSize,
      selectedForDelete: selectedForDelete || undefined
    });
    this.dispatch((0, _actionCreators.requestLocation)(queryUrl));
  }

}

var _default = {
  template: _bucketsTable.default,
  viewModel: BucketsTableViewModel
};
exports.default = _default;

},{"./buckets-table.html":428,"./resources-col-tooltip.html":430,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"components/connectable":446,"config":831,"knockout":"knockout","moment":"moment","numeral":"numeral","routes":972,"utils/browser-utils":1021,"utils/bucket-utils":1022,"utils/core-utils":1027,"utils/size-utils":1043,"utils/string-utils":1046}],430:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<ol class=\"list-no-style column\" ko.foreach=\"$data\">\n    <li ko.css.push-prev-half=\"$index\">\n        <p class=\"highlight\">\n            Resources in tier {{tierIndex}}\n        </p>\n        <!-- ko if: resources.length -->\n        <ul class=\"list-no-style\" ko.foreach=\"resources\">\n            <li class=\"row content-middle\">\n                <svg-icon class=\"icon-small push-next-half\"\n                    params=\"name: icon\"\n                ></svg-icon>\n                <a class=\"link\" ko.attr.href=\"href\">{{name}}</a>\n            </li>\n        </ul>\n        <!-- /ko -->\n        <!-- ko ifnot: resources.length -->\n        <p class=\"text-thin\">No resources</p>\n        <!-- /ko -->\n    </li>\n</ol>\n";

},{}],431:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"column pad card-shadow\">\n    <div class=\"row content-middle push-next\">\n        <div class=\"greedy\">\n            <input type=\"search\"\n                class=\"push-next\"\n                placeholder=\"Filter by bucket name\"\n                ko.textInput=\"ko.pc(filter, onFilterThrottled)\" />\n        </div>\n        <button class=\"btn push-next\"\n            ko.click=\"onConnectApplication\"\n            ko.enable=\"dataReady\"\n        >\n            Connect Application\n        </button>\n        <div ko.tooltip=\"createButtonTooltip\">\n            <button class=\"btn\"\n                ko.click=\"onCreate\"\n                ko.enable=\"allowCreateBucket\"\n            >\n                Create Namespace Bucket\n            </button>\n        </div>\n    </div>\n    <p>\n        Namespace buckets can be used for data visibility without replicas or encryptions by configuring namespace resources for R/W.\n    </p>\n</div>\n\n<data-table class=\"greedy buckets-table\" params=\"\n    columns: columns,\n    sorting: ko.pc(sorting, onSort, $component),\n    data: rows,\n    loading: !dataReady(),\n    emptyMessage: 'System does not contain any namespace buckets'\n\"></data-table>\n\n<paginator params=\"\n    itemCount: bucketCount,\n    pageSize: ko.pc(pageSize, onPageSize, $component),\n    page: ko.pc(page, onPage, $component)\n\"></paginator>\n";

},{}],432:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _namespaceBucketsTable = _interopRequireDefault(require("./namespace-buckets-table.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _browserUtils = require("utils/browser-utils");

var _stringUtils = require("utils/string-utils");

var _bucketUtils = require("utils/bucket-utils");

var _config = require("config");

var routes = _interopRequireWildcard(require("routes"));

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const columns = (0, _coreUtils.deepFreeze)([{
  name: 'state',
  type: 'icon',
  sortable: true,
  compareKey: bucket => bucket.mode
}, {
  name: 'name',
  label: 'bucket name',
  type: 'link',
  sortable: true,
  compareKey: bucket => bucket.name
}, {
  name: 'readPolicy',
  sortable: true,
  compareKey: bucket => bucket.placement.readFrom.length
}, {
  name: 'writePolicy',
  sortable: true,
  compareKey: bucket => bucket.placement.writeTo
}, {
  name: 'deleteButton',
  label: '',
  css: 'delete-col',
  type: 'delete'
}]);
const createButtonTooltips = (0, _coreUtils.deepFreeze)({
  MISSING_PERMISSIONS: 'The current account is not allowed to create new buckets in the system. To grant permissions, edit the account\'s S3 access in the account page',
  NO_RESOURCES: 'At least one namespace resource is needed. Please create a namespace resource in the resources section.'
});

function _mapBucketToRow(bucket, selectedForDelete, system) {
  const {
    name: bucketName,
    placement
  } = bucket;
  const {
    readFrom,
    writeTo
  } = placement;
  const name = {
    text: bucketName,
    href: (0, _browserUtils.realizeUri)(routes.namespaceBucket, {
      system,
      bucket: bucketName
    })
  };
  const readPolicy = {
    text: (0, _stringUtils.stringifyAmount)('namespace resource', readFrom.length, 'No'),
    tooltip: {
      template: 'list',
      text: readFrom
    }
  };
  return {
    name,
    state: (0, _bucketUtils.getNamespaceBucketStateIcon)(bucket),
    readPolicy,
    writePolicy: writeTo,
    deleteButton: {
      id: bucketName,
      active: selectedForDelete === bucketName
    }
  };
}

class BucketRowViewModel {
  constructor({
    table
  }) {
    (0, _defineProperty2.default)(this, "table", null);
    (0, _defineProperty2.default)(this, "state", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "name", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "objectCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "readPolicy", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "writePolicy", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "deleteButton", {
      text: 'Delete bucket',
      id: _knockout.default.observable(),
      active: _knockout.default.observable(),
      tooltip: 'Delete Bucket',
      onToggle: id => this.table.onSelectForDelete(id),
      onDelete: id => this.table.onDeleteBucket(id)
    });
    this.table = table;
  }

}

class NamespaceBucketsTableViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "columns", columns);
    (0, _defineProperty2.default)(this, "pathname", '');
    (0, _defineProperty2.default)(this, "allowCreateBucket", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "createButtonTooltip", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "sorting", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "filter", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "page", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "pageSize", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "selectedForDelete", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "bucketCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "rows", _knockout.default.observableArray().ofType(BucketRowViewModel, {
      table: this
    }));
    (0, _defineProperty2.default)(this, "onFilterThrottled", (0, _coreUtils.throttle)(this.onFilter, _config.inputThrottle, this));
  }

  selectState(state) {
    return [state.namespaceBuckets, state.location, state.namespaceResources, state.accounts, state.session && state.session.user];
  }

  mapStateToProps(buckets, location, resources, accounts, user) {
    if (!buckets || !accounts || location.params.tab !== 'namespace-buckets') {
      _knockout.default.assignToProps(this, {
        dataReady: false,
        allowCreateBucket: false
      });
    } else {
      const {
        pathname,
        params,
        query
      } = location;
      const systemHasResources = Object.keys(resources).length > 0;
      const {
        filter,
        sortBy = 'name',
        selectedForDelete
      } = query;
      const order = Number(query.order) || 1;
      const page = Number(query.page) || 0;

      const pageSize = Number(query.pageSize) || _config.paginationPageSize.default;

      const pageStart = page * pageSize;
      const {
        compareKey
      } = columns.find(column => column.name == sortBy);
      const {
        canCreateBuckets
      } = accounts[user];
      const createButtonTooltip = {
        align: 'end',
        text: true && !canCreateBuckets && createButtonTooltips.MISSING_PERMISSIONS || !systemHasResources && createButtonTooltips.NO_RESOURCES || ''
      };
      const filteredRows = Object.values(buckets).filter(bucket => (0, _stringUtils.includesIgnoreCase)(bucket.name, filter));
      const rows = filteredRows.sort((0, _coreUtils.createCompareFunc)(compareKey, order)).slice(pageStart, pageStart + pageSize).map(bucket => _mapBucketToRow(bucket, selectedForDelete, params.system));

      _knockout.default.assignToProps(this, {
        dataReady: true,
        pathname,
        allowCreateBucket: canCreateBuckets && systemHasResources,
        createButtonTooltip,
        filter,
        sorting: {
          sortBy,
          order
        },
        page,
        pageSize,
        bucketCount: filteredRows.length,
        selectedForDelete,
        rows
      });
    }
  }

  onFilter(filter) {
    this._query({
      filter: filter,
      page: 0,
      selectedForDelete: null
    });
  }

  onSort(sorting) {
    this._query({
      sorting: sorting,
      page: 0,
      selectedForDelete: null
    });
  }

  onSelectForDelete(bucket) {
    this._query({
      selectedForDelete: bucket
    });
  }

  onPage(page) {
    this._query({
      page: page,
      selectedForDelete: null
    });
  }

  onPageSize(pageSize) {
    this._query({
      pageSize,
      page: 0,
      selectedForDelete: null
    });
  }

  onCreate() {
    this.dispatch((0, _actionCreators.openCreateNamespaceBucketModal)());
  }

  onConnectApplication() {
    this.dispatch((0, _actionCreators.openConnectAppModal)());
  }

  onDeleteBucket(bucket) {
    this.dispatch((0, _actionCreators.deleteNamespaceBucket)(bucket));
  }

  _query({
    filter = this.filter(),
    sorting = this.sorting(),
    page = this.page(),
    pageSize = this.pageSize(),
    selectedForDelete = this.selectedForDelete
  }) {
    const query = {
      filter: filter || undefined,
      sortBy: sorting.sortBy,
      order: sorting.order,
      page,
      pageSize,
      selectedForDelete: selectedForDelete || undefined
    };
    const url = (0, _browserUtils.realizeUri)(this.pathname, {}, query);
    this.dispatch((0, _actionCreators.requestLocation)(url));
  }

}

var _default = {
  viewModel: NamespaceBucketsTableViewModel,
  template: _namespaceBucketsTable.default
};
exports.default = _default;

},{"./namespace-buckets-table.html":431,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"components/connectable":446,"config":831,"knockout":"knockout","routes":972,"utils/browser-utils":1021,"utils/bucket-utils":1022,"utils/core-utils":1027,"utils/string-utils":1046}],433:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<cloud-resource-summary class=\"push-next\" params=\"resourceName: resource\"></cloud-resource-summary>\n\n<div class=\"tabs greedy\" ko.if=\"route\">\n    <nav>\n        <a ko.css.selected=\"selectedTab.eq('properties')\"\n            ko.attr.href=\"tabHref('properties')\"\n        >\n            Properties\n        </a>\n        <a ko.css.selected=\"selectedTab.eq('connected-buckets')\"\n            ko.attr.href=\"tabHref('connected-buckets')\"\n        >\n            Connected Buckets\n        </a>\n        <a ko.css.selected=\"selectedTab.eq('associated-accounts')\"\n            ko.attr.href=\"tabHref('associated-accounts')\"\n        >\n            Associated Accounts\n        </a>\n        <a ko.css.selected=\"selectedTab.eq('parts')\"\n            ko.attr.href=\"tabHref('parts')\"\n        >\n            Stored Parts\n        </a>\n    </nav>\n\n    <div class=\"tabs-row\">\n        <cloud-resource-properties-form class=\"tab column\"\n            ko.css.selected=\"selectedTab.eq('properties')\"\n            params=\"resourceName: resource\"\n        ></cloud-resource-properties-form>\n\n        <resource-connected-buckets-form class=\"tab column\"\n            ko.css.selected=\"selectedTab.eq('connected-buckets')\"\n            params=\"resourceType: 'CLOUD', resourceName: resource\"\n        ></resource-connected-buckets-form>\n\n        <resource-associated-account-list class=\"tab column\"\n            ko.css.selected=\"selectedTab.eq('associated-accounts')\"\n            params=\"resourceType: 'CLOUD', resourceName: resource\"\n        ></resource-associated-account-list>\n\n        <host-parts-table class=\"tab column\"\n            ko.css.selected=\"selectedTab.eq('parts')\"\n            params=\"resourceType: 'CLOUD_RESOURCE', hostName: hostName\"\n        ></host-parts-table>\n    </div>\n</div>\n";

},{}],434:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _cloudResourcePanel = _interopRequireDefault(require("./cloud-resource-panel.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _browserUtils = require("utils/browser-utils");

var _config = require("config");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
class CloudResourcePanelViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "route", _knockout.default.observable(''));
    (0, _defineProperty2.default)(this, "resource", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "selectedTab", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "hostName", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "page", -1);
    (0, _defineProperty2.default)(this, "pageSize", -1);
  }

  selectState(state) {
    const {
      cloudResources = {},
      location
    } = state;
    const {
      resource: name
    } = location.params;
    const resource = cloudResources[name];
    return [location, resource && resource.internalHost];
  }

  onState(state, params) {
    super.onState(state, params);
    this.fetchParts(state.location);
  }

  mapStateToProps(location, resourceHost) {
    const {
      system,
      resource,
      tab = 'properties'
    } = location.params;

    _knockout.default.assignToProps(this, {
      route: (0, _browserUtils.realizeUri)(location.route, {
        system,
        resource
      }, {}, true),
      resource: resource,
      selectedTab: tab,
      hostName: resourceHost
    });
  }

  fetchParts(location) {
    if (location.params.tab !== 'parts') {
      return;
    }

    const page = Number(location.query.page) || 0;

    const pageSize = Number(location.query.pageSize) || _config.paginationPageSize.default;

    if (this.page === page && this.pageSize === pageSize) {
      return;
    }

    this.page = page;
    this.pageSize = pageSize;
    this.dispatch((0, _actionCreators.fetchCloudResourceObjects)(location.params.resource, page * pageSize, pageSize));
  }

  tabHref(tab) {
    return (0, _browserUtils.realizeUri)(this.route(), {
      tab
    });
  }

}

var _default = {
  viewModel: CloudResourcePanelViewModel,
  template: _cloudResourcePanel.default
};
exports.default = _default;

},{"./cloud-resource-panel.html":433,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"config":831,"knockout":"knockout","utils/browser-utils":1021}],435:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<section class=\"column\">\n    <div class=\"row pad card-shadow content-middle\">\n        <h3 class=\"heading3 greedy push-next\">\n            Cloud Resource Properties\n        </h3>\n\n        <button class=\"btn\" ko.click=\"onAssignRegion\">\n            Assign Region\n        </button>\n    </div>\n    <property-sheet class=\"pad\" params=\"\n        loading: !dataReady(),\n        properties: properties\n    \"></property-sheet>\n</section>\n\n\n";

},{}],436:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _cloudResourcePropertiesForm = _interopRequireDefault(require("./cloud-resource-properties-form.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _sizeUtils = require("utils/size-utils");

var _resourceUtils = require("utils/resource-utils");

var _actionCreators = require("action-creators");

var _knockout = _interopRequireDefault(require("knockout"));

var _config = require("config");

var _moment = _interopRequireDefault(require("moment"));

/* Copyright (C) 2016 NooBaa */
class CloudResourcePropertiesFormViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "resourceName", '');
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "properties", [{
      label: 'Resource name',
      value: _knockout.default.observable()
    }, {
      label: 'Service endpoint',
      value: _knockout.default.observable()
    }, {
      label: 'Cloud target bucket',
      value: _knockout.default.observable()
    }, {
      label: 'Region',
      value: _knockout.default.observable()
    }, {
      label: 'Used capacity (by NooBaa)',
      value: _knockout.default.observable()
    }, {
      label: 'Created by',
      value: _knockout.default.observable()
    }, {
      label: 'Creation time',
      value: _knockout.default.observable()
    }]);
  }

  selectState(state, params) {
    const {
      cloudResources = {}
    } = state;
    return [cloudResources[params.resourceName]];
  }

  mapStateToProps(resource) {
    if (!resource) {
      _knockout.default.assignToProps(this, {
        dataReady: false
      });
    } else {
      _knockout.default.assignToProps(this, {
        dataReady: true,
        resourceName: resource.name,
        properties: [{
          value: resource.name
        }, {
          value: resource.endpoint
        }, {
          value: resource.target
        }, {
          value: resource.region || _resourceUtils.unassignedRegionText
        }, {
          value: (0, _sizeUtils.formatSize)(resource.storage.used)
        }, {
          value: resource.createdBy
        }, {
          value: (0, _moment.default)(resource.creationTime).format(_config.timeShortFormat)
        }]
      });
    }
  }

  onAssignRegion() {
    this.dispatch((0, _actionCreators.openAssignRegionModal)('CLOUD', this.resourceName));
  }

}

var _default = {
  viewModel: CloudResourcePropertiesFormViewModel,
  template: _cloudResourcePropertiesForm.default
};
exports.default = _default;

},{"./cloud-resource-properties-form.html":435,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"config":831,"knockout":"knockout","moment":"moment","utils/resource-utils":1041,"utils/size-utils":1043}],437:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"fill row\" ko.visible=\"!dataReady()\">\n    <loading-indicator class=\"align-middle greedy\" params=\"label: true\"></loading-indicator>\n</div>\n\n<div class=\"summary greedy row\" ko.css.visible=\"dataReady\">\n    <section class=\"c3 column card\">\n        <div class=\"greedy hpad row content-middle\" ko.if=\"state\">\n            <svg-icon class=\"push-next\" params=\"name: state().icon.name\"\n                ko.css=\"state().icon.css\"\n                ko.tooltip=\"state().icon.tooltip\"\n            ></svg-icon>\n            <span class=\"heading3 greedy\" ko.text=\"state().text\"></span>\n        </div>\n        <hr/>\n        <div class=\"greedy hpad row content-middle\">\n            <span class=\"c6 highlight push-next\">Service:</span>\n            <span class=\"c6 text-right\" ko.text=\"service\"></span>\n        </div>\n        <hr>\n        <div class=\"greedy hpad row content-middle\">\n            <span class=\"c6 highlight push-next\">Cloud Target Bucket:</span>\n            <span class=\"c6 text-right no-wrap\"\n                ko.tooltip=\"targetBucket\"\n                ko.text=\"targetBucket\"\n            ></span>\n        </div>\n    </section>\n\n    <section class=\"c6 column push-both\">\n        <div class=\"row align-middle\">\n            <chart-legend class=\"pad push-next\" params=\"\n                items: chartLegend,\n                caption: 'Resource R/W traffic',\n                format: 'size'\n            \"></chart-legend>\n            <chartjs class=\"io-chart align-middle\" params=\"\n                type: 'bar',\n                options: chart.options,\n                data: chart.data\n            \"></chartjs>\n        </div>\n    </section>\n\n    <section class=\"c3 column card\">\n        <div class=\"row hpad pad-half content-middle highlight\">\n            Number of R/W operations\n        </div>\n        <hr>\n        <div class=\"row hpad content-middle greedy\">\n            <span class=\"c6 highlight push-next\">Reads:</span>\n            <span class=\"c6 text-right\" ko.text=\"readCount\"></span>\n        </div>\n        <hr/>\n        <div class=\"row hpad content-middle greedy\">\n            <span class=\"c6 highlight push-next\">Writes:</span>\n            <span class=\"c6 text-right\" ko.text=\"writeCount\"></span>\n        </div>\n    </section>\n</div>\n";

},{}],438:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _cloudResourceSummary = _interopRequireDefault(require("./cloud-resource-summary.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _resourceUtils = require("utils/resource-utils");

var _cloudUtils = require("utils/cloud-utils");

var _knockout = _interopRequireDefault(require("knockout"));

var _numeral = _interopRequireDefault(require("numeral"));

var _themes = _interopRequireDefault(require("themes"));

/* Copyright (C) 2016 NooBaa */
function _getServiceDisplayName(resource) {
  return resource.type === 'S3_COMPATIBLE' ? 'S3 Compatible' : (0, _cloudUtils.getCloudServiceMeta)(resource.type).displayName;
}

class CloudResourceSummaryViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "state", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "service", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "targetBucket", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "readCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "writeCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "readSize", {
      color: _knockout.default.observable(),
      value: _knockout.default.observable()
    });
    (0, _defineProperty2.default)(this, "writeSize", {
      color: _knockout.default.observable(),
      value: _knockout.default.observable()
    });
    (0, _defineProperty2.default)(this, "chartLegend", [{
      label: 'Reads',
      color: this.readSize.color,
      value: this.readSize.value
    }, {
      label: 'Writes',
      color: this.writeSize.color,
      value: this.writeSize.value
    }]);
    (0, _defineProperty2.default)(this, "chart", {
      options: {
        maintainAspectRatio: false,
        scales: {
          xAxes: [{
            categoryPercentage: .7,
            barPercentage: .8,
            display: false
          }],
          yAxes: [{
            gridLines: {
              color: 'transparent',
              drawTicks: false
            },
            ticks: {
              callback: () => ''
            }
          }]
        },
        tooltips: {
          enabled: false
        }
      },
      data: {
        labels: [],
        datasets: [{
          backgroundColor: this.readSize.color,
          hoverBackgroundColor: this.readSize.color,
          data: [this.readSize.value]
        }, {
          backgroundColor: this.writeSize.color,
          hoverBackgroundColor: this.writeSize.color,
          data: [this.writeSize.value]
        }]
      }
    });
  }

  selectState(state, params) {
    const {
      cloudResources = {},
      session
    } = state;
    return [cloudResources[params.resourceName], _themes.default[session.uiTheme]];
  }

  mapStateToProps(resource, theme) {
    if (!resource) {
      _knockout.default.assignToProps(this, {
        dataReady: false
      });
    } else {
      const {
        io
      } = resource;
      const {
        tooltip,
        ...icon
      } = (0, _resourceUtils.getCloudResourceStateIcon)(resource);

      _knockout.default.assignToProps(this, {
        dataReady: true,
        state: {
          icon: icon,
          text: tooltip
        },
        service: _getServiceDisplayName(resource),
        targetBucket: resource.target,
        readCount: (0, _numeral.default)(io.readCount).format(','),
        writeCount: (0, _numeral.default)(io.writeCount).format(','),
        readSize: {
          color: theme.color20,
          value: io.readSize
        },
        writeSize: {
          color: theme.color28,
          value: io.writeSize
        }
      });
    }
  }

}

var _default = {
  viewModel: CloudResourceSummaryViewModel,
  template: _cloudResourceSummary.default
};
exports.default = _default;

},{"./cloud-resource-summary.html":437,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"components/connectable":446,"knockout":"knockout","numeral":"numeral","themes":1018,"utils/cloud-utils":1024,"utils/resource-utils":1041}],439:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<cluster-summary class=\"push-next\"></cluster-summary>\n\n<section class=\"column greedy tabs\">\n    <nav>\n        <a ko.css.selected=\"selectedTab.eq('servers')\"\n            ko.attr.href=\"tabHref('servers')\"\n        >\n            Servers\n        </a>\n    </nav>\n    <div class=\"tabs-row\">\n        <server-table class=\"tab\"\n            ko.css.selected=\"selectedTab.eq('servers')\"\n        ></server-table>\n    </div>\n</section>\n\n\n\n\n";

},{}],440:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _clusterPanel = _interopRequireDefault(require("./cluster-panel.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _browserUtils = require("utils/browser-utils");

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
class ClusterPanelViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "baseRoute", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "selectedTab", _knockout.default.observable());
  }

  selectState(state) {
    return [state.location];
  }

  mapStateToProps(location) {
    const {
      system,
      tab = 'servers'
    } = location.params;

    _knockout.default.assignToProps(this, {
      baseRoute: (0, _browserUtils.realizeUri)(location.route, {
        system
      }, {}, true),
      selectedTab: tab
    });
  }

  tabHref(tab) {
    const route = this.baseRoute();
    return route ? (0, _browserUtils.realizeUri)(route, {
      tab
    }) : '';
  }

}

var _default = {
  viewModel: ClusterPanelViewModel,
  template: _clusterPanel.default
};
exports.default = _default;

},{"./cluster-panel.html":439,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"components/connectable":446,"knockout":"knockout","utils/browser-utils":1021}],441:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n<div class=\"fill row\" ko.visible=\"!dataReady()\">\n    <loading-indicator class=\"align-middle greedy\" params=\"label: true\"></loading-indicator>\n</div>\n\n<div class=\"summary greedy row\" ko.css.visible=\"dataReady\">\n    <section class=\"c4 column card\">\n        <div class=\"row hpad greedy content-middle\">\n            <svg-icon class=\"push-next success\"\n                params=\"name: status.icon\"\n                ko.css=\"status.css\"\n            ></svg-icon>\n            <span class=\"highlight\">{{status.text}}</span>\n        </div>\n        <hr>\n        <div class=\"row hpad greedy content-middle\">\n            <svg-icon class=\"push-next success\"\n                params=\"name: ha.icon\"\n                ko.css=\"ha.css\"\n            ></svg-icon>\n            <span class=\"highlight greedy push-next\">\n                {{ha.text}}\n            </span>\n            <more-info-icon params=\"tooltip: ha.tooltip\">\n            </more-info-icon>\n        </div>\n        <hr>\n        <div class=\"row hpad greedy content-middle\">\n            <svg-icon class=\"push-next success\"\n                params=\"name: faultTolerance.icon\"\n                ko.css=\"faultTolerance.css\"\n            \"></svg-icon>\n            <span class=\"greedy push-next\">\n                <span class=\"highlight push-next status-label\">\n                    Fault Tolerance:\n                </span>\n                {{faultTolerance.text}}\n            </span>\n            <more-info-icon params=\"tooltip: faultTolerance.tooltip\">\n            </more-info-icon>\n        </div>\n    </section>\n\n    <section class=\"column c4 column push-both\">\n        <chart-legend class=\"legend-row push-next\" params=\"\n            caption: legend.caption,\n            items: legend.values\n        \"></chart-legend>\n\n        <bar class=\"servers-bar bar-flip-markers push-prev\" params=\"\n            values: bar.values,\n            markers: bar.markers,\n            minRatio: 0,\n            spacing: .01\n        \"></bar>\n    </section>\n\n    <section class=\"c4 column card\">\n        <h3 class=\"heading3 hpad pad-half\">\n            No Cluster Activities\n        </h3>\n        <hr>\n    </section>\n</div>\n";

},{}],442:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _clusterSummary = _interopRequireDefault(require("./cluster-summary.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _stringUtils = require("utils/string-utils");

var _numeral = _interopRequireDefault(require("numeral"));

var _clusterUtils = require("utils/cluster-utils");

/* Copyright (C) 2016 NooBaa */
const faultToleranceTooltip = `
    The number of servers that can fail (disconnect from the cluster) before the system
    will stop servicing reads and writes
`;
const HATooltip = `
    High availability ensures that the system will keep servicing in the event of one
    or more server failures (dependent on the cluster fault tolerance).
`;

function _getStatus(topology, systemVersion) {
  const statusIcon = (0, _clusterUtils.getClusterStateIcon)(topology, systemVersion);
  return {
    icon: statusIcon.name,
    css: statusIcon.css,
    text: statusIcon.tooltip
  };
}

function _getHA(topology) {
  if (topology.isHighlyAvailable) {
    return {
      icon: 'healthy',
      css: 'success',
      text: 'Highly Available'
    };
  } else {
    return {
      icon: 'problem',
      css: 'error',
      text: 'Not Highly Available'
    };
  }
}

function _getFaultTolerance(topology) {
  const {
    faultTolerance,
    isHighlyAvailable
  } = topology;
  return {
    icon: faultTolerance > 0 ? 'healthy' : 'problem',
    css: faultTolerance > 0 ? 'success' : 'error',
    text: isHighlyAvailable ? (0, _stringUtils.stringifyAmount)('server', faultTolerance) : 'Not enough connected servers'
  };
}

function _countServers(servers) {
  const serverList = Object.values(servers);
  const serverCount = serverList.length;
  const byMode = (0, _coreUtils.countBy)(serverList, server => server.mode);
  return {
    all: serverCount,
    connected: byMode.CONNECTED || 0,
    pending: byMode.IN_PROCESS || 0,
    disconnected: byMode.DISCONNECTED || 0,
    missing: serverCount === 1 ? 2 : (serverCount + 1) % 2
  };
}

function _getLegend(supportHighAvailability, counters) {
  const missingLabel = `Missing Installed Servers for ${supportHighAvailability ? 'next Fault Tolerance' : 'H/A'}`;
  return {
    caption: `Servers in cluster: ${(0, _numeral.default)(counters.all).format(',')}`,
    values: [{
      value: counters.connected
    }, {
      value: counters.pending,
      visible: Boolean(counters.pending)
    }, {
      value: counters.disconnected
    }, {
      label: missingLabel,
      value: counters.missing,
      visible: Boolean(counters.missing)
    }]
  };
}

function _getBar(counters) {
  const values = (0, _coreUtils.flatMap)([{
    color: 'color27',
    count: counters.connected
  }, {
    color: 'color26',
    count: counters.pending
  }, {
    color: 'color31',
    count: counters.disconnected
  }, {
    color: 'color09',
    count: counters.missing
  }], item => (0, _coreUtils.makeArray)(item.count).fill({
    value: 1,
    color: `rgb(var(--${item.color}))`
  }));
  const markers = [{
    position: Math.floor(counters.all / 2) + 1,
    text: 'Minimum for R/W service'
  }];
  return {
    values,
    markers
  };
}

class ClusterSummaryViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "status", {
      icon: _knockout.default.observable(),
      css: _knockout.default.observable(),
      text: _knockout.default.observable()
    });
    (0, _defineProperty2.default)(this, "ha", {
      icon: _knockout.default.observable(),
      css: _knockout.default.observable(),
      text: _knockout.default.observable(),
      tooltip: HATooltip
    });
    (0, _defineProperty2.default)(this, "faultTolerance", {
      icon: _knockout.default.observable(),
      css: _knockout.default.observable(),
      text: _knockout.default.observable(),
      tooltip: faultToleranceTooltip
    });
    (0, _defineProperty2.default)(this, "legend", {
      caption: _knockout.default.observable(),
      values: [{
        label: 'Connected',
        color: 'rgb(var(--color27))',
        value: _knockout.default.observable()
      }, {
        label: 'Pending',
        color: 'rgb(var(--color26))',
        value: _knockout.default.observable(),
        visible: _knockout.default.observable()
      }, {
        label: 'Disconnected',
        color: 'rgb(var(--color31))',
        value: _knockout.default.observable()
      }, {
        label: _knockout.default.observable(),
        color: 'rgb(var(--color09))',
        value: _knockout.default.observable(),
        visible: _knockout.default.observable()
      }]
    });
    (0, _defineProperty2.default)(this, "bar", {
      values: _knockout.default.observableArray(),
      markers: _knockout.default.observableArray()
    });
  }

  selectState(state) {
    const {
      topology,
      system
    } = state;
    return [topology, system && system.version];
  }

  mapStateToProps(topology, systemVersion) {
    if (!topology || !systemVersion) {
      _knockout.default.assignToProps(this, {
        dataReady: false
      });
    } else {
      const counters = _countServers(topology.servers);

      _knockout.default.assignToProps(this, {
        dataReady: true,
        status: _getStatus(topology, systemVersion),
        ha: _getHA(topology),
        faultTolerance: _getFaultTolerance(topology),
        legend: _getLegend(topology.supportHighAvailability, counters),
        bar: _getBar(counters)
      });
    }
  }

}

var _default = {
  viewModel: ClusterSummaryViewModel,
  template: _clusterSummary.default
};
exports.default = _default;

},{"./cluster-summary.html":441,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"components/connectable":446,"knockout":"knockout","numeral":"numeral","utils/cluster-utils":1025,"utils/core-utils":1027,"utils/string-utils":1046}],443:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<section class=\"row pad card-shadow content-middle\">\n    <h2 class=\"heading3 greedy push-next\">Server Details</h2>\n    <div ko.tooltip=\"attachServerTooltip\">\n        <button class=\"btn align-end\"\n            ko.click=\"onAttachServerToCluster\"\n            ko.enable=\"canAttachServer\"\n        >\n            Attach Server\n        </button>\n    </div>\n</section>\n\n<data-table class=\"greedy server-data-table\" params=\"\n    columns: columns,\n    data: rows,\n    sorting: ko.pc(sorting, onSort, $component),\n    loading: !dataReady(),\n    emptyMessage: 'The current filter does not match any server'\n\">\n    <template name=\"usage\">\n        <div class=\"column usage-cell content-middle\" ko.tooltip=\"tooltip\">\n            <progress-bar class=\"push-next-quarter\"\n                params=\"progress: ratio\"\n            ></progress-bar>\n            <span class=\"remark\">{{percentage}} Usage</span>\n        </div>\n    </template>\n</data-table>\n";

},{}],444:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _serverTable = _interopRequireDefault(require("./server-table.html"));

var _usageTooltip = _interopRequireDefault(require("./usage-tooltip.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _coreUtils = require("utils/core-utils");

var _sizeUtils = require("utils/size-utils");

var _browserUtils = require("utils/browser-utils");

var _clusterUtils = require("utils/cluster-utils");

var _config = require("config");

var _actionCreators = require("action-creators");

var _knockout = _interopRequireDefault(require("knockout"));

var _numeral = _interopRequireDefault(require("numeral"));

/* Copyright (C) 2016 NooBaa */
const columns = (0, _coreUtils.deepFreeze)([{
  name: 'state',
  type: 'icon',
  sortable: true,
  compareKey: server => server.mode
}, {
  name: 'name',
  label: 'server name',
  sortable: true,
  compareKey: server => (0, _clusterUtils.getServerDisplayName)(server)
}, {
  name: 'diskUsage',
  label: 'Disk',
  type: 'usage',
  sortable: true,
  compareKey: server => 1 - (0, _sizeUtils.toBytes)(server.storage.free) / (0, _sizeUtils.toBytes)(server.storage.total)
}, {
  name: 'memoryUsage',
  label: 'Memory',
  type: 'usage',
  sortable: true,
  compareKey: server => server.memory.used / server.memory.total
}, {
  name: 'cpuUsage',
  label: 'CPUs',
  type: 'usage',
  sortable: true,
  compareKey: server => server.cpus.usage
}, {
  name: 'version',
  sortable: true,
  compareKey: server => server.version
}]);

function _matchFilter(server, filter = '') {
  const {
    addresses,
    locationTag
  } = server;
  const {
    ip
  } = addresses.length > 0 ? addresses[0] : '';
  return [`${(0, _clusterUtils.getServerDisplayName)(server)}`, ip, locationTag].some(key => key.toLowerCase().includes(filter.toLowerCase()));
}

function _getStatus(server, version, serverMinRequirements) {
  const issues = Object.values((0, _clusterUtils.summarizeServerIssues)(server, version, serverMinRequirements));

  if (server.mode === 'CONNECTED' && issues.length) {
    return {
      name: 'problem',
      css: 'warning',
      tooltip: {
        template: 'list',
        text: issues,
        align: 'start',
        breakWords: false
      }
    };
  }

  return (0, _clusterUtils.getServerStateIcon)(server);
}

function _getDiskUsage(server) {
  if (server.mode === 'DISCONNECTED') {
    return {
      ratio: 0,
      percentage: '0%',
      tooltip: ''
    };
  } else {
    const total = (0, _sizeUtils.toBytes)(server.storage.total);
    const free = (0, _sizeUtils.toBytes)(server.storage.free);
    const used = total - free;
    const usedRatio = total ? used / total : 0;
    const tooltip = {
      template: _usageTooltip.default,
      text: `${(0, _sizeUtils.formatSize)(used)} of ${(0, _sizeUtils.formatSize)(total)}`
    }; // let css = '';
    // if (usedRatio >= diskUsageWarningBound) {
    //     css = usedRatio >= diskUsageErrorBound ? 'error' : 'warning';
    // }

    return {
      ratio: usedRatio,
      percentage: (0, _numeral.default)(usedRatio).format('%'),
      tooltip
    };
  }
}

function _getMemoryUsage(server) {
  if (server.mode === 'DISCONNECTED') {
    return {
      ratio: 0,
      percentage: '0%',
      tooltip: ''
    };
  } else {
    const {
      total,
      used
    } = server.memory;
    const usedRatio = total ? used / total : total;
    return {
      ratio: usedRatio,
      percentage: (0, _numeral.default)(usedRatio).format('%'),
      tooltip: {
        template: _usageTooltip.default,
        text: `${(0, _sizeUtils.formatSize)(used)} of ${(0, _sizeUtils.formatSize)(total)}`
      }
    };
  }
}

function _getCpuUsage(server) {
  if (server.mode === 'DISCONNECTED') {
    return {
      ratio: 0,
      percentage: '0%',
      tooltip: ''
    };
  } else {
    const {
      usage,
      count
    } = server.cpus;
    return {
      ratio: usage,
      percentage: (0, _numeral.default)(usage).format('%'),
      tooltip: {
        template: _usageTooltip.default,
        text: `${(0, _numeral.default)(count).format(',')} CPUs`
      }
    };
  }
}

class ServerRowViewModel {
  constructor() {
    (0, _defineProperty2.default)(this, "baseRoute", '');
    (0, _defineProperty2.default)(this, "state", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "name", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "address", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "diskUsage", {
      ratio: _knockout.default.observable(),
      percentage: _knockout.default.observable(),
      tooltip: _knockout.default.observable()
    });
    (0, _defineProperty2.default)(this, "memoryUsage", {
      ratio: _knockout.default.observable(),
      percentage: _knockout.default.observable(),
      tooltip: _knockout.default.observable()
    });
    (0, _defineProperty2.default)(this, "cpuUsage", {
      ratio: _knockout.default.observable(),
      percentage: _knockout.default.observable(),
      tooltip: _knockout.default.observable()
    });
    (0, _defineProperty2.default)(this, "version", _knockout.default.observable());
  }

}

class ServerTableViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "pathname", '');
    (0, _defineProperty2.default)(this, "columns", columns);
    (0, _defineProperty2.default)(this, "filter", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "sorting", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "rows", _knockout.default.observableArray().ofType(ServerRowViewModel, {
      table: this
    }));
    (0, _defineProperty2.default)(this, "canAttachServer", false);
    (0, _defineProperty2.default)(this, "attachServerTooltip", {
      align: 'end',
      text: 'Attaching a server will be available in future versions'
    });
    (0, _defineProperty2.default)(this, "onFilterThrottled", (0, _coreUtils.throttle)(this.onFilter, _config.inputThrottle, this));
  }

  selectState(state) {
    const {
      topology,
      system,
      location
    } = state;
    return [topology, system && system.version, location];
  }

  mapStateToProps(topology, systemVersion, location) {
    if (!topology) {
      _knockout.default.assignToProps(this, {
        dataReady: false
      });
    } else {
      const {
        query,
        pathname
      } = location;
      const {
        filter = '',
        sortBy = 'name'
      } = query;
      const order = Number(location.query.order) || 1;
      const {
        compareKey
      } = columns.find(column => column.name === sortBy);
      const serverList = Object.values(topology.servers);

      _knockout.default.assignToProps(this, {
        dataReady: true,
        pathname,
        filter,
        sorting: {
          sortBy,
          order
        },
        rows: serverList.filter(server => _matchFilter(server, filter)).sort((0, _coreUtils.createCompareFunc)(compareKey, order)).map(server => {
          return {
            state: _getStatus(server, systemVersion, topology.serverMinRequirements),
            name: `${(0, _clusterUtils.getServerDisplayName)(server)} ${server.isMaster ? '(Master)' : ''}`,
            diskUsage: _getDiskUsage(server),
            memoryUsage: _getMemoryUsage(server),
            cpuUsage: _getCpuUsage(server),
            version: server.version
          };
        })
      });
    }
  }

  onFilter(filter) {
    this._query({
      filter
    });
  }

  onSort(sorting) {
    this._query({
      sorting
    });
  }

  _query(params) {
    const {
      filter = this.filter(),
      sorting = this.sorting()
    } = params;
    const {
      sortBy,
      order
    } = sorting;
    const query = {
      filter: filter || undefined,
      sortBy: sortBy,
      order: order
    };
    this.dispatch((0, _actionCreators.requestLocation)((0, _browserUtils.realizeUri)(this.pathname, null, query)));
  }

  onAttachServerToCluster() {
    this.dispatch((0, _actionCreators.openAttachServerModal)());
  }

}

var _default = {
  viewModel: ServerTableViewModel,
  template: _serverTable.default
};
exports.default = _default;

},{"./server-table.html":443,"./usage-tooltip.html":445,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"config":831,"knockout":"knockout","numeral":"numeral","utils/browser-utils":1021,"utils/cluster-utils":1025,"utils/core-utils":1027,"utils/size-utils":1043}],445:[function(require,module,exports){
module.exports = "<div class=\"column\">\n    <p class=\"highlight push-next-half\">{{$data}}</p>\n    <p class=\"remark\">\n        <svg-icon class=\"icon-small\" params=\"name: 'clock'\"></svg-icon>\n        Average utilization over the last minute\n    </p>\n</div>\n";

},{}],446:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _coreUtils = require("utils/core-utils");

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
const subSym = Symbol('Props subscription');
const lastSelectionSym = Symbol('Last state selection');
const actionsSym = Symbol('Actions stream');

function _isStateSelectionValid(selection) {
  return true && Array.isArray(selection) && selection.every(Object.isFrozen);
}

class ConnectableViewModel {
  constructor(params = {}, {
    state$,
    action$
  }) {
    (0, _defineProperty2.default)(this, actionsSym, null);
    (0, _defineProperty2.default)(this, lastSelectionSym, []);
    (0, _defineProperty2.default)(this, subSym, null);
    this[actionsSym] = action$; // Schedule the computed on the ko tasks queue to ensure that the
    // sub class constructor run and initialize fields before calling
    // first onState.

    _knockout.default.tasks.schedule(() => {
      const state = _knockout.default.fromRx(state$);

      this[subSym] = _knockout.default.computed(() => this.onState(state(), _knockout.default.deepUnwrap(params)));
    });
  }

  onState(state, params) {
    if (!state) return;
    const selection = this.selectState(state, params);

    if (!_isStateSelectionValid(selection)) {
      throw new Error('Invalid state selection');
    }

    if (!(0, _coreUtils.equalItems)(this[lastSelectionSym], selection)) {
      this[lastSelectionSym] = selection;
      this.mapStateToProps(...selection);
    }
  }

  selectState()
  /*state, params*/
  {
    return [];
  }

  mapStateToProps()
  /*...selection*/
  {}

  dispatch(...actions) {
    const action$ = this[actionsSym];

    for (const action of actions) {
      action$.next(action);
    }
  }

  dispose() {
    this[subSym].dispose();
  }

}

exports.default = ConnectableViewModel;

},{"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","utils/core-utils":1027}],447:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<managed-form params=\"\n    name: formName,\n    fields: formFields\n\">\n    <div class=\"card-shadow hpad pad-top column\">\n        <h2 class=\"heading3\">Endpoint Auto-Scale</h2>\n        <p class=\"push-next\">\n            Present the endpoint's scaling behavior according to configured Kubernetes metrics\n        </p>\n        <div class=\"row content-middle push-next\">\n            <dropdown class=\"push-next\" params=\"\n                options: groupOptions,\n                multiselect: true,\n                selected: $form.selectedGroups,\n                disabled: !dataReady(),\n                subject: 'group'\n            \"></dropdown>\n            <dropdown class=\"push-next\" params=\"\n                options: timespanOptions,\n                selected: $form.selectedTimespan,\n                disabled: !dataReady()\n            \"></dropdown>\n            <svg-icon class=\"spin match-theme\"\n                params=\"name: 'in-progress'\"\n                ko.visible=\"!dataReady()\"\n            ></svg-icon>\n        </div>\n    </div>\n\n    <div class=\"row pad content-middle push-next\">\n        <span class=\"heading3\">Compare To:</span>\n        <radio-group class=\"push-prev\" params=\"\n            options: metricOptions,\n            selected: $form.selectedMetric\n        \"></radio-group>\n    </div>\n\n    <chartjs class=\"pad push-next\" params=\"\n        type: chart.type,\n        options: chart.options,\n        data: chart.data,\n        emptyMessage: chart.emptyMessage\n    \"></chartjs>\n\n</managed-form>\n";

},{}],448:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _endpointGroupsScalingForm = _interopRequireDefault(require("./endpoint-groups-scaling-form.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _coreUtils = require("utils/core-utils");

var _formUtils = require("utils/form-utils");

var _sizeUtils = require("utils/size-utils");

var _knockout = _interopRequireDefault(require("knockout"));

var _moment = _interopRequireDefault(require("moment"));

var _numeral = _interopRequireDefault(require("numeral"));

var _themes = _interopRequireDefault(require("themes"));

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const FETCH_THRESHOLD = _moment.default.duration(10, 'minute').asMilliseconds();

const throughputGuides = (0, _coreUtils.deepFreeze)(['PB', 'TB', 'GB', 'MB'].map(unit => _sizeUtils.unitsInBytes[unit]));
const timespanScale = (0, _coreUtils.deepFreeze)({
  '24_HOURS': {
    label: 'Last 24 hours',
    formatValue: t => (0, _moment.default)(t).format('DD MMM HH:mm')
  },
  '7_DAYS': {
    label: 'Last 7 Days',
    formatValue: t => `${(0, _moment.default)(t).subtract(1, 'day').format('DD MMM')} - ${(0, _moment.default)(t).format('DD MMM')}`
  },
  '4_WEEKS': {
    label: 'Last 4 Weeks',
    formatValue: t => `${(0, _moment.default)(t).subtract(7, 'day').format('DD MMM')} - ${(0, _moment.default)(t).format('DD MMM')}`
  }
});
const metricScales = (0, _coreUtils.deepFreeze)({
  ENDPOINTS: {
    label: 'Endpoint Count',
    isFixed: true,
    getValue: sample => sample.endpointCount,
    formatValue: value => (0, _numeral.default)(value).format(',0.[00]'),
    getTicksConf: (data = []) => {
      const maxSample = Math.max(5, ...data);
      const step = Math.ceil(maxSample / 5);
      return {
        min: 0,
        max: step * 5,
        step
      };
    }
  },
  CPU: {
    label: 'CPU %',
    isFixed: false,
    getValue: sample => sample.cpuUsage,
    formatValue: value => (0, _numeral.default)(value).format('%'),
    getTicksConf: (data = []) => {
      const max = Math.max(1, ...data.map(Math.ceil));
      const step = max / 5;
      return {
        min: 0,
        max,
        step
      };
    }
  },
  MEM: {
    label: 'Memory %',
    isFixed: false,
    getValue: sample => sample.memoryUsage,
    formatValue: value => (0, _numeral.default)(value).format('%'),
    getTicksConf: () => ({
      min: 0,
      max: 1,
      step: .2
    })
  },
  THROUGHPUT: {
    label: 'Throughput',
    isFixed: false,
    getValue: sample => (0, _sizeUtils.toBytes)((0, _sizeUtils.sumSize)(sample.readSize, sample.writeSize)),
    formatValue: value => value === 0 ? '0' : (0, _sizeUtils.formatSize)(value),
    getTicksConf: (data = []) => {
      const maxSample = Math.max(_sizeUtils.unitsInBytes.MB, ...data);
      const bestUnit = throughputGuides.find(size => maxSample / size > 1000 / 1024);
      const factor = maxSample / (100 * bestUnit) > 1 && 100 * bestUnit || maxSample / (10 * bestUnit) > 1 && 10 * bestUnit || bestUnit;
      const max = Math.ceil(maxSample / factor) * factor;
      return {
        min: 0,
        max,
        step: max / 5
      };
    }
  }
});
const timespanOptions = Object.entries(timespanScale).map(pair => ({
  value: pair[0],
  label: pair[1].label
}));
const metricOptions = Object.entries(metricScales).filter(pair => !pair[1].isFixed).map(pair => ({
  value: pair[0],
  label: pair[1].label
}));
const chartOptions = {
  scales: {
    yAxes: Object.entries(metricScales).map(pair => {
      const [id, info] = pair;
      return {
        id,
        type: 'linear',
        display: info.isFixed ? true : 'auto',
        position: info.isFixed ? 'right' : 'left',
        scaleLabel: {
          display: true,
          labelString: info.label
        },
        ticks: {
          padding: 5,
          callback: info.formatValue
        },
        beforeDataLimits: scale => {
          const datasets = (0, _coreUtils.get)(scale, ['chart', 'config', 'data', 'datasets']);
          if (!datasets) return;
          const dataset = datasets.find(dataset => dataset.yAxisID === scale.options.id);
          const {
            min,
            max,
            step
          } = info.getTicksConf(dataset && dataset.data);
          scale.options.ticks.min = min;
          scale.options.ticks.max = max;
          scale.options.ticks.stepSize = step;
        }
      };
    })
  },
  tooltips: {
    position: 'nearest',
    mode: 'index',
    callbacks: {
      title: items => items[0].xLabel,
      label: (item, chartData) => {
        const {
          yAxisID,
          data
        } = chartData.datasets[item.datasetIndex];
        const {
          label,
          formatValue
        } = metricScales[yAxisID];
        return `${label}: ${formatValue(data[item.index])}`;
      }
    }
  }
};

function _perpareChartData(samples, labelFormatter, metric, theme) {
  const {
    display,
    getValue
  } = metricScales[metric];
  const lineColor = theme.color14;
  return {
    labels: samples.map(sample => labelFormatter(sample.timestamp)),
    datasets: [{
      order: 2,
      yAxisID: 'ENDPOINTS',
      label: 'Endpoint Count',
      backgroundColor: theme.color20,
      data: samples.map(metricScales.ENDPOINTS.getValue)
    }, {
      type: 'line',
      order: 1,
      yAxisID: metric,
      label: display,
      borderColor: lineColor,
      backgroundColor: 'transparent',
      pointBackgroundColor: lineColor,
      pointBorderColor: 'transparent',
      pointHoverBorderColor: lineColor,
      pointRadius: 3,
      pointBorderWidth: 4,
      pointHitRadius: 10,
      lineTension: 0,
      fill: false,
      data: samples.map(getValue)
    }]
  };
}

class EndpointGroupsScalingFormViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "lastFetchRefreshCount", 0);
    (0, _defineProperty2.default)(this, "formName", this.constructor.name);
    (0, _defineProperty2.default)(this, "groupOptions", _knockout.default.observableArray());
    (0, _defineProperty2.default)(this, "timespanOptions", timespanOptions);
    (0, _defineProperty2.default)(this, "metricOptions", metricOptions);
    (0, _defineProperty2.default)(this, "formFields", {
      initialized: false,
      selectedGroups: [],
      selectedTimespan: '24_HOURS',
      selectedMetric: 'CPU'
    });
    (0, _defineProperty2.default)(this, "chart", {
      type: 'bar',
      options: chartOptions,
      data: _knockout.default.observable(),
      emptyMessage: _knockout.default.observable()
    });
  }

  onState(state, params) {
    super.onState(state, params);
    this.fetchEndpointsHistory(state);
    this.initializeForm(state);
  }

  selectState(state) {
    const {
      endpointGroups,
      endpointsHistory,
      forms,
      session
    } = state;
    return [endpointGroups, endpointsHistory, forms && forms[this.formName], session && _themes.default[session.uiTheme]];
  }

  mapStateToProps(groups, history, form, theme) {
    if (!groups || !history.samples || !theme || !(0, _formUtils.getFieldValue)(form, 'initialized')) {
      _knockout.default.assignToProps(this, {
        dataReady: false,
        chart: {
          emptyMessage: 'Loading data...'
        }
      });
    } else {
      const groupNames = Object.keys(groups);
      const {
        formatValue
      } = history.query ? timespanScale[history.query.timespan] : {};

      _knockout.default.assignToProps(this, {
        dataReady: true,
        groupOptions: groupNames,
        chart: {
          data: _perpareChartData(history.samples, formatValue, (0, _formUtils.getFieldValue)(form, 'selectedMetric'), theme),
          emptyMessage: 'No data to display'
        }
      });
    }
  }

  initializeForm(state) {
    const form = state.forms[this.formName];
    if (!form) return;

    if (state.endpointGroups && !(0, _formUtils.getFieldValue)(form, 'initialized')) {
      const update = {
        selectedGroups: Object.keys(state.endpointGroups),
        initialized: true
      };
      this.dispatch((0, _actionCreators.updateForm)(this.formName, update, false));
    }
  }

  fetchEndpointsHistory(state) {
    const {
      query
    } = state.endpointsHistory;
    const form = state.forms[this.formName];
    if (!form) return;
    const {
      selectedTimespan,
      selectedGroups
    } = (0, _formUtils.getFormValues)(form);

    if (!query || Date.now() - query.timestamp > FETCH_THRESHOLD || selectedTimespan != query.timespan || !(0, _coreUtils.equalItems)(selectedGroups, query.groups)) {
      this.dispatch((0, _actionCreators.fetchEndpointsHistory)(selectedGroups, selectedTimespan));
    }
  }

  dispose() {
    this.dispatch((0, _actionCreators.dropEndpointsHistory)());
    super.dispose();
  }

}

var _default = {
  viewModel: EndpointGroupsScalingFormViewModel,
  template: _endpointGroupsScalingForm.default
};
exports.default = _default;

},{"./endpoint-groups-scaling-form.html":447,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout","moment":"moment","numeral":"numeral","themes":1018,"utils/core-utils":1027,"utils/form-utils":1030,"utils/size-utils":1043}],449:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n<div class=\"card-shadow row pad content-middle\">\n    <h2 class =\"heading3 push-next\">Endpoint Groups</h2>\n     <p class=\"remark content-middle push-next\" ko.visible=\"lastUpdate\">\n        <svg-icon class=\"icon-small\" params=\"name: 'clock'\"></svg-icon>\n        Updated: {{lastUpdate}}\n    </p>\n    <div class=\"greedy column content-end\">\n        <button class=btn\n            ko.click=onDeployRemoteEndpointGroup\n            ko.enable=\"dataReady\"\n        >\n            Deploy Remote Endpoint Group\n        </button>\n    </div>\n</div>\n\n<data-table class=\"greedy\" params=\"\n    columns: columns,\n    data: rows,\n    sorting: ko.pc(sorting, onSort, $component),\n    loading: !dataReady()\n\">\n    <template name=\"nameAndLocality\">\n        <p class=\"row content-middle\">\n            {{$data().name}}\n            <span class=\"tag push-prev-half\" ko.visible=\"$data().localGroup\">\n                Local Group\n            </span>\n        </p>\n    </template>\n</data-table>\n\n<paginator params=\"\n    itemCount: groupCount,\n    pageSize: ko.pc(pageSize, onPageSize, $component),\n    page: ko.pc(page, onPage, $component)\n\"></paginator>\n";

},{}],450:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _endpointGroupsTable = _interopRequireDefault(require("./endpoint-groups-table.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _numeral = _interopRequireDefault(require("numeral"));

var _moment = _interopRequireDefault(require("moment"));

var _coreUtils = require("utils/core-utils");

var _browserUtils = require("utils/browser-utils");

var _config = require("config");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const columns = Object.freeze([{
  name: 'name',
  type: 'nameAndLocality',
  label: 'Endpoint Group',
  sortable: true,
  compareKey: group => group.name
}, {
  name: 'count',
  sortable: true,
  compareKey: group => group.endpointCount
}, {
  name: 'range',
  label: 'Endpoint Range',
  sortable: false
}, {
  name: 'region',
  sortable: true,
  compareKey: group => group.region
}, {
  name: 'cpuUsage',
  label: 'CPU %',
  sortable: true,
  compareKey: group => group.cpuUsage
}, {
  name: 'memoryUsage',
  label: 'Memory %',
  sortable: true,
  compareKey: group => group.memoryUsage
}, {
  name: 'edit',
  label: '',
  type: 'iconButton'
}]);

class EndpointGroupRowViewModel {
  constructor({
    table
  }) {
    (0, _defineProperty2.default)(this, "name", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "count", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "range", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "region", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "cpuUsage", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "memoryUsage", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "edit", {
      id: _knockout.default.observable(),
      icon: 'edit',
      tooltip: 'Edit Endpoint Group',
      disabled: _knockout.default.observable(),
      onClick: name => this.table.onEditEndpointGroup(name)
    });
    this.table = table;
  }

}

class EndpointsTableViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "columns", columns);
    (0, _defineProperty2.default)(this, "pathname", '');
    (0, _defineProperty2.default)(this, "lastUpdate", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "sorting", _knockout.default.observable({}));
    (0, _defineProperty2.default)(this, "groupCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "pageSize", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "page", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "rows", _knockout.default.observableArray().ofType(EndpointGroupRowViewModel, {
      table: this
    }));
  }

  selectState(state) {
    return [state.location, state.endpointGroups];
  }

  mapStateToProps(location, groups) {
    if (!groups) {
      _knockout.default.assignToProps(this, {
        dataReady: false
      });
    } else {
      const {
        pathname,
        query
      } = location;
      const {
        sortBy = 'name'
      } = query;
      const order = Number(query.order) || 1;
      const page = Number(query.page) || 0;

      const pageSize = Number(query.pageSize) || _config.paginationPageSize.default;

      const {
        compareKey
      } = columns.find(column => column.name === sortBy);
      const groupList = Object.values(groups).sort((0, _coreUtils.createCompareFunc)(compareKey, order));
      const lastUpdate = Math.min(...groupList.map(group => group.lastReportTime));

      _knockout.default.assignToProps(this, {
        dataReady: true,
        pathname,
        lastUpdate: lastUpdate > 0 ? (0, _moment.default)(lastUpdate).fromNow() : null,
        sorting: {
          sortBy,
          order
        },
        pageSize,
        page,
        groupCount: groupList.length,
        rows: groupList.map(group => {
          const {
            min,
            max
          } = group.endpointRange;
          return {
            name: {
              name: group.name,
              localGroup: !group.isRemote
            },
            count: group.endpointCount,
            range: `${min} - ${max}`,
            region: group.region || '(Not Set)',
            cpuUsage: (0, _numeral.default)(group.cpuUsage).format('%'),
            memoryUsage: (0, _numeral.default)(group.memoryUsage).format('%'),
            edit: {
              id: group.name,
              disabled: group.isRemote
            }
          };
        })
      });
    }
  }

  onDeployRemoteEndpointGroup() {
    this.dispatch((0, _actionCreators.openDeployRemoteEndpointGroupModal)());
  }

  onSort(sorting) {
    this._query({
      sortBy: sorting.sortBy,
      order: sorting.order,
      page: 0
    });
  }

  onPageSize(pageSize) {
    this._query({
      pageSize,
      page: 0
    });
  }

  onPage(page) {
    this._query({
      page
    });
  }

  onEditEndpointGroup(name) {
    this.dispatch((0, _actionCreators.openEditEndpointGroupModal)(name));
  }

  _query(query) {
    const {
      // filter = this.filter(),
      sortBy = this.sorting().sortBy,
      order = this.sorting().order,
      page = this.page(),
      pageSize = this.pageSize()
    } = query;
    const queryUrl = (0, _browserUtils.realizeUri)(this.pathname, null, {
      // filter: filter || undefined,
      sortBy,
      order,
      page,
      pageSize
    });
    this.dispatch((0, _actionCreators.requestLocation)(queryUrl));
  }

}

var _default = {
  viewModel: EndpointsTableViewModel,
  template: _endpointGroupsTable.default
};
exports.default = _default;

},{"./endpoint-groups-table.html":449,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"config":831,"knockout":"knockout","moment":"moment","numeral":"numeral","utils/browser-utils":1021,"utils/core-utils":1027}],451:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<endpoints-summary class=\"push-next\"></endpoints-summary>\n\n<div class=\"column tabs greedy\">\n    <nav>\n        <a ko.css.selected=\"selectedTab.eq('statistics')\"\n            ko.attr.href=\"tabHref('statistics')\"\n        >\n            Statistics\n        </a>\n        <a ko.css.selected=\"selectedTab.eq('info')\"\n            ko.attr.href=\"tabHref('info')\"\n        >\n            Endpoints\n        </a>\n    </nav>\n\n    <div class=\"tabs-row\">\n        <div class=\"tab\"\n            ko.css.selected=\"selectedTab.eq('statistics')\"\n        >\n            <endpoint-groups-scaling-form class=\"column\"\n            ></endpoint-groups-scaling-form>\n            <hr>\n             <account-usage-form class=\"column\">\n            </account-usage-form>\n        </div>\n\n        <endpoint-groups-table class=\"tab column\"\n            ko.css.selected=\"selectedTab.eq('info')\"\n        ></endpoint-groups-table>\n    </div>\n</div>\n\n";

},{}],452:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _endpointsPanel = _interopRequireDefault(require("./endpoints-panel.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _browserUtils = require("utils/browser-utils");

/* Copyright (C) 2016 NooBaa */
class EndpointsPanelViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "baseRoute", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "selectedTab", _knockout.default.observable());
  }

  selectState(state) {
    return [state.location];
  }

  mapStateToProps(location) {
    const {
      system,
      tab = 'statistics'
    } = location.params;

    _knockout.default.assignToProps(this, {
      baseRoute: (0, _browserUtils.realizeUri)(location.route, {
        system
      }, {}, true),
      selectedTab: tab
    });
  }

  tabHref(tab) {
    const route = this.baseRoute();

    if (route) {
      return (0, _browserUtils.realizeUri)(route, {
        tab
      });
    }
  }

}

var _default = {
  viewModel: EndpointsPanelViewModel,
  template: _endpointsPanel.default
};
exports.default = _default;

},{"./endpoints-panel.html":451,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"components/connectable":446,"knockout":"knockout","utils/browser-utils":1021}],453:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"fill row\" ko.visible=\"!dataReady()\">\n    <loading-indicator class=\"align-middle greedy\" params=\"label: true\"></loading-indicator>\n</div>\n\n<div class=\"summary greedy row\" ko.css.visible=\"dataReady\">\n    <section class=\"card c4 column\">\n        <div class=\"row content-middle hpad greedy\">\n            <span class=\"c5 push-next\">Endpoint Groups:</span>\n            <span class=\"c7 text-right\">{{groupCount}}</span>\n        </div>\n        <hr/>\n        <div class=\"row content-middle hpad greedy\">\n            <span class=\"c5 push-next\">Endpoint Count:</span>\n            <span class=\"c7 text-right\">{{endpointCount}}</span>\n        </div>\n    </section>\n    <section class=\"c4 column hpad-double push-both\">\n        <div class=\"row content-middle push-next-half\">\n            <h2 class=\"heading3 greedy push-next\">Endpoint Groups Size</h2>\n            <p class=\"remark content-middle\" ko.visible=\"lastUpdate\">\n                <svg-icon class=\"icon-small\" params=\"name: 'clock'\"></svg-icon>\n                Updated: {{lastUpdate}}\n            </p>\n        </div>\n        <chartjs class=\"greedy groups-chart\" params=\"\n            type: 'bar',\n            options: chart.options,\n            data: chart.data\n        \"></chartjs>\n    </section>\n    <section class=\"c4 card column\">\n        <div class=\"row content-middle hpad greedy\">\n            <div class=\"column\">\n                <p class=\"heading3\">{{cpuUsage}}</p>\n                <p>\n                    CPU Utilization\n                </p>\n            </div>\n        </div>\n        <hr />\n        <div class=\"row content-middle hpad greedy\">\n            <div class=\"column\">\n                <p class=\"heading3\">{{memoryUsage}}</p>\n                <p>\n                    Memory Utilization\n                </p>\n            </div>\n        </div>\n    </section>\n</div>\n";

},{}],454:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _endpointsSummary = _interopRequireDefault(require("./endpoints-summary.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _numeral = _interopRequireDefault(require("numeral"));

var _moment = _interopRequireDefault(require("moment"));

var _coreUtils = require("utils/core-utils");

var _stringUtils = require("utils/string-utils");

var _themes = _interopRequireDefault(require("themes"));

/* Copyright (C) 2016 NooBaa */
class EndpointsSummaryViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable(true));
    (0, _defineProperty2.default)(this, "groupCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "endpointCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "cpuUsage", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "memoryUsage", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "lastUpdate", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "chart", {
      options: {
        layout: {
          padding: 0
        },
        maintainAspectRatio: false,
        scales: {
          yAxes: [{
            stacked: true,
            ticks: {
              maxTicksLimit: 10,
              suggestedMax: 10,
              precision: 1,
              stepSize: 2
            }
          }],
          xAxes: [{
            stacked: true,
            ticks: {
              callback: value => value.length > 10 ? `${value.slice(0, 7)}...` : value
            }
          }]
        },
        tooltips: {
          position: 'nearest',
          mode: 'x',
          displayColors: false,
          callbacks: {
            label: item => (0, _stringUtils.stringifyAmount)('Endpoint', item.yLabel)
          }
        }
      },
      data: _knockout.default.observable()
    });
  }

  selectState(state) {
    const {
      endpointGroups,
      session
    } = state;
    return [endpointGroups, session && _themes.default[session.uiTheme]];
  }

  mapStateToProps(groups, theme) {
    if (!groups) {
      _knockout.default.assignToProps(this, {
        dataReady: false
      });
    } else {
      const groupList = Object.values(groups);
      const endpointCount = (0, _coreUtils.sumBy)(groupList, group => group.endpointCount);
      const cpuCount = (0, _coreUtils.sumBy)(groupList, group => group.cpuCount);
      const cpuUsage = (0, _coreUtils.sumBy)(groupList, group => group.cpuUsage);
      const memoryUsage = (0, _coreUtils.sumBy)(groupList, group => group.memoryUsage);
      const lastUpdate = Math.min(...groupList.map(group => group.lastReportTime));
      const chartData = {
        labels: [...groupList.map(group => group.name), ...(0, _coreUtils.makeArray)(Math.max(3 - groupList.length, 0), () => '')],
        datasets: [{
          categoryPercentage: .5,
          backgroundColor: theme.color20,
          data: groupList.map(group => group.endpointCount)
        }]
      };

      _knockout.default.assignToProps(this, {
        dataReady: true,
        groupCount: (0, _numeral.default)(groupList.length).format(','),
        endpointCount: (0, _numeral.default)(endpointCount).format(','),
        cpuUsage: `${(0, _numeral.default)(cpuUsage).format('%')} (${(0, _stringUtils.stringifyAmount)('core', cpuCount)})`,
        memoryUsage: (0, _numeral.default)(memoryUsage).format('%'),
        lastUpdate: lastUpdate > 0 ? (0, _moment.default)(lastUpdate).fromNow() : '',
        chart: {
          data: chartData
        }
      });
    }
  }

}

var _default = {
  viewModel: EndpointsSummaryViewModel,
  template: _endpointsSummary.default
};
exports.default = _default;

},{"./endpoints-summary.html":453,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"components/connectable":446,"knockout":"knockout","moment":"moment","numeral":"numeral","themes":1018,"utils/core-utils":1027,"utils/string-utils":1046}],455:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"column greedy\"\n    ko.css.blur=\"isZipStale\"\n>\n    <div class=\"row content-middle card-shadow pad\">\n        <div class=\"column greedy push-next\">\n            <h3 class=\"heading3\">\n                Function Code: {{formattedFileCount}}\n            </h3>\n            <p class=\"row\">\n                <span class=\"no-wrap handler-summary\"\n                    ko.tooltip=\"execFile\"\n                >\n                    File: {{execFile.text}}\n                </span>\n                <vr class=\"push-both-half\"></vr>\n                <span class=\"no-wrap handler-summary\"\n                    ko.tooltip=\"execFunc\"\n                >\n                    Function: {{execFunc.text}}\n                </span>\n            </p>\n        </div>\n\n<!--         <button class=\"btn push-next\"\n            ko.click=\"onDownloadCode\"\n            ko.enable=\"areActionsEnabled\"\n        >\n            Download Code\n        </button> -->\n        <button class=\"btn push-next\"\n            ko.click=\"onEditCode\"\n            ko.enable=\"areActionsEnabled\"\n        >\n            Edit Code\n        </button>\n        <button class=\"btn\"\n            ko.click=\"onSetEventAndInvoke\"\n            ko.enable=\"areActionsEnabled\"\n        >\n            Set Event and Invoke\n        </button>\n    </div>\n\n    <!-- ko if: isFuncOversized -->\n    <p class=\"empty-message\">\n        Stored function code is too big to preview\n    </p>\n    <!-- /ko -->\n\n    <!-- ko ifnot: isFuncOversized -->\n    <list-details class=\"greedy\"\n        params=\"\n            loading: !isZipLoaded(),\n            rows: rows,\n            selected: ko.pc(selectedFile, onSelectFile, $component),\n            buttonLabel: 'Display Content'\n        \"\n    >\n        <template name =\"details\">\n            <div class=\"column greedy no-wrap\" ko.visible=\"$itemId\">\n                <div class=\"row content-middle hpad\">\n                    <h2 class=\"heading3 greedy push-next\">{{$itemId}}</h2>\n                    <button class=\"icon-btn\"\n                        ko.click=\"onX\"\n                    >\n                        <svg-icon class=\"icon-small\" params=\"name: 'x'\"></svg-icon>\n                    </button>\n                </div>\n                <hr />\n                <loading-indicator class=\"align-middle push-prev-half\"\n                    ko.visible=\"isFileContentLoading\"\n                ></loading-indicator>\n\n                <code-viewer class=\"greedy\"\n                    ko.visible=\"fileContent\"\n                    params=\"lang: fileLang, code: fileContent\"\n                ></code-viewer>\n            </div>\n        </template>\n    </list-details>\n    <hr>\n    <paginator params=\"\n        page: ko.pc(page, onPage, $component),\n        pageSize: ko.pc(pageSize, onPageSize, $component),\n        itemCount: fileCount\n    \"></paginator>\n    <!-- /ko -->\n</div>\n\n<div class=\"fill row\" ko.visible=\"isZipStale\">\n    <div class=\"fill stale-backdrop\"></div>\n    <p class=\"heading1 align-middle text-center greedy\">\n        This function was updated by another account\n        <br>\n        <button class=\"btn alt-colors\"\n            ko.click=\"onRefresh\"\n        >\n            Refresh\n        </button>\n    </p>\n</div>\n";

},{}],456:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _funcCodeForm = _interopRequireDefault(require("./func-code-form.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _stringUtils = require("utils/string-utils");

var _browserUtils = require("utils/browser-utils");

var _promiseUtils = require("utils/promise-utils");

var _funcUtils = require("utils/func-utils");

var _sizeUtils = require("utils/size-utils");

var _services = require("services");

var _jszip = _interopRequireDefault(require("jszip"));

var _config = require("config");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
async function _loadZip(handle) {
  const buffer = _services.bufferStore.get(handle);

  const zip = await _jszip.default.loadAsync(buffer);
  return zip;
}

class FuncCodeFormViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "funcSizeLimit", (0, _sizeUtils.formatSize)(_funcUtils.funcSizeLimit));
    (0, _defineProperty2.default)(this, "pathname", '');
    (0, _defineProperty2.default)(this, "funcName", '');
    (0, _defineProperty2.default)(this, "funcVersion", '');
    (0, _defineProperty2.default)(this, "areActionsEnabled", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "zip", null);
    (0, _defineProperty2.default)(this, "isFuncOversized", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isZipLoaded", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isZipStale", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "fileCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "formattedFileCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "execFile", {
      text: _knockout.default.observable(),
      align: 'start'
    });
    (0, _defineProperty2.default)(this, "execFunc", {
      text: _knockout.default.observable(),
      align: 'start'
    });
    (0, _defineProperty2.default)(this, "page", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "pageSize", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "selectedFile", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "rows", _knockout.default.observableArray());
    (0, _defineProperty2.default)(this, "fileLang", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "fileContent", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isFileContentLoading", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "_loadSelectedFileContent", (0, _coreUtils.throttle)(async () => {
      const {
        selectedFile,
        zip
      } = this;

      if (!zip || !selectedFile()) {
        return;
      }

      const [fileContent] = await (0, _promiseUtils.all)(zip.files[selectedFile()].async('string'), (0, _promiseUtils.sleep)(750));

      _knockout.default.assignToProps(this, {
        fileContent,
        isFileContentLoading: false
      });
    }, _config.inputThrottle, this));
  }

  selectState(state, params) {
    const {
      funcName,
      funcVersion
    } = params;
    const id = `${funcName}:${funcVersion}`;
    const {
      functions,
      location,
      session
    } = state;
    const func = functions && functions[id];
    return [funcName, funcVersion, func, location, session && session.user];
  }

  async mapStateToProps(name, version, func, location, user) {
    if (!func) {
      _knockout.default.assignToProps(this, {
        funcName: name,
        funcVersion: version,
        areActionsEnabled: false,
        isFuncOversized: false,
        isZipLoaded: false,
        isZipStale: false,
        formattedFileCount: '',
        execFile: {
          text: ''
        },
        execFunc: {
          text: ''
        }
      });
    } else if (func.codeSize > _funcUtils.funcSizeLimit) {
      const {
        execFile,
        execFunc
      } = func;

      _knockout.default.assignToProps(this, {
        funcName: name,
        funcVersion: version,
        areActionsEnabled: true,
        isFuncOversized: true,
        formattedFileCount: '',
        execFile: {
          text: execFile
        },
        execFunc: {
          text: execFunc
        }
      });
    } else {
      const {
        pathname,
        query
      } = location;
      const {
        execFile,
        execFunc,
        codeBuffer,
        lastModifier
      } = func;
      const {
        loading,
        error,
        handle
      } = codeBuffer;

      if (!handle) {
        const modifiedByOtherAccount = lastModifier !== user;
        const zip = modifiedByOtherAccount ? this.zip : null;

        _knockout.default.assignToProps(this, {
          funcName: name,
          funcVersion: version,
          areActionsEnabled: false,
          isFuncOversized: false,
          isZipLoaded: Boolean(zip),
          isZipStale: Boolean(zip),
          zip: zip,
          fileList: [],
          formattedFileCount: '',
          execFile: {
            text: execFile
          },
          execFunc: {
            text: execFunc
          }
        });
      } else {
        let zip = this.zip || (await _loadZip(handle));
        const page = Number(query.page) || 0;

        const pageSize = Number(query.pageSize) || _config.paginationPageSize.default;

        const fileNames = Object.values(zip.files).filter(zipObj => !zipObj.dir).map(zipObj => zipObj.name).sort();
        const fileCount = fileNames.length;
        const formattedFileCount = (0, _stringUtils.stringifyAmount)('file', fileCount);
        const pageStart = page * pageSize;
        const rows = fileNames.slice(pageStart, pageStart + pageSize);
        const selectedFile = query.selected && fileNames.includes(query.selected) ? query.selected : '';
        const [, fileLang = 'none'] = selectedFile.split(/\.(\w+)$/);
        const selectedFileChanged = this.selectedFile() !== selectedFile;
        const fileContent = selectedFileChanged ? '' : this.fileContent();
        const isFileContentLoading = selectedFile && !fileContent;

        _knockout.default.assignToProps(this, {
          funcName: name,
          funcVersion: version,
          areActionsEnabled: true,
          isZipLoaded: true,
          isZipStale: false,
          pathname,
          execFile: {
            text: execFile
          },
          execFunc: {
            text: execFunc
          },
          zip,
          fileCount,
          formattedFileCount,
          page,
          pageSize,
          selectedFile,
          rows,
          fileContent,
          fileLang,
          isFileContentLoading
        });

        if (selectedFileChanged) {
          this._loadSelectedFileContent();
        }
      }

      if (!this.zip && !error && !loading) {
        this.dispatch((0, _actionCreators.loadLambdaFuncCode)(name, version));
      }
    }
  }

  onDownloadCode() {}

  onEditCode() {
    const {
      funcName,
      funcVersion
    } = this;
    this.dispatch((0, _actionCreators.openEditFuncCodeModal)(funcName, funcVersion));
  }

  onSetEventAndInvoke() {
    const {
      funcName,
      funcVersion
    } = this;
    this.dispatch((0, _actionCreators.openInvokeFuncModal)(funcName, funcVersion));
  }

  onRefresh() {
    _knockout.default.assignToProps(this, {
      zip: null
    });

    this._query({
      page: 0,
      selected: ''
    });
  }

  onSelectFile(filename = '') {
    this._query({
      selected: filename
    });
  }

  onPage(page) {
    this._query({
      page,
      selected: ''
    });
  }

  onPageSize(pageSize) {
    this._query({
      pageSize,
      page: 0,
      selected: ''
    });
  }

  onX() {
    this._query({
      selected: ''
    });
  }

  _query(query) {
    const {
      page = this.page(),
      selected = this.selectedFile()
    } = query;
    const url = (0, _browserUtils.realizeUri)(this.pathname, null, {
      page,
      selected: selected || undefined
    });
    this.dispatch((0, _actionCreators.requestLocation)(url, true));
  }

  dispose() {
    const {
      funcName,
      funcVersion
    } = this;
    this.dispatch((0, _actionCreators.dropLambdaFuncCode)(funcName, funcVersion));
  }

}

var _default = {
  viewModel: FuncCodeFormViewModel,
  template: _funcCodeForm.default
};
exports.default = _default;

},{"./func-code-form.html":455,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"config":831,"jszip":"jszip","knockout":"knockout","services":1013,"utils/browser-utils":1021,"utils/core-utils":1027,"utils/func-utils":1031,"utils/promise-utils":1039,"utils/size-utils":1043,"utils/string-utils":1046}],457:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"row content-middle card-shadow pad\">\n    <h2 class=\"heading3 greedy\">\n        {{funcName}} Current Configuration\n    </h2>\n    <button class=\"btn\"\n        ko.enable=\"dataReady\"\n        ko.click=\"onEditConfiguration\"\n    >\n        Edit Configuration\n    </button>\n</div>\n\n<property-sheet class=\"pad\" params=\"\n    loading: !dataReady(),\n    properties: funcConfig\n\">\n    <template name=\"desc\">\n        <p class=\"preserve-whitespaces\" ko.text=\"$data\"></p>\n    </template>\n</property-sheet>\n";

},{}],458:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _funcConfigForm = _interopRequireDefault(require("./func-config-form.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _stringUtils = require("utils/string-utils");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
class FuncConfigFormViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "funcName", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "funcVersion", '');
    (0, _defineProperty2.default)(this, "funcConfig", [{
      label: 'Runtime',
      value: _knockout.default.observable()
    }, {
      label: 'Memory Size',
      value: _knockout.default.observable()
    }, {
      label: 'Timeout',
      value: _knockout.default.observable()
    }, {
      label: 'Description',
      template: 'desc',
      value: _knockout.default.observable()
    }]);
  }

  selectState(state, params) {
    const {
      functions
    } = state;
    const {
      funcName,
      funcVersion
    } = params;
    const id = `${funcName}:${funcVersion}`;
    return [funcName, functions && functions[id]];
  }

  mapStateToProps(funcName, func) {
    if (!func) {
      _knockout.default.assignToProps(this, {
        dataReady: false,
        funcName
      });
    } else {
      _knockout.default.assignToProps(this, {
        dataReady: true,
        funcName,
        funcVersion: func.version,
        funcConfig: [{
          value: func.runtime
        }, {
          value: `${func.memorySize}MB`
        }, {
          value: (0, _stringUtils.stringifyAmount)('second', func.timeout)
        }, {
          value: func.description
        }]
      });
    }
  }

  onEditConfiguration() {
    this.dispatch((0, _actionCreators.openEditFuncConfigModal)(this.funcName(), this.funcVersion));
  }

}

var _default = {
  viewModel: FuncConfigFormViewModel,
  template: _funcConfigForm.default
};
exports.default = _default;

},{"./func-config-form.html":457,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout","utils/string-utils":1046}],459:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"row content-middle pad card-shadow\">\n    <h2 class=\"heading3 greedy push-next\">\n        Function Statistics\n    </h2>\n    <toggle-group params=\"\n        options: durationOptions,\n        selected: ko.pc(selectedDuration, onDuration, $component)\n    \"></toggle-group>\n</div>\n\n<div class=\"charts greedy push-both-half auto-overflow\">\n    <section class=\"column pad\">\n        <h3 class=\"heading3\">\n            Request and Error Count Over Time\n        </h3>\n        <div class=\"row push-both\">\n            <counter class=\"push-next\" params=\"\n                label: 'Total Successes',\n                color: 'rgb(var(--color27))',\n                value: totalFulfilled,\n                format: 'number'\n            \"></counter>\n            <counter class=\"push-prev\" params=\"\n                label: 'Total Errors',\n                color: 'rgb(var(--color31))',\n                value: totalRejected,\n                format: 'number'\n            \"></counter>\n        </div>\n        <chartjs class=\"push-prev\" params=\"\n            type: 'bar',\n            options: invocationsChart.options,\n            data: invocationsChart.data\n        \"></chartjs>\n    </section>\n    <hr class=\"push-both\" />\n    <section class=\"column pad\">\n        <h3 class=\"heading3\">\n            Response Time\n        </h3>\n        <div class=\"row push-both\">\n            <div class=\"row content-middle greedy\">\n                <counter class=\"push-next\" params=\"\n                    label: 'Precentile',\n                    color: 'rgb(var(--color20))',\n                    value: '99th',\n                    tween: false\n                \"></counter>\n                <counter class=\"push-both\" params=\"\n                    label: 'Precentile',\n                    color: 'rgb(var(--color28))',\n                    value: '90th',\n                    tween: false\n                \"></counter>\n                <counter class=\"push-prev\" params=\"\n                    label: 'Precentile',\n                    color: 'rgb(var(--color17))',\n                    value: '50th',\n                    tween: false\n                \"></counter>\n            </div>\n             <div class=\"row content-middle\">\n                <counter class=\"push-next\" params=\"\n                    label: 'Max Response Time',\n                    format: formatMiliseconds,\n                    value: maxResponseTime\n                \"></counter>\n                <counter class=\"push-prev\" params=\"\n                    label: 'Avg Response Time',\n                    format: formatMiliseconds,\n                    value: avgResponseTime\n                \"></counter>\n            </div>\n        </div>\n        <chartjs class=\"push-prev\" params=\"\n            type: 'line',\n            options: responseTimeChart.options,\n            data: responseTimeChart.data\n        \"></chartjs>\n    </section>\n</div>\n";

},{}],460:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _funcMonitoringForm = _interopRequireDefault(require("./func-monitoring-form.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _moment = _interopRequireDefault(require("moment"));

var _numeral = _interopRequireDefault(require("numeral"));

var _coreUtils = require("utils/core-utils");

var _browserUtils = require("utils/browser-utils");

var _colorUtils = require("utils/color-utils");

var _themes = _interopRequireDefault(require("themes"));

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const durationMeta = (0, _coreUtils.deepFreeze)({
  '60_MIN': {
    label: '60 Minutes',
    unit: 'minute',
    span: 60,
    step: 5,
    tickFormat: 'HH:mm'
  },
  '24_HOURS': {
    label: '24 Hours',
    unit: 'hours',
    span: 24,
    step: 2,
    tickFormat: 'HH:mm'
  },
  '7_DAYS': {
    label: '7 Days',
    unit: 'day',
    span: 7,
    step: 1,
    tickFormat: 'DD/MM'
  },
  '30_DAYS': {
    label: '30 days',
    unit: 'day',
    span: 30,
    step: 3,
    tickFormat: 'DD/MM'
  }
});

function _formatMiliseconds(t) {
  return `${(0, _numeral.default)(t).format(',')} ms`;
}

function _reduceDataSets(slices) {
  return slices.reduce((ds, slice) => {
    ds.pre50.push(slice.responsePercentiles[0].value);
    ds.pre90.push(slice.responsePercentiles[1].value);
    ds.pre99.push(slice.responsePercentiles[2].value);
    ds.fulfilled.push(slice.fulfilled);
    ds.rejected.push(slice.rejected);
    return ds;
  }, {
    pre99: [],
    pre90: [],
    pre50: [],
    fulfilled: [],
    rejected: []
  });
}

class FuncMonitoringFormViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "formatMiliseconds", _formatMiliseconds);
    (0, _defineProperty2.default)(this, "pathname", '');
    (0, _defineProperty2.default)(this, "fetchKey", ['', '', '', 0]);
    (0, _defineProperty2.default)(this, "durationOptions", Object.entries(durationMeta).map(pair => ({
      label: pair[1].label,
      value: pair[0]
    })));
    (0, _defineProperty2.default)(this, "selectedDuration", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "maxResponseTime", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "avgResponseTime", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "responseTimeChart", {
      options: {
        scales: {
          yAxes: [{
            scaleLabel: {
              display: true,
              labelString: 'Miliseconds'
            },
            ticks: {
              suggestedMax: 1000,
              // Using space for visual padding.
              callback: tick => {
                const text = (0, _numeral.default)(tick).format(',');
                return `${text}${' '.repeat(5)}`;
              }
            }
          }],
          xAxes: [{
            gridLines: {
              display: false
            }
          }]
        },
        tooltips: {
          position: 'nearest',
          callbacks: {
            label: item => {
              const value = _formatMiliseconds(item.yLabel);

              const label = item.datasetIndex === 0 && '99th' || item.datasetIndex === 1 && '90th' || item.datasetIndex === 2 && '50th';
              return `${label} Precentile: ${value}`;
            }
          }
        }
      },
      data: _knockout.default.observable()
    });
    (0, _defineProperty2.default)(this, "totalFulfilled", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "totalRejected", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "invocationsChart", {
      options: {
        scales: {
          yAxes: [{
            stacked: true,
            scaleLabel: {
              display: true,
              labelString: 'Invocations'
            },
            ticks: {
              suggestedMax: 100,
              // Using space for visual padding.
              callback: tick => {
                const text = (0, _numeral.default)(tick).format(',');
                return `${text}${' '.repeat(5)}`;
              }
            }
          }],
          xAxes: [{
            stacked: true,
            gridLines: {
              display: false
            }
          }]
        },
        tooltips: {
          position: 'nearest',
          mode: 'x',
          callbacks: {
            label: item => {
              const value = (0, _numeral.default)(item.yLabel).format(',');
              const label = item.datasetIndex === 0 && 'Success' || item.datasetIndex === 1 && 'Errors';
              return `${label}: ${value}`;
            }
          }
        }
      },
      data: _knockout.default.observable()
    });
  }

  selectState(state, params) {
    const {
      funcName,
      funcVersion
    } = params;
    const {
      lambdaUsageHistory,
      location,
      session
    } = state;
    return [funcName, funcVersion, lambdaUsageHistory.data, location, _themes.default[session.uiTheme]];
  }

  mapStateToProps(funcName, funcVersion, usageHistory, location, theme) {
    const {
      pathname,
      query,
      refreshCount
    } = location;
    const selectedDuration = query.duration || this.durationOptions[0].value;
    const fetchKey = [funcName, funcVersion, selectedDuration, refreshCount];

    if (!(0, _coreUtils.equalItems)(fetchKey, this.fetchKey)) {
      this.fetchUsageHistory(...fetchKey);
    }

    if (!usageHistory) {
      _knockout.default.assignToProps(this, {
        dataReady: false,
        fetchKey,
        pathname,
        selectedDuration
      });
    } else {
      const {
        tickFormat
      } = durationMeta[selectedDuration];
      const {
        stats,
        slices
      } = usageHistory;

      const datasets = _reduceDataSets(slices);

      const commonLineDatasetSettings = {
        pointRadius: 3,
        pointBorderWidth: 4,
        pointHitRadius: 10,
        pointBorderColor: (0, _colorUtils.colorToRgb)(...(0, _colorUtils.rgbToColor)(theme.color11), .2),
        pointHoverBorderColor: 'transparent',
        borderJoinStyle: 'round',
        lineTension: 0,
        fill: false,
        backgroundColor: 'transparent'
      };

      _knockout.default.assignToProps(this, {
        dataReady: false,
        fetchKey,
        pathname,
        selectedDuration,
        maxResponseTime: stats.maxResponseTime,
        avgResponseTime: stats.invoked > 0 ? Math.round(stats.aggrResponseTime / stats.invoked) : 0,
        responseTimeChart: {
          data: {
            labels: slices.map(slice => (0, _moment.default)(slice.since).format(tickFormat)),
            datasets: [{ ...commonLineDatasetSettings,
              pointBackgroundColor: theme.color20,
              borderColor: theme.color20,
              data: datasets.pre99
            }, { ...commonLineDatasetSettings,
              pointBackgroundColor: theme.color28,
              borderColor: theme.color28,
              data: datasets.pre90
            }, { ...commonLineDatasetSettings,
              pointBackgroundColor: theme.color17,
              borderColor: theme.color17,
              data: datasets.pre50
            }]
          }
        },
        totalFulfilled: stats.fulfilled,
        totalRejected: stats.rejected,
        invocationsChart: {
          data: {
            labels: slices.map(slice => `${(0, _moment.default)(slice.since).format(tickFormat)} - ${(0, _moment.default)(slice.till).format(tickFormat)}`),
            datasets: [{
              backgroundColor: theme.color27,
              data: datasets.fulfilled
            }, {
              backgroundColor: theme.color31,
              data: datasets.rejected
            }]
          }
        }
      });
    }
  }

  fetchUsageHistory(name, version, duration) {
    if (!name || !version || !duration) {
      return;
    }

    const {
      unit,
      span,
      step
    } = durationMeta[duration];
    this.dispatch((0, _actionCreators.fetchLambdaFuncUsageHistory)(name, version, _moment.default.duration(span - step, unit).asMilliseconds(), _moment.default.duration(step, unit).asMilliseconds()));
  }

  onDuration(duration) {
    this.dispatch((0, _actionCreators.requestLocation)((0, _browserUtils.realizeUri)(this.pathname, null, {
      duration
    })));
  }

  dispose() {
    this.dispatch((0, _actionCreators.dropLambdaFuncUsageHistory)());
    super.dispose();
  }

}

var _default = {
  viewModel: FuncMonitoringFormViewModel,
  template: _funcMonitoringForm.default
};
exports.default = _default;

},{"./func-monitoring-form.html":459,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout","moment":"moment","numeral":"numeral","themes":1018,"utils/browser-utils":1021,"utils/color-utils":1026,"utils/core-utils":1027}],461:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<func-summary class=\"push-next\" params=\"\n    funcName: funcName,\n    funcVersion: funcVersion\n\"></func-summary>\n\n<div class=\"tabs greedy\">\n    <nav>\n        <a ko.css.selected=\"selectedTab.eq('monitoring')\"\n            ko.attr.href=\"tabHref('monitoring')\"\n        >\n            Monitoring\n        </a>\n\n        <a ko.css.selected=\"selectedTab.eq('code')\"\n            ko.attr.href=\"tabHref('code')\"\n        >\n            Code\n        </a>\n\n        <a ko.css.selected=\"selectedTab.eq('config')\"\n            ko.attr.href=\"tabHref('config')\"\n        >\n            Configuration\n        </a>\n\n        <a ko.css.selected=\"selectedTab.eq('triggers')\"\n            ko.attr.href=\"tabHref('triggers')\"\n        >\n            Triggers\n        </a>\n    </nav>\n\n    <div class=\"tabs-row\">\n        <func-monitoring-form class=\"tab column greedy\"\n            ko.css.selected=\"selectedTab.eq('monitoring')\"\n            params=\"\n                funcName: funcName,\n                funcVersion: funcVersion\n            \"\n        ></func-monitoring-form>\n\n        <func-code-form class=\"tab column greedy\"\n            ko.css.selected=\"selectedTab.eq('code')\"\n            params=\"\n                funcName: funcName,\n                funcVersion: funcVersion\n            \"\n        ></func-code-form>\n\n        <func-config-form class=\"tab\"\n            ko.css.selected=\"selectedTab.eq('config')\"\n            params=\"\n                funcName: funcName,\n                funcVersion: funcVersion\n            \"\n        ></func-config-form>\n\n        <func-triggers-form class=\"tab column greedy\"\n            ko.css.selected=\"selectedTab.eq('triggers')\"\n            params=\"\n                funcName: funcName,\n                funcVersion: funcVersion\n            \"\n        ></func-triggers-form>\n    </div>\n</div>\n";

},{}],462:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _funcPanel = _interopRequireDefault(require("./func-panel.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _browserUtils = require("utils/browser-utils");

/* Copyright (C) 2016 NooBaa */
class FuncPanelViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "baseRoute", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "selectedTab", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "funcName", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "funcVersion", _knockout.default.observable());
  }

  selectState(state) {
    return [state.location];
  }

  mapStateToProps(location) {
    const {
      route,
      params
    } = location;
    const {
      system,
      func,
      tab = 'monitoring'
    } = params;

    _knockout.default.assignToProps(this, {
      baseRoute: (0, _browserUtils.realizeUri)(route, {
        system,
        func
      }, {}, true),
      selectedTab: tab,
      funcName: func,
      funcVersion: '$LATEST'
    });
  }

  tabHref(tab) {
    return this.baseRoute() ? (0, _browserUtils.realizeUri)(this.baseRoute(), {
      tab
    }) : '';
  }

}

var _default = {
  viewModel: FuncPanelViewModel,
  template: _funcPanel.default
};
exports.default = _default;

},{"./func-panel.html":461,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"components/connectable":446,"knockout":"knockout","utils/browser-utils":1021}],463:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"fill row\" ko.visible=\"!dataReady()\">\n    <loading-indicator class=\"align-middle greedy\" params=\"label: true\"></loading-indicator>\n</div>\n\n<div class=\"summary greedy row\" ko.css.visible=\"dataReady\">\n\n    <section class=\"c6 column card push-next-half\">\n        <div class=\"greedy hpad row content-middle\">\n            <svg-icon class=\"push-next\"\n                ko.css=\"state.css\"\n                params=\"name: state.icon\"\n            ></svg-icon>\n            <span class=\"heading3\">{{state.text}}</span>\n        </div>\n        <hr />\n        <div class=\"greedy hpad row content-middle\">\n            <span class=\"c6 highlight push-next\">{{name}}</span>\n            <span class=\"c6 text-right\">\n                <span ko.tooltip=\"descTooltip\">\n                    {{descText}}\n                </span>\n            </span>\n        </div>\n        <hr />\n        <div class=\"greedy hpad row content-middle\" >\n            <span class=\"c6 highlight push-next\">Last Modified:</span>\n            <span class=\"c6 text-right\">{{lastModified}}</span>\n        </div>\n    </section>\n\n    <section class=\"c6 column card push-prev-half\">\n        <div class=\"greedy hpad row content-middle\">\n            <span class=\"c6 highlight push-next\">Runtime:</span>\n            <span class=\"c6 text-right\">{{runtime}}</span>\n        </div>\n        <hr />\n        <div class=\"greedy hpad row content-middle\">\n            <span class=\"c6 highlight push-next\">Code Size (Zip):</span>\n            <span class=\"c6 text-right\">{{codeSize}}</span>\n        </div>\n        <hr />\n        <div class=\"greedy hpad row content-middle\">\n            <span class=\"c6 highlight push-next\">Memory Size:</span>\n            <span class=\"c6 text-right\">{{memorySize}}</span>\n        </div>\n    </section>\n</div>\n";

},{}],464:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _funcSummary = _interopRequireDefault(require("./func-summary.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _sizeUtils = require("utils/size-utils");

var _moment = _interopRequireDefault(require("moment"));

var _config = require("config");

/* Copyright (C) 2016 NooBaa */
function _getDescText(description) {
  const descText = description.trim().split('\n')[0].slice(0, 30);
  return descText === description ? descText : `${descText}...`;
}

function _getDescTooltip(description) {
  if (description.length <= 30 && !description.includes('\n')) {
    return '';
  }

  return {
    template: 'preserveWhitespaces',
    text: description
  };
}

class FuncSummaryViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "state", {
      text: 'Deployed',
      css: 'success',
      icon: 'healthy'
    });
    (0, _defineProperty2.default)(this, "name", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "descText", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "descTooltip", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "lastModified", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "runtime", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "codeSize", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "memorySize", _knockout.default.observable());
  }

  selectState(state, params) {
    const {
      functions
    } = state;
    const {
      funcName,
      funcVersion
    } = params;
    const id = `${funcName}:${funcVersion}`;
    return [funcName, functions && functions[id]];
  }

  mapStateToProps(funcName, func) {
    if (!func) {
      _knockout.default.assignToProps(this, {
        dataReady: false
      });
    } else {
      _knockout.default.assignToProps(this, {
        dataReady: true,
        name: funcName,
        descText: _getDescText(func.description),
        descTooltip: _getDescTooltip(func.description),
        lastModified: (0, _moment.default)(func.lastModified).format(_config.timeShortFormat),
        runtime: func.runtime,
        codeSize: (0, _sizeUtils.formatSize)(func.codeSize),
        memorySize: `${func.memorySize}MB`
      });
    }
  }

}

var _default = {
  viewModel: FuncSummaryViewModel,
  template: _funcSummary.default
};
exports.default = _default;

},{"./func-summary.html":463,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"components/connectable":446,"config":831,"knockout":"knockout","moment":"moment","utils/size-utils":1043}],465:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"row card-shadow pad content-middle\">\n    <div class=\"column greedy push-next\">\n        <h3 class=\"heading3\">\n            Function Triggers: {{triggerCount}}\n        </h3>\n    </div>\n    <button class=\"btn\" ko.click=\"onAddTrigger\">\n        Add Trigger\n    </button>\n</div>\n\n<data-table class=\"functions-table greedy\" params=\"\n    columns: columns,\n    sorting: ko.pc(sorting, onSort, $component),\n    data: rows,\n    loading: !dataReady(),\n    emptyMessage: 'No triggers configured for this function'\n\"></data-table>\n\n<paginator params=\"\n    itemCount: triggerCount,\n    pageSize: ko.pc(pageSize, onPageSize, $component),\n    page: ko.pc(page, onPage, $component)\n\"></paginator>\n\n\n";

},{}],466:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _knockout = _interopRequireDefault(require("knockout"));

var _moment = _interopRequireDefault(require("moment"));

var _numeral = _interopRequireDefault(require("numeral"));

var _funcTriggersForm = _interopRequireDefault(require("./func-triggers-form.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _coreUtils = require("utils/core-utils");

var _browserUtils = require("utils/browser-utils");

var _config = require("config");

var _actionCreators = require("action-creators");

var routes = _interopRequireWildcard(require("routes"));

/* Copyright (C) 2016 NooBaa */
const modeToStatus = (0, _coreUtils.deepFreeze)({
  DISABLED: {
    name: 'healthy',
    css: 'disabled',
    tooltip: 'Disabled'
  },
  MISSING_PERMISSIONS: {
    name: 'problem',
    css: 'warning',
    tooltip: 'Access issue'
  },
  OPTIMAL: {
    name: 'healthy',
    css: 'success',
    tooltip: 'Healthy'
  }
});
const bucketTypeMeta = (0, _coreUtils.deepFreeze)({
  DATA_BUCKET: {
    displayName: 'Data',
    route: routes.bucket
  },
  NAMESPACE_BUCKET: {
    displayName: 'Namespace',
    route: routes.namespaceBucket
  }
});
const columns = (0, _coreUtils.deepFreeze)([{
  name: 'state',
  type: 'icon',
  sortable: true,
  compareKey: trigger => trigger.enabled
}, {
  name: 'bucketName',
  label: 'Bucket Name',
  type: 'link',
  sortable: true,
  compareKey: trigger => trigger.bucketName
}, {
  name: 'bucketType',
  label: 'Bucket Type'
}, {
  name: 'event',
  label: 'Event Type',
  sortable: true,
  compareKey: trigger => trigger.event
}, {
  name: 'prefix',
  sortable: true,
  compareKey: trigger => trigger.prefix
}, {
  name: 'suffix',
  sortable: true,
  compareKey: trigger => trigger.suffix
}, {
  name: 'lastRun',
  label: 'Last Run',
  sortable: true,
  compareKey: trigger => trigger.lastRun || 0
}, {
  name: 'edit',
  label: '',
  type: 'iconButton'
}, {
  name: 'delete',
  label: '',
  type: 'delete'
}]);

class BucketRowViewModel {
  constructor({
    table
  }) {
    (0, _defineProperty2.default)(this, "table", null);
    (0, _defineProperty2.default)(this, "state", {
      name: _knockout.default.observable(),
      css: _knockout.default.observable(),
      tooltip: _knockout.default.observable()
    });
    (0, _defineProperty2.default)(this, "bucketName", {
      text: _knockout.default.observable(),
      href: _knockout.default.observable()
    });
    (0, _defineProperty2.default)(this, "bucketType", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "event", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "prefix", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "suffix", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "lastRun", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "edit", {
      id: _knockout.default.observable(),
      icon: 'edit',
      tooltip: 'Edit Trigger',
      onClick: triggerId => this.table.onEditTrigger(triggerId, this.bucketName.text())
    });
    (0, _defineProperty2.default)(this, "delete", {
      text: 'Delete Trigger',
      active: _knockout.default.observable(),
      id: _knockout.default.observable(),
      onToggle: triggerId => this.table.onSelectForDelete(triggerId),
      onDelete: triggerId => this.table.onDeleteTrigger(triggerId, this.bucketName.text())
    });
    this.table = table;
  }

}

function _getLastRunText(trigger) {
  const {
    lastRun
  } = trigger;
  return lastRun ? (0, _moment.default)(lastRun).fromNow() : '(never run)';
}

class FuncTriggersFormViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "funcId", '');
    (0, _defineProperty2.default)(this, "triggerCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "sorting", _knockout.default.observable({}));
    (0, _defineProperty2.default)(this, "rows", _knockout.default.observableArray().ofType(BucketRowViewModel, {
      table: this
    }));
    (0, _defineProperty2.default)(this, "page", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "pageSize", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "selectedForDelete", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "pathname", '');
    (0, _defineProperty2.default)(this, "columns", columns);
  }

  selectState(state, params) {
    const {
      functions,
      bucketTriggers
    } = state;
    const id = `${params.funcName}:${params.funcVersion}`;
    return [state.location, functions && functions[id], bucketTriggers];
  }

  mapStateToProps(location, func, triggers) {
    if (!func || !triggers) {
      _knockout.default.assignToProps(this, {
        dataReady: false
      });
    } else {
      const {
        query,
        params,
        pathname
      } = location;
      const {
        sortBy = 'bucketName',
        selectedForDelete
      } = query;
      const page = Number(query.page) || 0;

      const pageSize = Number(query.pageSize) || _config.paginationPageSize.default;

      const order = Number(query.order) || 1;
      const {
        compareKey
      } = columns.find(column => column.name === sortBy);
      const pageStart = page * pageSize;
      const rows = Object.values(triggers).filter(trigger => trigger.func.name === func.name && trigger.func.version === func.version).sort((0, _coreUtils.createCompareFunc)(compareKey, order)).slice(pageStart, pageStart + pageSize).map(trigger => {
        const {
          name: bucketName,
          kind: bucketType
        } = trigger.bucket;
        const {
          displayName: bucketTypeDisplay,
          route
        } = bucketTypeMeta[bucketType];
        return {
          state: modeToStatus[trigger.mode],
          bucketName: {
            text: bucketName,
            href: (0, _browserUtils.realizeUri)(route, {
              system: params.system,
              bucket: bucketName
            })
          },
          bucketType: bucketTypeDisplay,
          event: trigger.event,
          prefix: trigger.prefix || '(not set)',
          suffix: trigger.suffix || '(not set)',
          lastRun: _getLastRunText(trigger),
          delete: {
            id: trigger.id,
            active: selectedForDelete === trigger.id
          },
          edit: {
            id: trigger.id
          }
        };
      });

      _knockout.default.assignToProps(this, {
        dataReady: true,
        funcId: `${func.name}:${func.version}`,
        pathname,
        page,
        pageSize,
        sorting: {
          sortBy,
          order
        },
        selectedForDelete,
        triggerCount: (0, _numeral.default)(rows.length).format(','),
        rows
      });
    }
  }

  onSort(sorting) {
    this._query({ ...sorting,
      page: 0,
      selectedForDelete: null
    });
  }

  onPage(page) {
    this._query({
      page,
      selectedForDelete: null
    });
  }

  onPageSize(pageSize) {
    this._query({
      pageSize,
      page: 0,
      selectedForDelete: null
    });
  }

  onAddTrigger() {
    this.dispatch((0, _actionCreators.openAddBucketTriggerModal)(null, this.funcId));
  }

  onEditTrigger(triggerId) {
    this.dispatch((0, _actionCreators.openEditBucketTriggerModal)('FUNCTION', triggerId));
  }

  onSelectForDelete(triggerId) {
    this._query({
      selectedForDelete: triggerId
    });
  }

  onDeleteTrigger(triggerId, bucketName) {
    this.dispatch((0, _actionCreators.removeBucketTrigger)(bucketName, triggerId));
  }

  _query(params) {
    const {
      sortBy = this.sorting().sortBy,
      order = this.sorting().order,
      page = this.page(),
      pageSize = this.pageSize(),
      selectedForDelete = this.selectedForDelete()
    } = params;
    const query = {
      sortBy,
      order,
      page,
      pageSize,
      selectedForDelete: selectedForDelete || undefined
    };
    const url = (0, _browserUtils.realizeUri)(this.pathname, {}, query);
    this.dispatch((0, _actionCreators.requestLocation)(url));
  }

}

var _default = {
  viewModel: FuncTriggersFormViewModel,
  template: _funcTriggersForm.default
};
exports.default = _default;

},{"./func-triggers-form.html":465,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"components/connectable":446,"config":831,"knockout":"knockout","moment":"moment","numeral":"numeral","routes":972,"utils/browser-utils":1021,"utils/core-utils":1027}],467:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<section class=\"column greedy tabs\">\n    <nav>\n        <a class=\"selected\">\n            Restless Functions\n        </a>\n    </nav>\n    <div class=\"tabs-row\">\n        <funcs-table class=\"tab selected\"></funcs-table>\n    </div>\n</section>\n";

},{}],468:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _funcsPanel = _interopRequireDefault(require("./funcs-panel.html"));

/* Copyright (C) 2016 NooBaa */
var _default = {
  template: _funcsPanel.default
};
exports.default = _default;

},{"./funcs-panel.html":467,"@babel/runtime/helpers/interopRequireDefault":1050}],469:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"row card-shadow pad content-middle\">\n    <div class=\"greedy push-next\">\n        <input type=\"search\"\n            placeholder=\"Filter by function name\"\n            ko.textInput=\"ko.pc(filter, onFilter)\"\n        />\n    </div>\n\n    <button class=\"btn align-end\"\n        ko.click=\"onCreateFunc\"\n        ko.enable=\"dataReady\"\n    >\n        Create Function\n    </button>\n</div>\n\n<data-table class=\"greedy\" params=\"\n    columns: columns,\n    data: rows,\n    sorting: ko.pc(sorting, onSort, $component),\n    loading: !dataReady(),\n    emptyMessage: emptyMessage\n\"></data-table>\n\n<paginator params=\"\n    itemCount: funcCount,\n    pageSize: ko.pc(pageSize, onPageSize, $component),\n    page: ko.pc(page, onPage, $component)\n\"></paginator>\n";

},{}],470:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _funcsTable = _interopRequireDefault(require("./funcs-table.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _moment = _interopRequireDefault(require("moment"));

var _coreUtils = require("utils/core-utils");

var _sizeUtils = require("utils/size-utils");

var _browserUtils = require("utils/browser-utils");

var _stringUtils = require("utils/string-utils");

var routes = _interopRequireWildcard(require("routes"));

var _config = require("config");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const columns = (0, _coreUtils.deepFreeze)([{
  name: 'state',
  type: 'icon',
  sortable: true,
  compareKey: () => true
}, {
  name: 'name',
  label: 'function name',
  type: 'link',
  sortable: true,
  compareKey: func => func.name
}, {
  name: 'description',
  sortable: true,
  compareKey: func => func.description
}, {
  name: 'size',
  sortable: true,
  compareKey: func => func.size
}, {
  name: 'lastModified',
  sortable: true,
  compareKey: func => func.lastModified
}, {
  name: 'deleteButton',
  label: '',
  css: 'delete-col',
  type: 'delete'
}]);

function _mapFunc(func, system, selectedForDelete) {
  const {
    name,
    version,
    description,
    codeSize,
    lastModified
  } = func;
  const id = `${name}:${version}`;
  return {
    name: {
      text: name,
      href: (0, _browserUtils.realizeUri)(routes.func, {
        system,
        func: name
      }),
      tooltip: {
        text: name,
        breakWords: true
      }
    },
    description,
    size: (0, _sizeUtils.formatSize)(codeSize),
    lastModified: (0, _moment.default)(lastModified).format(_config.timeShortFormat),
    deleteButton: {
      id: id,
      active: id === selectedForDelete
    }
  };
}

class FuncRowViewModel {
  constructor({
    table
  }) {
    (0, _defineProperty2.default)(this, "table", null);
    (0, _defineProperty2.default)(this, "state", {
      name: 'healthy',
      css: 'success',
      tooltip: 'Deployed'
    });
    (0, _defineProperty2.default)(this, "name", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "description", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "size", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "lastModified", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "deleteButton", {
      text: 'Delete function',
      tooltip: 'delete function',
      id: _knockout.default.observable(),
      active: _knockout.default.observable(),
      onDelete: id => this.table.onDeleteFunc(id),
      onToggle: id => this.table.onSelectFuncForDelete(id)
    });
    this.table = table;
  }

}

class FuncsTableViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "columns", columns);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "pathname", '');
    (0, _defineProperty2.default)(this, "funcCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "filter", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "sorting", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "page", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "pageSize", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "emptyMessage", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "rows", _knockout.default.observableArray().ofType(FuncRowViewModel, {
      table: this
    }));
    (0, _defineProperty2.default)(this, "onFilter", (0, _coreUtils.throttle)(filter => {
      this._query({
        filter,
        page: 0,
        selectedForDelete: null
      });
    }, _config.inputThrottle));
  }

  selectState(state) {
    return [state.functions, state.location];
  }

  mapStateToProps(funcs, location) {
    if (!funcs) {
      _knockout.default.assignToProps(this, {
        dataReady: false
      });
    } else {
      const {
        pathname,
        params,
        query
      } = location;
      const {
        filter = '',
        sortBy = 'name',
        selectedForDelete = ''
      } = query;
      const order = Number(query.order) || 1;
      const page = Number(query.page) || 0;

      const pageSize = Number(query.pageSize) || _config.paginationPageSize.default;

      const {
        compareKey
      } = columns.find(column => column.name === sortBy);
      const funcList = Object.values(funcs);
      const filtered = funcList.filter(func => (0, _stringUtils.includesIgnoreCase)(func.name, filter));
      const rows = filtered.sort((0, _coreUtils.createCompareFunc)(compareKey, order)).slice(page * pageSize, (page + 1) * pageSize).map(func => _mapFunc(func, params.system, selectedForDelete));
      const emptyMessage = funcList.length === 0 && 'No restless functions configured' || filtered.length === 0 && 'The current filter does not match any function' || '';

      _knockout.default.assignToProps(this, {
        dataReady: true,
        pathname: pathname,
        funcCount: filtered.length,
        filter,
        sorting: {
          sortBy,
          order
        },
        page,
        pageSize,
        emptyMessage,
        rows
      });
    }
  }

  onCreateFunc() {
    this.dispatch((0, _actionCreators.openCreateFuncModal)());
  }

  onSort(sorting) {
    this._query({
      sortBy: sorting.sortBy,
      order: sorting.order,
      page: 0,
      selectedForDelete: null
    });
  }

  onPage(page) {
    this._query({
      page,
      selectedForDelete: null
    });
  }

  onPageSize(pageSize) {
    this._query({
      pageSize,
      page: 0,
      selectedForDelete: null
    });
  }

  onSelectFuncForDelete(id = '') {
    this._query({
      selectedForDelete: id
    });
  }

  onDeleteFunc(id) {
    const [name, version] = id.split(':');
    this.dispatch((0, _actionCreators.deleteLambdaFunc)(name, version));
  }

  _query(query) {
    const {
      filter = this.filter(),
      sortBy = this.sorting().sortBy,
      order = this.sorting().order,
      page = this.page(),
      pageSize = this.pageSize(),
      selectedForDelete = this.selectedForDelete()
    } = query;
    const queryUrl = (0, _browserUtils.realizeUri)(this.pathname, null, {
      filter: filter || undefined,
      sortBy,
      order,
      page,
      pageSize,
      selectedForDelete: selectedForDelete || undefined
    });
    this.dispatch((0, _actionCreators.requestLocation)(queryUrl));
  }

}

var _default = {
  viewModel: FuncsTableViewModel,
  template: _funcsTable.default
};
exports.default = _default;

},{"./funcs-table.html":469,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"components/connectable":446,"config":831,"knockout":"knockout","moment":"moment","routes":972,"utils/browser-utils":1021,"utils/core-utils":1027,"utils/size-utils":1043,"utils/string-utils":1046}],471:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"column\">\n    <section class=\"column push-next\">\n        <div class=\"row pad card-shadow content-middle\">\n            <h3 class=\"heading3 greedy\">Daemon Information</h3>\n            <button class=\"btn push-next\"\n                ko.click=\"onRetrust\"\n                ko.visible=\"isRetrustButtonVisible\"\n            >\n                Set As Trusted\n            </button>\n        </div>\n        <property-sheet class=\"pad deamon-info\" params=\"\n            properties: daemonInfo,\n            loading: !hostLoaded()\n        \">\n            <template name=\"protocol\">\n                <div ko.if=\"$data\">\n                    {{text}}\n                    <span class=\"warning\" ko.visible=\"warning\">\n                        (Not optimized for performance)\n                    </span>\n                </div>\n            </template>\n\n            <template name=\"portRange\">\n                <!-- ko if: $data -->\n                <div class=\"row content-middle\" ko.css.warning=\"warning\">\n                    {{text}}\n                    <svg-icon params=\"name: 'problem'\"\n                        class=\"icon-small push-prev-half\"\n                        ko.visible=\"warning\"\n                        ko.tooltip=\"tooltip\"\n                    ></svg-icon>\n                </div>\n                <!-- /ko -->\n            </template>\n        </property-sheet>\n    </section>\n    <hr>\n    <section class=\"column push-next\">\n        <h3 class=\"heading3 pad card-shadow\">System Information</h3>\n        <property-sheet class=\"pad\" params=\"\n            properties: systemInfo,\n            loading: !hostLoaded()\n        \">\n            <template name=\"cpus\">\n                <div class=\"row content-middle\" ko.if=\"$data\">\n                    <span class=\"push-next-half\" ko.text=\"count\"></span>\n                    <!-- ko if: utilization -->\n                    |\n                    <span class=\"push-both-half\"\n                          ko.css=\"css\"\n                          ko.text=\"utilization\"></span>\n                    <svg-icon class=\"icon-small\"\n                              ko.css=\"css\"\n                              ko.tooltip=\"tooltip\"\n                              params=\"name: 'problem'\"\n                    ></svg-icon>\n                    <!-- /ko -->\n                </div>\n            </template>\n\n            <template name=\"memory\">\n                <div class=\"row content-middle\" ko.if=\"$data\">\n                    <span class=\"push-next-half\" ko.text=\"usage\"></span>\n                    <!-- ko if: utilization -->\n                    |\n                    <span class=\"push-both-half\"\n                        ko.css=\"css\"\n                        ko.text=\"utilization\"\n                    ></span>\n                    <svg-icon class=\"icon-small\"\n                        ko.css=\"css\"\n                        ko.tooltip=\"tooltip\"\n                        params=\"name: 'problem'\"\n                    ></svg-icon>\n                    <!-- /ko -->\n                </div>\n            </template>\n        </property-sheet>\n    </section>\n</div>\n\n\n";

},{}],472:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _hostDetailsForm = _interopRequireDefault(require("./host-details-form.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _coreUtils = require("utils/core-utils");

var _sizeUtils = require("utils/size-utils");

var _hostUtils = require("utils/host-utils");

var _knockout = _interopRequireDefault(require("knockout"));

var _moment = _interopRequireDefault(require("moment"));

var _numeral = _interopRequireDefault(require("numeral"));

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const portsBlockedTooltip = `Some ports might be blocked. Check the firewall settings
    and make sure that the ports range of 60100-60600 is open for inbound traffic.
    These ports are used to communicate between the storage nodes.`;
const errorLevel = 0.95;
const warningLevel = 0.8;

function _getCssByUsage(usage) {
  return true && usage > errorLevel && 'error' || usage > warningLevel && 'warning' || '';
}

function _getTooltipByUsage(subject, used, usedByNoobaa, usedByOther) {
  const usageLevel = used > errorLevel ? 'Very High' : used > warningLevel ? 'High' : '';
  return {
    template: 'listWithCaption',
    text: {
      title: `${usageLevel} ${subject} Pressure`.trim(),
      list: [`NooBaa utilization: ${(0, _numeral.default)(usedByNoobaa).format('%')}`, `Server local utilization: ${(0, _numeral.default)(usedByOther).format('%')}`]
    },
    position: 'after'
  };
}

function _getProtocol({
  protocol
}) {
  const text = protocol === 'UNKNOWN' ? 'Unknown protocol' : protocol;
  const warning = protocol === 'UDP';
  return {
    text,
    warning
  };
}

function _getPortRage({
  mode,
  ports
}) {
  const {
    min,
    max
  } = ports || {};
  const warning = mode === 'N2N_PORTS_BLOCKED';
  const text = ports ? min === max ? min : `${min}-${max}` : 'Initializing';
  const tooltip = portsBlockedTooltip;
  return {
    text,
    warning,
    tooltip
  };
}

function _getServicesString({
  services
}) {
  const {
    storage,
    endpoint
  } = (0, _coreUtils.mapValues)(services, service => service.mode !== 'DECOMMISSIONED');

  if (storage && endpoint) {
    return 'Used for storage and as a S3 endpoint';
  } else if (storage) {
    return 'Used for storage';
  } else if (endpoint) {
    return 'Used as a S3 endpoint';
  } else {
    return 'All services are disabled';
  }
}

function _getMemoryInfo({
  memory,
  mode
}) {
  const usedMemory = memory.usedByNoobaa + memory.usedByOther;
  const totalMemory = usedMemory + memory.free;
  const used = (0, _coreUtils.decimalRound)(usedMemory / totalMemory, 2);
  const usedByNoobaa = (memory.usedByNoobaa / totalMemory).toFixed(2);
  const usedByOther = used - usedByNoobaa;
  const usage = `${(0, _sizeUtils.formatSize)(usedMemory)} of ${(0, _sizeUtils.formatSize)(totalMemory)}`;

  if (mode === 'OFFLINE') {
    const utilization = '';
    return {
      usage,
      utilization
    };
  } else {
    const utilization = `${(0, _numeral.default)(used).format('%')} utilization`;

    const css = _getCssByUsage(used);

    const tooltip = _getTooltipByUsage('Memory', used, usedByNoobaa, usedByOther);

    return {
      usage,
      utilization,
      css,
      tooltip
    };
  }
}

function _getCpusInfo({
  cpus,
  mode
}) {
  const used = (0, _coreUtils.decimalRound)(cpus.usedByNoobaa + cpus.usedByOther, 2);
  const usedByNoobaa = cpus.usedByNoobaa.toFixed(2);
  const usedByOther = used - usedByNoobaa;
  const count = cpus.units.length;

  if (mode === 'OFFLINE') {
    const utilization = '';
    return {
      count,
      utilization
    };
  } else {
    const utilization = `${(0, _numeral.default)(used).format('%')} utilization`;

    const css = _getCssByUsage(used);

    const tooltip = _getTooltipByUsage('CPU', used, usedByNoobaa, usedByOther);

    return {
      count,
      utilization,
      css,
      tooltip
    };
  }
}

function _getUntrustedReasons(host) {
  if (host.trusted) {
    return [];
  } else {
    return (0, _coreUtils.flatMap)(host.services.storage.nodes, node => node.untrusted.map(events => ({
      events,
      drive: node.mount
    })));
  }
}

class HostDetailsFormViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "hostLoaded", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "hostName", '');
    (0, _defineProperty2.default)(this, "isDeleteButtonWorking", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isRetrustButtonVisible", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "untrustedReasons", []);
    (0, _defineProperty2.default)(this, "daemonInfo", [{
      label: 'Node Name',
      value: _knockout.default.observable()
    }, {
      label: 'Installed Version',
      value: _knockout.default.observable()
    }, {
      label: 'Services',
      value: _knockout.default.observable()
    }, {
      label: 'Last Communication',
      value: _knockout.default.observable()
    }, {
      label: 'Communication IP',
      value: _knockout.default.observable()
    }, {
      label: 'Peer to Peer Connectivity',
      value: _knockout.default.observable(),
      template: 'protocol'
    }, {
      label: 'Port Range',
      value: _knockout.default.observable(),
      template: 'portRange'
    }, {
      label: 'Server Endpoint',
      value: _knockout.default.observable()
    }, {
      label: 'Round Trip Time',
      value: _knockout.default.observable()
    }]);
    (0, _defineProperty2.default)(this, "systemInfo", [{
      label: 'Host Name',
      value: _knockout.default.observable()
    }, {
      label: 'Up Time',
      value: _knockout.default.observable()
    }, {
      label: 'OS Type',
      value: _knockout.default.observable()
    }, {
      label: 'CPUs',
      value: _knockout.default.observable(),
      template: 'cpus'
    }, {
      label: 'Memory',
      value: _knockout.default.observable(),
      template: 'memory'
    }]);
  }

  selectState(state, params) {
    const {
      hosts
    } = state;
    return [hosts && hosts.items[params.name]];
  }

  mapStateToProps(host) {
    if (!host) {
      _knockout.default.assignToProps(this, {
        hostLoaded: false,
        isDeleteButtonWorking: false,
        isRetrustButtonVisible: false
      });
    } else {
      const {
        name,
        version,
        lastCommunication,
        ip,
        endpoint,
        rtt,
        hostname,
        upTime,
        os
      } = host;

      _knockout.default.assignToProps(this, {
        hostLoaded: true,
        hostName: name,
        isDeleteButtonWorking: host.mode === 'DELETING',
        isRetrustButtonVisible: !host.trusted,
        untrustedReasons: _getUntrustedReasons(host),
        daemonInfo: [{
          value: (0, _hostUtils.getHostDisplayName)(name)
        }, {
          value: version
        }, {
          value: _getServicesString(host)
        }, {
          value: (0, _moment.default)(lastCommunication).fromNow()
        }, {
          value: ip
        }, {
          value: _getProtocol(host)
        }, {
          value: _getPortRage(host)
        }, {
          value: endpoint
        }, {
          value: `${rtt.toFixed(2)}ms`
        }],
        systemInfo: [{
          value: hostname
        }, {
          value: (0, _moment.default)(upTime).fromNow(true)
        }, {
          value: os
        }, {
          value: _getCpusInfo(host)
        }, {
          value: _getMemoryInfo(host)
        }]
      });
    }
  }

  onRetrust() {
    this.dispatch((0, _actionCreators.openSetNodeAsTrustedModal)(this.hostName, this.untrustedReasons));
  }

}

var _default = {
  viewModel: HostDetailsFormViewModel,
  template: _hostDetailsForm.default
};
exports.default = _default;

},{"./host-details-form.html":471,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout","moment":"moment","numeral":"numeral","utils/core-utils":1027,"utils/host-utils":1032,"utils/size-utils":1043}],473:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<section class=\"column push-next\">\n    <div class=\"row pad card-shadow content-middle\">\n        <h3 class=\"greedy heading3\">Diagnostics</h3>\n\n        <div class=\"push-next\" ko.tooltip=\"actionsTooltip().text\">\n            <button class=\"btn\"\n                ko.disable=\"areActionsDisabled\"\n                ko.click=\"onToggleDebugMode\"\n                ko.text=\"debugModeToggleText\"\n            \"></button>\n        </div>\n\n        <div ko.tooltip=\"actionsTooltip\">\n            <working-button params=\"\n                working: isCollectingDiagnostics,\n                workingLabel: 'Collecting Data...',\n                click: onDownloadDiagnostics,\n                disabled: areActionsDisabled\n            \">\n                Download Diagnostics\n            </working-button>\n        </div>\n    </div>\n\n    <property-sheet class=\"pad\" params=\"\n        properties: debugDetails,\n        loading: !dataReady()\n    \">\n        <template name=\"debugMode\">\n            <p ko.visible=\"$data\">\n                On <span class=\"warning\">(May cause node slowdown)</span>\n            </p>\n            <p ko.visible=\"!$data\">Off</p>\n        </template>\n    </property-sheet>\n</section>\n<hr class=\"push-prev\">\n<section class=\"column\">\n    <div class=\"row pad card-shadow content-middle\">\n        <h3 class=\"greedy heading3\">Node's connectivity</h3>\n\n        <div ko.tooltip=\"actionsTooltip\">\n            <button class=\"btn\"\n                ko.disable=\"areActionsDisabled\"\n                ko.click=\"onRunTest\"\n            \">\n                Run Test\n            </button>\n        </div>\n    </div>\n\n    <p class=\"pad\" ko.css.disabled=\"!dataReady()\">\n        Testing a node allows you the verify peer to peer connectivity and bandwidth between this node and several of its peers\n    </p>\n</section>\n";

},{}],474:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _hostDiagnosticsForm = _interopRequireDefault(require("./host-diagnostics-form.html"));

var _knockout = _interopRequireDefault(require("knockout"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _actionCreators = require("action-creators");

var _diagnosticUtils = require("utils/diagnostic-utils");

var _config = require("config");

/* Copyright (C) 2016 NooBaa */
function _getDebugModeToggleText(debugState) {
  return `Turn ${debugState ? 'off' : 'on'} node debug mode`;
}

function _getActionsTooltip(isOffline, isBeingDeleted) {
  const text = isOffline && 'Node must be online for diagnostics operations' || isBeingDeleted && 'This operation is not available during node’s deletion' || '';
  return text && {
    text: text,
    align: 'end'
  };
}

class HostDiagnosticsFormViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "ticker", setInterval(this.onTick.bind(this), _config.timeTickInterval));
    (0, _defineProperty2.default)(this, "hostName", '');
    (0, _defineProperty2.default)(this, "rpcAddress", '');
    (0, _defineProperty2.default)(this, "actionsTooltip", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "areActionsDisabled", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "debugModeToggleText", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isCollectingDiagnostics", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "debugState", false);
    (0, _defineProperty2.default)(this, "timeLeftToDebugMode", undefined);
    (0, _defineProperty2.default)(this, "debugDetails", [{
      label: 'Debug Mode',
      value: _knockout.default.observable(),
      template: 'debugMode'
    }, {
      label: 'Time left for debugging',
      value: _knockout.default.observable(),
      disabled: _knockout.default.observable()
    }]);
  }

  selectState(state, params) {
    return [state.hosts && state.hosts.items[params.name]];
  }

  mapStateToProps(host) {
    if (!host) {
      _knockout.default.assignToProps(this, {
        dataReady: false,
        areActionsDisabled: true,
        actionsTooltip: {},
        debugModeToggleText: _getDebugModeToggleText(false)
      });
    } else {
      const {
        mode,
        debugMode,
        rpcAddress,
        diagnostics
      } = host;
      const isOffline = mode === 'OFFLINE';
      const isBeingDeleted = mode === 'DELETING';

      _knockout.default.assignToProps(this, {
        dataReady: true,
        hostName: host.name,
        rpcAddress: rpcAddress,
        actionsTooltip: _getActionsTooltip(isOffline, isBeingDeleted),
        areActionsDisabled: isOffline || isBeingDeleted,
        isCollectingDiagnostics: diagnostics.collecting,
        debugState: debugMode.state,
        timeLeftToDebugMode: debugMode.timeLeft,
        debugModeToggleText: _getDebugModeToggleText(debugMode.state),
        debugDetails: [{
          value: debugMode.state
        }, {
          value: (0, _diagnosticUtils.formatTimeLeftForDebugMode)(debugMode.state, debugMode.timeLeft),
          disabled: !debugMode.state
        }]
      });
    }
  }

  onTick() {
    const {
      debugState,
      timeLeftToDebugMode
    } = this;
    if (!debugState || !timeLeftToDebugMode || timeLeftToDebugMode < _config.timeTickInterval) return;
    this.timeLeftToDebugMode = timeLeftToDebugMode - _config.timeTickInterval;
    const text = (0, _diagnosticUtils.formatTimeLeftForDebugMode)(debugState, timeLeftToDebugMode);
    this.debugDetails[1].value(text);
  }

  onToggleDebugMode() {
    const {
      hostName,
      debugState
    } = this;
    this.dispatch((0, _actionCreators.setHostDebugMode)(hostName, !debugState));
  }

  onDownloadDiagnostics() {
    this.dispatch((0, _actionCreators.collectHostDiagnostics)(this.hostName));
  }

  onRunTest() {
    this.dispatch((0, _actionCreators.openTestNodeModal)(this.rpcAddress));
  }

  dispose() {
    clearInterval(this.ticker);
    super.dispose();
  }

}

var _default = {
  viewModel: HostDiagnosticsFormViewModel,
  template: _hostDiagnosticsForm.default
};
exports.default = _default;

},{"./host-diagnostics-form.html":473,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"config":831,"knockout":"knockout","utils/diagnostic-utils":1028}],475:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<host-summary class=\"push-next\" params=\"name: host\"></host-summary>\n\n<div class=\"tabs greedy\">\n    <nav>\n        <a ko.css.selected=\"selectedTab.eq('details')\"\n            ko.attr.href=\"tabHref('details')\"\n        >\n            Details\n        </a>\n\n        <a ko.css.selected=\"selectedTab.eq('diagnostics')\"\n            ko.attr.href=\"tabHref('diagnostics')\"\n        >\n            Test &amp; Diagnostics\n        </a>\n\n        <a ko.css.selected=\"selectedTab.eq('parts')\"\n            ko.attr.href=\"tabHref('parts')\"\n        >\n            Stored Parts\n        </a>\n    </nav>\n\n    <div class=\"tabs-row\">\n         <host-details-form class=\"tab\"\n            ko.css.selected=\"selectedTab.eq('details')\"\n            params=\"name: host\"\n        ></host-details-form>\n\n        <host-diagnostics-form class=\"tab\"\n            ko.css.selected=\"selectedTab.eq('diagnostics')\"\n            params=\"name: host\"\n        ></host-diagnostics-form>\n\n        <host-parts-table class=\"tab\"\n            ko.css.selected=\"selectedTab.eq('parts')\"\n            params=\"resourceType: 'HOST', hostName: host\"\n        ></host-parts-table>\n    </div>\n</div>\n\n<div class=\"redirect-overlay row content-middle\" ko.visible=\"redirecting\">\n    <div class=\"column greedy content-middle\">\n        <h1 class=\"heading1\">Deleting Node</h1>\n        <loading-indicator class=\"push-both-half\"></loading-indicator>\n        <p class=\"heading3\">You will be redircted to a pool page in a moment</p>\n    </div>\n</div>\n";

},{}],476:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _hostPanel = _interopRequireDefault(require("./host-panel.html"));

var _observer = _interopRequireDefault(require("observer"));

var _state = require("state");

var _actionCreators = require("action-creators");

var _knockout = _interopRequireDefault(require("knockout"));

var _browserUtils = require("utils/browser-utils");

var _promiseUtils = require("utils/promise-utils");

var _rxExtensions = require("rx-extensions");

var routes = _interopRequireWildcard(require("routes"));

var _config = require("config");

/* Copyright (C) 2016 NooBaa */
const viewName = 'hostPanel';

class HostPanelViewModel extends _observer.default {
  constructor() {
    super();
    this.poolRedirectPath = '';
    this.basePath = '';
    this.host = _knockout.default.observable();
    this.selectedTab = _knockout.default.observable();
    this.redirecting = _knockout.default.observable();
    this.observe(_state.state$.pipe((0, _rxExtensions.get)('location')), this.onLocation);
    this.observe(_state.state$.pipe((0, _rxExtensions.get)('hosts')), this.onHosts);
  }

  onLocation(location) {
    const {
      route,
      params,
      query
    } = location;
    const {
      system,
      pool,
      host,
      tab = 'details'
    } = params;
    if (!host) return;
    this.host(host);
    this.poolRedirectPath = (0, _browserUtils.realizeUri)(routes.pool, {
      system,
      pool
    });
    this.basePath = (0, _browserUtils.realizeUri)(route, {
      system,
      pool,
      host
    }, {}, true);
    this.selectedTab(tab); // Load/update the host data.

    _state.action$.next((0, _actionCreators.fetchHosts)(viewName, {
      hosts: [host]
    }, true));

    const page = Number(query.page) || 0;

    const pageSize = Number(query.pageSize) || _config.paginationPageSize.default; // load the host object list.


    if (tab === 'parts') {
      _state.action$.next((0, _actionCreators.fetchHostObjects)(params.host, page * pageSize, pageSize));
    }
  }

  async onHosts(hosts) {
    const queryKey = hosts.views[viewName];
    const {
      [queryKey]: query
    } = hosts.queries;

    if (query && !query.fetching && query.result.items.length === 0) {
      this.redirecting(true);
      await (0, _promiseUtils.sleep)(_config.redirectOverlayDuration);

      _state.action$.next((0, _actionCreators.requestLocation)(this.poolRedirectPath));
    } else {
      this.redirecting(false);
    }
  }

  tabHref(tab) {
    return (0, _browserUtils.realizeUri)(this.basePath, {
      tab
    });
  }

  dispose() {
    _state.action$.next((0, _actionCreators.dropHostsView)(viewName));

    super.dispose();
  }

}

var _default = {
  viewModel: HostPanelViewModel,
  template: _hostPanel.default
};
exports.default = _default;

},{"./host-panel.html":475,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"config":831,"knockout":"knockout","observer":937,"routes":972,"rx-extensions":974,"state":1016,"utils/browser-utils":1021,"utils/promise-utils":1039}],477:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"fill row\" ko.visible=\"!dataReady()\">\n    <loading-indicator class=\"align-middle greedy\" params=\"label: true\"></loading-indicator>\n</div>\n\n<div class=\"row summary\" ko.css.visible=\"dataReady\">\n    <section class=\"c3 card column\">\n        <div class=\"row hpad greedy content-middle\">\n            <svg-icon class=\"push-next\"\n                ko.css=\"stateIcon().css\"\n                params=\"name: stateIcon().name\"\n            ></svg-icon>\n            <span class=\"greedy\">{{stateIcon().tooltip}}</span>\n        </div>\n        <hr />\n        <div class=\"row hpad greedy content-middle\">\n            <svg-icon class=\"push-next\"\n                ko.css=\"trustIcon().css\"\n                params=\"name: trustIcon().name\"\n            ></svg-icon>\n            <span class=\"greedy\">{{trustIcon().tooltip}}</span>\n            <more-info-icon params=\"tooltip: trustTooltip\"></more-info-icon>\n        </div>\n        <hr />\n        <div class=\"row hpad greedy content-middle\">\n            <svg-icon class=\"push-next\"\n                ko.css=\"accessibilityIcon().css\"\n                params=\"name: accessibilityIcon().name\"\n            ></svg-icon>\n            <span class=\"greedy\">{{accessibilityIcon().tooltip}}</span>\n        </div>\n    </section>\n\n    <section class=\"column c6 push-both\">\n        <div class=\"row align-middle\">\n            <chart-legend class=\"pad push-next\" params=\"\n                caption: 'Node Usage',\n                items: pieValues,\n                format: 'size'\n            \"></chart-legend>\n\n            <pie-chart params=\"\n                values: pieValues,\n                sumLabel: 'Total',\n                format: 'size'\n            \"></pie-chart>\n        </div>\n    </section>\n\n    <section class=\"c3 card column\">\n        <h3 class=\"hpad pad-half heading3\">{{activitiesTitle}}</h3>\n        <hr>\n        <p class=\"remark hpad pad-half push-next\">{{activityText}}</p>\n        <!-- ko if: hasActivities -->\n        <progress-bar class=\"hpad push-both-quarter\" params=\"\n            progress: activityProgress,\n            marker: true\n        \"></progress-bar>\n        <p class=\"remark align-end pad-right\">ETA: {{activityEta}}</p>\n\n        <!-- ko if: hasAdditionalActivities -->\n            <hr class=\"push-prev-half\">\n            <p class=\"hpad pad-half align-start\"\n                ko.text=\"additionalActivitiesMessage\"\n                ko.tooltip=\"additionalActivitiesTooltip\"\n            ></p>\n        <!-- /ko -->\n        <!-- /ko -->\n    </section>\n</div>\n\n\n";

},{}],478:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _hostSummary = _interopRequireDefault(require("./host-summary.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _sizeUtils = require("utils/size-utils");

var _stringUtils = require("utils/string-utils");

var _moment = _interopRequireDefault(require("moment"));

var _hostUtils = require("utils/host-utils");

/* Copyright (C) 2016 NooBaa */
const trustTooltip = `A reliability check that verifies that this node has no disk
    corruption or malicious activity`;

function _mapStateAndStatus(host) {
  return {
    stateIcon: (0, _hostUtils.getHostStateIcon)(host),
    trustIcon: (0, _hostUtils.getHostTrustIcon)(host),
    accessibilityIcon: (0, _hostUtils.getHostAccessibilityIcon)(host)
  };
}

function _mapStorageAndUsage(host) {
  const {
    free = 0,
    unavailableFree = 0,
    used = 0,
    unavailableUsed = 0,
    usedOther = 0
  } = (0, _coreUtils.mapValues)(host.storage, _sizeUtils.toBytes);
  return {
    availableCapacity: free,
    unavailableCapacity: unavailableFree,
    usedByNoobaaCapacity: used + unavailableUsed,
    usedByOthersCapacity: usedOther
  };
}

function _mapFirstActivity(host) {
  const list = host.activities;

  if (list.length > 0) {
    const {
      kind,
      nodeCount,
      progress,
      eta
    } = list[0] || {};
    const activityText = `${(0, _hostUtils.getActivityName)(kind)} ${(0, _stringUtils.stringifyAmount)('drive', nodeCount)}`;
    const etaText = (0, _coreUtils.isNumber)(eta) ? (0, _moment.default)(eta).fromNow() : 'calculating...';
    return {
      hasActivities: true,
      activitiesTitle: `${(0, _stringUtils.stringifyAmount)('Drive', nodeCount)} in Process`,
      activityText: activityText,
      activityProgress: progress,
      activityEta: etaText
    };
  } else {
    return {
      hasActivities: false,
      activitiesTitle: 'No Activities',
      activityText: 'Node has no activity'
    };
  }
}

function _mapAdditionalActivities(host) {
  const list = host.activities;
  const additionalActivities = list.slice(1);

  if (additionalActivities.length > 0) {
    const message = `${(0, _stringUtils.stringifyAmount)('More activity', additionalActivities.length)} running`;
    return {
      hasAdditionalActivities: true,
      additionalActivitiesMessage: message,
      additionalActivitiesTooltip: (0, _hostUtils.getActivityListTooltip)(additionalActivities)
    };
  } else {
    return {
      hasAdditionalActivities: false
    };
  }
}

class HostSummaryViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "trustTooltip", trustTooltip);
    (0, _defineProperty2.default)(this, "storageServiceState", _knockout.default.observable({}));
    (0, _defineProperty2.default)(this, "endpointServiceState", _knockout.default.observable({}));
    (0, _defineProperty2.default)(this, "stateIcon", _knockout.default.observable({}));
    (0, _defineProperty2.default)(this, "trustIcon", _knockout.default.observable({}));
    (0, _defineProperty2.default)(this, "accessibilityIcon", _knockout.default.observable({}));
    (0, _defineProperty2.default)(this, "availableCapacity", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "unavailableCapacity", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "usedByNoobaaCapacity", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "usedByOthersCapacity", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "pieValues", [{
      label: 'Available',
      color: 'rgb(var(--color09))',
      value: this.availableCapacity,
      tooltip: 'The total storage of this machine, does not include any offline or deactivated drives'
    }, {
      label: 'Unavailable Capacity',
      color: 'rgb(var(--color14))',
      value: this.unavailableCapacity,
      tooltip: 'The total storage from drives which are either offline or in process'
    }, {
      label: 'NooBaa Usage',
      color: 'rgb(var(--color20))',
      value: this.usedByNoobaaCapacity,
      tooltip: 'The actual storage utilization of this node by the buckets connected to its assigned pool'
    }, {
      label: 'Other Usage',
      color: 'rgb(var(--color29))',
      value: this.usedByOthersCapacity,
      tooltip: 'The machine utilization by OS, local files etc'
    }]);
    (0, _defineProperty2.default)(this, "hasActivities", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "activitiesTitle", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "activityText", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "activityProgress", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "activityEta", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "hasAdditionalActivities", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "additionalActivitiesMessage", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "additionalActivitiesTooltip", _knockout.default.observable());
  }

  selectState(state, params) {
    const {
      hosts
    } = state;
    return [hosts && hosts.items && hosts.items[params.name]];
  }

  mapStateToProps(host) {
    if (!host) {
      _knockout.default.assignToProps(this, {
        dataReady: false
      });
    } else {
      _knockout.default.assignToProps(this, {
        dataReady: true,
        ..._mapStateAndStatus(host),
        ..._mapStorageAndUsage(host),
        ..._mapFirstActivity(host),
        ..._mapAdditionalActivities(host)
      });
    }
  }

}

var _default = {
  viewModel: HostSummaryViewModel,
  template: _hostSummary.default
};
exports.default = _default;

},{"./host-summary.html":477,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"components/connectable":446,"knockout":"knockout","moment":"moment","utils/core-utils":1027,"utils/host-utils":1032,"utils/size-utils":1043,"utils/string-utils":1046}],479:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<form class=\"column content-middle\"\n    ko.trapFocus=\"true\"\n    ko.validationOptions=\"{ insertMessages: false }\"\n>\n    <h1 class=\"heading1 push-next welcome-message\">\n        Welcome to NooBaa!\n    </h1>\n\n    <section class=\"column card-bg card-shadow box push-both\">\n        <h2 class=\"heading1 push-next pad content-box\">\n            Reset Password\n        </h2>\n\n        <h3 class=\"heading3 hpad push-next\">\n            Please update your password for future login\n        </h3>\n\n        <div class=\"hpad\">\n            <editor params=\"label: 'Current Password'\">\n                <password-field ko.css.invalid=\"isPasswordInvalid\"\n                    params=\"\n                        value: password,\n                        placeholder: 'Enter your current password',\n                        hasFocus: true\n                    \"\n                ></password-field>\n                <span class=\"val-msg\" ko.validationMessage=\"password\"></span>\n            </editor>\n\n            <editor params=\"label: 'New Password'\">\n                <password-field class=\"push-next-half\"\n                    ko.css.invalid=\"isNewPasswordInvalid\"\n                    params=\"\n                        value: newPassword,\n                        placeholder: 'Enter your new password',\n                        strengthCalc: calcPasswordStrength\n                \"></password-field>\n                <validation-rules-list params=\"field: newPassword, highlightErrors: wasValidated\"></validation-rules-list>\n            </editor>\n        </div>\n\n        <div class=\"row content-middle pad content-box push-prev\">\n            <div class=\"greedy\"></div>\n            <button type=\"button\"\n                class=\"link alt-colors\"\n                ko.click=\"back\"\n            >\n                Go Back\n            </button>\n            <button\n                class=\"btn align-end push-prev\"\n                ko.click=\"change\"\n                ko.shakeOnClick=\"errors().length\"\n            >\n                Change\n            </button>\n        </div>\n    </section>\n    <div class=\"row\">\n        <a class=\"link\"\n            target=\"_blank\"\n            href=\"/public/eula\">\n            Terms &amp; Conditions\n        </a>\n        <vr class=\"push-both-half\"></vr>\n        <a class=\"link\"\n            ko.attr.href=\"supportEmailHref\"\n        >\n            Contact Support\n        </a>\n    </div>\n</form>\n";

},{}],480:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _changePasswordForm = _interopRequireDefault(require("./change-password-form.html"));

var _baseViewModel = _interopRequireDefault(require("components/base-view-model"));

var _knockout = _interopRequireDefault(require("knockout"));

var _actionCreators = require("action-creators");

var _model = require("model");

var _passwordUtils = require("utils/password-utils");

var _state = require("state");

var _browserUtils = require("utils/browser-utils");

var _config = require("config");

/* Copyright (C) 2016 NooBaa */
class ChangePasswordFormViewModel extends _baseViewModel.default {
  constructor() {
    super();
    this.supportEmailHref = (0, _browserUtils.formatEmailUri)(_config.support.email);
    this.password = _knockout.default.observable().extend({
      required: {
        message: 'Please enter your current password'
      },
      validation: {
        validator: () => this.touched() || (0, _model.resetPasswordState)() !== 'UNAUTHORIZED',
        message: 'Please make sure your password is correct'
      }
    });
    this.isPasswordInvalid = _knockout.default.pureComputed(() => {
      const {
        password
      } = this;
      return password.isModified() && !password.isValid() && !password.isValidating();
    });
    this.touched = _knockout.default.touched(this.password);
    this.wasValidated = _knockout.default.observable(false);
    this.newPassword = _knockout.default.observable().extend({
      required: true,
      minLength: {
        params: 5,
        message: 'At least 5 characters'
      },
      includesUppercase: true,
      includesLowercase: true,
      includesDigit: true
    });
    this.isNewPasswordInvalid = _knockout.default.pureComputed(() => {
      const {
        newPassword
      } = this;
      return newPassword.isModified() && !newPassword.isValid() && !newPassword.isValidating();
    });
    this.calcPasswordStrength = _passwordUtils.calcPasswordStrength;
    this.addToDisposeList(_model.resetPasswordState.subscribe(state => state === 'SUCCESS' && _state.action$.next((0, _actionCreators.refreshLocation)())));
    this.errors = _knockout.default.validation.group(this);
  }

  async change() {
    if (this.errors().length > 0) {
      this.errors.showAllMessages();
      this.wasValidated(true);
    } else {
      this.touched(false);

      _state.action$.next((0, _actionCreators.changeAccountPassword)(this.password(), (0, _model.sessionInfo)().user, this.newPassword()));
    }
  }

  back() {
    _state.action$.next((0, _actionCreators.signOut)());
  }

}

var _default = {
  viewModel: ChangePasswordFormViewModel,
  template: _changePasswordForm.default
};
exports.default = _default;

},{"./change-password-form.html":479,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/base-view-model":399,"config":831,"knockout":"knockout","model":936,"state":1016,"utils/browser-utils":1021,"utils/password-utils":1038}],481:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<form class=\"column content-middle\"\n    ko.trapFocus=\"true\"\n    ko.validationOptions=\"{ insertMessages: false }\"\n>\n    <h1 class=\"heading1 push-next welcome-message\">\n        Welcome to NooBaa!\n    </h1>\n\n    <section class=\"column card-bg card-shadow box push-both\">\n        <h2 class=\"heading1 push-next pad content-box\">\n            Create a NooBaa Account\n        </h2>\n\n        <h3 class=\"heading3 hpad push-next\">\n            Please complete the following information to get started\n        </h3>\n\n\n        <div class=\"hpad push-next\">\n            <editor params=\"label: 'System name'\">\n                <input type=\"text\"\n                    placeholder=\"e.g., company-name\"\n                    ko.value=\"systemName\"\n                    ko.hasFocus=\"true\"\n                    ko.css.invalid=\"isSystemNameInvalid\"\n                />\n                <span class=\"val-msg\" data-bind=\"validationMessage: systemName\"></span>\n            </editor>\n\n            <editor params=\"label: 'Email address'\">\n                <div class=\"row content-middle\">\n\n                    <input type=\"text\"\n                        placeholder=\"e.g., shadowman@cloud.com\"\n                        ko.disable=\"isEmailDisabled\"\n                        ko.value=\"email\"\n                        ko.css.invalid=\"isEmailInvalid\"\n                    />\n\n                    <svg-icon class=\"match-theme spin push-prev-half\"\n                        ko.visible=\"isEmailSpinnerVisible\"\n                        params=\"name: 'in-progress'\"></svg-icon>\n                </div>\n               <span class=\"val-msg\" data-bind=\"validationMessage: email\"></span>\n            </editor>\n\n            <editor class=\"push-next\" params=\"label: 'Password'\">\n                <password-field\n                    ko.css.invalid=\"isPasswordInvalid\"\n                    params=\"\n                        value: password,\n                        placeholder: 'e.g., ********',\n                        strengthCalc: calcPasswordStrength\n                    \"\n                ></password-field>\n\n                <validation-rules-list params=\"\n                    field: password,\n                    highlightErrors: wasValidated\"\n                ></validation-rules-list>\n            </editor>\n        </div>\n\n\n        <div class=\"row content-middle pad content-box\">\n            <p class=\"remark greedy push-next\">\n                By clicking on the create system button, you agree  <br>\n                to NooBaa\n                <a class=\"link\"\n                    target=\"_blank\"\n                    href=\"/public/eula\">\n                    terms and conditions\n                </a>\n            </p>\n            <working-button ko.shakeOnClick=\"errors().length\"\n                params=\"\n                    working: creatingSystem,\n                    workingLabel: 'Creating...',\n                    click: createSystem\n                \"\n            >\n                Create System\n            </working-button>\n        </div>\n    </section>\n\n    <p>\n        Need help?\n        <a class=\"link\"\n            ko.attr.href=\"supportEmailHref\"\n        >\n            Contact our support team\n        </a>\n    </p>\n</form>\n";

},{}],482:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _createSystemForm = _interopRequireDefault(require("./create-system-form.html"));

var _baseViewModel = _interopRequireDefault(require("components/base-view-model"));

var _knockout = _interopRequireDefault(require("knockout"));

var _actionCreators = require("action-creators");

var _model = require("model");

var _moment = _interopRequireDefault(require("moment"));

var _passwordUtils = require("utils/password-utils");

var _browserUtils = require("utils/browser-utils");

var _config = require("config");

var _state = require("state");

/* Copyright (C) 2016 NooBaa */
class CreateSystemFormViewModel extends _baseViewModel.default {
  constructor() {
    super();
    this.supportEmailHref = (0, _browserUtils.formatEmailUri)(_config.support.email, _config.support.createSystemSupportSubject);
    this.wasValidated = _knockout.default.observable(false);
    this.creatingSystem = _knockout.default.observable(false);

    const serverConfig = _knockout.default.pureComputed(() => (0, _model.serverInfo)() ? (0, _model.serverInfo)().config : {});

    const ownerAccount = _knockout.default.pureComputed(() => serverConfig().owner || {});

    this.systemName = _knockout.default.observable().extend({
      required: {
        message: 'Please enter a system name'
      },
      hasNoLeadingOrTrailingSpaces: true,
      maxLength: {
        params: 50,
        message: 'System name cannot be longer then 50 characters'
      }
    });
    this.isSystemNameInvalid = _knockout.default.pureComputed(() => {
      const {
        systemName
      } = this;
      return systemName.isModified() && !systemName.isValid() && !systemName.isValidating();
    });
    this.isEmailDisabled = _knockout.default.pureComputed(() => Boolean(ownerAccount().email));
    this.isEmailSpinnerVisible = _knockout.default.pureComputed(() => !ownerAccount().email && this.email.isValidating());
    this.email = _knockout.default.observableWithDefault(() => ownerAccount().email).extend({
      required: {
        message: 'Please enter an email address'
      },
      email: true
    });
    this.isEmailInvalid = _knockout.default.pureComputed(() => {
      const {
        email
      } = this;
      return email.isModified() && !email.isValid() && !email.isValidating();
    });
    this.password = _knockout.default.observable().extend({
      validation: {
        validator: pass => pass && pass.length >= 5,
        message: 'Use at least 5 characters'
      },
      includesUppercase: true,
      includesLowercase: true,
      includesDigit: true
    });
    this.isPasswordInvalid = _knockout.default.pureComputed(() => {
      const {
        password
      } = this;
      return password.isModified() && !password.isValid() && !password.isValidating();
    });
    this.calcPasswordStrength = _passwordUtils.calcPasswordStrength;
    this.errors = _knockout.default.validation.group([this.systemName, this.email, this.password]);
  }

  createSystem() {
    if (this.errors().length > 0) {
      this.errors.showAllMessages();
    } else {
      const serverConfig = (0, _model.serverInfo)().config;
      const dnsServers = !serverConfig.using_dhcp && serverConfig.dns_servers ? serverConfig.dns_servers : [];
      const timeConfig = {
        timezone: serverConfig.timezone || Intl.DateTimeFormat().resolvedOptions().timeZone,
        epoch: (0, _moment.default)().unix()
      };
      this.creatingSystem(true);

      _state.action$.next((0, _actionCreators.createSystem)(this.email(), this.password(), this.systemName(), '', dnsServers, timeConfig));
    }
  }

}

var _default = {
  viewModel: CreateSystemFormViewModel,
  template: _createSystemForm.default
};
exports.default = _default;

},{"./create-system-form.html":481,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/base-view-model":399,"config":831,"knockout":"knockout","model":936,"moment":"moment","state":1016,"utils/browser-utils":1021,"utils/password-utils":1038}],483:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<h1 class=\"heading1\">\n    Loading\n    <loading-indicator></loading-indicator>\n</h1>\n\n";

},{}],484:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _oauthCallback = _interopRequireDefault(require("./oauth-callback.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
class OAuthCallbackViewModel extends _connectable.default {
  selectState(state) {
    return [state.location];
  }

  mapStateToProps(location) {
    const {
      pathname,
      query
    } = location;

    if (query.code) {
      // Redirect back to requested location.
      if (query.state && pathname !== query.state) {
        this.dispatch((0, _actionCreators.requestLocation)(query.state, true));
      } // Sign in with the outh grant code.


      this.dispatch((0, _actionCreators.signInWithOAuth)(query.code));
    }

    if (query.error === 'access_denied') {
      this.dispatch((0, _actionCreators.openOAuthAccessDeniedModal)());
    }
  }

}

var _default = {
  viewModel: OAuthCallbackViewModel,
  template: _oauthCallback.default
};
exports.default = _default;

},{"./oauth-callback.html":483,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446}],485:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<form class=\"sign-in-from column content-middle\"\n    ko.trapFocus=\"true\"\n    ko.validationOptions=\"{ insertMessages: false }\"\n>\n    <h1 class=\"heading1 push-next welcome-message\">\n        Welcome to NooBaa!\n    </h1>\n\n    <section class=\"column card-bg card-shadow box push-both\">\n        <h2 class=\"heading1 push-next pad content-box\">\n            Login to Your Account\n        </h2>\n\n        <h3 class=\"heading3 hpad push-next\">\n            Use your admin credentials to login\n        </h3>\n\n        <div class=\"hpad push-next\">\n            <editor params=\"label: 'Email Address'\">\n                <input type=\"text\"\n                    ko.value=\"email\"\n                    ko.hasFocus=\"true\"\n                    ko.css.invalid=\"isEmailInvalid\"\n                />\n                <span class=\"val-msg\" data-bind=\"validationMessage: email\"></span>\n            </editor>\n\n\n            <editor params=\"label: 'Password'\">\n                <password-field ko.css.invalid=\"isPasswordInvalid\"\n                    params=\"value: password\"\n                ></password-field>\n                <span class=\"val-msg\" data-bind=\"validationMessage: password\"></span>\n            </editor>\n\n            <checkbox params=\"label: 'Keep me logged in', checked: keepSessionAlive\">\n            </checkbox>\n\n            <p class=\"error push-next\" ko.css.visible=\"showInvalidMessage\">\n                Invalid email address or password\n            </p>\n        </div>\n\n        <div class=\"row content-middle pad content-box\">\n            <p class=\"remark greedy push-next\">\n                Forgot your password? <br>\n                Ask your system owner for a password reset\n            </p>\n            <button class=\"btn\"\n                ko.shakeOnClick=\"errors().length\"\n                ko.click=\"signIn\"\n            >\n                Login\n            </button>\n        </div>\n    </section>\n\n    <div class=\"row\">\n        <a class=\"link\"\n            target=\"_blank\"\n            href=\"/public/eula\">\n            Terms &amp; Conditions\n        </a>\n        <vr class=\"push-both-half\"></vr>\n        <a class=\"link\"\n            ko.attr.href=\"supportEmailHref\"\n        >\n            Contact Support\n        </a>\n    </div>\n</form>\n";

},{}],486:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _signinForm = _interopRequireDefault(require("./signin-form.html"));

var _baseViewModel = _interopRequireDefault(require("components/base-view-model"));

var _knockout = _interopRequireDefault(require("knockout"));

var _model = require("model");

var _state = require("state");

var _actionCreators = require("action-creators");

var _browserUtils = require("utils/browser-utils");

var _config = require("config");

/* Copyright (C) 2016 NooBaa */
class SignInFormViewModel extends _baseViewModel.default {
  constructor() {
    super();
    this.supportEmailHref = (0, _browserUtils.formatEmailUri)(_config.support.email);

    const email = _knockout.default.observable();

    this.email = _knockout.default.pureComputed({
      read: email,
      write: val => email(val.trim())
    }).extend({
      required: {
        message: 'Please enter an email address'
      },
      email: {
        message: 'Please enter a valid email address'
      }
    });
    this.isEmailInvalid = _knockout.default.pureComputed(() => {
      const {
        email
      } = this;
      return email.isModified() && !email.isValid() && !email.isValidating();
    });
    this.password = _knockout.default.observable().extend({
      required: {
        message: 'Please enter a password'
      }
    });
    this.isPasswordInvalid = _knockout.default.pureComputed(() => {
      const {
        password
      } = this;
      return password.isModified() && !password.isValid() && !password.isValidating();
    });
    this.keepSessionAlive = _knockout.default.observable(false);

    let retryCount = _knockout.default.pureComputed(() => (0, _model.loginInfo)().retryCount);

    this.isDirty = _knockout.default.observable(false);
    this.showInvalidMessage = _knockout.default.pureComputed(() => !this.isDirty() && retryCount() > 0);
    this.errors = _knockout.default.validation.group([this.email, this.password]);
  }

  signIn() {
    if (this.errors().length > 0) {
      this.errors.showAllMessages();
    } else {
      this.isDirty(false);

      _state.action$.next((0, _actionCreators.signIn)(this.email(), this.password(), this.keepSessionAlive()));
    }
  }

}

var _default = {
  viewModel: SignInFormViewModel,
  template: _signinForm.default
};
exports.default = _default;

},{"./signin-form.html":485,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/base-view-model":399,"config":831,"knockout":"knockout","model":936,"state":1016,"utils/browser-utils":1021}],487:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<h1 class=\"heading1\">\n    Loading\n    <loading-indicator></loading-indicator>\n</h1>\n";

},{}],488:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _splashScreen = _interopRequireDefault(require("./splash-screen.html"));

/* Copyright (C) 2016 NooBaa */
class SplashScreenViewModel {}

var _default = {
  viewModel: SplashScreenViewModel,
  template: _splashScreen.default
};
exports.default = _default;

},{"./splash-screen.html":487,"@babel/runtime/helpers/interopRequireDefault":1050}],489:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"wrapper column\">\n    <h1 class=\"heading1 text-center push-next\">\n        Sorry, your browser is not yet supported.<br>\n        NooBaa works best on Chrome <!-- and Firefox -->\n    </h1>\n\n    <div class=\"row push-prev align-middle\">\n        <a class=\"btn push-next\" target=\"_blank\" href=\"https://www.google.com/chrome/browser\">\n            Download Chrome\n        </a>\n\n<!--         <a class=\"btn push-prev\" target=\"_blank\" href=\"https://www.mozilla.org/en-US/firefox\">\n            Download Firefox\n        </a> -->\n    </div>\n</div>\n";

},{}],490:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _unsupportedForm = _interopRequireDefault(require("./unsupported-form.html"));

/* Copyright (C) 2016 NooBaa */
var _default = {
  template: _unsupportedForm.default
};
exports.default = _default;

},{"./unsupported-form.html":489,"@babel/runtime/helpers/interopRequireDefault":1050}],491:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div ko.childEvent.click=\"onLocalClick\"\n    ko.globalEvent.click=\"onGlobalClick\"\n    ko.css.open=\"isOpen\"\n>\n    <div class=\"menu-header row hpad content-middle text-left cursor-pointer\">\n        <span class=\"push-next user-email no-wrap\">\n            {{accountName}}\n        </span>\n        <svg-icon params=\"name: 'account'\"></svg-icon>\n    </div>\n\n    <ul class=\"menu-items list-no-style\">\n        <hr />\n        <li>\n            <a class=\"menu-item\"\n                ko.attr.href=\"accountPageHref\"\n            >\n                My Account\n            </a>\n        </li>\n        <li>\n            <a class=\"menu-item\"\n                ko.attr.href=\"connectionPageHref\"\n            >\n                My Connections\n            </a>\n        </li>\n        <hr>\n        <li>\n            <a class=\"menu-item\"\n                ko.attr.href=\"supportEmailHref\"\n            >\n                Contact Us\n            </a>\n        </li>\n        <hr>\n        <li>\n            <button class=\"menu-item theme-switch\"\n                ko.click=\"onSwitchTheme\"\n            >\n                <span>{{switchThemeText}}</span>\n            </button>\n\n        </li>\n        <hr>\n        <li>\n            <!-- workaround using target black to allow the link to resolve even so the upper div loses the focus -->\n            <a class=\"menu-item\"\n                href=\"javascript:void(0)\"\n                ko.css.disabled=\"!allowSignOut()\"\n                ko.preventBubble=\"['click']\"\n                ko.click=\"onSignOut\"\n            >\n                <div class=\"column\">\n                    <span>Sign Out</span>\n                    <span class=\"remark\"\n                        ko.visible=\"!allowSignOut()\"\n                    >\n                        Not available for OpenShift users\n                    </span>\n                </div>\n            </a>\n        </li>\n\n    </ul>\n</div>\n";

},{}],492:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _accountMenu = _interopRequireDefault(require("./account-menu.html"));

var _knockout = _interopRequireDefault(require("knockout"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _stringUtils = require("utils/string-utils");

var _browserUtils = require("utils/browser-utils");

var _config = require("config");

var _actionCreators = require("action-creators");

var routes = _interopRequireWildcard(require("routes"));

/* Copyright (C) 2016 NooBaa */
class AccountMenuViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "isOpen", _knockout.default.observable(false));
    (0, _defineProperty2.default)(this, "isLocalClick", _knockout.default.observable(false));
    (0, _defineProperty2.default)(this, "accountName", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "accountPageHref", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "connectionPageHref", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "supportEmailHref", (0, _browserUtils.formatEmailUri)(_config.support.email));
    (0, _defineProperty2.default)(this, "oppositeTheme", '');
    (0, _defineProperty2.default)(this, "switchThemeText", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "allowSignOut", _knockout.default.observable());
  }

  selectState(state) {
    const {
      session,
      location
    } = state;
    return [location.params.system, session && state.session];
  }

  mapStateToProps(system, session) {
    if (!session) {
      return;
    }

    const {
      user: account,
      uiTheme
    } = session;
    const oppositeTheme = uiTheme === 'dark' ? 'light' : 'dark';

    _knockout.default.assignToProps(this, {
      accountName: account,
      accountPageHref: (0, _browserUtils.realizeUri)(routes.account, {
        system,
        account
      }),
      connectionPageHref: (0, _browserUtils.realizeUri)(routes.account, {
        system,
        account,
        tab: 'connections'
      }),
      oppositeTheme,
      switchThemeText: `Switch to ${(0, _stringUtils.capitalize)(oppositeTheme)} Theme`,
      allowSignOut: session.authorizedBy === 'noobaa'
    });
  }

  onLocalClick() {
    _knockout.default.assignToProps(this, {
      isOpen: !this.isOpen(),
      isLocalClick: true
    });
  }

  onGlobalClick() {
    _knockout.default.assignToProps(this, {
      isOpen: this.isLocalClick() && this.isOpen(),
      isLocalClick: false
    });
  }

  onSwitchTheme() {
    this.dispatch((0, _actionCreators.updateAccountUITheme)(this.accountName(), this.oppositeTheme));
  }

  onSignOut() {
    if (this.allowSignOut()) {
      this.dispatch((0, _actionCreators.signOut)());
    }
  }

}

var _default = {
  viewModel: AccountMenuViewModel,
  template: _accountMenu.default
};
exports.default = _default;

},{"./account-menu.html":491,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"components/connectable":446,"config":831,"knockout":"knockout","routes":972,"utils/browser-utils":1021,"utils/string-utils":1046}],493:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<a href=\"\" class=\"icon-btn no-focus-ring\"\n    ko.click=\"onRefresh\"\n    ko.tooltip=\"'Refresh'\"\n>\n    <svg-icon\n        ko.event.animationend=\"onRefreshAnimationEnd\"\n        ko.css.refresh-spin=\"isRefreshSpinning\"\n        params=\"name: 'refresh'\"\n    ></svg-icon>\n</a>\n\n<a class=\"icon-btn no-focus-ring\"\n    ko.attr.href=\"settingsHref\"\n    ko.tooltip=\"'System Management'\"\n>\n    <svg-icon params=\"name: 'cog'\"></svg-icon>\n</a>\n\n<button class=\"icon-btn no-focus-ring\"\n    ko.click=\"onAudit\"\n    ko.tooltip=\"'Audit'\"\n>\n    <svg-icon params=\"name: 'audit'\"></svg-icon>\n</button>\n\n<button class=\"icon-btn no-focus-ring alerts\"\n    ko.click=\"onAlerts\"\n    ko.tooltip=\"'Alerts'\"\n    ko.css.counter=\"unreadAlertsCount\"\n    ko.attr=\"{ 'data-count': unreadAlertsCount }\"\n>\n    <svg-icon params=\"name: 'alert'\"></svg-icon>\n</button>\n\n\n";

},{}],494:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _commandsBar = _interopRequireDefault(require("./commands-bar.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _browserUtils = require("utils/browser-utils");

var routes = _interopRequireWildcard(require("routes"));

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
class CommandBarViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "isRefreshSpinning", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "unreadAlertsCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "settingsHref", _knockout.default.observable());
    this.dispatch((0, _actionCreators.fetchUnreadAlertsCount)());
  }

  selectState(state) {
    return [state.alerts.unreadCountsm, state.location.params.system];
  }

  mapStateToProps(counters, system) {
    const unreadAlertsCount = counters ? (0, _coreUtils.sumBy)(Object.values(counters)) : 0;
    const settingsHref = (0, _browserUtils.realizeUri)(routes.management, {
      system
    });

    _knockout.default.assignToProps(this, {
      unreadAlertsCount,
      settingsHref
    });
  }

  onRefresh() {
    _knockout.default.assignToProps(this, {
      isRefreshSpinning: true
    });

    this.dispatch((0, _actionCreators.refreshLocation)());
  }

  onRefreshAnimationEnd() {
    _knockout.default.assignToProps(this, {
      isRefreshSpinning: false
    });
  }

  onAudit() {
    this.dispatch((0, _actionCreators.openAuditDrawer)());
  }

  onAlerts() {
    this.dispatch((0, _actionCreators.openAlertsDrawer)());
  }

}

var _default = {
  viewModel: CommandBarViewModel,
  template: _commandsBar.default
};
exports.default = _default;

},{"./commands-bar.html":493,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"components/connectable":446,"knockout":"knockout","routes":972,"utils/browser-utils":1021,"utils/core-utils":1027}],495:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<ul class=\"list-no-style hpad\"\n    ko.css=\"borders\"\n    ko.css.visible=\"visible\"\n    ko.foreach=\"notifications\"\n    ko.hover=\"hover\"\n    ko.event.transitionend=\"onTransitionEnd\"\n>\n    <li class=\"notif row content-middle\" ko.css=\"css\">\n        <svg-icon class=\"notif-icon push-next-half\"\n            params=\"name: icon\"\n        ></svg-icon>\n        <span class=\"notif-text greedy\" ko.text=\"text\" ></span>\n    </li>\n</ul>\n";

},{}],496:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _notificationBox = _interopRequireDefault(require("./notification-box.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _actionCreators = require("action-creators");

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _promiseUtils = require("utils/promise-utils");

var _config = require("config");

/* Copyright (C) 2016 NooBaa */
const {
  minTimeOnScreen,
  charTimeContribution
} = _config.notifications;
const severityMapping = (0, _coreUtils.deepFreeze)({
  info: {
    css: 'info',
    icon: 'notif-info'
  },
  success: {
    css: 'success',
    icon: 'notif-success'
  },
  warning: {
    css: 'warning',
    icon: 'problem'
  },
  error: {
    css: 'error',
    icon: 'problem'
  }
});

class NotificationBarViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "notifications", _knockout.default.observableArray());
    (0, _defineProperty2.default)(this, "borders", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "visible", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "hover", _knockout.default.observable());
  }

  selectState(state) {
    return [(0, _coreUtils.get)(state, ['notifications', 'list', '0'])];
  }

  mapStateToProps(notif) {
    if (!notif) {
      this.visible(false);
      return;
    }

    const current = this.notifications.get(0);

    if (!current || current.id < notif.id) {
      this._processNotification(notif);

      this.visible(true);
    }
  }

  onTransitionEnd() {
    if (!this.visible() || this.notifications().length > 1) {
      this.notifications.shift();
    }
  }

  async _processNotification({
    id,
    severity,
    message
  }) {
    const next = { ...severityMapping[severity],
      id: id,
      text: message
    };
    this.notifications.push(next);

    if (this.notifications().length >= 1) {
      this.borders(`${next.css}-borders`);
    }

    await (0, _promiseUtils.all)((0, _promiseUtils.sleep)(minTimeOnScreen), (0, _promiseUtils.sleep)(charTimeContribution * message.length));
    await this.hover.when(_coreUtils.isFalsy);
    this.dispatch((0, _actionCreators.hideNotification)(id));
  }

}

var _default = {
  viewModel: NotificationBarViewModel,
  template: _notificationBox.default
};
exports.default = _default;

},{"./notification-box.html":495,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"config":831,"knockout":"knockout","utils/core-utils":1027,"utils/promise-utils":1039}],497:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<button class=\"icon-btn column content-middle no-focus-ring\"\n    tabindex=\"-1\"\n    ko.tooltip=\"{ text: 'Upload transactions', position: 'after' }\"\n    ko.click=\"onClick\"\n    ko.css.uploading=\"uploadCount\"\n    ko.attr=\"{ 'data-count': uploadCount }\"\n>\n    <svg-icon params=\"name: 'upload'\"></svg-icon>\n    <progress-bar class=\"push-both-half\" params=\"\n        progress: uploadProgress\n    \"></bar>\n\n    <span class=\"anim shrink-in\"\n        ko.visible=\"animatedCount\"\n        ko.event.animationend=\"onUploadAnimationEnd\"\n        ko.text=\"animatedCount\"\n    ></span>\n</button>\n";

},{}],498:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _uploadsIndicator = _interopRequireDefault(require("./uploads-indicator.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
class UploadsIndicatorViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "uploadCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "lastUploadTime", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "uploadProgress", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "animatedCount", _knockout.default.observable());
  }

  selectState(state) {
    return [state.objectUploads];
  }

  mapStateToProps(objectUploads) {
    const {
      stats,
      lastUpload
    } = objectUploads;
    const {
      batchSize,
      batchLoaded
    } = stats;
    const shouldUpdateAnimatedCount = !lastUpload.time || lastUpload.time > this.lastUploadTime();
    const progress = batchSize !== 0 ? batchLoaded / batchSize : 0;

    _knockout.default.assignToProps(this, {
      uploadCount: stats.uploading,
      lastUploadTime: lastUpload.time,
      uploadProgress: progress,
      animatedCount: shouldUpdateAnimatedCount ? lastUpload.objectCount : undefined
    });
  }

  onClick() {
    this.dispatch((0, _actionCreators.openFileUploadsModal)());
  }

  onUploadAnimationEnd() {
    this.animatedCount(0);
  }

}

var _default = {
  viewModel: UploadsIndicatorViewModel,
  template: _uploadsIndicator.default
};
exports.default = _default;

},{"./uploads-indicator.html":497,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout"}],499:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<section class=\"column push-next\">\n    <h2 class=\"heading3 pad card-shadow\">Contact Support</h2>\n    <property-sheet class=\"pad\" params=\"properties: contactInfoProps\">\n        <template name=\"link\">\n            <a class=\"link\"\n                ko.attr.href=\"href\"\n                ko.attr.target=\"target\"\n            >\n                {{text}}\n            </a>\n        </template>\n    </property-sheet>\n</section>\n<hr>\n<section class=\"column\">\n    <div class=\"row pad card-shadow content-middle\">\n        <div class=\"column greedy\">\n            <h2 class=\"heading3 greedy\">Diagnostics</h2>\n        </div>\n\n        <button class=\"btn align-start push-next\"\n            ko.click=\"onToggleDebugMode\"\n            ko.text=\"toggleDebugModeButtonText\"\n            ko.enable=\"dataReady\"\n        \"></button>\n        <working-button class=\"align-start push-next\" params=\"\n            working: isCollectDiagButtonLocked,\n            workingLabel: 'Collecting Data...',\n            click: onDownloadDiagnosticPack,\n            disabled: !dataReady()\n        \">\n            Download Diagnostics\n        </working-button>\n    </div>\n    <property-sheet class=\"pad\" params=\"properties: debugSheet\">\n        <template name=\"stateAndWarning\">\n            <p>\n                {{stateText}}\n                <span class=\"warning\"\n                    ko.visible=\"isWarningVisible\"\n                >\n                    (May cause system slowdown)\n                </span>\n            </p>\n        </template>\n    </property-sheet>\n\n</section>\n\n";

},{}],500:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _diagnosticsForm = _interopRequireDefault(require("./diagnostics-form.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _diagnosticUtils = require("utils/diagnostic-utils");

var _config = require("config");

var _knockout = _interopRequireDefault(require("knockout"));

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
class DiagnosticsFormViewModel extends _connectable.default {
  constructor(params, inject) {
    super(params, inject);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "ticker", 0);
    (0, _defineProperty2.default)(this, "inDebugMode", false);
    (0, _defineProperty2.default)(this, "timeLeft", 0);
    (0, _defineProperty2.default)(this, "toggleDebugModeButtonText", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isCollectDiagButtonLocked", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "contactInfoProps", [{
      label: 'By email',
      template: 'link',
      value: {
        href: `mailto:${_config.support.email}`,
        text: _config.support.email,
        target: false
      }
    }]);
    (0, _defineProperty2.default)(this, "debugSheet", [{
      label: 'Debug Mode',
      template: 'stateAndWarning',
      value: {
        stateText: _knockout.default.observable(),
        isWarningVisible: _knockout.default.observable()
      }
    }, {
      label: 'Time Left For Debugging',
      value: _knockout.default.observable(),
      disabled: _knockout.default.observable()
    }]);
    this.ticker = setInterval(() => this.onTick(), _config.timeTickInterval);
  }

  selectState(state) {
    const {
      system
    } = state;
    return [system && system.debug, system && system.diagnostics];
  }

  mapStateToProps(debugState, diagnosticsState) {
    if (!debugState || !diagnosticsState) {
      _knockout.default.assignToProps(this, {
        dataReady: false,
        toggleDebugModeButtonText: 'Turn On System Debug Mode'
      });
    } else {
      const {
        level,
        till
      } = debugState;
      const inDebugMode = level > 0;
      const timeLeft = Math.max(0, till - Date.now());
      const toggleDebugModeButtonText = `Turn ${inDebugMode ? 'Off' : 'On'} System Debug Mode`;
      const isCollectDiagButtonLocked = diagnosticsState.collecting;

      _knockout.default.assignToProps(this, {
        dataReady: true,
        inDebugMode,
        timeLeft,
        toggleDebugModeButtonText,
        isCollectDiagButtonLocked,
        debugSheet: [{
          value: {
            stateText: inDebugMode ? 'On' : 'Off',
            isWarningVisible: inDebugMode
          }
        }, {
          value: (0, _diagnosticUtils.formatTimeLeftForDebugMode)(inDebugMode, timeLeft),
          disabled: !inDebugMode
        }]
      });
    }
  }

  onTick() {
    if (this.inDebugMode) {
      const timeLeft = Math.max(0, this.timeLeft - _config.timeTickInterval);
      const formattedTimeLeft = (0, _diagnosticUtils.formatTimeLeftForDebugMode)(true, timeLeft);

      _knockout.default.assignToProps(this, {
        timeLeft,
        debugSheet: {
          1: {
            value: formattedTimeLeft
          }
        }
      });
    }
  }

  onToggleDebugMode() {
    const level = this.inDebugMode ? 0 : 5;
    this.dispatch((0, _actionCreators.setSystemDebugLevel)(level));
  }

  onDownloadDiagnosticPack() {
    this.dispatch((0, _actionCreators.collectSystemDiagnostics)());
  }

  dispose() {
    clearInterval(this.ticker);
    super.dispose();
  }

}

var _default = {
  viewModel: DiagnosticsFormViewModel,
  template: _diagnosticsForm.default
};
exports.default = _default;

},{"./diagnostics-form.html":499,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"config":831,"knockout":"knockout","utils/diagnostic-utils":1028}],501:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<section>\n    <div class=\"row content-middle cursor-pointer\"\n        ko.click=\"onToggleSection\"\n    >\n        <div class=\"column greedy\">\n            <h2 class=\"heading3 greedy\">\n                Maintenance\n            </h2>\n            <section class=\"row\" ko.visible=\"!isExpanded()\">\n                <p>\n                    Maintenance Mode:\n                    <span ko.text=\"stateText\"></span>\n                </p>\n                <!-- ko if: hasTimeLeft -->\n                <vr class=\"push-both\"></vr>\n                <p>\n                    Time left for maintenance: {{formattedTime}}\n                </p>\n                <!-- /ko -->\n            </section>\n            <p ko.visible=\"isExpanded\">\n                Automatically, NooBaa is running data rebuild operations (moving data between different nodes).\n            </p>\n        </div>\n        <svg-icon class=\"icon-small rotate push-next-half\"\n            ko.css=\"{ 'deg-90': !isExpanded() }\"\n            params=\"name: 'chevron'\"\n        ></svg-icon>\n    </div>\n    <div ko.expand=\"isExpanded\" class=\"column greedy\">\n        <p>\n            If you wish to set the system to a temporary state of maintenance and prevent high-level data rebuilding, turn on maintenance mode for the needed period of time.\n        </p>\n        <button class=\"btn align-start push-prev\"\n            ko.text=\"buttonText\"\n            ko.click=\"onToggleMaintenance\"\n        ></button>\n    </div>\n</section>\n\n";

},{}],502:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _maintenanceForm = _interopRequireDefault(require("./maintenance-form.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _maintenanceUtils = require("utils/maintenance-utils");

var _browserUtils = require("utils/browser-utils");

var routes = _interopRequireWildcard(require("routes"));

var _config = require("config");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const sectionName = 'maintenance';

class MaintenanceFormViewModel extends _connectable.default {
  constructor(params, inject) {
    super(params, inject);
    (0, _defineProperty2.default)(this, "dataReady", false);
    (0, _defineProperty2.default)(this, "toggleUri", '');
    (0, _defineProperty2.default)(this, "isExpanded", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "stateText", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "buttonText", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "timeLeft", 0);
    (0, _defineProperty2.default)(this, "hasTimeLeft", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "formattedTime", _knockout.default.observable());
    this.ticker = setInterval(() => this.onTick(), _config.timeTickInterval);
  }

  selectState(state) {
    const {
      system,
      location
    } = state;
    return [system && system.maintenanceMode, location];
  }

  mapStateToProps(maintenanceMode, location) {
    if (!maintenanceMode) {
      _knockout.default.assignToProps(this, {
        dataReady: false
      });
    } else {
      const timeLeft = Math.max(maintenanceMode.till - Date.now(), 0);
      const {
        system,
        section
      } = location.params;
      const toggleSection = section === sectionName ? undefined : sectionName;
      const toggleUri = (0, _browserUtils.realizeUri)(routes.management, {
        system,
        tab: 'settings',
        section: toggleSection
      });
      const stateText = timeLeft !== 0 ? 'On' : 'Off';
      const buttonText = `Turn maintenance ${timeLeft ? 'off' : 'on'}`;

      _knockout.default.assignToProps(this, {
        dataReady: true,
        toggleUri,
        isExpanded: section === sectionName,
        stateText,
        buttonText,
        timeLeft,
        hasTimeLeft: timeLeft > 0,
        formattedTime: (0, _maintenanceUtils.formatTimeLeftForMaintenanceMode)(timeLeft)
      });
    }
  }

  onToggleSection() {
    this.dispatch((0, _actionCreators.requestLocation)(this.toggleUri));
  }

  onToggleMaintenance() {
    const action = this.hasTimeLeft() ? (0, _actionCreators.leaveMaintenanceMode)() : (0, _actionCreators.openStartMaintenanceModal)();
    this.dispatch(action);
  }

  onTick() {
    if (!this.dataReady && this.timeLeft <= 0) {
      return;
    }

    const newTimeLeft = Math.max(this.timeLeft - _config.timeTickInterval, 0);

    _knockout.default.assignToProps(this, {
      timeLeft: newTimeLeft,
      hasTimeLeft: newTimeLeft > 0,
      formattedTime: (0, _maintenanceUtils.formatTimeLeftForMaintenanceMode)(newTimeLeft)
    });
  }

  dispose() {
    clearInterval(this.ticker);
    super.dispose();
  }

}

var _default = {
  viewModel: MaintenanceFormViewModel,
  template: _maintenanceForm.default
};
exports.default = _default;

},{"./maintenance-form.html":501,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"components/connectable":446,"config":831,"knockout":"knockout","routes":972,"utils/browser-utils":1021,"utils/maintenance-utils":1035}],503:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"greedy tabs\">\n    <nav>\n        <a ko.css.selected=\"selectedTab.eq('settings')\"\n            ko.attr.href=\"tabHref('settings')\"\n        >\n            Configuration\n        </a>\n        <a ko.css.selected=\"selectedTab.eq('diagnostics')\"\n            ko.attr.href=\"tabHref('diagnostics')\"\n        >\n            Support &amp; Diagnostics\n        </a>\n        <a ko.css.selected=\"selectedTab.eq('version')\"\n            ko.attr.href=\"tabHref('version')\"\n        >\n            Version\n        </a>\n    </nav>\n\n    <div class=\"tabs-row\">\n        <section class=\"tab\"\n            ko.css.selected=\"selectedTab.eq('settings')\"\n        >\n            <virtual-hosting-form class=\"pad\">This should not be visible</virtual-hosting-form>\n            <hr />\n\n<!--        Hide until we re-implement cert uploding into a k8s secret.\n             <ssl-certificate-form class=\"pad\"></ssl-certificate-form>\n            <hr /> -->\n            <maintenance-form class=\"pad\"></maintenance-form>\n        </section>\n\n        <diagnostics-form class=\"tab\"\n            ko.css.selected=\"selectedTab.eq('diagnostics')\"\n        ></diagnostics-form>\n\n        <version-form class=\"tab\"\n            ko.css.selected=\"selectedTab.eq('version')\"\n        ></version-form>\n    </div>\n</div>\n";

},{}],504:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _managementPanel = _interopRequireDefault(require("./management-panel.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _browserUtils = require("utils/browser-utils");

/* Copyright (C) 2016 NooBaa */
class ManagementPanelViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "baseRoute", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "selectedTab", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "selectedSection", _knockout.default.observable());
  }

  selectState(state) {
    return [state.location];
  }

  mapStateToProps(location) {
    const {
      system,
      tab = 'settings',
      section
    } = location.params;

    _knockout.default.assignToProps(this, {
      baseRoute: (0, _browserUtils.realizeUri)(location.route, {
        system
      }, {}, true),
      selectedTab: tab,
      selectedSection: section || ''
    });
  }

  tabHref(tab) {
    return this.baseRoute() && (0, _browserUtils.realizeUri)(this.baseRoute(), {
      tab
    });
  }

}

var _default = {
  viewModel: ManagementPanelViewModel,
  template: _managementPanel.default
};
exports.default = _default;

},{"./management-panel.html":503,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"components/connectable":446,"knockout":"knockout","utils/browser-utils":1021}],505:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n<section>\n    <div class=\"row content-middle cursor-pointer\"\n         ko.click=\"onToggleSection\"\n    >\n        <div class=\"column greedy\">\n            <h2 class=\"heading3 greedy\">\n                Peer to Peer Settings\n                <dirty-mark ko.visible=\"isDirtyMarkerVisible\"></dirty-mark>\n            </h2>\n            <p ko.visible=\"!isExpanded()\">\n                {{summary}}\n            </p>\n            <p ko.visible=\"isExpanded\">\n                Transport layer protocols, such as the Transmission Control Protocol (TCP) and User Datagram Protocol (UDP),\n                specify a source and destination port number in their segment headers.\n            </p>\n        </div>\n        <svg-icon class=\"icon-small rotate push-next-half\"\n            ko.css=\"{ 'deg-90': !isExpanded() }\"\n            params=\"name: 'chevron'\"\n        ></svg-icon>\n    </div>\n    <div ko.expand=\"isExpanded\">\n        <managed-form params=\"\n            name: formName,\n            fields: fields,\n            onValidate: onValidate,\n            onSubmit: onSubmit\n        \">\n            <editor params=\"label: 'Configuration Type'\">\n                <radio-group params=\"\n                    options: portOptions,\n                    selected: $form.rangeType,\n                \"></radio-group>\n            </editor>\n\n            <!-- ko if: $form.rangeType.eq('SINGLE') -->\n            <editor params=\"label: 'Port Number'\">\n                <input type=\"number\"\n                    min=\"1\"\n                    ko.value=\"$form.rangeStart\"\n                    ko.validationCss=\"$form.rangeStart\",\n                />\n                <validation-message params=\"field: $form.rangeStart\"></validation-message>\n            </editor>\n            <!-- /ko -->\n            <!-- ko if: $form.rangeType.eq('RANGE') -->\n            <editor params=\"label: 'Port Range'\">\n                <div class=\"row content-middle\">\n                    <input type=\"number\"\n                        min=\"1\"\n                        ko.value=\"$form.rangeStart\"\n                        ko.validationCss=\"$form.rangeStart\"\n                    />\n                    <span class=\"push-both\"> - </span>\n                    <input type=\"number\"\n                        ko.value=\"$form.rangeEnd\"\n                        ko.attr.min=\"minRangeEnd\"\n                        ko.validationCss=\"$form.rangeEnd\"\n                    />\n                </div>\n                <validation-message params=\"field: $form.rangeStart\"></validation-message>\n                <validation-message\n                    ko.visible=\"$form.rangeStart.isValid()\"\n                    params=\"field: $form.rangeEnd\"\n                ></validation-message>\n            </editor>\n            <!-- /ko -->\n\n            <p class=\"push-both\">\n                In order the guarantee node to node communication add the following exception to your Firewall/NAT:\n            </p>\n\n            <div class=\"content-box pad config push-next align-start\">\n                <span>\n                    <span class=\"highlight\">Source:</span>\n                    <output class=\"text-tech\">any</output>\n                </span>\n                <span>\n                    <span class=\"highlight\">Destination:</span>\n                    <output class=\"text-tech\">any</output>\n                </span>\n                <span>\n                    <span class=\"highlight\">Protocol:</span>\n                    <output class=\"text-tech\">TCP</output>\n                </span>\n                <span>\n                    <span class=\"highlight\">Ports:</span>\n                    <output class=\"text-tech\" ko.value=\"summary.value\"></output>\n                </span>\n                <span>\n                    <span class=\"highlight\">Description:</span>\n                    <output class=\"text-tech\">NooBaa</output>\n                </span>\n            </div>\n\n            <div class=\"push-both remark\">\n                <span> Please note </span>\n                <ul class=\"bullet-list\">\n                    <li>TCP ports should be manually opened in firewalls/NATs in order to be reachable</li>\n                    <li>Connections are secured using SSL</li>\n                    <li>In any case if TCP will not be reachable, UDP will be used as fallback, which is capable of bypassing firewalls/NATs, assuming UDP is allowed in your network</li>\n                </ul>\n            </div>\n\n            <button class=\"btn align-start push-prev\"\n                ko.shakeOnClick=\"!$form.isValid()\"\n            >\n                Update\n            </button>\n        </managed-form>\n    </div>\n</section>\n";

},{}],506:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _p2pForm = _interopRequireDefault(require("./p2p-form.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _netUtils = require("utils/net-utils");

var _formUtils = require("utils/form-utils");

var _browserUtils = require("utils/browser-utils");

var routes = _interopRequireWildcard(require("routes"));

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const sectionName = 'p2p';
const portOptions = [{
  label: 'Single Port',
  value: 'SINGLE'
}, {
  label: 'Port Range',
  value: 'RANGE'
}];

class P2PFormViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "formName", this.constructor.name);
    (0, _defineProperty2.default)(this, "portOptions", portOptions);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isExpanded", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isDirtyMarkerVisible", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "toggleUri", '');
    (0, _defineProperty2.default)(this, "summary", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "minRangeEnd", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "fields", _knockout.default.observable());
  }

  selectState(state) {
    const {
      system,
      forms,
      location
    } = state;
    return [system && system.p2pSettings, location, forms[this.formName]];
  }

  mapStateToProps(p2pSettings, location, form) {
    if (!p2pSettings) {
      _knockout.default.assignToProps(this, {
        dataReady: false,
        isExpanded: false,
        summary: 'Port Number: '
      });
    } else {
      const {
        system,
        tab,
        section
      } = location.params;
      const toggleSection = section === sectionName ? undefined : sectionName;
      const toggleUri = (0, _browserUtils.realizeUri)(routes.management, {
        system,
        tab,
        section: toggleSection
      });
      const rangeStart = form ? (0, _formUtils.getFieldValue)(form, 'rangeStart') : p2pSettings.tcpPortRange.start;
      const rangeEnd = form ? (0, _formUtils.getFieldValue)(form, 'rangeEnd') : p2pSettings.tcpPortRange.end;
      const rangeType = form ? (0, _formUtils.getFieldValue)(form, 'rangeType') : rangeStart === rangeEnd ? 'SINGLE' : 'RANGE';
      const summary = rangeType === 'SINGLE' ? `Port Number: ${rangeStart}` : `Port Range: ${rangeStart}-${rangeEnd}`;

      _knockout.default.assignToProps(this, {
        dataReady: true,
        toggleUri,
        isExpanded: section === sectionName,
        summary,
        isDirtyMarkerVisible: form ? (0, _formUtils.isFormDirty)(form) : false,
        minRangeEnd: Math.max(rangeStart + 1, 1),
        fields: !form ? {
          rangeType,
          rangeStart,
          rangeEnd
        } : undefined
      });
    }
  }

  onToggleSection() {
    this.dispatch((0, _actionCreators.requestLocation)(this.toggleUri));
  }

  onValidate(values) {
    const {
      rangeType,
      rangeStart,
      rangeEnd
    } = values;
    const errors = {};

    if (!(0, _netUtils.isPortNumber)(rangeStart)) {
      errors.rangeStart = 'Please enter a valid port number';
    }

    if (rangeType === 'RANGE') {
      if (!(0, _netUtils.isPortNumber)(rangeEnd)) {
        errors.rangeEnd = 'Please enter a valid port number';
      } else if (rangeEnd <= rangeStart) {
        errors.rangeEnd = `Please enter a port number bigger then ${rangeStart}`;
      }
    }

    return errors;
  }

  onSubmit(values) {
    const tcpPortRange = {
      start: values.rangeStart,
      end: values.rangeType === 'SINGLE' ? values.rangeStart : values.rangeEnd
    };
    this.dispatch((0, _actionCreators.updateP2PSettings)(tcpPortRange));
  }

}

var _default = {
  viewModel: P2PFormViewModel,
  template: _p2pForm.default
};
exports.default = _default;

},{"./p2p-form.html":505,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"components/connectable":446,"knockout":"knockout","routes":972,"utils/browser-utils":1021,"utils/form-utils":1030,"utils/net-utils":1036}],507:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<section>\n    <div class=\"row content-middle cursor-pointer\"\n        ko.click=\"onToggleSection\"\n    >\n        <div class=\"column greedy\">\n            <h2 class=\"heading3 greedy\">\n                SSL Certificate\n            </h2>\n            <section class=\"row\" ko.visible=\"!isExpanded()\">\n                <p ko.visible=\"isCertInstalled\">\n                    Customer SSL certificate installed\n                </p>\n                <p ko.visible=\"!isCertInstalled()\">\n                    Using self-signed SSL certificate\n                </p>\n            </section>\n            <p ko.visible=\"isExpanded\">\n                Please upload a zip containing only two files without any folders, certificate (.cert) and private key (.key) in pem format.\n            </p>\n        </div>\n        <svg-icon class=\"icon-small rotate push-next-half\"\n            ko.css=\"{ 'deg-90': !isExpanded() }\"\n            params=\"name: 'chevron'\"\n        ></svg-icon>\n    </div>\n    <div ko.expand=\"isExpanded\" class=\"column\">\n        <drop-area class=\"push-prev-half push-next align-left\"\n            params=\"\n                onDrop: onDropCertPkg,\n                active: isCertUploading\n            \"\n        >\n            <!-- ko if: isCertUploading -->\n            <p ko.visible=\"isCertUploading\">\n                <svg-icon class=\"icon-small match-theme spin\" params=\"name: 'in-progress'\"></svg-icon>\n                {{uploadText}}\n            </p>\n            <!-- /ko -->\n\n            <!-- ko ifnot: isCertUploading -->\n            <div class=\"column content-middle\">\n                <!-- ko if: isCertInstalled -->\n                <p>A customer provided SSL certificate is installed</p>\n                 <label\n                    class=\"link alt-colors\"\n                    tabindex=\"0\"\n                    ko.keysToClicks=\"['space', 'enter']\"\n                >\n                    Replace with another certificate\n                    <input type=\"file\" class=\"hide\"\n                        tabindex=\"-1\"\n                        ko.attr.accept=\"sslCertificateSuffix\"\n                        ko.event.change=\"onSelectCrtPkg\"\n                    />\n                </label>\n                <!-- /ko -->\n                <!-- ko ifnot: isCertInstalled -->\n                <p class=\"push-next\">Drag an SSL certificate here or</p>\n                <label class=\"btn alt-colors\"\n                    tabindex=\"0\"\n                    ko.keysToClicks=\"['space', 'enter']\"\n                >\n                    Browse\n                    <input type=\"file\"\n                        tabindex=\"-1\"\n                        class=\"hide\"\n                        ko.attr.accept=\"sslCertificateSuffix\"\n                        ko.event.change=\"onSelectCrtPkg\"\n                    />\n                </label>\n                <!-- /ko -->\n            </div>\n            <!-- /ko -->\n        </drop-area>\n    </div>\n</section>\n";

},{}],508:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _sslCertificateForm = _interopRequireDefault(require("./ssl-certificate-form.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _numeral = _interopRequireDefault(require("numeral"));

var _config = require("config");

var _coreUtils = require("utils/core-utils");

var _browserUtils = require("utils/browser-utils");

var routes = _interopRequireWildcard(require("routes"));

var _services = require("services");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const sectionName = 'server-ssl';

class SSLCertificateFormViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "formName", this.constructor.name);
    (0, _defineProperty2.default)(this, "sslCertificateSuffix", _config.sslCertificateSuffix);
    (0, _defineProperty2.default)(this, "toggleUri", '');
    (0, _defineProperty2.default)(this, "isExpanded", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isCertInstalled", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isCertUploading", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "uploadText", _knockout.default.observable());
  }

  selectState(state) {
    const {
      system,
      forms,
      location
    } = state;
    return [system && system.sslCert, forms[this.formName], location];
  }

  mapStateToProps(sslCert, form, location) {
    if (!sslCert) {
      return;
    }

    const {
      system,
      section
    } = location.params;
    const toggleSection = section === sectionName ? undefined : sectionName;
    const toggleUri = (0, _browserUtils.realizeUri)(routes.management, {
      system,
      tab: 'settings',
      section: toggleSection
    });

    _knockout.default.assignToProps(this, {
      toggleUri,
      isExpanded: section === sectionName,
      isCertInstalled: sslCert.installed,
      isCertUploading: (0, _coreUtils.hasOwn)(sslCert, 'uploadProgress'),
      uploadText: `Uploading cartificate ${(0, _numeral.default)(sslCert.uploadProgress).format('%')}`
    });
  }

  onToggleSection() {
    this.dispatch((0, _actionCreators.requestLocation)(this.toggleUri));
  }

  onDropCertPkg(_, evt) {
    const [pkg] = evt.dataTransfer.files;
    return this._uploadCertPkg(pkg);
  }

  onSelectCrtPkg(_, evt) {
    const [pkg] = evt.target.files;
    return this._uploadCertPkg(pkg);
  }

  async _uploadCertPkg(pkg) {
    const buffer = await (0, _browserUtils.readFileAsArrayBuffer)(pkg);

    const bufferKey = _services.bufferStore.store(buffer);

    this.dispatch((0, _actionCreators.uploadSSLCertificate)(bufferKey));
  }

}

var _default = {
  viewModel: SSLCertificateFormViewModel,
  template: _sslCertificateForm.default
};
exports.default = _default;

},{"./ssl-certificate-form.html":507,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"components/connectable":446,"config":831,"knockout":"knockout","numeral":"numeral","routes":972,"services":1013,"utils/browser-utils":1021,"utils/core-utils":1027}],509:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<h2 class=\"heading3 pad card-shadow\">\n    Version Control\n</h1>\n\n<property-sheet class=\"pad\" params=\"\n    loading: !dataReady(),\n    properties: versionInfo\n\">\n    <template name=\"licenseInfo\">\n        Available |\n        <a class=\"link\" target=\"_blank\" href=\"/public/license-info\">\n            See details\n        </a>\n    </template>\n</property-sheet>\n\n";

},{}],510:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _versionForm = _interopRequireDefault(require("./version-form.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _config = require("config");

var _knockout = _interopRequireDefault(require("knockout"));

var _moment = _interopRequireDefault(require("moment"));

// Copyright (C) 2016 NooBaa
class VersionFormViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "versionInfo", [{
      label: 'Current Version',
      value: _knockout.default.observable()
    }, {
      label: 'Last Upgrade',
      value: _knockout.default.observable()
    }, {
      label: 'Automatic Upgrade',
      value: 'Upgraded via the operator'
    }, {
      label: 'Version Information',
      value: true,
      template: 'licenseInfo',
      visible: false
    }, {
      label: 'License Information',
      value: true,
      template: 'licenseInfo'
    }]);
  }

  selectState(state) {
    return [state.system];
  }

  mapStateToProps(system) {
    if (!system) {
      _knockout.default.assignToProps(this, {
        dataReady: false
      });
    } else {
      const {
        version,
        upgrade
      } = system;
      const lastUpgradeText = upgrade.lastUpgrade ? (0, _moment.default)(upgrade.lastUpgrade.time).format(_config.timeShortFormat) : 'System has never been upgraded';

      _knockout.default.assignToProps(this, {
        dataReady: true,
        versionInfo: [{
          value: version
        }, {
          value: lastUpgradeText
        }]
      });
    }
  }

}

var _default = {
  viewModel: VersionFormViewModel,
  template: _versionForm.default
};
exports.default = _default;

},{"./version-form.html":509,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"components/connectable":446,"config":831,"knockout":"knockout","moment":"moment"}],511:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<section>\n    <div class=\"row content-middle cursor-pointer\"\n        ko.click=\"onToggleSection\"\n    >\n        <div class=\"column greedy\">\n            <h2 class=\"heading3 greedy\">\n                Virtual Hosting\n            </h2>\n            <section class=\"row\" ko.visible=\"!isExpanded()\">\n                <p>\n                    <span class=\"valign-middle\">Internal name:</span>\n                    <span class=\"summary-value\">{{internalEndpoint}}</span>\n                </p>\n                <vr class=\"push-both\"></vr>\n                <p>\n                    <span class=\"valign-middle\">External name:</span>\n                    <span class=\"summary-value\">{{externalEndpoint}}<span>\n                </p>\n            </section>\n            <p ko.visible=\"isExpanded\">\n                Configuring DNS in NooBaa is useful for achieving high availability on installed agents or for working with bucket virtual domains\n            </p>\n        </div>\n        <svg-icon class=\"icon-small rotate push-next-half\"\n            ko.css=\"{ 'deg-90': !isExpanded() }\"\n            params=\"name: 'chevron'\"\n        ></svg-icon>\n    </div>\n    <div class=\"column greedy\" ko.expand=\"isExpanded\">\n        <property-sheet class=\"vpad\" params=\"properties: endpointProps\"></property-sheet>\n    </div>\n</section>\n";

},{}],512:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _virtualHostingForm = _interopRequireDefault(require("./virtual-hosting-form.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _browserUtils = require("utils/browser-utils");

var _coreUtils = require("utils/core-utils");

var _knockout = _interopRequireDefault(require("knockout"));

var routes = _interopRequireWildcard(require("routes"));

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const sectionName = 'virutal-hosting';

class VirtualHostingFormViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "toggleUri", '');
    (0, _defineProperty2.default)(this, "isExpanded", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "internalEndpoint", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "externalEndpoint", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "endpointProps", [{
      label: 'Cluster Internal name',
      value: this.internalEndpoint
    }, {
      label: 'Cluster External name',
      value: this.externalEndpoint
    }]);
  }

  selectState(state) {
    const {
      system,
      location
    } = state;
    return [system && system.s3Addresses, location];
  }

  mapStateToProps(s3Addresses, location) {
    if (!s3Addresses) {
      _knockout.default.assignToProps(this, {
        dataReady: false
      });
    } else {
      const {
        system,
        section
      } = location.params;
      const toggleSection = section === sectionName ? undefined : sectionName;
      const toggleUri = (0, _browserUtils.realizeUri)(routes.management, {
        system,
        tab: 'settings',
        section: toggleSection
      });
      const endpointByKind = (0, _coreUtils.keyByProperty)(s3Addresses, 'kind', endpoint => endpoint.address);

      _knockout.default.assignToProps(this, {
        dataReady: true,
        toggleUri,
        isExpanded: section === sectionName,
        internalEndpoint: endpointByKind['INTERNAL'],
        externalEndpoint: endpointByKind['EXTERNAL']
      });
    }
  }

  onToggleSection() {
    this.dispatch((0, _actionCreators.requestLocation)(this.toggleUri));
  }

}

var _default = {
  viewModel: VirtualHostingFormViewModel,
  template: _virtualHostingForm.default
};
exports.default = _default;

},{"./virtual-hosting-form.html":511,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"components/connectable":446,"knockout":"knockout","routes":972,"utils/browser-utils":1021,"utils/core-utils":1027}],513:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"column greedy pad\">\n    <p class=\"highlight push-next-half\">\n        Copy and send the following information to the account owner or connect an application:\n    </p>\n\n    <div class=\"content-box pad row content-start greedy\">\n        <pre class=\"greedy message\" ko.html=\"message\"></pre>\n        <copy-to-clipboard-button params=\"value: message\"></copy-to-clipboard-button>\n    </div>\n</div>\n\n<div class=\"content-box pad column content-end\">\n    <button class=\"btn align-end\"\n        ko.click=\"onDone\"\n    >\n        Done\n    </button>\n\n</div>\n";

},{}],514:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _accountCreatedModal = _interopRequireDefault(require("./account-created-modal.html"));

var _accountDetailsMessage = _interopRequireDefault(require("./account-details-message.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
class AccountCreatedModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "serverAddress", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "message", _knockout.default.observable());
  }

  selectState(state, params) {
    const {
      accounts,
      location,
      system
    } = state;
    return [accounts[params.accountName], params.password, location.hostname, system.sslPort];
  }

  mapStateToProps(account, password, endpoint, sslPort) {
    const {
      name,
      isAdmin,
      accessKeys
    } = account;

    const message = _knockout.default.renderToString(_accountDetailsMessage.default, {
      serverAddress: `https://${endpoint}:${sslPort}`,
      username: isAdmin ? name : '',
      password: isAdmin ? password : '',
      accessKey: accessKeys.accessKey,
      secretKey: accessKeys.secretKey
    });

    _knockout.default.assignToProps(this, {
      message
    });
  }

  onDone() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

}

var _default = {
  viewModel: AccountCreatedModalViewModel,
  template: _accountCreatedModal.default
};
exports.default = _default;

},{"./account-created-modal.html":513,"./account-details-message.html":515,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout"}],515:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\nHi, I created a NooBaa user for you:\n<!-- ko if: username && password -->\n<span class=\"highlight\">Use the following credentials to connect to the NooBaa console:</span>\n<span>Console Url: {{serverAddress}}</span>\n<span>Username: {{username}}</span>\n<span>Password: {{password}}</span>\n<!-- /ko --><!-- ko if: accessKey && secretKey -->\n<span class=\"highlight\">Use the following S3 access to connect an S3 compatible application to NooBaa:</span>\n<span>Access Key: {{accessKey}}</span>\n<span>Secret Key: {{secretKey}}</span>\n<!-- /ko -->\n";

},{}],516:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<managed-form class=\"column greedy\" params=\"\n    name: formName,\n    fields: fields,\n    onValidate: onValidate,\n    onValidateSubmit: values => onValidateSubmit(values, existingTriggers),\n    onSubmit: onSubmit\n\">\n    <div class=\"column greedy hpad pad-top\">\n        <p>Triggers will automatically invoke the selected function.</p>\n\n        <!-- ko if: bucketOptions -->\n        <editor params=\"label: 'Bucket'\">\n            <dropdown params=\"\n                    options: bucketOptions,\n                    selected: $form.bucket,\n                    placeholder: 'Choose Bucket',\n                    hasFocus: true\n                \"\n                ko.validationCss=\"$form.bucket\"\n            ></dropdown>\n            <validation-message params=\"field: $form.bucket\"></validation-message>\n        </editor>\n        <!-- /ko -->\n\n        <!-- ko if: funcOptions -->\n        <editor params=\"label: 'Function'\">\n            <dropdown params=\"\n                    filter: true,\n                    actions: funcActions,\n                    options: funcOptions,\n                    selected: $form.func,\n                    placeholder: 'Choose Function',\n                    hasFocus: true\n                \"\n                ko.validationCss=\"$form.func\"\n            ></dropdown>\n            <validation-message params=\"field: $form.func\"></validation-message>\n        </editor>\n        <!-- /ko -->\n\n        <editor params=\"label: 'Event Type'\">\n            <dropdown params=\"\n                    options: eventOptions,\n                    selected: $form.event,\n                    placeholder: 'Choose Event'\n                \"\n                ko.validationCss=\"$form.event\"\n            ></dropdown>\n            <validation-message params=\"field: $form.event\"></validation-message>\n        </editor>\n\n        <editor params=\"label: 'Prefix'\">\n            <input type=\"text\"\n                placeholder=\"e.g. Images/\"\n                ko.value=\"$form.prefix\"\n                ko.validationCss=\"$form.prefix\"\n            />\n            <p class=\"hint\">optional</p>\n        </editor>\n\n        <editor params=\"label: 'Suffix'\">\n            <input type=\"text\"\n                placeholder=\"e.g. .jpg\"\n                ko.value=\"$form.suffix\"\n                ko.validationCss=\"$form.suffix\"\n            />\n            <p class=\"hint\">optional</p>\n        </editor>\n\n        <editor params=\"label: 'Trigger Active'\">\n            <toggle-switch params=\"value: $form.active\"></toggle-switch>\n        </editor>\n    </div>\n\n    <div class=\"row content-middle pad content-box\">\n        <div class=\"row content-middle greedy push-next remark\">\n            <!-- ko if: $form.errors().global -->\n            <svg-icon class=\"error icon-small push-next-half\" params=\"name: 'problem'\"></svg-icon>\n            <p class=\"error\">{{$form.errors().global}}</p>\n            <!-- /ko -->\n       </div>\n        <button type=\"button\"\n            class=\"link alt-colors push-next\"\n            ko.click=\"onCancel\"\n       >\n            Cancel\n        </button>\n        <button class=\"btn\" ko.shakeOnClick=\"!$form.isValid()\">\n            Save\n        </button>\n    </div>\n</managed-form>\n\n";

},{}],517:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _addBucketTriggerModal = _interopRequireDefault(require("./add-bucket-trigger-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _bucketUtils = require("utils/bucket-utils");

var _funcUtils = require("utils/func-utils");

var _knockout = _interopRequireDefault(require("knockout"));

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _mapDataBucketOption(bucket) {
  return {
    value: bucket.name,
    remark: 'Data bucket'
  };
}

function _mapNamespaceBucketOption(bucket) {
  return {
    value: bucket.name,
    remark: 'Namespace bucket'
  };
}

class AddBucketTriggerModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "formName", this.constructor.name);
    (0, _defineProperty2.default)(this, "bucketName", '');
    (0, _defineProperty2.default)(this, "existingTriggers", null);
    (0, _defineProperty2.default)(this, "eventOptions", _bucketUtils.bucketEvents);
    (0, _defineProperty2.default)(this, "bucketOptions", _knockout.default.observableArray());
    (0, _defineProperty2.default)(this, "funcActions", [{
      label: 'Create new function',
      onClick: () => this.onCreateNewFunction()
    }]);
    (0, _defineProperty2.default)(this, "funcOptions", _knockout.default.observableArray());
    (0, _defineProperty2.default)(this, "fields", _knockout.default.observable());
  }

  selectState(state, params) {
    return [params.bucketName, params.funcId, state.buckets, state.namespaceBuckets, state.bucketTriggers, state.functions, state.accounts, Boolean(state.forms && state.forms[this.formName])];
  }

  mapStateToProps(bucketName, funcId, buckets, namespaceBuckets, triggers, funcs, accounts, isFormInitialized) {
    if (!buckets || !namespaceBuckets || !triggers || !funcs || !accounts) {
      return;
    }

    _knockout.default.assignToProps(this, {
      bucketName,
      existingTriggers: Object.values(triggers),
      bucketOptions: bucketName ? null : [...Object.values(buckets).map(_mapDataBucketOption), ...Object.values(namespaceBuckets).map(_mapNamespaceBucketOption)],
      funcOptions: funcId ? null : Object.values(funcs).map(func => (0, _funcUtils.getFunctionOption)(func, accounts, bucketName)),
      fields: !isFormInitialized ? {
        bucket: bucketName || '',
        func: funcId || '',
        event: '',
        prefix: '',
        suffix: '',
        active: true
      } : undefined
    });
  }

  onValidate(values) {
    const errors = {};
    const {
      event,
      func
    } = values;

    if (!func) {
      errors.func = 'Please select a function';
    }

    if (!event) {
      errors.event = 'Please select an event type';
    }

    return errors;
  }

  async onValidateSubmit(values, existingTriggers) {
    const errors = {};
    const {
      event,
      func,
      prefix,
      suffix,
      bucket
    } = values;
    const [funcName, funcVersion] = func.split(':');
    const unique = existingTriggers.every(trigger => trigger.bucket.name !== bucket || trigger.func.name !== funcName || trigger.func.version !== funcVersion || trigger.event !== event || trigger.prefix !== prefix || trigger.suffix !== suffix);

    if (!unique) {
      errors.bucket = errors.event = errors.func = errors.prefix = errors.suffix = '';
      errors.global = 'A trigger with the same setting already exists';
    }

    return errors;
  }

  onSubmit(values) {
    const [funcName, funcVersion] = values.func.split(':');
    const config = {
      bucket: values.bucket,
      funcName: funcName,
      funcVersion: funcVersion,
      event: values.event,
      prefix: values.prefix,
      suffix: values.suffix,
      enabled: values.active
    };
    this.dispatch((0, _actionCreators.closeModal)(), (0, _actionCreators.addBucketTrigger)(config));
  }

  onCreateNewFunction() {
    this.dispatch((0, _actionCreators.openCreateFuncModal)());
  }

  onCancel() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

}

var _default = {
  viewModel: AddBucketTriggerModalViewModel,
  template: _addBucketTriggerModal.default
};
exports.default = _default;

},{"./add-bucket-trigger-modal.html":516,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout","utils/bucket-utils":1022,"utils/func-utils":1031}],518:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<managed-form class=\"column greedy\" params=\"\n    name: formName,\n    fields: fields,\n    asyncTriggers: asyncTriggers,\n    onValidate: values => onValidate(values, existingConnections),\n    onValidateAsync: onValidateAsync,\n    onSubmit: onSubmit\n\">\n    <div class=\"column greedy pad\">\n        <editor params=\"label: 'Connection Name'\">\n            <input type=\"text\"\n                placeholder=\"Enter name\"\n                ko.value=\"$form.connectionName\",\n                ko.hasFocus=\"true\"\n                ko.validationCss=\"$form.connectionName\"\n            />\n            <validation-message params=\"field: $form.connectionName\"></validation-message>\n        </editor>\n\n        <editor params=\"label: 'Service'\">\n            <dropdown params=\"\n                options: serviceOptions,\n                selected: $form.service,\n                disabled: $form.isValidating\n            \"></dropdown>\n        </editor>\n\n        <!-- ko with: subTemplate -->\n        <!-- ko template: { html: $data, data: $parent } --><!-- /ko -->\n        <!-- /ko -->\n    </div>\n\n    <div class=\"row content-middle pad content-box\">\n        <div class=\"greedy\">\n            <p class=\"row content-middle error\" ko.visible=\"globalError\">\n                Somthing went wrong\n                <svg-icon class=\"icon-small push-prev-half\"\n                    ko.tooltip=\"{ text: globalError, breakWords: true }\",\n                    params=\"name: 'notif-info'\"\n                ></svg-icon>\n            </p>\n        </div>\n        <button type=\"button\" class=\"link alt-colors push-next\" ko.click=\"onCancel\">\n            Cancel\n        </button>\n        <button class=\"btn\" ko.shakeOnClick=\"!$form.isValid()\">\n            Save\n        </button>\n    </div>\n</managed-form>\n";

},{}],519:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _addCloudConnectionModal = _interopRequireDefault(require("./add-cloud-connection-modal.html"));

var _awsFields = _interopRequireDefault(require("./aws-fields.html"));

var _azureFields = _interopRequireDefault(require("./azure-fields.html"));

var _s3V2CompatibleFields = _interopRequireDefault(require("./s3-v2-compatible-fields.html"));

var _s3V4CompatibleFields = _interopRequireDefault(require("./s3-v4-compatible-fields.html"));

var _ibmFields = _interopRequireDefault(require("./ibm-fields.html"));

var _netStorageFields = _interopRequireDefault(require("./net-storage-fields.html"));

var _googleCloudFields = _interopRequireDefault(require("./google-cloud-fields.html"));

var _flashbladeFields = _interopRequireDefault(require("./flashblade-fields.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _formUtils = require("utils/form-utils");

var _browserUtils = require("utils/browser-utils");

var _promiseUtils = require("utils/promise-utils");

var _cloudUtils = require("utils/cloud-utils");

var _actionCreators = require("action-creators");

var _services = require("services");

/* Copyright (C) 2016 NooBaa */
const nameRegExp = /^Connection (\d+)$/;
const defaultService = 'AWS';
const gcEndpoint = (0, _cloudUtils.getCloudServiceMeta)('GOOGLE').defaultEndpoint;
const gcValidateFailureMessage = 'Try to regenerate and upload a new file';

const serviceOptions = _cloudUtils.cloudServices.map(service => ({
  value: service.value,
  label: service.displayName,
  icon: service.icon,
  selectedIcon: service.selectedIcon,
  remark: service.defaultEndpoint || 'No default endpoint'
}));

const templates = (0, _coreUtils.deepFreeze)({
  AWS: _awsFields.default,
  AZURE: _azureFields.default,
  S3_V2_COMPATIBLE: _s3V2CompatibleFields.default,
  S3_V4_COMPATIBLE: _s3V4CompatibleFields.default,
  NET_STORAGE: _netStorageFields.default,
  GOOGLE: _googleCloudFields.default,
  FLASHBLADE: _flashbladeFields.default,
  IBM_COS: _ibmFields.default
});
const asyncTriggers = (0, _coreUtils.deepFreeze)(['service', 'awsEndpoint', 'awsAccessKey', 'awsSecretKey', 'azureEndpoint', 'azureAccountName', 'azureAccountKey', 's3v2Endpoint', 's3v2AccessKey', 's3v2SecretKey', 's3v4Endpoint', 's3v4AccessKey', 's3v4SecretKey', 'nsHostname', 'nsStorageGroup', 'nsKeyName', 'nsCPCode', 'nsAuthKey', 'gcKeysFileName', 'gcKeysJson', 'fbEndpoint', 'fbAccessKey', 'fbSecretKey', 'ibmEndpoint', 'ibmAccessKey', 'ibmSecretKey']);
const s3LikeConnKeyMappings = (0, _coreUtils.deepFreeze)({
  AWS: {
    endpoint: 'awsEndpoint',
    accessKey: 'awsAccessKey',
    secretKey: 'awsSecretKey'
  },
  S3_V2_COMPATIBLE: {
    endpoint: 's3v2Endpoint',
    accessKey: 's3v2AccessKey',
    secretKey: 's3v2SecretKey'
  },
  S3_V4_COMPATIBLE: {
    endpoint: 's3v4Endpoint',
    accessKey: 's3v4AccessKey',
    secretKey: 's3v4SecretKey'
  },
  FLASHBLADE: {
    endpoint: 'fbEndpoint',
    accessKey: 'fbAccessKey',
    secretKey: 'fbSecretKey'
  },
  IBM_COS: {
    endpoint: 'ibmEndpoint',
    accessKey: 'ibmAccessKey',
    secretKey: 'ibmSecretKey'
  }
});

function _suggestConnectionName(existing) {
  const suffix = existing.map(({
    name
  }) => {
    const match = name.match(nameRegExp);
    return match ? parseInt(match[1]) : 0;
  }).reduce( // For some reason sending Math.max to reduce reutrns NaN for any value.
  // Using an an arrow function to bypass the problem.
  (max, val) => Math.max(max, val), 0);
  return `Connection ${suffix + 1}`;
}

function _getEmptyObj() {
  return {};
}

function _onS3LikeValidate(keys, values, existingConnections, displayName) {
  const errors = {};

  if (!(0, _browserUtils.isUri)(values[keys.endpoint])) {
    errors[keys.endpoint] = `Please enter valid ${displayName} endpoint URI`;
  }

  if (!values[keys.accessKey]) {
    errors[keys.accessKey] = 'Please enter an access key';
  } else {
    const alreadyExists = existingConnections.some(connection => connection.endpoint === values[keys.endpoint] && connection.identity === values[keys.accessKey]);

    if (alreadyExists) {
      errors[keys.accessKey] = 'A similar connection already exists';
    }
  }

  if (!values[keys.secretKey]) {
    errors[keys.secretKey] = 'Please enter a secret key';
  }

  return errors;
}

async function _onS3LikeValidateAsync(keys, values, service, displayName, authMethod) {
  const errors = {};
  const {
    status,
    error
  } = await _services.api.account.check_external_connection({
    endpoint_type: service,
    endpoint: values[keys.endpoint],
    identity: values[keys.accessKey],
    secret: values[keys.secretKey],
    auth_method: authMethod
  });

  switch (status) {
    case 'TIMEOUT':
      {
        errors[keys.endpoint] = `${displayName} connection timed out`;
        break;
      }

    case 'INVALID_ENDPOINT':
      {
        errors[keys.endpoint] = `Please enter a valid ${displayName} endpoint`;
        break;
      }

    case 'INVALID_CREDENTIALS':
      {
        errors[keys.accessKey] = errors[keys.secretKey] = 'Credentials do not match';
        break;
      }

    case 'NOT_SUPPORTED':
      {
        errors[keys.accessKey] = 'Account type is not supported';
        break;
      }

    case 'TIME_SKEW':
      {
        errors[keys.accessKey] = 'Time difference with the server is too large';
        break;
      }

    case 'UNKNOWN_FAILURE':
      {
        // Using empty message to mark the fields as invalid.
        errors[keys.endpoint] = errors[keys.accessKey] = errors[keys.secretKey] = '';
        errors.global = error.message;
        break;
      }
  }

  return errors;
}

class AddCloudConnectionModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "formName", this.constructor.name);
    (0, _defineProperty2.default)(this, "fields", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "asyncTriggers", asyncTriggers);
    (0, _defineProperty2.default)(this, "allowedServices", null);
    (0, _defineProperty2.default)(this, "service", '');
    (0, _defineProperty2.default)(this, "serviceOptions", null);
    (0, _defineProperty2.default)(this, "existingConnections", null);
    (0, _defineProperty2.default)(this, "subTemplate", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isFormInitialized", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "globalError", _knockout.default.observable());
  }

  selectState(state, params) {
    return [params.allowedServices, state.accounts, state.session && state.session.user, state.forms[this.formName]];
  }

  mapStateToProps(allowedServices, accounts, user, form) {
    if (!accounts || !user) {
      return;
    }

    const allowedServiceOptions = allowedServices ? serviceOptions.filter(opt => allowedServices.includes(opt.value)) : serviceOptions;
    const globalError = form ? (0, _formUtils.getFieldError)(form, 'global') : '';
    const existingConnections = accounts[user].externalConnections;
    const service = form ? (0, _formUtils.getFieldValue)(form, 'service') : defaultService;
    const serviceChanged = this.service !== service;

    _knockout.default.assignToProps(this, {
      serviceOptions: allowedServiceOptions,
      globalError,
      existingConnections,
      service,
      subTemplate: templates[service],
      fields: !form ? {
        // Common fields
        connectionName: _suggestConnectionName(existingConnections),
        service: service,
        // AWS fields.
        awsEndpoint: 'https://s3.amazonaws.com',
        awsAccessKey: '',
        awsSecretKey: '',
        // Azure fields.
        azureEndpoint: 'https://blob.core.windows.net',
        azureAccountName: '',
        azureAccountKey: '',
        // S3 V2 compatible fileds.
        s3v2Endpoint: '',
        s3v2AccessKey: '',
        s3v2SecretKey: '',
        // S3 V4 compatible fileds.
        s3v4Endpoint: '',
        s3v4AccessKey: '',
        s3v4SecretKey: '',
        // Net Storage fileds.
        nsHostname: 'nsu.akamaihd.net',
        nsStorageGroup: '',
        nsKeyName: '',
        nsCPCode: '',
        nsAuthKey: '',
        // Google Cloud field.
        gcKeysFileName: '',
        gcKeysJson: '',
        // Pure FlashBlade fields.
        fbEndpoint: '',
        fbAccessKey: '',
        fbSecretKey: '',
        // IBM COS fields.
        ibmEndpoint: '',
        ibmAccessKey: '',
        ibmSecretKey: ''
      } : undefined
    });

    if (serviceChanged) {
      // Clear the touch state of the form whenever the
      // service changes.
      this.dispatch((0, _actionCreators.untouchForm)(this.formName));
    }
  }

  onValidate(values, existingConnections) {
    const {
      connectionName,
      service
    } = values;
    const errors = {};

    if (!connectionName) {
      errors.connectionName = 'Please enter valid connection name';
    }

    if (existingConnections.map(connection => connection.name).includes(connectionName)) {
      errors.connectionName = 'Name already in use';
    }

    const serviceValidate = service === 'AWS' && this.awsOnValidate || service === 'AZURE' && this.azureOnValidate || service === 'S3_V2_COMPATIBLE' && this.s3v2OnValidate || service === 'S3_V4_COMPATIBLE' && this.s3v4OnValidate || service === 'NET_STORAGE' && this.nsOnValidate || service === 'GOOGLE' && this.gcOnValidate || service === 'FLASHBLADE' && this.flashBladeOnValidate || service === 'IBM_COS' && this.ibmOnValidate || _getEmptyObj;
    return Object.assign(errors, serviceValidate(values, existingConnections));
  }

  async onValidateAsync(values) {
    const {
      service
    } = values;
    const serviceValidateAsync = service === 'AWS' && this.awsOnValidateAsync || service === 'AZURE' && this.azureOnValidateAsync || service === 'S3_V2_COMPATIBLE' && this.s3v2OnValidateAsync || service === 'S3_V4_COMPATIBLE' && this.s3v4OnValidateAsync || service === 'NET_STORAGE' && this.nsOnValidateAsync || service === 'GOOGLE' && this.gcOnValidateAsync || service === 'FLASHBLADE' && this.flashBladeOnValidateAsync || service === 'IBM_COS' && this.ibmOnValidateAsync || _getEmptyObj;
    return await serviceValidateAsync(values);
  }

  onSubmit(values) {
    const {
      connectionName,
      service
    } = values;
    const fields = service === 'AWS' && Object.values(s3LikeConnKeyMappings['AWS']) || service === 'AZURE' && ['azureEndpoint', 'azureAccountName', 'azureAccountKey'] || service === 'S3_V2_COMPATIBLE' && Object.values(s3LikeConnKeyMappings['S3_V2_COMPATIBLE']) || service === 'S3_V4_COMPATIBLE' && Object.values(s3LikeConnKeyMappings['S3_V4_COMPATIBLE']) || service === 'NET_STORAGE' && ['nsHostname', 'nsStorageGroup', 'nsKeyName', 'nsCPCode', 'nsAuthKey'] || service === 'GOOGLE' && ['gcKeysJson'] || service === 'FLASHBLADE' && Object.values(s3LikeConnKeyMappings['FLASHBLADE']) || service === 'IBM_COS' && Object.values(s3LikeConnKeyMappings['IBM_COS']);
    const params = (0, _coreUtils.pick)(values, fields);
    if (service === 'GOOGLE') params.gcEndpoint = gcEndpoint;
    this.dispatch((0, _actionCreators.closeModal)(), (0, _actionCreators.addExternalConnection)(connectionName, service, params));
  }

  onCancel() {
    this.dispatch((0, _actionCreators.closeModal)());
  } // --------------------------------------
  // Azure related methods:
  // --------------------------------------


  azureOnValidate(values, existingConnections) {
    const {
      azureEndpoint,
      azureAccountName,
      azureAccountKey
    } = values;
    const errors = {};

    if (!(0, _browserUtils.isUri)(azureEndpoint)) {
      errors.azureEndpoint = 'Please enter valid Azure endpoint URI';
    }

    if (!azureAccountName) {
      errors.azureAccountName = 'Please enter an Azure acount name';
    } else {
      const alreadyExists = existingConnections.some(connection => connection.service === 'AZURE' && connection.endpoint === azureEndpoint && connection.identity === azureAccountName);

      if (alreadyExists) {
        errors.azureAccountName = 'A similar connection already exists';
      }
    }

    if (!azureAccountKey) {
      errors.azureAccountKey = 'Please enter an Azure account key';
    }

    return errors;
  }

  async azureOnValidateAsync(values) {
    const errors = {};
    const {
      azureEndpoint,
      azureAccountName,
      azureAccountKey
    } = values;
    const {
      status,
      error
    } = await _services.api.account.check_external_connection({
      endpoint_type: 'AZURE',
      endpoint: azureEndpoint,
      identity: azureAccountName,
      secret: azureAccountKey
    });

    switch (status) {
      case 'TIMEOUT':
        {
          errors.azureEndpoint = 'Azure connection timed out';
          break;
        }

      case 'INVALID_ENDPOINT':
        {
          errors.azureEndpoint = 'Please enter a valid Azure endpoint';
          break;
        }

      case 'INVALID_CREDENTIALS':
        {
          errors.azureAccountName = errors.azureAccountKey = 'Credentials do not match';
          break;
        }

      case 'NOT_SUPPORTED':
        {
          errors.azureAccountName = 'Account type is not supported';
          break;
        }

      case 'TIME_SKEW':
        {
          errors.azureAccountName = 'Time difference with the server is too large';
          break;
        }

      case 'UNKNOWN_FAILURE':
        {
          // Using empty message to mark the fields as invalid.
          errors.azureEndpoint = errors.azureAccountName = errors.azureAccountKey = '';
          errors.global = error.message;
          break;
        }
    }

    return errors;
  } // --------------------------------------
  // AWS related methods:
  // --------------------------------------


  awsOnValidate(values, existingConnections) {
    const awsConnections = existingConnections.filter(connection => connection.service === 'AWS');
    return _onS3LikeValidate(s3LikeConnKeyMappings['AWS'], values, awsConnections, 'AWS');
  }

  async awsOnValidateAsync(values) {
    return _onS3LikeValidateAsync(s3LikeConnKeyMappings['AWS'], values, 'AWS', 'AWS', 'AWS_V4');
  } // --------------------------------------
  // S3 Compatible (v2) methods:
  // --------------------------------------


  s3v2OnValidate(values, existingConnections) {
    const s3CompatibleConnections = existingConnections.filter(connection => connection.service === 'S3_V2_COMPATIBLE' || connection.service === 'S3_V4_COMPATIBLE');
    return _onS3LikeValidate(s3LikeConnKeyMappings['S3_V2_COMPATIBLE'], values, s3CompatibleConnections, 'S3 compatible');
  }

  async s3v2OnValidateAsync(values) {
    return _onS3LikeValidateAsync(s3LikeConnKeyMappings['S3_V2_COMPATIBLE'], values, 'S3_COMPATIBLE', 'S3 compatible', 'AWS_V2');
  } // --------------------------------------
  // S3 Compatible (v4) methods:
  // --------------------------------------


  s3v4OnValidate(values, existingConnections) {
    const s3CompatibleConnections = existingConnections.filter(connection => connection.service === 'S3_V2_COMPATIBLE' || connection.service === 'S3_V4_COMPATIBLE');
    return _onS3LikeValidate(s3LikeConnKeyMappings['S3_V4_COMPATIBLE'], values, s3CompatibleConnections, 'S3 compatible');
  }

  async s3v4OnValidateAsync(values) {
    return _onS3LikeValidateAsync(s3LikeConnKeyMappings['S3_V4_COMPATIBLE'], values, 'S3_COMPATIBLE', 'S3 compatible', 'AWS_V4');
  } // --------------------------------------
  // Pure FlashBlade related methods:
  // --------------------------------------


  flashBladeOnValidate(values, existingConnections) {
    const flashBladeConnections = existingConnections.filter(connection => connection.service === 'FLASHBLADE');
    return _onS3LikeValidate(s3LikeConnKeyMappings['FLASHBLADE'], values, flashBladeConnections, 'FlashBlade');
  }

  async flashBladeOnValidateAsync(values) {
    return _onS3LikeValidateAsync(s3LikeConnKeyMappings['FLASHBLADE'], values, 'FLASHBLADE', 'FlashBlade', 'AWS_V4');
  } // --------------------------------------
  // IBM COS related methods:
  // --------------------------------------


  ibmOnValidate(values, existingConnections) {
    const ibmConnections = existingConnections.filter(connection => connection.service === 'IBM_COS');
    return _onS3LikeValidate(s3LikeConnKeyMappings['IBM_COS'], values, ibmConnections, 'IBM COS');
  }

  async ibmOnValidateAsync(values) {
    return _onS3LikeValidateAsync(s3LikeConnKeyMappings['IBM_COS'], values, 'IBM_COS', 'IBM COS', 'AWS_V2');
  } // --------------------------------------
  // Net Storage related methods:
  // --------------------------------------


  nsOnValidate(values) {
    const errors = {};
    const {
      nsStorageGroup,
      nsKeyName,
      nsCPCode,
      nsAuthKey
    } = values;

    if (!nsStorageGroup) {
      errors.nsStorageGroup = 'Please enter a valid storage group';
    }

    if (!nsKeyName) {
      errors.nsKeyName = 'Enter a valid key name';
    }

    if (!Number(nsCPCode) || nsCPCode.length !== 6) {
      errors.nsCPCode = 'Enter a 6 digit CP Code';
    }

    if (!nsAuthKey) {
      errors.nsAuthKey = 'Please enter a valid authentication key';
    }

    return errors;
  }

  async nsOnValidateAsync(values) {
    const errors = {};
    const {
      nsHostname,
      nsStorageGroup,
      nsKeyName,
      nsCPCode,
      nsAuthKey
    } = values;
    const {
      status
    } = await _services.api.account.check_external_connection({
      endpoint_type: 'NET_STORAGE',
      endpoint: `${nsStorageGroup}-${nsHostname}`,
      identity: nsKeyName,
      secret: nsAuthKey,
      cp_code: nsCPCode
    });

    switch (status) {
      case 'UNKNOWN_FAILURE':
        {
          // Using empty message to mark the fields as invalid.
          errors.nsStorageGroup = errors.nsKeyName = errors.nsCPCode = errors.nsAuthKey = errors.global = '';
          break;
        }
    }

    return errors;
  } // --------------------------------------
  // Google Cloud related methods:
  // --------------------------------------


  gcOnDropKeysFile(vm, evt) {
    const [file] = evt.dataTransfer.files;
    return this._gcOnKeysFile(file);
  }

  async gcOnSelectKeysFile(vm, evt) {
    const [file] = evt.target.files;
    return await this._gcOnKeysFile(file);
  }

  gcOnValidate(values, existingConnections) {
    const errors = {};
    const {
      gcKeysJson
    } = values;

    if (!gcKeysJson) {
      errors.gcKeysJson = 'Please upload a JSON keys file';
    } else {
      try {
        const {
          private_key_id: id
        } = JSON.parse(gcKeysJson);

        if ((0, _coreUtils.isUndefined)(id)) {
          errors.gcKeysJson = gcValidateFailureMessage;
        } else {
          const alreadyExists = existingConnections.some(connection => connection.service === 'GOOGLE' && connection.identity === id);

          if (alreadyExists) {
            errors.gcKeysJson = 'A similar connection already exists';
          }
        }
      } catch (_) {
        errors.gcKeysJson = gcValidateFailureMessage;
      }
    }

    return errors;
  }

  async gcOnValidateAsync(values) {
    const errors = {};
    const {
      gcKeysJson
    } = values;
    const {
      private_key_id: id
    } = JSON.parse(gcKeysJson);
    const [{
      status,
      error
    }] = await (0, _promiseUtils.all)(_services.api.account.check_external_connection({
      endpoint_type: 'GOOGLE',
      endpoint: gcEndpoint,
      identity: id,
      secret: gcKeysJson
    }), (0, _promiseUtils.sleep)(1000));

    switch (status) {
      case 'INVALID_CREDENTIALS':
        {
          errors.gcKeysJson = gcValidateFailureMessage;
          break;
        }

      case 'UNKNOWN_FAILURE':
        {
          // Using empty message to mark the fields as invalid.
          errors.gcPrivateKeyId = errors.gcKeysJson = '';
          errors.global = error.message;
          break;
        }
    }

    return errors;
  }

  async _gcOnKeysFile(file) {
    const gcKeysFileName = file.name;
    const gcKeysJson = await (0, _browserUtils.readFileAsText)(file);
    this.dispatch((0, _actionCreators.updateForm)(this.formName, {
      gcKeysFileName,
      gcKeysJson
    }));
  }

}

var _default = {
  viewModel: AddCloudConnectionModalViewModel,
  template: _addCloudConnectionModal.default
};
exports.default = _default;

},{"./add-cloud-connection-modal.html":518,"./aws-fields.html":520,"./azure-fields.html":521,"./flashblade-fields.html":522,"./google-cloud-fields.html":523,"./ibm-fields.html":524,"./net-storage-fields.html":525,"./s3-v2-compatible-fields.html":526,"./s3-v4-compatible-fields.html":527,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout","services":1013,"utils/browser-utils":1021,"utils/cloud-utils":1024,"utils/core-utils":1027,"utils/form-utils":1030,"utils/promise-utils":1039}],520:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<editor params=\"label: 'Endpoint'\">\n    <div class=\"row\">\n        <input type=\"text\"\n            class=\"push-next-half\"\n            placeholder=\"Enter Endpoint\"\n            ko.value=\"$form.awsEndpoint\"\n            ko.validationCss=\"$form.awsEndpoint\"\n        />\n        <validation-indicator params=\"field: $form.awsEndpoint\"></validation-indicator>\n    </div>\n    <validation-message params=\"field: $form.awsEndpoint\"></validation-message>\n</editor>\n\n<editor params=\"label: 'Access Key'\">\n    <div class=\"row\">\n        <input type=\"text\"\n            class=\"push-next-half\"\n            placeholder=\"Enter Key\"\n            ko.value=\"$form.awsAccessKey\"\n            ko.validationCss=\"$form.awsAccessKey\"\n        />\n        <validation-indicator params=\"field: $form.awsAccessKey\"></validation-indicator>\n    </div>\n    <validation-message params=\"field: $form.awsAccessKey\"></validation-message>\n</editor>\n\n<editor params=\"label: 'Secret Key'\">\n    <div class=\"row\">\n        <input type=\"password\"\n            class=\"push-next-half\"\n            placeholder=\"Enter Secret\"\n            autocomplete=\"new-password\"\n            ko.value=\"$form.awsSecretKey\"\n            ko.validationCss=\"$form.awsSecretKey\"\n        />\n        <validation-indicator params=\"field: $form.awsSecretKey\"></validation-indicator>\n    </div>\n    <validation-message params=\"field: $form.awsSecretKey\"></validation-message>\n</editor>\n";

},{}],521:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<editor params=\"label: 'Endpoint'\">\n    <div class=\"row\">\n        <input type=\"text\"\n            class=\"push-next-half\"\n            placeholder=\"Enter endpoint\"\n            ko.value=\"$form.azureEndpoint\"\n            ko.validationCss=\"$form.azureEndpoint\"\n        />\n        <validation-indicator params=\"field: $form.azureEndpoint\"></validation-indicator>\n    </div>\n    <validation-message params=\"field: $form.azureEndpoint\"></validation-message>\n</editor>\n\n<editor params=\"label: 'Account Name'\">\n    <div class=\"row\">\n        <input type=\"text\"\n            class=\"push-next-half\"\n            placeholder=\"Enter name\"\n            ko.value=\"$form.azureAccountName\"\n            ko.validationCss=\"$form.azureAccountName\"\n        />\n        <validation-indicator params=\"field: $form.azureAccountName\"></validation-indicator>\n    </div>\n    <validation-message params=\"field: $form.azureAccountName\"></validation-message>\n</editor>\n\n<editor params=\"label: 'Account Key'\">\n    <div class=\"row\">\n        <input type=\"password\"\n            class=\"push-next-half\"\n            placeholder=\"Enter key\"\n            autocomplete=\"new-password\"\n            ko.value=\"$form.azureAccountKey\"\n            ko.validationCss=\"$form.azureAccountKey\"\n        />\n        <validation-indicator params=\"field: $form.azureAccountKey\"></validation-indicator>\n    </div>\n    <validation-message params=\"field: $form.azureAccountKey\"></validation-message>\n</editor>\n";

},{}],522:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<editor params=\"label: 'Endpoint'\">\n    <div class=\"row\">\n        <input type=\"text\"\n            class=\"push-next-half\"\n            placeholder=\"Enter endpoint\"\n            ko.value=\"$form.fbEndpoint\"\n            ko.validationCss=\"$form.fbEndpoint\"\n        />\n        <validation-indicator params=\"field: $form.fbEndpoint\"></validation-indicator>\n    </div>\n    <validation-message params=\"field: $form.fbEndpoint\"></validation-message>\n</editor>\n\n<editor params=\"label: 'Access Key'\">\n    <div class=\"row\">\n        <input type=\"text\"\n            class=\"push-next-half\"\n            placeholder=\"Enter Key\"\n            ko.value=\"$form.fbAccessKey\"\n            ko.validationCss=\"$form.fbAccessKey\"\n        />\n        <validation-indicator params=\"field: $form.fbAccessKey\"></validation-indicator>\n    </div>\n    <validation-message params=\"field: $form.fbAccessKey\"></validation-message>\n</editor>\n\n<editor params=\"label: 'Secret Key'\">\n    <div class=\"row\">\n        <input type=\"password\"\n            class=\"push-next-half\"\n            placeholder=\"Enter Secret\"\n            autocomplete=\"new-password\"\n            ko.value=\"$form.fbSecretKey\"\n            ko.validationCss=\"$form.fbSecretKey\"\n        />\n        <validation-indicator params=\"field: $form.fbSecretKey\"></validation-indicator>\n    </div>\n    <validation-message params=\"field: $form.fbSecretKey\"></validation-message>\n</editor>\n";

},{}],523:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<p class=\"push-prev push-next-half\">\n    Service Account Keys:\n</p>\n\n<div class=\"column greedy gc-file-selector\">\n    <drop-area class=\"greedy\"\n        params=\"onDrop: gcOnDropKeysFile\"\n        ko.validationCss=\"$form.gcKeysJson\"\n    >\n        <div class=\"column content-middle\" ko.visible=\"!$form.gcKeysJson()\">\n            <p class=\"push-next\">\n                Drag Json file here or\n            </p>\n            <label class=\"btn alt-colors\"\n                tabindex=\"0\"\n                ko.keysToClicks=\"['space', 'enter']\"\n            >\n                Browse\n                <input type=\"file\"\n                    tabindex=\"-1\"\n                    class=\"hide\"\n                    ko.attr.accept=\"'.json'\"\n                    ko.event.change=\"gcOnSelectKeysFile\"\n                />\n            </label>\n        </div>\n        <div class=\"column content-middle\" ko.visible=\"$form.gcKeysJson()\">\n            <p class=\"row content-middle push-next-half\" ko.visible=\"$form.gcKeysJson.isValidating\">\n                <svg-icon class=\"icon-small push-next-half spin match-theme\" params=\"name: 'in-progress'\"></svg-icon>\n                Validating \"{{$form.gcKeysFileName}}\"\n            </p>\n\n            <p class=\"row content-middle push-next-half\" ko.visible=\"$form.gcKeysJson.isValid\">\n                <svg-icon class=\"icon-small push-next-half success\" params=\"name: 'healthy'\"></svg-icon>\n                \"{{$form.gcKeysFileName}}\" validated successfully\n            </p>\n            <p class=\"row content-middle push-next-half\" ko.visible=\"$form.gcKeysJson.isInvalid\">\n                <svg-icon class=\"icon-small push-next-half error\" params=\"name: 'problem'\"></svg-icon>\n                \"{{$form.gcKeysFileName}}\" validation failed\n            </p>\n            <label\n                class=\"link alt-colors\"\n                tabindex=\"0\"\n                ko.keysToClicks=\"['space', 'enter']\"\n                ko.hidden=\"$form.isValidating\"\n            >\n                Choose another file\n                <input type=\"file\" class=\"hide\"\n                    tabindex=\"-1\"\n                    ko.attr.accept=\"'.json'\",\n                    ko.event.change=\"gcOnSelectKeysFile\"\n                    ko.disable=\"$form.isValidating\"\n                />\n            </label>\n        </div>\n    </drop-area>\n\n    <validation-message params=\"field: $form.gcKeysJson\"></validation-message>\n</div>\n";

},{}],524:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<editor params=\"label: 'Endpoint'\">\n    <div class=\"row\">\n        <input type=\"text\"\n            class=\"push-next-half\"\n            placeholder=\"Enter endpoint\"\n            ko.value=\"$form.ibmEndpoint\"\n            ko.validationCss=\"$form.ibmEndpoint\"\n        />\n        <validation-indicator params=\"field: $form.ibmEndpoint\"></validation-indicator>\n    </div>\n    <validation-message params=\"field: $form.ibmEndpoint\"></validation-message>\n</editor>\n\n<editor params=\"label: 'Access Key'\">\n    <div class=\"row\">\n        <input type=\"text\"\n            class=\"push-next-half\"\n            placeholder=\"Enter Key\"\n            ko.value=\"$form.ibmAccessKey\"\n            ko.validationCss=\"$form.ibmAccessKey\"\n        />\n        <validation-indicator params=\"field: $form.ibmAccessKey\"></validation-indicator>\n    </div>\n    <validation-message params=\"field: $form.ibmAccessKey\"></validation-message>\n</editor>\n\n<editor params=\"label: 'Secret Key'\">\n    <div class=\"row\">\n        <input type=\"password\"\n            class=\"push-next-half\"\n            placeholder=\"Enter Secret\"\n            autocomplete=\"new-password\"\n            ko.value=\"$form.ibmSecretKey\"\n            ko.validationCss=\"$form.ibmSecretKey\"\n        />\n        <validation-indicator params=\"field: $form.ibmSecretKey\"></validation-indicator>\n    </div>\n    <validation-message params=\"field: $form.ibmSecretKey\"></validation-message>\n</editor>\n";

},{}],525:[function(require,module,exports){
module.exports = "<editor params=\"label: 'Connection Hostname'\">\n    <div class=\"row\">\n        <input type=\"text\"\n            class=\"push-next-half small-input\"\n            placeholder=\"Storage Group\"\n            ko.value=\"$form.nsStorageGroup\"\n            ko.validationCss=\"$form.nsStorageGroup\"\n        />\n        <span class=\"push-next-half small-input\">-{{$form.nsHostname}}</span>\n        <validation-indicator params=\"field: $form.nsStorageGroup\"></validation-indicator>\n    </div>\n    <validation-message params=\"field: $form.nsStorageGroup\"></validation-message>\n</editor>\n\n<editor params=\"label: 'Key name and CP code'\">\n    <div class=\"row\">\n        <div class=\"column push-next-half\">\n            <input type=\"text\"\n                class=\"small-input\"\n                placeholder=\"Key Name\"\n                ko.value=\"$form.nsKeyName\"\n                ko.validationCss=\"$form.nsKeyName\"\n            />\n            <validation-message params=\"field: $form.nsKeyName\"></validation-message>\n        </div>\n        <div class=\"column push-next-half\">\n            <input type=\"text\"\n                class=\"small-input\"\n                placeholder=\"CP Code\"\n                ko.value=\"$form.nsCPCode\"\n                ko.validationCss=\"$form.nsCPCode\"\n            />\n            <validation-message params=\"field: $form.nsCPCode\"></validation-message>\n        </div>\n        <validation-indicator params=\"field: $form.nsCPCode\"></validation-indicator>\n    </div>\n</editor>\n\n<editor params=\"label: 'Authentication Key'\">\n    <div class=\"row\">\n        <input type=\"text\"\n            class=\"push-next-half\"\n            placeholder=\"Enter Key\"\n            ko.value=\"$form.nsAuthKey\"\n            ko.validationCss=\"$form.nsAuthKey\"\n        />\n        <validation-indicator params=\"field: $form.nsAuthKey\"></validation-indicator>\n    </div>\n    <validation-message params=\"field: $form.nsAuthKey\"></validation-message>\n</editor>\n";

},{}],526:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<editor params=\"label: 'Endpoint'\">\n    <div class=\"row\">\n        <input type=\"text\"\n            class=\"push-next-half\"\n            placeholder=\"Enter endpoint\"\n            ko.value=\"$form.s3v2Endpoint\"\n            ko.validationCss=\"$form.s3v2Endpoint\"\n        />\n        <validation-indicator params=\"field: $form.s3v2Endpoint\"></validation-indicator>\n    </div>\n    <validation-message params=\"field: $form.s3v2Endpoint\"></validation-message>\n</editor>\n\n<editor params=\"label: 'Access Key'\">\n    <div class=\"row\">\n        <input type=\"text\"\n            class=\"push-next-half\"\n            placeholder=\"Enter Key\"\n            ko.value=\"$form.s3v2AccessKey\"\n            ko.validationCss=\"$form.s3v2AccessKey\"\n        />\n        <validation-indicator params=\"field: $form.s3v2AccessKey\"></validation-indicator>\n    </div>\n    <validation-message params=\"field: $form.s3v2AccessKey\"></validation-message>\n</editor>\n\n<editor params=\"label: 'Secret Key'\">\n    <div class=\"row\">\n        <input type=\"password\"\n            class=\"push-next-half\"\n            placeholder=\"Enter Secret\"\n            autocomplete=\"new-password\"\n            ko.value=\"$form.s3v2SecretKey\"\n            ko.validationCss=\"$form.s3v2SecretKey\"\n        />\n        <validation-indicator params=\"field: $form.s3v2SecretKey\"></validation-indicator>\n    </div>\n    <validation-message params=\"field: $form.s3v2SecretKey\"></validation-message>\n</editor>\n";

},{}],527:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<editor params=\"label: 'Endpoint'\">\n    <div class=\"row\">\n        <input type=\"text\"\n            class=\"push-next-half\"\n            placeholder=\"Enter endpoint\"\n            ko.value=\"$form.s3v4Endpoint\"\n            ko.validationCss=\"$form.s3v4Endpoint\"\n        />\n        <validation-indicator params=\"field: $form.s3v4Endpoint\"></validation-indicator>\n    </div>\n    <validation-message params=\"field: $form.s3v4Endpoint\"></validation-message>\n</editor>\n\n<editor params=\"label: 'Access Key'\">\n    <div class=\"row\">\n        <input type=\"text\"\n            class=\"push-next-half\"\n            placeholder=\"Enter Key\"\n            ko.value=\"$form.s3v4AccessKey\"\n            ko.validationCss=\"$form.s3v4AccessKey\"\n        />\n        <validation-indicator params=\"field: $form.s3v4AccessKey\"></validation-indicator>\n    </div>\n    <validation-message params=\"field: $form.s3v4AccessKey\"></validation-message>\n</editor>\n\n<editor params=\"label: 'Secret Key'\">\n    <div class=\"row\">\n        <input type=\"password\"\n            class=\"push-next-half\"\n            placeholder=\"Enter Secret\"\n            autocomplete=\"new-password\"\n            ko.value=\"$form.s3v4SecretKey\"\n            ko.validationCss=\"$form.s3v4SecretKey\"\n        />\n        <validation-indicator params=\"field: $form.s3v4SecretKey\"></validation-indicator>\n    </div>\n    <validation-message params=\"field: $form.s3v4SecretKey\"></validation-message>\n</editor>\n";

},{}],528:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<managed-form class=\"column greedy\" params=\"\n    name: formName,\n    fields: fields,\n    onValidate: values => onValidate(values, existingNames),\n    onSubmit: onSubmit\n\">\n    <div class=\"column greedy pad\">\n        <p class=\"push-next\">\n            Use a bucket from a public cloud to serve as a NooBaa storage resource\n        </p>\n\n        <section class=\"coulmn greedy\">\n            <editor params=\"label: 'Target Connection'\">\n                <dropdown params=\"\n                        subject: 'connection',\n                        actions: connectionActions,\n                        options: connectionOptions,\n                        selected: $form.connection,\n                        hasFocus: true\n                    \"\n                    ko.validationCss=\"$form.connection\"\n                ></dropdown>\n                <validation-message params=\"field: $form.connection\"></validation-message>\n            </editor>\n\n            <editor params=\"\n                label: targetBucketLabel,\n                disabled: !targetBucketsOptions()\n            \">\n                <dropdown params=\"\n                        filter: true,\n                        subject: targetBucketSubject,\n                        disabled: !$form.connection(),\n                        options: targetBucketsOptions,\n                        loading: fetchingTargetBuckets,\n                        selected: $form.targetBucket,\n                        emptyMessage: targetBucketsEmptyMessage,\n                        errorMessage: targetBucketsErrorMessage,\n                        error: isTargetBucketsInError\n                    \"\n                    ko.validationCss=\"$form.targetBucket\"\n                ></dropdown>\n                <validation-message params=\"field: $form.targetBucket\"></validation-message>\n            </editor>\n\n            <editor params=\"label: 'Resource Name', disabled: !$form.connection()\">\n                <input type=\"text\"\n                       class=\"push-next-half\"\n                       placeholder=\"Type Name\"\n                       ko.textInput=\"ko.pc($form.resourceName, onResourceNameThrottled)\"\n                       ko.enable=\"$form.connection\"\n                       ko.validationCss=\"$form.resourceName\"\n                />\n\n                <ul class=\"restriction-list\"\n                    ko.css.disabled=\"!$form.connection()\"\n                    ko.foreach=\"nameRestrictionList\"\n                >\n                    <li ko.text=\"label\" ko.css=\"css\"></li>\n                </ul>\n            </editor>\n        </section>\n    </div>\n\n    <div class=\"column content-box pad\">\n        <div class=\"row content-middle align-end\">\n            <button type=\"button\" class=\"link alt-colors push-next\" ko.click=\"onCancel\">\n                Cancel\n            </button>\n            <button class=\"btn\" ko.shakeOnClick=\"!$form.isValid()\">\n                Create\n            </button>\n        </div>\n    </div>\n</managed-form>\n";

},{}],529:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _addCloudResourceModal = _interopRequireDefault(require("./add-cloud-resource-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _cloudUtils = require("utils/cloud-utils");

var _validationUtils = require("utils/validation-utils");

var _formUtils = require("utils/form-utils");

var _config = require("config");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const allowedServices = (0, _coreUtils.deepFreeze)(['AWS', 'S3_V2_COMPATIBLE', 'S3_V4_COMPATIBLE', 'AZURE', 'GOOGLE', 'FLASHBLADE', 'IBM_COS']);

class AddCloudResourceModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "formName", this.constructor.name);
    (0, _defineProperty2.default)(this, "existingNames", null);
    (0, _defineProperty2.default)(this, "connectionOptions", _knockout.default.observableArray());
    (0, _defineProperty2.default)(this, "nameRestrictionList", _knockout.default.observableArray());
    (0, _defineProperty2.default)(this, "targetBucketsEmptyMessage", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "targetBucketsErrorMessage", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isTargetBucketsInError", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "fetchingTargetBuckets", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "targetBucketsOptions", _knockout.default.observableArray());
    (0, _defineProperty2.default)(this, "targetBucketSubject", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "targetBucketLabel", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "connectionActions", (0, _coreUtils.deepFreeze)([{
      label: 'Add new connection',
      onClick: this.onAddNewConnection.bind(this)
    }]));
    (0, _defineProperty2.default)(this, "fields", {
      connection: '',
      targetBucket: '',
      resourceName: ''
    });
    (0, _defineProperty2.default)(this, "onResourceNameThrottled", (0, _coreUtils.throttle)(this.onResourceName, _config.inputThrottle, this));
  }

  selectState(state) {
    return [state.accounts, state.session, state.cloudResources, state.hostPools, state.forms[this.formName], state.cloudTargets];
  }

  mapStateToProps(accounts, session, cloudResources, hostPools, form, cloudTargets) {
    if (!accounts || !cloudResources || !hostPools || !form) {
      return;
    }

    const {
      externalConnections
    } = accounts[session.user];
    const connectionOptions = externalConnections.filter(conn => allowedServices.includes(conn.service)).map(conn => {
      const {
        icon,
        selectedIcon
      } = (0, _cloudUtils.getCloudServiceMeta)(conn.service);
      return {
        label: conn.name,
        value: conn.name,
        remark: conn.identity,
        icon: icon,
        selectedIcon: selectedIcon
      };
    });
    const fetchingTargetBuckets = cloudTargets.fetching && !cloudTargets.list;
    const targetBucketsOptions = (cloudTargets.list || []).map(target => {
      const {
        usedBy,
        name: value
      } = target;

      if (usedBy) {
        return {
          value,
          disabled: Boolean(usedBy),
          tooltip: (0, _cloudUtils.getCloudTargetTooltip)(target)
        };
      } else {
        return {
          value
        };
      }
    });
    const connection = (0, _formUtils.getFieldValue)(form, 'connection');
    const resourceName = (0, _formUtils.getFieldValue)(form, 'resourceName');
    const isResourceNameTouched = (0, _formUtils.isFieldTouched)(form, 'resourceName');
    const targetBucket = (0, _formUtils.getFieldValue)(form, 'targetBucket').toLowerCase();
    const existingNames = [...Object.keys(cloudResources), ...Object.keys(hostPools)];
    const nameRestrictionList = (0, _validationUtils.validateName)(resourceName, existingNames).map(result => {
      const css = !connection && 'nocss' || result.valid && 'success' || isResourceNameTouched && 'error' || 'nocss';
      return {
        label: result.message,
        css: css === 'nocss' ? '' : css
      };
    });
    const selectedConnection = externalConnections.find(con => con.name === connection);
    const subject = selectedConnection ? (0, _cloudUtils.getCloudServiceMeta)(selectedConnection.service).subject : '';

    _knockout.default.assignToProps(this, {
      targetBucketSubject: subject,
      targetBucketLabel: `Target ${subject}`,
      targetBucketsEmptyMessage: `No ${subject.toLowerCase()}s found`,
      targetBucketsErrorMessage: `Cannot retrieve ${subject.toLowerCase()}s`,
      isTargetBucketsInError: cloudTargets.error,
      connectionOptions,
      fetchingTargetBuckets,
      targetBucketsOptions,
      existingNames,
      nameRestrictionList
    }); // Load cloud targets if necessary.


    if (connection && connection !== cloudTargets.connection) {
      this.dispatch((0, _actionCreators.fetchCloudTargets)(connection));
    } // Suggest a name for the resource if the user didn't enter one himself.


    if (!isResourceNameTouched && targetBucket && resourceName !== targetBucket) {
      this.dispatch((0, _actionCreators.updateForm)(this.formName, {
        resourceName: targetBucket
      }, false));
    }
  }

  onResourceName(resourceName) {
    this.dispatch((0, _actionCreators.updateForm)(this.formName, {
      resourceName
    }));
  }

  onValidate(values, existingNames) {
    const {
      connection,
      targetBucket,
      resourceName
    } = values;
    const errors = {};

    if (!connection) {
      errors.connection = 'Please select a connection from the list';
    } else {
      if (!targetBucket) {
        errors.targetBucket = 'Please select a target bucket';
      }

      const hasNameErrors = (0, _validationUtils.validateName)(resourceName, existingNames).some(rule => !rule.valid);

      if (hasNameErrors) {
        errors.resourceName = '';
      }
    }

    return errors;
  }

  onSubmit(values) {
    const {
      resourceName,
      connection,
      targetBucket
    } = values;
    this.dispatch((0, _actionCreators.closeModal)(), (0, _actionCreators.createCloudResource)(resourceName, connection, targetBucket));
  }

  onAddNewConnection() {
    this.dispatch((0, _actionCreators.openAddCloudConnectionModal)(allowedServices));
  }

  onCancel() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

  dispose() {
    this.dispatch((0, _actionCreators.dropCloudTargets)());
    super.dispose();
  }

}

var _default = {
  viewModel: AddCloudResourceModalViewModel,
  template: _addCloudResourceModal.default
};
exports.default = _default;

},{"./add-cloud-resource-modal.html":528,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"config":831,"knockout":"knockout","utils/cloud-utils":1024,"utils/core-utils":1027,"utils/form-utils":1030,"utils/validation-utils":1047}],530:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<section class=\"row greedy pad\">\n    <div class=\"column content-box pad greedy push-next\">\n        <h2 class=\"heading3 row content-middle push-next\">\n            <svg-icon class=\"highlight push-next-half\"\n                params=\"name: 'nodes-pool'\"\n            ></svg-icon>\n            Kubernetes Pool\n        </h2>\n        <p class=\"push-next \">\n            NooBaa nodes will be deployed as StatefulSet which is the workload API object used to manage stateful applications.\n        </p>\n        <p class=\"push-next greedy\">\n            StatefulSet maintains a sticky identity for each of their Pods.\n            These pods are created from the same spec, but are not interchangeable: each has a persistent identifier that it maintains across any rescheduling.\n        </p>\n        <button class=\"btn\" ko.click=\"onDeployK8SNodes\">\n            Deploy Kubernetes Pool\n        </button>\n    </div>\n    <div class=\"column content-box pad greedy\">\n        <h2 class=\"heading3 row content-middle push-next\">\n            <svg-icon class=\"highlight push-next-half\"\n                params=\"name: 'cloud-hollow'\"\n            ></svg-icon>\n            Cloud\n        </h2>\n        <p class=\"push-next\">\n            A cloud resource can be either an Azure blob storage, AWS S3 bucket or any AWS S3 compatible service.\n        </p>\n        <p class=\"push-next greedy\">\n            It can be used as a resource in the NooBaa buckets created by the administrator.\n        </p>\n        <button class=\"btn\" ko.click=\"onAddCloudResource\">\n            Add Cloud Resource\n        </button>\n    </div>\n</section>\n\n";

},{}],531:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _addResourcesModal = _interopRequireDefault(require("./add-resources-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
class AddResourcesModalViewModel extends _connectable.default {
  onDeployK8SNodes() {
    this.dispatch((0, _actionCreators.closeModal)(), (0, _actionCreators.openDeployK8sPoolModal)());
  }

  onAddCloudResource() {
    this.dispatch((0, _actionCreators.closeModal)(), (0, _actionCreators.openAddCloudResourceModal)());
  }

}

var _default = {
  viewModel: AddResourcesModalViewModel,
  template: _addResourcesModal.default
};
exports.default = _default;

},{"./add-resources-modal.html":530,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446}],532:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<managed-form class=\"column greedy\" params=\"\n    name: formName,\n    fields: formFields,\n    onWarn: values => onWarn(values, hostPools(), cloudResources()),\n    onValidate: onValidate,\n    onSubmit: onSubmit\n\">\n    <div class=\"column greedy  pad\">\n        <div class=\"tier-indicator row content-middle push-next\">\n            <span class=\"push-next heading3\">\n                Tiering Structure:\n            </span>\n            <tag-list class=\"borders pad-quarter\" params=\"\n                tags: tiersSummary,\n                separator: 'arrow-right'\n            \"></tag-list>\n        </div>\n\n        <placement-policy-toggle class=\"push-next\" params=\"\n            selectedPolicy: $form.policyType,\n            hasFocus: true\n        \"></placement-policy-toggle>\n\n        <resources-selection-table class=\"column greedy\" params=\"\n            title: tableTitle,\n            hostPools: hostPools,\n            cloudResources: cloudResources,\n            disabled: resourcesInUse,\n            selected: $form.selectedResources,\n        \"></resources-selection-table>\n\n        <validation-message class=\"push-next\" params=\"\n            field: $form.selectedResources\"\n        ></validation-message>\n    </div>\n    <div class=\"row content-middle pad content-box\">\n        <p class=\"remark greedy push-next\">\n            <svg-icon class=\"icon-small valign-bottom\"\n                params=\"name: 'notif-info'\"\n            ></svg-icon>\n            To create a new resource go to\n            <a class=\"link\" ko.attr.href=\"resourcesHref\">\n                Resources\n            </a>\n        </p>\n        <button type=\"button\" class=\"link alt-colors push-next\" ko.click=\"onCancel\">\n            Cancel\n        </button>\n        <button class=\"btn\" ko.shakeOnClick=\"!$form.isValid()\">\n            add\n        </button>\n    </div>\n</managed-form>\n\n\n";

},{}],533:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _addTierModal = _interopRequireDefault(require("./add-tier-modal.html"));

var _tierSummaryTooltip = _interopRequireDefault(require("./tier-summary-tooltip.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _stringUtils = require("utils/string-utils");

var _storageUtils = require("utils/storage-utils");

var _sizeUtils = require("utils/size-utils");

var _coreUtils = require("utils/core-utils");

var _resourceUtils = require("utils/resource-utils");

var _browserUtils = require("utils/browser-utils");

var _bucketUtils = require("utils/bucket-utils");

var _actionCreators = require("action-creators");

var routes = _interopRequireWildcard(require("routes"));

/* Copyright (C) 2016 NooBaa */
function _getTierSummary(tier, tierIndex, hostPools, cloudResources) {
  const resources = (0, _coreUtils.flatMap)(tier.mirrorSets, ms => ms.resources);
  const policyTypeText = (0, _bucketUtils.getPlacementTypeDisplayName)(tier.policyType);
  const {
    HOSTS: hostPoolCount = 0,
    CLOUD: cloudResourceCount = 0
  } = (0, _coreUtils.countBy)(resources, res => res.type);
  const hasResources = hostPoolCount + cloudResourceCount > 0;
  const hostPoolsText = hostPoolCount > 0 ? (0, _stringUtils.stringifyAmount)('Node Pool', hostPoolCount) : '';
  const cloudResourcesText = cloudResourceCount > 0 ? (0, _stringUtils.stringifyAmount)('Cloud resource', cloudResourceCount) : '';
  const storage = (0, _storageUtils.aggregateStorage)(...resources.map(res => {
    const coll = res.type === 'HOSTS' ? hostPools : cloudResources;
    return coll[res.name].storage;
  }));
  const {
    total = 0,
    free = 0,
    unavailableFree = 0
  } = storage;
  const freeStorage = (0, _sizeUtils.sumSize)(free, unavailableFree);
  const availCapacityText = `${(0, _sizeUtils.formatSize)(freeStorage)} of ${(0, _sizeUtils.formatSize)(total)}`;
  return {
    text: `Tier ${tierIndex + 1}`,
    tooltip: {
      template: _tierSummaryTooltip.default,
      text: {
        hasResources,
        policyTypeText,
        hostPoolsText,
        cloudResourcesText,
        availCapacityText
      },
      align: 'start'
    }
  };
}

class AddTierModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "resourcesHref", '');
    (0, _defineProperty2.default)(this, "bucketName", '');
    (0, _defineProperty2.default)(this, "tiersSummary", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "tableTitle", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "hostPools", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "cloudResources", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "resourcesInUse", _knockout.default.observableArray());
    (0, _defineProperty2.default)(this, "formName", this.constructor.name);
    (0, _defineProperty2.default)(this, "formFields", {
      policyType: 'SPREAD',
      selectedResources: []
    });
    (0, _defineProperty2.default)(this, "onWarn", _bucketUtils.warnPlacementPolicy);
    (0, _defineProperty2.default)(this, "onValidate", _bucketUtils.validatePlacementPolicy);
  }

  selectState(state, params) {
    const {
      buckets,
      hostPools,
      cloudResources,
      location
    } = state;
    const bucket = buckets && buckets[params.bucketName];
    return [bucket, hostPools, cloudResources, location.params.system];
  }

  mapStateToProps(bucket, hostPools, cloudResources, system) {
    if (!bucket || !hostPools || !cloudResources) {
      _knockout.default.assignToProps(this, {
        dataReady: false
      });
    } else {
      const {
        tiers
      } = bucket.placement;
      const tableTitle = `Resources in Tier ${tiers.length + 1} policy`;
      const tiersSummary = [...tiers.map((tier, i) => _getTierSummary(tier, i, hostPools, cloudResources)), {
        text: `Tier ${tiers.length + 1}`,
        css: 'dim'
      }];
      const resourcesInUse = (0, _bucketUtils.flatPlacementPolicy)(bucket).map(record => {
        const {
          type,
          name
        } = record.resource;
        return (0, _resourceUtils.getResourceId)(type, name);
      });
      const resourcesHref = (0, _browserUtils.realizeUri)(routes.resources, {
        system
      });

      _knockout.default.assignToProps(this, {
        dataReady: true,
        bucketName: bucket.name,
        tiersSummary,
        tableTitle,
        hostPools,
        cloudResources,
        resourcesInUse,
        resourcesHref
      });
    }
  }

  onSubmit(values) {
    this.dispatch((0, _actionCreators.closeModal)());
    this.dispatch((0, _actionCreators.addBucketTier)(this.bucketName, values.policyType, values.selectedResources));
  }

  onCancel() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

}

var _default = {
  viewModel: AddTierModalViewModel,
  template: _addTierModal.default
};
exports.default = _default;

},{"./add-tier-modal.html":532,"./tier-summary-tooltip.html":534,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"components/connectable":446,"knockout":"knockout","routes":972,"utils/browser-utils":1021,"utils/bucket-utils":1022,"utils/core-utils":1027,"utils/resource-utils":1041,"utils/size-utils":1043,"utils/storage-utils":1045,"utils/string-utils":1046}],534:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<section class=\"column\">\n    <div class=\"column push-next\">\n        <p class=\"highlight push-next-quarter\">\n            Tier&grave;s Resources ({{policyTypeText}}):\n        </p>\n        <!-- ko if: hasResources -->\n        <ul class=\"list-no-style\">\n            <li class=\"row content-middle\" ko.visible=\"hostPoolsText\">\n                <svg-icon class=\"icon-small push-next-half\"\n                    params=\"name: 'nodes-pool'\"\n                ></svg-icon>\n                <span>{{hostPoolsText}}</span>\n            </li>\n            <li class=\"row content-middle\" ko.visible=\"cloudResourcesText\">\n                <svg-icon class=\"icon-small push-next-half\"\n                params=\"name: 'cloud-hollow'\"\n                ></svg-icon>\n                <span>{{cloudResourcesText}}</span>\n            </li>\n        </ul>\n        <!-- /ko -->\n        <!-- ko ifnot: hasResources -->\n        <p>No Resources</p>\n        <!-- /ko -->\n    </div>\n\n    <div class=\"column\">\n        <p class=\"highlight push-next-quarter\">\n            Available capacity:\n        </p>\n        <p>{{availCapacityText}}</p>\n    </div>\n</section>\n";

},{}],535:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<managed-form class=\"column greedy\" params=\"\n    name: formName,\n    fields: fields,\n    onValidate: onValidate,\n    onSubmit: onSubmit\n\">\n    <div class=\"column greedy pad\">\n        <p>\n            Regions are a way to mark proximity of resources. Assigning a region can improve performance if working from the endpoints within the region. It may also help with cost savings such as egress in the case of cloud regions.\n        </p>\n        <editor class=\"greedy\" params=\"label: 'region'\">\n            <autocomplete params=\"\n                suggestions: regionSuggestions,\n                value: $form.region,\n                placeholder: 'Enter region',\n                hasFocus: true\n            \"></autocomplete>\n\n            <validation-message params=\"field: $form.region\"></validation-message>\n            <p class=\"remark\" ko.visible=\"$form.region.isValid\">\n                Optional. Value length 3-32 characters\n            </p>\n        </editor>\n    </div>\n    <div class=\"column pad content-box\">\n        <div class=\"row content-middle align-end\">\n            <button type=\"button\"\n                class=\"link alt-colors push-next\"\n                ko.click=\"onCancel\"\n            >\n                Cancel\n            </button>\n            <button class=\"btn\"\n                ko.shakeOnClick=\"!$form.isValid()\"\n            >\n                Save\n            </button>\n        </div>\n    </div>\n</managed-form>\n";

},{}],536:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _assignRegionModal = _interopRequireDefault(require("./assign-region-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _coreUtils = require("utils/core-utils");

var _stringUtils = require("utils/string-utils");

var _resourceUtils = require("utils/resource-utils");

var _actionCreators = require("action-creators");

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
class AssignRegionModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "formName", this.constructor.name);
    (0, _defineProperty2.default)(this, "resourceType", '');
    (0, _defineProperty2.default)(this, "resourceName", '');
    (0, _defineProperty2.default)(this, "fields", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "regionSuggestions", _knockout.default.observableArray());
    (0, _defineProperty2.default)(this, "selectRegionList", (0, _coreUtils.memoize)((hostPools, cloudResources, resourceName) => {
      const resources = [...Object.values(hostPools), ...Object.values(cloudResources)];
      const usageMap = (0, _coreUtils.keyByProperty)(resources.filter(res => res.name !== resourceName && Boolean(res.region)), 'region', (_0, _1, usage) => usage ? usage + 1 : 1);
      return Object.entries(usageMap).map(([name, usage]) => ({
        name,
        usage
      }));
    }));
  }

  selectState(state, params) {
    const {
      resourceType,
      resourceName
    } = params;
    const {
      hostPools = {},
      cloudResources = {}
    } = state;
    const resource = resourceType === 'HOSTS' && hostPools[resourceName] || resourceType === 'CLOUD' && cloudResources[resourceName] || null;
    return [resourceType, resourceName, resource ? resource.region : '', this.selectRegionList(hostPools, cloudResources, resourceName)];
  }

  mapStateToProps(resourceType, resourceName, region, regionList) {
    _knockout.default.assignToProps(this, {
      resourceType: resourceType,
      resourceName: resourceName,
      regionSuggestions: regionList.map(region => ({
        value: region.name,
        remark: `Used by ${(0, _stringUtils.stringifyAmount)('resource', region.usage)}`
      })),
      fields: !this.fields() ? {
        region
      } : undefined
    });
  }

  onValidate(values) {
    const {
      region
    } = values;
    const errors = {};

    if (region) {
      if (region.length < 3 || region.length > 32) {
        errors.region = 'Region tag must be between 3-32 characters';
      }

      if ((0, _stringUtils.equalIgnoreCase)(region.trim(), _resourceUtils.unassignedRegionText)) {
        errors.region = `"${_resourceUtils.unassignedRegionText}" is reserved and cannot be used as a region name`;
      }
    }

    return errors;
  }

  onCancel() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

  onSubmit(values) {
    const {
      resourceType,
      resourceName
    } = this;
    this.dispatch((0, _actionCreators.assignRegionToResource)(resourceType, resourceName, values.region), (0, _actionCreators.closeModal)());
  }

}

var _default = {
  viewModel: AssignRegionModalViewModel,
  template: _assignRegionModal.default
};
exports.default = _default;

},{"./assign-region-modal.html":535,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout","utils/core-utils":1027,"utils/resource-utils":1041,"utils/string-utils":1046}],537:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<managed-form class=\"column greedy\" params=\"\n    name: formName,\n    fields: fields,\n    asyncTriggers: asyncValidationTriggers,\n    onValidate: onValidate,\n    onValidateAsync: onValidateAsync,\n    onSubmit: onSubmit\n\">\n    <wizard class=\"column greedy\" params=\"\n        steps: steps,\n        step: $form.step,\n        actionLabel: 'Create',\n        onBeforeStep: onBeforeStep,\n        onComplete: $form.submit,\n        onCancel: onCancel\n    \">\n        <section class=\"greedy pad\">\n            <h3 class=\"heading3\">\n                To attach a new server to the cluster complete the following steps:\n            </h3>\n            <ol class=\"bullet-list\">\n                <li>\n                    Provision a new server with an OVA that matches version\n                    <more-info-icon params=\"tooltip: version\"></more-info-icon>\n                </li>\n                <li>Login to the new server and setup networking</li>\n                <li>Copy the server IP and secret key shown on the terminal and fill the following fields:</li>\n            </ol>\n\n            <editor params=\"label: 'Server IP'\">\n                <div class=\"row content-middle\">\n                    <input type=\"text\"\n                        class=\"push-next-half\"\n                        ko.value=\"$form.address\"\n                        ko.hasFocus=\"true\"\n                        ko.validationCss=\"$form.address\"\n                    />\n                    <validation-indicator params=\"field: $form.address\"></validation-indicator>\n                </div>\n                <validation-message params=\"field: $form.address\"></validation-message>\n            </editor>\n\n            <editor params=\"label: 'Server Secret Key'\">\n                <div class=\"row content-middle\">\n                    <input type=\"text\"\n                        class=\"push-next-half\"\n                        ko.value=\"$form.secret\"\n                        ko.validationCss=\"$form.secret\"\n                    />\n                    <validation-indicator params=\"field: $form.secret\"></validation-indicator>\n                </div>\n                <validation-message params=\"field: $form.secret\"></validation-message>\n            </editor>\n        </section>\n\n        <section class=\"column greedy pad\">\n            <h3 class=\"heading3\" class=\"highlight\">\n                Edit or add additional details for this server\n            </h3>\n\n            <editor params=\"label: 'Server Name'\">\n                <div class=\"row content-middle\">\n                    <input type=\"text\"\n                        class=\"hostname\"\n                        ko.hasFocus=\"true\"\n                        ko.value=\"$form.hostname\"\n                        ko.validationCss=\"$form.hostname\"\n                    />\n                    <span class=\"name-suffix\">- {{$form.secret}}</span>\n                </div>\n                <span class=\"hint\" ko.visible=\"$form.hostname\">\n                    Consist of server hostname and unique id\n                </span>\n                <validation-message params=\"field: $form.hostname\"></validation-message>\n            </editor>\n\n            <editor params=\"label: 'Location Tag'\">\n                <input type=\"text\"\n                    ko.value=\"$form.location\"\n                    ko.validationCss=\"$form.location\"\n                />\n                <validation-message params=\"field: $form.location\"></validation-message>\n            </editor>\n        </section>\n    </wizard>\n</managed-form>\n";

},{}],538:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _attachServerModal = _interopRequireDefault(require("./attach-server-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _formUtils = require("utils/form-utils");

var _netUtils = require("utils/net-utils");

var _services = require("services");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const secretLength = 8;
const steps = (0, _coreUtils.deepFreeze)(['Configure Server', 'Edit Details']);
const fieldsByStep = {
  0: ['address', 'secret'],
  1: ['hostname', 'location']
};

class AttachServerModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "formName", this.constructor.name);
    (0, _defineProperty2.default)(this, "steps", steps);
    (0, _defineProperty2.default)(this, "form", null);
    (0, _defineProperty2.default)(this, "isStepValid", false);
    (0, _defineProperty2.default)(this, "version", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "asyncValidationTriggers", ['address', 'secret']);
    (0, _defineProperty2.default)(this, "fields", {
      step: 0,
      address: '',
      secret: '',
      hostname: '',
      location: 'DC1'
    });
  }

  selectState(state) {
    const {
      system,
      forms
    } = state;
    return [system && system.version, forms[this.formName]];
  }

  mapStateToProps(version, form) {
    _knockout.default.assignToProps(this, {
      version: version ? `System version: ${version}` : '',
      isStepValid: form ? (0, _formUtils.isFormValid)(form) : false
    });
  }

  onValidate(values) {
    const {
      step,
      address,
      secret
    } = values;
    const errors = {};

    if (step === 0) {
      if (!(0, _netUtils.isIP)(address)) {
        errors.address = 'Please enter a valid IP address';
      }

      if (!secret) {
        errors.secret = 'Please enter the server secret key';
      } else if (secret.length !== secretLength) {
        errors.secret = `Server secret key should be ${secretLength} characters long`;
      }
    }

    return errors;
  }

  async onValidateAsync(values) {
    const errors = {};
    const {
      address,
      secret
    } = values;
    const {
      result
    } = await _services.api.cluster_server.verify_candidate_join_conditions({
      address,
      secret
    });

    switch (result) {
      case 'SECRET_MISMATCH':
        {
          errors.secret = `Secret key does not match the server secret key at ${address}`;
          break;
        }

      case 'ADDING_SELF':
        {
          errors.address = 'Already a member of this cluster';
          break;
        }

      case 'UNREACHABLE':
        {
          errors.address = 'Address unreachable';
          break;
        }

      case 'VERSION_MISMATCH':
        {
          errors.address = 'Server is not up to date';
          break;
        }

      case 'ALREADY_A_MEMBER':
        {
          errors.address = 'Already a member of a cluster';
          break;
        }

      case 'HAS_OBJECTS':
        {
          errors.address = 'Server hold uploaded files';
          break;
        }

      case 'CONNECTION_TIMEOUT_ORIGIN':
        {
          errors.address = 'Firewall might be blocking master connectivity to new server';
          break;
        }

      case 'CONNECTION_TIMEOUT_NEW':
        {
          errors.address = 'Firewall might be blocking new server connectivity to master';
          break;
        }
    }

    return errors;
  }

  onBeforeStep(step) {
    if (!this.isStepValid) {
      this.dispatch((0, _actionCreators.touchForm)(this.formName, fieldsByStep[step]));
      return false;
    }

    return true;
  }

  onSubmit(values) {
    const {
      secret,
      address
    } = values;
    const location = values.location ? values.location : undefined;
    const hostname = values.hostname ? values.hostname : undefined;
    this.dispatch((0, _actionCreators.closeModal)(), (0, _actionCreators.attachServerToCluster)(secret, address, hostname, location));
  }

  onCancel() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

}

var _default = {
  viewModel: AttachServerModalViewModel,
  template: _attachServerModal.default
};
exports.default = _default;

},{"./attach-server-modal.html":537,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout","services":1013,"utils/core-utils":1027,"utils/form-utils":1030,"utils/net-utils":1036}],539:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"column greedy pad\">\n    <h2 class=\"heading3\">\n        Main Data Placement Tiers\n    </h2>\n    <p class=\"push-next\">\n        The main resources of this bucket store data.\n        \"Cold\" data will be moved to the second tier automatically according to an LRU policy.\n    </p>\n\n    <section class=\"greedy push-prev\">\n        <div class=\"column borders pad\" ko.forEach=\"tiers\">\n            <!-- ko if: $index -->\n            <svg-icon class=\"icon-small rotate deg90 align-middle push-both-half highlight\" params=\"\n                name: 'arrow-right'\n            \"></svg-icon>\n            <!-- /ko -->\n\n            <div class=\"content-box card-shadow pad row content-middle\">\n                <div class=\"column c10\">\n                    <h3 class=\"heading3\">{{label}}</h3>\n                    <p class=\"row content-middle\">\n                        Policy Type: {{policyType}}\n                        <vr class=\"push-both-half\"></vr>\n                        Pools: {{hostPoolCount}}\n                        <vr class=\"push-both-half\"></vr>\n                        Cloud Resources: {{cloudResourceCount}}\n                    </p>\n                </div>\n                <capacity-bar class=\"c2\" params=\"\n                    total: capacity.total,\n                    used: capacity.used\n                \"></capacity-bar>\n            </div>\n        </div>\n    </section>\n</div>\n\n<div class=\"column pad content-box\">\n    <button class=\"btn align-end\" ko.click=\"onDone\">\n        Done\n    </button>\n</div>\n";

},{}],540:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _bucketPlacementSummaryModal = _interopRequireDefault(require("./bucket-placement-summary-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _actionCreators = require("action-creators");

var _coreUtils = require("utils/core-utils");

var _storageUtils = require("utils/storage-utils");

var _sizeUtils = require("utils/size-utils");

var _bucketUtils = require("utils/bucket-utils");

var _numeral = _interopRequireDefault(require("numeral"));

/* Copyright (C) 2016 NooBaa */
class TierSummaryViewModal {
  constructor() {
    (0, _defineProperty2.default)(this, "label", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "policyType", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "hostPoolCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "cloudResourceCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "capacity", {
      total: _knockout.default.observable(),
      used: _knockout.default.observable()
    });
  }

}

class BucketPlacementSummaryModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "tiers", _knockout.default.observableArray().ofType(TierSummaryViewModal));
  }

  selectState(state, params) {
    const {
      bucketName
    } = params;
    const {
      buckets,
      hostPools,
      cloudResources
    } = state;
    const tiers = buckets && buckets[bucketName] && buckets[bucketName].placement.tiers;
    return [tiers, hostPools, cloudResources];
  }

  mapStateToProps(tiers, hostPools, cloudResources) {
    if (!tiers) {
      _knockout.default.assignToProps(this, {
        dataReady: false
      });
    } else {
      const tiersSummary = tiers.map((tier, i) => {
        const {
          policyType,
          mirrorSets
        } = tier;
        const resources = (0, _coreUtils.flatMap)(mirrorSets, ms => ms.resources);
        const {
          HOSTS: hostPoolCount = 0,
          CLOUD: cloudResourceCount = 0
        } = (0, _coreUtils.countBy)(resources, res => res.type);
        const storage = (0, _storageUtils.aggregateStorage)(...resources.map(res => {
          const coll = res.type === 'HOSTS' ? hostPools : cloudResources;
          return coll[res.name].storage;
        }));
        return {
          label: `Tier ${i + 1}`,
          policyType: (0, _bucketUtils.getPlacementTypeDisplayName)(policyType),
          hostPoolCount: (0, _numeral.default)(hostPoolCount).format(','),
          cloudResourceCount: (0, _numeral.default)(cloudResourceCount).format(','),
          capacity: {
            total: storage.total || 0,
            used: (0, _sizeUtils.sumSize)(storage.used || 0, storage.usedOther || 0, storage.unavailableUsed || 0)
          }
        };
      });

      _knockout.default.assignToProps(this, {
        dataReady: true,
        tiers: tiersSummary
      });
    }
  }

  onDone() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

}

var _default = {
  viewModel: BucketPlacementSummaryModalViewModel,
  template: _bucketPlacementSummaryModal.default
};
exports.default = _default;

},{"./bucket-placement-summary-modal.html":539,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout","numeral":"numeral","utils/bucket-utils":1022,"utils/core-utils":1027,"utils/size-utils":1043,"utils/storage-utils":1045}],541:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2017 NooBaa -->\n\n<managed-form class=\"column greedy\" params=\"\n    name: formName,\n    fields: fields,\n    asyncTriggers: asyncTriggers,\n    onValidate: onValidate,\n    onValidateAsync: onValidateAsync,\n    onSubmit: onSubmit\n\">\n    <section class=\"column greedy pad\">\n        <p class=\"push-next\">\n            Before updating the following fields, go to the linux installer or local DNS server and change the server IP. Once done, fill the following fields:\n        </p>\n        <editor params=\"\n            label: 'Old Server IP'\n        \">\n            <input disabled type=\"text\"\n                ko.value=\"oldAddress\"\n            />\n        </editor>\n        <editor params=\"\n            label: 'New Server IP'\n        \">\n            <div class=\"row\">\n                <input type=\"text\"\n                    class=\"push-next-half\"\n                    ko.value=\"$form.newAddress\"\n                    ko.validationCss=\"$form.newAddress\"\n                    ko.hasFocus=\"true\"\n                />\n                <validation-indicator params=\"field: $form.newAddress\"></validation-indicator>\n            </div>\n            <validation-message params=\"field: $form.newAddress\"></validation-message>\n        </editor>\n    </section>\n    <div class=\"column content-box pad\">\n        <div class=\"row content-middle align-end\">\n            <button type=\"button\" class=\"link alt-colors push-next\" ko.click=\"onCancel\">\n                Cancel\n            </button>\n            <button class=\"btn\" ko.shakeOnClick=\"!$form.isValid()\">\n                Update\n            </button>\n        </div>\n    </div>\n</managed-form>\n";

},{}],542:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _changeClusterConnectivityIpModal = _interopRequireDefault(require("./change-cluster-connectivity-ip-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _netUtils = require("utils/net-utils");

var _knockout = _interopRequireDefault(require("knockout"));

var _actionCreators = require("action-creators");

var _services = require("services");

/* Copyright (C) 2017 NooBaa */
class ChangeClusterConnectivityIpModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "formName", this.constructor.name);
    (0, _defineProperty2.default)(this, "fields", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "asyncTriggers", ['newAddress']);
    (0, _defineProperty2.default)(this, "secret", '');
    (0, _defineProperty2.default)(this, "hostname", '');
    (0, _defineProperty2.default)(this, "oldAddress", _knockout.default.observable());
  }

  selectState(state, params) {
    const {
      topology,
      forms
    } = state;
    return [topology && state.topology.servers[params.secret], forms[this.formName]];
  }

  mapStateToProps(server, form) {
    if (server) {
      const {
        secret,
        hostname,
        addresses
      } = server;

      _knockout.default.assignToProps(this, {
        secret,
        hostname,
        oldAddress: addresses.length > 0 ? addresses[0].ip : '',
        fields: !form ? {
          newAddress: ''
        } : undefined
      });
    }
  }

  onValidate(values) {
    const errors = {};
    const {
      newAddress
    } = values;

    if (!(0, _netUtils.isIP)(newAddress)) {
      errors.newAddress = 'Please enter a valid IP';
    }

    return errors;
  }

  async onValidateAsync(values) {
    const errors = {};
    const {
      newAddress
    } = values;
    const {
      result
    } = await _services.api.cluster_server.verify_new_ip({
      address: newAddress,
      secret: this.secret
    });

    switch (result) {
      case 'SECRET_MISMATCH':
        {
          errors.newAddress = 'Secret does not match server';
          break;
        }

      case 'UNREACHABLE':
        {
          errors.newAddress = 'Server is unreachable';
          break;
        }
    }

    return errors;
  }

  onSubmit(values) {
    this.dispatch((0, _actionCreators.closeModal)(), (0, _actionCreators.updateServerAddress)(this.secret, values.newAddress, this.hostname));
  }

  onCancel() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

}

var _default = {
  viewModel: ChangeClusterConnectivityIpModalViewModel,
  template: _changeClusterConnectivityIpModal.default
};
exports.default = _default;

},{"./change-cluster-connectivity-ip-modal.html":541,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout","services":1013,"utils/net-utils":1036}],543:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<managed-form class=\"column greedy\" params=\"\n    name: formName,\n    fields: formFields,\n    onValidate: onValidate,\n    onValidateSubmit: onValidateSubmit,\n    onSubmit: onSubmit\n\">\n    <div class=\"column greedy pad\">\n        <h2 class=\"heading3\">{{heading}}</h2>\n\n        <editor params=\"label: 'Current password'\">\n            <password-field\n                ko.validationCss=\"$form.password\"\n                params=\"\n                    value: $form.password,\n                    hasFocus: true\n                \"\n            ></password-field>\n            <validation-message params=\"field: $form.password\"></validation-message>\n        </editor>\n\n        <editor params=\"\n            label: 'New password',\n            insertValMessages: false\n        \">\n            <password-field\n                ko.validationCss=\"$form.newPassword\"\n                params=\"\n                    value: $form.newPassword,\n                    strengthCalc: calcPasswordStrength\n                \"\n            ></password-field>\n\n            <ul class=\"restriction-list\"\n                ko.foreach=\"passwordRestrictionList\"\n            >\n                <li ko.text=\"label\" ko.css=\"css\"></li>\n            </ul>\n        </editor>\n    </div>\n\n    <div class=\"column pad content-box\">\n        <div class=\"row content-middle align-end\">\n            <button class=\"link alt-colors push-next\"\n                ko.click=\"onCancel\"\n            >\n                Cancel\n            </button>\n            <working-button ko.shakeOnClick=\"!$form.isValid()\" params=\"\n                click: $form.submit,\n                working: $form.isSubmitting,\n                workingLabel: 'Applying...'\n            \">\n                Change Password\n            </working-button>\n        </div>\n    </div>\n</modal>\n";

},{}],544:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _changePasswordModal = _interopRequireDefault(require("./change-password-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _formUtils = require("utils/form-utils");

var _passwordUtils = require("utils/password-utils");

var _validationUtils = require("utils/validation-utils");

var _actionCreators = require("action-creators");

var _services = require("services");

/* Copyright (C) 2016 NooBaa */
class ChangePasswordModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "formName", this.constructor.name);
    (0, _defineProperty2.default)(this, "calcPasswordStrength", _passwordUtils.calcPasswordStrength);
    (0, _defineProperty2.default)(this, "passwordRestrictionList", _knockout.default.observableArray());
    (0, _defineProperty2.default)(this, "heading", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "accountName", '');
    (0, _defineProperty2.default)(this, "formFields", {
      password: '',
      newPassword: ''
    });
  }

  selectState(state, params) {
    return [params.accountName, state.forms[this.formName]];
  }

  mapStateToProps(accountName, form) {
    if (!form) return;
    const newPassword = (0, _formUtils.getFieldValue)(form, 'newPassword');
    const passwordRestrictionList = (0, _validationUtils.validatePassword)(newPassword).map(({
      valid,
      message
    }) => ({
      label: message,
      css: (0, _formUtils.isFieldTouched)(form, 'newPassword') ? valid ? 'success' : 'error' : ''
    }));

    _knockout.default.assignToProps(this, {
      heading: `Change ${accountName} password:`,
      accountName,
      passwordRestrictionList
    });
  }

  onValidate(values) {
    const {
      password,
      newPassword
    } = values;
    const errors = {};

    if (password.trim() === '') {
      errors.password = 'Please enter your current password';
    }

    if ((0, _validationUtils.validatePassword)(newPassword).some(rule => !rule.valid)) {
      errors.newPassword = '';
    }

    return errors;
  }

  async onValidateSubmit(values) {
    const {
      password: verification_password
    } = values;
    const errors = {};
    const verified = await _services.api.account.verify_authorized_account({
      verification_password
    });

    if (!verified) {
      errors.password = 'Please make sure your password is correct';
    }

    return errors;
  }

  onSubmit(values) {
    const {
      accountName
    } = this;
    const {
      password,
      newPassword
    } = values;
    this.dispatch((0, _actionCreators.closeModal)(), (0, _actionCreators.changeAccountPassword)(password, accountName, newPassword));
  }

  onCancel() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

}

var _default = {
  viewModel: ChangePasswordModalViewModel,
  template: _changePasswordModal.default
};
exports.default = _default;

},{"./change-password-modal.html":543,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout","services":1013,"utils/form-utils":1030,"utils/password-utils":1038,"utils/validation-utils":1047}],545:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<managed-form class=\"column greedy\" params=\"\n    name: formName,\n    fields:formFields\n\">\n    <div class=\"column greedy pad\">\n        <p class=\"push-next\">\n            Some cloud resources might lose access to their target buckets.\n            Before saving this change, make sure that the updated connection credentials have access to the target buckets\n        </p>\n\n        <data-table class=\"usage-table greedy content-box\" params=\"\n            columns: columns,\n            data: rows,\n            sorting: $form.sorting,\n            loading: !dataReady()\n        \"></data-table>\n    </div>\n\n    <div class=\"column pad content-box\">\n        <div class=\"row align-end content-middle\">\n            <button class=\"link alt-colors push-next\"\n                ko.click=\"onBack\"\n            >\n                Back to Edit Connection\n            </button>\n            <button class=\"btn\"\n                ko.click=\"onSave\"\n            >\n                Save\n            </button>\n        </div>\n    </div>\n</managed-form>\n";

},{}],546:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _cloudConnectionUpdateWarningModal = _interopRequireDefault(require("./cloud-connection-update-warning-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _formUtils = require("utils/form-utils");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const columns = (0, _coreUtils.deepFreeze)([{
  name: 'resourceName',
  sortable: true,
  compareKey: usage => usage.entity
}, {
  name: 'targetBucket',
  sortable: true,
  compareKey: usage => usage.externalEntity
}, {
  name: 'usageType',
  label: 'Used as',
  sortable: true,
  compareKey: usage => usage.usageType
}]);

class UsageRowViewModel {
  constructor() {
    (0, _defineProperty2.default)(this, "resourceName", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "targetBucket", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "usageType", _knockout.default.observable());
  }

}

class CloudConnectionUpdateWarningModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "columns", columns);
    (0, _defineProperty2.default)(this, "formName", this.constructor.name);
    (0, _defineProperty2.default)(this, "formFields", {
      sorting: {
        sortBy: 'resourceName',
        order: 1
      }
    });
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "updateAction", null);
    (0, _defineProperty2.default)(this, "rows", _knockout.default.observableArray().ofType(UsageRowViewModel));
  }

  selectState(state, params) {
    const {
      accounts,
      forms
    } = state;
    const connections = accounts && accounts[params.accountName] && accounts[params.accountName].externalConnections;
    const connection = (connections || []).find(connection => connection.name === params.connectionName);
    return [connection && connection.usage, params.updateAction, forms && forms[this.formName]];
  }

  mapStateToProps(usageList, updateAction, form) {
    if (!usageList || !form) {
      _knockout.default.assignToProps(this, {
        dataReady: false
      });
    } else {
      const {
        sortBy = 'resourceName',
        order = 1
      } = (0, _formUtils.getFormValues)(form).sorting;
      const {
        compareKey
      } = columns.find(column => column.name === sortBy);

      _knockout.default.assignToProps(this, {
        dataReady: true,
        updateAction,
        sorting: {
          sortBy,
          order
        },
        rows: [...usageList].sort((0, _coreUtils.createCompareFunc)(compareKey, order)).map(usage => ({
          resourceName: usage.entity,
          targetBucket: usage.externalEntity,
          usageType: usage.usageType === 'CLOUD_RESOURCE' && 'Cloud Resource' || usage.usageType === 'NAMESPACE_RESOURCE' && 'Namespace Resource' || 'Unknown'
        }))
      });
    }
  }

  onSave() {
    this.dispatch((0, _actionCreators.closeModal)(Infinity), this.updateAction);
  }

  onBack() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

}

var _default = {
  viewModel: CloudConnectionUpdateWarningModalViewModel,
  template: _cloudConnectionUpdateWarningModal.default
};
exports.default = _default;

},{"./cloud-connection-update-warning-modal.html":545,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout","utils/core-utils":1027,"utils/form-utils":1030}],547:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<p class=\"pad greedy\">\n    To complete the SSL certificate installation, the current page should be reloaded. <br/>\n    Click the \"Reload Page\" button below to continue.\n</p>\n\n<div class=\"column pad content-box\">\n    <button class=\"btn align-end\"\n        ko.click=\"onReloadPage\"\n    >\n         Reload Page\n    </button>\n</div>\n\n\n";

},{}],548:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _completeSslCertificateInstallationModal = _interopRequireDefault(require("./complete-ssl-certificate-installation-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _browserUtils = require("utils/browser-utils");

/* Copyright (C) 2016 NooBaa */
class CompleteSSLCertificateInstallationModalViewModel extends _connectable.default {
  onReloadPage() {
    (0, _browserUtils.reloadBrowser)();
  }

}

var _default = {
  viewModel: CompleteSSLCertificateInstallationModalViewModel,
  template: _completeSslCertificateInstallationModal.default
};
exports.default = _default;

},{"./complete-ssl-certificate-installation-modal.html":547,"@babel/runtime/helpers/interopRequireDefault":1050,"components/connectable":446,"utils/browser-utils":1021}],549:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<managed-form class=\"column greedy\" params=\"\n    name: formName,\n    fields: formFields,\n    onValidate: onValidate,\n    onSubmit: onSubmit\n\">\n    <div class=\"greedy column pad\">\n        <p>\n            Scaling down the number of nodes will start an evacuation of stored data. It's highly recommended to edit the connected buckets placement policy to avoid any warnings or data inaccessibility. \n        </p>\n        <editor params=\"label: 'Type &#34;scale&#34; to confirm'\">\n            <input class=\"input\"\n                ko.value=\"$form.confirm\"\n                ko.hasFocus=\"true\"\n                ko.validationCss=\"$form.confirm\"\n            />\n            <validation-message params=\"field: $form.confirm\"></validation-message>\n        </editor>\n    </div>\n    <div class=\"column pad content-box\">\n        <div class=\"row align-end content-middle\">\n            <button class=\"btn alt-colors push-next\"\n                ko.click=\"onBack\"\n            >\n                Back to Edit Pool\n            </button>\n            <button class=\"btn\"\n                ko.shakeOnClick=\"!$form.isValid()\"\n            >\n                Yes, Scale Anyway\n            </button>\n        </div>\n    </div>\n</managed-form>\n\n";

},{}],550:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _confirmDangerousScalingModal = _interopRequireDefault(require("./confirm-dangerous-scaling-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
class ConfirmDangerousScalingModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "formName", this.constructor.name);
    (0, _defineProperty2.default)(this, "scaleAction", null);
    (0, _defineProperty2.default)(this, "formFields", {
      confirm: ''
    });
  }

  selectState(state, params) {
    return [params.action];
  }

  mapStateToProps(action) {
    this.scaleAction = action;
  }

  onValidate(values) {
    const errors = {};
    const {
      confirm
    } = values;

    if (confirm.trim().toLowerCase() !== 'scale') {
      errors.confirm = 'Please type "scale" to confirm your action';
    }

    return errors;
  }

  onSubmit() {
    this.dispatch((0, _actionCreators.closeModal)(Infinity), this.scaleAction);
  }

  onBack() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

}

var _default = {
  viewModel: ConfirmDangerousScalingModalViewModel,
  template: _confirmDangerousScalingModal.default
};
exports.default = _default;

},{"./confirm-dangerous-scaling-modal.html":549,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446}],551:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<managed-form class=\"column greedy\" params=\"\n    name: formName,\n    fields: fields\n\">\n    <div class=\"column greedy pad\">\n        <h2 class=\"heading3\">\n            Set Credentials Source:\n        </h2>\n\n        <editor params=\"label: 'Target Account'\">\n            <dropdown params=\"\n                filter: true,\n                actions: accountActions,\n                options: accountOptions,\n                selected: $form.selectedAccount,\n                placeholder: 'Select account',\n                hasFocus: true\n            \"></dropdown>\n        </editor>\n\n        <editor params=\"label: 'S3 Endpoint Address'\">\n            <dropdown params=\"\n                options: endpointOptions,\n                selected: $form.selectedEndpoint,\n                placeholder: 'Select S3 Endpoint'\n            \"></dropdown>\n        </editor>\n\n\n        <h2 class=\"heading3 push-prev push-next-quarter\">\n            Connection Details:\n        </h2>\n\n        <div class=\"content-box pad greedy push-next\">\n            <property-sheet class=\"greedy summary\" params=\"properties: details\">\n                <template name=\"valueWithTooltip\">\n                    <div ko.tooltip=\"$data\">\n                        <div class=\"no-wrap\">{{$data}}</div>\n                    </div>\n                </template>\n            </property-sheet>\n        </div>\n    </div>\n    <div class=\"column pad content-box\">\n        <div class=\"row align-end content-middle\">\n            <button type=\"button\" class=\"link alt-colors push-next\" ko.click=\"onCancel\">\n                Cancel\n            </button>\n            <button class=\"btn\" ko.click=\"onSubmit\">\n                Done\n            </button>\n        </div>\n    </div>\n</managed-form>\n";

},{}],552:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _connectAppModal = _interopRequireDefault(require("./connect-app-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _formUtils = require("utils/form-utils");

var _coreUtils = require("utils/core-utils");

var _knockout = _interopRequireDefault(require("knockout"));

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const endpointKindLabel = (0, _coreUtils.deepFreeze)({
  EXTERNAL: 'Cluster External Name',
  INTERNAL: 'Cluster Internal Name',
  LOOPBACK: 'Server IP'
});

function _getSelectedAccount(accountsWithS3Access, user, form) {
  if (form) {
    return accountsWithS3Access.find(account => account.name === (0, _formUtils.getFieldValue)(form, 'selectedAccount'));
  } // return the user account if it have s3 acceess.


  const userAccount = accountsWithS3Access.find(account => account.name === user);

  if (userAccount) {
    return userAccount;
  } // Return the first user with s3 access.


  return accountsWithS3Access[0];
}

class ConnectAppModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "formName", this.constructor.name);
    (0, _defineProperty2.default)(this, "fields", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "accountOptions", _knockout.default.observableArray());
    (0, _defineProperty2.default)(this, "endpointOptions", _knockout.default.observableArray());
    (0, _defineProperty2.default)(this, "accountActions", [{
      label: 'Create new account',
      onClick: () => this.onCreateNewAccount()
    }]);
    (0, _defineProperty2.default)(this, "details", [{
      label: 'Storage Type',
      value: 'S3 compatible storage'
    }, {
      label: _knockout.default.observable(),
      value: _knockout.default.observable(),
      template: 'valueWithTooltip',
      allowCopy: true
    }, {
      label: 'Access Key',
      value: _knockout.default.observable(),
      allowCopy: true
    }, {
      label: 'Secret Key',
      value: _knockout.default.observable(),
      allowCopy: true
    }]);
  }

  selectState(state) {
    const {
      accounts,
      system,
      location,
      session,
      forms
    } = state;
    return [accounts, system && system.s3Addresses, location.hostname, session && session.user, forms[this.formName]];
  }

  mapStateToProps(accounts, s3Addresses, hostname, user, form) {
    if (!accounts || !s3Addresses || !user) {
      return;
    }

    const accountList = Object.values(accounts).filter(account => !account.roles.includes('operator'));
    const accountOptions = accountList.map(account => account.name);
    const endpointOptions = s3Addresses.map((endpoint, i) => ({
      value: i + 1,
      label: endpointKindLabel[endpoint.kind],
      remark: endpoint.address
    }));

    const {
      name: accountName,
      accessKeys
    } = _getSelectedAccount(accountList, user, form);

    const endpoint = s3Addresses[form ? (0, _formUtils.getFieldValue)(form, 'selectedEndpoint') - 1 : 0];

    _knockout.default.assignToProps(this, {
      accountOptions,
      endpointOptions,
      details: [{}, {
        label: endpointKindLabel[endpoint.kind],
        value: endpoint.address
      }, {
        value: accessKeys.accessKey
      }, {
        value: accessKeys.secretKey
      }],
      fields: !form ? {
        selectedAccount: accountName,
        selectedEndpoint: 1
      } : undefined
    });
  }

  onCreateNewAccount() {
    this.dispatch((0, _actionCreators.openCreateAccountModal)());
  }

  onSubmit() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

  onCancel() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

}

var _default = {
  viewModel: ConnectAppModalViewModel,
  template: _connectAppModal.default
};
exports.default = _default;

},{"./connect-app-modal.html":551,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout","utils/core-utils":1027,"utils/form-utils":1030}],553:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<managed-form class=\"column greedy\" params=\"\n    name: formName,\n    fields: fields,\n    onValidate: onValidate,\n    onWarn: onWarn,\n    onSubmit: onSubmit\n\">\n    <wizard class=\"column greedy\" params=\"\n        steps: steps,\n        step: $form.step,\n        actionLabel: 'Create',\n        disabled: $form.isSubmitted,\n        onBeforeStep: onBeforeStep,\n        onAfterStep: onAfterStep,\n        onComplete: $form.submit,\n        onCancel: onCancel\n    \">\n        <section class=\"column greedy hpad\">\n            <editor params=\"label: 'Access Type'\">\n                <radio-btn params=\"\n                    group: 'accessType',\n                    value: 'ADMIN',\n                    selected: $form.accessType,\n                    label: 'Administrator',\n                    hasFocus: true\n                \"></radio-btn>\n                <p class=\"remark push-next-half\">\n                    Enabling administrative access will generate a password that allows login to\n                    NooBaa management console as a system admin\n                </p>\n                <radio-btn params=\"\n                    group: 'accessType',\n                    value: 'APP',\n                    selected: $form.accessType,\n                    label: 'S3 Access Only'\n                \"></radio-btn>\n                <p class=\"remark\">\n                    Granting S3 access will allow this account to connect S3 client\n                    applications by generating security credentials (key set).\n                </p>\n            </editor>\n\n            <editor params=\"label: accountNameProps.label\">\n                <input type=\"text\"\n                    ko.validationCss=\"$form.accountName\"\n                    ko.value=\"$form.accountName\"\n                    ko.attr.placeholder=\"accountNameProps.placeholder\"\n                />\n                <p class=\"remark\" ko.visible=\"accountNameProps.isRemarkVisible\">\n                    3 - 32 characters\n                </p>\n                <validation-message params=\"field: $form.accountName\"></validation-message>\n            </editor>\n        </section>\n\n        <section class=\"column greedy pad\">\n            <!-- ko if: $form.accessType.eq('ADMIN') -->\n            <div class=\"info-box info pad row content-middle push-next\">\n                <svg-icon params=\"name: 'notif-info'\" class=\"push-next-half\"></svg-icon>\n                <span class=\"greedy\">\n                    Administrator accounts have full S3 access that includes all current and future created buckets via any S3 application or the management console\n                </span>\n            </div>\n            <!-- /ko -->\n\n            <editor params=\"\n                label: 'S3 default placement',\n                tooltip: s3PlacementToolTip,\n            \">\n                <dropdown params=\"\n                        filter: true,\n                        options: resourceOptions,\n                        selected: $form.defaultResource,\n                        subject: 'resource'\n                    \"\n                    ko.validationCss=\"$form.defaultResource\"\n                ></dropdown>\n                 <validation-message params=\"field: $form.defaultResource\"></validation-message>\n            </editor>\n\n            <!-- ko if:  $form.accessType.eq('APP') -->\n            <editor params=\"label: 'Buckets Permissions'\">\n                <dropdown class=\"push-next\" params=\"\n                    options: bucketOptions,\n                    selected: ko.pc(\n                        $form.allowedBuckets,\n                        buckets => onSelectAllowedBuckets(buckets)\n                    ),\n                    filter: true,\n                    subject: 'bucket',\n                    placeholder: 'Choose Buckets',\n                    multiselect: true,\n                    selectAllLabel: 'All Current Buckets'\n                \"></dropdown>\n                <checkbox params=\"\n                    label: 'Include any future buckets',\n                    checked: $form.allowAccessToFutureBuckets,\n                    disabled: isAllowAccessToFutureBucketsDisabled\n                \"></checkbox>\n            </editor>\n\n            <editor params=\"\n                label: 'Allow new bucket creation',\n                tooltip: allowBucketCreationTooltip,\n            \">\n                <toggle-switch params=\"\n                    value: $form.allowBucketCreation,\n                    onLabel: 'Enabled',\n                    offLabel: 'Disabled',\n                \"></toggle-switch>\n            </editor>\n            <!-- /ko -->\n        </section>\n    </wizard>\n</managed-form>\n";

},{}],554:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _createAccountModal = _interopRequireDefault(require("./create-account-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _sizeUtils = require("utils/size-utils");

var _stringUtils = require("utils/string-utils");

var _cloudUtils = require("utils/cloud-utils");

var _formUtils = require("utils/form-utils");

var _validations = require("validations");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const s3AccessTooltip = 'Granting S3 access will allow this account to connect S3 client applications by generating security credentials (key set).';
const s3PlacementToolTip = 'The selected resource will be associated to this account as it’s default data placement for each new bucket that will be created via an S3 application';
const allowBucketCreationTooltip = 'The ability to create new buckets. By disabling this option, the user could not create any new buckets via S3 client or via the management console';

function mapResourceToOptions({
  type,
  name: value,
  storage
}) {
  const {
    total,
    free: availableFree,
    unavailableFree
  } = storage;
  const free = (0, _sizeUtils.sumSize)(availableFree, unavailableFree);
  const remark = `${(0, _sizeUtils.formatSize)(free)} of ${(0, _sizeUtils.formatSize)(total)} Available`;
  const icons = type ? (0, _cloudUtils.getCloudServiceMeta)(type) : {
    icon: 'nodes-pool'
  };
  return { ...icons,
    value,
    remark
  };
}

const steps = (0, _coreUtils.deepFreeze)(['Account Details', 'S3 Access']);
const fieldsByStep = (0, _coreUtils.deepFreeze)({
  0: ['accountName'],
  1: ['defaultResource']
});

function _getAccountNameFieldProps(form) {
  if (!form) return {};
  const accessType = (0, _formUtils.getFieldValue)(form, 'accessType');

  if (accessType === 'ADMIN') {
    return {
      label: 'Email Address',
      placeholder: 'Enter account email address',
      isRemarkVisible: false
    };
  } else {
    const touched = (0, _formUtils.isFieldTouched)(form, 'accountName');
    const valid = (0, _formUtils.isFieldValid)(form, 'accountName');
    return {
      label: 'Account Name',
      placeholder: 'Name this account',
      isRemarkVisible: !touched || valid
    };
  }
}

class CreateAccountModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "formName", this.constructor.name);
    (0, _defineProperty2.default)(this, "steps", steps);
    (0, _defineProperty2.default)(this, "s3AccessTooltip", s3AccessTooltip);
    (0, _defineProperty2.default)(this, "s3PlacementToolTip", s3PlacementToolTip);
    (0, _defineProperty2.default)(this, "allowBucketCreationTooltip", allowBucketCreationTooltip);
    (0, _defineProperty2.default)(this, "accountNames", null);
    (0, _defineProperty2.default)(this, "systemHasResources", false);
    (0, _defineProperty2.default)(this, "resourceOptions", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "bucketOptions", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "password", (0, _stringUtils.randomString)());
    (0, _defineProperty2.default)(this, "accountNameProps", {
      label: _knockout.default.observable(),
      placeholder: _knockout.default.observable(),
      isRemarkVisible: _knockout.default.observable()
    });
    (0, _defineProperty2.default)(this, "isAllowAccessToFutureBucketsDisabled", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isStepValid", false);
    (0, _defineProperty2.default)(this, "fields", _knockout.default.observable());
  }

  selectState(state) {
    return [state.accounts, state.hostPools, state.cloudResources, state.buckets, state.namespaceBuckets, state.forms[this.formName]];
  }

  mapStateToProps(accounts, hostPools, cloudResources, buckets, namespaceBuckets, form) {
    if (!accounts || !hostPools || !cloudResources || !buckets) {
      _knockout.default.assignToProps(this, {
        accountNameProps: {}
      });
    } else {
      const bucketList = [...Object.keys(buckets), ...Object.keys(namespaceBuckets)];
      const {
        accessType = 'ADMIN',
        allowAccessToFutureBuckets = false,
        allowedBuckets = bucketList
      } = form ? (0, _formUtils.getFormValues)(form) : {};
      const accountNames = Object.keys(accounts);
      const resourceList = [...Object.values(hostPools), ...Object.values(cloudResources)];
      const resourceOptions = resourceList.map(mapResourceToOptions);
      const systemHasResources = resourceList.length > 0;
      const isAllowAccessToFutureBucketsDisabled = allowedBuckets.length < bucketList.length;

      _knockout.default.assignToProps(this, {
        accountNames,
        resourceOptions,
        bucketOptions: bucketList,
        accountNameProps: _getAccountNameFieldProps(form),
        isAllowAccessToFutureBucketsDisabled,
        systemHasResources,
        isStepValid: form ? (0, _formUtils.isFormValid)(form) : false,
        fields: !form ? {
          step: 0,
          accountName: '',
          accessType,
          defaultResource: undefined,
          allowedBuckets,
          allowAccessToFutureBuckets,
          allowBucketCreation: true
        } : undefined
      });
    }
  }

  onSelectAllowedBuckets(allowedBuckets) {
    const update = {
      allowedBuckets
    };

    if (allowedBuckets.length < this.bucketOptions().length) {
      update.allowAccessToFutureBuckets = false;
    }

    this.dispatch((0, _actionCreators.updateForm)(this.formName, update));
  }

  onWarn(values) {
    const warnings = {};
    const {
      step
    } = values;

    if (step === 1) {
      if (!this.systemHasResources) {
        warnings.defaultResource = 'Until connecting resources, internal storage will be used';
      }
    }

    return warnings;
  }

  onValidate(values) {
    const {
      step,
      accessType,
      accountName,
      defaultResource
    } = values;
    const subject = accessType === 'ADMIN' && 'Email address' || accessType === 'APP' && 'Account name' || '';
    const accounts = this.accountNames;
    const errors = {};
    const trimmedName = accountName.trim();

    if (step == 0) {
      if (!trimmedName) {
        errors.accountName = `${subject} is required`;
      } else if (accessType === 'ADMIN' && !(0, _validations.isEmail)(trimmedName)) {
        errors.accountName = 'Please enter a valid email address';
      } else if (accessType === 'ADMIN' && trimmedName.length > 70) {
        errors.accountName = 'Please enter an email address up to 70 characters';
      } else if (accessType === 'APP' && (trimmedName.length < 3 || trimmedName.length > 32)) {
        errors.accountName = 'Please enter a name between 3 - 32 characters';
      } else if (accounts.includes(trimmedName)) {
        errors.accountName = `${subject} already in use by another account`;
      }
    } else if (step === 1) {
      if (this.systemHasResources && !defaultResource) {
        errors.defaultResource = 'Please select a default resource for the account';
      }
    }

    return errors;
  }

  onBeforeStep(step) {
    if (!this.isStepValid) {
      this.dispatch((0, _actionCreators.touchForm)(this.formName, fieldsByStep[step]));
      return false;
    }

    return true;
  }

  onAfterStep(step) {
    if (step === 1 && !this.systemHasResources) {
      this.dispatch((0, _actionCreators.touchForm)(this.formName, ['defaultResource']));
    }
  }

  onSubmit(values) {
    const accountName = values.accountName.trim();
    const {
      accessType,
      defaultResource,
      allowAccessToFutureBuckets,
      allowedBuckets,
      allowBucketCreation
    } = values;
    const createAction = accessType === 'ADMIN' ? (0, _actionCreators.createAccount)(accountName, true, this.password, defaultResource, true, null, true) : (0, _actionCreators.createAccount)(accountName, false, null, defaultResource, allowAccessToFutureBuckets, allowedBuckets, allowBucketCreation);
    this.dispatch((0, _actionCreators.updateModal)({
      backdropClose: false,
      closeButton: 'disabled'
    }), createAction);
  }

  onCancel() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

}

var _default = {
  viewModel: CreateAccountModalViewModel,
  template: _createAccountModal.default
};
exports.default = _default;

},{"./create-account-modal.html":553,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout","utils/cloud-utils":1024,"utils/core-utils":1027,"utils/form-utils":1030,"utils/size-utils":1043,"utils/string-utils":1046,"validations":1048}],555:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<managed-form class=\"column greedy\" params=\"\n    name: formName,\n    fields: fields,\n    onValidate: onValidate,\n    onWarn: onWarn,\n    onSubmit: onSubmit\n\">\n    <wizard class=\"column greedy\" params=\"\n        steps: steps,\n        step: $form.step,\n        actionLabel: 'Create',\n        onBeforeStep: onBeforeStep,\n        onAfterStep: onAfterStep,\n        onComplete: $form.submit,\n        onCancel: onCancel,\n        renderControls: false\n    \">\n        <section class=\"column greedy\">\n            <div class=\"column greedy pad\">\n                 <editor params=\"label: 'Bucket Name'\">\n                    <input type=\"text\"\n                            class=\"push-next-half\"\n                            placeholder=\"Type here\"\n                            ko.textInput=\"$form.bucketName\"\n                            ko.hasFocus=\"true\"\n                    />\n                    <ul class=\"restriction-list\" ko.foreach=\"nameRestrictionList\">\n                        <li ko.text=\"label\" ko.css=\"css\"></li>\n                    </ul>\n                </editor>\n            </div>\n            <div class=\"row content-middle page-footer pad content-box\">\n                <p class=\"remark greedy\">\n                    <svg-icon params=\"name: 'notif-info'\" class=\"icon-small\"></svg-icon>\n                    <span>The bucket name cannot be changed after creation</span>\n                </p>\n                <wizard-controls></wizard-controls>\n            </div>\n        </section>\n\n        <section class=\"column greedy\">\n            <div class=\"column greedy pad\">\n                <placement-policy-toggle class=\"push-next-half\" params=\"\n                    selectedPolicy: $form.policyType,\n                    hasFocus: true\n                \"></placement-policy-toggle>\n                <resources-selection-table class=\"column greedy\" params=\"\n                    title: 'Resources in Policy',\n                    hostPools: hostPools,\n                    cloudResources: cloudResources,\n                    selected: $form.selectedResources,\n                    disabled: disabledResources\n                \"></resources-selection-table>\n                <validation-message params=\"field: $form.selectedResources\">\n                </validation-message>\n            </div>\n            <div class=\"row content-middle page-footer pad content-box\">\n                <p class=\"remark greedy\">\n                    <svg-icon params=\"name: 'notif-info'\" class=\"icon-small\"></svg-icon>\n                    <span>To create a new resource go to ></span>\n                    <a class=\"link\" ko.attr.href=\"resourcesHref\">Resources</a>\n                </p>\n                <wizard-controls></wizard-controls>\n            </div>\n        </section>\n    </wizard>\n</managed-form>\n";

},{}],556:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _createBucketModal = _interopRequireDefault(require("./create-bucket-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _formUtils = require("utils/form-utils");

var _coreUtils = require("utils/core-utils");

var _browserUtils = require("utils/browser-utils");

var _bucketUtils = require("utils/bucket-utils");

var _resourceUtils = require("utils/resource-utils");

var _validationUtils = require("utils/validation-utils");

var routes = _interopRequireWildcard(require("routes"));

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const steps = (0, _coreUtils.deepFreeze)([{
  label: 'choose name',
  size: 'small'
}, {
  label: 'set policy',
  size: 'xlarge'
}]);
const fieldsByStep = (0, _coreUtils.deepFreeze)({
  0: ['bucketName'],
  1: ['policyType', 'selectedResources']
});
const invalidHostPoolStates = (0, _coreUtils.deepFreeze)(['INITIALIZING', 'DELETING']);

class CreateBucketModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "formName", this.constructor.name);
    (0, _defineProperty2.default)(this, "steps", steps.map(step => step.label));
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "resourcesHref", '');
    (0, _defineProperty2.default)(this, "isStepValid", false);
    (0, _defineProperty2.default)(this, "nameRestrictionList", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "existingNames", []);
    (0, _defineProperty2.default)(this, "systemResourceCount", 0);
    (0, _defineProperty2.default)(this, "hostPools", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "cloudResources", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "disabledResources", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "fields", {
      step: 0,
      bucketName: '',
      policyType: 'SPREAD',
      selectedResources: []
    });
  }

  onState(state, params) {
    super.onState(state, params);
  }

  selectState(state) {
    return [state.buckets, state.hostPools, state.cloudResources, state.forms[this.formName], state.location.params.system];
  }

  mapStateToProps(buckets, hostPools, cloudResources, form, system) {
    if (!buckets || !hostPools || !cloudResources || !form) {
      _knockout.default.assignToProps(this, {
        dataReady: false
      });
    } else {
      const existingNames = Object.keys(buckets);
      const systemResourceCount = Object.keys(hostPools).length + Object.keys(cloudResources).length;
      const bucketName = (0, _formUtils.getFieldValue)(form, 'bucketName');
      const resourcesHref = (0, _browserUtils.realizeUri)(routes.resources, {
        system
      });
      const isStepValid = (0, _formUtils.isFormValid)(form);
      const nameRestrictionList = (0, _validationUtils.validateName)(bucketName, existingNames).map(({
        valid,
        message
      }) => ({
        label: message,
        css: (0, _formUtils.isFieldTouched)(form, 'bucketName') ? valid ? 'success' : 'error' : ''
      }));
      const disabledResources = Object.values(hostPools).filter(pool => invalidHostPoolStates.includes(pool.mode)).map(pool => (0, _resourceUtils.getResourceId)('HOSTS', pool.name));

      _knockout.default.assignToProps(this, {
        existingNames,
        systemResourceCount,
        nameRestrictionList,
        resourcesHref,
        isStepValid,
        hostPools,
        cloudResources,
        disabledResources
      });
    }
  }

  onValidate(values) {
    const {
      step,
      bucketName,
      policyType,
      selectedResources
    } = values;
    const errors = {};

    if (step === 0) {
      const hasNameErrors = (0, _validationUtils.validateName)(bucketName, this.existingNames).some(({
        valid
      }) => !valid);

      if (hasNameErrors) {
        errors.bucketName = '';
      }
    } else if (step === 1) {
      if (this.systemResourceCount > 0) {
        (0, _bucketUtils.validatePlacementPolicy)(values, errors); // This rule should be inforced only on bucket creation, this is why it's not
        // part of the generic validatePlacementPolicy check.

        if (policyType === 'SPREAD' && selectedResources.length === 0) {
          errors.selectedResources = 'Spread policy requires at least 1 participating resources';
        }
      }
    }

    return errors;
  }

  onWarn(values) {
    const warnings = {};

    if (this.systemResourceCount === 0) {
      warnings.selectedResources = `This Bucket will be using the internal server’s disks capacity as a storage
                resource until a healthy resource will be added`;
    } else {
      (0, _bucketUtils.warnPlacementPolicy)(values, this.hostPools(), this.cloudResources(), warnings);
    }

    return warnings;
  }

  onBeforeStep(step) {
    if (!this.isStepValid) {
      this.dispatch((0, _actionCreators.touchForm)(this.formName, fieldsByStep[step]));
      return false;
    }

    return true;
  }

  onAfterStep(step) {
    const {
      size
    } = steps[step];
    this.dispatch((0, _actionCreators.updateModal)({
      size
    }));
  }

  onCancel() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

  onSubmit(values) {
    const {
      bucketName,
      policyType,
      selectedResources
    } = values;
    this.dispatch((0, _actionCreators.closeModal)());
    this.dispatch((0, _actionCreators.createBucket)(bucketName, policyType, selectedResources));
  }

}

var _default = {
  viewModel: CreateBucketModalViewModel,
  template: _createBucketModal.default
};
exports.default = _default;

},{"./create-bucket-modal.html":555,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"components/connectable":446,"knockout":"knockout","routes":972,"utils/browser-utils":1021,"utils/bucket-utils":1022,"utils/core-utils":1027,"utils/form-utils":1030,"utils/resource-utils":1041,"utils/validation-utils":1047}],557:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<managed-form class=\"column greedy\" params=\"\n    name: formName,\n    fields: fields,\n    onValidate: values => onValidate(values, existingNames),\n    onSubmit: onSubmit\n\">\n    <wizard class=\"column greedy\" params=\"\n        steps: steps,\n        step: $form.step,\n        actionLabel: 'Create',\n        onBeforeStep: onBeforeStep,\n        onComplete: $form.submit,\n        onCancel: onCancel\n    \">\n        <section class=\"column greedy\">\n            <div class=\"column greedy pad\">\n                <editor params=\"label: 'Function Name'\">\n                    <input type=\"text\"\n                        ko.value=\"$form.funcName\"\n                        ko.hasFocus=\"true\"\n                        ko.validationCss=\"$form.funcName\"\n                    />\n                    <validation-message params=\"field: $form.funcName\"></validation-message>\n                </editor>\n                <editor params=\"label: 'Description'\">\n                    <textarea class=\"desc-field\"\n                        ko.value=\"$form.funcDesc\"\n                        ko.validationCss=\"$form.funcDesc\"\n                    ></textarea>\n                    <p class=\"hint\" ko.visible=\"$form.funcDesc.isValid\">Up to 256 characters</p>\n                    <validation-message params=\"field: $form.funcDesc\"></validation-message>\n                </editor>\n                <editor class=\"greedy\" params=\"label: 'Runtime', tooltip: runtimeTooltip\">\n                    <input type=\"text\" disabled ko.value=\"runtime\" />\n                </editor>\n            </div>\n        </section>\n\n        <section class=\"column greedy\">\n            <div class=\"column greedy pad\">\n                <radio-group params=\"\n                    options: codeFormatOptions,\n                    selected: $form.codeFormat,\n                    hasFocus: true\n                \"></radio-group>\n\n                <textarea class=\"greedy align-stretch content-box code-field\"\n                    placeholder=\"Type your code here\"\n                    ko.visible=\"$form.codeFormat.eq('TEXT')\"\n                    ko.value=\"$form.inlineCode\"\n                    ko.hasFocus=\"true\"\n                    ko.validationCss=\"$form.inlineCode\"\n                ></textarea>\n                <validation-message params=\"field: $form.inlineCode\"></validation-message>\n\n                <div class=\"column greedy push-next\"\n                    ko.visible=\"$form.codeFormat.eq('PACKAGE')\"\n                >\n                    <drop-area class=\"greedy\"\n                        ko.validationCss=\"$form.codePackage\"\n                        params=\"onDrop: onDropPackage \"\n                    >\n                        <!-- ko ifnot: $form.codePackage -->\n                        <p class=\"push-next-half\">\n                            Drag a zip file here or\n                        </p>\n                        <label class=\"btn alt-colors\"\n                            tabindex=\"0\"\n                            ko.keysToClicks=\"['space', 'enter']\"\n                        >\n                            Browse\n                            <input type=\"file\"\n                                tabindex=\"-1\"\n                                class=\"hide\"\n                                ko.attr.accept=\"'.zip'\",\n                                ko.event.change=\"onSelectPackage\"\n                            />\n                        </label>\n                        <!-- /ko -->\n\n                        <!-- ko if: $form.codePackage -->\n                       <p class=\"row content-middle push-next-half\">\n                            <!-- ko if: $form.codePackage.isInvalid -->\n                            <svg-icon class=\"icon-small error push-next-half\" params=\"\n                                name: 'problem'\n                            \"></svg-icon>\n                            {{$form.codePackage().name}} upload failed\n                            <!-- /ko -->\n\n                            <!-- ko if: $form.codePackage.isValid -->\n                            <svg-icon class=\"icon-small success push-next-half\" params=\"\n                                name: 'healthy'\n                            \"></svg-icon>\n                            {{$form.codePackage().name}} uploaded\n                            <!-- /ko -->\n                        </p>\n                        <label class=\"link alt-colors\">\n                            Change File\n                            <input type=\"file\"\n                                class=\"hide\"\n                                ko.attr.accept=\"'.zip'\",\n                                ko.event.change=\"onSelectPackage\"\n                            />\n                        </label>\n                        <!-- /ko -->\n                    </drop-area>\n                    <p class=\"remark\" ko.visible=\"!$form.codePackage.isInvalidTouched()\">\n                        Maximum upload size: {{formattedPkgSizeLimit}}\n                    </p>\n                    <validation-message params=\"field: $form.codePackage\"></validation-message>\n                </div>\n\n                <editor params=\"label: 'Execution File', tooltip: handlerFileTooltip\"\n                    ko.visible=\"$form.codeFormat.eq('PACKAGE')\"\n                >\n                    <div class=\"row content-middle\">\n                        <dropdown class=\"push-next-half\"\n                            ko.validationCss=\"$form.handlerFile\"\n                            params=\"\n                                placeholder: 'Choose file...',\n                                filter: true,\n                                filterPlaceholder: handlerFileFilterPlaceholder,\n                                options: handlerFileOptions,\n                                selected: $form.handlerFile,\n                                disabled: isHandlerSelectionDisabled\n                            \"\n                        ></dropdown>\n                        <button class=\"icon-btn\"\n                            ko.disable=\"isShowFileContentBtnDisabled\"\n                            ko.click=\"onShowFileContent\"\n                            ko.tooltip=\"'Open file content in new tab'\"\n                        >\n                            <svg-icon class=\"icon-small\" params=\"name: 'expand'\"></svg-icon>\n                        </button>\n                    </div>\n                    <validation-message params=\"field: $form.handlerFile\"></validation-message>\n                </editor>\n\n                <editor params=\"label: 'Execution Function', tooltip: handlerFuncTooltip\">\n                    <input type=\"text\"\n                        placeholder=\"Function name\"\n                        ko.value=\"$form.handlerFunc\"\n                        ko.validationCss=\"$form.handlerFunc\"\n                        ko.disable=\"isHandlerSelectionDisabled\"\n                    />\n                    <validation-message params=\"field: $form.handlerFunc\"></validation-message>\n                </editor>\n            </div>\n        </section>\n\n        <section class=\"column greedy\">\n            <div class=\"column greedy pad\">\n                <editor params=\"label: 'Memory Size'\">\n                    <dropdown params=\"\n                        options: memorySizeOptions,\n                        selected: $form.memorySize,\n                        hasFocus: true\n                    \"></dropdown>\n                </editor>\n                <editor class=\"greedy\" params=\"label: 'Timeout'\">\n                    <div class=\"row\">\n                        <input type=\"number\"\n                            min=\"0\"\n                            class=\"push-next-half\"\n                            ko.value=\"$form.timeoutMinutes\"\n                            ko.validationCss=\"$form.timeoutMinutes\"\n                        />\n                        <span class=\"push-next\">Min</span>\n                        <input type=\"number\"\n                            min=\"0\"\n                            class=\"push-next-half\"\n                            ko.value=\"$form.timeoutSeconds\"\n                            ko.validationCss=\"$form.timeoutSeconds\"\n                        />\n                        <span>Sec</span>\n                    </div>\n                    <span class=\"val-msg\">{{timeoutError}}</span>\n                </editor>\n            </div>\n        </section>\n    </wizard>\n</managed-form>\n";

},{}],558:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _createFuncModal = _interopRequireDefault(require("./create-func-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _browserUtils = require("utils/browser-utils");

var _stringUtils = require("utils/string-utils");

var _sizeUtils = require("utils/size-utils");

var _formUtils = require("utils/form-utils");

var _services = require("services");

var _jszip = _interopRequireDefault(require("jszip"));

var _funcUtils = require("utils/func-utils");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const steps = (0, _coreUtils.deepFreeze)(['Basic Configuration', 'Function Code', 'Configuration']);
const codeFormatOptions = (0, _coreUtils.deepFreeze)([{
  value: 'TEXT',
  label: 'Type code manually'
}, {
  value: 'PACKAGE',
  label: 'Upload a code package (zip file)'
}]);
const inlineCodeHandlerFile = 'main.js';
const handlerFileTooltip = 'The name of the file which the handler function is written in';
const handlerFuncTooltip = 'The function within your code that will initiate the execution. The name should match to the function name in the selected file';
const fieldsByStep = (0, _coreUtils.deepFreeze)({
  0: ['funcName', 'funcDesc'],
  1: ['codeFormat', 'inlineCode', 'codePackage', 'handlerFile', 'handlerFunc'],
  2: ['memorySize', 'timeoutMinutes', 'timeoutSeconds']
});

function _getRuntimeTooltip(runtime) {
  return `The runtime environment for the function you are uploading. Currently, ${runtime} is the only available environment in NooBaa.`;
}

async function _selectCode(codeFormat, inlineCode, codePackage) {
  switch (codeFormat) {
    case 'TEXT':
      {
        const zip = new _jszip.default();
        zip.file(inlineCodeHandlerFile, inlineCode);
        const uint8 = await zip.generateAsync({
          type: 'uint8array',
          compression: 'DEFLATE',
          compressionOptions: {
            level: 9
          }
        });
        return {
          bufferKey: _services.bufferStore.store(uint8.buffer),
          size: uint8.byteLength
        };
      }

    case 'PACKAGE':
      {
        return (0, _coreUtils.pick)(codePackage, ['bufferKey', 'size']);
      }

    default:
      {
        return null;
      }
  }
}

class CreateFuncModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "formName", this.constructor.name);
    (0, _defineProperty2.default)(this, "steps", steps);
    (0, _defineProperty2.default)(this, "runtime", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "formattedPkgSizeLimit", (0, _sizeUtils.formatSize)(_funcUtils.funcSizeLimit));
    (0, _defineProperty2.default)(this, "codeFormatOptions", codeFormatOptions);
    (0, _defineProperty2.default)(this, "memorySizeOptions", _funcUtils.memorySizeOptions);
    (0, _defineProperty2.default)(this, "runtimeTooltip", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "handlerFileTooltip", handlerFileTooltip);
    (0, _defineProperty2.default)(this, "handlerFuncTooltip", handlerFuncTooltip);
    (0, _defineProperty2.default)(this, "handlerFileFilterPlaceholder", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "existingNames", []);
    (0, _defineProperty2.default)(this, "isHandlerSelectionDisabled", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isShowFileContentBtnDisabled", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "handlerFileOptions", _knockout.default.observableArray());
    (0, _defineProperty2.default)(this, "selectedFileInfo", null);
    (0, _defineProperty2.default)(this, "isStepValid", false);
    (0, _defineProperty2.default)(this, "timeoutError", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "fields", {
      step: 0,
      funcName: '',
      funcDesc: '',
      codeFormat: codeFormatOptions[0].value,
      inlineCode: '',
      codePackage: null,
      handlerFile: '',
      handlerFunc: '',
      memorySize: _funcUtils.memorySizeOptions[0].value,
      timeoutMinutes: 0,
      timeoutSeconds: 30
    });
  }

  selectState(state) {
    const {
      functions,
      forms,
      system
    } = state;
    return [functions, forms && forms[this.formName], system.nodeVersion];
  }

  mapStateToProps(functions, form, nodeVersion) {
    if (!functions || !form) {
      return;
    }

    const [major, minor] = nodeVersion.slice(1).split('.', 2);
    const runtime = `nodejs${major}.${minor}`;
    const existingNames = Object.values(functions).map(func => func.name);
    const {
      codeFormat,
      codePackage,
      handlerFile
    } = (0, _formUtils.getFormValues)(form);
    const hasValidCodePkg = codeFormat !== 'PACKAGE' || (0, _formUtils.isFieldValid)(form, 'codePackage');
    const isPkgFileSelected = hasValidCodePkg && Boolean(handlerFile);
    const handlerFileOptions = (codePackage && codePackage.files || []).map(filename => {
      const label = (0, _stringUtils.shortString)(filename, 35, 20);
      const value = filename;
      const tooltip = {
        text: filename,
        breakWords: true
      };
      const disabled = !filename.endsWith(_funcUtils.handlerFileSuffix);
      return {
        label,
        value,
        disabled,
        tooltip
      };
    });
    const selectedFileInfo = isPkgFileSelected ? {
      bufferKey: codePackage && codePackage.bufferKey,
      filename: handlerFile
    } : null;
    const handlerFileFilterPlaceholder = `Search in ${(0, _stringUtils.stringifyAmount)('file', handlerFileOptions.length)}`;

    _knockout.default.assignToProps(this, {
      runtime,
      runtimeTooltip: _getRuntimeTooltip(runtime),
      existingNames,
      isHandlerSelectionDisabled: !hasValidCodePkg,
      isShowFileContentBtnDisabled: !isPkgFileSelected,
      handlerFileOptions: handlerFileOptions,
      handlerFileFilterPlaceholder: handlerFileFilterPlaceholder,
      selectedFileInfo: selectedFileInfo,
      isStepValid: (0, _formUtils.isFormValid)(form),
      timeoutError: (0, _formUtils.getFieldError)(form, 'timeout') || ''
    });
  }

  onValidate(values, existingNames) {
    const {
      step
    } = values;
    const errors = {};

    switch (step) {
      case 0:
        {
          const {
            funcName,
            funcDesc
          } = values;

          if (!funcName) {
            errors.funcName = 'Name must contain at least one character';
          } else if (funcName.length > 140) {
            errors.funcName = 'Name must be 140 characters or less';
          } else if (!(0, _funcUtils.isValidFuncName)(funcName)) {
            errors.funcName = 'Please use only alphanumeric characters, hyphens or underscores';
          } else if (existingNames.includes(funcName)) {
            errors.funcName = 'Name already in use';
          }

          const overflow = funcDesc.length - 256;

          if (overflow > 0) {
            errors.funcDesc = `${overflow} characters over the limit of 256`;
          }

          break;
        }

      case 1:
        {
          const {
            codeFormat,
            inlineCode,
            codePackage,
            handlerFile,
            handlerFunc
          } = values;

          if (codeFormat === 'TEXT') {
            if (!inlineCode) {
              errors.inlineCode = 'Please enter javascript code';
            }
          } else {
            if (!codePackage) {
              errors.codePackage = 'Please upload a code package';
            } else if (codePackage.oversized) {
              errors.codePackage = `Package size exceeds ${(0, _sizeUtils.formatSize)(_funcUtils.funcSizeLimit)}. Please use AWS API to complete the upload`;
            } else if (codePackage.files.length === 0) {
              errors.codePackage = 'Package does not contain execution files';
            } else if (!handlerFile) {
              errors.handlerFile = 'Please choose an execution file name';
            }
          }

          if (codeFormat === 'TEXT' || !errors.codePackage) {
            if (!handlerFunc) {
              errors.handlerFunc = 'Please enter the name of the requested execution function';
            } else if (!(0, _funcUtils.isValidHandlerFuncName)(handlerFunc)) {
              errors.handlerFunc = 'Please enter a valid javascript function name';
            }
          }

          break;
        }

      case 2:
        {
          const {
            timeoutSeconds,
            timeoutMinutes
          } = values;
          const isTimeoutValid = Number.isInteger(timeoutMinutes) && Number.isInteger(timeoutSeconds) && timeoutMinutes >= 0 && timeoutSeconds >= 0 && timeoutMinutes + timeoutSeconds > 0;

          if (!isTimeoutValid) {
            errors.timeoutMinutes = errors.timeoutSeconds = '';
            errors.timeout = 'Please enter a timeout greater then 0';
          }

          break;
        }
    }

    return errors;
  }

  onBeforeStep(step) {
    if (!this.isStepValid) {
      this.dispatch((0, _actionCreators.touchForm)(this.formName, fieldsByStep[step]));
      return false;
    }

    return true;
  }

  onDropPackage(_, evt) {
    const [file] = evt.dataTransfer.files;

    this._onCodePackage(file);
  }

  onSelectPackage(_, evt) {
    const [file] = evt.target.files;

    this._onCodePackage(file);
  }

  async onSubmit(values) {
    const {
      funcName,
      funcDesc,
      handlerFile,
      handlerFunc,
      memorySize,
      timeoutMinutes,
      timeoutSeconds,
      codeFormat,
      inlineCode,
      codePackage
    } = values;
    const {
      bufferKey,
      size
    } = await _selectCode(codeFormat, inlineCode, codePackage);
    const selectedHandlerFile = codeFormat === 'TEXT' ? inlineCodeHandlerFile : handlerFile;
    this.dispatch((0, _actionCreators.closeModal)(), (0, _actionCreators.createLambdaFunc)(funcName, '$LATEST', funcDesc, this.runtime(), selectedHandlerFile, handlerFunc, memorySize, timeoutMinutes * 60 + timeoutSeconds, bufferKey, size));
  }

  onCancel() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

  async onShowFileContent() {
    const {
      bufferKey,
      filename
    } = this.selectedFileInfo;

    const buffer = _services.bufferStore.get(bufferKey);

    if (buffer) {
      const zip = await _jszip.default.loadAsync(buffer);
      const file = await zip.file(filename).async('string');
      (0, _browserUtils.openInNewTab)((0, _browserUtils.toObjectUrl)(file));
    }
  }

  async _onCodePackage(pkg) {
    const {
      name,
      size
    } = pkg;

    if (size > _funcUtils.funcSizeLimit) {
      const codePackage = {
        name,
        size,
        oversized: true
      };
      this.dispatch((0, _actionCreators.updateForm)(this.formName, {
        codePackage
      }));
    } else {
      const buffer = await (0, _browserUtils.readFileAsArrayBuffer)(pkg);

      const bufferKey = _services.bufferStore.store(buffer);

      const zip = await _jszip.default.loadAsync(buffer);
      const files = Object.values(zip.files).filter(file => file.name.endsWith(_funcUtils.handlerFileSuffix)).map(file => file.name);
      const codePackage = {
        name,
        size,
        files,
        bufferKey
      };
      this.dispatch((0, _actionCreators.updateForm)(this.formName, {
        codePackage,
        handlerFile: '',
        handlerFunc: ''
      }), (0, _actionCreators.untouchForm)(this.formName, ['handlerFile', 'handlerFunc']));
    }
  }

}

var _default = {
  viewModel: CreateFuncModalViewModel,
  template: _createFuncModal.default
};
exports.default = _default;

},{"./create-func-modal.html":557,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"jszip":"jszip","knockout":"knockout","services":1013,"utils/browser-utils":1021,"utils/core-utils":1027,"utils/form-utils":1030,"utils/func-utils":1031,"utils/size-utils":1043,"utils/string-utils":1046}],559:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<managed-form class=\"column greedy\" params=\"\n    name: formName,\n    fields: fields,\n    onValidate: onValidate,\n    onWarn: values => onWarn(values, resourceServiceMapping),\n    onSubmit: onSubmit\n\">\n    <wizard class=\"column greedy\" params=\"\n        steps: steps,\n        step: $form.step,\n        actionLabel: 'Create',\n        onBeforeStep: onBeforeStep,\n        onComplete: $form.submit,\n        onCancel: onCancel,\n        renderControls: false\n    \">\n        <section class=\"column greedy\">\n            <div class=\"column greedy pad\">\n                <p class=\"push-next\">\n                    A Namespace bucket can be used for data display, the data will reside in\n                    it's original source and will not be encrypted or replicated\n                </p>\n                <editor class=\"greedy\" params=\"label: 'Bucket Name'\">\n                    <input type=\"text\"\n                        class=\"push-next-half\"\n                        ko.textInput=\"ko.pc($form.bucketName, onBucketName)\"\n                        ko.validationCss=\"$form.bucketName\"\n                        ko.hasFocus=\"true\"\n                    />\n                    <ul class=\"restriction-list\" ko.foreach=\"nameRestrictionList\">\n                        <li ko.text=\"label\" ko.css=\"css\"></li>\n                    </ul>\n                </editor>\n            </div>\n            <div class=\"row content-middle pad content-box\">\n                <p class=\"remark greedy push-next\">\n                    <svg-icon class=\"icon-small valign-bottom\"\n                        params=\"name: 'notif-info'\"\n                    ></svg-icon>\n                    The bucket name cannot be changed after creation\n                </p>\n                <wizard-controls></wizard-controls>\n            </div>\n        </section>\n\n        <section class=\"column greedy\">\n            <div class=\"column greedy pad\">\n                <h2 class=\"heading3\">Read Policy</h2>\n                <p class=\"push-next-half\">This namespace bucket will read its data from the selected namespace resources</p>\n                <data-table class=\"greedy content-box resource-table\" params=\"\n                    columns: readPolicyTableColumns,\n                    data: readPolicyRows\n                \"></data-table>\n                <validation-message params=\"field: $form.readPolicy\"></validation-message>\n\n                <h2 class=\"heading3 push-prev\">Write Policy</h2>\n                <p>This namespace bucket will write its data to the selected namespace resource</p>\n                <editor params=\"\n                    label: 'Namespace Resource',\n                    disabled: isWritePolicyDisabled\n                \">\n                    <dropdown params=\"\n                            options: writePolicyOptions,\n                            selected: $form.writePolicy,\n                            disabled: isWritePolicyDisabled,\n                        \"\n                        ko.validationCss=\"$form.writePolicy\"\n                    ></dropdown>\n                    <validation-message params=\"field: $form.writePolicy\"></validation-message>\n                </editor>\n            </div>\n            <div class=\"column pad content-box\">\n                <wizard-controls class=\"align-end\"></wizard-controls>\n            </div>\n        </section>\n\n        <section class=\"column greedy\">\n            <div class=\"column greedy pad\">\n                <h2 class=\"heading3\">Caching Configuration (Dev Preview Feature)</h2>\n                <p class=\"push-next\">\n                    Caching configuration controls how data is cached in local storage\n                </p>\n                <checkbox params=\"\n                    label: 'Enable caching', \n                    checked: $form.enableCaching\n                \"></checkbox>\n            </div>\n            <div class=\"column pad content-box\">\n                <wizard-controls class=\"align-end\"></wizard-controls>\n            </div>\n        </section>\n    </wizard>\n</managed-form>\n\n\n";

},{}],560:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _createNamespaceBucketModal = _interopRequireDefault(require("./create-namespace-bucket-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _validationUtils = require("utils/validation-utils");

var _resourceUtils = require("utils/resource-utils");

var _formUtils = require("utils/form-utils");

var _config = require("config");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const steps = (0, _coreUtils.deepFreeze)(['Choose Name', 'Set Placement', 'Set Caching Policy']);
const readPolicyTableColumns = (0, _coreUtils.deepFreeze)([{
  name: 'selected',
  label: '',
  type: 'checkbox'
}, {
  name: 'state',
  type: 'icon'
}, {
  name: 'type',
  type: 'icon'
}, {
  name: 'name',
  label: 'Namespace Resource Name'
}, {
  name: 'target',
  label: 'Target Name'
}]);
const fieldsByStep = (0, _coreUtils.deepFreeze)({
  0: ['bucketName'],
  1: ['readPolicy', 'writePolicy']
});

class ResourceRowViewModel {
  constructor({
    table
  }) {
    (0, _defineProperty2.default)(this, "table", null);
    (0, _defineProperty2.default)(this, "state", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "type", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "name", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "target", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isSelected", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "selected", _knockout.default.pureComputed({
      read: this.isSelected,
      write: this.onToggle,
      owner: this
    }));
    this.table = table;
  }

  onToggle(val) {
    this.table.onToggleReadPolicyResource(this.name(), val);
  }

}

class CreateNamespaceBucketModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "formName", this.constructor.name);
    (0, _defineProperty2.default)(this, "steps", steps);
    (0, _defineProperty2.default)(this, "isStepValid", false);
    (0, _defineProperty2.default)(this, "existingNames", []);
    (0, _defineProperty2.default)(this, "nameRestrictionList", _knockout.default.observableArray());
    (0, _defineProperty2.default)(this, "readPolicyTableColumns", readPolicyTableColumns);
    (0, _defineProperty2.default)(this, "readPolicyRows", _knockout.default.observableArray().ofType(ResourceRowViewModel, {
      table: this
    }));
    (0, _defineProperty2.default)(this, "isWritePolicyDisabled", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "writePolicyOptions", _knockout.default.observableArray());
    (0, _defineProperty2.default)(this, "resourceServiceMapping", {});
    (0, _defineProperty2.default)(this, "readPolicy", []);
    (0, _defineProperty2.default)(this, "writePolicy", '');
    (0, _defineProperty2.default)(this, "fields", {
      step: 0,
      bucketName: '',
      readPolicy: [],
      writePolicy: undefined,
      enableCaching: false
    });
    (0, _defineProperty2.default)(this, "onBucketName", (0, _coreUtils.throttle)(bucketName => this.dispatch((0, _actionCreators.updateForm)(this.formName, {
      bucketName
    })), _config.inputThrottle, this));
  }

  selectState(state) {
    return [state.buckets, state.namespaceBuckets, state.namespaceResources, state.forms[this.formName]];
  }

  mapStateToProps(buckets, namespaceBuckets, resources, form) {
    if (!buckets || !namespaceBuckets || !resources || !form) {
      return;
    }

    const bucketName = (0, _formUtils.getFieldValue)(form, 'bucketName');
    const readPolicy = (0, _formUtils.getFieldValue)(form, 'readPolicy');
    const writePolicy = (0, _formUtils.getFieldValue)(form, 'writePolicy');
    const existingNames = [...Object.keys(buckets), ...Object.keys(namespaceBuckets)];
    const nameRestrictionList = (0, _validationUtils.validateName)(bucketName, existingNames).map(result => {
      // Use nocss class to indeicate no css is needed, cannot use empty string
      // because of the use of logical or as condition fallback operator.
      const css = !(0, _formUtils.isFieldTouched)(form, 'bucketName') && 'nocss' || result.valid && 'success' || 'error';
      return {
        label: result.message,
        css: css === 'nocss' ? '' : css
      };
    });
    const resourceList = Object.values(resources);
    const readPolicyRows = resourceList.map(resource => ({
      state: (0, _resourceUtils.getNamespaceResourceStateIcon)(resource),
      type: (0, _resourceUtils.getNamespaceResourceTypeIcon)(resource),
      name: resource.name,
      target: resource.target,
      isSelected: readPolicy.includes(resource.name)
    }));
    const writePolicyOptions = resourceList.filter(resource => readPolicy.includes(resource.name)).map(resource => {
      const {
        name: value
      } = resource;
      const {
        name: icon
      } = (0, _resourceUtils.getNamespaceResourceTypeIcon)(resource);
      return {
        value,
        icon
      };
    });
    const resourceServiceMapping = (0, _coreUtils.mapValues)(resources, resource => resource.service);

    _knockout.default.assignToProps(this, {
      resources,
      existingNames,
      nameRestrictionList,
      readPolicyRows,
      isWritePolicyDisabled: readPolicy.length === 0,
      writePolicyOptions,
      resourceServiceMapping,
      isStepValid: (0, _formUtils.isFormValid)(form),
      readPolicy,
      writePolicy
    });
  }

  onToggleReadPolicyResource(resource, select) {
    const {
      readPolicy,
      writePolicy,
      formName
    } = this;

    if (!select) {
      const filtered = readPolicy.filter(name => name !== resource);
      this.dispatch((0, _actionCreators.updateForm)(formName, {
        readPolicy: filtered,
        writePolicy: resource === writePolicy ? '' : undefined
      }));
    } else if (!readPolicy.includes(resource)) {
      const updated = [...readPolicy, resource];
      this.dispatch((0, _actionCreators.updateForm)(formName, {
        readPolicy: updated
      }));
    }
  }

  onValidate(values) {
    const {
      step,
      bucketName,
      readPolicy,
      writePolicy
    } = values;
    const errors = {};

    if (step === 0) {
      const hasNameErrors = (0, _validationUtils.validateName)(bucketName, this.existingNames).some(rule => !rule.valid);

      if (hasNameErrors) {
        errors.bucketName = '';
      }
    } else if (step === 1) {
      if (readPolicy.length === 0) {
        errors.readPolicy = 'Please select at least one namespace resources';
      } else if (!writePolicy) {
        errors.writePolicy = 'Please select a namespace resource';
      }
    }

    return errors;
  }

  onWarn(values, resourceServiceMapping) {
    const {
      step,
      readPolicy
    } = values;
    const warnings = {};

    if (step === 1 && readPolicy.length > 1) {
      const firstService = resourceServiceMapping[readPolicy[0]];
      const mixedServices = readPolicy.some(res => resourceServiceMapping[res] !== firstService);

      if (mixedServices) {
        warnings.readPolicy = 'A mixture of different resource services will require to read and re-write the data without optimization';
      }
    }

    return warnings;
  }

  onBeforeStep(step) {
    if (!this.isStepValid) {
      this.dispatch((0, _actionCreators.touchForm)(this.formName, fieldsByStep[step]));
      return false;
    }

    return true;
  }

  onSubmit(values) {
    const {
      bucketName,
      readPolicy,
      writePolicy,
      enableCaching
    } = values;
    this.dispatch((0, _actionCreators.closeModal)(), (0, _actionCreators.createNamespaceBucket)(bucketName, readPolicy, writePolicy, enableCaching ? {
      ttl_ms: 60000
    } : undefined));
  }

  onCancel() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

}

var _default = {
  viewModel: CreateNamespaceBucketModalViewModel,
  template: _createNamespaceBucketModal.default
};
exports.default = _default;

},{"./create-namespace-bucket-modal.html":559,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"config":831,"knockout":"knockout","utils/core-utils":1027,"utils/form-utils":1030,"utils/resource-utils":1041,"utils/validation-utils":1047}],561:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<managed-form class=\"column greedy\" params=\"\n    name: formName,\n    fields: fields,\n    onValidate: values => onValidate(values, existingNames),\n    onSubmit: onSubmit\n\">\n    <div class=\"column greedy pad\">\n        <p class=\"push-next\">\n            Use a bucket from a public cloud to serve as a NooBaa namespace resource\n        </p>\n\n        <section class=\"coulmn greedy\">\n            <editor params=\"label: 'Target Connection'\">\n                <dropdown params=\"\n                        actions: connectionActions,\n                        options: connectionOptions,\n                        selected: $form.connection,\n                        placeholder: 'Choose Connection',\n                        emptyMessage: 'No connections',\n                        hasFocus: true\n                    \"\n                    ko.validationCss=\"$form.connection\"\n                ></dropdown>\n                <validation-message params=\"field: $form.connection\"></validation-message>\n            </editor>\n\n            <editor params=\"\n                label: targetBucketLabel,\n                disabled: !$form.connection()\n            \">\n                <dropdown params=\"\n                        subject: 'bucket',\n                        filter: true,\n                        options: targetOptions,\n                        selected: $form.target,\n                        disabled: !$form.connection(),\n                        loading: fetchingTargets,\n                        placeholder: 'Choose Bucket',\n                        emptyMessage: targetBucketsEmptyMessage,\n                        errorMessage: targetBucketsErrorMessage,\n                        error: isTargetBucketsInError\n                    \"\n                    ko.validationCss=\"$form.target\"\n                ></dropdown>\n                <validation-message params=\"field: $form.target\"></validation-message>\n            </editor>\n\n            <editor params=\"label: 'Resource Name', disabled: !$form.connection()\">\n                <input type=\"text\"\n                    class=\"push-next-half\"\n                    ko.textInput=\"ko.pc($form.resourceName, onResourceNameThrottled)\"\n                    ko.enable=\"$form.connection\"\n                    ko.attr.placeholder=\"'Type Name'\"\n                    ko.validationCss=\"$form.resourceName\"\n                />\n\n                <ul class=\"restriction-list\"\n                    ko.css.disabled=\"!$form.connection()\"\n                    ko.foreach=\"nameRestrictionList\"\n                >\n                    <li ko.text=\"label\" ko.css=\"css\"></li>\n                </ul>\n            </editor>\n        </section>\n    </div>\n    <div class=\"column pad content-box\">\n        <div class=\"row content-middle align-end \">\n            <button type=\"button push-next\"\n                class=\"link alt-colors push-next\"\n                ko.click=\"onCancel\"\n            >\n                Cancel\n            </button>\n            <button class=\"btn\" ko.shakeOnClick=\"!$form.isValid()\">\n                Create\n            </button>\n        </div>\n    </div>\n</managed-form>\n";

},{}],562:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _createNamespaceResourceModal = _interopRequireDefault(require("./create-namespace-resource-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _cloudUtils = require("utils/cloud-utils");

var _validationUtils = require("utils/validation-utils");

var _formUtils = require("utils/form-utils");

var _config = require("config");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const allowedServices = (0, _coreUtils.deepFreeze)(['AWS', 'S3_V2_COMPATIBLE', 'S3_V4_COMPATIBLE', 'AZURE', 'NET_STORAGE', 'IBM_COS']);

class CreateNamespaceResourceModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "formName", this.constructor.name);
    (0, _defineProperty2.default)(this, "fields", {
      connection: '',
      target: '',
      resourceName: ''
    });
    (0, _defineProperty2.default)(this, "fetchingTargets", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "targetOptions", _knockout.default.observableArray());
    (0, _defineProperty2.default)(this, "existingNames", []);
    (0, _defineProperty2.default)(this, "nameRestrictionList", _knockout.default.observableArray());
    (0, _defineProperty2.default)(this, "targetBucketsEmptyMessage", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "targetBucketsErrorMessage", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isTargetBucketsInError", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "targetBucketPlaceholder", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "targetBucketLabel", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "connectionOptions", _knockout.default.observableArray());
    (0, _defineProperty2.default)(this, "connectionActions", (0, _coreUtils.deepFreeze)([{
      label: 'Add new connection',
      onClick: this.onAddNewConnection.bind(this)
    }]));
    (0, _defineProperty2.default)(this, "onResourceNameThrottled", (0, _coreUtils.throttle)(this.onResourceName.bind(this), _config.inputThrottle, this));
  }

  selectState(state) {
    return [state.accounts, state.session, state.namespaceResources, state.hostPools, state.cloudTargets, state.forms && state.forms[this.formName]];
  }

  mapStateToProps(accounts, session, namespaceResources, hostPools, cloudTargets, form) {
    if (!accounts || !namespaceResources || !hostPools || !form) {
      return;
    }

    const {
      externalConnections
    } = accounts[session.user];
    const connectionOptions = externalConnections.filter(connection => allowedServices.includes(connection.service)).map(connection => {
      const {
        icon,
        selectedIcon
      } = (0, _cloudUtils.getCloudServiceMeta)(connection.service);
      return {
        label: connection.name,
        value: connection.name,
        remark: connection.identity,
        icon: icon,
        selectedIcon: selectedIcon
      };
    });
    const fetchingTargets = cloudTargets.fetching && !cloudTargets.list;
    const targetOptions = (cloudTargets.list || []).map(target => ({
      value: target.name,
      disabled: Boolean(target.usedBy),
      tooltip: (0, _cloudUtils.getCloudTargetTooltip)(target)
    }));
    const {
      connection,
      resourceName,
      target
    } = (0, _formUtils.getFormValues)(form);
    const isResourceNameTouched = (0, _formUtils.isFieldTouched)(form, 'resourceName');
    const existingNames = [...Object.keys(namespaceResources), ...Object.keys(hostPools)];
    const nameRestrictionList = (0, _validationUtils.validateName)(resourceName, existingNames).map(result => {
      // Use nocss class to indeicate no css is needed, cannot use empty string
      // because of the use of logical or as condition fallback operator.
      const css = !connection && 'nocss' || result.valid && 'success' || isResourceNameTouched && 'error' || 'nocss';
      return {
        label: result.message,
        css: css === 'nocss' ? '' : css
      };
    });
    const selectedConnection = externalConnections.find(con => con.name === connection);
    const subject = selectedConnection ? (0, _cloudUtils.getCloudServiceMeta)(selectedConnection.service).subject : '';

    _knockout.default.assignToProps(this, {
      targetBucketPlaceholder: `Choose ${subject}`,
      targetBucketLabel: `Target ${subject}`,
      targetBucketsEmptyMessage: `No ${subject.toLowerCase()}s found`,
      targetBucketsErrorMessage: `Cannot retrieve ${subject.toLowerCase()}s`,
      isTargetBucketsInError: cloudTargets.error,
      connectionOptions,
      fetchingTargets,
      targetOptions,
      existingNames,
      nameRestrictionList
    }); // Load cloud targets of necessary.


    if (connection && connection !== cloudTargets.connection) {
      this.dispatch((0, _actionCreators.fetchCloudTargets)(connection));
    } // Suggest a name for the resource if the user didn't enter one himself.


    if (!isResourceNameTouched && target) {
      const suggestedName = target.toLowerCase();

      if (resourceName !== suggestedName) {
        this.dispatch((0, _actionCreators.updateForm)(this.formName, {
          resourceName: suggestedName
        }, false));
      }
    }
  }

  onResourceName(resourceName) {
    this.dispatch((0, _actionCreators.updateForm)(this.formName, {
      resourceName
    }));
  }

  onValidate(values, existingNames) {
    const {
      connection,
      target,
      resourceName
    } = values;
    const errors = {};

    if (!connection) {
      errors.connection = 'Please select a connection';
    } else {
      if (!target) {
        errors.target = 'Please select a target bucket';
      }

      const hasNameErrors = (0, _validationUtils.validateName)(resourceName, existingNames).some(rule => !rule.valid);

      if (hasNameErrors) {
        errors.resourceName = '';
      }
    }

    return errors;
  }

  onSubmit(values) {
    const {
      resourceName,
      connection,
      target
    } = values;
    this.dispatch((0, _actionCreators.closeModal)(), (0, _actionCreators.createNamespaceResource)(resourceName, connection, target));
  }

  onCancel() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

  onAddNewConnection() {
    this.dispatch((0, _actionCreators.openAddCloudConnectionModal)(allowedServices));
  }

  dispose() {
    this.dispatch((0, _actionCreators.dropCloudTargets)());
    super.dispose();
  }

}

var _default = {
  viewModel: CreateNamespaceResourceModalViewModel,
  template: _createNamespaceResourceModal.default
};
exports.default = _default;

},{"./create-namespace-resource-modal.html":561,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"config":831,"knockout":"knockout","utils/cloud-utils":1024,"utils/core-utils":1027,"utils/form-utils":1030,"utils/validation-utils":1047}],563:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"column greedy pad\">\n    <p class=\"push-next\">\n        You are about to delete {{email}} which is the account you are currently logged in with. After the deletion, you will be automatically signed out from the system.\n    </p>\n\n    <p class=\"greedy push-next\">\n        Delete this account anyway?\n    </p>\n</div>\n\n<div class=\"column content-box pad\">\n    <div class=\"row content-middle align-end\">\n        <button class=\"link alt-colors push-next\"\n            ko.click=\"onCancel\"\n            ko.hasFocus=\"true\"\n        >\n            Cancel\n        </button>\n\n        <button class=\"btn\" ko.click=\"onDelete\">\n            Yes, Delete and Signout\n        </button>\n    </div>\n</div>\n";

},{}],564:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _deleteCurrentAccountWarningModal = _interopRequireDefault(require("./delete-current-account-warning-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _actionCreators = require("action-creators");

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
class DeleteAccountWarningModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "email", _knockout.default.observable());
  }

  selectState(state, params) {
    return [params.email];
  }

  mapStateToProps(email) {
    _knockout.default.assignToProps(this, {
      email
    });
  }

  onDelete() {
    this.dispatch((0, _actionCreators.closeModal)(), (0, _actionCreators.tryDeleteAccount)(this.email(), true, true));
  }

  onCancel() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

}

var _default = {
  viewModel: DeleteAccountWarningModalViewModel,
  template: _deleteCurrentAccountWarningModal.default
};
exports.default = _default;

},{"./delete-current-account-warning-modal.html":563,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout"}],565:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<managed-form class=\"column greedy\" params=\"\n    name: formName,\n    fields: formFields,\n    onValidate: onValidate,\n    onSubmit: onSubmit\n\">\n    <section class=\"pad greedy column\">\n        <p class=\"push-next\">\n            This pool has some stored data. Deleting the pool and it's StatefulSet will start an evacuation process.\n            The pool will not delete until all stored data will be rebuilt on other resources.\n        </p>\n        <p class=\"highlight push-next-half push-prev\">\n            Note: This cannot be undone.\n        </p>\n\n        <ul class=\"list-no-style column push-next\">\n            <li class=\"row content-middle push-next-half\">\n                <checkbox params=\"checked: $form.deleteConfirmed\"></checkbox>\n                Delete this pool with its {{formattedHostCount}} installed nodes.\n            </li>\n            <li class=\"row content-middle\">\n                <checkbox params=\"checked: $form.rebuildConfirmed\"></checkbox>\n                Start rebuilding all stored data to remaining resources in the system\n            </li>\n        </ul>\n\n        <!-- ko if: isErrorMsgVisible -->\n        <p class=\"remark error\">Please confirm all deletion results before continuing</p>\n        <!-- /ko -->\n\n    </section>\n\n    <div class=\"column pad content-box\">\n        <div class=\"row align-end content-middle\">\n            <button class=\"link alt-colors push-next\"\n                ko.click=\"onCancel\"\n            >\n                Cancel\n            </button>\n            <button class=\"btn\"\n                ko.shakeOnClick=\"!$form.isValid()\"\n            >\n                Start Deletion Process\n            </button>\n        </div>\n    </div>\n</managed-form>\n\n";

},{}],566:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _deletePoolWithDataWarningModal = _interopRequireDefault(require("./delete-pool-with-data-warning-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _numeral = _interopRequireDefault(require("numeral"));

var _formUtils = require("utils/form-utils");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
class DeletePoolWithDataWarningModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "formName", this.constructor.name);
    (0, _defineProperty2.default)(this, "poolName", '');
    (0, _defineProperty2.default)(this, "formattedHostCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isErrorMsgVisible", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "formFields", {
      deleteConfirmed: false,
      rebuildConfirmed: false
    });
  }

  selectState(state, params) {
    const {
      hostPools,
      forms
    } = state;
    return [hostPools && hostPools[params.poolName], forms[this.formName]];
  }

  mapStateToProps(pool, form) {
    if (!pool || !form) {
      return;
    }

    const isErrorMsgVisible = (0, _formUtils.isFieldTouchedAndInvalid)(form, 'deleteConfirmed') || (0, _formUtils.isFieldTouchedAndInvalid)(form, 'rebuildConfirmed');

    _knockout.default.assignToProps(this, {
      poolName: pool.name,
      formattedHostCount: (0, _numeral.default)(pool.configuredHostCount).format(','),
      isErrorMsgVisible
    });
  }

  onValidate(values) {
    const errors = {};
    const {
      deleteConfirmed,
      rebuildConfirmed
    } = values;

    if (!deleteConfirmed) {
      errors.deleteConfirmed = '';
    }

    if (!rebuildConfirmed) {
      errors.rebuildConfirmed = '';
    }

    return errors;
  }

  onSubmit() {
    this.dispatch((0, _actionCreators.closeModal)(), (0, _actionCreators.deleteResource)(this.poolName));
  }

  onCancel() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

}

var _default = {
  viewModel: DeletePoolWithDataWarningModalViewModel,
  template: _deletePoolWithDataWarningModal.default
};
exports.default = _default;

},{"./delete-pool-with-data-warning-modal.html":565,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout","numeral":"numeral","utils/form-utils":1030}],567:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<managed-form class=\"column greedy\" params=\"\n    name: formName,\n    fields: fields,\n    onValidate: onValidate,\n    onSubmit: onSubmit\n\">\n    <wizard class=\"column greedy\" params=\"\n        steps: steps,\n        step: $form.step,\n        renderControls: false,\n        onBeforeStep: onBeforeStep,\n        onComplete: $form.submit,\n        onCancel: onCancel,\n        actionLabel: deployBtnLabel\n    \">\n        <section class=\"column greedy\">\n            <div class=\"column pad greedy\">\n                <p class=\"push-next\">\n                    Kubernetes nodes will be deployed in a kuberenetes pool type,\n                    and cannot be re-assigned later on to other resources.\n                </p>\n                <editor params=\"label: 'Kubernetes Pool Name'\">\n                    <input class=\"push-next\"\n                        type=\"text\"\n                        placeholder=\"Type here\"\n                        ko.textInput=\"ko.pc($form.poolName, onPoolName)\"\n                        ko.validationCss=\"$form.poolName\"\n                        ko.hasFocus=\"true\"\n                    />\n                    <ul class=\"restriction-list\" ko.foreach=\"nameRestrictionList\">\n                        <li ko.text=\"label\" ko.css=\"css\"></li>\n                    </ul>\n                </editor>\n            </div>\n            <div class=\"content-box pad row content-middle\">\n                <p class=\"greedy push-next row\">\n                    <svg-icon class=\"icon-small push-next-quarter\"\n                        params=\"name: 'notif-info'\"\n                    ></svg-icon>\n                    <span class=\"remark\">\n                        If you wish to scale up an existing kubernetes pool go to <br>\n                        <a class=\"link\" ko.attr.href=\"poolTableHref\">Resources > Pools</a>\n                    </span>\n                </p>\n                <wizard-controls></wizard-controls>\n            </div>\n        </section>\n\n        <section class=\"column greedy\">\n            <div class=\"column pad greedy\">\n                <p class=\"push-next\">\n                    A Kubernetes node is a worker machine in Kubernetes and can be deployed by configuring a stateful set.\n                    these nodes cannot be moved from their original pool.\n                    Each kubernetes node is used as Endpoint by default.\n                </p>\n                <editor class=\"editor-large-label\"\n                    params=\"label: 'Nubmer of Nodes (pods)'\"\n                >\n                    <input type=\"number\"\n                        min=\"1\"\n                        step=\"1\"\n                        ko.value=\"$form.nodeCount\"\n                        ko.validationCss=\"$form.nodeCount\"\n                    />\n                    <validation-message params=\"field: $form.nodeCount\">\n                    </validation-message>\n                    <p class=\"remark\" ko.visible=\"$form.nodeCount.isValid()\">Maximal number of nodes is 20</p>\n                </editor>\n                <editor class=\"editor-large-label\"\n                    params=\"label: 'Node PV Size'\"\n                >\n                    <div class=\"row content-middle\">\n                        <input class=\"push-next\"\n                            type=\"number\"\n                            min=\"1\"\n                            step=\"1\"\n                            ko.value=\"$form.pvSize\"\n                            ko.validationCss=\"$form.pvSize\"\n                        />\n                        <dropdown class=\"size-unit-dd\" params=\"\n                            options: unitOptions,\n                            selected: $form.pvSizeUnit\n                        \"></dropdown>\n                    </div>\n                    <validation-message params=\"field: $form.pvSize\">\n                    </validation-message>\n                    <p class=\"remark\" ko.visible=\"$form.pvSize.isValid()\">This cannot be changed later on</p>\n                </editor>\n            </div>\n            <div class=\"content-box pad row content-middle\">\n                <p class=\"greedy push-next row\">\n                    <svg-icon class=\"icon-small push-next-quarter\"\n                        params=\"name: 'notif-info'\"\n                    ></svg-icon>\n                    <span class=\"remark\">\n                        For each new node one PV will be created\n                    </span>\n                </p>\n                <wizard-controls></wizard-controls>\n            </div>\n        </section>\n\n        <section class=\"column greedy\">\n            <div class=\"column pad greedy\">\n                <h2 class=\"heading3 push-next-half\">\n                    Before deploying, review the kubernetes pool details:\n                </h2>\n                <div class=\"content-box pad-double hpad row content-middle push-next\">\n                    <div class=\"column greedy content-middle\">\n                        <span class=\"highlight push-next-quarter\">{{formattedNodeCount}}</span>\n                        <sapn class=\"remark\">Nodes (Pods)</sapn>\n                    </div>\n                    <vr></vr>\n                    <div class=\"column greedy content-middle\">\n                        <span class=\"highlight push-next-quarter\">{{formattedCapacity}}</span>\n                        <sapn class=\"remark\">Total Pool Capacity</sapn>\n                    </div>\n                    <vr></vr>\n                    <div class=\"column greedy content-middle\">\n                        <span class=\"highlight push-next-quarter\">StatefullSet</span>\n                        <sapn class=\"remark\">Kind</sapn>\n                    </div>\n                    <vr></vr>\n                    <div class=\"column greedy content-middle\">\n                        <span class=\"highlight push-next-quarter\">Storage & Endpoint</span>\n                        <sapn class=\"remark\">Node Services</sapn>\n                    </div>\n                </div>\n\n                <div class=\"column\">\n                    <radio-btn params=\"\n                        group: 'deployMethod',\n                        value: 'NOOBAA',\n                        selected: $form.deployMethod,\n                        label: 'Deploy localy (in the kubernetes cluster)',\n                        hasFocus: true\n                    \"></radio-btn>\n                    <p class=\"push-next\">The Kubernetes nodes will deploy within the cluster</p>\n                    <radio-btn params=\"\n                        group: 'deployMethod',\n                        value: 'YAML',\n                        selected: $form.deployMethod,\n                        label: 'Deploy external to the kubernetes cluster'\n                    \"></radio-btn>\n                    <p class=\"push-next\">A YAML file will be provided for an external cluster deployment</p>\n                </div>\n            </div>\n            <div class=\"content-box pad column content-end\">\n                <wizard-controls></wizard-controls>\n            </div>\n        </section>\n    </wizard>\n</managed-form>\n";

},{}],568:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _deployK8sPoolModal = _interopRequireDefault(require("./deploy-k8s-pool-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _formUtils = require("utils/form-utils");

var _coreUtils = require("utils/core-utils");

var _validationUtils = require("utils/validation-utils");

var _sizeUtils = require("utils/size-utils");

var _browserUtils = require("utils/browser-utils");

var _config = require("config");

var _numeral = _interopRequireDefault(require("numeral"));

var routes = _interopRequireWildcard(require("routes"));

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const valueFieldsByStep = (0, _coreUtils.deepFreeze)({
  0: ['poolName'],
  1: ['nodeCount', 'pvSize', 'pvSizeUnit'],
  2: ['deployMethod']
});
const unitOptions = (0, _coreUtils.deepFreeze)(['GB', 'TB', 'PB']);

class DeployK8SPoolModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "formName", this.constructor.name);
    (0, _defineProperty2.default)(this, "steps", ['Create Pool', 'Configure', 'Review']);
    (0, _defineProperty2.default)(this, "isStepValid", false);
    (0, _defineProperty2.default)(this, "existingNames", []);
    (0, _defineProperty2.default)(this, "nameRestrictionList", _knockout.default.observableArray());
    (0, _defineProperty2.default)(this, "unitOptions", unitOptions);
    (0, _defineProperty2.default)(this, "formattedNodeCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "formattedCapacity", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "deployBtnLabel", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "poolTableHref", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "fields", {
      step: 0,
      poolName: '',
      nodeCount: 3,
      pvSize: 100,
      pvSizeUnit: 'GB',
      deployMethod: 'NOOBAA'
    });
    (0, _defineProperty2.default)(this, "onPoolName", (0, _coreUtils.throttle)(poolName => this.dispatch((0, _actionCreators.updateForm)(this.formName, {
      poolName
    })), _config.inputThrottle, this));
  }

  selectState(state) {
    return [state.hostPools, state.cloudResources, state.system && state.system.name, state.forms[this.formName]];
  }

  mapStateToProps(hostPools, cloudResources, systemName, form) {
    if (!hostPools || !cloudResources || !form) {
      return;
    }

    const {
      poolName,
      nodeCount,
      pvSize,
      pvSizeUnit,
      deployMethod
    } = (0, _formUtils.getFormValues)(form);
    const isPoolNameTouched = (0, _formUtils.isFieldTouched)(form, 'poolName');
    const existingNames = [...Object.keys(hostPools), ...Object.keys(cloudResources)];
    const nameRestrictionList = (0, _validationUtils.validateName)(poolName, existingNames, {
      disallowPeriods: true,
      maxLength: 47
    }).map(record => ({
      label: record.message,
      css: isPoolNameTouched ? record.valid ? 'success' : 'error' : ''
    }));
    const formattedNodeCount = (0, _numeral.default)(nodeCount).format(',');
    const formattedCapacity = (0, _sizeUtils.formatSize)(nodeCount * pvSize * _sizeUtils.unitsInBytes[pvSizeUnit]);
    const deployBtnLabel = deployMethod === 'NOOBAA' && 'Deploy' || deployMethod === 'YAML' && 'Download YAML' || '';
    const poolTableHref = (0, _browserUtils.realizeUri)(routes.resources, {
      system: systemName,
      tab: 'storage'
    });

    _knockout.default.assignToProps(this, {
      existingNames,
      nameRestrictionList,
      isStepValid: (0, _formUtils.isFormValid)(form),
      formattedNodeCount,
      formattedCapacity,
      deployBtnLabel,
      poolTableHref
    });
  }

  onValidate(values) {
    const {
      step,
      poolName,
      nodeCount,
      pvSize,
      pvSizeUnit
    } = values;
    const errors = {};

    if (step === 0) {
      const hasNameErrors = (0, _validationUtils.validateName)(poolName, this.existingNames, {
        maxLength: 47
      }).some(({
        valid
      }) => !valid);

      if (hasNameErrors) {
        errors.poolName = '';
      }
    } else if (step === 1) {
      if (nodeCount < 1 || nodeCount > 20 || !Number.isInteger(nodeCount)) {
        errors.nodeCount = 'Please enter a whole number between 1-20';
      }

      const minSize = pvSizeUnit === 'GB' ? 16 : 1;

      if (pvSize < minSize || !Number.isInteger(pvSize)) {
        errors.pvSize = `Please enter a whole number greater than ${minSize - 1}`;
      }
    }

    return errors;
  }

  onBeforeStep(step) {
    if (!this.isStepValid) {
      this.dispatch((0, _actionCreators.touchForm)(this.formName, valueFieldsByStep[step]));
      return false;
    }

    return true;
  }

  onSubmit(values) {
    const {
      poolName,
      nodeCount,
      pvSize,
      pvSizeUnit,
      deployMethod
    } = values;
    this.dispatch((0, _actionCreators.closeModal)(), (0, _actionCreators.createHostsPool)(poolName, nodeCount, (0, _sizeUtils.fromSizeAndUnit)(pvSize, pvSizeUnit), deployMethod === 'NOOBAA'));
  }

  onCancel() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

}

var _default = {
  viewModel: DeployK8SPoolModalViewModel,
  template: _deployK8sPoolModal.default
};
exports.default = _default;

},{"./deploy-k8s-pool-modal.html":567,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"components/connectable":446,"config":831,"knockout":"knockout","numeral":"numeral","routes":972,"utils/browser-utils":1021,"utils/core-utils":1027,"utils/form-utils":1030,"utils/size-utils":1043,"utils/validation-utils":1047}],569:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<managed-form class=\"column greedy\" params=\"\n    name: formName,\n    fields: formFields,\n    onValidate: onValidate,\n    onSubmit: onSubmit\n\">\n    <div class=\"column pad greedy\">\n        <editor params=\"label: 'Region'\">\n            <input type=\"text\"\n                class=\"push-next-half\"\n                ko.value=\"$form.region\"\n            />\n        </editor>\n        <editor params=\"label: 'Auto-scaling'\">\n            <toggle-switch params=\"\n                onLabel: 'Enabled',\n                offLabel: 'Disabled',\n                hasFocus: true,\n                value: $form.useAutoScaling\n            \"></toggle-switch>\n            <p class=\"remark push-next\">\n                {{toggleRemark}}\n            </p>\n        </editor>\n        <editor params=\"label: endpointCountLabel\">\n            <div class=\"row content-middle\">\n                <input type=\"number\"\n                    class=\"push-next-half\"\n                    ko.value=\"$form.minCount\"\n                />\n                <!-- ko if: $form.useAutoScaling -->\n                -\n                <input type=\"number\"\n                    class=\"push-prev-half\"\n                    ko.value=\"$form.maxCount\"\n                />\n                <!-- /ko -->\n            </div>\n            <validation-message class=\"push-prev-quarter\"\n                params=\"field: $form.minCount\"\n            ></validation-message>\n        </editor>\n    </div>\n\n    <div class=\"column pad content-box\">\n        <div class=\"row content-middle\">\n            <p class=\"greedy push-next row\">\n                <svg-icon class=\"icon-small push-next-quarter\"\n                    params=\"name: 'notif-info'\"\n                ></svg-icon>\n                <span class=\"remark\">\n                    Endpoint count cannot be guaranteed and will be set based on the available Kubernetes resources\n                </span>\n            </p>\n            <button class=\"link alt-colors push-next\"\n                ko.click=\"onCancel\"\n            >\n                Cancel\n            </button>\n            <button class=\"btn\"\n                ko.shakeOnClick=\"!$form.isValid()\"\n            >\n                Download Deployment YAML\n            </button>\n        </div>\n    </div>\n</managed-form>\n\n";

},{}],570:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _deployRemoteEndpointGroupModal = _interopRequireDefault(require("./deploy-remote-endpoint-group-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _formUtils = require("utils/form-utils");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
class DeployRemoteEndpointGroupModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "formName", this.constructor.name);
    (0, _defineProperty2.default)(this, "toggleRemark", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "endpointCountLabel", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "formFields", {
      region: '',
      useAutoScaling: true,
      minCount: 1,
      maxCount: 10
    });
  }

  selectState(state) {
    return [state.forms[this.formName]];
  }

  mapStateToProps(form) {
    if (!form) {
      return;
    }

    const useAutoScaling = (0, _formUtils.getFieldValue)(form, 'useAutoScaling');

    _knockout.default.assignToProps(this, {
      toggleRemark: useAutoScaling ? 'The number of endpoints will automatically increase/decrease based on Kubernetes metrics' : 'The number of endpoints will remain constant regardless of Kubernetes metrics',
      endpointCountLabel: useAutoScaling ? 'Endpoint Range' : 'Number of Endpoints '
    });
  }

  onValidate(values) {
    const errors = {};
    const {
      useAutoScaling,
      minCount,
      maxCount
    } = values;

    if (minCount < 1) {
      errors.minCount = useAutoScaling ? 'Invalid range, Lower bound must be greater then 1' : 'Nubmer of endpoint must be greater then 1';
    } else if (useAutoScaling && maxCount < minCount) {
      errors.minCount = 'Invalid range, upper bound must be greater than lower bound';
    }

    return errors;
  }

  onSubmit(values) {
    const {
      region,
      useAutoScaling,
      minCount,
      maxCount
    } = values;
    const endpointConf = {
      minCount: minCount,
      maxCount: useAutoScaling ? maxCount : minCount
    };
    this.dispatch((0, _actionCreators.generateEndpointGroupDeploymentYAML)(region, endpointConf), (0, _actionCreators.closeModal)());
  }

  onCancel() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

}

var _default = {
  viewModel: DeployRemoteEndpointGroupModalViewModel,
  template: _deployRemoteEndpointGroupModal.default
};
exports.default = _default;

},{"./deploy-remote-endpoint-group-modal.html":569,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout","utils/form-utils":1030}],571:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<managed-form class=\"column greedy\" params=\"\n    name: formName,\n    fields: fields,\n    onWarn: onWarn,\n    onValidate: onValidate,\n    onSubmit: onSubmit\n\">\n    <div class=\"column greedy pad\">\n         <!-- ko if: accessType.eq('ADMIN') -->\n        <div class=\"info-box info pad row content-middle push-next\">\n            <svg-icon params=\"name: 'notif-info'\" class=\"push-next-half\"></svg-icon>\n            <span class=\"greedy\">\n                Administrator accounts have full S3 access that includes all current and future created buckets via any S3 application or the management console\n            </span>\n        </div>\n        <!-- /ko -->\n        <editor params=\"\n            label: 'S3 default placement',\n            tooltip: s3PlacementToolTip\n        \">\n            <dropdown params=\"\n                    filter: true,\n                    options: resourceOptions,\n                    selected: $form.defaultResource,\n                    placeholder: 'Choose Resource'\n                \"\n                ko.validationCss=\"$form.defaultResource\"\n            ></dropdown>\n             <validation-message params=\"field: $form.defaultResource\"></validation-message>\n        </editor>\n\n        <!-- ko if: accessType.eq('APP') -->\n        <editor params=\"label: 'Buckets Permissions',\">\n            <dropdown class=\"push-next\" params=\"\n                options: bucketOptions,\n                selected: ko.pc(\n                    $form.allowedBuckets,\n                    buckets => onSelectAllowedBuckets(buckets)\n                ),\n                filter: true,\n                subject: 'bucket',\n                placeholder: 'Choose Buckets',\n                multiselect: true,\n                selectAllLabel: 'All Current Buckets'\n            \"></dropdown>\n            <checkbox params=\"\n                label: 'Include any future buckets',\n                checked: $form.allowAccessToFutureBuckets,\n                disabled: isAllowAccessToFutureBucketsDisabled\n            \"></checkbox>\n        </editor>\n\n        <editor params=\"\n            label: 'Allow new bucket creation',\n            tooltip: allowBucketCreationTooltip\n        \">\n            <toggle-switch params=\"\n                value: $form.allowBucketCreation,\n                onLabel: 'Enabled',\n                offLabel: 'Disabled'\n            \"></toggle-switch>\n        </editor>\n        <!-- /ko -->\n    </div>\n    <div class=\"column content-box pad\">\n        <div class=\"row align-end content-middle\">\n            <button type=\"button\" class=\"link alt-colors push-next\" ko.click=\"onCancel\">\n                Cancel\n            </button>\n            <button class=\"btn\" ko.shakeOnClick=\"!$form.isValid()\">\n                Save\n            </button>\n        </div>\n    </div>\n</managed-form>\n";

},{}],572:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _editAccountS3AccessModal = _interopRequireDefault(require("./edit-account-s3-access-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _coreUtils = require("utils/core-utils");

var _sizeUtils = require("utils/size-utils");

var _cloudUtils = require("utils/cloud-utils");

var _formUtils = require("utils/form-utils");

var _knockout = _interopRequireDefault(require("knockout"));

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const s3PlacementToolTip = 'The selected resource will be associated to this account as it’s default data placement for each new bucket that will be created via an S3 application';
const allowBucketCreationTooltip = 'The ability to create new buckets. By disabling this option, the user could not create any new buckets via S3 client or via the management console';

function mapResourceToOption({
  type,
  name: value,
  storage
}) {
  const {
    total,
    free: availableFree,
    unavailableFree
  } = storage;
  const free = (0, _sizeUtils.sumSize)(availableFree, unavailableFree);
  const remark = `${(0, _sizeUtils.formatSize)(free)} of ${(0, _sizeUtils.formatSize)(total)} Available`;
  const icons = type ? (0, _cloudUtils.getCloudServiceMeta)(type) : {
    icon: 'nodes-pool'
  };
  return { ...icons,
    value,
    remark
  };
}

class EditAccountS3AccessModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "formName", this.constructor.name);
    (0, _defineProperty2.default)(this, "s3PlacementToolTip", s3PlacementToolTip);
    (0, _defineProperty2.default)(this, "accessType", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "allowBucketCreationTooltip", allowBucketCreationTooltip);
    (0, _defineProperty2.default)(this, "isAllowAccessToFutureBucketsDisabled", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "resourceOptions", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "systemHasResources", false);
    (0, _defineProperty2.default)(this, "bucketOptions", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "fields", _knockout.default.observable());
  }

  selectState(state, params) {
    const {
      accounts,
      hostPools,
      cloudResources,
      buckets,
      namespaceBuckets,
      forms
    } = state;
    return [accounts && accounts[params.accountName], hostPools, cloudResources, buckets, namespaceBuckets, forms[this.formName]];
  }

  mapStateToProps(account, hostPools, cloudResources, buckets, namespaceBuckets, form) {
    if (!account || !hostPools || !cloudResources || !buckets || !namespaceBuckets) {
      return;
    }

    const resourceOptions = (0, _coreUtils.flatMap)([hostPools, cloudResources], resources => Object.values(resources).map(mapResourceToOption));
    const systemHasResources = resourceOptions.length > 0;
    const allBuckets = [...Object.keys(buckets), ...Object.keys(namespaceBuckets)];
    const bucketOptions = allBuckets.map(bucket => {
      const value = bucket;
      const tooltip = {
        text: bucket,
        breakWords: true
      };
      return {
        value,
        tooltip
      };
    });
    const {
      allowedBuckets = account.allowedBuckets
    } = form ? (0, _formUtils.getFormValues)(form) : {};
    const isAllowAccessToFutureBucketsDisabled = allowedBuckets.length < bucketOptions.length;
    const defaultResource = account.defaultResource !== 'INTERNAL_STORAGE' ? account.defaultResource : undefined;

    _knockout.default.assignToProps(this, {
      accessType: account.isAdmin ? 'ADMIN' : 'APP',
      resourceOptions: resourceOptions,
      systemHasResources,
      bucketOptions: bucketOptions,
      isAllowAccessToFutureBucketsDisabled,
      fields: !form ? {
        accountName: account.name,
        allowAccessToFutureBuckets: account.hasAccessToAllBuckets,
        allowedBuckets: account.allowedBuckets || [],
        defaultResource,
        allowBucketCreation: account.canCreateBuckets
      } : undefined
    });
  }

  onSelectAllowedBuckets(allowedBuckets) {
    const update = {
      allowedBuckets
    };

    if (allowedBuckets.length < this.bucketOptions().length) {
      update.allowAccessToFutureBuckets = false;
    }

    this.dispatch((0, _actionCreators.updateForm)(this.formName, update));
  }

  onWarn() {
    const warnings = {};

    if (!this.systemHasResources) {
      warnings.defaultResource = 'Until connecting resources, internal storage will be used';
    }

    return warnings;
  }

  onValidate(values) {
    const errors = {};
    const {
      defaultResource
    } = values;

    if (this.systemHasResources && !defaultResource) {
      errors.defaultResource = 'Please select a default resource for the account';
    }

    return errors;
  }

  onSelectAllBuckets() {
    const allowedBuckets = this.bucketOptions().map(opt => opt.value);
    this.dispatch((0, _actionCreators.updateForm)(this.formName, {
      allowedBuckets
    }));
  }

  onClearSelectedBuckets() {
    this.dispatch((0, _actionCreators.updateForm)(this.formName, {
      allowedBuckets: []
    }));
  }

  onSubmit({
    accountName,
    defaultResource,
    allowAccessToFutureBuckets,
    allowedBuckets,
    allowBucketCreation
  }) {
    this.dispatch((0, _actionCreators.closeModal)(), (0, _actionCreators.updateAccountS3Access)(accountName, defaultResource, allowAccessToFutureBuckets, allowedBuckets, allowBucketCreation));
  }

  onCancel() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

}

var _default = {
  viewModel: EditAccountS3AccessModalViewModel,
  template: _editAccountS3AccessModal.default
};
exports.default = _default;

},{"./edit-account-s3-access-modal.html":571,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout","utils/cloud-utils":1024,"utils/core-utils":1027,"utils/form-utils":1030,"utils/size-utils":1043}],573:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<managed-form class=\"column greedy\" params=\"\n    name: formName,\n    fields: fields,\n    onValidate: onValidate,\n    onSubmit: onSubmit\n\">\n    <div class=\"column greedy pad push-next-half\">\n        <div ko.expand=\"$form.isInfoVisible\" class=\"column\">\n            <div class=\"info-box info pad row content-middle push-next\">\n                <svg-icon params=\"name: 'notif-info'\" class=\"push-next-half\"></svg-icon>\n                <span class=\"greedy\">\n                    Cloud resources are considered resilient and store only one replica on this type of resource regardless of the configured replica number.\n                    <button class=\"link alt-colors\"\n                        ko.click=\"onDismissInfo\"\n                    >\n                        Dismiss\n                    </button>\n                </span>\n            </div>\n        </div>\n\n        <div class=\"row content-middle push-next-half\">\n            <h2 class=\"heading3 greedy push-next\">Choose Resiliency Type</h2>\n            <button class=\"link\"\n                type=\"button\"\n                ko.click=\"onToggleMode\"\n                ko.text=\"toggleModeBtnText\"\n            ></button>\n        </div>\n\n        <div class=\"column greedy pad-right scroll-overflow\">\n            <section class=\"column push-next\">\n                <div class=\"row content-middle\">\n                    <radio-btn params=\"\n                        label: 'Replication',\n                        value: 'REPLICATION',\n                        group: 'dataResiliency',\n                        selected: $form.resiliencyType,\n                        hasFocus: true\n                    \"></radio-btn>\n                    <span class=\"push-both-half\">|</span>\n                    Full copies of stored objects parts.\n                </div>\n                <div class=\"column pad-left\">\n                    <div class=\"row content-middle push-next\" ko.expand=\"$form.advancedMode\">\n                        <span class=\"push-next\"\n                            ko.css.disabled=\"isReplicationDisabled\"\n                        >\n                            Number of Replicas:\n                        </span>\n                        <div class=\"column\">\n                            <input type=\"number\"\n                                min=\"1\"\n                                max=\"32\"\n                                ko.value=\"$form.replicas\"\n                                ko.disable=\"isReplicationDisabled\"\n                                ko.validationCss=\"$form.replicas\"\n                            />\n                            <div class=\"validation-message-wrapper\">\n                                <validation-message params=\"field: $form.replicas\">\n                                </validation-message>\n                            </div>\n                        </div>\n                    </div>\n                    <div class=\"content-box pad-half hpad row no-wrap\">\n                        <p class=\"greedy column remark\">\n                            <span class=\"highlight push-next-half\">{{repCopies}}</span>\n                            Copies\n                        </p>\n                        <vr class=\"push-both-half\"></vr>\n                        <p class=\"greedy column remark\">\n                            <span class=\"highlight push-next-half\">{{repStorageOverhead}}</span>\n                            Storage Overhead\n                        </p>\n                        <vr class=\"push-both-half\"></vr>\n                        <p class=\"greedy column remark\" ko.with=\"repFailureTolerance\">\n                            <span class=\"highlight row content-middle push-next-half\" ko.css=\"css\">\n                                {{text}}\n                                <svg-icon class=\"icon-small push-prev-half\"\n                                    ko.tooltip=\"tooltip\"\n                                    ko.visible=\"tooltip\"\n                                    params=\"name: 'problem'\"\n                                ></svg-icon>\n                            </span>\n                            Failure Tolerance\n                        </p>\n                        <vr class=\"push-both-half\"></vr>\n                        <p class=\"greedy column remark\" ko.with=\"repRequiredDrives\">\n                            <span class=\"highlight row content-middle push-next-half\" ko.css=\"css\">\n                                {{text}}\n                                <svg-icon class=\"icon-small push-prev-half\"\n                                    ko.tooltip=\"tooltip\"\n                                    ko.visible=\"tooltip\"\n                                    params=\"name: 'problem'\"\n                                ></svg-icon>\n                            </span>\n                            Minimum Required Drives\n                        </p>\n                        <vr class=\"push-both-half\"></vr>\n                        <p class=\"greedy column remark\">\n                           <span class=\"highlight push-next-half\">{{repRebuildEffort}}</span>\n                            Rebuild Time Effort\n                        </p>\n                    </div>\n                </div>\n            </section>\n\n            <section class=\"column greedy\">\n                <div class=\"row content-middle\">\n                    <radio-btn params=\"\n                        label: 'Erasure Coding',\n                        value: 'ERASURE_CODING',\n                        group: 'dataResiliency',\n                        selected: $form.resiliencyType\n                    \"></radio-btn>\n                    <span class=\"push-both-half\">|</span>\n                    Data is broken into fragments and encoded with redundant data pieces.\n                </div>\n                <div class=\"column pad-left\">\n                    <div class=\"row push-next\" ko.expand=\"$form.advancedMode\">\n                        <div class=\"row content-middle push-next\"\n                            ko.css.disabled=\"isErasureCodingDisabled\"\n                        >\n                            <span class=\"push-next\">Data:</span>\n                            <div class=\"column\">\n                                <input type=\"number\"\n                                    min=\"1\"\n                                    max=\"32\"\n                                    ko.value=\"$form.dataFrags\"\n                                    ko.disable=\"isErasureCodingDisabled\"\n                                    ko.validationCss=\"$form.dataFrags\"\n                                />\n                                <div class=\"validation-message-wrapper\">\n                                    <validation-message params=\"field: $form.dataFrags\">\n                                    </validation-message>\n                                </div>\n                            </div>\n                        </div>\n                        <div class=\"row content-middle push-prev\"\n                            ko.css.disabled=\"isErasureCodingDisabled\"\n                        >\n                            <span class=\"push-next\">Parity:</span>\n                            <div class=\"column\">\n                                <input type=\"number\"\n                                    min=\"1\"\n                                    max=\"32\"\n                                    ko.value=\"$form.parityFrags\"\n                                    ko.disable=\"isErasureCodingDisabled\"\n                                    ko.validationCss=\"$form.parityFrags\"\n                                />\n                                <div class=\"validation-message-wrapper\">\n                                    <validation-message params=\"field: $form.parityFrags\">\n                                    </validation-message>\n                                </div>\n                            </div>\n                        </div>\n                    </div>\n                    <div class=\"content-box pad-half hpad row no-wrap\">\n                        <p class=\"greedy column remark\">\n                            <span class=\"highlight push-next-half\">{{ecDisribution}}</span>\n                            Data + Parity\n                        </p>\n                        <vr class=\"push-both-half\"></vr>\n                        <p class=\"greedy column remark\">\n                            <span class=\"highlight push-next-half\">{{ecStorageOverhead}}</span>\n                            Storage Overhead\n                        </p>\n                        <vr class=\"push-both-half\"></vr>\n                        <p class=\"greedy column remark\" ko.with=\"ecFailureTolerance\">\n                            <span class=\"highlight row content-middle push-next-half\" ko.css=\"css\">\n                                {{text}}\n                                <svg-icon class=\"icon-small push-prev-half\"\n                                    ko.tooltip=\"tooltip\"\n                                    ko.visible=\"tooltip\"\n                                    params=\"name: 'problem'\"\n                                ></svg-icon>\n                            </span>\n                            Failure Tolerance\n                        </p>\n                        <vr class=\"push-both-half\"></vr>\n                        <p class=\"greedy column remark\" ko.with=\"ecRequiredDrives\">\n                            <span class=\"highlight row content-middle push-next-half\" ko.css=\"css\">\n                                {{text}}\n                                <svg-icon class=\"icon-small push-prev-half\"\n                                    ko.tooltip=\"tooltip\"\n                                    ko.visible=\"tooltip\"\n                                    params=\"name: 'problem'\"\n                                ></svg-icon>\n                            </span>\n                            Minimum Required Drives\n                        </p>\n                        <vr class=\"push-both-half\"></vr>\n                        <p class=\"greedy column remark\" ko.with=\"ecRebuildEffort\">\n                           <span class=\"highlight row content-middle push-next-half\" ko.css=\"css\">\n                                {{text}}\n                                <svg-icon\n                                    class=\"icon-small push-prev-half\"\n                                    ko.tooltip=\"tooltip\"\n                                    ko.visible=\"tooltip\"\n                                    params=\"name: 'problem'\"\n                                ></svg-icon>\n                            </span>\n                            Rebuild Time Effort\n                        </p>\n                    </div>\n                </div>\n            </section>\n        </div>\n    </div>\n\n    <div class=\"row content-middle pad content-box\">\n        <div class=\"row remark push-next greedy\">\n            <svg-icon class=\"icon-small align-start push-next-half\" params=\"name: 'notif-info'\"></svg-icon>\n            <p>\n                File parts or fragments distribution changes according to the resource type.\n            </p>\n        </div>\n\n        <button type=\"button\"\n            class=\"link alt-colors push-next\"\n            ko.click=\"onCancel\"\n        >\n            Cancel\n        </button>\n        <button class=\"btn\" ko.shakeOnClick=\"!$form.isValid()\">\n            Done\n        </button>\n    </div>\n</managed-form>\n";

},{}],574:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _editBucketDataResiliencyModal = _interopRequireDefault(require("./edit-bucket-data-resiliency-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _numeral = _interopRequireDefault(require("numeral"));

var _coreUtils = require("utils/core-utils");

var _formUtils = require("utils/form-utils");

var _bucketUtils = require("utils/bucket-utils");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const defaults = (0, _coreUtils.deepFreeze)({
  replicas: 1,
  dataFrags: 4,
  parityFrags: 2
});
const rebuildEffortToDisplay = (0, _coreUtils.deepFreeze)({
  LOW: 'Low',
  HIGH: 'High',
  VERY_HIGH: 'Very High'
});
const failureToleranceTooltip = (0, _coreUtils.deepFreeze)({
  position: 'above',
  text: 'It is not recommended to use a resiliency policy which results in less than a fault tolerance value of 2'
});
const rebuildEffortTooltip = (0, _coreUtils.deepFreeze)({
  position: 'above',
  text: 'Parity fragments rebuild time might take a while, varies according to data placement policy resources and type'
});

function _getFormInitalValues(bucket) {
  const {
    kind: resiliencyType,
    replicas = defaults.replicas,
    dataFrags = defaults.dataFrags,
    parityFrags = defaults.parityFrags
  } = bucket.resiliency;
  const advancedMode = replicas !== defaults.replicas || dataFrags !== defaults.dataFrags || parityFrags !== defaults.parityFrags;
  const usesCloudResources = bucket.placement.tiers.some(tier => (tier.mirrorSets || []).some(ms => ms.resources.some(resource => resource.type === 'CLOUD')));
  return {
    isInfoVisible: usesCloudResources,
    resiliencyType,
    advancedMode,
    replicas,
    dataFrags,
    parityFrags
  };
}

function _getFailureToleranceInfo(failureTolerance) {
  const warn = failureTolerance < 2;
  return {
    text: failureTolerance,
    css: warn ? 'warning' : '',
    tooltip: warn ? failureToleranceTooltip : undefined
  };
}

function _getRequiredDrivesInfo(resiliencyType, requiredDrives, driveCountMetric) {
  const warn = requiredDrives > driveCountMetric;
  const tooltip = {
    position: 'above',
    text: (0, _bucketUtils.getResiliencyRequirementsWarning)(resiliencyType, driveCountMetric)
  };
  return {
    text: requiredDrives,
    css: warn ? 'warning' : '',
    tooltip: warn ? tooltip : undefined
  };
}

function _getErasureCodingRebuildEffortInfo(rebuildEffort) {
  const warn = rebuildEffort === 'VERY_HIGH';
  return {
    text: rebuildEffortToDisplay[rebuildEffort],
    css: warn ? 'error' : '',
    tooltip: warn ? rebuildEffortTooltip : undefined
  };
}

class EditBucketDataResiliencyModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "formName", this.constructor.name);
    (0, _defineProperty2.default)(this, "bucketName", '');
    (0, _defineProperty2.default)(this, "advancedMode", false);
    (0, _defineProperty2.default)(this, "toggleModeBtnText", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isReplicationDisabled", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isErasureCodingDisabled", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "repCopies", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "repStorageOverhead", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "repFailureTolerance", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "repRequiredDrives", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "repRebuildEffort", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "ecDisribution", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "ecStorageOverhead", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "ecFailureTolerance", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "ecRequiredDrives", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "ecRebuildEffort", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "fields", _knockout.default.observable());
  }

  selectState(state, params) {
    const {
      buckets,
      hostPools,
      forms
    } = state;
    return [buckets && buckets[params.bucketName], hostPools, forms[this.formName]];
  }

  mapStateToProps(bucket, hostPools, form) {
    if (!bucket || !hostPools) {
      return;
    }

    const values = form ? (0, _formUtils.getFormValues)(form) : _getFormInitalValues(bucket);
    const nodeCountInMirrorSets = (0, _coreUtils.flatMap)(bucket.placement.tiers, tier => (0, _bucketUtils.countStorageNodesByMirrorSet)(tier, hostPools));
    const minNodeCountInMirrorSets = Math.min(...nodeCountInMirrorSets);
    const repSummary = (0, _bucketUtils.summrizeResiliency)({
      kind: 'REPLICATION',
      replicas: values.replicas
    });

    const repRequiredDrives = _getRequiredDrivesInfo('REPLICATION', repSummary.requiredDrives, minNodeCountInMirrorSets);

    const ecSummary = (0, _bucketUtils.summrizeResiliency)({
      kind: 'ERASURE_CODING',
      dataFrags: values.dataFrags,
      parityFrags: values.parityFrags
    });

    const ecRequiredDrives = _getRequiredDrivesInfo('ERASURE_CODING', ecSummary.requiredDrives, minNodeCountInMirrorSets);

    _knockout.default.assignToProps(this, {
      bucketName: bucket.name,
      advancedMode: values.advancedMode,
      toggleModeBtnText: values.advancedMode ? 'Basic Settings' : 'Advanced Settings',
      isReplicationDisabled: !values.advancedMode || values.resiliencyType !== 'REPLICATION',
      isErasureCodingDisabled: !values.advancedMode || values.resiliencyType !== 'ERASURE_CODING',
      repCopies: repSummary.replicas,
      repStorageOverhead: (0, _numeral.default)(repSummary.storageOverhead).format('%'),
      repFailureTolerance: _getFailureToleranceInfo(repSummary.failureTolerance),
      repRequiredDrives: repRequiredDrives,
      repRebuildEffort: rebuildEffortToDisplay[repSummary.rebuildEffort],
      ecDisribution: `${ecSummary.dataFrags} + ${ecSummary.parityFrags}`,
      ecStorageOverhead: (0, _numeral.default)(ecSummary.storageOverhead).format('%'),
      ecFailureTolerance: _getFailureToleranceInfo(ecSummary.failureTolerance),
      ecRequiredDrives: ecRequiredDrives,
      ecRebuildEffort: _getErasureCodingRebuildEffortInfo(ecSummary.rebuildEffort),
      fields: !form ? values : undefined
    });
  }

  onDismissInfo() {
    this.dispatch((0, _actionCreators.updateForm)(this.formName, {
      isInfoVisible: false
    }, false));
  }

  onToggleMode() {
    const values = {
      advancedMode: !this.advancedMode,
      ...defaults
    };
    this.dispatch((0, _actionCreators.updateForm)(this.formName, values, false));
  }

  onCancel() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

  onValidate(values) {
    const errors = {};
    const {
      resiliencyType,
      replicas,
      dataFrags,
      parityFrags
    } = values;

    if (resiliencyType === 'REPLICATION') {
      if (Number.isNaN(replicas) || replicas < 1 || replicas > 32) {
        errors.replicas = 'Please enter a value between 1-32';
      }
    }

    if (values.resiliencyType === 'ERASURE_CODING') {
      if (Number.isNaN(dataFrags) || dataFrags < 1 || dataFrags > 32) {
        errors.dataFrags = 'Please enter a value between 1-32';
      }

      if (Number.isNaN(parityFrags) || parityFrags < 1 || parityFrags > 32) {
        errors.parityFrags = 'Please enter a value between 1-32';
      }
    }

    return errors;
  }

  onSubmit(values) {
    const {
      resiliencyType
    } = values;
    const policy = resiliencyType == 'REPLICATION' ? (0, _coreUtils.pick)(values, ['resiliencyType', 'replicas']) : (0, _coreUtils.pick)(values, ['resiliencyType', 'dataFrags', 'parityFrags']);
    this.dispatch((0, _actionCreators.closeModal)(), (0, _actionCreators.updateBucketResiliencyPolicy)(this.bucketName, policy));
  }

}

var _default = {
  viewModel: EditBucketDataResiliencyModalViewModel,
  template: _editBucketDataResiliencyModal.default
};
exports.default = _default;

},{"./edit-bucket-data-resiliency-modal.html":573,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout","numeral":"numeral","utils/bucket-utils":1022,"utils/core-utils":1027,"utils/form-utils":1030}],575:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<managed-form class=\"column greedy\" params=\"\n    name: formName,\n    fields: fields,\n    onValidate: onValidate,\n    onSubmit: onSubmit\n\">\n    <div class=\"column greedy pad\">\n        <editor params=\"label: 'Bucket Quota'\">\n            <toggle-switch params=\"\n                value: $form.enabled,\n                onLabel: 'Enabled',\n                offLabel: 'Disabled',\n                hasFocus: true\n            \"></toggle-switch>\n        </editor>\n\n        <editor params=\"label: 'Set Limit', disabled: !$form.enabled()\">\n            <div class=\"row\">\n                <input type=\"number\" min=\"1\"\n                    class=\"push-next\"\n                    ko.enable=\"$form.enabled\"\n                    ko.value=\"$form.size\"\n                    ko.validationCss=\"$form.size\"\n                    ko.hasFocus=\"true\"\n                />\n                <dropdown class=\"size-unit\" params=\"\n                    options: unitOptions,\n                    disabled: !$form.enabled(),\n                    selected: $form.unit\n                \"></dropdown>\n            </div>\n            <validation-message params=\"field: $form.size\"></validation-message>\n        </editor>\n\n        <div class=\"row push-both\">\n            <bar class=\"storage-bar bar-flip-markers greedy push-next\"\n                ko.css.disabled=\"!$form.enabled()\"\n                params=\"\n                    values: bar.values,\n                    markers: bar.markers,\n                    limits: true,\n                    format: 'size'\n                \"\n            ></bar>\n        </div>\n        <chart-legend class=\"legend-row push-prev-half\"\n            ko.css.disabled=\"!$form.enabled()\"\n            params=\"\n                items: bar.values,\n                format: 'size'\n            \"\n        ></chart-legend>\n    </div>\n\n    <div class=\"row content-middle pad content-box\">\n        <p class=\"remark greedy row push-next\">\n            <svg-icon class=\"icon-small push-next-half\" params=\"name: 'notif-info'\"></svg-icon>\n            When a quota is not set the bucket will utilize all its available resources.\n        </p>\n        <button type=\"button\" class=\"link alt-colors push-both\" ko.click=\"onCancel\">\n            Cancel\n        </button>\n        <button class=\"btn\" ko.shakeOnClick=\"!$form.isValid()\">\n            Save\n        </button>\n    </div>\n</managed-form>\n";

},{}],576:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _editBucketQuotaModal = _interopRequireDefault(require("./edit-bucket-quota-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _coreUtils = require("utils/core-utils");

var _bucketUtils = require("utils/bucket-utils");

var _knockout = _interopRequireDefault(require("knockout"));

var _actionCreators = require("action-creators");

var _sizeUtils = require("utils/size-utils");

/* Copyright (C) 2016 NooBaa */
const unitOptions = (0, _coreUtils.deepFreeze)([{
  label: 'GB',
  value: 'GIGABYTE'
}, {
  label: 'TB',
  value: 'TERABYTE'
}, {
  label: 'PB',
  value: 'PETABYTE'
}]);

function _findMaxQuotaPossible(data) {
  const {
    PETABYTE,
    TERABYTE,
    GIGABYTE
  } = _sizeUtils.unitsInBytes;
  const {
    size,
    availableForUpload
  } = data;
  const total = (0, _sizeUtils.toBigInteger)(size).add((0, _sizeUtils.toBigInteger)(availableForUpload));

  if (total.greaterOrEquals(PETABYTE)) {
    return {
      size: (0, _sizeUtils.fromBigInteger)(total.divide(PETABYTE)),
      unit: 'PETABYTE'
    };
  } else if (total.greaterOrEquals(TERABYTE)) {
    return {
      size: (0, _sizeUtils.fromBigInteger)(total.divide(TERABYTE)),
      unit: 'TERABYTE'
    };
  } else if (total.greaterOrEquals(GIGABYTE)) {
    return {
      size: (0, _sizeUtils.fromBigInteger)(total.divide(GIGABYTE)),
      unit: 'GIGABYTE'
    };
  } else {
    return {
      size: 1,
      unit: 'GIGABYTE'
    };
  }
}

function _getQuota(formValues, bucket) {
  if (formValues) {
    const size = Number.isInteger(formValues.size) ? Math.max(formValues.size, 0) : 0;
    const unit = formValues.unit;
    return {
      size,
      unit
    };
  } else {
    return bucket.quota || _findMaxQuotaPossible(bucket.data);
  }
}

class EditBucketQuotaModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "formName", this.constructor.name);
    (0, _defineProperty2.default)(this, "unitOptions", unitOptions);
    (0, _defineProperty2.default)(this, "bucketName", '');
    (0, _defineProperty2.default)(this, "fields", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "bar", {
      values: [{
        label: 'Used Data',
        color: 'rgb(var(--color20))',
        value: _knockout.default.observable()
      }, {
        label: 'Available',
        color: 'rgb(var(--color07))',
        value: _knockout.default.observable()
      }, {
        label: 'Overallocated',
        color: 'rgb(var(--color31))',
        value: _knockout.default.observable(),
        visible: _knockout.default.observable()
      }, {
        label: 'Overused',
        color: 'rgb(var(--color26))',
        value: _knockout.default.observable(),
        visible: _knockout.default.observable()
      }, {
        label: 'Potential',
        color: 'rgb(var(--color07))',
        value: _knockout.default.observable(),
        visible: _knockout.default.observable()
      }],
      markers: [{
        visible: _knockout.default.observable(),
        text: _knockout.default.observable(),
        position: 3
      }]
    });
  }

  selectState(state, params) {
    const {
      buckets,
      forms
    } = state;
    return [buckets && buckets[params.bucketName], forms[this.formName]];
  }

  mapStateToProps(bucket, form) {
    if (!bucket) {
      return;
    }

    const formValues = form && (0, _coreUtils.mapValues)(form.fields, field => field.value);
    const enabled = formValues ? formValues.enabled : Boolean(bucket.quota);

    const quota = _getQuota(formValues, bucket);

    const breakdown = (0, _bucketUtils.getDataBreakdown)(bucket.data, enabled ? quota : undefined);

    _knockout.default.assignToProps(this, {
      bucketName: bucket.name,
      bar: {
        values: [{
          value: (0, _sizeUtils.toBytes)(breakdown.used)
        }, {
          value: (0, _sizeUtils.toBytes)(breakdown.availableForUpload)
        }, {
          value: (0, _sizeUtils.toBytes)(breakdown.overallocated),
          visible: !(0, _sizeUtils.isSizeZero)(breakdown.overallocated)
        }, {
          value: (0, _sizeUtils.toBytes)(breakdown.overused),
          visible: !(0, _sizeUtils.isSizeZero)(breakdown.overused)
        }, {
          value: (0, _sizeUtils.toBytes)(breakdown.potentialForUpload),
          visible: !(0, _sizeUtils.isSizeZero)(breakdown.potentialForUpload)
        }],
        markers: [{
          visible: enabled,
          text: enabled ? `Quota: ${(0, _sizeUtils.formatSize)((0, _bucketUtils.getQuotaValue)(quota))}` : ''
        }]
      },
      fields: !form ? {
        enabled: enabled,
        unit: quota.unit,
        size: quota.size
      } : undefined
    });
  }

  onValidate(values) {
    const errors = {};
    const {
      size,
      enabled
    } = values;

    if (enabled && (!Number.isInteger(size) || size < 1)) {
      errors.size = 'Please enter an integer bigger or equal to 1';
    }

    return errors;
  }

  onSubmit(values) {
    const quota = values.enabled ? {
      unit: values.unit,
      size: Number(values.size)
    } : null;
    this.dispatch((0, _actionCreators.closeModal)(), (0, _actionCreators.updateBucketQuotaPolicy)(this.bucketName, quota));
  }

  onCancel() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

}

var _default = {
  viewModel: EditBucketQuotaModalViewModel,
  template: _editBucketQuotaModal.default
};
exports.default = _default;

},{"./edit-bucket-quota-modal.html":575,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout","utils/bucket-utils":1022,"utils/core-utils":1027,"utils/size-utils":1043}],577:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<managed-form class=\"column greedy\" params=\"\n    name: formName,\n    fields: fields,\n    onSubmit: onSubmit\n\">\n    <div class=\"column greedy pad\">\n        <div class=\"row content-middle\">\n            <h2 class=\"heading3 greedy\">Edit accounts S3 access permissions</h2>\n            <div>\n                <button type=\"button\" class=\"link alt-colors\" ko.click=\"selectAllAccounts\">\n                    Select all\n                </button>\n                |\n                <button type=\"button\" class=\"link alt-colors\" ko.click=\"clearAllAccounts\">\n                    Clear\n                </button>\n            </div>\n        </div>\n        <multiselect class=\"cols-3 greedy\" params=\"\n            options: accountOptions,\n            selected: $form.selectedAccounts\n        \"></multiselect>\n        <p>\n            <svg-icon class=\"icon-small\" params=\"name: 'notif-info'\"></svg-icon>\n            To create a new account go to System Management >\n            <a class=\"link\" ko.attr.href=\"accountsHref\">\n                Accounts\n            </a>\n        </p>\n    </div>\n    <div class=\"column pad content-box\">\n        <div class=\"row content-middle align-end\">\n            <button type=\"button\" class=\"link alt-colors push-next\" ko.click=\"onCancel\">\n                Cancel\n            </button>\n            <button class=\"btn\">\n                Save\n            </button>\n        </div>\n    </div>\n</managed-form>\n";

},{}],578:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _editBucketS3AccessModal = _interopRequireDefault(require("./edit-bucket-s3-access-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _browserUtils = require("utils/browser-utils");

var routes = _interopRequireWildcard(require("routes"));

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _getAccountOption({
  name,
  hasAccessToAllBuckets
}) {
  return {
    value: name,
    disabled: hasAccessToAllBuckets,
    tooltip: hasAccessToAllBuckets ? 'This account access permissions is set to “all buckets” and cannot be edited' : name
  };
}

function _getSelectedAccounts(accountList, bucketName) {
  return accountList.filter(account => account.allowedBuckets.includes(bucketName)).map(account => account.name);
}

class EditBucketS3AccessModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "formName", this.constructor.name);
    (0, _defineProperty2.default)(this, "bucketName", '');
    (0, _defineProperty2.default)(this, "accountsHref", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "accountOptions", _knockout.default.observableArray());
    (0, _defineProperty2.default)(this, "fields", _knockout.default.observable());
  }

  selectState(state, params) {
    const {
      accounts,
      location,
      forms
    } = state;
    return [params.bucketName, accounts, location.params.system, forms && forms[this.formName]];
  }

  mapStateToProps(bucketName, accounts, system, form) {
    if (!accounts) {
      return;
    }

    const accountList = Object.values(accounts);

    _knockout.default.assignToProps(this, {
      bucketName,
      accountsHref: (0, _browserUtils.realizeUri)(routes.accounts, {
        system
      }),
      accountOptions: accountList.filter(account => !account.roles.includes('operator')).map(_getAccountOption),
      fields: !form ? {
        selectedAccounts: _getSelectedAccounts(accountList, bucketName)
      } : undefined
    });
  }

  selectAllAccounts() {
    const selectedAccounts = this.accountOptions().map(opt => opt.value);
    this.dispatch((0, _actionCreators.updateForm)(this.formName, {
      selectedAccounts
    }));
  }

  clearAllAccounts() {
    const selectedAccounts = this.accountOptions().filter(opt => opt.disabled).map(opt => opt.value);
    this.dispatch((0, _actionCreators.updateForm)(this.formName, {
      selectedAccounts
    }));
  }

  onSubmit(values) {
    this.dispatch((0, _actionCreators.closeModal)(), (0, _actionCreators.updateBucketS3Access)(this.bucketName, values.selectedAccounts));
  }

  onCancel() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

}

var _default = {
  viewModel: EditBucketS3AccessModalViewModel,
  template: _editBucketS3AccessModal.default
};
exports.default = _default;

},{"./edit-bucket-s3-access-modal.html":577,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"components/connectable":446,"knockout":"knockout","routes":972,"utils/browser-utils":1021}],579:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<managed-form class=\"column greedy\" params=\"\n    name: formName,\n    fields: fields,\n    onValidateSubmit: values => onValidateSubmit(values, existingTriggers),\n    onSubmit: onSubmit\n\">\n    <div class=\"column greedy pad\">\n        <p>Triggers will automatically invoke the selected function.</p>\n\n        <!-- ko if: bucketOptions -->\n        <editor params=\"label: 'Bucket'\">\n            <dropdown params=\"\n                    options: bucketOptions,\n                    selected: $form.bucket,\n                    placeholder: 'Choose Bucket',\n                    hasFocus: true\n                \"\n                ko.validationCss=\"$form.bucket\"\n            ></dropdown>\n            <validation-message params=\"field: $form.bucket\"></validation-message>\n        </editor>\n        <!-- /ko -->\n\n        <!-- ko if: funcOptions -->\n        <editor params=\"label: 'Function'\">\n            <dropdown params=\"\n                    options: funcOptions,\n                    actions: funcActions,\n                    selected: $form.func,\n                    placeholder: 'Choose Function',\n                    hasFocus: true\n                \"\n                ko.validationCss=\"$form.func\"\n            ></dropdown>\n            <validation-message params=\"field: $form.func\"></validation-message>\n        </editor>\n        <!-- /ko -->\n\n        <editor params=\"label: 'Event Type'\">\n            <dropdown params=\"\n                    options: eventOptions,\n                    selected: $form.event,\n                    placeholder: 'Choose Event'\n                \"\n                ko.validationCss=\"$form.event\"\n            ></dropdown>\n            <validation-message params=\"field: $form.event\"></validation-message>\n        </editor>\n\n        <editor params=\"label: 'Prefix'\">\n            <input type=\"text\"\n                placeholder=\"e.g. Images/\"\n                ko.value=\"$form.prefix\"\n                ko.validationCss=\"$form.prefix\"\n            />\n            <p class=\"hint\">optional</p>\n        </editor>\n\n        <editor params=\"label: 'Suffix'\">\n            <input type=\"text\"\n                placeholder=\"e.g. .jpg\"\n                ko.value=\"$form.suffix\"\n                ko.validationCss=\"$form.suffix\"\n            />\n            <p class=\"hint\">optional</p>\n        </editor>\n\n        <editor params=\"label: 'Trigger Active'\">\n            <toggle-switch params=\"value: $form.active\"></toggle-switch>\n        </editor>\n    </div>\n    <div class=\"row content-middle pad content-box\">\n        <div class=\"row content-middle greedy push-next remark\">\n            <!-- ko if: $form.errors().global -->\n            <svg-icon class=\"error icon-small push-next-half\" params=\"name: 'problem'\"></svg-icon>\n            <p class=\"error\">{{$form.errors().global}}</p>\n            <!-- /ko -->\n\n            <!-- ko ifnot: $form.errors().global -->\n            <svg-icon class=\"icon-small push-next-half\" params=\"name: 'notif-info'\"></svg-icon>\n            <p>\n               To create a new function go to\n               <a class=\"link\" ko.attr.href=\"funcsUrl\">Functions </a>\n               &gt; Create Function\n            </p>\n            <!-- /ko -->\n       </div>\n        <button type=\"button\"\n            class=\"link alt-colors push-next\"\n            ko.click=\"onCancel\"\n        >\n            Cancel\n        </button>\n        <button class=\"btn\" ko.shakeOnClick=\"!$form.isValid()\">\n            Save\n        </button>\n    </div>\n</managed-form>\n\n";

},{}],580:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _editBucketTriggerModal = _interopRequireDefault(require("./edit-bucket-trigger-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _bucketUtils = require("utils/bucket-utils");

var _browserUtils = require("utils/browser-utils");

var _funcUtils = require("utils/func-utils");

var _knockout = _interopRequireDefault(require("knockout"));

var routes = _interopRequireWildcard(require("routes"));

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _getDataBucketOption(bucket) {
  return {
    value: bucket.name,
    remark: 'Data bucket'
  };
}

function _getNamespaceBucketOptions(bucket) {
  return {
    value: bucket.name,
    remark: 'Namespace bucket'
  };
}

class EditBucketTriggerModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "formName", this.constructor.name);
    (0, _defineProperty2.default)(this, "updateDisplayName", '');
    (0, _defineProperty2.default)(this, "originalBucketName", '');
    (0, _defineProperty2.default)(this, "funcName", '');
    (0, _defineProperty2.default)(this, "triggerId", '');
    (0, _defineProperty2.default)(this, "existingTriggers", []);
    (0, _defineProperty2.default)(this, "fields", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "funcsUrl", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "eventOptions", _bucketUtils.bucketEvents);
    (0, _defineProperty2.default)(this, "funcOptions", _knockout.default.observableArray());
    (0, _defineProperty2.default)(this, "bucketOptions", _knockout.default.observableArray());
    (0, _defineProperty2.default)(this, "funcActions", [{
      label: 'Create new function',
      onClick: () => this.onCreateNewFunction()
    }]);
  }

  selectState(state, params) {
    return [params.mode, params.triggerId, state.buckets, state.namespaceBuckets, state.functions, state.bucketTriggers, state.accounts, state.location.params.system, Boolean(state.forms && state.forms[this.formName])];
  }

  mapStateToProps(modalMode, triggerId, buckets, namespaceBuckets, funcs, triggers, accounts, system, isFormInitialized) {
    if (!buckets || !funcs || !accounts) {
      return;
    }

    const inBucketMode = modalMode === 'BUCKET';
    const inFuncMode = modalMode === 'FUNCTION';
    const trigger = triggers[triggerId];
    const existingTriggers = Object.values(triggers).filter(other => other !== trigger);
    const funcsUrl = (0, _browserUtils.realizeUri)(routes.funcs, {
      system: system
    });
    const bucketOptions = inFuncMode ? [...Object.values(buckets).map(_getDataBucketOption), ...Object.values(namespaceBuckets).map(_getNamespaceBucketOptions)] : null;
    const funcOptions = inBucketMode ? Object.values(funcs).map(func => (0, _funcUtils.getFunctionOption)(func, accounts, trigger.bucket.name)) : null;

    _knockout.default.assignToProps(this, {
      updateDisplayName: inBucketMode ? `funciton ${trigger.func.name}` : `bucket ${trigger.bucket.name}`,
      originalBucketName: trigger.bucket.name,
      triggerId,
      funcsUrl,
      funcOptions,
      bucketOptions,
      existingTriggers,
      fields: !isFormInitialized ? {
        bucket: trigger.bucket.name,
        func: `${trigger.func.name}:${trigger.func.version}`,
        event: trigger.event,
        prefix: trigger.prefix,
        suffix: trigger.suffix,
        active: trigger.mode !== 'DISABLED'
      } : undefined
    });
  }

  onCreateNewFunction() {
    this.dispatch((0, _actionCreators.openCreateFuncModal)());
  }

  async onValidateSubmit(values, existingTriggers) {
    const errors = {};
    const {
      event,
      func,
      prefix,
      suffix,
      bucket
    } = values;
    const [funcName, funcVersion] = func.split(':');
    const unique = existingTriggers.every(trigger => trigger.bucket.name !== bucket || trigger.event !== event || trigger.func.name !== funcName || trigger.func.version !== funcVersion || trigger.prefix !== prefix || trigger.suffix !== suffix);

    if (!unique) {
      errors.event = errors.func = errors.bucket = errors.prefix = errors.suffix = ' ';
      errors.global = 'A trigger with the same setting already exists';
    }

    return errors;
  }

  onSubmit(values) {
    const {
      triggerId,
      originalBucketName,
      updateDisplayName
    } = this;
    const bucketName = values.bucket;
    const [funcName, funcVersion] = values.func.split(':');
    const config = {
      bucketName,
      funcName,
      funcVersion,
      event: values.event,
      prefix: values.prefix,
      suffix: values.suffix,
      enabled: values.active
    };
    this.dispatch((0, _actionCreators.closeModal)(), (0, _actionCreators.updateBucketTrigger)(originalBucketName, triggerId, config, updateDisplayName));
  }

  onCancel() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

}

var _default = {
  viewModel: EditBucketTriggerModalViewModel,
  template: _editBucketTriggerModal.default
};
exports.default = _default;

},{"./edit-bucket-trigger-modal.html":579,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"components/connectable":446,"knockout":"knockout","routes":972,"utils/browser-utils":1021,"utils/bucket-utils":1022,"utils/func-utils":1031}],581:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<editor params=\"label: 'Endpoint'\">\n    <input type=\"text\"\n        class=\"push-next-half\"\n        ko.value=\"$form.awsEndpoint\"\n        ko.disable=\"true\"\n    />\n</editor>\n\n<editor params=\"label: 'Access Key'\">\n    <div class=\"row\">\n        <input type=\"text\"\n            class=\"push-next-half\"\n            placeholder=\"Enter Key\"\n            ko.value=\"$form.awsAccessKey\"\n            ko.validationCss=\"$form.awsAccessKey\"\n        />\n        <validation-indicator params=\"field: $form.awsAccessKey\"></validation-indicator>\n    </div>\n    <validation-message params=\"field: $form.awsAccessKey\"></validation-message>\n</editor>\n\n<editor params=\"label: 'Secret Key'\">\n    <div class=\"row\">\n        <input type=\"password\"\n            class=\"push-next-half\"\n            placeholder=\"Enter Secret\"\n            autocomplete=\"new-password\"\n            ko.value=\"$form.awsSecretKey\"\n            ko.validationCss=\"$form.awsSecretKey\"\n        />\n        <validation-indicator params=\"field: $form.awsSecretKey\"></validation-indicator>\n    </div>\n    <validation-message params=\"field: $form.awsSecretKey\"></validation-message>\n</editor>\n";

},{}],582:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<editor params=\"label: 'Endpoint'\">\n    <input type=\"text\"\n        class=\"push-next-half\"\n        ko.value=\"$form.azureEndpoint\"\n        ko.disable=\"true\"\n    />\n</editor>\n\n<editor params=\"label: 'Account Name'\">\n    <input type=\"text\"\n        class=\"push-next-half\"\n        ko.value=\"$form.azureAccountName\"\n        ko.disable=\"true\"\n    />\n</editor>\n\n<editor params=\"label: 'Account Key'\">\n    <div class=\"row\">\n        <input type=\"password\"\n            class=\"push-next-half\"\n            placeholder=\"Enter key\"\n            autocomplete=\"new-password\"\n            ko.value=\"$form.azureAccountKey\"\n            ko.validationCss=\"$form.azureAccountKey\"\n        />\n        <validation-indicator params=\"field: $form.azureAccountKey\"></validation-indicator>\n    </div>\n    <validation-message params=\"field: $form.azureAccountKey\"></validation-message>\n</editor>\n";

},{}],583:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<managed-form class=\"column greedy\" params=\"\n    name: formName,\n    fields: formFields,\n    asyncTriggers: asyncTriggers,\n    onValidate: values => onValidate(values, existingConnections),\n    onValidateAsync: onValidateAsync,\n    onSubmit: onSubmit\n\">\n    <div class=\"column greedy pad\">\n        <editor params=\"label: 'Connection Name'\">\n            <input type=\"text\"\n                ko.value=\"$form.connectionName\"\n                ko.disable=\"true\"\n            />\n        </editor>\n\n        <editor params=\"label: 'Service'\">\n            <dropdown params=\"\n                options: serviceOptions,\n                selected: $form.service,\n                disabled: true\n            \"></dropdown>\n        </editor>\n\n        <!-- ko with: subTemplate -->\n        <!-- ko template: { html: $data, data: $parent } --><!-- /ko -->\n        <!-- /ko -->\n    </div>\n    <div class=\"row content-middle pad content-box\">\n        <div class=\"greedy\">\n            <p class=\"row content-middle error\" ko.visible=\"globalError\">\n                Somthing went wrong\n                <svg-icon class=\"icon-small push-prev-half\"\n                    ko.tooltip=\"{ text: globalError, breakWords: true }\",\n                    params=\"name: 'notif-info'\"\n                ></svg-icon>\n            </p>\n        </div>\n        <button type=\"button\" class=\"link alt-colors push-next\" ko.click=\"onCancel\">\n            Cancel\n        </button>\n        <button class=\"btn\" ko.shakeOnClick=\"!$form.isValid()\">\n            Save\n        </button>\n    </div>\n</managed-form>\n\n";

},{}],584:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _editCloudConnectionModal = _interopRequireDefault(require("./edit-cloud-connection-modal.html"));

var _awsFields = _interopRequireDefault(require("./aws-fields.html"));

var _ibmFields = _interopRequireDefault(require("./ibm-fields.html"));

var _azureFields = _interopRequireDefault(require("./azure-fields.html"));

var _s3V2CompatibleFields = _interopRequireDefault(require("./s3-v2-compatible-fields.html"));

var _s3V4CompatibleFields = _interopRequireDefault(require("./s3-v4-compatible-fields.html"));

var _googleCloudFields = _interopRequireDefault(require("./google-cloud-fields.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _cloudUtils = require("utils/cloud-utils");

var _browserUtils = require("utils/browser-utils");

var _formUtils = require("utils/form-utils");

var _promiseUtils = require("utils/promise-utils");

var _services = require("services");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const gcEndpoint = (0, _cloudUtils.getCloudServiceMeta)('GOOGLE').defaultEndpoint;
const gcValidateFailureMessage = 'Try to regenerate and upload a new file';
const templates = (0, _coreUtils.deepFreeze)({
  AWS: _awsFields.default,
  AZURE: _azureFields.default,
  S3_V2_COMPATIBLE: _s3V2CompatibleFields.default,
  S3_V4_COMPATIBLE: _s3V4CompatibleFields.default,
  GOOGLE: _googleCloudFields.default,
  IBM_COS: _ibmFields.default
});
const s3LikeConnKeyMappings = (0, _coreUtils.deepFreeze)({
  AWS: {
    endpoint: 'awsEndpoint',
    accessKey: 'awsAccessKey',
    secretKey: 'awsSecretKey'
  },
  S3_V2_COMPATIBLE: {
    endpoint: 's3v2Endpoint',
    accessKey: 's3v2AccessKey',
    secretKey: 's3v2SecretKey'
  },
  S3_V4_COMPATIBLE: {
    endpoint: 's3v4Endpoint',
    accessKey: 's3v4AccessKey',
    secretKey: 's3v4SecretKey'
  },
  FLASHBLADE: {
    endpoint: 'fbEndpoint',
    accessKey: 'fbAccessKey',
    secretKey: 'fbSecretKey'
  },
  IBM_COS: {
    endpoint: 'ibmEndpoint',
    accessKey: 'ibmAccessKey',
    secretKey: 'ibmSecretKey'
  }
});

function _getFormFields(connection) {
  const commonFields = {
    connectionName: connection.name,
    service: connection.service
  };

  switch (connection.service) {
    case 'AWS':
      {
        return { ...commonFields,
          awsEndpoint: connection.endpoint,
          awsAccessKey: connection.identity,
          awsSecretKey: ''
        };
      }

    case 'AZURE':
      {
        return { ...commonFields,
          azureEndpoint: connection.endpoint,
          azureAccountName: connection.identity,
          azureAccountKey: ''
        };
      }

    case 'S3_V2_COMPATIBLE':
      {
        return { ...commonFields,
          s3v2Endpoint: connection.endpoint,
          s3v2AccessKey: connection.identity,
          s3v2SecretKey: ''
        };
      }

    case 'S3_V4_COMPATIBLE':
      {
        return { ...commonFields,
          s3v4Endpoint: connection.endpoint,
          s3v4AccessKey: connection.identity,
          s3v4SecretKey: ''
        };
      }

    case 'GOOGLE':
      {
        return { ...commonFields,
          gcKeysFileName: '',
          gcKeysJson: ''
        };
      }

    case 'IBM_COS':
      {
        return { ...commonFields,
          ibmEndpoint: connection.endpoint,
          ibmAccessKey: connection.identity,
          ibmSecretKey: ''
        };
      }
  }
}

function _onS3LikeValidate(keys, values, existingConnections) {
  const errors = {};

  if (!values[keys.accessKey]) {
    errors[keys.accessKey] = 'Please enter an access key';
  } else {
    const alreadyExists = existingConnections.some(connection => connection.endpoint === values[keys.endpoint] && connection.identity === values[keys.accessKey]);

    if (alreadyExists) {
      errors[keys.accessKey] = 'A similar connection already exists';
    }
  }

  if (!values[keys.secretKey]) {
    errors[keys.secretKey] = 'Please enter a secret key';
  }

  return errors;
}

async function _onS3LikeValidateAsync(keys, values, service, displayName, authMethod) {
  const errors = {};
  const {
    status,
    error
  } = await _services.api.account.check_external_connection({
    endpoint_type: service,
    endpoint: values[keys.endpoint],
    identity: values[keys.accessKey],
    secret: values[keys.secretKey],
    auth_method: authMethod
  });

  switch (status) {
    case 'TIMEOUT':
      {
        errors.global = `${displayName} connection timed out`;
        break;
      }

    case 'INVALID_ENDPOINT':
      {
        errors.global = `Please enter a valid ${displayName} endpoint`;
        break;
      }

    case 'INVALID_CREDENTIALS':
      {
        errors[keys.accessKey] = errors[keys.secretKey] = 'Credentials do not match';
        break;
      }

    case 'NOT_SUPPORTED':
      {
        errors[keys.accessKey] = 'Account type is not supported';
        break;
      }

    case 'TIME_SKEW':
      {
        errors[keys.accessKey] = 'Time difference with the server is too large';
        break;
      }

    case 'UNKNOWN_FAILURE':
      {
        // Using empty message to mark the fields as invalid.
        errors[keys.endpoint] = errors[keys.accessKey] = errors[keys.secretKey] = '';
        errors.global = error.message;
        break;
      }
  }

  return errors;
}

class EditCloudConnectionModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "formName", this.constructor.name);
    (0, _defineProperty2.default)(this, "accountName", '');
    (0, _defineProperty2.default)(this, "serviceOptions", _knockout.default.observableArray());
    (0, _defineProperty2.default)(this, "subTemplate", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "existingConnections", null);
    (0, _defineProperty2.default)(this, "asyncTriggers", ['service', 'awsEndpoint', 'awsAccessKey', 'awsSecretKey', 'azureEndpoint', 'azureAccountName', 'azureAccountKey', 's3v2Endpoint', 's3v2AccessKey', 's3v2SecretKey', 's3v4Endpoint', 's3v4AccessKey', 's3v4SecretKey', 'gcKeysFileName', 'gcKeysJson', 'ibmEndpoint', 'ibmAccessKey', 'ibmSecretKey']);
    (0, _defineProperty2.default)(this, "formFields", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "globalError", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isConnectionInUse", false);
  }

  selectState(state, params) {
    const {
      accounts,
      forms
    } = state;
    const connections = accounts && accounts[params.accountName] && accounts[params.accountName].externalConnections;
    return [params.accountName, params.connectionName, connections, forms[this.formName]];
  }

  mapStateToProps(accountName, connectionName, connections, form) {
    if (!connections) {
      return;
    }

    const connection = connections.find(conn => conn.name === connectionName);
    const otherConnections = connections.filter(conn => conn !== connection);
    const {
      service
    } = connection;
    const serviceMeta = (0, _cloudUtils.getCloudServiceMeta)(service);

    _knockout.default.assignToProps(this, {
      accountName,
      existingConnections: otherConnections,
      serviceOptions: [{
        value: serviceMeta.value,
        label: serviceMeta.displayName,
        icon: serviceMeta.icon,
        selectedIcon: serviceMeta.selectedIcon,
        remark: serviceMeta.defaultEndpoint || 'No default endpoint'
      }],
      subTemplate: templates[service],
      formFields: !form ? _getFormFields(connection) : undefined,
      globalError: form ? (0, _formUtils.getFieldError)(form, 'global') : '',
      isConnectionInUse: connection.usage.length > 0
    });
  }

  onValidate(values, existingConnections) {
    const {
      service
    } = values;

    const serviceValidateSync = service === 'AWS' && this.awsOnValidate || service === 'AZURE' && this.azureOnValidate || service === 'S3_V2_COMPATIBLE' && this.s3v2OnValidate || service === 'S3_V4_COMPATIBLE' && this.s3v4OnValidate || service === 'GOOGLE' && this.gcOnValidate || service === 'IBM_COS' && this.ibmOnValidate || (() => {});

    return serviceValidateSync(values, existingConnections);
  }

  async onValidateAsync(values) {
    const {
      service
    } = values;

    const serviceValidateAsync = service === 'AWS' && this.awsOnValidateAsync || service === 'AZURE' && this.azureOnValidateAsync || service === 'S3_V2_COMPATIBLE' && this.s3v2OnValidateAsync || service === 'S3_V4_COMPATIBLE' && this.s3v4OnValidateAsync || service === 'GOOGLE' && this.gcOnValidateAsync || service === 'IBM_COS' && this.ibmOnValidateAsync || (() => {});

    return await serviceValidateAsync(values);
  }

  onSubmit(values) {
    const {
      connectionName,
      service
    } = values;
    const fields = service === 'AWS' && ['awsAccessKey', 'awsSecretKey'] || service === 'AZURE' && ['azureAccountKey'] || service === 'S3_V2_COMPATIBLE' && ['s3v2AccessKey', 's3v2SecretKey'] || service === 'S3_V4_COMPATIBLE' && ['s3v4AccessKey', 's3v4SecretKey'] || service === 'IBM_COS' && ['ibmAccessKey', 'ibmSecretKey'] || service === 'GOOGLE' && ['gcKeysJson'];
    const params = (0, _coreUtils.pick)(values, fields);
    if (service === 'GOOGLE') params.gcEndpoint = gcEndpoint;
    const updateAction = (0, _actionCreators.updateExternalConnection)(connectionName, service, params);

    if (this.isConnectionInUse) {
      this.dispatch((0, _actionCreators.openCloudConnectionUpdateWarningModal)(this.accountName, connectionName, updateAction));
    } else {
      this.dispatch((0, _actionCreators.closeModal)(), updateAction);
    }
  }

  onCancel() {
    this.dispatch((0, _actionCreators.closeModal)());
  } // --------------------------------------
  // Azure related methods:
  // --------------------------------------


  azureOnValidate(values) {
    const {
      azureAccountKey
    } = values;
    const errors = {};

    if (!azureAccountKey) {
      errors.azureAccountKey = 'Please enter an Azure account key';
    }

    return errors;
  }

  async azureOnValidateAsync(values) {
    const errors = {};
    const {
      azureEndpoint,
      azureAccountName,
      azureAccountKey
    } = values;
    const {
      status,
      error
    } = await _services.api.account.check_external_connection({
      endpoint_type: 'AZURE',
      endpoint: azureEndpoint,
      identity: azureAccountName,
      secret: azureAccountKey
    });

    switch (status) {
      case 'TIMEOUT':
        {
          errors.global = 'Azure connection timed out';
          break;
        }

      case 'INVALID_ENDPOINT':
        {
          errors.global = 'Please enter a valid Azure endpoint';
          break;
        }

      case 'INVALID_CREDENTIALS':
        {
          errors.azureAccountKey = 'Credentials do not match';
          break;
        }

      case 'NOT_SUPPORTED':
        {
          errors.global = 'Account type is not supported';
          break;
        }

      case 'TIME_SKEW':
        {
          errors.global = 'Time difference with the server is too large';
          break;
        }

      case 'UNKNOWN_FAILURE':
        {
          // Using empty message to mark the fields as invalid.
          errors.global = error.message;
          break;
        }
    }

    return errors;
  } // --------------------------------------
  // AWS related methods:
  // --------------------------------------


  awsOnValidate(values, existingConnections) {
    const awsConnections = existingConnections.filter(connection => connection.service === 'AWS');
    return _onS3LikeValidate(s3LikeConnKeyMappings['AWS'], values, awsConnections);
  }

  async awsOnValidateAsync(values) {
    return _onS3LikeValidateAsync(s3LikeConnKeyMappings['AWS'], values, 'AWS', 'AWS', 'AWS_V4');
  } // --------------------------------------
  // AWS related methods:
  // --------------------------------------


  ibmOnValidate(values, existingConnections) {
    const ibmConnections = existingConnections.filter(connection => connection.service === 'IBM_COS');
    return _onS3LikeValidate(s3LikeConnKeyMappings['IBM_COS'], values, ibmConnections);
  }

  async ibmOnValidateAsync(values) {
    return _onS3LikeValidateAsync(s3LikeConnKeyMappings['IBM_COS'], values, 'IBM_COS', 'IBM COS', 'AWS_V2');
  } // --------------------------------------
  // S3 Compatible (v2) methods:
  // --------------------------------------


  s3v2OnValidate(values, existingConnections) {
    const s3CompatibleConnections = existingConnections.filter(connection => connection.service === 'S3_V2_COMPATIBLE' || connection.service === 'S3_V4_COMPATIBLE');
    return _onS3LikeValidate(s3LikeConnKeyMappings['S3_V2_COMPATIBLE'], values, s3CompatibleConnections);
  }

  async s3v2OnValidateAsync(values) {
    return _onS3LikeValidateAsync(s3LikeConnKeyMappings['S3_V2_COMPATIBLE'], values, 'S3_COMPATIBLE', 'S3 compatible', 'AWS_V2');
  } // --------------------------------------
  // S3 Compatible (v4) methods:
  // --------------------------------------


  s3v4OnValidate(values, existingConnections) {
    const s3CompatibleConnections = existingConnections.filter(connection => connection.service === 'S3_V2_COMPATIBLE' || connection.service === 'S3_V4_COMPATIBLE');
    return _onS3LikeValidate(s3LikeConnKeyMappings['S3_V4_COMPATIBLE'], values, s3CompatibleConnections);
  }

  async s3v4OnValidateAsync(values) {
    return _onS3LikeValidateAsync(s3LikeConnKeyMappings['S3_V4_COMPATIBLE'], values, 'S3_COMPATIBLE', 'S3 compatible', 'AWS_V4');
  } // --------------------------------------
  // Google Cloud related methods:
  // --------------------------------------


  gcOnDropKeysFile(vm, evt) {
    const [file] = evt.dataTransfer.files;
    return this._gcOnKeysFile(file);
  }

  async gcOnSelectKeysFile(vm, evt) {
    const [file] = evt.target.files;
    return await this._gcOnKeysFile(file);
  }

  gcOnValidate(values, existingConnections) {
    const errors = {};
    const {
      gcKeysJson
    } = values;

    if (!gcKeysJson) {
      errors.gcKeysJson = 'Please upload a JSON keys file';
    } else {
      try {
        const {
          private_key_id: id
        } = JSON.parse(gcKeysJson);

        if ((0, _coreUtils.isUndefined)(id)) {
          errors.gcKeysJson = gcValidateFailureMessage;
        } else {
          const alreadyExists = existingConnections.some(connection => connection.service === 'GOOGLE' && connection.identity === id);

          if (alreadyExists) {
            errors.gcKeysJson = 'A similar connection already exists';
          }
        }
      } catch (_) {
        errors.gcKeysJson = gcValidateFailureMessage;
      }
    }

    return errors;
  }

  async gcOnValidateAsync(values) {
    const errors = {};
    const {
      gcKeysJson
    } = values;
    const {
      private_key_id: id
    } = JSON.parse(gcKeysJson);
    const [{
      status,
      error
    }] = await (0, _promiseUtils.all)(_services.api.account.check_external_connection({
      endpoint_type: 'GOOGLE',
      endpoint: gcEndpoint,
      identity: id,
      secret: gcKeysJson
    }), (0, _promiseUtils.sleep)(1000));

    switch (status) {
      case 'INVALID_CREDENTIALS':
        {
          errors.gcKeysJson = gcValidateFailureMessage;
          break;
        }

      case 'UNKNOWN_FAILURE':
        {
          // Using empty message to mark the fields as invalid.
          errors.gcPrivateKeyId = errors.gcKeysJson = '';
          errors.global = error.message;
          break;
        }
    }

    return errors;
  }

  async _gcOnKeysFile(file) {
    const gcKeysFileName = file.name;
    const gcKeysJson = await (0, _browserUtils.readFileAsText)(file);
    this.dispatch((0, _actionCreators.updateForm)(this.formName, {
      gcKeysFileName,
      gcKeysJson
    }));
  }

}

var _default = {
  viewModel: EditCloudConnectionModalViewModel,
  template: _editCloudConnectionModal.default
};
exports.default = _default;

},{"./aws-fields.html":581,"./azure-fields.html":582,"./edit-cloud-connection-modal.html":583,"./google-cloud-fields.html":585,"./ibm-fields.html":586,"./s3-v2-compatible-fields.html":587,"./s3-v4-compatible-fields.html":588,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout","services":1013,"utils/browser-utils":1021,"utils/cloud-utils":1024,"utils/core-utils":1027,"utils/form-utils":1030,"utils/promise-utils":1039}],585:[function(require,module,exports){
arguments[4][523][0].apply(exports,arguments)
},{"dup":523}],586:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<editor params=\"label: 'Endpoint'\">\n    <input type=\"text\"\n        class=\"push-next-half\"\n        ko.value=\"$form.ibmEndpoint\"\n        ko.disable=\"true\"\n    />\n</editor>\n\n<editor params=\"label: 'Access Key'\">\n    <div class=\"row\">\n        <input type=\"text\"\n            class=\"push-next-half\"\n            placeholder=\"Enter Key\"\n            ko.value=\"$form.ibmAccessKey\"\n            ko.validationCss=\"$form.ibmAccessKey\"\n        />\n        <validation-indicator params=\"field: $form.ibmAccessKey\"></validation-indicator>\n    </div>\n    <validation-message params=\"field: $form.ibmAccessKey\"></validation-message>\n</editor>\n\n<editor params=\"label: 'Secret Key'\">\n    <div class=\"row\">\n        <input type=\"password\"\n            class=\"push-next-half\"\n            placeholder=\"Enter Secret\"\n            autocomplete=\"new-password\"\n            ko.value=\"$form.ibmSecretKey\"\n            ko.validationCss=\"$form.ibmSecretKey\"\n        />\n        <validation-indicator params=\"field: $form.ibmSecretKey\"></validation-indicator>\n    </div>\n    <validation-message params=\"field: $form.ibmSecretKey\"></validation-message>\n</editor>\n";

},{}],587:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<editor params=\"label: 'Endpoint'\">\n    <input type=\"text\"\n        class=\"push-next-half\"\n        ko.value=\"$form.s3v2Endpoint\"\n        ko.disable=\"true\"\n    />\n</editor>\n\n<editor params=\"label: 'Access Key'\">\n    <div class=\"row\">\n        <input type=\"text\"\n            class=\"push-next-half\"\n            placeholder=\"Enter Key\"\n            ko.value=\"$form.s3v2AccessKey\"\n            ko.validationCss=\"$form.s3v2AccessKey\"\n        />\n        <validation-indicator params=\"field: $form.s3v2AccessKey\"></validation-indicator>\n    </div>\n    <validation-message params=\"field: $form.s3v2AccessKey\"></validation-message>\n</editor>\n\n<editor params=\"label: 'Secret Key'\">\n    <div class=\"row\">\n        <input type=\"password\"\n            class=\"push-next-half\"\n            placeholder=\"Enter Secret\"\n            autocomplete=\"new-password\"\n            ko.value=\"$form.s3v2SecretKey\"\n            ko.validationCss=\"$form.s3v2SecretKey\"\n        />\n        <validation-indicator params=\"field: $form.s3v2SecretKey\"></validation-indicator>\n    </div>\n    <validation-message params=\"field: $form.s3v2SecretKey\"></validation-message>\n</editor>\n";

},{}],588:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<editor params=\"label: 'Endpoint'\">\n    <input type=\"text\"\n        class=\"push-next-half\"\n        ko.value=\"$form.s3v4Endpoint\"\n        ko.disable=\"true\"\n    />\n</editor>\n\n<editor params=\"label: 'Access Key'\">\n    <div class=\"row\">\n        <input type=\"text\"\n            class=\"push-next-half\"\n            placeholder=\"Enter Key\"\n            ko.value=\"$form.s3v4AccessKey\"\n            ko.validationCss=\"$form.s3v4AccessKey\"\n        />\n        <validation-indicator params=\"field: $form.s3v4AccessKey\"></validation-indicator>\n    </div>\n    <validation-message params=\"field: $form.s3v4AccessKey\"></validation-message>\n</editor>\n\n<editor params=\"label: 'Secret Key'\">\n    <div class=\"row\">\n        <input type=\"password\"\n            class=\"push-next-half\"\n            placeholder=\"Enter Secret\"\n            autocomplete=\"new-password\"\n            ko.value=\"$form.s3v4SecretKey\"\n            ko.validationCss=\"$form.s3v4SecretKey\"\n        />\n        <validation-indicator params=\"field: $form.s3v4SecretKey\"></validation-indicator>\n    </div>\n    <validation-message params=\"field: $form.s3v4SecretKey\"></validation-message>\n</editor>\n";

},{}],589:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<managed-form class=\"column greedy\" params=\"\n    name: formName,\n    fields: formFields,\n    onValidate: onValidate,\n    onSubmit: onSubmit\n\">\n    <div class=\"column pad greedy\">\n        <editor params=\"label: 'Region'\">\n            <input type=\"text\"\n                class=\"push-next-half\"\n                ko.value=\"$form.region\"\n            />\n        </editor>\n        <editor params=\"label: 'Auto-scaling'\">\n            <toggle-switch params=\"\n                onLabel: 'Enabled',\n                offLabel: 'Disabled',\n                hasFocus: true,\n                value: $form.useAutoScaling\n            \"></toggle-switch>\n            <p class=\"remark push-next\">\n                {{toggleRemark}}\n            </p>\n        </editor>\n        <editor params=\"label: endpointCountLabel\">\n            <div class=\"row content-middle\">\n                <input type=\"number\"\n                    class=\"push-next-half\"\n                    ko.value=\"$form.minCount\"\n                />\n                <!-- ko if: $form.useAutoScaling -->\n                -\n                <input type=\"number\"\n                    class=\"push-prev-half\"\n                    ko.value=\"$form.maxCount\"\n                />\n                <!-- /ko -->\n            </div>\n            <validation-message class=\"push-prev-quarter\"\n                params=\"field: $form.minCount\"\n            ></validation-message>\n        </editor>\n    </div>\n\n    <div class=\"column pad content-box\">\n        <div class=\"row content-middle\">\n            <p class=\"greedy push-next row\">\n                <svg-icon class=\"icon-small push-next-quarter\"\n                    params=\"name: 'notif-info'\"\n                ></svg-icon>\n                <span class=\"remark\">\n                    Endpoint count cannot be guaranteed and will be set based on the available Kubernetes resources\n                </span>\n            </p>\n            <button class=\"link alt-colors push-next\"\n                ko.click=\"onCancel\"\n            >\n                Cancel\n            </button>\n            <button class=\"btn\"\n                ko.shakeOnClick=\"!$form.isValid()\"\n            >\n                Save\n            </button>\n        </div>\n    </div>\n</managed-form>\n\n";

},{}],590:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _editEndpointGroupModal = _interopRequireDefault(require("./edit-endpoint-group-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _formUtils = require("utils/form-utils");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
class EditEndpointGroupModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "formName", this.constructor.name);
    (0, _defineProperty2.default)(this, "groupName", '');
    (0, _defineProperty2.default)(this, "toggleRemark", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "endpointCountLabel", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "formFields", _knockout.default.observable());
  }

  selectState(state, params) {
    const {
      endpointGroups = {},
      forms = {}
    } = state;
    return [endpointGroups[params.groupName], forms[this.formName]];
  }

  mapStateToProps(group, form) {
    if (!group) {
      return;
    }

    const {
      endpointRange
    } = group;
    const {
      region = group.region || '',
      useAutoScaling = endpointRange.min !== endpointRange.max,
      minCount = endpointRange.min,
      maxCount = endpointRange.max
    } = form ? (0, _formUtils.getFormValues)(form) : {};

    _knockout.default.assignToProps(this, {
      groupName: group.name,
      toggleRemark: useAutoScaling ? 'The number of endpoints will automatically increase/decrease based on Kubernetes metrics' : 'The number of endpoints will remain constant regardless of Kubernetes metrics',
      endpointCountLabel: useAutoScaling ? 'Endpoint Range' : 'Number of Endpoints ',
      formFields: !form ? {
        useAutoScaling,
        minCount,
        maxCount,
        region
      } : undefined
    });
  }

  onValidate(values) {
    const errors = {};
    const {
      useAutoScaling,
      minCount,
      maxCount
    } = values;

    if (minCount < 1) {
      errors.minCount = useAutoScaling ? 'Invalid range, Lower bound must be greater then 1' : 'Nubmer of endpoint must be greater then 1';
    } else if (useAutoScaling && maxCount < minCount) {
      errors.minCount = 'Invalid range, upper bound must be greater than lower bound';
    }

    return errors;
  }

  onSubmit(values) {
    const {
      region = '',
      useAutoScaling,
      minCount,
      maxCount
    } = values;
    const endpointConf = {
      minCount: minCount,
      maxCount: useAutoScaling ? maxCount : minCount
    };
    this.dispatch((0, _actionCreators.closeModal)(), (0, _actionCreators.updateEndpointGroup)(this.groupName, region.trim(), endpointConf));
  }

  onCancel() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

}

var _default = {
  viewModel: EditEndpointGroupModalViewModel,
  template: _editEndpointGroupModal.default
};
exports.default = _default;

},{"./edit-endpoint-group-modal.html":589,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout","utils/form-utils":1030}],591:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<managed-form class=\"column greedy\" params=\"\n    name: formName,\n    fields: formFields,\n    onValidate: onValidate,\n    onSubmit: onSubmit\n\">\n    <div class=\"column greedy pad\">\n        <radio-group params=\"\n            options: inputFormatOptions,\n            selected: $form.inputFormat,\n            hasFocus: true\n        \"></radio-group>\n\n        <textarea class=\"greedy align-stretch code-field content-box\"\n            placeholder=\"Type your code here\"\n            ko.visible=\"$form.inputFormat.eq('TEXT')\"\n            ko.value=\"$form.inlineCode\"\n            ko.hasFocus=\"true\"\n            ko.validationCss=\"$form.inlineCode\"\n        ></textarea>\n        <validation-message params=\"field: $form.inlineCode\"></validation-message>\n\n        <div class=\"column greedy push-next\"\n            ko.visible=\"$form.inputFormat.eq('PACKAGE')\"\n        >\n            <drop-area class=\"greedy\"\n                ko.validationCss=\"$form.codePackage\"\n                params=\"onDrop: onDropPackage\"\n            >\n                <!-- ko ifnot: $form.codePackage().filename -->\n                <p class=\"push-next-half\">\n                    To replace, drag a new zip file here or\n                </p>\n                <label class=\"btn alt-colors\"\n                    tabindex=\"0\"\n                    ko.keysToClicks=\"['space', 'enter']\"\n                >\n                    Browse\n                    <input type=\"file\"\n                        tabindex=\"-1\"\n                        class=\"hide\"\n                        ko.attr.accept=\"'.zip'\",\n                        ko.event.change=\"onSelectPackage\"\n                    />\n                </label>\n                <!-- /ko -->\n                <!-- ko if: $form.codePackage().filename -->\n               <p class=\"row content-middle push-next-half\">\n                    <!-- ko if: $form.codePackage.isInvalid -->\n                    <svg-icon class=\"icon-small error push-next-half\" params=\"\n                        name: 'problem'\n                    \"></svg-icon>\n                    {{$form.codePackage().filename}} upload failed\n                    <!-- /ko -->\n\n                    <!-- ko if: $form.codePackage.isValid -->\n                    <svg-icon class=\"icon-small success push-next-half\" params=\"\n                        name: 'healthy'\n                    \"></svg-icon>\n                    {{$form.codePackage().filename}} uploaded\n                    <!-- /ko -->\n                </p>\n                <label class=\"link alt-colors\">\n                    Change File\n                    <input type=\"file\"\n                        class=\"hide\"\n                        ko.attr.accept=\"'.zip'\",\n                        ko.event.change=\"onSelectPackage\"\n                    />\n                </label>\n                <!-- /ko -->\n            </drop-area>\n            <p class=\"remark\" ko.visible=\"!$form.codePackage.isInvalidTouched()\">\n                Maximum upload size: {{formattedPkgSizeLimit}}\n            </p>\n            <validation-message params=\"field: $form.codePackage\"></validation-message>\n        </div>\n\n        <editor params=\"label: 'Execution File', tooltip: handlerFileTooltip\"\n            ko.visible=\"$form.inputFormat.eq('PACKAGE')\"\n        >\n            <div class=\"row content-middle\">\n                <!-- ko if: handlerFileOptions -->\n                <dropdown class=\"push-next-half\"\n                    ko.validationCss=\"$form.handlerFile\"\n                    params=\"\n                        placeholder: 'Choose file...',\n                        filter: true,\n                        filterPlaceholder: fileSelectionFilterPlaceholder,\n                        options: handlerFileOptions,\n                        selected: $form.handlerFile,\n                        disabled: isFileSelectionDisabled\n                    \"\n                ></dropdown>\n                <!-- /ko -->\n                <!-- ko ifnot: handlerFileOptions -->\n                <input class=\"push-next-half\"\n                    type=\"text\"\n                    placeholder=\"Function name\"\n                    ko.value=\"$form.handlerFile\"\n                    ko.validationCss=\"$form.handlerFile\"\n                />\n                <!-- /ko -->\n                <div ko.tooltip=\"showFileContentTooltip\">\n                    <button class=\"icon-btn\"\n                        tabindex=\"-1\"\n                        ko.disable=\"isShowFileContentBtnDisabled\"\n                        ko.click=\"() => onShowFileContent(\n                            $form.codePackage().buffer,\n                            $form.handlerFile()\n                        )\"\n                        ko.tooltip=\"'Open file content in new tab'\"\n                    >\n                        <svg-icon class=\"icon-small\" params=\"name: 'expand'\"></svg-icon>\n                    </button>\n                </div>\n            </div>\n            <validation-message params=\"field: $form.handlerFile\"></validation-message>\n        </editor>\n\n        <editor params=\"label: 'Execution Function', tooltip: handlerFuncTooltip\">\n            <input type=\"text\"\n                placeholder=\"Function name\"\n                ko.value=\"$form.handlerFunc\"\n                ko.validationCss=\"$form.handlerFunc\"\n                ko.disable=\"isFuncSelectionDisabled\"\n            />\n            <validation-message params=\"field: $form.handlerFunc\"></validation-message>\n        </editor>\n    </div>\n    <div class=\"row content-middle pad content-box\">\n        <p class=\"remark greedy push-next\">\n            <!-- ko if: $form.inputFormat.eq('PACKAGE') -->\n            <svg-icon class=\"icon-small\" params=\"name: 'notif-info'\"></svg-icon>\n            Uploading a new zip file will replace the currently used file.\n            <!-- /ko -->\n        </p>\n        <button class=\"link alt-colors push-next\"\n            ko.click=\"onCancel\"\n        >\n            Cancel\n        </button>\n        <button class=\"btn\"\n            ko.shakeOnClick=\"!$form.isValid()\"\n        >\n            Save\n        </button>\n    </div>\n</managed-form>\n\n";

},{}],592:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _editFuncCodeModal = _interopRequireDefault(require("./edit-func-code-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _browserUtils = require("utils/browser-utils");

var _sizeUtils = require("utils/size-utils");

var _funcUtils = require("utils/func-utils");

var _stringUtils = require("utils/string-utils");

var _formUtils = require("utils/form-utils");

var _services = require("services");

var _jszip = _interopRequireDefault(require("jszip"));

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const handlerFileTooltip = 'The name of the file which the handler function is written in';
const handlerFuncTooltip = 'The function within your code that will initiate the execution. The name should match to the function name in the selected file';
const inputFormatOptions = (0, _coreUtils.deepFreeze)([{
  value: 'TEXT',
  label: 'Type code manually'
}, {
  value: 'PACKAGE',
  label: 'Upload a code package (zip file)'
}]);

async function _extractFileList(buffer) {
  const zip = await _jszip.default.loadAsync(buffer);
  return Object.values(zip.files).map(zipObj => zipObj.name).filter(filename => filename.endsWith(_funcUtils.handlerFileSuffix));
}

function _getHandlerFileOptions(pkg) {
  if (pkg.size > _funcUtils.funcSizeLimit) {
    return pkg.filename ? [] : null;
  }

  return pkg.fileList.map(filename => {
    const value = filename;
    const label = (0, _stringUtils.shortString)(filename, 35, 20);
    const tooltip = {
      text: filename,
      breakWords: true
    };
    return {
      value,
      label,
      tooltip
    };
  });
}

async function _extractFile(buffer, filename) {
  const zip = await _jszip.default.loadAsync(buffer);
  return zip.file(filename).async('string');
}

async function _packageInlineCode(filename, inlineCode) {
  const zip = new _jszip.default();
  zip.file(filename, inlineCode);
  const uint8 = await zip.generateAsync({
    type: 'uint8array',
    compression: 'DEFLATE',
    compressionOptions: {
      level: 9
    }
  });
  return uint8.buffer;
}

class EditFuncCodeViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "formName", this.constructor.name);
    (0, _defineProperty2.default)(this, "inputFormatOptions", inputFormatOptions);
    (0, _defineProperty2.default)(this, "formattedPkgSizeLimit", (0, _sizeUtils.formatSize)(_funcUtils.funcSizeLimit));
    (0, _defineProperty2.default)(this, "handlerFileTooltip", handlerFileTooltip);
    (0, _defineProperty2.default)(this, "handlerFuncTooltip", handlerFuncTooltip);
    (0, _defineProperty2.default)(this, "funcName", '');
    (0, _defineProperty2.default)(this, "funcVersion", '');
    (0, _defineProperty2.default)(this, "fileSelectionFilterPlaceholder", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "handlerFileOptions", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isFileSelectionDisabled", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isFuncSelectionDisabled", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isShowFileContentBtnDisabled", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "showFileContentTooltip", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "formFields", _knockout.default.observable());
  }

  selectState(state, params) {
    const {
      functions,
      forms
    } = state;
    const {
      funcName,
      funcVersion
    } = params;
    const funcId = `${funcName}:${funcVersion}`;
    return [functions && functions[funcId], forms[this.formName]];
  }

  async mapStateToProps(func, form) {
    if (!form) {
      const {
        codeBuffer: {
          handle
        },
        codeSize,
        execFile,
        execFunc
      } = func;

      const buffer = _services.bufferStore.get(handle);

      const fileList = handle ? await _extractFileList(buffer) : 0;
      const isSingleFile = fileList.length === 1;

      _knockout.default.assignToProps(this, {
        funcName: func.name,
        funcVersion: func.version,
        formFields: {
          inputFormat: isSingleFile ? 'TEXT' : 'PACKAGE',
          inlineCode: isSingleFile ? await _extractFile(buffer, fileList[0]) : '',
          codePackage: {
            filename: '',
            size: codeSize,
            buffer: handle,
            fileList: fileList
          },
          handlerFile: execFile,
          handlerFunc: execFunc
        }
      });
    } else {
      const {
        codePackage,
        handlerFile
      } = (0, _formUtils.getFormValues)(form);
      const isCodePackageInvalid = (0, _formUtils.isFieldTouchedAndInvalid)(form, 'codePackage');
      const {
        size,
        fileList
      } = codePackage;
      const isOversized = size > _funcUtils.funcSizeLimit;
      const fileSelectionFilterPlaceholder = fileList ? `Search in ${(0, _stringUtils.stringifyAmount)('file', fileList.length)}` : '';
      const showFileContentTooltip = isOversized ? `Function is bigger than ${(0, _sizeUtils.formatSize)(_funcUtils.funcSizeLimit)}, cannot display the content of the file` : '';

      _knockout.default.assignToProps(this, {
        funcName: func.name,
        funcVersion: func.version,
        handlerFileOptions: _getHandlerFileOptions(codePackage),
        fileSelectionFilterPlaceholder,
        showFileContentTooltip,
        isFileSelectionDisabled: isCodePackageInvalid,
        isFuncSelectionDisabled: isCodePackageInvalid,
        isShowFileContentBtnDisabled: isOversized || isCodePackageInvalid || !handlerFile
      });
    }
  }

  onDropPackage(_, evt) {
    const [file] = evt.dataTransfer.files;

    this._onCodePackage(file);
  }

  onSelectPackage(_, evt) {
    const [file] = evt.target.files;

    this._onCodePackage(file);
  }

  async onShowFileContent(handle, path) {
    const buffer = handle && _services.bufferStore.get(handle);

    if (buffer) {
      const file = await _extractFile(buffer, path);
      (0, _browserUtils.openInNewTab)((0, _browserUtils.toObjectUrl)(file));
    }
  }

  onValidate(values) {
    const errors = {};
    const {
      inputFormat,
      inlineCode,
      codePackage,
      handlerFile,
      handlerFunc
    } = values;

    if (inputFormat === 'TEXT') {
      if (!inlineCode) {
        errors.inlineCode = 'Please enter javascript code';
      }
    } else if (codePackage.filename) {
      if (codePackage.size > _funcUtils.funcSizeLimit) {
        errors.codePackage = `Package size exceeds ${(0, _sizeUtils.formatSize)(_funcUtils.funcSizeLimit)}. Please use AWS API to complete the upload`;
      } else if (codePackage.fileList.length === 0) {
        errors.codePackage = 'Package does not contain execution files';
      } else if (!handlerFile) {
        errors.handlerFile = 'Please choose an execution file name';
      }
    }

    if (inputFormat === 'TEXT' || !errors.codePackage) {
      if (!handlerFunc) {
        errors.handlerFunc = 'Please enter the name of the requested execution function';
      } else if (!(0, _funcUtils.isValidHandlerFuncName)(handlerFunc)) {
        errors.handlerFunc = 'Please enter a valid javascript function name';
      }
    }

    return errors;
  }

  async onSubmit(values) {
    const {
      inputFormat,
      inlineCode,
      codePackage,
      handlerFile,
      handlerFunc
    } = values;
    let updateAction = null;

    switch (inputFormat) {
      case 'PACKAGE':
        {
          updateAction = (0, _actionCreators.updateLambdaFuncCode)(this.funcName, this.funcVersion, handlerFile, handlerFunc, codePackage.buffer, codePackage.size);
          break;
        }

      case 'TEXT':
        {
          const buffer = await _packageInlineCode('main.js', inlineCode);
          updateAction = (0, _actionCreators.updateLambdaFuncCode)(this.funcName, this.funcVersion, 'main.js', handlerFunc, _services.bufferStore.store(buffer), buffer.byteLength);
          break;
        }
    }

    this.dispatch(updateAction, (0, _actionCreators.closeModal)());
  }

  onCancel() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

  async _onCodePackage(pkg) {
    let handle = null;
    let fileList = null;

    if (pkg.size <= _funcUtils.funcSizeLimit) {
      const buffer = await (0, _browserUtils.readFileAsArrayBuffer)(pkg);
      handle = _services.bufferStore.store(buffer);
      fileList = await _extractFileList(buffer);
    }

    this.dispatch((0, _actionCreators.updateForm)(this.formName, {
      codePackage: {
        filename: pkg.name,
        size: pkg.size,
        buffer: handle,
        fileList
      },
      handlerFile: fileList.length === 1 ? fileList[0] : '',
      handlerFunc: ''
    }), (0, _actionCreators.untouchForm)(this.formName, ['handlerFile', 'handlerFunc']));
  }

}

var _default = {
  viewModel: EditFuncCodeViewModel,
  template: _editFuncCodeModal.default
};
exports.default = _default;

},{"./edit-func-code-modal.html":591,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"jszip":"jszip","knockout":"knockout","services":1013,"utils/browser-utils":1021,"utils/core-utils":1027,"utils/form-utils":1030,"utils/func-utils":1031,"utils/size-utils":1043,"utils/string-utils":1046}],593:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<managed-form class=\"column greedy\" params=\"\n    name: formName,\n    fields: formFields,\n    onValidate: onValidate,\n    onSubmit: onSubmit\n\">\n    <div class=\"column greedy pad\">\n        <editor params=\"label: 'Runtime'\">\n            <input type=\"text\"\n                disabled\n                ko.value=\"$form.runtime\"\n            />\n        </editor>\n\n        <editor params=\"label: 'Memory Size'\">\n            <dropdown params=\"\n                options: memorySizeOptions,\n                selected: $form.memorySize\n            \"></dropdown>\n        </editor>\n\n        <editor params=\"label: 'Timeout'\">\n            <div class=\"row\">\n                <input type=\"number\"\n                    min=\"0\"\n                    class=\"push-next-half\"\n                    ko.value=\"$form.timeoutMinutes\"\n                    ko.validationCss=\"$form.timeoutMinutes\"\n                />\n                <span class=\"push-next\">Min</span>\n                <input type=\"number\"\n                    min=\"0\"\n                    class=\"push-next-half\"\n                    ko.value=\"$form.timeoutSeconds\"\n                    ko.validationCss=\"$form.timeoutSeconds\"\n                />\n                <span>Sec</span>\n            </div>\n            <span class=\"val-msg\">{{timeoutError}}</span>\n        </editor>\n\n        <editor class=\"greedy\" params=\"label: 'Description'\">\n            <textarea class=\"desc-field\"\n                ko.value=\"$form.description\"\n                ko.validationCss=\"$form.description\"\n            ></textarea>\n            <p class=\"hint\" ko.visible=\"$form.description.isValid\">Up to 256 characters</p>\n            <validation-message params=\"field: $form.description\"></validation-message>\n        </editor>\n    </div>\n    <div class=\"column content-box pad\">\n        <div class=\"row align-end content-middle\">\n            <button class=\"link alt-colors push-next\"\n                ko.click=\"onCancel\"\n            >\n                Cancel\n            </button>\n            <button class=\"btn\"\n                ko.shakeOnClick=\"!$form.isValid()\"\n            >\n                Save\n            </button>\n        </div>\n    </div>\n</managed-form>\n";

},{}],594:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _editFuncConfigModal = _interopRequireDefault(require("./edit-func-config-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _funcUtils = require("utils/func-utils");

var _formUtils = require("utils/form-utils");

var _knockout = _interopRequireDefault(require("knockout"));

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
class EditFuncConfigModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "formName", this.constructor.name);
    (0, _defineProperty2.default)(this, "memorySizeOptions", _funcUtils.memorySizeOptions);
    (0, _defineProperty2.default)(this, "funcName", '');
    (0, _defineProperty2.default)(this, "funcVersion", '');
    (0, _defineProperty2.default)(this, "timeoutError", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "formFields", _knockout.default.observable());
  }

  selectState(state, params) {
    const {
      functions,
      forms
    } = state;
    const {
      funcName,
      funcVersion
    } = params;
    const funcId = `${funcName}:${funcVersion}`;
    return [functions && functions[funcId], forms[this.formName]];
  }

  mapStateToProps(func, form) {
    if (func) {
      _knockout.default.assignToProps(this, {
        funcName: func.name,
        funcVersion: func.version,
        timeoutError: form && ((0, _formUtils.getFieldError)(form, 'timeout') || ''),
        formFields: !form ? {
          runtime: func.runtime,
          memorySize: func.memorySize,
          timeoutMinutes: Math.floor(func.timeout / 60),
          timeoutSeconds: func.timeout % 60,
          description: func.description
        } : undefined
      });
    }
  }

  onValidate(values) {
    const errors = {};
    const {
      description,
      timeoutMinutes,
      timeoutSeconds
    } = values;
    const isTimeoutValid = Number.isInteger(timeoutMinutes) && Number.isInteger(timeoutSeconds) && timeoutMinutes >= 0 && timeoutSeconds >= 0 && timeoutMinutes + timeoutSeconds > 0;

    if (!isTimeoutValid) {
      errors.timeoutMinutes = errors.timeoutSeconds = '';
      errors.timeout = 'Please enter a timeout greater then 0';
    }

    const overflow = description.length - 256;

    if (overflow > 0) {
      errors.description = `${overflow} characters over the limit of 256`;
    }

    return errors;
  }

  onSubmit(values) {
    const {
      funcName,
      funcVersion
    } = this;
    const {
      description,
      runtime,
      memorySize,
      timeoutMinutes,
      timeoutSeconds
    } = values;
    const updateAction = (0, _actionCreators.updateLambdaFuncConfig)(funcName, funcVersion, description, runtime, memorySize, timeoutMinutes * 60 + timeoutSeconds);
    this.dispatch((0, _actionCreators.closeModal)(), updateAction);
  }

  onCancel() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

}

var _default = {
  viewModel: EditFuncConfigModalViewModel,
  template: _editFuncConfigModal.default
};
exports.default = _default;

},{"./edit-func-config-modal.html":593,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout","utils/form-utils":1030,"utils/func-utils":1031}],595:[function(require,module,exports){
module.exports = "<div class=\"column\">\n    <p>The following connected buckets policies would encounter issues with the configured number of nodes:</p>\n    <ul class=\"bullet-list\" ko.foreach=\"buckets\">\n        <li>{{$data}}</li>\n    </ul>\n    <p class=\"row content-middle push-prev\">\n        The recommended number of nodes according to the listed buckets policies is {{recommendedHostCount}}\n    </p>\n</div>\n";

},{}],596:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<managed-form class=\"column greedy\" params=\"\n    name: formName,\n    fields: formFields,\n    onValidate: onValidate,\n    onSubmit: onSubmit\n\">\n    <section class=\"column greedy pad\">\n        <p class=\"push-next\">\n            A Kubernetes pool is a StatefulSet in Kubernetes, Each StatefulSet contains a certain number of pods,\n            each pod serves both as an Endpoint serivce and as a Storage provider.\n        </p>\n        <editor class=\"editor-large-label\"\n            params=\"label: 'Nubmer of Nodes (pods)'\"\n        >\n            <input type=\"number\"\n                min=\"1\"\n                step=\"1\"\n                ko.value=\"$form.nodeCount\"\n                ko.validationCss=\"$form.nodeCount\"\n            />\n            <validation-message params=\"field: $form.nodeCount\">\n            </validation-message>\n            <p class=\"remark\" ko.visible=\"$form.nodeCount.isValid()\">Maximal number of nodes is 20</p>\n        </editor>\n        <editor class=\"editor-large-label push-next\"\n            params=\"\n                label: 'Node PV Size',\n                tooltip: 'Editing Nodes PV size is not available for this current version'\n            \"\n        >\n            <div class=\"row content-middle\">\n                <input class=\"push-next\"\n                    type=\"number\"\n                    min=\"1\"\n                    step=\"1\"\n                    disabled\n                    ko.value=\"$form.pvSize\"\n                    ko.validationCss=\"$form.pvSize\"\n                />\n                <dropdown class=\"size-unit-dd\" params=\"\n                    options: unitOptions,\n                    selected: $form.pvSizeUnit,\n                    disabled: true\n                \"></dropdown>\n            </div>\n            <validation-message params=\"field: $form.pvSize\">\n            </validation-message>\n        </editor>\n\n        <h2 class=\"heading3\">Review the Changes:</h2>\n        <div class=\"content-box pad-double hpad row content-middle push-next\"\n            ko.foreach=\"summary\"\n        >\n            <!-- ko if: $index -->\n            <vr></vr>\n            <!-- /ko -->\n            <div class=\"column greedy content-middle\">\n                <span class=\"row push-next-quarter\"\n                    ko.css=\"css\"\n                >\n                    <span class=\"push-next-quarter\">{{value}}</span>\n                    <svg-icon class=\"icon-small\"\n                        ko.visible=\"icon\"\n                        ko.tooltip=\"tooltip\"\n                        params=\"name: icon\"\n                    ></svg-icon>\n                </span>\n                <sapn class=\"remark\">{{label}}</sapn>\n            </div>\n        </div>\n    </section>\n\n    <div class=\"column pad content-box\">\n        <div class=\"row align-end content-middle\">\n            <button class=\"link alt-colors push-next\"\n                ko.click=\"onCancel\"\n            >\n                Cancel\n            </button>\n            <button class=\"btn\"\n                ko.shakeOnClick=\"!$form.isValid()\"\n            >\n                Save\n            </button>\n        </div>\n    </div>\n</managed-form>\n\n";

},{}],597:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _editK8sPoolModal = _interopRequireDefault(require("./edit-k8s-pool-modal.html"));

var _connectedBucketsTooltip = _interopRequireDefault(require("./connected-buckets-tooltip.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _sizeUtils = require("utils/size-utils");

var _formUtils = require("utils/form-utils");

var _bucketUtils = require("utils/bucket-utils");

var _actionCreators = require("action-creators");

var _coreUtils = require("utils/core-utils");

var _knockout = _interopRequireDefault(require("knockout"));

var _numeral = _interopRequireDefault(require("numeral"));

/* Copyright (C) 2016 NooBaa */
const selectedCapacityTooLowWarning = () => `
    The configured storage is not enough to store all data on this resource.
    This issue can reflect on the resource health and on its connected buckets health
`;

const usedCapacityAboveConfigWarning = used => `
    This pool currently stores ${(0, _sizeUtils.formatSize)(used)} of data.
    The selected storage configuration will not be enough to continue storing the data
`;

const poolIsScalingNotif = configuredCapacity => `
    This pool is currently scaling, its capacity will settle on ${(0, _sizeUtils.formatSize)(configuredCapacity)} once the process is done.
`;

const unitOptions = (0, _coreUtils.deepFreeze)(['GB', 'TB', 'PB']);

function _getCapacityInBytes(hostCount, size, unit) {
  return hostCount * size * _sizeUtils.unitsInBytes[unit];
}

function _getConnectedBucketsInfo(buckets, poolName) {
  return (0, _coreUtils.flatMap)(Object.values(buckets), bucket => (0, _bucketUtils.flatPlacementPolicy)(bucket)).filter(item => item.resource.type === 'HOSTS' && item.resource.name === poolName).map(item => {
    const {
      replicas = 0,
      dataFrags = 0,
      parityFrags = 0
    } = buckets[item.bucket].resiliency;
    return {
      name: item.bucket,
      requiredHosts: replicas + dataFrags + parityFrags
    };
  });
}

function _getConnectedBucketsTooltip(connectedBuckets, hostCount, requiredHostCount) {
  if (hostCount < requiredHostCount) {
    return {
      template: _connectedBucketsTooltip.default,
      text: {
        buckets: connectedBuckets.filter(bucket => bucket.requiredHosts > hostCount).map(bucket => bucket.name),
        recommendedHostCount: (0, _numeral.default)(requiredHostCount).format(',')
      }
    };
  } else {
    return {
      template: 'list',
      text: connectedBuckets.map(bucket => bucket.name)
    };
  }
}

class EditK8SPoolModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "formName", this.constructor.name);
    (0, _defineProperty2.default)(this, "poolName", '');
    (0, _defineProperty2.default)(this, "isSelectedCapacityBelowUsed", false);
    (0, _defineProperty2.default)(this, "unitOptions", unitOptions);
    (0, _defineProperty2.default)(this, "summary", [{
      label: 'Current Pool Capacity',
      value: _knockout.default.observable(),
      css: 'highlight',
      icon: _knockout.default.observable(),
      tooltip: {
        position: 'above',
        text: _knockout.default.observable()
      }
    }, {
      label: 'After Configuration',
      value: _knockout.default.observable(),
      css: _knockout.default.observable(),
      icon: _knockout.default.observable(),
      tooltip: {
        position: 'above',
        text: _knockout.default.observable()
      }
    }, {
      label: 'Used',
      value: _knockout.default.observable(),
      css: _knockout.default.observable(),
      icon: _knockout.default.observable(),
      tooltip: {
        position: 'above',
        text: _knockout.default.observable()
      }
    }, {
      label: 'Connected Buckets',
      value: _knockout.default.observable(),
      css: _knockout.default.observable(),
      icon: _knockout.default.observable(),
      tooltip: {
        template: _knockout.default.observable(),
        position: 'above',
        text: _knockout.default.observable()
      }
    }]);
    (0, _defineProperty2.default)(this, "formFields", _knockout.default.observable());
  }

  selectState(state, params) {
    const {
      hostPools,
      buckets,
      forms
    } = state;
    return [hostPools && hostPools[params.poolName], buckets, forms[this.formName]];
  }

  mapStateToProps(pool, buckets, form) {
    if (!pool || !buckets) {
      return;
    }

    const volumeSize = (0, _sizeUtils.toSizeAndUnit)(pool.hostConfig.volumeSize);
    const {
      pvSize = volumeSize.size,
      pvSizeUnit = volumeSize.unit,
      nodeCount = pool.configuredHostCount
    } = form ? (0, _formUtils.getFormValues)(form) : {};

    const configuredCapacity = _getCapacityInBytes(pool.configuredHostCount, volumeSize.size, volumeSize.unit);

    const selectedCapacity = _getCapacityInBytes(nodeCount, pvSize, pvSizeUnit);

    const {
      total,
      used,
      usedOther
    } = pool.storage;
    const usedCapacity = (0, _sizeUtils.sumSize)(used, usedOther);
    const isSelectedCapacityBelowUsed = (0, _sizeUtils.compareSize)(selectedCapacity, usedCapacity) < 0;

    const connectedBuckets = _getConnectedBucketsInfo(buckets, pool.name);

    const requiredHostCount = Math.max(...connectedBuckets.map(bucket => bucket.requiredHosts));
    const notEnoughHosts = nodeCount < requiredHostCount;

    _knockout.default.assignToProps(this, {
      poolName: pool.name,
      isSelectedCapacityBelowUsed,
      summary: [{
        value: (0, _sizeUtils.formatSize)(total),
        icon: total != configuredCapacity ? 'notif-info' : '',
        tooltip: {
          text: poolIsScalingNotif(configuredCapacity)
        }
      }, {
        value: (0, _sizeUtils.formatSize)(selectedCapacity),
        css: isSelectedCapacityBelowUsed ? 'error' : 'highlight',
        icon: isSelectedCapacityBelowUsed ? 'problem' : '',
        tooltip: {
          text: isSelectedCapacityBelowUsed ? selectedCapacityTooLowWarning() : ''
        }
      }, {
        value: (0, _sizeUtils.formatSize)(usedCapacity),
        css: isSelectedCapacityBelowUsed ? 'error' : 'highlight',
        icon: isSelectedCapacityBelowUsed ? 'problem' : '',
        tooltip: {
          text: isSelectedCapacityBelowUsed ? usedCapacityAboveConfigWarning(usedCapacity) : ''
        }
      }, {
        value: (0, _numeral.default)(connectedBuckets.length).format(','),
        css: notEnoughHosts ? 'warning' : 'highlight',
        icon: connectedBuckets.length ? notEnoughHosts ? 'problem' : 'notif-info' : '',
        tooltip: _getConnectedBucketsTooltip(connectedBuckets, nodeCount, requiredHostCount)
      }],
      formFields: !form ? {
        nodeCount: pool.configuredHostCount,
        pvSize: volumeSize.size,
        pvSizeUnit: volumeSize.unit
      } : undefined
    });
  }

  onValidate(values) {
    const errors = {};
    const {
      nodeCount,
      pvSize,
      pvSizeUnit
    } = values;

    if (nodeCount < 1 || nodeCount > 20 || !Number.isInteger(nodeCount)) {
      errors.nodeCount = 'Please enter a whole number between 1-20';
    }

    const minSize = pvSizeUnit === 'GB' ? 16 : 1;

    if (pvSize < minSize || !Number.isInteger(pvSize)) {
      errors.pvSize = `Please enter a whole number greater than ${minSize - 1}`;
    }

    return errors;
  }

  onSubmit(values) {
    const {
      nodeCount
    } = values;
    const scaleAction = (0, _actionCreators.scaleHostsPool)(this.poolName, nodeCount);

    if (this.isSelectedCapacityBelowUsed) {
      this.dispatch((0, _actionCreators.openConfirmDangerousScalingModal)(scaleAction));
    } else {
      this.dispatch((0, _actionCreators.closeModal)(), scaleAction);
    }
  }

  onCancel() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

}

var _default = {
  viewModel: EditK8SPoolModalViewModel,
  template: _editK8sPoolModal.default
};
exports.default = _default;

},{"./connected-buckets-tooltip.html":595,"./edit-k8s-pool-modal.html":596,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout","numeral":"numeral","utils/bucket-utils":1022,"utils/core-utils":1027,"utils/form-utils":1030,"utils/size-utils":1043}],598:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<managed-form class=\"column greedy\" params=\"\n    name: formName,\n    fields: fields,\n    onValidate: onValidate,\n    onWarn: values => onWarn(values, resourceServiceMapping),\n    onSubmit: onSubmit\n\">\n    <div class=\"column greedy pad\">\n        <div class=\"column greedy push-next\">\n            <h2 class=\"heading3\">Read Policy</h2>\n            <p class=\"push-next-half\">This namespace bucket will read its data from the selected namespace resources</p>\n            <data-table class=\"greedy content-box resource-table\" params=\"\n                columns: readPolicyTableColumns,\n                data: readPolicyRows\n            \"></data-table>\n            <validation-message params=\"field: $form.readPolicy\"></validation-message>\n        </div>\n\n        <div>\n            <h2 class=\"heading3\">Write Policy</h2>\n            <p>This namespace bucket will write its data to the selected namespace resource</p>\n            <editor params=\"\n                label: 'Namespace Resource',\n                disabled: isWritePolicyDisabled\n            \">\n                <dropdown params=\"\n                        options: writePolicyOptions,\n                        selected: $form.writePolicy,\n                        disabled: isWritePolicyDisabled,\n                    \"\n                    ko.validationCss=\"$form.writePolicy\"\n                ></dropdown>\n                <validation-message params=\"field: $form.writePolicy\"></validation-message>\n            </editor>\n        </div>\n    </div>\n    <div class=\"row content-middle pad content-box\">\n        <p class=\"remark greedy push-next\">\n            <svg-icon class=\"icon-small valign-bottom\"\n                params=\"name: 'notif-info'\"\n            ></svg-icon>\n            Any data deletions will affect both read and write resources\n        </p>\n        <button type=\"button\" class=\"link alt-colors push-next\" ko.click=\"onCancel\">\n            Cancel\n        </button>\n\n        <button class=\"btn\" ko.shakeOnClick=\"!$form.isValid()\">\n            Save\n        </button>\n    </div>\n</managed-form>\n";

},{}],599:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _editNamespaceBucketDataPlacementModal = _interopRequireDefault(require("./edit-namespace-bucket-data-placement-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _resourceUtils = require("utils/resource-utils");

var _formUtils = require("utils/form-utils");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const readPolicyTableColumns = (0, _coreUtils.deepFreeze)([{
  name: 'selected',
  label: '',
  type: 'checkbox'
}, {
  name: 'state',
  type: 'icon'
}, {
  name: 'type',
  type: 'icon'
}, {
  name: 'name',
  label: 'Namespace Resource Name'
}, {
  name: 'target',
  label: 'Target Name'
}]);

class ResourceRowViewModel {
  constructor({
    table
  }) {
    (0, _defineProperty2.default)(this, "state", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "type", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "name", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "target", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isSelected", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "selected", _knockout.default.pureComputed({
      read: this.isSelected,
      write: this.onToggle,
      owner: this
    }));
    this.table = table;
  }

  onToggle(val) {
    this.table.onToggleReadPolicyResource(this.name(), val);
  }

}

class EditNamespaceBucketDataPlacementModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "formName", this.constructor.name);
    (0, _defineProperty2.default)(this, "bucketName", '');
    (0, _defineProperty2.default)(this, "readPolicyTableColumns", readPolicyTableColumns);
    (0, _defineProperty2.default)(this, "resourceServiceMapping", null);
    (0, _defineProperty2.default)(this, "fields", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "readPolicyRows", _knockout.default.observableArray().ofType(ResourceRowViewModel, {
      table: this
    }));
    (0, _defineProperty2.default)(this, "writePolicyOptions", _knockout.default.observableArray());
    (0, _defineProperty2.default)(this, "isWritePolicyDisabled", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "readPolicy", []);
    (0, _defineProperty2.default)(this, "writePolicy", '');
  }

  selectState(state, params) {
    const {
      namespaceBuckets,
      namespaceResources,
      forms
    } = state;
    const {
      bucket
    } = params;
    return [namespaceBuckets && namespaceBuckets[bucket], namespaceResources, forms[this.formName]];
  }

  mapStateToProps(bucket, resources, form) {
    if (!bucket || !resources) {
      return;
    }

    const {
      readFrom,
      writeTo
    } = bucket.placement;
    const readPolicy = form ? (0, _formUtils.getFieldValue)(form, 'readPolicy') : readFrom;
    const resourceList = Object.values(resources);
    const readPolicyRows = resourceList.map(resource => ({
      state: (0, _resourceUtils.getNamespaceResourceStateIcon)(resource),
      type: (0, _resourceUtils.getNamespaceResourceTypeIcon)(resource),
      name: resource.name,
      target: resource.target,
      isSelected: readPolicy.includes(resource.name)
    }));
    const writePolicy = form ? (0, _formUtils.getFieldValue)(form, 'writePolicy') : writeTo;
    const writePolicyOptions = resourceList.filter(resource => readPolicy.includes(resource.name)).map(resource => {
      const {
        name: value
      } = resource;
      const {
        name: icon
      } = (0, _resourceUtils.getNamespaceResourceTypeIcon)(resource);
      return {
        value,
        icon
      };
    });
    const resourceServiceMapping = (0, _coreUtils.mapValues)(resources, resource => resource.service);

    _knockout.default.assignToProps(this, {
      bucketName: bucket.name,
      isWritePolicyDisabled: readPolicy.length === 0,
      readPolicy,
      readPolicyRows,
      writePolicy,
      writePolicyOptions,
      resourceServiceMapping,
      fields: !form ? {
        readPolicy: readFrom,
        writePolicy: writeTo
      } : undefined
    });
  }

  onValidate(values) {
    const {
      readPolicy,
      writePolicy
    } = values;
    const errors = {};

    if (readPolicy.length === 0) {
      errors.readPolicy = 'Please select at least one namespace resources';
    } else if (!writePolicy) {
      errors.writePolicy = 'Please select a namespace resource';
    }

    return errors;
  }

  onWarn(values, resourceServiceMapping) {
    const {
      readPolicy
    } = values;
    const warnings = {};

    if (readPolicy.length > 1) {
      const firstService = resourceServiceMapping[readPolicy[0]];
      const mixedServices = readPolicy.some(res => resourceServiceMapping[res] !== firstService);

      if (mixedServices) {
        warnings.readPolicy = 'A mixture of different resource services will require to read and re-write the data without optimization';
      }
    }

    return warnings;
  }

  onToggleReadPolicyResource(resource, select) {
    const {
      readPolicy,
      writePolicy,
      formName
    } = this;

    if (!select) {
      const filtered = readPolicy.filter(name => name !== resource);
      this.dispatch((0, _actionCreators.updateForm)(formName, {
        readPolicy: filtered
      }));

      if (writePolicy == resource) {
        this.dispatch((0, _actionCreators.updateForm)(formName, {
          writePolicy: ''
        }, false));
      }
    } else if (!readPolicy.includes(resource)) {
      const updated = [...readPolicy, resource];
      this.dispatch((0, _actionCreators.updateForm)(formName, {
        readPolicy: updated
      }));
    }
  }

  onSubmit(values) {
    const {
      readPolicy,
      writePolicy
    } = values;
    this.dispatch((0, _actionCreators.closeModal)(), (0, _actionCreators.updateNamespaceBucketPlacement)(this.bucketName, readPolicy, writePolicy));
  }

  onCancel() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

}

var _default = {
  viewModel: EditNamespaceBucketDataPlacementModalViewModel,
  template: _editNamespaceBucketDataPlacementModal.default
};
exports.default = _default;

},{"./edit-namespace-bucket-data-placement-modal.html":598,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout","utils/core-utils":1027,"utils/form-utils":1030,"utils/resource-utils":1041}],600:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<managed-form class=\"column greedy\" params=\"\n    name: formName,\n    fields: formFields,\n    onValidate: onValidate,\n    onSubmit: onSubmit\n\">\n    <div class=\"column greedy pad\">\n        <editor params=\"label: 'Hostname'\">\n            <input type=\"text\"\n                ko.value=\"$form.hostname\"\n                ko.validationCss=\"$form.hostname\"\n                ko.hasFocus=\"true\"\n            />\n            <validation-message params=\"field: $form.hostname\">\n            </validation-message>\n        </editor>\n        <editor params=\"label: 'Location Tag'\">\n            <input type=\"text\"\n                ko.value=\"$form.locationTag\"\n            />\n            <p class=\"hint\">optional</p>\n        </editor>\n    </div>\n    <div class=\"column pad content-box\">\n        <div class=\"row content-middle align-end\">\n            <button class=\"link alt-colors push-next\"\n                ko.click=\"onCancel\"\n            >\n                Cancel\n            </button>\n            <button class=\"btn\"\n                ko.shakeOnClick=\"!$form.isValid()\"\n            >\n                save\n            </button>\n        </div>\n    </div>\n</managed-form>\n";

},{}],601:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _editServerDetailsModal = _interopRequireDefault(require("./edit-server-details-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _actionCreators = require("action-creators");

var _validations = require("validations");

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
class EditServerDetailsModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "formName", this.constructor.name);
    (0, _defineProperty2.default)(this, "serverSecret", '');
    (0, _defineProperty2.default)(this, "serverHostname", '');
    (0, _defineProperty2.default)(this, "formFields", _knockout.default.observable());
  }

  selectState(state, params) {
    const {
      servers
    } = state.topology || {};
    return [servers && servers[params.serverSecret], state.forms[this.formName]];
  }

  mapStateToProps(server, form) {
    if (server) {
      const {
        secret,
        hostname,
        locationTag
      } = server;

      _knockout.default.assignToProps(this, {
        serverSecret: secret,
        serverHostname: hostname,
        formFields: !form ? {
          hostname,
          locationTag
        } : undefined
      });
    }
  }

  onValidate(values) {
    const {
      hostname
    } = values;
    const errors = {};

    if (!hostname || !(0, _validations.isHostname)(hostname)) {
      errors.hostname = 'Please enter a valid hostname';
    }

    return errors;
  }

  onSubmit(values) {
    this.dispatch((0, _actionCreators.updateServerDetails)(this.serverSecret, this.serverHostname, values.hostname, values.locationTag), (0, _actionCreators.closeModal)());
  }

  onCancel() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

}

var _default = {
  viewModel: EditServerDetailsModalViewModel,
  template: _editServerDetailsModal.default
};
exports.default = _default;

},{"./edit-server-details-modal.html":600,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout","validations":1048}],602:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<managed-form class=\"column greedy\" params=\"\n    name: formName,\n    fields: formFields,\n    onWarn: values => onWarn(values, hostPools(), cloudResources()),\n    onValidate: onValidate,\n    onSubmit: onSubmit\n\">\n    <div class=\"column greedy pad\">\n        <placement-policy-toggle class=\"push-next\" params=\"\n            selectedPolicy: $form.policyType,\n            hasFocus: true\n        \"></placement-policy-toggle>\n\n        <resources-selection-table class=\"column greedy\" params=\"\n            title: tableHeader,\n            hostPools: hostPools,\n            cloudResources: cloudResources,\n            selected: $form.selectedResources,\n            disabled: disabledResources\n        \"></resources-selection-table>\n\n        <validation-message params=\"\n            field: $form.selectedResources\"\n        ></validation-message>\n    </div>\n\n    <div class=\"row content-middle pad content-box\">\n        <p class=\"remark greedy push-next\">\n            <svg-icon class=\"icon-small valign-bottom\"\n                params=\"name: 'notif-info'\"\n            ></svg-icon>\n            To create a new resource go to\n            <a class=\"link\" ko.attr.href=\"resourcesHref\">\n                Resources\n            </a>\n        </p>\n        <button type=\"button\" class=\"link alt-colors push-next\" ko.click=\"onCancel\">\n            Cancel\n        </button>\n        <button class=\"btn\" ko.shakeOnClick=\"!$form.isValid()\">\n            Save\n        </button>\n    </div>\n</managed-form>\n";

},{}],603:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _editTierDataPlacementModal = _interopRequireDefault(require("./edit-tier-data-placement-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _resourceUtils = require("utils/resource-utils");

var _browserUtils = require("utils/browser-utils");

var _bucketUtils = require("utils/bucket-utils");

var _actionCreators = require("action-creators");

var routes = _interopRequireWildcard(require("routes"));

/* Copyright (C) 2016 NooBaa */
const invalidHostPoolStates = (0, _coreUtils.deepFreeze)(['INITIALIZING', 'DELETING']);

class EditTierDataPlacementModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "formName", this.constructor.name);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "bucketName", '');
    (0, _defineProperty2.default)(this, "tierName", '');
    (0, _defineProperty2.default)(this, "usingInternalStorage", false);
    (0, _defineProperty2.default)(this, "resourcesHref", '');
    (0, _defineProperty2.default)(this, "hostPools", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "cloudResources", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "disabledResources", _knockout.default.observableArray());
    (0, _defineProperty2.default)(this, "tableHeader", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "formFields", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "onWarn", _bucketUtils.warnPlacementPolicy);
    (0, _defineProperty2.default)(this, "onValidate", _bucketUtils.validatePlacementPolicy);
  }

  selectState(state, params) {
    const {
      buckets,
      hostPools,
      cloudResources,
      location
    } = state;
    const {
      bucketName,
      tierName
    } = params;
    const bucket = buckets && buckets[bucketName];
    return [tierName, bucket, hostPools, cloudResources, location.params.system];
  }

  mapStateToProps(tierName, bucket, hostPools, cloudResources, system) {
    if (!bucket || !hostPools || !cloudResources) {
      _knockout.default.assignToProps(this, {
        dataReady: false
      });
    } else {
      const {
        tiers
      } = bucket.placement;
      const tierIndex = tiers.findIndex(tier => tier.name === tierName);
      const tier = tiers[tierIndex];
      const usingInternalStorage = tier.policyType === 'INTERNAL_STORAGE';
      const resourcesInUse = (0, _bucketUtils.flatPlacementPolicy)(bucket).filter(record => record.tier !== tierName).map(record => {
        const {
          type,
          name
        } = record.resource;
        return (0, _resourceUtils.getResourceId)(type, name);
      });
      const invalidResources = Object.values(hostPools).filter(pool => invalidHostPoolStates.includes(pool.mode)).map(pool => (0, _resourceUtils.getResourceId)('HOSTS', pool.name));
      const resourcesHref = (0, _browserUtils.realizeUri)(routes.resources, {
        system
      });

      _knockout.default.assignToProps(this, {
        dataReady: true,
        bucketName: bucket.name,
        tierName: tier.name,
        usingInternalStorage,
        hostPools,
        cloudResources,
        disabledResources: [...resourcesInUse, ...invalidResources],
        resourcesHref,
        tableHeader: `Resources in Tier ${tierIndex + 1} policy`,
        formFields: !this.formFields() ? {
          policyType: !usingInternalStorage ? tier.policyType : 'SPREAD',
          selectedResources: (0, _coreUtils.flatMap)(tier.mirrorSets || [], ms => ms.resources.map(res => (0, _resourceUtils.getResourceId)(res.type, res.name)))
        } : undefined
      });
    }
  }

  onSubmit(values) {
    const {
      bucketName,
      tierName,
      usingInternalStorage
    } = this;
    const {
      policyType,
      selectedResources
    } = values;
    const action = (0, _actionCreators.updateTierPlacementPolicy)(bucketName, tierName, policyType, selectedResources);

    if (selectedResources.length > 0) {
      this.dispatch((0, _actionCreators.closeModal)(), action);
    } else if (usingInternalStorage) {
      this.dispatch((0, _actionCreators.openKeepUsingInternalStorageModal)(action));
    } else {
      this.dispatch((0, _actionCreators.openEmptyDataPlacementWarningModal)(bucketName, tierName, action));
    }
  }

  onCancel() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

}

var _default = {
  viewModel: EditTierDataPlacementModalViewModel,
  template: _editTierDataPlacementModal.default
};
exports.default = _default;

},{"./edit-tier-data-placement-modal.html":602,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"components/connectable":446,"knockout":"knockout","routes":972,"utils/browser-utils":1021,"utils/bucket-utils":1022,"utils/core-utils":1027,"utils/resource-utils":1041}],604:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<p class=\"greedy pad\">\n    {{message}}\n    Would you like to leave this tier without any resource?\n</p>\n\n<div class=\"column content-box pad\">\n    <div class=\"row content-middle align-end\">\n        <button class=\"btn alt-colors push-next\"\n            ko.click=\"onBack\"\n            ko.hasFocus=\"true\"\n        >\n            Back to edit resources\n        </button>\n        <button class=\"btn\" ko.click=\"onContinue\">\n            Yes, Continue without resources\n        </button>\n    </div>\n</div>\n";

},{}],605:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _emptyDataPlacementWarningModal = _interopRequireDefault(require("./empty-data-placement-warning-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _actionCreators = require("action-creators");

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
function _getMessage(tiers, tierName) {
  const hasNoOtherResources = tiers.filter(tier => tier.name !== tierName).every(tier => tier.mode === 'NO_RESOURCES');

  if (hasNoOtherResources) {
    return 'Removing all resources from the tier data placement policy will cause data inaccessibility.';
  } else {
    const i = tiers.findIndex(tier => tier.name == tierName);
    return `Removing all the tier’s resources will leave tier ${i + 1} inoperable until new resources will be added.`;
  }
}

class EmptyDataPlacementWarningModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "action", null);
    (0, _defineProperty2.default)(this, "message", _knockout.default.observable());
  }

  selectState(state, params) {
    const bucket = state.buckets && state.buckets[params.bucketName];
    return [bucket && bucket.placement.tiers, params.tierName, params.action];
  }

  mapStateToProps(tiers, tierName, action) {
    if (!tiers) {
      return;
    }

    const message = _getMessage(tiers, tierName);

    _knockout.default.assignToProps(this, {
      action,
      message
    });
  }

  onBack() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

  onContinue() {
    this.dispatch((0, _actionCreators.closeModal)(Infinity), this.action);
  }

}

var _default = {
  viewModel: EmptyDataPlacementWarningModalViewModel,
  template: _emptyDataPlacementWarningModal.default
};
exports.default = _default;

},{"./empty-data-placement-warning-modal.html":604,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout"}],606:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"column pad greedy\">\n    <div class=\"row push-next content-middle\">\n        <div class=\"column greedy\">\n            <h2 class=\"heading2\">Upload progress</h2>\n\n            <div class=\"row content-middle\" ko.visible=\"uploading\">\n                <span class=\"remark push-next-half\" ko.text=\"progressText\"></span>\n                <progress-bar params=\"progress: progress\"></progress-bar>\n            </div>\n\n            <span ko.visible=\"!uploading()\">\n                No uploads running\n            </span>\n        </div>\n\n        <button class=\"btn\"\n            ko.click=\"onClearCompeleted\"\n            ko.hasFocus=\"true\"\n        >\n            Clear Completed\n        </button>\n    </div>\n\n    <data-table class=\"content-box uploads-table greedy\" params=\"\n        columns: columns,\n        data: rows,\n        emptyMessage: 'No upload transactions'\n    \">\n        <template name=\"fileName\">\n            <!-- ko ifnot: $data().href  -->\n            <span class=\"remark\"\n               ko.text=\"$data().text\"\n               ko.tooltip=\"$data().tooltip\"\n            ></span>\n            <!-- /ko -->\n            <!-- ko if: $data().href -->\n            <a class=\"link\"\n               ko.attr.href=\"$data().href\"\n               ko.text=\"$data().text\"\n               ko.tooltip=\"$data().tooltip\"\n            ></a>\n            <!-- /ko -->\n        </template>\n    </data-table>\n    <hr>\n    <section class=\"content-box summary row push-next content-middle\">\n        <span class=\"row success push-next content-middle\">\n            <svg-icon params=\"name: 'healthy'\" class=\"success icon-small\">\n            </svg-icon>\n            <span>Uploaded {{uploaded}}</span>\n        </span>\n\n        <span class=\"row content-middle error push-both\"\n            ko.css.disabled=\"failed() === 0\">\n            <svg-icon params=\"name: 'problem'\" class=\"error icon-small\">\n            </svg-icon>\n            <span>Failed {{failed}}</span>\n        </span>\n\n        <span class=\"row content-middle push-prev\" ko.visible=\"uploading\">\n            <svg-icon class=\"spin icon-small\" params=\"name: 'in-progress'\"></svg-icon>\n            <span>Uploading {{uploading}}</span>\n        </span>\n\n        <span class=\"file-counter content-middle\" ko.text=\"countText\">\n        </span>\n    </section>\n</div>\n<div class=\"column pad content-box\">\n    <button class=\"btn align-end\" ko.click=\"onClose\">\n        Close\n    </button>\n</div>\n";

},{}],607:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _fileUploadsModal = _interopRequireDefault(require("./file-uploads-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _stringUtils = require("utils/string-utils");

var _sizeUtils = require("utils/size-utils");

var _numeral = _interopRequireDefault(require("numeral"));

var _actionCreators = require("action-creators");

var _browserUtils = require("utils/browser-utils");

var routes = _interopRequireWildcard(require("routes"));

/* Copyright (C) 2016 NooBaa */
const columns = (0, _coreUtils.deepFreeze)([{
  name: 'fileName',
  type: 'fileName'
}, 'bucketName', 'size', 'progress']);
const errorCodeToProgressText = (0, _coreUtils.deepFreeze)({
  NoSuchUpload: 'ABORTED'
});

function _getUploadProgressSummary(stats) {
  const {
    uploading,
    batchSize,
    batchLoaded
  } = stats;

  if (uploading === 0) {
    return '';
  }

  return `Uploading ${(0, _sizeUtils.formatSize)(batchLoaded)} of ${(0, _sizeUtils.formatSize)(batchSize)} (${(0, _numeral.default)(batchLoaded / batchSize).format('%')})`;
}

function _getUploadProgress(upload) {
  const {
    completed,
    error,
    size,
    loaded
  } = upload;

  if (completed) {
    if (error) {
      return {
        text: errorCodeToProgressText[error.code] || 'FAILED',
        tooltip: error.message,
        css: 'error'
      };
    } else {
      return {
        text: 'COMPLETED',
        css: 'success'
      };
    }
  } else {
    return {
      text: size > 0 ? (0, _numeral.default)(loaded / size).format('%') : 0
    };
  }
}

function _mapUploadToRow(upload, system) {
  const {
    name,
    bucket,
    versionId,
    completed,
    error,
    size
  } = upload;
  const fileNameData = {
    text: name,
    tooltip: {
      text: name,
      breakWords: true
    }
  };

  if (completed && !error) {
    fileNameData.href = (0, _browserUtils.realizeUri)(routes.object, {
      system,
      bucket,
      object: name,
      version: versionId
    });
  }

  return {
    fileName: fileNameData,
    bucketName: bucket,
    size: (0, _sizeUtils.formatSize)(size),
    progress: _getUploadProgress(upload)
  };
}

class UploadRowViewModel {
  constructor() {
    (0, _defineProperty2.default)(this, "fileName", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "bucketName", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "size", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "progress", _knockout.default.observable());
  }

}

class FileUploadsModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "columns", columns);
    (0, _defineProperty2.default)(this, "countText", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "uploaded", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "failed", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "uploading", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "progress", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "progressText", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "rows", _knockout.default.observableArray().ofType(UploadRowViewModel));
  }

  selectState(state) {
    const {
      objectUploads,
      location
    } = state;
    return [objectUploads, location.params.system];
  }

  mapStateToProps(objectUploads, system) {
    const {
      stats,
      objects
    } = objectUploads;

    _knockout.default.assignToProps(this, {
      countText: (0, _stringUtils.stringifyAmount)('file', stats.count),
      uploading: stats.uploading,
      failed: stats.failed,
      uploaded: stats.uploaded,
      progress: stats.batchLoaded / stats.batchSize,
      progressText: _getUploadProgressSummary(stats),
      rows: Array.from(objects).reverse().map(upload => _mapUploadToRow(upload, system))
    });
  }

  onClearCompeleted() {
    this.dispatch((0, _actionCreators.clearCompletedObjectUploads)());
  }

  onClose() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

}

var _default = {
  viewModel: FileUploadsModalViewModel,
  template: _fileUploadsModal.default
};
exports.default = _default;

},{"./file-uploads-modal.html":606,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"components/connectable":446,"knockout":"knockout","numeral":"numeral","routes":972,"utils/browser-utils":1021,"utils/core-utils":1027,"utils/size-utils":1043,"utils/string-utils":1046}],608:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<managed-form class=\"column greedy\" params=\"\n    name: formName,\n    fields: formFields,\n    onValidate: onValidate,\n    onSubmit: onSubmit\n\">\n    <div class=\"column greedy pad\">\n        <p class=\"push-next\">\n            Execute your function, replace the event below with an event that matches the function.\n        </p>\n\n        <h2 class=\"heading3 push-next-half\">\n            Event\n        </h2>\n\n        <textarea class=\"greedy align-stretch event-field\"\n            ko.value=\"$form.event\"\n            ko.validationCss=\"$form.event\"\n            ko.hasFocus=\"true\"\n        ></textarea>\n        <validation-message\n            class=\"push-next\"\n            params=\"field: $form.event\"\n        ></validation-message>\n    </div>\n    <div class=\"column pad content-box\">\n        <div class=\"row content-middle align-end\">\n            <button class=\"link alt-colors push-next\"\n                ko.click=\"onCancel\"\n            >\n                Cancel\n            </button>\n            <button class=\"btn\"\n                ko.shakeOnClick=\"!$form.isValid()\"\n            >\n                Set and Invoke\n            </button>\n        </div>\n    </div>\n</managed-form>\n";

},{}],609:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _invokeFuncModal = _interopRequireDefault(require("./invoke-func-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const exampleEvent = {
  key1: 'value1',
  key2: 'value2',
  key3: 'value3'
};

class InvokeFuncModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "formName", this.constructor.name);
    (0, _defineProperty2.default)(this, "funcName", '');
    (0, _defineProperty2.default)(this, "funcVersion", '');
    (0, _defineProperty2.default)(this, "formFields", {
      event: JSON.stringify(exampleEvent, null, 4)
    });
  }

  selectState(state, params) {
    return [params.funcName, params.funcVersion];
  }

  mapStateToProps(funcName, funcVersion) {
    _knockout.default.assignToProps(this, {
      funcName,
      funcVersion
    });
  }

  onValidate(values) {
    const {
      event
    } = values;
    const errors = {};

    try {
      JSON.parse(event);
    } catch (_) {
      errors.event = 'Please enter a valid JSON object';
    }

    return errors;
  }

  onSubmit(values) {
    const {
      funcName,
      funcVersion
    } = this;
    const event = JSON.parse(values.event);
    this.dispatch((0, _actionCreators.closeModal)(), (0, _actionCreators.invokeLambdaFunc)(funcName, funcVersion, event));
  }

  onCancel() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

}

var _default = {
  viewModel: InvokeFuncModalViewModel,
  template: _invokeFuncModal.default
};
exports.default = _default;

},{"./invoke-func-modal.html":608,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout"}],610:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n<managed-form class=\"column greedy\" params=\"\n    name: formName,\n    fields: formFields,\n    onValidate: onValidate,\n    onSubmit: onSubmit\n\">\n    <div class=\"column greedy pad\">\n        <p class=\"push-next\">\n            The selected data placement of tier 1 does not contain any resources. <br>\n            Currently this bucket is using the system internal disks storage in order to be able to continue writing data.\n        </p>\n\n        <div class=\"column greedy\">\n            <h2 class=\" heading3\">\n                How would you like like to proceed?\n            </h2>\n            <radio-group params=\"\n                multiline: true,\n                options: options,\n                selected: $form.selection,\n                hasFocus: true\n            \"></radio-group>\n            <validation-message params=\"field: $form.selection\"></validation-message>\n        </div>\n    </div>\n    <div class=\"column pad content-box\">\n        <div class=\"row align-end\">\n            <button class=\"btn alt-colors push-next\"\n                ko.click=\"onBack\"\n            >\n                Back to edit resources\n            </button>\n            <button class=\"btn align-end\"\n                ko.shakeOnClick=\"!$form.isValid()\"\n            >\n                Save\n            </button>\n        </div>\n    </div>\n</managed-form>\n";

},{}],611:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _keepUsingInternalStorageModal = _interopRequireDefault(require("./keep-using-internal-storage-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const options = [{
  label: 'Keep using the internal disks storage until new resources will be added',
  value: 'DROP_ACTION'
}, {
  label: 'Leave this bucket without resources (non-writable)',
  value: 'APPLY_ACTION'
}];

class KeepUsingInternalStorageModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "options", options);
    (0, _defineProperty2.default)(this, "action", null);
    (0, _defineProperty2.default)(this, "formName", this.constructor.name);
    (0, _defineProperty2.default)(this, "formFields", {
      selection: ''
    });
  }

  selectState(state, params) {
    return [params.action];
  }

  mapStateToProps(action) {
    _knockout.default.assignToProps(this, {
      action
    });
  }

  onValidate(values) {
    const errors = {};

    if (values.selection === '') {
      errors.selection = 'Please select one of the options above';
    }

    return errors;
  }

  onSubmit(values) {
    this.dispatch((0, _actionCreators.closeModal)(Infinity));

    if (values.selection === 'APPLY_ACTION') {
      this.dispatch(this.action);
    }
  }

  onBack() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

}

var _default = {
  viewModel: KeepUsingInternalStorageModalViewModel,
  template: _keepUsingInternalStorageModal.default
};
exports.default = _default;

},{"./keep-using-internal-storage-modal.html":610,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout"}],612:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<p class=\"greedy pad\">\n    Sorry... for some reason, the NooBaa management console has crashed.\n    If this error re-occurs, please contact our support team via\n    <a class=\"link\"\n        ko.attr.href=\"emailInfo.href\"\n    >\n        {{emailInfo.text}}\n    </a>\n</p>\n<div class=\"column pad content-box\">\n    <button class=\"btn align-end\"\n        ko.click=\"onReload\"\n        ko.hasFocus=\"true\"\n    >\n        Reload Management Console\n    </button>\n</div>\n";

},{}],613:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _managementConsoleErrorModal = _interopRequireDefault(require("./management-console-error-modal.html"));

var _config = require("config");

var _coreUtils = require("utils/core-utils");

var _browserUtils = require("utils/browser-utils");

/* Copyright (C) 2016 NooBaa */
const emailInfo = (0, _coreUtils.deepFreeze)({
  text: _config.support.email,
  href: (0, _browserUtils.formatEmailUri)(_config.support.email, _config.support.managementConsoleSubject)
});

class ManagementConsoleErrorModalViewModel {
  constructor() {
    this.emailInfo = emailInfo;
  }

  onReload() {
    (0, _browserUtils.reloadBrowser)('/');
  }

}

var _default = {
  viewModel: ManagementConsoleErrorModalViewModel,
  template: _managementConsoleErrorModal.default
};
exports.default = _default;

},{"./management-console-error-modal.html":612,"@babel/runtime/helpers/interopRequireDefault":1050,"config":831,"utils/browser-utils":1021,"utils/core-utils":1027}],614:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"column greedy pad\">\n    NooBaa needs access to your OpenShift account information,\n    please grant the proper access when requested.\n</div>\n\n<div class=\"column pad content-box\">\n    <button class=\"btn align-end \" ko.click=\"onBack\">\n        OK, Take me Back\n    </button>\n</div>\n\n";

},{}],615:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _oauthAccessDeniedModal = _interopRequireDefault(require("./oauth-access-denied-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _browserUtils = require("utils/browser-utils");

/* Copyright (C) 2016 NooBaa */
class OAuthAccessDeniedModalViewModel extends _connectable.default {
  onBack() {
    // Using navigateTo instead of requestLocation action because
    // login layout was not fully moved to new arch and will not react
    // to state location changes
    // TODO: move to requestLocation action after login layout rewrite
    (0, _browserUtils.navigateTo)('/fe');
  }

}

var _default = {
  viewModel: OAuthAccessDeniedModalViewModel,
  template: _oauthAccessDeniedModal.default
};
exports.default = _default;

},{"./oauth-access-denied-modal.html":614,"@babel/runtime/helpers/interopRequireDefault":1050,"components/connectable":446,"utils/browser-utils":1021}],616:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"greedy column pad\">\n    <p class=\"push-next\">\n        In order to access the NooBaa Management Console using your OpenShift account you need to be a member\n        of the <span class=\"highlight\">system:cluster-admins</span> group.\n    </p>\n\n    <p>Alternatively, You can use a NooBaa admin account</p>\n</div>\n\n<div class=\"column pad content-box\">\n    <button class=\"btn align-end \" ko.click=\"onBack\">\n        OK, Take me to NooBaa Login\n    </button>\n</div>\n\n";

},{}],617:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _oauthUnauthorizedModal = _interopRequireDefault(require("./oauth-unauthorized-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _browserUtils = require("utils/browser-utils");

/* Copyright (C) 2016 NooBaa */
class OauthUnauthorizedModalViewModel extends _connectable.default {
  onBack() {
    // Using navigateTo instead of requestLocation action because
    // login layout was not fully moved to new arch and will not react
    // to state location changes
    // TODO: move to requestLocation action after login layout rewrite
    (0, _browserUtils.navigateTo)('/fe?skip-oauth');
  }

}

var _default = {
  viewModel: OauthUnauthorizedModalViewModel,
  template: _oauthUnauthorizedModal.default
};
exports.default = _default;

},{"./oauth-unauthorized-modal.html":616,"@babel/runtime/helpers/interopRequireDefault":1050,"components/connectable":446,"utils/browser-utils":1021}],618:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"column pad greedy\" ko.if=\"uri\">\n    <iframe ko.attr.src=\"uri\"></iframe>\n</div>\n\n<div class=\"column pad content-box\">\n    <button class=\"align-end btn\"\n        ko.click=\"onClose\"\n        ko.hasFocus=\"true\"\n    >\n        Close\n    </button>\n</div>\n\n";

},{}],619:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectPreviewModal = _interopRequireDefault(require("./object-preview-modal.html"));

var _state = require("state");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
class ObjectPreviewModalViewModel {
  constructor({
    objectUri
  }) {
    (0, _defineProperty2.default)(this, "uri", '');
    this.uri = objectUri;
  }

  onClose() {
    _state.action$.next((0, _actionCreators.closeModal)());
  }

}

var _default = {
  viewModel: ObjectPreviewModalViewModel,
  template: _objectPreviewModal.default
};
exports.default = _default;

},{"./object-preview-modal.html":618,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"state":1016}],620:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n<div class=\"column greedy pad\">\n    <p class=\"heading3\">\n        A new password has been generated\n    </p>\n    <p class=\"push-next no-wrap copy-message\">\n         Please copy and send the following message to {{accountName}}\n    </p>\n\n\n    <div class=\"content-box pad row content-start greedy\">\n        <pre class=\"user-message greedy\"\n            ko.html=\"userMessage\"\n        ></pre>\n\n        <copy-to-clipboard-button params=\"value: userMessage\">\n        </copy-to-clipboard-button>\n    </div>\n\n    <p class=\"remark push-next push-prev-half\">\n        <svg-icon class=\"icon-small\"\n            params=\"name: 'notif-info'\"\n        ></svg-icon>\n        The account will receive a temporary password and will be asked to change it on its next login.\n    </p>\n</div>\n\n<div class=\"column pad content-box\">\n    <button class=\"btn align-end\"\n        ko.click=\"onDone\"\n    >\n        Done\n    </button>\n</div>\n";

},{}],621:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _passwordResetCompletedModal = _interopRequireDefault(require("./password-reset-completed-modal.html"));

var _userMessage = _interopRequireDefault(require("./user-message.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
class PasswordResetSuccessfulModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "accountName", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "userMessage", _knockout.default.observable());
  }

  selectState(state, params) {
    return [params.accountName, params.password];
  }

  mapStateToProps(accountName, password) {
    const userMessage = _knockout.default.renderToString(_userMessage.default, {
      accountName,
      password
    });

    _knockout.default.assignToProps(this, {
      accountName,
      userMessage
    });
  }

  onDone() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

}

var _default = {
  viewModel: PasswordResetSuccessfulModalViewModel,
  template: _passwordResetCompletedModal.default
};
exports.default = _default;

},{"./password-reset-completed-modal.html":620,"./user-message.html":622,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout"}],622:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<span class=\"highlight\">Hi, I reset your password:</span>\nAccount name: <span>{{accountName}}</span>\nNew temporary password: <span>{{password}}</span>\n";

},{}],623:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"column greedy pad\">\n    <p class=\"heading3 push-next\">\n        A problem has occurred while resetting {{accountName}} password\n    </p>\n\n    <p class=\"greedy\">\n        Please try again later.\n        If the problem doesn’t resolve please contact\n        <a class=\"link\" ko.attr.href=\"supportHref\">NooBaa support</a>\n    </p>\n</div>\n<div class=\"column pad content-box\">\n    <button class=\"btn align-end\"\n        ko.click=\"onClose\"\n    >\n        Close\n    </button>\n</div>\n";

},{}],624:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _passwordResetFailedModal = _interopRequireDefault(require("./password-reset-failed-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _browserUtils = require("utils/browser-utils");

var _actionCreators = require("action-creators");

var _config = require("config");

/* Copyright (C) 2016 NooBaa */
class PasswordResetFailedModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "accountName", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "supportHref", (0, _browserUtils.formatEmailUri)(_config.support.email, _config.support.cannotResetAccountPasswordSubject));
  }

  selectState(state, params) {
    return [params.accountName];
  }

  mapStateToProps(accountName) {
    _knockout.default.assignToProps(this, {
      accountName
    });
  }

  onClose() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

}

var _default = {
  viewModel: PasswordResetFailedModalViewModel,
  template: _passwordResetFailedModal.default
};
exports.default = _default;

},{"./password-reset-failed-modal.html":623,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"config":831,"knockout":"knockout","utils/browser-utils":1021}],625:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<managed-form class=\"column greedy\" params=\"\n    name: formName,\n    fields: fields,\n    onValidate: onValidate,\n    onSubmit: onSubmit,\n    owner: $component\n\">\n    <div class=\"greedy column pad\">\n        <p class=\"warning-box warning row pad content-middle\">\n            <svg-icon class=\"push-next\" params=\"name: 'notif-warning'\">\n            </svg-icon>\n            <span class=\"greedy\">\n                You are about to regenerate an account's security credentials.\n                This will invalidate all connections between S3 clients and NooBaa which are connected using the current credentials.\n            </span>\n        </p>\n\n        <editor params=\"label: 'Type &#34;regenerate&#34;'\">\n            <input class=\"input\"\n                ko.value=\"$form.confirm\"\n                ko.hasFocus=\"true\"\n                ko.validationCss=\"$form.confirm\"\n            />\n            <validation-message params=\"field: $form.confirm\"></validation-message>\n        </editor>\n    </div>\n    <div class=\"column pad content-box\">\n        <div class=\"row content-middle align-end\">\n            <button type=\"button\"\n                class=\"link alt-colors push-next\"\n                ko.click=\"onCancel\"\n            >\n                Cancel\n            </button>\n            <button class=\"btn\"\n                ko.shakeOnClick=\"!$form.isValid()\"\n            >\n                Regenerate Credentials\n            </button>\n        </div>\n    </div>\n</managed-form>\n";

},{}],626:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _regenerateAccountCredentialsModal = _interopRequireDefault(require("./regenerate-account-credentials-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _actionCreators = require("action-creators");

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
class RegenerateAccountCredentialsModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "formName", this.constructor.name);
    (0, _defineProperty2.default)(this, "targetAccount", '');
    (0, _defineProperty2.default)(this, "fields", {
      confirm: ''
    });
  }

  selectState(_, params) {
    return [params.accountName];
  }

  mapStateToProps(targetAccount) {
    _knockout.default.assignToProps(this, {
      targetAccount
    });
  }

  onValidate(values) {
    const {
      confirm
    } = values;
    const errors = {};

    if (confirm.trim().toLowerCase() !== 'regenerate') {
      errors.confirm = 'Please type "regenerate" to confirm your action';
    }

    return errors;
  }

  onSubmit() {
    this.dispatch((0, _actionCreators.closeModal)(), (0, _actionCreators.regenerateAccountCredentials)(this.targetAccount));
  }

  onCancel() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

}

var _default = {
  viewModel: RegenerateAccountCredentialsModalViewModel,
  template: _regenerateAccountCredentialsModal.default
};
exports.default = _default;

},{"./regenerate-account-credentials-modal.html":625,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout"}],627:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<managed-form class=\"column greedy\" params=\"\n    name: formName,\n    fields: formFields,\n    onValidate: onValidate,\n    onValidateSubmit: onValidateSubmit,\n    onSubmit: onSubmit\n\">\n    <div class=\"column greedy pad\">\n        <p class=\"heading3\">\n            You are about to reset {{accountName}} password,\n            please enter your password as verification.\n        </p>\n\n        <editor class=\"greedy\"\n            params=\"label: 'Your Password'\"\n        >\n            <password-field\n                ko.validationCss=\"$form.verificationPassword\"\n                params=\"\n                    value: $form.verificationPassword,\n                    disabled: $form.isSubmittingOrSubmitted,\n                    hasFocus: true\n                \"\n            ></password-field>\n            <validation-message params=\"field: $form.verificationPassword\"></validation-message>\n        </editor>\n    </div>\n    <div class=\"column pad content-box\">\n        <div class=\"row align-end content-middle\">\n            <button class=\"link alt-colors push-next\"\n                ko.click=\"onCancel\"\n                ko.disable=\"$form.isSubmittingOrSubmitted\"\n            >\n                Cancel\n            </button>\n\n            <working-button ko.shakeOnClick=\"!$form.isValid()\" params=\"\n                click: $form.submit,\n                working: $form.isSubmittingOrSubmitted,\n                workingLabel: 'Resetting...'\n            \">\n                Reset Password\n            </working-button>\n        </div>\n    </div>\n</managed-form>\n";

},{}],628:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _resetPasswordModal = _interopRequireDefault(require("./reset-password-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _stringUtils = require("utils/string-utils");

var _actionCreators = require("action-creators");

var _services = require("services");

/* Copyright (C) 2016 NooBaa */
class RestPasswordModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "formName", this.constructor.name);
    (0, _defineProperty2.default)(this, "accountName", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "formFields", {
      verificationPassword: ''
    });
  }

  selectState(state, params) {
    return [params.accountName];
  }

  mapStateToProps(accountName) {
    _knockout.default.assignToProps(this, {
      accountName
    });
  }

  onValidate(values) {
    const {
      verificationPassword
    } = values;
    const errors = {};

    if (verificationPassword.trim() === '') {
      errors.verificationPassword = 'Please enter your current password';
    }

    return errors;
  }

  async onValidateSubmit(values) {
    const {
      verificationPassword: verification_password
    } = values;
    const errors = {};
    const verified = await _services.api.account.verify_authorized_account({
      verification_password
    });

    if (!verified) {
      errors.verificationPassword = 'Please make sure your password is correct';
    }

    return errors;
  }

  onCancel() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

  onSubmit(values) {
    const {
      verificationPassword
    } = values;
    const accountName = this.accountName();
    const newPassword = (0, _stringUtils.randomString)();
    const lockModalAction = (0, _actionCreators.updateModal)({
      backdropClose: false,
      closeButton: 'disabled'
    });
    const resetAction = (0, _actionCreators.resetAccountPassword)(verificationPassword, accountName, newPassword);
    this.dispatch(lockModalAction, resetAction);
  }

}

var _default = {
  viewModel: RestPasswordModalViewModel,
  template: _resetPasswordModal.default
};
exports.default = _default;

},{"./reset-password-modal.html":627,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout","services":1013,"utils/string-utils":1046}],629:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n<managed-form class=\"column greedy\" params=\"\n    name: formName,\n    fields: fields,\n    onValidate: onValidate,\n    onValidateSubmit: onValidateSubmit,\n    onSubmit: onSubmit\n\">\n    <div class=\"column greedy pad\">\n        <p class=\"push-next\">\n            The configured data resiliency policy that was set has less then 2 failure tolerance\n            option, in any case of resource failure data may be at risk\n        </p>\n\n        <editor class=\"greedy\" params=\"label: 'Type your password to confirm'\">\n            <div class=\"row content-middle\">\n                <password-field class=\"push-next-half\"\n                    ko.validationCss=\"$form.password\"\n                    params=\"\n                        value: $form.password,\n                        hasFocus: true\n                    \"\n                ></password-field>\n                <svg-icon class=\"spin match-theme\"\n                    params=\"name: 'in-progress'\"\n                    ko.visible=\"$form.isSubmitting\"\n                ></svg-icon>\n            </div>\n            <validation-message params=\"field: $form.password\"></validation-message>\n        </editor>\n    </div>\n    <div class=\"column pad content-box\">\n        <div class=\"row content-middle align-end\">\n            <button type=\"button\"\n                class=\"btn alt-colors push-next\"\n                ko.click=\"onBack\"\n            >\n                Back to Edit Data Resiliency\n            </button>\n            <button class=\"btn\" ko.shakeOnClick=\"!$form.isValid()\">\n                Done\n            </button>\n        </div>\n    </div>\n</managed-form>\n";

},{}],630:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _riskyBucketDataResiliencyWarningModal = _interopRequireDefault(require("./risky-bucket-data-resiliency-warning-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _actionCreators = require("action-creators");

var _promiseUtils = require("utils/promise-utils");

var _services = require("services");

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
class RiskyBucketDataResiliencyWarningModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "formName", this.constructor.name);
    (0, _defineProperty2.default)(this, "action", null);
    (0, _defineProperty2.default)(this, "fields", {
      password: ''
    });
  }

  selectState(_, params) {
    return [params.action];
  }

  mapStateToProps(action) {
    _knockout.default.assignToProps(this, {
      action
    });
  }

  onValidate(values) {
    const errors = {};

    if (!values.password) {
      errors.password = 'Please enter your account\'s password';
    }

    return errors;
  }

  async onValidateSubmit(values) {
    const errors = {};
    const [match] = await (0, _promiseUtils.all)(_services.api.account.verify_authorized_account({
      verification_password: values.password
    }), (0, _promiseUtils.sleep)(500));

    if (!match) {
      errors.password = 'Please enter your account\'s password';
    }

    return errors;
  }

  onSubmit() {
    this.dispatch((0, _actionCreators.closeModal)(Infinity), this.action);
  }

  onBack() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

}

var _default = {
  viewModel: RiskyBucketDataResiliencyWarningModalViewModel,
  template: _riskyBucketDataResiliencyWarningModal.default
};
exports.default = _default;

},{"./risky-bucket-data-resiliency-warning-modal.html":629,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout","services":1013,"utils/promise-utils":1039}],631:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"column greedy pad\">\n    <h2 class=\"heading3\">\n        Use the following details to connect your S3 application\n    </h2>\n\n    <div class=\"content-box pad greedy\">\n        <property-sheet class=\"push-next greedy\" params=\"properties: details\">\n        </property-sheet>\n    </div>\n</div>\n<div class=\"column pad content-box\">\n    <button class=\"btn align-end\"\n        ko.click=\"onClose\"\n        ko.hasFocus=\"true\"\n    >\n        close\n    </button>\n</div>\n";

},{}],632:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _s3AccessDetailsModal = _interopRequireDefault(require("./s3-access-details-modal.html"));

var _actionCreators = require("action-creators");

var _state = require("state");

/* Copyright (C) 2016 NooBaa */
class S3AccessDetailsModalViewModel {
  constructor({
    endpoint,
    accessKey,
    secretKey
  }) {
    (0, _defineProperty2.default)(this, "details", null);
    this.details = [{
      label: 'Storage Type',
      value: 'S3 Compatible Storage',
      allowCopy: false
    }, {
      label: 'Endpoint',
      value: endpoint,
      allowCopy: true
    }, {
      label: 'Access Key',
      value: accessKey,
      allowCopy: true
    }, {
      label: 'Secret Key',
      value: secretKey,
      allowCopy: true
    }];
  }

  onClose() {
    _state.action$.next((0, _actionCreators.closeModal)());
  }

}

var _default = {
  viewModel: S3AccessDetailsModalViewModel,
  template: _s3AccessDetailsModal.default
};
exports.default = _default;

},{"./s3-access-details-modal.html":631,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"state":1016}],633:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n<section class=\"column greedy pad\">\n    <p>\n        Your session has expired. Please login again to continue working.\n    </p>\n</section>\n<div class=\"column pad content-box\">\n    <button class=\"btn align-end\"\n        ko.click=\"onBackToLogin\"\n    >\n        Back to Login Screen\n    </button>\n</div>\n";

},{}],634:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _sessionExpiredModal = _interopRequireDefault(require("./session-expired-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
class sessionExpiredModal extends _connectable.default {
  onBackToLogin() {
    this.dispatch((0, _actionCreators.closeModal)(), (0, _actionCreators.signOut)());
  }

}

var _default = {
  viewModel: sessionExpiredModal,
  template: _sessionExpiredModal.default
};
exports.default = _default;

},{"./session-expired-modal.html":633,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446}],635:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<managed-form class=\"column greedy\" params=\"\n    name: formName,\n    fields: fields,\n    onValidate: onValidate,\n    onSubmit: onSubmit\n\">\n    <div class=\"column greedy pad\">\n        <editor params=\"label: 'IP Restriction'\">\n            <toggle-switch params=\"\n                onLabel: 'Enabled',\n                offLabel: 'Disabled',\n                value: $form.usingIpRestrictions,\n                hasFocus: true\n            \"></toggle-switch>\n        </editor>\n\n        <div class=\"column greedy push-next\">\n            <h2 class=\"heading3\" ko.css.disabled=\"!$form.usingIpRestrictions()\">\n                Allowed IPs\n            </h2>\n            <p class=\"push-next\" ko.css.disabled=\"!$form.usingIpRestrictions()\">\n                Accept S3 access requests from these addresses only.\n                Specify a single IP address or an IP address range.\n            </p>\n            <token-field class=\"column greedy\" params=\"\n                disabled: !$form.usingIpRestrictions(),\n                placeholder: allowedIpsPlaceholder,\n                tokens: $form.allowedIps,\n                validator: tokenValidator\n            \"></token-field>\n            <p class=\"remark\"\n                ko.visible=\"!$form.allowedIps.isInvalidTouched()\"\n                ko.css.disabled=\"!$form.usingIpRestrictions()\"\n            >\n                Type IP address accurately, click enter after each address or range\n            </p>\n            <validation-message params=\"field: $form.allowedIps\"></validation-message>\n        </div>\n    </div>\n    <div class=\"column pad content-box\">\n        <div class=\"row align-end content-middle\">\n            <button type=\"button\" class=\"link alt-colors push-next\" ko.click=\"onCancel\">\n                Cancel\n            </button>\n            <button class=\"btn\" ko.shakeOnClick=\"!$form.isValid()\">\n                Save\n            </button>\n        </div>\n    </div>\n</managed-form>\n";

},{}],636:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _setAccountIpRestrictionsModal = _interopRequireDefault(require("./set-account-ip-restrictions-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _netUtils = require("utils/net-utils");

var _actionCreators = require("action-creators");

var _coreUtils = require("utils/core-utils");

/* Copyright (C) 2016 NooBaa */
const invalidIpReasonMapping = (0, _coreUtils.deepFreeze)({
  MALFORMED: 'All values must be of the IPv4 format',
  INVALID_RANGE_ORDER: 'IP range must start with lowest value',
  MULTIPLE_INVALID_IPS: 'Some IPs are invalid'
});
const allowedIpsPlaceholder = `e.g., 10.5.3.2 or 10.2.253.5 - 24 and click enter ${String.fromCodePoint(0x23ce)}`;

class setAccountIpRestrictionsModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "formName", this.constructor.name);
    (0, _defineProperty2.default)(this, "tokenValidator", val => (0, _netUtils.isIPOrIPRange)(val).valid);
    (0, _defineProperty2.default)(this, "allowedIpsPlaceholder", allowedIpsPlaceholder);
    (0, _defineProperty2.default)(this, "fields", _knockout.default.observable());
  }

  selectState(state, params) {
    const {
      accounts,
      forms
    } = state;
    return [accounts && accounts[params.accountName], Boolean(forms && forms[this.formName])];
  }

  mapStateToProps(account, formInitialized) {
    if (!account || formInitialized) return;
    const usingIpRestrictions = Boolean(account.allowedIps);
    const allowedIps = (account.allowedIps || []).map(({
      start,
      end
    }) => start === end ? start : `${start} - ${end}`);

    _knockout.default.assignToProps(this, {
      fields: {
        accountName: account.name,
        usingIpRestrictions: usingIpRestrictions,
        allowedIps: allowedIps
      }
    });
  }

  onValidate({
    usingIpRestrictions,
    allowedIps
  }) {
    const errors = {};

    if (usingIpRestrictions) {
      const ipErrors = allowedIps.map(_netUtils.isIPOrIPRange).filter(({
        valid
      }) => !valid);
      const errorCount = ipErrors.length;

      if (errorCount > 0) {
        const reason = errorCount === 1 ? ipErrors[0].reason : 'MULTIPLE_INVALID_IPS';
        errors.allowedIps = invalidIpReasonMapping[reason];
      }
    }

    return errors;
  }

  onSubmit({
    accountName,
    usingIpRestrictions,
    allowedIps
  }) {
    this.dispatch((0, _actionCreators.closeModal)(), (0, _actionCreators.setAccountIpRestrictions)(accountName, usingIpRestrictions ? allowedIps : null));
  }

  onCancel() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

}

var _default = {
  viewModel: setAccountIpRestrictionsModalViewModel,
  template: _setAccountIpRestrictionsModal.default
};
exports.default = _default;

},{"./set-account-ip-restrictions-modal.html":635,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout","utils/core-utils":1027,"utils/net-utils":1036}],637:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"column greedy pad\">\n    <section class=\"column c8 push-next\">\n        <h3 class=\"heading3 push-next-half\">Reliability test result</h3>\n        <data-table class=\"greedy content-box untrusted-reason-table\" params=\"\n            columns: columns,\n            data: rows\n        \"></data-table>\n    </section>\n    <section class=\"column c4\">\n        <p class=\"push-next\">\n            This node was marked as untrusted after an internal reliability test.\n        </p>\n        <p>\n            Setting this node as trusted may risk its stored data.\n        </p>\n        <p class=\"push-next\">\n            Would you like to trust this node anyway?\n        </p>\n    </section>\n</div>\n<div class=\"column pad content-box\">\n    <div class=\"row content-middle align-end\">\n        <button class=\"link alt-colors push-next\"\n            ko.click=\"onCancel\"\n            ko.hasFocus=\"true\"\n        >\n            Cancel\n        </button>\n        <button class=\"btn\"\n            ko.click=\"onRetrust\"\n        >\n            Yes, trust this node\n        </button>\n    </div>\n</div>\n";

},{}],638:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _setNodeAsTrustedModal = _interopRequireDefault(require("./set-node-as-trusted-modal.html"));

var _coreUtils = require("utils/core-utils");

var _actionCreators = require("action-creators");

var _state = require("state");

var _config = require("config");

var _moment = _interopRequireDefault(require("moment"));

/* Copyright (C) 2016 NooBaa */
const columns = (0, _coreUtils.deepFreeze)([{
  name: 'testDate'
}, {
  name: 'drive'
}, {
  name: 'testType'
}, {
  name: 'results'
}]);
const eventMapping = (0, _coreUtils.deepFreeze)({
  CORRUPTION: {
    type: 'Disk corruption',
    results: 'Data was changed'
  },
  TEMPERING: {
    type: 'Permission tampering',
    results: 'Directory permissions were changed'
  }
});

class SetNodeAsTrustedModalViewModel {
  constructor({
    host,
    untrustedReasons
  }) {
    this.columns = columns;
    this.host = host;
    this.rows = (0, _coreUtils.flatMap)(untrustedReasons, ({
      drive,
      events
    }) => events.map(event => {
      const {
        time,
        reason
      } = event;
      const testDate = (0, _moment.default)(time).format(_config.timeShortFormat);
      const {
        type: testType,
        results
      } = eventMapping[reason];
      return {
        testDate,
        drive,
        testType,
        results
      };
    }));
  }

  onRetrust() {
    _state.action$.next((0, _actionCreators.retrustHost)(this.host));

    _state.action$.next((0, _actionCreators.closeModal)());
  }

  onCancel() {
    _state.action$.next((0, _actionCreators.closeModal)());
  }

}

var _default = {
  viewModel: SetNodeAsTrustedModalViewModel,
  template: _setNodeAsTrustedModal.default
};
exports.default = _default;

},{"./set-node-as-trusted-modal.html":637,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"config":831,"moment":"moment","state":1016,"utils/core-utils":1027}],639:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n<managed-form class=\"column greedy\" params=\"\n    name: formName,\n    fields: fields,\n    onValidate: onValidate,\n    onSubmit: onSubmit\n\">\n    <div class=\"column greedy pad\">\n        <div class=\"warning-box warning row pad content-middle push-next\">\n            <svg-icon class=\"push-next warning\" params=\"name: 'notif-warning'\">\n            </svg-icon>\n            Performance and functionality issues may occur while the system is in maintenance mode\n        </div>\n\n        <div class=\"greedy\">\n            <editor params=\"label: 'Maintenance duration'\">\n                <div class=\"row\">\n                    <input class=\"push-next\"\n                        type=\"number\"\n                        min=\"0\"\n                        ko.value=\"$form.duration\"\n                        ko.hasFocus=\"true\"\n                        ko.validationCss=\"$form.duration\"\n                    />\n\n                    <dropdown class=\"duration-unit\" params=\"\n                        options: durationUnitOptions,\n                        selected: $form.durationUnit\n                    \"></dropdown>\n                </div>\n                <validation-message params=\"field: $form.duration\"></validation-message>\n            </editor>\n        </div>\n    </div>\n    <div class=\"column pad content-box\">\n        <div class=\"row content-middle align-end\">\n            <button type=\"button\" class=\"link alt-colors push-next\" ko.click=\"onCancel\">\n                Cancel\n            </button>\n            <button class=\"btn\" ko.shakeOnClick=\"!$form.isValid()\">\n                Start maintenance\n            </button>\n        </div>\n    </div>\n</managed-form>\n";

},{}],640:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _startMaintenanceModal = _interopRequireDefault(require("./start-maintenance-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _formUtils = require("utils/form-utils");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const durationUnitOptions = (0, _coreUtils.deepFreeze)([{
  label: 'Minutes',
  value: 1
}, {
  label: 'Hours',
  value: 60
}]);

class StartMaintenanceModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "formName", this.constructor.name);
    (0, _defineProperty2.default)(this, "durationUnitOptions", durationUnitOptions);
    (0, _defineProperty2.default)(this, "durationInMin", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "fields", {
      duration: 30,
      durationUnit: 1
    });
  }

  selectState(state) {
    return [state.forms[this.formName]];
  }

  mapStateToProps(form) {
    if (!form) return;
    const {
      duration,
      durationUnit
    } = (0, _formUtils.getFormValues)(form);
    const durationInMin = duration * durationUnit;

    _knockout.default.assignToProps(this, {
      durationInMin
    });
  }

  onValidate(values) {
    const {
      duration
    } = values;
    const errors = {};

    if (!Number.isInteger(duration)) {
      errors.duration = 'Please enter a whole number';
    } else if (duration <= 0) {
      errors.duration = 'Please enter a number greater then 0';
    }

    return errors;
  }

  onCancel() {
    this.dispatch((0, _actionCreators.closeModal)());
  }

  onSubmit() {
    this.dispatch((0, _actionCreators.closeModal)(), (0, _actionCreators.enterMaintenanceMode)(this.durationInMin()));
  }

}

var _default = {
  viewModel: StartMaintenanceModalViewModel,
  template: _startMaintenanceModal.default
};
exports.default = _default;

},{"./start-maintenance-modal.html":639,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout","utils/core-utils":1027,"utils/form-utils":1030}],641:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"column greedy pad push-next\">\n    <div class=\"config row content-middle push-next\">\n        <radio-group class=\"greedy push-next\" params=\"\n            selected: selectedTests,\n            options: testTypeOptions,\n            hasFocus: true\n        \"></radio-group>\n        <button class=\"btn run-btn\" data-bind=\"\n            click: runTest,\n            disable: testing\n        \">\n            Run\n        </button>\n    </div>\n\n    <data-table class=\"column greedy content-box\" params=\"\n        columns: columns,\n        rowFactory: test => createTestRow(test),\n        data: results,\n        emptyMessage: 'Click on the run button to start the test'\n    \"></data-table>\n    <hr>\n    <section class=\"content-box summary row content-middle\">\n        <!-- ko if:summary -->\n        <span class=\"row success push-next content-middle\">\n            <svg-icon params=\"name: 'healthy'\" class=\"success icon-small\">\n            </svg-icon>\n            <span>\n                Completed\n                <span data-bind=\"text: summary().completed\"></span>\n            </span>\n        </span>\n\n        <span class=\"row content-middle error push-both\">\n            <svg-icon params=\"name: 'problem'\" class=\"error icon-small\"></svg-icon>\n            <span>\n                Failed\n                <span data-bind=\"text: summary().failed\"></span>\n            </span>\n\n        </span>\n\n        <span class=\"row content-middle push-prev\" data-bind=\"\n            visible: summary().inProcess\n        \">\n            <svg-icon class=\"spin icon-small\" params=\"name: 'in-progress'\"></svg-icon>\n            <span>\n                In Process\n                <span data-bind=\"text: summary().inProcess\"></span>\n            </span>\n        </span>\n        <!-- /ko -->\n    </section>\n</div>\n\n<div class=\"column pad content-box\">\n    <button class=\"action btn align-end\" data-bind=\"\n        click: close,\n        text: closeBtnText\n    \">\n        Close\n    </button>\n</div>\n";

},{}],642:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _testNodeModal = _interopRequireDefault(require("./test-node-modal.html"));

var _testRow = _interopRequireDefault(require("./test-row"));

var _baseViewModel = _interopRequireDefault(require("components/base-view-model"));

var _knockout = _interopRequireDefault(require("knockout"));

var _model = require("model");

var _actions = require("actions");

var _coreUtils = require("utils/core-utils");

var _state = require("state");

var _actionCreators = require("action-creators");

var _moment = _interopRequireDefault(require("moment"));

/* Copyright (C) 2016 NooBaa */
const testTypes = Object.freeze([{
  name: 'Full test',
  tests: ['connectivity', 'bandwidth']
}, {
  name: 'Connectivity',
  tests: ['connectivity']
}, {
  name: 'Bandwidth',
  tests: ['bandwidth']
}]);
const columns = (0, _coreUtils.deepFreeze)(['test', 'targetNode', 'protocol', 'ip', 'port', 'time', 'speed', 'progress']);

class TestNodeModalViewModel extends _baseViewModel.default {
  constructor({
    nodeRpcAddress
  }) {
    super();
    this.columns = columns;
    this.testTypeOptions = testTypes.map(({
      name,
      tests
    }) => {
      return {
        label: name,
        value: tests
      };
    });
    this.nodeRpcAddress = nodeRpcAddress;
    this.selectedTests = _knockout.default.observable(testTypes[0].tests);
    this.results = _knockout.default.pureComputed(() => (0, _model.nodeTestInfo)() && (0, _model.nodeTestInfo)().results);
    this.lastTestTime = _knockout.default.pureComputed(() => (0, _model.nodeTestInfo)() && `( Last test results from: ${(0, _moment.default)((0, _model.nodeTestInfo)().timestamp).format('HH:mm:ss')} )`);
    this.testing = _knockout.default.pureComputed(() => !!(0, _model.nodeTestInfo)() && (0, _model.nodeTestInfo)().state === 'IN_PROGRESS');
    this.summary = _knockout.default.pureComputed(() => this.results() && this._summarizeResults(this.results()));
    this.bandwidthSummary = _knockout.default.pureComputed(() => this._getTestSummary(this.results(), 'bandwidth'));
    this.closeBtnText = _knockout.default.pureComputed(() => this.testing() ? 'Abort & Close' : 'Close');
  }

  _summarizeResults(results) {
    return results.reduce((summary, {
      state
    }) => {
      summary.inProcess += Number(state === 'RUNNING' || state === 'WAITING');
      summary.completed += Number(state === 'COMPLETED');
      summary.failed += Number(state === 'FAILED');
      summary.aborted += Number(state === 'ABORTED');
      return summary;
    }, {
      inProcess: 0,
      completed: 0,
      failed: 0,
      aborted: 0
    });
  }

  createTestRow(test) {
    return new _testRow.default(test);
  }

  runTest() {
    (0, _actions.testNode)(_knockout.default.unwrap(this.nodeRpcAddress), this.selectedTests());
  }

  close() {
    if (this.testing()) {
      (0, _actions.abortNodeTest)();
    }

    _state.action$.next((0, _actionCreators.closeModal)());
  }

}

var _default = {
  viewModel: TestNodeModalViewModel,
  template: _testNodeModal.default
};
exports.default = _default;

},{"./test-node-modal.html":641,"./test-row":643,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"actions":320,"components/base-view-model":399,"knockout":"knockout","model":936,"moment":"moment","state":1016,"utils/core-utils":1027}],643:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _baseViewModel = _interopRequireDefault(require("components/base-view-model"));

var _knockout = _interopRequireDefault(require("knockout"));

var _numeral = _interopRequireDefault(require("numeral"));

/* Copyright (C) 2016 NooBaa */
class TestRowViewModel extends _baseViewModel.default {
  constructor(result) {
    super();
    this.test = _knockout.default.pureComputed(() => result() ? result().testType : '');
    this.targetNode = _knockout.default.pureComputed(() => {
      if (!result) {
        return;
      }

      let {
        targetName
      } = result();
      return {
        text: targetName,
        tooltip: targetName
      };
    });
    this.protocol = _knockout.default.pureComputed(() => result() ? result().protocol.toUpperCase() : '');
    this.ip = _knockout.default.pureComputed(() => result() ? result().targetIp : '');
    this.port = _knockout.default.pureComputed(() => result() ? result().targetPort : '');
    this.time = _knockout.default.pureComputed(() => result() ? `${(result().time / 1000).toFixed(2)} seconds` : '');
    this.stateClass = _knockout.default.pureComputed(() => result() ? result().state.toLowerCase() : '');
    this.speed = _knockout.default.pureComputed(() => {
      if (!result()) {
        return '';
      }

      return `${(result().speed * 1000 / Math.pow(1024, 2)).toFixed(1)} MB/s`;
    });
    this.progress = _knockout.default.pureComputed(() => {
      if (!result()) {
        return {};
      }

      let {
        state,
        progress
      } = result();
      return {
        css: state.toLowerCase(),
        text: state === 'RUNNING' ? (0, _numeral.default)(progress).format('0%') : state.toLowerCase()
      };
    });
  }

}

exports.default = TestRowViewModel;

},{"@babel/runtime/helpers/interopRequireDefault":1050,"components/base-view-model":399,"knockout":"knockout","numeral":"numeral"}],644:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<section class=\"column greedy pad\">\n    <p>Congratulations, You are now ready to use NooBaa management system</p>\n    <br />\n    <p>\n        To make it as easy as we can, we have created a resource which reside on the local VM's disks.\n        You can start writing data to the first bucket right away.\n    </p>\n</section>\n<div class=\"column pad content-box\">\n    <button class=\"btn align-end\"\n        ko.hasFocus=\"true\"\n        ko.click=\"onStart\"\n    >\n        Take Me to The System\n    </button>\n</div>\n";

},{}],645:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _welcomeModal = _interopRequireDefault(require("./welcome-modal.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _browserUtils = require("utils/browser-utils");

var _actionCreators = require("action-creators");

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
class WelcomeModalViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "systemUri", '');
  }

  selectState(state) {
    return [state.location];
  }

  mapStateToProps(location) {
    _knockout.default.assignToProps(this, {
      systemUri: (0, _browserUtils.realizeUri)(location.route, location.params)
    });
  }

  onStart() {
    this.dispatch((0, _actionCreators.closeModal)());
    this.dispatch((0, _actionCreators.requestLocation)(this.systemUri, true));
  }

}

var _default = {
  viewModel: WelcomeModalViewModel,
  template: _welcomeModal.default
};
exports.default = _default;

},{"./welcome-modal.html":644,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout","utils/browser-utils":1021}],646:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"row content-middle pad card-shadow\">\n    <div class=\"cloumn greedy\">\n        <h3 class=\"heading3\">Resources</h3>\n        <p>This namespace bucket will read it’s data from the following namespace resources and write to one selected resource</p>\n    </div>\n    <button class=\"btn\"\n        ko.click=\"onEditPlacement\"\n        ko.enable=\"dataReady\"\n    >\n        Edit placement policy\n    </button>\n</div>\n\n<data-table class=\"greedy placement-table\" params=\"\n    columns: columns,\n    data: rows,\n    loading: !dataReady(),\n    emptyMessage: 'No resources participate in policy'\n\">\n    <template name=\"nameAndRule\">\n        <p class=\"row content-middle\">\n            {{$data().name}}\n            <span class=\"tag push-prev-half\" ko.text=\"$data().rule\"></span>\n        </p>\n    </template>\n</data-table>\n";

},{}],647:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _namespaceBucketDataPlacementForm = _interopRequireDefault(require("./namespace-bucket-data-placement-form.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _coreUtils = require("utils/core-utils");

var _knockout = _interopRequireDefault(require("knockout"));

var _resourceUtils = require("utils/resource-utils");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const columns = (0, _coreUtils.deepFreeze)([{
  name: 'state',
  type: 'icon'
}, {
  name: 'type',
  type: 'icon'
}, {
  name: 'name',
  type: 'nameAndRule',
  label: 'Namespace Resource Name'
}, {
  name: 'target',
  label: 'Target Name'
}]);

class ResourceRowViewModel {
  constructor() {
    (0, _defineProperty2.default)(this, "state", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "type", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "name", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "target", _knockout.default.observable());
  }

}

class NamespaceBucketDataPlacementFormViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "columns", columns);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "bucketName", '');
    (0, _defineProperty2.default)(this, "rows", _knockout.default.observableArray().ofType(ResourceRowViewModel));
  }

  selectState(state, params) {
    const {
      namespaceBuckets,
      namespaceResources
    } = state;
    return [namespaceBuckets && namespaceBuckets[params.bucket], namespaceResources];
  }

  mapStateToProps(bucket, resources) {
    if (!bucket || !resources) {
      _knockout.default.assignToProps(this, {
        dataReady: false
      });
    } else {
      const {
        readFrom,
        writeTo
      } = bucket.placement;
      const resourceList = Object.values((0, _coreUtils.pick)(resources, readFrom));

      _knockout.default.assignToProps(this, {
        dataReady: true,
        bucketName: bucket.name,
        rows: resourceList.map(resource => ({
          state: (0, _resourceUtils.getNamespaceResourceStateIcon)(resource),
          type: (0, _resourceUtils.getNamespaceResourceTypeIcon)(resource),
          name: {
            name: resource.name,
            rule: resource.name === writeTo ? 'Read & Write' : 'Read'
          },
          target: resource.target
        }))
      });
    }
  }

  onEditPlacement() {
    this.dispatch((0, _actionCreators.openEditNamespaceBucketDataPlacementModal)(this.bucketName));
  }

}

var _default = {
  viewModel: NamespaceBucketDataPlacementFormViewModel,
  template: _namespaceBucketDataPlacementForm.default
};
exports.default = _default;

},{"./namespace-bucket-data-placement-form.html":646,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout","utils/core-utils":1027,"utils/resource-utils":1041}],648:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n<namespace-bucket-summary class=\"push-next\" params=\"bucket: bucketName\"></namespace-bucket-summary>\n\n<div class=\"tabs greedy\">\n    <nav>\n        <a ko.css.selected=\"selectedTab.eq('data-placement')\"\n            ko.attr.href=\"tabHref('data-placement')\"\n        >\n            Data Placement\n        </a>\n        <a ko.attr.href=\"tabHref('s3-access')\"\n            ko.css.selected=\"selectedTab.eq('s3-access')\"\n        >\n            S3 Access\n        </a>\n        <a ko.attr.href=\"tabHref('triggers')\"\n            ko.css.selected=\"selectedTab.eq('triggers')\"\n        >\n            Triggers\n        </a>\n    </nav>\n\n    <div class=\"tabs-row\">\n        <namespace-bucket-data-placement-form class=\"tab column\"\n            ko.css.selected=\"selectedTab.eq('data-placement')\"\n            params=\"bucket: bucketName\"\n        ></namespace-bucket-data-placement-form>\n\n        <namespace-bucket-s3-access-form class=\"tab column\"\n            ko.css.selected=\"selectedTab.eq('s3-access')\"\n            params=\"bucket: bucketName\"\n        ></namespace-bucket-s3-access-form>\n\n        <namespace-bucket-triggers-form class=\"tab column\"\n            ko.css.selected=\"selectedTab.eq('triggers')\"\n            params=\"bucket: bucketName\"\n        ></namespace-bucket-triggers-form>\n    </div>\n</div>\n";

},{}],649:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _namespaceBucketPanel = _interopRequireDefault(require("./namespace-bucket-panel.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _browserUtils = require("utils/browser-utils");

/* Copyright (C) 2016 NooBaa */
class NamespaceBucketPanelViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "baseRoute", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "selectedTab", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "bucketName", _knockout.default.observable());
  }

  selectState(state) {
    return [state.location];
  }

  mapStateToProps(location) {
    const {
      system,
      bucket,
      tab = 'data-placement'
    } = location.params;

    _knockout.default.assignToProps(this, {
      bucketName: bucket,
      baseRoute: (0, _browserUtils.realizeUri)(location.route, {
        system,
        bucket
      }, {}, true),
      selectedTab: tab
    });
  }

  tabHref(tab) {
    const route = this.baseRoute();
    return route ? (0, _browserUtils.realizeUri)(route, {
      tab
    }) : '';
  }

}

var _default = {
  viewModel: NamespaceBucketPanelViewModel,
  template: _namespaceBucketPanel.default
};
exports.default = _default;

},{"./namespace-bucket-panel.html":648,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"components/connectable":446,"knockout":"knockout","utils/browser-utils":1021}],650:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"row content-middle card-shadow pad\">\n    <h2 class=\"heading3 greedy\">\n        Accounts with S3 access for this bucket: {{accountCount}}\n    </h2>\n\n    <button class=\"btn\" ko.click=\"onEditS3Access\">\n        Edit S3 Access\n    </button>\n</div>\n\n<data-table class=\"greedy accounts-table\" params=\"\n    columns: columns,\n    data: rows,\n    sorting: ko.pc(sorting, onSort, $component),\n    loading: !dataReady,\n    emptyMessage: 'No accounts were granted access for this bucket'\n\"></data-table>\n";

},{}],651:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _namespaceBucketS3AccessForm = _interopRequireDefault(require("./namespace-bucket-s3-access-form.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _browserUtils = require("utils/browser-utils");

var routes = _interopRequireWildcard(require("routes"));

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const columns = (0, _coreUtils.deepFreeze)([{
  name: 'name',
  type: 'link',
  sortable: true,
  compareKey: account => account.name
}, {
  name: 'credentialsDetails',
  type: 'button'
}]);

class AccountRowViewModel {
  constructor({
    table
  }) {
    (0, _defineProperty2.default)(this, "name", {
      text: _knockout.default.observable(),
      href: _knockout.default.observable()
    });
    (0, _defineProperty2.default)(this, "credentialsDetails", {
      text: 'View',
      click: this.onShowDetails.bind(this)
    });
    (0, _defineProperty2.default)(this, "accessDetails", null);
    this.table = table;
  }

  onShowDetails() {
    this.table.onShowAccessDetails(this.accessDetails);
  }

}

class NamespaceBucketS3AccessFormViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "columns", columns);
    (0, _defineProperty2.default)(this, "bucketName", '');
    (0, _defineProperty2.default)(this, "pathname", '');
    (0, _defineProperty2.default)(this, "accounts", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "sorting", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "accountCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "rows", _knockout.default.observableArray().ofType(AccountRowViewModel, {
      table: this
    }));
  }

  selectState(state, params) {
    return [params.bucket, state.accounts, state.location];
  }

  mapStateToProps(bucketName, accounts, location) {
    if (!accounts) {
      _knockout.default.assignToProps(this, {
        dataReady: false,
        bucketName,
        accountCount: 0
      });
    } else {
      const {
        sortBy = 'name',
        order = 1
      } = location.query;
      const {
        compareKey
      } = columns.find(column => column.name === sortBy) || columns[0];
      const baseRoute = (0, _browserUtils.realizeUri)(routes.account, {
        system: location.params.system
      }, {}, true);
      const filteredAccounts = Object.values(accounts).filter(account => account.allowedBuckets.includes(this.bucketName) && !account.roles.includes('operator'));

      _knockout.default.assignToProps(this, {
        dataReady: true,
        bucketName,
        accountCount: filteredAccounts.length,
        sorting: {
          sortBy,
          order: Number(order)
        },
        pathname: location.pathname,
        rows: filteredAccounts.sort((0, _coreUtils.createCompareFunc)(compareKey, order)).map(account => ({
          name: {
            text: account.name,
            href: (0, _browserUtils.realizeUri)(baseRoute, {
              account: account.name
            })
          },
          accessDetails: {
            endpoint: location.hostname,
            ...account.accessKeys
          }
        }))
      });
    }
  }

  onSort(sorting) {
    const query = _knockout.default.deepUnwrap(sorting);

    const url = (0, _browserUtils.realizeUri)(this.pathname, {}, query);
    this.dispatch((0, _actionCreators.requestLocation)(url));
  }

  onEditS3Access() {
    this.dispatch((0, _actionCreators.openBucketS3AccessModal)(this.bucketName));
  }

  onShowAccessDetails(accessDetails) {
    const {
      endpoint,
      accessKey,
      secretKey
    } = accessDetails;
    this.dispatch((0, _actionCreators.openS3AccessDetailsModal)(endpoint, accessKey, secretKey));
  }

}

var _default = {
  viewModel: NamespaceBucketS3AccessFormViewModel,
  template: _namespaceBucketS3AccessForm.default
};
exports.default = _default;

},{"./namespace-bucket-s3-access-form.html":650,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"components/connectable":446,"knockout":"knockout","routes":972,"utils/browser-utils":1021,"utils/core-utils":1027}],652:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"fill row\" ko.visible=\"!dataReady()\">\n    <loading-indicator class=\"align-middle greedy\" params=\"label: true\"></loading-indicator>\n</div>\n\n<div class=\"summary row greedy\" ko.css.visible=\"dataReady\">\n    <section class=\"c4 column card\">\n        <div class=\"greedy hpad row content-middle vpad\">\n            <svg-icon class=\"push-next\" params=\"name: state.name\" ko.css=\"state.css\">\n            </svg-icon>\n            <span class=\"heading3 greedy\" ko.text=\"state.tooltip\"></span>\n        </div>\n        <hr />\n        <div class=\"greedy hpad row content-middle vpad\">\n            <span class=\"c5 highlight push-next\">Write Policy:</span>\n            <span class=\"c7 text-right no-wrap\" ko.text=\"writePolicy\"></span>\n        </div>\n        <hr />\n        <div class=\"greedy hpad row content-middle vpad\">\n            <span class=\"c5 highlight push-next\">Read Policy:</span>\n            <span class=\"c7 text-right no-wrap\" ko.text=\"readPolicy\"></span>\n        </div>\n    </section>\n\n    <section class=\"c4 column card push-both\">\n        <h2 class=\"heading3 pad greedy row content-middle\">Bucket I/O Counters</h2>\n        <hr />\n        <div class=\"greedy hpad row content-middle vpad\">\n            <span class=\"c5 highlight push-next\">Total Reads:</span>\n            <span class=\"c7 text-right\" ko.text=\"readCount\"></span>\n        </div>\n        <hr />\n        <div class=\"greedy hpad row content-middle vpad\">\n            <span class=\"c5 highlight push-next\">Total Writes:</span>\n            <span class=\"c7 text-right\" ko.text=\"writeCount\"></span>\n        </div>\n    </section>\n\n    <section class=\"c4 column card\">\n        <div class=\"greedy hpad row content-middle vpad\">\n            <span class=\"c5 highlight push-next\">Bucket Type:</span>\n            <span class=\"c7 text-right\">Namespace Bucket</span>\n        </div>\n        <hr />\n        <div class=\"greedy hpad row content-middle vpad\">\n            <span class=\"c5 highlight push-next\">Last Read:</span>\n            <span class=\"c7 text-right\" ko.text=\"lastRead\"></span>\n        </div>\n        <hr />\n        <div class=\"greedy hpad row content-middle vpad\">\n            <span class=\"c5 highlight push-next\">Last Write:</span>\n            <span class=\"c7 text-right\" ko.text=\"lastWrite\"></span>\n        </div>\n    </section>\n</div>\n";

},{}],653:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _namespaceBucketSummary = _interopRequireDefault(require("./namespace-bucket-summary.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _moment = _interopRequireDefault(require("moment"));

var _config = require("config");

var _bucketUtils = require("utils/bucket-utils");

var _stringUtils = require("utils/string-utils");

var _numeral = _interopRequireDefault(require("numeral"));

/* Copyright (C) 2016 NooBaa */
class NamespaceBucketSummaryViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "state", {
      name: _knockout.default.observable(),
      css: _knockout.default.observable(),
      tooltip: _knockout.default.observable()
    });
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "writePolicy", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "readPolicy", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "readCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "writeCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "lastRead", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "lastWrite", _knockout.default.observable());
  }

  selectState(state, params) {
    const {
      namespaceBuckets: buckets
    } = state;
    return [buckets && buckets[params.bucket]];
  }

  mapStateToProps(bucket) {
    if (!bucket) {
      _knockout.default.assignToProps(this, {
        dataReady: false
      });
    } else {
      const {
        readFrom,
        writeTo
      } = bucket.placement;
      const state = (0, _bucketUtils.getNamespaceBucketStateIcon)(bucket);
      const readPolicyText = readFrom.length === 1 ? readFrom[0] : (0, _stringUtils.stringifyAmount)('resource', readFrom.length);
      const {
        lastRead,
        lastWrite,
        readCount,
        writeCount
      } = bucket.io;
      const lastReadText = lastRead >= 0 ? (0, _moment.default)(lastRead).format(_config.timeShortFormat) : 'Never Read';
      const lastWriteText = lastWrite >= 0 ? (0, _moment.default)(lastWrite).format(_config.timeShortFormat) : 'Never Written';

      _knockout.default.assignToProps(this, {
        dataReady: true,
        state: state,
        writePolicy: writeTo,
        readPolicy: readPolicyText,
        readCount: (0, _numeral.default)(readCount).format('0,0'),
        writeCount: (0, _numeral.default)(writeCount).format('0,0'),
        lastRead: lastReadText,
        lastWrite: lastWriteText
      });
    }
  }

}

var _default = {
  viewModel: NamespaceBucketSummaryViewModel,
  template: _namespaceBucketSummary.default
};
exports.default = _default;

},{"./namespace-bucket-summary.html":652,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"components/connectable":446,"config":831,"knockout":"knockout","moment":"moment","numeral":"numeral","utils/bucket-utils":1022,"utils/string-utils":1046}],654:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"row pad row content-middle card-shadow\">\n    <div class=\"column greedy push-next\">\n        <h3 class=\"heading3\">\n            Bucket Triggers\n        </h3>\n        <p>Triggers will automatically invoke selected function on the bucket.</p>\n    </div>\n    <button class=\"btn\" ko.click=\"onAddTrigger\">\n        Add Trigger\n    </button>\n</div>\n\n<data-table class=\"functions-table greedy\" params=\"\n    columns: columns,\n    sorting: ko.pc(sorting, onSort, $component),\n    data: rows,\n    loading: !dataReady(),\n    emptyMessage: 'No triggers configured for this bucket'\n\"></data-table>\n\n<paginator params=\"\n    itemCount: triggerCount,\n    pageSize: ko.pc(pageSize, onPageSize, $component),\n    page: ko.pc(page, onPage, $component)\n\"></paginator>\n\n\n";

},{}],655:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _namespaceBucketTriggersForm = _interopRequireDefault(require("./namespace-bucket-triggers-form.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _moment = _interopRequireDefault(require("moment"));

var _coreUtils = require("utils/core-utils");

var _browserUtils = require("utils/browser-utils");

var _bucketUtils = require("utils/bucket-utils");

var _config = require("config");

var _actionCreators = require("action-creators");

var routes = _interopRequireWildcard(require("routes"));

/* Copyright (C) 2016 NooBaa */
const columns = (0, _coreUtils.deepFreeze)([{
  name: 'state',
  type: 'icon',
  sortable: true,
  compareKey: trigger => trigger.enabled
}, {
  name: 'funcName',
  label: 'Function Name',
  type: 'link',
  sortable: true,
  compareKey: trigger => trigger.func.name
}, {
  name: 'event',
  label: 'Event Type',
  sortable: true,
  compareKey: trigger => trigger.event
}, {
  name: 'prefix',
  sortable: true,
  compareKey: trigger => trigger.prefix
}, {
  name: 'suffix',
  sortable: true,
  compareKey: trigger => trigger.suffix
}, {
  name: 'lastRun',
  label: 'Last Run',
  sortable: true,
  compareKey: trigger => trigger.lastRun || 0
}, {
  name: 'edit',
  label: '',
  type: 'iconButton'
}, {
  name: 'delete',
  label: '',
  type: 'delete'
}]);
const modeToStatus = (0, _coreUtils.deepFreeze)({
  DISABLED: {
    name: 'healthy',
    css: 'disabled',
    tooltip: 'Disabled'
  },
  MISSING_PERMISSIONS: {
    name: 'problem',
    css: 'warning',
    tooltip: 'Access issue'
  },
  OPTIMAL: {
    name: 'healthy',
    css: 'success',
    tooltip: 'Healthy'
  }
});

function _mapTriggerToRow(trigger, system, selectedForDelete) {
  const event = _bucketUtils.bucketEvents.find(event => event.value === trigger.event).label;

  const func = trigger.func.name;
  const funcName = {
    text: func,
    href: (0, _browserUtils.realizeUri)(routes.func, {
      system,
      func
    })
  };
  const lastRun = trigger.lastRun ? (0, _moment.default)(trigger.lastRun).fromNow() : '(never run)';
  return {
    state: modeToStatus[trigger.mode],
    funcName,
    event,
    prefix: trigger.prefix || '(not set)',
    suffix: trigger.suffix || '(not set)',
    lastRun,
    triggerId: trigger.id,
    delete: {
      active: selectedForDelete === trigger.id
    }
  };
}

class TriggerRowViewModel {
  constructor({
    table
  }) {
    (0, _defineProperty2.default)(this, "table", null);
    (0, _defineProperty2.default)(this, "state", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "funcName", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "event", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "prefix", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "suffix", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "lastRun", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "triggerId", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "edit", {
      id: this.triggerId,
      icon: 'edit',
      tooltip: 'Edit Trigger',
      onClick: id => this.table.onEditTrigger(id)
    });
    (0, _defineProperty2.default)(this, "delete", {
      text: 'Delete trigger',
      disabled: false,
      active: _knockout.default.observable(),
      id: this.triggerId,
      onToggle: id => this.table.onSelectForDelete(id),
      onDelete: id => this.table.onDeleteTrigger(id)
    });
    this.table = table;
  }

}

class NamespaceBucketTriggersFormViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "bucketName", '');
    (0, _defineProperty2.default)(this, "columns", columns);
    (0, _defineProperty2.default)(this, "pathname", '');
    (0, _defineProperty2.default)(this, "sorting", _knockout.default.observable({}));
    (0, _defineProperty2.default)(this, "page", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "pageSize", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "selectedForDelete", '');
    (0, _defineProperty2.default)(this, "triggerCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "rows", _knockout.default.observableArray().ofType(TriggerRowViewModel, {
      table: this
    }));
  }

  selectState(state, params) {
    return [params.bucket, state.bucketTriggers, state.location];
  }

  mapStateToProps(bucketName, triggers, location) {
    if (!triggers || location.params.tab !== 'triggers') {
      _knockout.default.assignToProps(this, {
        dataReady: false
      });
    } else {
      const bucketTriggers = Object.values(triggers).filter(trigger => {
        const {
          kind,
          name
        } = trigger.bucket;
        return kind === 'NAMESPACE_BUCKET' && name === bucketName;
      });
      const {
        params,
        query,
        pathname
      } = location;
      const {
        sortBy = 'funcName',
        selectedForDelete
      } = query;
      const page = Number(query.page) || 0;

      const pageSize = Number(query.pageSize) || _config.paginationPageSize.default;

      const order = Number(query.page) || 1;
      const {
        compareKey
      } = columns.find(column => column.name === sortBy);
      const pageStart = page * pageSize;
      const triggerList = Object.values(bucketTriggers);
      const rows = triggerList.sort((0, _coreUtils.createCompareFunc)(compareKey, order)).slice(pageStart, pageStart + pageSize).map(trigger => _mapTriggerToRow(trigger, params.system, selectedForDelete));

      _knockout.default.assignToProps(this, {
        dataReady: true,
        bucketName,
        triggerCount: triggerList.length,
        pathname,
        sorting: {
          sortBy,
          order
        },
        page,
        pageSize,
        selectedForDelete,
        rows: rows
      });
    }
  }

  onAddTrigger() {
    this.dispatch((0, _actionCreators.openAddBucketTriggerModal)(this.bucketName));
  }

  onEditTrigger(triggerId) {
    this.dispatch((0, _actionCreators.openEditBucketTriggerModal)('BUCKET', triggerId));
  }

  onDeleteTrigger(triggerId) {
    this.dispatch((0, _actionCreators.removeBucketTrigger)(this.bucketName, triggerId));
  }

  onSort(sorting) {
    this._query({ ...sorting,
      page: 0,
      selectedForDelete: null
    });
  }

  onPage(page) {
    this._query({
      page,
      selectedForDelete: null
    });
  }

  onPageSize(pageSize) {
    this._query({
      pageSize,
      page: 0,
      selectedForDelete: null
    });
  }

  onSelectForDelete(selected) {
    this._query({
      selectedForDelete: selected
    });
  }

  _query(params) {
    const {
      sortBy = this.sorting().sortBy,
      order = this.sorting().order,
      page = this.page(),
      pageSize = this.pageSize(),
      selectedForDelete = this.selectedForDelete
    } = params;
    const query = {
      sortBy,
      order,
      page,
      pageSize,
      selectedForDelete: selectedForDelete || undefined
    };
    this.dispatch((0, _actionCreators.requestLocation)((0, _browserUtils.realizeUri)(this.pathname, {}, query)));
  }

}

var _default = {
  viewModel: NamespaceBucketTriggersFormViewModel,
  template: _namespaceBucketTriggersForm.default
};
exports.default = _default;

},{"./namespace-bucket-triggers-form.html":654,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"components/connectable":446,"config":831,"knockout":"knockout","moment":"moment","routes":972,"utils/browser-utils":1021,"utils/bucket-utils":1022,"utils/core-utils":1027}],656:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<object-summary class=\"push-next\" params=\"\n    objectId: objectId,\n    fetchOwner: viewName\n\"></object-summary>\n\n<div class=\"tabs greedy\">\n    <nav>\n        <a ko.css.selected=\"selectedTab.eq('properties')\"\n            ko.attr.href=\"tabHref('properties')\"\n        >\n            Properties\n        </a>\n        <a ko.css.selected=\"selectedTab.eq('parts')\"\n            ko.attr.href=\"tabHref('parts')\"\n        >\n            Object Parts\n        </a>\n    </nav>\n\n    <div class=\"tabs-row\">\n        <object-properties class=\"tab column\"\n            ko.css.selected=\"selectedTab.eq('properties')\"\n            params=\"objectId: objectId, fetchOwner: viewName\"\n        ></object-properties>\n        <object-parts-list class=\"tab column\"\n            ko.css.selected=\"selectedTab.eq('parts')\"\n            params=\"objectId: objectId\"\n        ></object-parts-list>\n    </div>\n</div>\n";

},{}],657:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectPanel = _interopRequireDefault(require("./object-panel.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _browserUtils = require("utils/browser-utils");

var _objectUtils = require("utils/object-utils");

var _actionCreators = require("action-creators");

var _config = require("config");

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
class ObjectPanelViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "viewName", this.constructor.name);
    (0, _defineProperty2.default)(this, "baseRoute", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "objectId", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "selectedTab", _knockout.default.observable());
  }

  selectState(state) {
    return [state.location];
  }

  mapStateToProps(location) {
    const {
      route,
      params,
      query,
      hostname
    } = location;
    const {
      system,
      bucket,
      object,
      version,
      tab = 'properties'
    } = params;
    if (!object) return;

    _knockout.default.assignToProps(this, {
      baseRoute: (0, _browserUtils.realizeUri)(route, {
        system,
        bucket,
        object,
        version
      }, {}, true),
      selectedTab: tab,
      objectId: (0, _objectUtils.getObjectId)(bucket, object, version)
    }); // Load/update the object/object parts info.


    this._fetchObjectInfo(bucket, object, version, hostname, Number(query.page) || 0, Number(query.pageSize) || _config.paginationPageSize.default);
  }

  tabHref(tab) {
    const route = this.baseRoute();
    return route ? (0, _browserUtils.realizeUri)(route, {
      tab
    }) : '';
  }

  dispose() {
    this.dispatch((0, _actionCreators.dropObjectsView)(this.viewName));
    super.dispose();
  }

  _fetchObjectInfo(bucket, object, version, hostname, page, pageSize) {
    const fetchObjectAction = (0, _actionCreators.fetchObject)(this.viewName, bucket, object, version, hostname);
    const fetchObjectPartsAction = (0, _actionCreators.fetchObjectParts)({
      bucket,
      key: object,
      version,
      skip: page * pageSize,
      limit: pageSize
    });
    this.dispatch(fetchObjectAction, fetchObjectPartsAction);
  }

}

var _default = {
  viewModel: ObjectPanelViewModel,
  template: _objectPanel.default
};
exports.default = _default;

},{"./object-panel.html":656,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"config":831,"knockout":"knockout","utils/browser-utils":1021,"utils/object-utils":1037}],658:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"row content-middle card-shadow pad\">\n    <div class=\"column greedy push-next\">\n        <h3 class=\"heading3\">\n            Part count for this object:\n            {{partCount}}\n        </h3>\n        <span class=\"row\">\n            Data resiliency type: {{resilinecySummary}}\n            <vr class=\"push-both-half\"></vr>\n            Number of resources: {{resourceCount}}\n        </span>\n    </div>\n\n    <div class=\"column push-next\"\n        ko.tooltip=\"downloadTooltip\"\n        ko.visible=\"areActionsAllowed\"\n    >\n        <a class=\"btn\" download\n            ko.click=\"onDownloadClick\"\n            ko.attr.href=\"s3SignedUrl\" >\n            Download Object\n        </a>\n    </div>\n\n    <div ko.tooltip=\"previewTooltip\"\n        ko.visible=\"areActionsAllowed\"\n    >\n        <button class=\"btn\"\n            ko.click=\"onPreviewFile\">\n            Preview Object\n        </button>\n    </div>\n</div>\n\n<list-details class=\"greedy\"\n    params=\"\n        loading: !dataReady(),\n        rows: rows,\n        selected: ko.pc(selectedPart, onSelectPart, $component),\n        idSelector: row => row.seq,\n        buttonLabel: 'More Details'\n    \"\n>\n    <template name=\"row\">\n        <div class=\"row content-middle\">\n            <svg-icon class=\"push-next-half\"\n                ko.css=\"$item.state().css\"\n                ko.tooltip=\"$item.state().tooltip\"\n                params=\"name: $item.state().name\"\n            ></svg-icon>\n            {{$item.summary}}\n        </div>\n    </template>\n\n    <template name=\"details\">\n        <div class=\"column greedy hpad no-wrap\" ko.with=\"partDetails\">\n            <div class=\"row content-middle\">\n                <h2 class=\"heading3 greedy push-next\">Part {{partSeq}} Distribution Details</h2>\n                <button class=\"icon-btn no-focus-ring\" ko.click=\"onX\">\n                    <svg-icon class=\"icon-small\" params=\"name: 'x'\"></svg-icon>\n                </button>\n            </div>\n            <hr class=\"push-next-half\"/>\n            <div class=\"greedy pad-right block-tables\"\n                ko.css.fade-in=\"fade\"\n                ko.event.animationend=\"onAnimationEnd\"\n                ko.foreach=\"blockTables\"\n            >\n                <section class=\"column vpad\">\n                    <div class=\"row content-middle push-next-half\">\n                        <p class=\"row greedy push-next content-middle\">\n                            <span class=\"highlight push-next-half\">{{label}}:</span>\n                            {{policy}}\n\n                            <!-- ko with: storage -->\n                            <!-- ko if: tierIndex -->\n                            | Resides in tier {{tierIndex}}\n                            <!-- ko with: resources -->\n                            on\n                            <!-- ko if: $data.href -->\n                            <a class=\"tag link no-focus-ring row content-middle cursor-pointer push-prev-half\"\n                                ko.attr.href=\"href\"\n                            >\n                                <svg-icon class=\"icon-small highlight push-next-half\"\n                                    params=\"name: icon\"\n                                ></svg-icon>\n                                {{text}}\n                            </a>\n                            <!-- /ko -->\n                            <!-- ko ifnot: $data.href -->\n                            <span class=\"tag push-prev-half\" ko.tooltip=\"tooltip\">\n                                {{text}}\n                            </span>\n                            <!-- /ko -->\n\n                            <!-- /ko -->\n                            <!-- /ko -->\n                            <!-- /ko -->\n                        </p>\n                        <!-- ko if: tooltip -->\n                        <more-info-icon params=\"tooltip: tooltip\"></more-info-icon>\n                        <!-- /ko -->\n                    </div>\n\n                    <data-table class=\"content-box\" params=\"\n                        columns: columns,\n                        visibleColumns: visibleColumns,\n                        data: rows,\n                    \">\n                        <template name=\"marking\">\n                            <span class=\"tag\"\n                                ko.text=\"$data().text\"\n                                ko.tooltip=\"$data().tooltip\"\n                            ></span>\n                        </template>\n                    </data-table>\n                </section>\n            </div>\n        </div>\n    </template>\n</list-details>\n<hr>\n<paginator params=\"\n    itemCount: partCount,\n    pageSize: ko.pc(pageSize, onPageSize, $component),\n    page: ko.pc(page, onPage, $component)\n\"></paginator>\n";

},{}],659:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectPartsList = _interopRequireDefault(require("./object-parts-list.html"));

var _resourceListTooltip = _interopRequireDefault(require("./resource-list-tooltip.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _actionCreators = require("action-creators");

var _config = require("config");

var _browserUtils = require("utils/browser-utils");

var _resourceUtils = require("utils/resource-utils");

var _objectUtils = require("utils/object-utils");

var _bucketUtils = require("utils/bucket-utils");

var _sizeUtils = require("utils/size-utils");

var _stringUtils = require("utils/string-utils");

var _hostUtils = require("utils/host-utils");

var _numeral = _interopRequireDefault(require("numeral"));

var _knockout = _interopRequireDefault(require("knockout"));

var routes = _interopRequireWildcard(require("routes"));

var _coreUtils = require("utils/core-utils");

/* Copyright (C) 2016 NooBaa */
const partModeToState = (0, _coreUtils.deepFreeze)({
  UNAVAILABLE: {
    name: 'problem',
    css: 'error',
    tooltip: 'Unavailable'
  },
  BUILDING: {
    name: 'working',
    css: 'warning',
    tooltip: 'Rebuilding'
  },
  AVAILABLE: {
    name: 'healthy',
    css: 'success',
    tooltip: 'Healthy'
  }
});
const groupTooltips = (0, _coreUtils.deepFreeze)({
  'MIRROR_SET:REPLICAS:HOSTS': 'Replicas on nodes pool are distributed between the different nodes in the pool according to the configured policy parameters',
  'MIRROR_SET:FRAGMENTS:HOSTS': 'Fragments resides in nodes pool are distributed between the different nodes in the pool according to the configured policy parameters',
  'MIRROR_SET:REPLICAS:CLOUD': 'NooBaa considers cloud resource as resilient and keeps only one replica on this type of resource',
  'MIRROR_SET:FRAGMENTS:CLOUD': 'NooBaa considers cloud resource as resilient and keeps only data fragments on this type of resource',
  'INTERNAL_STORAGE_SET': 'While using the system internal storage, no parity fragments / replicas will be kept regardless of the configured policy parameters',
  'DELETE_SET': 'In a case of policy changes, data allocation might be changed and some replicas/ fragments will need to be removed'
});
const blocksTableColumns = (0, _coreUtils.deepFreeze)([{
  name: 'state',
  type: 'icon'
}, {
  name: 'replicas',
  prop: 'marking',
  type: 'marking',
  visibleFor: 'REPLICAS'
}, {
  name: 'fragments',
  prop: 'marking',
  type: 'marking',
  visibleFor: 'FRAGMENTS'
}, {
  name: 'mixed',
  prop: 'marking',
  type: 'marking',
  label: 'fragments / replicas',
  visibleFor: 'MIXED'
}, {
  name: 'resource',
  type: 'link',
  label: 'resource'
}]);
const blockModeToState = (0, _coreUtils.deepFreeze)({
  NOT_ACCESSIBLE: {
    name: 'problem',
    css: 'error',
    tooltip: 'Unavailable'
  },
  CANNOT_BE_DELETED: {
    name: 'problem',
    css: 'error',
    tooltip: 'Unavailable - Cannot be wipped'
  },
  WAITING_FOR_ALLOCATION: {
    name: 'working',
    css: 'warning',
    tooltip: 'Allocating'
  },
  WAITING_FOR_DELETE: {
    name: 'working',
    css: 'warning',
    tooltip: 'Wiping'
  },
  HEALTHY: {
    name: 'healthy',
    css: 'success',
    tooltip: 'Healthy'
  }
});
const specialStorageSets = ['INTERNAL_STORAGE_SET', 'DELETE_SET'];

const _compareGroupIds = (0, _coreUtils.createCompareFunc)(pair => {
  const [groupId] = pair;
  return specialStorageSets.indexOf(groupId);
});

function _summrizeResiliency(resiliency) {
  const {
    kind,
    replicas,
    dataFrags,
    parityFrags
  } = resiliency;
  const counts = kind === 'ERASURE_CODING' ? [dataFrags, parityFrags].join(' + ') : replicas;
  return `${(0, _bucketUtils.getResiliencyTypeDisplay)(kind)} (${counts})`;
}

function _getActionsTooltip(isOwner, httpsNoCert, verb, align) {
  if (!isOwner) {
    return {
      text: `${(0, _stringUtils.capitalize)(verb)} is only available for the system owner`,
      align: align
    };
  }

  if (httpsNoCert) {
    return {
      text: `A certificate must be installed in order to ${verb} the file via https`,
      align: align
    };
  }

  return '';
}

function _formatBlockTypeCounters(counters, seperator = ', ') {
  const {
    REPLICA: replicas = 0,
    DATA: dataFrags = 0,
    PARITY: parityFrags = 0,
    IN_PROCESS: inProcess = 0
  } = counters;
  const parts = [];

  if (replicas > 0) {
    parts.push((0, _stringUtils.stringifyAmount)('Replica', replicas));
  }

  if (dataFrags > 0) {
    parts.push((0, _stringUtils.stringifyAmount)('Data Fragment', dataFrags));
  }

  if (parityFrags > 0) {
    parts.push((0, _stringUtils.stringifyAmount)('Parity Fragment', parityFrags));
  }

  if (inProcess > 0) {
    parts.push(`${(0, _stringUtils.stringifyAmount)('Block', inProcess)} in process`);
  }

  return parts.join(seperator);
}

function _mapPartToRow(part) {
  const formattedSeq = (0, _numeral.default)(part.seq + 1).format(',');
  const size = (0, _sizeUtils.formatSize)(part.size);

  const distribution = _formatBlockTypeCounters((0, _coreUtils.countBy)(part.blocks, block => block.mode.startsWith('WAITING') ? 'IN_PROCESS' : block.kind));

  return {
    seq: String(part.seq),
    state: partModeToState[part.mode],
    summary: `Part ${formattedSeq} | ${size} | ${distribution}`
  };
}

function _getBlockGroupId(block) {
  const {
    mode,
    storage,
    mirrorSet
  } = block;
  return mode === 'WAITING_FOR_DELETE' && 'DELETE_SET' || mode === 'CANNOT_BE_DELETED' && 'DELETE_SET' || storage.kind === 'INTERNAL_STORAGE' && 'INTERNAL_STORAGE_SET' || mirrorSet;
}

function _getGroupTooltip(groupId, blockType, storageType) {
  const parts = [specialStorageSets.includes(groupId) ? groupId : 'MIRROR_SET'];

  if (parts[0] === 'MIRROR_SET') {
    parts.push(blockType, storageType);
  }

  const text = groupTooltips[parts.join(':')];

  if (text) {
    return {
      text,
      align: 'end'
    };
  }
}

function _getResourceInfo(resource, cloudTypeMapping, system) {
  const {
    type,
    name
  } = resource;

  switch (type) {
    case 'HOSTS':
      {
        return {
          icon: 'nodes-pool',
          text: name,
          href: (0, _browserUtils.realizeUri)(routes.pool, {
            system,
            pool: name
          })
        };
      }

    case 'CLOUD':
      {
        const cloudType = cloudTypeMapping[name];
        return {
          icon: (0, _resourceUtils.getCloudResourceTypeIcon)({
            type: cloudType
          }).name,
          text: name,
          href: (0, _browserUtils.realizeUri)(routes.cloudResource, {
            system,
            resource: name
          })
        };
      }
  }
}

function _getStorageSummary(tierIndex, resources, system, cloudTypeMapping) {
  if (tierIndex === -1) {
    return {
      tierIndex: 0,
      resources: null
    };
  } else if (resources.length === 0) {
    return {
      tierIndex: tierIndex + 1,
      resources: null
    };
  } else if (resources.length === 1) {
    return {
      tierIndex: tierIndex + 1,
      resources: _getResourceInfo(resources[0], cloudTypeMapping, system)
    };
  } else {
    return {
      tierIndex: tierIndex + 1,
      resources: {
        text: (0, _stringUtils.stringifyAmount)('resource', resources.length),
        tooltip: {
          template: _resourceListTooltip.default,
          text: resources.map(res => _getResourceInfo(res, cloudTypeMapping, system))
        }
      }
    };
  }
}

function _getGroupBlocksType(blockTypeCounters) {
  const {
    REPLICA = 0,
    DATA = 0,
    PARITY = 0
  } = blockTypeCounters;
  return REPLICA === 0 && 'FRAGMENTS' || DATA + PARITY === 0 && 'REPLICAS' || 'MIXED';
}

function _listUsedResources(blocks) {
  const map = blocks.reduce((map, block) => {
    const {
      kind,
      pool,
      resource
    } = block.storage;

    if (kind === 'HOSTS' || kind === 'CLOUD') {
      const type = kind;
      const name = kind === 'HOSTS' ? pool : resource;
      const key = `${type}:${name}`;

      if (!map.has(key)) {
        map.set(key, {
          name,
          type
        });
      }
    }

    return map;
  }, new Map());
  return Array.from(map.values());
}

function _getGroupLabel(groupId, groupIndex) {
  return false || groupId === 'DELETE_SET' && 'To be removed' || groupId === 'INTERNAL_STORAGE_SET' && 'Internal storage' || `Mirror set ${groupIndex + 1}`;
}

function _getBlockMarking(block) {
  switch (block.kind) {
    case 'REPLICA':
      {
        return {
          text: 'R',
          tooltip: 'Replica'
        };
      }

    case 'DATA':
      {
        const digit = block.seq + 1;
        return {
          text: `D${digit}`,
          tooltip: `Data Fragment ${digit}`
        };
      }

    case 'PARITY':
      {
        const digit = block.seq + 1;
        return {
          text: `P${digit}`,
          tooltip: `Parity Fragment ${digit}`
        };
      }
  }

  const letter = block.kind[0];
  const digit = block.seq == null ? '' : block.seq + 1;
  return `${letter}${digit}`;
}

function _getBlockResource(block, system) {
  const {
    kind,
    resource,
    pool,
    host
  } = block.storage;

  switch (kind) {
    case 'HOSTS':
      {
        const text = (0, _hostUtils.getHostDisplayName)(host);
        const href = (0, _browserUtils.realizeUri)(routes.host, {
          system,
          pool,
          host
        });
        return {
          text,
          href
        };
      }

    case 'CLOUD':
      {
        const text = resource;
        const href = (0, _browserUtils.realizeUri)(routes.cloudResource, {
          system,
          resource
        });
        return {
          text,
          href
        };
      }

    case 'INTERNAL_STORAGE':
      {
        return {
          text: 'Internal Storage'
        };
      }

    case 'NOT_ALLOCATED':
      {
        return {
          text: 'Searching for resource'
        };
      }
  }
}

function _mapBlockToRow(block, system) {
  return {
    state: blockModeToState[block.mode],
    marking: _getBlockMarking(block),
    resource: _getBlockResource(block, system)
  };
}

function _mapBlocksToTables(blocks, placement, cloudTypeMapping, system) {
  const groups = (0, _coreUtils.groupBy)(blocks, _getBlockGroupId);
  return Object.entries(groups).sort(_compareGroupIds).map(([groupId, blocks], i) => {
    const blockTypeCounters = (0, _coreUtils.countBy)(blocks, block => block.kind);

    const blockType = _getGroupBlocksType(blockTypeCounters);

    const blockStorageType = blocks[0].storage.kind;

    const resources = _listUsedResources(blocks);

    const tierIndex = placement.tiers.findIndex(tier => (tier.mirrorSets || []).some(ms => ms.name === groupId));
    const visibleColumns = blocksTableColumns.filter(column => !column.visibleFor || column.visibleFor === blockType).map(column => column.name);

    const label = _getGroupLabel(groupId, i);

    const policy = _formatBlockTypeCounters(blockTypeCounters);

    const tooltip = _getGroupTooltip(groupId, blockType, blockStorageType);

    const storage = _getStorageSummary(tierIndex, resources, system, cloudTypeMapping);

    const rows = blocks.map(block => _mapBlockToRow(block, system));
    return {
      visibleColumns,
      label,
      policy,
      tooltip,
      storage,
      rows
    };
  });
}

function _mapPartDetails(part, placement, cloudTypeMapping, system) {
  if (!part) {
    return;
  }

  return {
    fade: true,
    partSeq: (0, _numeral.default)(part.seq + 1).format(','),
    blockTables: _mapBlocksToTables(part.blocks, placement, cloudTypeMapping, system)
  };
}

class PartRowViewModel {
  constructor() {
    (0, _defineProperty2.default)(this, "seq", '');
    (0, _defineProperty2.default)(this, "state", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "summary", _knockout.default.observable());
  }

}

class BlockRowViewModel {
  constructor() {
    (0, _defineProperty2.default)(this, "state", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "marking", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "resource", _knockout.default.observable());
  }

}

class BlocksTableViewModel {
  constructor() {
    (0, _defineProperty2.default)(this, "columns", blocksTableColumns);
    (0, _defineProperty2.default)(this, "visibleColumns", _knockout.default.observableArray());
    (0, _defineProperty2.default)(this, "label", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "policy", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "tooltip", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "storage", {
      visible: _knockout.default.observable(),
      tierIndex: _knockout.default.observable(),
      resources: _knockout.default.observable()
    });
    (0, _defineProperty2.default)(this, "rows", _knockout.default.observableArray().ofType(BlockRowViewModel));
  }

}

class PartDetailsViewModel {
  constructor({
    list
  }) {
    (0, _defineProperty2.default)(this, "list", null);
    (0, _defineProperty2.default)(this, "fade", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "partSeq", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "blockTables", _knockout.default.observableArray().ofType(BlocksTableViewModel));
    this.list = list;
  }

  onAnimationEnd() {
    this.fade(false);
  }

  onX() {
    this.list.onCloseDetails();
  }

}

class ObjectPartsListViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "pathname", '');
    (0, _defineProperty2.default)(this, "selectedPart", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "page", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "pageSize", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "s3SignedUrl", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "partCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "placementType", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "resilinecySummary", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "resourceCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "downloadTooltip", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "previewTooltip", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isPaneExpanded", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "areActionsAllowed", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "actionsTooltip", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "partDetails", _knockout.default.observable().ofType(PartDetailsViewModel, {
      list: this
    }));
    (0, _defineProperty2.default)(this, "rows", _knockout.default.observableArray().ofType(PartRowViewModel));
  }

  selectState(state, params) {
    const {
      bucket: bucketName
    } = (0, _objectUtils.splitObjectId)(params.objectId);
    const {
      location,
      buckets,
      objects,
      objectParts,
      cloudResources,
      accounts,
      system
    } = state;
    return [location, buckets && buckets[bucketName], objects && objects.items[params.objectId], objectParts && objectParts.items, cloudResources, accounts && accounts[state.session.user], system && system.sslCert.installed];
  }

  mapStateToProps(location, bucket, object, parts, cloudResources, user, sslCert) {
    if (!parts || !user || !bucket || !object) {
      _knockout.default.assignToProps(this, {
        dataReady: false,
        partCount: 0,
        placementType: '',
        resilinecySummary: '',
        resourceCount: '',
        areActionsAllowed: false
      });
    } else {
      const {
        params,
        query,
        protocol,
        pathname
      } = location;
      const httpsNoCert = protocol === 'https' && !sslCert;
      const selectedPart = query.part || '';
      const cloudTypeMapping = (0, _coreUtils.mapValues)(cloudResources, res => res.type);
      const resourceCount = bucket.placement.tiers.reduce((count, tier) => count + (tier.mirrorSets || []).reduce((count, ms) => count + ms.resources.length, 0), 0);

      _knockout.default.assignToProps(this, {
        dataReady: true,
        pathname: pathname,
        s3SignedUrl: object.s3SignedUrl,
        partCount: object.partCount,
        resilinecySummary: _summrizeResiliency(bucket.resiliency),
        resourceCount: resourceCount,
        downloadTooltip: _getActionsTooltip(user.isOwner, httpsNoCert, 'download'),
        previewTooltip: _getActionsTooltip(user.isOwner, httpsNoCert, 'preview', 'end'),
        page: Number(query.page) || 0,
        pageSize: Number(query.pageSize) || _config.paginationPageSize.default,
        areActionsAllowed: user.isOwner && !httpsNoCert,
        rows: parts.map(_mapPartToRow),
        selectedPart: selectedPart,
        partDetails: _mapPartDetails(parts.find(part => selectedPart === String(part.seq)), bucket.placement, cloudTypeMapping, params.system)
      });
    }
  }

  onPreviewFile() {
    this.dispatch((0, _actionCreators.openObjectPreviewModal)(this.s3SignedUrl()));
  }

  onDownloadClick() {
    // If action are not allowed we prevent the default action
    // on the download link.
    return this.areActionsAllowed();
  }

  onSelectPart(part) {
    this._query({
      part
    });
  }

  onPage(page) {
    this._query({
      page,
      part: ''
    });
  }

  onPageSize(pageSize) {
    this._query({
      pageSize,
      page: 0,
      part: ''
    });
  }

  onCloseDetails() {
    this._query({
      part: ''
    });
  }

  _query(query) {
    const {
      part = this.selectedPart(),
      page = this.page(),
      pageSize = this.pageSize()
    } = query;
    const url = (0, _browserUtils.realizeUri)(this.pathname, null, {
      part: part !== '' ? part : undefined,
      page,
      pageSize
    });
    this.dispatch((0, _actionCreators.requestLocation)(url));
  }

}

var _default = {
  viewModel: ObjectPartsListViewModel,
  template: _objectPartsList.default
};
exports.default = _default;

},{"./object-parts-list.html":658,"./resource-list-tooltip.html":660,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"components/connectable":446,"config":831,"knockout":"knockout","numeral":"numeral","routes":972,"utils/browser-utils":1021,"utils/bucket-utils":1022,"utils/core-utils":1027,"utils/host-utils":1032,"utils/object-utils":1037,"utils/resource-utils":1041,"utils/size-utils":1043,"utils/string-utils":1046}],660:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<ul class=\"list-no-style column\" ko.foreach=\"$data\">\n    <li class=\"row content-middle\" ko.css=\"{ 'push-prev-half': $index() > 0 }\">\n        <svg-icon class=\"icon-small highlight push-next-half\" params=\"name: icon\">\n        </svg-icon>\n        <!-- ko if: href -->\n        <a class=\"link greedy no-wrap\" ko.attr.href=\"href\" ko.text=\"text\"></a>\n        <!-- /ko -->\n        <!-- ko ifnot: href -->\n        <span class=\"highlight greddy no-wrap\" ko.text=\"text\"></span>\n        <!-- /ko -->\n    </li>\n</ul>\n";

},{}],661:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"row content-middle card-shadow pad\">\n    <h3 class=\"heading3 greedy\">\n        Object Properties\n    </h3>\n    <!-- ko if: isBucketVersioned -->\n    <div class=\"heading3 push-next\">Version:</div>\n    <dropdown params=\"\n        placeholder: 'Loading versions...',\n        options: versionsOptions,\n        loading: !versionsLoaded(),\n        selected: ko.pc(selectedVersion, onSelectVersion, $component)\n    \"></dropdown>\n    <!-- /ko -->\n</div>\n<property-sheet class=\"pad\" params=\"\n    properties: properties,\n    loading: !dataReady()\n\"></property-sheet>\n";

},{}],662:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectProperties = _interopRequireDefault(require("./object-properties.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _bucketUtils = require("utils/bucket-utils");

var _objectUtils = require("utils/object-utils");

var _browserUtils = require("utils/browser-utils");

var _coreUtils = require("utils/core-utils");

var _knockout = _interopRequireDefault(require("knockout"));

var _moment = _interopRequireDefault(require("moment"));

var _numeral = _interopRequireDefault(require("numeral"));

var _config = require("config");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _getVersionLabel(object) {
  const {
    deleteMarker,
    latestVersion
  } = object;
  const versionId = (0, _objectUtils.formatVersionId)(object.versionId);
  return true && deleteMarker && `${versionId} (Delete marker)` || latestVersion && `${versionId} (Latest version)` || versionId;
}

function _mapVersionsOptions(versions, location) {
  if (!versions) {
    return [];
  }

  return versions.map(version => {
    const {
      versionId,
      createTime,
      deleteMarker
    } = version;
    return {
      value: (0, _browserUtils.realizeUri)(location.route, { ...location.params,
        version: versionId
      }),
      label: _getVersionLabel(version),
      disabled: deleteMarker,
      remark: (0, _moment.default)(createTime).format(_config.timeShortFormat)
    };
  });
}

class ObjectPropertiesViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isBucketVersioned", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "versionsLoaded", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "versionsOptions", _knockout.default.observableArray());
    (0, _defineProperty2.default)(this, "selectedVersion", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "properties", [{
      label: 'Object name',
      value: _knockout.default.observable()
    }, {
      label: 'Content type',
      value: _knockout.default.observable()
    }, {
      label: 'Last Modified',
      value: _knockout.default.observable()
    }, {
      label: 'Last read time',
      value: _knockout.default.observable()
    }, {
      label: 'Number of reads',
      value: _knockout.default.observable()
    }, {
      label: 'File\'s bucket versioning',
      value: _knockout.default.observable()
    }, {
      label: 'Number of versions',
      visible: _knockout.default.observable(),
      value: _knockout.default.observable()
    }, {
      label: 'Version ID',
      visible: _knockout.default.observable(),
      value: _knockout.default.observable()
    }]);
    (0, _defineProperty2.default)(this, "selectVersions", (0, _coreUtils.memoize)((objects, queryOwner) => {
      const query = objects.queries[objects.views[queryOwner]];
      if (!query || !query.result) return null;
      return query.result.items.map(objId => objects.items[objId]).sort((v1, v2) => v2.createTime - v1.createTime);
    }));
  }

  selectState(state, params) {
    const {
      location,
      buckets = {},
      objects = {}
    } = state;
    const {
      bucket: bucketName
    } = (0, _objectUtils.splitObjectId)(params.objectId);
    return [location, buckets[bucketName], objects.items[params.objectId], this.selectVersions(objects, params.fetchOwner)];
  }

  mapStateToProps(location, bucket, object, versions) {
    if (!bucket || !object) {
      _knockout.default.assignToProps(this, {
        objectLoaded: false
      });
    } else {
      const versionCount = versions ? (0, _numeral.default)(versions.length).format(',') : 'calculating...';
      const bucketVersioningMode = bucket.versioning.mode;
      const isBucketVersioned = bucketVersioningMode !== 'DISABLED';

      _knockout.default.assignToProps(this, {
        dataReady: true,
        isBucketVersioned,
        versionsLoaded: Boolean(versions),
        versionsOptions: _mapVersionsOptions(versions, location),
        selectedVersion: location.pathname,
        properties: [{
          value: object.key
        }, {
          value: object.contentType
        }, {
          value: (0, _moment.default)(object.createTime).format(_config.timeShortFormat)
        }, {
          value: object.lastReadTime ? (0, _moment.default)(object.lastReadTime) : 'Not read yet'
        }, {
          value: (0, _numeral.default)(object.readCount).format(',')
        }, {
          value: (0, _bucketUtils.getVersioningStateText)(bucketVersioningMode)
        }, {
          value: versionCount,
          visible: isBucketVersioned
        }, {
          value: _getVersionLabel(object),
          visible: isBucketVersioned
        }]
      });
    }
  }

  onSelectVersion(versionUrl) {
    this.dispatch((0, _actionCreators.requestLocation)(versionUrl));
  }

}

var _default = {
  viewModel: ObjectPropertiesViewModel,
  template: _objectProperties.default
};
exports.default = _default;

},{"./object-properties.html":661,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"config":831,"knockout":"knockout","moment":"moment","numeral":"numeral","utils/browser-utils":1021,"utils/bucket-utils":1022,"utils/core-utils":1027,"utils/object-utils":1037}],663:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"fill row\" ko.visible=\"!dataReady()\">\n    <loading-indicator class=\"align-middle greedy\" params=\"label: true\"></loading-indicator>\n</div>\n\n<div class=\"row summary\" ko.css.visible=\"dataReady\">\n    <section class=\"c3 column card\">\n        <div class=\"hpad greedy row content-middle\">\n            <span class=\"c5 highlight push-next\">Bucket name:</span>\n            <span class=\"c7 text-right break-words\" ko.text=\"bucketName\"></span>\n        </div>\n        <hr />\n        <div class=\"hpad greedy row content-middle\">\n            <span class=\"c5 highlight push-next\">Content-Type:</span>\n            <span class=\"c7 text-right break-words\" ko.text=\"contentType\"></span>\n        </div>\n    </section>\n\n    <section class=\"c6 column push-both content-middle\">\n        <div class=\"row greedy\">\n            <chart-legend class=\"pad\" params=\"\n                items: legend,\n                caption: 'Object Size',\n                format: 'size'\n            \"></chart-legend>\n\n            <chartjs class=\"size-chart align-stretch\" params=\"\n                type: 'bar',\n                options: chart.options,\n                data: chart.data,\n                emptyMessage: 'Object Size Not Available'\n            \"></chartjs>\n        </div>\n    </section>\n\n    <section class=\"c3 column card\">\n        <div class=\"hpad greedy row content-middle\">\n            <span class=\"c5 highlight push-next\">Creation time:</span>\n            <span class=\"c7 text-right\" ko.text=\"creationTime\"></span>\n        </div>\n        <hr />\n        <div class=\"hpad greedy row content-middle\" ko.visible=\"isVersioningOn\">\n            <span class=\"c5 highlight push-next\">Version ID:</span>\n            <span class=\"c7 text-right\" ko.text=\"versionId\"></span>\n        </div>\n        <div class=\"hpad greedy row content-middle\" ko.visible=\"!isVersioningOn()\">\n            <span class=\"c5 highlight push-next\">Last read time:</span>\n            <span class=\"c7 text-right\" ko.text=\"lastReadTime\"></span>\n        </div>\n        <hr />\n        <div class=\"hpad greedy row content-middle\" ko.visible=\"isVersioningOn\">\n            <span class=\"c5 highlight push-next\">Num of Versions:</span>\n            <span class=\"c7 text-right\" ko.text=\"versionCount\"></span>\n        </div>\n        <div class=\"hpad greedy row content-middle\" ko.visible=\"!isVersioningOn()\">\n            <span class=\"c5 highlight push-next\">Read count:</span>\n            <span class=\"c7 text-right\" ko.text=\"readCount\"></span>\n        </div>\n    </section>\n</div>\n";

},{}],664:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectSummary = _interopRequireDefault(require("./object-summary.html"));

var _knockout = _interopRequireDefault(require("knockout"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _sizeUtils = require("utils/size-utils");

var _objectUtils = require("utils/object-utils");

var _config = require("config");

var _moment = _interopRequireDefault(require("moment"));

var _numeral = _interopRequireDefault(require("numeral"));

var _themes = _interopRequireDefault(require("themes"));

/* Copyright (C) 2016 NooBaa */
class ObjectSummaryViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "bucketName", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isVersioningOn", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "versionId", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "versionCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "contentType", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "creationTime", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "lastReadTime", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "readCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "originalSize", {
      color: _knockout.default.observable(),
      value: _knockout.default.observable()
    });
    (0, _defineProperty2.default)(this, "actualSize", {
      color: _knockout.default.observable(),
      value: _knockout.default.observable()
    });
    (0, _defineProperty2.default)(this, "legend", [{
      label: 'Original Size',
      color: this.originalSize.color,
      tooltip: 'The original size of the object as written prior to optimization or data resiliency',
      value: this.originalSize.value
    }, {
      label: 'Actual Used Storage',
      color: this.actualSize.color,
      tooltip: 'The actual raw usage of this object includes the data resiliency replications or fragments after compression',
      value: this.actualSize.value
    }]);
    (0, _defineProperty2.default)(this, "chart", {
      options: {
        maintainAspectRatio: false,
        scales: {
          xAxes: [{
            categoryPercentage: .7,
            barPercentage: .8,
            display: false
          }],
          yAxes: [{
            gridLines: {
              color: 'transparent',
              drawTicks: false
            },
            ticks: {
              callback: () => ''
            }
          }]
        },
        tooltips: {
          enabled: false
        }
      },
      data: {
        labels: [],
        datasets: [{
          backgroundColor: this.originalSize.color,
          hoverBackgroundColor: this.originalSize.color,
          data: [this.originalSize.value]
        }, {
          backgroundColor: this.actualSize.color,
          hoverBackgroundColor: this.actualSize.color,
          data: [this.actualSize.value]
        }]
      }
    });
  }

  selectState(state, params) {
    const {
      buckets = {},
      objects = {},
      session
    } = state;
    const {
      bucket: bucketName
    } = (0, _objectUtils.splitObjectId)(params.objectId);
    const query = objects.queries[objects.views[params.fetchOwner]];
    const versionCount = query && query.result ? query.result.items.length : NaN;
    return [buckets[bucketName], objects.items[params.objectId], versionCount, _themes.default[session.uiTheme]];
  }

  mapStateToProps(bucket, object, versionCount, theme) {
    if (!bucket || !object) {
      _knockout.default.assignToProps(this, {
        dataReady: false
      });
    } else {
      const {
        original,
        onDisk
      } = object.size;
      const hasOnDiskSize = Boolean(onDisk);

      _knockout.default.assignToProps(this, {
        dataReady: true,
        isVersioningOn: bucket.versioning.mode !== 'DISABLED',
        versionId: (0, _objectUtils.formatVersionId)(object.versionId),
        versionCount: Number.isNaN(versionCount) ? 'calculating...' : (0, _numeral.default)(versionCount).format(','),
        bucketName: bucket.name,
        contentType: object.contentType,
        creationTime: (0, _moment.default)(object.createTime).format(_config.timeShortFormat),
        lastReadTime: object.lastReadTime ? (0, _moment.default)(object.lastRead).format(_config.timeShortFormat) : 'File not read',
        readCount: (0, _numeral.default)(object.readCount).format(','),
        originalSize: {
          value: hasOnDiskSize ? (0, _sizeUtils.toBytes)(original) : 0,
          color: theme.color20
        },
        actualSize: {
          value: hasOnDiskSize ? (0, _sizeUtils.toBytes)(onDisk) : 0,
          color: theme.color28
        }
      });
    }
  }

}

var _default = {
  viewModel: ObjectSummaryViewModel,
  template: _objectSummary.default
};
exports.default = _default;

},{"./object-summary.html":663,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"components/connectable":446,"config":831,"knockout":"knockout","moment":"moment","numeral":"numeral","themes":1018,"utils/object-utils":1037,"utils/size-utils":1043}],665:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<!-- ko if: dataReady -->\n<section class=\"card greedy\">\n    <div class=\"hpad pad-half row\">\n        <svg-icon class=\"icon-small push-next-half\"\n            ko.tooltip=\"alertsTooltip\"\n            ko.css=\"alertsIcon().css\"\n            params=\"name: alertsIcon().name\"\n        ></svg-icon>\n        <span class=\"greedy highlight\">Alerts</span>\n        <button class=\"link\" ko.click=\"onViewAlerts\">View Alerts</button>\n    </div>\n    <hr>\n    <div class=\"pad greedy\">\n        <p>{{alertsSummary}}</p>\n    </div>\n</section>\n<!-- /ko -->\n";

},{}],666:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _alertsOverview = _interopRequireDefault(require("./alerts-overview.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _stringUtils = require("utils/string-utils");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
class AlertsOverviewViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "alertsIcon", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "alertsTooltip", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "alertsSummary", _knockout.default.observable());
  }

  selectState(state) {
    // Using the system for indication that we got enough information in order to delay the
    // rendering untill the component in the overview can render
    return [Boolean(state.system), state.alerts.unreadCounts];
  }

  mapStateToProps(systemLoaded, unreadAlertsCounters) {
    if (!systemLoaded) {
      _knockout.default.assignToProps(this, {
        dataReady: false
      });
    } else {
      const {
        crit,
        major,
        info
      } = unreadAlertsCounters;
      const alertsSummary = (0, _stringUtils.stringifyAmount)('unread critical alert', crit, 'No');
      const alertsIcon = crit ? {
        name: 'problem',
        css: 'error'
      } : {
        name: 'healthy',
        css: 'success'
      };
      const alertsTooltip = {
        template: 'listWithCaption',
        text: {
          title: 'Uread alerts',
          list: [`${crit} Critical`, `${major} Important`, `${info} Minor`]
        }
      };

      _knockout.default.assignToProps(this, {
        dataReady: true,
        alertsIcon,
        alertsTooltip,
        alertsSummary
      });
    }
  }

  onViewAlerts() {
    this.dispatch((0, _actionCreators.openAlertsDrawer)('CRIT', true));
  }

}

var _default = {
  viewModel: AlertsOverviewViewModel,
  template: _alertsOverview.default
};
exports.default = _default;

},{"./alerts-overview.html":665,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout","utils/string-utils":1046}],667:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<section class=\"card-bg card-shadow column content-middle greedy pad\" pad>\n    <!-- ko ifnot: dataLoaded -->\n    <loading-indicator class=\"align-middle push-prev\"></loading-indicator>\n    <!-- /ko -->\n\n    <!-- ko if: dataLoaded -->\n    <svg-icon class=\"circled-icon push-next-half\"\n        params=\"name: 'buckets'\"\n    ></svg-icon>\n    <h2 class=\"heading2\">Object Buckets</h2>\n    <a class=\"heading3 link push-next\" ko.attr.href=\"bucketsLinkHref\">\n        {{bucketsLinkText}}\n    </a>\n\n    <div class=\"align-start highlight push-next-half\">\n        Buckets Raw Usage\n    </div>\n\n    <chart-legend class=\"align-stretch push-next-half\" params=\"\n        items: usedValues,\n        format: 'size'\n    \"></chart-legend>\n\n    <toggle-group class=\"toggle-light align-end\" params=\"\n        options: durationOptions,\n        selected: ko.pc(selectedDuration, onSelectDuration, $component)\n    \"></toggle-group>\n\n    <chartjs class=\"greedy usage-chart push-next\" params=\"\n        type: 'line',\n        options: chartParams().options,\n        data: chartParams().data,\n        emptyMessage: emptyChartMessage\n    \"></chartjs>\n\n\n    <button class=\"btn overview-btn\" ko.click=\"onConnectApplication\">\n        Connect Application\n    </button>\n    <!-- /ko -->\n</section>\n\n\n";

},{}],668:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _observer = _interopRequireDefault(require("observer"));

var _bucketsOverview = _interopRequireDefault(require("./buckets-overview.html"));

var _browserUtils = require("utils/browser-utils");

var _stringUtils = require("utils/string-utils");

var _coreUtils = require("utils/core-utils");

var _sizeUtils = require("utils/size-utils");

var _colorUtils = require("utils/color-utils");

var _state = require("state");

var routes = _interopRequireWildcard(require("routes"));

var _knockout = _interopRequireDefault(require("knockout"));

var _moment = _interopRequireDefault(require("moment"));

var _themes = _interopRequireDefault(require("themes"));

var _rxExtensions = require("rx-extensions");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const minRedrawInterval = 5000;
const durations = (0, _coreUtils.deepFreeze)({
  DAY: {
    label: 'Day',
    timespan: 24,
    stepSize: 4,
    stepUnit: 'hour',
    tickFormat: 'HH:mm',
    points: true
  },
  WEEK: {
    label: 'Week',
    timespan: 7,
    stepSize: 1,
    stepUnit: 'day',
    tickFormat: 'D MMM',
    points: false
  },
  MONTH: {
    label: 'Month',
    timespan: 30,
    stepSize: 6,
    stepUnit: 'day',
    tickFormat: 'D MMM',
    points: false
  }
});
const chartDatasets = (0, _coreUtils.deepFreeze)([{
  key: 'hosts',
  label: 'Used on Nodes',
  labelPadding: 10,
  color: 'color17'
}, {
  key: 'cloud',
  label: 'Used on Cloud',
  labelPadding: 10,
  color: 'color20'
}, {
  key: 'internal',
  label: 'Used on Internal',
  labelPadding: 10,
  color: 'color28'
}]);

const firstSampleHideDuration = _moment.default.duration(1, 'hours').asMilliseconds();

function _isInternalSotrageUsed(internalStorage, buckets) {
  if (internalStorage.used > 0) {
    return true;
  }

  if (Object.values(buckets).some(bucket => bucket.placement.tiers[0].policyType === 'INTERNAL_STORAGE')) {
    return true;
  }

  return false;
}

function _getChartEmptyMessage(showSamples, samples, selectedDatasets) {
  if (!selectedDatasets.length) return 'No resources selected for display';
  if (!showSamples) return 'Not enough usage history to display';
  const datasetKeys = selectedDatasets.map(set => set.key);
  const sum = (0, _sizeUtils.sumSize)(...(0, _coreUtils.flatMap)(datasetKeys, key => samples.map(sample => sample[key])));
  return (0, _sizeUtils.toBytes)(sum) === 0 ? 'No data uploaded yet' : '';
}

function _shouldRedraw(lastDuration, currentDuration, lastPoints, currentPoints) {
  const shouldNotRedraw = lastDuration === currentDuration && lastPoints.length === currentPoints.length && currentPoints.some((currentPoint, i) => currentPoint.x - lastPoints[i].x < minRedrawInterval && currentPoint.y === lastPoints[i].y);
  return !shouldNotRedraw;
}

function _getTimespanBounds(unit, timespan, now) {
  const t = (0, _moment.default)(now).add(1, unit).startOf(unit);
  const end = t.valueOf();
  const start = t.subtract(timespan, unit).startOf(unit).valueOf();
  return {
    end,
    start
  };
}

function _interpolateSamples(sample0, sample1, timestamp) {
  const dt = (timestamp - sample0.timestamp) / (sample1.timestamp - sample0.timestamp);
  return (0, _coreUtils.mapValues)(sample0, (value, key) => key !== 'timestamp' ? (0, _sizeUtils.interpolateSizes)(value, sample1[key], dt) : timestamp);
}

function _filterSamples(samples, start, end) {
  const filtered = [];

  for (const sample of samples) {
    if (sample.timestamp <= start) {
      filtered[0] = sample;
    } else {
      filtered.push(sample);
      if (sample.timestamp >= end) break;
    }
  }

  if (filtered.length > 1) {
    const [first, second] = filtered;

    if (first.timestamp < start) {
      filtered[0] = _interpolateSamples(first, second, start);
    }

    const [secondToLast, last] = filtered;

    if (last.timestamp > end) {
      filtered[filtered.length - 1] = _interpolateSamples(secondToLast, last, end);
    }
  }

  return filtered;
}

function _getChartOptions(selectedDatasets, samples, durationSettings, start, end, timezone) {
  const {
    stepSize,
    stepUnit,
    tickFormat
  } = durationSettings;
  const datasetKeys = Object.values(selectedDatasets).map(set => set.key);
  const useFixedMax = samples.every(sample => datasetKeys.every(key => sample[key] === 0));
  return {
    maintainAspectRatio: false,
    scales: {
      xAxes: [{
        type: 'linear',
        ticks: {
          fontSize: 8,
          min: start,
          max: end,
          stepSize: _moment.default.duration(stepSize, stepUnit).asMilliseconds(),
          maxTicksLimit: 10000,
          callback: t => _moment.default.tz(t, timezone).format(tickFormat)
        }
      }],
      yAxes: [{
        ticks: {
          fontSize: 8,
          max: useFixedMax ? Math.pow(1024, 2) : undefined,
          stepSize: useFixedMax ? Math.pow(1024, 2) / 10 : undefined,
          callback: size => size > 0 ? (0, _sizeUtils.formatSize)(Math.floor(size)) : '0'
        }
      }]
    },
    tooltips: {
      callbacks: {
        title: items => _moment.default.tz(items[0].xLabel, timezone).format('D MMM HH:mm'),
        label: item => `  ${selectedDatasets[item.datasetIndex].label}  ${(0, _sizeUtils.formatSize)(item.yLabel)}`
      }
    }
  };
}

function _getChartParams(selectedDatasets, used, storageHistory, selectedDuration, now, timezone, theme) {
  const durationSettings = durations[selectedDuration];
  const {
    stepUnit,
    timespan,
    points
  } = durationSettings;

  const {
    start,
    end
  } = _getTimespanBounds(stepUnit, timespan, now);

  const currSample = {
    timestamp: now,
    ...used
  };
  const historySamples = storageHistory.map(record => ({
    timestamp: record.timestamp,
    hosts: record.hosts.used || 0,
    cloud: record.cloud.used || 0,
    internal: record.internal.used || 0
  }));
  const [firstSample, secondSample] = historySamples;
  const showSamples = secondSample || firstSample && now - firstSample.timestamp > firstSampleHideDuration;
  const allSamples = showSamples ? [...historySamples, currSample] : [];

  const filteredSamples = _filterSamples(allSamples, start, end);

  const emptyChartMessage = _getChartEmptyMessage(showSamples, filteredSamples, selectedDatasets);

  const options = _getChartOptions(selectedDatasets, filteredSamples, durationSettings, start, end, timezone);

  let datasets = [];

  if (!emptyChartMessage) {
    datasets = selectedDatasets.map(({
      key,
      color
    }) => ({
      lineTension: 0,
      borderWidth: 2,
      borderColor: theme[color],
      backgroundColor: 'transparent',
      pointRadius: points ? 2 : 0,
      pointBorderWidth: 4,
      pointHitRadius: 10,
      pointBackgroundColor: theme[color],
      pointBorderColor: (0, _colorUtils.colorToRgb)(...(0, _colorUtils.rgbToColor)(theme.color11), .2),
      pointHoverBorderColor: 'transparent',
      data: filteredSamples.map(sample => ({
        x: sample.timestamp,
        y: (0, _sizeUtils.toBytes)(sample[key])
      }))
    }));
  }

  return {
    options,
    data: {
      datasets
    },
    emptyChartMessage
  };
}

class BucketsOverviewViewModel extends _observer.default {
  constructor() {
    super();
    (0, _defineProperty2.default)(this, "pathname", '');
    (0, _defineProperty2.default)(this, "lastDurationFilter", '');
    (0, _defineProperty2.default)(this, "lastDataPoints", []);
    (0, _defineProperty2.default)(this, "durationOptions", Object.entries(durations).map(pair => ({
      value: pair[0],
      label: pair[1].label
    })));
    (0, _defineProperty2.default)(this, "location", null);
    (0, _defineProperty2.default)(this, "dataLoaded", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "bucketsLinkText", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "bucketsLinkHref", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "selectedDuration", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "hiddenDatasets", null);
    (0, _defineProperty2.default)(this, "showInternalLegend", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "hideHosts", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "hideCloud", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "hideInternal", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "chartParams", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "emptyChartMessage", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "usedValues", [{
      label: 'Used on Nodes',
      value: _knockout.default.observable(),
      disabled: _knockout.default.pc(this.hideHosts, val => this.onToggleDataset('hosts', !val)),
      color: 'rgb(var(--color17)',
      tooltip: 'The total raw data that was written on all installed nodes in the system'
    }, {
      label: 'Used on Cloud',
      value: _knockout.default.observable(),
      disabled: _knockout.default.pc(this.hideCloud, val => this.onToggleDataset('cloud', !val)),
      color: 'rgb(var(--color20)',
      tooltip: 'The total raw data that was written on all configured cloud resources in the system'
    }, {
      label: 'Used on Internal',
      value: _knockout.default.observable(),
      visible: this.showInternalLegend,
      disabled: _knockout.default.pc(this.hideInternal, val => this.onToggleDataset('internal', !val)),
      color: 'rgb(var(--color28)',
      tooltip: 'The total raw data that was written to the system internal storage disks'
    }]);
    this.observe(_state.state$.pipe((0, _rxExtensions.get)('location')), this.onLocation);
    this.observe(_state.state$.pipe((0, _rxExtensions.getMany)('buckets', 'hostPools', 'cloudResources', ['system', 'internalStorage'], ['topology', 'servers'], 'storageHistory', ['session', 'uiTheme'])), this.onState);
  }

  onLocation(location) {
    // Should move inside onState without creating an
    // multipule chart redraws
    this.location = location;

    _state.action$.next((0, _actionCreators.fetchSystemStorageHistory)());
  }

  onState(state) {
    if (!state.every(Boolean)) {
      this.bucketsLinkText('');
      this.dataLoaded(false);
      return;
    }

    const [buckets, hostPools, cloudResources, internalStorage, servers, storageHistory, theme] = state;
    const {
      query,
      params
    } = this.location;
    const selectedDuration = query.selectedDuration || this.durationOptions[0].value;
    const hiddenDatasets = new Set(query.hiddenDatasets && query.hiddenDatasets.split(','));

    const isIntenralStorageUsed = _isInternalSotrageUsed(internalStorage, buckets);

    if (!isIntenralStorageUsed) hiddenDatasets.add('internal');
    const {
      system
    } = params;
    const bucketList = Object.values(buckets);
    const bucketsLinkText = (0, _stringUtils.stringifyAmount)('bucket', bucketList.length);
    const bucketsLinkHref = (0, _browserUtils.realizeUri)(routes.buckets, {
      system
    });
    const used = {
      hosts: (0, _sizeUtils.sumSize)(...Object.values(hostPools).map(res => res.storage.used || 0)),
      cloud: (0, _sizeUtils.sumSize)(...Object.values(cloudResources).map(res => res.storage.used || 0)),
      internal: internalStorage.used || 0
    };
    const now = Date.now();
    const {
      timezone
    } = Object.values(servers).find(server => server.isMaster);
    const datasets = chartDatasets.filter(ds => !hiddenDatasets.has(ds.key));

    const chartParams = _getChartParams(datasets, used, storageHistory, selectedDuration, now, timezone, _themes.default[theme]);

    const currentDataPoints = chartParams.data.datasets.map(ds => (0, _coreUtils.last)(ds.data)).filter(Boolean);

    const shouldRedraw = _shouldRedraw(this.lastDurationFilter, selectedDuration, this.lastDataPoints, currentDataPoints);

    _knockout.default.assignToProps(this, {
      dataLoaded: true,
      bucketsLinkText: bucketsLinkText,
      bucketsLinkHref: bucketsLinkHref,
      selectedDuration: selectedDuration,
      hiddenDatasets: Array.from(hiddenDatasets.values()),
      showInternalLegend: isIntenralStorageUsed,
      hideHosts: hiddenDatasets.has('hosts'),
      hideCloud: hiddenDatasets.has('cloud'),
      hideInternal: hiddenDatasets.has('internal'),
      usedValues: [{
        value: used.hosts
      }, {
        value: used.cloud
      }, {
        value: used.internal
      }],
      emptyChartMessage: chartParams.emptyChartMessage,
      chartParams: shouldRedraw ? chartParams : undefined,
      lastDurationFilter: selectedDuration,
      lastDataPoints: currentDataPoints
    });
  }

  onSelectDuration(duration) {
    const query = { ...this.location.query,
      selectedDuration: duration
    };
    const url = (0, _browserUtils.realizeUri)(this.location.pathname, {}, query);

    _state.action$.next((0, _actionCreators.requestLocation)(url, true));
  }

  onConnectApplication() {
    _state.action$.next((0, _actionCreators.openConnectAppModal)());
  }

  onToggleDataset(name, value) {
    const {
      query
    } = this.location;
    const set = new Set(this.hiddenDatasets);
    value ? set.delete(name) : set.add(name);
    const hiddenDatasets = set.size > 0 ? Array.from(set.values()) : undefined;
    const updatedQuery = { ...query,
      hiddenDatasets
    };
    const url = (0, _browserUtils.realizeUri)(this.location.pathname, {}, updatedQuery);

    _state.action$.next((0, _actionCreators.requestLocation)(url, true));
  }

}

var _default = {
  viewModel: BucketsOverviewViewModel,
  template: _bucketsOverview.default
};
exports.default = _default;

},{"./buckets-overview.html":667,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"knockout":"knockout","moment":"moment","observer":937,"routes":972,"rx-extensions":974,"state":1016,"themes":1018,"utils/browser-utils":1021,"utils/color-utils":1026,"utils/core-utils":1027,"utils/size-utils":1043,"utils/string-utils":1046}],669:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<!-- ko if: dataReady -->\n<section class=\"card column greedy\">\n    <div class=\"hpad pad-half row\">\n        <svg-icon class=\"icon-small push-next-half\"\n            ko.tooltip=\"clusterState\"\n            ko.css=\"clusterIcon().css\"\n            params=\"name: clusterIcon().name\"\n        ></svg-icon>\n        <span class=\"greedy highlight\">Cluster</span>\n    </div>\n    <hr>\n    <div class=\"pad greedy column\">\n        <p class=\"c6 push-next\">{{clusterState}}</p>\n        <p class=\"c6 push-next\">Highly available within the cluster</p>\n    </div>\n</section>\n<!-- /ko -->\n";

},{}],670:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _clusterOverview = _interopRequireDefault(require("./cluster-overview.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _clusterUtils = require("utils/cluster-utils");

/* Copyright (C) 2016 NooBaa */
class ClusterOverviewViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "clusterIcon", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "clusterState", _knockout.default.observable());
  }

  selectState(state) {
    const {
      system,
      topology
    } = state;
    return [topology, system];
  }

  mapStateToProps(topology, system) {
    if (!system) {
      _knockout.default.assignToProps(this, {
        dataReady: false
      });
    } else {
      const {
        tooltip: clusterState,
        ...clusterIcon
      } = (0, _clusterUtils.getClusterStateIcon)(topology, system.version);

      _knockout.default.assignToProps(this, {
        dataReady: true,
        clusterIcon,
        clusterState
      });
    }
  }

}

var _default = {
  viewModel: ClusterOverviewViewModel,
  template: _clusterOverview.default
};
exports.default = _default;

},{"./cluster-overview.html":669,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"components/connectable":446,"knockout":"knockout","utils/cluster-utils":1025}],671:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"row content-stretch content-wrapper\">\n    <resource-overview class=\"column c4 push-next-half\"></resource-overview>\n    <div class=\"column c4 push-both-half\">\n        <storage-overview class=\"greedy push-next-half\"></storage-overview>\n        <cluster-overview class=\"greedy push-both-half\"></cluster-overview>\n        <alerts-overview class=\"greedy push-prev-half\"></alerts-overview>\n    </div>\n    <buckets-overview class=\"column c4 push-prev-half\"></buckets-overview>\n</div>\n";

},{}],672:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _overviewPanel = _interopRequireDefault(require("./overview-panel.html"));

/* Copyright (C) 2016 NooBaa */
class OverviewPanelViewModel {
  constructor() {}

}

var _default = {
  viewModel: OverviewPanelViewModel,
  template: _overviewPanel.default
};
exports.default = _default;

},{"./overview-panel.html":671,"@babel/runtime/helpers/interopRequireDefault":1050}],673:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<section class=\"card-bg card-shadow column content-middle greedy pad\">\n    <!-- ko ifnot: dataReady -->\n    <loading-indicator class=\"align-middle push-prev\"></loading-indicator>\n    <!-- /ko -->\n\n    <!-- ko if: dataReady -->\n    <svg-icon class=\"circled-icon push-next-half\"\n        params=\"name: 'resources'\"\n    ></svg-icon>\n    <h2 class=\"heading2\">Storage Resources</h2>\n    <a class=\"heading3 link push-next\" ko.attr.href=\"resourcesLink.href\">\n        {{resourcesLink.text}}\n    </a>\n\n    <div class=\"align-start highlight push-next-half\">\n        Resources Health Status\n    </div>\n\n    <chart-legend class=\"align-stretch push-next\" params=\"\n        items: resourceCounters,\n        format: 'number'\n    \"></chart-legend>\n\n    <chartjs class=\"greedy resources-chart push-next\" params=\"\n        type: 'bar',\n        options: chart.options,\n        data: chart.data,\n        forceEmptyMessage: chart.forceEmptyMessage,\n        emptyMessage: 'No resources connected',\n    \"></chartjs>\n\n    <button class=\"btn overview-btn\" ko.click=\"onAddResources\">\n        Add Storage Resources\n    </button>\n     <!-- /ko -->\n</section>\n\n";

},{}],674:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _resourceOverview = _interopRequireDefault(require("./resource-overview.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _stringUtils = require("utils/string-utils");

var _browserUtils = require("utils/browser-utils");

var _coreUtils = require("utils/core-utils");

var routes = _interopRequireWildcard(require("routes"));

var _actionCreators = require("action-creators");

var _knockout = _interopRequireDefault(require("knockout"));

var _themes = _interopRequireDefault(require("themes"));

var _numeral = _interopRequireDefault(require("numeral"));

/* Copyright (C) 2016 NooBaa */
const chartBars = (0, _coreUtils.deepFreeze)([{
  label: 'Pools',
  resourceType: 'HOSTS'
}, {
  label: 'AWS',
  resourceType: 'CLOUD',
  cloudTypes: ['AWS']
}, {
  label: 'Google',
  resourceType: 'CLOUD',
  cloudTypes: ['GOOGLE']
}, {
  label: 'Azure',
  resourceType: 'CLOUD',
  cloudTypes: ['AZURE']
}, {
  label: 'Other S3',
  resourceType: 'CLOUD',
  cloudTypes: ['S3_COMPATIBLE', 'FLASHBLADE', 'NET_STORAGE', 'IBM_COS']
}]);

function _getHostsPoolState(pool) {
  return pool.mode === 'OPTIMAL' && 'healthy' || pool.mode === 'ALL_NODES_OFFLINE' && 'error' || pool.mode === 'HAS_NO_NODES' && 'error' || pool.mode === 'NO_CAPACITY' && 'error' || pool.mode === 'MOST_NODES_ISSUES' && 'error' || pool.mode === 'MOST_STORAGE_ISSUES' && 'error' || pool.mode === 'MOST_S3_ISSUES' && 'error' || 'issue';
}

function _getCloudResourceState(resource) {
  return resource.mode === 'OPTIMAL' && 'healthy' || resource.mode === 'IO_ERRORS' && 'error' || resource.mode === 'STORAGE_NOT_EXIST' && 'error' || resource.mode === 'AUTH_FAILED' && 'error' || resource.mode === 'ALL_NODES_OFFLINE' && 'error' || 'issue';
}

class ResourceOverviewViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "resourcesLink", {
      text: _knockout.default.observable(),
      href: _knockout.default.observable()
    });
    (0, _defineProperty2.default)(this, "resourceCounters", [{
      label: 'Healthy',
      color: 'rgb(var(--color27))',
      value: _knockout.default.observable()
    }, {
      label: 'Issues',
      color: 'rgb(var(--color26))',
      value: _knockout.default.observable()
    }, {
      label: 'Errors',
      color: 'rgb(var(--color31))',
      value: _knockout.default.observable()
    }]);
    (0, _defineProperty2.default)(this, "chart", {
      options: {
        layout: {
          padding: 0
        },
        maintainAspectRatio: false,
        scales: {
          yAxes: [{
            stacked: true,
            ticks: {
              suggestedMax: 5,
              callback: (value, i, values) => {
                const curr = Math.round(value);
                const next = Math.round(values[i - 1]);
                return curr !== next ? `${(0, _numeral.default)(curr).format(',')}${' '.repeat(5)}` : null;
              }
            }
          }],
          xAxes: [{
            stacked: true,
            categoryPercentage: .5
          }]
        },
        tooltips: {
          position: 'nearest',
          mode: 'x',
          custom: tooltip => {
            if (!tooltip.title || tooltip.title.length === 0) {
              tooltip.opacity = 0;
            }
          },
          callbacks: {
            title: items => {
              const count = (0, _coreUtils.sumBy)(items, item => item.yLabel);
              return items.some(item => item.yLabel > 0) ? `${items[0].xLabel}: ${(0, _numeral.default)(count).format(',')}` : '';
            },
            label: item => `${item.datasetIndex === 2 && 'Healthy' || item.datasetIndex === 1 && 'Issues' || item.datasetIndex === 0 && 'Errors'}: ${(0, _numeral.default)(item.yLabel).format(',')}`
          }
        }
      },
      data: _knockout.default.observable(),
      forceEmptyMessage: _knockout.default.observable()
    });
  }

  selectState(state) {
    const {
      location,
      hostPools,
      cloudResources,
      session
    } = state;
    return [location, hostPools, cloudResources, session && _themes.default[session.uiTheme]];
  }

  mapStateToProps(location, hostPools, cloudResources, theme) {
    if (!hostPools || !cloudResources || !theme) {
      _knockout.default.assignToProps(this, {
        dataReady: false
      });
    } else {
      const hostPoolList = Object.values(hostPools);
      const cloudResourceList = Object.values(cloudResources);
      const resourceCount = hostPoolList.length + cloudResourceList.length;
      const cloudResourceByType = (0, _coreUtils.groupBy)(cloudResourceList, res => res.type);
      const counters = chartBars.reduce((aggr, bar) => {
        let counters = null;

        if (bar.resourceType === 'HOSTS') {
          counters = (0, _coreUtils.countBy)(hostPoolList, _getHostsPoolState);
        } else {
          counters = (0, _coreUtils.countBy)((0, _coreUtils.flatMap)(bar.cloudTypes, cloudType => cloudResourceByType[cloudType]), _getCloudResourceState);
        }

        aggr.healthy.push(counters.healthy || 0);
        aggr.issue.push(counters.issue || 0);
        aggr.error.push(counters.error || 0);
        return aggr;
      }, {
        healthy: [],
        issue: [],
        error: []
      });
      const chartData = {
        labels: chartBars.map(bar => bar.label),
        datasets: [{
          backgroundColor: theme.color31,
          data: counters.error
        }, {
          backgroundColor: theme.color26,
          data: counters.issue
        }, {
          backgroundColor: theme.color27,
          data: counters.healthy
        }]
      };

      _knockout.default.assignToProps(this, {
        dataReady: true,
        resourcesLink: {
          text: (0, _stringUtils.stringifyAmount)('resource', resourceCount),
          href: (0, _browserUtils.realizeUri)(routes.resources, {
            system: location.params.system
          })
        },
        resourceCounters: [{
          value: (0, _coreUtils.sumBy)(counters.healthy)
        }, {
          value: (0, _coreUtils.sumBy)(counters.issue)
        }, {
          value: (0, _coreUtils.sumBy)(counters.error)
        }],
        chart: {
          data: chartData,
          forceEmptyMessage: resourceCount === 0
        }
      });
    }
  }

  onAddResources() {
    this.dispatch((0, _actionCreators.openAddResourcesModal)());
  }

}

var _default = {
  viewModel: ResourceOverviewViewModel,
  template: _resourceOverview.default
};
exports.default = _default;

},{"./resource-overview.html":673,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"components/connectable":446,"knockout":"knockout","numeral":"numeral","routes":972,"themes":1018,"utils/browser-utils":1021,"utils/core-utils":1027,"utils/string-utils":1046}],675:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<!-- ko if: dataReady -->\n<section class=\"card\">\n    <div class=\"hpad pad-half row\">\n        <svg-icon class=\"icon-small push-next-half\"\n            ko.css=\"storageIcon().css\"\n            ko.tooltip=\"storageIcon().tooltip\"\n            params=\"name: storageIcon().name\"\n        ></svg-icon>\n        <span class=\"greedy highlight\">Storage</span>\n    </div>\n    <hr>\n    <div class=\"pad column greedy\">\n        <div class=\"row push-next-half\">\n            <p class=\"column greedy\">\n                <span class=\"highlight\">{{storageTotal}}</span>\n                <span class=\"remark\">Total Storage</span>\n            </p>\n            <p class=\"column\">\n                <span class=\"highlight\">{{storagePools}}</span>\n                <span class=\"remark\">Pools</span>\n            </p>\n            <vr class=\"push-both-half\"></vr>\n            <p class=\"column\">\n                <span class=\"highlight\">{{storageCloud}}</span>\n                <span class=\"remark\">Cloud</span>\n            </p>\n            <!-- ko if: isIntenralStorageVisible -->\n            <vr class=\"push-both-half\"></vr>\n            <p class=\"column\">\n                <span class=\"highlight\">{{storageInternal}}</span>\n                <span class=\"remark\">Internal</span>\n            </p>\n            <!-- /ko -->\n        </div>\n        <bar class=\"usage-bar push-prev\" params=\"\n            values: storageBarValues,\n            minRatio: .02,\n            format: 'size',\n        \"></bar>\n        <chart-legend class=\"legend-row1 push-prev-half\" params=\"\n            items: storageBarValues,\n            format: 'size'\n        \"></chart-legend>\n    </div>\n</section>\n<!-- /ko -->\n";

},{}],676:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _storageOverview = _interopRequireDefault(require("./storage-overview.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _sizeUtils = require("utils/size-utils");

var _storageUtils = require("utils/storage-utils");

var _numeral = _interopRequireDefault(require("numeral"));

/* Copyright (C) 2016 NooBaa */
function _getSystemStorageIcon(total = 0, free = 0) {
  const totalBytes = (0, _sizeUtils.toBytes)(total);
  const freeBytes = (0, _sizeUtils.toBytes)(free);
  const ratio = freeBytes / totalBytes;

  if (totalBytes === 0) {
    return {
      name: 'problem',
      css: 'disabled',
      tooltip: 'No system storage - add nodes or cloud resources'
    };
  } else if (freeBytes < _sizeUtils.unitsInBytes.MB) {
    return {
      name: 'problem',
      css: 'error',
      tooltip: 'No free storage left'
    };
  } else {
    const percentage = ratio < .01 ? 'Lower than 1%' : (0, _numeral.default)(ratio).format('%');
    return {
      name: ratio <= .2 ? 'problem' : 'healthy',
      css: ratio <= .2 ? 'warning' : 'success',
      tooltip: `${percentage} free storage left`
    };
  }
}

function _isInternalSotrageUsed(internalStorage, buckets) {
  if (internalStorage.used > 0) {
    return true;
  }

  if (Object.values(buckets).some(bucket => bucket.placement.tiers[0].policyType === 'INTERNAL_STORAGE')) {
    return true;
  }

  return false;
}

class StorageOverviewViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "storageIcon", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isIntenralStorageVisible", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "storageTotal", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "storagePools", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "storageCloud", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "storageInternal", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "storageBarValues", [{
      label: 'Used',
      value: _knockout.default.observable(),
      color: 'rgb(var(--color20))',
      tooltip: 'The raw storage used in the system'
    }, {
      label: 'Unavailable',
      value: _knockout.default.observable(),
      color: 'rgb(var(--color14))',
      tooltip: 'All offline resources or unusable storage such as OS usage'
    }, {
      label: 'Available',
      value: _knockout.default.observable(),
      color: 'rgb(var(--color09))',
      tooltip: 'The total free space for upload prior to data resiliency considerations'
    }]);
  }

  selectState(state) {
    const {
      buckets,
      hostPools,
      cloudResources,
      system = {}
    } = state;
    const {
      internalStorage
    } = system;
    return [buckets, hostPools, cloudResources, internalStorage];
  }

  mapStateToProps(buckets, hostPools, cloudResources, internalStorage) {
    if (!buckets || !hostPools || !cloudResources || !internalStorage) {
      _knockout.default.assignToProps(this, {
        dataReady: false
      });
    } else {
      const poolsStorage = (0, _storageUtils.aggregateStorage)(...Object.values(hostPools).map(pool => pool.storage));
      const cloudStorage = (0, _storageUtils.aggregateStorage)(...Object.values(cloudResources).map(resource => resource.storage));
      const systemStorage = (0, _storageUtils.aggregateStorage)(poolsStorage, cloudStorage, internalStorage);
      const systemUnavailable = systemStorage.unavailableFree || 0;

      _knockout.default.assignToProps(this, {
        dataReady: true,
        storageIcon: _getSystemStorageIcon(systemStorage.total, systemStorage.free),
        isIntenralStorageVisible: _isInternalSotrageUsed(internalStorage, buckets),
        storageTotal: (0, _sizeUtils.formatSize)(systemStorage.total || 0),
        storagePools: (0, _sizeUtils.formatSize)(poolsStorage.total || 0),
        storageCloud: (0, _sizeUtils.formatSize)(cloudStorage.total || 0),
        storageInternal: (0, _sizeUtils.formatSize)(internalStorage.total || 0),
        storageBarValues: [{
          value: (0, _sizeUtils.toBytes)(systemStorage.used)
        }, {
          value: (0, _sizeUtils.toBytes)(systemUnavailable)
        }, {
          value: (0, _sizeUtils.toBytes)(systemStorage.free)
        }]
      });
    }
  }

}

var _default = {
  viewModel: StorageOverviewViewModel,
  template: _storageOverview.default
};
exports.default = _default;

},{"./storage-overview.html":675,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"components/connectable":446,"knockout":"knockout","numeral":"numeral","utils/size-utils":1043,"utils/storage-utils":1045}],677:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _knockout = _interopRequireDefault(require("knockout"));

var _browserUtils = require("utils/browser-utils");

var _hostUtils = require("utils/host-utils");

/* Copyright (C) 2016 NooBaa */
class HostRowViewModel {
  constructor({
    baseRoute
  }) {
    this.baseRoute = baseRoute;
    this.state = _knockout.default.observable();
    this.hostname = _knockout.default.observable();
    this.ip = _knockout.default.observable();
    this.capacity = _knockout.default.observable();
    this.dataActivity = _knockout.default.observable();
  }

  onHost(host) {
    const {
      name,
      ip,
      activities
    } = host;
    const uri = (0, _browserUtils.realizeUri)(this.baseRoute, {
      host: name
    });
    const hostname = {
      text: (0, _hostUtils.getHostDisplayName)(name),
      href: uri
    };
    const [firstActivity = {}] = activities;
    const dataActivity = {
      text: (0, _hostUtils.getActivityName)(firstActivity.kind) || 'No Activity',
      tooltip: (0, _hostUtils.getActivityListTooltip)(activities)
    };
    this.state((0, _hostUtils.getHostStateIcon)(host));
    this.hostname(hostname);
    this.ip(ip);
    this.capacity((0, _hostUtils.getNodeOrHostCapacityBarValues)(host));
    this.dataActivity(dataActivity);
  }

}

exports.default = HostRowViewModel;

},{"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","utils/browser-utils":1021,"utils/host-utils":1032}],678:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"row pad card-shadow content-middle\">\n    <input type=\"search\"\n        class=\"push-next-half\"\n        placeholder=\"Filter by Node Name or IP\"\n        ko.textInput=\"ko.pc(nameFilter, onFilterByNameThrottled, $component)\"\n    />\n\n    <div class=\"row content-middle greedy push-next\">\n        <dropdown params=\"\n            multiselect: true,\n            subject: 'state',\n            options: stateFilterOptions,\n            selected: ko.pc(stateFilter, onFilterByState, $component)\n        \"></dropdown>\n    </div>\n\n    <div ko.tooltip=\"actionsTooltip\">\n        <button class=\"btn\" ko.disable=\"areActionsDisabled\"\n            ko.click=\"onAssignRegion\"\n        >\n            Assign Region\n        </button>\n    </div>\n\n    <div class=\"push-prev\" ko.tooltip=\"actionsTooltip\"\n        ko.visible=\"isEditPoolConfigVisible\"\n    >\n        <button class=\"btn\"\n            ko.disable=\"areActionsDisabled\"\n            ko.click=\"onEditPoolConfig\"\n        >\n            Edit Pool Configuration\n        </button>\n    </div>\n</div>\n\n<data-table class=\"greedy\" params=\"\n    columns: columns,\n    data: rows,\n    sorting: ko.pc(sorting, onSort, $component),\n    loading: fetching,\n    emptyMessage: emptyMessage\n\">\n    <template name=\"service-indicators\">\n        <span class=\"indicator\"\n            ko.css.lighted=\"$data().storage\"\n            ko.tooltip=\"'Storage Service'\"\n        >\n            S\n        </span>\n        <span class=\"indicator\"\n            ko.css.lighted=\"$data().endpoint\"\n            ko.tooltip=\"'S3 Endpoint Service'\"\n        >\n            E\n        </span>\n    </template>\n</data-table>\n\n<paginator params=\"\n    itemCount: hostCount,\n    pageSize: ko.pc(pageSize, onPageSize, $component),\n    page: ko.pc(page, onPage, $component)\n\"></paginator>\n";

},{}],679:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _poolHostsTable = _interopRequireDefault(require("./pool-hosts-table.html"));

var _hostRow = _interopRequireDefault(require("./host-row"));

var _observer = _interopRequireDefault(require("observer"));

var _state2 = require("state");

var _knockout = _interopRequireDefault(require("knockout"));

var _numeral = _interopRequireDefault(require("numeral"));

var _coreUtils = require("utils/core-utils");

var _browserUtils = require("utils/browser-utils");

var _hostUtils = require("utils/host-utils");

var _rxExtensions = require("rx-extensions");

var _config = require("config");

var routes = _interopRequireWildcard(require("routes"));

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const columns = (0, _coreUtils.deepFreeze)([{
  name: 'state',
  sortable: 'mode',
  type: 'icon'
}, {
  name: 'hostname',
  label: 'node name',
  sortable: 'name',
  type: 'link'
}, {
  name: 'ip',
  label: 'IP Address',
  sortable: true
}, {
  name: 'capacity',
  label: 'used capacity',
  sortable: 'used',
  type: 'capacity'
}, {
  name: 'dataActivity',
  sortable: 'data_activity'
}]);
const states = (0, _coreUtils.deepFreeze)(['HEALTHY', 'HAS_ISSUES', 'OFFLINE']);

function _getStateFilterOptions(all, healthy, issues, offline) {
  return [{
    value: states[0],
    label: `Healthy (${(0, _numeral.default)(healthy).format('0,0')})`
  }, {
    value: states[1],
    label: `Issues (${(0, _numeral.default)(issues).format('0,0')})`
  }, {
    value: states[2],
    label: `Offline (${(0, _numeral.default)(offline).format('0,0')})`
  }];
}

class PoolHostsTableViewModel extends _observer.default {
  constructor() {
    super();
    this.viewName = this.constructor.name;
    this.baseRoute = '';
    this.baseHostRoute = '';
    this.poolName = '';
    this.columns = columns;
    this.stateFilterOptions = _knockout.default.observableArray();
    this.nameFilter = _knockout.default.observable();
    this.stateFilter = _knockout.default.observableArray();
    this.page = _knockout.default.observable();
    this.pageSize = _knockout.default.observable();
    this.sorting = _knockout.default.observable();
    this.rows = _knockout.default.observableArray();
    this.hostCount = _knockout.default.observable();
    this.emptyMessage = _knockout.default.observable();
    this.fetching = _knockout.default.observable();
    this.onFilterByNameThrottled = (0, _coreUtils.throttle)(this.onFilterByName, _config.inputThrottle, this);
    this.areActionsDisabled = _knockout.default.observable(true);
    this.actionsTooltip = _knockout.default.observable('');
    this.isEditPoolConfigVisible = _knockout.default.observable(false);
    this.observe(_state2.state$.pipe((0, _rxExtensions.getMany)('location', 'hostPools')), this.onLocation);
    this.observe(_state2.state$.pipe((0, _rxExtensions.get)('hosts')), this.onHosts);
  }

  onLocation([location, pools]) {
    const {
      route,
      params,
      query
    } = location;

    if (!pools || !params) {
      return;
    }

    const {
      system,
      pool,
      tab = 'nodes'
    } = params;
    if (!pool || !pools[pool] || tab !== 'nodes') return;
    const {
      name,
      sortBy = 'name'
    } = query;
    const page = Number(query.page) || 0;

    const pageSize = Number(query.pageSize) || _config.paginationPageSize.default;

    const order = Number(query.order) || 1;
    const state = query.state === true && [] || query.state && query.state.split('|') || states;
    const disableActions = pools[pool].mode === 'DELETING';
    this.poolName = pool;
    this.baseRoute = (0, _browserUtils.realizeUri)(route, {
      system,
      pool,
      tab
    }, {}, true);
    this.baseHostRoute = (0, _browserUtils.realizeUri)(routes.host, {
      system,
      pool
    }, {}, true);
    this.nameFilter(name);
    this.stateFilter(state);
    this.sorting({
      sortBy,
      order
    });
    this.page(page);
    this.pageSize(pageSize);
    this.areActionsDisabled(disableActions);
    this.actionsTooltip(disableActions ? 'Pool is being deleted' : '');
    this.isEditPoolConfigVisible(pools[pool].isManaged);

    _state2.action$.next((0, _actionCreators.fetchHosts)(this.viewName, {
      pools: [pool],
      name: name,
      modes: (0, _coreUtils.flatMap)(state, state => (0, _hostUtils.getHostModeListForState)(state)),
      sortBy: sortBy,
      order: order,
      skip: pageSize * page,
      limit: pageSize
    }));
  }

  onHosts({
    views,
    queries,
    items
  }) {
    const queryKey = views[this.viewName];

    if (!queryKey) {
      this.stateFilterOptions(_getStateFilterOptions(0, 0, 0, 0));
      return;
    }

    const query = queries[queryKey];

    if (query.result) {
      const {
        items: itemKeys,
        counters
      } = query.result; // Update toggle and paginator counters.

      const {
        all,
        healthy,
        hasIssues,
        offline
      } = (0, _hostUtils.summrizeHostModeCounters)(counters.byMode);
      this.stateFilterOptions(_getStateFilterOptions(all, healthy, hasIssues, offline));
      this.hostCount(counters.nonPaginated); // Update table rows.

      const rowParams = {
        baseRoute: this.baseHostRoute
      };
      const rows = itemKeys.map((hostName, i) => {
        const row = this.rows()[i] || new _hostRow.default(rowParams);
        row.onHost(items[hostName]);
        return row;
      });
      this.rows(rows);
      this.emptyMessage(rows.length === 0 ? 'No matching nodes' : ''); // TODO: find a way to change empry message to support: Pool does not contain any nodes

      this.fetching(false);
    } else {
      this.rows([]);
      this.fetching(true);
      this.emptyMessage('');
    }
  }

  onFilterByName(name) {
    const page = 0;
    this.onQuery({
      name,
      page
    });
  }

  onFilterByState(state) {
    const page = 0;
    this.onQuery({
      state,
      page
    });
  }

  onSort({
    sortBy,
    order
  }) {
    const page = 0;
    this.onQuery({
      sortBy,
      order,
      page
    });
  }

  onPage(page) {
    this.onQuery({
      page
    });
  }

  onPageSize(pageSize) {
    this.onQuery({
      pageSize,
      page: 0
    });
  }

  onQuery(query) {
    const {
      name: _name = this.nameFilter(),
      state: _state = this.stateFilter(),
      sortBy = this.sorting().sortBy,
      order = this.sorting().order,
      page = this.page(),
      pageSize = this.pageSize()
    } = query;
    const name = _name || undefined;

    const state = _state.join('|');

    const url = (0, _browserUtils.realizeUri)(this.baseRoute, {}, {
      name,
      state,
      sortBy,
      order,
      page,
      pageSize
    });

    _state2.action$.next((0, _actionCreators.requestLocation)(url));
  }

  onAssignRegion() {
    _state2.action$.next((0, _actionCreators.openAssignRegionModal)('HOSTS', this.poolName));
  }

  onEditPoolConfig() {
    _state2.action$.next((0, _actionCreators.openEditK8sPoolModal)(this.poolName));
  }

  dispose() {
    _state2.action$.next((0, _actionCreators.dropHostsView)(this.viewName));

    super.dispose();
  }

}

var _default = {
  viewModel: PoolHostsTableViewModel,
  template: _poolHostsTable.default
};
exports.default = _default;

},{"./host-row":677,"./pool-hosts-table.html":678,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"config":831,"knockout":"knockout","numeral":"numeral","observer":937,"routes":972,"rx-extensions":974,"state":1016,"utils/browser-utils":1021,"utils/core-utils":1027,"utils/host-utils":1032}],680:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<pool-summary class=\"push-next\" params=\"poolName: pool\"></pool-summary>\n\n<div class=\"tabs greedy\" ko.if=\"baseRoute\">\n    <nav>\n        <a ko.css.selected=\"selectedTab.eq('nodes')\"\n            ko.attr.href=\"tabHref('nodes')\"\n        >\n            Kubernetes Nodes\n        </a>\n        <a ko.css.selected=\"selectedTab.eq('connected-buckets')\"\n            ko.attr.href=\"tabHref('connected-buckets')\"\n        >\n            Connected Buckets\n        </a>\n        <a ko.css.selected=\"selectedTab.eq('associated-accounts')\"\n            ko.attr.href=\"tabHref('associated-accounts')\"\n        >\n            Associated Accounts\n        </a>\n    </nav>\n\n    <div class=\"tabs-row\">\n        <pool-hosts-table class=\"tab column\"\n            ko.css.selected=\"selectedTab.eq('nodes')\"\n            params=\"poolName: pool\"\n        ></pool-hosts-table>\n\n        <resource-connected-buckets-form class=\"tab column\"\n            ko.css.selected=\"selectedTab.eq('connected-buckets')\"\n            params=\"resourceType: 'HOSTS', resourceName: pool\"\n        ></resource-connected-buckets-form>\n\n        <resource-associated-account-list class=\"tab column\"\n            ko.css.selected=\"selectedTab.eq('associated-accounts')\"\n            params=\"resourceType: 'HOSTS', resourceName: pool\"\n        ></resource-associated-account-list>\n    </div>\n</div>\n\n<div class=\"redirect-overlay row content-middle\" ko.visible=\"redirecting\">\n    <div class=\"column greedy content-middle\">\n        <h1 class=\"heading1\">This pool was deleted</h1>\n        <loading-indicator class=\"push-both-half\"></loading-indicator>\n        <p class=\"heading3\">You will be redircted to the resources page in a moment</p>\n    </div>\n</div>\n";

},{}],681:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _poolPanel = _interopRequireDefault(require("./pool-panel.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _browserUtils = require("utils/browser-utils");

var _actionCreators = require("action-creators");

var _config = require("config");

var routes = _interopRequireWildcard(require("routes"));

/* Copyright (C) 2016 NooBaa */
class PoolPanelViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "baseRoute", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "pool", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "selectedTab", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "redirecting", _knockout.default.observable());
  }

  selectState(state) {
    const {
      location,
      hostPools
    } = state;
    return [location, hostPools];
  }

  mapStateToProps(location, pools) {
    const {
      system,
      pool,
      tab = 'nodes'
    } = location.params;
    if (!pool) return; // In case the pool does not exists

    if (pools && !pools[pool]) {
      this.redirectToResourcePage(system);
      return;
    }

    _knockout.default.assignToProps(this, {
      baseRoute: (0, _browserUtils.realizeUri)(location.route, {
        system,
        pool
      }, {}, true),
      pool: pool,
      selectedTab: tab
    });
  }

  redirectToResourcePage(system) {
    this.redirecting(true);
    setTimeout(() => {
      const resourcePageUri = (0, _browserUtils.realizeUri)(routes.resources, {
        system
      });
      this.dispatch((0, _actionCreators.requestLocation)(resourcePageUri));
    }, _config.redirectOverlayDuration);
  }

  tabHref(tab) {
    return (0, _browserUtils.realizeUri)(this.baseRoute(), {
      tab
    });
  }

}

var _default = {
  viewModel: PoolPanelViewModel,
  template: _poolPanel.default
};
exports.default = _default;

},{"./pool-panel.html":680,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"components/connectable":446,"config":831,"knockout":"knockout","routes":972,"utils/browser-utils":1021}],682:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"fill row\" ko.visible=\"!dataReady()\">\n    <loading-indicator class=\"align-middle greedy\" params=\"label: true\"></loading-indicator>\n</div>\n\n<div class=\"row summary\" ko.css.visible=\"dataReady\">\n    <section class=\"c3 column card\">\n        <p class=\"greedy hpad row heading3 content-middle\">\n            <svg-icon class=\"c2 push-next-half\" ko.css=\"state().css\" params=\"name: state().name\"></svg-icon>\n            {{state().tooltip}}\n        </p>\n        <hr />\n        <p class=\"greedy hpad row content-middle\">\n            <span class=\"greedy push-next\">Nodes (Pods):</span>\n            <span>{{hostCount}}</span>\n        </p>\n        <hr />\n        <p class=\"greedy hpad row content-middle\">\n            <span class=\"greedy push-next\">Region:</span>\n            <span>{{region}}</span>\n        </p>\n    </section>\n\n    <section class=\"c6 column push-both\">\n        <div class=\"row align-middle\">\n            <chart-legend class=\"pad\" params=\"\n                items: pieValues,\n                caption: 'Kubernetes Pool Usage',\n                format: 'size'\n            \"></chart-legend>\n\n            <pie-chart class=\"align-middle push-prev\" params=\"\n                values: pieValues,\n                sumLabel: 'Total',\n                format: 'size'\n            \"></pie-chart>\n        </div>\n    </section>\n\n    <section class=\"column c3 card\">\n        <h3 class=\"hpad pad-half heading3\">{{activitiesTitle}}</h3>\n        <hr>\n        <p class=\"remark hpad pad-half push-next\">{{activityText}}</p>\n        <!-- ko if: hasActivities -->\n        <progress-bar class=\"hpad push-both-quarter\" params=\"\n            progress: activityProgress,\n            marker: true\n        \"></progress-bar>\n        <p class=\"remark align-end pad-right\">ETA: {{activityEta}}</p>\n\n        <!-- ko if: hasAdditionalActivities -->\n            <hr class=\"push-prev-half\">\n            <p class=\"hpad pad-half align-start\"\n                ko.text=\"additionalActivitiesMessage\"\n                ko.tooltip=\"additionalActivitiesTooltip\"\n            ></p>\n        <!-- /ko -->\n        <!-- /ko -->\n    </section>\n</div>\n";

},{}],683:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _poolSummary = _interopRequireDefault(require("./pool-summary.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _numeral = _interopRequireDefault(require("numeral"));

var _coreUtils = require("utils/core-utils");

var _sizeUtils = require("utils/size-utils");

var _stringUtils = require("utils/string-utils");

var _resourceUtils = require("utils/resource-utils");

var _hostUtils = require("utils/host-utils");

var _moment = _interopRequireDefault(require("moment"));

/* Copyright (C) 2016 NooBaa */
function _mapStateAndStatus(pool) {
  const {
    hostCount,
    region
  } = pool;
  return {
    state: (0, _resourceUtils.getHostPoolStateIcon)(pool),
    hostCount: (0, _numeral.default)(hostCount).format('0,0'),
    region: region || _resourceUtils.unassignedRegionText
  };
}

function _mapStorageAndUsage(pool) {
  const {
    free,
    unavailableFree,
    used,
    usedOther
  } = pool.storage;
  return {
    availableCapacity: (0, _sizeUtils.toBytes)(free),
    unavailableCapacity: (0, _sizeUtils.toBytes)(unavailableFree),
    usedByNoobaaCapacity: (0, _sizeUtils.toBytes)(used),
    usedByOthersCapacity: (0, _sizeUtils.toBytes)(usedOther)
  };
}

function _mapFirstActivity(pool) {
  const {
    hostCount,
    list
  } = pool.activities;

  if (list.length > 0) {
    const {
      kind,
      nodeCount,
      progress,
      eta
    } = list[0] || {};
    const activityText = `${(0, _hostUtils.getActivityName)(kind)} ${(0, _stringUtils.stringifyAmount)('node', nodeCount)}`;
    const etaText = (0, _coreUtils.isNumber)(eta) ? (0, _moment.default)(eta).fromNow() : 'calculating...';
    return {
      hasActivities: true,
      activitiesTitle: `${(0, _stringUtils.stringifyAmount)('Node', hostCount)} in Process`,
      activityText: activityText,
      activityProgress: progress,
      activityEta: etaText
    };
  } else {
    return {
      hasActivities: false,
      activitiesTitle: 'No Activities',
      activityText: 'Pool has no activity'
    };
  }
}

function _mapAdditionalActivities(pool) {
  const {
    list
  } = pool.activities;
  const additionalActivities = list.slice(1);

  if (additionalActivities.length > 0) {
    const message = `${(0, _stringUtils.stringifyAmount)('More activity', additionalActivities.length)} running`;
    return {
      hasAdditionalActivities: true,
      additionalActivitiesMessage: message,
      additionalActivitiesTooltip: (0, _hostUtils.getActivityListTooltip)(additionalActivities)
    };
  } else {
    return {
      hasAdditionalActivities: false
    };
  }
}

class PoolSummaryViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "state", _knockout.default.observable({}));
    (0, _defineProperty2.default)(this, "hostCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "region", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "availableCapacity", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "unavailableCapacity", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "usedByNoobaaCapacity", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "usedByOthersCapacity", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "inProcessHotsts", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "pieValues", [{
      label: 'Available',
      color: 'rgb(var(--color09))',
      value: this.availableCapacity,
      tooltip: 'The total aggregated storage from installed nodes in this pool, does not include any offline or deactivated nodes'
    }, {
      label: 'Unavailable',
      color: 'rgb(var(--color14))',
      value: this.unavailableCapacity,
      tooltip: 'The total aggregated storage from offline nodes in this pool'
    }, {
      label: 'NooBaa Usage',
      color: 'rgb(var(--color20))',
      value: this.usedByNoobaaCapacity,
      tooltip: 'The actual storage utilization of this pool by the buckets connected to it'
    }, {
      label: 'Other Usage',
      color: 'rgb(var(--color29))',
      value: this.usedByOthersCapacity,
      tooltip: 'The machines utilization by OS, local files etc'
    }]);
    (0, _defineProperty2.default)(this, "hasActivities", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "activitiesTitle", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "activityText", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "activityProgress", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "activityEta", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "hasAdditionalActivities", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "additionalActivitiesMessage", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "additionalActivitiesTooltip", _knockout.default.observable());
  }

  selectState(state, params) {
    const {
      hostPools
    } = state;
    return [hostPools && hostPools[params.poolName]];
  }

  mapStateToProps(pool) {
    if (!pool) {
      _knockout.default.assignToProps(this, {
        dataReady: false
      });
    } else {
      _knockout.default.assignToProps(this, {
        dataReady: true,
        ..._mapStateAndStatus(pool),
        ..._mapStorageAndUsage(pool),
        ..._mapFirstActivity(pool),
        ..._mapAdditionalActivities(pool)
      });
    }
  }

}

var _default = {
  viewModel: PoolSummaryViewModel,
  template: _poolSummary.default
};
exports.default = _default;

},{"./pool-summary.html":682,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"components/connectable":446,"knockout":"knockout","moment":"moment","numeral":"numeral","utils/core-utils":1027,"utils/host-utils":1032,"utils/resource-utils":1041,"utils/size-utils":1043,"utils/string-utils":1046}],684:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = register;

var _coreUtils = require("utils/core-utils");

var _stringUtils = require("utils/string-utils");

var _app = _interopRequireDefault(require("./application/app/app"));

var _mainLayout = _interopRequireDefault(require("./application/main-layout/main-layout"));

var _loginLayout = _interopRequireDefault(require("./application/login-layout/login-layout"));

var _modalManager = _interopRequireDefault(require("./application/modal-manager/modal-manager"));

var _exitConfirmationMessage = _interopRequireDefault(require("./application/exit-confirmation-message/exit-confirmation-message"));

var _signinForm = _interopRequireDefault(require("./login/signin-form/signin-form"));

var _createSystemForm = _interopRequireDefault(require("./login/create-system-form/create-system-form"));

var _unsupportedForm = _interopRequireDefault(require("./login/unsupported-form/unsupported-form"));

var _changePasswordForm = _interopRequireDefault(require("./login/change-password-form/change-password-form"));

var _splashScreen = _interopRequireDefault(require("./login/splash-screen/splash-screen"));

var _oauthCallback = _interopRequireDefault(require("./login/oauth-callback/oauth-callback"));

var _commandsBar = _interopRequireDefault(require("./main/commands-bar/commands-bar"));

var _notificationBox = _interopRequireDefault(require("./main/notification-box/notification-box"));

var _accountMenu = _interopRequireDefault(require("./main/account-menu/account-menu"));

var _uploadsIndicator = _interopRequireDefault(require("./main/uploads-indicator/uploads-indicator"));

var _debugModeSticky = _interopRequireDefault(require("./stickies/debug-mode-sticky/debug-mode-sticky"));

var _maintenanceSticky = _interopRequireDefault(require("./stickies/maintenance-sticky/maintenance-sticky"));

var _phoneHomeConnectivitySticky = _interopRequireDefault(require("./stickies/phone-home-connectivity-sticky/phone-home-connectivity-sticky"));

var _clusterAvailabilitySticky = _interopRequireDefault(require("./stickies/cluster-availability-sticky/cluster-availability-sticky"));

var _preferedBrowsersSticky = _interopRequireDefault(require("./stickies/prefered-browsers-sticky/prefered-browsers-sticky"));

var _welcomeModal = _interopRequireDefault(require("./modals/welcome-modal/welcome-modal"));

var _addCloudResourceModal = _interopRequireDefault(require("./modals/add-cloud-resource-modal/add-cloud-resource-modal"));

var _addCloudConnectionModal = _interopRequireDefault(require("./modals/add-cloud-connection-modal/add-cloud-connection-modal"));

var _s3AccessDetailsModal = _interopRequireDefault(require("./modals/s3-access-details-modal/s3-access-details-modal"));

var _editBucketS3AccessModal = _interopRequireDefault(require("./modals/edit-bucket-s3-access-modal/edit-bucket-s3-access-modal"));

var _startMaintenanceModal = _interopRequireDefault(require("./modals/start-maintenance-modal/start-maintenance-modal"));

var _fileUploadsModal = _interopRequireDefault(require("./modals/file-uploads-modal/file-uploads-modal"));

var _deleteCurrentAccountWarningModal = _interopRequireDefault(require("./modals/delete-current-account-warning-modal/delete-current-account-warning-modal"));

var _objectPreviewModal = _interopRequireDefault(require("./modals/object-preview-modal/object-preview-modal"));

var _testNodeModal = _interopRequireDefault(require("./modals/test-node-modal/test-node-modal"));

var _editAccountS3AccessModal = _interopRequireDefault(require("./modals/edit-account-s3-access-modal/edit-account-s3-access-modal"));

var _editServerDetailsModal = _interopRequireDefault(require("./modals/edit-server-details-modal/edit-server-details-modal"));

var _createAccountModal = _interopRequireDefault(require("./modals/create-account-modal/create-account-modal"));

var _accountCreatedModal = _interopRequireDefault(require("./modals/account-created-modal/account-created-modal"));

var _editBucketQuotaModal = _interopRequireDefault(require("./modals/edit-bucket-quota-modal/edit-bucket-quota-modal"));

var _setAccountIpRestrictionsModal = _interopRequireDefault(require("./modals/set-account-ip-restrictions-modal/set-account-ip-restrictions-modal"));

var _connectAppModal = _interopRequireDefault(require("./modals/connect-app-modal/connect-app-modal"));

var _createNamespaceResourceModal = _interopRequireDefault(require("./modals/create-namespace-resource-modal/create-namespace-resource-modal"));

var _createNamespaceBucketModal = _interopRequireDefault(require("./modals/create-namespace-bucket-modal/create-namespace-bucket-modal"));

var _editNamespaceBucketDataPlacementModal = _interopRequireDefault(require("./modals/edit-namespace-bucket-data-placement-modal/edit-namespace-bucket-data-placement-modal"));

var _emptyDataPlacementWarningModal = _interopRequireDefault(require("./modals/empty-data-placement-warning-modal/empty-data-placement-warning-modal"));

var _setNodeAsTrustedModal = _interopRequireDefault(require("./modals/set-node-as-trusted-modal/set-node-as-trusted-modal"));

var _editBucketDataResiliencyModal = _interopRequireDefault(require("./modals/edit-bucket-data-resiliency-modal/edit-bucket-data-resiliency-modal"));

var _riskyBucketDataResiliencyWarningModal = _interopRequireDefault(require("./modals/risky-bucket-data-resiliency-warning-modal/risky-bucket-data-resiliency-warning-modal"));

var _changeClusterConnectivityIpModal = _interopRequireDefault(require("./modals/change-cluster-connectivity-ip-modal/change-cluster-connectivity-ip-modal"));

var _managementConsoleErrorModal = _interopRequireDefault(require("./modals/management-console-error-modal/management-console-error-modal"));

var _addBucketTriggerModal = _interopRequireDefault(require("./modals/add-bucket-trigger-modal/add-bucket-trigger-modal"));

var _editBucketTriggerModal = _interopRequireDefault(require("./modals/edit-bucket-trigger-modal/edit-bucket-trigger-modal"));

var _attachServerModal = _interopRequireDefault(require("./modals/attach-server-modal/attach-server-modal"));

var _createFuncModal = _interopRequireDefault(require("./modals/create-func-modal/create-func-modal"));

var _createBucketModal = _interopRequireDefault(require("./modals/create-bucket-modal/create-bucket-modal"));

var _assignRegionModal = _interopRequireDefault(require("./modals/assign-region-modal/assign-region-modal"));

var _changePasswordModal = _interopRequireDefault(require("./modals/change-password-modal/change-password-modal"));

var _resetPasswordModal = _interopRequireDefault(require("./modals/reset-password-modal/reset-password-modal"));

var _passwordResetCompletedModal = _interopRequireDefault(require("./modals/password-reset-completed-modal/password-reset-completed-modal"));

var _passwordResetFailedModal = _interopRequireDefault(require("./modals/password-reset-failed-modal/password-reset-failed-modal"));

var _editFuncConfigModal = _interopRequireDefault(require("./modals/edit-func-config-modal/edit-func-config-modal"));

var _invokeFuncModal = _interopRequireDefault(require("./modals/invoke-func-modal/invoke-func-modal"));

var _editFuncCodeModal = _interopRequireDefault(require("./modals/edit-func-code-modal/edit-func-code-modal"));

var _bucketPlacementSummaryModal = _interopRequireDefault(require("./modals/bucket-placement-summary-modal/bucket-placement-summary-modal"));

var _keepUsingInternalStorageModal = _interopRequireDefault(require("./modals/keep-using-internal-storage-modal/keep-using-internal-storage-modal"));

var _addResourcesModal = _interopRequireDefault(require("./modals/add-resources-modal/add-resources-modal"));

var _regenerateAccountCredentialsModal = _interopRequireDefault(require("./modals/regenerate-account-credentials-modal/regenerate-account-credentials-modal"));

var _editTierDataPlacementModal = _interopRequireDefault(require("./modals/edit-tier-data-placement-modal/edit-tier-data-placement-modal"));

var _addTierModal = _interopRequireDefault(require("./modals/add-tier-modal/add-tier-modal"));

var _sessionExpiredModal = _interopRequireDefault(require("./modals/session-expired-modal/session-expired-modal"));

var _deployK8sPoolModal = _interopRequireDefault(require("./modals/deploy-k8s-pool-modal/deploy-k8s-pool-modal"));

var _editK8sPoolModal = _interopRequireDefault(require("./modals/edit-k8s-pool-modal/edit-k8s-pool-modal"));

var _deletePoolWithDataWarningModal = _interopRequireDefault(require("./modals/delete-pool-with-data-warning-modal/delete-pool-with-data-warning-modal"));

var _confirmDangerousScalingModal = _interopRequireDefault(require("./modals/confirm-dangerous-scaling-modal/confirm-dangerous-scaling-modal"));

var _editCloudConnectionModal = _interopRequireDefault(require("./modals/edit-cloud-connection-modal/edit-cloud-connection-modal"));

var _cloudConnectionUpdateWarningModal = _interopRequireDefault(require("./modals/cloud-connection-update-warning-modal/cloud-connection-update-warning-modal"));

var _completeSslCertificateInstallationModal = _interopRequireDefault(require("./modals/complete-ssl-certificate-installation-modal/complete-ssl-certificate-installation-modal"));

var _deployRemoteEndpointGroupModal = _interopRequireDefault(require("./modals/deploy-remote-endpoint-group-modal/deploy-remote-endpoint-group-modal"));

var _editEndpointGroupModal = _interopRequireDefault(require("./modals/edit-endpoint-group-modal/edit-endpoint-group-modal"));

var _oauthAccessDeniedModal = _interopRequireDefault(require("./modals/oauth-access-denied-modal/oauth-access-denied-modal"));

var _oauthUnauthorizedModal = _interopRequireDefault(require("./modals/oauth-unauthorized-modal/oauth-unauthorized-modal"));

var _overviewPanel = _interopRequireDefault(require("./overview/overview-panel/overview-panel"));

var _bucketsOverview = _interopRequireDefault(require("./overview/buckets-overview/buckets-overview"));

var _resourceOverview = _interopRequireDefault(require("./overview/resource-overview/resource-overview"));

var _storageOverview = _interopRequireDefault(require("./overview/storage-overview/storage-overview"));

var _clusterOverview = _interopRequireDefault(require("./overview/cluster-overview/cluster-overview"));

var _alertsOverview = _interopRequireDefault(require("./overview/alerts-overview/alerts-overview"));

var _bucketsPanel = _interopRequireDefault(require("./buckets/buckets-panel/buckets-panel"));

var _bucketsTable = _interopRequireDefault(require("./buckets/buckets-table/buckets-table"));

var _namespaceBucketsTable = _interopRequireDefault(require("./buckets/namespace-buckets-table/namespace-buckets-table"));

var _bucketsSummary = _interopRequireDefault(require("./buckets/buckets-summary/buckets-summary"));

var _bucketPanel = _interopRequireDefault(require("./bucket/bucket-panel/bucket-panel"));

var _bucketSummary = _interopRequireDefault(require("./bucket/bucket-summary/bucket-summary"));

var _bucketObjectsTable = _interopRequireDefault(require("./bucket/bucket-objects-table/bucket-objects-table"));

var _bucketDataPoliciesForm = _interopRequireDefault(require("./bucket/bucket-data-policies-form/bucket-data-policies-form"));

var _bucketDataResiliencyPolicyForm = _interopRequireDefault(require("./bucket/bucket-data-resiliency-policy-form/bucket-data-resiliency-policy-form"));

var _bucketQuotaPolicyForm = _interopRequireDefault(require("./bucket/bucket-quota-policy-form/bucket-quota-policy-form"));

var _bucketVersioningPolicyForm = _interopRequireDefault(require("./bucket/bucket-versioning-policy-form/bucket-versioning-policy-form"));

var _bucketS3AccessPolicyForm = _interopRequireDefault(require("./bucket/bucket-s3-access-policy-form/bucket-s3-access-policy-form"));

var _bucketTriggersForm = _interopRequireDefault(require("./bucket/bucket-triggers-form/bucket-triggers-form"));

var _bucketDataPlacementForm = _interopRequireDefault(require("./bucket/bucket-data-placement-form/bucket-data-placement-form"));

var _tierDataPlacementPolicyForm = _interopRequireDefault(require("./bucket/tier-data-placement-policy-form/tier-data-placement-policy-form"));

var _namespaceBucketPanel = _interopRequireDefault(require("./namespace-bucket/namespace-bucket-panel/namespace-bucket-panel"));

var _namespaceBucketSummary = _interopRequireDefault(require("./namespace-bucket/namespace-bucket-summary/namespace-bucket-summary"));

var _namespaceBucketDataPlacementForm = _interopRequireDefault(require("./namespace-bucket/namespace-bucket-data-placement-form/namespace-bucket-data-placement-form"));

var _namespaceBucketS3AccessForm = _interopRequireDefault(require("./namespace-bucket/namespace-bucket-s3-access-form/namespace-bucket-s3-access-form"));

var _namespaceBucketTriggersForm = _interopRequireDefault(require("./namespace-bucket/namespace-bucket-triggers-form/namespace-bucket-triggers-form"));

var _objectPanel = _interopRequireDefault(require("./object/object-panel/object-panel"));

var _objectSummary = _interopRequireDefault(require("./object/object-summary/object-summary"));

var _objectProperties = _interopRequireDefault(require("./object/object-properties/object-properties"));

var _objectPartsList = _interopRequireDefault(require("./object/object-parts-list/object-parts-list"));

var _resourcesPanel = _interopRequireDefault(require("./resources/resources-panel/resources-panel"));

var _resourcesSummary = _interopRequireDefault(require("./resources/resources-summary/resources-summary"));

var _storageResourcesTable = _interopRequireDefault(require("./resources/storage-resources-table/storage-resources-table"));

var _namespaceResourcesTable = _interopRequireDefault(require("./resources/namespace-resources-table/namespace-resources-table"));

var _poolPanel = _interopRequireDefault(require("./pool/pool-panel/pool-panel"));

var _poolSummary = _interopRequireDefault(require("./pool/pool-summary/pool-summary"));

var _poolHostsTable = _interopRequireDefault(require("./pool/pool-hosts-table/pool-hosts-table"));

var _cloudResourcePanel = _interopRequireDefault(require("./cloud-resource/cloud-resource-panel/cloud-resource-panel"));

var _cloudResourceSummary = _interopRequireDefault(require("./cloud-resource/cloud-resource-summary/cloud-resource-summary"));

var _cloudResourcePropertiesForm = _interopRequireDefault(require("./cloud-resource/cloud-resource-properties-form/cloud-resource-properties-form"));

var _hostPanel = _interopRequireDefault(require("./host/host-panel/host-panel"));

var _hostSummary = _interopRequireDefault(require("./host/host-summary/host-summary"));

var _hostDetailsForm = _interopRequireDefault(require("./host/host-details-form/host-details-form"));

var _hostDiagnosticsForm = _interopRequireDefault(require("./host/host-diagnostics-form/host-diagnostics-form"));

var _managementPanel = _interopRequireDefault(require("./management/management-panel/management-panel"));

var _p2pForm = _interopRequireDefault(require("./management/p2p-form/p2p-form"));

var _versionForm = _interopRequireDefault(require("./management/version-form/version-form"));

var _diagnosticsForm = _interopRequireDefault(require("./management/diagnostics-form/diagnostics-form"));

var _maintenanceForm = _interopRequireDefault(require("./management/maintenance-form/maintenance-form"));

var _sslCertificateForm = _interopRequireDefault(require("./management/ssl-certificate-form/ssl-certificate-form"));

var _virtualHostingForm = _interopRequireDefault(require("./management/virtual-hosting-form/virtual-hosting-form"));

var _accountsPanel = _interopRequireDefault(require("./accounts/accounts-panel/accounts-panel"));

var _accountsTable = _interopRequireDefault(require("./accounts/accounts-table/accounts-table"));

var _accountPanel = _interopRequireDefault(require("./account/account-panel/account-panel"));

var _accountDetailsForm = _interopRequireDefault(require("./account/account-details-form/account-details-form"));

var _accountS3AccessForm = _interopRequireDefault(require("./account/account-s3-access-form/account-s3-access-form"));

var _accountConnectionsList = _interopRequireDefault(require("./account/account-connections-list/account-connections-list"));

var _clusterPanel = _interopRequireDefault(require("./cluster/cluster-panel/cluster-panel"));

var _serverTable = _interopRequireDefault(require("./cluster/server-table/server-table"));

var _clusterSummary = _interopRequireDefault(require("./cluster/cluster-summary/cluster-summary"));

var _funcsPanel = _interopRequireDefault(require("./funcs/funcs-panel/funcs-panel"));

var _funcsTable = _interopRequireDefault(require("./funcs/funcs-table/funcs-table"));

var _funcPanel = _interopRequireDefault(require("./func/func-panel/func-panel"));

var _funcSummary = _interopRequireDefault(require("./func/func-summary/func-summary"));

var _funcConfigForm = _interopRequireDefault(require("./func/func-config-form/func-config-form"));

var _funcCodeForm = _interopRequireDefault(require("./func/func-code-form/func-code-form"));

var _funcMonitoringForm = _interopRequireDefault(require("./func/func-monitoring-form/func-monitoring-form"));

var _funcTriggersForm = _interopRequireDefault(require("./func/func-triggers-form/func-triggers-form"));

var _analyticsPanel = _interopRequireDefault(require("./analytics/analytics-panel/analytics-panel"));

var _analyticsResourceDistributionForm = _interopRequireDefault(require("./analytics/analytics-resource-distribution-form/analytics-resource-distribution-form"));

var _bucketUsageForm = _interopRequireDefault(require("./analytics/bucket-usage-form/bucket-usage-form"));

var _accountUsageForm = _interopRequireDefault(require("./analytics/account-usage-form/account-usage-form"));

var _objectsDistributionForm = _interopRequireDefault(require("./analytics/objects-distribution-form/objects-distribution-form"));

var _cloudUsageStatsForm = _interopRequireDefault(require("./analytics/cloud-usage-stats-form/cloud-usage-stats-form"));

var _dataBreakdownForm = _interopRequireDefault(require("./analytics/data-breakdown-form/data-breakdown-form"));

var _endpointsPanel = _interopRequireDefault(require("./endpoints/endpoints-panel/endpoints-panel"));

var _endpointsSummary = _interopRequireDefault(require("./endpoints/endpoints-summary/endpoints-summary"));

var _endpointGroupsTable = _interopRequireDefault(require("./endpoints/endpoint-groups-table/endpoint-groups-table"));

var _endpointGroupsScalingForm = _interopRequireDefault(require("./endpoints/endpoint-groups-scaling-form/endpoint-groups-scaling-form"));

var _auditPane = _interopRequireDefault(require("./admin/audit-pane/audit-pane"));

var _alertsPane = _interopRequireDefault(require("./admin/alerts-pane/alerts-pane"));

var _svgIcon = _interopRequireDefault(require("./shared/svg-icon/svg-icon"));

var _dropdown = _interopRequireDefault(require("./shared/dropdown/dropdown"));

var _radioBtn = _interopRequireDefault(require("./shared/radio-btn/radio-btn"));

var _radioGroup = _interopRequireDefault(require("./shared/radio-group/radio-group"));

var _checkbox = _interopRequireDefault(require("./shared/checkbox/checkbox"));

var _bar = _interopRequireDefault(require("./shared/bar/bar"));

var _rangeIndicator = _interopRequireDefault(require("./shared/range-indicator/range-indicator"));

var _stepper = _interopRequireDefault(require("./shared/stepper/stepper"));

var _multiselect = _interopRequireDefault(require("./shared/multiselect/multiselect"));

var _slider = _interopRequireDefault(require("./shared/slider/slider"));

var _paginator = _interopRequireDefault(require("./shared/paginator/paginator"));

var _drawer = _interopRequireDefault(require("./shared/drawer/drawer"));

var _deleteButton = _interopRequireDefault(require("./shared/delete-button/delete-button"));

var _fileSelector = _interopRequireDefault(require("./shared/file-selector/file-selector"));

var _autocomplete = _interopRequireDefault(require("./shared/autocomplete/autocomplete"));

var _editor = _interopRequireDefault(require("./shared/editor/editor"));

var _toggleSwitch = _interopRequireDefault(require("./shared/toggle-switch/toggle-switch"));

var _propertySheet = _interopRequireDefault(require("./shared/property-sheet/property-sheet"));

var _capacityBar = _interopRequireDefault(require("./shared/capacity-bar/capacity-bar"));

var _toggleGroup = _interopRequireDefault(require("./shared/toggle-group/toggle-group"));

var _dataTable = _interopRequireDefault(require("./shared/data-table/data-table"));

var _timezoneChooser = _interopRequireDefault(require("./shared/timezone-chooser/timezone-chooser"));

var _dateTimeChooser = _interopRequireDefault(require("./shared/date-time-chooser/date-time-chooser"));

var _pieChart = _interopRequireDefault(require("./shared/pie-chart/pie-chart"));

var _chartLegend = _interopRequireDefault(require("./shared/chart-legend/chart-legend"));

var _copyToClipboardButton = _interopRequireDefault(require("./shared/copy-to-clipboard-button/copy-to-clipboard-button"));

var _passwordField = _interopRequireDefault(require("./shared/password-field/password-field"));

var _workingButton = _interopRequireDefault(require("./shared/working-button/working-button"));

var _collapsibleSection = _interopRequireDefault(require("./shared/collapsible-section/collapsible-section"));

var _chartjs = _interopRequireDefault(require("./shared/chartjs/chartjs"));

var _breadcrumbs = _interopRequireDefault(require("./shared/breadcrumbs/breadcrumbs"));

var _sideNav = _interopRequireDefault(require("./shared/side-nav/side-nav"));

var _tokenField = _interopRequireDefault(require("./shared/token-field/token-field"));

var _validationMessage = _interopRequireDefault(require("./shared/validation-message/validation-message"));

var _validationRulesList = _interopRequireDefault(require("./shared/validation-rules-list/validation-rules-list"));

var _validationIndicator = _interopRequireDefault(require("./shared/validation-indicator/validation-indicator"));

var _loadingIndicator = _interopRequireDefault(require("./shared/loading-indicator/loading-indicator"));

var _dropArea = _interopRequireDefault(require("./shared/drop-area/drop-area"));

var _wizard = _interopRequireDefault(require("./shared/wizard/wizard"));

var _wizardControls = _interopRequireDefault(require("./shared/wizard-controls/wizard-controls"));

var _managedForm = _interopRequireDefault(require("./shared/managed-form/managed-form"));

var _buttonGroup = _interopRequireDefault(require("./shared/button-group/button-group"));

var _resourceAssociatedAccountList = _interopRequireDefault(require("./shared/resource-associated-account-list/resource-associated-account-list"));

var _resourceConnectedBucketsForm = _interopRequireDefault(require("./shared/resource-connected-buckets-form/resource-connected-buckets-form"));

var _resourceDistributionTable = _interopRequireDefault(require("./shared/resource-distribution-table/resource-distribution-table"));

var _resourceDistributionChart = _interopRequireDefault(require("./shared/resource-distribution-chart/resource-distribution-chart"));

var _hostPartsTable = _interopRequireDefault(require("./shared/host-parts-table/host-parts-table"));

var _counter = _interopRequireDefault(require("./shared/counter/counter"));

var _listDetails = _interopRequireDefault(require("./shared/list-details/list-details"));

var _codeViewer = _interopRequireDefault(require("./shared/code-viewer/code-viewer"));

var _resourcesSelectionTable = _interopRequireDefault(require("./shared/resources-selection-table/resources-selection-table"));

var _placementPolicyToggle = _interopRequireDefault(require("./shared/placement-policy-toggle/placement-policy-toggle"));

var _tagList = _interopRequireDefault(require("./shared/tag-list/tag-list"));

var _moreInfoIcon = _interopRequireDefault(require("./shared/more-info-icon/more-info-icon"));

var _progressBar = _interopRequireDefault(require("./shared/progress-bar/progress-bar"));

var _gaugeChart = _interopRequireDefault(require("./shared/gauge-chart/gauge-chart"));

/* Copyright (C) 2016 NooBaa */
// -------------------------------
// Top level components
// -------------------------------

/** INJECT:application.import **/
// -------------------------------
// Login layout components
// -------------------------------

/** INJECT:login.import **/
// -------------------------------
// Main layout components
// -------------------------------

/** INJECT:main.import **/
// -------------------------------
// Sticky components
// -------------------------------

/** INJECT:stickies.import **/
// -------------------------------
// Modal components
// -------------------------------

/** INJECT:modals.import **/
// -------------------------------
// Overview page components
// -------------------------------

/** INJECT:overview.import **/
// -------------------------------
// Buckets page components
// -------------------------------

/** INJECT:bucket.import **/
// -------------------------------
// Bucket page components
// -------------------------------

/** INJECT:bucket.import **/
// -------------------------------
// Namespace bucket page components
// -------------------------------

/** INJECT:namespace-bucket.import **/
// -------------------------------
// Object page components
// -------------------------------

/** INJECT:object.import **/
// -------------------------------
// Resources page components
// -------------------------------

/** INJECT:resources.import **/
// -------------------------------
// Pool page components
// -------------------------------

/** INJECT:pool.import **/
// -------------------------------
// Cloud resource page components
// -------------------------------

/** INJECT:cloud-resource.import **/
// -------------------------------
// Host page components
// -------------------------------

/** INJECT:host.import **/
// -------------------------------
// Management page components
// -------------------------------

/** INJECT:management.import **/
// -------------------------------
// Accounts page components
// -------------------------------

/** INJECT:accounts.import **/
// -------------------------------
// Account page components
// -------------------------------

/** INJECT:account.import **/
// -------------------------------
// Cluster page components
// -------------------------------

/** INJECT:cluster.import **/
// -------------------------------
// Server page components
// -------------------------------
// import serverPanel from './server/server-panel/server-panel';
// import serverSummary from './server/server-summary/server-summary';
// import serverMonitoringForm from './server/server-monitoring-form/server-monitoring-form';
// import serverDiagnosticsForm from './server/server-diagnostics-form/server-diagnostics-form';
// import serverCommunicationForm from './server/server-communication-form/server-communication-form';
// import serverDetailsForm from './server/server-details-form/server-details-form';

/** INJECT:server.import **/
// -------------------------------
// Functions page components
// -------------------------------

/** INJECT:funcs.import **/
// -------------------------------
// Function page components
// -------------------------------

/** INJECT:func.import **/
// -------------------------------
// Analytics page components
// -------------------------------

/** INJECT:analytics.import **/
// -------------------------------
// Analytics page components
// -------------------------------

/** INJECT:endpoints.import **/
// -------------------------------
// Admin components
// -------------------------------

/** INJECT:admin.import **/
// -------------------------------
// Shared components
// -------------------------------

/** INJECT:shared.import **/
// Register the components with knockout component container.
function register(ko, services) {
  // A view model loader that inject services into the view model
  // constructors.
  function loadViewModel(name, vmConfig, callback) {
    if ((0, _coreUtils.isFunction)(vmConfig)) {
      callback(params => new vmConfig(params, services));
    } else if ((0, _coreUtils.isFunction)(vmConfig.createViewModel)) {
      callback((params, compInfo) => vmConfig.createViewModel(params, compInfo, services));
    } else {
      callback(null);
    }
  } // Register the custom loader.


  ko.components.loaders.unshift({
    loadViewModel
  }); // Register the components.

  Object.entries({
    app: _app.default,
    mainLayout: _mainLayout.default,
    loginLayout: _loginLayout.default,
    modalManager: _modalManager.default,
    exitConfirmationMessage: _exitConfirmationMessage.default,

    /** INJECT:application.list **/
    signinForm: _signinForm.default,
    createSystemForm: _createSystemForm.default,
    unsupportedForm: _unsupportedForm.default,
    changePasswordForm: _changePasswordForm.default,
    splashScreen: _splashScreen.default,
    oauthCallback: _oauthCallback.default,

    /** INJECT:login.list **/
    commandsBar: _commandsBar.default,
    notificationBox: _notificationBox.default,
    accountMenu: _accountMenu.default,
    uploadsIndicator: _uploadsIndicator.default,

    /** INJECT:main.list **/
    debugModeSticky: _debugModeSticky.default,
    maintenanceSticky: _maintenanceSticky.default,
    phoneHomeConnectivitySticky: _phoneHomeConnectivitySticky.default,
    clusterAvailabilitySticky: _clusterAvailabilitySticky.default,
    preferedBrowsersSticky: _preferedBrowsersSticky.default,

    /** INJECT:stickies.list **/
    welcomeModal: _welcomeModal.default,
    addCloudResourceModal: _addCloudResourceModal.default,
    addCloudConnectionModal: _addCloudConnectionModal.default,
    s3AccessDetailsModal: _s3AccessDetailsModal.default,
    editBucketS3AccessModal: _editBucketS3AccessModal.default,
    startMaintenanceModal: _startMaintenanceModal.default,
    fileUploadsModal: _fileUploadsModal.default,
    deleteCurrentAccountWarningModal: _deleteCurrentAccountWarningModal.default,
    objectPreviewModal: _objectPreviewModal.default,
    testNodeModal: _testNodeModal.default,
    editAccountS3AccessModal: _editAccountS3AccessModal.default,
    editServerDetailsModal: _editServerDetailsModal.default,
    createAccountModal: _createAccountModal.default,
    accountCreatedModal: _accountCreatedModal.default,
    editBucketQuotaModal: _editBucketQuotaModal.default,
    setAccountIpRestrictionsModal: _setAccountIpRestrictionsModal.default,
    connectAppModal: _connectAppModal.default,
    createNamespaceResourceModal: _createNamespaceResourceModal.default,
    createNamespaceBucketModal: _createNamespaceBucketModal.default,
    editNamespaceBucketDataPlacementModal: _editNamespaceBucketDataPlacementModal.default,
    emptyDataPlacementWarningModal: _emptyDataPlacementWarningModal.default,
    setNodeAsTrustedModal: _setNodeAsTrustedModal.default,
    editBucketDataResiliencyModal: _editBucketDataResiliencyModal.default,
    riskyBucketDataResiliencyWarningModal: _riskyBucketDataResiliencyWarningModal.default,
    changeClusterConnectivityIpModal: _changeClusterConnectivityIpModal.default,
    managementConsoleErrorModal: _managementConsoleErrorModal.default,
    addBucketTriggerModal: _addBucketTriggerModal.default,
    editBucketTriggerModal: _editBucketTriggerModal.default,
    attachServerModal: _attachServerModal.default,
    createFuncModal: _createFuncModal.default,
    createBucketModal: _createBucketModal.default,
    assignRegionModal: _assignRegionModal.default,
    changePasswordModal: _changePasswordModal.default,
    resetPasswordModal: _resetPasswordModal.default,
    passwordResetCompletedModal: _passwordResetCompletedModal.default,
    passwordResetFailedModal: _passwordResetFailedModal.default,
    editFuncConfigModal: _editFuncConfigModal.default,
    invokeFuncModal: _invokeFuncModal.default,
    editFuncCodeModal: _editFuncCodeModal.default,
    bucketPlacementSummaryModal: _bucketPlacementSummaryModal.default,
    keepUsingInternalStorageModal: _keepUsingInternalStorageModal.default,
    addResourcesModal: _addResourcesModal.default,
    regenerateAccountCredentialsModal: _regenerateAccountCredentialsModal.default,
    editTierDataPlacementModal: _editTierDataPlacementModal.default,
    addTierModal: _addTierModal.default,
    sessionExpiredModal: _sessionExpiredModal.default,
    deployK8sPoolModal: _deployK8sPoolModal.default,
    editK8sPoolModal: _editK8sPoolModal.default,
    deletePoolWithDataWarningModal: _deletePoolWithDataWarningModal.default,
    confirmDangerousScalingModal: _confirmDangerousScalingModal.default,
    editCloudConnectionModal: _editCloudConnectionModal.default,
    cloudConnectionUpdateWarningModal: _cloudConnectionUpdateWarningModal.default,
    completeSslCertificateInstallationModal: _completeSslCertificateInstallationModal.default,
    deployRemoteEndpointGroupModal: _deployRemoteEndpointGroupModal.default,
    editEndpointGroupModal: _editEndpointGroupModal.default,
    oauthAccessDeniedModal: _oauthAccessDeniedModal.default,
    oauthUnauthorizedModal: _oauthUnauthorizedModal.default,

    /** INJECT:modals.list **/
    overviewPanel: _overviewPanel.default,
    bucketsOverview: _bucketsOverview.default,
    resourceOverview: _resourceOverview.default,
    storageOverview: _storageOverview.default,
    clusterOverview: _clusterOverview.default,
    alertsOverview: _alertsOverview.default,

    /** INJECT:overview.list **/
    bucketsPanel: _bucketsPanel.default,
    bucketsTable: _bucketsTable.default,
    namespaceBucketsTable: _namespaceBucketsTable.default,
    bucketsSummary: _bucketsSummary.default,

    /** INJECT:buckets.list **/
    bucketPanel: _bucketPanel.default,
    bucketSummary: _bucketSummary.default,
    bucketObjectsTable: _bucketObjectsTable.default,
    bucketDataPoliciesForm: _bucketDataPoliciesForm.default,
    bucketDataResiliencyPolicyForm: _bucketDataResiliencyPolicyForm.default,
    bucketQuotaPolicyForm: _bucketQuotaPolicyForm.default,
    bucketVersioningPolicyForm: _bucketVersioningPolicyForm.default,
    bucketS3AccessPolicyForm: _bucketS3AccessPolicyForm.default,
    bucketTriggersForm: _bucketTriggersForm.default,
    bucketDataPlacementForm: _bucketDataPlacementForm.default,
    tierDataPlacementPolicyForm: _tierDataPlacementPolicyForm.default,

    /** INJECT:bucket.list **/
    namespaceBucketPanel: _namespaceBucketPanel.default,
    namespaceBucketSummary: _namespaceBucketSummary.default,
    namespaceBucketDataPlacementForm: _namespaceBucketDataPlacementForm.default,
    namespaceBucketS3AccessForm: _namespaceBucketS3AccessForm.default,
    namespaceBucketTriggersForm: _namespaceBucketTriggersForm.default,

    /** INJECT:namespace-bucket.list **/
    objectPanel: _objectPanel.default,
    objectSummary: _objectSummary.default,
    objectProperties: _objectProperties.default,
    objectPartsList: _objectPartsList.default,

    /** INJECT:object.list **/
    resourcesPanel: _resourcesPanel.default,
    resourcesSummary: _resourcesSummary.default,
    storageResourcesTable: _storageResourcesTable.default,
    namespaceResourcesTable: _namespaceResourcesTable.default,

    /** INJECT:resources.list **/
    poolPanel: _poolPanel.default,
    poolSummary: _poolSummary.default,
    poolHostsTable: _poolHostsTable.default,

    /** INJECT:pool.list **/
    cloudResourcePanel: _cloudResourcePanel.default,
    cloudResourceSummary: _cloudResourceSummary.default,
    cloudResourcePropertiesForm: _cloudResourcePropertiesForm.default,

    /** INJECT:cloud-resource.list **/
    hostPanel: _hostPanel.default,
    hostSummary: _hostSummary.default,
    hostDetailsForm: _hostDetailsForm.default,
    hostDiagnosticsForm: _hostDiagnosticsForm.default,

    /** INJECT:host.list **/
    managementPanel: _managementPanel.default,
    p2pForm: _p2pForm.default,
    versionForm: _versionForm.default,
    diagnosticsForm: _diagnosticsForm.default,
    maintenanceForm: _maintenanceForm.default,
    sslCertificateForm: _sslCertificateForm.default,
    virtualHostingForm: _virtualHostingForm.default,

    /** INJECT:management.list **/
    accountsPanel: _accountsPanel.default,
    accountsTable: _accountsTable.default,

    /** INJECT:accounts.list **/
    accountPanel: _accountPanel.default,
    accountDetailsForm: _accountDetailsForm.default,
    accountS3AccessForm: _accountS3AccessForm.default,
    accountConnectionsList: _accountConnectionsList.default,

    /** INJECT:account.list **/
    clusterPanel: _clusterPanel.default,
    serverTable: _serverTable.default,
    clusterSummary: _clusterSummary.default,

    /** INJECT:cluster.list **/
    // serverPanel,
    // serverSummary,
    // serverMonitoringForm,
    // serverDiagnosticsForm,
    // serverCommunicationForm,
    // serverDetailsForm,

    /** INJECT:server.list **/
    funcsPanel: _funcsPanel.default,
    funcsTable: _funcsTable.default,

    /** INJECT:funcs.list **/
    funcPanel: _funcPanel.default,
    funcSummary: _funcSummary.default,
    funcConfigForm: _funcConfigForm.default,
    funcCodeForm: _funcCodeForm.default,
    funcTriggersForm: _funcTriggersForm.default,
    funcMonitoringForm: _funcMonitoringForm.default,

    /** INJECT:func.list **/
    analyticsPanel: _analyticsPanel.default,
    analyticsResourceDistributionForm: _analyticsResourceDistributionForm.default,
    bucketUsageForm: _bucketUsageForm.default,
    accountUsageForm: _accountUsageForm.default,
    objectsDistributionForm: _objectsDistributionForm.default,
    cloudUsageStatsForm: _cloudUsageStatsForm.default,
    dataBreakdownForm: _dataBreakdownForm.default,

    /** INJECT:analytics.list **/
    endpointsPanel: _endpointsPanel.default,
    endpointsSummary: _endpointsSummary.default,
    endpointGroupsTable: _endpointGroupsTable.default,
    endpointGroupsScalingForm: _endpointGroupsScalingForm.default,

    /** INJECT:endpoints.list **/
    auditPane: _auditPane.default,
    alertsPane: _alertsPane.default,

    /** INJECT:admin.list **/
    svgIcon: _svgIcon.default,
    dropdown: _dropdown.default,
    radioBtn: _radioBtn.default,
    radioGroup: _radioGroup.default,
    checkbox: _checkbox.default,
    bar: _bar.default,
    rangeIndicator: _rangeIndicator.default,
    stepper: _stepper.default,
    multiselect: _multiselect.default,
    slider: _slider.default,
    paginator: _paginator.default,
    drawer: _drawer.default,
    deleteButton: _deleteButton.default,
    fileSelector: _fileSelector.default,
    autocomplete: _autocomplete.default,
    editor: _editor.default,
    toggleSwitch: _toggleSwitch.default,
    propertySheet: _propertySheet.default,
    capacityBar: _capacityBar.default,
    toggleGroup: _toggleGroup.default,
    dataTable: _dataTable.default,
    timezoneChooser: _timezoneChooser.default,
    dateTimeChooser: _dateTimeChooser.default,
    pieChart: _pieChart.default,
    chartLegend: _chartLegend.default,
    copyToClipboardButton: _copyToClipboardButton.default,
    passwordField: _passwordField.default,
    workingButton: _workingButton.default,
    collapsibleSection: _collapsibleSection.default,
    chartjs: _chartjs.default,
    breadcrumbs: _breadcrumbs.default,
    sideNav: _sideNav.default,
    tokenField: _tokenField.default,
    validationMessage: _validationMessage.default,
    validationRulesList: _validationRulesList.default,
    validationIndicator: _validationIndicator.default,
    loadingIndicator: _loadingIndicator.default,
    dropArea: _dropArea.default,
    wizard: _wizard.default,
    wizardControls: _wizardControls.default,
    managedForm: _managedForm.default,
    buttonGroup: _buttonGroup.default,
    resourceAssociatedAccountList: _resourceAssociatedAccountList.default,
    resourceConnectedBucketsForm: _resourceConnectedBucketsForm.default,
    resourceDistributionTable: _resourceDistributionTable.default,
    resourceDistributionChart: _resourceDistributionChart.default,
    hostPartsTable: _hostPartsTable.default,
    counter: _counter.default,
    listDetails: _listDetails.default,
    codeViewer: _codeViewer.default,
    resourcesSelectionTable: _resourcesSelectionTable.default,
    placementPolicyToggle: _placementPolicyToggle.default,
    tagList: _tagList.default,
    moreInfoIcon: _moreInfoIcon.default,
    progressBar: _progressBar.default,
    gaugeChart: _gaugeChart.default,

    /** INJECT:shared.list **/
    // An empty component used for app/data loading periods
    empty: {
      template: ' '
    }
  }).forEach(pair => ko.components.register((0, _stringUtils.toDashedCase)(pair[0]), pair[1]));
}

},{"./account/account-connections-list/account-connections-list":357,"./account/account-details-form/account-details-form":359,"./account/account-panel/account-panel":361,"./account/account-s3-access-form/account-s3-access-form":363,"./accounts/accounts-panel/accounts-panel":365,"./accounts/accounts-table/accounts-table":367,"./admin/alerts-pane/alerts-pane":370,"./admin/audit-pane/audit-pane":372,"./analytics/account-usage-form/account-usage-form":375,"./analytics/analytics-panel/analytics-panel":377,"./analytics/analytics-resource-distribution-form/analytics-resource-distribution-form":379,"./analytics/bucket-usage-form/bucket-usage-form":381,"./analytics/cloud-usage-stats-form/cloud-usage-stats-form":383,"./analytics/data-breakdown-form/data-breakdown-form":385,"./analytics/objects-distribution-form/objects-distribution-form":387,"./application/app/app":389,"./application/exit-confirmation-message/exit-confirmation-message":391,"./application/login-layout/login-layout":393,"./application/main-layout/main-layout":395,"./application/modal-manager/modal-manager":398,"./bucket/bucket-data-placement-form/bucket-data-placement-form":401,"./bucket/bucket-data-policies-form/bucket-data-policies-form":403,"./bucket/bucket-data-resiliency-policy-form/bucket-data-resiliency-policy-form":405,"./bucket/bucket-objects-table/bucket-objects-table":407,"./bucket/bucket-panel/bucket-panel":410,"./bucket/bucket-quota-policy-form/bucket-quota-policy-form":412,"./bucket/bucket-s3-access-policy-form/bucket-s3-access-policy-form":414,"./bucket/bucket-summary/bucket-summary":416,"./bucket/bucket-triggers-form/bucket-triggers-form":419,"./bucket/bucket-versioning-policy-form/bucket-versioning-policy-form":421,"./bucket/tier-data-placement-policy-form/tier-data-placement-policy-form":423,"./buckets/buckets-panel/buckets-panel":425,"./buckets/buckets-summary/buckets-summary":427,"./buckets/buckets-table/buckets-table":429,"./buckets/namespace-buckets-table/namespace-buckets-table":432,"./cloud-resource/cloud-resource-panel/cloud-resource-panel":434,"./cloud-resource/cloud-resource-properties-form/cloud-resource-properties-form":436,"./cloud-resource/cloud-resource-summary/cloud-resource-summary":438,"./cluster/cluster-panel/cluster-panel":440,"./cluster/cluster-summary/cluster-summary":442,"./cluster/server-table/server-table":444,"./endpoints/endpoint-groups-scaling-form/endpoint-groups-scaling-form":448,"./endpoints/endpoint-groups-table/endpoint-groups-table":450,"./endpoints/endpoints-panel/endpoints-panel":452,"./endpoints/endpoints-summary/endpoints-summary":454,"./func/func-code-form/func-code-form":456,"./func/func-config-form/func-config-form":458,"./func/func-monitoring-form/func-monitoring-form":460,"./func/func-panel/func-panel":462,"./func/func-summary/func-summary":464,"./func/func-triggers-form/func-triggers-form":466,"./funcs/funcs-panel/funcs-panel":468,"./funcs/funcs-table/funcs-table":470,"./host/host-details-form/host-details-form":472,"./host/host-diagnostics-form/host-diagnostics-form":474,"./host/host-panel/host-panel":476,"./host/host-summary/host-summary":478,"./login/change-password-form/change-password-form":480,"./login/create-system-form/create-system-form":482,"./login/oauth-callback/oauth-callback":484,"./login/signin-form/signin-form":486,"./login/splash-screen/splash-screen":488,"./login/unsupported-form/unsupported-form":490,"./main/account-menu/account-menu":492,"./main/commands-bar/commands-bar":494,"./main/notification-box/notification-box":496,"./main/uploads-indicator/uploads-indicator":498,"./management/diagnostics-form/diagnostics-form":500,"./management/maintenance-form/maintenance-form":502,"./management/management-panel/management-panel":504,"./management/p2p-form/p2p-form":506,"./management/ssl-certificate-form/ssl-certificate-form":508,"./management/version-form/version-form":510,"./management/virtual-hosting-form/virtual-hosting-form":512,"./modals/account-created-modal/account-created-modal":514,"./modals/add-bucket-trigger-modal/add-bucket-trigger-modal":517,"./modals/add-cloud-connection-modal/add-cloud-connection-modal":519,"./modals/add-cloud-resource-modal/add-cloud-resource-modal":529,"./modals/add-resources-modal/add-resources-modal":531,"./modals/add-tier-modal/add-tier-modal":533,"./modals/assign-region-modal/assign-region-modal":536,"./modals/attach-server-modal/attach-server-modal":538,"./modals/bucket-placement-summary-modal/bucket-placement-summary-modal":540,"./modals/change-cluster-connectivity-ip-modal/change-cluster-connectivity-ip-modal":542,"./modals/change-password-modal/change-password-modal":544,"./modals/cloud-connection-update-warning-modal/cloud-connection-update-warning-modal":546,"./modals/complete-ssl-certificate-installation-modal/complete-ssl-certificate-installation-modal":548,"./modals/confirm-dangerous-scaling-modal/confirm-dangerous-scaling-modal":550,"./modals/connect-app-modal/connect-app-modal":552,"./modals/create-account-modal/create-account-modal":554,"./modals/create-bucket-modal/create-bucket-modal":556,"./modals/create-func-modal/create-func-modal":558,"./modals/create-namespace-bucket-modal/create-namespace-bucket-modal":560,"./modals/create-namespace-resource-modal/create-namespace-resource-modal":562,"./modals/delete-current-account-warning-modal/delete-current-account-warning-modal":564,"./modals/delete-pool-with-data-warning-modal/delete-pool-with-data-warning-modal":566,"./modals/deploy-k8s-pool-modal/deploy-k8s-pool-modal":568,"./modals/deploy-remote-endpoint-group-modal/deploy-remote-endpoint-group-modal":570,"./modals/edit-account-s3-access-modal/edit-account-s3-access-modal":572,"./modals/edit-bucket-data-resiliency-modal/edit-bucket-data-resiliency-modal":574,"./modals/edit-bucket-quota-modal/edit-bucket-quota-modal":576,"./modals/edit-bucket-s3-access-modal/edit-bucket-s3-access-modal":578,"./modals/edit-bucket-trigger-modal/edit-bucket-trigger-modal":580,"./modals/edit-cloud-connection-modal/edit-cloud-connection-modal":584,"./modals/edit-endpoint-group-modal/edit-endpoint-group-modal":590,"./modals/edit-func-code-modal/edit-func-code-modal":592,"./modals/edit-func-config-modal/edit-func-config-modal":594,"./modals/edit-k8s-pool-modal/edit-k8s-pool-modal":597,"./modals/edit-namespace-bucket-data-placement-modal/edit-namespace-bucket-data-placement-modal":599,"./modals/edit-server-details-modal/edit-server-details-modal":601,"./modals/edit-tier-data-placement-modal/edit-tier-data-placement-modal":603,"./modals/empty-data-placement-warning-modal/empty-data-placement-warning-modal":605,"./modals/file-uploads-modal/file-uploads-modal":607,"./modals/invoke-func-modal/invoke-func-modal":609,"./modals/keep-using-internal-storage-modal/keep-using-internal-storage-modal":611,"./modals/management-console-error-modal/management-console-error-modal":613,"./modals/oauth-access-denied-modal/oauth-access-denied-modal":615,"./modals/oauth-unauthorized-modal/oauth-unauthorized-modal":617,"./modals/object-preview-modal/object-preview-modal":619,"./modals/password-reset-completed-modal/password-reset-completed-modal":621,"./modals/password-reset-failed-modal/password-reset-failed-modal":624,"./modals/regenerate-account-credentials-modal/regenerate-account-credentials-modal":626,"./modals/reset-password-modal/reset-password-modal":628,"./modals/risky-bucket-data-resiliency-warning-modal/risky-bucket-data-resiliency-warning-modal":630,"./modals/s3-access-details-modal/s3-access-details-modal":632,"./modals/session-expired-modal/session-expired-modal":634,"./modals/set-account-ip-restrictions-modal/set-account-ip-restrictions-modal":636,"./modals/set-node-as-trusted-modal/set-node-as-trusted-modal":638,"./modals/start-maintenance-modal/start-maintenance-modal":640,"./modals/test-node-modal/test-node-modal":642,"./modals/welcome-modal/welcome-modal":645,"./namespace-bucket/namespace-bucket-data-placement-form/namespace-bucket-data-placement-form":647,"./namespace-bucket/namespace-bucket-panel/namespace-bucket-panel":649,"./namespace-bucket/namespace-bucket-s3-access-form/namespace-bucket-s3-access-form":651,"./namespace-bucket/namespace-bucket-summary/namespace-bucket-summary":653,"./namespace-bucket/namespace-bucket-triggers-form/namespace-bucket-triggers-form":655,"./object/object-panel/object-panel":657,"./object/object-parts-list/object-parts-list":659,"./object/object-properties/object-properties":662,"./object/object-summary/object-summary":664,"./overview/alerts-overview/alerts-overview":666,"./overview/buckets-overview/buckets-overview":668,"./overview/cluster-overview/cluster-overview":670,"./overview/overview-panel/overview-panel":672,"./overview/resource-overview/resource-overview":674,"./overview/storage-overview/storage-overview":676,"./pool/pool-hosts-table/pool-hosts-table":679,"./pool/pool-panel/pool-panel":681,"./pool/pool-summary/pool-summary":683,"./resources/namespace-resources-table/namespace-resources-table":686,"./resources/resources-panel/resources-panel":688,"./resources/resources-summary/resources-summary":690,"./resources/storage-resources-table/storage-resources-table":692,"./shared/autocomplete/autocomplete":694,"./shared/bar/bar":696,"./shared/breadcrumbs/breadcrumbs":698,"./shared/button-group/button-group":700,"./shared/capacity-bar/capacity-bar":702,"./shared/chart-legend/chart-legend":704,"./shared/chartjs/chartjs":708,"./shared/checkbox/checkbox":710,"./shared/code-viewer/code-viewer":713,"./shared/collapsible-section/collapsible-section":715,"./shared/copy-to-clipboard-button/copy-to-clipboard-button":717,"./shared/counter/counter":719,"./shared/data-table/data-table":732,"./shared/date-time-chooser/date-time-chooser":734,"./shared/delete-button/delete-button":736,"./shared/drawer/drawer":738,"./shared/drop-area/drop-area":740,"./shared/dropdown/dropdown":743,"./shared/editor/editor":746,"./shared/file-selector/file-selector":748,"./shared/gauge-chart/gauge-chart":750,"./shared/host-parts-table/host-parts-table":752,"./shared/list-details/list-details":754,"./shared/loading-indicator/loading-indicator":756,"./shared/managed-form/managed-form":758,"./shared/more-info-icon/more-info-icon":760,"./shared/multiselect/multiselect":762,"./shared/paginator/paginator":764,"./shared/password-field/password-field":766,"./shared/pie-chart/pie-chart":768,"./shared/placement-policy-toggle/placement-policy-toggle":770,"./shared/progress-bar/progress-bar":772,"./shared/property-sheet/property-sheet":774,"./shared/radio-btn/radio-btn":776,"./shared/radio-group/radio-group":778,"./shared/range-indicator/range-indicator":780,"./shared/resource-associated-account-list/resource-associated-account-list":782,"./shared/resource-connected-buckets-form/resource-connected-buckets-form":784,"./shared/resource-distribution-chart/resource-distribution-chart":786,"./shared/resource-distribution-table/resource-distribution-table":788,"./shared/resources-selection-table/resources-selection-table":790,"./shared/side-nav/side-nav":792,"./shared/slider/slider":794,"./shared/stepper/stepper":796,"./shared/svg-icon/svg-icon":798,"./shared/tag-list/tag-list":800,"./shared/timezone-chooser/timezone-chooser":802,"./shared/toggle-group/toggle-group":804,"./shared/toggle-switch/toggle-switch":806,"./shared/token-field/token-field":808,"./shared/validation-indicator/validation-indicator":810,"./shared/validation-message/validation-message":812,"./shared/validation-rules-list/validation-rules-list":814,"./shared/wizard-controls/wizard-controls":816,"./shared/wizard/wizard":818,"./shared/working-button/working-button":820,"./stickies/cluster-availability-sticky/cluster-availability-sticky":822,"./stickies/debug-mode-sticky/debug-mode-sticky":824,"./stickies/maintenance-sticky/maintenance-sticky":826,"./stickies/phone-home-connectivity-sticky/phone-home-connectivity-sticky":828,"./stickies/prefered-browsers-sticky/prefered-browsers-sticky":830,"@babel/runtime/helpers/interopRequireDefault":1050,"utils/core-utils":1027,"utils/string-utils":1046}],685:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"column pad card-shadow\">\n    <div class=\"row content-middle push-next\">\n        <div class=\"greedy\">\n            <input type=\"search\"\n                class=\"push-next\"\n                placeholder=\"Filter by resource name\"\n                ko.textInput=\"ko.pc(filter, onFilter, $component)\"\n            />\n        </div>\n        <button class=\"btn\"\n            ko.enable=\"dataReady\"\n            ko.click=\"onCreate\"\n        >\n            Create Namespace Resource\n        </button>\n    </div>\n    <p>\n        Namespace resource can be an Azure blob storage, AWS bucket or any S3 compatible\n        service and can be used for data visibility without replicas or encryption\n    </p>\n</div>\n\n<data-table class=\"greedy resources-table\" params=\"\n    columns: columns,\n    sorting: ko.pc(sorting, onSort, $component),\n    data: rows,\n    loading: !dataReady(),\n    emptyMessage: 'System does not contain any namespace resources'\n\"></data-table>\n\n<paginator params=\"\n    itemCount: resourceCount,\n    pageSize: ko.pc(pageSize, onPageSize, $component),\n    page: ko.pc(page, onPage, $component)\n\"></paginator>\n";

},{}],686:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _namespaceResourcesTable = _interopRequireDefault(require("./namespace-resources-table.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _browserUtils = require("utils/browser-utils");

var _stringUtils = require("utils/string-utils");

var _resourceUtils = require("utils/resource-utils");

var _config = require("config");

var routes = _interopRequireWildcard(require("routes"));

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const columns = (0, _coreUtils.deepFreeze)([{
  name: 'state',
  type: 'icon',
  sortable: true,
  compareKey: resource => resource.state
}, {
  name: 'type',
  type: 'icon',
  sortable: true,
  compareKey: resource => resource.type
}, {
  name: 'name',
  label: 'Resource name',
  sortable: true,
  compareKey: resource => resource.name
}, {
  name: 'connectedBuckets',
  label: 'connected namespace buckets',
  sortable: true,
  compareKey: (resource, connectedBucketsMap) => {
    const {
      name
    } = resource;
    return (connectedBucketsMap[name] || []).length;
  }
}, {
  name: 'target',
  label: 'Cloud Target Bucket',
  sortable: true,
  compareKey: resource => resource.target
}, {
  name: 'deleteButton',
  label: '',
  css: 'delete-col',
  type: 'delete'
}]);
const undeletableReasonToTooltip = (0, _coreUtils.deepFreeze)({
  IN_USE: 'Cannot delete a resource which is used by a namespace bucket'
});

function _mapResourceToRow(resource, connectedBuckets, system, selectedForDelete) {
  const {
    name,
    target,
    undeletable
  } = resource;
  const connectedBucketsInfo = {
    text: (0, _stringUtils.stringifyAmount)('bucket', connectedBuckets.length),
    tooltip: {
      template: 'linkList',
      text: connectedBuckets.length > 0 ? connectedBuckets.map(bucket => ({
        text: bucket,
        href: (0, _browserUtils.realizeUri)(routes.namespaceBucket, {
          system,
          bucket
        })
      })) : null
    }
  };
  return {
    state: (0, _resourceUtils.getNamespaceResourceStateIcon)(resource),
    type: (0, _resourceUtils.getNamespaceResourceTypeIcon)(resource),
    name,
    connectedBuckets: connectedBucketsInfo,
    target: {
      text: target,
      tooltip: target
    },
    deleteButton: {
      id: name,
      active: selectedForDelete == name,
      disabled: Boolean(undeletable),
      tooltip: undeletableReasonToTooltip[undeletable] || 'Delete Resource'
    }
  };
}

class ResourceRowViewModel {
  constructor({
    table
  }) {
    (0, _defineProperty2.default)(this, "table", null);
    (0, _defineProperty2.default)(this, "state", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "type", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "name", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "connectedBuckets", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "target", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "deleteButton", {
      text: 'Delete resource',
      id: _knockout.default.observable(),
      active: _knockout.default.observable(),
      disabled: _knockout.default.observable(),
      tooltip: _knockout.default.observable(),
      onToggle: id => this.table.onSelectForDelete(id),
      onDelete: id => this.table.onDeleteResource(id)
    });
    this.table = table;
  }

}

class NamespaceResourceTableViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "columns", columns);
    (0, _defineProperty2.default)(this, "pathname", '');
    (0, _defineProperty2.default)(this, "sorting", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "filter", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "page", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "pageSize", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "selectedForDelete", '');
    (0, _defineProperty2.default)(this, "resourceCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "rows", _knockout.default.observableArray().ofType(ResourceRowViewModel, {
      table: this
    }));
    (0, _defineProperty2.default)(this, "onFilter", (0, _coreUtils.throttle)(filter => {
      this._query({
        filter: filter,
        page: 0,
        selectedForDelete: null
      });
    }, _config.inputThrottle));
  }

  selectState(state) {
    return [state.namespaceResources, state.namespaceBuckets, state.location];
  }

  mapStateToProps(resources, buckets, location) {
    if (!resources || !buckets || location.params.tab !== 'namespace') {
      _knockout.default.assignToProps(this, {
        dataReady: false
      });
    } else {
      const {
        pathname,
        query,
        params
      } = location;
      const {
        filter,
        sortBy = 'name',
        selectedForDelete
      } = query;
      const page = Number(query.page) || 0;

      const pageSize = Number(query.pageSize) || _config.paginationPageSize.default;

      const order = Number(query.order) || 1;
      const pageStart = page * pageSize;
      const {
        compareKey
      } = columns.find(column => column.name == sortBy);
      const connectedBucketsMap = Object.values(buckets).reduce((connectedBucketsMap, bucket) => {
        const {
          name,
          placement
        } = bucket;
        placement.readFrom.map(resource => {
          let bucketList = connectedBucketsMap[resource];
          if (!bucketList) bucketList = connectedBucketsMap[resource] = [];
          bucketList.push(name);
        });
        return connectedBucketsMap;
      }, {});
      const filteredRows = Object.values(resources).filter(resource => (0, _stringUtils.includesIgnoreCase)(resource.name, filter));
      const rows = filteredRows.sort((0, _coreUtils.createCompareFunc)(compareKey, order, connectedBucketsMap)).slice(pageStart, pageStart + pageSize).map(resource => _mapResourceToRow(resource, connectedBucketsMap[resource.name] || [], params.system, selectedForDelete));

      _knockout.default.assignToProps(this, {
        dataReady: true,
        pathname,
        filter,
        sorting: {
          sortBy,
          order
        },
        page,
        pageSize,
        resourceCount: filteredRows.length,
        selectedForDelete,
        rows
      });
    }
  }

  onSort(sorting) {
    this._query({
      sorting: sorting,
      page: 0,
      selectedForDelete: null
    });
  }

  onSelectForDelete(resource) {
    this._query({
      selectedForDelete: resource
    });
  }

  onPage(page) {
    this._query({
      page,
      selectedForDelete: null
    });
  }

  onPageSize(pageSize) {
    this._query({
      pageSize,
      page: 0,
      selectedForDelete: null
    });
  }

  onCreate() {
    this.dispatch((0, _actionCreators.openCreateNamespaceResourceModal)());
  }

  onDeleteResource(resource) {
    this.dispatch((0, _actionCreators.deleteNamespaceResource)(resource));
  }

  _query({
    filter = this.filter(),
    sorting = this.sorting(),
    page = this.page(),
    pageSize = this.pageSize(),
    selectedForDelete = this.selectedForDelete
  }) {
    const query = {
      filter: filter || undefined,
      sortBy: sorting.sortBy,
      order: sorting.order,
      page,
      pageSize,
      selectedForDelete: selectedForDelete || undefined
    };
    const url = (0, _browserUtils.realizeUri)(this.pathname, {}, query);
    this.dispatch((0, _actionCreators.requestLocation)(url));
  }

}

var _default = {
  viewModel: NamespaceResourceTableViewModel,
  template: _namespaceResourcesTable.default
};
exports.default = _default;

},{"./namespace-resources-table.html":685,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"components/connectable":446,"config":831,"knockout":"knockout","routes":972,"utils/browser-utils":1021,"utils/core-utils":1027,"utils/resource-utils":1041,"utils/string-utils":1046}],687:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<resources-summary class=\"push-next\"></resources-summary>\n\n<section class=\"greedy tabs\">\n    <nav>\n        <a ko.attr.href=\"tabHref('storage')\"\n            ko.css.selected=\"selectedTab.eq('storage')\"\n        >\n            Storage Resources\n        </a>\n        <a ko.attr.href=\"tabHref('namespace')\"\n            ko.css.selected=\"selectedTab.eq('namespace')\"\n        >\n            Namespace Resources\n        </a>\n    </nav>\n\n    <div class=\"tabs-row\">\n        <storage-resources-table class=\"tab column\"\n            ko.css.selected=\"selectedTab.eq('storage')\"\n        ></storage-resources-table>\n\n        <namespace-resources-table class=\"tab column\"\n            ko.css.selected=\"selectedTab.eq('namespace')\"\n        ></namespace-resources-table>\n\n\n    </div>\n</section>\n\n\n";

},{}],688:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _resourcesPanel = _interopRequireDefault(require("./resources-panel.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _browserUtils = require("utils/browser-utils");

/* Copyright (C) 2016 NooBaa */
class ResourcesPanelViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "baseRoute", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "selectedTab", _knockout.default.observable());
  }

  selectState(state) {
    return [state.location];
  }

  mapStateToProps(location) {
    const {
      system,
      tab = 'storage'
    } = location.params;

    _knockout.default.assignToProps(this, {
      baseRoute: (0, _browserUtils.realizeUri)(location.route, {
        system
      }, {}, true),
      selectedTab: tab
    });
  }

  tabHref(tab) {
    const route = this.baseRoute();
    return route ? (0, _browserUtils.realizeUri)(route, {
      tab
    }) : '';
  }

}

var _default = {
  viewModel: ResourcesPanelViewModel,
  template: _resourcesPanel.default
};
exports.default = _default;

},{"./resources-panel.html":687,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"components/connectable":446,"knockout":"knockout","utils/browser-utils":1021}],689:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"fill row\" ko.visible=\"!dataReady()\">\n    <loading-indicator class=\"align-middle greedy\" params=\"label: true\"></loading-indicator>\n</div>\n\n<section class=\"summary row greedy\" ko.css.visible=\"dataReady\">\n    <div class=\"c4 card column push-next\">\n        <div class=\"row content-middle pad-double hpad highlight\">\n            <span class=\"greedy\">Kubernetes pools</span>\n            <span>{{hostPoolCount}}</span>\n        </div>\n        <hr>\n        <div class=\"row content-middle pad-double hpad highlight\">\n            <span class=\"greedy\">Number of Nodes (Pods)</span>\n            <span>{{hostCount}}</span>\n        </div>\n    </div>\n    <div class=\"c4 card column push-both\">\n        <div class=\"row content-middle pad-double hpad highlight\">\n            <span class=\"greedy\">Cloud Resources</span>\n            <span>{{cloudResourceCount}}</span>\n        </div>\n        <hr>\n        <div class=\"row content-middle pad-double hpad highlight\">\n            <span class=\"greedy\">Providers</span>\n            <span>{{cloudServiceCount}}</span>\n        </div>\n    </div>\n    <div class=\"c4 card column push-prev\">\n        <div class=\"row content-middle pad-double hpad highlight\">\n            <span class=\"greedy\">Namespace Resources</span>\n            <span>{{nsResourceCount}}</span>\n        </div>\n        <hr>\n        <div class=\"row content-middle pad-double hpad highlight\">\n            <span class=\"greedy\">Providers</span>\n            <span>{{nsServiceCount}}</span>\n        </div>\n    </div>\n</section>\n\n\n\n";

},{}],690:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _resourcesSummary = _interopRequireDefault(require("./resources-summary.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _numeral = _interopRequireDefault(require("numeral"));

/* Copyright (C) 2016 NooBaa */
class ResourcesSummaryViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "hostPoolCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "hostCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "cloudResourceCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "cloudServiceCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "nsResourceCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "nsServiceCount", _knockout.default.observable());
  }

  selectState(state) {
    return [state.hostPools, state.cloudResources, state.namespaceResources];
  }

  mapStateToProps(hostPools, cloudResources, nsResources) {
    if (!hostPools || !cloudResources || !nsResources) {
      _knockout.default.assignToProps(this, {
        dataReady: false
      });
    } else {
      const hostPoolList = Object.values(hostPools);
      const hostPoolCount = hostPoolList.length;
      const hostCount = (0, _coreUtils.sumBy)(hostPoolList, pool => pool.hostCount);
      const cloudResourceList = Object.values(cloudResources);
      const cloudResourceCount = cloudResourceList.length;
      const cloudServiceCount = (0, _coreUtils.unique)(cloudResourceList.map(res => res.type)).length;
      const nsResourceList = Object.values(nsResources);
      const nsResourceCount = nsResourceList.length;
      const nsServiceCount = (0, _coreUtils.unique)(nsResourceList.map(res => res.service)).length;

      _knockout.default.assignToProps(this, {
        dataReady: true,
        hostPoolCount: (0, _numeral.default)(hostPoolCount).format(','),
        hostCount: (0, _numeral.default)(hostCount).format(','),
        cloudResourceCount: (0, _numeral.default)(cloudResourceCount).format(','),
        cloudServiceCount: (0, _numeral.default)(cloudServiceCount).format(','),
        nsResourceCount: (0, _numeral.default)(nsResourceCount).format(','),
        nsServiceCount: (0, _numeral.default)(nsServiceCount).format(',')
      });
    }
  }

}

var _default = {
  viewModel: ResourcesSummaryViewModel,
  template: _resourcesSummary.default
};
exports.default = _default;

},{"./resources-summary.html":689,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"components/connectable":446,"knockout":"knockout","numeral":"numeral","utils/core-utils":1027}],691:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"row content-middle card-shadow pad push-next\">\n    <input class=\"push-next\"\n        type=\"search\"\n        placeholder=\"Filter by name or region\"\n        ko.textInput=\"ko.pc(filter, onFilter)\"\n    />\n    <div class=\"greedy push-next row content-middle\">\n        <dropdown params=\"\n            options: resourceTypeOptions,\n            selected: ko.pc(typeFilter, onTypeFilter, $component)\n        \"></dropdown>\n    </div>\n    <button class=\"btn push-next\" ko.click=\"onDeplyK8sPool\">\n        Deploy Kubernetes Pool\n    </button>\n    <button class=\"btn\" ko.click=\"onAddCloudResource\">\n        Add Cloud Resource\n    </button>\n</div>\n\n<data-table class=\"greedy resources-table\" params=\"\n    columns: columns,\n    data: rows,\n    sorting: ko.pc(sorting, onSort, $component),\n    loading: !dataReady(),\n    emptyMessage: emptyMessage\n\"></data-table>\n\n<paginator params=\"\n    itemCount: resourceCount,\n    pageSize: ko.pc(pageSize, onPageSize, $component),\n    page: ko.pc(page, onPage, $component)\n\"></paginator>\n";

},{}],692:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _storageResourcesTable = _interopRequireDefault(require("./storage-resources-table.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _browserUtils = require("utils/browser-utils");

var _coreUtils = require("utils/core-utils");

var _stringUtils = require("utils/string-utils");

var _bucketUtils = require("utils/bucket-utils");

var _hostUtils = require("utils/host-utils");

var _sizeUtils = require("utils/size-utils");

var _knockout = _interopRequireDefault(require("knockout"));

var routes = _interopRequireWildcard(require("routes"));

var _config = require("config");

var _numeral = _interopRequireDefault(require("numeral"));

var _resourceUtils = require("utils/resource-utils");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const columns = (0, _coreUtils.deepFreeze)([{
  name: 'state',
  type: 'icon',
  sortable: true,
  compareKey: resource => resource.mode
}, {
  name: 'type',
  type: 'icon',
  sortable: true,
  compareKey: resource => resource.type
}, {
  name: 'name',
  label: 'resource name',
  type: 'link',
  sortable: true,
  compareKey: resource => resource.name
}, {
  name: 'region',
  sortable: true,
  compareKey: resource => resource.region || ''
}, {
  name: 'buckets',
  label: 'connected buckets',
  sortable: true,
  compareKey: (resource, bucketsByResource) => (bucketsByResource[resource.name] || []).length
}, {
  name: 'hosts',
  label: 'Nubmer of Nodes',
  sortable: true,
  compareKey: resource => resource.type === 'HOSTS' ? resource.configuredHostCount : -1
}, {
  name: 'capacity',
  label: 'used capacity',
  type: 'capacity',
  sortable: true,
  compareKey: resource => (0, _sizeUtils.toBytes)(resource.storage.used) + (0, _sizeUtils.toBytes)(resource.storage.usedOther)
}, {
  name: 'deleteButton',
  label: '',
  css: 'delete-col',
  type: 'delete'
}]);
const resourceTypeOptions = [{
  value: 'ALL',
  label: 'All Resource Types'
}, {
  value: 'HOSTS',
  label: 'Kubernetes Pool',
  icon: 'nodes-pool'
}, {
  value: 'AWS',
  label: 'AWS S3',
  icon: 'aws-s3'
}, {
  value: 'AZURE',
  label: 'Azure Blob',
  icon: 'azure'
}, {
  value: 'GOOGLE',
  label: 'Google Cloud',
  icon: 'google-cloud'
}, {
  value: 'S3_COMPATIBLE',
  label: 'S3 Compatible',
  icon: 'cloud'
}, {
  value: 'FLASHBLADE',
  label: 'Pure FlashBlade',
  icon: 'pure'
}, {
  value: 'IBM_COS',
  label: 'IBM COS',
  icon: 'ibm-cos'
}];

function _getBucketsByResource(buckets) {
  const placement = (0, _coreUtils.flatMap)(Object.values(buckets), bucket => (0, _bucketUtils.flatPlacementPolicy)(bucket));
  return (0, _coreUtils.groupBy)(placement, r => r.resource.name, r => r.bucket);
}

function _matchFilters(resource, typeFilter, textFilter) {
  const {
    type,
    name,
    region = ''
  } = resource; // Filter by resource type:

  if (typeFilter !== 'ALL' && type !== typeFilter) {
    return false;
  }

  return (0, _stringUtils.includesIgnoreCase)(name, textFilter) || (0, _stringUtils.includesIgnoreCase)(region, textFilter);
}

function _getHostsColumnValue(resource) {
  if (resource.type === 'HOSTS') {
    const {
      all,
      healthy,
      hasIssues,
      offline
    } = (0, _hostUtils.summrizeHostModeCounters)(resource.hostsByMode);
    return {
      text: (0, _numeral.default)(all).format(','),
      tooltip: {
        template: 'propertySheet',
        text: [{
          label: 'Healthy Nodes',
          value: (0, _numeral.default)(healthy).format(',')
        }, {
          label: 'Nodes with issues',
          value: (0, _numeral.default)(hasIssues).format(',')
        }, {
          label: 'Offline nodes',
          value: (0, _numeral.default)(offline).format(',')
        }]
      }
    };
  } else {
    return {
      text: '---'
    };
  }
}

function _getEmptyMessage(resourceCount, typeFilter, filteredCount) {
  if (resourceCount === 0) {
    return 'There are no existing storage resources in the system';
  }

  if (filteredCount === 0) {
    const subject = typeFilter !== 'ALL' ? resourceTypeOptions.find(t => t.value == typeFilter).label.toLowerCase() : 'storage';
    return `The current filter does not match any ${subject} resource`;
  }
}

function _mapResourceToRow(resource, connectedBuckets, selectedForDelete, system, lockingAccounts) {
  const {
    type,
    name,
    region = _resourceUtils.unassignedRegionText,
    storage,
    undeletable = ''
  } = resource;
  const stateIcon = type === 'HOSTS' ? (0, _resourceUtils.getHostPoolStateIcon)(resource) : (0, _resourceUtils.getCloudResourceStateIcon)(resource);
  const typeIcon = type === 'HOSTS' ? {
    name: 'nodes-pool',
    tooltip: 'Kubernetes Pool'
  } : (0, _resourceUtils.getCloudResourceTypeIcon)(resource);
  const resourceUri = type === 'HOSTS' ? (0, _browserUtils.realizeUri)(routes.pool, {
    system,
    pool: name
  }) : (0, _browserUtils.realizeUri)(routes.cloudResource, {
    system,
    resource: name
  });
  const subject = (0, _resourceUtils.getResourceTypeDisplayName)(resource.type === 'HOSTS' ? 'HOSTS' : 'CLOUD');
  return {
    state: { ...stateIcon,
      tooltip: {
        text: stateIcon.tooltip,
        align: 'start'
      }
    },
    type: typeIcon,
    name: {
      text: name,
      href: resourceUri
    },
    region: {
      text: region,
      tooltip: region
    },
    buckets: {
      text: connectedBuckets.length ? (0, _stringUtils.stringifyAmount)('bucket', connectedBuckets.length) : 'None',
      tooltip: connectedBuckets.length ? {
        template: 'linkList',
        text: connectedBuckets.map(name => ({
          text: name,
          href: (0, _browserUtils.realizeUri)(routes.bucket, {
            system,
            bucket: name
          })
        }))
      } : ''
    },
    hosts: _getHostsColumnValue(resource),
    inUse: Boolean(storage.used),
    capacity: {
      total: storage.total,
      used: [{
        value: storage.used
      }, {
        value: storage.usedOther
      }]
    },
    deleteButton: {
      id: name,
      text: `Delete ${subject}`,
      disabled: Boolean(undeletable),
      active: selectedForDelete === name,
      tooltip: {
        text: {
          subject: subject,
          reason: undeletable,
          accounts: lockingAccounts
        }
      }
    }
  };
}

class RowViewModel {
  constructor({
    table
  }) {
    (0, _defineProperty2.default)(this, "table", null);
    (0, _defineProperty2.default)(this, "state", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "type", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "name", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "region", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "buckets", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "hosts", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "inUse", false);
    (0, _defineProperty2.default)(this, "capacity", {
      total: _knockout.default.observable(),
      used: [{
        label: 'Used (Noobaa)',
        value: _knockout.default.observable()
      }, {
        label: 'Used (other)',
        value: _knockout.default.observable()
      }]
    });
    (0, _defineProperty2.default)(this, "deleteButton", {
      text: _knockout.default.observable(),
      id: _knockout.default.observable(),
      active: _knockout.default.observable(),
      disabled: _knockout.default.observable(),
      tooltip: {
        template: 'deleteResource',
        text: _knockout.default.observable()
      },
      onToggle: this.onToggle.bind(this),
      onDelete: this.onDelete.bind(this)
    });
    this.table = table;
  }

  onToggle(poolName) {
    this.table.onSelectForDelete(poolName, this.inUse);
  }

  onDelete(poolName) {
    this.table.onDeletePool(poolName);
  }

}

class StorageResourcesTableViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "columns", columns);
    (0, _defineProperty2.default)(this, "resourceTypeOptions", resourceTypeOptions);
    (0, _defineProperty2.default)(this, "pathname", '');
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isCreatePoolDisabled", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "createPoolTooltip", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "filter", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "typeFilter", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "sorting", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "page", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "pageSize", _knockout.default.observable(_config.paginationPageSize));
    (0, _defineProperty2.default)(this, "resourceCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "emptyMessage", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "rows", _knockout.default.observableArray().ofType(RowViewModel, {
      table: this
    }));
    (0, _defineProperty2.default)(this, "onFilter", (0, _coreUtils.throttle)(filter => {
      this._query({
        filter,
        page: 0,
        selectedForDelete: null
      });
    }, _config.inputThrottle));
  }

  selectState(state) {
    return [state.hostPools, state.cloudResources, state.accounts, state.buckets, state.location];
  }

  mapStateToProps(pools, cloudResources, accounts, buckets, location) {
    const {
      system,
      tab
    } = location.params;
    if (tab && tab !== 'storage') return;

    if (!pools || !cloudResources || !accounts || !buckets) {
      _knockout.default.assignToProps(this, {
        dataReady: false,
        isCreatePoolDisabled: true
      });
    } else {
      const {
        filter = '',
        typeFilter = 'ALL',
        sortBy = 'name',
        selectedForDelete
      } = location.query;
      const order = Number(location.query.order) || 1;
      const page = Number(location.query.page) || 0;

      const pageSize = Number(location.query.pageSize) || _config.paginationPageSize.default;

      const pageStart = page * pageSize;
      const nameFilter = filter.trim().toLowerCase();
      const resourceList = [...Object.values(pools).map(pool => ({
        type: 'HOSTS',
        ...pool
      })), ...Object.values(cloudResources)];
      const filteredResources = resourceList.filter(resource => _matchFilters(resource, typeFilter, nameFilter));

      const bucketsByResource = _getBucketsByResource(buckets);

      const accountsByUsingResource = (0, _coreUtils.groupBy)(Object.values(accounts), account => account.defaultResource, account => {
        const name = account.name;
        const href = (0, _browserUtils.realizeUri)(routes.account, {
          system,
          account: name
        });
        return {
          name,
          href
        };
      });
      const compareOp = (0, _coreUtils.createCompareFunc)(columns.find(column => column.name === sortBy).compareKey, order, bucketsByResource);

      _knockout.default.assignToProps(this, {
        dataReady: true,
        pathname: location.pathname,
        filter,
        typeFilter,
        sorting: {
          sortBy,
          order
        },
        page,
        pageSize,
        resourceCount: filteredResources.length,
        emptyMessage: _getEmptyMessage(resourceList.length, typeFilter, filteredResources.length),
        rows: filteredResources.sort(compareOp).slice(pageStart, pageStart + pageSize).map(resource => _mapResourceToRow(resource, bucketsByResource[resource.name] || [], selectedForDelete, system, accountsByUsingResource[resource.name]))
      });
    }
  }

  onDeplyK8sPool() {
    this.dispatch((0, _actionCreators.openDeployK8sPoolModal)());
  }

  onAddCloudResource() {
    this.dispatch((0, _actionCreators.openAddCloudResourceModal)());
  }

  onTypeFilter(type) {
    this._query({
      typeFilter: type,
      page: 0,
      selectedForDelete: null
    });
  }

  onSort(sorting) {
    this._query({
      sortBy: sorting.sortBy,
      order: sorting.order,
      page: 0,
      selectedForDelete: null
    });
  }

  onPage(page) {
    this._query({
      page,
      selectedForDelete: null
    });
  }

  onPageSize(pageSize) {
    this._query({
      pageSize,
      page: 0,
      selectedForDelete: null
    });
  }

  onSelectForDelete(poolName, inUse) {
    if (inUse) {
      this.dispatch((0, _actionCreators.openDeletePoolWithDataWarningModal)(poolName));
    } else {
      const selectedForDelete = poolName || '';

      this._query({
        selectedForDelete
      });
    }
  }

  onDeletePool(poolName) {
    this.dispatch((0, _actionCreators.deleteResource)(poolName));
  }

  _query(query) {
    const {
      filter = this.filter(),
      typeFilter = this.typeFilter(),
      sortBy = this.sorting().sortBy,
      order = this.sorting().order,
      page = this.page(),
      pageSize = this.pageSize(),
      selectedForDelete = this.selectedForDelete()
    } = query;
    const queryUrl = (0, _browserUtils.realizeUri)(this.pathname, null, {
      filter: filter || undefined,
      typeFilter,
      sortBy,
      order,
      page,
      pageSize,
      selectedForDelete: selectedForDelete || undefined
    });
    this.dispatch((0, _actionCreators.requestLocation)(queryUrl));
  }

}

var _default = {
  viewModel: StorageResourcesTableViewModel,
  template: _storageResourcesTable.default
};
exports.default = _default;

},{"./storage-resources-table.html":691,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"components/connectable":446,"config":831,"knockout":"knockout","numeral":"numeral","routes":972,"utils/browser-utils":1021,"utils/bucket-utils":1022,"utils/core-utils":1027,"utils/host-utils":1032,"utils/resource-utils":1041,"utils/size-utils":1043,"utils/string-utils":1046}],693:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<input type=\"text\"\n    ko.textInput=\"ko.pc(text, onInput, $component)\"\n    ko.hasFocus=\"hasFocus\"\n    ko.attr.placeholder=\"placeholder\"\n    ko.event.blur=\"onBlur\"\n    ko.event.keydown=\"onKeyDown\"\n    ko.validationCss=\"$form.region\"\n/>\n<ul class=\"list-no-style card-shadow suggestion-list\"\n    ko.visible=\"isListVisible\"\n    ko.foreach=\"suggestions\"\n    ko.scrollTo=\"$component.keyboardFocus\"\n>\n    <li class=\"suggestion\"\n        ko.css.ring=\"$index.eq($component.keyboardFocus)\"\n        ko.event.mousedown=\" () => $component.onSuggetionMouseDown(value)\"\n    >\n        <div class=\"no-wrap\">\n            {{prefix}}<span class=\"match\">{{match}}</span>{{suffix}}\n        </div>\n        <div class=\"no-wrap remark\">\n            {{remark}}\n        </div>\n    </li>\n</ul>\n";

},{}],694:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _autocomplete = _interopRequireDefault(require("./autocomplete.html"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _stringUtils = require("utils/string-utils");

/* Copyright (C) 2016 NooBaa */
const keyBlackList = (0, _coreUtils.deepFreeze)(['control', 'alt', 'capslock', 'meta', 'contextmenu', 'tab', 'shift', 'home', 'pagedown', 'pageup', 'end', 'clear']);

function _normalizeSuggestion(suggestion, phrase, phraseRegExp) {
  const {
    value = suggestion,
    remark = ''
  } = suggestion;

  if (!value.toLowerCase().includes(phrase)) {
    return null;
  } else {
    const [prefix, match, suffix] = value.split(phraseRegExp);
    return {
      value,
      prefix,
      match,
      suffix,
      remark
    };
  }
}

function _compareSuggestions(s1, s2) {
  const r = (0, _coreUtils.compare)(s1.prefix.length, s2.prefix.length);
  return r || (0, _coreUtils.compare)(s1.value.toLowerCase(), s2.value.toLowerCase());
}

class AutoCompleteViewModel {
  constructor(params) {
    const {
      value: outerValue = _knockout.default.observable(),
      suggestions = [],
      hasFocus = false,
      placeholder = '',
      maxCount = 5
    } = params;
    this.value = _knockout.default.observable(outerValue());
    this.text = _knockout.default.observable(outerValue());
    this.outerValue = outerValue;
    this.keyboardFocus = _knockout.default.observable(-1);
    this.isActive = _knockout.default.observable(false);
    this.placeholder = placeholder;
    this.maxCount = maxCount;
    this.valueSub = outerValue.subscribe(value => {
      this.value(value);
      this.text(value);
    });
    this.hasFocus = _knockout.default.isWritableObservable(hasFocus) ? hasFocus : _knockout.default.observable(_knockout.default.unwrap(hasFocus));
    this.suggestions = _knockout.default.pureComputed(() => {
      const value = this.value();

      if (!value) {
        return [];
      }

      const lc = value.toLowerCase();
      const re = new RegExp(`(${(0, _stringUtils.escapeRegExp)(value)})(.*)$`, 'i');
      return _knockout.default.unwrap(suggestions).map(suggestion => _normalizeSuggestion(suggestion, lc, re)).filter(Boolean).sort(_compareSuggestions).slice(0, _knockout.default.unwrap(this.maxCount));
    });
    this.isListVisible = _knockout.default.pureComputed(() => this.isActive() && this.suggestions().length > 0);
  }

  onInput(value) {
    this.value(value);
    this.text(value);
  }

  onBlur() {
    const value = this.text();
    this.value(value);
    this.outerValue(value);
    this.isActive(false);
  }

  onKeyDown(_, evt) {
    const key = evt.key.toLowerCase();

    if (keyBlackList.includes(key)) {
      return true;
    }

    switch (key) {
      case 'enter':
        {
          return this.onEnter(evt);
        }

      case 'escape':
        {
          return this.onEscape(evt);
        }

      case 'arrowup':
        {
          return this.onArrowUp(evt);
        }

      case 'arrowdown':
        {
          return this.onArrowDown(evt);
        }

      default:
        {
          this.isActive(true);
          this.keyboardFocus(-1);
          return true;
        }
    }
  }

  onEnter() {
    const text = this.text();
    this.value(text);
    this.outerValue(text);
    this.isActive(false);
    return true;
  }

  onEscape(evt) {
    if (this.isActive() && this.keyboardFocus() >= 0) {
      this.text(this.value());
      this.keyboardFocus(-1);
      evt.cancelBubble = true;

      if (evt.stopPropagation) {
        evt.stopPropagation();
      }

      return false;
    }

    return true;
  }

  onArrowUp() {
    if (this.isActive()) {
      const kbFocus = Math.max(this.keyboardFocus() - 1, -1);
      const text = kbFocus >= 0 ? this.suggestions()[kbFocus].value : this.value();
      this.keyboardFocus(kbFocus);
      this.text(text);
    }

    return false;
  }

  onArrowDown() {
    if (this.isActive()) {
      const kbFocus = Math.min(this.keyboardFocus() + 1, this.suggestions().length - 1);
      const {
        value
      } = this.suggestions()[kbFocus];
      this.keyboardFocus(kbFocus);
      this.text(value);
    }

    return false;
  }

  onSuggetionMouseDown(value) {
    this.text(value);
    this.value(value);
    this.outerValue(value);
    this.isActive(false);
    this.hasFocus(true);
    return false;
  }

  dispose() {
    this.valueSub.dispose();
  }

}

var _default = {
  viewModel: AutoCompleteViewModel,
  template: _autocomplete.default
};
exports.default = _default;

},{"./autocomplete.html":693,"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","utils/core-utils":1027,"utils/string-utils":1046}],695:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<!-- ko if: limits.visible -->\n<div class=\"bar-limits\">\n    <span class=\"bar-limit\">{{limits.low}}</span>\n    <span class=\"bar-limit\">{{limits.high}}</span>\n</div>\n<!-- /ko -->\n\n<div class=\"bar-line\">\n    <div class=\"bar-markers\" ko.foreach=\"markers\">\n        <span class=\"bar-marker card-shadow card-bg\" ko.style=\"style\">{{text}}</span>\n    </div>\n\n    <svg class=\"bar-svg\"\n        ko.css.empty=\"isEmpty\"\n        ko.foreach=\"lines\"\n    >\n        <line class=\"bar-line\" ko.attr=\"$data\" />\n    </svg>\n</div>\n\n";

},{}],696:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _bar = _interopRequireDefault(require("./bar.html"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _chartUtils = require("utils/chart-utils");

/* Copyright (C) 2016 NooBaa */
function _asPercentage(val) {
  return `${val * 100}%`;
}

function _getMarkerStyle(pos) {
  return {
    left: pos <= .5 ? _asPercentage(pos) : 'auto',
    right: pos > .5 ? _asPercentage(1 - pos) : 'auto',
    transform: `translateX(${Math.sign(pos - .5) * 50}%)`
  };
}

class LineViewModel {
  constructor() {
    (0, _defineProperty2.default)(this, "x1", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "x2", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "stroke", _knockout.default.observable());
  }

}

class MarkerViewModel {
  constructor() {
    (0, _defineProperty2.default)(this, "text", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "style", {
      left: _knockout.default.observable(),
      right: _knockout.default.observable(),
      transform: _knockout.default.observable()
    });
  }

}

class BarViewModel {
  constructor(params) {
    (0, _defineProperty2.default)(this, "sub", null);
    (0, _defineProperty2.default)(this, "limits", {
      visible: _knockout.default.observable(),
      low: _knockout.default.observable(),
      high: _knockout.default.observable()
    });
    (0, _defineProperty2.default)(this, "lines", _knockout.default.observableArray().ofType(LineViewModel));
    (0, _defineProperty2.default)(this, "markers", _knockout.default.observableArray().ofType(MarkerViewModel));
    (0, _defineProperty2.default)(this, "isEmpty", _knockout.default.observable());
    this.sub = _knockout.default.computed(() => this.onParams(_knockout.default.deepUnwrap(params)));
  }

  onParams(params) {
    const {
      values: items = [],
      markers: _markers = [],
      limits: showLimits = false,
      spacing = 0,
      minRatio = .03,
      format = 'none'
    } = params;
    const values = items.map(item => item.value);
    const nonZeroCount = (0, _coreUtils.sumBy)(values, value => value ? 1 : 0);
    const spacingFactor = 1 - spacing * Math.max(nonZeroCount - 1, 0); // need to exclude zero items;

    const ratios = (0, _coreUtils.normalizeValues)(values, 1, minRatio);
    let offset = 0;
    const segments = items.map((item, i) => {
      const len = ratios[i] * spacingFactor;
      const start = offset;
      const end = offset + len;
      const color = item.color;
      if (len > 0) offset += len + spacing;
      return {
        start,
        end,
        color
      };
    });
    const lines = segments.map(seg => ({
      x1: _asPercentage(seg.start),
      x2: _asPercentage(seg.end),
      stroke: seg.color
    }));
    const sum = (0, _coreUtils.sumBy)(values);
    const isEmpty = sum === 0;
    const formatter = (0, _chartUtils.getFormatter)(format);
    const limits = {
      visible: Boolean(showLimits),
      low: formatter(0),
      high: formatter(sum)
    };

    const markers = _markers.filter(marker => marker.visible !== false).map(marker => {
      const i = (0, _coreUtils.clamp)(marker.position || 0, 0, segments.length);
      const pos = i === segments.length && 1 || i > 0 && (segments[i - 1].end + segments[i].start) / 2 || 0;
      return {
        text: marker.text,
        style: _getMarkerStyle(pos)
      };
    });

    _knockout.default.assignToProps(this, {
      lines,
      isEmpty,
      markers,
      limits
    });
  }

  dispose() {
    this.sub && this.sub.dispose();
  }

}

var _default = {
  viewModel: BarViewModel,
  template: _bar.default
};
exports.default = _default;

},{"./bar.html":695,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","utils/chart-utils":1023,"utils/core-utils":1027}],697:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n <nav class=\"row content-middle\" ko.foreach=\"crumbs\">\n     <a class=\"crumb\"\n        ko.attr.href=\"url\"\n        ko.tooltip=\"label\"\n    >\n        <span class=\"no-wrap\" ko.text=\"label\"></span>\n    </a>\n</nav>\n";

},{}],698:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _breadcrumbs = _interopRequireDefault(require("./breadcrumbs.html"));

/* Copyright (C) 2016 NooBaa */
class BreadcrumbsViewModel {
  constructor({
    crumbs = []
  }) {
    this.crumbs = crumbs;
  }

}

var _default = {
  viewModel: BreadcrumbsViewModel,
  template: _breadcrumbs.default
};
exports.default = _default;

},{"./breadcrumbs.html":697,"@babel/runtime/helpers/interopRequireDefault":1050}],699:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"column group-wrapper\"\n    ko.globalEvent.click=\"onClose\"\n>\n    <div class=\"row main-action\">\n        <!-- ko template: { nodes: [mainBtn], data: $parent } --><!-- /ko -->\n        <button class=\"btn more-toggle\"\n            ko.preventBubble=\"['click']\"\n            ko.click=\"onToggle\"\n        >\n            <svg-icon class=\"icon-small dd-chevron\" params=\"name: 'chevron'\">\n            </svg-icon>\n        </button>\n    </div>\n    <div class=\"card-bg column more-actions\"\n        ko.expand=\"opened\"\n        ko.template=\"{ nodes: otherBtns, data: $parent }\"\n    ></div>\n</div>\n";

},{}],700:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _buttonGroup = _interopRequireDefault(require("./button-group.html"));

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
class ButtonGroupViewModel {
  constructor([mainBtn, ...otherBtns]) {
    (0, _defineProperty2.default)(this, "mainBtn", null);
    (0, _defineProperty2.default)(this, "otherBtns", []);
    (0, _defineProperty2.default)(this, "opened", _knockout.default.observable(false));
    this.mainBtn = mainBtn;
    this.otherBtns = otherBtns;
  }

  onToggle() {
    this.opened(!this.opened());
  }

  onClose() {
    this.opened(false);
  }

}

function viewModelFactory(_, info) {
  const buttons = info.templateNodes.filter(node => node.nodeType === Node.ELEMENT_NODE).map(button => {
    button.classList.add('btn');
    return button;
  });
  return new ButtonGroupViewModel(buttons);
}

var _default = {
  viewModel: {
    createViewModel: viewModelFactory
  },
  template: _buttonGroup.default
};
exports.default = _default;

},{"./button-group.html":699,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout"}],701:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"column content-middle\" ko.tooltip=\"tooltip\">\n    <bar class=\"push-next-half\" params=\"values: values\"></bar>\n    <div class=\"bar-legend\">\n        <span class=\"used\" ko.text=\"usedText\"></span>\n        of\n        <span class=\"total\" ko.text=\"totalText\"></span>\n    </div>\n</div>\n";

},{}],702:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _capacityBar = _interopRequireDefault(require("./capacity-bar.html"));

var _knockout = _interopRequireDefault(require("knockout"));

var _sizeUtils = require("utils/size-utils");

/* Copyright (C) 2016 NooBaa */
class CapacityBarViewModel {
  constructor({
    total,
    used
  }) {
    const sum = _knockout.default.pureComputed(() => {
      const usedNaked = _knockout.default.deepUnwrap(used);

      if (Array.isArray(usedNaked)) {
        const sizeList = usedNaked.map(({
          value
        }) => value);
        return (0, _sizeUtils.sumSize)(...sizeList);
      } else {
        return usedNaked;
      }
    });

    this.usedText = sum.extend({
      formatSize: true
    });
    this.totalText = _knockout.default.pureComputed(() => _knockout.default.unwrap(total)).extend({
      formatSize: true
    });

    const usedRatio = _knockout.default.pureComputed(() => {
      const totalInBytes = (0, _sizeUtils.toBytes)(_knockout.default.unwrap(total) || 0);
      const sumInBytes = (0, _sizeUtils.toBytes)(sum());
      return totalInBytes > 0 ? sumInBytes / totalInBytes : 0;
    });

    this.values = [{
      value: usedRatio,
      color: 'rgb(var(--color20)'
    }, {
      value: _knockout.default.pureComputed(() => 1 - usedRatio()),
      color: 'rgb(var(--color07)'
    }];
    this.tooltip = _knockout.default.pureComputed(() => {
      const usedNaked = _knockout.default.deepUnwrap(used);

      if (!Array.isArray(usedNaked)) {
        return;
      }

      return {
        template: 'propertySheet',
        text: usedNaked.map(({
          label,
          value
        }) => ({
          label,
          value: (0, _sizeUtils.formatSize)(value)
        }))
      };
    });
  }

}

var _default = {
  viewModel: CapacityBarViewModel,
  template: _capacityBar.default
};
exports.default = _default;

},{"./capacity-bar.html":701,"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","utils/size-utils":1043}],703:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<h3 class=\"legend-caption heading3\" ko.visible=\"caption\" ko.text=\"caption\"></h3>\n<ul class=\"list-no-style legend-items \" ko.foreach=\"items\">\n    <li class=\"legend-item\"\n        ko.visible=\"visible\"\n        ko.style=\"style\"\n        ko.css=\"css\"\n        ko.click=\"onToggle\"\n    >\n        <span class=\"legend-label\">\n            <span ko.text=\"label\" ko.tooltip=\"tooltip\"></span>\n        </span>\n        <span class=\"legend-value\" ko.text=\"formattedValue\"></span>\n    </li>\n</ul>\n";

},{}],704:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _chartLegend = _interopRequireDefault(require("./chart-legend.html"));

var _coreUtils = require("utils/core-utils");

var _chartUtils = require("utils/chart-utils");

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
function _noramlizeTooltip(tooltip) {
  if (!tooltip) {
    return;
  } else if ((0, _coreUtils.isObject)(tooltip)) {
    return { ...tooltip,
      position: 'after',
      align: 'center'
    };
  } else {
    return {
      text: tooltip,
      position: 'after',
      align: 'center'
    };
  }
}

class ChartLegendViewModel {
  constructor({
    caption = '',
    items,
    format = 'none'
  }) {
    this.caption = caption;
    this.formatter = (0, _chartUtils.getFormatter)(format);
    this.items = _knockout.default.pureComputed(() => _knockout.default.unwrap(items).map(item => this.normalizeItem(item)));
  }

  normalizeItem({
    label,
    color,
    value,
    visible = true,
    disabled = false,
    tooltip
  }) {
    const toggable = _knockout.default.isWriteableObservable(disabled);

    const onToggle = toggable ? () => disabled(!disabled()) : _coreUtils.echo;
    return {
      label,
      style: {
        'border-color': color
      },
      formattedValue: this.formatter(_knockout.default.unwrap(value) || 0),
      visible,
      css: {
        disabled,
        toggable
      },
      tooltip: _noramlizeTooltip(_knockout.default.unwrap(tooltip)),
      onToggle
    };
  }

}

var _default = {
  viewModel: ChartLegendViewModel,
  template: _chartLegend.default
};
exports.default = _default;

},{"./chart-legend.html":703,"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","utils/chart-utils":1023,"utils/core-utils":1027}],705:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _knockout = _interopRequireDefault(require("knockout"));

var _chartjs = _interopRequireDefault(require("chartjs"));

var _operators = require("rxjs/operators");

var _coreUtils = require("utils/core-utils");

var _chartjsDefaults = _interopRequireDefault(require("./chartjs-defaults"));

var _state = require("state");

var _config = require("config");

/* Copyright (C) 2016 NooBaa */
// Metrge NooBaa default chartjs global default settings.
const selectedTheme = _knockout.default.observable();

_state.state$.pipe((0, _operators.map)(state => (0, _coreUtils.get)(state, ['session', 'uiTheme'], _config.defaultTheme)), (0, _operators.distinctUntilChanged)(Object.is)).subscribe(theme => {
  // Merge custom settings with chartjs settings.
  _chartjs.default.defaults = (0, _coreUtils.deepAssign)(_chartjs.default.defaults, theme && (0, _chartjsDefaults.default)(theme)); // Initiate a redraw for all rendered charts.

  selectedTheme(theme);
});

function createChart(canvas, type, options, data) {
  return new _chartjs.default(canvas, {
    type: type,
    options: (0, _coreUtils.deepClone)(options),
    data: (0, _coreUtils.deepClone)(data)
  });
}

_knockout.default.bindingHandlers.chartjs = {
  init: function (canvas, valueAccessor) {
    const config = _knockout.default.unwrap(valueAccessor());

    const type = _knockout.default.pureComputed(() => _knockout.default.unwrap(config.type));

    const options = _knockout.default.pureComputed(() => _knockout.default.deepUnwrap(config.options));

    const data = _knockout.default.pureComputed(() => _knockout.default.deepUnwrap(config.data));

    let lastType = type.peek();
    let lastOptions = options.peek();
    let lastData = data.peek();
    let lastTheme = selectedTheme.peek();
    let chart = createChart(canvas, lastType, lastOptions, lastData);

    const sub = _knockout.default.pureComputed(() => [type(), options(), data(), selectedTheme()]).extend({
      rateLimit: {
        method: 'notifyWhenChangesStop',
        timeout: 1
      }
    }).subscribe(([type, options, data, theme]) => {
      const shouldDestory = type !== lastType || options !== lastOptions || theme !== lastTheme;

      if (shouldDestory) {
        if (chart) chart.destroy();
        chart = createChart(canvas, type, options, data);
      } else if (chart) {
        if (data !== lastData) {
          const {
            datasets,
            labels
          } = chart.data;

          if (Array.isArray(labels) && Array.isArray(data.labels)) {
            labels.length = data.labels.length;
            chart.data.labels = Object.assign(labels, data.labels);
          } else {
            chart.data.labels = data.labels;
          }

          datasets.length = data.datasets.length;

          for (let i = 0; i < datasets.length; ++i) {
            datasets[i] = Object.assign(datasets[i] || {}, data.datasets[i]);
          }
        }

        chart.update();
      }

      lastType = type;
      lastOptions = options;
      lastData = data;
      lastTheme = theme;
    });

    _knockout.default.utils.domNodeDisposal.addDisposeCallback(canvas, () => {
      chart.destroy();
      sub.dispose();
    });
  }
};

},{"./chartjs-defaults":706,"@babel/runtime/helpers/interopRequireDefault":1050,"chartjs":"chartjs","config":831,"knockout":"knockout","rxjs/operators":287,"state":1016,"utils/core-utils":1027}],706:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _style = _interopRequireDefault(require("style"));

var _themes = _interopRequireDefault(require("themes"));

var _colorUtils = require("utils/color-utils");

/* Copyright (C) 2016 NooBaa */
const gutter = parseInt(_style.default['gutter']);

function _default(themeName) {
  const theme = _themes.default[themeName];
  return {
    // Defualt settings that apply to all chart types.
    global: {
      responsive: true,
      aspectRatio: 4,
      maintainAspectRatio: true,
      legend: {
        display: false
      },
      tooltips: {
        backgroundColor: (0, _colorUtils.colorToRgb)(...(0, _colorUtils.rgbToColor)(theme.color13), .8),
        position: 'nearest',
        multiKeyBackground: 'transparent',
        caretSize: 7,
        cornerRadius: gutter / 4,
        xPadding: gutter / 2,
        yPadding: gutter / 2,
        titleFontFamily: _style.default['font-family1'],
        titleFonrStyle: 'normal',
        titleFontColor: theme.color02,
        titleFontSize: parseInt(_style.default['font-size2']),
        titleMarginBottom: gutter / 2,
        bodyFontFamily: _style.default['font-family1'],
        bodyFontColor: theme.color02,
        bodyFontSize: parseInt(_style.default['font-size1']),
        bodySpacing: gutter / 2
      }
    },
    // Defualt settings that apply to the scales for all chart types.
    scale: {
      gridLines: {
        color: theme.color07,
        zeroLineColor: theme.color07,
        drawBorder: false
      },
      ticks: {
        fontSize: 10,
        fontColor: theme.color11,
        fontFamily: _style.default['font-family1'],
        min: 0
      },
      scaleLabel: {
        fontSize: 11,
        fontColor: theme.color17,
        fontFamily: _style.default['font-family1']
      },
      maxBarThickness: gutter * 3
    },
    // Defualt settings for all charts of bar type.
    bar: {
      tooltips: {
        intersect: false
      },
      scales: {
        xAxes: [{
          gridLines: {
            display: false
          },
          ticks: {
            fontColor: theme.color17
          }
        }]
      }
    },
    // Defualt settings for all charts of line type.
    line: {
      tooltips: {
        mode: 'index'
      }
    }
  };
}

},{"@babel/runtime/helpers/interopRequireDefault":1050,"style":"style","themes":1018,"utils/color-utils":1026}],707:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<canvas class=\"no-select\" ko.chartjs=\"config\"></canvas>\n<div class=\"fill chartjs-overlay\"\n    ko.visible=\"emptyMessage\"\n    ko.if=\"emptyMessage\"\n>\n    <p class=\"empty-message fade-in\" ko.text=\"emptyMessage\"></p>\n</div>\n";

},{}],708:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("./chartjs-binding");

var _chartjs = _interopRequireDefault(require("./chartjs.html"));

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
function isEmpty(data) {
  const _data = _knockout.default.unwrap(data);

  if (!_data) return true;

  let datasets = _knockout.default.unwrap(_data.datasets);

  if (!datasets) return true;
  return datasets.every(dataset => {
    let _dataset = _knockout.default.unwrap(dataset);

    if (!_dataset) return true;

    const data = _knockout.default.unwrap(_dataset.data);

    if (!data) return true;
    return data.length === 0;
  });
}

class ChartJSViewModel {
  constructor(params) {
    const {
      type = 'line',
      data = {},
      options = {},
      emptyMessage = 'No data to display',
      forceEmptyMessage = false
    } = params;
    this.config = {
      type,
      options,
      data
    };
    this.emptyMessage = _knockout.default.pureComputed(() => _knockout.default.unwrap(forceEmptyMessage) || isEmpty(data) ? _knockout.default.unwrap(emptyMessage) : '');
  }

}

var _default = {
  viewModel: ChartJSViewModel,
  template: _chartjs.default
};
exports.default = _default;

},{"./chartjs-binding":705,"./chartjs.html":707,"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout"}],709:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<label class=\"row\">\n    <input type=\"checkbox\"\n        ko.checked=\"$data.checked\"\n        ko.checkedValue=\"$data.value\"\n        ko.disable=\"$data.disabled || false\"\n    \"/>\n    <svg class=\"checkbox-box\">\n        <rect class=\"outer-rect\"></rect>\n        <path class=\"inner-path\"></path>\n    </svg>\n    <span class=\"checkbox-label no-wrap\"\n        ko.text=\"$data.label || $data.value\"\n        ko.tooltip=\"$data.tooltip\"\n    \"></span>\n</label>\n";

},{}],710:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _checkbox = _interopRequireDefault(require("./checkbox.html"));

/* Copyright (C) 2016 NooBaa */

/*
    Component Parameters:
    - value: the value of the checkbox input
    - checked: the observable to bind the value to.
    - disabled: true if the radio should be disabled.
*/
var _default = {
  template: _checkbox.default
};
exports.default = _default;

},{"./checkbox.html":709,"@babel/runtime/helpers/interopRequireDefault":1050}],711:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _knockout = _interopRequireDefault(require("knockout"));

var _prism = _interopRequireDefault(require("prism"));

/* Copyright (C) 2016 NooBaa */
const contentSizeLimit = 500000;
const toLargeMessageHtml = '<p class="empty-message">Content too be large to be displayed</p>';

function _addLineNumbers(html) {
  return html.split('\n').map(line => `<span class="codeline">${line}</span>`).join('\n');
}

_knockout.default.bindingHandlers.codeviewer = {
  update(element, valueAccessor) {
    const {
      code,
      lang
    } = _knockout.default.deepUnwrap(valueAccessor());

    if (element.textContent !== code) {
      if (!code) {
        element.innerHTML = '';
      } else {
        if (code.length > contentSizeLimit) {
          element.innerHTML = toLargeMessageHtml;
        } else if (lang === 'none') {
          element.innerHTML = _addLineNumbers(code);
        } else {
          element.innerHTML = _addLineNumbers(_prism.default.highlight(code, _prism.default.languages[lang]));
        }
      }
    }
  }

};

},{"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","prism":"prism"}],712:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<!-- Do not relayout this file! the code tag cannot be prexied or suffixed with\n    whitespaces or linebrakes because pre tag preserve these  -->\n<pre class=\"pad line-number\" ko.css=\"css\"><code ko.codeviewer=\"{ code, lang }\"></code></pre>\n";

},{}],713:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("./code-viewer-binding");

var _codeViewer = _interopRequireDefault(require("./code-viewer.html"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

/* Copyright (C) 2016 NooBaa */
const langMapping = (0, _coreUtils.deepFreeze)({
  js: 'javascript',
  json: 'javascript',
  html: 'html',
  xml: 'xml',
  css: 'css',
  less: 'css',
  svg: 'svg'
});

class CodeViewerViewModel {
  constructor(params) {
    this.code = _knockout.default.pureComputed(() => _knockout.default.unwrap(params.code));
    this.lang = _knockout.default.pureComputed(() => langMapping[_knockout.default.unwrap(params.lang)] || 'none');
    this.css = _knockout.default.pureComputed(() => `language-${this.lang()}`);
  }

}

var _default = {
  viewModel: CodeViewerViewModel,
  template: _codeViewer.default
};
exports.default = _default;

},{"./code-viewer-binding":711,"./code-viewer.html":712,"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","utils/core-utils":1027}],714:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"row content-middle cursor-pointer\"\n    ko.click=\"() => intent.toggle()\"\n>\n    <h2 class=\"greedy heading3\" ko.text=\"title\"></h2>\n\n    <button class=\"btn-flat expand-btn\" >\n        <svg-icon class=\"icon-small rotate\"\n            params=\"name: 'chevron'\"\n            ko.css.deg-90=\"intent\"\n        ></svg-icon>\n    </button>\n</div>\n\n<!-- ko if: collapsedTemplate.length -->\n<div class=\"collapsed-wrapper\"\n    ko.css.show=\"intent\"\n    ko.template=\"{ nodes: collapsedTemplate, data: $parent }\"\n></div>\n<!-- /ko -->\n\n<div ko.expand=\"!intent()\"\n    ko.template=\"{ nodes: expandedTemplate, data: $parent }\"\n></div>\n\n\n";

},{}],715:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _collapsibleSection = _interopRequireDefault(require("./collapsible-section.html"));

/* Copyright (C) 2016 NooBaa */
class CollapsibleSectionViewModel {
  constructor(params, collapsedTemplate, expandedTemplate) {
    let {
      title,
      collapsed
    } = params;
    this.title = title;
    this.intent = collapsed;
    this.collapsedTemplate = collapsedTemplate;
    this.expandedTemplate = expandedTemplate;
  }

}

function viewModelFactory(params, info) {
  const collapsedTemplate = info.templateNodes.find(template => template.dataset && template.dataset.name === 'collapsed');
  const expandedTemplate = info.templateNodes.find(template => template.dataset && template.dataset.name === 'expanded');
  return new CollapsibleSectionViewModel(params, collapsedTemplate ? [collapsedTemplate] : [], expandedTemplate ? [expandedTemplate] : []);
}

var _default = {
  viewModel: {
    createViewModel: viewModelFactory
  },
  template: _collapsibleSection.default
};
exports.default = _default;

},{"./collapsible-section.html":714,"@babel/runtime/helpers/interopRequireDefault":1050}],716:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<button class=\"icon-btn\"\n    tabindex=\"-1\"\n    ko.tooltip=\"tooltip\"\n    ko.event.mouseenter=\"onEnter\"\n    ko.click=\"onClick\"\n\">\n    <svg-icon class=\"icon-small\" params=\"name: 'copy-to-clipboard'\"></svg-icon>\n</button>\n";

},{}],717:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _copyToClipboardButton = _interopRequireDefault(require("./copy-to-clipboard-button.html"));

var _knockout = _interopRequireDefault(require("knockout"));

var _browserUtils = require("utils/browser-utils");

var _promiseUtils = require("utils/promise-utils");

/* Copyright (C) 2016 NooBaa */
const copyMessage = 'Copy to Clipboard';
const copiedMessage = 'Copied';

class CopyToClipboardButtonViewModel {
  constructor({
    value,
    disabled = false
  }) {
    (0, _defineProperty2.default)(this, "value", '');
    (0, _defineProperty2.default)(this, "disabled", false);
    (0, _defineProperty2.default)(this, "tooltip", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "handle", -1);
    this.value = value;
    this.disabled = disabled;
    this.tooltip = _knockout.default.observable(copyMessage);
  }

  onClick() {
    (0, _browserUtils.copyTextToClipboard)(_knockout.default.unwrap(this.value));
    this.tooltip(copiedMessage);
  }

  async onEnter() {
    if (this.tooltip() == copiedMessage) {
      this.tooltip(null);
      await (0, _promiseUtils.sleep)(400);
      this.tooltip(copyMessage);
    }
  }

}

var _default = {
  viewModel: CopyToClipboardButtonViewModel,
  template: _copyToClipboardButton.default
};
exports.default = _default;

},{"./copy-to-clipboard-button.html":716,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","utils/browser-utils":1021,"utils/promise-utils":1039}],718:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<span class=\"column\"\n    ko.css.no-color=\"color.eq('')\"\n    ko.style.border-left-color=\"color\"\n>\n    <span class=\"heading3\">{{value}}</span>\n    <span>{{label}}</span>\n</span>\n";

},{}],719:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _counter = _interopRequireDefault(require("./counter.html"));

var _knockout = _interopRequireDefault(require("knockout"));

var _chartUtils = require("utils/chart-utils");

/* Copyright (C) 2016 NooBaa */
class CounterViewModel {
  constructor(params) {
    const {
      label,
      color = '',
      value,
      format,
      tween = true
    } = params;
    const formatter = (0, _chartUtils.getFormatter)(format);

    const pureValue = _knockout.default.pureComputed(() => _knockout.default.unwrap(value) || 0).extend(tween ? {
      tween: {
        useDiscreteValues: true
      }
    } : {});

    this.label = label;
    this.color = _knockout.default.pureComputed(() => _knockout.default.unwrap(color));
    this.value = _knockout.default.pureComputed(() => formatter(pureValue()));
  }

}

var _default = {
  viewModel: CounterViewModel,
  template: _counter.default
};
exports.default = _default;

},{"./counter.html":718,"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","utils/chart-utils":1023}],720:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"button-cell\">\n    <button class=\"link alt-colors\"\n        ko.text=\"ko.unwrap($data).text || $data\"\n        ko.click=\"ko.unwrap($data).click\"\n    ></button>\n</div>\n";

},{}],721:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<capacity-bar params=\"\n    total: ko.unwrap($data).total,\n    used: ko.unwrap($data).used\n\"></capacity-bar>\n";

},{}],722:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<checkbox params=\"checked: $data\"></checkbox>\n";

},{}],723:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<delete-button params=\"\n    id: ko.unwrap($data).id,\n    text: ko.unwrap($data).text,\n    subject: ko.unwrap($data).subject,\n    active: ko.unwrap($data).active,\n    disabled: ko.unwrap($data).disabled,\n    onDelete: ko.unwrap($data).onDelete || $data,\n    onToggle: ko.unwrap($data).onToggle,\n    tooltip: ko.unwrap($data).tooltip\n\"></delete-button>\n";

},{}],724:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<button class=\"btn-flat rotate\"\n    ko.click=\"() => $row.isExpanded.toggle()\"\n    ko.css.deg-90=\"!$row.isExpanded()\"\n\">\n    <svg-icon class=\"icon-small\" params=\"name: 'chevron'\"></svg-icon>\n</button>\n\n";

},{}],725:[function(require,module,exports){
module.exports = "<div ko.tooltip=\"$data.tooltip\">\n    <button class=\"icon-btn\"\n        ko.click=\"() => $data.onClick(ko.unwrap($data.id))\"\n        ko.disable=\"$data.disabled\"\n    >\n        <svg-icon params=\"name: $data.icon\"></svg-icon>\n    </button>\n</div>\n";

},{}],726:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<svg-icon params=\"name: ko.unwrap($data).name || $data\"\n    ko.css=\"ko.unwrap($data).css\"\n    ko.tooltip=\"ko.unwrap($data).tooltip\"\n\"></svg-icon>\n";

},{}],727:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "expand", {
  enumerable: true,
  get: function () {
    return _expandCell.default;
  }
});
Object.defineProperty(exports, "text", {
  enumerable: true,
  get: function () {
    return _textCell.default;
  }
});
Object.defineProperty(exports, "icon", {
  enumerable: true,
  get: function () {
    return _iconCell.default;
  }
});
Object.defineProperty(exports, "link", {
  enumerable: true,
  get: function () {
    return _linkCell.default;
  }
});
Object.defineProperty(exports, "checkbox", {
  enumerable: true,
  get: function () {
    return _checkboxCell.default;
  }
});
Object.defineProperty(exports, "capacity", {
  enumerable: true,
  get: function () {
    return _capacityCell.default;
  }
});
Object.defineProperty(exports, "delete", {
  enumerable: true,
  get: function () {
    return _deleteCell.default;
  }
});
Object.defineProperty(exports, "button", {
  enumerable: true,
  get: function () {
    return _buttonCell.default;
  }
});
Object.defineProperty(exports, "iconButton", {
  enumerable: true,
  get: function () {
    return _iconButtonCell.default;
  }
});

var _expandCell = _interopRequireDefault(require("./expand-cell.html"));

var _textCell = _interopRequireDefault(require("./text-cell.html"));

var _iconCell = _interopRequireDefault(require("./icon-cell.html"));

var _linkCell = _interopRequireDefault(require("./link-cell.html"));

var _checkboxCell = _interopRequireDefault(require("./checkbox-cell.html"));

var _capacityCell = _interopRequireDefault(require("./capacity-cell.html"));

var _deleteCell = _interopRequireDefault(require("./delete-cell.html"));

var _buttonCell = _interopRequireDefault(require("./button-cell.html"));

var _iconButtonCell = _interopRequireDefault(require("./icon-button-cell.html"));

},{"./button-cell.html":720,"./capacity-cell.html":721,"./checkbox-cell.html":722,"./delete-cell.html":723,"./expand-cell.html":724,"./icon-button-cell.html":725,"./icon-cell.html":726,"./link-cell.html":728,"./text-cell.html":729,"@babel/runtime/helpers/interopRequireDefault":1050}],728:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"link-cell\">\n    <!-- ko if: ko.unwrap($data).href -->\n    <a class=\"link\"\n       ko.attr.href=\"ko.unwrap($data).href\"\n       ko.text=\"ko.unwrap($data).text\"\n       ko.tooltip=\"ko.unwrap($data).tooltip\"\n    ></a>\n    <!-- /ko -->\n    <!-- ko ifnot: ko.unwrap($data).href -->\n    <span ko.text=\"ko.unwrap($data).text\"\n       ko.tooltip=\"ko.unwrap($data).tooltip\"\n    ></span>\n    <!-- /ko -->\n</div>\n";

},{}],729:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"text-cell\" ko.tooltip=\"ko.unwrap($data).tooltip\">\n    <span ko.text=\"ko.unwrap($data).text || $data\"\n        ko.css=\"ko.unwrap($data).css\"\n    ></span>\n</div>\n\n";

},{}],730:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _stringUtils = require("utils/string-utils");

/* Copyright (C) 2016 NooBaa */
function addSpaces(str) {
  return str.replace(/[A-Z1-9]+/g, match => ` ${match}`);
}

class ColumnViewModel {
  constructor(config, templates, sorting) {
    const normalized = (0, _coreUtils.isObject)(config) ? config : {
      name: config.toString()
    };
    const {
      name,
      prop = name,
      label = addSpaces(name),
      type = 'text',
      accessor = _coreUtils.noop,
      css = `${(0, _stringUtils.toDashedCase)(name)}-col`,
      sortable = false
    } = normalized;
    this.name = name;
    this.prop = prop;
    this.label = label;
    this.accessor = accessor;
    this.template = templates[type];
    this.css = css;
    this.sorting = sorting;
    this.sortKey = sortable && ((0, _coreUtils.isString)(sortable) ? sortable : name);
    this.sortCss = _knockout.default.pureComputed(() => this.getSortCss());
  }

  getSortCss() {
    const {
      sorting,
      sortKey
    } = this;

    if (!sorting || !sortKey) {
      return '';
    }

    const {
      sortBy,
      order
    } = _knockout.default.unwrap(sorting) || {};
    return `sortable ${sortBy === sortKey ? order === 1 ? 'des' : 'asc' : ''}`;
  }

  sortBy() {
    if (!this.sortKey) {
      return;
    }

    const {
      sortBy,
      order
    } = this.sorting();
    this.sorting({
      sortBy: this.sortKey,
      order: sortBy === this.sortKey ? 0 - order : 1
    });
  }

  generateCellTemplate() {
    const {
      css,
      name,
      prop,
      template
    } = this;
    const visibleValue = `$component.isColumnVisible('${name}')`;
    const cssValue = `'${css}'`;
    const letValue = `{ $data: $data.${prop}, $rawData: $data.${prop} }`;
    return `<td ko.visible="${visibleValue}" ko.css="${cssValue}" ko.let="${letValue}">${template}</td>`;
  }

}

exports.default = ColumnViewModel;

},{"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","utils/core-utils":1027,"utils/string-utils":1046}],731:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<table ko.css=\"tableCss\"\n    ko.scroll=\"scroll\"\n>\n    <thead>\n        <tr class=\"header-row\" ko.foreach=\"columns\">\n            <th ko.css=\"css\"\n                ko.visible=\"$component.isColumnVisible(name)\"\n            >\n                <span ko.text=\"label\"\n                    ko.css=\"sortCss\"\n                    ko.click=\"sortBy\"\n                ></span>\n            </th>\n        </tr>\n    </thead>\n    <tbody ko.foreach=\"rows\">\n        <!-- ko if: vm -->\n        <tr class=\"main-row\"\n            ko.css=\"md.css\"\n            ko.css.row-disabled=\"md.isDisabled\"\n            ko.click=\"md.clickHandler\"\n            ko.template=\"{ html: md.template, data: vm, let: { $row: md } }\"\n        ></tr>\n        <!-- /ko -->\n\n        <!-- ko if: md.subRowTemplate -->\n        <tr class=\"sub-row text-left\">\n             <td ko.attr.colspan=\"md.columnCount\">\n                 <div class=\"column\"\n                    ko.expand=\"md.isExpanded\"\n                    ko.template=\"{ html: md.subRowTemplate, data: vm }\"\n                ><div>\n             </td>\n        </tr>\n        <!-- /ko -->\n    </tbody>\n</table>\n\n<loading-indicator class=\"align-middle pad\"\n    ko.visible=\"loading\"\n></loading-indicator>\n\n<div class=\"empty-message\"\n    ko.visible=\"emptyMessage\"\n>\n    {{emptyMessage}}\n</div>\n\n\n\n";

},{}],732:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _dataTable = _interopRequireDefault(require("./data-table.html"));

var _column = _interopRequireDefault(require("./column"));

var cellTemplates = _interopRequireWildcard(require("./cell-templates"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

/* Copyright (C) 2016 NooBaa */
const scrollThrottle = 750;
const expandColumnDescriptor = {
  name: 'expand',
  type: 'expand',
  label: ''
};

class DataTableViewModel {
  constructor(params, inlineTemplates) {
    const {
      columns = [],
      // The default is used to strip the accessor in case the
      // data array is the actual rows view model array
      rowFactory,
      data,
      sorting,
      scroll = _knockout.default.observable(),
      rowCssProp,
      rowDisabledProp,
      rowClick,
      subRow,
      emptyMessage,
      loading = false,
      disabled = false,
      expandColumn = false,
      visibleColumns
    } = params;
    const templates = Object.assign({}, cellTemplates, inlineTemplates);
    this.subRowTemplate = subRow && inlineTemplates[subRow];
    this.tableCss = {
      'has-sub-rows': Boolean(this.subRowTemplate),
      'table-disabled': disabled
    }; // Hold current position of vertical scroll of the table.

    this.scroll = scroll.extend({
      rateLimit: {
        method: 'notifyWhenChangesStop',
        timeout: scrollThrottle
      }
    }); // Hold table sorting infromation (sortBy and order).

    this.sorting = sorting;
    this.expandColumn = expandColumn; // Create view model for columns.

    this.columns = _knockout.default.pureComputed(() => {
      let descriptors = _knockout.default.unwrap(columns); // Add a descriptor for the sub row expand/collapse button.


      if (this.subRowTemplate && this.expandColumn) {
        descriptors = descriptors.concat(expandColumnDescriptor);
      }

      return descriptors.map(descriptor => new _column.default(descriptor, templates, sorting));
    });
    this.visibleColumns = visibleColumns;
    this.columnCount = _knockout.default.pureComputed(() => {
      const visible = _knockout.default.unwrap(this.visibleColumns) || this.columns();
      return visible.length;
    });
    this.rowFactory = rowFactory;
    this.rows = _knockout.default.observableArray(); // This is used to generate a complete template for a row in order to
    // to skip using knockout template bindings for each column which will
    // strip down the observable and rerender the entire cell each time the
    // computeds in the rowViewModel change values.

    this.rowTemplate = _knockout.default.pureComputed(() => this.columns().map(column => column.generateCellTemplate()).join(''));
    this.rowCssProp = rowCssProp;
    this.rowDisabledProp = rowDisabledProp;
    this.rowClick = rowClick; // Set loading flags

    this.loading = loading; // Empty table message handling.

    this.emptyMessage = _knockout.default.pureComputed(() => {
      if (_knockout.default.unwrap(loading) || this.rows().length !== 0) {
        return null;
      }

      return _knockout.default.unwrap(emptyMessage);
    }); // Init the table rows.

    this.updateRows(data); // Update the table rows on data change event.

    if (_knockout.default.isObservable(data)) {
      this.updateSub = data.subscribe(() => this.updateRows(data));
    }
  }

  updateRows(data) {
    const currLen = this.rows().length;
    const nextLen = (_knockout.default.unwrap(data) || []).length;
    let diff = currLen - nextLen;

    if (diff < 0) {
      for (let i = currLen; i < nextLen; ++i) {
        const vm = (0, _coreUtils.isFunction)(this.rowFactory) ? this.rowFactory(() => (_knockout.default.unwrap(data) || [])[i]) : (_knockout.default.unwrap(data) || [])[i];
        const md = this.newRowMetaData(vm);
        this.rows.push({
          vm,
          md
        });
      }
    } else if (diff > 0) {
      while (diff-- > 0) {
        const {
          vm
        } = this.rows.pop();
        (0, _coreUtils.isFunction)(vm.dispose) && vm.dispose();
      }
    }
  }

  newRowMetaData(rowVM) {
    let isExpanded = true;

    if ((0, _coreUtils.isString)(this.expandColumn)) {
      const columnProp = rowVM[this.expandColumn];
      isExpanded = _knockout.default.isWritableObservable(columnProp) ? columnProp : _knockout.default.pureComputed({
        read: () => _knockout.default.unwrap(columnProp),
        write: _coreUtils.echo
      });
    } else if (this.expandColumn) {
      isExpanded = _knockout.default.observable(false);
    }

    let isDisabled = false;

    if ((0, _coreUtils.isString)(this.rowDisabledProp)) {
      const value = rowVM[this.rowDisabledProp];
      isDisabled = _knockout.default.isObservable(value) ? _knockout.default.pureComputed(value) : value;
    }

    return {
      template: this.rowTemplate,
      subRowTemplate: this.subRowTemplate,
      columnCount: this.columnCount,
      css: _knockout.default.pureComputed(() => _knockout.default.unwrap(rowVM[this.rowCssProp])),
      isExpanded,
      isDisabled,
      clickHandler: this.rowClick && (() => this.rowClick(rowVM))
    };
  }

  isColumnVisible(name) {
    const visibleColumns = _knockout.default.unwrap(this.visibleColumns);

    return !Array.isArray(visibleColumns) || visibleColumns.includes(name);
  }

  dispose() {
    const {
      rows,
      updateSub
    } = this;
    rows().forEach(row => (0, _coreUtils.isFunction)(row.vm.dispose) && row.vm.dispose());
    updateSub && updateSub.dispose();
  }

}

function viewModelFactory(params, info) {
  const templates = info.templateNodes.filter(({
    nodeType
  }) => nodeType === 1).reduce((templates, template) => {
    const name = template.getAttribute('name');
    const html = template.innerHTML;
    templates[name] = html;
    return templates;
  }, {});
  return new DataTableViewModel(params, templates);
}

var _default = {
  viewModel: {
    createViewModel: viewModelFactory
  },
  template: _dataTable.default
};
exports.default = _default;

},{"./cell-templates":727,"./column":730,"./data-table.html":731,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"knockout":"knockout","utils/core-utils":1027}],733:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<editor params=\"label: 'Date'\">\n    <div class=\"row editor-row\">\n        <dropdown class=\"text-center push-next\" params=\"\n            options: monthOptions,\n            placeholder: 'month',\n            selected: month\n        \"></dropdown>\n        <dropdown class=\"text-center push-next\" params=\"\n            options: dayOptions,\n            placeholder: 'day',\n            selected: day\n        \"></dropdown>\n        <dropdown class=\"text-center\" params=\"\n            options: yearOptions,\n            placeholder: 'year',\n            selected: year\n        \"></dropdown>\n    </div>\n</editor>\n\n<editor params=\"label: 'Time', insertValMessages: false\">\n    <div class=\"row editor-row\">\n        <input type=\"number\"\n            class=\"push-next\"\n            min=\"0\"\n            max=\"23\"\n            placeholder=\"hours\"\n            ko.textInput=\"hour\"\n        />\n        <input type=\"number\"\n            class=\"push-next\"\n            min=\"0\"\n            max=\"59\"\n            placeholder=\"minutes\"\n            ko.textInput=\"minute\"\n        />\n        <input type=\"number\"\n            min=\"0\"\n            max=\"59\"\n            placeholder=\"seconds\"\n            ko.textInput=\"second\"\n        />\n    </div>\n</editor>\n";

},{}],734:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _dateTimeChooser = _interopRequireDefault(require("./date-time-chooser.html"));

var _knockout = _interopRequireDefault(require("knockout"));

var _moment = _interopRequireDefault(require("moment"));

var _coreUtils = require("utils/core-utils");

/* Copyright (C) 2016 NooBaa */
class DateTimeChooserViewModel {
  constructor({
    time,
    timezone
  }) {
    this.yearOptions = (0, _coreUtils.makeRange)((0, _moment.default)().year() - 10, (0, _moment.default)().year() + 10).map(value => ({
      label: value,
      value: value
    }));
    this.monthOptions = (0, _coreUtils.makeRange)(12).map(month => ({
      label: (0, _moment.default)({
        month
      }).format('MMM'),
      value: month
    }));
    this.dayOptions = _knockout.default.pureComputed(() => {
      let lastDayOfMonth = (0, _moment.default)({
        year: this.year(),
        month: this.month()
      }).endOf('month').date();
      return (0, _coreUtils.makeRange)(1, lastDayOfMonth).map(value => ({
        label: value,
        value: value
      }));
    });
    this.year = this.makePartComputed(time, timezone, 'year');
    this.month = this.makePartComputed(time, timezone, 'month');
    this.day = this.makePartComputed(time, timezone, 'date');
    this.hour = this.makePartComputed(time, timezone, 'hour').extend({
      required: true,
      min: 0,
      max: 23
    });
    this.minute = this.makePartComputed(time, timezone, 'minute').extend({
      required: true,
      min: 0,
      max: 59
    });
    this.second = this.makePartComputed(time, timezone, 'second').extend({
      required: true,
      min: 0,
      max: 59
    });
  }

  makePartComputed(time, timezone, part) {
    return _knockout.default.pureComputed({
      read() {
        return _moment.default.tz(time(), _knockout.default.unwrap(timezone)).get(part);
      },

      write(value) {
        time(_moment.default.tz(time(), _knockout.default.unwrap(timezone)).set(part, value).valueOf());
      }

    });
  }

}

var _default = {
  viewModel: DateTimeChooserViewModel,
  template: _dateTimeChooser.default
};
exports.default = _default;

},{"./date-time-chooser.html":733,"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","moment":"moment","utils/core-utils":1027}],735:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div ko.css.active=\"isActive\"\n    ko.tooltip=\"tooltip\"\n>\n    <span class=\"message-wrapper\">\n        <span class=\"row content-middle message-text\">\n            <span class=\"push-next\">{{question}}</span>\n\n            <a class=\"link\"\n                tabindex=\"-1\"\n                href\n                ko.click=\"onConfirm\"\n            >YES</a>\n            /\n            <a class=\"link\"\n                tabindex=\"-1\"\n                href\n                ko.click=\"onCancel\"\n            >NO</a>\n        </span>\n    </span>\n\n    <button class=\"icon-btn no-focus-ring\"\n        ko.disable=\"disabled\"\n        ko.click=\"onToggle\"\n    \">\n        <svg-icon params=\"name: icon\"></svg-icon>\n    </button>\n</div>\n";

},{}],736:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _deleteButton = _interopRequireDefault(require("./delete-button.html"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _stringUtils = require("utils/string-utils");

/* Copyright (C) 2016 NooBaa */
class DeleteButtonViewModel {
  constructor({
    id = (0, _stringUtils.randomString)(),
    text = 'Delete',
    active = _knockout.default.observable(),
    tooltip,
    disabled = false,
    onDelete,
    onToggle
  }) {
    this.id = id;
    this.onDelete = (0, _coreUtils.isFunction)(onDelete) ? onDelete : _coreUtils.noop;
    this.disabled = disabled;
    this.isActive = (0, _coreUtils.isFunction)(onToggle) ? this.isActive = _knockout.default.pureComputed({
      read: active,
      write: val => onToggle(val ? _knockout.default.unwrap(id) : null)
    }) : active;
    this.tooltip = _knockout.default.pureComputed(() => {
      if (this.isActive()) return;

      const naked = _knockout.default.unwrap(tooltip);

      if (naked == null) {
        return {
          align: 'end',
          text: _knockout.default.unwrap(text)
        };
      } else if ((0, _coreUtils.isString)(naked)) {
        return {
          align: 'end',
          text: naked
        };
      } else {
        return {
          align: 'end',
          ...naked
        };
      }
    });
    this.icon = _knockout.default.pureComputed(() => _knockout.default.unwrap(this.disabled) || !this.isActive() ? 'bin-closed' : 'bin-opened');
    this.question = _knockout.default.pureComputed(() => `${_knockout.default.unwrap(text)}?`);
  }

  onToggle() {
    this.isActive.toggle();
  }

  onConfirm() {
    this.isActive(false);
    this.onDelete(_knockout.default.unwrap(this.id));
  }

  onCancel() {
    this.isActive(false);
  }

}

var _default = {
  viewModel: DeleteButtonViewModel,
  template: _deleteButton.default
};
exports.default = _default;

},{"./delete-button.html":735,"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","utils/core-utils":1027,"utils/string-utils":1046}],737:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"drawer-wrapper\"\n    ko.if=\"component\"\n    ko.visible=\"component\"\n    ko.css.opened=\"opened\"\n\">\n    <div class=\"drawer-backdrop\" ko.click=\"close\"></div>\n    <div class=\"drawer-content\"\n        ko.component=\"{ name: component, params: params }\"\n        ko.css=\"component\"\n        ko.event.transitionend=\"onTransitionEnd\"\n    \"></div>\n</div>\n";

},{}],738:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _drawer = _interopRequireDefault(require("./drawer.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _actionCreators = require("action-creators");

var _coreUtils = require("utils/core-utils");

/* Copyright (C) 2016 NooBaa */
class DrawerViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "component", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "params", {
      onClose: this.close.bind(this)
    });
    (0, _defineProperty2.default)(this, "opened", _knockout.default.observable());
  }

  selectState(state) {
    return [state.drawer];
  }

  mapStateToProps(drawer) {
    if (!this.opened() || drawer) {
      this.component(drawer);
    } // Must be async in oreder to invoke the css transition.


    (0, _coreUtils.runAsync)(() => this.opened(Boolean(drawer)));
  }

  onTransitionEnd() {
    // Destroy the component only after the transition ends.
    if (!this.opened()) {
      this.component(null);
    }
  }

  close() {
    this.dispatch((0, _actionCreators.closeDrawer)());
  }

}

var _default = {
  viewModel: DrawerViewModel,
  template: _drawer.default
};
exports.default = _default;

},{"./drawer.html":737,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout","utils/core-utils":1027}],739:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"row drop-container pad\"\n    ko.css=\"css\"\n    ko.event=\"events\"\n    ko.event.drop=\"(vm ,evt) => onDrop(vm, evt, $parent)\"\n>\n    <div class=\"column align-middle content-middle greedy\" ko.template=\"{\n        nodes: $componentTemplateNodes || [],\n        data: $parent\n    }\"></div>\n</div>\n\n";

},{}],740:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _dropArea = _interopRequireDefault(require("./drop-area.html"));

var _coreUtils = require("utils/core-utils");

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
class DropAreaViewModel {
  constructor({
    onDrop = _coreUtils.noop,
    disabled = false,
    active = false
  }) {
    this.dropHandler = onDrop;
    this.dragCounter = _knockout.default.observable(0);
    this.css = _knockout.default.pureComputed(() => ({
      dragover: Boolean(this.dragCounter()),
      disabled: Boolean(_knockout.default.unwrap(disabled)),
      active: Boolean(_knockout.default.unwrap(active))
    }));
    this.events = {
      dragenter: this.onDragEnter.bind(this),
      dragleave: this.onDragLeave.bind(this),
      dragover: this.onDragOver.bind(this)
    };
  }

  onDragEnter() {
    this.dragCounter(this.dragCounter() + 1);
    return false;
  }

  onDragLeave() {
    this.dragCounter(this.dragCounter() - 1);
    return false;
  }

  onDragOver() {
    return false;
  }

  onDrop(viewModel, event, parentViewModel) {
    this.dragCounter(0);
    this.dropHandler.call(parentViewModel, viewModel, event);
  }

}

var _default = {
  viewModel: DropAreaViewModel,
  template: _dropArea.default
};
exports.default = _default;

},{"./drop-area.html":739,"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","utils/core-utils":1027}],741:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _stringUtils = require("utils/string-utils");

/* Copyright (C) 2016 NooBaa */
function _getActionTooltip(tooltip) {
  if (!tooltip) {
    return '';
  }

  if ((0, _coreUtils.isObject)(tooltip) && !Array.isArray(tooltip) && !null) {
    return { ...tooltip,
      position: 'after'
    };
  }

  return {
    text: tooltip,
    position: 'after'
  };
}

class ActionRowViewModel {
  constructor({
    onFocus
  }) {
    (0, _defineProperty2.default)(this, "focusId", (0, _stringUtils.randomString)());
    (0, _defineProperty2.default)(this, "clickHandler", null);
    (0, _defineProperty2.default)(this, "focusHandler", null);
    (0, _defineProperty2.default)(this, "label", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "disabled", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "hasFocus", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "tooltip", _knockout.default.observable());
    this.focusHandler = onFocus;
  }

  onUpdate(action, focus) {
    const {
      label = action,
      disabled = false,
      tooltip,
      onClick = _coreUtils.noop
    } = action;
    this.label(label);
    this.disabled(disabled);
    this.tooltip(_getActionTooltip(tooltip));
    this.clickHandler = onClick;
    this.hasFocus(focus === this.focusId);
  }

  onClick() {
    this.clickHandler();
  }

  onFocus(val) {
    this.focusHandler(val ? this.focusId : '');
  }

  onMouseDown() {
    // Prevent disabled options form foucsing out
    // the active element.
    return !this.disabled();
  }

}

exports.default = ActionRowViewModel;

},{"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","utils/core-utils":1027,"utils/string-utils":1046}],742:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"dd-wrapper\">\n    <div class=\"dd-summary input no-wrap\"\n        ko.css.focus=\"focus\"\n        ko.css.disabled=\"disabled\"\n        ko.css.placeholder=\"usingPlacholderText\"\n        ko.attr.tabindex=\"tabIndex\"\n        ko.event.keydown=\"onSummaryKeyDown\"\n        ko.click=\"onSummaryClick\"\n        ko.hasFocus=\"ko.pc(summaryHasFocus, onSummaryFocus, $data)\"\n    >\n        {{summary}}\n    </div>\n    <svg-icon class=\"icon-small dd-chevron\"\n        ko.css.disabled=\"disabled\"\n        params=\"name: 'chevron'\"\n    ></svg-icon>\n\n    <div class=\"fill card-shadow dd-collapse-wrapper\"\n        ko.expand=\"isListVisible\"\n        ko.event.transitionend=\"onListTransitionEnd\"\n    >\n        <div class=\"dd-list column content-stretch\"\n            ko.event.keydown=\"onListKeydown\"\n            ko.keyboardNavigation=\"true\"\n        >\n            <!-- ko if: isFilterVisible -->\n            <div class=\"column dd-filter\">\n                <input type=\"search\"\n                    ko.attr.placeholder=\"filterPlaceholder\"\n                    ko.textInput=\"filter\"\n                    ko.event.keydown=\"onFilterKeyDown\"\n                    ko.hasFocus=\"ko.pc(filterHasFocus, onFilterFocus, $data)\"\n                />\n            </div>\n            <hr>\n            <!-- /ko -->\n\n            <!-- ko if: actionRows().length -->\n            <div class=\"dd-actions\" ko.foreach=\"actionRows\">\n                <div ko.tooltip=\"tooltip\">\n                    <button type=\"button\"\n                        class=\"text-left no-wrap dd-action\"\n                        ko.click=\"$component.onActionClick.bind($component)\"\n                        ko.disable=\"disabled\"\n                        ko.hasFocus=\"ko.pc(hasFocus, onFocus, $data)\"\n                        ko.event.mousedown=\"onMouseDown\"\n                    >\n                        {{label}}\n                    </button>\n                </div>\n            </div>\n            <hr>\n            <!-- /ko -->\n\n            <!-- ko if: optionRows().length -->\n            <!-- ko if: isSelectAllVisible-->\n            <label class=\"row greedy content-middle dd-option\"\n                tabindex=\"0\"\n                ko.css.selected=\"selectAllValue.eq('ALL')\"\n                ko.css.partial=\"selectAllValue.eq('SOME')\"\n                ko.keysToClicks=\"['space', 'enter']\"\n                ko.click=\"onSelectAllClick\"\n                ko.hasFocus=\"ko.pc(selectAllHasFocus, onSelectAllFocus, $data)\"\n            >\n                    <svg class=\"dd-checkbox push-next-half\"\n                        ko.visible=\"$component.multiselect\"\n                    >\n                        <rect class=\"outer-rect\"></rect>\n                        <path class=\"inner-path\"></path>\n                    </svg>\n                <div class=\"no-wrap greedy dd-option-label\">{{selectAllLabel}}</div>\n            </label>\n            <hr>\n            <!-- /ko -->\n\n            <div class=\"dd-options\"\n                ko.scroll=\"optionsScrollPos\"\n            >\n                <!-- ko foreach: optionRows -->\n                <label class=\"row content-middle dd-option\"\n                    tabindex=\"0\"\n                    ko.click=\"$component.onOptionClick.bind($component)\"\n                    ko.tooltip=\"tooltip\"\n                    ko.css=\"css\"\n                    ko.css.selected=\"selected\"\n                    ko.css.disabled=\"disabled\"\n                    ko.keysToClicks=\"['space', 'enter']\"\n                    ko.hasFocus=\"ko.pc(hasFocus, onFocus, $data)\"\n                    ko.event.mousedown=\"onMouseDown\"\n                >\n                    <svg class=\"dd-checkbox push-next-half\"\n                        ko.visible=\"$component.multiselect\"\n                    >\n                        <rect class=\"outer-rect\"></rect>\n                        <path class=\"inner-path\"></path>\n                    </svg>\n                    <!-- ko if: icon -->\n                    <svg-icon class=\"push-next-half\"\n                        ko.css=\"icon().css || ''\"\n                        params=\"name: icon().name || icon()\"\n                    ></svg-icon>\n                    <!-- /ko -->\n                    <div class=\"no-wrap greedy dd-option-label\">\n                        <div class=\"no-wrap\">{{label}}</div>\n                        <div class=\"no-wrap remark\">{{remark}}</div>\n                    </div>\n                </label>\n                <!-- /ko -->\n            </div>\n            <!-- /ko -->\n\n            <!-- ko if: loading -->\n            <loading-indicator class=\"align-middle pad\"></loading-indicator>\n            <!-- /ko -->\n\n            <!-- ko if: emptyMessage -->\n            <div class=\"dd-empty\" ko.css.error=\"emptyMessage().isError\">\n                {{emptyMessage().text}}\n            </div>\n            <!-- /ko -->\n        </div>\n    </div>\n</div>\n";

},{}],743:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _dropdown = _interopRequireDefault(require("./dropdown.html"));

var _optionRow = _interopRequireDefault(require("./option-row"));

var _actionRow = _interopRequireDefault(require("./action-row"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _stringUtils = require("utils/string-utils");

var _config = require("config");

/* Copyright (C) 2016 NooBaa */
// import './dropdown-binding';
const maxOptionCount = 1000; // Cannot use ensure array util (core utils) because
// of the special case of an empty string (which in this case)
// should become an empty string.

function _toArray(value) {
  if (Array.isArray(value)) {
    return value;
  }

  if (value) {
    return [value];
  }

  return [];
}

function _normalizeOptions(options) {
  return options.map(option => {
    const {
      value = option,
      label = value,
      remark = '',
      icon,
      selectedIcon = icon,
      css,
      disabled = false
    } = option;
    return {
      value,
      label,
      remark,
      icon,
      selectedIcon,
      css,
      disabled
    };
  });
}

function _summarizeSelected(subject, values, placeholder, options) {
  const count = values.length;

  if (count == 0) {
    return placeholder;
  }

  if (count === 1) {
    const [first] = values;
    const selected = options.find(opt => opt.value === first);
    return selected && selected.label;
  }

  if (count === options.length) {
    return `All ${subject}s selected`;
  }

  return `${(0, _stringUtils.stringifyAmount)(subject, count)} selected`;
}

function _getEmptyMessage(optionCount, filteredCount, visibleCount, isLoading, inError, errorMessage, emptyMessage, filterMessage, listTooLongMessage) {
  if (isLoading) {
    return null;
  }

  if (inError) {
    return {
      text: errorMessage,
      isError: true
    };
  }

  if (optionCount === 0) {
    return {
      text: emptyMessage,
      isError: false
    };
  }

  if (filteredCount === 0) {
    return {
      text: filterMessage,
      isError: false
    };
  }

  if (visibleCount === 0) {
    return {
      text: listTooLongMessage,
      isError: false
    };
  }

  return null;
}

function _matchOption(option, filter) {
  const text = option.label.toString().toLowerCase();
  return !filter || text.includes(filter);
}

function _findFirstFocusId(filterVisible, actionRows, selectAllVisible, optionRows) {
  if (filterVisible) {
    return 'FILTER';
  }

  const [actionFocusId] = actionRows.filter(row => !row.disabled()).map(row => row.focusId);

  if (actionFocusId) {
    return actionFocusId;
  }

  if (selectAllVisible) {
    return 'SELECT_ALL';
  }

  const [optionFocusId] = optionRows.filter(row => !row.disabled()).map(row => row.focusId);

  if (optionFocusId) {
    return optionFocusId;
  }

  return 'SUMMARY';
}

class DropdownViewModel {
  constructor({
    selected,
    hasFocus,
    ...rest
  }) {
    (0, _defineProperty2.default)(this, "sub", null);
    (0, _defineProperty2.default)(this, "subject", '');
    (0, _defineProperty2.default)(this, "selectableValues", []);
    (0, _defineProperty2.default)(this, "selected", null);
    (0, _defineProperty2.default)(this, "fistItemFocusId", '');
    (0, _defineProperty2.default)(this, "summary", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "usingPlacholderText", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "multiselect", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "disabled", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "focus", _knockout.default.observable(''));
    (0, _defineProperty2.default)(this, "active", _knockout.default.observable(false));
    (0, _defineProperty2.default)(this, "loading", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isListVisible", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "optionsScrollPos", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "optionRows", _knockout.default.observableArray());
    (0, _defineProperty2.default)(this, "actionRows", _knockout.default.observableArray());
    (0, _defineProperty2.default)(this, "hiddenOptionCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isFilterVisible", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isSelectAllVisible", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "selectAllLabel", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "filter", _knockout.default.observable().throttle(_config.inputThrottle));
    (0, _defineProperty2.default)(this, "filterPlaceholder", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "selectAllValue", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "emptyMessage", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "tabIndex", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "summaryHasFocus", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "filterHasFocus", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "selectAllHasFocus", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "rowParams", {
      onFocus: this.focus
    });

    // Check if the dropdown should be focused on initial render.
    if (_knockout.default.unwrap(hasFocus)) {
      this.focus('SUMMARY');
    }

    this.selected = _knockout.default.isWritableObservable(selected) ? selected : _knockout.default.observable();

    const comp = _knockout.default.pureComputed(() => _knockout.default.deepUnwrap({ ...rest,
      selected: this.selected,
      filterText: this.filter,
      focus: this.focus,
      active: this.active
    })).extend({
      rateLimit: 10
    });

    this.onUpdate(comp());
    this.sub = comp.subscribe(val => this.onUpdate(val));
  }

  onUpdate(args) {
    const {
      subject = 'item',
      multiselect = false,
      placeholder = multiselect ? `Select ${(0, _stringUtils.pluralize)(subject)}` : `Choose ${subject}`,
      filter = false,
      filterPlaceholder = `Search ${subject || ''}`,
      filterText = '',
      disabled = false,
      loading = false,
      error = false,
      emptyMessage = (0, _stringUtils.stringifyAmount)(subject, 0, 'No'),
      errorMessage = 'Ooops... Someting went wrong',
      filterMessage = 'No Match',
      listTooLongMessage = 'List too long to show',
      selectAllLabel = 'Select All',
      actions = [],
      options: rawOptions = [],
      selected,
      focus,
      active
    } = args; // Fix active in case we lost the focus.

    if (!focus && active) {
      // Updating active will create a second onUpdate.
      // so in order to prevent duplicate updates we terminate the
      // currnet update.
      this.active(false);
      this.filter('');
      return;
    }

    const options = _normalizeOptions(rawOptions);

    const isListVisible = !disabled && active;
    const isFilterVisible = filter && !loading && !error && options.length > 0;
    const isSelectAllVisible = multiselect && !filterText;

    const selectedValues = _toArray(selected);

    const normalizedFilter = filterText.trim().toLowerCase();
    const usingPlacholderText = selectedValues.length === 0;
    const tabIndex = disabled ? false : '0';
    const filteredOptions = options.filter(option => !error && _matchOption(option, normalizedFilter));
    const visibleOptions = filteredOptions.length < maxOptionCount ? filteredOptions : [];
    const selectAllValue = selectedValues.length === options.length && 'ALL' || selectedValues.length > 0 && 'SOME' || 'NONE';

    const emptyMessageInfo = _getEmptyMessage(options.length, filteredOptions.length, visibleOptions.length, loading, error, errorMessage, emptyMessage, filterMessage, listTooLongMessage);

    const actionRows = actions.map((action, i) => {
      const row = this.actionRows.get(i) || new _actionRow.default(this.rowParams);
      row.onUpdate(action, focus);
      return row;
    });
    const optionRows = visibleOptions.map((option, i) => {
      const row = this.optionRows.get(i) || new _optionRow.default(this.rowParams);
      row.onUpdate(option, multiselect, selectedValues, focus);
      return row;
    });
    const selectableValues = options.filter(option => !option.disabled).map(option => (0, _coreUtils.isObject)(option) ? option.value : option);

    const firstItemFocusId = _findFirstFocusId(isFilterVisible, actionRows, isSelectAllVisible, optionRows);

    this.isListVisible(isListVisible);
    if (!isListVisible) this.optionsScrollPos(0);
    this.selectableValues = selectableValues;
    this.isFilterVisible(isFilterVisible);
    this.filterPlaceholder(filterPlaceholder);
    this.isSelectAllVisible(isSelectAllVisible);
    this.selectAllLabel(selectAllLabel);
    this.multiselect(multiselect);
    this.disabled(disabled);
    this.selectAllValue(selectAllValue);
    this.loading(loading);
    this.tabIndex(tabIndex);
    this.summary(_summarizeSelected(subject, selectedValues, placeholder, options));
    this.usingPlacholderText(usingPlacholderText);
    this.emptyMessage(emptyMessageInfo);
    this.actionRows(actionRows);
    this.optionRows(optionRows);
    this.summaryHasFocus(focus === 'SUMMARY');
    this.filterHasFocus(focus === 'FILTER');
    this.selectAllHasFocus(focus === 'SELECT_ALL');
    this.firstItemFocusId = firstItemFocusId;
  }

  onSummaryFocus(val) {
    this.focus(val ? 'SUMMARY' : '');
  }

  onSummaryClick() {
    this._toggleList();
  }

  onListTransitionEnd(_, {
    target: list
  }) {
    // Currently works only on latest chrome.
    list.scrollIntoViewIfNeeded();
  }

  onSummaryKeyDown(_, evt) {
    const code = evt.code.toLowerCase();

    switch (code) {
      case 'space':
      case 'enter':
        {
          this._toggleList();

          return false;
        }

      case 'arrowup':
        {
          this._toggleList(true);

          return false;
        }

      case 'escape':
        {
          if (this.active()) {
            evt.stopPropagation();

            this._toggleList(true);

            return false;
          }

          return true;
        }

      case 'arrowdown':
        {
          if (!this.active()) {
            this.active(true);
          } else {
            this.focus(this.firstItemFocusId);
          }

          return false;
        }
    }
  }

  onListKeydown(_, evt) {
    const code = evt.code.toLowerCase();

    switch (code) {
      case 'escape':
        {
          evt.stopPropagation();

          this._toggleList(true);

          return false;
        }

      case 'arrowup':
        {
          if (this.focus() === this.firstItemFocusId) {
            this.focus('SUMMARY');
            return false;
          }
        }
    }

    return true;
  }

  onSelectAllFocus(val) {
    this.focus(val ? 'SELECT_ALL' : '');
  }

  onSelectAllClick() {
    const selected = _toArray(this.selected());

    const values = selected.length === 0 ? this.selectableValues : [];
    this.selected(values);
  }

  onFilterKeyDown(_, evt) {
    // Prevent enter on filter form submitting outer forms.
    return evt.code.toLowerCase() !== 'enter';
  }

  onFilterFocus(val) {
    this.focus(val ? 'FILTER' : '');
  }

  onActionClick(actionRow) {
    actionRow.onClick();

    this._toggleList(true);
  }

  onOptionClick(optionRow) {
    if (optionRow.disabled()) {
      return;
    }

    if (this.multiselect()) {
      const value = optionRow.value();

      const before = _toArray(this.selected());

      const after = before.filter(other => other !== value);
      if (before.length === after.length) after.push(value);
      this.selected(after);
    } else {
      this.selected(optionRow.value());

      this._toggleList(true);
    }

    return true;
  }

  _toggleList(close = this.active()) {
    if (close) {
      this.focus('SUMMARY');
      this.active(false);
      this.filter('');
    } else {
      this.active(true);
    }
  }

  dispose() {
    this.sub.dispose();
  }

}

var _default = {
  viewModel: DropdownViewModel,
  template: _dropdown.default
};
exports.default = _default;

},{"./action-row":741,"./dropdown.html":742,"./option-row":744,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"config":831,"knockout":"knockout","utils/core-utils":1027,"utils/string-utils":1046}],744:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _stringUtils = require("utils/string-utils");

/* Copyright (C) 2016 NooBaa */
function _getOptionTooltip(tooltip) {
  if (!tooltip) {
    return '';
  }

  if ((0, _coreUtils.isString)(tooltip)) {
    return {
      text: tooltip,
      position: 'after'
    };
  }

  if (!tooltip.position) {
    return { ...tooltip,
      position: 'after'
    };
  }

  return tooltip;
}

class OptionRowViewModel {
  constructor({
    onFocus
  }) {
    (0, _defineProperty2.default)(this, "focusId", (0, _stringUtils.randomString)());
    (0, _defineProperty2.default)(this, "focusHandler", null);
    (0, _defineProperty2.default)(this, "value", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "label", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "remark", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "icon", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "tooltip", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "css", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "disabled", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "selected", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "tabIndex", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "hasFocus", _knockout.default.observable());
    this.focusHandler = onFocus;
  }

  onUpdate(option, multiselect, selectedValues, focus) {
    const {
      value,
      label,
      remark,
      icon,
      selectedIcon,
      css,
      disabled
    } = option;
    const isSelected = selectedValues.includes(value);
    this.value(value);
    this.label(label.toString());
    this.remark(remark);
    this.icon(isSelected ? selectedIcon : icon);
    this.tooltip(_getOptionTooltip(option.tooltip));
    this.css(css);
    this.disabled(disabled);
    this.selected(isSelected);
    this.tabIndex(disabled ? false : '0');
    this.hasFocus(focus === this.focusId);
  }

  onFocus(val) {
    this.focusHandler(val ? this.focusId : '');
  }

  onMouseDown() {
    // Prevent disabled options form foucsing out
    // the active element.
    return !this.disabled();
  }

}

exports.default = OptionRowViewModel;

},{"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","utils/core-utils":1027,"utils/string-utils":1046}],745:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<!-- ko if: visible -->\n<span class=\"editor-label push-next row align-start content-middle\"\n    ko.css.disabled=\"disabled\"\n>\n    {{ko.unwrap(label)}}:\n    <!-- ko if: tooltip -->\n    <more-info-icon\n        class=\"push-prev-half\"\n        params=\"tooltip: tooltip\"\n    ></more-info-icon>\n    <!-- /ko -->\n</span>\n<div class=\"editor-content column\"\n    ko.template=\"{ nodes: $componentTemplateNodes, data: $parent }\"\n    ko.validationOptions.insertMessages=\"insertValMessages\"\n></div>\n<!-- /ko -->\n";

},{}],746:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _editor = _interopRequireDefault(require("./editor.html"));

/* Copyright (C) 2016 NooBaa */
class EditorViewModel {
  constructor({
    label = '',
    visible = true,
    disabled = false,
    tooltip = '',
    insertValMessages = true
  }) {
    this.label = label;
    this.visible = visible;
    this.disabled = disabled;
    this.tooltip = tooltip;
    this.insertValMessages = insertValMessages;
  }

}

var _default = {
  viewModel: EditorViewModel,
  template: _editor.default
};
exports.default = _default;

},{"./editor.html":745,"@babel/runtime/helpers/interopRequireDefault":1050}],747:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<drop-area params=\"onDrop: onDrop, disabled: disabled\">\n    <p class=\"drop-message\">{{message}} or</p>\n    <label class=\"btn alt-colors\" ko.css.disabled=\"disabled\">\n        Browse\n        <input type=\"file\" class=\"hide\"\n            ko.attr.multiple=\"allowMultiSelect\"\n            ko.attr.accept=\"filter\",\n            ko.event.change=\"onChange\"\n            ko.event.click=\"onClick\"\n            ko.disable=\"disabled\"\n        />\n    </label>\n</drop-area>\n\n";

},{}],748:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _fileSelector = _interopRequireDefault(require("./file-selector.html"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

/* Copyright (C) 2016 NooBaa */
class FileSelectorViewModel {
  constructor({
    onFilesReady = _coreUtils.noop,
    allowMultiSelect = false,
    filter = '',
    message = `Drag your file${allowMultiSelect ? 's' : ''} here`,
    disabled = false
  }) {
    this.onFilesReady = onFilesReady;
    this.allowMultiSelect = allowMultiSelect;
    this.filter = filter;
    this.message = message;
    this.disabled = disabled;
  }

  onDrop(_, evt) {
    const {
      files
    } = evt.dataTransfer;
    const payload = _knockout.default.unwrap(this.allowMultiSelect) ? files : files[0];
    this.onFilesReady(payload);
  }

  onChange(_, evt) {
    const {
      files
    } = evt.target;
    const payload = _knockout.default.unwrap(this.allowMultiSelect) ? files : files[0];
    this.onFilesReady(payload);
  }

  onClick(_, evt) {
    // Fixes the problem of traiying to select a file with the same name
    // twice in a row.
    evt.target.value = '';
    return true;
  }

}

var _default = {
  viewModel: FileSelectorViewModel,
  template: _fileSelector.default
};
exports.default = _default;

},{"./file-selector.html":747,"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","utils/core-utils":1027}],749:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div ko.visible=\"label\" class=\"gc-label\">\n    {{label}}\n</div>\n<svg class=\"gc-svg\">\n    <g>\n        <path class=\"gc-outline\"/>\n        <path class=\"gc-filler\" ko.style.d=\"path\"/>\n    </g>\n    <text class=\"gc-value\">\n        {{formattedValue}}\n    </text>\n</svg>\n";

},{}],750:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _gaugeChart = _interopRequireDefault(require("./gauge-chart.html"));

var _knockout = _interopRequireDefault(require("knockout"));

var _chartUtils = require("utils/chart-utils");

var _shifty = require("shifty");

/* Copyright (C) 2016 NooBaa */
const {
  PI,
  cos,
  sin
} = Math;

class GaugeChartViewModel {
  constructor(params) {
    (0, _defineProperty2.default)(this, "sub", null);
    (0, _defineProperty2.default)(this, "label", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "value", 0);
    (0, _defineProperty2.default)(this, "formattedValue", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "path", _knockout.default.observable());
    this.sub = _knockout.default.computed(() => this.onParams(_knockout.default.deepUnwrap(params)));
  }

  onParams(params) {
    const {
      scale = 1,
      value = 0,
      format,
      label
    } = params;
    const formatter = (0, _chartUtils.getFormatter)(format);
    const lastValue = this.value;

    _knockout.default.assignToProps(this, {
      label,
      value
    });

    (0, _shifty.tween)({
      from: {
        value: lastValue
      },
      to: {
        value: value
      },
      duration: 1000,
      easing: 'easeOutQuad',
      attachment: {
        scale,
        formatter
      },
      step: this.onTweenStep.bind(this)
    });
  }

  onTweenStep(step, attachment) {
    const {
      value
    } = step;
    const {
      scale,
      formatter
    } = attachment;
    const ratio = Math.min(scale > 0 ? value / scale : 0, 1);
    const angle = (1 + ratio) * PI;

    _knockout.default.assignToProps(this, {
      formattedValue: formatter(value),
      path: `path("M-1 0 A1 1 0 0 1 ${cos(angle)} ${sin(angle)}")`
    });
  }

  dispose() {
    this.sub && this.sub.dispose();
  }

}

var _default = {
  viewModel: GaugeChartViewModel,
  template: _gaugeChart.default
};
exports.default = _default;

},{"./gauge-chart.html":749,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","shifty":"shifty","utils/chart-utils":1023}],751:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<h3 class=\"heading3 pad card-shadow\">\n    Object parts stored on this {{subject}}: {{partCountFormatted}}\n</h3>\n\n<data-table class=\"parts-table greedy\" params=\"\n    columns: columns,\n    data: rows,\n    loading: !dataReady(),\n    emptyMessage: emptyMessage\n\"></data-table>\n\n<paginator params=\"\n    itemCount: partCount,\n    pageSize: ko.pc(pageSize, onPageSize, $component),\n    page: ko.pc(page, onPage, $component)\n\"></paginator>\n";

},{}],752:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _hostPartsTable = _interopRequireDefault(require("./host-parts-table.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _actionCreators = require("action-creators");

var _knockout = _interopRequireDefault(require("knockout"));

var _config = require("config");

var _coreUtils = require("utils/core-utils");

var _browserUtils = require("utils/browser-utils");

var _numeral = _interopRequireDefault(require("numeral"));

var routes = _interopRequireWildcard(require("routes"));

/* Copyright (C) 2016 NooBaa */
const columns = (0, _coreUtils.deepFreeze)([{
  name: 'state',
  type: 'icon'
}, {
  name: 'object',
  type: 'link'
}, {
  name: 'bucket',
  type: 'link'
}, {
  name: 'version'
}, {
  name: 'start'
}, {
  name: 'end'
}, {
  name: 'size'
}]);
const modeToIcon = (0, _coreUtils.deepFreeze)({
  AVAILABLE: {
    name: 'healthy',
    css: 'success',
    tooltip: 'Available'
  },
  BUILDING: {
    name: 'working',
    css: 'warning',
    tooltip: 'In process'
  },
  UNAVAILABLE: {
    name: 'problem',
    css: 'error',
    tooltip: 'Unavailable'
  }
});

class PartRowViewModel {
  constructor() {
    (0, _defineProperty2.default)(this, "state", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "object", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "bucket", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "version", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "start", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "end", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "size", _knockout.default.observable());
  }

}

class HostPartsTableViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "columns", columns);
    (0, _defineProperty2.default)(this, "pathname", '');
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "subject", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "emptyMessage", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "partCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "partCountFormatted", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "page", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "pageSize", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "rows", _knockout.default.observableArray().ofType(PartRowViewModel));
  }

  selectState(state, params) {
    const hostParts = state.hostParts.host === params.hostName ? state.hostParts : null;
    return [params.resourceType, hostParts, state.location];
  }

  mapStateToProps(resourceType, hostParts, location) {
    const subject = resourceType === 'HOST' && 'node' || resourceType === 'CLOUD_RESOURCE' && 'cloud resource';

    if (!hostParts || !hostParts.parts) {
      _knockout.default.assignToProps(this, {
        dataReady: false,
        subject: subject,
        rows: []
      });
    } else {
      const {
        partCount,
        parts
      } = hostParts;
      const {
        system
      } = location.params;
      const page = Number(location.query.page) || 0;

      const pageSize = Number(location.query.pageSize) || _config.paginationPageSize.default;

      _knockout.default.assignToProps(this, {
        dataReady: true,
        subject,
        emptyMessage: `No object parts are stored on this ${subject}`,
        pathname: location.pathname,
        page,
        pageSize,
        partCount,
        partCountFormatted: (0, _numeral.default)(partCount).format(','),
        rows: parts.map(part => {
          const {
            mode,
            objectInfo,
            start,
            end
          } = part;
          const {
            bucket,
            key,
            version,
            isUploading,
            isDeleteMarker
          } = objectInfo;
          const href = !isUploading && !isDeleteMarker ? (0, _browserUtils.realizeUri)(routes.object, {
            system,
            bucket,
            object: key,
            version
          }) : undefined;
          return {
            state: modeToIcon[mode],
            object: {
              text: key,
              href: href,
              tooltip: key
            },
            version: version,
            bucket: {
              text: bucket,
              href: (0, _browserUtils.realizeUri)(routes.bucket, {
                system,
                bucket
              }),
              tooltip: bucket
            },
            start: (0, _numeral.default)(start).format('0.0 b'),
            end: (0, _numeral.default)(end).format('0.0 b'),
            size: (0, _numeral.default)(end - start).format('0.0 b')
          };
        })
      });
    }
  }

  onPage(page) {
    this._query({
      page
    });
  }

  onPageSize(pageSize) {
    this._query({
      pageSize,
      page: 0
    });
  }

  _query(query) {
    const {
      pageSize = this.pageSize(),
      page = this.page()
    } = query;
    const url = (0, _browserUtils.realizeUri)(this.pathname, null, {
      page,
      pageSize
    });
    this.dispatch((0, _actionCreators.requestLocation)(url));
  }

}

var _default = {
  viewModel: HostPartsTableViewModel,
  template: _hostPartsTable.default
};
exports.default = _default;

},{"./host-parts-table.html":751,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"components/connectable":446,"config":831,"knockout":"knockout","numeral":"numeral","routes":972,"utils/browser-utils":1021,"utils/core-utils":1027}],753:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<loading-indicator class=\"align-middle ld-loading-indicator\"\n    ko.visible=\"loading\"\n></loading-indicator>\n\n<section class=\"row ld-wrapper\"\n    ko.css.ld-expanded=\"selected\"\n    ko.visible=\"!ko.unwrap(loading)\"\n>\n    <ul class=\"list-no-style column greedy ld-list \"\n        ko.visible=\"rows().length\"\n        ko.foreach=\"rows\"\n    >\n        <li class=\"row content-middle border-bottom ld-row\"\n            ko.css.ld-row-selected=\"$component.isSelected($data)\"\n            ko.click=\"item => $component.onToggleItem(item)\"\n        >\n            <div class=\"no-wrap greedy\" ko.template=\"{\n                html: $component.rowTemplate,\n                data: $parents[1],\n                let: { $item: $data }\n            }\"></div>\n            <button class=\"link alt-colors ld-details-btn push-prev\"\n                ko.visible=\"$component.buttonLabel\"\n            >\n                {{$component.buttonLabel}}\n            </button>\n        </li>\n    </ul>\n\n    <!-- ko if: rows().length === 0 -->\n    <p class=\"empty-message greedy\">{{emptyMessage}}</p>\n    <!-- /ko -->\n\n    <div class=\"column ld-details-pane\" ko.template=\"{\n        html: $component.detailsTemplate,\n        data: $parent,\n        let: { $itemId: selected }\n    }\"></div>\n</section>\n";

},{}],754:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _listDetails = _interopRequireDefault(require("./list-details.html"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

/* Copyright (C) 2016 NooBaa */
const defaultRowTemplate = '{{$item}}';
const defaultDetailsTemplate = `
    <h2 class="pad heading3">
        {{$item}}
    </h2>
`;

class ListDetailsViewModel {
  constructor(params, templates) {
    const {
      row: rowTemplate = defaultRowTemplate,
      details: detailsTemplate = defaultDetailsTemplate
    } = templates;
    const {
      loading = false,
      rows = [],
      buttonLabel = 'Show Details',
      emptyMessage = 'List is empty',
      idSelector = _coreUtils.echo,
      selected = ''
    } = params;
    this.loading = loading;
    this.rowTemplate = rowTemplate;
    this.detailsTemplate = detailsTemplate;
    this.rows = rows;
    this.buttonLabel = buttonLabel;
    this.emptyMessage = emptyMessage;
    this.idSelector = idSelector;
    this.selected = !_knockout.default.isWritableObservable(selected) ? _knockout.default.observable(_knockout.default.unwrap(selected)) : selected;
  }

  onToggleItem(item) {
    const id = String(this.idSelector(item));
    this.selected(id === this.selected() ? '' : id);
  }

  isSelected(item) {
    return String(this.idSelector(item)) === this.selected();
  }

}

function viewModelFactory(params, info) {
  const templateElms = info.templateNodes.filter(node => node.nodeType === Node.ELEMENT_NODE && node.tagName.toUpperCase() === 'TEMPLATE');
  const templates = (0, _coreUtils.groupBy)(templateElms, elm => elm.getAttribute('name'), elm => elm.innerHTML);
  return new ListDetailsViewModel(params, templates);
}

var _default = {
  viewModel: {
    createViewModel: viewModelFactory
  },
  template: _listDetails.default
};
exports.default = _default;

},{"./list-details.html":753,"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","utils/core-utils":1027}],755:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div>\n    <span class=\"circle\"></span>\n    <span class=\"circle\"></span>\n    <span class=\"circle\"></span>\n</div>\n<p class=\"label remark\" ko.visible=\"$data.label\">Loading</p>\n";

},{}],756:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _loadingIndicator = _interopRequireDefault(require("./loading-indicator.html"));

/* Copyright (C) 2016 NooBaa */
var _default = {
  template: _loadingIndicator.default
};
exports.default = _default;

},{"./loading-indicator.html":755,"@babel/runtime/helpers/interopRequireDefault":1050}],757:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<loading-indicator class=\"align-start pad\"\n    ko.visible=\"!isInitialized()\"\n></loading-indicator>\n<!-- ko if: isInitialized -->\n<form novalidate\n    class=\"column greedy\"\n    ko.submit=\"submit\"\n    ko.template=\"{\n        nodes: $componentTemplateNodes,\n        data: $parent,\n        let: { $form: $data }\n    }\"\n></form>\n<!-- /ko -->\n";

},{}],758:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _managedForm = _interopRequireDefault(require("./managed-form.html"));

var _coreUtils = require("utils/core-utils");

var _formUtils = require("utils/form-utils");

var _rxExtensions = require("rx-extensions");

var _knockout = _interopRequireDefault(require("knockout"));

var _state2 = require("state");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
class ManagedFormViewModel {
  constructor({
    name,
    fields = {},
    onWarn,
    onValidate,
    onValidateAsync,
    onValidateSubmit,
    asyncTriggers,
    onSubmit = _coreUtils.noop
  }, owner) {
    if (!name) {
      throw new Error('Cannot create a form without a name');
    }

    this._name = name;
    this._submitHandler = onSubmit && onSubmit.bind(owner);
    this._warnHandler = onWarn && onWarn.bind(owner);
    this._validateHandler = onValidate && onValidate.bind(owner);
    this._validateAsyncHandler = onValidateAsync && onValidateAsync.bind(owner);
    this._validateSubmitHandler = onValidateSubmit && onValidateSubmit.bind(owner);
    this._asyncTriggers = asyncTriggers;
    this._asyncValidationHandle = null; // Create an observable to hold the loaded form state.

    const state = this._state = _knockout.default.observable();

    this.isInitialized = _knockout.default.pureComputed(() => Boolean(state()));
    this.isValidating = _knockout.default.pureComputed(() => Boolean(state() && state().validatingAsync));
    this.isValid = _knockout.default.pureComputed(() => Boolean(state()) && (0, _formUtils.isFormValid)(state()));
    this.isDirty = _knockout.default.pureComputed(() => Boolean(state()) && (0, _formUtils.isFormDirty)(state()));
    this.isSubmitting = _knockout.default.pureComputed(() => Boolean(state()) && state().submitting);
    this.isSubmittingOrSubmitted = _knockout.default.pureComputed(() => Boolean(state()) && (state().submitting || state().submitted));
    this.isSubmitted = _knockout.default.pureComputed(() => Boolean(state()) && state().submitted);
    this.warnings = _knockout.default.pureComputed(() => state() ? state().warnings : {});
    this.errors = _knockout.default.pureComputed(() => state() ? { ...state().syncErrors,
      ...state().asyncErrors,
      ...state().submitErrors
    } : {}); // Bind form action to the form view model.

    for (const method of ['submit', 'reset']) {
      this[method] = this[method].bind(this);
    }

    if (_knockout.default.isObservable(fields) && !fields()) {
      fields.once(fields => this._initialize(fields));
    } else {
      this._initialize(_knockout.default.unwrap(fields));
    } // listen for state changes.


    this.stateSub = _state2.state$.pipe((0, _rxExtensions.get)('forms', name)).subscribe(this._onState.bind(this));
  }

  get name() {
    return this._name;
  }

  submit() {
    _state2.action$.next((0, _actionCreators.submitForm)(this.name));
  }

  reset() {
    _state2.action$.next((0, _actionCreators.resetForm)(this.name));
  }

  dispose() {
    _state2.action$.next((0, _actionCreators.dropForm)(this.name));

    this.stateSub.unsubscribe();
  }

  _initialize(fields) {
    // Create the fields observables.
    for (const fieldName of Object.keys(fields)) {
      this[fieldName] = this._createFieldObservable(fieldName);
    } // Initialze the form.


    _state2.action$.next((0, _actionCreators.initializeForm)(this.name, fields));
  }

  _createFieldObservable(fieldName) {
    const {
      _state,
      name: formName
    } = this;

    const field = _knockout.default.pureComputed(() => _state() ? _state().fields[fieldName] : {});

    const set = function (value, touch = true) {
      if (_state() && field().value !== value) {
        _state2.action$.next((0, _actionCreators.updateForm)(formName, {
          [fieldName]: value
        }, touch));
      }
    };

    const obs = _knockout.default.pureComputed({
      read: () => field().value,
      write: set
    });

    return Object.assign(obs, {
      set: (value, touch = false) => {
        if (field().value !== value) {
          set(value, touch);
        }
      },
      isDirty: _knockout.default.pureComputed(() => field().value !== field().initial),
      wasTouched: _knockout.default.pureComputed(() => field().touched),
      isValidating: _knockout.default.pureComputed(() => Boolean(_state() && _state().validatingAsync && _state().validatingAsync.includes(fieldName))),
      isValid: _knockout.default.pureComputed(() => field().validity === 'VALID'),
      isInvalid: _knockout.default.pureComputed(() => field().validity === 'INVALID'),
      isInvalidTouched: _knockout.default.pureComputed(() => obs.isInvalid() && obs.wasTouched()),
      warning: _knockout.default.pureComputed(() => _state() && _state().warnings[fieldName] || ''),
      error: _knockout.default.pureComputed(() => {
        if (!_state()) return '';
        return _state().syncErrors[fieldName] || _state().asyncErrors[fieldName] || _state().submitErrors[fieldName] || '';
      })
    });
  }

  _onState(state) {
    if (!state) return;
    const prevValues = this._state() && (0, _formUtils.getFormValues)(this._state());
    const values = (0, _formUtils.getFormValues)(state);
    const changes = prevValues ? Object.keys(prevValues).filter(name => prevValues[name] !== values[name]) : Object.keys(values);

    this._state(state);

    if (changes.length > 0) {
      this._validate(values, changes);
    } else if (state.submitting) {
      this._handleSubmitting(values);
    } else if (state.submitted) {
      this._submitHandler(values);
    }
  }

  _validate(values, changed) {
    const {
      _warnHandler,
      _validateHandler,
      _validateAsyncHandler,
      _asyncTriggers
    } = this;

    const warnings = _warnHandler && _warnHandler(values);

    const syncErrors = _validateHandler && _validateHandler(values);

    const shouldValidateAsync = _validateAsyncHandler && _asyncTriggers && _asyncTriggers.some(field => changed.includes(field));

    const canValidateAsync = shouldValidateAsync && Object.keys(syncErrors || {}).every(field => !_asyncTriggers.includes(field));
    const fieldsValidity = (0, _coreUtils.mapValues)(values, (_, field) => {
      if (syncErrors && (0, _coreUtils.hasOwn)(syncErrors, field)) {
        return 'INVALID';
      }

      if ((_asyncTriggers || []).includes(field)) {
        return shouldValidateAsync ? 'UNKNOWN' : undefined;
      }

      return 'VALID';
    }); // Dispatching while running inside a handler of subscribe
    // need to be asynchronous. (to prevent a recursive behavior)

    _state2.action$.next((0, _actionCreators.setFormValidity)(this.name, {
      values,
      fieldsValidity,
      warnings,
      syncErrors,
      asyncErrors: shouldValidateAsync ? {} : undefined,
      validatingAsync: canValidateAsync ? _asyncTriggers : undefined,
      confirmValidity: true
    }));

    if (canValidateAsync) {
      const asyncValidatedValues = (0, _coreUtils.pick)(values, _asyncTriggers);

      this._validateAsync(asyncValidatedValues);
    } else if (shouldValidateAsync) {
      this._asyncValidationHandle = null;
    }
  }

  async _validateAsync(values, retries = 2) {
    const {
      _validateAsyncHandler
    } = this;
    const handle = this._asyncValidationHandle = {}; // Try running the async validation 3 time before forfit.

    for (let i = 1 + retries; i > 0; --i) {
      try {
        // Gard the store update against stale validation state.
        const asyncErrors = await _validateAsyncHandler(values);
        if (this._asyncValidationHandle !== handle) return;
        const hasAsyncErrors = Object.keys(asyncErrors).length > 0;
        const fieldsValidity = hasAsyncErrors ? (0, _coreUtils.mapValues)(values, (_, name) => (0, _coreUtils.hasOwn)(asyncErrors, name) ? 'INVALID' : 'UNKNOWN') : (0, _coreUtils.mapValues)(values, () => 'VALID');

        _state2.action$.next((0, _actionCreators.setFormValidity)(this.name, {
          values,
          fieldsValidity,
          asyncErrors,
          validatingAsync: null,
          touch: hasAsyncErrors
        }));

        break;
      } catch (error) {
        if (this._asyncValidationHandle !== handle) break;
        if (i === 0) throw error;
      }
    }
  }

  async _handleSubmitting(values) {
    if ((0, _coreUtils.isFunction)(this._validateSubmitHandler)) {
      const errors = await this._validateSubmitHandler(values);

      _state2.action$.next((0, _actionCreators.completeSubmitForm)(this.name, errors));
    } else {
      _state2.action$.next((0, _actionCreators.completeSubmitForm)(this.name));
    }
  }

}

function viewModelFactory(params, info) {
  const owner = _knockout.default.dataFor(info.element);

  return new ManagedFormViewModel(params, owner);
}

var _default = {
  viewModel: {
    createViewModel: viewModelFactory
  },
  template: _managedForm.default
};
exports.default = _default;

},{"./managed-form.html":757,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"knockout":"knockout","rx-extensions":974,"state":1016,"utils/core-utils":1027,"utils/form-utils":1030}],759:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n    <svg-icon class=\"icon-small scale-on-hover\"\n        ko.tooltip=\"tooltip\"\n        ko.css=\"css\"\n        params=\"name: icon\"\n    ></svg-icon>\n";

},{}],760:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _moreInfoIcon = _interopRequireDefault(require("./more-info-icon.html"));

var _coreUtils = require("utils/core-utils");

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
const severityMapping = (0, _coreUtils.deepFreeze)({
  normal: {
    css: 'normal',
    icon: 'question'
  },
  warning: {
    css: 'warning',
    icon: 'problem'
  },
  error: {
    css: 'error',
    icon: 'problem'
  },
  success: {
    css: 'sucess',
    icon: 'healthy'
  }
});

class MoreInfoIconViewModel {
  constructor({
    tooltip = '',
    disabled = false,
    severity = 'normal'
  }) {
    const meta = _knockout.default.pureComputed(() => severityMapping[severity] || severityMapping.info);

    this.tooltip = _knockout.default.pureComputed(() => _knockout.default.unwrap(disabled) ? '' : _knockout.default.unwrap(tooltip));
    this.icon = _knockout.default.pureComputed(() => meta().icon);
    this.css = _knockout.default.pureComputed(() => `${meta().css} ${_knockout.default.unwrap(disabled) ? 'disabled' : ''}`);
  }

}

var _default = {
  viewModel: MoreInfoIconViewModel,
  template: _moreInfoIcon.default
};
exports.default = _default;

},{"./more-info-icon.html":759,"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","utils/core-utils":1027}],761:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"multiselect-options greedy\" ko.validationOptions=\"{ insertMessages: false }\">\n    <ul class=\"list-no-style row multiline greedy\" ko.foreach=\"options\">\n        <li class=\"option\">\n            <checkbox params=\"\n                value: value,\n                label: label,\n                checked: $component.selected,\n                disabled: disabled || ko.unwrap($component.disabled),\n                tooltip: tooltip\n            \"></checkbox>\n        </li>\n    </ul>\n</div>\n\n<!-- ko if: insertValidationMessage -->\n<div class=\"val-msg\" ko.validationMessage=\"selected\"></div>\n<!-- /ko -->\n";

},{}],762:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _multiselect = _interopRequireDefault(require("./multiselect.html"));

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
function _normalizeOption(option) {
  const naked = _knockout.default.deepUnwrap(option);

  const {
    value = naked,
    label = value.toString(),
    tooltip = label,
    disabled = false
  } = naked;
  return {
    value,
    label,
    disabled,
    tooltip
  };
}

class MultiSelectViewModel {
  constructor({
    options = [],
    selected,
    disabled = false,
    insertValidationMessage = false
  }) {
    this.options = _knockout.default.pureComputed(() => (_knockout.default.unwrap(options) || []).map(_normalizeOption));
    this.selected = _knockout.default.isWritableObservable(selected) ? _knockout.default.pureComputed({
      read: () => Array.from(_knockout.default.unwrap(selected) || []),
      write: selected
    }) : _knockout.default.observableArray(Array.from(_knockout.default.unwnrap(selected) || []));
    this.disabled = disabled;
    this.insertValidationMessage = insertValidationMessage;
  }

}

var _default = {
  viewModel: MultiSelectViewModel,
  template: _multiselect.default
};
exports.default = _default;

},{"./multiselect.html":761,"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout"}],763:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"paginator-wrapper\">\n    <span class=\"item-counter\">\n        <span class=\"text-bold\" ko.text=\"itemRange\"></span>\n        of\n        <span class=\"text-bold\" ko.text=\"itemCount\"></span>\n        items\n    </span>\n\n    <div class=\"page-size-selector\"\n        tabindex=\"-1\"\n    >\n        <ul class=\"card-bg card-shadow list-no-style page-size-options\"\n            ko.foreach=\"sizeOptions\"\n        >\n            <li>\n                <button class=\"page-size-option\"\n                    ko.css.selected=\"$component.pageSize.eq($data)\"\n                    ko.click=\"$component.onSelectPageSize.bind($component)\"\n                >\n                    {{$data}}\n                </button>\n            </li>\n        </ul>\n    </div>\n\n    <button class=\"btn-flat\"\n        ko.click=\"onJumpToFirstPage\"\n        ko.disable=\"isFirstPage\"\n    >\n        <svg-icon class=\"icon-small\" params=\"name: 'dbl-angle-left'\"></svg-icon>\n    </button>\n\n    <button class=\"btn-flat\"\n        ko.click=\"onPageBackward\"\n        ko.disable=\"isFirstPage\"\n    >\n        <svg-icon class=\"icon-small\" params=\"name: 'angle-left'\"></svg-icon>\n    </button>\n\n    <span class=\"page-counter\" ko.text=\"pageText\"></span>\n\n    <button class=\"btn-flat\"\n        ko.click=\"onPageForward\"\n        ko.disable=\"isLastPage\"\n    >\n        <svg-icon class=\"icon-small rotate deg180\" params=\"name: 'angle-left'\"></svg-icon>\n    </button>\n\n    <button class=\"btn-flat\"\n        ko.click=\"onJumpToLastPage\"\n        ko.disable=\"isLastPage\"\n    >\n        <svg-icon class=\"icon-small rotate deg180\" params=\"name: 'dbl-angle-left'\"></svg-icon>\n    </button>\n</div>\n";

},{}],764:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _paginator = _interopRequireDefault(require("./paginator.html"));

var _knockout = _interopRequireDefault(require("knockout"));

var _numeral = _interopRequireDefault(require("numeral"));

var _config = require("config");

/* Copyright (C) 2016 NooBaa */
class PaginatorViewModel {
  constructor({
    itemCount,
    pageSize,
    page
  }) {
    this.sizeOptions = _config.paginationPageSize.options;
    this.pageSize = pageSize;
    this.page = page;
    this.count = _knockout.default.pureComputed(() => _knockout.default.unwrap(itemCount));
    this.noResults = _knockout.default.pureComputed(() => this.count() === 0);
    this.pageText = _knockout.default.pureComputed(() => {
      const page = this.page() + 1;
      const pageCount = Math.ceil(this.count() / this.pageSize());
      return `${(0, _numeral.default)(page).format(',')} of ${(0, _numeral.default)(pageCount).format(',')}`;
    });
    this.itemRange = _knockout.default.pureComputed(() => {
      const count = this.count() || 0;
      const start = count !== 0 ? (this.page() || 0) * this.pageSize() + 1 : 0;
      const end = Math.min(start + this.pageSize() - 1, count);
      return `${(0, _numeral.default)(start).format(',')} - ${(0, _numeral.default)(end).format(',')}`;
    });
    this.itemCount = _knockout.default.pureComputed(() => (0, _numeral.default)(this.count() || 0).format(','));
    this.lastPageIndex = _knockout.default.pureComputed(() => this.count() > 0 ? Math.floor((this.count() - 1) / this.pageSize()) : 0);
    this.isFirstPage = _knockout.default.pureComputed(() => this.page() === 0);
    this.isLastPage = _knockout.default.pureComputed(() => this.page() === this.lastPageIndex());
  }

  onSelectPageSize(pageSize, evt) {
    this.pageSize(pageSize);
    evt.target.blur();
  }

  onJumpToFirstPage() {
    this.page(0);
  }

  onPageForward() {
    if (!this.isLastPage()) {
      this.page(this.page() + 1);
    }
  }

  onPageBackward() {
    if (!this.isFirstPage()) {
      this.page(this.page() - 1);
    }
  }

  onJumpToLastPage() {
    this.page(this.lastPageIndex());
  }

}

var _default = {
  viewModel: PaginatorViewModel,
  template: _paginator.default
};
exports.default = _default;

},{"./paginator.html":763,"@babel/runtime/helpers/interopRequireDefault":1050,"config":831,"knockout":"knockout","numeral":"numeral"}],765:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"input\"\n    ko.css.focus=\"hasFocus\"\n    ko.css.disabled=\"disabled\"\n>\n    <div class=\"row content-middle\" ko.validationOptions=\"{ insertMessages: false }\">\n        <input class=\"password-input greedy\" type=\"password\" autocomplete=\"off\"\n            ko.textInput=\"value\"\n            ko.disable=\"disabled\"\n            ko.attr.type=\"type\"\n            ko.attr.placeholder=\"placeholder\",\n            ko.hasFocus=\"hasFocus\"\n        />\n        <button class=\"icon-btn btn-flat no-focus-ring push-prev\" type=\"button\" tabindex=\"-1\"\n            ko.click=\"toogleType\"\n            ko.tooltip=\"tooltip\"\n            ko.visible=\"value\"\n        >\n            <svg-icon params=\"name: icon\"></svg-icon>\n        </button>\n    </div>\n\n    <!-- ko if: strength -->\n    <div class=\"strength-indicator\" ko.style.width=\"strength().length\">\n        <div class=\"rect\" ko.style.opacity=\"strength().o1\"></div>\n        <div class=\"rect\" ko.style.opacity=\"strength().o2\"></div>\n    </div>\n    <!-- /ko -->\n</div>\n";

},{}],766:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _passwordField = _interopRequireDefault(require("./password-field.html"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

/* Copyright (C) 2016 NooBaa */
const iconMapping = (0, _coreUtils.deepFreeze)({
  password: {
    icon: 'eye',
    tooltip: 'Show password'
  },
  text: {
    icon: 'no-eye',
    tooltip: 'Hide password'
  }
});

class PasswordFieldViewModel {
  constructor(params) {
    const {
      value,
      disabled,
      placeholder = '',
      hasFocus = _knockout.default.observable(false),
      strengthCalc
    } = params;
    this.value = value;
    this.disabled = disabled;
    this.type = _knockout.default.observable('password');
    this.placeholder = placeholder;
    this.hasFocus = hasFocus;
    this.icon = _knockout.default.pureComputed(() => iconMapping[this.type()].icon);
    this.tooltip = _knockout.default.pureComputed(() => iconMapping[this.type()].tooltip);
    this.strength = _knockout.default.pureComputed(() => {
      if (!(0, _coreUtils.isFunction)(strengthCalc)) {
        return null;
      }

      const value = strengthCalc(_knockout.default.unwrap(this.value) || '');
      return {
        length: `${value * 100}%`,
        o1: Math.min(2 * value, 1),
        o2: Math.min(2 * (1 - value), 1)
      };
    });
  }

  toogleType() {
    this.type(this.type() === 'password' ? 'text' : 'password');
  }

}

var _default = {
  viewModel: PasswordFieldViewModel,
  template: _passwordField.default
};
exports.default = _default;

},{"./password-field.html":765,"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","utils/core-utils":1027}],767:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n <svg viewBox=\"0 0 168 168\">\n    <g class=\"content-wrapper\">\n        <circle class=\"outline\"/>\n        <g class=\"segments\" ko.foreach=\"segments\">\n            <g>\n                <path class=\"outer-seg\"\n                    ko.attr.d=\"d\"\n                    ko.attr.stroke=\"stroke\"\n                />\n                <path class=\"inner-seg\"\n                    ko.attr.d=\"d\"\n                    ko.attr.stroke=\"stroke\"\n                />\n                <text class=\"pri-text\">{{formattedValue}}</text>\n                <text class=\"sec-text\">{{label}}</text>\n            </g>\n        </g>\n        <text class=\"pri-text\">{{sumValue}}</text>\n        <text class=\"sec-text\">{{sumLabel}}</text>\n    </g>\n</svg>\n";

},{}],768:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _pieChart = _interopRequireDefault(require("./pie-chart.html"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _chartUtils = require("utils/chart-utils");

/* Copyright (C) 2016 NooBaa */
const {
  PI,
  max,
  cos,
  sin
} = Math;
const separator = 2 * PI / 1000;
const threshold = 2 * separator;
const changeResilience = 3;

function _normalizeValues(values) {
  const sum = (0, _coreUtils.sumBy)(values);
  const thresholdSize = threshold * sum;
  const {
    delta,
    overhead
  } = values.reduce((aggr, value) => {
    if (value > 0) {
      if (value < thresholdSize) {
        aggr.delta += thresholdSize - value;
      } else {
        aggr.overhead += value - thresholdSize;
      }
    }

    return aggr;
  }, {
    delta: 0,
    overhead: 0
  });
  let reminder = 0;
  return values.map((value, i) => {
    if (value === 0) {
      return 0;
    }

    if (value <= thresholdSize) {
      return threshold;
    }

    const ratio = (value - (value - thresholdSize) * delta / overhead) / sum;

    if (i < values.length - 1) {
      const rounded = (0, _coreUtils.decimalRound)(ratio, changeResilience);
      reminder += ratio - rounded;
      return rounded;
    } else {
      return (0, _coreUtils.decimalRound)(ratio + reminder, changeResilience);
    }
  });
}

class PieChartViewModel {
  constructor({
    values = [],
    sumLabel = '',
    format
  }) {
    const formatValue = (0, _chartUtils.getFormatter)(format);
    this.sumValue = _knockout.default.pureComputed(() => {
      const sum = (0, _coreUtils.sumBy)(values, entry => _knockout.default.unwrap(entry.value));
      return formatValue(sum);
    });
    this.sumLabel = sumLabel;
    this.colors = _knockout.default.pureComputed(() => values.map(entry => entry.color));

    const normalized = _knockout.default.pureComputed(() => _normalizeValues(values.map(entry => _knockout.default.unwrap(entry.value) || 0)));

    this.values = (0, _coreUtils.makeArray)(values.length, i => _knockout.default.pureComputed(() => normalized()[i]).extend({
      tween: {
        resetOnChange: true,
        resetValue: 0
      }
    }));
    this.segments = _knockout.default.pureComputed(() => {
      const hasSeparator = this.values.filter(value => value() > 0).length > 1;
      const colors = this.colors();
      let offset = 0;
      return this.values.map((ratio, i) => {
        const len = hasSeparator ? max(ratio() - separator, 0) : ratio();

        if (len <= 0) {
          return;
        }

        const start = offset * 2 * PI;
        const end = (offset + len) * 2 * PI;
        const d = `M${cos(start)} ${sin(start)} A1 1 0 ${len < .5 ? 0 : 1} 1 ${cos(end)} ${sin(end)}`;
        const stroke = colors[i];

        const value = _knockout.default.unwrap(values[i].value);

        const label = _knockout.default.unwrap(values[i].label);

        const formattedValue = (0, _coreUtils.isDefined)(value) ? formatValue(value) : '';
        offset += ratio();
        return {
          d,
          stroke,
          formattedValue,
          label
        };
      }).filter(Boolean);
    });
  }

}

var _default = {
  viewModel: PieChartViewModel,
  template: _pieChart.default
};
exports.default = _default;

},{"./pie-chart.html":767,"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","utils/chart-utils":1023,"utils/core-utils":1027}],769:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<section class=\"column\">\n    <h2 class=\"heading3\">Policy Type</h2>\n\n    <!-- ko foreach: policyTypeOptions -->\n    <div class=\"row content-middle option-row\">\n        <radio-btn params=\"\n            group: $component.toggleGroupId,\n            value: policyType,\n            selected: $component.selectedPolicy,\n            label: label,\n            hasFocus: ko.unwrap($component.hasFocus) && $index() == 0\n        \"></radio-btn>\n        <span class=\"push-both-half\">|</span>\n        {{description}}\n        <more-info-icon\n            class=\"push-prev-half\"\n            params=\"tooltip: tooltip\"\n        ></more-info-icon>\n    </div>\n    <!-- /ko -->\n</section>\n";

},{}],770:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _placementPolicyToggle = _interopRequireDefault(require("./placement-policy-toggle.html"));

var _coreUtils = require("utils/core-utils");

var _stringUtils = require("utils/string-utils");

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
const policyTypeOptions = (0, _coreUtils.deepFreeze)([{
  policyType: 'SPREAD',
  label: 'Spread',
  description: 'Spreading the data across the chosen resources, does not include failure tolerance in case of resource failure',
  tooltip: {
    template: 'checkList',
    text: {
      list: [{
        text: 'Copies/fragments across the underlying resources for each of the object parts',
        checked: true
      }, {
        text: 'Includes failure tolerance in case of resource failure',
        checked: false
      }]
    }
  }
}, {
  policyType: 'MIRROR',
  label: 'Mirror',
  description: 'Full duplication of the data in each chosen resource, includes failure tolerance in case of resource failure',
  tooltip: {
    template: 'checkList',
    text: {
      list: [{
        text: 'Copies/fragments across the underlying resources for each of the object parts',
        checked: true
      }, {
        text: 'Includes failure tolerance in case of resource failure',
        checked: true
      }]
    }
  }
}]);

class PlacementPolicyToggleViewModel {
  constructor(params) {
    (0, _defineProperty2.default)(this, "policyTypeOptions", policyTypeOptions);
    (0, _defineProperty2.default)(this, "toggleGroupId", (0, _stringUtils.randomString)());
    (0, _defineProperty2.default)(this, "hasFocus", false);
    (0, _defineProperty2.default)(this, "selectedPolicy", null);
    const {
      selectedPolicy,
      hasFocus
    } = params;
    this.hasFocus = hasFocus || false;
    this.selectedPolicy = _knockout.default.isWritableObservable(selectedPolicy) ? selectedPolicy : _knockout.default.observable(_knockout.default.unwrap(selectedPolicy));
  }

}

var _default = {
  viewModel: PlacementPolicyToggleViewModel,
  template: _placementPolicyToggle.default
};
exports.default = _default;

},{"./placement-policy-toggle.html":769,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","utils/core-utils":1027,"utils/string-utils":1046}],771:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<bar params=\"\n    values: values,\n    markers: markers,\n    minRatio: 0\n\"></bar>\n";

},{}],772:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _progressBar = _interopRequireDefault(require("./progress-bar.html"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _numeral = _interopRequireDefault(require("numeral"));

/* Copyright (C) 2016 NooBaa */
class ProgressBarViewModel {
  constructor(params) {
    const {
      progress = 0,
      marker = false
    } = params;

    const ratio = _knockout.default.pureComputed(() => (0, _coreUtils.clamp)(_knockout.default.unwrap(progress) || 0, 0, 1));

    this.values = [{
      color: 'rgb(var(--color20))',
      value: ratio
    }, {
      color: 'rgb(var(--color09))',
      value: _knockout.default.pureComputed(() => 1 - ratio())
    }];
    this.markers = [{
      visible: marker,
      position: 1,
      text: _knockout.default.pureComputed(() => (0, _numeral.default)(ratio()).format('%'))
    }];
  }

}

var _default = {
  viewModel: ProgressBarViewModel,
  template: _progressBar.default
};
exports.default = _default;

},{"./progress-bar.html":771,"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","numeral":"numeral","utils/core-utils":1027}],773:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<loading-indicator ko.visible=\"loading\"></loading-indicator>\n\n<ul class=\"porp-list list-no-style column\"\n    ko.css.visible=\"!ko.unwrap(loading)\"\n    ko.foreach=\"properties\"\n>\n    <li class=\"row content-start\" ko.visible=\"visible\">\n        <div class=\"prop-name push-next\"\n            ko.text=\"labelText\"\n            ko.css.disabled=\"disabled\"\n        ></div>\n\n        <div class=\"prop-value no-wrap greedy\"\n            ko.template=\"{ html: template, data: value }\"\n            ko.css=\"css\"\n        ></div>\n\n        <copy-to-clipboard-button ko.visible=\"allowCopy\"\n            params=\"value: value, disabled: disabled\n        \"></copy-to-clipboard-button>\n    </li>\n</ul>\n";

},{}],774:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _propertySheet = _interopRequireDefault(require("./property-sheet.html"));

var _knockout = _interopRequireDefault(require("knockout"));

var _browserUtils = require("utils/browser-utils");

/* Copyright (C) 2016 NooBaa */
const defaultTemplate = '{{$data}}';

function _mapProperty(prop, templates) {
  const {
    label,
    value,
    visible = true,
    disabled = false,
    allowCopy = false,
    template: templateName
  } = prop;
  const labelText = `${label}:`;
  const template = templates[templateName] || defaultTemplate;
  const css = {
    'push-next': allowCopy,
    disabled: disabled
  };
  return {
    labelText,
    value,
    css,
    visible,
    disabled,
    allowCopy,
    template
  };
}

class PropertyRowViewModel {
  constructor() {
    (0, _defineProperty2.default)(this, "labelText", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "value", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "css", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "visible", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "disabled", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "allowCopy", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "template", null);
  }

}

class PropertySheetViewModel {
  constructor(params, templates) {
    (0, _defineProperty2.default)(this, "sub", null);
    (0, _defineProperty2.default)(this, "loading", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "properties", _knockout.default.observableArray().ofType(PropertyRowViewModel));
    this.sub = _knockout.default.computed(() => this.onParams(_knockout.default.deepUnwrap(params), templates));
  }

  onParams(params, templates) {
    const loading = Boolean(params.loading);
    const properties = params.properties.map(prop => _mapProperty(prop, templates));

    _knockout.default.assignToProps(this, {
      loading,
      properties
    });
  }

  copyToClipboard(text) {
    (0, _browserUtils.copyTextToClipboard)(_knockout.default.unwrap(text));
  }

  dispose() {
    this.sub && this.sub.dispose();
  }

}

function viewModelFactory(params, info) {
  const templates = info.templateNodes.filter(({
    nodeType
  }) => nodeType === 1).reduce((templates, template) => {
    const name = template.getAttribute('name');
    const html = template.innerHTML;
    templates[name] = html;
    return templates;
  }, {});
  return new PropertySheetViewModel(params, templates);
}

var _default = {
  viewModel: {
    createViewModel: viewModelFactory
  },
  template: _propertySheet.default
};
exports.default = _default;

},{"./property-sheet.html":773,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","utils/browser-utils":1021}],775:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<label ko.tooltip=\"$data.tooltip\">\n    <input type=\"radio\"\n        ko.attr.name=\"$data.group\"\n        ko.checked=\"$data.selected\"\n        ko.checkedValue=\"$data.value\"\n        ko.disable=\"$data.disabled || false\"\n        ko.hasFocus=\"$data.hasFocus\"\n    />\n    <svg class=\"radio-knob\">\n        <circle class=\"outer-circle\"></circle>\n        <circle class=\"inner-circle\"></circle>\n    </svg>\n    <span class=\"radio-label\"\n        ko.text=\"$data.label || $data.value\"\n    ></span>\n</label>\n";

},{}],776:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _radioBtn = _interopRequireDefault(require("./radio-btn.html"));

/* Copyright (C) 2016 NooBaa */

/*
    Component Parameters:
    - group: the name of the radio group.
    - value: the value of the radio input
    - selected: the observable to bind the value to.
    - disabled: true if the radio should be disabled.
*/
var _default = {
  template: _radioBtn.default
};
exports.default = _default;

},{"./radio-btn.html":775,"@babel/runtime/helpers/interopRequireDefault":1050}],777:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"radio-group-container\" ko.css=\"css\" ko.foreach=\"options\">\n    <radio-btn ko.css=\"$component.buttonCss\" params=\"\n        group: $component.name,\n        selected: $component.selected,\n        label: label,\n        value: value,\n        disabled: disabled,\n        tooltip: tooltip,\n        hasFocus: ko.unwrap($component.hasFocus) && $index() === 0\n    \"></radio-btn>\n</div>\n";

},{}],778:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _radioGroup = _interopRequireDefault(require("./radio-group.html"));

var _knockout = _interopRequireDefault(require("knockout"));

var _stringUtils = require("utils/string-utils");

/* Copyright (C) 2016 NooBaa */
class RadioGroupViewModel {
  constructor({
    selected = _knockout.default.observable(),
    name = (0, _stringUtils.randomString)(5),
    options = [],
    multiline = false,
    disabled = false,
    hasFocus = false
  }) {
    this.name = name;
    this.selected = selected;
    this.disabled = disabled;
    this.hasFocus = hasFocus;
    this.css = multiline ? 'multiline' : '';
    this.options = _knockout.default.pureComputed(() => _knockout.default.unwrap(options).map(opt => {
      const {
        value = opt,
        label = value,
        tooltip
      } = opt;
      const disabled = _knockout.default.unwrap(this.disabled) || _knockout.default.unwrap(opt.disabled) || false;
      return {
        value,
        label,
        disabled,
        tooltip
      };
    }));
  }

}

var _default = {
  viewModel: RadioGroupViewModel,
  template: _radioGroup.default
};
exports.default = _default;

},{"./radio-group.html":777,"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","utils/string-utils":1046}],779:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"bar\" ko.foreach=\"values\">\n    <div class=\"value\"\n        ko.visible=\"value !== 0\"\n        ko.style.width=\"$component.percentageFor(value)\"\n        ko.style.backgroundColor=\"color\"\n        ko.style.color=\"color\",\n        ko.attr.data-value=\"label\"\n    \"></div>\n</div>\n";

},{}],780:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _rangeIndicator = _interopRequireDefault(require("./range-indicator.html"));

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
class RangeIndicatorViewModel {
  constructor({
    values
  }) {
    this.values = values;
    this.total = _knockout.default.computed(() => values.reduce((sum, {
      value
    }) => {
      return sum + _knockout.default.unwrap(value);
    }, 0));
  }

  percentageFor(value) {
    return `${_knockout.default.unwrap(value) / this.total() * 100}%`;
  }

}

var _default = {
  viewModel: RangeIndicatorViewModel,
  template: _rangeIndicator.default
};
exports.default = _default;

},{"./range-indicator.html":779,"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout"}],781:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"column pad card-shadow\">\n    <h2 class=\"heading3 push-next-half\">Accounts: {{accountCount}}</h2>\n    <p>The following accounts were associated to this {{subject}}. Each new bucket created by these accounts via an S3 application will have a data placement policy containing this {{subject}}.</p>\n</div>\n\n<loading-indicator class=\"greedy push-prev\" ko.visible=\"!dataReady()\"></loading-indicator>\n\n<section class=\"column greedy accounts-list push-both-half\"\n    ko.visible=\"dataReady\"\n>\n    <ul class=\"list-no-style column\" ko.foreach=\"accounts\">\n        <li class=\"pad-half hpad\">\n            <a class=\"link\" ko.text=\"name\" ko.attr.href=\"href\"></a>\n        </li>\n    </ul>\n    <p class=\"empty-message hpad\"\n        ko.visible=\"accounts().length === 0\"\n    >\n        No associated accounts for this {{subject}}\n    </p>\n</section>\n<hr>\n<p class=\"pad-half hpad row content-middle remark\">\n    <svg-icon class=\"icon-small push-next-half\" params=\"name: 'notif-info'\"></svg-icon>\n    To edit an account's default policy click on the account name then click \"Edit S3 Access\"\n</p>\n";

},{}],782:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _resourceAssociatedAccountList = _interopRequireDefault(require("./resource-associated-account-list.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _numeral = _interopRequireDefault(require("numeral"));

var routes = _interopRequireWildcard(require("routes"));

var _browserUtils = require("utils/browser-utils");

var _coreUtils = require("utils/core-utils");

/* Copyright (C) 2016 NooBaa */
const resourceTypeMeta = (0, _coreUtils.deepFreeze)({
  HOSTS: {
    subject: 'pool',
    stateKey: 'hostPools'
  },
  CLOUD: {
    subject: 'cloud resource',
    stateKey: 'cloudResources'
  }
});

class AccountRowViewModel {
  constructor() {
    (0, _defineProperty2.default)(this, "name", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "href", _knockout.default.observable());
  }

}

class ResourceAssociatedAccountListViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "subject", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "accountCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "accounts", _knockout.default.observableArray().ofType(AccountRowViewModel));
    (0, _defineProperty2.default)(this, "selectAccounts", (0, _coreUtils.memoize)((names, accounts) => {
      return accounts && names && names.map(name => accounts[name]);
    }));
  }

  selectState(state, params) {
    const {
      resourceType,
      resourceName
    } = params;
    const {
      subject,
      stateKey
    } = resourceTypeMeta[resourceType];
    const collection = state[stateKey];
    const accountsNames = collection && collection[resourceName] && collection[resourceName].associatedAccounts;
    return [this.selectAccounts(accountsNames, state.accounts), subject, state.location.params.system];
  }

  mapStateToProps(accountList, subject, system) {
    if (!accountList) {
      _knockout.default.assignToProps(this, {
        subject: subject,
        accountCount: '',
        dataReady: false
      });
    } else {
      _knockout.default.assignToProps(this, {
        dataReady: true,
        subject: subject,
        accountCount: (0, _numeral.default)(accountList.length || 0).format(','),
        accounts: accountList.filter(account => account.roles.every(role => role !== 'operator')).map(account => ({
          name: account.name,
          href: (0, _browserUtils.realizeUri)(routes.account, {
            system,
            account: account.name
          })
        }))
      });
    }
  }

}

var _default = {
  viewModel: ResourceAssociatedAccountListViewModel,
  template: _resourceAssociatedAccountList.default
};
exports.default = _default;

},{"./resource-associated-account-list.html":781,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"components/connectable":446,"knockout":"knockout","numeral":"numeral","routes":972,"utils/browser-utils":1021,"utils/core-utils":1027}],783:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n<div class=\"pad card-shadow row content-middle\">\n    <div class=\"column greedy push-next-half\">\n        <div class=\"row content-middle\">\n            <h2 class=\"heading3 push-next\">Buckets using this {{subject}}: {{bucketCount}}</h2>\n            <p class=\"remark content-middle\" ko.visible=\"dataReady\">\n                <svg-icon class=\"icon-small\" params=\"name: 'clock'\"></svg-icon>\n                Updated: {{lastUpdateTime}}\n            </p>\n        </div>\n        <p>The following buckets are using this {{subject}} as part of their placement policy</p>\n    </div>\n    <toggle-group params=\"\n        options: viewOptions,\n        selected: ko.pc(selectedView, onView, $component)\n    \"></toggle-group>\n</div>\n\n<!-- ko if: selectedView.eq('TABLE') -->\n<resource-distribution-table class=\"column greedy\" params=\"\n    resourceType: resourceType,\n    resourceName: resourceName\n\"></resource-distribution-table>\n<!-- /ko -->\n\n<!-- ko if: selectedView.eq('CHART') -->\n<resource-distribution-chart class=\"column greedy\" params=\"\n    resourceType: resourceType,\n    resourceName: resourceName\n\"></resource-distribution-chart>\n<!-- /ko -->\n\n";

},{}],784:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _resourceConnectedBucketsForm = _interopRequireDefault(require("./resource-connected-buckets-form.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _coreUtils = require("utils/core-utils");

var _browserUtils = require("utils/browser-utils");

var _resourceUtils = require("utils/resource-utils");

var _actionCreators = require("action-creators");

var _knockout = _interopRequireDefault(require("knockout"));

var _numeral = _interopRequireDefault(require("numeral"));

var _moment = _interopRequireDefault(require("moment"));

/* Copyright (C) 2016 NooBaa */
const viewOptions = (0, _coreUtils.deepFreeze)([{
  icon: 'list',
  value: 'TABLE'
}, {
  icon: 'pie',
  value: 'CHART'
}]);

class ResourceConnectedBucketsFormViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "viewOptions", viewOptions);
    (0, _defineProperty2.default)(this, "pathname", '');
    (0, _defineProperty2.default)(this, "subject", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "resourceType", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "resourceName", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "bucketCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "lastUpdateTime", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "selectedView", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "selectUsageDistribution", (0, _coreUtils.memoize)((resourceType, resourceName, buckets) => {
      return buckets && (0, _resourceUtils.getUsageDistribution)(resourceType, resourceName, buckets);
    }));
  }

  selectState(state, params) {
    const {
      resourceType,
      resourceName
    } = params;
    const {
      query,
      pathname
    } = state.location;
    const usageDistribution = this.selectUsageDistribution(resourceType, resourceName, state.buckets);
    return [resourceType, resourceName, usageDistribution, query.view || viewOptions[0].value, pathname];
  }

  mapStateToProps(resourceType, resourceName, usageDistribution, selectedView, pathname) {
    if (!usageDistribution) {
      _knockout.default.assignToProps(this, {
        dataReady: false,
        subject: (0, _resourceUtils.getResourceTypeDisplayName)(resourceType),
        bucketCount: '',
        selectedView: selectedView
      });
    } else {
      const lastUpdateTime = usageDistribution.map(record => record.lastUpdate).reduce((t1, t2) => Math.min(t1, t2), Date.now());

      _knockout.default.assignToProps(this, {
        dataReady: true,
        resourceType: resourceType,
        resourceName: resourceName,
        subject: (0, _resourceUtils.getResourceTypeDisplayName)(resourceType),
        selectedView: selectedView,
        pathname: pathname,
        bucketCount: (0, _numeral.default)(usageDistribution.length).format(','),
        lastUpdateTime: (0, _moment.default)(lastUpdateTime).fromNow()
      });
    }
  }

  onView(view) {
    const url = (0, _browserUtils.realizeUri)(this.pathname, null, {
      view
    });
    this.dispatch((0, _actionCreators.requestLocation)(url));
  }

}

var _default = {
  viewModel: ResourceConnectedBucketsFormViewModel,
  template: _resourceConnectedBucketsForm.default
};
exports.default = _default;

},{"./resource-connected-buckets-form.html":783,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout","moment":"moment","numeral":"numeral","utils/browser-utils":1021,"utils/core-utils":1027,"utils/resource-utils":1041}],785:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<loading-indicator class=\"align-start pad\"\n    ko.visible=\"!dataReady()\"\n></loading-indicator>\n\n<div class=\"row push-both\">\n    <div class=\"row pad align-start borders content-box push-both\"\n        ko.visible=\"dataReady()\"\n    >\n        <chart-legend class=\"push-next\" params=\"\n            caption: 'Usage Distribution',\n            items: chartValues,\n            format: formatRatio\n        \"></chart-legend>\n\n        <pie-chart class=\"push-prev\" params=\"\n            values: chartValues,\n            sumLabel: 'Total Usage',\n            format: formatRatio\n        \"></pie-chart>\n    </div>\n</div>\n\n";

},{}],786:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _resourceDistributionChart = _interopRequireDefault(require("./resource-distribution-chart.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _resourceUtils = require("utils/resource-utils");

var _numeral = _interopRequireDefault(require("numeral"));

/* Copyright (C) 2016 NooBaa */
const maxChartValues = 6;
const colors = (0, _coreUtils.deepFreeze)(['rgb(var(--color20))', 'rgb(var(--color28))', 'rgb(var(--color30))', 'rgb(var(--color26))', 'rgb(var(--color27))', 'rgb(var(--color17))']);

function _formatRatio(ratio) {
  const rounded = (0, _coreUtils.decimalRound)(ratio, 3);
  return (0, _numeral.default)(rounded).format(Number.isInteger(rounded * 100) ? '%' : '0.0%');
}

class ResourceDistributionChartViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "formatRatio", _formatRatio);
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "chartValues", (0, _coreUtils.makeArray)(maxChartValues, i => ({
      value: _knockout.default.observable(),
      color: colors[i],
      label: _knockout.default.observable(),
      visible: _knockout.default.observable(),
      tooltip: _knockout.default.observable()
    })));
    (0, _defineProperty2.default)(this, "selectUsageDistribution", (0, _coreUtils.memoize)((resourceType, resourceName, buckets) => {
      return buckets && (0, _resourceUtils.getUsageDistribution)(resourceType, resourceName, buckets);
    }));
  }

  selectState(state, params) {
    const usageDistribution = this.selectUsageDistribution(params.resourceType, params.resourceName, state.buckets);
    return [usageDistribution];
  }

  mapStateToProps(usageDistribution) {
    if (!usageDistribution) {
      _knockout.default.assignToProps(this, {
        dataReady: false
      });
    } else {
      const orderedByUsage = Array.from(usageDistribution).sort((b1, b2) => b2.ratio - b1.ratio);
      const chartValues = (0, _coreUtils.makeArray)(maxChartValues, i => {
        if (i < maxChartValues - 1 || orderedByUsage.length === maxChartValues) {
          const record = orderedByUsage[i];
          const value = record ? record.ratio : 0;
          const label = record ? record.bucket : '';
          const visible = Boolean(record);
          return {
            value,
            label,
            visible
          };
        } else {
          const other = orderedByUsage.slice(maxChartValues - 1);
          const visible = other.length > 0;
          const value = visible ? (0, _coreUtils.sumBy)(other, bucket => bucket.ratio) : 0;
          const label = visible ? `Other buckets (${other.length})` : '';
          const tooltip = {
            template: 'propertySheet',
            text: other.map(item => ({
              label: item.bucket,
              value: _formatRatio(item.ratio)
            }))
          };
          return {
            value,
            label,
            visible,
            tooltip
          };
        }
      });

      _knockout.default.assignToProps(this, {
        dataReady: true,
        chartValues: chartValues
      });
    }
  }

  formatRatio(ratio) {
    const rounded = (0, _coreUtils.decimalRound)(ratio, 3);
    return (0, _numeral.default)(rounded).format(Number.isInteger(rounded * 100) ? '%' : '0.0%');
  }

}

var _default = {
  viewModel: ResourceDistributionChartViewModel,
  template: _resourceDistributionChart.default
};
exports.default = _default;

},{"./resource-distribution-chart.html":785,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"components/connectable":446,"knockout":"knockout","numeral":"numeral","utils/core-utils":1027,"utils/resource-utils":1041}],787:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<data-table class=\"column greedy buckets-table\" params=\"\n    columns: columns,\n    data: rows,\n    loading: !dataLoaded(),\n    sorting: ko.pc(sorting, onSort, $component),\n    emptyMessage: emptyMessage\n\">\n    <template name=\"usage\">\n        <span class=\"column\">\n            <span class=\"row content-middle align-middle\">\n                {{$data().size}}\n                <svg-icon class=\"icon-small warning push-prev-half\"\n                    ko.visible=\"$data().usageWarning\"\n                    ko.tooltip=\"$data().usageWarning\"\n                    params=\"name: 'notif-info'\"\n                ></svg-icon>\n            </span>\n        </span>\n    </template>\n</data-table>\n\n<div class=\"row content-middle\">\n    <p class=\"remark greedy push-next hpad row content-middle\">\n        <svg-icon class=\"icon-small push-next-half\" params=\"name: 'notif-info'\"></svg-icon>\n        To edit a bucket's placement policy click on the bucket name then click \"Edit Placement Policy\"\n    </p>\n\n    <paginator params=\"\n        itemCount: bucketCount,\n        pageSize: ko.pc(pageSize, onPageSize, $component),\n        page: ko.pc(page, onPage, $component)\n    \"></paginator>\n</div>\n\n\n";

},{}],788:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _resourceDistributionTable = _interopRequireDefault(require("./resource-distribution-table.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _browserUtils = require("utils/browser-utils");

var _sizeUtils = require("utils/size-utils");

var _resourceUtils = require("utils/resource-utils");

var _config = require("config");

var _actionCreators = require("action-creators");

var _numeral = _interopRequireDefault(require("numeral"));

var routes = _interopRequireWildcard(require("routes"));

/* Copyright (C) 2016 NooBaa */
const waitingToBeWipedWarning = 'The bucket is no longer using this resource as storage and it is currently wiping it’s stored data. Once done, it will not be shown as a connected bucket.';
const columns = (0, _coreUtils.deepFreeze)([{
  name: 'name',
  label: 'Bucket Name',
  type: 'link',
  sortable: true,
  compareKey: item => item.name
}, {
  name: 'usage',
  sortable: true,
  type: 'usage',
  compareKey: item => item.reason
}, {
  name: 'distribution',
  label: 'Usage Distribution',
  sortable: true,
  compareKey: item => item.ratio
}]);

function _formatRatio(ratio) {
  const rounded = (0, _coreUtils.decimalRound)(ratio, 3);
  return (0, _numeral.default)(rounded).format(Number.isInteger(rounded * 100) ? '%' : '0.0%');
}

class BucketRowViewModel {
  constructor() {
    (0, _defineProperty2.default)(this, "name", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "usage", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "distribution", _knockout.default.observable());
  }

}

class ResourceDistributionTableViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "columns", columns);
    (0, _defineProperty2.default)(this, "pathname", '');
    (0, _defineProperty2.default)(this, "dataLoaded", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "bucketCount", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "page", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "pageSize", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "sorting", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "emptyMessage", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "rows", _knockout.default.observableArray().ofType(BucketRowViewModel));
    (0, _defineProperty2.default)(this, "selectUsageDistribution", (0, _coreUtils.memoize)((resourceType, resourceName, buckets) => {
      return buckets && (0, _resourceUtils.getUsageDistribution)(resourceType, resourceName, buckets);
    }));
  }

  selectState(state, params) {
    const usageDistribution = this.selectUsageDistribution(params.resourceType, params.resourceName, state.buckets);
    return [params.resourceType, usageDistribution, state.location];
  }

  mapStateToProps(resourceType, usageDistribution, location) {
    const {
      params,
      query,
      pathname
    } = location;
    const {
      system,
      tab
    } = params;

    if (tab && tab !== 'connected-buckets' || !usageDistribution) {
      _knockout.default.assignToProps(this, {
        dataLoaded: false
      });
    } else {
      const subject = (0, _resourceUtils.getResourceTypeDisplayName)(resourceType);
      const sortBy = query.sortBy || 'usage';
      const order = Number(query.order) || -1;
      const page = Number(query.page) || 0;

      const pageSize = Number(query.pageSize) || _config.paginationPageSize.default;

      const pageStart = page * pageSize;
      const {
        compareKey
      } = columns.find(column => column.name === sortBy); // Clone the array on order to prevent inline sort.

      const usageList = Array.from(usageDistribution).sort((0, _coreUtils.createCompareFunc)(compareKey, order)).slice(pageStart, pageStart + pageSize);

      _knockout.default.assignToProps(this, {
        dataLoaded: true,
        pathname,
        page,
        pageSize,
        sorting: {
          sortBy,
          order
        },
        bucketCount: usageDistribution.length,
        emptyMessage: `No associated buckets for this ${subject}`,
        rows: usageList.map(record => {
          const {
            bucket,
            size,
            ratio,
            reason
          } = record;
          const href = (0, _browserUtils.realizeUri)(routes.bucket, {
            system,
            bucket
          });
          const usageWarning = reason === 'WAITING_TO_BE_WIPED' ? waitingToBeWipedWarning : '';
          return {
            name: {
              text: bucket,
              href
            },
            usage: {
              size: (0, _sizeUtils.formatSize)(size),
              usageWarning
            },
            distribution: _formatRatio(ratio)
          };
        })
      });
    }
  }

  onPage(page) {
    this._query({
      page
    });
  }

  onPageSize(pageSize) {
    this._query({
      pageSize,
      page: 0
    });
  }

  onSort(sorting) {
    this._query(sorting);
  }

  _query(params) {
    const {
      page = this.page(),
      pageSize = this.pageSize(),
      sortBy = this.sorting().sortBy,
      order = this.sorting().order
    } = params;
    const url = (0, _browserUtils.realizeUri)(this.pathname, null, {
      page,
      pageSize,
      sortBy,
      order
    });
    this.dispatch((0, _actionCreators.requestLocation)(url));
  }

}

var _default = {
  viewModel: ResourceDistributionTableViewModel,
  template: _resourceDistributionTable.default
};
exports.default = _default;

},{"./resource-distribution-table.html":787,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"components/connectable":446,"config":831,"knockout":"knockout","numeral":"numeral","routes":972,"utils/browser-utils":1021,"utils/core-utils":1027,"utils/resource-utils":1041,"utils/size-utils":1043}],789:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<!-- ko if: dataReady -->\n<section class=\"column greedy\">\n     <div class=\"row content-middle push-next-half\">\n        <h2 class=\"heading3 greedy push-next\">\n            {{title}}\n        </h2>\n        <div>\n            <button type=\"button\" class=\"link alt-colors\" ko.click=\"onSelectAll\">\n                Select all\n            </button>\n            |\n            <button type=\"button\" class=\"link alt-colors\" ko.click=\"onClearAll\">\n                Clear all\n            </button>\n        </div>\n    </div>\n    <data-table class=\"greedy content-box resource-table\" params=\"\n        columns: columns,\n        data: rows,\n        rowDisabledProp: 'isDisabled',\n        emptyMessage: 'No resources are connected to the system'\n    \"></data-table>\n</section>\n<!-- /ko -->\n";

},{}],790:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _resourcesSelectionTable = _interopRequireDefault(require("./resources-selection-table.html"));

var _coreUtils = require("utils/core-utils");

var _resourceUtils = require("utils/resource-utils");

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
const columns = (0, _coreUtils.deepFreeze)([{
  name: 'selected',
  label: '',
  type: 'checkbox'
}, {
  name: 'state',
  type: 'icon'
}, {
  name: 'type',
  type: 'icon'
}, {
  name: 'name'
}, {
  name: 'region'
}, {
  name: 'healthyHosts',
  label: 'Healthy Nodes'
}, {
  name: 'healthyNodes',
  label: 'Healthy Drives'
}, {
  name: 'usage',
  label: 'Used Capacity',
  type: 'capacity'
}]);

function _mapHostPoolToRow(id, pool, isDisabled, isSelected) {
  return {
    id,
    isDisabled,
    isSelected,
    state: (0, _resourceUtils.getHostPoolStateIcon)(pool),
    type: {
      name: 'nodes-pool',
      tooltip: 'Nodes Pool'
    },
    name: {
      text: pool.name,
      tooltip: pool.name
    },
    region: pool.region || _resourceUtils.unassignedRegionText,
    healthyHosts: (0, _resourceUtils.getHostPoolHostsSummary)(pool),
    healthyNodes: (0, _resourceUtils.getHostPoolNodesSummary)(pool),
    usage: (0, _coreUtils.pick)(pool.storage, ['total', 'used'])
  };
}

function _mapCloudResourceToRow(id, res, isDisabled, isSelected) {
  return {
    id,
    isDisabled,
    isSelected,
    state: (0, _resourceUtils.getCloudResourceStateIcon)(res),
    type: (0, _resourceUtils.getCloudResourceTypeIcon)(res),
    name: {
      text: res.name,
      tooltip: res.name
    },
    region: res.region || _resourceUtils.unassignedRegionText,
    healthyHosts: '---',
    healthyNodes: '---',
    usage: (0, _coreUtils.pick)(res.storage, ['total', 'used'])
  };
}

class RowViewModel {
  // This pure computed is used to bound the checkbox column.
  constructor({
    table
  }) {
    (0, _defineProperty2.default)(this, "id", '');
    (0, _defineProperty2.default)(this, "state", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "type", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "name", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "region", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "healthyHosts", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "healthyNodes", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "usage", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isDisabled", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "isSelected", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "selected", _knockout.default.pureComputed({
      read: this.isSelected,
      write: this.onToggle,
      owner: this
    }));
    this.table = table;
  }

  onToggle(selected) {
    this.table.onToggleResource(this.id, selected);
  }

}

class ResourcesSelectionTableViewModel {
  constructor(params) {
    (0, _defineProperty2.default)(this, "dataReady", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "sub", null);
    (0, _defineProperty2.default)(this, "onSelect", _coreUtils.noop);
    (0, _defineProperty2.default)(this, "columns", columns);
    (0, _defineProperty2.default)(this, "title", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "selected", []);
    (0, _defineProperty2.default)(this, "disabled", []);
    (0, _defineProperty2.default)(this, "rows", _knockout.default.observableArray().ofType(RowViewModel, {
      table: this
    }));

    if (_knockout.default.isWritableObservable(params.selected)) {
      this.onSelect = val => params.selected(val);
    }

    this.sub = _knockout.default.computed(() => this.mapParamsToProps(_knockout.default.unwrap(params.title), _knockout.default.unwrap(params.hostPools), _knockout.default.unwrap(params.cloudResources), _knockout.default.unwrap(params.disabled || []), _knockout.default.unwrap(params.selected)));
  }

  mapParamsToProps(title, hostPools, cloudResources, disabled, selected) {
    if (!hostPools || !cloudResources) {
      _knockout.default.assignToProps(this, {
        dataReady: false
      });
    } else {
      const hostPoolRows = Object.values(hostPools).map(pool => {
        const id = (0, _resourceUtils.getResourceId)('HOSTS', pool.name);
        const isDisabled = disabled.includes(id);
        const isSelected = selected.includes(id);
        return _mapHostPoolToRow(id, pool, isDisabled, isSelected);
      });
      const cloudResourceRows = Object.values(cloudResources).map(res => {
        const id = (0, _resourceUtils.getResourceId)('CLOUD', res.name);
        const isDisabled = disabled.includes(id);
        const isSelected = selected.includes(id);
        return _mapCloudResourceToRow(id, res, isDisabled, isSelected);
      });

      _knockout.default.assignToProps(this, {
        dataReady: true,
        title,
        selected,
        disabled,
        rows: [...hostPoolRows, ...cloudResourceRows]
      });
    }
  }

  onToggleResource(resId, selected) {
    if (selected) {
      const ids = [...this.selected, resId];
      this.onSelect(ids);
    } else {
      const ids = this.selected.filter(id => id !== resId);
      this.onSelect(ids);
    }
  }

  onSelectAll() {
    const ids = this.rows().map(row => row.id).filter(id => !this.disabled.includes(id));
    this.onSelect(ids);
  }

  onClearAll() {
    this.onSelect([]);
  }

  dispose() {
    this.sub.dispose();
  }

}

var _default = {
  viewModel: ResourcesSelectionTableViewModel,
  template: _resourcesSelectionTable.default
};
exports.default = _default;

},{"./resources-selection-table.html":789,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","utils/core-utils":1027,"utils/resource-utils":1041}],791:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<nav class=\"column\">\n    <!-- ko foreach: items -->\n    <a class=\"nav-link row pad content-middle\"\n        ko.attr.href=\"url\"\n        ko.css=\"{\n            selected: $component.isSelected(name),\n            'preview-only': $data.preview\n        }\"\n    \">\n        <svg-icon params=\"name: icon\" ko.css.beta-tag=\"beta\"></svg-icon>\n        <span class=\"pad\" ko.text=\"label\"></span>\n    </a>\n    <!-- /ko -->\n</nav>\n";

},{}],792:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _sideNav = _interopRequireDefault(require("./side-nav.html"));

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
class SideNavViewModel {
  constructor({
    items,
    selected
  }) {
    this.items = items;
    this.selected = selected;
  }

  isSelected(item) {
    return item === _knockout.default.unwrap(this.selected);
  }

}

var _default = {
  viewModel: SideNavViewModel,
  template: _sideNav.default
};
exports.default = _default;

},{"./side-nav.html":791,"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout"}],793:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<section class=\"steps\"\n    ko.style.transform=\"transform\"\n    ko.foreach=\"slides || $componentTemplateNodes).filter(elm => elm.nodeType !== 3)\"\n\">\n    <div class=\"step\"\n        ko.css.current=\"$component.isCurrent($index)\"\n        ko.template=\"{ nodes: [$data], data: $parents[1] }\"\n    ></div>\n</section>\n";

},{}],794:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _slider = _interopRequireDefault(require("./slider.html"));

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
class SliderViewModel {
  constructor({
    current = 1
  }) {
    this.current = current;
    this.transform = _knockout.default.pureComputed(() => `translate(${(_knockout.default.unwrap(this.current) - 1) * -100}%)`);
  }

  isCurrent(index) {
    return _knockout.default.unwrap(this.current()) === index() + 1;
  }

}

var _default = {
  viewModel: SliderViewModel,
  template: _slider.default
};
exports.default = _default;

},{"./slider.html":793,"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout"}],795:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<ol ko.foreach=\"steps\">\n    <li class=\"stepper-step\" ko.css.selected=\"selected\">\n        <div class=\"step-bullet\">\n            <span class=\"step-number\" ko.text=\"$index() + 1\"></span>\n            <svg class=\"step-done\">\n                <use xlink:href=\"#inverted-v-icon\"></use>\n            </svg>\n        </div>\n        <span class=\"step-label\" ko.text=\"name\"></span>\n    </li>\n</ol>\n";

},{}],796:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _stepper = _interopRequireDefault(require("./stepper.html"));

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
class StepperViewModel {
  constructor({
    steps,
    current = 0
  }) {
    this.current = current;
    this.steps = steps.map((name = '[not set]', i) => ({
      name: name,
      selected: _knockout.default.pureComputed(() => i === _knockout.default.unwrap(this.current))
    }));
  }

}

var _default = {
  viewModel: StepperViewModel,
  template: _stepper.default
};
exports.default = _default;

},{"./stepper.html":795,"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout"}],797:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<!--\nForcing recreation of the <use> element each time the href value changes (using ko.with)\nThis is done due to the fact that chrome 58 broke behavior that cause changes to xlink:href\nto be ignored which manifested itself as empty icons (issue #2994)\n-->\n<svg ko.style.fill=\"fill\" ko.style.stroke=\"stroke\" ko.with=\"href\">\n    <use xlink:href ko.attr=\"{ 'xlink:href': $data }\"></use>\n</svg>\n";

},{}],798:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _svgIcon = _interopRequireDefault(require("./svg-icon.html"));

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
class SVGIconViewModel {
  constructor({
    name,
    fill,
    stroke
  }) {
    this.href = _knockout.default.pureComputed(() => `#${_knockout.default.unwrap(name)}-icon`);
    this.fill = fill;
    this.stroke = stroke;
  }

}

var _default = {
  viewModel: SVGIconViewModel,
  template: _svgIcon.default
};
exports.default = _default;

},{"./svg-icon.html":797,"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout"}],799:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"row content-middle\" ko.ifnot=\"emptyMessage\">\n    <ul class=\"no-wrap list-no-style row content-middle\" ko.forEach=\"tags\">\n        <!-- ko if: $index() && $component.separator() -->\n        <svg-icon class=\"icon-small push-prev-half\"\n            params=\"name: $component.separator\"\n        ></svg-icon>\n        <!-- /ko -->\n\n        <li class=\"no-wrap pad tag\"\n            ko.css=\"css\"\n            ko.tooltip=\"tooltip\"\n        >\n           {{text}}\n        </li>\n    </ul>\n    <!-- ko with: extra -->\n    <span class=\"highlight align-middle push-prev-half\"\n        ko.tooltip=\"tooltip\"\n    >\n        {{text}}\n    </span>\n    <!-- /ko -->\n</div>\n\n{{emptyMessage}}\n";

},{}],800:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _tagList = _interopRequireDefault(require("./tag-list.html"));

var _knockout = _interopRequireDefault(require("knockout"));

var _numeral = _interopRequireDefault(require("numeral"));

var _coreUtils = require("utils/core-utils");

/* Copyright (C) 2016 NooBaa */
function _normalizeTooltip(tooltip) {
  if ((0, _coreUtils.isObject)(tooltip)) {
    return { ...tooltip,
      breakWords: true
    };
  } else {
    return {
      text: tooltip,
      breakWords: true
    };
  }
}

function _mapParamsToProps(params) {
  const {
    tags: allTags = [],
    maxCount = Infinity,
    separator = '',
    emptyMessage: emptyMessageText = ''
  } = params;
  const hasTooMany = allTags.length > maxCount;
  const tags = allTags.slice(0, hasTooMany ? maxCount - 1 : allTags.length).map((tag, i) => ({
    text: tag.text || tag,
    css: {
      'push-prev-half': Boolean(i),
      [tag.css || '']: Boolean(tag.css)
    },
    tooltip: tag.tooltip && _normalizeTooltip(tag.tooltip)
  }));
  let extra = null;

  if (hasTooMany) {
    const extraTags = allTags.slice(maxCount - 1);
    extra = {
      text: `${(0, _numeral.default)(extraTags.length).format(',')} more`,
      tooltip: {
        text: extraTags,
        template: 'list',
        align: 'end',
        breakWords: true
      }
    };
  }

  const emptyMessage = allTags.length === 0 ? emptyMessageText : '';
  return {
    tags,
    extra,
    separator,
    emptyMessage
  };
}

class TagListViewModel {
  constructor(params) {
    (0, _defineProperty2.default)(this, "tags", _knockout.default.observableArray());
    (0, _defineProperty2.default)(this, "separator", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "extra", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "emptyMessage", _knockout.default.observable());
    this.sub = _knockout.default.computed(() => {
      const unwraped = _knockout.default.deepUnwrap(params);

      const props = _mapParamsToProps(unwraped);

      _knockout.default.assignToProps(this, props);
    });
  }

  dispose() {
    this.sub.dispose();
  }

}

var _default = {
  viewModel: TagListViewModel,
  template: _tagList.default
};
exports.default = _default;

},{"./tag-list.html":799,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","numeral":"numeral","utils/core-utils":1027}],801:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<editor params=\"label: 'Timezone'\">\n    <dropdown params=\"\n        options: options,\n        selected: selected,\n        filter: true\n    \"></dropdown>\n</editor>\n";

},{}],802:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _timezoneChooser = _interopRequireDefault(require("./timezone-chooser.html"));

var _momentTimezone = _interopRequireDefault(require("moment-timezone"));

/* Copyright (C) 2016 NooBaa */
const options = _momentTimezone.default.tz.names().map(name => ({
  name: name,
  offset: _momentTimezone.default.tz(name).utcOffset()
})).sort((tz1, tz2) => tz1.offset - tz2.offset).map(({
  name
}) => {
  let offsetText = (0, _momentTimezone.default)().tz(name).format('[GMT]Z');
  let label = name.replace(/\_/g, ' ');
  return {
    label: `(${offsetText}) ${label}`,
    value: name
  };
});

class TimezoneChooserViewModel {
  constructor({
    timezone
  }) {
    this.options = options;
    this.selected = timezone;
  }

  matchByTimezoneName(option, input) {
    let regExp = new RegExp(`\\b${input.replace('/', '\\/')}`);
    return regExp.test(option.label.toLowerCase());
  }

}

var _default = {
  viewModel: TimezoneChooserViewModel,
  template: _timezoneChooser.default
};
exports.default = _default;

},{"./timezone-chooser.html":801,"@babel/runtime/helpers/interopRequireDefault":1050,"moment-timezone":"moment-timezone"}],803:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"row toggle-options\" ko.foreach=\"options\">\n    <!-- ko if: $index() -->\n    <vr></vr>\n    <!-- /ko -->\n    <label class=\"toggle-option\">\n        <input type=\"radio\"\n            ko.attr.name=\"$component.group\"\n            ko.checkedValue=\"value\"\n            ko.checked=\"$component.selected\"\n        />\n        <div class=\"toggle-btn content-middle\" ko.css=\"layoutCss\">\n            <!-- ko if: icon -->\n            <svg-icon class=\"icon-small\" ko.css.push-next-half=\"label\"\n                params=\"name: icon\"\n            ></svg-icon>\n            <!-- /ko -->\n            {{label}}\n        </div>\n    </label>\n</div>\n";

},{}],804:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _toggleGroup = _interopRequireDefault(require("./toggle-group.html"));

var _knockout = _interopRequireDefault(require("knockout"));

var _stringUtils = require("utils/string-utils");

var _coreUtils = require("utils/core-utils");

/* Copyright (C) 2016 NooBaa */
function _normalizeOption(opt) {
  if ((0, _coreUtils.isObject)(opt)) {
    const {
      value,
      label = '',
      icon = ''
    } = opt;
    const layoutCss = label && icon ? 'row' : 'column';
    return {
      value,
      label,
      icon,
      layoutCss
    };
  } else {
    const value = String(opt);
    return {
      value,
      label: value,
      icon: '',
      layoutCss: 'column'
    };
  }
}

class ToggleButtonViewModel {
  constructor() {
    (0, _defineProperty2.default)(this, "value", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "label", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "icon", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "layoutCss", _knockout.default.observable());
  }

}

class ToggleGroupViewModel {
  constructor({
    options = [],
    selected = _knockout.default.observable(),
    name = (0, _stringUtils.randomString)(5)
  }) {
    this.options = _knockout.default.pureComputed(() => _knockout.default.unwrap(options).map((opt, i) => {
      const btnVM = (this.options.peek() || [])[i] || new ToggleButtonViewModel();

      _knockout.default.assignToProps(btnVM, _normalizeOption(opt));

      return btnVM;
    }));
    this.selected = selected;
    this.group = name;
  }

}

var _default = {
  viewModel: ToggleGroupViewModel,
  template: _toggleGroup.default
};
exports.default = _default;

},{"./toggle-group.html":803,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","utils/core-utils":1027,"utils/string-utils":1046}],805:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<label class=\"toggle-wrapper\"\n    ko.css.disabled=\"disabled\"\n    ko.keysToClicks=\"['space', 'enter']\"\n>\n    <input class=\"hide\"\n        type=\"checkbox\"\n        ko.checked=\"value\"\n        ko.disable=\"disabled\"\n        ko.hasFocus=\"hasFocus\"\n    />\n\n    <svg class=\"toggle-box\">\n        <rect class=\"outer-capsule\"></rect>\n        <circle class=\"inner-circle\"></circle>\n    </svg>\n    <span class=\"toggle-label\" ko.text=\"label\"></span>\n</label>\n";

},{}],806:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _toggleSwitch = _interopRequireDefault(require("./toggle-switch.html"));

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
class ToggleSwitchViewModel {
  constructor(params) {
    const {
      value = _knockout.default.observable(true),
      onLabel = 'on',
      offLabel = 'off',
      disabled = false,
      hasFocus = false
    } = params;
    this.value = value;
    this.disabled = disabled;
    this.hasFocus = hasFocus;
    this.label = _knockout.default.pureComputed(() => _knockout.default.unwrap(value) ? _knockout.default.unwrap(onLabel) : _knockout.default.unwrap(offLabel));
  }

}

var _default = {
  viewModel: ToggleSwitchViewModel,
  template: _toggleSwitch.default
};
exports.default = _default;

},{"./toggle-switch.html":805,"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout"}],807:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<div class=\"input row multiline content-start token-field-wrapper\"\n    ko.css.focus=\"hasFocus\"\n    ko.css.disabled=\"disabled\"\n    ko.event=\"eventHandlers\"\n    ko.scroll=\"scroll\"\n>\n    <!-- ko foreach: list -->\n    <div class=\"row content-middle token\"\n        ko.css.error=!$component.validateToken($data)\n    >\n        <span class=\"greedy token-text\"\n            ko.preventBubble=\"'mousedown'\"\n            ko.text=\"$data\"\n        ></span>\n        <button type=\"button\"\n            class=\"icon-btn token-remove-btn\"\n            tabindex=\"-1\"\n            ko.click=\"() => $component.onRemoveToken($index())\"\n            ko.disable=\"$component.disabled\"\n        >\n            <svg-icon params=\"name: 'x'\"></svg-icon>\n        </button>\n    </div>\n    <!-- /ko -->\n    <input type=\"text\"\n        class=\"internal-input greedy\"\n        ko.textInput=\"text\"\n        ko.hasFocus=\"hasFocus\"\n        ko.attr.placeholder=\"placeholder\"\n        ko.selection=\"selection\"\n        ko.preventBubble=\"'mousedown'\"\n        ko.disable=\"disabled\"\n    />\n</div>\n";

},{}],808:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _tokenField = _interopRequireDefault(require("./token-field.html"));

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

var _stringUtils = require("utils/string-utils");

/* Copyright (C) 2016 NooBaa */
const enterKeyCode = 13;
const backspaceKeyCode = 8;
const tokenSeperator = '\n';

class TokenFieldViewModel {
  constructor({
    tokens = _knockout.default.observable([]),
    disabled = false,
    placeholder = 'Type to add tokens',
    validator
  }) {
    this.text = _knockout.default.observable('');
    this.disabled = disabled;
    this.placeholder = _knockout.default.pureComputed(() => this.hasFocus() ? '' : _knockout.default.unwrap(placeholder));
    this.validateToken = (0, _coreUtils.isFunction)(validator) ? validator : () => true;
    this.list = _knockout.default.observableArray(Array.from(_knockout.default.unwrap(tokens) || []));
    this.selection = _knockout.default.observable(0);
    this.hasFocus = _knockout.default.observable(false);
    this.hasFocus.subscribe(f => !f && this.onBlur());
    this.scroll = _knockout.default.observable().extend({
      notify: 'always'
    });
    this.eventHandlers = {
      mousedown: this.onMouseDown,
      paste: this.onPaste,
      keypress: this.onKeyPress,
      keydown: this.onKeyDown
    };
    this.tokens = tokens;
    this.tokensSub = tokens.subscribe(tokens => this.list(Array.from(tokens)));
  }

  onMouseDown() {
    this.hasFocus(true);
  }

  onKeyPress(_, evt) {
    if (evt.which !== enterKeyCode) {
      return true;
    }

    this.commitText();
    evt.preventDefault();
  }

  onKeyDown(_, {
    which
  }) {
    if (which === backspaceKeyCode && !this.text()) {
      this.text(this.list.pop());
    } else {
      return true;
    }
  }

  onBlur() {
    this.commitText();
    this.tokens(Array.from(this.list()));
  }

  onPaste(_, {
    clipboardData
  }) {
    const text = clipboardData.getData('text');

    if (!text) {
      return;
    }

    const {
      start,
      end
    } = this.selection();
    const list = (0, _stringUtils.splice)(this.text(), start, end, text).split(tokenSeperator).filter(token => Boolean(token.trim()));

    if (list.length > 1) {
      this.text('');
      this.list.push(...list);
      this.scroll(1);
    } else {
      return true;
    }
  }

  onRemoveToken(index) {
    this.list.splice(index, 1);
    this.hasFocus(true);
  }

  dispose() {
    this.tokensSub.dispose();
  }

  commitText() {
    const text = this.text().trim();
    if (!text) return;
    this.list.push(text);
    this.text('');
    this.scroll(1);
  }

}

var _default = {
  viewModel: TokenFieldViewModel,
  template: _tokenField.default
};
exports.default = _default;

},{"./token-field.html":807,"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","utils/core-utils":1027,"utils/string-utils":1046}],809:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<svg-icon params=\"name: icon\" ko.css=\"css\" ko.visible=\"visible\"></svg-icon>\n";

},{}],810:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _validationIndicator = _interopRequireDefault(require("./validation-indicator.html"));

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
class ValidationIndicatorViewModel {
  constructor({
    field
  }) {
    const {
      isDirty,
      isValid,
      isValidating
    } = field;
    this.visible = _knockout.default.pureComputed(() => isDirty() && (isValid() || isValidating()));
    this.icon = _knockout.default.pureComputed(() => isValid() ? 'healthy' : 'in-progress');
    this.css = _knockout.default.pureComputed(() => ({
      success: isValid(),
      'match-theme': isValidating,
      spin: isValidating
    }));
  }

}

var _default = {
  viewModel: ValidationIndicatorViewModel,
  template: _validationIndicator.default
};
exports.default = _default;

},{"./validation-indicator.html":809,"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout"}],811:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n<span ko.visible=\"visible\" ko.css=\"css\" ko.text=\"text\"></span>\n";

},{}],812:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _validationMessage = _interopRequireDefault(require("./validation-message.html"));

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
class ValidationMessageViewModel {
  constructor({
    field
  }) {
    const {
      isValid,
      wasTouched,
      error,
      warning
    } = field;
    this.visible = _knockout.default.pureComputed(() => error() ? wasTouched() : Boolean(warning()));
    this.css = _knockout.default.pureComputed(() => !isValid() ? 'error' : warning() ? 'warning' : '');
    this.text = _knockout.default.pureComputed(() => isValid() ? warning() || '' : error() || '');
  }

}

var _default = {
  viewModel: ValidationMessageViewModel,
  template: _validationMessage.default
};
exports.default = _default;

},{"./validation-message.html":811,"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout"}],813:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n<ul class=\"remark push-prev\"\n    ko.foreach=\"validationRules\">\n    <li ko.text=\"message\"\n        ko.css=\"css\">\n    </li>\n</ul>\n";

},{}],814:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _validationRulesList = _interopRequireDefault(require("./validation-rules-list.html"));

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
class ValidationRulesListViewModel {
  constructor({
    field,
    highlightErrors = false
  }) {
    this.validationRules = _knockout.default.pureComputed(() => _knockout.default.validation.fullValidationState(field)().map(({
      message,
      isValid
    }) => ({
      message: message,
      css: {
        success: field() && isValid,
        error: highlightErrors() && (!field() || !isValid)
      }
    })));
  }

}

var _default = {
  viewModel: ValidationRulesListViewModel,
  template: _validationRulesList.default
};
exports.default = _default;

},{"./validation-rules-list.html":813,"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout"}],815:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<button class=\"link alt-colors wiz-back push-next\"\n    type=\"button\"\n    ko.click=\"_wizard_.onCancel\"\n    ko.disable=\"_wizard_.disabled\"\n    ko.visible=\"_wizard_.isFirstStep\"\n>\n    Cancel\n</button>\n\n<button class=\"link alt-colors wiz-back push-next\"\n    type=\"button\"\n    ko.click=\"_wizard_.onStepBackword\"\n    ko.disable=\"_wizard_.disabled\"\n    ko.hidden=\"_wizard_.isFirstStep\"\n>\n    Previous\n</button>\n\n<button class=\"btn wiz-fwd\"\n    type=\"button\"\n    ko.click=\"_wizard_.onStepForward\"\n    ko.shakeOnClick=\"_wizard_.shake\"\n    ko.disable=\"_wizard_.disabled\"\n    ko.hidden=\"_wizard_.isLastStep\"\n>\n    Next\n</button>\n\n<button class=\"btn wiz-fwd\"\n    type=\"submit\"\n    ko.click=\"_wizard_.onComplete\"\n    ko.shakeOnClick=\"_wizard_.shake\"\n    ko.disable=\"_wizard_.disabled\"\n    ko.visible=\"_wizard_.isLastStep\"\n>\n    {{_wizard_.actionLabel}}\n</button>\n\n";

},{}],816:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _wizardControls = _interopRequireDefault(require("./wizard-controls.html"));

/* Copyright (C) 2016 NooBaa */
var _default = {
  template: _wizardControls.default
};
exports.default = _default;

},{"./wizard-controls.html":815,"@babel/runtime/helpers/interopRequireDefault":1050}],817:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<section class=\"column greedy\" ko.let=\"{ _wizard_: $data }\">\n    <stepper params=\"steps: steps, current: step\">\n    </stepper>\n\n    <div class=\"pages column greedy\" ko.forEach=\"stepTemplate\">\n        <div class=\"page column greedy\" ko.template=\"{\n            nodes: [$data],\n            data: $parents[1]\n        }\"></div>\n    </div>\n\n    <!-- ko if: renderControls -->\n    <div class=\"column content-box pad\">\n        <wizard-controls class=\"align-end\">\n        </wizard-controls>\n    </div>\n    <!-- /ko -->\n</section>\n";

},{}],818:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _wizard = _interopRequireDefault(require("./wizard.html"));

var _coreUtils = require("utils/core-utils");

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
const methodsTobind = (0, _coreUtils.deepFreeze)(['onCancel', 'onStepForward', 'onStepBackword', 'onComplete']);

class WizardViewModel {
  constructor(params, templates, owner) {
    const {
      steps = [],
      step = _knockout.default.observable(0),
      actionLabel = 'Done',
      disabled = false,
      shakeOnFailedStep = true,
      onBeforeStep = () => true,
      onAfterStep = _coreUtils.noop,
      onCancel = _coreUtils.noop,
      onComplete = _coreUtils.noop,
      renderControls = true
    } = params;
    this.steps = steps;
    this.step = step;
    this.actionLabel = actionLabel;
    this.disabled = disabled;
    this.shakeOnFailedStep = shakeOnFailedStep;
    this.shake = _knockout.default.observable(false);
    this.afterStepHandler = onAfterStep.bind(owner);
    this.beforeStepHandler = onBeforeStep.bind(owner);
    this.cancelHandler = onCancel.bind(owner);
    this.completeHandler = onComplete.bind(owner);
    this.renderControls = renderControls;
    this.stepTemplate = _knockout.default.pureComputed(() => {
      // Returning an array of one item to be used in with knockout foreach
      // binding and solve the problem of concurent rerandering that occur
      // when using knockout with binding.
      return (0, _coreUtils.ensureArray)(templates[_knockout.default.unwrap(step)]);
    });
    this.isFirstStep = _knockout.default.pureComputed(() => this.step() === 0);
    this.isLastStep = _knockout.default.pureComputed(() => this.step() === _knockout.default.unwrap(steps).length - 1);
    this.prevLabel = _knockout.default.pureComputed(() => this.isFirstStep() ? 'Cancel' : 'Previous');
    this.nextLabel = _knockout.default.pureComputed(() => this.isLastStep() ? _knockout.default.unwrap(actionLabel) : 'Next');

    for (const method of methodsTobind) {
      this[method] = this[method].bind(this);
    }
  } // ----------------------------------------------------------------------------
  // Making all of the following handlers async to gurentee that the handlers`
  // code will be schedule to run at the end of the event queue.
  // ----------------------------------------------------------------------------


  async onCancel() {
    this.cancelHandler();
  }

  async onStepForward() {
    this.shake(false);
    const step = this.step();

    if (!this.beforeStepHandler(step)) {
      this.shake(_knockout.default.unwrap(this.shakeOnFailedStep));
      return;
    }

    this.step(step + 1);
    this.afterStepHandler(step + 1);
  }

  async onStepBackword() {
    const step = this.step();
    this.step(step - 1);
    this.afterStepHandler(step - 1);
  }

  async onComplete() {
    if (!this.isLastStep()) {
      return;
    }

    this.shake(false);

    if (!this.beforeStepHandler(this.step())) {
      this.shake(_knockout.default.unwrap(this.shakeOnFailedStep));
      return;
    }

    this.completeHandler();
  }

}

function _createViewModel(params, info) {
  const owner = _knockout.default.dataFor(info.element);

  const templates = info.templateNodes.filter(({
    nodeType
  }) => nodeType === Node.ELEMENT_NODE);
  return new WizardViewModel(params, templates, owner);
}

var _default = {
  viewModel: {
    createViewModel: _createViewModel
  },
  template: _wizard.default
};
exports.default = _default;

},{"./wizard.html":817,"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","utils/core-utils":1027}],819:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<button class=\"btn\"\n    ko.click=\"() => onClick($parent)\"\n    ko.css.disabled=\"working\"\n    ko.disable=\"disabled\"\n\">\n    <div class=\"content-wrapper\" ko.template=\"{ nodes: $componentTemplateNodes, data: $parent }\">\n    </div>\n    <div class=\"working-label\" ko.visible=\"working\">\n        <svg-icon class=\"spin match-theme\" params=\"name: 'in-progress'\"></svg-icon>\n        {{label}}\n    </div>\n</button>\n";

},{}],820:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _workingButton = _interopRequireDefault(require("./working-button.html"));

var _coreUtils = require("utils/core-utils");

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
class WorkingBtnViewModel {
  constructor({
    working,
    workingLabel,
    click,
    disabled
  }) {
    this.working = working;
    this.label = workingLabel;
    this.clickHandler = click;
    this.disabled = disabled;
  }

  onClick(parentViewModel) {
    const {
      working,
      clickHandler
    } = this;

    if ((0, _coreUtils.isFunction)(clickHandler) && !_knockout.default.unwrap(working)) {
      clickHandler.call(parentViewModel);
    }
  }

}

var _default = {
  viewModel: WorkingBtnViewModel,
  template: _workingButton.default
};
exports.default = _default;

},{"./working-button.html":819,"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","utils/core-utils":1027}],821:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<section class=\"sticky sticky-warning\" ko.css.active=\"isActive\">\n    <p class=\"sticky-content row content-middle\">\n        <svg-icon class=\"icon-small push-next-half\"\n            params=\"name: 'problem'\"\n        ></svg-icon>\n        <span class=\"greedy\">\n            Too many servers in the cluster cannot be reached\n        </span>\n    </p>\n</section>\n";

},{}],822:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _clusterAvailabilitySticky = _interopRequireDefault(require("./cluster-availability-sticky.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
class ClusterAvailabilityStickyViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "isActive", _knockout.default.observable());
  }

  selectState(state) {
    const {
      topology = {}
    } = state;
    return [topology.servers];
  }

  mapStateToProps(servers) {
    if (!servers) {
      _knockout.default.assignToProps(this, {
        isActive: false
      });
    } else {
      const serverList = Object.values(servers);
      const connected = serverList.filter(server => server.mode === 'CONNECTED').length;
      const isActive = connected < Math.floor(serverList.length / 2) + 1;

      _knockout.default.assignToProps(this, {
        isActive
      });
    }
  }

}

var _default = {
  viewModel: ClusterAvailabilityStickyViewModel,
  template: _clusterAvailabilitySticky.default
};
exports.default = _default;

},{"./cluster-availability-sticky.html":821,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"components/connectable":446,"knockout":"knockout"}],823:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<section class=\"sticky sticky-warning\" ko.css.active=\"isActive\"\">\n    <p class=\"sticky-content row content-middle\">\n        <svg-icon class=\"icon-small push-next-half\"\n            params=\"name: 'problem'\"\n        ></svg-icon>\n\n        <span class=\"greedy\">\n            System is in debug mode and might exhibit temporary performance degradation\n        </span>\n\n        <button class=\"sticky-action\"\n            ko.click=\"onTurnOffDebugMode\"\n        >\n            Turn off debug mode\n        </button>\n    </p>\n</section>\n";

},{}],824:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _debugModeSticky = _interopRequireDefault(require("./debug-mode-sticky.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _actionCreators = require("action-creators");

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
class DebugModeStickyViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "isActive", _knockout.default.observable());
  }

  selectState(state) {
    const {
      system
    } = state;
    return [system && system.debug.level];
  }

  mapStateToProps(debugLevel) {
    _knockout.default.assignToProps(this, {
      isActive: debugLevel > 0
    });
  }

  onTurnOffDebugMode() {
    this.dispatch((0, _actionCreators.setSystemDebugLevel)(0));
  }

}

var _default = {
  viewModel: DebugModeStickyViewModel,
  template: _debugModeSticky.default
};
exports.default = _default;

},{"./debug-mode-sticky.html":823,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"knockout":"knockout"}],825:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<section class=\"sticky sticky-warning\" ko.css.active=\"isActive\">\n    <p class=\"sticky-content row content-middle\">\n        <svg-icon class=\"icon-small push-next-half\"\n            params=\"name: 'problem'\"\n        ></svg-icon>\n        System is in maintenance mode and will not perform data rebuilds\n        <vr></vr>\n        <span class=\"greedy\">\n            Time left\n            {{formattedTimeLeft}}\n        </span>\n        <button class=\"sticky-action\" ko.click=\"onTurnMaintenanceOff\">\n            Turn maintenance off\n        </button>\n    </p>\n</section>\n";

},{}],826:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _maintenanceSticky = _interopRequireDefault(require("./maintenance-sticky.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _maintenanceUtils = require("utils/maintenance-utils");

var _config = require("config");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
class MaintenanceModeStickyViewModel extends _connectable.default {
  constructor(params, inject) {
    super(params, inject);
    (0, _defineProperty2.default)(this, "isActive", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "timeLeft", _knockout.default.observable());
    (0, _defineProperty2.default)(this, "formattedTimeLeft", _knockout.default.observable());
    this.ticker = setInterval(() => this.onTick(), _config.timeTickInterval);
  }

  selectState(state) {
    return [state.system && state.system.maintenanceMode];
  }

  mapStateToProps(maintenanceMode) {
    if (!maintenanceMode) {
      _knockout.default.assignToProps(this, {
        isActive: false
      });
    } else {
      const timeLeft = Math.max(maintenanceMode.till - Date.now(), 0);
      const formattedTimeLeft = (0, _maintenanceUtils.formatTimeLeftForMaintenanceMode)(timeLeft);

      _knockout.default.assignToProps(this, {
        isActive: Boolean(timeLeft),
        timeLeft,
        formattedTimeLeft
      });
    }
  }

  onTurnMaintenanceOff() {
    this.dispatch((0, _actionCreators.leaveMaintenanceMode)());
  }

  onTick() {
    if (!this.timeLeft()) {
      return;
    }

    const timeLeft = Math.max(this.timeLeft() - _config.timeTickInterval, 0);
    const formattedTimeLeft = (0, _maintenanceUtils.formatTimeLeftForMaintenanceMode)(timeLeft);

    _knockout.default.assignToProps(this, {
      timeLeft,
      formattedTimeLeft
    });
  }

  dispose() {
    clearInterval(this.ticker);
    super.dispose();
  }

}

var _default = {
  viewModel: MaintenanceModeStickyViewModel,
  template: _maintenanceSticky.default
};
exports.default = _default;

},{"./maintenance-sticky.html":825,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"config":831,"knockout":"knockout","utils/maintenance-utils":1035}],827:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<section class=\"sticky\" ko.css.active=\"isActive\">\n    <p class=\"sticky-content row content-middle\">\n        <svg-icon params=\"name: 'notif-info'\"\n            class=\"icon-small push-next-half\"\n        ></svg-icon>\n\n        <span class=\"greedy\">\n            Phone home option is not available. By enabling conectivity you could get proactive support for the product\n        </span>\n    </p>\n</section>\n";

},{}],828:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _phoneHomeConnectivitySticky = _interopRequireDefault(require("./phone-home-connectivity-sticky.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
class PhoneHomeConnectivityStickyViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "isActive", _knockout.default.observable());
  }

  selectState(state) {
    const {
      system
    } = state;
    return [system ? system.phoneHome.reachable : true];
  }

  mapStateToProps(isPhoneHomeReachable) {
    _knockout.default.assignToProps(this, {
      isActive: !isPhoneHomeReachable
    });
  }

}

var _default = {
  viewModel: PhoneHomeConnectivityStickyViewModel,
  template: _phoneHomeConnectivitySticky.default
};
exports.default = _default;

},{"./phone-home-connectivity-sticky.html":827,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"components/connectable":446,"knockout":"knockout"}],829:[function(require,module,exports){
module.exports = "<!-- Copyright (C) 2016 NooBaa -->\n\n<section class=\"sticky\" ko.css.active=\"isActive\">\n    <p class=\"sticky-content row content-middle\">\n        <svg-icon params=\"name: 'notif-info'\"\n            class=\"icon-small push-next-half\"\n        ></svg-icon>\n\n        <span class=\"greedy\">\n            For the best experience of NooBaa, we recommend using chrome.\n        </span>\n\n        <button class=\"sticky-action\" tabindex=\"-1\" ko.click=\"onIgnore\">\n            <svg-icon class=\"icon-xsmall\" params=\"name: 'x'\"></svg-icon>\n        </button>\n    </p>\n</section>\n\n";

},{}],830:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _preferedBrowsersSticky = _interopRequireDefault(require("./prefered-browsers-sticky.html"));

var _connectable = _interopRequireDefault(require("components/connectable"));

var _knockout = _interopRequireDefault(require("knockout"));

var _config = require("config");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
class PreferedBrowsersStickyViewModel extends _connectable.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "isActive", _knockout.default.observable());
  }

  selectState(state) {
    return [state.env];
  }

  mapStateToProps(env) {
    if (!env) {
      _knockout.default.assignToProps(this, {
        isActive: false
      });
    } else {
      const {
        browser,
        isBrowserStickyDismissed
      } = env;
      const isActive = !_config.preferdBrowsers.includes(browser) && !isBrowserStickyDismissed;

      _knockout.default.assignToProps(this, {
        isActive
      });
    }
  }

  onIgnore() {
    this.dispatch((0, _actionCreators.dismissBrowserSticky)());
  }

}

var _default = {
  viewModel: PreferedBrowsersStickyViewModel,
  template: _preferedBrowsersSticky.default
};
exports.default = _default;

},{"./prefered-browsers-sticky.html":829,"@babel/runtime/helpers/defineProperty":1049,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"components/connectable":446,"config":831,"knockout":"knockout"}],831:[function(require,module,exports){
module.exports={
    "patchFile": "/fe/config.patch.json",
    "inputThrottle": 300,
    "paginationPageSize": {
        "default": 25,
        "options": [10, 25, 50]
    },
    "infinitScrollPageSize": 25,
    "timeShortFormat": "DD MMM YYYY HH:mm:ss",
    "timeLongFormat": "DD MMM YYYY HH:mm:ss ([GMT]Z)",
    "sslCertificateSuffix": ".zip",
    "serverRestartWaitInterval": 20000,
    "readAuthRetryCount": 2,
    "readAuthRetryDelay": 1000,
    "sessionTokenKey": "sessionToken",
    "previewContentKey": "previewContent",
    "redirectOverlayDuration": 4000,
    "timeTickInterval": 1000,
    "autoRefreshInterval": 30000,
    "maxTiersAllowed": 2,
    "nodeTest": {
        "targetCount": 20,
        "testSettings": {
            "connectivity": {
                "stepCount": 1,
                "requestLength": 0,
                "responseLength": 0,
                "count": 1,
                "concur": 1
            },
            "bandwidth": {
                "stepCount": 8,
                "requestLength": 524288,
                "responseLength": 524288,
                "count": 64,
                "concur": 16
            }
        }
    },
    "notifications": {
        "minTimeOnScreen": 3200,
        "charTimeContribution": 50
    },
    "supportedBrowsers": [
        "chrome"
    ],
    "preferdBrowsers": [
        "chrome"
    ],
    "support":  {
        "email": "support@noobaa.com",
        "createSystemSupportSubject": "Need help creating a system",
        "missingOVAMailSubject": "Please help me find my original OVA",
        "managementConsoleSubject": "My NooBaa management console has crushed",
        "cannotResetAccountPasswordSubject": "Cannot reset account password"
    },
    "releaseNotes": {
        "baseUrl": "https://storage.googleapis.com/noobaa-fe-assets/release-notes",
        "suffix": "txt"
    },
    "logo": "logo-up",
    "themes": {
        "dark": "theme-up-dark",
        "light": "theme-up-light"
    },
    "defaultTheme": "dark"
}

},{}],832:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var model = _interopRequireWildcard(require("model"));

var _state = require("state");

var actionCreators = _interopRequireWildcard(require("action-creators"));

var _schema = _interopRequireDefault(require("schema"));

var _services = require("services");

var _coreUtils = require("utils/core-utils");

var _browserUtils = require("utils/browser-utils");

/* Copyright (C) 2016 NooBaa */
const logToConsole = console.log.bind(console);
const HELP = [{
  function: 'dumpAppLog()',
  description: 'Downloads Management Console dump file'
}, {
  function: 'toggleApiLogging([enable: boolean])',
  description: 'Toggle the logging of RPC traffic messages to the browser development tools console'
}, {
  function: 'openDebugConsole()',
  description: 'Opens a proprietary debug console tool that tracks the Management Console state'
}, {
  function: 'printAsJsonInNewTab(value: any)',
  description: 'Stringify the value to JSON format and dump the json to a new window/tab.'
}, {
  function: 'downloadAsJson(value: any)',
  description: 'Stringify the value to JSON format and download a file containing the json'
}];
const actions = (0, _coreUtils.mapValues)(actionCreators, creator => function (...args) {
  _state.action$.next(creator(...args));
});

function printAsJsonInNewTab(data) {
  (0, _browserUtils.openInNewTab)((0, _browserUtils.toObjectUrl)(data));
}

function downloadAsJson(data, name = 'data.json') {
  (0, _browserUtils.downloadFile)((0, _browserUtils.toObjectUrl)(data), name);
}

function openDebugConsole() {
  const [, windowId] = (0, _browserUtils.getWindowName)().split(':');
  (0, _browserUtils.openInNewTab)('/fe/debug', `NobaaDebugConsole:${windowId}`);
  return windowId;
}

function toggleApiLogging(enable = !_services.api.rpc.get_request_logger()) {
  const logger = enable ? logToConsole : null;

  _services.api.rpc.set_request_logger(logger);

  return Boolean(logger);
}

function togglePreviewContent() {
  actions.togglePreviewContent();
}

function dumpAppLog() {
  actions.dumpAppLog();
}

function help() {
  for (const f of HELP) {
    console.log(`%cnb.utils.${f.function} - %c${f.description}`, 'font-weight: bold', 'color:blue');
  }
}

const cli = Object.seal({
  model: model,
  schema: _schema.default.def,
  actions: actions,
  state: undefined,
  api: _services.api,
  utils: {
    printAsJsonInNewTab,
    downloadAsJson,
    openDebugConsole,
    toggleApiLogging,
    dumpAppLog,
    togglePreviewContent,
    help
  }
});

_state.state$.subscribe(state => {
  cli.state = state;
});

var _default = cli;
exports.default = _default;

},{"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"model":936,"schema":995,"services":1013,"state":1016,"utils/browser-utils":1021,"utils/core-utils":1027}],833:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.ADD_BUCKET_TIER), (0, _operators.mergeMap)(async action => {
    const {
      bucket,
      policyType,
      resourceIds
    } = action.payload;
    const resourceNames = resourceIds.map(res => res.split(':')[1]);

    try {
      await api.tiering_policy.add_tier_to_bucket({
        bucket_name: bucket,
        tier: {
          data_placement: policyType,
          attached_pools: resourceNames
        }
      });
      return (0, _actionCreators.completeAddBucketTier)(bucket);
    } catch (error) {
      return (0, _actionCreators.failAddBucketTier)(bucket, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],834:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.ADD_BUCKET_TRIGGER), (0, _operators.mergeMap)(async action => {
    const {
      bucket,
      funcName,
      funcVersion,
      event,
      prefix,
      suffix,
      enabled
    } = action.payload;

    try {
      await api.bucket.add_bucket_lambda_trigger({
        bucket_name: bucket,
        func_name: funcName,
        func_version: funcVersion,
        event_name: event,
        object_prefix: prefix,
        object_suffix: suffix,
        enabled: enabled
      });
      return (0, _actionCreators.completeAddBucketTrigger)(bucket);
    } catch (error) {
      return (0, _actionCreators.failAddBucketTrigger)(bucket, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],835:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _getApiRequestParams(payload) {
  const {
    name,
    service,
    params
  } = payload;

  switch (service) {
    case 'AWS':
      {
        return {
          name,
          endpoint_type: service,
          endpoint: params.awsEndpoint,
          identity: params.awsAccessKey,
          secret: params.awsSecretKey,
          auth_method: 'AWS_V4'
        };
      }

    case 'S3_V2_COMPATIBLE':
      {
        return {
          name,
          endpoint_type: 'S3_COMPATIBLE',
          endpoint: params.s3v2Endpoint,
          identity: params.s3v2AccessKey,
          secret: params.s3v2SecretKey,
          auth_method: 'AWS_V2'
        };
      }

    case 'S3_V4_COMPATIBLE':
      {
        return {
          name,
          endpoint_type: 'S3_COMPATIBLE',
          endpoint: params.s3v4Endpoint,
          identity: params.s3v4AccessKey,
          secret: params.s3v4SecretKey,
          auth_method: 'AWS_V4'
        };
      }

    case 'AZURE':
      {
        return {
          name,
          endpoint_type: service,
          endpoint: params.azureEndpoint,
          identity: params.azureAccountName,
          secret: params.azureAccountKey
        };
      }

    case 'NET_STORAGE':
      {
        return {
          name,
          endpoint_type: service,
          endpoint: `${params.nsStorageGroup}-${params.nsHostname}`,
          identity: params.nsKeyName,
          secret: params.nsAuthKey,
          cp_code: params.nsCPCode
        };
      }

    case 'GOOGLE':
      {
        const {
          private_key_id
        } = JSON.parse(params.gcKeysJson);
        return {
          name,
          endpoint_type: service,
          endpoint: params.gcEndpoint,
          identity: private_key_id,
          secret: params.gcKeysJson
        };
      }

    case 'FLASHBLADE':
      {
        return {
          name,
          endpoint_type: 'FLASHBLADE',
          endpoint: params.fbEndpoint,
          identity: params.fbAccessKey,
          secret: params.fbSecretKey,
          auth_method: 'AWS_V4'
        };
      }

    case 'IBM_COS':
      {
        return {
          name,
          endpoint_type: 'IBM_COS',
          endpoint: params.ibmEndpoint,
          identity: params.ibmAccessKey,
          secret: params.ibmSecretKey,
          auth_method: 'AWS_V2'
        };
      }

    default:
      {
        throw new Error(`Invalid service: ${service}`);
      }
  }
}

function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.ADD_EXTERNAL_CONNECTION), (0, _operators.mergeMap)(async action => {
    const {
      name
    } = action.payload;

    try {
      const requestParams = _getApiRequestParams(action.payload);

      await api.account.add_external_connection(requestParams);
      return (0, _actionCreators.completeAddExternalConnection)(name);
    } catch (error) {
      return (0, _actionCreators.failAddExternalConnection)(name, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],836:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.ASSIGN_REGION_TO_RESOURCE), (0, _operators.mergeMap)(async action => {
    const {
      resourceType,
      resourceName,
      region
    } = action.payload;

    try {
      await api.pool.assign_pool_to_region({
        name: resourceName,
        region: region
      });
      return (0, _actionCreators.completeAssignRegionToResource)(resourceType, resourceName, region);
    } catch (error) {
      return (0, _actionCreators.failAssignRegionToResource)(resourceType, resourceName, region, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],837:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.ATTACH_SERVER_TO_CLUSTER), (0, _operators.mergeMap)(async action => {
    const {
      secret,
      address,
      hostname,
      location
    } = action.payload;

    try {
      await api.cluster_server.add_member_to_cluster({
        address,
        secret,
        role: 'REPLICA',
        shard: 'shard1',
        location: location,
        new_hostname: hostname
      });
      return (0, _actionCreators.completeAttachServerToCluster)(secret);
    } catch (error) {
      return (0, _actionCreators.failAttachServerToCluster)(secret, error);
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287}],838:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.CHANGE_ACCOUNT_PASSWORD), (0, _operators.mergeMap)(async action => {
    const {
      payload
    } = action;

    try {
      await api.account.reset_password({
        verification_password: payload.verificationPassword,
        email: payload.accountName,
        password: payload.password,
        must_change_password: false
      });
      return (0, _actionCreators.completeChangeAccountPassword)(payload.accountName);
    } catch (error) {
      return (0, _actionCreators.failChangeAccountPassword)(payload.accountName, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],839:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.CHANGE_LOCATION), (0, _operators.map)(() => (0, _actionCreators.closeModal)(Number.POSITIVE_INFINITY)));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287}],840:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.COLLECT_HOST_DIAGNOSTICS), (0, _operators.mergeMap)(async action => {
    const {
      host
    } = action.payload;

    try {
      const packageUri = await api.host.diagnose_host({
        name: host
      });
      return (0, _actionCreators.completeCollectHostDiagnostics)(host, packageUri);
    } catch (error) {
      return (0, _actionCreators.failCollectHostDiagnostics)(host, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],841:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.COLLECT_SYSTEM_DIAGNOSTICS), (0, _operators.mergeMap)(async () => {
    try {
      const packageUri = await api.cluster_server.diagnose_system({});
      return (0, _actionCreators.completeCollectSystemDiagnostics)(packageUri);
    } catch (error) {
      return (0, _actionCreators.failCollectSystemDiagnostics)((0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],842:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _promiseUtils = require("utils/promise-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.CREATE_ACCOUNT), (0, _operators.mergeMap)(async action => {
    const {
      accountName,
      isAdmin,
      password,
      defaultResource,
      hasAccessToAllBucekts,
      allowedBuckets,
      allowBucketCreation
    } = action.payload;

    try {
      await (0, _promiseUtils.all)(api.account.create_account({
        name: accountName.split('@')[0],
        email: accountName,
        has_login: isAdmin,
        password: isAdmin ? password : undefined,
        must_change_password: isAdmin || undefined,
        s3_access: true,
        default_pool: defaultResource,
        allowed_buckets: {
          full_permission: hasAccessToAllBucekts,
          permission_list: !hasAccessToAllBucekts ? allowedBuckets : undefined
        },
        allow_bucket_creation: allowBucketCreation
      }), (0, _promiseUtils.sleep)(750));
      return (0, _actionCreators.completeCreateAccount)(accountName, password);
    } catch (error) {
      return (0, _actionCreators.failCreateAccount)(accountName, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/promise-utils":1039,"utils/state-utils":1044}],843:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.CREATE_BUCKET), (0, _operators.mergeMap)(async action => {
    const {
      name,
      placementType,
      resourceIds
    } = action.payload;

    try {
      const bucketInfo = await api.bucket.create_bucket({
        name
      }); // TODO: Find a better indication that we are going to use internal storage

      if (resourceIds.length > 0) {
        await api.tier.update_tier({
          name: bucketInfo.tiering.tiers[0].tier,
          data_placement: placementType,
          attached_pools: resourceIds.map(res => res.split(':')[1])
        });
      }

      return (0, _actionCreators.completeCreateBucket)(name);
    } catch (error) {
      return (0, _actionCreators.failCreateBucket)(name, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],844:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.CREATE_CLOUD_RESOURCE), (0, _operators.mergeMap)(async action => {
    const {
      name,
      connection,
      target: target_bucket
    } = action.payload;

    try {
      await api.pool.create_cloud_pool({
        name,
        connection,
        target_bucket
      });
      return (0, _actionCreators.completeCreateCloudResource)(name);
    } catch (error) {
      return (0, _actionCreators.failCreateCloudResource)(name, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],845:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api,
  browser
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.CREATE_HOSTS_POOL), (0, _operators.mergeMap)(async action => {
    const {
      name,
      hostCount,
      hostVolumeSize,
      isManaged
    } = action.payload;

    try {
      const deployYAML = await api.pool.create_hosts_pool({
        name: name,
        is_managed: isManaged,
        host_count: hostCount,
        host_config: {
          volume_size: hostVolumeSize
        }
      });
      const deployYAMLUri = browser.toObjectUrl(deployYAML, 'text/yaml');
      return (0, _actionCreators.completeCreateHostsPool)(name, deployYAMLUri, !isManaged);
    } catch (error) {
      return (0, _actionCreators.failCreateHostsPool)(name, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],846:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _funcUtils = require("utils/func-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

var _buffer = require("buffer");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api,
  bufferStore
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.CREATE_LAMBDA_FUNC), (0, _operators.mergeMap)(async action => {
    const {
      name,
      version,
      description,
      runtime,
      handlerFile,
      handlerFunc,
      memorySize,
      timeout,
      codeBufferKey
    } = action.payload;

    try {
      const handler = (0, _funcUtils.getFullHandlerName)(handlerFile, handlerFunc);
      const config = {
        name,
        version,
        description,
        runtime,
        handler,
        memory_size: memorySize,
        timeout
      };

      const buffer = _buffer.Buffer.from(new Uint8Array(bufferStore.get(codeBufferKey)));

      await api.func.create_func({
        config,
        code: {},
        [api.RPC_BUFFERS]: {
          zipfile: buffer
        }
      });
      return (0, _actionCreators.completeCreateLambdaFunc)(name, version);
    } catch (error) {
      return (0, _actionCreators.failCreateLambdaFunc)(name, version, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"buffer":53,"rx-extensions":974,"rxjs/operators":287,"utils/func-utils":1031,"utils/state-utils":1044}],847:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.CREATE_NAMESPACE_BUCKET), (0, _operators.mergeMap)(async action => {
    const {
      name,
      readFrom,
      writeTo,
      caching
    } = action.payload;

    try {
      const namespace = {
        read_resources: readFrom,
        write_resource: writeTo,
        caching: caching
      };
      await api.bucket.create_bucket({
        name,
        namespace
      });
      return (0, _actionCreators.completeCreateNamespaceBucket)(name);
    } catch (error) {
      return (0, _actionCreators.failCreateNamespaceBucket)(name, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],848:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.CREATE_NAMESPACE_RESOURCE), (0, _operators.mergeMap)(async action => {
    const {
      name,
      connection,
      target: target_bucket
    } = action.payload;

    try {
      await api.pool.create_namespace_resource({
        name,
        connection,
        target_bucket
      });
      return (0, _actionCreators.completeCreateNamespaceResource)(name);
    } catch (error) {
      return (0, _actionCreators.failCreateNamespaceResource)(name, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],849:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

var _config = require("config");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.CREATE_SYSTEM), (0, _operators.mergeMap)(async action => {
    const {
      ownerEmail,
      password,
      systemName,
      dnsName //dnsServers, //Should be introduced back after Issue #2469
      //timeConfig

    } = action.payload;

    try {
      const {
        token
      } = await api.system.create_system({
        name: systemName,
        email: ownerEmail,
        password: password,
        dns_name: dnsName //dns_servers: dnsServers, //Should be introduced back after Issue #2469
        //time_config: timeConfig

      });
      return (0, _actionCreators.completeCreateSystem)(systemName, ownerEmail, token, _config.defaultTheme);
    } catch (error) {
      return (0, _actionCreators.failCreateSystem)((0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"config":831,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],850:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.DELETE_BUCKET), (0, _operators.mergeMap)(async action => {
    const {
      bucket
    } = action.payload;

    try {
      await api.bucket.delete_bucket({
        name: bucket
      });
      return (0, _actionCreators.completeDeleteBucket)(bucket);
    } catch (error) {
      return (0, _actionCreators.failDeleteBucket)(bucket, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],851:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.DELETE_EXTERNAL_CONNECTION), (0, _operators.mergeMap)(async action => {
    const {
      connection
    } = action.payload;

    try {
      await api.account.delete_external_connection({
        connection_name: connection
      });
      return (0, _actionCreators.completeDeleteExternalConnection)(connection);
    } catch (error) {
      return (0, _actionCreators.failDeleteExternalConnection)(connection, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],852:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.DELETE_LAMBDA_FUNC), (0, _operators.mergeMap)(async action => {
    const {
      name,
      version
    } = action.payload;

    try {
      await await api.func.delete_func({
        name,
        version
      });
      return (0, _actionCreators.completeDeleteLambdaFunc)(name, version);
    } catch (error) {
      return (0, _actionCreators.failDeleteLambdaFunc)(name, version, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],853:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.DELETE_NAMESPACE_BUCKET), (0, _operators.mergeMap)(async action => {
    const {
      name
    } = action.payload;

    try {
      await api.bucket.delete_bucket({
        name
      });
      return (0, _actionCreators.completeDeleteNamespaceBucket)(name);
    } catch (error) {
      return (0, _actionCreators.failDeleteNamespaceBucket)(name, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],854:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.DELETE_NAMESPACE_RESOURCE), (0, _operators.mergeMap)(async action => {
    const {
      name
    } = action.payload;

    try {
      await api.pool.delete_namespace_resource({
        name
      });
      return (0, _actionCreators.completeDeleteNamespaceResource)(name);
    } catch (error) {
      return (0, _actionCreators.failDeleteNamespaceResource)(name, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],855:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _rxjs = require("rxjs");

var _awsUtils = require("utils/aws-utils");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  AWS
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.DELETE_OBJECT), (0, _operators.mergeMap)(action => {
    const {
      objId,
      accessData
    } = action.payload;
    const {
      bucket,
      key,
      version,
      uploadId
    } = objId;
    const s3 = (0, _awsUtils.createS3Client)(AWS, accessData);
    const deleteEvent$ = new _rxjs.Subject();

    if (uploadId) {
      const params = {
        Bucket: bucket,
        Key: key,
        UploadId: uploadId
      };
      s3.abortMultipartUpload(params, error => {
        deleteEvent$.next(error ? (0, _actionCreators.failDeleteObject)(objId, (0, _stateUtils.mapErrorObject)(error)) : (0, _actionCreators.completeDeleteObject)(objId));
        deleteEvent$.complete();
      });
    } else {
      const params = {
        Bucket: bucket,
        Key: key,
        VersionId: version
      };
      s3.deleteObject(params, error => {
        deleteEvent$.next(error ? (0, _actionCreators.failDeleteObject)(objId, (0, _stateUtils.mapErrorObject)(error)) : (0, _actionCreators.completeDeleteObject)(objId));
        deleteEvent$.complete();
      });
    }

    return deleteEvent$;
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs":89,"rxjs/operators":287,"utils/aws-utils":1020,"utils/state-utils":1044}],856:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.DELETE_RESOURCE), (0, _operators.mergeMap)(async action => {
    const {
      resource
    } = action.payload;

    try {
      await api.pool.delete_pool({
        name: resource
      });
      return (0, _actionCreators.completeDeleteResource)(resource);
    } catch (error) {
      return (0, _actionCreators.failDeleteResource)(resource, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],857:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _coreUtils = require("utils/core-utils");

var _operators = require("rxjs/operators");

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
const actionToFileInfo = (0, _coreUtils.deepFreeze)({
  [_actionTypes.COMPLETE_COLLECT_HOST_DIAGNOSTICS]: payload => ({
    uri: payload.packageUri
  }),
  [_actionTypes.COMPLETE_COLLECT_SYSTEM_DIAGNOSTICS]: payload => ({
    uri: payload.packageUri
  }),
  [_actionTypes.COMPLETE_EXPORT_AUDIT_LOG]: payload => ({
    uri: payload.logUri
  }),
  [_actionTypes.COMPLETE_CREATE_HOSTS_POOL]: payload => {
    if (!payload.autoDownload) {
      return null;
    }

    return {
      uri: payload.deployYAMLUri,
      name: `${payload.name}.yaml`
    };
  },
  [_actionTypes.COMPLETE_GENERATE_ENDPOINT_GROUP_DEPLOYMENT_YAML]: payload => ({
    uri: payload.deployYAMLUri,
    name: 'deploy.yaml'
  })
});

function _default(action$, {
  browser
}) {
  return action$.pipe((0, _operators.map)(action => {
    const getFileInfo = actionToFileInfo[action.type];
    if (!getFileInfo) return;
    const fileInfo = getFileInfo(action.payload);
    if (!fileInfo) return;
    browser.downloadFile(fileInfo.uri, fileInfo.name, true);
  }));
}

},{"action-types":318,"rxjs/operators":287,"utils/core-utils":1027}],858:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.ENTER_MAINTENANCE_MODE), (0, _operators.mergeMap)(async action => {
    const {
      duration
    } = action.payload;

    try {
      await api.system.set_maintenance_mode({
        duration
      });
      return (0, _actionCreators.completeEnterMaintenanceMode)();
    } catch (error) {
      return (0, _actionCreators.failEnterMaintenanceMode)((0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],859:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.EXPORT_AUDIT_LOG), (0, _operators.mergeMap)(async action => {
    try {
      const {
        categories
      } = action.payload;
      const event = categories.length > 0 ? categories.map(category => `(^${category}.)`).join('|') : '^&';
      const logUri = await api.events.export_activity_log({
        event
      });
      return (0, _actionCreators.completeExportAuditLog)(logUri);
    } catch (error) {
      return (0, _actionCreators.failExportAuditLog)((0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],860:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

var _moment = _interopRequireDefault(require("moment"));

/* Copyright (C) 2016 NooBaa */
const durationMeta = {
  DAY: {
    unit: 'hour',
    timespan: 24
  },
  WEEK: {
    unit: 'day',
    timespan: 7
  },
  MONTH: {
    unit: 'day',
    timespan: 28
  }
};

function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.FETCH_ACCOUNT_USAGE_HISTORY), (0, _operators.mergeMap)(async action => {
    const query = action.payload;
    const {
      unit,
      timespan
    } = durationMeta[query.duration];
    const till = (0, _moment.default)().endOf(unit).valueOf();
    const since = (0, _moment.default)(till + 1).subtract(timespan, unit).valueOf();

    try {
      const usageHistory = await api.account.get_account_usage({
        endpoint_groups: query.endpointGroups,
        since,
        till
      });
      return (0, _actionCreators.completeFetchAccountUsageHistory)(query, usageHistory);
    } catch (error) {
      return (0, _actionCreators.failFetchAccountUsageHistory)(query, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"action-types":318,"moment":"moment","rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],861:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.FETCH_ALERTS), (0, _operators.mergeMap)(async action => {
    const {
      query,
      limit
    } = action.payload;

    try {
      const list = await api.events.read_alerts({
        query,
        limit
      });
      return (0, _actionCreators.completeFetchAlerts)(limit, list);
    } catch (error) {
      return (0, _actionCreators.failFetchAlerts)((0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],862:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

var _promiseUtils = require("utils/promise-utils");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.FETCH_AUDIT_LOG), (0, _operators.mergeMap)(async action => {
    await (0, _promiseUtils.sleep)(1000);
    const {
      query,
      limit,
      till
    } = action.payload;

    try {
      const {
        categories
      } = query;
      const event = categories.length > 0 ? categories.map(category => `(^${category}.)`).join('|') : '^&';
      const {
        logs: list
      } = await api.events.read_activity_log({
        event,
        limit,
        till
      });
      return (0, _actionCreators.completeFetchAuditLog)(limit, list);
    } catch (error) {
      return (0, _actionCreators.failFetchAuditLog)((0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/promise-utils":1039,"utils/state-utils":1044}],863:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

var _moment = _interopRequireDefault(require("moment"));

/* Copyright (C) 2016 NooBaa */
const durationMeta = {
  DAY: {
    unit: 'hour',
    timespan: 24,
    resolution: 1
  },
  WEEK: {
    unit: 'day',
    timespan: 7,
    resolution: 1 / 4
  },
  MONTH: {
    unit: 'day',
    timespan: 28,
    resolution: 1
  }
};

function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.FETCH_BUCKET_USAGE_HISTORY), (0, _operators.mergeMap)(async action => {
    const query = action.payload;
    const {
      unit,
      timespan,
      resolution
    } = durationMeta[query.duration];

    const resolutionInHours = _moment.default.duration(resolution, unit).asHours();

    const till = (0, _moment.default)().endOf(unit).valueOf(); // Adding the reslution to the timesamp in oreder to fetch a base
    // sample to be used in the charts

    const since = (0, _moment.default)(till + 1).subtract(timespan + resolution, unit).valueOf();

    try {
      const usageHistory = await api.bucket.get_bucket_throughput_usage({
        buckets: query.buckets,
        since,
        till,
        resolution: resolutionInHours
      });
      return (0, _actionCreators.completeFetchBucketUsageHistory)(query, usageHistory);
    } catch (error) {
      return (0, _actionCreators.failFetchBucketUsageHistory)(query, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"action-types":318,"moment":"moment","rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],864:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.FETCH_CLOUD_RESOURCE_OBJECTS), (0, _operators.mergeMap)(async action => {
    const {
      resource,
      skip,
      limit
    } = action.payload;

    try {
      const {
        nodes: [node]
      } = await api.node.list_nodes({
        query: {
          pools: [resource]
        }
      });
      const response = await api.object.read_node_mapping({
        name: node.name,
        skip: skip,
        limit: limit,
        adminfo: true
      });
      return (0, _actionCreators.completeFetchCloudResourceObjects)(resource, skip, limit, response);
    } catch (error) {
      return (0, _actionCreators.failFetchCloudResourceObjects)(resource, skip, limit, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],865:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.FETCH_CLOUD_TARGETS), (0, _operators.mergeMap)(async action => {
    const {
      connection
    } = action.payload;

    try {
      const response = await api.bucket.get_cloud_buckets({
        connection
      });
      return (0, _actionCreators.completeFetchCloudTargets)(connection, response);
    } catch (error) {
      return (0, _actionCreators.failFetchCloudTargets)(connection, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],866:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

var _moment = _interopRequireDefault(require("moment"));

/* Copyright (C) 2016 NooBaa */
const durationMeta = {
  DAY: {
    unit: 'hour',
    timespan: 24
  },
  WEEK: {
    unit: 'day',
    timespan: 7
  },
  MONTH: {
    unit: 'day',
    timespan: 28
  }
};

function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.FETCH_CLOUD_USAGE_STATS), (0, _operators.mergeMap)(async action => {
    const query = action.payload;
    const {
      unit,
      timespan
    } = durationMeta[query.duration];
    const till = (0, _moment.default)().endOf(unit).valueOf();
    const since = (0, _moment.default)(till + 1).subtract(timespan, unit).valueOf();

    try {
      const usage = await api.pool.get_cloud_services_stats({
        start_date: since,
        end_date: till
      });
      return (0, _actionCreators.completeFetchCloudUsageStats)(query, usage);
    } catch (error) {
      return (0, _actionCreators.failFetchCloudUsageStats)(query, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"action-types":318,"moment":"moment","rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],867:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _coreUtils = require("utils/core-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

var _moment = _interopRequireDefault(require("moment"));

/* Copyright (C) 2016 NooBaa */
const timespanMapping = (0, _coreUtils.deepFreeze)({
  '24_HOURS': {
    unit: 'hour',
    span: 24,
    step: 1
  },
  '7_DAYS': {
    unit: 'day',
    span: 7,
    step: 24
  },
  '4_WEEKS': {
    unit: 'day',
    span: 28,
    step: 7 * 24
  }
});

function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.FETCH_ENDPOINTS_HISTORY), (0, _operators.mergeMap)(async action => {
    const query = action.payload;
    const {
      groups,
      timespan
    } = query;
    const {
      unit,
      span,
      step
    } = timespanMapping[timespan];
    const till = (0, _moment.default)().endOf(unit).valueOf();
    const since = (0, _moment.default)(till + 1).subtract(span, unit).valueOf();

    try {
      const history = await api.system.get_endpoints_history({
        groups,
        since,
        till,
        step
      });
      return (0, _actionCreators.completeFetchEndpointsHistory)(query, history);
    } catch (error) {
      return (0, _actionCreators.failFetchEndpointsHistory)(query, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"action-types":318,"moment":"moment","rx-extensions":974,"rxjs/operators":287,"utils/core-utils":1027,"utils/state-utils":1044}],868:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.FETCH_HOST_OBJECTS), (0, _operators.mergeMap)(async action => {
    const {
      host,
      skip,
      limit
    } = action.payload;

    try {
      const response = await api.object.read_node_mapping({
        name: host,
        by_host: true,
        skip: skip,
        limit: limit,
        adminfo: true
      });
      return (0, _actionCreators.completeFetchHostObjects)(host, skip, limit, response);
    } catch (error) {
      return (0, _actionCreators.failFetchHostObjects)(host, skip, limit, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],869:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.FETCH_HOSTS), (0, _operators.mergeMap)(async action => {
    const {
      query,
      statistics
    } = action.payload;
    const {
      hosts,
      pools,
      name,
      modes,
      sortBy,
      order,
      skip,
      limit,
      recommendedHint
    } = query;

    try {
      return (0, _actionCreators.completeFetchHosts)(query, (await api.host.list_hosts({
        query: {
          pools: pools,
          filter: name,
          mode: modes,
          hosts: hosts
        },
        sort: sortBy,
        order: order,
        recommended_hint: recommendedHint,
        skip: skip,
        limit: limit,
        adminfo: statistics
      })));
    } catch (error) {
      return (0, _actionCreators.failFetchHosts)(query, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],870:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api,
  getTime
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.FETCH_LAMBDA_FUNC_USAGE_HISTORY), (0, _operators.mergeMap)(async action => {
    const query = action.payload;

    try {
      const usageHistory = await api.func.read_func_stats({
        name: query.name,
        version: query.version,
        since: getTime() - query.timespan,
        step: query.step
      });
      return (0, _actionCreators.completeFetchLambdaFuncUsageHistory)(query, usageHistory);
    } catch (error) {
      return (0, _actionCreators.failFetchLambdaFuncUsageHistory)(query, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],871:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.FETCH_NODE_INSTALLATION_COMMANDS), (0, _operators.mergeMap)(async action => {
    const {
      targetPool,
      excludedDrives
    } = action.payload;

    try {
      const commands = await api.system.get_node_installation_string({
        pool: targetPool,
        exclude_drives: excludedDrives
      });
      return (0, _actionCreators.completeFetchNodeInstallationCommands)(targetPool, excludedDrives, commands);
    } catch (error) {
      return (0, _actionCreators.failFetchNodeInstallationCommands)((0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],872:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.FETCH_OBJECT_PARTS), (0, _operators.mergeMap)(async action => {
    const query = action.payload;

    try {
      const {
        chunks
      } = await api.object.read_object_mapping_admin({
        bucket: query.bucket,
        key: query.key,
        version_id: query.version,
        skip: query.skip,
        limit: query.limit
      });
      return (0, _actionCreators.completeFetchObjectParts)(query, chunks);
    } catch (error) {
      return (0, _actionCreators.failFetchObjectParts)(query, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],873:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stringUtils = require("utils/string-utils");

var _stateUtils = require("utils/state-utils");

var _promiseUtils = require("utils/promise-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const MAX_VERSION_COUNT = 100;

function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.FETCH_OBJECT), (0, _operators.mergeMap)(async action => {
    const {
      bucket,
      object,
      version,
      s3Endpoint
    } = action.payload;

    try {
      const [versions, curr] = await (0, _promiseUtils.all)( // fetch object versions info.
      api.object.list_objects_admin({
        bucket: bucket,
        key_regexp: `^${(0, _stringUtils.escapeRegExp)(object)}$`,
        skip: 0,
        limit: MAX_VERSION_COUNT,
        adminfo: {
          signed_url_endpoint: s3Endpoint
        }
      }), // Fetch the full object info for the requested version.
      api.object.read_object_md({
        bucket: bucket,
        key: object,
        version_id: version,
        adminfo: {
          signed_url_endpoint: s3Endpoint
        }
      })); // Override the current version with the full version info.

      const index = versions.objects.findIndex(ver => ver.obj_id === curr.obj_id);
      versions.objects[index] = curr;
      return (0, _actionCreators.completeFetchObject)(bucket, object, version, versions);
    } catch (error) {
      return (0, _actionCreators.failFetchObject)(bucket, object, version, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/promise-utils":1039,"utils/state-utils":1044,"utils/string-utils":1046}],874:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.FETCH_OBJECTS_DISTRIBUTION), (0, _operators.mergeMap)(async () => {
    try {
      const distribution = await api.bucket.get_objects_size_histogram();
      return (0, _actionCreators.completeFetchObjectsDistribution)(distribution);
    } catch (error) {
      return (0, _actionCreators.failFetchObjectsDistribution)((0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],875:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.FETCH_OBJECTS), (0, _operators.mergeMap)(async action => {
    const {
      query,
      s3Endpoint
    } = action.payload;

    try {
      const {
        bucket,
        filter,
        sortBy,
        order,
        skip,
        limit,
        stateFilter,
        versions
      } = query;
      let uploadMode;
      if (stateFilter !== 'ALL') uploadMode = false;
      if (stateFilter === 'UPLOADING') uploadMode = true;
      const response = await api.object.list_objects_admin({
        bucket,
        key_query: filter,
        sort: sortBy,
        order,
        skip,
        limit,
        pagination: true,
        upload_mode: uploadMode,
        latest_versions: versions ? undefined : true,
        filter_delete_markers: versions ? undefined : true,
        adminfo: {
          signed_url_endpoint: s3Endpoint
        }
      });
      return (0, _actionCreators.completeFetchObjects)(query, response);
    } catch (error) {
      return (0, _actionCreators.failFetchObjects)(query, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],876:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.FETCH_SYSTEM_INFO), (0, _operators.switchMap)(async () => {
    try {
      const info = await api.system.read_system();
      return (0, _actionCreators.completeFetchSystemInfo)(info);
    } catch (error) {
      return (0, _actionCreators.failFetchSystemInfo)((0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],877:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.FETCH_SYSTEM_STORAGE_HISTORY), (0, _operators.switchMap)(async () => {
    try {
      const history = await api.pool.get_pool_history({});
      return (0, _actionCreators.completeFetchSystemStorageHistory)(history);
    } catch (error) {
      return (0, _actionCreators.failFetchSystemStorageHistory)((0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],878:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.FETCH_UNREAD_ALERTS_COUNT), (0, _operators.mergeMap)(async () => {
    try {
      const {
        CRIT,
        MAJOR,
        INFO
      } = await api.events.get_unread_alerts_count();
      return (0, _actionCreators.completeFetchUnreadAlertsCount)(CRIT, MAJOR, INFO);
    } catch (error) {
      return (0, _actionCreators.failFetchUnreadAlertsCount)((0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],879:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _config = require("config");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  fetch
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.FETCH_VERSION_RELEASE_NOTES), (0, _operators.switchMap)(async action => {
    const {
      baseUrl,
      suffix
    } = _config.releaseNotes;
    const {
      version
    } = action.payload;
    const [versionWithNoBuildNumber] = version.split('-');
    const url = `${baseUrl}/${versionWithNoBuildNumber}.${suffix}`;
    const alpha_url = `${baseUrl}/${versionWithNoBuildNumber}-alpha.${suffix}`;

    try {
      let res1 = await fetch(url);

      if (!res1.ok) {
        const res2 = await fetch(alpha_url);
        if (!res2.ok) throw new Error(`Got HTTP: ${res1.status}`);
        res1 = res2;
      }

      const notes = await res1.text();
      return (0, _actionCreators.completeFetchVersionReleaseNotes)(version, notes);
    } catch (error) {
      return (0, _actionCreators.failFetchVersionReleaseNotes)(version, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"config":831,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],880:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api,
  browser
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.GENERATE_ENDPOINT_GROUP_DEPLOYMENT_YAML), (0, _operators.mergeMap)(async action => {
    const {
      region,
      endpointConf
    } = action.payload;

    try {
      const yaml = await api.system.get_join_cluster_yaml({
        region,
        endpoints: {
          min_count: endpointConf.minCount,
          max_count: endpointConf.maxCount
        }
      });
      const yamlUri = browser.toObjectUrl(yaml, 'text/yaml');
      return (0, _actionCreators.completeGenerateEndpointGroupDeploymentYAML)(yamlUri);
    } catch (error) {
      return (0, _actionCreators.failGenerateEndpointGroupDeploymentYAML)((0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],881:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _actionTypes = require("action-types");

var routes = _interopRequireWildcard(require("routes"));

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  browser,
  router
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.REQUEST_LOCATION), (0, _operators.map)(action => {
    const {
      url,
      redirect
    } = action.payload;

    if (url.startsWith(routes.root)) {
      if (redirect) {
        router.redirect(url);
      } else {
        router.show(url);
      }
    } else {
      browser.navigateTo(url);
    }
  }));
}

},{"@babel/runtime/helpers/interopRequireWildcard":1051,"action-types":318,"routes":972,"rx-extensions":974,"rxjs/operators":287}],882:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _rxjs = require("rxjs");

var _operators = require("rxjs/operators");

var _notify = _interopRequireDefault(require("./notify"));

var _createSystem = _interopRequireDefault(require("./create-system"));

var _restoreSession = _interopRequireDefault(require("./restore-session"));

var _handleLocationRequests = _interopRequireDefault(require("./handle-location-requests"));

var _signIn = _interopRequireDefault(require("./sign-in"));

var _fetchSystemInfo = _interopRequireDefault(require("./fetch-system-info"));

var _createAccount = _interopRequireDefault(require("./create-account"));

var _refresh = _interopRequireDefault(require("./refresh"));

var _reactToCreateAccountResult = _interopRequireDefault(require("./react-to-create-account-result"));

var _reactToResetAccountPasswordResult = _interopRequireDefault(require("./react-to-reset-account-password-result"));

var _updateAccountS3Access = _interopRequireDefault(require("./update-account-s3-access"));

var _fetchAuditLog = _interopRequireDefault(require("./fetch-audit-log"));

var _exportAuditLog = _interopRequireDefault(require("./export-audit-log"));

var _updateAlerts = _interopRequireDefault(require("./update-alerts"));

var _fetchUnreadAlertsCount = _interopRequireDefault(require("./fetch-unread-alerts-count"));

var _fetchAlerts = _interopRequireDefault(require("./fetch-alerts"));

var _fetchNodeInstallationCommands = _interopRequireDefault(require("./fetch-node-installation-commands"));

var _uploadObjects = _interopRequireDefault(require("./upload-objects"));

var _setAccountIpRestrictions = _interopRequireDefault(require("./set-account-ip-restrictions"));

var _updateInstallNodesFormCommandsField = _interopRequireDefault(require("./update-install-nodes-form-commands-field"));

var _changeAccountPassword = _interopRequireDefault(require("./change-account-password"));

var _resetAccountPassword = _interopRequireDefault(require("./reset-account-password"));

var _regenerateAccountCredentials = _interopRequireDefault(require("./regenerate-account-credentials"));

var _addExternalConnection = _interopRequireDefault(require("./add-external-connection"));

var _updateExternalConnection = _interopRequireDefault(require("./update-external-connection"));

var _deleteExternalConnection = _interopRequireDefault(require("./delete-external-connection"));

var _deleteResource = _interopRequireDefault(require("./delete-resource"));

var _createHostsPool = _interopRequireDefault(require("./create-hosts-pool"));

var _scaleHostsPool = _interopRequireDefault(require("./scale-hosts-pool"));

var _fetchHosts = _interopRequireDefault(require("./fetch-hosts"));

var _collectHostDiagnostics = _interopRequireDefault(require("./collect-host-diagnostics"));

var _setHostDebugMode = _interopRequireDefault(require("./set-host-debug-mode"));

var _downloadFile = _interopRequireDefault(require("./download-file"));

var _fetchHostObjects = _interopRequireDefault(require("./fetch-host-objects"));

var _tryDeleteAccount = _interopRequireDefault(require("./try-delete-account"));

var _signOutDeletedUser = _interopRequireDefault(require("./sign-out-deleted-user"));

var _createBucket = _interopRequireDefault(require("./create-bucket"));

var _updateBucketQuotaPolicy = _interopRequireDefault(require("./update-bucket-quota-policy"));

var _updateBucketResiliencyPolicy = _interopRequireDefault(require("./update-bucket-resiliency-policy"));

var _updateBucketVersioningPolicy = _interopRequireDefault(require("./update-bucket-versioning-policy"));

var _addBucketTier = _interopRequireDefault(require("./add-bucket-tier"));

var _deleteBucket = _interopRequireDefault(require("./delete-bucket"));

var _updateTierPlacementPolicy = _interopRequireDefault(require("./update-tier-placement-policy"));

var _fetchCloudTargets = _interopRequireDefault(require("./fetch-cloud-targets"));

var _createNamespaceResource = _interopRequireDefault(require("./create-namespace-resource"));

var _deleteNamespaceResource = _interopRequireDefault(require("./delete-namespace-resource"));

var _createNamespaceBucket = _interopRequireDefault(require("./create-namespace-bucket"));

var _updateNamespaceBucketPlacement = _interopRequireDefault(require("./update-namespace-bucket-placement"));

var _deleteNamespaceBucket = _interopRequireDefault(require("./delete-namespace-bucket"));

var _retrustHost = _interopRequireDefault(require("./retrust-host"));

var _fetchObjects = _interopRequireDefault(require("./fetch-objects"));

var _fetchObject = _interopRequireDefault(require("./fetch-object"));

var _deleteObject = _interopRequireDefault(require("./delete-object"));

var _fetchObjectParts = _interopRequireDefault(require("./fetch-object-parts"));

var _fetchSystemStorageHistory = _interopRequireDefault(require("./fetch-system-storage-history"));

var _fetchVersionReleaseNotes = _interopRequireDefault(require("./fetch-version-release-notes"));

var _updateServerAddress = _interopRequireDefault(require("./update-server-address"));

var _updateBucketS3Access = _interopRequireDefault(require("./update-bucket-s3-access"));

var _addBucketTrigger = _interopRequireDefault(require("./add-bucket-trigger"));

var _updateBucketTrigger = _interopRequireDefault(require("./update-bucket-trigger"));

var _removeBucketTrigger = _interopRequireDefault(require("./remove-bucket-trigger"));

var _closeModalsOnLocationChange = _interopRequireDefault(require("./close-modals-on-location-change"));

var _attachServerToCluster = _interopRequireDefault(require("./attach-server-to-cluster"));

var _createCloudResource = _interopRequireDefault(require("./create-cloud-resource"));

var _createLambdaFunc = _interopRequireDefault(require("./create-lambda-func"));

var _updateLambdaFuncConfig = _interopRequireDefault(require("./update-lambda-func-config"));

var _updateLambdaFuncCode = _interopRequireDefault(require("./update-lambda-func-code"));

var _deleteLambdaFunc = _interopRequireDefault(require("./delete-lambda-func"));

var _loadLambdaFuncCode = _interopRequireDefault(require("./load-lambda-func-code"));

var _invokeLambdaFunc = _interopRequireDefault(require("./invoke-lambda-func"));

var _enterMaintenanceMode = _interopRequireDefault(require("./enter-maintenance-mode"));

var _leaveMaintenanceMode = _interopRequireDefault(require("./leave-maintenance-mode"));

var _fetchCloudResourceObjects = _interopRequireDefault(require("./fetch-cloud-resource-objects"));

var _assignRegionToResource = _interopRequireDefault(require("./assign-region-to-resource"));

var _fetchBucketUsageHistory = _interopRequireDefault(require("./fetch-bucket-usage-history"));

var _fetchAccountUsageHistory = _interopRequireDefault(require("./fetch-account-usage-history"));

var _fetchLambdaFuncUsageHistory = _interopRequireDefault(require("./fetch-lambda-func-usage-history"));

var _fetchObjectsDistribution = _interopRequireDefault(require("./fetch-objects-distribution"));

var _fetchCloudUsageStats = _interopRequireDefault(require("./fetch-cloud-usage-stats"));

var _updateP2pSettings = _interopRequireDefault(require("./update-p2p-settings"));

var _resendActivationCode = _interopRequireDefault(require("./resend-activation-code"));

var _setSystemDebugMode = _interopRequireDefault(require("./set-system-debug-mode"));

var _collectSystemDiagnostics = _interopRequireDefault(require("./collect-system-diagnostics"));

var _scheduleDebugModeRefresh = _interopRequireDefault(require("./schedule-debug-mode-refresh"));

var _scheduleMaintenanceModeRefresh = _interopRequireDefault(require("./schedule-maintenance-mode-refresh"));

var _scheduleAutoRefresh = _interopRequireDefault(require("./schedule-auto-refresh"));

var _updateAccountPreferedTheme = _interopRequireDefault(require("./update-account-prefered-theme"));

var _updateServerDetails = _interopRequireDefault(require("./update-server-details"));

var _redirectAfterSignOut = _interopRequireDefault(require("./redirect-after-sign-out"));

var _uploadSslCertificate = _interopRequireDefault(require("./upload-ssl-certificate"));

var _generateEndpointGroupDeploymentYaml = _interopRequireDefault(require("./generate-endpoint-group-deployment-yaml"));

var _updateEndpointGroup = _interopRequireDefault(require("./update-endpoint-group"));

var _fetchEndpointsHistory = _interopRequireDefault(require("./fetch-endpoints-history"));

/* Copyright (C) 2016 NooBaa */
const epics = [// General epics
_handleLocationRequests.default, _notify.default, _downloadFile.default, _fetchCloudTargets.default, _closeModalsOnLocationChange.default, _scheduleAutoRefresh.default, // Session related epics
_restoreSession.default, _signIn.default, _redirectAfterSignOut.default, // System related epics
_createSystem.default, _fetchSystemInfo.default, _refresh.default, _fetchNodeInstallationCommands.default, _updateInstallNodesFormCommandsField.default, _fetchSystemStorageHistory.default, _fetchVersionReleaseNotes.default, _enterMaintenanceMode.default, _leaveMaintenanceMode.default, _updateP2pSettings.default, _resendActivationCode.default, _setSystemDebugMode.default, _collectSystemDiagnostics.default, _scheduleDebugModeRefresh.default, _scheduleMaintenanceModeRefresh.default, _uploadSslCertificate.default, // Topology related epics
_updateServerAddress.default, _attachServerToCluster.default, _updateServerDetails.default, // Alerts related epics
_fetchAlerts.default, _updateAlerts.default, _fetchUnreadAlertsCount.default, // Audit log related epics
_fetchAuditLog.default, _exportAuditLog.default, // Account related epics
_createAccount.default, _reactToCreateAccountResult.default, _reactToResetAccountPasswordResult.default, _updateAccountS3Access.default, _setAccountIpRestrictions.default, _changeAccountPassword.default, _resetAccountPassword.default, _regenerateAccountCredentials.default, _addExternalConnection.default, _updateExternalConnection.default, _tryDeleteAccount.default, _signOutDeletedUser.default, _deleteExternalConnection.default, _updateAccountPreferedTheme.default, // Bucket related epics
_createBucket.default, _updateBucketQuotaPolicy.default, _updateBucketResiliencyPolicy.default, _updateBucketVersioningPolicy.default, _addBucketTier.default, _deleteBucket.default, _updateTierPlacementPolicy.default, _createNamespaceBucket.default, _updateNamespaceBucketPlacement.default, _deleteNamespaceBucket.default, _updateBucketS3Access.default, _addBucketTrigger.default, _updateBucketTrigger.default, _removeBucketTrigger.default, // Object related epics
_uploadObjects.default, _fetchObjects.default, _fetchObject.default, _deleteObject.default, _fetchObjectParts.default, // Resource related epics
_createHostsPool.default, _scaleHostsPool.default, _deleteResource.default, _createCloudResource.default, _fetchCloudResourceObjects.default, _assignRegionToResource.default, // Host related epics
_fetchHosts.default, _fetchHostObjects.default, _collectHostDiagnostics.default, _setHostDebugMode.default, _retrustHost.default, // Namespace related epics
_createNamespaceResource.default, _deleteNamespaceResource.default, // Lambda related epics
_createLambdaFunc.default, _deleteLambdaFunc.default, _updateLambdaFuncConfig.default, _updateLambdaFuncCode.default, _loadLambdaFuncCode.default, _invokeLambdaFunc.default, // Endpoint related epics
_generateEndpointGroupDeploymentYaml.default, _updateEndpointGroup.default, _fetchEndpointsHistory.default, // Analytics related epics
_fetchBucketUsageHistory.default, _fetchAccountUsageHistory.default, _fetchLambdaFuncUsageHistory.default, _fetchObjectsDistribution.default, _fetchCloudUsageStats.default]; /// Create the root epic by merging all epics into one.

function _default(action$, injected) {
  return (0, _rxjs.from)(epics).pipe((0, _operators.mergeMap)(epic => epic(action$, injected)));
}

},{"./add-bucket-tier":833,"./add-bucket-trigger":834,"./add-external-connection":835,"./assign-region-to-resource":836,"./attach-server-to-cluster":837,"./change-account-password":838,"./close-modals-on-location-change":839,"./collect-host-diagnostics":840,"./collect-system-diagnostics":841,"./create-account":842,"./create-bucket":843,"./create-cloud-resource":844,"./create-hosts-pool":845,"./create-lambda-func":846,"./create-namespace-bucket":847,"./create-namespace-resource":848,"./create-system":849,"./delete-bucket":850,"./delete-external-connection":851,"./delete-lambda-func":852,"./delete-namespace-bucket":853,"./delete-namespace-resource":854,"./delete-object":855,"./delete-resource":856,"./download-file":857,"./enter-maintenance-mode":858,"./export-audit-log":859,"./fetch-account-usage-history":860,"./fetch-alerts":861,"./fetch-audit-log":862,"./fetch-bucket-usage-history":863,"./fetch-cloud-resource-objects":864,"./fetch-cloud-targets":865,"./fetch-cloud-usage-stats":866,"./fetch-endpoints-history":867,"./fetch-host-objects":868,"./fetch-hosts":869,"./fetch-lambda-func-usage-history":870,"./fetch-node-installation-commands":871,"./fetch-object":873,"./fetch-object-parts":872,"./fetch-objects":875,"./fetch-objects-distribution":874,"./fetch-system-info":876,"./fetch-system-storage-history":877,"./fetch-unread-alerts-count":878,"./fetch-version-release-notes":879,"./generate-endpoint-group-deployment-yaml":880,"./handle-location-requests":881,"./invoke-lambda-func":883,"./leave-maintenance-mode":884,"./load-lambda-func-code":885,"./notify":886,"./react-to-create-account-result":887,"./react-to-reset-account-password-result":888,"./redirect-after-sign-out":889,"./refresh":890,"./regenerate-account-credentials":891,"./remove-bucket-trigger":892,"./resend-activation-code":893,"./reset-account-password":894,"./restore-session":895,"./retrust-host":896,"./scale-hosts-pool":897,"./schedule-auto-refresh":898,"./schedule-debug-mode-refresh":899,"./schedule-maintenance-mode-refresh":900,"./set-account-ip-restrictions":901,"./set-host-debug-mode":902,"./set-system-debug-mode":903,"./sign-in":904,"./sign-out-deleted-user":905,"./try-delete-account":906,"./update-account-prefered-theme":907,"./update-account-s3-access":908,"./update-alerts":909,"./update-bucket-quota-policy":910,"./update-bucket-resiliency-policy":911,"./update-bucket-s3-access":912,"./update-bucket-trigger":913,"./update-bucket-versioning-policy":914,"./update-endpoint-group":915,"./update-external-connection":916,"./update-install-nodes-form-commands-field":917,"./update-lambda-func-code":918,"./update-lambda-func-config":919,"./update-namespace-bucket-placement":920,"./update-p2p-settings":921,"./update-server-address":922,"./update-server-details":923,"./update-tier-placement-policy":924,"./upload-objects":925,"./upload-ssl-certificate":926,"@babel/runtime/helpers/interopRequireDefault":1050,"rxjs":89,"rxjs/operators":287}],883:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.INVOKE_LAMBDA_FUNC), (0, _operators.mergeMap)(async action => {
    const {
      name,
      version,
      event
    } = action.payload;

    try {
      const {
        result,
        error
      } = await api.func.invoke_func({
        name,
        version,
        event
      });
      return (0, _actionCreators.completeInvokeLambdaFunc)(name, version, error, result);
    } catch (error) {
      return (0, _actionCreators.failInvokeLambdaFunc)(name, version, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],884:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.LEAVE_MAINTENANCE_MODE), (0, _operators.mergeMap)(async () => {
    try {
      await api.system.set_maintenance_mode({
        duration: 0
      });
      return (0, _actionCreators.completeLeaveMaintenanceMode)();
    } catch (error) {
      return (0, _actionCreators.failLeaveMaintenanceMode)((0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],885:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api,
  bufferStore
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.LOAD_LAMBDA_FUNC_CODE), (0, _operators.switchMap)(async action => {
    const {
      name,
      version
    } = action.payload;

    try {
      const reply = await api.func.read_func({
        name,
        version,
        read_code: true
      });
      const {
        code_sha256: codeHash
      } = reply.config;
      const {
        zipfile
      } = reply[api.RPC_BUFFERS];
      return {
        name,
        version,
        codeHash,
        zipfile
      };
    } catch (e) {
      const error = (0, _stateUtils.mapErrorObject)(e);
      return {
        name,
        version,
        error
      };
    }
  }), // Sepreating the following code into a secondary map operation allows us to store
  // the code buffer in the buffer store only for oprations that were no debounced
  // by the switch map operator.
  (0, _operators.map)(res => {
    const {
      name,
      version,
      codeHash,
      zipfile,
      error
    } = res;

    if (!error) {
      const bufferHandle = bufferStore.store(zipfile.buffer);
      return (0, _actionCreators.completeLoadLambdaFuncCode)(name, version, codeHash, bufferHandle);
    } else {
      return (0, _actionCreators.failLoadLambdaFuncCode)(name, version, error);
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],886:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _coreUtils = require("utils/core-utils");

var _hostUtils = require("utils/host-utils");

var _clusterUtils = require("utils/cluster-utils");

var _sizeUtils = require("utils/size-utils");

var _actionCreators = require("action-creators");

var _rxjs = require("rxjs");

var _operators = require("rxjs/operators");

var types = _interopRequireWildcard(require("action-types"));

/* Copyright (C) 2016 NooBaa */
// Used to decide if we should show a notifcation indicating that
// a package upload will take some time.
const largeUploadSizeThreshold = 10 * _sizeUtils.unitsInBytes.MEGABYTE;
const actionToNotification = (0, _coreUtils.deepFreeze)({
  [types.FAIL_CREATE_ACCOUNT]: ({
    accountName
  }) => ({
    message: `Creating account ${accountName} failed`,
    severity: 'error'
  }),
  [types.COMPLETE_UPDATE_ACCOUNT_S3_ACCESS]: ({
    accountName
  }) => ({
    message: `${accountName} S3 access updated successfully`,
    severity: 'success'
  }),
  [types.FAIL_UPDATE_ACCOUNT_S3_ACCESS]: ({
    accountName
  }) => ({
    message: `Updating ${accountName} S3 access failed`,
    severity: 'error'
  }),
  [types.COMPLETE_SET_ACCOUNT_IP_RESTRICTIONS]: ({
    accountName
  }) => ({
    message: `IP restrictions for ${accountName} set successfully`,
    severity: 'success'
  }),
  [types.FAIL_SET_ACCOUNT_IP_RESTRICTIONS]: ({
    accountName
  }) => ({
    message: `Setting IP restrictions for ${accountName} failed`,
    severity: 'error'
  }),
  [types.COMPLETE_CHANGE_ACCOUNT_PASSWORD]: ({
    accountName
  }) => ({
    message: `${accountName} password changed successfully`,
    severity: 'success'
  }),
  [types.FAIL_CHANGE_ACCOUNT_PASSWORD]: ({
    accountName
  }) => ({
    message: `Changing ${accountName} password failed`,
    severity: 'error'
  }),
  [types.COMPLETE_REGENERATE_ACCOUNT_CREDENTIALS]: ({
    accountName
  }) => ({
    message: `${accountName} credentials regenerated successfully`,
    severity: 'success'
  }),
  [types.FAIL_REGENERATE_ACCOUNT_CREDENTIALS]: ({
    accountName
  }) => ({
    message: `Regenerating ${accountName} credentials failed`,
    severity: 'error'
  }),
  [types.COMPLETE_ADD_EXTERNAL_CONNECTION]: ({
    connection
  }) => ({
    message: `Adding ${connection} completed successfully`,
    severity: 'success'
  }),
  [types.FAIL_ADD_EXTERNAL_CONNECTION]: ({
    connection
  }) => ({
    message: `Adding ${connection} failed`,
    severity: 'error'
  }),
  [types.COMPLETE_UPDATE_EXTERNAL_CONNECTION]: ({
    connection
  }) => ({
    message: `Updating ${connection} completed successfully`,
    severity: 'success'
  }),
  [types.FAIL_UPDATE_EXTERNAL_CONNECTION]: ({
    connection
  }) => ({
    message: `Updating ${connection} failed`,
    severity: 'error'
  }),
  [types.COMPLETE_DELETE_RESOURCE]: ({
    resource
  }) => ({
    message: `Resource ${resource} deleted successfully`,
    severity: 'success'
  }),
  [types.FAIL_DELETE_RESOURCE]: ({
    resource
  }) => ({
    message: `Resource ${resource} deletion failed`,
    severity: 'error'
  }),
  [types.COLLECT_HOST_DIAGNOSTICS]: ({
    host
  }) => ({
    message: `Collecting diagnostic for ${(0, _hostUtils.getHostDisplayName)(host)}, it may take a few seconds`,
    severity: 'success'
  }),
  [types.FAIL_COLLECT_HOST_DIAGNOSTICS]: ({
    host
  }) => ({
    message: `Collecting diagnostic file for ${(0, _hostUtils.getHostDisplayName)(host)} failed`,
    severity: 'error'
  }),
  [types.COMPLETE_SET_HOST_DEBUG_MODE]: ({
    host,
    on
  }) => ({
    message: `Debug mode was turned ${on ? 'on' : 'off'} for node ${(0, _hostUtils.getHostDisplayName)(host)}`,
    severity: 'success'
  }),
  [types.FAIL_SET_HOST_DEBUG_MODE]: ({
    host,
    on
  }) => ({
    message: `Could not turn ${on ? 'on' : 'off'} debug mode for node ${(0, _hostUtils.getHostDisplayName)(host)}`,
    severity: 'error'
  }),
  [types.COMPLETE_CREATE_HOSTS_POOL]: ({
    name
  }) => ({
    message: `Pool ${name} created successfully`,
    severity: 'success'
  }),
  [types.FAIL_CREATE_HOSTS_POOL]: ({
    name
  }) => ({
    message: `Pool ${name} creation failed`,
    severity: 'error'
  }),
  [types.COMPLETE_SCALE_HOSTS_POOL]: ({
    poolName
  }) => ({
    message: `Pool ${poolName} updated successfully`,
    severity: 'success'
  }),
  [types.FAIL_SCALE_HOSTS_POOL]: ({
    poolName
  }) => ({
    message: `Pool ${poolName} update failed`,
    severity: 'error'
  }),
  [types.COMPLETE_DELETE_ACCOUNT]: ({
    email
  }) => ({
    message: `Account ${email} deleted successfully`,
    severity: 'success'
  }),
  [types.FAIL_DELETE_ACCOUNT]: ({
    email
  }) => ({
    message: `Account ${email} deletion failed`,
    severity: 'error'
  }),
  [types.COMPLETE_DELETE_EXTERNAL_CONNECTION]: ({
    connection
  }) => ({
    message: `Connection ${connection} deleted successfully`,
    severity: 'success'
  }),
  [types.FAIL_DELETE_EXTERNAL_CONNECTION]: ({
    connection
  }) => ({
    message: `Connection ${connection} deletion failed`,
    severity: 'error'
  }),
  [types.COMPLETE_CREATE_NAMESPACE_RESOURCE]: ({
    name
  }) => ({
    message: `Namespace resource ${name} created successfully`,
    severity: 'success'
  }),
  [types.FAIL_CREATE_NAMESPACE_RESOURCE]: ({
    name
  }) => ({
    message: `Namespace resource ${name} creation failed`,
    severity: 'error'
  }),
  [types.COMPLETE_DELETE_NAMESPACE_RESOURCE]: ({
    name
  }) => ({
    message: `Namespace resource ${name} deleted successfully`,
    severity: 'success'
  }),
  [types.FAIL_DELETE_NAMESPACE_RESOURCE]: ({
    name
  }) => ({
    message: `Namespace resource ${name} deletion failed`,
    severity: 'error'
  }),
  [types.COMPLETE_UPDATE_BUCKET_QUOTA_POLICY]: ({
    bucket
  }) => ({
    message: `${bucket} quota updated successfully`,
    severity: 'success'
  }),
  [types.FAIL_UPDATE_BUCKET_QUOTA_POLICY]: ({
    bucket
  }) => ({
    message: `Updating quota for ${bucket} failed`,
    severity: 'error'
  }),
  [types.COMPLETE_UPDATE_TIER_PLACEMENT_POLICY]: ({
    bucket
  }) => ({
    message: `${bucket} placement policy updated successfully`,
    severity: 'success'
  }),
  [types.FAIL_UPDATE_TIER_PLACEMENT_POLICY]: ({
    bucket
  }) => ({
    message: `Updating ${bucket} placement policy failed`,
    severity: 'error'
  }),
  [types.COMPLETE_UPDATE_BUCKET_RESILIENCY_POLICY]: ({
    bucket
  }) => ({
    message: `${bucket} resiliency policy updated successfully`,
    severity: 'success'
  }),
  [types.FAIL_UPDATE_BUCKET_RESILIENCY_POLICY]: ({
    bucket
  }) => ({
    message: `Updating ${bucket} resiliency policy failed`,
    severity: 'error'
  }),
  [types.COMPLETE_UPDATE_BUCKET_VERSIONING_POLICY]: ({
    bucket,
    versioning
  }) => {
    const action = versioning === 'ENABLED' && 'enabled' || versioning === 'SUSPENDED' && 'suspended';
    return {
      message: `${bucket} versioning ${action} successfully`,
      severity: 'success'
    };
  },
  [types.FAIL_UPDATE_BUCKET_VERSIONING_POLICY]: ({
    bucket,
    versioning
  }) => {
    const action = versioning === 'ENABLED' && 'Enabling' || versioning === 'SUSPENDED' && 'Suspending';
    return {
      message: `${action} ${bucket} versioning failed`,
      severity: 'error'
    };
  },
  [types.COMPLETE_ADD_BUCKET_TIER]: ({
    bucket
  }) => ({
    message: `A tier was added to bucket ${bucket} successfully`,
    severity: 'success'
  }),
  [types.FAIL_ADD_BUCKET_TIER]: ({
    bucket
  }) => ({
    message: `Adding a tier to bucket ${bucket} failed`,
    severity: 'error'
  }),
  [types.COMPLETE_DELETE_BUCKET]: ({
    bucket
  }) => ({
    message: `Bucket ${bucket} deleted successfully`,
    severity: 'success'
  }),
  [types.FAIL_DELETE_BUCKET]: ({
    bucket
  }) => ({
    message: `Bucket ${bucket} deletion failed`,
    severity: 'error'
  }),
  [types.COMPLETE_CREATE_NAMESPACE_BUCKET]: ({
    name
  }) => ({
    message: `Namespace bucket ${name} created successfully`,
    severity: 'success'
  }),
  [types.FAIL_CREATE_NAMESPACE_BUCKET]: ({
    name
  }) => ({
    message: `Namespace bucket ${name} creation failed`,
    severity: 'error'
  }),
  [types.COMPLETE_UPDATE_NAMESPACE_BUCKET_PLACEMENT]: ({
    name
  }) => ({
    message: `Namespace bucket ${name} placement policy updated successfully`,
    severity: 'success'
  }),
  [types.FAIL_UPDATE_NAMESPACE_BUCKET_PLACEMENT]: ({
    name
  }) => ({
    message: `Updating namespace bucket ${name} placement policy failed`,
    severity: 'error'
  }),
  [types.COMPLETE_DELETE_NAMESPACE_BUCKET]: ({
    name
  }) => ({
    message: `Namespace bucket ${name} deleted successfully`,
    severity: 'success'
  }),
  [types.FAIL_DELETE_NAMESPACE_BUCKET]: ({
    name
  }) => ({
    message: `Namespace bucket ${name} deletion failed`,
    severity: 'error'
  }),
  [types.COMPLETE_RETRUST_HOST]: ({
    host
  }) => ({
    message: `Node ${host} was set as trusted successfully`,
    severity: 'success'
  }),
  [types.FAIL_RETRUST_HOST]: ({
    host
  }) => ({
    message: `Set node ${host} as trusted failed `,
    severity: 'error'
  }),
  [types.COMPLETE_DELETE_OBJECT]: ({
    objId
  }) => {
    const name = objId.version ? `${objId.key} (${objId.version})` : objId.key;
    return {
      message: `File ${name} deleted successfully`,
      severity: 'success'
    };
  },
  [types.FAIL_DELETE_OBJECT]: ({
    objId
  }) => {
    const name = objId.version ? `${objId.key} (${objId.version})` : objId.key;
    return {
      message: `File ${name} deletion failed`,
      severity: 'error'
    };
  },
  [types.COMPLETE_UPDATE_SERVER_ADDRESS]: ({
    secret,
    hostname
  }) => ({
    message: `${(0, _clusterUtils.getServerDisplayName)({
      secret,
      hostname
    })} cluster connectivity IP updated successfully`,
    severity: 'success'
  }),
  [types.FAIL_UPDATE_SERVER_ADDRESS]: ({
    secret,
    hostname
  }) => ({
    message: `Updating cluster connectivity IP for ${(0, _clusterUtils.getServerDisplayName)({
      secret,
      hostname
    })} failed`,
    severity: 'error'
  }),
  [types.COMPLETE_UPDATE_BUCKET_S3_ACCESS]: ({
    bucketName
  }) => ({
    message: `${bucketName} S3 access control updated successfully`,
    severity: 'success'
  }),
  [types.FAIL_UPDATE_BUCKET_S3_ACCESS]: ({
    bucketName
  }) => ({
    message: `Updating ${bucketName} S3 access control failed`,
    severity: 'error'
  }),
  [types.COMPLETE_ADD_BUCKET_TRIGGER]: ({
    bucketName
  }) => ({
    message: `A trigger added to ${bucketName} successfully`,
    severity: 'success'
  }),
  [types.FAIL_ADD_BUCKET_TRIGGER]: ({
    bucketName
  }) => ({
    message: `Adding a trigger to ${bucketName} failed`,
    severity: 'error'
  }),
  [types.COMPLETE_UPDATE_BUCKET_TRIGGER]: ({
    displayEntity
  }) => ({
    message: `A trigger updated for ${displayEntity} successfully`,
    severity: 'success'
  }),
  [types.FAIL_UPDATE_BUCKET_TRIGGER]: ({
    displayEntity
  }) => ({
    message: `Updating a trigger for ${displayEntity} failed`,
    severity: 'error'
  }),
  [types.COMPLETE_REMOVE_BUCKET_TRIGGER]: ({
    bucketName
  }) => ({
    message: `A trigger removed from ${bucketName} successfully`,
    severity: 'success'
  }),
  [types.FAIL_REMOVE_BUCKET_TRIGGER]: ({
    bucketName
  }) => ({
    message: `Removing a trigger from ${bucketName} failed`,
    severity: 'error'
  }),
  [types.COMPLETE_ATTACH_SERVER_TO_CLUSTER]: ({
    secret
  }) => ({
    message: `Attaching a new server (secret: ${secret}) to the cluster, this might take a few moments`,
    severity: 'info'
  }),
  [types.FAIL_ATTACH_SERVER_TO_CLUSTER]: ({
    secret
  }) => ({
    message: `Attaching a new server (secret: ${secret}) to the cluster failed`,
    severity: 'error'
  }),
  [types.COMPLETE_CREATE_CLOUD_RESOURCE]: ({
    name
  }) => ({
    message: `Cloud resource ${name} created successfully`,
    severity: 'success'
  }),
  [types.FAIL_CREATE_CLOUD_RESOURCE]: ({
    name
  }) => ({
    message: `Cloud resource ${name} creation failed`,
    severity: 'error'
  }),
  [types.CREATE_LAMBDA_FUNC]: ({
    codeBufferSize
  }) => {
    if (codeBufferSize < largeUploadSizeThreshold) {
      return;
    }

    return {
      message: 'Uploading a large function package, it may take a few moments',
      severity: 'info'
    };
  },
  [types.COMPLETE_CREATE_LAMBDA_FUNC]: ({
    name
  }) => ({
    message: `Function ${name} created successfully`,
    severity: 'success'
  }),
  [types.FAIL_CREATE_LAMBDA_FUNC]: ({
    name
  }) => ({
    message: `Creating function ${name} failed`,
    severity: 'error'
  }),
  [types.COMPLETE_DELETE_LAMBDA_FUNC]: ({
    name
  }) => ({
    message: `Function ${name} deleted successfully`,
    severity: 'success'
  }),
  [types.FAIL_DELETE_LAMBDA_FUNC]: ({
    name
  }) => ({
    message: `Function ${name} deletion failed`,
    severity: 'error'
  }),
  [types.COMPLETE_UPDATE_LAMBDA_FUNC_CONFIG]: ({
    name
  }) => ({
    message: `${name} configuration updated successfully`,
    severity: 'success'
  }),
  [types.FAIL_UPDATE_LAMBDA_FUNC_CONFIG]: ({
    name
  }) => ({
    message: `Updating ${name} configuration failed`,
    severity: 'error'
  }),
  [types.COMPLETE_INVOKE_LAMBDA_FUNC]: ({
    name,
    error,
    result
  }) => {
    if (error) {
      return {
        message: `${name} invoked but returned error: ${error.message}`,
        severity: 'warning'
      };
    } else {
      return {
        message: `${name} invoked successfully result: ${JSON.stringify(result)}`,
        severity: 'success'
      };
    }
  },
  [types.UPDATE_LAMBDA_FUNC_CODE]: ({
    bufferHandle,
    bufferSize
  }) => {
    if (bufferHandle === null || bufferSize < largeUploadSizeThreshold) {
      return;
    }

    return {
      message: 'Uploading a large function package, it may take a few moments',
      severity: 'info'
    };
  },
  [types.COMPLETE_UPDATE_LAMBDA_FUNC_CODE]: ({
    name
  }) => ({
    message: `${name} code updated successfully`,
    severity: 'success'
  }),
  [types.FAIL_UPDATE_LAMBDA_FUNC_CODE]: ({
    name
  }) => ({
    message: `Updating ${name} code  updated failed`,
    severity: 'error'
  }),
  [types.FAIL_INVOKE_LAMBDA_FUNC]: ({
    name
  }) => ({
    message: `${name} invocation failed`,
    severity: 'error'
  }),
  [types.FAIL_ENTER_MAINTENANCE_MODE]: () => ({
    message: 'Entering maintenance mode failed',
    severity: 'error'
  }),
  [types.FAIL_LEAVE_MAINTENANCE_MODE]: () => ({
    message: 'Leaving maintenance mode failed',
    severity: 'error'
  }),
  [types.COMPLETE_CREATE_BUCKET]: ({
    name
  }) => ({
    message: `Bucket ${name} created successfully`,
    severity: 'success'
  }),
  [types.FAIL_CREATE_BUCKET]: ({
    name
  }) => ({
    message: `Bucket ${name} creation failed`,
    severity: 'error'
  }),
  [types.COMPLETE_ASSIGN_REGION_TO_RESOURCE]: ({
    resourceName,
    region
  }) => ({
    message: `A region was ${region ? 'assigned to' : 'removed from'} ${resourceName} successfully`,
    severity: 'success'
  }),
  [types.FAIL_ASSIGN_REGION_TO_RESOURCE]: ({
    resourceName,
    region
  }) => ({
    message: `Failed to ${region ? 'assign a region to' : 'remove a region from'} ${resourceName}`,
    severity: 'error'
  }),
  [types.COMPLETE_UPDATE_P2P_SETTINGS]: () => ({
    message: 'Peer to peer settings updated successfully',
    severity: 'success'
  }),
  [types.FAIL_UPDATE_P2P_SETTINGS]: () => ({
    message: 'Peer to peer settings update failed',
    severity: 'error'
  }),
  [types.FAIL_SET_SYSTEM_DEBUG_LEVEL]: ({
    level
  }) => ({
    message: `Setting system debug level to ${level} failed`,
    severity: 'error'
  }),
  [types.COMPLETE_UPDATE_SERVER_DETAILS]: ({
    hostname
  }) => ({
    message: `${hostname} details updated successfully`,
    severity: 'success'
  }),
  [types.FAIL_UPDATE_SERVER_DETAILS]: ({
    hostname
  }) => ({
    message: `Updating ${hostname} details failed`,
    severity: 'error'
  }),
  [types.FAIL_UPLOAD_SSL_CERTIFICATE]: ({
    error
  }) => ({
    message: `Uploading SSL cartificate failed: ${error.message}`,
    severity: 'error'
  }),
  [types.FAIL_EXPORT_AUDIT_LOG]: () => ({
    message: 'Exporting audit log failed',
    severity: 'error'
  }),
  [types.FAIL_GENERATE_ENDPOINT_GROUP_DEPLOYMENT_YAML]: () => ({
    message: 'Generating endpoint group deployment YAML failed',
    severity: 'error'
  }),
  [types.COMPLETE_UPDATE_ENDPOINT_GROUP]: ({
    name
  }) => ({
    message: `Endpoint group ${name} updated successfuly`,
    severity: 'success'
  }),
  [types.FAIL_UPDATE_ENDPOINT_GROUP]: ({
    name
  }) => ({
    message: `Updating endpoint group ${name} failed`,
    severity: 'error'
  }),
  [types.FAIL_FETCH_ENDPOINTS_HISTORY]: () => ({
    message: 'Fetching endpoint groups history failed',
    severity: 'error'
  })
});

function _default(action$) {
  return action$.pipe((0, _operators.mergeMap)(action => {
    const generator = actionToNotification[action.type];

    if (generator) {
      return (0, _coreUtils.ensureArray)(generator(action.payload)).map(notif => (0, _actionCreators.showNotification)(notif.message, notif.severity));
    } else {
      return (0, _rxjs.empty)();
    }
  }));
}

},{"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"action-types":318,"rxjs":89,"rxjs/operators":287,"utils/cluster-utils":1025,"utils/core-utils":1027,"utils/host-utils":1032,"utils/size-utils":1043}],887:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _rxjs = require("rxjs");

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _actionCreators = require("action-creators");

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
function _replaceModalAfterSuccess(action$) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.COMPLETE_CREATE_ACCOUNT), (0, _operators.mergeMap)(action => {
    const {
      accountName,
      password
    } = action.payload;
    return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.COMPLETE_FETCH_SYSTEM_INFO), (0, _operators.take)(1), (0, _operators.mergeMap)(() => [(0, _actionCreators.closeModal)(), (0, _actionCreators.openAccountCreatedModal)(accountName, password)]));
  }));
}

function _closeModalAfterFaliure(action$) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.FAIL_CREATE_ACCOUNT), (0, _operators.map)(() => (0, _actionCreators.closeModal)()));
}

function _default(action$) {
  return (0, _rxjs.from)([_replaceModalAfterSuccess, _closeModalAfterFaliure]).pipe((0, _operators.mergeMap)(epic => epic(action$)));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs":89,"rxjs/operators":287}],888:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _rxjs = require("rxjs");

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _actionCreators = require("action-creators");

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
const handlers = {
  [_actionTypes.COMPLETE_RESET_ACCOUNT_PASSWORD]: action => {
    const {
      accountName,
      password
    } = action.payload;
    return (0, _actionCreators.openPasswordResetCompletedModal)(accountName, password);
  },
  [_actionTypes.FAIL_RESET_ACCOUNT_PASSWORD]: action => {
    const {
      accountName
    } = action.payload;
    return (0, _actionCreators.openPasswordResetFailedModal)(accountName);
  }
};

function _default(action$) {
  return action$.pipe((0, _rxExtensions.ofType)(...Object.keys(handlers)), (0, _operators.mergeMap)(action => (0, _rxjs.of)((0, _actionCreators.closeModal)(), handlers[action.type](action))));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs":89,"rxjs/operators":287}],889:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

var routes = _interopRequireWildcard(require("routes"));

/* Copyright (C) 2016 NooBaa */
function _default(action$) {
  // Adding the delay in order to enusre that the UI has refreshed before changing to the new location,
  // This prevents view models who are relaying on some url params (e.g. system param) from throwing.
  // The dealy gurentee that these view model will be destroied before the change
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.SIGN_OUT), (0, _operators.delay)(1), (0, _operators.map)(() => (0, _actionCreators.requestLocation)(routes.root)));
}

},{"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"action-types":318,"routes":972,"rx-extensions":974,"rxjs/operators":287}],890:[function(require,module,exports){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _actionCreators = require("action-creators");

var types = _interopRequireWildcard(require("action-types"));

/* Copyright (C) 2016 NooBaa */
function _default(action$) {
  return action$.pipe((0, _rxExtensions.ofType)(types.COMPLETE_CREATE_ACCOUNT, types.COMPLETE_UPDATE_ACCOUNT_S3_ACCESS, types.COMPLETE_SET_ACCOUNT_IP_RESTRICTIONS, types.COMPLETE_ADD_EXTERNAL_CONNECTION, types.COMPLETE_UPDATE_EXTERNAL_CONNECTION, types.COMPLETE_DELETE_RESOURCE, types.COMPLETE_DELETE_EXTERNAL_CONNECTION, types.COMPLETE_CREATE_HOSTS_POOL, types.COMPLETE_SCALE_HOSTS_POOL, types.COMPLETE_SET_HOST_DEBUG_MODE, types.COMPLETE_DELETE_ACCOUNT, types.COMPLETE_CREATE_NAMESPACE_RESOURCE, types.COMPLETE_DELETE_NAMESPACE_RESOURCE, types.COMPLETE_UPDATE_BUCKET_QUOTA_POLICY, types.COMPLETE_UPDATE_BUCKET_RESILIENCY_POLICY, types.COMPLETE_UPDATE_BUCKET_VERSIONING_POLICY, types.COMPLETE_ADD_BUCKET_TIER, types.COMPLETE_DELETE_BUCKET, types.COMPLETE_UPDATE_TIER_PLACEMENT_POLICY, types.COMPLETE_CREATE_NAMESPACE_BUCKET, types.COMPLETE_UPDATE_NAMESPACE_BUCKET_PLACEMENT, types.COMPLETE_DELETE_NAMESPACE_BUCKET, types.COMPLETE_RETRUST_HOST, types.COMPLETE_DELETE_OBJECT, types.UPLOAD_OBJECTS, types.COMPLETE_OBJECT_UPLOAD, types.REMOVE_HOST, types.COMPLETE_UPDATE_BUCKET_S3_ACCESS, types.COMPLETE_ADD_BUCKET_TRIGGER, types.COMPLETE_UPDATE_BUCKET_TRIGGER, types.COMPLETE_REMOVE_BUCKET_TRIGGER, types.COMPLETE_ATTACH_SERVER_TO_CLUSTER, types.COMPLETE_CREATE_CLOUD_RESOURCE, types.COMPLETE_CREATE_LAMBDA_FUNC, types.COMPLETE_UPDATE_LAMBDA_FUNC_CONFIG, types.COMPLETE_UPDATE_LAMBDA_FUNC_CODE, types.COMPLETE_DELETE_LAMBDA_FUNC, types.COMPLETE_ENTER_MAINTENANCE_MODE, types.COMPLETE_LEAVE_MAINTENANCE_MODE, types.COMPLETE_CREATE_BUCKET, types.COMPLETE_REGENERATE_ACCOUNT_CREDENTIALS, types.COMPLETE_ASSIGN_REGION_TO_RESOURCE, types.COMPLETE_UPDATE_P2P_SETTINGS, types.COMPLETE_SET_SYSTEM_DEBUG_LEVEL, types.COMPLETE_UPDATE_SERVER_DETAILS, types.COMPLETE_UPDATE_ENDPOINT_GROUP, types.COMPLETE_FETCH_ENDPOINTS_HISTORY), (0, _operators.map)(() => (0, _actionCreators.refreshLocation)()));
}

},{"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287}],891:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.REGENERATE_ACCOUNT_CREDENTIALS), (0, _operators.mergeMap)(async action => {
    const {
      accountName
    } = action.payload;

    try {
      await api.account.generate_account_keys({
        email: accountName
      });
      return (0, _actionCreators.completeRegenerateAccountCredentials)(accountName);
    } catch (error) {
      return (0, _actionCreators.failRegenerateAccountCredentials)(accountName, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],892:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.REMOVE_BUCKET_TRIGGER), (0, _operators.mergeMap)(async action => {
    const {
      bucketName,
      triggerId
    } = action.payload;

    try {
      await api.bucket.delete_bucket_lambda_trigger({
        bucket_name: bucketName,
        id: triggerId
      });
      return (0, _actionCreators.completeRemoveBucketTrigger)(bucketName);
    } catch (error) {
      return (0, _actionCreators.failRemoveBucketTrigger)(bucketName, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],893:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _rxjs = require("rxjs");

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.RESEND_ACTIVATION_CODE), (0, _operators.mergeMap)(action => {
    const {
      email
    } = action.payload;
    api.system.resend_activation_code({
      email
    });
    return (0, _rxjs.empty)();
  }));
}

},{"action-types":318,"rx-extensions":974,"rxjs":89,"rxjs/operators":287}],894:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

var _promiseUtils = require("utils/promise-utils");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.RESET_ACCOUNT_PASSWORD), (0, _operators.mergeMap)(async action => {
    const {
      verificationPassword,
      accountName,
      password
    } = action.payload;

    try {
      await (0, _promiseUtils.all)(api.account.reset_password({
        verification_password: verificationPassword,
        email: accountName,
        password: password,
        must_change_password: true
      }), (0, _promiseUtils.sleep)(750));
      return (0, _actionCreators.completeResetAccountPassword)(accountName, password);
    } catch (error) {
      return (0, _actionCreators.failResetAccountPassword)(accountName, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/promise-utils":1039,"utils/state-utils":1044}],895:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

var _config = require("config");

var _rxjs = require("rxjs");

/* Copyright (C) 2016 NooBaa */
const UNAUTHORIZED = 'UNAUTHORIZED';
const RPC_CONNECT_TIMEOUT = 'RPC_CONNECT_TIMEOUT';

function _loadStoredToken(key, localStorage, sessionStorage) {
  const sessionToken = sessionStorage.getItem(key);
  const localToken = localStorage.getItem(key);
  return {
    token: sessionToken || localToken,
    persistent: Boolean(localToken)
  };
}

function _createUnauthorizedException(message) {
  const error = new Error(message);
  error.rpc_code = UNAUTHORIZED;
  return error;
}

function _default(action$, {
  api,
  localStorage,
  sessionStorage
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.RESTORE_SESSION), (0, _operators.mergeMap)(() => {
    const {
      token,
      persistent
    } = _loadStoredToken(_config.sessionTokenKey, localStorage, sessionStorage);

    if (!token) {
      const error = _createUnauthorizedException('Token not available');

      return (0, _rxjs.of)((0, _actionCreators.failRestoreSession)(token, (0, _stateUtils.mapErrorObject)(error)));
    }

    api.options.auth_token = token;
    return (0, _rxjs.of)(true).pipe((0, _operators.mergeMap)(async () => {
      const sessionInfo = await api.auth.read_auth();
      const account = await api.account.read_account({
        email: sessionInfo.account.email
      });
      const uiTheme = account.preferences.ui_theme.toLowerCase();
      return {
        sessionInfo: sessionInfo,
        uiTheme
      };
    }), (0, _operators.map)(({
      sessionInfo,
      uiTheme
    }) => {
      if (!sessionInfo.account) {
        throw _createUnauthorizedException('Account not found');
      }

      return (0, _actionCreators.completeRestoreSession)(token, sessionInfo, persistent, uiTheme);
    }), (0, _operators.retryWhen)(errors => errors.pipe((0, _operators.scan)((count, err) => {
      if (err.rpc_code !== RPC_CONNECT_TIMEOUT || count >= _config.readAuthRetryCount) {
        throw err;
      }

      return count + 1;
    }, 0), (0, _operators.delay)(_config.readAuthRetryDelay))), (0, _operators.catchError)(error => {
      if (error.rpc_code !== UNAUTHORIZED) throw error;
      return (0, _rxjs.of)((0, _actionCreators.failRestoreSession)(token, (0, _stateUtils.mapErrorObject)(error)));
    }));
  }));
}

},{"action-creators":306,"action-types":318,"config":831,"rx-extensions":974,"rxjs":89,"rxjs/operators":287,"utils/state-utils":1044}],896:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.RETRUST_HOST), (0, _operators.mergeMap)(async action => {
    const {
      host
    } = action.payload;

    try {
      await api.host.retrust_host({
        name: host
      });
      return (0, _actionCreators.completeRetrustHost)(host);
    } catch (error) {
      return (0, _actionCreators.failRetrustHost)(host, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],897:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.SCALE_HOSTS_POOL), (0, _operators.mergeMap)(async action => {
    const {
      poolName,
      hostCount
    } = action.payload;

    try {
      await api.pool.scale_hosts_pool({
        name: poolName,
        host_count: hostCount
      });
      return (0, _actionCreators.completeScaleHostsPool)(poolName);
    } catch (error) {
      return (0, _actionCreators.failScaleHostsPool)(poolName, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],898:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _actionCreators = require("action-creators");

var _config = require("config");

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
function _default(action$) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.CHANGE_LOCATION, _actionTypes.REFRESH_LOCATION), (0, _operators.debounceTime)(_config.autoRefreshInterval), (0, _operators.map)(() => (0, _actionCreators.refreshLocation)()));
}

},{"action-creators":306,"action-types":318,"config":831,"rx-extensions":974,"rxjs/operators":287}],899:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _promiseUtils = require("utils/promise-utils");

var _actionCreators = require("action-creators");

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
// A fixed delay added to the time left in order to compensate for the time it takes the server
// to lower the debug level (where read_system returns { debug: { level: 5, time_left: 0 } })
// and prevent redundent refershs.
const GRACE_TIME = 500;

function _default(action$) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.COMPLETE_FETCH_SYSTEM_INFO), (0, _operators.switchMap)(async action => {
    const {
      level,
      time_left = 0
    } = action.payload.debug;
    if (level === 0) return;
    await (0, _promiseUtils.sleep)(time_left + GRACE_TIME);
    return (0, _actionCreators.refreshLocation)();
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/promise-utils":1039}],900:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _promiseUtils = require("utils/promise-utils");

var _actionCreators = require("action-creators");

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
// A fixed delay added to the time left in order to compensate for the time it takes the server
// to get out of maintenance mode (where read_system returns { maintenance_mode: { state: true, time_left: 0 } })
// and prevent redundent refershs.
const GRACE_TIME = 500;

function _default(action$) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.COMPLETE_FETCH_SYSTEM_INFO), (0, _operators.switchMap)(async action => {
    const {
      state,
      time_left = 0
    } = action.payload.maintenance_mode;
    if (!state) return;
    await (0, _promiseUtils.sleep)(time_left + GRACE_TIME);
    return (0, _actionCreators.refreshLocation)();
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/promise-utils":1039}],901:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

var _netUtils = require("utils/net-utils");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.SET_ACCOUNT_IP_RESTRICTIONS), (0, _operators.mergeMap)(async action => {
    const {
      accountName: email,
      allowedIps
    } = action.payload;
    const ips = allowedIps && allowedIps.map(_netUtils.splitIPRange);

    try {
      await api.account.update_account({
        email,
        ips
      });
      return (0, _actionCreators.completeSetAccountIpRestrictions)(email);
    } catch (error) {
      return (0, _actionCreators.failSetAccountIpRestrictions)(email, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/net-utils":1036,"utils/state-utils":1044}],902:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.SET_HOST_DEBUG_MODE), (0, _operators.mergeMap)(async action => {
    const {
      host,
      on
    } = action.payload;

    try {
      await api.host.set_debug_host({
        name: host,
        level: on ? 5 : 0
      });
      return (0, _actionCreators.completeSetHostDebugMode)(host, on);
    } catch (error) {
      return (0, _actionCreators.failSetHostDebugMode)(host, on, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],903:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.SET_SYSTEM_DEBUG_LEVEL), (0, _operators.mergeMap)(async action => {
    const {
      level
    } = action.payload;

    try {
      await api.cluster_server.set_debug_level({
        level
      });
      return (0, _actionCreators.completeSetSystemDebugLevel)(level);
    } catch (error) {
      return (0, _actionCreators.failSetSystemDebugLevel)(level, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],904:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _rxjs = require("rxjs");

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  // handles sign in request with email and password.
  const credentialsBasedSignIn$ = action$.pipe((0, _rxExtensions.ofType)(_actionTypes.SIGN_IN), (0, _operators.map)(async action => {
    const {
      email,
      password,
      persistent
    } = action.payload;
    await api.create_auth_token({
      email,
      password
    });
    const {
      systems
    } = await api.system.list_systems();
    const {
      name: system
    } = systems[0];
    const res = await api.create_auth_token({
      system,
      email,
      password
    });
    return { ...res,
      persistent
    };
  })); // handles sign in request from an oauth srouce.

  const k8sBasedSignIn$ = action$.pipe((0, _rxExtensions.ofType)(_actionTypes.SIGN_IN_WITH_OAUTH), (0, _operators.map)(async action => {
    const {
      oauthGrantCode: grant_code
    } = action.payload;
    const res = await api.create_k8s_auth({
      grant_code
    });
    return { ...res,
      persistent: false
    };
  })); // Merge the two streams of requests (promises) and handle
  // the results uniformly.

  return (0, _rxjs.merge)(credentialsBasedSignIn$, k8sBasedSignIn$).pipe((0, _operators.mergeMap)(async req => {
    try {
      const {
        info,
        token,
        persistent
      } = await req;
      const account = await api.account.read_account({
        email: info.account.email
      });
      const theme = account.preferences.ui_theme.toLowerCase();
      return (0, _actionCreators.completeSignIn)(token, info, persistent, theme);
    } catch (err) {
      if (err.rpc_code !== 'UNAUTHORIZED') throw err;
      return (0, _actionCreators.failSignIn)((0, _stateUtils.mapErrorObject)(err));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs":89,"rxjs/operators":287,"utils/state-utils":1044}],905:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2017 NooBaa */
function _default(action$) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.COMPLETE_DELETE_ACCOUNT), (0, _operators.map)(action => {
    const {
      isCurrentUser
    } = action.payload;

    if (isCurrentUser) {
      return (0, _actionCreators.signOut)();
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287}],906:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2017 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.TRY_DELETE_ACCOUNT), (0, _operators.mergeMap)(async action => {
    const {
      email,
      isCurrentUser,
      isConfirmed
    } = action.payload;

    try {
      if (isCurrentUser && !isConfirmed) {
        return (0, _actionCreators.openDeleteCurrentAccountWarningModal)(email);
      } else {
        await api.account.delete_account({
          email
        });
        return (0, _actionCreators.completeDeleteAccount)(email, isCurrentUser);
      }
    } catch (error) {
      return (0, _actionCreators.failDeleteAccount)(email, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],907:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _rxjs = require("rxjs");

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
const retryCount = 2;
const retryDelay = 500;

function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.UPDATE_ACCOUNT_UI_THEME), (0, _operators.mergeMap)(action => {
    const {
      accountName,
      theme
    } = action.payload;
    return (0, _rxjs.of)(true).pipe((0, _operators.mergeMap)(() => api.account.update_account({
      email: accountName,
      preferences: {
        ui_theme: theme.toUpperCase()
      }
    })), (0, _operators.retryWhen)(errors => errors.pipe((0, _operators.delay)(retryDelay), (0, _operators.take)(retryCount))));
  }));
}

},{"action-types":318,"rx-extensions":974,"rxjs":89,"rxjs/operators":287}],908:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.UPDATE_ACCOUNT_S3_ACCESS), (0, _operators.mergeMap)(async action => {
    const {
      accountName,
      defaultResource,
      hasAccessToAllBuckets,
      allowedBuckets,
      allowBucketCreation
    } = action.payload;

    try {
      await api.account.update_account_s3_access({
        email: accountName,
        s3_access: true,
        default_pool: defaultResource,
        allowed_buckets: {
          full_permission: hasAccessToAllBuckets,
          permission_list: hasAccessToAllBuckets ? undefined : allowedBuckets
        },
        allow_bucket_creation: allowBucketCreation
      });
      return (0, _actionCreators.completeUpdateAccountS3Access)(accountName);
    } catch (error) {
      return (0, _actionCreators.failUpdateAccountS3Access)(accountName, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],909:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.UPDATE_ALERTS), (0, _operators.mergeMap)(async action => {
    const {
      query,
      read
    } = action.payload;

    try {
      await api.events.update_alerts_state({
        query,
        state: read
      });
      return (0, _actionCreators.completeUpdateAlerts)(query, read);
    } catch (error) {
      return (0, _actionCreators.failUpdateAlerts)(query, read, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],910:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.UPDATE_BUCKET_QUOTA_POLICY), (0, _operators.mergeMap)(async action => {
    const {
      bucket,
      quota
    } = action.payload;

    try {
      await api.bucket.update_bucket({
        name: bucket,
        quota
      });
      return (0, _actionCreators.completeUpdateBucketQuotaPolicy)(bucket);
    } catch (error) {
      return (0, _actionCreators.failUpdateBucketQuotaPolicy)(bucket, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],911:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.UPDATE_BUCKET_RESILIENCY_POLICY), (0, _operators.mergeMap)(async action => {
    const {
      bucket,
      policy
    } = action.payload;
    const {
      replicas,
      dataFrags: data_frags,
      parityFrags: parity_frags
    } = policy;

    try {
      await api.tiering_policy.update_chunk_config_for_bucket({
        bucket_name: bucket,
        chunk_coder_config: {
          replicas,
          data_frags,
          parity_frags
        }
      });
      return (0, _actionCreators.completeUpdateBucketResiliencyPolicy)(bucket);
    } catch (error) {
      return (0, _actionCreators.failUpdateBucketResiliencyPolicy)(bucket, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],912:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.UPDATE_BUCKET_S3_ACCESS), (0, _operators.mergeMap)(async action => {
    const {
      bucketName,
      allowedAccounts
    } = action.payload;

    try {
      await api.bucket.update_bucket_s3_access({
        name: bucketName,
        allowed_accounts: allowedAccounts
      });
      return (0, _actionCreators.completeUpdateBucketS3Access)(bucketName);
    } catch (error) {
      return (0, _actionCreators.failUpdateBucketS3Access)(bucketName, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],913:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.UPDATE_BUCKET_TRIGGER), (0, _operators.mergeMap)(async action => {
    const {
      bucketName,
      triggerId,
      config,
      displayEntity
    } = action.payload;

    try {
      if (bucketName !== config.bucketName) {
        await api.bucket.delete_bucket_lambda_trigger({
          bucket_name: bucketName,
          id: triggerId
        });
        await api.bucket.add_bucket_lambda_trigger({
          bucket_name: config.bucketName,
          event_name: config.event,
          func_name: config.funcName,
          func_version: config.funcVersion,
          object_prefix: config.prefix,
          object_suffix: config.suffix,
          enabled: config.enabled
        });
      } else {
        await api.bucket.update_bucket_lambda_trigger({
          bucket_name: bucketName,
          id: triggerId,
          event_name: config.event,
          func_name: config.funcName,
          func_version: config.funcVersion,
          object_prefix: config.prefix,
          object_suffix: config.suffix,
          enabled: config.enabled
        });
      }

      return (0, _actionCreators.completeUpdateBucketTrigger)(displayEntity);
    } catch (error) {
      return (0, _actionCreators.failUpdateBucketTrigger)(displayEntity, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],914:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.UPDATE_BUCKET_VERSIONING_POLICY), (0, _operators.mergeMap)(async action => {
    const {
      bucket,
      versioning
    } = action.payload;

    try {
      await api.bucket.update_bucket({
        name: bucket,
        versioning
      });
      return (0, _actionCreators.completeUpdateBucketVersioningPolicy)(bucket, versioning);
    } catch (error) {
      return (0, _actionCreators.failUpdateBucketVersioningPolicy)(bucket, versioning, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],915:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.UPDATE_ENDPOINT_GROUP), (0, _operators.mergeMap)(async action => {
    const {
      name,
      region,
      endpointConf
    } = action.payload;

    try {
      await api.system.update_endpoint_group({
        group_name: name,
        region,
        endpoint_range: {
          min: endpointConf.minCount,
          max: endpointConf.maxCount
        }
      });
      return (0, _actionCreators.completeUpdateEndpointGroup)(name);
    } catch (error) {
      return (0, _actionCreators.failUpdateEndpointGroup)(name, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],916:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _getApiRequestParams(payload) {
  const {
    name,
    service,
    params
  } = payload;

  switch (service) {
    case 'AWS':
      {
        return {
          name,
          identity: params.awsAccessKey,
          secret: params.awsSecretKey
        };
      }

    case 'S3_V2_COMPATIBLE':
      {
        return {
          name,
          identity: params.s3v2AccessKey,
          secret: params.s3v2SecretKey
        };
      }

    case 'S3_V4_COMPATIBLE':
      {
        return {
          name,
          identity: params.s3v4AccessKey,
          secret: params.s3v4SecretKey
        };
      }

    case 'AZURE':
      {
        return {
          name,
          secret: params.azureAccountKey
        };
      }

    case 'GOOGLE':
      {
        const {
          private_key_id
        } = JSON.parse(params.gcKeysJson);
        return {
          name,
          identity: private_key_id,
          secret: params.gcKeysJson
        };
      }

    default:
      {
        throw new Error(`Invalid service: ${service}`);
      }
  }
}

function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.UPDATE_EXTERNAL_CONNECTION), (0, _operators.mergeMap)(async action => {
    const {
      name
    } = action.payload;

    try {
      const requestParams = _getApiRequestParams(action.payload);

      await api.account.update_external_connection(requestParams);
      return (0, _actionCreators.completeUpdateExternalConnection)(name);
    } catch (error) {
      return (0, _actionCreators.failUpdateExternalConnection)(name, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],917:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.COMPLETE_FETCH_NODE_INSTALLATION_COMMANDS), (0, _operators.map)(action => {
    const command = action.payload.commands['KUBERNETES'];
    return (0, _actionCreators.updateForm)('InstallNodeModalViewModel', {
      command
    });
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287}],918:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _funcUtils = require("utils/func-utils");

var _actionTypes = require("action-types");

var _buffer = require("buffer");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api,
  bufferStore
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.UPDATE_LAMBDA_FUNC_CODE), (0, _operators.mergeMap)(async action => {
    const {
      name,
      version,
      handlerFile,
      handlerFunc,
      bufferHandle
    } = action.payload;

    try {
      const handler = (0, _funcUtils.getFullHandlerName)(handlerFile, handlerFunc);
      const buffers = bufferHandle ? {
        zipfile: _buffer.Buffer.from(bufferStore.get(bufferHandle))
      } : undefined;
      await api.func.update_func({
        config: {
          name,
          version,
          handler
        },
        code: bufferHandle ? {} : undefined,
        [api.RPC_BUFFERS]: buffers
      });
      return (0, _actionCreators.completeUpdateLambdaFuncCode)(name, version);
    } catch (error) {
      return (0, _actionCreators.failUpdateLambdaFuncCode)(name, version, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"buffer":53,"rx-extensions":974,"rxjs/operators":287,"utils/func-utils":1031,"utils/state-utils":1044}],919:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.UPDATE_LAMBDA_FUNC_CONFIG), (0, _operators.mergeMap)(async action => {
    const {
      name,
      version,
      description,
      runtime,
      memorySize,
      timeout
    } = action.payload;

    try {
      await api.func.update_func({
        config: {
          name,
          version,
          description,
          runtime,
          memory_size: memorySize,
          timeout
        }
      });
      return (0, _actionCreators.completeUpdateLambdaFuncConfig)(name, version);
    } catch (error) {
      return (0, _actionCreators.failUpdateLambdaFuncConfig)(name, version, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],920:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.UPDATE_NAMESPACE_BUCKET_PLACEMENT), (0, _operators.mergeMap)(async action => {
    const {
      name,
      readFrom,
      writeTo
    } = action.payload;

    try {
      const namespace = {
        read_resources: readFrom,
        write_resource: writeTo
      };
      await api.bucket.update_bucket({
        name,
        namespace
      });
      return (0, _actionCreators.completeUpdateNamespaceBucketPlacement)(name);
    } catch (error) {
      return (0, _actionCreators.failUpdateNamespaceBucketPlacement)(name, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],921:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _buildConfigObj(start, end) {
  if (start === end) {
    return {
      tcp_permanent_passive: {
        port: start
      }
    };
  } else {
    return {
      tcp_permanent_passive: {
        min: start,
        max: end
      }
    };
  }
}

function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.UPDATE_P2P_SETTINGS), (0, _operators.mergeMap)(async action => {
    const {
      start,
      end
    } = action.payload.tcpPortRange;

    try {
      await api.system.update_n2n_config({
        config: _buildConfigObj(start, end)
      });
      return (0, _actionCreators.completeUpdateP2PSettings)();
    } catch (error) {
      return (0, _actionCreators.failUpdateP2PSettings)((0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],922:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.UPDATE_SERVER_ADDRESS), (0, _operators.mergeMap)(async action => {
    const {
      newAddress,
      secret,
      hostname
    } = action.payload;

    try {
      await api.cluster_server.update_member_of_cluster({
        new_address: newAddress,
        target_secret: secret
      });
      return (0, _actionCreators.completeUpdateServerAddress)(secret, hostname);
    } catch (error) {
      return (0, _actionCreators.failUpdateServerAddress)(secret, hostname, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],923:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.UPDATE_SERVER_DETAILS), (0, _operators.mergeMap)(async action => {
    const {
      secret,
      hostname,
      newHostname,
      locationTag
    } = action.payload;

    try {
      await api.cluster_server.update_server_conf({
        target_secret: secret,
        hostname: newHostname,
        location: locationTag
      });
      return (0, _actionCreators.completeUpdateServerDetails)(secret, hostname, newHostname);
    } catch (error) {
      return (0, _actionCreators.failUpdateServerDetails)(secret, hostname, error);
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287}],924:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
function _default(action$, {
  api
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.UPDATE_TIER_PLACEMENT_POLICY), (0, _operators.mergeMap)(async action => {
    const {
      bucket,
      tier,
      policyType,
      resourceIds
    } = action.payload;
    const resourceNames = resourceIds.map(res => res.split(':')[1]);

    try {
      await api.tier.update_tier({
        name: tier,
        data_placement: policyType,
        attached_pools: resourceNames
      });
      return (0, _actionCreators.completeUpdateTierPlacementPolicy)(bucket, tier);
    } catch (error) {
      return (0, _actionCreators.failUpdateTierPlacementPolicy)(bucket, tier, (0, _stateUtils.mapErrorObject)(error));
    }
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs/operators":287,"utils/state-utils":1044}],925:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _rxjs = require("rxjs");

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _actionTypes = require("action-types");

var _coreUtils = require("utils/core-utils");

var _stateUtils = require("utils/state-utils");

var _awsUtils = require("utils/aws-utils");

var _sizeUtils = require("utils/size-utils");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const s3UploadOptions = (0, _coreUtils.deepFreeze)({
  partSize: 10 * _sizeUtils.unitsInBytes.MB,
  queueSize: 4
});

function _default(action$, {
  AWS
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.UPLOAD_OBJECTS), (0, _operators.mergeMap)(action => {
    const {
      objects,
      connection
    } = action.payload;
    const s3 = (0, _awsUtils.createS3Client)(AWS, connection);
    const uploadEvent$ = new _rxjs.Subject();
    let uploading = objects.length;

    for (const {
      id,
      bucket,
      file
    } of objects) {
      s3.upload({
        Key: file.name,
        Bucket: bucket,
        Body: file,
        ContentType: file.type
      }, s3UploadOptions, (error, data) => {
        const action = error ? (0, _actionCreators.failObjectUpload)(id, (0, _stateUtils.mapErrorObject)(error)) : (0, _actionCreators.completeObjectUpload)(id, {
          verisonId: data.VersionId || 'null'
        });
        uploadEvent$.next(action);

        if (--uploading == 0) {
          uploadEvent$.complete();
        }
      }).on('httpUploadProgress', ({
        loaded
      }) => uploadEvent$.next((0, _actionCreators.updateObjectUpload)(id, loaded)));
    }

    return uploadEvent$;
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs":89,"rxjs/operators":287,"utils/aws-utils":1020,"utils/core-utils":1027,"utils/size-utils":1043,"utils/state-utils":1044}],926:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _rxjs = require("rxjs");

var _operators = require("rxjs/operators");

var _rxExtensions = require("rx-extensions");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
async function _initiateUpload(uploadEvent$, certPkg, browser) {
  try {
    const xhr = new browser.XMLHttpRequest();

    xhr.upload.onprogress = evt => {
      const progress = evt.lengthComputable && evt.loaded / evt.total;
      uploadEvent$.next((0, _actionCreators.updateUploadSSLCertificate)(progress));
    };

    const evt = await browser.httpRequest('/upload_certificate', {
      verb: 'POST',
      xhr,
      payload: browser.toFormData({
        upload_file: certPkg
      })
    });

    if (evt.target.status !== 200) {
      throw new Error(`${evt.target.responseText}`);
    }

    uploadEvent$.next((0, _actionCreators.completeUploadSSLCertificate)());
    uploadEvent$.next((0, _actionCreators.openCompleteSSLCertificateInstallationModal)());
  } catch (error) {
    uploadEvent$.next((0, _actionCreators.failUploadSSLCertificate)((0, _stateUtils.mapErrorObject)(error)));
  } finally {
    uploadEvent$.complete();
  }
}

function _default(action$, {
  bufferStore,
  browser
}) {
  return action$.pipe((0, _rxExtensions.ofType)(_actionTypes.UPLOAD_SSL_CERTIFICATE), (0, _operators.mergeMap)(action => {
    const {
      certBufferKey
    } = action.payload;
    const certPkg = new Blob([bufferStore.get(certBufferKey)]);
    const uploadEvent$ = new _rxjs.Subject();

    _initiateUpload(uploadEvent$, certPkg, browser);

    return uploadEvent$;
  }));
}

},{"action-creators":306,"action-types":318,"rx-extensions":974,"rxjs":89,"rxjs/operators":287,"utils/state-utils":1044}],927:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = formatNumber;

/* Copyright (C) 2016 NooBaa */
function formatNumber(target, compareOp) {
  target.equalityComparer = compareOp;
  return target;
}

},{}],928:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = formatNumber;

var _knockout = _interopRequireDefault(require("knockout"));

var _numeral = _interopRequireDefault(require("numeral"));

var _coreUtils = require("utils/core-utils");

/* Copyright (C) 2016 NooBaa */
function formatNumber(target, {
  format = '0,0'
}) {
  return _knockout.default.pureComputed(() => (0, _coreUtils.isNumber)(target()) ? (0, _numeral.default)(target()).format(format || 0) : '');
}

},{"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","numeral":"numeral","utils/core-utils":1027}],929:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = formatSize;

var _knockout = _interopRequireDefault(require("knockout"));

var _sizeUtils = require("utils/size-utils");

var _coreUtils = require("utils/core-utils");

/* Copyright (C) 2016 NooBaa */
function formatSize(target) {
  return _knockout.default.pureComputed(() => {
    const value = target();

    if (isNaN(value) && (!(0, _coreUtils.isObject)(value) || (0, _coreUtils.isUndefined)(value.peta))) {
      return 'N/A';
    }

    return (0, _sizeUtils.formatSize)(value);
  });
}

},{"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","utils/core-utils":1027,"utils/size-utils":1043}],930:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = formatTime;

var _knockout = _interopRequireDefault(require("knockout"));

var _momentTimezone = _interopRequireDefault(require("moment-timezone"));

var _coreUtils = require("utils/core-utils");

var _config = require("config");

/* Copyright (C) 2016 NooBaa */
function formatTime(target, params) {
  return _knockout.default.pureComputed(() => {
    const naked = _knockout.default.deepUnwrap(params);

    const {
      format = (0, _coreUtils.isString)(naked) ? naked : _config.timeShortFormat,
      timezone = '',
      notAvailableText = 'N/A'
    } = naked;
    const value = target();

    if (!(0, _coreUtils.isNumber)(value)) {
      return notAvailableText;
    }

    const time = timezone ? _momentTimezone.default.tz(value, timezone) : (0, _momentTimezone.default)(value);
    return time.format(format);
  });
}

},{"@babel/runtime/helpers/interopRequireDefault":1050,"config":831,"knockout":"knockout","moment-timezone":"moment-timezone","utils/core-utils":1027}],931:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = isModified;

var _knockout = _interopRequireDefault(require("knockout"));

var _coreUtils = require("utils/core-utils");

/* Copyright (C) 2016 NooBaa */
function isModified(target, expr) {
  if (!_knockout.default.isComputed(target) && !_knockout.default.isWriteableObservable(target)) {
    throw new TypeError('Invalid target, must be a non writeable computed observable');
  }

  if (!(0, _coreUtils.isFunction)(expr)) {
    throw new TypeError('Invalid expression, must be a function or observable');
  }

  target.isModified = _knockout.default.computed({
    read: expr,
    write: _coreUtils.noop
  });
}

},{"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","utils/core-utils":1027}],932:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = register;

var _tween = _interopRequireDefault(require("./tween"));

var _formatSize = _interopRequireDefault(require("./format-size"));

var _formatNumber = _interopRequireDefault(require("./format-number"));

var _formatTime = _interopRequireDefault(require("./format-time"));

var _isModified = _interopRequireDefault(require("./is-modified"));

var _compareUsing = _interopRequireDefault(require("./compare-using"));

/* Copyright (C) 2016 NooBaa */
function register(ko) {
  Object.assign(ko.extenders, {
    tween: _tween.default,
    formatSize: _formatSize.default,
    formatNumber: _formatNumber.default,
    formatTime: _formatTime.default,
    isModified: _isModified.default,
    compareUsing: _compareUsing.default
  });
}

},{"./compare-using":927,"./format-number":928,"./format-size":929,"./format-time":930,"./is-modified":931,"./tween":933,"@babel/runtime/helpers/interopRequireDefault":1050}],933:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = tweenExtender;

var _knockout = _interopRequireDefault(require("knockout"));

var _shifty = require("shifty");

/* Copyright (C) 2016 NooBaa */
function tweenExtender(target, {
  duration = 1000,
  delay = 0,
  easing = 'easeOutQuad',
  resetValue = target(),
  resetOnChange = false,
  useDiscreteValues = false
}) {
  const result = _knockout.default.observable(resetValue);

  (0, _shifty.tween)({
    from: {
      val: resetValue
    },
    to: {
      val: target()
    },
    delay,
    duration,
    easing,
    step: ({
      val
    }) => result(val)
  }); // Create a pure observable to control the life time of the subscription
  // and to allow for automatic disposing in order to prevent memory leaks.

  const pure = _knockout.default.pureComputed(useDiscreteValues ? () => Math.round(result()) : result);

  let subscription;
  pure.subscribe(() => {
    subscription = target.subscribe(val => (0, _shifty.tween)({
      from: {
        val: resetOnChange ? 0 : result()
      },
      to: {
        val
      },
      delay,
      duration,
      easing,
      step: ({
        val
      }) => result(val)
    }));
  }, null, 'awake');
  pure.subscribe(() => {
    subscription.dispose();
  }, null, 'asleep');
  return pure;
}

},{"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","shifty":"shifty"}],934:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _knockout = _interopRequireDefault(require("knockout"));

var _stringUtils = require("utils/string-utils");

var _coreUtils = require("utils/core-utils");

/* Copyright (C) 2016 NooBaa */
// -----------------------------------------
// Knockout object extnesions
// -----------------------------------------
// @DEPRECATED
_knockout.default.observableWithDefault = function (valueAccessor) {
  const storage = _knockout.default.observable();

  return _knockout.default.pureComputed({
    read: () => (0, _coreUtils.isUndefined)(storage()) ? _knockout.default.unwrap(valueAccessor()) : storage(),
    write: storage
  });
}; // @DEPRECATED


_knockout.default.touched = function (root) {
  let initialized = false;

  const trigger = _knockout.default.observable(false);

  return _knockout.default.pureComputed({
    read: () => {
      trigger();

      if (!initialized) {
        _knockout.default.deepUnwrap(root);

        initialized = true;
        return false;
      }

      return true;
    },
    write: () => {
      initialized = false;
      trigger.toggle();
    }
  });
}; // @DEPRECATED


_knockout.default.group = function (...observables) {
  return _knockout.default.pureComputed(() => observables.map(obs => _knockout.default.unwrap(obs)));
};

_knockout.default.deepUnwrap = function (value) {
  const naked = _knockout.default.unwrap(value);

  if ((0, _coreUtils.isObject)(naked)) {
    let needUnwrap = false;
    const res = Object.entries(naked).reduce((res, [key, val]) => {
      res[key] = _knockout.default.deepUnwrap(val);
      needUnwrap = res[key] !== val || needUnwrap;
      return res;
    }, Array.isArray(naked) ? [] : {});
    return needUnwrap ? res : naked;
  } else {
    return naked;
  }
};

_knockout.default.renderToString = function (template, data) {
  const doc = new DOMParser().parseFromString(template, 'text/html');

  _knockout.default.applyBindings(data, doc.body);

  const htmlString = doc.body.innerHTML.toString();

  _knockout.default.cleanNode(doc);

  return htmlString;
};

_knockout.default.pc = function (read, write, owner) {
  return _knockout.default.pureComputed({
    read,
    write,
    owner
  });
};

_knockout.default.isObservableArray = function (obs) {
  return _knockout.default.isObservable(obs) && typeof obs.push === 'function';
};

_knockout.default.fromRx = function (stream$) {
  const value = _knockout.default.observable();

  let streamSub = null;

  function onAwake() {
    streamSub = stream$.subscribe(value);
  }

  function onAsleep() {
    streamSub.unsubscribe();
    streamSub = null;
  }

  const pure = _knockout.default.pureComputed(value);

  pure.subscribe(onAwake, null, 'awake');
  pure.subscribe(onAsleep, null, 'asleep');
  return pure;
}; // Smart and fast assign of values to view model props.
// Take into account observables, observable arrays, typed observables
// and typed observable arrays.


Object.assign(_knockout.default, (ko => {
  const updateFuncs = new WeakMap();
  const templates = (0, _coreUtils.deepFreeze)({
    STRUCT: (accessor, propValue) => {
      const block = _generateStructUpdateCode(propValue);

      return !block ? '' : `
                if (parent = vm, typeof (value = values${accessor}) !== 'undefined') {
                    const values = value, vm = parent${accessor};
                    ${block}
                }
            `;
    },
    VALUE: (accessor, _, owner) => {
      return Object.isFrozen(owner) ? '' : `
                if (typeof (value = values${accessor}) !== 'undefined') vm${accessor} = value;
            `;
    },
    OBS: accessor => `
            if (typeof (value = values${accessor}) !== 'undefined') vm${accessor}(value);
        `,
    TYPED_OBS: accessor => `
            if (typeof (value = values${accessor}) !== 'undefined') {
                const obs = vm${accessor};
                utils.updateTypedObs(obs, value, utils);
            }
        `,
    TYPED_OBS_ARRAY: accessor => `
            if (typeof (value = values${accessor}) !== 'undefined') {
                const obs = vm${accessor};
                utils.updateTypedObsArray(obs, value, utils);
            }
        `
  });
  const utils = (0, _coreUtils.deepFreeze)({
    updateTypedObsArray: _updateTypedObsArray,
    updateTypedObs: _updateTypedObs
  });

  function _getPropType(value) {
    if (ko.isObservableArray(value)) {
      return value.typeInfo ? 'TYPED_OBS_ARRAY' : 'OBS';
    } else if (ko.isWritableObservable(value)) {
      return value.typeInfo ? 'TYPED_OBS' : 'OBS';
    } else if (!ko.isObservable(value) && !(0, _coreUtils.isFunction)(value)) {
      return true && Array.isArray(value) && value.length > 0 && 'STRUCT' || (0, _coreUtils.isObject)(value) && Object.keys(value).length > 0 && 'STRUCT' || 'VALUE';
    } else {
      return 'UNSUPPORTED';
    }
  }

  function _generateStructUpdateCode(vm) {
    const isArray = Array.isArray(vm);
    return Object.entries(vm).map(pair => {
      const [propName, propValue] = pair;

      const propType = _getPropType(propValue);

      if (propType === 'UNSUPPORTED') {
        return '';
      } else {
        const isIndex = isArray && Number.isInteger(Number(propName));
        const propAccessor = `[${isIndex ? propName : `'${propName}'`}]`;
        return templates[propType](propAccessor, propValue, vm).trim();
      }
    }).filter(Boolean).join('\n');
  }

  function _generateUpdateFunction(vm) {
    const body = `
            let value, parent;
            ${_generateStructUpdateCode(vm)}
        `.trim();
    return new Function('vm', 'values', 'utils', body);
  }

  function _updateTypedObsArray(obsArray, value, utils) {
    const {
      Type,
      params
    } = obsArray.typeInfo;
    const items = value.map((item, i) => {
      const itemVm = obsArray.peek()[i] || new Type(params);

      const update = _getUpdateFunc(itemVm);

      update(itemVm, item, utils);
      return itemVm;
    });
    obsArray(items);
  }

  function _updateTypedObs(obs, value, utils) {
    if (value === null) {
      obs(null);
    } else {
      const {
        Type,
        params
      } = obs.typeInfo;
      let valueVm = obs.peek();
      if (valueVm == null) obs(valueVm = new Type(params));

      const update = _getUpdateFunc(valueVm);

      update(valueVm, value, utils);
    }
  }

  function _getUpdateFunc(obj) {
    const Type = obj.constructor;
    let update = updateFuncs.get(Type);

    if (!update) {
      updateFuncs.set(Type, update = _generateUpdateFunction(obj));
    }

    return update;
  }

  return {
    getAssignToPropHelper: _getUpdateFunc,
    assignToProps: function (vm, values) {
      const update = _getUpdateFunc(vm);

      update(vm, values, utils);
    }
  };
})(_knockout.default)); // -----------------------------------------
// Knockout subscribable extnesions
// -----------------------------------------

_knockout.default.subscribable.fn.toggle = function () {
  this(!this());
  return this;
};

_knockout.default.subscribable.fn.assign = function (data) {
  const changes = _knockout.default.unwrap(data);

  const value = (0, _coreUtils.isUndefined)(this()) ? changes : Object.assign(this(), changes);
  this(value);
  return this;
};

_knockout.default.subscribable.fn.once = function (callback, ctx, event) {
  const sub = this.subscribe(val => {
    sub.dispose();
    callback(val);
  }, ctx, event);
  return sub;
};

_knockout.default.subscribable.fn.debug = function (prefix) {
  prefix ? console.debug(prefix, this()) : console.debug(this());
  return this.subscribe(val => prefix ? console.debug(prefix, val) : console.debug(val));
};

_knockout.default.subscribable.fn.eq = function (value) {
  return _knockout.default.pureComputed(() => this() === _knockout.default.unwrap(value));
};

_knockout.default.subscribable.fn.notEq = function (value) {
  return _knockout.default.pureComputed(() => this() !== _knockout.default.unwrap(value));
};

_knockout.default.subscribable.fn.in = function (values) {
  return _knockout.default.pureComputed(() => _knockout.default.unwrap(values).includes(this()));
};

_knockout.default.subscribable.fn.oneOf = function (...values) {
  return _knockout.default.pureComputed(() => values.includes(this()));
};

_knockout.default.subscribable.fn.when = function (condition = Boolean) {
  const val = this.peek();

  if (condition(val)) {
    return Promise.resolve(val);
  } else {
    return new Promise(resolve => {
      const sub = this.subscribe(val => {
        if (condition(val)) {
          sub.dispose();
          resolve(val);
        }
      });
    });
  }
};

_knockout.default.subscribable.fn.throttle = function (duration = 1, owner) {
  return _knockout.default.pureComputed({
    read: this,
    write: (0, _coreUtils.throttle)(val => this(val), duration),
    owner: owner
  });
};

_knockout.default.subscribable.fn.ofType = function (Type, params) {
  if (typeof Type !== 'function') {
    throw new TypeError('Must be a constructor function');
  }

  this.typeInfo = {
    Type,
    params
  };
  return this;
};

_knockout.default.observable.fn.map = function (mapOp) {
  let prevItems = [];

  const projected = _knockout.default.pureComputed(() => {
    const current = this();

    if (Array.isArray(current)) {
      const prev = prevItems;
      return (prevItems = current).map((item, i) => item === prev[i] ? projected.peek()[i] : mapOp(item));
    } else {
      return prevItems = [];
    }
  });

  return projected;
};

_knockout.default.observableArray.fn.get = function (i) {
  return this()[i];
};

_knockout.default.observableArray.fn.peek = function (i) {
  if ((0, _coreUtils.isNumber)(i)) {
    return _knockout.default.observable.fn.peek.call(this)[i];
  } else {
    return _knockout.default.observable.fn.peek.call(this);
  }
}; // -----------------------------------------
// Knockout validation specific extentions
// -----------------------------------------


const kv = _knockout.default.validation;
const kvGroup = kv.group;

function getRuleValidationState(observable, appliedRule) {
  const {
    rule = 'inline',
    params,
    validator = kv.rules[rule].validator,
    message = kv.rules[rule].message
  } = appliedRule;
  return {
    rule: rule,
    isValid: validator(observable(), params),
    message: kv.formatMessage(message, params, observable)
  };
}

function validatingCount() {
  return this.filter(obj => obj.isValidating()).length;
}

_knockout.default.validation.fullValidationState = function (observable) {
  return _knockout.default.pureComputed(() => {
    const rules = observable.rules;

    if (!rules) {
      return [];
    }

    return rules().map(rule => getRuleValidationState(observable, rule));
  });
};

_knockout.default.validation.group = function (obj, options) {
  return Object.assign(kvGroup(obj, options), {
    validatingCount
  });
};

// -----------------------------------------
// Binding syntax extentions
// -----------------------------------------
const bindPrefix = 'ko.';
const magicBindingName = '@';
const magicBindings = new Map();
const bindingNameMapping = new Map();
const origGetBindingHandler = _knockout.default.getBindingHandler;
const copyrightsIdentifiers = (0, _coreUtils.deepFreeze)(['copyright', 'noobaa']);
const preprocessByNodeType = (0, _coreUtils.deepFreeze)({
  [Node.ELEMENT_NODE]: preprocessElement,
  [Node.TEXT_NODE]: preprocessTextNode,
  [Node.COMMENT_NODE]: preprocessComment
});

function getCanonicalBindingName(name) {
  if ((0, _coreUtils.hasOwn)(_knockout.default.bindingHandlers, name)) {
    return name;
  }

  if (bindingNameMapping.has(name)) {
    return bindingNameMapping.get(name);
  }

  const canonicalName = Object.keys(_knockout.default.bindingHandlers).find(other => (0, _stringUtils.equalIgnoreCase)(name, other));

  if (canonicalName) {
    bindingNameMapping.set(name, canonicalName);
    return canonicalName;
  }

  return null;
}

function preprocessElement(node) {
  const {
    attributes,
    dataset
  } = node;
  const bindings = Array.from(attributes).filter(({
    name
  }) => name.startsWith(bindPrefix)).map(({
    name,
    value
  }) => {
    const [key, subKey] = name.substr(bindPrefix.length).split('.');
    const canonicalKey = getCanonicalBindingName(key);
    const bindingName = subKey ? `${canonicalKey}.${subKey}` : canonicalKey;
    return [bindingName, value];
  });

  if (bindings.length > 0) {
    const key = (0, _stringUtils.randomString)();
    magicBindings.set(key, bindings);

    if (dataset.bind) {
      dataset.bind += `,${magicBindingName}:${key}`;
    } else {
      dataset.bind = `${magicBindingName}:${key}`;
    }
  }
}

function preprocessTextNode(node) {
  node.normalize();
  const before = node.nodeValue;
  const after = before.replace(/\{\{[\s\S]*?\}\}/g, match => {
    const expr = match.substr(2, match.length - 4);
    return `'+ko.unwrap(${expr})+'`;
  });

  if (after !== before) {
    // Replace tabs and newlines with spaces because knokcout virtual elements
    // has problem in parseing multiline expressions.
    const expr = after.replace(/\s+/g, () => ' ');
    const parent = node.parentNode;
    const nodes = [document.createComment(` ko text: '${expr}' `), document.createComment(' /ko ')];
    parent.insertBefore(nodes[0], node);
    parent.replaceChild(nodes[1], node);
    return nodes;
  }
}

function preprocessComment(comment) {
  // Remove copyright comments from templates.
  const text = comment.nodeValue.toLowerCase();

  if (copyrightsIdentifiers.every(identifier => text.includes(identifier))) {
    comment.parentNode.removeChild(comment);
    return [];
  }
}

function subclassBindingHandler(key, handler) {
  return Object.assign(Object.create(handler), {
    init: handler.init && ((a, b, c, d, e) => handler.init(a, () => ({
      [key]: b()
    }), c, d, e)),
    update: handler.update && ((a, b, c, d, e) => handler.update(a, () => ({
      [key]: b()
    }), c, d, e))
  });
}

_knockout.default.bindingProvider.instance.preprocessNode = function (node) {
  const preprocess = preprocessByNodeType[node.nodeType];
  return preprocess && preprocess(node);
};

_knockout.default.getBindingHandler = function (name) {
  let handler = origGetBindingHandler(name);
  if (handler) return handler;
  const [key, subKey] = name.split('.');

  if (subKey) {
    handler = origGetBindingHandler(key);

    if (handler) {
      handler = subclassBindingHandler(subKey, handler);
      _knockout.default.bindingHandlers[name] = handler;
    }
  }

  return handler;
};

_knockout.default.bindingHandlers[magicBindingName] = {
  preprocess(key, _, addBinding) {
    for (const [name, value] of magicBindings.get(key)) {
      addBinding(name, value);
    }

    magicBindings.delete(key);
  }

};

},{"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","utils/core-utils":1027,"utils/string-utils":1046}],935:[function(require,module,exports){
(function (global){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _knockout = _interopRequireDefault(require("knockout"));

require("knockout-projections");

require("knockout-validation");

require("knockout-extensions");

var _operators = require("rxjs/operators");

var _register = _interopRequireDefault(require("extenders/register"));

var _validations = _interopRequireDefault(require("validations"));

var _register2 = _interopRequireDefault(require("bindings/register"));

var _register3 = _interopRequireDefault(require("components/register"));

var _page = _interopRequireDefault(require("page"));

var _routing = _interopRequireDefault(require("routing"));

var _state = require("state");

var _services = require("services");

var _actionCreators = require("action-creators");

var _devCli = _interopRequireDefault(require("dev-cli"));

var _actionsModelBridge = _interopRequireDefault(require("actions-model-bridge"));

var _epics = _interopRequireDefault(require("epics"));

var _stateSideEffects = _interopRequireDefault(require("state-side-effects"));

var _supportability = _interopRequireDefault(require("supportability.js"));

var _config = _interopRequireDefault(require("config"));

var _coreUtils = require("utils/core-utils");

var browser = _interopRequireWildcard(require("utils/browser-utils"));

/* Copyright (C) 2016 NooBaa */
function configureKnockout(ko) {
  const injectedServices = {
    api: _services.api,
    state$: _state.state$,
    action$: _state.action$
  }; // Enable knockout 3.4 deferred updates.

  ko.options.deferUpdates = true; // Setup validation policy.

  ko.validation.init({
    errorMessageClass: 'val-msg',
    decorateInputElement: true,
    errorElementClass: 'invalid',
    errorsAsTitle: false,
    messagesOnModified: true,
    writeInputAttributes: true
  }); // Register custom extenders, bindings, components and validation rules.

  (0, _register.default)(ko);
  (0, _register2.default)(ko);
  (0, _validations.default)(ko);
  (0, _register3.default)(ko, injectedServices);
}

function registerSideEffects(action$, state$) {
  const injectedServices = {
    random: Math.random,
    getTime: Date.now,
    localStorage: localStorage,
    sessionStorage: sessionStorage,
    fetch: fetch,
    AWS: _services.AWS,
    api: _services.api,
    router: _page.default,
    browser: browser,
    bufferStore: _services.bufferStore
  };
  (0, _epics.default)(action$, injectedServices).pipe((0, _operators.filter)(Boolean)).subscribe(action$);
  (0, _supportability.default)(_state.record$, injectedServices);
  (0, _stateSideEffects.default)(state$, injectedServices);
}

async function patchConfig() {
  try {
    const response = await fetch(_config.default.patchFile);

    try {
      const patch = await response.json();
      (0, _coreUtils.deepAssign)(_config.default, patch);
      console.info(`PATH_CONFIG ${_config.default.patchFile}`);
    } catch (err) {
      console.warn(`PATCH_CONFIG malformed file ${_config.default.patchFile}: ${err.message}`);
    }
  } catch (_) {
    (0, _coreUtils.noop)();
  }
}

async function main() {
  // Patch the app configuration using a server served patch file.
  await patchConfig();
  configureKnockout(_knockout.default); // Configure the appliction router.

  (0, _routing.default)(_page.default);
  registerSideEffects(_state.action$, _state.state$); // Bridge between the action stream and the old model

  (0, _actionsModelBridge.default)(_state.action$); // Mount dev cli on the global scope.

  global.nb = _devCli.default; // Bind the ui to the

  _knockout.default.applyBindings(null, document.querySelector('app'));

  _state.action$.next((0, _actionCreators.setupEnv)(browser.recognizeBrowser()));

  _state.action$.next((0, _actionCreators.restoreSession)());
}

main();

}).call(this,typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})

},{"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"actions-model-bridge":319,"bindings/register":333,"components/register":684,"config":831,"dev-cli":832,"epics":882,"extenders/register":932,"knockout":"knockout","knockout-extensions":934,"knockout-projections":"knockout-projections","knockout-validation":"knockout-validation","page":"page","routing":973,"rxjs/operators":287,"services":1013,"state":1016,"state-side-effects":1015,"supportability.js":1017,"utils/browser-utils":1021,"utils/core-utils":1027,"validations":1048}],936:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.resetPasswordState = exports.collectDiagnosticsState = exports.nodeTestInfo = exports.systemInfo = exports.serverInfo = exports.sessionInfo = exports.loginInfo = exports.routeContext = void 0;

var _knockout = _interopRequireDefault(require("knockout"));

/* Copyright (C) 2016 NooBaa */
// Hold the current route context. The rate limit delay the route context change notification
// in order to let knockout time t teardown and dispose view models that may be depended on
// the route context value (mainly it's parameters).
const routeContext = _knockout.default.observable().extend({
  rateLimit: 1
}); // Hold login state information.


exports.routeContext = routeContext;

const loginInfo = _knockout.default.observable({
  retryCount: 0
}); // Hold current session information.


exports.loginInfo = loginInfo;

const sessionInfo = _knockout.default.observable(); // Hold the state of the server.


exports.sessionInfo = sessionInfo;

const serverInfo = _knockout.default.observable(); // Hold current system information.


exports.serverInfo = serverInfo;

const systemInfo = _knockout.default.observable(); // Hold node test information.


exports.systemInfo = systemInfo;

const nodeTestInfo = _knockout.default.observable(); // Hold diagnostics information


exports.nodeTestInfo = nodeTestInfo;

const collectDiagnosticsState = _knockout.default.observable({}); // Hold last rest password attampt result (only used in change-password-form);


exports.collectDiagnosticsState = collectDiagnosticsState;

const resetPasswordState = _knockout.default.observable();

exports.resetPasswordState = resetPasswordState;

},{"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout"}],937:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/* Copyright (C) 2016 NooBaa */
const subscriptionsSym = Symbol('subscriptions');

class Observer {
  constructor() {
    this[subscriptionsSym] = [];
  }

  observe(subject, handler, target = this) {
    const sub = subject.subscribe(handler.bind(target));
    this[subscriptionsSym].push(sub);
  }

  dispose() {
    for (const sub of this[subscriptionsSym]) {
      if (typeof sub.dispose === 'function') {
        sub.dispose(); // Added to support rxjs subscription disposals.
      } else if (typeof sub.unsubscribe === 'function') {
        sub.unsubscribe();
      }
    }
  }

}

exports.default = Observer;

},{}],938:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _reducerUtils = require("utils/reducer-utils");

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
// ------------------------------
// Initial State
// ------------------------------
const initialState = {
  query: undefined,
  samples: undefined,
  fetching: false,
  error: false
}; // ------------------------------
// Action Handlers
// ------------------------------

function onFetchAccountUsageHistory(state, {
  payload
}) {
  return { ...initialState,
    query: payload,
    fetching: true
  };
}

function onCompleteFetchAccountUsageHistory(state, {
  payload
}) {
  if (payload.query !== state.query) {
    return state;
  }

  return { ...state,
    fetching: false,
    error: false,
    samples: payload.usage.map(sample => ({
      account: sample.account,
      readSize: sample.read_bytes,
      writeSize: sample.write_bytes
    }))
  };
}

function onFailFetchAccountUsageHistory(state, {
  payload
}) {
  if (payload.query !== state.query) {
    return state;
  }

  return { ...state,
    error: true
  };
}

function onDropAccountUsageHistory() {
  return initialState;
} // ------------------------------
// Local util functions
// ------------------------------
// ------------------------------
// Exported reducer function
// ------------------------------


var _default = (0, _reducerUtils.createReducer)(initialState, {
  [_actionTypes.FETCH_ACCOUNT_USAGE_HISTORY]: onFetchAccountUsageHistory,
  [_actionTypes.COMPLETE_FETCH_ACCOUNT_USAGE_HISTORY]: onCompleteFetchAccountUsageHistory,
  [_actionTypes.FAIL_FETCH_ACCOUNT_USAGE_HISTORY]: onFailFetchAccountUsageHistory,
  [_actionTypes.DROP_ACCOUNT_USAGE_HISTORY]: onDropAccountUsageHistory
});

exports.default = _default;

},{"action-types":318,"utils/reducer-utils":1040}],939:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _reducerUtils = require("utils/reducer-utils");

var _coreUtils = require("utils/core-utils");

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
// ------------------------------
// Initial State
// ------------------------------
const initialState = undefined; // ------------------------------
// Action Handlers
// ------------------------------

function onCompleteFetchSystemInfo(_, {
  payload
}) {
  const {
    name: systemName,
    buckets,
    accounts,
    owner,
    pools
  } = payload;
  const allBuckets = buckets.map(bucket => bucket.name);
  const accountsOwningBuckets = new Set(buckets.map(b => b.owner_account.email));
  return (0, _coreUtils.keyByProperty)(accounts, 'email', account => _mapAccount(account, owner, systemName, pools, allBuckets, accountsOwningBuckets));
} // ------------------------------
// Local util functions
// ------------------------------


function _mapAccount(account, owner, systemName, pools, allBuckets, accountsOwningBuckets) {
  const {
    email,
    has_login,
    is_external,
    access_keys,
    has_s3_access,
    default_pool,
    allowed_buckets,
    can_create_buckets,
    allowed_ips,
    external_connections
  } = account;
  const {
    access_key: accessKey,
    secret_key: secretKey
  } = access_keys[0];
  const hasAccessToAllBuckets = has_s3_access && allowed_buckets.full_permission;
  const allowedBuckets = has_s3_access ? hasAccessToAllBuckets ? allBuckets : allowed_buckets.permission_list : [];

  const externalConnections = _mapExternalConnections(external_connections);

  const internalResource = pools.find(pool => pool.resource_type === 'INTERNAL');
  const {
    roles
  } = account.systems.find(system => system.name === systemName);
  const isOwner = Boolean(email === owner.email);
  const undeletable = isOwner && 'OWNER' || accountsOwningBuckets.has(email) && 'OWN_BUCKET' || undefined;
  return {
    name: email,
    isAdmin: has_login,
    isOwner,
    isExternal: Boolean(is_external),
    // is_external might be undefined
    hasAccessToAllBuckets,
    allowedBuckets,
    canCreateBuckets: Boolean(has_s3_access && can_create_buckets),
    defaultResource: default_pool !== internalResource.name ? default_pool : 'INTERNAL_STORAGE',
    accessKeys: {
      accessKey,
      secretKey
    },
    allowedIps: allowed_ips,
    externalConnections,
    undeletable,
    roles
  };
}

function _mapExternalConnections(externalConnections) {
  return externalConnections.connections.map(conn => {
    const {
      name,
      auth_method,
      endpoint_type,
      identity,
      cp_code
    } = conn;
    const endpoint = cp_code ? `${conn.endpoint} at ${cp_code}` : conn.endpoint;
    const service = endpoint_type === 'S3_COMPATIBLE' ? auth_method === 'AWS_V2' ? 'S3_V2_COMPATIBLE' : 'S3_V4_COMPATIBLE' : endpoint_type;
    return {
      name,
      service,
      endpoint,
      identity,
      usage: conn.usage.map(record => ({
        entity: record.entity,
        externalEntity: record.external_entity,
        usageType: record.usage_type
      }))
    };
  });
} // ------------------------------
// Exported reducer function
// ------------------------------


var _default = (0, _reducerUtils.createReducer)(initialState, {
  [_actionTypes.COMPLETE_FETCH_SYSTEM_INFO]: onCompleteFetchSystemInfo
});

exports.default = _default;

},{"action-types":318,"utils/core-utils":1027,"utils/reducer-utils":1040}],940:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _coreUtils = require("utils/core-utils");

var _reducerUtils = require("utils/reducer-utils");

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
// ------------------------------
// Initial state
// ------------------------------
const initialState = {
  loading: 0,
  loadError: null,
  filter: {},
  list: [],
  endOfList: false,
  unreadCounts: {}
}; // ------------------------------
// Action Handlers
// ------------------------------

function onFetchAlerts(state, {
  payload
}) {
  const {
    query
  } = payload;
  const loading = state.loading + 1;
  const loadError = null;
  const {
    severity,
    read
  } = query;
  const {
    filter
  } = state;

  if (severity === filter.severity && read === filter.read) {
    return { ...state,
      loading,
      loadError
    };
  } else {
    const filter = {
      severity,
      read
    };
    const list = [];
    const endOfList = false;
    return { ...state,
      loading,
      loadError,
      filter,
      list,
      endOfList
    };
  }
}

function onCompleteFetchAlerts(state, {
  payload
}) {
  let {
    requested,
    list
  } = payload;
  const loading = state.loading - 1;

  if (loading === 0) {
    const endOfList = list.length < requested;
    list = (0, _coreUtils.mergeBy)(state.list, list, item => item.id).sort((a, b) => -1 * (0, _coreUtils.compare)(a.id, b.id));
    return { ...state,
      list,
      endOfList,
      loading
    };
  } else {
    return { ...state,
      loading
    };
  }
}

function onFailFetchAlerts(state, {
  payload
}) {
  const loading = state.loading - 1;

  if (loading === 0) {
    const {
      message: loadError
    } = payload.error;
    return { ...state,
      loading,
      loadError
    };
  } else {
    return { ...state,
      loading
    };
  }
}

function onUpdateAlerts(state, {
  payload
}) {
  const {
    query
  } = payload;
  const list = state.list.map(item => _matches(item, query) ? { ...item,
    updating: true
  } : item);
  return { ...state,
    list
  };
}

function onCompleteUpdateAlerts(state, {
  payload
}) {
  const {
    query,
    read
  } = payload;
  const list = state.list.map(item => _matches(item, query) ? { ...item,
    updating: false,
    read: read
  } : item);
  return { ...state,
    list
  };
}

function onFailUpdateAlerts(state, {
  payload
}) {
  const {
    query
  } = payload;
  const list = state.list.map(item => _matches(item, query) ? { ...item,
    updating: false
  } : item);
  return { ...state,
    list
  };
}

function onCompleteFetchUnreadAlertsCount(state, {
  payload
}) {
  return { ...state,
    unreadCounts: payload
  };
}

function onDropAlerts(state) {
  const {
    unreadCounts
  } = state;
  return { ...initialState,
    unreadCounts
  };
} // ------------------------------
// Local util functions
// ------------------------------


function _matches(item, {
  ids,
  severity,
  read
}) {
  return true && ((0, _coreUtils.isUndefined)(ids) || ids.includes(item.id)) && ((0, _coreUtils.isUndefined)(severity) || item.severity === severity) && ((0, _coreUtils.isUndefined)(read) || item.read === read);
} // ------------------------------
// Exported reducer function.
// ------------------------------


var _default = (0, _reducerUtils.createReducer)(initialState, {
  [_actionTypes.FETCH_ALERTS]: onFetchAlerts,
  [_actionTypes.COMPLETE_FETCH_ALERTS]: onCompleteFetchAlerts,
  [_actionTypes.FAIL_FETCH_ALERTS]: onFailFetchAlerts,
  [_actionTypes.UPDATE_ALERTS]: onUpdateAlerts,
  [_actionTypes.COMPLETE_UPDATE_ALERTS]: onCompleteUpdateAlerts,
  [_actionTypes.FAIL_UPDATE_ALERTS]: onFailUpdateAlerts,
  [_actionTypes.COMPLETE_FETCH_UNREAD_ALERTS_COUNT]: onCompleteFetchUnreadAlertsCount,
  [_actionTypes.DROP_ALERTS]: onDropAlerts
});

exports.default = _default;

},{"action-types":318,"utils/core-utils":1027,"utils/reducer-utils":1040}],941:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _reducerUtils = require("utils/reducer-utils");

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
// ------------------------------
// Initial state
// ------------------------------
const initialState = {
  loading: 0,
  loadError: null,
  categories: [],
  list: [],
  endOfList: false,
  selectedRecord: ''
}; // ------------------------------
// Action Handlers
// ------------------------------

function onFetchAuditLog(state, {
  payload
}) {
  const categories = [...payload.query.categories].sort();

  if (categories.toString() === state.categories.toString()) {
    return { ...state,
      loading: state.loading + 1,
      loadError: null
    };
  } else {
    return { ...initialState,
      categories,
      loading: state.loading + 1
    };
  }
}

function onCompleteFetchAuditLog(state, {
  payload
}) {
  if (state.loading > 1) {
    return { ...state,
      loading: state.loading - 1
    };
  } else {
    const {
      requested,
      list
    } = payload;
    const endOfList = list.length < requested;
    return { ...state,
      endOfList,
      loading: 0,
      list: [...state.list, ...list.map(_mapAuditRecord)]
    };
  }
}

function onFailFetchAuditLog(state, {
  payload
}) {
  if (state.loading > 1) {
    return { ...state,
      loading: state.loading - 1
    };
  } else {
    return { ...state,
      loading: 0,
      loadError: payload.error.message
    };
  }
}

function onDropAuditLog() {
  return initialState;
}

function onSelectAuditRecord(state, {
  payload
}) {
  const {
    recordId
  } = payload;

  if (state.list.every(record => record.id !== recordId)) {
    return state;
  }

  return { ...state,
    selectedRecord: recordId
  };
} // ------------------------------
// Local util functions
// ------------------------------


function _mapAuditRecord(record) {
  const {
    id,
    time,
    actor
  } = record;
  const [category, event] = record.event.split('.');
  const desc = record.desc.map(line => line.trim()).filter(Boolean).join('\n');
  return {
    id,
    time,
    actor: actor && {
      name: actor.email,
      linkable: actor.linkable
    },
    category,
    event,
    entity: _getEntity(record),
    desc
  };
}

function _getEntity(record) {
  switch (record.event) {
    case 'node.create':
    case 'node.test_node':
    case 'node.decommission':
    case 'node.storage_disabled':
    case 'node.storage_enabled':
    case 'node.edit_drives':
    case 'node.endpoint_disabled':
    case 'node.endpoint_enabled':
    case 'node.recommission':
    case 'node.connected':
    case 'node.deleted':
    case 'node.delete_started':
    case 'node.untrusted':
    case 'node.retrust':
    case 'node.disconnected':
    case 'dbg.set_debug_node':
      {
        if (!record.node) {
          return;
        }

        const {
          name,
          pool,
          linkable
        } = record.node;
        return {
          kind: 'node',
          linkable,
          name,
          pool
        };
      }

    case 'obj.uploaded':
    case 'obj.deleted':
      {
        if (!record.obj) {
          return;
        }

        const {
          key,
          version,
          bucket,
          linkable
        } = record.obj;
        return {
          kind: 'object',
          linkable,
          key,
          version,
          bucket
        };
      }

    case 'bucket.create':
    case 'bucket.delete':
    case 'bucket.set_cloud_sync':
    case 'bucket.update_cloud_sync':
    case 'bucket.remove_cloud_sync':
    case 'bucket.edit_policy':
    case 'bucket.edit_resiliency':
    case 'bucket.s3_access_updated':
    case 'bucket.set_lifecycle_configuration_rules':
    case 'bucket.quota':
    case 'bucket.versioning':
    case 'bucket.delete_lifecycle_configuration_rules':
      {
        if (!record.bucket) {
          return;
        }

        const {
          linkable,
          name
        } = record.bucket;
        return {
          kind: 'bucket',
          linkable,
          name
        };
      }

    case 'account.create':
    case 'account.update':
    case 'account.delete':
    case 'account.s3_access_updated':
    case 'account.generate_credentials':
    case 'account.connection_create':
    case 'account.connection_delete':
      {
        if (!record.account) {
          return;
        }

        const {
          linkable,
          email
        } = record.account;
        return {
          kind: 'account',
          linkable,
          name: email
        };
      }

    case 'resource.create':
    case 'resource.delete':
    case 'resource.cloud_create':
    case 'resource.cloud_delete':
    case 'resource.assign_nodes':
    case 'resource.pool_assign_region':
    case 'resource.cloud_assign_region':
    case 'resource.scale':
      {
        if (!record.pool) {
          return;
        }

        const {
          linkable,
          name,
          resource_type
        } = record.pool;
        return {
          kind: 'resource',
          linkable,
          name,
          resourceType: resource_type
        };
      }

    case 'dbg.set_server_debug_level':
    case 'cluster.added_member_to_cluster':
    case 'cluster.set_server_conf':
      {
        const {
          hostname,
          secret
        } = record.server;

        if (!hostname || !secret) {
          return;
        }

        return {
          kind: 'server',
          linkable: true,
          name: `${hostname}-${secret}`
        };
      }

    case 'functions.func_created':
    case 'functions.func_config_edit':
    case 'functions.func_code_edit':
      {
        if (!record.func) {
          return;
        }

        const {
          linkable,
          name
        } = record.func;
        return {
          kind: 'function',
          linkable,
          name
        };
      }

    default:
      {
        return;
      }
  }
} // ------------------------------
// Exported reducer function.
// ------------------------------


var _default = (0, _reducerUtils.createReducer)(initialState, {
  [_actionTypes.FETCH_AUDIT_LOG]: onFetchAuditLog,
  [_actionTypes.COMPLETE_FETCH_AUDIT_LOG]: onCompleteFetchAuditLog,
  [_actionTypes.FAIL_FETCH_AUDIT_LOG]: onFailFetchAuditLog,
  [_actionTypes.DROP_AUDIT_LOG]: onDropAuditLog,
  [_actionTypes.SELECT_AUDIT_RECORD]: onSelectAuditRecord
});

exports.default = _default;

},{"action-types":318,"utils/reducer-utils":1040}],942:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _reducerUtils = require("utils/reducer-utils");

var _coreUtils = require("utils/core-utils");

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
// ------------------------------
// Initial State
// ------------------------------
const initialState = undefined; // ------------------------------
// Action Handlers
// ------------------------------

function onCompleteFetchSystemInfo(state, {
  payload
}) {
  return (0, _coreUtils.keyByProperty)((0, _coreUtils.flatMap)(payload.buckets, bucket => bucket.triggers.map(trigger => _mapTrigger(bucket, trigger))), 'id');
} // ------------------------------
// Local util functions
// ------------------------------


function _calcTriggerMode(trigger) {
  if (!trigger.enabled) {
    return 'DISABLED';
  }

  if (trigger.permission_problem) {
    return 'MISSING_PERMISSIONS';
  }

  return 'OPTIMAL';
}

function _mapTrigger(bucket, trigger) {
  return {
    id: trigger.id,
    mode: _calcTriggerMode(trigger),
    event: trigger.event_name,
    bucket: {
      kind: bucket.bucket_type === 'REGULAR' ? 'DATA_BUCKET' : 'NAMESPACE_BUCKET',
      name: bucket.name
    },
    func: {
      name: trigger.func_name,
      version: trigger.func_version
    },
    prefix: trigger.object_prefix || '',
    suffix: trigger.object_suffix || '',
    lastRun: trigger.last_run
  };
} // ------------------------------
// Exported reducer function
// ------------------------------


var _default = (0, _reducerUtils.createReducer)(initialState, {
  [_actionTypes.COMPLETE_FETCH_SYSTEM_INFO]: onCompleteFetchSystemInfo
});

exports.default = _default;

},{"action-types":318,"utils/core-utils":1027,"utils/reducer-utils":1040}],943:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _reducerUtils = require("utils/reducer-utils");

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
// ------------------------------
// Initial State
// ------------------------------
const initialState = {
  query: undefined,
  samples: undefined,
  fetching: false,
  error: false
}; // ------------------------------
// Action Handlers
// ------------------------------

function onFetchBucketUsageHistory(state, {
  payload
}) {
  return { ...initialState,
    query: payload,
    fetching: true
  };
}

function onCompleteFetchBucketUsageHistory(state, {
  payload
}) {
  if (payload.query !== state.query) {
    return state;
  }

  return { ...state,
    fetching: false,
    error: false,
    samples: payload.usage.map(sample => ({
      startTime: sample.start_time,
      endTime: sample.end_time,
      readSize: sample.read_bytes,
      writeSize: sample.write_bytes
    }))
  };
}

function onFailFetchBucketUsageHistory(state, {
  payload
}) {
  if (payload.query !== state.query) {
    return state;
  }

  return { ...state,
    fetching: false,
    error: true
  };
}

function onDropBucketUsageHistory() {
  return initialState;
} // ------------------------------
// Local util functions
// ------------------------------
// ------------------------------
// Exported reducer function
// ------------------------------


var _default = (0, _reducerUtils.createReducer)(initialState, {
  [_actionTypes.FETCH_BUCKET_USAGE_HISTORY]: onFetchBucketUsageHistory,
  [_actionTypes.COMPLETE_FETCH_BUCKET_USAGE_HISTORY]: onCompleteFetchBucketUsageHistory,
  [_actionTypes.FAIL_FETCH_BUCKET_USAGE_HISTORY]: onFailFetchBucketUsageHistory,
  [_actionTypes.DROP_BUCKET_USAGE_HISTORY]: onDropBucketUsageHistory
});

exports.default = _default;

},{"action-types":318,"utils/reducer-utils":1040}],944:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _coreUtils = require("utils/core-utils");

var _reducerUtils = require("utils/reducer-utils");

var _resourceUtils = require("utils/resource-utils");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
// ------------------------------
// Initial State
// ------------------------------
const initialState = undefined; // ------------------------------
// Action Handlers
// ------------------------------

function onCompleteFetchSystemInfo(state, {
  payload
}) {
  const dataBuckets = payload.buckets.filter(bucket => bucket.bucket_type === 'REGULAR');
  const tiersByName = (0, _coreUtils.keyByProperty)(payload.tiers, 'name');
  const resTypeByName = (0, _coreUtils.keyByProperty)(payload.pools, 'name', res => res.resource_type);
  return (0, _coreUtils.keyByProperty)(dataBuckets, 'name', bucket => _mapBucket(bucket, tiersByName, resTypeByName));
} // ------------------------------
// Local util functions
// ------------------------------


function _mapBucket(bucket, tiersByName, resTypeByName) {
  const placementRecords = bucket.tiering.tiers.filter(record => !record.disabled).sort((r1, r2) => (0, _coreUtils.compare)(r1.order, r2.order)).map(record => {
    const {
      mode,
      tier: name
    } = record;
    const tier = tiersByName[name];
    return {
      mode,
      tier
    };
  });
  const {
    storage,
    data,
    quota,
    stats,
    policy_modes,
    stats_by_type = []
  } = bucket;
  const {
    resiliency_status,
    quota_status
  } = policy_modes;
  return {
    name: bucket.name,
    mode: bucket.mode,
    storage: (0, _stateUtils.mapApiStorage)(storage.values, storage.last_update),
    data: _mapData(data),
    quota: _mapQuota(quota_status, quota),
    objects: {
      count: bucket.num_objects.value,
      lastUpdate: bucket.num_objects.last_update
    },
    undeletable: bucket.undeletable,
    placement: _mapPlacement(placementRecords, resTypeByName),
    resiliency: _mapResiliency(resiliency_status, placementRecords[0].tier),
    failureTolerance: _mapFailureTolerance(bucket),
    versioning: _mapVersioning(bucket),
    io: _mapIO(stats),
    usageDistribution: _mapUsageDistribution(bucket, resTypeByName),
    statsByDataType: (0, _coreUtils.keyByProperty)(stats_by_type, 'data_type', record => (0, _coreUtils.pick)(record, ['reads', 'writes', 'count', 'size']))
  };
}

function _mapData(data) {
  return {
    lastUpdate: data.last_update,
    size: data.size,
    sizeReduced: data.size_reduced,
    availableForUpload: data.free
  };
}

function _mapQuota(mode, quota) {
  if (!quota) {
    return;
  }

  const {
    size,
    unit
  } = quota;
  return {
    mode,
    size,
    unit
  };
}

function _usingInternalStorage(placement, typeByName) {
  if (placement.length !== 1) {
    return false;
  }

  const {
    mirror_groups
  } = placement[0].tier;

  if (mirror_groups.length !== 1) {
    return false;
  }

  const {
    pools
  } = mirror_groups[0];

  if (pools.length !== 1) {
    return false;
  }

  const poolType = typeByName[pools[0]];

  if (poolType !== 'INTERNAL') {
    return false;
  }

  return true;
}

function _mapPlacement(placement, typeByName) {
  if (_usingInternalStorage(placement, typeByName)) {
    const {
      mode,
      tier
    } = placement[0];
    return {
      tiers: [{
        name: tier.name,
        mode: mode,
        policyType: 'INTERNAL_STORAGE'
      }]
    };
  } else {
    return {
      tiers: placement.map(record => {
        const {
          mode,
          tier
        } = record;
        const {
          name,
          data_placement: policyType,
          mirror_groups
        } = tier;
        const mirrorSets = mirror_groups.sort((g1, g2) => (0, _coreUtils.compare)(g1.name, g2.name)).map(group => {
          const {
            name,
            pools
          } = group;
          const resources = pools.map(name => {
            const type = typeByName[name];
            return {
              type,
              name
            };
          });
          return {
            name,
            resources
          };
        });
        return {
          name,
          mode,
          policyType,
          mirrorSets
        };
      })
    };
  }
}

function _mapResiliency(mode, tier) {
  const {
    data_frags,
    parity_frags,
    replicas
  } = tier.chunk_coder_config;

  if (parity_frags) {
    return {
      kind: 'ERASURE_CODING',
      mode: mode,
      dataFrags: data_frags,
      parityFrags: parity_frags
    };
  } else {
    return {
      kind: 'REPLICATION',
      mode: mode,
      replicas: replicas
    };
  }
}

function _mapFailureTolerance(bucket) {
  const {
    host_tolerance: hosts,
    node_tolerance: nodes
  } = bucket;
  return {
    hosts,
    nodes
  };
}

function _mapIO(stats = {}) {
  const {
    reads = 0,
    writes = 0,
    last_read = -1,
    last_write = -1
  } = stats;
  return {
    readCount: reads,
    lastRead: last_read,
    writeCount: writes,
    lastWrite: last_write
  };
}

function _mapVersioning(bucket) {
  const {
    versioning: mode
  } = bucket;
  return {
    mode
  };
}

function _mapUsageDistribution(bucket, resTypeByName) {
  const {
    last_update,
    pools
  } = bucket.usage_by_pool;
  return {
    lastUpdate: last_update,
    resources: (0, _coreUtils.keyBy)(pools, record => {
      const name = record.pool_name;
      return (0, _resourceUtils.getResourceId)(resTypeByName[name], name);
    }, record => record.storage.blocks_size)
  };
} // ------------------------------
// Exported reducer function
// ------------------------------


var _default = (0, _reducerUtils.createReducer)(initialState, {
  [_actionTypes.COMPLETE_FETCH_SYSTEM_INFO]: onCompleteFetchSystemInfo
});

exports.default = _default;

},{"action-types":318,"utils/core-utils":1027,"utils/reducer-utils":1040,"utils/resource-utils":1041,"utils/state-utils":1044}],945:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _coreUtils = require("utils/core-utils");

var _reducerUtils = require("utils/reducer-utils");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
// ------------------------------
// Initial State
// ------------------------------
const initialState = {}; // ------------------------------
// Action Handlers
// ------------------------------

function onCompleteFetchSystemInfo(_, {
  payload
}) {
  const {
    pools,
    buckets,
    tiers
  } = payload;

  const bucketsByPools = _mapPoolsToBuckets(buckets, tiers);

  return (0, _coreUtils.keyByProperty)(pools.filter(pool => pool.resource_type === 'CLOUD'), 'name', res => _mapResource(res, bucketsByPools));
} // ------------------------------
// Local util functions
// ------------------------------


function _mapResource(resource, bucketsByPools) {
  const {
    name,
    mode,
    cloud_info,
    region,
    storage,
    undeletable,
    create_time,
    io_stats
  } = resource;
  return {
    name,
    mode,
    region,
    type: cloud_info.endpoint_type,
    endpoint: cloud_info.endpoint,
    target: cloud_info.target_bucket,
    storage: (0, _stateUtils.mapApiStorage)(storage),
    usedBy: bucketsByPools[name] || [],
    associatedAccounts: resource.associated_accounts || [],
    createdBy: cloud_info.created_by,
    creationTime: create_time,
    internalHost: `${name}#internal-host`,
    io: _mapIO(io_stats),
    undeletable
  };
}

function _mapTiersToBuckets(buckets) {
  const dataBuckets = buckets.filter(bucket => bucket.bucket_type === 'REGULAR');
  const pairs = (0, _coreUtils.flatMap)(dataBuckets, bucket => bucket.tiering.tiers.map(item => {
    const bucketName = bucket.name;
    const tierName = item.tier;
    return {
      bucketName,
      tierName
    };
  }));
  return (0, _coreUtils.keyBy)(pairs, pair => pair.tierName, pair => pair.bucketName);
}

function _mapPoolsToBuckets(buckets, tiers) {
  const bucketsByTierName = _mapTiersToBuckets(buckets);

  const pairs = (0, _coreUtils.flatMap)(tiers.filter(tier => Boolean(bucketsByTierName[tier.name])), tier => (0, _coreUtils.flatMap)(tier.mirror_groups, mirrorGroup => mirrorGroup.pools.map(poolName => ({
    bucket: bucketsByTierName[tier.name],
    pool: poolName
  }))));
  return (0, _coreUtils.groupBy)(pairs, pair => pair.pool, pair => pair.bucket);
}

function _mapIO(stats) {
  return {
    readCount: stats.read_count,
    readSize: stats.read_bytes,
    writeCount: stats.write_count,
    writeSize: stats.write_bytes
  };
} // ------------------------------
// Exported reducer function.
// ------------------------------


var _default = (0, _reducerUtils.createReducer)(initialState, {
  [_actionTypes.COMPLETE_FETCH_SYSTEM_INFO]: onCompleteFetchSystemInfo
});

exports.default = _default;

},{"action-types":318,"utils/core-utils":1027,"utils/reducer-utils":1040,"utils/state-utils":1044}],946:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _reducerUtils = require("utils/reducer-utils");

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
// ------------------------------
// Initial State
// ------------------------------
const initialState = {
  connection: undefined,
  list: undefined,
  fetching: false,
  error: false
}; // ------------------------------
// Action Handlers
// ------------------------------
// An example of an action handler

function onFetchCloudTargets(state, {
  payload
}) {
  const list = state.connection === payload.connection ? state.list : undefined;
  return {
    connection: payload.connection,
    list: list,
    fetching: true,
    error: false
  };
}

function onCompleteFetchCloudTargets(state, {
  payload
}) {
  if (state.connection !== payload.connection) {
    return state;
  }

  const list = payload.targets.map(target => ({
    name: target.name,
    usedBy: _mapTargetUser(target.used_by)
  }));
  return { ...state,
    list: list,
    fetching: false
  };
}

function onFailFetchCloudTargets(state, {
  payload
}) {
  if (state.connection !== payload.connection) {
    return state;
  }

  return { ...state,
    fetching: false,
    error: true
  };
}

function onDropCloudTargets() {
  return initialState;
} // ------------------------------
// Local util functions
// ------------------------------


function _mapTargetUser(user) {
  if (!user) return;
  return {
    kind: user.usage_type,
    name: user.name
  };
} // ------------------------------
// Exported reducer function
// ------------------------------


var _default = (0, _reducerUtils.createReducer)(initialState, {
  [_actionTypes.FETCH_CLOUD_TARGETS]: onFetchCloudTargets,
  [_actionTypes.COMPLETE_FETCH_CLOUD_TARGETS]: onCompleteFetchCloudTargets,
  [_actionTypes.FAIL_FETCH_CLOUD_TARGETS]: onFailFetchCloudTargets,
  [_actionTypes.DROP_CLOUD_TARGETS]: onDropCloudTargets
});

exports.default = _default;

},{"action-types":318,"utils/reducer-utils":1040}],947:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _reducerUtils = require("utils/reducer-utils");

var _coreUtils = require("utils/core-utils");

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
// ------------------------------
// Initial State
// ------------------------------
const initialState = {
  fetching: false,
  error: false
}; // ------------------------------
// Action Handlers
// ------------------------------

function onFetchCloudUsageStats(state, {
  payload
}) {
  return { ...initialState,
    query: payload,
    fetching: true
  };
}

function onCompleteFetchCloudUsageStats(state, {
  payload
}) {
  if (payload.query !== state.query) {
    return state;
  }

  return { ...state,
    fetching: false,
    error: false,
    usage: (0, _coreUtils.keyByProperty)(payload.usage, 'service', record => ({
      readCount: record.read_count,
      writeCount: record.write_count,
      readSize: record.read_bytes,
      writeSize: record.write_bytes
    }))
  };
}

function onFailFetchCloudUsageStats(state, {
  payload
}) {
  if (payload.query !== state.query) {
    return state;
  }

  return { ...state,
    fetching: false,
    error: true
  };
}

function onDropFetchCloudUsageStats() {
  return initialState;
} // ------------------------------
// Local util functions
// ------------------------------
// ------------------------------
// Exported reducer function
// ------------------------------


var _default = (0, _reducerUtils.createReducer)(initialState, {
  [_actionTypes.FETCH_CLOUD_USAGE_STATS]: onFetchCloudUsageStats,
  [_actionTypes.COMPLETE_FETCH_CLOUD_USAGE_STATS]: onCompleteFetchCloudUsageStats,
  [_actionTypes.FAIL_FETCH_CLOUD_USAGE_STATS]: onFailFetchCloudUsageStats,
  [_actionTypes.DROP_CLOUD_USAGE_STATS]: onDropFetchCloudUsageStats
});

exports.default = _default;

},{"action-types":318,"utils/core-utils":1027,"utils/reducer-utils":1040}],948:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _reducerUtils = require("utils/reducer-utils");

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
// ------------------------------
// Initial State
// ------------------------------
const initialState = undefined; // ------------------------------
// Action Handlers
// ------------------------------

function onOpenDrawer(_, {
  payload
}) {
  return payload.pane;
}

function onCloseDrawer() {
  return initialState;
}

function onChangeLocation() {
  return initialState;
} // ------------------------------
// Exported reducer function.
// ------------------------------


var _default = (0, _reducerUtils.createReducer)(initialState, {
  [_actionTypes.OPEN_DRAWER]: onOpenDrawer,
  [_actionTypes.CLOSE_DRAWER]: onCloseDrawer,
  [_actionTypes.CHANGE_LOCATION]: onChangeLocation
});

exports.default = _default;

},{"action-types":318,"utils/reducer-utils":1040}],949:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _reducerUtils = require("utils/reducer-utils");

var _coreUtils = require("utils/core-utils");

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
// ------------------------------
// Initial State
// ------------------------------
const initialState = undefined; // ------------------------------
// Action Handlers
// ------------------------------
// An example of an action handler

function onCompleteFetchSystemInfo(state, {
  payload
}) {
  return (0, _coreUtils.keyByProperty)(payload.endpoint_groups, 'group_name', group => ({
    name: group.group_name,
    isRemote: group.is_remote,
    region: group.region,
    endpointCount: group.endpoint_count,
    endpointRange: {
      min: group.min_endpoint_count,
      max: group.max_endpoint_count
    },
    cpuCount: group.cpu_count,
    cpuUsage: group.cpu_usage,
    memoryUsage: group.memory_usage,
    lastReportTime: group.last_report_time
  }));
} // ------------------------------
// Local util functions
// ------------------------------
// ------------------------------
// Exported reducer function
// ------------------------------


var _default = (0, _reducerUtils.createReducer)(initialState, {
  [_actionTypes.COMPLETE_FETCH_SYSTEM_INFO]: onCompleteFetchSystemInfo
});

exports.default = _default;

},{"action-types":318,"utils/core-utils":1027,"utils/reducer-utils":1040}],950:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _reducerUtils = require("utils/reducer-utils");

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
// ------------------------------
// Initial State
// ------------------------------
const initialState = {
  query: undefined,
  samples: undefined,
  fetching: false,
  error: false
}; // ------------------------------
// Action Handlers
// ------------------------------

function onFetchEndpointsHistory(state, {
  payload
}) {
  return { ...initialState,
    query: payload,
    fetching: true
  };
}

function onCompleteFetchEndpointsHistory(state, {
  payload
}) {
  if (payload.query !== state.query) {
    return state;
  }

  return { ...state,
    fetching: false,
    error: false,
    samples: payload.history.map(record => ({
      timestamp: record.timestamp,
      endpointCount: record.endpoint_count,
      cpuCount: record.cpu_count,
      cpuUsage: record.cpu_usage,
      memoryUsage: record.memory_usage,
      readSize: record.read_bytes,
      writeSize: record.write_bytes
    }))
  };
}

function onFailFetchEndpointsHistory(state, {
  payload
}) {
  if (payload.query !== state.query) {
    return state;
  }

  return { ...state,
    error: true
  };
}

function onDropEndpointsHistory() {
  return initialState;
} // ------------------------------
// Local util functions
// ------------------------------
// ------------------------------
// Exported reducer function
// ------------------------------


var _default = (0, _reducerUtils.createReducer)(initialState, {
  [_actionTypes.FETCH_ENDPOINTS_HISTORY]: onFetchEndpointsHistory,
  [_actionTypes.COMPLETE_FETCH_ENDPOINTS_HISTORY]: onCompleteFetchEndpointsHistory,
  [_actionTypes.FAIL_FETCH_ENDPOINTS_HISTORY]: onFailFetchEndpointsHistory,
  [_actionTypes.DROP_ENDPOINTS_HISTORY]: onDropEndpointsHistory
});

exports.default = _default;

},{"action-types":318,"utils/reducer-utils":1040}],951:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _reducerUtils = require("utils/reducer-utils");

var _actionTypes = require("action-types");

// ------------------------------
// Initial State
// ------------------------------
const initialState = undefined; // ------------------------------
// Action Handlers
// ------------------------------

function onSetupEnv(env, {
  payload
}) {
  return {
    previewContent: false,
    browser: payload.browser,
    isBrowserStickyDismissed: false
  };
}

function onTogglePreviewContent(env) {
  return { ...env,
    previewContent: !env.previewContent
  };
}

function onDismissBrowserSticky(env) {
  return { ...env,
    isBrowserStickyDismissed: true
  };
} // ------------------------------
// Exported reducer function
// ------------------------------


var _default = (0, _reducerUtils.createReducer)(initialState, {
  [_actionTypes.SETUP_ENV]: onSetupEnv,
  [_actionTypes.TOGGLE_PREVIEW_CONTENT]: onTogglePreviewContent,
  [_actionTypes.DISSMISS_BROWSER_STICKY]: onDismissBrowserSticky
});

exports.default = _default;

},{"action-types":318,"utils/reducer-utils":1040}],952:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _coreUtils = require("utils/core-utils");

var _reducerUtils = require("utils/reducer-utils");

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
// ------------------------------
// Initial State
// ------------------------------
const initialState = {};
const initialFormState = {
  fields: {},
  warnings: {},
  syncErrors: {},
  asyncErrors: {},
  submitErrors: {},
  validatingAsync: null,
  validated: false,
  submitting: false,
  submitted: false
}; // ------------------------------
// Action Handlers
// ------------------------------

function onInitForm(forms, {
  payload
}) {
  if (forms[payload.form]) return forms;
  const fields = (0, _coreUtils.mapValues)(payload.values, _initializeValue);
  return { ...forms,
    [payload.form]: { ...initialFormState,
      fields
    }
  };
}

function onUpdateForm(forms, {
  payload
}) {
  const form = forms[payload.form];
  if (!form) return forms;
  const updates = payload.values;
  const fields = (0, _coreUtils.mapValues)(form.fields, (field, name) => {
    if (!(0, _coreUtils.hasOwn)(updates, name)) {
      return field;
    }

    return { ...field,
      value: updates[name],
      touched: field.touched || payload.touch
    };
  });
  return { ...forms,
    [payload.form]: { ...form,
      fields,
      validated: false,
      submitted: false,
      submitting: false,
      submitErrors: {}
    }
  };
}

function onResetForm(forms, {
  payload
}) {
  const form = forms[payload.form];
  if (!form) return forms;
  const fields = (0, _coreUtils.mapValues)(form.fields, ({
    initial
  }) => _initializeValue(initial));
  return { ...forms,
    [payload.form]: { ...initialFormState,
      fields
    }
  };
}

function onTouchForm(forms, {
  payload
}) {
  return _toggleFormTouch(forms, payload.form, payload.fields, true);
}

function onUntouchForm(forms, {
  payload
}) {
  return _toggleFormTouch(forms, payload.form, payload.fields, false);
}

function onSetFormValidity(forms, {
  payload
}) {
  const form = forms[payload.form];
  if (!form) return forms;

  if (Object.keys(payload.values).some(name => form.fields[name].value !== payload.values[name])) {
    return forms;
  }

  const {
    fieldsValidity = {},
    warnings = form.warnings,
    syncErrors = form.syncErrors,
    asyncErrors = form.asyncErrors,
    validatingAsync = form.validatingAsync,
    confirmValidity,
    touch = false
  } = payload;
  const fields = (0, _coreUtils.mapValues)(form.fields, (field, name) => fieldsValidity[name] ? { ...field,
    validity: fieldsValidity[name],
    touched: field.touched || touch
  } : field);
  const validated = confirmValidity || form.validated;
  return { ...forms,
    [payload.form]: { ...form,
      fields,
      warnings,
      syncErrors,
      asyncErrors,
      validatingAsync,
      validated
    }
  };
}

function onSubmitForm(forms, {
  payload
}) {
  const form = forms[payload.form]; // Touch all the fields.

  const fields = (0, _coreUtils.mapValues)(form.fields, field => ({ ...field,
    touched: true
  }));
  const isValid = form.validated && Object.values(form.fields).every(field => field.validity === 'VALID');
  return { ...forms,
    [payload.form]: { ...form,
      fields,
      submitted: false,
      submitting: isValid
    }
  };
}

function onCompleteSubmitForm(forms, {
  payload
}) {
  const form = forms[payload.form];
  if (!form || !form.submitting) return forms;
  const {
    errors
  } = payload;
  const submitted = Object.keys(errors).length === 0;
  const fields = (0, _coreUtils.mapValues)(form.fields, (field, key) => ({ ...field,
    initial: submitted ? field.value : field.initial,
    validity: (0, _coreUtils.hasOwn)(errors, key) ? 'INVALID' : 'VALID'
  }));
  return { ...forms,
    [payload.form]: { ...form,
      fields,
      submitting: false,
      submitted: submitted,
      submitErrors: errors
    }
  };
}

function onDropForm(forms, {
  payload
}) {
  const {
    [payload.form]: _,
    ...other
  } = forms;
  return other;
} // ------------------------------
// Local utils function
// ------------------------------


function _initializeValue(value) {
  return {
    initial: value,
    value: value,
    touched: false,
    validity: 'VALID'
  };
}

function _toggleFormTouch(forms, formName, fields, touch) {
  const form = forms[formName];
  if (!form) return forms;
  const touchList = fields || Object.keys(form.fields);
  const fieldsState = (0, _coreUtils.mapValues)(form.fields, (field, name) => touchList.includes(name) ? { ...field,
    touched: touch
  } : field);
  return { ...forms,
    [formName]: { ...form,
      fields: fieldsState
    }
  };
} // ------------------------------
// Exported reducer function
// ------------------------------


var _default = (0, _reducerUtils.createReducer)(initialState, {
  [_actionTypes.INIT_FORM]: onInitForm,
  [_actionTypes.UPDATE_FORM]: onUpdateForm,
  [_actionTypes.RESET_FORM]: onResetForm,
  [_actionTypes.TOUCH_FORM]: onTouchForm,
  [_actionTypes.UNTOUCH_FORM]: onUntouchForm,
  [_actionTypes.SET_FORM_VALIDITY]: onSetFormValidity,
  [_actionTypes.SUBMIT_FORM]: onSubmitForm,
  [_actionTypes.COMPLETE_SUBMIT_FORM]: onCompleteSubmitForm,
  [_actionTypes.DROP_FROM]: onDropForm
});

exports.default = _default;

},{"action-types":318,"utils/core-utils":1027,"utils/reducer-utils":1040}],953:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _reducerUtils = require("utils/reducer-utils");

var _coreUtils = require("utils/core-utils");

var _funcUtils = require("utils/func-utils");

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
// ------------------------------
// Initial State
// ------------------------------
const initialState = undefined; // ------------------------------
// Action Handlers
// ------------------------------

function onCompleteFetchSystemInfo(state, {
  payload
}) {
  return (0, _coreUtils.keyBy)(payload.functions || [], func => _getFuncId(func.config.name, func.config.version), (func, id) => _mapFunc(state && state[id], func));
}

function onLoadLambdaFuncCode(state, {
  payload
}) {
  const id = _getFuncId(payload.name, payload.version);

  if (!state || !state[id]) {
    return state;
  }

  return { ...state,
    [id]: { ...state[id],
      codeBuffer: {
        loading: true,
        error: false,
        handle: null
      }
    }
  };
}

function onCompleteLoadLambdaFuncCode(state, {
  payload
}) {
  const {
    name,
    version,
    codeHash,
    bufferHandle
  } = payload;

  const id = _getFuncId(name, version);

  if (!state || !state[id]) {
    return state;
  }

  const mismatch = state[id].codeHash !== codeHash;
  const handle = mismatch ? null : bufferHandle;
  return { ...state,
    [id]: { ...state[id],
      codeBuffer: {
        loading: false,
        error: mismatch,
        handle
      }
    }
  };
}

function onFailLoadLambdaFuncCode(state, {
  payload
}) {
  const id = _getFuncId(payload.name, payload.version);

  if (!state || !state[id]) {
    return state;
  }

  return { ...state,
    [id]: { ...state[id],
      codeBuffer: {
        loading: false,
        error: true,
        handle: null
      }
    }
  };
}

function onDropLambdaFuncCode(state, {
  payload
}) {
  const id = _getFuncId(payload.name, payload.version);

  if (!state || !state[id]) {
    return state;
  }

  return { ...state,
    [id]: { ...state[id],
      codeBuffer: {
        loading: false,
        error: false,
        handle: null
      }
    }
  };
} // ------------------------------
// Local util functions
// ------------------------------


function _getFuncId(name, version) {
  return `${name}:${version}`;
}

function _mapFunc(state = {}, func) {
  const {
    config
  } = func;
  const [execFile, execFunc] = config.handler.split(/[.]([^.]+$)/);
  const codeBuffer = state.codeHash === config.code_sha256 ? state.codeBuffer : {
    loading: false,
    error: false,
    handle: null
  };
  return {
    name: config.name,
    version: config.version,
    execFile: `${execFile}${_funcUtils.handlerFileSuffix}`,
    execFunc,
    description: config.description,
    runtime: config.runtime,
    timeout: config.timeout,
    memorySize: config.memory_size,
    lastModified: config.last_modified,
    lastModifier: config.last_modifier,
    executor: config.exec_account,
    codeSize: config.code_size,
    codeHash: config.code_sha256,
    codeBuffer
  };
} // ------------------------------
// Exported reducer function
// ------------------------------


var _default = (0, _reducerUtils.createReducer)(initialState, {
  [_actionTypes.COMPLETE_FETCH_SYSTEM_INFO]: onCompleteFetchSystemInfo,
  [_actionTypes.LOAD_LAMBDA_FUNC_CODE]: onLoadLambdaFuncCode,
  [_actionTypes.COMPLETE_LOAD_LAMBDA_FUNC_CODE]: onCompleteLoadLambdaFuncCode,
  [_actionTypes.FAIL_LOAD_LAMBDA_FUNC_CODE]: onFailLoadLambdaFuncCode,
  [_actionTypes.DROP_LAMBDA_FUNC_CODE]: onDropLambdaFuncCode
});

exports.default = _default;

},{"action-types":318,"utils/core-utils":1027,"utils/func-utils":1031,"utils/reducer-utils":1040}],954:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _reducerUtils = require("utils/reducer-utils");

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
// ------------------------------
// Initial State
// ------------------------------
const initialState = {
  host: '',
  parts: undefined,
  partCount: 0,
  fetching: false,
  error: false
}; // ------------------------------
// Action Handlers
// ------------------------------

function onFetchHostObjects(state, {
  payload
}) {
  const parts = _queryMatching(payload, state) ? state.parts : undefined;
  const {
    host,
    skip,
    limit
  } = payload;
  return { ...state,
    host: host,
    skip: skip,
    limit: limit,
    parts: parts,
    fetching: true,
    error: false
  };
}

function onCompleteFetchHostObjects(state, {
  payload
}) {
  const {
    query,
    response
  } = payload;
  const {
    total_chunks,
    chunks,
    objects
  } = response;
  if (!_queryMatching(query, state)) return state;
  const parts = chunks.map(chunk => {
    const part = chunk.parts[0];
    const obj = objects.find(it => it.obj_id === part.obj_id);
    const mode = (chunk.is_building_blocks || chunk.is_building_frags) && 'BUILDING' || (chunk.is_accessible ? 'AVAILABLE' : 'UNAVAILABLE');
    return {
      mode,
      objectInfo: {
        bucket: obj.bucket,
        key: obj.key,
        version: obj.version_id || 'null',
        isUploading: Boolean(obj.upload_started),
        isDeleteMarker: Boolean(obj.delete_marker)
      },
      start: part.start,
      end: part.end
    };
  });
  return { ...state,
    parts,
    partCount: total_chunks,
    fetching: false,
    error: false
  };
}

function onFailFetchHostObjects(state, {
  payload
}) {
  if (!_queryMatching(payload.query, state)) return state;
  return { ...state,
    fetching: false,
    error: true
  };
}

function onFetchCloudResourceObjects(state, {
  payload
}) {
  return onFetchHostObjects(state, {
    payload: _resourceQueryToHostQuery(payload)
  });
}

function onCompleteFetchCloudResourceObjects(state, {
  payload
}) {
  return onCompleteFetchHostObjects(state, {
    payload: {
      query: _resourceQueryToHostQuery(payload.query),
      response: payload.response
    }
  });
}

function onFailCloudResourceObjects(state, {
  payload
}) {
  return onFailFetchHostObjects(state, {
    payload: {
      query: _resourceQueryToHostQuery(payload.query),
      error: payload.error
    }
  });
} // ------------------------------
// Local util functions
// ------------------------------


function _queryMatching(query, state) {
  return query.host === state.host && query.skip === state.skip && query.limit === state.limit;
}

function _resourceQueryToHostQuery(query) {
  const {
    resource: _,
    ...rest
  } = query;
  return { ...rest,
    host: `${query.resource}#internal-host`
  };
} // ------------------------------
// Exported reducer function
// ------------------------------


var _default = (0, _reducerUtils.createReducer)(initialState, {
  [_actionTypes.FETCH_HOST_OBJECTS]: onFetchHostObjects,
  [_actionTypes.COMPLETE_FETCH_HOST_OBJECTS]: onCompleteFetchHostObjects,
  [_actionTypes.FAIL_FETCH_HOST_OBJECTS]: onFailFetchHostObjects,
  [_actionTypes.FETCH_CLOUD_RESOURCE_OBJECTS]: onFetchCloudResourceObjects,
  [_actionTypes.COMPLETE_FETCH_CLOUD_RESOURCE_OBJECTS]: onCompleteFetchCloudResourceObjects,
  [_actionTypes.FAIL_FETCH_CLOUD_RESOURCE_OBJECTS]: onFailCloudResourceObjects
});

exports.default = _default;

},{"action-types":318,"utils/reducer-utils":1040}],955:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _coreUtils = require("utils/core-utils");

var _reducerUtils = require("utils/reducer-utils");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
// ------------------------------
// Initial State
// ------------------------------
const initialState = undefined;
const beingCreatedPoolState = {
  mode: 'BEING_CREATED',
  isManaged: true,
  activities: {
    hostCount: 0,
    list: []
  },
  associatedAccounts: [],
  hostCount: 0,
  hostsByMode: {},
  configuredHostCount: 0,
  storageNodeCount: 0,
  storageNodesByMode: {},
  endpointNodeCount: 0,
  endpointNodesByMode: {},
  storage: {
    total: 0,
    free: 0,
    unavailableFree: 0,
    used: 0,
    usedOther: 0,
    unavailableUsed: 0,
    reserved: 0
  }
}; // ------------------------------
// Action Handlers
// ------------------------------

function onCreateHostsPool(state, {
  payload
}) {
  const {
    name
  } = payload;
  if (state[name]) return state;
  return {
    [name]: { ...beingCreatedPoolState,
      name,
      creationTime: Date.now()
    },
    ...state
  };
}

function onCompleteFetchSystemInfo(state, {
  payload
}) {
  const {
    pools
  } = payload;
  const nodePools = pools.filter(pool => pool.resource_type === 'HOSTS');
  return (0, _coreUtils.keyByProperty)(nodePools, 'name', pool => _mapPool(pool));
} // ------------------------------
// Local util functions
// ------------------------------


function _mapPool(pool) {
  const activityList = (pool.data_activities.activities || []).map(activity => ({
    kind: activity.reason,
    nodeCount: activity.count,
    progress: activity.progress,
    eta: activity.time.end
  }));
  return {
    name: pool.name,
    creationTime: pool.create_time,
    mode: pool.mode,
    isManaged: pool.is_managed,
    storage: (0, _stateUtils.mapApiStorage)(pool.storage),
    associatedAccounts: pool.associated_accounts,
    hostCount: pool.hosts.count,
    hostsByMode: pool.hosts.by_mode,
    configuredHostCount: pool.hosts.configured_count,
    storageNodeCount: pool.storage_nodes.count,
    storageNodesByMode: pool.storage_nodes.by_mode,
    endpointNodeCount: pool.s3_nodes.count,
    endpointNodesByMode: pool.s3_nodes.by_mode,
    undeletable: pool.undeletable,
    region: pool.region,
    activities: {
      hostCount: pool.data_activities.host_count,
      list: activityList
    },
    hostConfig: {
      volumeSize: pool.host_info.volume_size
    }
  };
} // ------------------------------
// Exported reducer function
// ------------------------------


var _default = (0, _reducerUtils.createReducer)(initialState, {
  [_actionTypes.CREATE_HOSTS_POOL]: onCreateHostsPool,
  [_actionTypes.COMPLETE_FETCH_SYSTEM_INFO]: onCompleteFetchSystemInfo
});

exports.default = _default;

},{"action-types":318,"utils/core-utils":1027,"utils/reducer-utils":1040,"utils/state-utils":1044}],956:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _reducerUtils = require("utils/reducer-utils");

var _coreUtils = require("utils/core-utils");

var _config = require("config");

var _stateUtils = require("utils/state-utils");

var _itemCacheUtils = require("utils/item-cache-utils");

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
const inMemoryQueryLimit = 10;
const inMemoryHostLimit = _config.paginationPageSize.default * inMemoryQueryLimit;
const eventToReasonCode = (0, _coreUtils.deepFreeze)({
  PERMISSION_EVENT: 'TEMPERING',
  DATA_EVENT: 'CORRUPTION'
}); // ------------------------------
// Initial State
// ------------------------------

const initialHostDiagnosticsState = {
  collecting: false,
  error: false,
  packageUri: ''
}; // ------------------------------
// Action Handlers
// ------------------------------

function onFetchHosts(state, {
  payload,
  timestamp
}) {
  const {
    view,
    query
  } = payload;
  return (0, _itemCacheUtils.handleFetch)(state, query, view, timestamp, inMemoryQueryLimit, inMemoryHostLimit);
}

function onCompleteFetchHosts(state, {
  payload
}) {
  const {
    response
  } = payload;
  const items = (0, _coreUtils.keyByProperty)(response.hosts, 'name', data => _mapDataToHost(state.items[data.name], data));
  const counters = {
    nonPaginated: response.counters.non_paginated,
    byMode: response.counters.by_mode
  };
  return (0, _itemCacheUtils.handleFetchCompleted)(state, payload.query, items, {
    counters
  }, inMemoryQueryLimit, inMemoryHostLimit);
}

function onFailFetchHosts(state, {
  payload
}) {
  return (0, _itemCacheUtils.handleFetchFailed)(state, payload.query);
}

function onCollectHostDiagnostics(state, {
  payload
}) {
  const diagnostics = {
    collecting: true,
    error: false,
    packageUri: ''
  };
  return (0, _itemCacheUtils.handleUpdateItem)(state, payload.host, {
    diagnostics
  });
}

function onCompleteCollectHostDiagnostics(state, {
  payload
}) {
  const diagnostics = {
    collecting: false,
    error: false,
    packageUri: payload.packageUri
  };
  return (0, _itemCacheUtils.handleUpdateItem)(state, payload.host, {
    diagnostics
  });
}

function onFailCollectHostDiagnostics(state, {
  payload
}) {
  const diagnostics = {
    collecting: false,
    error: true,
    packageUri: ''
  };
  return (0, _itemCacheUtils.handleUpdateItem)(state, payload.host, {
    diagnostics
  });
}

function onCompleteSetHostDebugMode(state, {
  payload
}) {
  const debugMode = {
    state: payload.on,
    timeLeft: undefined
  };
  return (0, _itemCacheUtils.handleUpdateItem)(state, payload.host, {
    debugMode
  });
}

function onDropHostsView(state, {
  payload
}) {
  return (0, _itemCacheUtils.handleDropView)(state, payload.view);
}

function onRemoveHost(state, {
  payload
}) {
  const {
    host
  } = payload;
  return (0, _itemCacheUtils.handleRemoveItem)(state, host, extras => {
    const {
      nonPaginated,
      byMode
    } = extras.counters;
    const hostMode = state.items[host].mode;
    const counters = {
      nonPaginated: nonPaginated - 1,
      byMode: { ...byMode,
        [hostMode]: byMode[hostMode] ? byMode[hostMode] - 1 : 0
      }
    };
    return {
      counters
    };
  });
} // ------------------------------
// Local util functions
// ------------------------------


function _mapDataToHost(host = {}, data) {
  const {
    storage_nodes_info,
    os_info,
    ports,
    debug
  } = data;
  const {
    diagnostics = initialHostDiagnosticsState
  } = host;
  const reasonByMount = (0, _coreUtils.groupBy)(data.untrusted_reasons || [], reason => reason.drive.drive_id, reason => reason.events.map(item => {
    const {
      event,
      time
    } = item;
    const reason = eventToReasonCode[event];
    return {
      reason,
      time
    };
  }));
  const cpuUnits = os_info.cpus.map(cpu => ({
    model: cpu.model,
    speed: cpu.speed
  }));
  const activities = (storage_nodes_info.data_activities || []).map(activity => ({
    kind: activity.reason,
    nodeCount: activity.count,
    progress: activity.progress,
    eta: activity.time.end
  }));
  return {
    name: data.name,
    hostname: os_info.hostname,
    pool: data.pool,
    suggestedPool: data.suggested_pool,
    mode: data.mode,
    version: data.version,
    ip: data.ip,
    publicIp: data.public_ip,
    ports: ports && {
      min: ports.range.min || ports.range.port,
      max: ports.range.max || ports.range.port
    },
    protocol: data.connectivity,
    endpoint: data.base_address,
    rpcAddress: data.rpc_address,
    lastCommunication: data.last_communication,
    rtt: (0, _coreUtils.averageBy)(data.latency_to_server),
    storage: (0, _stateUtils.mapApiStorage)(data.storage),
    trusted: data.trusted,
    activities: activities,
    services: {
      storage: _mapStorageService(storage_nodes_info, reasonByMount)
    },
    upTime: os_info.uptime,
    os: os_info.ostype,
    cpus: {
      units: cpuUnits,
      usedByOther: os_info.cpu_usage - data.process_cpu_usage,
      usedByNoobaa: data.process_cpu_usage
    },
    memory: {
      free: os_info.freemem,
      usedByNoobaa: data.process_mem_usage,
      usedByOther: os_info.totalmem - os_info.freemem
    },
    debugMode: {
      state: Boolean(debug.level),
      timeLeft: debug.time_left
    },
    diagnostics: diagnostics
  };
}

function _mapStorageService({
  mode,
  enabled,
  nodes
}, reasonByMount) {
  return {
    mode,
    enabled: Boolean(enabled),
    nodes: nodes.map(node => {
      const {
        name,
        mode,
        drive,
        latency_of_disk_read,
        storage,
        latency_of_disk_write,
        data_activity
      } = node;
      const activity = data_activity && {
        kind: data_activity.reason,
        progress: data_activity.progress,
        stage: data_activity.stage.name
      };
      return {
        name,
        mode,
        storage: (0, _stateUtils.mapApiStorage)(storage),
        drive: drive.drive_id,
        mount: drive.mount,
        readLatency: (0, _coreUtils.averageBy)(latency_of_disk_read),
        writeLatency: (0, _coreUtils.averageBy)(latency_of_disk_write),
        activity,
        untrusted: reasonByMount[drive.drive_id] || []
      };
    })
  };
} // ------------------------------
// Exported reducer function
// ------------------------------


var _default = (0, _reducerUtils.createReducer)(_itemCacheUtils.initialState, {
  [_actionTypes.FETCH_HOSTS]: onFetchHosts,
  [_actionTypes.COMPLETE_FETCH_HOSTS]: onCompleteFetchHosts,
  [_actionTypes.FAIL_FETCH_HOSTS]: onFailFetchHosts,
  [_actionTypes.COLLECT_HOST_DIAGNOSTICS]: onCollectHostDiagnostics,
  [_actionTypes.COMPLETE_COLLECT_HOST_DIAGNOSTICS]: onCompleteCollectHostDiagnostics,
  [_actionTypes.FAIL_COLLECT_HOST_DIAGNOSTICS]: onFailCollectHostDiagnostics,
  [_actionTypes.COMPLETE_SET_HOST_DEBUG_MODE]: onCompleteSetHostDebugMode,
  [_actionTypes.DROP_HOSTS_VIEW]: onDropHostsView,
  [_actionTypes.REMOVE_HOST]: onRemoveHost
});

exports.default = _default;

},{"action-types":318,"config":831,"utils/core-utils":1027,"utils/item-cache-utils":1034,"utils/reducer-utils":1040,"utils/state-utils":1044}],957:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _reducerUtils = require("utils/reducer-utils");

var _envReducer = _interopRequireDefault(require("./env-reducer"));

var _locationReducer = _interopRequireDefault(require("./location-reducer"));

var _sessionReducer = _interopRequireDefault(require("./session-reducer"));

var _drawerReducer = _interopRequireDefault(require("./drawer-reducer"));

var _modalsReducer = _interopRequireDefault(require("./modals-reducer"));

var _formsReducer = _interopRequireDefault(require("./forms-reducer"));

var _bucketsReducer = _interopRequireDefault(require("./buckets-reducer"));

var _namespaceBucketsReducer = _interopRequireDefault(require("./namespace-buckets-reducer"));

var _hostPoolsReducer = _interopRequireDefault(require("./host-pools-reducer"));

var _cloudResourcesReducer = _interopRequireDefault(require("./cloud-resources-reducer"));

var _namespaceResourcesReducer = _interopRequireDefault(require("./namespace-resources-reducer"));

var _hostsReducer = _interopRequireDefault(require("./hosts-reducer"));

var _accountsReducer = _interopRequireDefault(require("./accounts-reducer"));

var _objectUploadsReducer = _interopRequireDefault(require("./object-uploads-reducer"));

var _alertsReducer = _interopRequireDefault(require("./alerts-reducer"));

var _auditLogReducer = _interopRequireDefault(require("./audit-log-reducer"));

var _notificaitonsReducer = _interopRequireDefault(require("./notificaitons-reducer"));

var _topologyReducer = _interopRequireDefault(require("./topology-reducer"));

var _hostPartsReducer = _interopRequireDefault(require("./host-parts-reducer"));

var _cloudTargetsReducer = _interopRequireDefault(require("./cloud-targets-reducer"));

var _objectsReducer = _interopRequireDefault(require("./objects-reducer"));

var _objectPartsReducer = _interopRequireDefault(require("./object-parts-reducer"));

var _systemReducer = _interopRequireDefault(require("./system-reducer"));

var _functionsReducer = _interopRequireDefault(require("./functions-reducer"));

var _storageHistoryReducer = _interopRequireDefault(require("./storage-history-reducer"));

var _bucketUsageHistoryReducer = _interopRequireDefault(require("./bucket-usage-history-reducer"));

var _accountUsageHistoryReducer = _interopRequireDefault(require("./account-usage-history-reducer"));

var _lambdaUsageHistoryReducer = _interopRequireDefault(require("./lambda-usage-history-reducer"));

var _objectsDistributionReducer = _interopRequireDefault(require("./objects-distribution-reducer"));

var _cloudUsageStatsReducer = _interopRequireDefault(require("./cloud-usage-stats-reducer"));

var _bucketTriggersReducer = _interopRequireDefault(require("./bucket-triggers-reducer"));

var _endpointGroupsReducer = _interopRequireDefault(require("./endpoint-groups-reducer"));

var _endpointsHistoryReducer = _interopRequireDefault(require("./endpoints-history-reducer"));

/* Copyright (C) 2016 NooBaa */

/** INJECT:import **/

/* eslint-disable comma-dangle */
var _default = (0, _reducerUtils.combineReducers)({
  env: _envReducer.default,
  location: _locationReducer.default,
  session: _sessionReducer.default,
  drawer: _drawerReducer.default,
  modals: _modalsReducer.default,
  forms: _formsReducer.default,
  notifications: _notificaitonsReducer.default,
  alerts: _alertsReducer.default,
  auditLog: _auditLogReducer.default,
  buckets: _bucketsReducer.default,
  namespaceBuckets: _namespaceBucketsReducer.default,
  cloudResources: _cloudResourcesReducer.default,
  namespaceResources: _namespaceResourcesReducer.default,
  hostPools: _hostPoolsReducer.default,
  hosts: _hostsReducer.default,
  hostParts: _hostPartsReducer.default,
  accounts: _accountsReducer.default,
  topology: _topologyReducer.default,
  cloudTargets: _cloudTargetsReducer.default,
  objects: _objectsReducer.default,
  objectUploads: _objectUploadsReducer.default,
  objectParts: _objectPartsReducer.default,
  system: _systemReducer.default,
  functions: _functionsReducer.default,
  storageHistory: _storageHistoryReducer.default,
  bucketUsageHistory: _bucketUsageHistoryReducer.default,
  accountUsageHistory: _accountUsageHistoryReducer.default,
  lambdaUsageHistory: _lambdaUsageHistoryReducer.default,
  objectsDistribution: _objectsDistributionReducer.default,
  cloudUsageStats: _cloudUsageStatsReducer.default,
  bucketTriggers: _bucketTriggersReducer.default,
  endpointGroups: _endpointGroupsReducer.default,
  endpointsHistory: _endpointsHistoryReducer.default
  /** INJECT:list **/

});

exports.default = _default;

},{"./account-usage-history-reducer":938,"./accounts-reducer":939,"./alerts-reducer":940,"./audit-log-reducer":941,"./bucket-triggers-reducer":942,"./bucket-usage-history-reducer":943,"./buckets-reducer":944,"./cloud-resources-reducer":945,"./cloud-targets-reducer":946,"./cloud-usage-stats-reducer":947,"./drawer-reducer":948,"./endpoint-groups-reducer":949,"./endpoints-history-reducer":950,"./env-reducer":951,"./forms-reducer":952,"./functions-reducer":953,"./host-parts-reducer":954,"./host-pools-reducer":955,"./hosts-reducer":956,"./lambda-usage-history-reducer":958,"./location-reducer":959,"./modals-reducer":960,"./namespace-buckets-reducer":961,"./namespace-resources-reducer":962,"./notificaitons-reducer":963,"./object-parts-reducer":964,"./object-uploads-reducer":965,"./objects-distribution-reducer":966,"./objects-reducer":967,"./session-reducer":968,"./storage-history-reducer":969,"./system-reducer":970,"./topology-reducer":971,"@babel/runtime/helpers/interopRequireDefault":1050,"utils/reducer-utils":1040}],958:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _reducerUtils = require("utils/reducer-utils");

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
// ------------------------------
// Initial State
// ------------------------------
const initialState = {
  query: undefined,
  data: undefined,
  fetching: false,
  error: false
}; // ------------------------------
// Action Handlers
// ------------------------------

function onFetchLambdaFuncUsageHistory(state, {
  payload
}) {
  return { ...initialState,
    query: payload,
    fetching: true
  };
}

function onCompleteFetchLambdaFuncUsageHistory(state, {
  payload
}) {
  if (payload.query !== state.query) {
    return state;
  }

  return { ...state,
    fetching: false,
    error: false,
    data: {
      stats: _mapUsageStats(payload.usage.stats),
      slices: payload.usage.slices.map(_mapUsageStats)
    }
  };
}

function onFailFetchLambdaFuncUsageHistory(state, {
  payload
}) {
  if (payload.query !== state.query) {
    return state;
  }

  return { ...state,
    error: true
  };
}

function onDropLambdaFuncUsageHistory() {
  return initialState;
} // ------------------------------
// Local util functions
// ------------------------------


function _mapUsageStats(sample) {
  return {
    since: sample.since,
    till: sample.till,
    invoked: sample.invoked,
    fulfilled: sample.fulfilled,
    rejected: sample.rejected,
    aggrResponseTime: sample.aggr_response_time,
    maxResponseTime: sample.max_response_time,
    avgResponseTime: sample.avg_response_time,
    responsePercentiles: sample.response_percentiles
  };
} // ------------------------------
// Exported reducer function
// ------------------------------


var _default = (0, _reducerUtils.createReducer)(initialState, {
  [_actionTypes.FETCH_LAMBDA_FUNC_USAGE_HISTORY]: onFetchLambdaFuncUsageHistory,
  [_actionTypes.COMPLETE_FETCH_LAMBDA_FUNC_USAGE_HISTORY]: onCompleteFetchLambdaFuncUsageHistory,
  [_actionTypes.FAIL_FETCH_LAMBDA_FUNC_USAGE_HISTORY]: onFailFetchLambdaFuncUsageHistory,
  [_actionTypes.DROP_LAMBDA_FUNC_USAGE_HISTORY]: onDropLambdaFuncUsageHistory
});

exports.default = _default;

},{"action-types":318,"utils/reducer-utils":1040}],959:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _reducerUtils = require("utils/reducer-utils");

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
// ------------------------------
// Initial State
// ------------------------------
const initialState = undefined; // ------------------------------
// Action Handlers
// ------------------------------

function onChangeLocation(location, {
  payload
}) {
  return { ...payload,
    refreshCount: 0
  };
}

function onRefreshLocation(location) {
  return { ...location,
    refreshCount: location.refreshCount + 1
  };
} // ------------------------------
// Local util functions
// ------------------------------
// ------------------------------
// Exported reducer function
// ------------------------------


var _default = (0, _reducerUtils.createReducer)(initialState, {
  [_actionTypes.CHANGE_LOCATION]: onChangeLocation,
  [_actionTypes.REFRESH_LOCATION]: onRefreshLocation
});

exports.default = _default;

},{"action-types":318,"utils/reducer-utils":1040}],960:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _reducerUtils = require("utils/reducer-utils");

var _coreUtils = require("utils/core-utils");

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
const optionList = (0, _coreUtils.deepFreeze)(['title', 'size', 'severity', 'closeButton', 'backdropClose']); // ------------------------------
// Initial State
// ------------------------------

const initialState = []; // ------------------------------
// Action Handlers
// ------------------------------

function onOpenModal(modals, {
  payload
}) {
  return _openModal(modals, payload);
}

function onUpdateModal(modals, {
  payload
}) {
  if (modals.length > 0) {
    return [...modals.slice(0, -1), { ...(0, _coreUtils.last)(modals),
      ...(0, _coreUtils.pick)(payload, optionList)
    }];
  } else {
    return modals;
  }
}

function onCloseModal(modals, {
  payload
}) {
  return modals.slice(0, -payload.count);
} // ------------------------------
// Local util functions
// ------------------------------


function _openModal(modals, {
  component = 'empty',
  options = {}
}) {
  const {
    name = component,
    params = {}
  } = component;
  const {
    title = '',
    size = 'small',
    severity = '',
    closeButton = 'visible',
    backdropClose = true
  } = options;
  return [...modals, {
    title,
    size,
    severity,
    backdropClose,
    closeButton,
    component: {
      name,
      params
    }
  }];
} // ------------------------------
// Exported reducer function.
// ------------------------------


var _default = (0, _reducerUtils.createReducer)(initialState, {
  [_actionTypes.OPEN_MODAL]: onOpenModal,
  [_actionTypes.UPDATE_MODAL]: onUpdateModal,
  [_actionTypes.CLOSE_MODAL]: onCloseModal
});

exports.default = _default;

},{"action-types":318,"utils/core-utils":1027,"utils/reducer-utils":1040}],961:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _coreUtils = require("utils/core-utils");

var _reducerUtils = require("utils/reducer-utils");

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
// ------------------------------
// Initial State
// ------------------------------
const initialState = undefined; // ------------------------------
// Action Handlers
// ------------------------------

function onCompleteFetchSystemInfo(_, {
  payload
}) {
  const namespaceBuckets = payload.buckets.filter(bucket => bucket.bucket_type === 'NAMESPACE');
  return (0, _coreUtils.keyByProperty)(namespaceBuckets, 'name', _mapBucket);
} // ------------------------------
// Local util functions
// ------------------------------


function _mapBucket(bucket) {
  return {
    name: bucket.name,
    mode: bucket.mode,
    placement: _mapPlacement(bucket.namespace),
    io: _mapIO(bucket.stats)
  };
}

function _mapPlacement(namespace) {
  return {
    readFrom: namespace.read_resources,
    writeTo: namespace.write_resource
  };
}

function _mapIO(stats = {}) {
  const {
    reads = 0,
    writes = 0,
    last_read = -1,
    last_write = -1
  } = stats;
  return {
    readCount: reads,
    lastRead: last_read,
    writeCount: writes,
    lastWrite: last_write
  };
} // ------------------------------
// Exported reducer function
// ------------------------------


var _default = (0, _reducerUtils.createReducer)(initialState, {
  [_actionTypes.COMPLETE_FETCH_SYSTEM_INFO]: onCompleteFetchSystemInfo
});

exports.default = _default;

},{"action-types":318,"utils/core-utils":1027,"utils/reducer-utils":1040}],962:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _coreUtils = require("utils/core-utils");

var _reducerUtils = require("utils/reducer-utils");

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
// ------------------------------
// Initial State
// ------------------------------
const initialState = undefined; // ------------------------------
// Action Handlers
// ------------------------------

function onCompleteFetchSystemInfo(_, {
  payload
}) {
  const resources = payload.namespace_resources;
  return (0, _coreUtils.keyByProperty)(resources, 'name', _mapResource);
} // ------------------------------
// Local util functions
// ------------------------------


function _mapResource(resource) {
  return {
    mode: resource.mode,
    name: resource.name,
    service: resource.endpoint_type,
    target: resource.target_bucket,
    undeletable: resource.undeletable
  };
} // ------------------------------
// Exported reducer function
// ------------------------------


var _default = (0, _reducerUtils.createReducer)(initialState, {
  [_actionTypes.COMPLETE_FETCH_SYSTEM_INFO]: onCompleteFetchSystemInfo
});

exports.default = _default;

},{"action-types":318,"utils/core-utils":1027,"utils/reducer-utils":1040}],963:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _reducerUtils = require("utils/reducer-utils");

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
// ------------------------------
// Initial State
// ------------------------------
const initialState = {
  nextId: 0,
  list: []
}; // ------------------------------
// Action Handlers
// ------------------------------

function onHideNotification(notifications, {
  payload
}) {
  const newlist = notifications.list.filter(notification => notification.id != payload.id);
  return { ...notifications,
    list: newlist
  };
}

function onShowNotification(notifications, {
  payload
}) {
  const {
    severity,
    message
  } = payload;
  const {
    list,
    nextId
  } = notifications;
  return {
    list: [...list, {
      id: nextId,
      severity,
      message
    }],
    nextId: nextId + 1
  };
} // ------------------------------
// Exported reducer function
// ------------------------------


var _default = (0, _reducerUtils.createReducer)(initialState, {
  [_actionTypes.HIDE_NOTIFICATION]: onHideNotification,
  [_actionTypes.SHOW_NOTIFICATION]: onShowNotification
});

exports.default = _default;

},{"action-types":318,"utils/reducer-utils":1040}],964:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _reducerUtils = require("utils/reducer-utils");

var _coreUtils = require("utils/core-utils");

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
// ------------------------------
// Initial State
// ------------------------------
const initialState = {
  fetching: false,
  error: false,
  query: undefined,
  items: undefined
}; // ------------------------------
// Action Handlers
// ------------------------------
// An example of an action handler

function onFetchObjectParts(state, {
  payload
}) {
  const items = _queryMatch(state.query || {}, payload) ? state.items : undefined;
  return { ...state,
    fetching: true,
    error: false,
    query: payload,
    items: items
  };
}

function onCompleteFetchObjectParts(state, {
  payload
}) {
  const {
    query,
    chunks
  } = payload;

  if (!_queryMatch(state.query, query)) {
    return state;
  }

  return { ...state,
    fetching: false,
    error: false,
    items: chunks.map(_mapPart)
  };
}

function onFailFetchObjectParts(state, {
  payload
}) {
  if (!_queryMatch(state.query, payload.query)) {
    return state;
  }

  return { ...state,
    fetching: false,
    error: true
  };
} // ------------------------------
// Local util functions
// ------------------------------


const notAllocatedStorage = {
  kind: 'NOT_ALLOCATED'
};

function _queryMatch(q1, q2) {
  return true && q1.bucket === q2.bucket && q1.key === q2.key && q1.version === q2.version && q1.limit === q2.limit && q1.skip === q2.skip;
}

function _mapPart(chunk) {
  const {
    chunk_coder_config: config
  } = chunk;
  const part = chunk.parts[0];
  const mode = (chunk.is_building_blocks || chunk.is_building_frags) && 'BUILDING' || (chunk.is_accessible ? 'AVAILABLE' : 'UNAVAILABLE');
  const resiliency = config.parity_frags > 0 ? 'ERASURE_CODING' : 'REPLICATION';
  return {
    seq: part.seq,
    size: part.end - part.start,
    mode,
    blocks: _mapPartBlocks(chunk, resiliency)
  };
}

function _mapPartBlocks(chunk, resiliency) {
  return (0, _coreUtils.flatMap)(chunk.frags, frag => {
    const [kind, seq] = _getBlockKindAndSeq(resiliency, frag);

    const blocks = frag.blocks ? frag.blocks.map(block => {
      const toBeRemoved = block.is_deletion || block.is_future_deletion;
      const mode = toBeRemoved && block.is_accessible && 'WAITING_FOR_DELETE' || toBeRemoved && !block.is_accessible && 'CANNOT_BE_DELETED' || block.is_accessible && 'HEALTHY' || 'NOT_ACCESSIBLE';

      const storage = _mapBlockStorage(block);

      const mirrorSet = block.adminfo.mirror_group;
      return {
        mode,
        kind,
        seq,
        mirrorSet,
        storage
      };
    }) : [];
    const allocations = frag.allocations ? frag.allocations.map(alloc => {
      const mode = 'WAITING_FOR_ALLOCATION';
      const storage = notAllocatedStorage;
      const mirrorSet = alloc.mirror_group;
      return {
        mode,
        kind,
        seq,
        mirrorSet,
        storage
      };
    }) : [];
    return [...blocks, ...allocations];
  });
}

function _getBlockKindAndSeq(resiliency, frag) {
  if (resiliency === 'REPLICATION') {
    return ['REPLICA'];
  }

  if ((0, _coreUtils.isDefined)(frag.parity_index)) {
    return ['PARITY', frag.parity_index];
  }

  return ['DATA', frag.data_index];
}

function _mapBlockStorage(block) {
  const {
    in_cloud_pool,
    in_mongo_pool,
    pool_name,
    host_name
  } = block.adminfo;

  if (in_mongo_pool) {
    return {
      kind: 'INTERNAL_STORAGE'
    };
  } else if (in_cloud_pool) {
    return {
      kind: 'CLOUD',
      resource: pool_name
    };
  } else {
    return {
      kind: 'HOSTS',
      pool: pool_name,
      host: host_name
    };
  }
} // ------------------------------
// Exported reducer function
// ------------------------------


var _default = (0, _reducerUtils.createReducer)(initialState, {
  [_actionTypes.FETCH_OBJECT_PARTS]: onFetchObjectParts,
  [_actionTypes.COMPLETE_FETCH_OBJECT_PARTS]: onCompleteFetchObjectParts,
  [_actionTypes.FAIL_FETCH_OBJECT_PARTS]: onFailFetchObjectParts
});

exports.default = _default;

},{"action-types":318,"utils/core-utils":1027,"utils/reducer-utils":1040}],965:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _coreUtils = require("utils/core-utils");

var _reducerUtils = require("utils/reducer-utils");

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
// ------------------------------
// Initial State
// ------------------------------
const initialState = (0, _coreUtils.deepFreeze)({
  objects: [],
  lastUpload: {
    time: 0,
    objectCount: 0
  },
  stats: {
    count: 0,
    uploading: 0,
    uploaded: 0,
    failed: 0,
    batchSize: 0,
    batchLoaded: 0
  }
});
const initialObjectState = (0, _coreUtils.deepFreeze)({
  id: '',
  name: '',
  bucket: '',
  versionId: '',
  size: 0,
  loaded: 0,
  completed: false,
  archived: false,
  error: undefined
}); // ------------------------------
// Action Handlers
// ------------------------------

function onUploadObjects(uploads, {
  payload
}) {
  let {
    time,
    objects
  } = payload;
  const newObjects = objects.map(({
    id,
    bucket,
    file
  }) => ({ ...initialObjectState,
    id,
    bucket,
    name: file.name,
    size: file.size
  }));
  objects = [...uploads.objects, ...newObjects];

  const stats = _recalcStats(objects);

  const lastUpload = {
    time: time,
    objectCount: newObjects.length
  };
  return { ...uploads,
    objects,
    lastUpload,
    stats
  };
}

function onUpdateObjectUpload(uploads, {
  payload
}) {
  const {
    id,
    loaded
  } = payload;
  const objects = uploads.objects.map(obj => obj.id === id ? { ...obj,
    loaded
  } : obj);

  const stats = _recalcStats(objects);

  return { ...uploads,
    objects,
    stats
  };
}

function onCompleteObjectUpload(uploads, {
  payload
}) {
  return _completeUpload(uploads, payload);
}

function onFailObjectUpload(uploads, {
  payload
}) {
  return _completeUpload(uploads, payload);
}

function onClearCompletedObjectUploads(uploads) {
  const objects = uploads.objects.filter(obj => !obj.completed);

  const stats = _recalcStats(objects);

  return { ...uploads,
    objects,
    stats
  };
} // ------------------------------
// Local util functions
// ------------------------------


function _completeUpload(uploads, {
  id,
  extras,
  error
}) {
  const objects = uploads.objects.map(obj => {
    if (obj.id !== id) return obj;
    return { ...obj,
      versionId: error ? undefined : extras.verisonId,
      completed: true,
      error: error && {
        code: error.code,
        message: error.message
      }
    };
  });

  const stats = _recalcStats(objects);

  if (stats.uploading === 0) {
    return { ...uploads,
      objects: objects.map(obj => ({ ...obj,
        archived: true
      })),
      stats: { ...stats,
        batchSize: 0,
        batchLoaded: 0
      }
    };
  } else {
    return { ...uploads,
      objects,
      stats
    };
  }
}

function _recalcStats(objects) {
  return objects.reduce((stats, obj) => {
    const {
      archived,
      completed,
      error
    } = obj;
    stats.count += 1;
    stats.uploading += Number(!completed);
    stats.failed += Number(completed && Boolean(error));
    stats.uploaded += Number(completed && !error);

    if (!archived) {
      const {
        size,
        loaded
      } = obj;
      stats.batchSize += size;
      stats.batchLoaded += loaded;
    }

    return stats;
  }, Object.assign({}, initialState.stats));
} // ------------------------------
// Exported reducer function
// ------------------------------


var _default = (0, _reducerUtils.createReducer)(initialState, {
  [_actionTypes.UPLOAD_OBJECTS]: onUploadObjects,
  [_actionTypes.UPDATE_OBJECT_UPLOAD]: onUpdateObjectUpload,
  [_actionTypes.COMPLETE_OBJECT_UPLOAD]: onCompleteObjectUpload,
  [_actionTypes.FAIL_OBJECT_UPLOAD]: onFailObjectUpload,
  [_actionTypes.CLEAR_COMPLETED_OBJECT_UPLOADES]: onClearCompletedObjectUploads
});

exports.default = _default;

},{"action-types":318,"utils/core-utils":1027,"utils/reducer-utils":1040}],966:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _reducerUtils = require("utils/reducer-utils");

var _coreUtils = require("utils/core-utils");

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
// ------------------------------
// Initial State
// ------------------------------
const initialState = {
  fetching: false,
  error: false
}; // ------------------------------
// Action Handlers
// ------------------------------

function onFetchObjectsDistribution() {
  return { ...initialState,
    fetching: true
  };
}

function onCompleteFetchObjectsDistribution(state, {
  payload
}) {
  return { ...state,
    fetching: false,
    buckets: (0, _coreUtils.keyByProperty)(payload, 'name', record => record.bins.map(bin => ({
      size: bin.sum,
      count: bin.count
    })))
  };
}

function onFailFetchObjectsDistribution(state) {
  return { ...state,
    fetching: false,
    error: true
  };
}

function onDropFetchObjectsDistribution() {
  return initialState;
} // ------------------------------
// Local util functions
// ------------------------------
// ------------------------------
// Exported reducer function
// ------------------------------


var _default = (0, _reducerUtils.createReducer)(initialState, {
  [_actionTypes.FETCH_OBJECTS_DISTRIBUTION]: onFetchObjectsDistribution,
  [_actionTypes.COMPLETE_FETCH_OBJECTS_DISTRIBUTION]: onCompleteFetchObjectsDistribution,
  [_actionTypes.FAIL_FETCH_OBJECTS_DISTRIBUTION]: onFailFetchObjectsDistribution,
  [_actionTypes.DROP_FETCH_OBJECTS_DISTRIBUTION]: onDropFetchObjectsDistribution
});

exports.default = _default;

},{"action-types":318,"utils/core-utils":1027,"utils/reducer-utils":1040}],967:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _reducerUtils = require("utils/reducer-utils");

var _config = require("config");

var _coreUtils = require("utils/core-utils");

var _objectUtils = require("utils/object-utils");

var _itemCacheUtils = require("utils/item-cache-utils");

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
const inMemoryQueryLimit = 10;
const inMemoryHostLimit = _config.paginationPageSize.default * inMemoryQueryLimit; // ------------------------------
// Action Handlers
// ------------------------------

function onFetchObjects(state, {
  payload,
  timestamp
}) {
  const {
    view,
    query
  } = payload;
  return (0, _itemCacheUtils.handleFetch)(state, query, view, timestamp, inMemoryQueryLimit, inMemoryHostLimit);
}

function onCompleteFetchObjects(state, {
  payload
}) {
  const {
    query,
    response
  } = payload;
  return _onCompleteFetch(state, query, response);
}

function onFailFetchObjects(state, {
  payload
}) {
  return (0, _itemCacheUtils.handleFetchFailed)(state, payload.query);
}

function onFetchObject(state, {
  payload,
  timestamp
}) {
  const {
    view,
    bucket,
    object
  } = payload;
  return (0, _itemCacheUtils.handleFetch)(state, {
    bucket,
    object
  }, view, timestamp, inMemoryQueryLimit, inMemoryHostLimit);
}

function onCompleteFetchObject(state, {
  payload
}) {
  const {
    bucket,
    object,
    response
  } = payload;
  return _onCompleteFetch(state, {
    bucket,
    object
  }, response);
}

function onFailFetchObject(state, {
  payload
}) {
  const {
    bucket,
    object
  } = payload;
  return (0, _itemCacheUtils.handleFetchFailed)(state, {
    bucket,
    object
  });
}

function onCompleteDeleteObject(state, {
  payload
}) {
  const {
    bucket,
    key,
    versionId,
    uploadId
  } = payload;
  return (0, _itemCacheUtils.handleRemoveItem)(state, (0, _objectUtils.getObjectId)(bucket, key, versionId, uploadId), (extras, obj) => {
    const counterName = obj.mode.toLowerCase();
    const updatedCounter = extras.counters[counterName] - 1;
    const counters = { ...extras.counters,
      [counterName]: updatedCounter
    };
    return {
      counters
    };
  });
}

function onDropObjectsView(state, {
  payload
}) {
  return (0, _itemCacheUtils.handleDropView)(state, payload.view);
} // ------------------------------
// Local util functions
// ------------------------------


function _onCompleteFetch(state, query, response) {
  const items = (0, _coreUtils.keyBy)(response.objects, obj => (0, _objectUtils.getObjectId)(obj.bucket, obj.key, obj.version_id || 'null', _getUploadId(obj)), (obj, objId) => _mapObject(obj, state.items[objId]));
  const emptyReason = items.length > 0 ? undefined : response.empty_reason;
  const counters = {
    optimal: response.counters.by_mode.completed,
    uploading: response.counters.by_mode.uploading
  };
  return (0, _itemCacheUtils.handleFetchCompleted)(state, query, items, {
    counters,
    emptyReason
  }, inMemoryQueryLimit, inMemoryHostLimit);
}

function _mapObject(obj, lastState) {
  const mode = obj.upload_started ? 'UPLOADING' : 'OPTIMAL';

  const uploadId = _getUploadId(obj);

  const {
    reads = 0,
    last_read
  } = obj.stats || {};
  return {
    bucket: obj.bucket,
    key: obj.key,
    versionId: obj.version_id || 'null',
    uploadId: uploadId,
    latestVersion: Boolean(obj.is_latest),
    deleteMarker: Boolean(obj.delete_marker),
    mode: mode,
    size: {
      original: obj.size,
      onDisk: lastState && lastState.size.onDisk || obj.capacity_size
    },
    contentType: obj.content_type,
    createTime: obj.create_time,
    lastReadTime: last_read,
    readCount: reads,
    partCount: obj.num_parts,
    s3SignedUrl: obj.s3_signed_url
  };
}

function _getUploadId(obj) {
  return obj.upload_started ? obj.obj_id : undefined;
} // ------------------------------
// Exported reducer function
// ------------------------------


var _default = (0, _reducerUtils.createReducer)(_itemCacheUtils.initialState, {
  [_actionTypes.FETCH_OBJECTS]: onFetchObjects,
  [_actionTypes.COMPLETE_FETCH_OBJECTS]: onCompleteFetchObjects,
  [_actionTypes.FAIL_FETCH_OBJECTS]: onFailFetchObjects,
  [_actionTypes.FETCH_OBJECT]: onFetchObject,
  [_actionTypes.COMPLETE_FETCH_OBJECT]: onCompleteFetchObject,
  [_actionTypes.FAIL_FETCH_OBJECT]: onFailFetchObject,
  [_actionTypes.COMPLETE_DELETE_OBJECT]: onCompleteDeleteObject,
  [_actionTypes.DROP_OBJECTS_VIEW]: onDropObjectsView
});

exports.default = _default;

},{"action-types":318,"config":831,"utils/core-utils":1027,"utils/item-cache-utils":1034,"utils/object-utils":1037,"utils/reducer-utils":1040}],968:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _reducerUtils = require("utils/reducer-utils");

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
// ------------------------------
// Initial State
// ------------------------------
const initialState = undefined; // ------------------------------
// Action Handlers
// ------------------------------

function onCompleteCreateSystem(_, {
  payload
}) {
  return payload;
}

function onCompleteRestoreSession(_, {
  payload
}) {
  return payload;
}

function onFailRestoreSession() {
  return null;
}

function onExpireSession(state) {
  if (!state || state.expired) {
    return state;
  }

  return { ...state,
    expired: true
  };
}

function onCompleteSignIn(_, {
  payload
}) {
  return payload;
}

function onSignOut() {
  return null;
}

function onCompleteChangeAccountPassword(state) {
  return { ...state,
    passwordExpired: false
  };
}

function onUpdateAccountUITheme(state, {
  payload
}) {
  const {
    accountName,
    theme
  } = payload;

  if (accountName !== state.user) {
    return state;
  }

  return { ...state,
    uiTheme: theme.toLowerCase()
  };
} // ------------------------------
// Exported reducer function
// ------------------------------


var _default = (0, _reducerUtils.createReducer)(initialState, {
  [_actionTypes.COMPLETE_CREATE_SYSTEM]: onCompleteCreateSystem,
  [_actionTypes.COMPLETE_RESTORE_SESSION]: onCompleteRestoreSession,
  [_actionTypes.FAIL_RESTORE_SESSION]: onFailRestoreSession,
  [_actionTypes.EXPIRE_SESSION]: onExpireSession,
  [_actionTypes.COMPLETE_SIGN_IN]: onCompleteSignIn,
  [_actionTypes.SIGN_OUT]: onSignOut,
  [_actionTypes.COMPLETE_CHANGE_ACCOUNT_PASSWORD]: onCompleteChangeAccountPassword,
  [_actionTypes.UPDATE_ACCOUNT_UI_THEME]: onUpdateAccountUITheme
});

exports.default = _default;

},{"action-types":318,"utils/reducer-utils":1040}],969:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _reducerUtils = require("utils/reducer-utils");

var _stateUtils = require("utils/state-utils");

var _storageUtils = require("utils/storage-utils");

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
// ------------------------------
// Initial State
// ------------------------------
const initialState = undefined; // ------------------------------
// Action Handlers
// ------------------------------

function onFetchSystemStorageHistory(_, {
  payload
}) {
  return payload.history.map(({
    timestamp,
    pool_list
  }) => {
    let {
      HOSTS: hosts = {},
      CLOUD: cloud = {},
      INTERAL: internal = {}
    } = _summarizeResourceList(pool_list);

    return {
      timestamp,
      hosts,
      cloud,
      internal
    };
  }).sort((r1, r2) => r1.timestamp - r2.timestamp);
} // ------------------------------
// Local util functions
// ------------------------------


function _summarizeResourceList(resourceList) {
  return resourceList.reduce((summary, record) => {
    const {
      resource_type: key,
      storage
    } = record;
    summary[key] = (0, _storageUtils.aggregateStorage)(summary[key] || {}, (0, _stateUtils.mapApiStorage)(storage));
    return summary;
  }, {});
} // ------------------------------
// Exported reducer function
// ------------------------------


var _default = (0, _reducerUtils.createReducer)(initialState, {
  [_actionTypes.COMPLETE_FETCH_SYSTEM_STORAGE_HISTORY]: onFetchSystemStorageHistory
});

exports.default = _default;

},{"action-types":318,"utils/reducer-utils":1040,"utils/state-utils":1044,"utils/storage-utils":1045}],970:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _reducerUtils = require("utils/reducer-utils");

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
// ------------------------------
// Initial State
// ------------------------------
const initialState = undefined;
const diagnosticsInitialState = {
  collecting: false,
  error: false,
  packageUri: ''
}; // ------------------------------
// Action Handlers
// ------------------------------

function onCompleteFetchSystemInfo(state, {
  payload,
  timestamp
}) {
  const internalStorage = _mapInternalStorage(payload.pools.find(pool => pool.resource_type === 'INTERNAL'));

  return {
    name: payload.name,
    version: payload.version,
    nodeVersion: payload.node_version,
    dnsName: payload.dns_name,
    ipAddress: payload.ip_address,
    sslPort: Number(payload.ssl_port),
    sslCert: _mapSSLCert(state, Boolean(payload.has_ssl_cert)),
    upgrade: _mapUpgrade(payload),
    p2pSettings: _mapP2PSettings(payload),
    phoneHome: _mapPhoneHome(payload),
    debug: _mapDebug(payload, timestamp),
    maintenanceMode: _mapMaintenanceMode(payload, timestamp),
    releaseNotes: state && state.releaseNotes,
    diagnostics: state ? state.diagnostics : diagnosticsInitialState,
    internalStorage,
    s3Addresses: payload.s3_service.addresses
  };
}

function onFetchVersionReleaseNotes(state, {
  payload
}) {
  const {
    version
  } = payload;
  const releaseNotes = { ...(state.releaseNotes || {}),
    [version]: {
      fetching: true
    }
  };
  return { ...state,
    releaseNotes
  };
}

function onCompleteFetchVersionReleaseNotes(state, {
  payload
}) {
  const {
    version,
    notes
  } = payload;
  const releaseNotes = { ...state.releaseNotes,
    [version]: {
      fetching: false,
      text: notes
    }
  };
  return { ...state,
    releaseNotes
  };
}

function onFailFetchVersionReleaseNotes(state, {
  payload
}) {
  const {
    version
  } = payload;
  const releaseNotes = { ...state.releaseNotes,
    [version]: {
      fetching: false,
      error: true
    }
  };
  return { ...state,
    releaseNotes
  };
}

function onCollectSystemDiagnostics(state) {
  return { ...state,
    diagnostics: {
      collecting: true,
      error: false,
      packageUri: ''
    }
  };
}

function onCompleteCollectSystemDiagnostics(state, {
  payload
}) {
  return { ...state,
    diagnostics: {
      collecting: false,
      error: false,
      packageUri: payload.packageUri
    }
  };
}

function onFailCollectSystemDiagnostics(state) {
  return { ...state,
    diagnostics: {
      collecting: false,
      error: true,
      packageUri: ''
    }
  };
}

function onUploadCertificate(state) {
  return { ...state,
    sslCert: { ...state.sslCert,
      uploadProgress: 0
    }
  };
}

function onUpdateUploadCertificate(state, {
  payload
}) {
  return { ...state,
    sslCert: { ...state.sslCert,
      uploadProgress: payload.progress
    }
  };
}

function onCompleteUploadCertificate(state) {
  const {
    uploadProgress,
    ...sslCert
  } = state.sslCert;
  return { ...state,
    sslCert
  };
}

function onFailUploadCertificate(state) {
  const {
    uploadProgress,
    ...sslCert
  } = state.sslCert;
  return { ...state,
    sslCert
  };
} // ------------------------------
// Local util functions
// ------------------------------


function _mapSSLCert(state, isCertInstalled) {
  return { ...(state ? state.sslCert : {}),
    installed: isCertInstalled
  };
}

function _mapUpgrade(payload) {
  const {
    last_upgrade
  } = payload.upgrade; // DZDZ - hardcoded initiator - not relevant anymore

  return {
    lastUpgrade: last_upgrade && {
      time: last_upgrade.timestamp,
      initiator: 'operator@noobaa.io'
    }
  };
}

function _mapP2PSettings(payload) {
  const {
    port,
    min,
    max
  } = payload.n2n_config.tcp_permanent_passive;
  return {
    tcpPortRange: {
      start: min || port || 1,
      end: max || port || 1
    }
  };
}

function _mapPhoneHome(payload) {
  const reachable = !payload.phone_home_config.phone_home_unable_comm;
  return {
    reachable
  };
}

function _mapDebug(payload, timestamp) {
  const {
    level,
    time_left
  } = payload.debug;
  const till = time_left ? timestamp + time_left : 0;
  return {
    level,
    till
  };
}

function _mapMaintenanceMode(payload, timestamp) {
  const {
    state,
    time_left
  } = payload.maintenance_mode;
  const till = state ? timestamp + time_left : 0;
  return {
    till
  };
}

function _mapInternalStorage(internalResource) {
  const {
    total = 0,
    used = 0,
    free = 0
  } = internalResource ? internalResource.storage : {};
  return {
    total,
    used,
    free
  };
} // ------------------------------
// Exported reducer function
// ------------------------------


var _default = (0, _reducerUtils.createReducer)(initialState, {
  [_actionTypes.COMPLETE_FETCH_SYSTEM_INFO]: onCompleteFetchSystemInfo,
  [_actionTypes.FETCH_VERSION_RELEASE_NOTES]: onFetchVersionReleaseNotes,
  [_actionTypes.COMPLETE_FETCH_VERSION_RELEASE_NOTES]: onCompleteFetchVersionReleaseNotes,
  [_actionTypes.FAIL_FETCH_VERSION_RELEASE_NOTES]: onFailFetchVersionReleaseNotes,
  [_actionTypes.COLLECT_SYSTEM_DIAGNOSTICS]: onCollectSystemDiagnostics,
  [_actionTypes.COMPLETE_COLLECT_SYSTEM_DIAGNOSTICS]: onCompleteCollectSystemDiagnostics,
  [_actionTypes.FAIL_COLLECT_SYSTEM_DIAGNOSTICS]: onFailCollectSystemDiagnostics,
  [_actionTypes.UPLOAD_SSL_CERTIFICATE]: onUploadCertificate,
  [_actionTypes.UPDATE_UPLOAD_SSL_CERTIFICATE]: onUpdateUploadCertificate,
  [_actionTypes.COMPLETE_UPLOAD_SSL_CERTIFICATE]: onCompleteUploadCertificate,
  [_actionTypes.FAIL_UPLOAD_SSL_CERTIFICATE]: onFailUploadCertificate
});

exports.default = _default;

},{"action-types":318,"utils/reducer-utils":1040}],971:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _coreUtils = require("utils/core-utils");

var _reducerUtils = require("utils/reducer-utils");

var _stateUtils = require("utils/state-utils");

var _actionTypes = require("action-types");

/* Copyright (C) 2016 NooBaa */
// ------------------------------
// Initial State
// ------------------------------
const initialState = undefined; // ------------------------------
// Action Handlers
// ------------------------------

function onCompleteFetchSystemInfo(state, {
  payload,
  timestamp
}) {
  const {
    cluster
  } = payload;
  const serverList = (0, _coreUtils.flatMap)(cluster.shards, shard => shard.servers.map(server => {
    const {
      servers = {}
    } = state || {};
    const {
      [server.secret]: serverState = {}
    } = servers;
    return _mapServer(serverState, server, cluster.master_secret, timestamp);
  }));
  const servers = (0, _coreUtils.keyByProperty)(serverList, 'secret');

  const serverMinRequirements = _mapMinRequirements(cluster.min_requirements);

  const serverCount = serverList.length;
  const disconnectedCount = serverList.filter(server => server.mode === 'DISCONNECTED').length;
  const supportHighAvailability = serverCount >= 3;
  const isHighlyAvailable = supportHighAvailability && cluster.shards[0].high_availabilty;
  const faultTolerance = Math.max(Math.ceil(serverCount / 2 - 1) - disconnectedCount, 0);
  return {
    servers,
    serverMinRequirements,
    supportHighAvailability,
    isHighlyAvailable,
    faultTolerance
  };
} // ------------------------------
// Local util functions
// ------------------------------


function _mapServer(serverState, update, masterSecret, timestamp) {
  return {
    hostname: update.hostname,
    secret: update.secret,
    mode: update.status,
    version: update.version,
    addresses: _mapAddresses(update),
    timezone: update.timezone,
    locationTag: update.location,
    storage: (0, _stateUtils.mapApiStorage)(update.storage),
    memory: (0, _coreUtils.pick)(update.memory, ['total', 'used']),
    cpus: (0, _coreUtils.pick)(update.cpus, ['count', 'usage']),
    clockSkew: timestamp - update.time_epoch * 1000,
    dns: _mapDNS(update),
    phonehome: _mapPhonehome(update),
    clusterConnectivity: _mapClusterConnectivity(update),
    debugMode: Boolean(update.debug_level),
    isMaster: update.secret === masterSecret
  };
}

function _mapAddresses(update) {
  return update.addresses.map(addr => ({
    ip: addr
  }));
}

function _mapMinRequirements(requirements) {
  const {
    storage,
    ram: memory,
    cpu_count: cpus
  } = requirements;
  return {
    storage,
    memory,
    cpus
  };
}

function _mapDNS(server) {
  const {
    dns_name_resolution,
    dns_servers
  } = server.services_status;
  return {
    nameResolution: dns_name_resolution && {
      status: dns_name_resolution
    },
    servers: {
      list: server.dns_servers,
      status: dns_servers
    }
  };
}

function _mapPhonehome(server) {
  const {
    phonehome_server
  } = server.services_status;
  return {
    status: phonehome_server.status,
    lastStatusCheck: phonehome_server.test_time * 1000
  };
}

function _mapClusterConnectivity(server) {
  const {
    cluster_communication
  } = server.services_status;
  return (0, _coreUtils.keyByProperty)(cluster_communication.results || {}, 'secret', result => result.status);
} // ------------------------------
// Exported reducer function
// ------------------------------


var _default = (0, _reducerUtils.createReducer)(initialState, {
  [_actionTypes.COMPLETE_FETCH_SYSTEM_INFO]: onCompleteFetchSystemInfo
});

exports.default = _default;

},{"action-types":318,"utils/core-utils":1027,"utils/reducer-utils":1040,"utils/state-utils":1044}],972:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.endpoints = exports.analytics = exports.func = exports.funcs = exports.server = exports.cluster = exports.account = exports.accounts = exports.management = exports.host = exports.cloudResource = exports.pool = exports.resources = exports.object = exports.namespaceBucket = exports.bucket = exports.buckets = exports.system = exports.oauthCallback = exports.asset = exports.root = void 0;

/* Copyright (C) 2016 NooBaa */
const root = '/fe';
exports.root = root;
const asset = `${root}/assets/:asset`;
exports.asset = asset;
const oauthCallback = `${root}/oauth/callback`;
exports.oauthCallback = oauthCallback;
const system = `${root}/systems/:system`;
exports.system = system;
const buckets = `${root}/systems/:system/buckets/:tab?`;
exports.buckets = buckets;
const bucket = `${root}/systems/:system/buckets/data-buckets/:bucket/:tab?/:section?`;
exports.bucket = bucket;
const namespaceBucket = `${root}/systems/:system/buckets/namespace-buckets/:bucket/:tab?`;
exports.namespaceBucket = namespaceBucket;
const object = `${root}/systems/:system/buckets/:bucket/objects/:object/:version/:tab?`;
exports.object = object;
const resources = `${root}/systems/:system/resources/:tab?`;
exports.resources = resources;
const pool = `${root}/systems/:system/resources/storage/pools/:pool/:tab?`;
exports.pool = pool;
const cloudResource = `${root}/systems/:system/resources/storage/cloud/:resource/:tab?`;
exports.cloudResource = cloudResource;
const host = `${root}/systems/:system/resources/storage/pools/:pool/nodes/:host/:tab?`;
exports.host = host;
const management = `${root}/systems/:system/management/:tab?/:section?`;
exports.management = management;
const accounts = `${root}/systems/:system/accounts`;
exports.accounts = accounts;
const account = `${root}/systems/:system/accounts/:account/:tab?`;
exports.account = account;
const cluster = `${root}/systems/:system/cluster/:tab?`;
exports.cluster = cluster;
const server = `${root}/systems/:system/cluster/servers/:server/:tab?`;
exports.server = server;
const funcs = `${root}/systems/:system/functions`;
exports.funcs = funcs;
const func = `${root}/systems/:system/functions/:func/:tab?`;
exports.func = func;
const analytics = `${root}/systems/:system/analytics/:tab?`;
exports.analytics = analytics;
const endpoints = `${root}/systems/:system/endpoints/:tab?`;
exports.endpoints = endpoints;

},{}],973:[function(require,module,exports){
(function (global){
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = routing;

var _coreUtils = require("utils/core-utils");

var _browserUtils = require("utils/browser-utils");

var routes = _interopRequireWildcard(require("routes"));

var _state = require("state");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const protocol = global.location.protocol.slice(0, -1);
const hostname = global.location.hostname; // Register a route handler

function registerRouteHandler(page, route) {
  page(route, ctx => {
    const query = (0, _browserUtils.parseQueryString)(ctx.querystring);
    const {
      ['0']: _,
      ...params
    } = ctx.params;
    const decodedParams = (0, _coreUtils.mapValues)(params, p => p && decodeURIComponent(p)); // Update state about location:

    _state.action$.next((0, _actionCreators.changeLocation)({
      protocol,
      hostname,
      pathname: ctx.pathname,
      route: route !== '*' ? route : undefined,
      params: decodedParams,
      query
    }));
  });
}

function routing(page) {
  // Route handlers.
  registerRouteHandler(page, routes.system);
  registerRouteHandler(page, routes.buckets);
  registerRouteHandler(page, routes.bucket);
  registerRouteHandler(page, routes.namespaceBucket);
  registerRouteHandler(page, routes.object);
  registerRouteHandler(page, routes.resources);
  registerRouteHandler(page, routes.pool);
  registerRouteHandler(page, routes.cloudResource);
  registerRouteHandler(page, routes.host);
  registerRouteHandler(page, routes.account);
  registerRouteHandler(page, routes.management);
  registerRouteHandler(page, routes.accounts);
  registerRouteHandler(page, routes.cluster);
  registerRouteHandler(page, routes.server);
  registerRouteHandler(page, routes.funcs);
  registerRouteHandler(page, routes.func);
  registerRouteHandler(page, routes.analytics);
  registerRouteHandler(page, routes.endpoints); // Catch unknown routes handler

  registerRouteHandler(page, '*');
}

}).call(this,typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})

},{"@babel/runtime/helpers/interopRequireWildcard":1051,"action-creators":306,"routes":972,"state":1016,"utils/browser-utils":1021,"utils/core-utils":1027}],974:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ofType = ofType;
exports.get = get;
exports.getMany = getMany;
exports.toPromise = toPromise;

var _coreUtils = require("utils/core-utils");

var _operators = require("rxjs/operators");

/* Copyright (C) 2016 NooBaa */
function ofType(...types) {
  if (!types.every(_coreUtils.isString)) {
    throw new TypeError('Invalid type constant');
  }

  return source => source.pipe((0, _operators.filter)(obj => types.includes(obj.type)));
}

function get(...path) {
  return source => source.pipe((0, _operators.map)(obj => (0, _coreUtils.get)(obj, path)), (0, _operators.distinctUntilChanged)(Object.is));
}

function getMany(...paths) {
  return source => source.pipe((0, _operators.map)(state => paths.map(path => (0, _coreUtils.get)(state, (0, _coreUtils.ensureArray)(path)))), (0, _operators.distinctUntilChanged)(_coreUtils.equalItems));
}

function toPromise(source) {
  return new Promise((resolve, reject) => {
    source.subscribe(resolve, reject, () => reject(new Error('No more values on stream')));
  });
}

},{"rxjs/operators":287,"utils/core-utils":1027}],975:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/* Copyright (C) 2016 NooBaa */
var _default = {
  type: 'object',
  required: ['fetching', 'error'],
  properties: {
    fetching: {
      type: 'boolean'
    },
    error: {
      type: 'boolean'
    },
    query: {
      duration: {
        type: 'string',
        enum: ['DAY', 'WEEK', 'MONTH']
      },
      buckets: {
        type: 'array',
        items: {
          type: ' string'
        }
      }
    },
    samples: {
      type: 'array',
      items: {
        type: 'object',
        required: ['account', 'readSize', 'writeSize'],
        properties: {
          account: {
            type: 'string'
          },
          readSize: {
            $ref: '#/def/common/size'
          },
          writeSize: {
            $ref: '#/def/common/size'
          }
        }
      }
    }
  }
};
exports.default = _default;

},{}],976:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/* Copyright (C) 2016 NooBaa */
var _default = {
  type: 'object',
  additionalProperties: {
    type: 'object',
    required: ['accessKeys', 'allowedBuckets', 'canCreateBuckets', 'externalConnections', 'isAdmin', 'isOwner', 'isExternal', 'name', 'roles'],
    properties: {
      accessKeys: {
        type: 'object',
        required: ['accessKey', 'secretKey'],
        properties: {
          accessKey: {
            type: 'string'
          },
          secretKey: {
            type: 'string'
          }
        }
      },
      allowedBuckets: {
        type: 'array',
        items: {
          type: 'string'
        }
      },
      canCreateBuckets: {
        type: 'boolean'
      },
      allowedIps: {
        type: 'array',
        items: {
          type: 'object',
          required: ['start', 'end'],
          properties: {
            start: {
              type: 'string'
            },
            end: {
              type: 'string'
            }
          }
        }
      },
      defaultResource: {
        type: 'string'
      },
      externalConnections: {
        type: 'array',
        items: {
          type: 'object',
          required: ['name', 'service', 'endpoint', 'identity', 'usage'],
          properties: {
            name: {
              type: 'string'
            },
            service: {
              type: 'string',
              enum: ['AWS', 'AZURE', 'S3_V2_COMPATIBLE', 'S3_V4_COMPATIBLE', 'NET_STORAGE', 'GOOGLE', 'FLASHBLADE', 'IBM_COS']
            },
            endpoint: {
              type: 'string'
            },
            identity: {
              type: 'string'
            },
            usage: {
              type: 'array',
              items: {
                type: 'object',
                required: ['entity', 'externalEntity', 'usageType'],
                properties: {
                  entity: {
                    type: 'string'
                  },
                  externalEntity: {
                    type: 'string'
                  },
                  usageType: {
                    type: 'string',
                    enum: ['CLOUD_RESOURCE', 'NAMESPACE_RESOURCE']
                  }
                }
              }
            }
          }
        }
      },
      undeletable: {
        type: 'string',
        enum: ['OWNER', 'OWN_BUCKET']
      },
      hasAccessToAllBuckets: {
        type: 'boolean'
      },
      isAdmin: {
        type: 'boolean'
      },
      isOwner: {
        type: 'boolean'
      },
      isExternal: {
        type: 'boolean'
      },
      name: {
        type: 'string'
      },
      roles: {
        type: 'array',
        items: {
          type: 'string'
        }
      }
    }
  }
};
exports.default = _default;

},{}],977:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/* Copyright (C) 2016 NooBaa */
var _default = {
  type: 'object',
  required: ['loading', 'loadError', 'filter', 'list', 'endOfList', 'unreadCounts'],
  properties: {
    loading: {
      type: 'number'
    },
    loadError: {
      oneOf: [{
        type: 'null'
      }, {
        type: 'string'
      }]
    },
    filter: {
      type: 'object',
      properties: {
        read: {
          type: 'boolean'
        },
        severity: {
          type: 'string',
          enum: ['CRIT', 'MAJOR', 'INFO']
        }
      }
    },
    list: {
      type: 'array',
      items: {
        type: 'object',
        required: ['alert', 'id', 'read', 'severity', 'time'],
        properties: {
          alert: {
            type: 'string'
          },
          id: {
            type: 'string'
          },
          read: {
            type: 'boolean'
          },
          severity: {
            type: 'string',
            enum: ['CRIT', 'MAJOR', 'INFO']
          },
          time: {
            type: 'number'
          },
          updating: {
            type: 'boolean'
          }
        }
      }
    },
    endOfList: {
      type: 'boolean'
    },
    unreadCounts: {
      type: 'object',
      properties: {
        crit: {
          type: 'number'
        },
        major: {
          type: 'number'
        },
        info: {
          type: 'number'
        }
      }
    }
  }
};
exports.default = _default;

},{}],978:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/* Copyright (C) 2016 NooBaa */
var _default = {
  type: 'object',
  required: ['loading', 'loadError', 'categories', 'list', 'endOfList', 'selectedRecord'],
  properties: {
    loading: {
      type: 'number'
    },
    loadError: {
      oneOf: [{
        type: 'null'
      }, {
        type: 'string'
      }]
    },
    categories: {
      type: 'array',
      items: {
        type: 'string'
      }
    },
    list: {
      type: 'array',
      items: {
        type: 'object',
        required: ['id', 'time', 'category', 'event', 'desc'],
        properties: {
          id: {
            type: 'string'
          },
          time: {
            type: 'integer'
          },
          actor: {
            type: 'object',
            required: ['name', 'linkable'],
            properties: {
              name: {
                type: 'string'
              },
              linkable: {
                type: 'boolean'
              }
            }
          },
          category: {
            type: 'event'
          },
          event: {
            type: 'string'
          },
          entity: {
            type: 'object',
            required: ['kind', 'linkable'],
            properties: {
              'kind': {
                type: 'string',
                enum: ['node', 'object', 'bucket', 'account', 'resource', 'server', 'func']
              },
              linkable: {
                type: 'boolean'
              }
            },
            additionalProperties: {
              type: 'string'
            }
          },
          desc: {
            type: 'string'
          }
        }
      }
    },
    endOfList: {
      type: 'boolean'
    },
    selectedRecord: {
      type: 'string'
    }
  }
};
exports.default = _default;

},{}],979:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _default = {
  type: 'object',
  additionalProperties: {
    type: 'object',
    required: ['id', 'mode', 'event', 'bucket', 'func', 'prefix', 'suffix'],
    properties: {
      id: {
        type: 'string'
      },
      mode: {
        type: 'string',
        enum: ['OPTIMAL', 'MISSING_PERMISSIONS', 'DISABLED']
      },
      event: {
        type: ' string',
        enum: ['ObjectCreated', 'ObjectRemoved', 'ObjectRead']
      },
      bucket: {
        type: 'object',
        requried: ['kind', 'name'],
        properties: {
          kind: {
            type: 'string',
            enum: ['DATA_BUCKET', 'NAMESPACE_BUCKET']
          },
          name: {
            type: 'string'
          }
        }
      },
      func: {
        type: 'object',
        required: ['name', 'version'],
        properties: {
          name: {
            type: 'string'
          },
          version: {
            type: 'string'
          }
        }
      },
      prefix: {
        type: 'string'
      },
      suffix: {
        type: 'string'
      },
      lastRun: {
        type: ' integer'
      }
    }
  }
};
exports.default = _default;

},{}],980:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/* Copyright (C) 2016 NooBaa */
var _default = {
  type: 'object',
  required: ['fetching', 'error'],
  properties: {
    fetching: {
      type: 'boolean'
    },
    error: {
      type: 'boolean'
    },
    query: {
      duration: {
        type: 'string',
        enum: ['DAY', 'WEEK', 'MONTH']
      },
      buckets: {
        type: 'array',
        items: {
          type: ' string'
        }
      }
    },
    samples: {
      type: 'array',
      items: {
        type: 'object',
        required: ['startTime', 'endTime', 'readSize', 'writeSize'],
        properties: {
          startTime: {
            type: 'integer'
          },
          endTime: {
            type: 'integer'
          },
          readSize: {
            $ref: '#/def/common/size'
          },
          writeSize: {
            $ref: '#/def/common/size'
          }
        }
      }
    }
  }
};
exports.default = _default;

},{}],981:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/* Copyright (C) 2016 NooBaa */
const resiliencyMode = {
  type: 'string',
  enum: ['NOT_ENOUGH_RESOURCES', 'POLICY_PARTIALLY_APPLIED', 'RISKY_TOLERANCE', 'DATA_ACTIVITY', 'OPTIMAL']
};
const tierMode = {
  type: 'string',
  enum: ['NO_RESOURCES', 'NOT_ENOUGH_RESOURCES', 'NOT_ENOUGH_HEALTHY_RESOURCES', 'INTERNAL_STORAGE_ISSUES', 'NO_CAPACITY', 'LOW_CAPACITY', 'OPTIMAL']
};
var _default = {
  type: 'object',
  additionalProperties: {
    type: 'object',
    required: ['name', 'mode', 'storage', 'data', 'objects', 'placement', 'resiliency', 'versioning', 'io', 'usageDistribution', 'failureTolerance', 'usageDistribution', 'statsByDataType'],
    properties: {
      name: {
        type: 'string'
      },
      mode: {
        type: 'string',
        enum: ['NO_RESOURCES', 'NOT_ENOUGH_RESOURCES', 'NOT_ENOUGH_HEALTHY_RESOURCES', 'NO_CAPACITY', 'ALL_TIERS_HAVE_ISSUES', 'EXCEEDING_QUOTA', 'TIER_NO_RESOURCES', 'TIER_NOT_ENOUGH_RESOURCES', 'TIER_NOT_ENOUGH_HEALTHY_RESOURCES', 'TIER_NO_CAPACITY', 'LOW_CAPACITY', 'TIER_LOW_CAPACITY', 'NO_RESOURCES_INTERNAL', 'RISKY_TOLERANCE', 'APPROUCHING_QUOTA', 'DATA_ACTIVITY', 'OPTIMAL']
      },
      storage: {
        $ref: '#/def/common/storage'
      },
      data: {
        type: 'object',
        properties: {
          lastUpdate: {
            type: 'integer'
          },
          size: {
            $ref: '#/def/common/size'
          },
          sizeReduced: {
            $ref: '#/def/common/size'
          },
          availableForUpload: {
            $ref: '#/def/common/size'
          }
        }
      },
      objects: {
        type: 'object',
        properties: {
          count: {
            type: 'integer'
          },
          lastUpdate: {
            type: 'integer'
          }
        }
      },
      placement: {
        type: 'object',
        required: ['tiers'],
        properties: {
          tiers: {
            oneOf: [{
              type: 'array',
              minItems: 1,
              maxItems: 1,
              items: {
                type: 'object',
                required: ['name', 'mode', 'policyType'],
                properties: {
                  name: {
                    type: 'string'
                  },
                  mode: tierMode,
                  policyType: {
                    type: 'string',
                    enum: ['INTERNAL_STORAGE']
                  }
                }
              }
            }, {
              type: 'array',
              minItems: 1,
              maxItems: 2,
              items: {
                type: 'object',
                required: ['name', 'mode', 'policyType'],
                properties: {
                  name: {
                    type: 'string'
                  },
                  mode: tierMode,
                  policyType: {
                    type: 'string',
                    enum: ['MIRROR', 'SPREAD']
                  },
                  mirrorSets: {
                    type: 'array',
                    items: {
                      type: 'object',
                      required: ['name', 'resources'],
                      properties: {
                        name: {
                          type: 'string'
                        },
                        resources: {
                          type: 'array',
                          items: {
                            type: 'object',
                            required: ['type', 'name'],
                            properties: {
                              type: {
                                type: 'string',
                                enum: ['HOSTS', 'CLOUD']
                              },
                              name: {
                                type: 'string'
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }]
          }
        }
      },
      resiliency: {
        oneOf: [{
          type: 'object',
          required: ['mode', 'kind', 'replicas'],
          properties: {
            mode: resiliencyMode,
            kind: {
              const: 'REPLICATION'
            },
            replicas: {
              type: 'integer'
            }
          }
        }, {
          type: 'object',
          required: ['mode', 'kind', 'dataFrags', 'parityFrags'],
          properties: {
            mode: resiliencyMode,
            kind: {
              const: 'ERASURE_CODING'
            },
            dataFrags: {
              type: 'integer'
            },
            parityFrags: {
              type: 'integer'
            }
          }
        }]
      },
      versioning: {
        type: 'object',
        required: ['mode'],
        properties: {
          mode: {
            type: 'string',
            enum: ['DISABLED', 'SUSPENDED', 'ENABLED']
          }
        }
      },
      io: {
        type: 'object',
        required: ['readCount', 'writeCount', 'lastRead', 'lastWrite'],
        properties: {
          readCount: {
            type: 'integer'
          },
          lastRead: {
            type: 'integer'
          },
          writeCount: {
            type: 'integer'
          },
          lastWrite: {
            type: 'integer'
          }
        }
      },
      quota: {
        type: 'object',
        required: ['mode', 'size', 'unit'],
        properties: {
          mode: {
            type: 'string',
            enum: ['EXCEEDING_QUOTA', 'APPROUCHING_QUOTA', 'OPTIMAL']
          },
          size: {
            type: 'integer'
          },
          unit: {
            type: 'string',
            enum: ['GIGABYTE', 'TERABYTE', 'PETABYTE']
          }
        }
      },
      failureTolerance: {
        type: 'object',
        required: ['hosts', 'nodes'],
        properties: {
          hosts: {
            type: 'integer'
          },
          nodes: {
            type: 'integer'
          }
        }
      },
      usageDistribution: {
        type: 'object',
        required: ['lastUpdate', 'resources'],
        properties: {
          lastUpdate: {
            type: 'integer'
          },
          resources: {
            type: 'object',
            additionalProperties: {
              type: 'integer'
            }
          }
        }
      },
      statsByDataType: {
        type: 'object',
        additionalProperties: {
          type: 'object',
          required: ['reads', 'writes', 'size', 'count'],
          properties: {
            reads: {
              type: 'integer'
            },
            writes: {
              type: 'integer'
            },
            size: {
              $ref: '#/def/common/size'
            },
            count: {
              type: 'integer'
            }
          }
        }
      },
      undeletable: {
        type: 'string',
        enum: ['NOT_EMPTY']
      }
    }
  }
};
exports.default = _default;

},{}],982:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/* Copyright (C) 2016 NooBaa */
var _default = {
  type: 'object',
  additionalProperties: {
    type: 'object',
    required: ['name', 'mode', 'type', 'endpoint', 'target', 'storage', 'usedBy', 'associatedAccounts', 'createdBy', 'creationTime', 'internalHost', 'io'],
    properties: {
      name: {
        type: 'string'
      },
      mode: {
        type: 'string',
        enum: ['OPTIMAL', 'INITIALIZING', 'IO_ERRORS', 'ALL_NODES_OFFLINE', 'STORAGE_NOT_EXIST', 'AUTH_FAILED']
      },
      type: {
        type: 'string',
        enum: ['AWS', 'AZURE', 'S3_COMPATIBLE', 'GOOGLE', 'FLASHBLADE', 'NET_STORAGE', 'IBM_COS']
      },
      endpoint: {
        type: 'string'
      },
      target: {
        type: 'string'
      },
      storage: {
        $ref: '#/def/common/storage'
      },
      region: {
        type: 'string'
      },
      undeletable: {
        type: 'string',
        enum: ['NOT_EMPTY', 'IN_USE', 'DEFAULT_RESOURCE', 'CONNECTED_BUCKET_DELETING', 'IS_BACKINGSTORE']
      },
      usedBy: {
        type: 'array',
        items: {
          type: 'string'
        }
      },
      associatedAccounts: {
        type: 'array',
        items: {
          type: 'string'
        }
      },
      createdBy: {
        type: 'string'
      },
      creationTime: {
        type: 'integer'
      },
      'internalHost': {
        type: 'string'
      },
      io: {
        type: 'object',
        requires: ['readCount', 'readSize', 'writeCount', 'writeSize'],
        properties: {
          readCount: {
            type: 'integer'
          },
          readSize: {
            $ref: '#/def/common/size'
          },
          writeCount: {
            type: 'integer'
          },
          writeSize: {
            $ref: '#/def/common/size'
          }
        }
      }
    }
  }
};
exports.default = _default;

},{}],983:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/* Copyright (C) 2016 NooBaa */
var _default = {
  type: 'object',
  properties: {
    connection: {
      type: 'string'
    },
    list: {
      type: 'array',
      items: {
        type: 'object',
        required: ['name'],
        properties: {
          name: {
            type: 'string'
          },
          usedBy: {
            type: 'object',
            required: ['kind', 'name'],
            properties: {
              kind: {
                type: 'string',
                enum: ['CLOUD_RESOURCE', 'NAMESPACE_RESOURCE']
              },
              name: {
                type: 'string'
              }
            }
          }
        }
      }
    },
    fetching: {
      type: 'boolean'
    },
    error: {
      type: 'boolean'
    }
  }
};
exports.default = _default;

},{}],984:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/* Copyright (C) 2016 NooBaa */
var _default = {
  type: 'object',
  required: ['fetching', 'error'],
  properties: {
    fetching: {
      type: 'boolean'
    },
    error: {
      type: 'boolean'
    },
    query: {
      duration: {
        type: 'string',
        enum: ['DAY', 'WEEK', 'MONTH']
      }
    },
    usage: {
      type: 'object',
      additionalProperties: {
        type: 'object',
        required: ['readCount', 'writeCount', 'readSize', 'writeSize'],
        properties: {
          readCount: {
            type: 'integer'
          },
          writeCount: {
            type: 'integer'
          },
          readSize: {
            $ref: '#/def/common/size'
          },
          writeSize: {
            $ref: '#/def/common/size'
          }
        }
      }
    }
  }
};
exports.default = _default;

},{}],985:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.lambdaFuncStats = exports.bufferKey = exports.diagnostics = exports.port = exports.serviceCheckResult = exports.storage = exports.size = void 0;

/* Copyright (C) 2016 NooBaa */
const size = {
  oneOf: [{
    type: 'integer'
  }, {
    type: 'object',
    properties: {
      n: {
        type: 'integer'
      },
      peta: {
        type: 'integer'
      }
    }
  }]
};
exports.size = size;
const storage = {
  type: 'object',
  properties: {
    lastUpdate: {
      type: 'integer'
    },
    total: {
      $ref: '#/def/common/size'
    },
    free: {
      $ref: '#/def/common/size'
    },
    unavailableFree: {
      $ref: '#/def/common/size'
    },
    used: {
      $ref: '#/def/common/size'
    },
    unavailableUsed: {
      $ref: '#/def/common/size'
    },
    usedOther: {
      $ref: '#/def/common/size'
    },
    reserved: {
      $ref: '#/def/common/size'
    }
  }
};
exports.storage = storage;
const serviceCheckResult = {
  type: 'string',
  enum: ['UNKNOWN', 'FAULTY', 'UNREACHABLE', 'OPERATIONAL']
};
exports.serviceCheckResult = serviceCheckResult;
const port = {
  type: 'integer',
  minimum: 1,
  maximum: 65535
};
exports.port = port;
const diagnostics = {
  type: 'object',
  required: ['collecting', 'error', 'packageUri'],
  properties: {
    collecting: {
      type: 'boolean'
    },
    error: {
      type: 'boolean'
    },
    packageUri: {
      type: 'string'
    }
  }
};
exports.diagnostics = diagnostics;
const bufferKey = {
  oneOf: [{
    type: 'null'
  }, {
    type: 'object',
    required: ['key'],
    properties: {
      key: {
        type: 'string'
      }
    }
  }]
};
exports.bufferKey = bufferKey;
const lambdaFuncStats = {
  type: 'object',
  required: ['since', 'till', 'invoked', 'fulfilled', 'rejected', 'aggrResponseTime', 'maxResponseTime', 'avgResponseTime', 'responsePercentiles'],
  properties: {
    since: {
      type: 'integer'
    },
    till: {
      type: 'integer'
    },
    invoked: {
      type: 'integer'
    },
    fulfilled: {
      type: 'integer'
    },
    rejected: {
      type: 'integer'
    },
    aggrResponseTime: {
      type: 'integer'
    },
    maxResponseTime: {
      type: 'integer'
    },
    avgResponseTime: {
      type: 'integer'
    },
    responsePercentiles: {
      type: 'array',
      items: {
        type: 'object',
        required: ['percentile', 'value'],
        properties: {
          percentile: {
            type: 'number',
            minimum: 0,
            maximum: 1
          },
          value: {
            type: 'integer'
          }
        }
      }
    }
  }
};
exports.lambdaFuncStats = lambdaFuncStats;

},{}],986:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/* Copyright (C) 2016 NooBaa */
var _default = {
  type: 'string'
};
exports.default = _default;

},{}],987:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/* Copyright (C) 2016 NooBaa */
var _default = {
  type: 'object',
  additionalProperties: {
    type: 'object',
    required: ['name', 'lastReportTime', 'endpointCount', 'cpuCount', 'cpuUsage', 'memoryUsage'],
    properties: {
      name: {
        type: 'string'
      },
      isRemote: {
        type: 'boolean'
      },
      region: {
        type: 'string'
      },
      endpointCount: {
        type: 'integer'
      },
      endpointRange: {
        type: 'object',
        required: ['min', 'max'],
        properties: {
          min: {
            type: 'integer',
            minimum: 1
          },
          max: {
            type: 'integer',
            minimum: 1
          }
        }
      },
      cpuCount: {
        type: 'integer'
      },
      cpuUsage: {
        type: 'number'
      },
      memoryUsage: {
        type: 'number'
      },
      lastReportTime: {
        type: 'integer'
      }
    }
  }
};
exports.default = _default;

},{}],988:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/* Copyright (C) 2016 NooBaa */
var _default = {
  type: 'object',
  required: ['fetching', 'error'],
  properties: {
    fetching: {
      type: 'boolean'
    },
    error: {
      type: 'boolean'
    },
    query: {
      groups: {
        type: 'array',
        items: {
          type: 'string'
        }
      },
      timespan: {
        type: 'string',
        enum: ['24_HOURS', '7_DAYS', '4_WEEKS']
      }
    },
    samples: {
      type: 'array',
      items: {
        type: 'object',
        required: ['readSize', 'writeSize'],
        properties: {
          timestamp: {
            type: 'integer'
          },
          endpointCount: {
            type: 'number'
          },
          cpuCount: {
            type: 'number'
          },
          cpuUsage: {
            type: 'number'
          },
          memoryUsage: {
            type: 'number'
          },
          readSize: {
            $ref: '#/def/common/size'
          },
          writeSize: {
            $ref: '#/def/common/size'
          }
        }
      }
    }
  }
};
exports.default = _default;

},{}],989:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/* Copyright (C) 2016 NooBaa */
var _default = {
  type: 'object',
  required: ['previewContent', 'browser', 'isBrowserStickyDismissed'],
  properties: {
    browser: {
      type: 'string'
    },
    previewContent: {
      type: 'boolean'
    },
    isBrowserStickyDismissed: {
      type: 'boolean'
    }
  }
};
exports.default = _default;

},{}],990:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/* Copyright (C) 2016 NooBaa */
var _default = {
  type: 'object',
  additionalProperties: {
    type: 'object',
    required: ['fields', 'warnings', 'syncErrors', 'asyncErrors', 'submitErrors', 'validatingAsync', 'validated', 'submitting', 'submitted'],
    properties: {
      fields: {
        type: 'object',
        additionalProperties: {
          type: 'object',
          required: ['touched', 'validity'],
          properties: {
            initial: {},
            touched: {
              type: 'boolean'
            },
            validity: {
              type: 'string',
              enum: ['INVALID', 'UNKNOWN', 'VALID']
            },
            value: {}
          }
        }
      },
      warnings: {
        type: 'object',
        additionalProperties: {
          type: 'string'
        }
      },
      syncErrors: {
        type: 'object',
        additionalProperties: {
          type: 'string'
        }
      },
      asyncErrors: {
        type: 'object',
        additionalProperties: {
          type: 'string'
        }
      },
      submitErrors: {
        type: 'object',
        additionalProperties: {
          type: 'string'
        }
      },
      validatingAsync: {
        oneOf: [{
          type: 'null'
        }, {
          type: 'array',
          items: {
            type: 'string'
          }
        }]
      },
      validated: {
        type: 'boolean'
      },
      submitting: {
        type: 'boolean'
      },
      submitted: {
        type: 'boolean'
      }
    }
  }
};
exports.default = _default;

},{}],991:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/* Copyright (C) 2016 NooBaa */
var _default = {
  type: 'object',
  additionalProperties: {
    type: 'object',
    required: ['name', 'version', 'description', 'execFile', 'execFunc', 'runtime', 'timeout', 'memorySize', 'lastModified', 'lastModifier', 'executor', 'codeSize', 'codeHash', 'codeBuffer'],
    properties: {
      name: {
        type: 'string'
      },
      version: {
        type: 'string'
      },
      execFile: {
        type: 'string'
      },
      execFunc: {
        type: 'string'
      },
      description: {
        type: 'string'
      },
      runtime: {
        type: 'string'
      },
      timeout: {
        type: 'integer'
      },
      memorySize: {
        type: 'integer'
      },
      lastModified: {
        type: 'integer'
      },
      lastModifier: {
        type: 'string'
      },
      executor: {
        type: 'string'
      },
      codeHash: {
        type: 'string'
      },
      codeSize: {
        $ref: '#/def/common/size'
      },
      codeBuffer: {
        type: 'object',
        required: ['loading', 'error', 'handle'],
        properties: {
          loading: {
            type: 'boolean'
          },
          error: {
            type: 'boolean'
          },
          handle: {
            $ref: '#/def/common/bufferKey'
          }
        }
      }
    }
  }
};
exports.default = _default;

},{}],992:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/* Copyright (C) 2016 NooBaa */
var _default = {
  type: 'object',
  required: ['host', 'partCount', 'fetching', 'error'],
  properties: {
    host: {
      type: 'string'
    },
    parts: {
      type: 'array',
      items: {
        type: 'object',
        required: ['mode', 'objectInfo', 'start', 'end'],
        properties: {
          mode: {
            type: 'string',
            enum: ['AVAILABLE', 'BUILDING', 'UNAVAILABLE']
          },
          objectInfo: {
            type: 'object',
            required: ['bucket', 'key', 'version', 'isUploading', 'isDeleteMarker'],
            properties: {
              bucket: {
                type: 'string'
              },
              key: {
                type: 'string'
              },
              version: {
                type: 'string'
              },
              isUploading: {
                type: 'boolean'
              },
              isDeleteMarker: {
                type: 'boolean'
              }
            }
          },
          start: {
            type: 'integer'
          },
          end: {
            type: 'integer'
          }
        }
      }
    },
    skip: {
      type: 'integer'
    },
    limit: {
      type: 'integer'
    },
    partCount: {
      type: 'integer'
    },
    fetching: {
      type: 'boolean'
    },
    error: {
      type: 'boolean'
    }
  }
};
exports.default = _default;

},{}],993:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/* Copyright (C) 2016 NooBaa */
var _default = {
  type: 'object',
  additionalProperties: {
    type: 'object',
    required: ['name', 'creationTime', 'mode', 'isManaged', 'activities', 'associatedAccounts', 'hostCount', 'hostsByMode', 'configuredHostCount', 'storageNodeCount', 'storageNodesByMode', 'endpointNodeCount', 'endpointNodesByMode', 'storage'],
    properties: {
      name: {
        type: 'string'
      },
      creationTime: {
        type: 'integer'
      },
      mode: {
        type: 'string',
        enum: ['BEING_CREATED', 'INITIALIZING', 'INITIALIZING_FAILED', 'DELETING', 'HAS_NO_NODES', 'SCALING', 'ALL_NODES_OFFLINE', 'NO_CAPACITY', 'ALL_HOSTS_IN_PROCESS', 'MOST_NODES_ISSUES', 'MANY_NODES_ISSUES', 'MOST_STORAGE_ISSUES', 'MANY_STORAGE_ISSUES', 'MOST_S3_ISSUES', 'MANY_S3_ISSUES', 'MANY_NODES_OFFLINE', 'LOW_CAPACITY', 'HIGH_DATA_ACTIVITY', 'IO_ERRORS', 'STORAGE_NOT_EXIST', 'AUTH_FAILED', 'OPTIMAL']
      },
      isManaged: {
        type: 'boolean'
      },
      activities: {
        type: 'object',
        required: ['hostCount', 'list'],
        properties: {
          hostCount: {
            type: 'integer'
          },
          list: {
            type: 'array',
            items: {
              type: 'object',
              required: ['kind', 'nodeCount'],
              properties: {
                kind: {
                  type: 'string',
                  enum: ['RESTORING', 'MIGRATING', 'DECOMMISSIONING', 'DELETING']
                },
                nodeCount: {
                  type: 'integer'
                },
                progress: {
                  type: 'number',
                  minimum: 0,
                  maximum: 1
                },
                eta: {
                  type: 'integer'
                }
              }
            }
          }
        }
      },
      associatedAccounts: {
        type: 'array',
        items: {
          type: 'string'
        }
      },
      hostCount: {
        type: 'integer'
      },
      hostsByMode: {
        type: 'object',
        additionalProperties: {
          type: 'integer'
        }
      },
      configuredHostCount: {
        type: 'integer'
      },
      storageNodeCount: {
        type: 'integer'
      },
      storageNodesByMode: {
        type: 'object',
        additionalProperties: {
          type: 'integer'
        }
      },
      endpointNodeCount: {
        type: 'integer'
      },
      endpointNodesByMode: {
        type: 'object',
        additionalProperties: {
          type: 'integer'
        }
      },
      storage: {
        $ref: '#/def/common/storage'
      },
      region: {
        type: 'string'
      },
      undeletable: {
        type: 'string',
        enum: ['SYSTEM_ENTITY', 'NOT_EMPTY', 'IN_USE', 'DEFAULT_RESOURCE', 'BEING_DELETED', 'CONNECTED_BUCKET_DELETING', 'IS_BACKINGSTORE']
      },
      hostConfig: {
        type: 'object',
        required: ['volumeSize'],
        properties: {
          volumeSize: {
            $ref: '#/def/common/size'
          }
        }
      }
    }
  }
};
exports.default = _default;

},{}],994:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/* Copyright (C) 2016 NooBaa */
const storageNode = {
  type: 'object',
  required: ['name', 'mode', 'storage', 'drive', 'mount', 'readLatency', 'writeLatency', 'untrusted'],
  properties: {
    name: {
      type: 'string'
    },
    mode: {
      type: 'string',
      enum: ['OFFLINE', 'UNTRUSTED', 'INITIALIZING', 'DELETING', 'DECOMMISSIONING', 'DECOMMISSIONED', 'MIGRATING', 'N2N_ERRORS', 'GATEWAY_ERRORS', 'IO_ERRORS', 'LOW_CAPACITY', 'NO_CAPACITY', 'N2N_PORTS_BLOCKED', 'STORAGE_NOT_EXIST', 'OPTIMAL']
    },
    storage: {
      $ref: '#/def/common/storage'
    },
    drive: {
      type: 'string'
    },
    mount: {
      type: 'string'
    },
    readLatency: {
      type: 'number'
    },
    writeLatency: {
      type: 'number'
    },
    activity: {
      type: 'object',
      required: ['kind', 'progress', 'stage'],
      properties: {
        kind: {
          type: 'string',
          enum: ['RESTORING', 'MIGRATING', 'DECOMMISSIONING', 'DELETING']
        },
        progress: {
          type: 'number',
          minimum: 0,
          maximum: 1
        },
        stage: {
          type: 'string',
          enum: ['OFFLINE_GRACE', 'REBUILDING', 'WIPING']
        }
      }
    },
    untrusted: {
      type: 'array',
      items: {
        type: 'array',
        items: {
          type: 'object',
          required: ['reason', 'time'],
          properties: {
            reason: {
              type: 'string',
              enum: ['CORRUPTION', 'TEMPERING']
            },
            time: {
              type: 'integer'
            }
          }
        }
      }
    }
  }
};
const host = {
  type: 'object',
  required: ['name', 'hostname', 'pool', 'mode', 'version', 'ip', 'protocol', 'endpoint', 'rpcAddress', 'lastCommunication', 'rtt', 'storage', 'trusted', 'activities', 'services', 'upTime', 'os', 'cpus', 'memory', 'debugMode', 'diagnostics'],
  properties: {
    name: {
      type: 'string'
    },
    hostname: {
      type: 'string'
    },
    pool: {
      type: 'string'
    },
    suggestedPool: {
      type: 'string'
    },
    mode: {
      type: 'string',
      enum: ['DECOMMISSIONED', 'OFFLINE', 'STORAGE_OFFLINE', 'UNTRUSTED', 'STORAGE_NOT_EXIST', 'IO_ERRORS', 'N2N_ERRORS', 'GATEWAY_ERRORS', 'INITIALIZING', 'DECOMMISSIONING', 'MIGRATING', 'IN_PROCESS', 'SOME_STORAGE_MIGRATING', 'SOME_STORAGE_INITIALIZING', 'SOME_STORAGE_DECOMMISSIONING', 'DELETING', 'SOME_STORAGE_OFFLINE', 'SOME_STORAGE_NOT_EXIST', 'SOME_STORAGE_IO_ERRORS', 'NO_CAPACITY', 'LOW_CAPACITY', 'HAS_ERRORS', 'HAS_ISSUES', 'N2N_PORTS_BLOCKED', 'OPTIMAL']
    },
    version: {
      type: 'string'
    },
    ip: {
      type: 'string'
    },
    publicIp: {
      type: 'string'
    },
    ports: {
      type: 'object',
      required: ['max', 'min'],
      properties: {
        max: {
          type: 'integer'
        },
        min: {
          type: 'integer'
        }
      }
    },
    protocol: {
      type: 'string'
    },
    endpoint: {
      type: 'string'
    },
    rpcAddress: {
      type: 'string'
    },
    lastCommunication: {
      type: 'integer'
    },
    rtt: {
      type: 'number'
    },
    storage: {
      $ref: '#/def/common/storage'
    },
    trusted: {
      type: 'boolean'
    },
    activities: {
      type: 'array',
      items: {
        type: 'object',
        required: ['kind', 'nodeCount', 'progress'],
        properties: {
          kind: {
            type: 'string',
            enum: ['RESTORING', 'MIGRATING', 'DECOMMISSIONING', 'DELETING']
          },
          nodeCount: {
            type: 'integer'
          },
          progress: {
            type: 'number',
            minimum: 0,
            maximum: 1
          },
          eta: {
            type: 'integer'
          }
        }
      }
    },
    services: {
      type: 'object',
      required: ['storage'],
      properties: {
        storage: {
          type: 'object',
          required: ['enabled', 'mode', 'nodes'],
          properties: {
            enabled: {
              type: 'boolean'
            },
            mode: {
              type: 'string',
              enum: ['DECOMMISSIONED', 'OFFLINE', 'UNTRUSTED', 'STORAGE_NOT_EXIST', 'IO_ERRORS', 'N2N_ERRORS', 'GATEWAY_ERRORS', 'INITIALIZING', 'DELETING', 'DECOMMISSIONING', 'MIGRATING', 'IN_PROCESS', 'SOME_STORAGE_MIGRATING', 'SOME_STORAGE_INITIALIZING', 'SOME_STORAGE_DECOMMISSIONING', 'SOME_STORAGE_OFFLINE', 'SOME_STORAGE_NOT_EXIST', 'SOME_STORAGE_IO_ERRORS', 'NO_CAPACITY', 'LOW_CAPACITY', 'N2N_PORTS_BLOCKED', 'OPTIMAL']
            },
            nodes: {
              type: 'array',
              items: storageNode
            }
          }
        }
      }
    },
    upTime: {
      type: 'integer'
    },
    os: {
      type: 'string'
    },
    cpus: {
      type: 'object',
      required: ['units', 'usedByOther', 'usedByNoobaa'],
      properties: {
        units: {
          type: 'array',
          items: {
            type: 'object',
            required: ['model', 'speed'],
            properties: {
              model: {
                type: 'string'
              },
              speed: {
                type: 'integer'
              }
            }
          }
        },
        usedByOther: {
          type: 'number'
        },
        usedByNoobaa: {
          type: 'number'
        }
      }
    },
    memory: {
      type: 'object',
      required: ['free', 'usedByNoobaa', 'usedByOther'],
      properties: {
        free: {
          type: 'integer'
        },
        usedByNoobaa: {
          type: 'integer'
        },
        usedByOther: {
          type: 'integer'
        }
      }
    },
    debugMode: {
      type: 'object',
      required: ['state'],
      properties: {
        state: {
          type: 'boolean'
        },
        timeLeft: {
          type: 'integer'
        }
      }
    },
    diagnostics: {
      $ref: '#/def/common/diagnostics'
    }
  }
};
var _default = {
  type: 'object',
  required: ['views', 'queries', 'items'],
  properties: {
    views: {
      type: 'object',
      additionalProperties: {
        type: 'integer'
      }
    },
    queries: {
      type: 'object',
      additionalProperties: {
        type: 'object',
        required: ['timestamp', 'fetching', 'error'],
        properties: {
          timestamp: {
            type: 'integer'
          },
          fetching: {
            type: 'boolean'
          },
          error: {
            type: 'boolean'
          },
          result: {
            type: 'object',
            required: ['counters', 'items'],
            properties: {
              counters: {
                type: 'object',
                required: ['byMode', 'nonPaginated'],
                properties: {
                  byMode: {
                    type: 'object',
                    properties: {
                      DECOMMISSIONED: {
                        type: 'integer'
                      },
                      OFFLINE: {
                        type: 'integer'
                      },
                      STORAGE_OFFLINE: {
                        type: 'integer'
                      },
                      UNTRUSTED: {
                        type: 'integer'
                      },
                      STORAGE_NOT_EXIST: {
                        type: 'integer'
                      },
                      IO_ERRORS: {
                        type: 'integer'
                      },
                      N2N_ERRORS: {
                        type: 'integer'
                      },
                      GATEWAY_ERRORS: {
                        type: 'integer'
                      },
                      INITIALIZING: {
                        type: 'integer'
                      },
                      DECOMMISSIONING: {
                        type: 'integer'
                      },
                      MIGRATING: {
                        type: 'integer'
                      },
                      IN_PROCESS: {
                        type: 'integer'
                      },
                      SOME_STORAGE_MIGRATING: {
                        type: 'integer'
                      },
                      SOME_STORAGE_INITIALIZING: {
                        type: 'integer'
                      },
                      SOME_STORAGE_DECOMMISSIONING: {
                        type: 'integer'
                      },
                      DELETING: {
                        type: 'integer'
                      },
                      SOME_STORAGE_OFFLINE: {
                        type: 'integer'
                      },
                      SOME_STORAGE_NOT_EXIST: {
                        type: 'integer'
                      },
                      SOME_STORAGE_IO_ERRORS: {
                        type: 'integer'
                      },
                      NO_CAPACITY: {
                        type: 'integer'
                      },
                      LOW_CAPACITY: {
                        type: 'integer'
                      },
                      HAS_ERRORS: {
                        type: 'integer'
                      },
                      HAS_ISSUES: {
                        type: 'integer'
                      },
                      N2N_PORTS_BLOCKED: {
                        type: 'integer'
                      },
                      OPTIMAL: {
                        type: 'integer'
                      }
                    }
                  },
                  nonPaginated: {
                    type: 'integer'
                  }
                }
              },
              items: {
                type: 'array',
                items: {
                  type: 'string'
                }
              }
            }
          }
        }
      }
    },
    items: {
      type: 'object',
      additionalProperties: host
    }
  }
};
exports.default = _default;

},{}],995:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _coreUtils = require("utils/core-utils");

var _schemaUtils = require("utils/schema-utils");

var common = _interopRequireWildcard(require("./common"));

var _location = _interopRequireDefault(require("./location"));

var _session = _interopRequireDefault(require("./session"));

var _namespaceResources = _interopRequireDefault(require("./namespace-resources"));

var _buckets = _interopRequireDefault(require("./buckets"));

var _namespaceBuckets = _interopRequireDefault(require("./namespace-buckets"));

var _objectUploads = _interopRequireDefault(require("./object-uploads"));

var _cloudTargets = _interopRequireDefault(require("./cloud-targets"));

var _storageHistory = _interopRequireDefault(require("./storage-history"));

var _topology = _interopRequireDefault(require("./topology"));

var _system = _interopRequireDefault(require("./system"));

var _notifications = _interopRequireDefault(require("./notifications"));

var _alerts = _interopRequireDefault(require("./alerts"));

var _auditLog = _interopRequireDefault(require("./audit-log"));

var _drawer = _interopRequireDefault(require("./drawer"));

var _modals = _interopRequireDefault(require("./modals"));

var _hostParts = _interopRequireDefault(require("./host-parts"));

var _hostPools = _interopRequireDefault(require("./host-pools"));

var _objects = _interopRequireDefault(require("./objects"));

var _objectParts = _interopRequireDefault(require("./object-parts"));

var _accounts = _interopRequireDefault(require("./accounts"));

var _env = _interopRequireDefault(require("./env"));

var _forms = _interopRequireDefault(require("./forms"));

var _cloudResources = _interopRequireDefault(require("./cloud-resources"));

var _hosts = _interopRequireDefault(require("./hosts"));

var _functions = _interopRequireDefault(require("./functions"));

var _bucketUsageHistory = _interopRequireDefault(require("./bucket-usage-history"));

var _accountUsageHistory = _interopRequireDefault(require("./account-usage-history"));

var _lambdaUsageHistory = _interopRequireDefault(require("./lambda-usage-history"));

var _objectsDistribution = _interopRequireDefault(require("./objects-distribution"));

var _cloudUsageStats = _interopRequireDefault(require("./cloud-usage-stats"));

var _bucketTriggers = _interopRequireDefault(require("./bucket-triggers"));

var _endpointGroups = _interopRequireDefault(require("./endpoint-groups"));

var _endpointsHistory = _interopRequireDefault(require("./endpoints-history"));

/* Copyright (C) 2016 NooBaa */
const schemas = {
  location: _location.default,
  session: _session.default,
  namespaceResources: _namespaceResources.default,
  buckets: _buckets.default,
  objectUploads: _objectUploads.default,
  namespaceBuckets: _namespaceBuckets.default,
  cloudTargets: _cloudTargets.default,
  storageHistory: _storageHistory.default,
  topology: _topology.default,
  system: _system.default,
  notifications: _notifications.default,
  alerts: _alerts.default,
  auditLog: _auditLog.default,
  drawer: _drawer.default,
  modals: _modals.default,
  hostParts: _hostParts.default,
  hostPools: _hostPools.default,
  objects: _objects.default,
  objectParts: _objectParts.default,
  accounts: _accounts.default,
  env: _env.default,
  forms: _forms.default,
  cloudResources: _cloudResources.default,
  hosts: _hosts.default,
  functions: _functions.default,
  bucketUsageHistory: _bucketUsageHistory.default,
  accountUsageHistory: _accountUsageHistory.default,
  lambdaUsageHistory: _lambdaUsageHistory.default,
  objectsDistribution: _objectsDistribution.default,
  cloudUsageStats: _cloudUsageStats.default,
  bucketTriggers: _bucketTriggers.default,
  endpointGroups: _endpointGroups.default,
  endpointsHistory: _endpointsHistory.default
};

var _default = (0, _coreUtils.deepFreeze)((0, _schemaUtils.strictify)({
  def: {
    common,
    ...schemas
  },
  type: 'object',
  properties: (0, _coreUtils.mapValues)(schemas, (_, name) => ({
    $ref: `#/def/${name}`
  }))
}));

exports.default = _default;

},{"./account-usage-history":975,"./accounts":976,"./alerts":977,"./audit-log":978,"./bucket-triggers":979,"./bucket-usage-history":980,"./buckets":981,"./cloud-resources":982,"./cloud-targets":983,"./cloud-usage-stats":984,"./common":985,"./drawer":986,"./endpoint-groups":987,"./endpoints-history":988,"./env":989,"./forms":990,"./functions":991,"./host-parts":992,"./host-pools":993,"./hosts":994,"./lambda-usage-history":996,"./location":997,"./modals":998,"./namespace-buckets":999,"./namespace-resources":1000,"./notifications":1001,"./object-parts":1002,"./object-uploads":1003,"./objects":1005,"./objects-distribution":1004,"./session":1006,"./storage-history":1007,"./system":1008,"./topology":1009,"@babel/runtime/helpers/interopRequireDefault":1050,"@babel/runtime/helpers/interopRequireWildcard":1051,"utils/core-utils":1027,"utils/schema-utils":1042}],996:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/* Copyright (C) 2016 NooBaa */
var _default = {
  type: 'object',
  required: ['fetching', 'error'],
  properties: {
    fetching: {
      type: 'boolean'
    },
    error: {
      type: 'boolean'
    },
    query: {
      duration: {
        type: 'string',
        enum: ['DAY', 'WEEK', 'MONTH']
      },
      buckets: {
        type: 'array',
        items: {
          type: ' string'
        }
      }
    },
    data: {
      type: 'object',
      required: ['stats', 'slices'],
      properties: {
        stats: {
          $ref: '#/def/common/lambdaFuncStats'
        },
        slices: {
          type: 'array',
          items: {
            $ref: '#/def/common/lambdaFuncStats'
          }
        }
      }
    }
  }
};
exports.default = _default;

},{}],997:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/* Copyright (C) 2016 NooBaa */
var _default = {
  type: 'object',
  required: ['pathname', 'protocol', 'query', 'hostname', 'refreshCount'],
  properties: {
    pathname: {
      type: 'string'
    },
    protocol: {
      type: 'string'
    },
    hostname: {
      type: 'string'
    },
    route: {
      type: 'string'
    },
    params: {
      type: 'object',
      additionalProperties: {
        type: 'string'
      }
    },
    query: {
      type: 'object',
      additionalProperties: {
        oneOf: [{
          type: 'string'
        }, {
          type: 'boolean'
        }]
      }
    },
    refreshCount: {
      type: 'number'
    }
  }
};
exports.default = _default;

},{}],998:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/* Copyright (C) 2016 NooBaa */
var _default = {
  type: 'array',
  items: {
    type: 'object',
    required: ['backdropClose', 'closeButton', 'component', 'severity', 'size', 'title'],
    properties: {
      backdropClose: {
        type: 'boolean'
      },
      closeButton: {
        type: 'string',
        enum: ['hidden', 'visible', 'disabled']
      },
      component: {
        type: 'object',
        required: ['name', 'params'],
        properties: {
          name: {
            type: 'string'
          },
          params: {
            type: 'object',
            additionalProperties: true
          }
        }
      },
      severity: {
        type: 'string',
        enum: ['info', 'success', 'warning', 'error', '']
      },
      size: {
        type: 'string',
        enum: ['xsmall', 'small', 'medium', 'large', 'xlarge', 'auto-height']
      },
      title: {
        type: 'string'
      }
    }
  }
};
exports.default = _default;

},{}],999:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/* Copyright (C) 2016 NooBaa */
var _default = {
  type: 'object',
  additionalProperties: {
    type: 'object',
    required: ['name', 'mode', 'placement', 'io'],
    properties: {
      name: {
        type: 'string'
      },
      mode: {
        type: 'string',
        enum: ['OPTIMAL']
      },
      placement: {
        type: 'object',
        required: ['readFrom', 'writeTo'],
        properties: {
          readFrom: {
            type: 'array',
            items: {
              type: 'string'
            }
          },
          writeTo: {
            type: 'string'
          }
        }
      },
      io: {
        type: 'object',
        required: ['readCount', 'writeCount', 'lastRead', 'lastWrite'],
        properties: {
          readCount: {
            type: 'integer'
          },
          writeCount: {
            type: 'integer'
          },
          lastRead: {
            type: 'integer'
          },
          lastWrite: {
            type: 'integer'
          }
        }
      }
    }
  }
};
exports.default = _default;

},{}],1000:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/* Copyright (C) 2016 NooBaa */
var _default = {
  type: 'object',
  additionalProperties: {
    type: 'object',
    required: ['name', 'mode', 'service', 'target'],
    properties: {
      name: {
        type: 'string'
      },
      mode: {
        type: 'string',
        enum: ['OPTIMAL']
      },
      service: {
        type: 'string',
        enum: ['AWS', 'AZURE', 'S3_COMPATIBLE', 'NET_STORAGE', 'IBM_COS']
      },
      target: {
        type: 'string'
      },
      undeletable: {
        type: 'string',
        enum: ['IN_USE']
      }
    }
  }
};
exports.default = _default;

},{}],1001:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/* Copyright (C) 2016 NooBaa */
var _default = {
  type: 'object',
  required: ['nextId', 'list'],
  properties: {
    nextId: {
      type: 'number'
    },
    list: {
      type: 'array',
      items: {
        type: 'object',
        required: ['id', 'message', 'severity'],
        properties: {
          id: {
            type: 'number'
          },
          message: {
            type: 'string'
          },
          severity: {
            type: 'string',
            enum: ['info', 'success', 'warning', 'error']
          }
        }
      }
    }
  }
};
exports.default = _default;

},{}],1002:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/* Copyright (C) 2016 NooBaa */
var _default = {
  type: 'object',
  required: ['fetching', 'error'],
  properties: {
    fetching: {
      type: 'boolean'
    },
    error: {
      type: 'boolean'
    },
    query: {
      type: 'object',
      required: ['bucket', 'key', 'version', 'limit', 'skip'],
      properties: {
        bucket: {
          type: 'string'
        },
        key: {
          type: 'string'
        },
        version: {
          type: 'string'
        },
        limit: {
          type: 'integer'
        },
        skip: {
          type: 'integer'
        }
      }
    },
    items: {
      type: 'array',
      items: {
        type: 'object',
        required: ['seq', 'mode', 'size', 'blocks'],
        properties: {
          seq: {
            type: 'integer'
          },
          mode: {
            type: 'string',
            enum: ['AVAILABLE', 'BUILDING', 'UNAVAILABLE']
          },
          size: {
            $ref: '#/def/common/size'
          },
          blocks: {
            type: 'array',
            items: {
              type: 'object',
              required: ['kind', 'mode'],
              properties: {
                kind: {
                  type: 'string',
                  enum: ['REPLICA', 'DATA', 'PARITY']
                },
                seq: {
                  type: 'integer'
                },
                mode: {
                  type: 'string',
                  enum: ['NOT_ACCESSIBLE', 'CANNOT_BE_DELETED', 'WAITING_FOR_ALLOCATION', 'WAITING_FOR_DELETE', 'HEALTHY']
                },
                mirrorSet: {
                  type: 'string'
                },
                storage: {
                  oneOf: [{
                    type: 'object',
                    required: ['kind', 'pool', 'host'],
                    properties: {
                      kind: {
                        const: 'HOSTS'
                      },
                      pool: {
                        type: 'string'
                      },
                      host: {
                        type: 'string'
                      }
                    }
                  }, {
                    type: 'object',
                    required: ['kind', 'resource'],
                    properties: {
                      kind: {
                        const: 'CLOUD'
                      },
                      resource: {
                        type: 'string'
                      }
                    }
                  }, {
                    type: 'object',
                    required: ['kind'],
                    properties: {
                      kind: {
                        type: 'string',
                        enum: ['INTERNAL_STORAGE', 'NOT_ALLOCATED']
                      }
                    }
                  }]
                }
              }
            }
          }
        }
      }
    }
  }
};
exports.default = _default;

},{}],1003:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/* Copyright (C) 2016 NooBaa */
var _default = {
  type: 'object',
  properties: {
    objects: {
      type: 'array',
      items: {
        type: 'object',
        required: ['id', 'name', 'bucket', 'size', 'loaded', 'completed', 'archived'],
        properties: {
          id: {
            type: 'string'
          },
          name: {
            type: 'string'
          },
          bucket: {
            type: 'string'
          },
          versionId: {
            type: 'string'
          },
          size: {
            type: 'integer'
          },
          loaded: {
            type: 'integer'
          },
          completed: {
            type: 'boolean'
          },
          archived: {
            type: 'boolean'
          },
          error: {
            type: 'object',
            required: ['code', 'message'],
            properties: {
              code: {
                type: 'string'
              },
              message: {
                type: 'string'
              }
            }
          }
        }
      }
    },
    lastUpload: {
      type: 'object',
      required: ['time', 'objectCount'],
      properties: {
        time: {
          type: 'integer'
        },
        objectCount: {
          type: 'integer'
        }
      }
    },
    stats: {
      type: 'object',
      required: ['count', 'uploading', 'uploaded', 'failed', 'batchSize', 'batchLoaded'],
      properties: {
        count: {
          type: 'integer'
        },
        uploading: {
          type: 'integer'
        },
        uploaded: {
          type: 'integer'
        },
        failed: {
          type: 'integer'
        },
        batchSize: {
          type: 'integer'
        },
        batchLoaded: {
          type: 'integer'
        }
      }
    }
  }
};
exports.default = _default;

},{}],1004:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/* Copyright (C) 2016 NooBaa */
var _default = {
  type: 'object',
  required: ['fetching', 'error'],
  properties: {
    fetching: {
      type: 'boolean'
    },
    error: {
      type: 'boolean'
    },
    buckets: {
      type: 'object',
      additionalProperties: {
        type: 'array',
        items: {
          type: 'object',
          required: ['size', 'count'],
          properties: {
            size: {
              $ref: '#/def/common/size'
            },
            count: {
              type: 'integer'
            }
          }
        }
      }
    }
  }
};
exports.default = _default;

},{}],1005:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/* Copyright (C) 2016 NooBaa */
var _default = {
  type: 'object',
  required: ['views', 'queries', 'items'],
  properties: {
    views: {
      type: 'object',
      additionalProperties: {
        type: 'integer'
      }
    },
    queries: {
      type: 'object',
      additionalProperties: {
        type: 'object',
        required: ['timestamp', 'fetching', 'error'],
        properties: {
          timestamp: {
            type: 'integer'
          },
          fetching: {
            type: 'boolean'
          },
          error: {
            type: 'boolean'
          },
          result: {
            type: 'object',
            required: ['counters', 'items'],
            properties: {
              counters: {
                type: 'object',
                required: ['optimal', 'uploading'],
                properties: {
                  optimal: {
                    type: 'integer'
                  },
                  uploading: {
                    type: 'integer'
                  }
                }
              },
              items: {
                type: 'array',
                items: {
                  type: 'string'
                }
              },
              emptyReason: {
                type: 'string',
                enum: ['NO_MATCHING_KEYS', 'NO_RESULTS', 'NO_OBJECTS', 'NO_LATEST', 'NO_UPLOADS']
              }
            }
          }
        }
      }
    },
    items: {
      type: 'object',
      additionalProperties: {
        type: 'object',
        required: ['bucket', 'key', 'versionId', 'latestVersion', 'deleteMarker', 'mode', 'size', 'contentType', 'createTime', 'lastReadTime', 'readCount', 's3SignedUrl'],
        properties: {
          bucket: {
            type: 'string'
          },
          key: {
            type: 'string'
          },
          versionId: {
            type: 'string'
          },
          latestVersion: {
            type: 'boolean'
          },
          deleteMarker: {
            type: 'boolean'
          },
          mode: {
            type: 'string',
            enum: ['OPTIMAL', 'UPLOADING']
          },
          uploadId: {
            type: 'string'
          },
          size: {
            type: 'object',
            required: ['original'],
            properties: {
              original: {
                $ref: '#/def/common/size'
              },
              onDisk: {
                $ref: '#/def/common/size'
              }
            }
          },
          contentType: {
            type: 'string'
          },
          createTime: {
            type: 'integer'
          },
          lastReadTime: {
            type: 'integer'
          },
          readCount: {
            type: 'integer'
          },
          partCount: {
            type: 'integer'
          },
          s3SignedUrl: {
            type: 'string'
          }
        }
      }
    }
  }
};
exports.default = _default;

},{}],1006:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/* Copyright (C) 2016 NooBaa */
var _default = {
  oneOf: [{
    type: 'null'
  }, {
    type: 'object',
    required: ['token', 'user', 'system', 'persistent', 'passwordExpired', 'authorizedBy', 'uiTheme'],
    properties: {
      token: {
        type: 'string'
      },
      expired: {
        type: 'boolean'
      },
      user: {
        type: 'string'
      },
      system: {
        type: 'string'
      },
      persistent: {
        type: 'boolean'
      },
      passwordExpired: {
        type: 'boolean'
      },
      authorizedBy: {
        type: 'string',
        enum: ['noobaa', 'k8s']
      },
      uiTheme: {
        type: 'string',
        enum: ['dark', 'light']
      }
    }
  }]
};
exports.default = _default;

},{}],1007:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/* Copyright (C) 2016 NooBaa */
var _default = {
  type: 'array',
  items: {
    type: 'object',
    required: ['timestamp', 'hosts', 'cloud', 'internal'],
    properties: {
      timestamp: {
        type: 'integer'
      },
      hosts: {
        $ref: '#/def/common/storage'
      },
      cloud: {
        $ref: '#/def/common/storage'
      },
      internal: {
        $ref: '#/def/common/storage'
      }
    }
  }
};
exports.default = _default;

},{}],1008:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/* Copyright (C) 2016 NooBaa */
var _default = {
  type: 'object',
  required: ['name', 'version', 'nodeVersion', 'ipAddress', 'maintenanceMode', 'p2pSettings', 'phoneHome', 'debug', 'diagnostics', 'internalStorage', 's3Addresses'],
  properties: {
    name: {
      type: 'string'
    },
    version: {
      type: 'string'
    },
    nodeVersion: {
      type: 'string'
    },
    ipAddress: {
      type: 'string'
    },
    dnsName: {
      type: 'string'
    },
    sslPort: {
      type: 'integer'
    },
    sslCert: {
      type: 'object',
      required: ['installed'],
      properties: {
        installed: {
          type: 'boolean'
        },
        uploadProgress: {
          type: 'number'
        }
      }
    },
    upgrade: {
      type: 'object',
      properties: {
        lastUpgrade: {
          type: 'object',
          required: ['time', 'initiator'],
          properties: {
            time: {
              type: 'integer'
            },
            initiator: {
              type: 'string'
            }
          }
        }
      }
    },
    releaseNotes: {
      type: 'object',
      additionalProperties: {
        type: 'object',
        required: ['fetching'],
        properties: {
          fetching: {
            type: 'boolean'
          },
          error: {
            type: 'boolean'
          },
          text: {
            type: 'string'
          }
        }
      }
    },
    p2pSettings: {
      type: 'object',
      required: ['tcpPortRange'],
      properties: {
        tcpPortRange: {
          type: 'object',
          required: ['start', 'end'],
          properties: {
            start: {
              $ref: '#/def/common/port'
            },
            end: {
              $ref: '#/def/common/port'
            }
          }
        }
      }
    },
    phoneHome: {
      type: 'object',
      required: ['reachable'],
      properties: {
        reachable: {
          type: 'boolean'
        }
      }
    },
    debug: {
      type: 'object',
      required: ['level', 'till'],
      properties: {
        level: {
          type: 'integer',
          minimum: 0,
          maximum: 5
        },
        till: {
          type: 'integer'
        }
      }
    },
    maintenanceMode: {
      type: 'object',
      required: ['till'],
      properties: {
        till: {
          type: 'integer'
        }
      }
    },
    diagnostics: {
      $ref: '#/def/common/diagnostics'
    },
    internalStorage: {
      total: {
        $ref: '#/def/common/size'
      },
      size: {
        $ref: '#/def/common/size'
      }
    },
    s3Addresses: {
      type: 'array',
      items: {
        type: 'object',
        required: ['kind', 'address'],
        properties: {
          kind: {
            type: 'string',
            enum: ['EXTERNAL', 'INTERNAL', 'LOOPBACK']
          },
          address: {
            type: 'string'
          }
        }
      }
    }
  }
};
exports.default = _default;

},{}],1009:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/* Copyright (C) 2016 NooBaa */
const server = {
  type: 'object',
  required: ['hostname', 'secret', 'mode', 'version', 'addresses', 'timezone', 'locationTag', 'storage', 'memory', 'cpus', 'clockSkew', 'dns', 'phonehome', 'clusterConnectivity', 'debugMode', 'isMaster'],
  properties: {
    secret: {
      type: 'string'
    },
    hostname: {
      type: 'string'
    },
    mode: {
      type: 'string',
      enum: ['CONNECTED', 'DISCONNECTED', 'IN_PROGRESS']
    },
    version: {
      type: 'string'
    },
    addresses: {
      type: 'array',
      items: {
        type: 'object',
        required: ['ip'],
        properties: {
          ip: {
            type: 'string'
          }
        }
      }
    },
    timezone: {
      type: 'string'
    },
    locationTag: {
      type: 'string'
    },
    storage: {
      $ref: '#/def/common/storage'
    },
    memory: {
      type: 'object',
      required: ['total', 'used'],
      properties: {
        total: {
          type: 'number'
        },
        used: {
          type: 'number'
        }
      }
    },
    cpus: {
      type: 'object',
      required: ['count', 'usage'],
      properties: {
        count: {
          type: 'integer'
        },
        usage: {
          type: 'number'
        }
      }
    },
    clockSkew: {
      type: 'integer'
    },
    dns: {
      type: 'object',
      required: ['servers'],
      properties: {
        nameResolution: {
          type: 'object',
          required: ['status'],
          properties: {
            status: {
              $ref: '#/def/common/serviceCheckResult'
            }
          }
        },
        servers: {
          required: ['list'],
          list: {
            type: 'array',
            items: {
              type: 'string'
            }
          },
          status: {
            $ref: '#/def/common/serviceCheckResult'
          }
        }
      }
    },
    phonehome: {
      type: 'object',
      required: ['status', 'lastStatusCheck'],
      properties: {
        status: {
          $ref: '#/def/common/serviceCheckResult'
        },
        lastStatusCheck: {
          type: 'integer'
        }
      }
    },
    clusterConnectivity: {
      type: 'object',
      additionalProperties: {
        $ref: '#/def/common/serviceCheckResult'
      }
    },
    debugMode: {
      type: 'boolean'
    },
    isMaster: {
      type: 'boolean'
    }
  }
};
var _default = {
  type: 'object',
  required: ['servers', 'serverMinRequirements', 'supportHighAvailability', 'isHighlyAvailable', 'faultTolerance'],
  properties: {
    servers: {
      type: 'object',
      additionalProperties: server
    },
    serverMinRequirements: {
      type: 'object',
      properties: {
        storage: {
          type: 'integer'
        },
        memory: {
          type: 'integer'
        },
        cpus: {
          type: 'integer'
        }
      }
    },
    supportHighAvailability: {
      type: 'boolean'
    },
    isHighlyAvailable: {
      type: 'boolean'
    },
    faultTolerance: {
      type: 'integer',
      minimum: 0
    }
  }
};
exports.default = _default;

},{}],1010:[function(require,module,exports){
(function (global){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _notifications = _interopRequireDefault(require("./notifications"));

var _nbApi = require("nb-api");

var _state = require("state");

var _actionCreators = require("action-creators");

/* Copyright (C) 2016 NooBaa */
const rpc_proto = global.WebSocket ? location.protocol === 'https:' ? 'wss:' : 'ws:' : location.protocol;
const base_address = `${rpc_proto}//${global.location.host}`;
const rpc = (0, _nbApi.new_rpc_default_only)(base_address);
rpc.register_service(rpc.schema.frontend_notifications_api, new _notifications.default(_state.action$), {});
rpc.set_error_handler(err => {
  if (err.rpc_code === 'UNAUTHORIZED') {
    _state.action$.next((0, _actionCreators.expireSession)());
  }
});
const api = rpc.new_client();
rpc.on('reconnect', () => api.redirector.register_for_alerts());
var _default = api;
exports.default = _default;

}).call(this,typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})

},{"./notifications":1014,"@babel/runtime/helpers/interopRequireDefault":1050,"action-creators":306,"nb-api":"nb-api","state":1016}],1011:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("aws-sdk");

/* Copyright (C) 2016 NooBaa */
// TODO: resolve browserify issue with export of the aws-sdk module.
// The current workaround use the AWS that is set on the global window object.
var _default = window.AWS;
exports.default = _default;

},{"aws-sdk":"aws-sdk"}],1012:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _stringUtils = require("utils/string-utils");

class TypedStore {
  constructor(type) {
    this._type = type;
    this._storage = new WeakMap();
    Object.freeze(this);
  }

  get(key) {
    return this._storage.get(key);
  }

  store(value) {
    const {
      _type,
      _storage
    } = this;

    if (!(value instanceof _type)) {
      throw new Error('Invalid argument buffer');
    }

    const key = Object.freeze({
      key: (0, _stringUtils.randomString)()
    });

    _storage.set(key, value);

    return key;
  }

  remove(key) {
    this._storage.delete(key);
  }

}

var _default = new TypedStore(ArrayBuffer);

exports.default = _default;

},{"utils/string-utils":1046}],1013:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "api", {
  enumerable: true,
  get: function () {
    return _api.default;
  }
});
Object.defineProperty(exports, "AWS", {
  enumerable: true,
  get: function () {
    return _aws.default;
  }
});
Object.defineProperty(exports, "bufferStore", {
  enumerable: true,
  get: function () {
    return _bufferStore.default;
  }
});

var _api = _interopRequireDefault(require("./api"));

var _aws = _interopRequireDefault(require("./aws"));

var _bufferStore = _interopRequireDefault(require("./buffer-store"));

},{"./api":1010,"./aws":1011,"./buffer-store":1012,"@babel/runtime/helpers/interopRequireDefault":1050}],1014:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _actionCreators = require("action-creators");

class NotificationApiImpl {
  constructor(action$) {
    this.dispatch = action => action$.next(action);
  }

  alert() {
    this.dispatch((0, _actionCreators.fetchUnreadAlertsCount)());
  }

  add_memeber_to_cluster(req) {
    const {
      result
    } = req.rpc_params; //TODO: This is a W/A until we move attach server to the new arch

    const action = result ? (0, _actionCreators.showNotification)('Server was successfully added to the cluster', 'success') : (0, _actionCreators.showNotification)('Adding server to the cluster failed', 'error');
    this.dispatch(action);
  }

  remove_host(req) {
    const {
      name: host
    } = req.rpc_params;
    this.dispatch((0, _actionCreators.removeHost)(host));
  }

  change_upgrade_status() {
    this.dispatch((0, _actionCreators.fetchSystemInfo)());
  }

}

exports.default = NotificationApiImpl;

},{"action-creators":306}],1015:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _rxExtensions = require("rx-extensions");

var _config = require("config");

/* Copyright (C) 2016 NooBaa */
function _default(state$, {
  localStorage,
  sessionStorage
}) {
  // Presist session token.
  state$.pipe((0, _rxExtensions.get)('session')).subscribe(session => {
    if (session === null) {
      localStorage.removeItem(_config.sessionTokenKey);
      sessionStorage.removeItem(_config.sessionTokenKey);
    }

    if (session) {
      const storage = session.persistent ? localStorage : sessionStorage;
      storage.setItem(_config.sessionTokenKey, session.token);
    }
  }); // Presist preview content flag.

  state$.pipe((0, _rxExtensions.get)('env', 'previewContent')).subscribe(previewContent => {
    previewContent ? localStorage.setItem(_config.previewContentKey, true) : localStorage.removeItem(_config.previewContentKey);
  });
}

},{"config":831,"rx-extensions":974}],1016:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.state$ = exports.record$ = exports.action$ = void 0;

var _reducers = _interopRequireDefault(require("reducers"));

var _schema = _interopRequireDefault(require("./schema"));

var _coreUtils = require("utils/core-utils");

var _schemaUtils = require("utils/schema-utils");

var _stateUtils = require("utils/state-utils");

var _rxjs = require("rxjs");

var _operators = require("rxjs/operators");

/* Copyright (C) 2016 NooBaa */
const schemaValidator = (0, _schemaUtils.createSchemaValidator)(_schema.default);

function _filterMishapedActions(action) {
  if (!(0, _coreUtils.isObject)(action)) {
    console.warn('Invalid action:', action, 'is not an object');
    return false;
  }

  if (!action.type) {
    console.warn('Invalid action:', action, 'is missing a type property');
    return false;
  }

  return true;
}

function _reduceState(prevState, action) {
  try {
    const state = (0, _reducers.default)(prevState, action);
    const violations = schemaValidator(state);

    if (violations) {
      const error = {
        type: 'STATE_SCHEMA_VAIOLATIONS',
        violations
      };
      console.error('Invalid state', error);
      return (0, _coreUtils.deepFreeze)({ ...prevState,
        lastError: error
      });
    } else {
      return (0, _coreUtils.deepFreeze)({ ...state,
        lastError: prevState.lastError
      });
    }
  } catch (exp) {
    console.error(exp);
    const error = {
      type: 'STATE_REDUCER_ERROR',
      ...(0, _stateUtils.mapErrorObject)(exp)
    };
    return (0, _coreUtils.deepFreeze)({ ...prevState,
      lastError: error
    });
  }
}

function _reduceRecords(prev, action) {
  action = Object.freeze({ ...action,
    timestamp: Date.now()
  });

  const state = _reduceState(prev.state || {}, action);

  return {
    action,
    state
  };
} // Actions stream.


const action$ = new _rxjs.Subject();
exports.action$ = action$;
const record$ = action$.pipe((0, _operators.filter)(_filterMishapedActions), (0, _operators.scan)(_reduceRecords, {}), (0, _operators.share)());
exports.record$ = record$;
const state$ = record$.pipe((0, _operators.pluck)('state'), (0, _operators.distinctUntilChanged)(Object.is), (0, _operators.switchMap)(value => Promise.resolve(value)), (0, _operators.shareReplay)(1)); // Subcribe so we will not loose action that are dispatched
// before any other subscription.

exports.state$ = state$;
state$.subscribe(_coreUtils.noop);

},{"./schema":995,"@babel/runtime/helpers/interopRequireDefault":1050,"reducers":957,"rxjs":89,"rxjs/operators":287,"utils/core-utils":1027,"utils/schema-utils":1042,"utils/state-utils":1044}],1017:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _zlib = _interopRequireDefault(require("zlib"));

var _promiseUtils = require("utils/promise-utils");

var _moment = _interopRequireDefault(require("moment"));

var _actionTypes = require("action-types");

var _buffer = require("buffer");

var _operators = require("rxjs/operators");

/* Copyright (C) 2016 NooBaa */
const maxLogSize = 450;

const _compress = (0, _promiseUtils.promisify)(_zlib.default.gzip);

const _decompress = (0, _promiseUtils.promisify)(_zlib.default.gunzip);

async function _writeDumpLog(gzip, log, nbVersion) {
  gzip.write(`{"buildNubmer":"${nbVersion}","log":[`);

  for (let i = 0; i < log.length; ++i) {
    if (i > 0) gzip.write(',');
    gzip.write((await _decompress(log[i])));
  }

  gzip.end(']}');
}

function _createDumpPkg(nbVersion, time, log) {
  return new Promise(resolve => {
    const buffers = [];

    const gzip = _zlib.default.createGzip();

    gzip.on('data', data => buffers.push(data));
    gzip.on('end', () => {
      const timestamp = (0, _moment.default)(time).format('YYYY_MM_DD-HH_mm_ss');
      const name = `nbfedump.${timestamp}.json.gz`;

      const dump = _buffer.Buffer.concat(buffers).toString('base64');

      resolve({
        name,
        dump
      });
    }); // We should not wait for the write to complete before finishing the promise creartion.
    // the end of the write will be notified using the resolve func call on end event

    _writeDumpLog(gzip, log, nbVersion);
  });
}

async function _default(record$, {
  api,
  browser,
  getTime
}) {
  const nbVersion = browser.getDocumentMetaTag('nbversion');
  const [, windowId] = browser.getWindowName().split(':'); // Post each record to the debugChannel to be intercepted by the
  // debug console.

  const debugChannel = browser.createBroadcastChannel(`debugChannel:${windowId}`);
  const scanBase = {
    log: [],
    dumpToFile: false,
    sendToServer: false
  };
  record$.pipe((0, _operators.tap)(record => debugChannel.postMessage({
    type: 'RECORD',
    origin: 'FE',
    payload: record
  })), (0, _operators.mergeMap)(async record => ({
    compressed: await _compress(JSON.stringify(record)),
    dumpToFile: record.action.type === _actionTypes.DUMP_APP_LOG,
    sendToServer: Boolean(record.state.lastError)
  })), (0, _operators.scan)(({
    log
  }, {
    compressed,
    dumpToFile,
    sendToServer
  }) => {
    // Add a compressed version of the record to the log.
    return {
      log: log.concat(compressed).slice(-maxLogSize),
      dumpToFile,
      sendToServer
    };
  }, scanBase), (0, _operators.filter)(({
    sendToServer,
    dumpToFile
  }) => dumpToFile || sendToServer), (0, _operators.mergeMap)(async ({
    log,
    dumpToFile,
    sendToServer
  }) => ({
    pkg: await _createDumpPkg(nbVersion, getTime(), log),
    dumpToFile,
    sendToServer
  }))).subscribe(({
    pkg,
    dumpToFile,
    sendToServer
  }) => {
    // Download the log on demand.
    if (dumpToFile) {
      browser.downloadFile(`data:application/zip;base64,${pkg.dump}`, pkg.name);
    } // Every time we get to an error state we gzip the last maxLogSize
    // records and send the gzip to the server to be archived and attached
    // to the next diagnostic pack download.


    if (sendToServer) {
      api.debug.upload_fe_dump(pkg);
    }
  });
}

},{"@babel/runtime/helpers/interopRequireDefault":1050,"action-types":318,"buffer":53,"moment":"moment","rxjs/operators":287,"utils/promise-utils":1039,"zlib":52}],1018:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _coreUtils = require("utils/core-utils");

var _config = require("config");

function _readThemeFromStyleSheet(className) {
  const {
    style
  } = Array.from(document.styleSheets[0].cssRules).find(rule => rule.selectorText === `.${className}`);
  const propNames = Array.from(style).filter(name => name.startsWith('--'));
  return (0, _coreUtils.deepFreeze)((0, _coreUtils.keyBy)(propNames, name => name.substr(2), name => {
    const val = style.getPropertyValue(name).split(',').map(c => c.trim());
    return val.length === 3 && `rgb(${val.join()})` || val.length === 4 && `rgba(${val.join()})` || 'rgba(0,0,0,0)';
  }));
}

function getThemes(themes) {
  // Creating an object with getters in order to delay the resolution of
  // the theme class. This is needed becasue the config file (which define the mapping
  // between a theme name and the underlaying theme class) may cahnge during the
  // loading pashe of the application via the conifg patch mechanism.
  // In order to mitigate the cost of the style access process we save a cashe
  // keyd by the actual class name and not the theme name.
  const casheByClassName = new Map();
  return Object.defineProperties({}, (0, _coreUtils.mapValues)(themes, (_, themeName) => ({
    enumerable: true,
    get: () => {
      const className = themes[themeName];
      let theme = casheByClassName.get(className);

      if (!theme) {
        casheByClassName.set(className, theme = _readThemeFromStyleSheet(className));
      }

      return theme;
    }
  })));
}

var _default = getThemes(_config.themes);

exports.default = _default;

},{"config":831,"utils/core-utils":1027}],1019:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.canEditAccount = canEditAccount;
exports.canDeleteAccount = canDeleteAccount;

/* Copyright (C) 2016 NooBaa */
function canEditAccount(user, account) {
  return !user.isExternal || user == account;
}

function canDeleteAccount(user, account) {
  return !account.undeletable && canEditAccount(user, account);
}

},{}],1020:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createS3Client = createS3Client;

/* Copyright (C) 2016 NooBaa */
function createS3Client(AWS, connection) {
  const {
    endpoint,
    accessKey,
    secretKey
  } = connection;
  return new AWS.S3({
    endpoint: endpoint,
    credentials: {
      accessKeyId: accessKey,
      secretAccessKey: secretKey
    },
    s3ForcePathStyle: true,
    sslEnabled: false
  });
}

},{}],1021:[function(require,module,exports){
(function (global){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.parseQueryString = parseQueryString;
exports.stringifyQueryString = stringifyQueryString;
exports.realizeUri = realizeUri;
exports.copyTextToClipboard = copyTextToClipboard;
exports.downloadFile = downloadFile;
exports.domFromHtml = domFromHtml;
exports.encodeBase64 = encodeBase64;
exports.recognizeBrowser = recognizeBrowser;
exports.toFormData = toFormData;
exports.httpRequest = httpRequest;
exports.httpWaitForResponse = httpWaitForResponse;
exports.formatEmailUri = formatEmailUri;
exports.isUri = isUri;
exports.reloadBrowser = reloadBrowser;
exports.toObjectUrl = toObjectUrl;
exports.openInNewTab = openInNewTab;
exports.createBroadcastChannel = createBroadcastChannel;
exports.getDocumentMetaTag = getDocumentMetaTag;
exports.getWindowName = getWindowName;
exports.readFileAsText = readFileAsText;
exports.readFileAsArrayBuffer = readFileAsArrayBuffer;
exports.hasSameOrigin = hasSameOrigin;
exports.navigateTo = navigateTo;
exports.XMLHttpRequest = void 0;

var _coreUtils = require("./core-utils");

var _stringUtils = require("./string-utils");

var _promiseUtils = require("./promise-utils");

var _routes = require("routes");

/* Copyright (C) 2016 NooBaa */
const XMLHttpRequest = global.XMLHttpRequest;
exports.XMLHttpRequest = XMLHttpRequest;

function parseQueryString(str) {
  return str.replace(/(^\?)/, '').split('&').filter(Boolean).reduce((result, part) => {
    const [name, value] = part.split('=').map(decodeURIComponent);
    result[(0, _stringUtils.toCammelCase)(name)] = value || true;
    return result;
  }, {});
}

function stringifyQueryString(query) {
  return Object.keys(query).reduce((list, key) => {
    if (!(0, _coreUtils.isUndefined)(query[key])) {
      const encodedName = encodeURIComponent((0, _stringUtils.toDashedCase)(key));
      const value = query[key] === true ? encodedName : `${encodedName}=${encodeURIComponent(query[key])}`;
      list.push(value);
    }

    return list;
  }, []).join('&');
}

function realizeUri(template, params = {}, query = {}, partial = false) {
  const search = stringifyQueryString(query);
  const base = template.split('/').map(part => {
    const isParam = part.startsWith(':');
    const isOptional = part.endsWith('?');

    if (isParam) {
      const name = part.slice(1, isOptional ? -1 : undefined);
      const value = params[name];

      if (value) {
        return encodeURIComponent(encodeURIComponent(value));
      } else if (partial) {
        return part;
      } else if (isOptional) {
        return null;
      } else {
        throw new Error(`Cannot satisfy mandatory parameter: ${name}`);
      }
    } else {
      return part;
    }
  }).filter(part => part !== null).join('/');
  return search ? `${base}?${search}` : base;
}

function copyTextToClipboard(text) {
  // Prevent XSS attacks.
  let doc = new DOMParser().parseFromString(text, 'text/html');
  text = doc.body.textContent;
  let input = document.createElement('textarea');
  document.body.appendChild(input);
  input.value = text;
  input.focus();
  input.select();
  document.execCommand('Copy');
  input.remove();
}

function downloadFile(url, name = '', useDownloadHelper = false) {
  if (useDownloadHelper) {
    const u = new URL(window.location.origin);
    u.pathname = `${_routes.root}/download.html`;
    u.searchParams.set('uri', url);
    u.searchParams.set('name', name);
    return window.open(u.toString(), '_blank');
  } else {
    const body = window.document.body;
    const link = window.document.createElement('a');
    link.download = name;
    link.href = url;
    body.appendChild(link);
    link.click();
    (0, _coreUtils.runAsync)(() => body.removeChild(link));
  }
}

function domFromHtml(html) {
  // Switched to template element because DOMParser did not parsed
  // <tr>, <td>, <option> and <li> elements as root elements.
  let template = document.createElement('template');
  template.innerHTML = html;
  return template.content.childNodes;
}

function encodeBase64(obj) {
  return btoa(JSON.stringify(obj));
}

function recognizeBrowser() {
  const userAgentTokens = ['chrome', 'chromium', 'firefox', 'edge', 'msie', 'safari', 'opr'];
  let userAgent = navigator.userAgent.toLowerCase();
  return userAgentTokens.find(token => userAgent.includes(token));
}

function toFormData(payload) {
  return Object.entries(payload).reduce((formData, [key, value]) => {
    if (value.constructor === Blob) {
      formData.append(key, value, key);
    } else {
      formData.append(key, value);
    }

    return formData;
  }, new FormData());
}

function httpRequest(url, options = {}) {
  const {
    verb = 'GET',
    payload,
    xhr = new XMLHttpRequest()
  } = options;
  return new Promise((resolve, reject) => {
    xhr.open(verb, url, true);
    xhr.onerror = reject;
    xhr.onabort = resolve;
    xhr.onload = resolve;

    if (payload) {
      xhr.send(payload);
    } else {
      xhr.send();
    }
  });
}

function httpWaitForResponse(url, status, retryDelay = 3000) {
  return function tryGet() {
    // Try GET on url, if failed wait for retryDelay seconds and then try again.
    return httpRequest(url).then(evt => {
      if (!status || evt.target.status === status) {
        return evt;
      } else {
        throw evt;
      }
    }).catch(() => (0, _promiseUtils.sleep)(retryDelay).then(tryGet));
  }();
}

function formatEmailUri(uri, subject) {
  const query = stringifyQueryString({
    subject
  });
  return `mailto:${uri}${query ? `?${query}` : ''}`;
}

function isUri(str, inforceHttp = true) {
  const hasProtocol = str.startsWith('http://') || str.startsWith('https://');
  const value = `${!inforceHttp && !hasProtocol ? 'http://' : ''}${//Strip whitespace
  str.replace(/^\s+|\s+$/, '')}`; //Regex by Diego Perini from: http://mathiasbynens.be/demo/url-regex
  //Modified regex - removed the restrictions for private ip ranges

  const regExp = new RegExp('^' + // protocol identifier
  '(?:(?:https?|ftp)://)' + // user:pass authentication
  '(?:\\S+(?::\\S*)?@)?' + '(?:' + // IP address dotted notation octets
  // excludes loopback network 0.0.0.0
  // excludes reserved space >= 224.0.0.0
  // excludes network & broacast addresses
  // (first & last IP address of each class)
  '(?:[1-9]\\d?|1\\d\\d|2[01]\\d|22[0-3])' + '(?:\\.(?:1?\\d{1,2}|2[0-4]\\d|25[0-5])){2}' + '(?:\\.(?:[1-9]\\d?|1\\d\\d|2[0-4]\\d|25[0-4]))' + '|' + // host name
  '(?:(?:[a-z\\u00a1-\\uffff0-9]-*)*[a-z\\u00a1-\\uffff0-9]+)' + // domain name
  '(?:\\.(?:[a-z\\u00a1-\\uffff0-9]-*)*[a-z\\u00a1-\\uffff0-9]+)*' + // TLD identifier
  '(?:\\.(?:[a-z\\u00a1-\\uffff]{2,}))' + // TLD may end with dot
  '\\.?' + ')' + // port number
  '(?::\\d{2,5})?' + // resource path
  '(?:[/?#]\\S*)?' + '$', 'i');
  return regExp.test(value);
}

function reloadBrowser(url) {
  if (url) {
    global.location.href = url;
  } else {
    global.location.reload();
  }
}

function toObjectUrl(data, type = 'text/json') {
  let content = null;

  switch (type) {
    case 'text/json':
      {
        content = JSON.stringify(data, undefined, 2);
        break;
      }

    case 'text/yaml':
      {
        content = String(data);
        break;
      }

    default:
      {
        throw new Error(`Unsupported type, got ${type}`);
      }
  }

  const blob = new Blob([content], {
    type
  });
  return global.URL.createObjectURL(blob);
}

function openInNewTab(url, name) {
  if (name) {
    global.open(url, name);
  } else {
    global.open(url);
  }
}

function createBroadcastChannel(name) {
  return new BroadcastChannel(name);
}

function getDocumentMetaTag(name) {
  const metaElm = document.querySelector(`meta[name=${name}]`);
  return metaElm && metaElm.content;
}

function getWindowName() {
  return global.name || (global.name = `NooBaa:${(0, _stringUtils.randomString)()}`);
}

function readFileAsText(file) {
  const reader = new FileReader();
  return new Promise((resolve, reject) => {
    reader.onload = evt => resolve(evt.target.result);

    reader.onerror = err => reject(err);

    reader.readAsText(file);
  });
}

function readFileAsArrayBuffer(file) {
  const reader = new FileReader();
  return new Promise((resolve, reject) => {
    reader.onload = evt => resolve(evt.target.result);

    reader.onerror = err => reject(err);

    reader.readAsArrayBuffer(file);
  });
}

function hasSameOrigin(url) {
  return new URL(url).origin === window.location.origin;
}

function navigateTo(url) {
  return window.location = url;
}

}).call(this,typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})

},{"./core-utils":1027,"./promise-utils":1039,"./string-utils":1046,"routes":972}],1022:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getBucketStateIcon = getBucketStateIcon;
exports.getPlacementTypeDisplayName = getPlacementTypeDisplayName;
exports.getPlacementStateIcon = getPlacementStateIcon;
exports.getNamespaceBucketStateIcon = getNamespaceBucketStateIcon;
exports.getQuotaStateIcon = getQuotaStateIcon;
exports.getDataBreakdown = getDataBreakdown;
exports.getQuotaValue = getQuotaValue;
exports.isBucketWritable = isBucketWritable;
exports.countStorageNodesByMirrorSet = countStorageNodesByMirrorSet;
exports.summrizeResiliency = summrizeResiliency;
exports.getResiliencyStateIcon = getResiliencyStateIcon;
exports.getResiliencyTypeDisplay = getResiliencyTypeDisplay;
exports.getResiliencyRequirementsWarning = getResiliencyRequirementsWarning;
exports.getVersioningStateText = getVersioningStateText;
exports.flatPlacementPolicy = flatPlacementPolicy;
exports.validatePlacementPolicy = validatePlacementPolicy;
exports.warnPlacementPolicy = warnPlacementPolicy;
exports.bucketEvents = void 0;

var _coreUtils = require("./core-utils");

var _sizeUtils = require("utils/size-utils");

var _stringUtils = require("utils/string-utils");

var _iconUtils = require("utils/icon-utils");

/* Copyright (C) 2016 NooBaa */
const bucketStateToIcon = (0, _coreUtils.deepFreeze)({
  NO_RESOURCES: (_, align) => (0, _iconUtils.errorIcon)({
    text: 'No storage resources',
    align
  }),
  NOT_ENOUGH_RESOURCES: (_, align) => (0, _iconUtils.errorIcon)({
    text: 'Not enough drives to meet resiliency policy',
    align
  }),
  NOT_ENOUGH_HEALTHY_RESOURCES: (_, align) => (0, _iconUtils.errorIcon)({
    text: 'Not enough healthy storage resources',
    align
  }),
  NO_CAPACITY: (_, align) => (0, _iconUtils.errorIcon)({
    text: 'No potential available storage',
    align
  }),
  ALL_TIERS_HAVE_ISSUES: (_, align) => (0, _iconUtils.errorIcon)({
    text: 'All tiers have mixed issues',
    align
  }),
  EXCEEDING_QUOTA: (_, align) => (0, _iconUtils.errorIcon)({
    text: 'Exceeded configured quota',
    align
  }),
  TIER_NO_RESOURCES: (bucket, align) => {
    const i = _tierIndexForMode(bucket, 'NO_RESOURCES');

    return (0, _iconUtils.warningIcon)({
      text: `Tier ${i + 1} has no storage resources`,
      align
    });
  },
  TIER_NOT_ENOUGH_RESOURCES: (bucket, align) => {
    const i = _tierIndexForMode(bucket, 'NOT_ENOUGH_RESOURCES');

    return (0, _iconUtils.warningIcon)({
      text: `Not enough drives to meet resiliency policy in tier ${i + 1}`,
      align
    });
  },
  TIER_NOT_ENOUGH_HEALTHY_RESOURCES: (bucket, align) => {
    const i = _tierIndexForMode(bucket, 'NOT_ENOUGH_HEALTHY_RESOURCES');

    return (0, _iconUtils.warningIcon)({
      text: `Not enough healthy storage resources in tier ${i + 1}`,
      align
    });
  },
  TIER_NO_CAPACITY: (bucket, align) => {
    const i = _tierIndexForMode(bucket, 'NO_CAPACITY');

    return (0, _iconUtils.warningIcon)({
      text: `No potential available storage in tier ${i + 1}`,
      align
    });
  },
  LOW_CAPACITY: (_, align) => (0, _iconUtils.warningIcon)({
    text: 'Storage is low',
    align
  }),
  TIER_LOW_CAPACITY: (bucket, align) => {
    const i = _tierIndexForMode(bucket, 'LOW_CAPACITY');

    return (0, _iconUtils.warningIcon)({
      text: `Storage is low in tier ${i + 1}`,
      align
    });
  },
  NO_RESOURCES_INTERNAL: (_, align) => (0, _iconUtils.warningIcon)({
    text: 'No Storage Resources - Using Internal Storage',
    align
  }),
  RISKY_TOLERANCE: (_, align) => (0, _iconUtils.warningIcon)({
    text: 'Risky failure tolerance',
    align
  }),
  APPROUCHING_QUOTA: (_, align) => (0, _iconUtils.warningIcon)({
    text: 'Approaching configured quota',
    align
  }),
  DATA_ACTIVITY: (_, align) => (0, _iconUtils.processIcon)({
    text: 'In Process',
    align
  }),
  OPTIMAL: (_, align) => (0, _iconUtils.healthyIcon)({
    text: 'Healthy',
    align
  })
});
const placementModeToIcon = (0, _coreUtils.deepFreeze)({
  NO_RESOURCES: () => (0, _iconUtils.errorIcon)({
    text: 'No storage resources',
    align: 'start'
  }),
  NOT_ENOUGH_RESOURCES: () => (0, _iconUtils.errorIcon)({
    text: 'Not enough drives to meet resiliency policy',
    align: 'start'
  }),
  NOT_ENOUGH_HEALTHY_RESOURCES: () => (0, _iconUtils.errorIcon)({
    text: 'Not enough healthy storage resources',
    align: 'start'
  }),
  INTERNAL_STORAGE_ISSUES: () => (0, _iconUtils.errorIcon)({
    text: 'Tier has no resources and the internal storage is unavailable',
    align: 'start'
  }),
  NO_CAPACITY: () => (0, _iconUtils.errorIcon)({
    text: 'No potential available storage',
    align: 'start'
  }),
  LOW_CAPACITY: () => (0, _iconUtils.warningIcon)({
    text: 'Storage is low',
    align: 'start'
  }),
  OPTIMAL: () => (0, _iconUtils.healthyIcon)({
    text: 'Healthy',
    align: 'start'
  })
});
const placementTypeToDisplayName = (0, _coreUtils.deepFreeze)({
  SPREAD: 'Spread',
  MIRROR: 'Mirror'
});
const namespaceBucketToStateIcon = (0, _coreUtils.deepFreeze)({
  OPTIMAL: {
    name: 'healthy',
    css: 'success',
    tooltip: 'Healthy'
  }
});
const resiliencyModeToIcon = (0, _coreUtils.deepFreeze)({
  NOT_ENOUGH_RESOURCES: () => (0, _iconUtils.errorIcon)({
    text: 'Not enough drives to meet resiliency policy',
    align: 'start'
  }),
  POLICY_PARTIALLY_APPLIED: resiliency => {
    const resiliencyEntity = resiliency.kind === 'REPLICATION' ? 'replicas' : 'parity fragments';
    return (0, _iconUtils.warningIcon)({
      text: `Bucket has no resources - no ${resiliencyEntity} will be kept while using internal storage`,
      align: 'start'
    });
  },
  RISKY_TOLERANCE: () => (0, _iconUtils.warningIcon)({
    text: 'Risky failure tolerance',
    align: 'start'
  }),
  LOW_CAPACITY: () => (0, _iconUtils.warningIcon)({
    text: 'Storage is low',
    align: 'start'
  }),
  OPTIMAL: () => (0, _iconUtils.healthyIcon)({
    text: 'Healthy',
    align: 'start'
  })
});
const resiliencyTypeToDisplay = (0, _coreUtils.deepFreeze)({
  REPLICATION: 'Replication',
  ERASURE_CODING: 'Erasure Coding'
});
const writableStates = (0, _coreUtils.deepFreeze)(['OPTIMAL', 'DATA_ACTIVITY', 'APPROUCHING_QUOTA', 'RISKY_TOLERANCE', 'NO_RESOURCES_INTERNAL', 'TIER_LOW_CAPACITY', 'LOW_CAPACITY', 'TIER_NO_CAPACITY', 'TIER_NOT_ENOUGH_HEALTHY_RESOURCES', 'TIER_NOT_ENOUGH_RESOURCES', 'TIER_NO_RESOURCES']);
const resiliencyTypeToBlockType = (0, _coreUtils.deepFreeze)({
  REPLICATION: 'replica',
  ERASURE_CODING: 'fragment'
});
const quotaModeToIcon = (0, _coreUtils.deepFreeze)({
  EXCEEDING_QUOTA: () => (0, _iconUtils.errorIcon)({
    text: 'Exceeded configured quota',
    align: 'start'
  }),
  APPROUCHING_QUOTA: () => (0, _iconUtils.warningIcon)({
    text: 'Approaching configured quota',
    align: 'start'
  }),
  OPTIMAL: () => (0, _iconUtils.healthyIcon)({
    text: 'Enabled',
    align: 'start'
  })
});
const versioningModeToText = (0, _coreUtils.deepFreeze)({
  ENABLED: 'Enabled',
  SUSPENDED: 'Suspended',
  DISABLED: 'Disabled'
});
const bucketEvents = (0, _coreUtils.deepFreeze)([{
  value: 'ObjectCreated',
  label: 'Object Created'
}, {
  value: 'ObjectRemoved',
  label: 'Object Removed'
}, {
  value: 'ObjectRead',
  label: 'Object Read'
}]);
exports.bucketEvents = bucketEvents;

function _tierIndexForMode(bucket, mode) {
  return bucket.placement.tiers.findIndex(tier => tier.mode === mode);
}

function getBucketStateIcon(bucket, align = 'center') {
  return bucketStateToIcon[bucket.mode](bucket, align);
}

function getPlacementTypeDisplayName(type) {
  return placementTypeToDisplayName[type];
}

function getPlacementStateIcon(tier) {
  return placementModeToIcon[tier.mode](tier);
}

function getNamespaceBucketStateIcon(bucket) {
  const {
    mode
  } = bucket;
  return namespaceBucketToStateIcon[mode];
}

function getQuotaStateIcon(quota) {
  return quotaModeToIcon[quota.mode](quota);
}

function getDataBreakdown(data, quota) {
  if (!quota) {
    return {
      used: data.size,
      overused: 0,
      availableForUpload: data.availableForUpload,
      potentialForUpload: 0,
      overallocated: 0
    };
  }

  const {
    zero,
    max,
    min
  } = _sizeUtils.bigInteger;
  const sizeBigInt = (0, _sizeUtils.toBigInteger)(data.size);
  const uploadBigInt = (0, _sizeUtils.toBigInteger)(data.availableForUpload);
  let q = (0, _sizeUtils.toBigInteger)(quota.size).multiply(_sizeUtils.unitsInBytes[quota.unit]);
  const used = min(sizeBigInt, q);
  const overused = sizeBigInt.subtract(used);
  q = max(q.subtract(sizeBigInt), zero);
  const availableForUpload = min(uploadBigInt, q);
  const potentialForUpload = uploadBigInt.subtract(availableForUpload);
  const overallocated = max(q.subtract(uploadBigInt), zero);
  return {
    used: (0, _sizeUtils.fromBigInteger)(used),
    overused: (0, _sizeUtils.fromBigInteger)(overused),
    availableForUpload: (0, _sizeUtils.fromBigInteger)(availableForUpload),
    potentialForUpload: (0, _sizeUtils.fromBigInteger)(potentialForUpload),
    overallocated: (0, _sizeUtils.fromBigInteger)(overallocated)
  };
}

function getQuotaValue(quota) {
  const {
    size,
    unit
  } = quota;
  const quotaBigInt = (0, _sizeUtils.toBigInteger)(size).multiply(_sizeUtils.unitsInBytes[unit]);
  return (0, _sizeUtils.fromBigInteger)(quotaBigInt);
}

function isBucketWritable(bucket) {
  return writableStates.includes(bucket.mode);
}

function countStorageNodesByMirrorSet(tier, hostPools) {
  return (tier.mirrorSets || []).map(ms => (0, _coreUtils.sumBy)(ms.resources, res => res.type === 'HOSTS' ? hostPools[res.name].storageNodeCount : Infinity));
}

function summrizeResiliency(resiliency) {
  switch (resiliency.kind) {
    case 'REPLICATION':
      {
        const replicas = Math.max(resiliency.replicas, 0);
        const copies = Math.max(replicas - 1, 0);
        return {
          type: 'REPLICATION',
          mode: resiliency.mode,
          replicas: replicas,
          storageOverhead: copies,
          failureTolerance: copies,
          requiredDrives: replicas,
          rebuildEffort: 'LOW'
        };
      }

    case 'ERASURE_CODING':
      {
        const dataFrags = Math.max(resiliency.dataFrags, 0);
        const parityFrags = Math.max(resiliency.parityFrags, 0);
        return {
          type: 'ERASURE_CODING',
          mode: resiliency.mode,
          dataFrags: dataFrags,
          parityFrags: parityFrags,
          storageOverhead: dataFrags > 0 ? parityFrags / dataFrags : 0,
          failureTolerance: parityFrags,
          requiredDrives: dataFrags + parityFrags,
          rebuildEffort: dataFrags <= 4 ? 'HIGH' : 'VERY_HIGH'
        };
      }
  }
}

function getResiliencyStateIcon(resiliency) {
  return resiliencyModeToIcon[resiliency.mode](resiliency);
}

function getResiliencyTypeDisplay(resiliencyType) {
  return resiliencyTypeToDisplay[resiliencyType];
}

function getResiliencyRequirementsWarning(resiliencyType, drivesCount) {
  const subject = resiliencyTypeToBlockType[resiliencyType];
  return `The current placement policy allows for a maximum of ${(0, _stringUtils.stringifyAmount)(subject, drivesCount)}. The number of possible ${(0, _stringUtils.pluralize)(subject)} is derived from the minimal number of available drives across all mirror sets.`;
}

function getVersioningStateText(versioningMode) {
  return versioningModeToText[versioningMode];
}

function flatPlacementPolicy(bucket) {
  return (0, _coreUtils.flatMap)(bucket.placement.tiers, (tier, i) => (0, _coreUtils.flatMap)(tier.policyType === 'INTERNAL_STORAGE' ? [] : tier.mirrorSets, ms => ms.resources.map(resource => ({
    bucket: bucket.name,
    tier: tier.name,
    tierIndex: i,
    mirrorSet: ms.name,
    resource: resource
  }))));
}

function validatePlacementPolicy(policy, errors = {}) {
  const {
    policyType,
    selectedResources
  } = policy;

  if (policyType === 'MIRROR' && selectedResources.length < 2) {
    errors.selectedResources = 'Mirror policy requires at least 2 participating resources';
  } else if (policyType === 'SPREAD') {
    const [first, ...others] = selectedResources.map(res => res.split(':')[0]);

    if (others.some(type => type !== first)) {
      errors.selectedResources = 'Configuring pools combined with cloud resource as spread is not allowed';
    }
  }

  return errors;
}

function warnPlacementPolicy(policy, hostPools, cloudResources, warnings = {}) {
  const {
    policyType,
    selectedResources
  } = policy;

  if (policyType === 'SPREAD') {
    const [first, ...rest] = selectedResources.map(id => {
      const [type, name] = id.split(':');
      const {
        region
      } = (type === 'HOSTS' ? hostPools : cloudResources)[name];
      return region || 'NOT_SET';
    });

    if (first && rest.some(region => region !== first)) {
      warnings.selectedResources = 'Combining resources with different assigned regions is not recommended and might raise costs';
    }
  }

  return warnings;
}

},{"./core-utils":1027,"utils/icon-utils":1033,"utils/size-utils":1043,"utils/string-utils":1046}],1023:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getFormatter = getFormatter;

var _coreUtils = require("./core-utils");

var _sizeUtils = require("./size-utils");

var _numeral = _interopRequireDefault(require("numeral"));

/* Copyright (C) 2016 NooBaa */
const namedFormatter = (0, _coreUtils.deepFreeze)({
  none: _coreUtils.echo,
  size: _sizeUtils.formatSize,
  number: value => (0, _numeral.default)(value).format(','),
  percentage: value => (0, _numeral.default)(value).format('%')
});

function getFormatter(format = 'none') {
  return (0, _coreUtils.isFunction)(format) ? format : namedFormatter[format];
}

},{"./core-utils":1027,"./size-utils":1043,"@babel/runtime/helpers/interopRequireDefault":1050,"numeral":"numeral"}],1024:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getCloudServiceMeta = getCloudServiceMeta;
exports.getCloudTargetTooltip = getCloudTargetTooltip;
exports.cloudServices = void 0;

var _coreUtils = require("./core-utils");

/* Copyright (C) 2016 NooBaa */
const cloudServices = (0, _coreUtils.deepFreeze)([{
  value: 'AWS',
  displayName: 'AWS S3',
  subject: 'Bucket',
  identityDisplayName: 'Access Key',
  icon: 'aws-s3',
  defaultEndpoint: 'https://s3.amazonaws.com'
}, {
  value: 'AZURE',
  displayName: 'Azure Blob',
  subject: 'Container',
  identityDisplayName: 'Account Name',
  icon: 'azure',
  defaultEndpoint: 'https://blob.core.windows.net'
}, {
  value: 'GOOGLE',
  displayName: 'Google Cloud',
  subject: 'Bucket',
  identityDisplayName: 'Private Key ID',
  icon: 'google-cloud',
  defaultEndpoint: 'www.googleapis.com'
}, {
  value: 'S3_V2_COMPATIBLE',
  displayName: 'S3 V2 Compatible service',
  subject: 'Bucket',
  identityDisplayName: 'Access Key',
  icon: 'cloud-v2'
}, {
  value: 'S3_V4_COMPATIBLE',
  displayName: 'S3 V4 Compatible service',
  subject: 'Bucket',
  identityDisplayName: 'Access Key',
  icon: 'cloud-v4'
}, // {
//     value: 'NET_STORAGE',
//     displayName: 'NetStorage service',
//     identityDisplayName: 'Key',
//     subject: 'Bucket',
//     icon: 'net-storage'
// },
{
  value: 'FLASHBLADE',
  displayName: 'Pure FlashBlade service',
  subject: 'Bucket',
  identityDisplayName: 'Access Key',
  icon: 'pure'
}, {
  value: 'IBM_COS',
  displayName: 'IBM COS service',
  subject: 'Bucket',
  identityDisplayName: 'Access Key',
  icon: 'ibm-cos'
}]);
exports.cloudServices = cloudServices;
const usedCloudTargetTooltip = (0, _coreUtils.deepFreeze)({
  CLOUD_RESOURCE: name => `Already used by ${name} cloud resource`,
  NAMESPACE_RESOURCE: name => `Already used by ${name} namespace resource `
});
const serviceToMeta = (0, _coreUtils.keyByProperty)(cloudServices, 'value');

function getCloudServiceMeta(service) {
  return serviceToMeta[service];
}

function getCloudTargetTooltip(cloudTarget) {
  if (!cloudTarget.usedBy) return '';
  const {
    kind,
    name
  } = cloudTarget.usedBy;
  return usedCloudTargetTooltip[kind](name);
}

},{"./core-utils":1027}],1025:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.summarizeServerIssues = summarizeServerIssues;
exports.getServerDisplayName = getServerDisplayName;
exports.getClsuterHAState = getClsuterHAState;
exports.getClusterStateIcon = getClusterStateIcon;
exports.getServerStateIcon = getServerStateIcon;

var _coreUtils = require("utils/core-utils");

/* Copyright (C) 2016 NooBaa */
const clsuterModeToIcon = (0, _coreUtils.deepFreeze)({
  UNHEALTHY: {
    name: 'problem',
    css: 'error',
    tooltip: 'Not enough connected servers'
  },
  WITH_ISSUES: {
    name: 'problem',
    css: 'warning',
    tooltip: 'High number of issues'
  },
  HEALTHY: {
    name: 'healthy',
    css: 'success',
    tooltip: 'Healthy'
  }
});
const serverModeToIcon = (0, _coreUtils.deepFreeze)({
  CONNECTED: {
    name: 'healthy',
    css: 'success',
    tooltip: 'Healthy'
  },
  IN_PROGRESS: {
    name: 'in-progress',
    css: 'warning',
    tooltip: 'In Progress'
  },
  DISCONNECTED: {
    name: 'problem',
    css: 'error',
    tooltip: 'Problem'
  }
});
const majorIssues = (0, _coreUtils.deepFreeze)(['version', 'dnsServers', 'dnsNameResolution', 'clusterConnectivity']);

function _formatIssueMessage(subject, status, plural = false) {
  switch (status) {
    case 'FAULTY':
      return `${subject} ${plural ? 'are' : 'is'} faulty`;

    case 'UNREACHABLE':
      return `${subject} ${plural ? 'are' : 'is'} unreachable`;

    case 'UNKNOWN':
      return `${subject} has an unknown problem`;
  }
}

function summarizeServerIssues(server, systemVersion, minRequirements) {
  const dnsServerStatus = server.dns.servers.status;
  const dnsNameResolutionStatus = (server.dns.nameResolution || {}).status;
  const phonehomeStatus = server.phonehome.status;
  const clsuterConnectivityStatus = Object.values(server.clusterConnectivity).some(status => status !== 'OPERATIONAL');
  const minRequirementsStatus = server.storage.total < minRequirements.storage || server.memory.total < minRequirements.memory || server.cpus.count < minRequirements.cpus;
  return (0, _coreUtils.omitUndefined)({
    debugMode: server.debugMode ? 'Server is in debug mode' : undefined,
    version: server.version !== systemVersion ? 'Server version is not synced with master' : undefined,
    dnsNameResolution: dnsNameResolutionStatus && dnsNameResolutionStatus !== 'OPERATIONAL' ? 'System DNS name does not point to this server\'s IP' : undefined,
    dnsServers: _formatIssueMessage('DNS servers', dnsServerStatus, true),
    phonehome: _formatIssueMessage('Phone Home server', phonehomeStatus),
    clusterConnectivity: clsuterConnectivityStatus ? 'Cannot reach some cluster members' : undefined,
    minRequirements: minRequirementsStatus ? 'Server specs are below minimum requirements' : undefined
  });
}

function getServerDisplayName(server) {
  const {
    hostname,
    secret
  } = server;
  return `${hostname}-${secret}`;
}

function getClsuterHAState(topology) {
  const {
    supportHighAvailability,
    isHighlyAvailable
  } = topology;
  return !supportHighAvailability && 'Not configured for high availability' || isHighlyAvailable && 'Highly Available' || 'Not highly available';
}

function getClusterStateIcon(topology, systemVersion) {
  const servers = Object.values(topology.servers);
  const connected = servers.filter(server => server.mode === 'CONNECTED');
  const issueCount = connected.reduce((count, server) => {
    const serverIssues = summarizeServerIssues(server, systemVersion, topology.serverMinRequirements);
    const hasMajorIssues = Object.keys(serverIssues).filter(issue => majorIssues.includes(issue)).length > 0;
    return count + Number(hasMajorIssues);
  }, 0);
  const {
    supportHighAvailability,
    isHighlyAvailable
  } = topology;
  const mode = supportHighAvailability && !isHighlyAvailable && 'UNHEALTHY' || issueCount > connected.length / 2 && 'WITH_ISSUES' || 'HEALTHY';
  return clsuterModeToIcon[mode];
}

function getServerStateIcon(server) {
  return serverModeToIcon[server.mode];
}

},{"utils/core-utils":1027}],1026:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.colorToHex = colorToHex;
exports.colorToRgb = colorToRgb;
exports.hexToColor = hexToColor;
exports.rgbToColor = rgbToColor;
exports.rgbaToColor = rgbaToColor;
exports.hexToRgb = hexToRgb;
exports.tweenColors = tweenColors;

var _coreUtils = require("./core-utils");

var _stringUtils = require("./string-utils");

/* Copyright (C) 2016 NooBaa */
function colorToHex(r, g, b) {
  return `#${(0, _stringUtils.pad)(r.toString(16), 2)}${(0, _stringUtils.pad)(g.toString(16), 2)}${(0, _stringUtils.pad)(b.toString(16), 2)}`;
}

function colorToRgb(r, g, b, alpha) {
  return (0, _coreUtils.isDefined)(alpha) ? `rgba(${r},${g},${b},${alpha})` : `rgb(${r},${g},${b})`;
}

function hexToColor(hex) {
  const regExp = /^#([0-9A-Fa-f]{2})([0-9A-Fa-f]{2})([0-9A-Fa-f]{2})$/;
  const [, ...channels] = hex.match(regExp).map(hex => parseInt(hex, 16));
  return channels;
}

function rgbToColor(rgb) {
  const regExp = /^rgb\(\s*(\d{1,3})\s*,\s*(\d{1,3})\s*,\s*(\d{1,3})\s*\)$/;
  const match = rgb.match(regExp);

  if (!match) {
    return null;
  }

  const channels = match.slice(1).map(Number);

  if (channels.some(c => Number.isNaN(c) || c > 255)) {
    return null;
  }

  return channels;
}

function rgbaToColor(rgba) {
  const regExp = /^rgba\(\s*(\d{1,3})\s*,\s*(\d{1,3})\s*,\s*(\d{1,3})\s*,\s*(1|0|(?:0?\.\d+))\s*\)$/;
  const match = rgba.match(regExp);

  if (!match) {
    return null;
  }

  const channels = match.slice(1).map(Number);

  if (channels.some(Number.isNaN)) {
    return null;
  }

  const [r, g, b, a] = channels;

  if (r > 255 || g > 255 || b > 255 || a > 1) {
    return null;
  }

  return channels;
}

function hexToRgb(hex, alpha) {
  return colorToRgb(...hexToColor(hex), alpha);
}

function tweenColors(ratio, ...colors) {
  if (colors.length === 1) {
    return colors[0];
  }

  let scaledRatio = ratio * (colors.length - 1);
  let lowerBound = Math.floor(scaledRatio);
  let upperBound = Math.ceil(scaledRatio);
  let tweenValue = scaledRatio - lowerBound;
  let [r1, g1, b1] = hexToColor(colors[lowerBound]);
  let [r2, g2, b2] = hexToColor(colors[upperBound]);
  let r = r1 + (r2 - r1) * tweenValue | 0;
  let g = g1 + (g2 - g1) * tweenValue | 0;
  let b = b1 + (b2 - b1) * tweenValue | 0;
  return colorToHex(r, g, b);
}

},{"./core-utils":1027,"./string-utils":1046}],1027:[function(require,module,exports){
(function (global){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.noop = noop;
exports.echo = echo;
exports.deepFreeze = deepFreeze;
exports.deepClone = deepClone;
exports.deepAssign = deepAssign;
exports.isNumber = isNumber;
exports.isString = isString;
exports.isFunction = isFunction;
exports.isObject = isObject;
exports.isUndefined = isUndefined;
exports.isDefined = isDefined;
exports.isFalsy = isFalsy;
exports.hasOwn = hasOwn;
exports.pick = pick;
exports.throttle = throttle;
exports.compare = compare;
exports.compareArray = compareArray;
exports.createCompareFunc = createCompareFunc;
exports.makeArray = makeArray;
exports.makeRange = makeRange;
exports.first = first;
exports.last = last;
exports.clamp = clamp;
exports.bitsToNumber = bitsToNumber;
exports.flatMap = flatMap;
exports.sumBy = sumBy;
exports.averageBy = averageBy;
exports.keyBy = keyBy;
exports.keyByProperty = keyByProperty;
exports.groupBy = groupBy;
exports.countBy = countBy;
exports.assignWith = assignWith;
exports.mapValues = mapValues;
exports.interpolateLinear = interpolateLinear;
exports.decimalRound = decimalRound;
exports.mergeBy = mergeBy;
exports.reverse = reverse;
exports.get = get;
exports.equalItems = equalItems;
exports.ensureArray = ensureArray;
exports.unique = unique;
exports.union = union;
exports.hashCode = hashCode;
exports.filterValues = filterValues;
exports.omitUndefined = omitUndefined;
exports.normalizeValues = normalizeValues;
exports.memoize = memoize;
exports.runAsync = void 0;

/* Copyright (C) 2016 NooBaa */
function noop() {}

function echo(val) {
  return val;
}

function deepFreeze(val) {
  if (isObject(val) && !Object.isFrozen(val)) {
    Object.keys(val).forEach(key => {
      val[key] = deepFreeze(val[key]);
    });
    return Object.freeze(val);
  } else {
    return val;
  }
}

function deepClone(val) {
  if (Array.isArray(val)) {
    return val.map(deepClone);
  } else if (isObject(val)) {
    return mapValues(val, deepClone);
  } else {
    return val;
  }
}

function deepAssign(target, other) {
  if (Array.isArray(target) && Array.isArray(other)) {
    for (let i = 0; i < other.length; ++i) {
      target[i] = deepAssign(target[i], other[i]);
    }

    return target;
  } else if (isObject(target) && isObject(other)) {
    for (const [key, value] of Object.entries(other)) {
      target[key] = deepAssign(target[key], value);
    }

    return target;
  } else {
    return deepClone(other);
  }
}

function isNumber(value) {
  return typeof value === 'number' || value instanceof Number;
}

function isString(value) {
  return typeof value === 'string' || value instanceof String;
}

function isFunction(value) {
  return typeof value === 'function';
}

function isObject(value) {
  return typeof value === 'object' && value !== null;
}

function isUndefined(value) {
  return typeof value === 'undefined';
}

function isDefined(value) {
  return !isUndefined(value);
}

function isFalsy(value) {
  return !value;
}

function hasOwn(obj, propName) {
  return Object.prototype.hasOwnProperty.call(obj, propName);
}

function pick(obj, keys) {
  return keys.reduce((picked, key) => {
    if (hasOwn(obj, key)) {
      picked[key] = obj[key];
    }

    return picked;
  }, {});
}

function throttle(func, grace, owner) {
  let handle = null;
  return function (...args) {
    clearTimeout(handle);
    handle = setTimeout(() => func.apply(owner || this, args), grace);
  };
}

function compare(a, b) {
  return a < b ? -1 : b < a ? 1 : 0;
}

function compareArray(a, b) {
  for (let i = 0; i < a.length; ++i) {
    let result = compare(a[i], b[i]);
    if (result !== 0) return result;
  }

  return 0;
}

function createCompareFunc(valueSelector, factor = 1, ...additionalArgs) {
  return (a, b) => {
    const key1 = valueSelector(a, ...additionalArgs);
    const key2 = valueSelector(b, ...additionalArgs);
    return factor * (Array.isArray(key1) ? compareArray(key1, key2) : compare(key1, key2));
  };
}

function makeArray(size, initializer) {
  if (!isFunction(initializer)) {
    let val = initializer;

    initializer = () => val;
  }

  let array = [];

  for (let i = 0; i < size; ++i) {
    array.push(initializer(i));
  }

  return array;
}

function makeRange(start, end) {
  if (isUndefined(end)) {
    if (start < 0) {
      throw new TypeError('Invalid count');
    }

    end = start - 1;
    start = 0;
  }

  let dir = start > end ? -1 : 1;
  let count = Math.abs(end - start + dir);
  return makeArray(count, i => i * dir + start);
}

function first(arr) {
  return arr[0];
}

function last(arr) {
  return arr[arr.length - 1];
}

function clamp(num, min, max) {
  return Math.max(min, Math.min(num, max));
}

function bitsToNumber(...bits) {
  return bits.reduce((number, bit) => number << 1 | (!!bit | 0), 0);
}

function flatMap(arr, predicate = echo) {
  return arr.reduce((result, item, i) => {
    let mappedValue = predicate(item, i);

    if (isDefined(mappedValue)) {
      if (Array.isArray(mappedValue)) {
        result.push(...mappedValue);
      } else {
        result.push(mappedValue);
      }
    }

    return result;
  }, []);
}

function sumBy(array, selector = echo) {
  return array.map(selector).reduce((sum, value) => sum + value, 0);
}

function averageBy(array, selector = echo) {
  return sumBy(array, selector) / array.length;
}

function keyBy(arrayOrIter, keySelector, valueMapper = echo) {
  const array = Array.isArray(arrayOrIter) ? arrayOrIter : Array.from(arrayOrIter);
  return array.reduce((map, item, i) => {
    const key = keySelector(item, i);
    map[key] = valueMapper(item, key, map[key]);
    return map;
  }, {});
}

function keyByProperty(array, keyName, valueMapper = echo) {
  return keyBy(array, item => item[keyName], valueMapper);
}

function groupBy(array, keySelector, valueMapper = echo) {
  return keyBy(array, keySelector, (item, _, list = []) => {
    list.push(valueMapper(item));
    return list;
  });
}

function countBy(array, keySelector) {
  return keyBy(array, keySelector, (_, __, count = 0) => count + 1);
}

function assignWith(target, ...sources) {
  const assignOp = isFunction(last(sources)) ? sources.pop() : (_, value) => value;

  for (const source of sources) {
    for (const [key, value] of Object.entries(source)) {
      target[key] = assignOp(target[key], value);
    }
  }

  return target;
}

function mapValues(obj, mapOp, omitUndefinedValues = true) {
  const res = {};

  for (const [key, value] of Object.entries(obj)) {
    const newValue = mapOp(value, key);
    if (!omitUndefinedValues || isDefined(newValue)) res[key] = newValue;
  }

  return res;
}

function interpolateLinear(a, b, t) {
  return a + (b - a) * t;
}

function decimalRound(number, fractionalLength = 2) {
  const factor = 10 ** fractionalLength;
  return Math.round(number * factor) / factor;
}

function mergeBy(...arrays) {
  const keySelector = isFunction(last(arrays)) ? arrays.pop() : echo;
  const merge = {};

  for (const arr of arrays) {
    Object.assign(merge, keyBy(arr, keySelector));
  }

  return Object.values(merge);
}

const runAsync = function (env) {
  if (env.setImmediate) {
    return callback => env.setImmediate(callback);
  }

  if (env.postMessage) {
    const messageKey = 'PROCESS_TICK';
    const queue = [];
    env.addEventListener('message', evt => {
      const {
        source
      } = evt;

      if ((source === env || source === null) && evt.data === messageKey) {
        evt.stopPropagation();

        if (queue.length > 0) {
          const callback = queue.shift();
          callback();
        }
      }
    }, true);
    return callback => {
      queue.push(callback);
      env.postMessage(messageKey, '*');
    };
  }

  if (env.setTimeout) {
    return callback => {
      env.setTimeout(callback, 0);
    };
  }

  throw new Error('No implementation method for run async is available');
}(global);

exports.runAsync = runAsync;

function reverse(iterable) {
  return Array.from(iterable).reverse();
}

function get(val, path, defaultValue) {
  for (const part of path) {
    if (val == null) {
      val = undefined;
      break;
    }

    val = val[part];
  }

  return isDefined(val) ? val : defaultValue;
}

function equalItems(arr1, arr2) {
  if (arr1.length !== arr2.length) {
    return false;
  }

  for (let i = 0; i < arr1.length; ++i) {
    if (!Object.is(arr1[i], arr2[i])) {
      return false;
    }
  }

  return true;
}

function ensureArray(val) {
  if (isUndefined(val)) {
    return [];
  }

  if (val === null || isString(val) || !isFunction(val[Symbol.iterator])) {
    return [val];
  }

  if (!Array.isArray(val)) {
    return Array.from(val);
  }

  return val;
}

function unique(values) {
  return Array.from(new Set(values).values());
}

function union(...arrays) {
  return unique(flatMap(arrays));
}

function hashCode(value) {
  return Array.from(JSON.stringify(value)).reduce((hash, char) => (hash << 5) - hash + char.charCodeAt(0) | 0, 0);
}

function filterValues(obj, filter) {
  return mapValues(obj, (value, key) => filter(value, key) ? value : undefined, true);
}

function omitUndefined(obj) {
  return mapValues(obj, echo, true);
}

function normalizeValues(values, newSum = 1, minValue = 0) {
  if (minValue * values.length > newSum) {
    throw new Error('Invalid arguments, sum of min values is greater then new total');
  }

  const minRatio = minValue / newSum;
  const threshold = sumBy(values) * minRatio;
  const belowCount = sumBy(values, value => Number(0 < value && value <= threshold));
  const aboveSum = sumBy(values, value => value > threshold ? value : 0);
  const factor = (1 - belowCount * minRatio) / aboveSum;
  return values.map(value => {
    if (value === 0) return 0;
    return (value <= threshold ? minRatio : value * factor) * newSum;
  });
}

function memoize(func, areArgsEqual = equalItems) {
  let lastArgs = [],
      lastResult;
  return function (...args) {
    if (!areArgsEqual(args, lastArgs)) {
      lastResult = deepFreeze(func(...(lastArgs = args)));
    }

    return lastResult;
  };
}

}).call(this,typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})

},{}],1028:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.formatTimeLeftForDebugMode = formatTimeLeftForDebugMode;

var _moment = _interopRequireDefault(require("moment"));

/* Copyright (C) 2016 NooBaa */
function formatTimeLeftForDebugMode(debugState, timeLeft) {
  if (!debugState) {
    return 'None';
  } else if (timeLeft == null) {
    return 'Calculating...';
  } else {
    const duration = _moment.default.duration(timeLeft);

    const minutes = String(duration.minutes()).padStart(2, 0);
    const seconds = String(duration.seconds()).padStart(2, 0);
    return `${minutes}:${seconds} minutes`;
  }
}

},{"@babel/runtime/helpers/interopRequireDefault":1050,"moment":"moment"}],1029:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.findFirstFocusableIn = findFirstFocusableIn;
exports.findLastFocusableIn = findLastFocusableIn;
exports.findPrevFocusableIn = findPrevFocusableIn;
exports.findNextFocusableIn = findNextFocusableIn;
exports.findNthPrevFocusableIn = findNthPrevFocusableIn;
exports.findNthNextFocusableIn = findNthNextFocusableIn;

/* Copyright (C) 2016 NooBaa */
const query = ['input', 'select', 'textarea', 'a', 'button', '[tabindex]'].join(',');

function _compareFocusOrder(p1, p2) {
  return false || p1[0] === p2[0] && p1[1] - p2[1] || p1[0] === 0 && 1 || p2[0] === 0 && -1 || p1[0] - p2[0];
}

function _listFocusable(container) {
  const focusables = Array.from(container.querySelectorAll(query));
  return focusables.map((elm, i) => [elm.tabIndex, i]).sort(_compareFocusOrder).map(([, i]) => focusables[i]);
}

function _canBeFocused(elm) {
  const {
    tabIndex,
    disabled,
    offsetParent
  } = elm;
  return Boolean(offsetParent) && tabIndex !== null && tabIndex >= 0 && !disabled;
}

function _findFocusableIn(container, fromElm, dir, n, cyclic) {
  const focusables = _listFocusable(container);

  const count = focusables.length;
  let index = focusables.findIndex(other => fromElm === other);
  let candidate = null;
  let last = null;

  do {
    index = cyclic ? (count + index + dir) % count : index + dir;
    candidate = focusables[index];

    if (candidate && _canBeFocused(candidate)) {
      last = candidate;
      --n;
    }
  } while (candidate && candidate !== fromElm && n > 0);

  return last;
}

function findFirstFocusableIn(container) {
  return _listFocusable(container).find(_canBeFocused);
}

function findLastFocusableIn(container) {
  return _listFocusable(container).reverse().find(_canBeFocused);
}

function findPrevFocusableIn(container, fromElm, cyclic = false) {
  return _findFocusableIn(container, fromElm, -1, 1, cyclic);
}

function findNextFocusableIn(container, fromElm, cyclic = false) {
  return _findFocusableIn(container, fromElm, 1, 1, cyclic);
}

function findNthPrevFocusableIn(container, fromElm, n, cyclic = false) {
  return _findFocusableIn(container, fromElm, -1, n, cyclic);
}

function findNthNextFocusableIn(container, fromElm, n, cyclic = false) {
  return _findFocusableIn(container, fromElm, 1, n, cyclic);
}

},{}],1030:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getFieldValue = getFieldValue;
exports.getFieldInitialValue = getFieldInitialValue;
exports.getFieldError = getFieldError;
exports.getFieldWarning = getFieldWarning;
exports.isFieldTouched = isFieldTouched;
exports.isFieldValid = isFieldValid;
exports.isFieldDirty = isFieldDirty;
exports.getFormValues = getFormValues;
exports.isFormValid = isFormValid;
exports.isFormDirty = isFormDirty;
exports.isFieldTouchedAndInvalid = isFieldTouchedAndInvalid;

var _coreUtils = require("./core-utils");

/* Copyright (C) 2016 NooBaa */
function _getFieldProp(form, fieldName, propName) {
  const {
    [fieldName]: field
  } = form.fields;
  return field && field[propName];
}

function getFieldValue(form, field) {
  return _getFieldProp(form, field, 'value');
}

function getFieldInitialValue(form, field) {
  return _getFieldProp(form, field, 'initial');
}

function getFieldError(form, name) {
  const {
    syncErrors,
    asyncErrors,
    submitErrors
  } = form;
  return syncErrors[name] || asyncErrors[name] || submitErrors[name];
}

function getFieldWarning(form, name) {
  return form.warnings[name];
}

function isFieldTouched(form, field) {
  return _getFieldProp(form, field, 'touched');
}

function isFieldValid(form, field) {
  return _getFieldProp(form, field, 'validity') === 'VALID';
}

function isFieldDirty(form, field) {
  return getFieldValue(form, field) !== getFieldInitialValue(form, field);
}

function getFormValues(form) {
  return (0, _coreUtils.mapValues)(form.fields, field => field.value, false);
}

function isFormValid(form) {
  return form.validated && Object.values(form.fields).every(field => field.validity === 'VALID');
}

function isFormDirty(form) {
  return Object.keys(form.fields).some(field => isFieldDirty(form, field));
}

function isFieldTouchedAndInvalid(form, fieldName) {
  return isFieldTouched(form, fieldName) && !isFieldValid(form, fieldName);
}

},{"./core-utils":1027}],1031:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getFunctionOption = getFunctionOption;
exports.isValidFuncName = isValidFuncName;
exports.isValidHandlerFuncName = isValidHandlerFuncName;
exports.getFullHandlerName = getFullHandlerName;
exports.memorySizeOptions = exports.handlerFileSuffix = exports.funcSizeLimit = void 0;

var _coreUtils = require("./core-utils");

var _sizeUtils = require("utils/size-utils");

/* Copyright (C) 2016 NooBaa */
const funcNameRegExp = /^[a-zA-Z0-9-_]+$/;
const handlerFuncNameRegExp = /^[a-zA-Z_$][a-zA-Z0-9_$]*$/;
const funcSizeLimit = _sizeUtils.unitsInBytes.MEGABYTE * 100;
exports.funcSizeLimit = funcSizeLimit;
const handlerFileSuffix = '.js';
exports.handlerFileSuffix = handlerFileSuffix;
const memorySizeOptions = (0, _coreUtils.deepFreeze)([{
  value: 128,
  label: '128 MB'
}, {
  value: 256,
  label: '256 MB'
}, {
  value: 512,
  label: '512 MB'
}]);
exports.memorySizeOptions = memorySizeOptions;

function getFunctionOption(func, accounts, bucket) {
  const {
    name,
    version
  } = func;
  const value = `${name}:${version}`;
  const icon = {
    name: 'healthy',
    css: 'success'
  };
  const label = name;
  const executor = accounts[func.executor];
  const disabled = !executor.hasAccessToAllBuckets && !executor.allowedBuckets.includes(bucket);
  let tooltip = '';

  if (disabled) {
    tooltip = `This function was created by ${executor.name},
            This account doesn’t have permissions for this bucket and the function
            cannot be selected until access is granted.`;
  }

  return {
    value,
    icon,
    label,
    disabled,
    tooltip
  };
}

function isValidFuncName(name) {
  return funcNameRegExp.test(name);
}

function isValidHandlerFuncName(name) {
  return handlerFuncNameRegExp.test(name);
}

function getFullHandlerName(handlerFile, handlerFunc) {
  return `${handlerFile.slice(0, -handlerFileSuffix.length)}.${handlerFunc}`;
}

},{"./core-utils":1027,"utils/size-utils":1043}],1032:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getHostDisplayName = getHostDisplayName;
exports.getHostStateIcon = getHostStateIcon;
exports.getHostTrustIcon = getHostTrustIcon;
exports.getHostAccessibilityIcon = getHostAccessibilityIcon;
exports.getNodeOrHostCapacityBarValues = getNodeOrHostCapacityBarValues;
exports.getHostModeListForState = getHostModeListForState;
exports.getHostModeListForStates = getHostModeListForStates;
exports.summrizeHostModeCounters = summrizeHostModeCounters;
exports.getHostServiceDisplayName = getHostServiceDisplayName;
exports.getStorageNodeStateIcon = getStorageNodeStateIcon;
exports.getActivityName = getActivityName;
exports.getActivityStageName = getActivityStageName;
exports.getActivityListTooltip = getActivityListTooltip;
exports.storageNodeWritableModes = exports.hostWritableModes = void 0;

var _coreUtils = require("./core-utils");

var _stringUtils = require("utils/string-utils");

var _moment = _interopRequireDefault(require("moment"));

var _numeral = _interopRequireDefault(require("numeral"));

/* Copyright (C) 2016 NooBaa */
const modeToStateIcon = (0, _coreUtils.deepFreeze)({
  DECOMMISSIONED: {
    name: 'problem',
    css: 'warning',
    tooltip: 'Node Deactivated'
  },
  OFFLINE: {
    name: 'problem',
    css: 'error',
    tooltip: 'Offline'
  },
  STORAGE_OFFLINE: {
    name: 'problem',
    css: 'error',
    tooltip: 'All Drives Offline'
  },
  UNTRUSTED: {
    name: 'problem',
    css: 'warning',
    tooltip: 'Has Issues'
  },
  STORAGE_NOT_EXIST: {
    name: 'problem',
    css: 'error',
    tooltip: 'All Drives are Unmounted'
  },
  IO_ERRORS: {
    name: 'problem',
    css: 'error',
    tooltip: 'All drives have I/O errors'
  },
  N2N_ERRORS: {
    name: 'problem',
    css: 'error',
    tooltip: 'Node to node communication problems'
  },
  GATEWAY_ERRORS: {
    name: 'problem',
    css: 'error',
    tooltip: 'Server communication problems'
  },
  INITIALIZING: {
    name: 'working',
    css: 'warning',
    tooltip: 'Initializing'
  },
  DECOMMISSIONING: {
    name: 'working',
    css: 'warning',
    tooltip: 'Deactivating'
  },
  MIGRATING: {
    name: 'working',
    css: 'warning',
    tooltip: 'Migrating'
  },
  IN_PROCESS: {
    name: 'working',
    css: 'warning',
    tooltip: 'In Process'
  },
  SOME_STORAGE_MIGRATING: {
    name: 'working',
    css: 'warning',
    tooltip: 'Some Drives are Migrating'
  },
  SOME_STORAGE_INITIALIZING: {
    name: 'working',
    css: 'warning',
    tooltip: 'Some Drives are Initializing'
  },
  SOME_STORAGE_DECOMMISSIONING: {
    name: 'working',
    css: 'warning',
    tooltip: 'Some Drives are Deactivating'
  },
  DELETING: {
    name: 'working',
    css: 'warning',
    tooltip: 'Deleting Node'
  },
  SOME_STORAGE_OFFLINE: {
    name: 'problem',
    css: 'warning',
    tooltip: 'Some Drives are Offline'
  },
  SOME_STORAGE_NOT_EXIST: {
    name: 'problem',
    css: 'warning',
    tooltip: 'Some Drives are Unmounted'
  },
  SOME_STORAGE_IO_ERRORS: {
    name: 'problem',
    css: 'warning',
    tooltip: 'Some Drives have I/O errors'
  },
  NO_CAPACITY: {
    name: 'problem',
    css: 'warning',
    tooltip: 'No Available Capacity'
  },
  LOW_CAPACITY: {
    name: 'problem',
    css: 'warning',
    tooltip: 'Low Available Capacity'
  },
  HAS_ERRORS: {
    name: 'problem',
    css: 'error',
    tooltip: 'Services have Errors'
  },
  HAS_ISSUES: {
    name: 'problem',
    css: 'warning',
    tooltip: 'Services have Issues'
  },
  N2N_PORTS_BLOCKED: {
    name: 'problem',
    css: 'warning',
    tooltip: 'Some Ports Might be Blocked'
  },
  OPTIMAL: {
    name: 'healthy',
    css: 'success',
    tooltip: 'Healthy'
  }
});
const trustToIcon = (0, _coreUtils.deepFreeze)({
  true: {
    name: 'healthy',
    css: 'success',
    tooltip: 'Trusted'
  },
  false: {
    name: 'problem',
    css: 'error',
    tooltip: 'Untrusted'
  }
});
const modeToAccessibilityIcon = (0, _coreUtils.deepFreeze)({
  DECOMMISSIONED: {
    name: 'healthy',
    css: 'success',
    tooltip: 'No Access'
  },
  OFFLINE: {
    name: 'problem',
    css: 'error',
    tooltip: 'No access'
  },
  UNTRUSTED: {
    name: 'problem',
    css: 'error',
    tooltip: 'No access'
  },
  STORAGE_NOT_EXIST: {
    name: 'problem',
    css: 'error',
    tooltip: 'No access'
  },
  IO_ERRORS: {
    name: 'problem',
    css: 'error',
    tooltip: 'No access'
  },
  GATEWAY_ERRORS: {
    name: 'problem',
    css: 'error',
    tooltip: 'No access'
  },
  N2N_ERRORS: {
    name: 'problem',
    css: 'error',
    tooltip: 'No access'
  },
  DELETING: {
    name: 'problem',
    css: 'error',
    tooltip: 'No Access'
  },
  INITIALIZING: {
    name: 'problem',
    css: 'error',
    tooltip: 'No access'
  },
  DECOMMISSIONING: {
    name: 'problem',
    css: 'warning',
    tooltip: 'Read Only'
  },
  MIGRATING: {
    name: 'problem',
    css: 'warning',
    tooltip: 'Read Only - Moving data'
  },
  IN_PROCESS: {
    name: 'healthy',
    css: 'success',
    tooltip: 'Readable & Writable'
  },
  SOME_STORAGE_MIGRATING: {
    name: 'healthy',
    css: 'success',
    tooltip: 'Readable & Writable'
  },
  SOME_STORAGE_INITIALIZING: {
    name: 'healthy',
    css: 'success',
    tooltip: 'Readable & Writable'
  },
  SOME_STORAGE_DECOMMISSIONING: {
    name: 'healthy',
    css: 'success',
    tooltip: 'Readable & Writable'
  },
  SOME_STORAGE_OFFLINE: {
    name: 'healthy',
    css: 'success',
    tooltip: 'Readable & Writable'
  },
  SOME_STORAGE_NOT_EXIST: {
    name: 'healthy',
    css: 'success',
    tooltip: 'Readable & Writable'
  },
  SOME_STORAGE_IO_ERRORS: {
    name: 'healthy',
    css: 'success',
    tooltip: 'Readable & Writable'
  },
  NO_CAPACITY: {
    name: 'problem',
    css: 'warning',
    tooltip: 'Read Only'
  },
  LOW_CAPACITY: {
    name: 'healthy',
    css: 'success',
    tooltip: 'Readable & Writable'
  },
  N2N_PORTS_BLOCKED: {
    name: 'healthy',
    css: 'success',
    tooltip: 'Readable & Writable'
  },
  OPTIMAL: {
    name: 'healthy',
    css: 'success',
    tooltip: 'Readable & Writable'
  }
});
const stateToModes = (0, _coreUtils.deepFreeze)({
  HEALTHY: ['OPTIMAL'],
  HAS_ISSUES: ['STORAGE_OFFLINE', 'DECOMMISSIONED', 'UNTRUSTED', 'STORAGE_NOT_EXIST', 'IO_ERRORS', 'N2N_ERRORS', 'GATEWAY_ERRORS', 'INITIALIZING', 'DELETING', 'DECOMMISSIONING', 'MIGRATING', 'IN_PROCESS', 'SOME_STORAGE_MIGRATING', 'SOME_STORAGE_INITIALIZING', 'SOME_STORAGE_DECOMMISSIONING', 'SOME_STORAGE_OFFLINE', 'SOME_STORAGE_NOT_EXIST', 'SOME_STORAGE_IO_ERRORS', 'NO_CAPACITY', 'LOW_CAPACITY', 'HAS_ERRORS', 'HAS_ISSUES', 'N2N_PORTS_BLOCKED'],
  OFFLINE: ['OFFLINE']
});
const serviceToDisplayName = (0, _coreUtils.deepFreeze)({
  storage: 'Storage'
});
const storageNodeModeToStateIcon = (0, _coreUtils.deepFreeze)({
  OFFLINE: {
    name: 'problem',
    css: 'error',
    tooltip: 'Offline'
  },
  UNTRUSTED: {
    name: 'problem',
    css: 'warning',
    tooltip: 'Untrusted'
  },
  INITIALIZING: {
    name: 'working',
    css: 'warning',
    tooltip: 'Initializing'
  },
  DELETING: {
    name: 'working',
    css: 'warning',
    tooltip: 'Deleting'
  },
  DECOMMISSIONING: {
    name: 'working',
    css: 'warning',
    tooltip: 'Deactivating'
  },
  DECOMMISSIONED: {
    name: 'healthy',
    css: '',
    tooltip: 'Deactivated'
  },
  MIGRATING: {
    name: 'working',
    css: 'warning',
    tooltip: 'Migrating'
  },
  N2N_ERRORS: {
    name: 'problem',
    css: 'error',
    tooltip: 'Node to node communication problems'
  },
  GATEWAY_ERRORS: {
    name: 'problem',
    css: 'error',
    tooltip: 'Server communication problems'
  },
  IO_ERRORS: {
    name: 'problem',
    css: 'error',
    tooltip: 'Read/Write problems'
  },
  LOW_CAPACITY: {
    name: 'problem',
    css: 'warning',
    tooltip: 'Available capacity is low'
  },
  NO_CAPACITY: {
    name: 'problem',
    css: 'warning',
    tooltip: 'No available capacity'
  },
  N2N_PORTS_BLOCKED: {
    name: 'problem',
    css: 'warning',
    tooltip: 'Some ports might be blocked'
  },
  STORAGE_NOT_EXIST: {
    name: 'problem',
    css: 'error',
    tooltip: 'Drive is unmounted'
  },
  OPTIMAL: {
    name: 'healthy',
    css: 'success',
    tooltip: 'Healthy'
  }
});
const activityTypeToName = (0, _coreUtils.deepFreeze)({
  RESTORING: 'Restoring',
  MIGRATING: 'Migrating',
  DECOMMISSIONING: 'Deactivating',
  DELETING: 'Deleting'
});
const activityStageToName = (0, _coreUtils.deepFreeze)({
  OFFLINE_GRACE: 'Waiting',
  REBUILDING: 'Rebuilding',
  WIPING: 'Wiping Data'
});
const dataActivityTooltipTemplate = `<ul class="list-no-style column" ko.foreach="$data">
        <li class="push-next-half">
            <p ko.text="activity"><p>
            <p class="remark push-next-half" ko.text="eta"></p>
        </li>
    </ul>`;
const hostWritableModes = (0, _coreUtils.deepFreeze)(['IN_PROCESS', 'SOME_STORAGE_MIGRATING', 'SOME_STORAGE_INITIALIZING', 'SOME_STORAGE_DECOMMISSIONING', 'SOME_STORAGE_OFFLINE', 'SOME_STORAGE_NOT_EXIST', 'SOME_STORAGE_IO_ERRORS', 'LOW_CAPACITY', 'N2N_PORTS_BLOCKED', 'OPTIMAL']);
exports.hostWritableModes = hostWritableModes;
const storageNodeWritableModes = (0, _coreUtils.deepFreeze)(['OPTIMAL', 'LOW_CAPACITY', 'N2N_PORTS_BLOCKED']);
exports.storageNodeWritableModes = storageNodeWritableModes;

function getHostDisplayName(hostName) {
  const [namePart] = hostName.split('#');
  return `${namePart}`;
}

function getHostStateIcon(host) {
  return modeToStateIcon[host.mode];
}

function getHostTrustIcon(host) {
  return trustToIcon[host.trusted];
}

function getHostAccessibilityIcon(host) {
  return modeToAccessibilityIcon[host.services.storage.mode];
}

function getNodeOrHostCapacityBarValues({
  storage
}) {
  const {
    total,
    used,
    usedOther
  } = storage;
  const usage = [{
    value: used,
    label: 'Used (Noobaa)'
  }, {
    value: usedOther,
    label: 'Used (other)'
  }];
  return {
    total,
    used: usage
  };
}

function getHostModeListForState(state) {
  return stateToModes[state];
}

function getHostModeListForStates(...states) {
  return (0, _coreUtils.flatMap)(states, state => stateToModes[state]);
}

function summrizeHostModeCounters(counters) {
  const {
    HEALTHY,
    HAS_ISSUES,
    OFFLINE
  } = (0, _coreUtils.mapValues)(stateToModes, modes => (0, _coreUtils.sumBy)(modes, mode => counters[mode] || 0));
  return {
    all: HEALTHY + HAS_ISSUES + OFFLINE,
    healthy: HEALTHY,
    hasIssues: HAS_ISSUES,
    offline: OFFLINE
  };
}

function getHostServiceDisplayName(service) {
  return serviceToDisplayName[service];
}

function getStorageNodeStateIcon(host) {
  return storageNodeModeToStateIcon[host.mode];
}

function getActivityName(activityType) {
  return activityTypeToName[activityType];
}

function getActivityStageName(stage) {
  return activityStageToName[stage];
}

function getActivityListTooltip(activityList) {
  const data = activityList.map(act => {
    const name = activityTypeToName[act.kind];
    const driveCount = (0, _stringUtils.stringifyAmount)('drive', act.nodeCount);
    const progress = (0, _numeral.default)(act.progress).format('%');
    const eta = (0, _coreUtils.isNumber)(act.eta) ? (0, _moment.default)(act.eta).fromNow() : 'calculating...';
    return {
      activity: `${name} ${driveCount} ${progress}`,
      eta: `ETA: ${eta}`
    };
  });
  return {
    template: dataActivityTooltipTemplate,
    text: data.length ? data : null
  };
}

},{"./core-utils":1027,"@babel/runtime/helpers/interopRequireDefault":1050,"moment":"moment","numeral":"numeral","utils/string-utils":1046}],1033:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.errorIcon = errorIcon;
exports.warningIcon = warningIcon;
exports.processIcon = processIcon;
exports.healthyIcon = healthyIcon;

/* Copyright (C) 2016 NooBaa */
function errorIcon(tooltip) {
  return {
    name: 'problem',
    css: 'error',
    tooltip
  };
}

function warningIcon(tooltip) {
  return {
    name: 'problem',
    css: 'warning',
    tooltip
  };
}

function processIcon(tooltip) {
  return {
    name: 'working',
    css: 'warning',
    tooltip
  };
}

function healthyIcon(tooltip) {
  return {
    name: 'healthy',
    css: 'success',
    tooltip
  };
}

},{}],1034:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.handleFetch = handleFetch;
exports.handleFetchCompleted = handleFetchCompleted;
exports.handleFetchFailed = handleFetchFailed;
exports.handleDropView = handleDropView;
exports.handleUpdateItem = handleUpdateItem;
exports.handleRemoveItem = handleRemoveItem;
exports.initialState = void 0;

var _coreUtils = require("utils/core-utils");

const initialState = (0, _coreUtils.deepFreeze)({
  items: {},
  queries: {},
  views: {}
});
exports.initialState = initialState;

function handleFetch(state, query, view, timestamp, queryLimit, itemLimit) {
  const queryKey = _generateQueryKey(query);

  const queryState = { ...(state.queries[queryKey] || {}),
    timestamp: timestamp,
    fetching: true,
    error: false
  };
  const newState = { ...state,
    queries: { ...state.queries,
      [queryKey]: queryState
    },
    views: { ...state.views,
      [view]: queryKey
    }
  };
  return _clearOverallocated(newState, queryLimit, itemLimit);
}

function handleFetchCompleted(state, query, newItems, extras, queryLimit, itemLimit) {
  const queryKey = _generateQueryKey(query);

  let {
    queries,
    items
  } = state;
  const queryState = queries[queryKey]; // If the query is still valid we update the
  // query and add the new items (override the current items).

  if (queryState) {
    queries = { ...queries,
      [queryKey]: { ...queryState,
        fetching: false,
        error: false,
        result: {
          items: Object.keys(newItems),
          ...extras
        }
      }
    };
    items = { ...state.items,
      ...newItems
    }; // If the query is not valid we use the new items to
    // update the items that are already in the cache.
  } else {
    items = (0, _coreUtils.mapValues)(items, (item, key) => newItems[key] || items[key]);
  }

  const newState = { ...state,
    queries: queries,
    items: items
  };
  return _clearOverallocated(newState, queryLimit, itemLimit);
}

function handleFetchFailed(state, query) {
  const queryKey = _generateQueryKey(query);

  const queryState = state.queries[queryKey];
  if (!queryState) return state;
  const updatedQueryState = { ...queryState,
    fetching: false,
    error: true
  };
  return { ...state,
    queries: { ...state.queries,
      [queryKey]: updatedQueryState
    }
  };
}

function handleDropView(state, view) {
  return { ...state,
    views: (0, _coreUtils.omitUndefined)({ ...state.views,
      [view]: undefined
    })
  };
}

function handleUpdateItem(state, key, updates) {
  const item = state.items[key];
  if (!item) return state;
  return { ...state,
    items: { ...state.items,
      [key]: { ...item,
        ...updates
      }
    }
  };
}

function handleRemoveItem(state, itemKey, handleExtras = _coreUtils.echo) {
  const item = state.items[itemKey];
  if (!item) return state;
  const items = (0, _coreUtils.omitUndefined)({ ...state.items,
    [itemKey]: undefined
  });
  const queries = (0, _coreUtils.mapValues)(state.queries, query => {
    const {
      items: itemList,
      ...extras
    } = query.result;
    const updatedItemList = itemList.filter(item => item !== itemKey);
    if (updatedItemList.length === itemList.length) return query;
    return { ...query,
      result: { ...handleExtras(extras, item),
        items: updatedItemList
      }
    };
  });
  return { ...state,
    items,
    queries
  };
}

function _clearOverallocated(state, queryLimit, hostLimit) {
  let overallocatedQueries = Math.max(0, Object.keys(state.queries).length - queryLimit);
  let overallocatedHosts = Math.max(0, Object.keys(state.items).length - hostLimit);

  if (overallocatedQueries > 0 || overallocatedHosts > 0) {
    const lockedQueries = new Set(Object.values(state.views));
    const candidateQueryPairs = Object.entries(state.queries).filter(([key, query]) => !lockedQueries.has(key) && !query.fetching).sort((0, _coreUtils.createCompareFunc)(([, query]) => query.timestamp)); // Remove queries or items

    const queries = { ...state.queries
    };
    const items = { ...state.items
    };

    for (const [key, query] of candidateQueryPairs) {
      queries[key] = undefined;
      --overallocatedQueries;

      if (query.result) {
        const lockedItems = new Set((0, _coreUtils.flatMap)(Object.values(queries), _getQueryItems));

        for (const itemKey of query.result.items) {
          if (!lockedItems.has(itemKey)) {
            items[itemKey] = undefined;
            --overallocatedHosts;
          }
        }
      }

      if (overallocatedQueries === 0 && overallocatedHosts <= 0) {
        break;
      }
    }

    return { ...state,
      queries: (0, _coreUtils.omitUndefined)(queries),
      items: (0, _coreUtils.omitUndefined)(items)
    };
  } else {
    return state;
  }
}

function _getQueryItems(query) {
  if (!query || !query.result) {
    return [];
  }

  return query.result.items;
}

function _generateQueryKey(query) {
  return (0, _coreUtils.hashCode)(query);
}

},{"utils/core-utils":1027}],1035:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.formatTimeLeftForMaintenanceMode = formatTimeLeftForMaintenanceMode;

var _moment = _interopRequireDefault(require("moment"));

/* Copyright (C) 2018 NooBaa */
function formatTimeLeftForMaintenanceMode(timeLeft) {
  if (!timeLeft) return;

  const duration = _moment.default.duration(timeLeft);

  return `${String(duration.days()).padStart(2, 0)}:${String(duration.hours()).padStart(2, 0)}:${String(duration.minutes()).padStart(2, 0)}:${String(duration.seconds()).padStart(2, 0)}`;
}

},{"@babel/runtime/helpers/interopRequireDefault":1050,"moment":"moment"}],1036:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.splitIPRange = splitIPRange;
exports.ipToNumber = ipToNumber;
exports.isIP = isIP;
exports.isIPRange = isIPRange;
exports.isIPOrIPRange = isIPOrIPRange;
exports.isDNSName = isDNSName;
exports.isIPOrDNSName = isIPOrDNSName;
exports.isUri = isUri;
exports.isPortNumber = isPortNumber;

var _coreUtils = require("utils/core-utils");

/* Copyright (C) 2016 NooBaa */
function splitIPRange(range) {
  const sides = range.split('-');
  const start = sides[0].trim();
  const partialEnd = (sides[1] || '').trim();
  const startParts = start.split('.').map(Number);
  const endParts = partialEnd ? partialEnd.split('.').map(Number) : [];
  const end = [...startParts.slice(0, 4 - endParts.length), ...endParts].join('.');
  return {
    start,
    end
  };
}

function ipToNumber(ip) {
  return ip.split('.').map((part, i) => Math.pow(256, 4 - i) * part).reduce((a, b) => a + b);
}

function isIP(str) {
  const regExp = /^(?:(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/;
  return regExp.test(str);
}

function isIPRange(str) {
  if (str.split('-').length !== 2) {
    return false;
  }

  const {
    start,
    end
  } = splitIPRange(str);
  const reason = !isIP(start) && 'MALFORMED' || !isIP(end) && 'MALFORMED' || ipToNumber(start) >= ipToNumber(end) && 'INVALID_RANGE_ORDER' || undefined;
  return {
    valid: !reason,
    reason
  };
}

function isIPOrIPRange(str) {
  if (isIP(str)) {
    return {
      valid: true
    };
  } else {
    return !isIPRange(str) ? {
      valid: false,
      reason: 'MALFORMED'
    } : isIPRange(str);
  }
}

function isDNSName(str) {
  const regExp = /^[A-Za-z0-9][A-Za-z0-9-\.]*[A-Za-z0-9]$/;
  return regExp.test(str);
}

function isIPOrDNSName(str) {
  return isIP(str) || isDNSName(str);
}

function isUri(str) {
  const value = str.replace(/^\s+|\s+$/, ''); //Strip whitespace
  //Regex by Diego Perini from: http://mathiasbynens.be/demo/url-regex
  //Modified regex - removed the restrictions for private ip ranges

  const regExp = new RegExp('^' + // protocol identifier
  '(?:(?:https?|ftp)://)' + // user:pass authentication
  '(?:\\S+(?::\\S*)?@)?' + '(?:' + // IP address dotted notation octets
  // excludes loopback network 0.0.0.0
  // excludes reserved space >= 224.0.0.0
  // excludes network & broacast addresses
  // (first & last IP address of each class)
  '(?:[1-9]\\d?|1\\d\\d|2[01]\\d|22[0-3])' + '(?:\\.(?:1?\\d{1,2}|2[0-4]\\d|25[0-5])){2}' + '(?:\\.(?:[1-9]\\d?|1\\d\\d|2[0-4]\\d|25[0-4]))' + '|' + // host name
  '(?:(?:[a-z\\u00a1-\\uffff0-9]-*)*[a-z\\u00a1-\\uffff0-9]+)' + // domain name
  '(?:\\.(?:[a-z\\u00a1-\\uffff0-9]-*)*[a-z\\u00a1-\\uffff0-9]+)*' + // TLD identifier
  '(?:\\.(?:[a-z\\u00a1-\\uffff]{2,}))' + // TLD may end with dot
  '\\.?' + ')' + // port number
  '(?::\\d{2,5})?' + // resource path
  '(?:[/?#]\\S*)?' + '$', 'i');
  return regExp.test(value);
}

function isPortNumber(value) {
  return (0, _coreUtils.isNumber)(value) && value >= 1 && value <= 65536;
}

},{"utils/core-utils":1027}],1037:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getObjectId = getObjectId;
exports.splitObjectId = splitObjectId;
exports.formatVersionId = formatVersionId;

/* Copyright (C) 2016 NooBaa */
function getObjectId(bucket, key, versionId, uploadId) {
  return uploadId ? `${bucket}:${key}:${versionId}:${uploadId}` : `${bucket}:${key}:${versionId}`;
}

function splitObjectId(objId) {
  const [bucket, key, version, uploadId] = objId.split(':');
  return {
    bucket,
    key,
    version,
    uploadId
  };
}

function formatVersionId(versionId) {
  return versionId === 'null' ? 'Null' : versionId;
}

},{}],1038:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.calcPasswordStrength = calcPasswordStrength;

var _coreUtils = require("./core-utils");

var _stringUtils = require("./string-utils");

/* Copyright (C) 2016 NooBaa */
function calcPasswordStrength(password) {
  if (!password) {
    return 0;
  }

  let charsInfo = Array.from(password).map(char => {
    let digit = (0, _stringUtils.isDigit)(char);
    let letter = (0, _stringUtils.isLetter)(char);
    let symbol = !digit && !letter;
    let upperCase = (0, _stringUtils.isUpperCase)(char);
    let lowerCase = (0, _stringUtils.isLowerCase)(char);
    let place = !letter ? symbol ? _stringUtils.symbols.indexOf(char) : Number(char) : _stringUtils.letters.indexOf(char.toLowerCase());
    return {
      digit,
      letter,
      symbol,
      upperCase,
      lowerCase,
      place
    };
  });
  let counts = charsInfo.reduce((counts, charInfo) => {
    counts.upperCase += charInfo.upperCase && charInfo.letter ? 1 : 0;
    counts.lowerCase += charInfo.lowerCase && charInfo.letter ? 1 : 0;
    counts.symbol += charInfo.symbol ? 1 : 0;
    counts.digit += charInfo.digit ? 1 : 0;
    counts.letter += charInfo.letter ? 1 : 0;
    return counts;
  }, {
    upperCase: 0,
    lowerCase: 0,
    symbol: 0,
    digit: 0,
    letter: 0
  });
  let score = 0; //  Number of Characters : +(n*4)

  score += charsInfo.length * 4; // Uppercase Letters : +((len-n)*2)

  score += counts.upperCase ? (charsInfo.length - counts.upperCase) * 2 : 0; // Lowercase Letters : +((len-n)*2)

  score += counts.lowerCase ? (charsInfo.length - counts.lowerCase) * 2 : 0; // Numbers : +(n*4)

  score += counts.digit * 4; // Symbols : +(n*6)

  score += counts.symbol * 6; // Middle Numbers or Symbols : +(n*2)

  score += (counts.digit + counts.symbol) * 2;
  score -= charsInfo[0].digit || charsInfo[0].symbol ? 2 : 0;
  score -= (0, _coreUtils.last)(charsInfo).digit || (0, _coreUtils.last)(charsInfo).symbol ? 2 : 0; // Requirements : +(n*2)
  // Minimum 8 characters in length
  // Contains 3/4 of the following items:
  // - Uppercase Letters
  // - Lowercase Letters
  // - Numbers
  // - Symbols

  let checkedRequirements = 0;
  checkedRequirements += Number(counts.digit > 0) + Number(counts.upperCase > 0) + Number(counts.lowerCase > 0) + Number(counts.symbol > 0);
  if (checkedRequirements >= 3 && charsInfo.length >= 8) score += (checkedRequirements + 1) * 2; //Letters Only : -n

  score -= charsInfo.length === counts.letter ? counts.letter : 0; // Numbers Only : -n

  score -= charsInfo.length === counts.digit ? counts.digit : 0; // Consecutive Uppercase Letters  : -(n*2)

  score -= charsInfo.reduce((inc, currInfo, i) => {
    if (i < 1) return inc;
    let lastChar = charsInfo[i - 1];
    return inc + Number(currInfo.letter && currInfo.upperCase && lastChar.letter && lastChar.upperCase) * 2;
  }, 0); // Consecutive Lowercase Letters : -(n*2)

  score -= charsInfo.reduce((inc, currInfo, i) => {
    if (i < 1) return inc;
    let lastChar = charsInfo[i - 1];
    return inc + Number(currInfo.letter && currInfo.lowerCase && lastChar.letter && lastChar.lowerCase) * 2;
  }, 0); // Consecutive Numbers : -(n*2)

  score -= charsInfo.reduce((inc, currInfo, i) => {
    if (i < 1) return inc;
    let lastChar = charsInfo[i - 1];
    return inc + Number(currInfo.digit && lastChar.digit) * 2;
  }, 0); // Sequential Letters (3+) : -(n*3)

  score -= charsInfo.reduce((inc, currInfo, i) => {
    if (i < 2) return inc;
    let last1 = charsInfo[i - 1];
    let last2 = charsInfo[i - 2];

    if (!last2.letter || !last1.letter || !currInfo.letter) {
      return inc;
    }

    let diff = last2.place - last1.place;
    let diff2 = last1.place - currInfo.place;
    let delta = Math.abs(diff) === 1 && diff === diff2 ? 3 : 0;
    return inc + delta;
  }, 0); // Sequential Numbers (3+) : -(n*3)

  score -= charsInfo.reduce((inc, currInfo, i) => {
    if (i < 2) return inc;
    let last1 = charsInfo[i - 1];
    let last2 = charsInfo[i - 2];

    if (!last2.digit || !last1.digit || !currInfo.digit) {
      return inc;
    }

    let diff = last2.place - last1.place;
    let diff2 = last1.place - currInfo.place;
    let delta = Math.abs(diff) === 1 && diff === diff2 ? 3 : 0;
    return inc + delta;
  }, 0); // Sequential Symbols (3+) : -(n*3)

  score -= charsInfo.reduce((inc, currInfo, i) => {
    if (i < 2) return inc;
    let last1 = charsInfo[i - 1];
    let last2 = charsInfo[i - 2];

    if (!last2.symbol || !last1.symbol || !currInfo.symbol) {
      return inc;
    }

    let diff = last2.place - last1.place;
    let diff2 = last1.place - currInfo.place;
    let delta = Math.abs(diff) === 1 && diff === diff2 ? 3 : 0;
    return inc + delta;
  }, 0); // Repeat Characters (Case Insensitive)

  let uniquesCount = password.length;
  score -= Array.from(password).reduce((inc, char, i) => {
    let delta = 0;
    let j = password.indexOf(char);

    while (j > -1) {
      if (j !== i) {
        delta += password.length / Math.abs(j - i);
      }

      j = password.indexOf(char, j + 1);
    }

    if (delta > 0) {
      inc += delta;

      if (--uniquesCount) {
        inc /= uniquesCount;
      }
    }

    return Math.ceil(inc);
  }, 0);
  return (0, _coreUtils.clamp)(score / 100, 0, 1);
}

},{"./core-utils":1027,"./string-utils":1046}],1039:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.all = all;
exports.execInOrder = execInOrder;
exports.sleep = sleep;
exports.promisify = promisify;

/* Copyright (C) 2016 NooBaa */
function all(...args) {
  return Promise.all(args);
}

function execInOrder(list, executer) {
  let result = Promise.resolve();

  for (let i = 0; i < list.length; ++i) {
    result = result.then(res => res === true || executer(list[i], i));
  }

  return result;
}

function sleep(miliseconds, wakeValue) {
  return new Promise(resolve => setTimeout(() => resolve(wakeValue), miliseconds));
}

function promisify(func, owner = null) {
  return (...args) => new Promise((resolve, reject) => {
    const cb = (err, result) => err ? reject(err) : resolve(result);

    func.call(owner, ...args, cb);
  });
}

},{}],1040:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createReducer = createReducer;
exports.combineReducers = combineReducers;
exports.reduceReducers = reduceReducers;
exports.selectReducer = selectReducer;
exports.filterActions = filterActions;

var _coreUtils = require("utils/core-utils");

/* Copyright (C) 2016 NooBaa */
// Join action handlers into a single reducer.
function createReducer(initialState, handlers) {
  return function (state = initialState, action) {
    return (handlers[action.type] || _coreUtils.echo)(state, action);
  };
} // Combine a map of slice reducers into a master reducer.


function combineReducers(reducers) {
  return function (state = {}, action) {
    return (0, _coreUtils.mapValues)(reducers, (reducer, key) => reducer(state[key], action));
  };
} // Reduce the state using each reducer in the list in order.


function reduceReducers(...reducers) {
  return function (state, action) {
    return reducers.reduce((state, reducer) => {
      return reducer(state, action);
    }, state);
  };
} // Select a reducer based on a selector. The selector should return a boolean
// for left/right selection.


function selectReducer(selector, leftReducer = _coreUtils.echo, rightReducer = _coreUtils.echo) {
  return function (state, action) {
    return (selector(state, action) ? leftReducer : rightReducer)(state, action);
  };
}

function filterActions(filter, reducer) {
  return function (state, action) {
    return filter(action) ? reducer(state, action) : state;
  };
}

},{"utils/core-utils":1027}],1041:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getResourceId = getResourceId;
exports.getHostPoolStateIcon = getHostPoolStateIcon;
exports.getHostPoolHostsSummary = getHostPoolHostsSummary;
exports.getHostPoolNodesSummary = getHostPoolNodesSummary;
exports.getCloudResourceStateIcon = getCloudResourceStateIcon;
exports.getCloudResourceTypeIcon = getCloudResourceTypeIcon;
exports.getNamespaceResourceStateIcon = getNamespaceResourceStateIcon;
exports.getNamespaceResourceTypeIcon = getNamespaceResourceTypeIcon;
exports.getUsageDistribution = getUsageDistribution;
exports.getResourceTypeDisplayName = getResourceTypeDisplayName;
exports.unassignedRegionText = void 0;

var _coreUtils = require("utils/core-utils");

var _sizeUtils = require("utils/size-utils");

var _bucketUtils = require("utils/bucket-utils");

var _hostUtils = require("utils/host-utils");

var _numeral = _interopRequireDefault(require("numeral"));

/* Copyright (C) 2016 NooBaa */
const GB = Math.pow(1024, 3);
const hostsPoolModeToStateIcon = (0, _coreUtils.deepFreeze)({
  BEING_CREATED: {
    tooltip: 'Creating pool...',
    css: 'warning',
    name: 'working'
  },
  INITIALIZING: {
    tooltip: 'Initializing',
    css: 'warning',
    name: 'working'
  },
  INITIALIZING_FAILED: {
    tooltip: 'Initialization Failed',
    css: 'error',
    name: 'problem'
  },
  DELETING: {
    tooltip: 'Deleting',
    css: 'warning',
    name: 'working'
  },
  HAS_NO_NODES: {
    tooltip: 'Pool is empty',
    css: 'error',
    name: 'problem'
  },
  SCALING: pool => {
    const {
      configuredHostCount,
      hostCount
    } = pool;
    const tooltip = `Scaling ${configuredHostCount > hostCount ? 'up' : 'down'} to ${configuredHostCount} nodes`;
    return {
      tooltip,
      css: 'warning',
      name: 'working'
    };
  },
  ALL_NODES_OFFLINE: {
    tooltip: 'All nodes are offline',
    css: 'error',
    name: 'problem'
  },
  NO_CAPACITY: {
    tooltip: 'No available pool capacity',
    css: 'error',
    name: 'problem'
  },
  ALL_HOSTS_IN_PROCESS: {
    tooltip: 'All Nodes are migrating/deactivating/initializing ',
    css: 'warning',
    name: 'working'
  },
  MOST_NODES_ISSUES: {
    tooltip: 'More than 90% of nodes have issues',
    css: 'error',
    name: 'problem'
  },
  MANY_NODES_ISSUES: {
    tooltip: 'More than 50% of nodes have issues',
    css: 'warning',
    name: 'problem'
  },
  MOST_STORAGE_ISSUES: {
    tooltip: 'More than 90% of nodes have storage issues',
    css: 'error',
    name: 'problem'
  },
  MANY_STORAGE_ISSUES: {
    tooltip: 'More than 50% of nodes have storage issues',
    css: 'warning',
    name: 'problem'
  },
  MOST_S3_ISSUES: {
    tooltip: 'More than 90% of nodes have S3 endpoint issues',
    css: 'error',
    name: 'problem'
  },
  MANY_S3_ISSUES: {
    tooltip: 'More than 50% of nodes have S3 endpoint issues',
    css: 'warning',
    name: 'problem'
  },
  MANY_NODES_OFFLINE: pool => {
    const {
      hostCount,
      hostsByMode
    } = pool;
    const percentage = (0, _numeral.default)((hostsByMode.OFFLINE || 0) / hostCount).format('%');
    return {
      tooltip: `${percentage} nodes are offline`,
      css: 'warning',
      name: 'problem'
    };
  },
  LOW_CAPACITY: pool => {
    const free = (0, _sizeUtils.toBytes)(pool.storage.free);
    const limit = (0, _sizeUtils.formatSize)(Math.max(30 * GB, .2 * free));
    return {
      tooltip: `Available capacity is below ${limit}`,
      css: 'warning',
      name: 'problem'
    };
  },
  HIGH_DATA_ACTIVITY: {
    tooltip: 'High data activity in pool',
    css: 'warning',
    name: 'working'
  },
  OPTIMAL: {
    tooltip: 'Healthy',
    css: 'success',
    name: 'healthy'
  }
});
const cloudResourceModeToStateIcon = (0, _coreUtils.deepFreeze)({
  OPTIMAL: {
    tooltip: 'Healthy',
    css: 'success',
    name: 'healthy'
  },
  IO_ERRORS: {
    tooltip: 'Resource has Read/Write problems',
    css: 'error',
    name: 'problem'
  },
  STORAGE_NOT_EXIST: resource => {
    const tooltip = resource.type === 'AZURE' ? 'Target Azure container does not exist' : 'Target S3 bucket does not exist';
    return {
      tooltip,
      css: 'error',
      name: 'problem'
    };
  },
  AUTH_FAILED: {
    tooltip: 'Authentication failure',
    css: 'error',
    name: 'problem'
  },
  INITIALIZING: {
    tooltip: 'Initializing',
    css: 'warning',
    name: 'working'
  },
  ALL_NODES_OFFLINE: {
    tooltip: 'Offline',
    css: 'error',
    name: 'problem'
  }
});
const namespaceResourceModeToStateIcon = (0, _coreUtils.deepFreeze)({
  OPTIMAL: {
    name: 'healthy',
    css: 'success',
    tooltip: 'Healthy'
  }
});
const cloudAndNamespaceResourceTypeToIcon = (0, _coreUtils.deepFreeze)({
  AWS: {
    name: 'aws-s3',
    tooltip: 'AWS S3 resource'
  },
  AZURE: {
    name: 'azure',
    tooltip: 'Azure blob resource'
  },
  GOOGLE: {
    name: 'google-cloud',
    tooltip: 'Google Cloud resource'
  },
  S3_COMPATIBLE: {
    name: 'cloud',
    tooltip: 'Generic S3 compatible resource'
  },
  NET_STORAGE: {
    name: 'net-storage',
    tooltip: 'NetStorage resource'
  },
  FLASHBLADE: {
    name: 'pure',
    tooltip: 'Pure FlashBlade'
  },
  IBM_COS: {
    name: 'ibm-cos',
    tooltip: 'IBM COS'
  }
});
const resourceTypeToDisplayName = (0, _coreUtils.deepFreeze)({
  HOSTS: 'pool',
  CLOUD: 'cloud resource'
});
const unassignedRegionText = 'Not set';
exports.unassignedRegionText = unassignedRegionText;

function getResourceId(type, name) {
  return `${type}:${name}`;
}

function getHostPoolStateIcon(pool) {
  const {
    mode
  } = pool;
  const state = hostsPoolModeToStateIcon[mode];
  return (0, _coreUtils.isFunction)(state) ? state(pool) : state;
}

function getHostPoolHostsSummary(pool) {
  const healthyHosts = (0, _coreUtils.sumBy)(_hostUtils.hostWritableModes, mode => pool.hostsByMode[mode] || 0);
  return `${(0, _numeral.default)(healthyHosts).format(',')} of ${(0, _numeral.default)(pool.hostCount).format(',')}`;
}

function getHostPoolNodesSummary(pool) {
  const healthyNodes = (0, _coreUtils.sumBy)(_hostUtils.storageNodeWritableModes, mode => pool.hostsByMode[mode] || 0);
  return `${(0, _numeral.default)(healthyNodes).format(',')} of ${(0, _numeral.default)(pool.storageNodeCount).format(',')}`;
}

function getCloudResourceStateIcon(resource) {
  const {
    mode
  } = resource;
  const state = cloudResourceModeToStateIcon[mode];
  return (0, _coreUtils.isFunction)(state) ? state(resource) : state;
}

function getCloudResourceTypeIcon(resource) {
  const {
    type
  } = resource;
  return cloudAndNamespaceResourceTypeToIcon[type];
}

function getNamespaceResourceStateIcon(resource) {
  const {
    mode
  } = resource;
  return namespaceResourceModeToStateIcon[mode];
}

function getNamespaceResourceTypeIcon(resource) {
  const {
    service
  } = resource;
  return cloudAndNamespaceResourceTypeToIcon[service];
}

function getUsageDistribution(resourceType, resourceName, buckets) {
  const resId = getResourceId(resourceType, resourceName);
  const usageList = Object.values(buckets).map(bucket => {
    const {
      name,
      usageDistribution
    } = bucket;
    const usage = usageDistribution.resources[resId];
    const lastUpdate = usageDistribution.lastUpdate;
    const resources = (0, _bucketUtils.flatPlacementPolicy)(bucket).map(record => record.resource);

    if (resources.some(res => getResourceId(res.type, res.name) === resId)) {
      return {
        bucket: name,
        lastUpdate: lastUpdate,
        reason: 'PLACEMENT_TARGET',
        size: (0, _sizeUtils.toBytes)(usage || 0)
      };
    } else if ((0, _coreUtils.isDefined)(usage)) {
      return {
        bucket: name,
        lastUpdate: lastUpdate,
        reason: 'WAITING_TO_BE_WIPED',
        size: (0, _sizeUtils.toBytes)(usage)
      };
    } else {
      return null;
    }
  }).filter(Boolean);
  const totalUsage = (0, _coreUtils.sumBy)(usageList, record => record.size);
  return usageList.map(record => {
    const ratio = totalUsage > 0 ? record.size / totalUsage : 0;
    return { ...record,
      ratio
    };
  });
}

function getResourceTypeDisplayName(resourceType) {
  return resourceTypeToDisplayName[resourceType];
}

},{"@babel/runtime/helpers/interopRequireDefault":1050,"numeral":"numeral","utils/bucket-utils":1022,"utils/core-utils":1027,"utils/host-utils":1032,"utils/size-utils":1043}],1042:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createSchemaValidator = createSchemaValidator;
exports.strictify = strictify;

var _ajv = _interopRequireDefault(require("ajv"));

var _coreUtils = require("utils/core-utils");

var _stringUtils = require("utils/string-utils");

/* Copyright (C) 2016 NooBaa */
function createSchemaValidator(schema) {
  // Strictify the schema definitions.
  const ajv = new _ajv.default({
    schemaId: 'auto'
  });
  const avjValidate = ajv.compile(schema);
  return function validate(state) {
    if (!avjValidate(state)) {
      return avjValidate.errors.map(error => {
        if (error.dataPath) {
          const accessor = _createDataPathAccessor(error.dataPath);

          error.data = accessor(state);
        }

        return error;
      });
    }
  };
}

function strictify(schema) {
  if ((0, _coreUtils.isObject)(schema)) {
    if (schema.type === 'object') {
      schema.additionalProperties = schema.additionalProperties || false;
    }

    Object.values(schema).forEach(strictify);
  }

  return schema;
}

function _createDataPathAccessor(dataPath) {
  const body = `
        try {
            return state${dataPath};
        } catch (err) {
            console.warn('SCHEMA DATA ACCSSESOR, Could not retrive data for path: ${(0, _stringUtils.escapeQuotes)(dataPath)}');
            return;
        }
    `;

  try {
    return new Function('state', body);
  } catch (err) {
    return function () {
      console.warn(`SCHEMA DATA ACCSSESOR, Could not compile data accessor for path: ${dataPath}`);
      return;
    };
  }
}

},{"@babel/runtime/helpers/interopRequireDefault":1050,"ajv":1,"utils/core-utils":1027,"utils/string-utils":1046}],1043:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.normalizeSize = normalizeSize;
exports.compactSize = compactSize;
exports.toBigInteger = toBigInteger;
exports.fromBigInteger = fromBigInteger;
exports.fromSizeAndUnit = fromSizeAndUnit;
exports.toSizeAndUnit = toSizeAndUnit;
exports.mulBigIntegerReal = mulBigIntegerReal;
exports.toBytes = toBytes;
exports.interpolateSizes = interpolateSizes;
exports.sumSize = sumSize;
exports.formatSize = formatSize;
exports.isSizeZero = isSizeZero;
exports.compareSize = compareSize;
Object.defineProperty(exports, "bigInteger", {
  enumerable: true,
  get: function () {
    return _bigInteger.default;
  }
});
exports.unitsInBytes = exports.sizeUnits = void 0;

var _bigInteger = _interopRequireDefault(require("big-integer"));

var _coreUtils = require("./core-utils");

/* Copyright (C) 2016 NooBaa */
const sizeUnits = (0, _coreUtils.deepFreeze)([' bytes', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB']);
exports.sizeUnits = sizeUnits;
const kilo = 1024;
const unitsInBytes = (0, _coreUtils.deepFreeze)({
  KILOBYTE: kilo,
  KB: kilo,
  MEGABYTE: Math.pow(kilo, 2),
  MB: Math.pow(kilo, 2),
  GIGABYTE: Math.pow(kilo, 3),
  GB: Math.pow(kilo, 3),
  TERABYTE: Math.pow(kilo, 4),
  TB: Math.pow(kilo, 4),
  PETABYTE: Math.pow(kilo, 5),
  PB: Math.pow(kilo, 5)
});
exports.unitsInBytes = unitsInBytes;

// normalize size number or size object to size object.
function normalizeSize(sizeOrBytes) {
  const {
    peta = 0,
    n = sizeOrBytes
  } = sizeOrBytes;
  return peta !== 0 ? sizeOrBytes : {
    peta,
    n
  };
} // Compact a size object to nubmer if possible.


function compactSize(sizeOrBytes) {
  const {
    peta,
    n
  } = normalizeSize(sizeOrBytes);
  return peta === 0 ? n : sizeOrBytes;
}

function toBigInteger(sizeOrBytes) {
  const {
    n,
    peta
  } = normalizeSize(sizeOrBytes);
  return _toBigInteger(n, peta);
}

function fromBigInteger(bi) {
  const {
    quotient,
    remainder
  } = bi.divmod(unitsInBytes.PETABYTE);
  return compactSize({
    peta: quotient.toJSNumber(),
    n: remainder.toJSNumber()
  });
}

function fromSizeAndUnit(size, unit) {
  return fromBigInteger((0, _bigInteger.default)(unitsInBytes[unit]).multiply(size));
}

function toSizeAndUnit(sizeOrBytes) {
  let {
    peta,
    n
  } = normalizeSize(sizeOrBytes);
  let i = 0;

  if (peta > 0) {
    i = 5;
    n = peta + n / unitsInBytes.PETABYTE;
  }

  while (n / kilo >= 1) {
    n /= kilo;
    ++i;
  }

  return {
    size: n,
    unit: sizeUnits[i]
  };
}

function mulBigIntegerReal(bi, real) {
  const scalar = Math.floor(real);
  const friction = real % 1;
  const {
    quotient,
    remainder
  } = bi.divmod(Number.MAX_SAFE_INTEGER);
  const p1 = Math.floor(quotient * friction);
  const p2 = Math.round(remainder * friction + quotient % 1 * Number.MAX_SAFE_INTEGER);
  return (0, _bigInteger.default)(Number.MAX_SAFE_INTEGER).multiply(p1).add(p2).add(bi.multiply(scalar));
} // This function, if passed a size object, will convert the object to a non exact
// integer representation of the size object. A difference may happen for sizes above
// Number.MAX_SAFE_INTEGER because of the inability of floating point numbers to
// represent very big numbers.


function toBytes(sizeOrBytes) {
  const {
    peta,
    n
  } = normalizeSize(sizeOrBytes);
  return peta * unitsInBytes.PETABYTE + n;
}

function interpolateSizes(sizeOrBytes1 = 0, sizeOrBytes2 = 0, t) {
  const bi1 = toBigInteger(sizeOrBytes1);
  const bi2 = toBigInteger(sizeOrBytes2); // Interpolates bi1 and bi2 using the the formola bi1 + (bi2 - bi1) * t
  // where 0 <= t <= 1. The interpolation is written using Numbers because bigInteger
  // does not support multiplication with a fraction. The algorithm it guaranteed to
  // work because t is defined as friction between 0 and 1.

  const {
    quotient,
    remainder
  } = bi2.subtract(bi1).divmod(unitsInBytes.PETABYTE);
  const peta = Math.floor(quotient * t);
  const n = Math.round(remainder * t + quotient % 1 * unitsInBytes.PETABYTE);
  return fromBigInteger(_toBigInteger(n, peta).add(bi1));
}

function sumSize(...sizeOrBytesList) {
  return fromBigInteger(sizeOrBytesList.reduce((sum, size) => sum.add(toBigInteger(size)), _bigInteger.default.zero));
} // Format a size number or size object to human readable string.


function formatSize(sizeOrBytes) {
  let {
    peta,
    n
  } = normalizeSize(sizeOrBytes);
  let i = 0;

  if (peta > 0) {
    i = 5;
    n = peta + n / unitsInBytes.PETABYTE;
  }

  while (n / kilo >= 1) {
    n /= kilo;
    ++i;
  }

  if (i > 0) {
    n = n.toFixed(n < 10 ? 1 : 0);
  }

  return `${n}${sizeUnits[i]}`;
}

function isSizeZero(sizeOrBytes) {
  let {
    peta,
    n
  } = normalizeSize(sizeOrBytes);
  return peta === 0 && n == 0;
}

function compareSize(sizeOrBytes1, sizeOrBytes2) {
  const {
    peta: p1,
    n: n1
  } = normalizeSize(sizeOrBytes1);
  const {
    peta: p2,
    n: n2
  } = normalizeSize(sizeOrBytes2);
  return p1 === p2 ? Math.sign(n1 - n2) : Math.sign(p1 - p2);
} // ----------------------------------
// Internal Helpers
// ----------------------------------


function _toBigInteger(n, peta) {
  return (0, _bigInteger.default)(unitsInBytes.PETABYTE).multiply(peta).add(n);
}

},{"./core-utils":1027,"@babel/runtime/helpers/interopRequireDefault":1050,"big-integer":"big-integer"}],1044:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.mapErrorObject = mapErrorObject;
exports.mapApiStorage = mapApiStorage;
exports.createSelector = createSelector;

var _coreUtils = require("utils/core-utils");

var _sizeUtils = require("utils/size-utils");

/* Copyright (C) 2016 NooBaa */
const expFieldsToCopy = ['message', 'stack', 'code', 'rpc_code'];

function _subSize(size1 = 0, size2 = 0) {
  return (0, _sizeUtils.fromBigInteger)((0, _sizeUtils.toBigInteger)(size1).subtract((0, _sizeUtils.toBigInteger)(size2)));
}

function mapErrorObject(exp) {
  return (0, _coreUtils.omitUndefined)((0, _coreUtils.pick)(exp, expFieldsToCopy));
}

function mapApiStorage(storage, lastUpdate) {
  return (0, _coreUtils.omitUndefined)({
    lastUpdate: lastUpdate,
    total: storage.total,
    free: storage.free,
    unavailableFree: storage.unavailable_free,
    used: _subSize(storage.used, storage.unavailable_used),
    unavailableUsed: storage.unavailable_used,
    usedOther: storage.used_other,
    reserved: storage.reserved
  });
}

function createSelector(argsSelectors, resultSelector, options = {}) {
  const {
    areResultArgsEqual = _coreUtils.equalItems
  } = options;
  let lastResult,
      lastResultArgs = [];
  return (...args) => {
    const resultArgs = [];

    for (let i = 0; i < argsSelectors.length; ++i) {
      resultArgs.push(argsSelectors[i](...args));
    }

    if (!areResultArgsEqual(resultArgs, lastResultArgs)) {
      lastResultArgs = resultArgs;
      lastResult = resultSelector(...resultArgs);
    }

    return lastResult;
  };
}

},{"utils/core-utils":1027,"utils/size-utils":1043}],1045:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.aggregateStorage = aggregateStorage;
exports.interpolateStorage = interpolateStorage;

var _coreUtils = require("./core-utils");

var _sizeUtils = require("./size-utils");

/* Copyright (C) 2016 NooBaa */
function aggregateStorage(...list) {
  const aggregate = list.reduce((aggregate, storage) => {
    for (const [key, value] of Object.entries(storage)) {
      aggregate[key] = (aggregate[key] || _sizeUtils.bigInteger.zero).add((0, _sizeUtils.toBigInteger)(value));
    }

    return aggregate;
  }, {});
  return (0, _coreUtils.mapValues)(aggregate, _sizeUtils.fromBigInteger);
}

function interpolateStorage(storage1, storage2, t) {
  const keySet = new Set([...Object.keys(storage1), ...Object.keys(storage2)]);
  return (0, _coreUtils.keyBy)(keySet.keys(), _coreUtils.echo, key => (0, _sizeUtils.interpolateSizes)(storage1[key], storage2[key], t));
}

},{"./core-utils":1027,"./size-utils":1043}],1046:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.toCammelCase = toCammelCase;
exports.toDashedCase = toDashedCase;
exports.formatDuration = formatDuration;
exports.randomString = randomString;
exports.equalIgnoreCase = equalIgnoreCase;
exports.includesIgnoreCase = includesIgnoreCase;
exports.lastSegment = lastSegment;
exports.shortString = shortString;
exports.pad = pad;
exports.capitalize = capitalize;
exports.isLowerCase = isLowerCase;
exports.isUpperCase = isUpperCase;
exports.isLetter = isLetter;
exports.isDigit = isDigit;
exports.pluralize = pluralize;
exports.stringifyAmount = stringifyAmount;
exports.splice = splice;
exports.escapeQuotes = escapeQuotes;
exports.escapeRegExp = escapeRegExp;
exports.symbols = exports.letters = exports.digits = void 0;

var _coreUtils = require("./core-utils");

var _numeral = _interopRequireDefault(require("numeral"));

/* Copyright (C) 2016 NooBaa */
const digits = '123456789';
exports.digits = digits;
const letters = 'abcdefghijklmnopqrstuvwxyz';
exports.letters = letters;
const symbols = ')!@#$%^&*(';
exports.symbols = symbols;

function toCammelCase(str) {
  return str.replace(/-\w/g, match => match[1].toUpperCase());
}

function toDashedCase(str) {
  return str.replace(/[A-Z]+/g, match => `-${match.toLowerCase()}`);
}

function formatDuration(minutes) {
  let hours = minutes / 60 | 0;
  let days = hours / 24 | 0;
  hours %= 24;
  minutes %= 60;
  return [days > 0 ? `${days} day${days > 1 ? 's' : ''}` : null, hours > 0 ? `${hours} hour${hours > 1 ? 's' : ''}` : null, minutes > 0 ? `${minutes} minute${minutes > 1 ? 's' : ''}` : null].filter(part => part).reduce((str, part, i, parts) => str + (i === parts.length - 1 ? ' and ' : ', ') + parts);
}

function randomString(len = 8) {
  var possible = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
  return (0, _coreUtils.makeArray)(len, () => possible.charAt(Math.random() * possible.length | 0)).join('');
}

function equalIgnoreCase(str1, str2) {
  return str1.toLowerCase() === str2.toLowerCase();
}

function includesIgnoreCase(str, substr = '') {
  return str.toLowerCase().includes(substr.toLowerCase());
}

function lastSegment(str = '', delimiter) {
  return str.substr(str.lastIndexOf(delimiter) + 1);
}

function shortString(str, maxLength = 25, suffixLength = 5) {
  if (str.length <= maxLength) {
    return str;
  }

  return `${str.slice(0, maxLength - (suffixLength + 3))}...${suffixLength ? str.slice(-suffixLength) : ''}`;
}

function pad(str, size, char = '0') {
  return (char.repeat(size) + str).substr(-size);
}

function capitalize(str) {
  return str[0].toUpperCase() + str.substr(1);
}

function isLowerCase(str) {
  return str.toLowerCase() === str;
}

function isUpperCase(str) {
  return str.toUpperCase() === str;
}

function isLetter(str) {
  return letters.includes(str.toLowerCase());
}

function isDigit(str) {
  return !isNaN(Number(str)) && str.length === 1;
}

function pluralize(word, amount = 2) {
  if (amount === 1) {
    return word;
  }

  return word.slice(-1) === 'y' ? `${word.slice(0, -1)}ies` : `${word}s`;
}

function stringifyAmount(subject, amount, zeroMoniker = '0') {
  return `${amount > 0 ? (0, _numeral.default)(amount).format(',') : zeroMoniker} ${pluralize(subject, amount)}`;
}

function splice(str, start, end, replacement = '') {
  return `${str.substr(0, start)}${replacement}${str.substr(end)}`;
}

function escapeQuotes(str) {
  return str.replace(/'/g, "\\'") // eslint-disable-line quotes
  .replace(/"/g, '\\"');
}

function escapeRegExp(str) {
  return str.replace(/[\\^$.*+?()[\]{}|]/g, '\\$&');
}

},{"./core-utils":1027,"@babel/runtime/helpers/interopRequireDefault":1050,"numeral":"numeral"}],1047:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.validateName = validateName;
exports.validatePassword = validatePassword;

/* Copyright (C) 2016 NooBaa */
function validateName(name = '', existing, options = {}) {
  const {
    disallowPeriods = false,
    minLength = 3,
    maxLength = 63
  } = options;
  const symbolsRule = disallowPeriods ? {
    valid: name && /^[a-z0-9-]*$/.test(name) && !name.includes(' ') && !name.includes('--'),
    message: 'Only lowercase letters, numbers and nonconsecutive hyphens'
  } : {
    valid: name && /^[a-z0-9.-]*$/.test(name) && !name.includes(' ') && !name.includes('..') && !name.includes('.-') && !name.includes('-.') && !name.includes('--'),
    message: 'Only lowercase letters, numbers, nonconsecutive periods or hyphens'
  };
  return [{
    valid: minLength <= name.length && name.length <= maxLength,
    message: `${minLength}-${maxLength} characters`
  }, {
    valid: /^[a-z0-9](.*[a-z0-9])?$/.test(name),
    message: 'Starts and ends with a lowercase letter or number'
  }, symbolsRule, {
    valid: name && !/^\d+\.\d+\.\d+\.\d+$/.test(name),
    message: 'Avoid using the form of an IP address'
  }, {
    valid: name && !existing.includes(name),
    message: 'Globally unique name'
  }];
}

function validatePassword(password = '') {
  return [{
    valid: password.length >= 5,
    message: 'At least 5 characters'
  }, {
    valid: /[A-Z]/.test(password),
    message: 'At least one uppercased letter'
  }, {
    valid: /[a-z]/.test(password),
    message: 'At least one lowercase letter'
  }, {
    valid: /[0-9]/.test(password),
    message: 'At least one digit'
  }];
}

},{}],1048:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.matchPattern = matchPattern;
exports.notIn = notIn;
exports.hasNoLeadingOrTrailingSpaces = hasNoLeadingOrTrailingSpaces;
exports.includesUppercase = includesUppercase;
exports.includesLowercase = includesLowercase;
exports.includesDigit = includesDigit;
exports.isJSON = isJSON;
exports.isHostname = isHostname;
exports.exactLength = exactLength;
exports.inRange = inRange;
exports.isEmail = isEmail;
exports.default = register;

var _knockout = _interopRequireDefault(require("knockout"));

var _netUtils = require("utils/net-utils");

var _browserUtils = require("utils/browser-utils");

/* Copyright (C) 2016 NooBaa */
function matchPattern(value, regExp) {
  return !value || regExp.test(value);
}

function notIn(value, params) {
  params = _knockout.default.unwrap(params);

  if (Array.isArray(params)) {
    params = {
      list: params
    };
  }

  let {
    list = [],
    compareFunc = (a, b) => a === b
  } = params;
  return _knockout.default.unwrap(list).every(item => !compareFunc(value, item));
}

function hasNoLeadingOrTrailingSpaces(value) {
  return value.trim() === value;
}

function includesUppercase(value) {
  return matchPattern(value, /[A-Z]/);
}

function includesLowercase(value) {
  return matchPattern(value, /[a-z]/);
}

function includesDigit(value) {
  return matchPattern(value, /[0-9]/);
}

function isJSON(value) {
  try {
    JSON.parse(value);
    return true;
  } catch (err) {
    return false;
  }
}

function isHostname(value) {
  const regExp = /^[a-zA-Z0-9]+(-[a-zA-Z0-9]+)*(\.[a-zA-Z0-9]+(-[a-zA-Z0-9]+)*)*$/;
  return matchPattern(value, regExp);
}

function exactLength(value, len) {
  return value.length === len;
}

function inRange(value, {
  min,
  max,
  inclusive = true
}) {
  if (min > max) {
    throw new Error('Max value must be bigger then min value');
  }

  return inclusive ? min <= value && value <= max : min < value && value < max;
}

function isEmail(value) {
  const regExp = /^((([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+(\.([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+)*)|((\x22)((((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(([\x01-\x08\x0b\x0c\x0e-\x1f\x7f]|\x21|[\x23-\x5b]|[\x5d-\x7e]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(\\([\x01-\x09\x0b\x0c\x0d-\x7f]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))))*(((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(\x22)))@((([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.)+(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))$/i;
  return matchPattern(value, regExp);
}

function register(ko) {
  Object.assign(ko.validation.rules, {
    notIn: {
      validator: notIn,
      message: 'Value already exists'
    },
    hasNoLeadingOrTrailingSpaces: {
      validator: hasNoLeadingOrTrailingSpaces,
      message: 'Value cannot start or end with spaces'
    },
    isDNSName: {
      validator: val => !val || (0, _netUtils.isDNSName)(val),
      message: 'Please enter a valid DNS name'
    },
    isIP: {
      validator: val => !val || (0, _netUtils.isIP)(val),
      message: 'Please enter a valid IP address'
    },
    isIPOrDNSName: {
      validator: val => !val || (0, _netUtils.isIPOrDNSName)(val),
      message: 'Please enter a valid IP or DNS name'
    },
    isURI: {
      validator: val => !val || (0, _browserUtils.isUri)(val),
      message: 'Please enter a valid URI'
    },
    isHostname: {
      validator: isHostname,
      message: 'Please enter a valid hostname'
    },
    includesUppercase: {
      validator: includesUppercase,
      message: 'At least one uppercased letter'
    },
    includesLowercase: {
      validator: includesLowercase,
      message: 'At least one lowercased letter'
    },
    includesDigit: {
      validator: includesDigit,
      message: 'At least one digit'
    },
    isJSON: {
      validator: isJSON,
      message: 'Please enter a valid JSON string'
    },
    exactLength: {
      validator: exactLength,
      message: 'Must be exactly {0} characters'
    },
    inRange: {
      validator: inRange,
      message: ({
        params
      }) => `Must be bewteen ${params.min} and ${params.max}`
    }
  });
  ko.validation.registerExtenders();
}

},{"@babel/runtime/helpers/interopRequireDefault":1050,"knockout":"knockout","utils/browser-utils":1021,"utils/net-utils":1036}],1049:[function(require,module,exports){
function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

module.exports = _defineProperty;
},{}],1050:[function(require,module,exports){
function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : {
    "default": obj
  };
}

module.exports = _interopRequireDefault;
},{}],1051:[function(require,module,exports){
var _typeof = require("../helpers/typeof");

function _getRequireWildcardCache() {
  if (typeof WeakMap !== "function") return null;
  var cache = new WeakMap();

  _getRequireWildcardCache = function _getRequireWildcardCache() {
    return cache;
  };

  return cache;
}

function _interopRequireWildcard(obj) {
  if (obj && obj.__esModule) {
    return obj;
  }

  if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") {
    return {
      "default": obj
    };
  }

  var cache = _getRequireWildcardCache();

  if (cache && cache.has(obj)) {
    return cache.get(obj);
  }

  var newObj = {};
  var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;

  for (var key in obj) {
    if (Object.prototype.hasOwnProperty.call(obj, key)) {
      var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;

      if (desc && (desc.get || desc.set)) {
        Object.defineProperty(newObj, key, desc);
      } else {
        newObj[key] = obj[key];
      }
    }
  }

  newObj["default"] = obj;

  if (cache) {
    cache.set(obj, newObj);
  }

  return newObj;
}

module.exports = _interopRequireWildcard;
},{"../helpers/typeof":1052}],1052:[function(require,module,exports){
function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    module.exports = _typeof = function _typeof(obj) {
      return typeof obj;
    };
  } else {
    module.exports = _typeof = function _typeof(obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

module.exports = _typeof;
},{}],"style":[function(require,module,exports){
module.exports={"font-family1":"\"Roboto\", sans-serif","font-family2":"consolas, monospace","font-size1":"12px","font-size2":"13px","font-size3":"14px","font-size4":"16px","font-size5":"20px","font-size6":"26px","font-thin":"200","font-light":"300","font-regular":"400","font-medium":"500","cursor-pointer":"pointer","cursor-not-allowed":"not-allowed","gutter":"18px","content-max-width":"1404px","assets":"'/fe/assets'"}
},{}]},{},[935])

//# sourceMappingURL=app.js.map
